"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AlgorithmController = void 0;
const common_1 = require("@nestjs/common");
const passport_1 = require("@nestjs/passport");
const context_service_1 = require("../context/context.service");
const algorithm_service_1 = require("./algorithm.service");
let AlgorithmController = class AlgorithmController {
    constructor(algorithmService) {
        this.algorithmService = algorithmService;
    }
    async channelAlgm(req) {
        let user = req.user;
        this.algorithmService.channelAlgm1(user);
    }
    async contactUpdateAlgm(contactId, req) {
        let user = req.user;
        this.algorithmService.channelAlgm1(user);
    }
    async productAlgm(contactId, req) {
        let user = { contactId: contactId, channelId: req.user.channelId, channelTypeId: req.user.channelTypeId, profileTypeId: req.user.profileTypeId };
        return this.algorithmService.productAlgm(user);
    }
    async channelUpdateAlgmAdmin(req) {
        if (req.body) {
            this.algorithmService.channelAlgm1(req.body);
            return true;
        }
        else {
            return false;
        }
    }
};
__decorate([
    common_1.Get('channel'),
    __param(0, common_1.Req()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], AlgorithmController.prototype, "channelAlgm", null);
__decorate([
    common_1.Get('channel/:contactId'),
    __param(0, common_1.Param('contactId')), __param(1, common_1.Req()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], AlgorithmController.prototype, "contactUpdateAlgm", null);
__decorate([
    common_1.Get('product/:contactId'),
    __param(0, common_1.Param('contactId')), __param(1, common_1.Req()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], AlgorithmController.prototype, "productAlgm", null);
__decorate([
    common_1.Post('channel/admin'),
    __param(0, common_1.Req()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], AlgorithmController.prototype, "channelUpdateAlgmAdmin", null);
AlgorithmController = __decorate([
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    common_1.Controller('algorithm'),
    __metadata("design:paramtypes", [algorithm_service_1.AlgorithmService])
], AlgorithmController);
exports.AlgorithmController = AlgorithmController;
//# sourceMappingURL=algorithm.controller.js.map