"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppModule = void 0;
const common_1 = require("@nestjs/common");
const config_1 = require("@nestjs/config");
const app_controller_1 = require("./app.controller");
const app_service_1 = require("./app.service");
const database_module_1 = require("./core/database/database.module");
const auth_module_1 = require("./modules/auth/auth.module");
const context_module_1 = require("./context/context.module");
const channel_module_1 = require("./modules/channel/channel.module");
const user_module_1 = require("./modules/user/user.module");
const media_module_1 = require("./modules/media/media.module");
const order_module_1 = require("./modules/order/order.module");
const common_module_1 = require("./modules/common/common.module");
const product_module_1 = require("./modules/product/product.module");
const account_module_1 = require("./modules/account/account.module");
const notification_module_1 = require("./modules/notification/notification.module");
const hubspot_module_1 = require("./hubspot/hubspot.module");
const activity_module_1 = require("./modules/activity/activity.module");
const core_1 = require("@nestjs/core");
const http_error_filter_1 = require("./shared/http-error.filter");
const logging_interceptor_1 = require("./shared/logging.interceptor");
const emailer_module_1 = require("./modules/emailer/emailer.module");
const validation_pipe_1 = require("./middleware/pipe/validation.pipe");
const admin_module_1 = require("./modules/admin/admin.module");
const platform_express_1 = require("@nestjs/platform-express");
const algorithm_module_1 = require("./algorithm/algorithm.module");
const meeting_module_1 = require("./modules/meeting/meeting.module");
const cart_module_1 = require("./modules/cart/cart.module");
const wishlist_module_1 = require("./modules/wishlist/wishlist.module");
const walletRecharge_module_1 = require("./modules/walletRecharge/walletRecharge.module");
const mailerservice_module_1 = require("./mailerservice/mailerservice.module");
const complain_module_1 = require("./complains/complain.module");
const error_module_1 = require("./error/error.module");
const report_module_1 = require("./modules/report/report.module");
let AppModule = class AppModule {
};
AppModule = __decorate([
    common_1.Module({
        imports: [
            config_1.ConfigModule.forRoot({ isGlobal: true }),
            database_module_1.DatabaseModule,
            context_module_1.ContextModule,
            auth_module_1.AuthModule,
            channel_module_1.ChannelModule,
            user_module_1.UserModule,
            media_module_1.MediaModule,
            order_module_1.OrderModule,
            common_module_1.CommonModule,
            product_module_1.ProductModule,
            account_module_1.AccountModule,
            notification_module_1.NotificationModule,
            hubspot_module_1.HubspotModule,
            activity_module_1.ActivityModule,
            emailer_module_1.EmailerModule,
            admin_module_1.AdminModule,
            meeting_module_1.MeetingModule,
            cart_module_1.CartModule,
            platform_express_1.MulterModule.register({
                dest: './upload_files'
            }),
            algorithm_module_1.AlgorithmModule,
            wishlist_module_1.WishlistModule,
            walletRecharge_module_1.WalletRechargeModule,
            mailerservice_module_1.MailerserviceModule,
            complain_module_1.ComplainModule,
            error_module_1.ErrorModule,
            report_module_1.ReportModule
        ],
        controllers: [app_controller_1.AppController],
        providers: [app_service_1.AppService,
            {
                provide: core_1.APP_FILTER,
                useClass: http_error_filter_1.HttpErrorFilter,
            },
            {
                provide: core_1.APP_INTERCEPTOR,
                useClass: logging_interceptor_1.LoggingInterceptor,
            },
            {
                provide: core_1.APP_PIPE,
                useClass: validation_pipe_1.ValidationPipe,
            }
        ],
    })
], AppModule);
exports.AppModule = AppModule;
//# sourceMappingURL=app.module.js.map