'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComplainAdminController = void 0;
const common_1 = require("@nestjs/common");
const complain_service_1 = require("../service/complain.service");
const core_1 = require("../../core");
const complainAction_dto_1 = require("../dto/complainAction.dto");
const paginationTransformation_1 = require("../../core/transformation/paginationTransformation");
const complain_dto_1 = require("../dto/complain.dto");
let ComplainAdminController = class ComplainAdminController extends core_1.BaseController {
    constructor(complainService) {
        super();
        this.complainService = complainService;
        this.paginationTransform = new paginationTransformation_1.PaginationTransform();
    }
    async getComplainList(req, res, dto) {
        let pagination = {
            limit: dto.limit,
            offset: dto.offset,
            search: dto.search
        };
        let sort = (req.query.sort && ['asc', 'desc'].includes(req.query.sort.toLowerCase())) ? req.query.sort.toLowerCase() : 'desc';
        let result = await this.complainService.getComplain(dto, sort);
        res.status(common_1.HttpStatus.OK).json(this.paginationTransform.make(result.rows, pagination, result.count, result.aggregations));
    }
    async setComplainAction(complainId, req, res, complainActionDto) {
        let user = req.user;
        const result = await this.complainService.setComplainAction(user, complainId, complainActionDto);
        return res.status(common_1.HttpStatus.OK).json(result);
    }
    async getComplainCategoryByComplainType(complaintype, req, res) {
        const result = await this.complainService.getComplainCategoryByComplainType(complaintype);
        return res.status(common_1.HttpStatus.OK).json(result);
    }
    async setComplain(req, res, channelApprovalDto) {
        let user = req.user;
        const result = await this.complainService.setComplain(user, channelApprovalDto);
        return res.status(common_1.HttpStatus.OK).json(result);
    }
};
__decorate([
    common_1.Post('/'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body(new common_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ComplainAdminController.prototype, "getComplainList", null);
__decorate([
    common_1.Post('/action/:complainId'),
    __param(0, common_1.Param('complainId')), __param(1, common_1.Request()), __param(2, common_1.Response()), __param(3, common_1.Body(new common_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object, complainAction_dto_1.ComplainActionDto]),
    __metadata("design:returntype", Promise)
], ComplainAdminController.prototype, "setComplainAction", null);
__decorate([
    common_1.Get('/:complaintype'),
    __param(0, common_1.Param('complaintype')), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ComplainAdminController.prototype, "getComplainCategoryByComplainType", null);
__decorate([
    common_1.Post('/complain'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body(new common_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, complain_dto_1.ComplainDto]),
    __metadata("design:returntype", Promise)
], ComplainAdminController.prototype, "setComplain", null);
ComplainAdminController = __decorate([
    common_1.Controller('master'),
    __metadata("design:paramtypes", [complain_service_1.ComplainService])
], ComplainAdminController);
exports.ComplainAdminController = ComplainAdminController;
//# sourceMappingURL=complain.admin.controller.js.map