'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComplainController = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("../../core");
const complain_service_1 = require("../service/complain.service");
const complain_dto_1 = require("../dto/complain.dto");
const passport_1 = require("@nestjs/passport");
let ComplainController = class ComplainController extends core_1.BaseController {
    constructor(complainService) {
        super();
        this.complainService = complainService;
    }
    async getComplainCategoryByComplainType(complaintype, req, res) {
        const result = await this.complainService.getComplainCategoryByComplainType(complaintype);
        return res.status(common_1.HttpStatus.OK).json(result);
    }
    async setComplain(req, res, channelApprovalDto) {
        let user = req.user;
        const result = await this.complainService.setComplain(user, channelApprovalDto);
        return res.status(common_1.HttpStatus.OK).json(result);
    }
};
__decorate([
    common_1.Get('/category/:complaintype'),
    __param(0, common_1.Param('complaintype')), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ComplainController.prototype, "getComplainCategoryByComplainType", null);
__decorate([
    common_1.Post('/'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body(new common_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, complain_dto_1.ComplainDto]),
    __metadata("design:returntype", Promise)
], ComplainController.prototype, "setComplain", null);
ComplainController = __decorate([
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    common_1.Controller('complain'),
    __metadata("design:paramtypes", [complain_service_1.ComplainService])
], ComplainController);
exports.ComplainController = ComplainController;
//# sourceMappingURL=complain.controller.js.map