"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComplainDto = exports.ChannelType = exports.ComplainType = void 0;
const class_validator_1 = require("class-validator");
const class_transformer_1 = require("class-transformer");
const compalainDocument_dto_1 = require("./compalainDocument.dto");
var ComplainType;
(function (ComplainType) {
    ComplainType[ComplainType["ContactType"] = 0] = "ContactType";
    ComplainType[ComplainType["Complaint"] = 1] = "Complaint";
    ComplainType[ComplainType["IPR"] = 2] = "IPR";
})(ComplainType = exports.ComplainType || (exports.ComplainType = {}));
var ChannelType;
(function (ChannelType) {
    ChannelType[ChannelType["GUEST"] = 0] = "GUEST";
    ChannelType[ChannelType["HUB"] = 1] = "HUB";
    ChannelType[ChannelType["VENDOR"] = 2] = "VENDOR";
    ChannelType[ChannelType["DISTRIBUTOR"] = 3] = "DISTRIBUTOR";
    ChannelType[ChannelType["RETAILER"] = 4] = "RETAILER";
    ChannelType[ChannelType["SALESREP"] = 5] = "SALESREP";
    ChannelType[ChannelType["SIGNUP"] = 6] = "SIGNUP";
})(ChannelType = exports.ChannelType || (exports.ChannelType = {}));
class ComplainDto {
}
__decorate([
    class_validator_1.IsNotEmpty({ message: "complain:complainttype:shouldNotEmpty" }),
    class_validator_1.IsString({ message: "complain:complainttype:shouldbeString" }),
    class_validator_1.IsEnum(ComplainType, { message: "Please choose anyone ComplainType from the list ( ContactType, Complaint, IPR)" }),
    __metadata("design:type", String)
], ComplainDto.prototype, "complainttype", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNumber({}, { message: "complain:channelid:shouldBeNumber" }),
    __metadata("design:type", Number)
], ComplainDto.prototype, "channelid", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNumber({}, { message: "complain:userid:shouldBeNumber" }),
    __metadata("design:type", Number)
], ComplainDto.prototype, "userid", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "complain:channeltype:shouldNotEmpty" }),
    class_validator_1.IsString({ message: "complain:channeltype:shouldbeString" }),
    class_validator_1.IsEnum(ChannelType, { message: "Please choose anyone ChannelType from the list ( GUEST, HUB, VENDOR, DISTRIBUTOR, RETAILER , SALESREP, SIGNUP )" }),
    __metadata("design:type", String)
], ComplainDto.prototype, "channeltype", void 0);
__decorate([
    class_validator_1.IsString({ message: "complain:firstname:shouldbeString" }),
    class_validator_1.IsNotEmpty({ message: "complain:firstname:shouldNotEmpty" }),
    __metadata("design:type", String)
], ComplainDto.prototype, "firstname", void 0);
__decorate([
    class_validator_1.IsString({ message: "complain:lastname:shouldbeString" }),
    class_validator_1.IsNotEmpty({ message: "complain:lastname:shouldNotEmpty" }),
    __metadata("design:type", String)
], ComplainDto.prototype, "lastname", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "complain:email:shouldNotEmpty" }),
    class_validator_1.IsString({ message: "complain:email:shouldbeString" }),
    __metadata("design:type", String)
], ComplainDto.prototype, "email", void 0);
__decorate([
    class_validator_1.IsString({ message: "complain:email:shouldbeString" }),
    class_validator_1.IsOptional(),
    __metadata("design:type", String)
], ComplainDto.prototype, "phoneno", void 0);
__decorate([
    class_validator_1.IsString({ message: "complain:email:shouldbeString" }),
    class_validator_1.IsOptional(),
    __metadata("design:type", String)
], ComplainDto.prototype, "mobileno", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "complain:countryid:shouldNotEmpty" }),
    class_validator_1.IsNumber({}, { message: "complain:countryid:shouldBeNumber" }),
    __metadata("design:type", Number)
], ComplainDto.prototype, "countryid", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "complain:subject:shouldNotEmpty" }),
    class_validator_1.IsString({ message: "complain:subject:shouldbeString" }),
    class_validator_1.MaxLength(255, { message: "validate:field:validateMaxLength" }),
    __metadata("design:type", String)
], ComplainDto.prototype, "subject", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "complain:detaildesc:shouldNotEmpty" }),
    class_validator_1.IsString({ message: "complain:detaildesc:shouldbeString" }),
    class_validator_1.MaxLength(8000, { message: "validate:field:validateMaxLength" }),
    __metadata("design:type", String)
], ComplainDto.prototype, "detaildesc", void 0);
__decorate([
    class_validator_1.IsString({ message: "complain:iprurl:shouldbeString" }),
    class_validator_1.IsOptional(),
    __metadata("design:type", String)
], ComplainDto.prototype, "iprurl", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "complain:complaintcategoryid:shouldNotEmpty" }),
    class_validator_1.IsNumber({}, { message: "complain:complaintcategoryid:shouldBeNumber" }),
    __metadata("design:type", Number)
], ComplainDto.prototype, "complaintcategoryid", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => compalainDocument_dto_1.CompalainDocumentDto),
    __metadata("design:type", Array)
], ComplainDto.prototype, "compalainDocument", void 0);
exports.ComplainDto = ComplainDto;
//# sourceMappingURL=complain.dto.js.map