"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ComplainsFilterDto = exports.ChannelType = exports.ComplainType = exports.ComplainActions = void 0;
const class_validator_1 = require("class-validator");
var ComplainActions;
(function (ComplainActions) {
    ComplainActions[ComplainActions["pending"] = 0] = "pending";
    ComplainActions[ComplainActions["replied"] = 1] = "replied";
    ComplainActions[ComplainActions["closed"] = 2] = "closed";
})(ComplainActions = exports.ComplainActions || (exports.ComplainActions = {}));
var ComplainType;
(function (ComplainType) {
    ComplainType[ComplainType["ContactType"] = 0] = "ContactType";
    ComplainType[ComplainType["Complaint"] = 1] = "Complaint";
    ComplainType[ComplainType["IPR"] = 2] = "IPR";
})(ComplainType = exports.ComplainType || (exports.ComplainType = {}));
var ChannelType;
(function (ChannelType) {
    ChannelType[ChannelType["GUEST"] = 0] = "GUEST";
    ChannelType[ChannelType["HUB"] = 1] = "HUB";
    ChannelType[ChannelType["VENDOR"] = 2] = "VENDOR";
    ChannelType[ChannelType["DISTRIBUTOR"] = 3] = "DISTRIBUTOR";
    ChannelType[ChannelType["RETAILER"] = 4] = "RETAILER";
    ChannelType[ChannelType["SALESREP"] = 5] = "SALESREP";
    ChannelType[ChannelType["SIGNUP"] = 6] = "SIGNUP";
})(ChannelType = exports.ChannelType || (exports.ChannelType = {}));
class ComplainsFilterDto {
}
__decorate([
    class_validator_1.IsNotEmpty({ message: "complain:complainttype:shouldNotEmpty" }),
    class_validator_1.IsString({ message: "complain:complainttype:shouldbeString" }),
    class_validator_1.IsEnum(ComplainType, { message: "Please choose anyone ComplainType from the list ( ContactType, Complaint, IPR)" }),
    __metadata("design:type", String)
], ComplainsFilterDto.prototype, "complainttype", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "validate:field:shouldBeArray" }),
    class_validator_1.IsEnum(ComplainActions, {
        each: true,
        message: "Please choose anyone status from the list ( pending, replied, closed )"
    }),
    __metadata("design:type", String)
], ComplainsFilterDto.prototype, "status", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "validate:field:shouldBeArray" }),
    class_validator_1.IsNumber({}, {
        each: true,
        message: "complain:complaintcategoryid:shouldBeNumber"
    }),
    __metadata("design:type", Number)
], ComplainsFilterDto.prototype, "complaintcategoryid", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "validate:field:shouldBeArray" }),
    class_validator_1.IsEnum(ChannelType, {
        each: true,
        message: "Please choose anyone ChannelType from the list ( GUEST, HUB, VENDOR, DISTRIBUTOR, RETAILER , SALESREP, SIGNUP )"
    }),
    __metadata("design:type", String)
], ComplainsFilterDto.prototype, "channeltype", void 0);
exports.ComplainsFilterDto = ComplainsFilterDto;
//# sourceMappingURL=complainsFilter.dto.js.map