'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Complain = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const ComplaintCategory_entity_1 = require("../models/ComplaintCategory.entity");
const ComplaintAttachment_entity_1 = require("../models/ComplaintAttachment.entity");
const ComplaintReplyContent_entity_1 = require("../models/ComplaintReplyContent.entity");
const Country_entity_1 = require("../../modules/common/models/Country.entity");
const User_entity_1 = require("../../modules/user/models/User.entity");
const Channel_entity_1 = require("../../modules/channel/models/Channel.entity");
const tableOptions = { timestamps: false, tableName: 'tblcomplaint' };
let Complain = class Complain extends sequelize_typescript_1.Model {
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Complain.prototype, "complaintid", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(150)),
    __metadata("design:type", String)
], Complain.prototype, "complaintnumber", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.ENUM('ContactType', 'Complaint', 'IPR')),
    __metadata("design:type", String)
], Complain.prototype, "complainttype", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Complain.prototype, "channelid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel),
    __metadata("design:type", Channel_entity_1.Channel)
], Complain.prototype, "channel", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => User_entity_1.User),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Complain.prototype, "userid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => User_entity_1.User),
    __metadata("design:type", User_entity_1.User)
], Complain.prototype, "user", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.ENUM('VENDOR', 'DISTRIBUTOR', 'RETAILER', 'SALESREP')),
    __metadata("design:type", String)
], Complain.prototype, "channeltype", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], Complain.prototype, "firstname", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Complain.prototype, "lastname", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Complain.prototype, "email", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Complain.prototype, "phoneno", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Complain.prototype, "mobileno", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Country_entity_1.Country),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Complain.prototype, "countryid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Country_entity_1.Country),
    __metadata("design:type", Country_entity_1.Country)
], Complain.prototype, "country", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], Complain.prototype, "subject", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(8000)),
    __metadata("design:type", String)
], Complain.prototype, "detaildesc", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Complain.prototype, "iprurl", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => ComplaintCategory_entity_1.ComplaintCategory),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Complain.prototype, "complaintcategoryid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => ComplaintCategory_entity_1.ComplaintCategory),
    __metadata("design:type", ComplaintCategory_entity_1.ComplaintCategory)
], Complain.prototype, "complaintcategory", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.ENUM('pending', 'replied', 'closed')),
    __metadata("design:type", String)
], Complain.prototype, "status", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Complain.prototype, "createdat", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Complain.prototype, "updatedat", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Complain.prototype, "deletedat", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ComplaintAttachment_entity_1.ComplaintAttachment, 'complaintid'),
    __metadata("design:type", ComplaintAttachment_entity_1.ComplaintAttachment)
], Complain.prototype, "complaintAttachment", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ComplaintReplyContent_entity_1.ComplaintReplyContent, 'complaintid'),
    __metadata("design:type", ComplaintReplyContent_entity_1.ComplaintReplyContent)
], Complain.prototype, "complaintReplyContent", void 0);
Complain = __decorate([
    sequelize_typescript_1.Table(tableOptions),
    sequelize_typescript_1.Scopes({
        baseDetail: {}
    })
], Complain);
exports.Complain = Complain;
//# sourceMappingURL=Complain.entity.js.map