import { Complain } from '../models/Complain.entity';
import { ComplaintAttachment } from '../models/ComplaintAttachment.entity';
import { ComplaintCategory } from '../models/ComplaintCategory.entity';
import { ComplainDto } from '../dto/complain.dto';
import { ComplaintReplyContent } from '../models/ComplaintReplyContent.entity';
import { ComplainActionDto } from '../dto/complainAction.dto';
import { BaseService } from 'src/core/service/base.service';
import { Media } from 'src/modules/media/models/Media.entity';
import { Channel } from 'src/modules/channel/models/Channel.entity';
import { User } from 'src/modules/user/models/User.entity';
export declare class ComplainService extends BaseService {
    private readonly complainRepository;
    private readonly complaintAttachmentRepository;
    private readonly complaintCategoryRepository;
    private readonly mediaRepository;
    private readonly channelRepository;
    private readonly userRepository;
    private readonly complaintReplyContentRepository;
    private readonly sequelizeInstance;
    constructor(complainRepository: typeof Complain, complaintAttachmentRepository: typeof ComplaintAttachment, complaintCategoryRepository: typeof ComplaintCategory, mediaRepository: typeof Media, channelRepository: typeof Channel, userRepository: typeof User, complaintReplyContentRepository: typeof ComplaintReplyContent, sequelizeInstance: any);
    getComplainCategoryByComplainType(complainType: string): Promise<any>;
    setComplain(user: any, complain: ComplainDto): Promise<any>;
    getCount(): Promise<any>;
    getComplain(dto: any, order?: any): Promise<any>;
    setComplainAction(user: any, complainId: number, complainActionDto: ComplainActionDto): Promise<any>;
}
