"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.appconstant = void 0;
exports.appconstant = {
    ADMINAPP: 'adminapp',
    CLIENTAPP: 'clientapp',
    SWAGGER_TITLE: 'Channel Hub',
    SWAGGER_DESCRIPTION: 'Channel Hub',
    SWAGGER_VERSION: '1.0.0',
    SWAGGER_TAG: 'ChannelHub',
    PREMIUM_PLAN_SUBSCRIPTION_ID: 30,
    pagination: {
        size: 10,
        max: 250,
        min: 1
    },
    CHANNELHUB_CURRENCY: 2,
    CHANNELHUB_CURRENCY_CODE: 'EUR',
    VERIFICATION: 1,
    REVERIFICATION: 2,
    REVERIFICATION_MAILCHANGE: 3,
    SUBSCRIPTION: 4,
    PAYMENT_PENDING: 5,
    PAYMENT_FAILURE: 6,
    ACCOUNTSETUP: 7,
    ACCOUNTSETUP_COMPANYPROFILE: 8,
    ACCOUNTSETUP_TRADEINFORMATION: 9,
    ACCOUNTSETUP_TRADELOCATION: 10,
    REQUEST_INTRO: 10,
    MAYBELATER: 11,
    CLAIM: 11,
    CLAIM_APPROVED: 12,
    CLAIM_REJECTED: 13,
    CHANNEL_APPROVAL: 14,
    CHANNEL_APPROVED: 15,
    REMOVE_CONFIDENTIAL: 16,
    DOCUMENTTYPE_IMAGE: 1,
    DOCUMENTTYPE_DOC: 2,
    DOCUMENTTYPE_VIDEO: 3,
    CHANNELHUB_CHANNEL_ID: 1,
    CHANNEL_TYPE_HUB: 1,
    CHANNEL_TYPE_VENDOR: 2,
    CHANNEL_TYPE_DISTRIBUTOR: 3,
    CHANNEL_TYPE_RETAILER: 4,
    CHANNEL_TYPE_RESELLER: 5,
    CHANNEL_TYPE_SIGNUP: 6,
    CERTIFICATETYPE_REGISTRATION: 1,
    CERTIFICATETYPE_TAX: 2,
    SOCIAL_SITE_TYPE_LINKEDIN: 1,
    SOCIAL_SITE_TYPE_GOOGLEPLUS: 2,
    SOCIAL_SITE_TYPE_INSTAGRAM: 3,
    SOCIAL_SITE_TYPE_TWITTER: 4,
    SOCIAL_SITE_TYPE_FACEBOOK: 5,
    FOLDER_PATH_PROFILE: 'profile',
    FOLDER_PATH_BRAND: 'brand',
    FOLDER_PATH_NEWS: 'news',
    FOLDER_PATH_CLAIM: 'claim',
    FOLDER_PATH_COMPANY_LOGO: 'company/logo',
    FOLDER_PATH_COMPANY_BANNER: 'company/banner',
    FOLDER_PATH_COMPANY_ICON: 'company/icon',
    FOLDER_PATH_CONNECTIONVIDEOS: 'connectionVideos',
    PROFILE_TYPE_BROADLINER: 3,
    FRONTEND_PROFILE_URI: 'account/(accountroute:profile)/',
    FRONTEND_SUB_LANDING_URI: 'user/landing',
    FRONTEND_ACCOUNT_SETUP_URI: 'profile/(profileroute:companyprofile)/',
    FRONTEND_DASHBOARD_URL: 'dashboard',
    FRONTEND_PROFILE_URL: 'profile',
    FRONTEND_CHANNEL_DETAIL_VIEW_BO_URL: 'customers/channel/channel-detail-view',
    FRONTEND_CHANNEL_DETAIL_VIEW_FO_URL: 'channel/channelView',
    FOLDER_PATH_PRODUCT_ARTICLE: 'product/article',
    FOLDER_PATH_PRODUCT_AWARDS: 'product/awards',
    FOLDER_PATH_PRODUCT_IMAGE: 'product/image',
    FOLDER_PATH_PRODUCT_DISPLAY_IMAGE: 'product/display',
    FOLDER_PATH_PRODUCT_PACKING_IMAGE: 'product/packing',
    FOLDER_PATH_PRODUCT_BROUCHER: 'product/broucher',
    FOLDER_PATH_CHANNEL_KEY_RETAILER_IMAGE: 'channel/keypartners',
    PRODUCT_IMAGE_TYPE: 'Image',
    PRODUCT_DISPLAY_IMAGE_TYPE: 'Display',
    PRODUCT_PACKING_IMAGE_TYPE: 'Packing',
    PRODUCT_BROUCHER_IMAGE_TYPE: 'Broucher',
    LOCATION_TYPE_SELLING: 'SELLING',
    LOCATION_TYPE_TARGET: 'TARGET',
    LOCATION_TYPE_RETAIL: 'RETAIL',
    FOLDER_PATH_PRODUCT_RETAILER: 'product/retailer',
    SOCKET_NAME_SPACE: ['notification'],
    USER_PRODUCTS_ACCESS_ID: '42',
    USER_MY_PRODUCTS_ACCESS_ID: '50',
    USER_PRODUCTS_IMAGE_RESTRICT_ID: '29',
    USER_PRODUCTS_VIDEO_RESTRICT_ID: '30',
    MYSUGGESTION: 1,
    PENDINGMYPROSPECT: 7,
    MYPROSPECT: 2,
    PENDINGAPPROVAL: 3,
    MYCHANNEL: 4,
    DISMISS: 5,
    DISMISS_OTHER_REASON: 6,
    MY_CHANNEL_REJECTED: 6,
    FREE_PLANID: 1,
    FOLDER_PATH_SPOTDEAL: 'spotdeal',
    MESSAGE_FORMATE_CONTACTIDS: {
        MAILMESSAGE: 'MAIL_MESSAGE',
        ADDTOPROSPECTS: 'ADD_TO_PROSPECTS',
        REQUEST_TO_MYCHANNEL: 'REQUEST_TO_MYCHANNEL',
        MYCHANNEL_APPROVAL: 'MYCHANNEL_APPROVAL',
        MYCHANNEL_DECLINE: 'MYCHANNEL_DECLINE',
        DISMISS_CHANNEL: 'DISMISS_CHANNEL',
        CHANGE_OF_CONTACT: 'CHANGE_OF_CONTACT',
        RATING: 'RATING',
        MESSAGING: 'MESSAGING',
        NOT_INTEREST_IN_THIS_PRODUCT: 'NOT_INTEREST_IN_THIS_PRODUCT',
        NOT_INTEREST_IN_THIS_PRODUCT_AF_EVA: 'NOT_INTEREST_IN_THIS_PRODUCT_AF_EVA',
        ORDER_CHECKOUT: 'ORDER_CHECKOUT',
        ORDER_APPROVAL: 'ORDER_APPROVAL',
        ORDER_PAID: 'ORDER_PAID',
        ORDER_CANCEL: 'ORDER_CANCEL',
        ORDER_PACKED: 'ORDER_PACKED',
        ORDER_SHIPPED: 'ORDER_SHIPPED',
        ORDER_DELIVERED: 'ORDER_DELIVERED',
        ORDER_EVALUATED: 'ORDER_EVALUATED',
        ORDER_REFUND_APPROVED: 'ORDER_REFUND_APPROVED',
        ORDER_REFUND_REJECTED: 'ORDER_REFUND_REJECTED',
        ORDER_REFUND_CANCEL: 'ORDER_REFUND_CANCEL',
        ORDER_RE_CREATION: 'ORDER_RE_CREATION',
        ORDER_TRANSFER: 'ORDER_TRANSFER',
        ORDER_RE_TRANSFER: 'ORDER_RE_TRANSFER',
        ORDER_MAIL_INVOICE: 'ORDER_MAIL_INVOICE',
        COMPLAINTS: 'COMPLAINTS',
        CHANNEL_APPROVED: 'CHANNEL_APPROVED',
        CHANNEL_REJECT: 'CHANNEL_REJECT',
        SUGGESTION_CHANNEL: 'SUGGESTION_CHANNEL',
        SUGGESTION_PRODUCT: 'SUGGESTION_PRODUCT',
        ORDER_REFUND_PENDDING: 'ORDER_REFUND_PENDDING',
        COMPLAINTS_REPLAY: 'COMPLAINTS_REPLAY',
        CHANNEL_APPROVAL_PENDING: 'CHANNEL_APPROVAL_PENDING',
        CLAIM_APPROVED: 'CLAIM_APPROVED',
        CLAIM_REJECTED: 'CLAIM_REJECTED',
        CHANNEL_RECOMMENDED: 'CHANNEL_RECOMMENDED',
        REQUEST_TO_MYPROSPECT: 'REQUEST_TO_MYPROSPECT',
        REQUEST_TO_MYPROSPECT_REMAINDER: 'REQUEST_TO_MYPROSPECT_REMAINDER',
        MYPROSPECT_APPROVAL: 'MYPROSPECT_APPROVAL',
        MYPROSPECT_DECLINE: 'MYPROSPECT_DECLINE',
        PRODUCT_READY_FOR_BUSSINESS: 'PRODUCT_READY_FOR_BUSSINESS',
        CHANNEL_INVITATION: 'CHANNEL_INVITATION',
        CHANNEL_INVITATION_VERIFY: 'CHANNEL_INVITATION_VERIFY',
        CHANNEL_INVITATION_REMAINDER: 'CHANNEL_INVITATION_REMAINDER',
        MAYBE_LATER: "MAYBE_LATER",
        DEACTIVATE_CHANNEL: "DEACTIVATE_CHANNEL"
    },
    MESSAGE_TYPE: {
        PROMOTION: 1,
        SUGGESTION: 2,
        COMMUNICATION: 3,
        ACTION: 4,
    },
    UNIVERSAL_CODE_TYPE: [
        'UPC', 'EAN', 'HSN'
    ],
    DISCOUNT_UNIT_PERCENTAGE: 2,
    CHANNEL_DISTRIBUTOR_CONNECTION_TYPE_ID: 4,
    PROFILE_TYPE_DISTRIBUTOR: 'DISTRIBUTOR',
    PROFILE_TYPE_RETAILER: 'RETAILER',
    ORDER_STATUS_PENDING_CONFIRMATION: 1,
    ORDER_STATUS_PENDING_APPROVAL: 2,
    ORDER_STATUS_PENDING_PACKING: 3,
    ORDER_STATUS_PENDING_SHIPPING: 4,
    ORDER_STATUS_PENDING_DELIVERY: 5,
    ORDER_STATUS_PENDING_EVALUATION: 6,
    ORDER_STATUS_EVALUATED: 7,
    ORDER_STATUS_PENDING_REFUND: 8,
    ORDER_STATUS_REFUNDED: 9,
    ORDER_STATUS_CANCELED_REFUND: 10,
    ORDER_STATUS_CANCELED: 11,
    ORDER_DISCOUNT_PERCENTAGE: 2,
    ORDER_GRAND_TOTAL_AMOUNT_LIMIT: 900000,
    DEFAULT_CURRENCY: 2,
    PRODUCT_QUALITY_LEVEL_TYPE: 'Entry, Mid, High',
    AUTO_RENEWAL_TRACKING_STATUS: {
        NEW: 1,
        PROCESSING: 2,
        COMPLETED: 3,
        FAILED: 4
    },
    AUTO_RENEWAL_REMINDER: 6,
    MAX_ALLOWED_QTY_FOR_UNLIMITED: 100,
    SOURCING_CONTACT: [
        1,
    ],
    SELLING_CONTACT: [
        2,
        3,
    ],
    OTHER_CONTACT: [
        4,
        5,
        6,
        7
    ],
    FOLDER_PATH_LANGUAGE: 'i18n',
    FOLDER_PATH_COMPANY_DOCUMENT: 'company/document',
    VAT_PERCENTAGE: 20,
    FOLDER_PATH_PRODUCT_EXISTING_RATING_LOGO: 'product/existingRatingLogo',
    CONTACT_TYPE_SENDER: 'SENDER',
    CONTACT_TYPE_RECEIVER: 'RECEIVER',
    CONTACT_TYPE_BO: 'BO',
    SANITIZE_HTML: {
        allowedTags: ['h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'blockquote', 'p', 'a', 'ul', 'ol',
            'nl', 'li', 'b', 'i', 'strong', 'em', 'strike', 'code', 'hr', 'br', 'div',
            'table', 'thead', 'caption', 'tbody', 'tr', 'th', 'td', 'pre', 'u', 's', 'pre', 'sup'],
        allowedAttributes: false,
        allowedSchemes: ['http', 'https', 'mailto'],
    },
    VISIBILITY_SHARED: '1',
    VISIBILITY_CONFIDENCIAL: '0',
    VISIBILITY: {
        2: ['1', '2', '3', '4'],
        3: ['1', '2', '3', '4'],
        4: ['1', '2', '3', '4'],
        5: ['1', '2', '3', '4'],
    },
    CHANNELTYPES: {
        1: 'HUB',
        2: 'VENDOR',
        3: 'DISTRIBUTOR',
        4: 'RETAILER',
        5: 'SALESREP',
        6: 'SIGNUP',
    },
    SIGNUPSTATUS: {
        1: 'VERIFICATION',
        2: 'REVERIFICATION',
        3: 'REVERIFICATION_MAILCHANGE',
        4: 'SUBSCRIPTION',
        5: 'PAYMENT_PENDING',
        6: 'PAYMENT_FAILURE',
        7: 'ACCOUNTSETUP',
        8: 'ACCOUNTSETUP_COMPANYPROFILE',
        9: 'ACCOUNTSETUP_TRADEINFORMATION',
        10: 'ACCOUNTSETUP_TRADELOCATION',
        11: 'CLAIM',
        12: 'CLAIM_APPROVED',
        13: 'CLAIM_REJECTED',
        14: 'CHANNEL_APPROVAL',
        15: 'CHANNEL_APPROVED',
    },
    SEARCH_ALLOWED_TYPES: {
        2: [3, 4],
        3: [2, 4],
        4: [3, 2]
    },
    INVITATION_REMAINDER: {
        INTERVAL: +process.env.INVITATION_REMAINDER_INTERVAL,
        NO_OF_TIMES: +process.env.INVITATION_REMAINDER_NO_OF_TIMES
    },
    CONNECTION_REMAINDER: {
        INTERVAL: +process.env.CONNECTION_REMAINDER_INTERVAL,
        NO_OF_TIMES: +process.env.CONNECTION_REMAINDER_NO_OF_TIMES
    },
    EMAIL_LOG: process.env.EMAIL_LOG,
    EMAIL_BCC: [
        process.env.EMAIL_BCC,
        process.env.HUBSPOT_ALL_BCC
    ],
    PAYMENT_METHOD: {
        'ONLINE_CREDIT_DEBIT_CART': 1,
        'OFFLINE_WIRE_TRANSFER': 2,
        'PAYPAL_TRANSFER': 3,
        'STRIPE_ALIPAY': 4
    },
    shareTypeId: {
        2: 1,
        3: 2,
        4: 3
    },
    SubscriptionCharcteristicFeature: {
        'PROFILE_PUBLIC_VIEW': 22,
        'PRODUCT_CH_HOMEPAGE': 23,
        'COMPANY_FEATURE_BRAND_HOMEPAGE': 24,
        'PRODUCT_ON_CATLOG_LISTING': 25,
        'PRODUCT_ON_SOCIALMEDIA': 26,
        'PRODUCT_IN_SUGGESTION_TO_BUYER': 27,
        'SOCIAL_SHARING': 28,
        'NO_OF_PRODUCT': 29,
        'BUYING_SEND_CONNECTION_REQUEST': 30,
        'ACCESS_TO_DATABASE': 31,
        'SUGGESTION_BUYER': 32,
        'SAVE_PROFILE_TO_FAVOURITE': 33,
        'FAVOURITE_BUYER_INVITE_FOR_EVENT': 34,
        'FAVOURITE_BUYER_NOTIFY_WHEN_CONNECT_TO_ACCOUNT': 35,
        'DASHBOARD_PROFILE_PRODUCT': 36,
        'FOLLOW_THIS_BRAND': 37,
        'ADD_USER': 38,
        'DEDICATE_ACCOUNT_MANAGER': 39
    }
};
//# sourceMappingURL=app.constant.js.map