'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
exports.ratelimiter = exports.bullredis = void 0;
exports.bullredis = {
    OPTIONS: {
        redis: {
            port: +process.env.REDIS_PORT,
            host: process.env.REDIS_HOST,
            retry_strategy: function (options) {
                if (options.total_retry_time > 1000 * 60 * 60) {
                    return new Error('Retry time exhausted');
                }
                if (options.attempt > 10) {
                    return undefined;
                }
                return Math.min(options.attempt * 100, 3000);
            }
        },
    }
};
exports.ratelimiter = {
    OPTIONS: {
        redis: {
            port: +process.env.REDIS_PORT,
            host: process.env.REDIS_HOST,
            retry_strategy: function (options) {
                if (options.total_retry_time > 1000 * 60 * 60) {
                    return new Error('Retry time exhausted');
                }
                if (options.attempt > 10) {
                    return undefined;
                }
                return Math.min(options.attempt * 100, 3000);
            }
        },
        limiter: {
            max: 5,
            duration: 60000,
            bounceBack: false
        }
    }
};
//# sourceMappingURL=bullredis.constant.js.map