'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
exports.esearch = void 0;
exports.esearch = {
    SUGGEST_QUEUE_NAME: 'es-suggest',
    SUGGEST_TABLE_QUEUE_NAME: 'es-tblchannelsuggestions',
    SUGGEST_TABLE_PROCESSING_QUEUE_NAME: 'es-pending-suggestion',
    MAIL_QUEUE_NAME: 'email-queue',
    FREE_AUTO_RENEWAL: 'channel-free-auto-renewal',
    QUEUE_NAME: 'elasticsearch',
    suggestionTypes: {
        2: [
            { type: 'DISTRIBUTOR', type_id: 3, shareTypeId: 1, suggestionId: 8, limit: 50 },
            { type: 'RETAILER', type_id: 4, shareTypeId: 1, suggestionId: 8, limit: 50 }
        ],
        3: [
            { type: 'VENDOR', type_id: 2, shareTypeId: 2, suggestionId: 5, limit: 50 },
            { type: 'RETAILER', type_id: 4, shareTypeId: 2, suggestionId: 8, limit: 50 }
        ],
        4: [
            { type: 'VENDOR', type_id: 2, shareTypeId: 3, suggestionId: 5, limit: 50 },
            { type: 'DISTRIBUTOR', type_id: 3, shareTypeId: 3, suggestionId: 5, limit: 50 }
        ]
    },
    inBoundRequest: {
        2: [
            { type: 'DISTRIBUTOR_INB', type_id: 3, suggestionId: 74 },
            { type: 'RETAILER_INB', type_id: 4, suggestionId: 74 },
        ],
        3: [
            { type: 'VENDOR_INB', type_id: 2, suggestionId: 74 },
            { type: 'RETAILER_INB', type_id: 4, suggestionId: 74 },
        ],
        4: [
            { type: 'VENDOR_INB', type_id: 2, suggestionId: 74 },
            { type: 'DISTRIBUTOR_INB', type_id: 3, suggestionId: 74 },
        ]
    },
    outBoundRequest: {
        2: [
            { type: 'DISTRIBUTOR_OTB', type_id: 3, suggestionId: 76 },
            { type: 'RETAILER_OTB', type_id: 4, suggestionId: 76 }
        ],
        3: [
            { type: 'VENDOR_OTB', type_id: 2, suggestionId: 77 },
            { type: 'RETAILER_OTB', type_id: 4, suggestionId: 79 }
        ],
        4: [
            { type: 'VENDOR_OTB', type_id: 2, suggestionId: 77 },
            { type: 'DISTRIBUTOR_OTB', type_id: 3, suggestionId: 81 }
        ]
    },
    suggestionIds: {
        'INBOUND': 74,
        'OUTBOUND': {
            2: {
                3: 76,
                4: 76
            },
            3: {
                2: 77,
                4: 79
            },
            4: {
                2: 77,
                3: 81
            }
        }
    },
    shareTypeId: {
        2: 1,
        3: 2,
        4: 3
    },
    brand: {
        BATCH_LIST_NAME: 'elastic_brand_batch',
        BATCH_SIZE: 50,
        INDEX_NAME: 'brand',
        INDEX_ID_FIELD: 'id'
    },
    company: {
        BATCH_LIST_NAME: 'elastic_company_batch',
        INDEX_NAME: 'company',
        BATCH_SIZE: 25,
        INDEX_ID_FIELD: 'channelId'
    },
    product: {
        BATCH_LIST_NAME: 'elastic_product_batch',
        BATCH_SIZE: 50,
        INDEX_NAME: 'product',
        INDEX_ID_FIELD: 'productId'
    }
};
//# sourceMappingURL=esearch.js.map