export interface INotificationConfigAttributes {
    formatContact: any;
    messageType: number;
    mail: boolean;
    socket: boolean;
    recipients: {
        requested: INotificationUser | null;
        receiver: INotificationUser | null;
    };
}
export interface INotificationEnvironmentConfig {
    SUGGESTION_CHANNEL: INotificationConfigAttributes;
    SUGGESTION_PRODUCT: INotificationConfigAttributes;
    ADDTOPROSPECTS: INotificationConfigAttributes;
    REQUEST_TO_MYCHANNEL: INotificationConfigAttributes;
    REQUEST_TO_MYPROSPECT: INotificationConfigAttributes;
    REQUEST_TO_MYPROSPECT_REMAINDER: INotificationConfigAttributes;
    MYPROSPECT_APPROVAL: INotificationConfigAttributes;
    MYPROSPECT_DECLINE: INotificationConfigAttributes;
    MYCHANNEL_APPROVAL: INotificationConfigAttributes;
    MYCHANNEL_DECLINE: INotificationConfigAttributes;
    DISMISS_CHANNEL: INotificationConfigAttributes;
    CHANGE_OF_CONTACT: INotificationConfigAttributes;
    RATING: INotificationConfigAttributes;
    MESSAGING: INotificationConfigAttributes;
    NOT_INTEREST_IN_THIS_PRODUCT: INotificationConfigAttributes;
    NOT_INTEREST_IN_THIS_PRODUCT_AF_EVA: INotificationConfigAttributes;
    ORDER_CHECKOUT: INotificationConfigAttributes;
    ORDER_APPROVAL: INotificationConfigAttributes;
    ORDER_PAID: INotificationConfigAttributes;
    ORDER_CANCEL: INotificationConfigAttributes;
    ORDER_PACKED: INotificationConfigAttributes;
    ORDER_SHIPPED: INotificationConfigAttributes;
    ORDER_DELIVERED: INotificationConfigAttributes;
    ORDER_REFUND_APPROVED: INotificationConfigAttributes;
    ORDER_REFUND_REJECTED: INotificationConfigAttributes;
    ORDER_REFUND_PENDDING: INotificationConfigAttributes;
    ORDER_RE_CREATION: INotificationConfigAttributes;
    ORDER_TRANSFER: INotificationConfigAttributes;
    ORDER_RE_TRANSFER: INotificationConfigAttributes;
    ORDER_MAIL_INVOICE: INotificationConfigAttributes;
    COMPLAINTS: INotificationConfigAttributes;
    CHANNEL_APPROVED: INotificationConfigAttributes;
    CHANNEL_REJECT: INotificationConfigAttributes;
    CONTACT_MAIL: INotificationConfigAttributes;
    ORDER_EVALUATED: INotificationConfigAttributes;
    MAILMESSAGE: INotificationConfigAttributes;
    COMPLAINTS_REPLAY: INotificationConfigAttributes;
    ORDER_REFUND_CANCEL: INotificationConfigAttributes;
    CHANNEL_APPROVAL_PENDING: INotificationConfigAttributes;
    CLAIM_APPROVED: INotificationConfigAttributes;
    CLAIM_REJECTED: INotificationConfigAttributes;
    CHANNEL_RECOMMENDATION: INotificationConfigAttributes;
    PRODUCT_READY_FOR_BUSSINESS: INotificationConfigAttributes;
    CHANNEL_INVITATION: INotificationConfigAttributes;
    CHANNEL_INVITATION_VERIFY: INotificationConfigAttributes;
    CHANNEL_INVITATION_REMAINDER: INotificationConfigAttributes;
    MAYBE_LATER: INotificationConfigAttributes;
    DEACTIVATE_CHANNEL: INotificationConfigAttributes;
}
export interface INotificationUser {
    requesteduser?: boolean;
    receiveruser?: boolean;
    company?: boolean;
    accountowner?: boolean;
    reportinguser?: boolean;
    channelsuperadmin?: boolean;
    channelaccountowner?: boolean;
}
export declare const notification: INotificationEnvironmentConfig;
export declare const socketEvent: {
    EVENT: string;
};
