'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
exports.socketEvent = exports.notification = void 0;
const app_constant_1 = require("../config/app.constant");
exports.notification = {
    MAILMESSAGE: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.MAILMESSAGE,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: false,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: false,
                reportinguser: false,
            }
        }
    },
    SUGGESTION_CHANNEL: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.SUGGESTION_CHANNEL,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.SUGGESTION,
        mail: false,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            }
        }
    },
    SUGGESTION_PRODUCT: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.SUGGESTION_PRODUCT,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.SUGGESTION,
        mail: false,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: true,
                reportinguser: true,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: true,
                reportinguser: true,
            }
        }
    },
    ADDTOPROSPECTS: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.ADDTOPROSPECTS,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: false,
        socket: false,
        recipients: {
            requested: {
                requesteduser: false,
                company: false,
                accountowner: false,
                reportinguser: false,
            },
            receiver: {
                receiveruser: false,
                company: false,
                accountowner: false,
                reportinguser: false,
            }
        }
    },
    REQUEST_TO_MYPROSPECT: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.REQUEST_TO_MYPROSPECT,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: {
                requesteduser: false,
                company: false,
                accountowner: false,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: false,
                reportinguser: false,
            }
        }
    },
    MAYBE_LATER: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.MAYBE_LATER,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: {
                requesteduser: false,
                company: false,
                accountowner: false,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: false,
                reportinguser: false,
            }
        }
    },
    DEACTIVATE_CHANNEL: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.DEACTIVATE_CHANNEL,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: {
                requesteduser: false,
                company: false,
                accountowner: false,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: false,
                reportinguser: false,
            }
        }
    },
    REQUEST_TO_MYPROSPECT_REMAINDER: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.REQUEST_TO_MYPROSPECT_REMAINDER,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: {
                requesteduser: false,
                company: false,
                accountowner: false,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: false,
                reportinguser: false,
            }
        }
    },
    MYPROSPECT_APPROVAL: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.MYPROSPECT_APPROVAL,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: {
                requesteduser: false,
                company: false,
                accountowner: false,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: false,
                reportinguser: false,
            }
        }
    },
    MYPROSPECT_DECLINE: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.MYPROSPECT_DECLINE,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: {
                requesteduser: false,
                company: false,
                accountowner: false,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: false,
                reportinguser: false,
            }
        }
    },
    REQUEST_TO_MYCHANNEL: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.REQUEST_TO_MYCHANNEL,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: {
                requesteduser: false,
                company: false,
                accountowner: false,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: false,
                reportinguser: false,
            }
        }
    },
    MYCHANNEL_APPROVAL: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.MYCHANNEL_APPROVAL,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: false,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: false,
                reportinguser: false,
            }
        }
    },
    MYCHANNEL_DECLINE: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.MYCHANNEL_DECLINE,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: false,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: false,
                reportinguser: false,
            }
        }
    },
    DISMISS_CHANNEL: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.DISMISS_CHANNEL,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: false,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: false,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: false,
                reportinguser: false,
            }
        }
    },
    CHANGE_OF_CONTACT: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.CHANGE_OF_CONTACT,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: false,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: false,
                reportinguser: false,
            },
            receiver: {
                receiveruser: false,
                company: false,
                accountowner: false,
                reportinguser: false,
            }
        }
    },
    RATING: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.RATING,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: true,
                reportinguser: true,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: true,
                reportinguser: true,
            }
        }
    },
    MESSAGING: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.MESSAGING,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: true,
                reportinguser: true,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: true,
                reportinguser: true,
            }
        }
    },
    NOT_INTEREST_IN_THIS_PRODUCT: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.NOT_INTEREST_IN_THIS_PRODUCT,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: false,
        socket: true,
        recipients: {
            requested: {
                requesteduser: false
            },
            receiver: {
                receiveruser: true
            }
        }
    },
    NOT_INTEREST_IN_THIS_PRODUCT_AF_EVA: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.NOT_INTEREST_IN_THIS_PRODUCT_AF_EVA,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: {
                requesteduser: false
            },
            receiver: {
                receiveruser: true
            }
        }
    },
    ORDER_CHECKOUT: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.ORDER_CHECKOUT,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            }
        }
    },
    ORDER_APPROVAL: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.ORDER_APPROVAL,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: {
                requesteduser: false,
                company: false,
                accountowner: false,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            }
        }
    },
    ORDER_PAID: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.ORDER_PAID,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: false,
        socket: true,
        recipients: {
            requested: {
                requesteduser: false,
                company: false,
                accountowner: false,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            }
        }
    },
    ORDER_CANCEL: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.ORDER_CANCEL,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: false,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            }
        }
    },
    ORDER_PACKED: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.ORDER_PACKED,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: false,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            }
        }
    },
    ORDER_SHIPPED: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.ORDER_SHIPPED,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: false,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            }
        }
    },
    ORDER_DELIVERED: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.ORDER_DELIVERED,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: false,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            }
        }
    },
    ORDER_REFUND_APPROVED: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.ORDER_REFUND_APPROVED,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: false,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            }
        }
    },
    ORDER_REFUND_REJECTED: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.ORDER_REFUND_REJECTED,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: false,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            }
        }
    },
    ORDER_REFUND_CANCEL: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.ORDER_REFUND_CANCEL,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: false,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            }
        }
    },
    ORDER_REFUND_PENDDING: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.ORDER_REFUND_PENDDING,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: false,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            }
        }
    },
    ORDER_RE_CREATION: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.ORDER_RE_CREATION,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: false,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            }
        }
    },
    ORDER_TRANSFER: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.ORDER_TRANSFER,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            }
        }
    },
    ORDER_RE_TRANSFER: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.ORDER_RE_TRANSFER,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            }
        }
    },
    ORDER_MAIL_INVOICE: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.ORDER_MAIL_INVOICE,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: false,
                reportinguser: false,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: true,
                reportinguser: false,
            }
        }
    },
    COMPLAINTS: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.COMPLAINTS,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: null,
            receiver: null
        }
    },
    COMPLAINTS_REPLAY: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.COMPLAINTS_REPLAY,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: null,
            receiver: null
        }
    },
    CHANNEL_APPROVED: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.CHANNEL_APPROVED,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        socket: true,
        mail: true,
        recipients: {
            requested: null,
            receiver: {
                company: false,
                accountowner: true,
            }
        }
    },
    CHANNEL_REJECT: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.CHANNEL_REJECT,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        socket: true,
        mail: true,
        recipients: {
            requested: null,
            receiver: {
                company: false,
                accountowner: true,
            }
        }
    },
    CONTACT_MAIL: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.MAILMESSAGE,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        socket: true,
        mail: true,
        recipients: {
            requested: {
                requesteduser: true,
                company: false,
                accountowner: true,
                reportinguser: true,
            },
            receiver: {
                receiveruser: true,
                company: false,
                accountowner: true,
                reportinguser: true,
            }
        }
    },
    ORDER_EVALUATED: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.ORDER_EVALUATED,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        socket: true,
        mail: true,
        recipients: {
            requested: {
                requesteduser: false
            },
            receiver: {
                receiveruser: true
            }
        }
    },
    CHANNEL_APPROVAL_PENDING: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.CHANNEL_APPROVAL_PENDING,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        socket: true,
        mail: true,
        recipients: {
            requested: null,
            receiver: {
                company: false,
                accountowner: true,
            }
        }
    },
    CLAIM_APPROVED: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.CLAIM_APPROVED,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        socket: false,
        mail: true,
        recipients: {
            requested: null,
            receiver: {
                company: false,
                accountowner: true,
            }
        }
    },
    CLAIM_REJECTED: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.CLAIM_REJECTED,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        socket: false,
        mail: true,
        recipients: {
            requested: null,
            receiver: {
                company: false,
                accountowner: true,
            }
        }
    },
    CHANNEL_RECOMMENDATION: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.CHANNEL_RECOMMENDED,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        socket: true,
        mail: true,
        recipients: {
            requested: null,
            receiver: {
                company: false,
                accountowner: true,
            }
        }
    },
    CHANNEL_INVITATION: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.CHANNEL_INVITATION,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        socket: false,
        mail: true,
        recipients: {
            requested: null,
            receiver: {
                receiveruser: true
            }
        }
    },
    CHANNEL_INVITATION_REMAINDER: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.CHANNEL_INVITATION_REMAINDER,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        socket: false,
        mail: true,
        recipients: {
            requested: null,
            receiver: {
                receiveruser: true
            }
        }
    },
    CHANNEL_INVITATION_VERIFY: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.CHANNEL_INVITATION_VERIFY,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        socket: true,
        mail: true,
        recipients: {
            requested: null,
            receiver: {
                receiveruser: true,
            }
        }
    },
    PRODUCT_READY_FOR_BUSSINESS: {
        formatContact: app_constant_1.appconstant.MESSAGE_FORMATE_CONTACTIDS.PRODUCT_READY_FOR_BUSSINESS,
        messageType: app_constant_1.appconstant.MESSAGE_TYPE.ACTION,
        mail: true,
        socket: true,
        recipients: {
            requested: {
                requesteduser: false
            },
            receiver: {
                receiveruser: true
            }
        }
    }
};
exports.socketEvent = {
    EVENT: 'event'
};
//# sourceMappingURL=notificaton.constant.js.map