'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseController = void 0;
const app_constant_1 = require("../../config/app.constant");
const Process_exception_1 = require("../../middleware/exception/Process.exception");
const sequelize_1 = require("sequelize");
const Channel_entity_1 = require("../../modules/channel/models/Channel.entity");
const _ = require("lodash");
const Auth_exception_1 = require("../../middleware/exception/Auth.exception");
class BaseController {
    constructor() {
    }
    async getRejectedChannelIds(channelId, contactId) {
        return await Channel_entity_1.Channel.sequelize.query('select case when "channelId"=:channelId then "partnerChannelId" when  "partnerChannelId"=:channelId then "channelId" end as a  from "tblChannelJCT" where "connectionStatusTypeId" in (:rejectStatus) and ("channelId"=:channelId or "partnerChannelId"=:channelId) and case when "requested_to" = :contactId then "requested_by" not in(select case when "requested_by"=:contactId then "requested_to" when "requested_to"=:contactId then "requested_by" end from "tblChannelJCT" where ("requested_to"=:contactId or "requested_by"=:contactId) and "deletedat" is null and  "connectionStatusTypeId" in(1,2,7,10,11)) when "requested_by" = :contactId then "requested_to" not in(select case when "requested_by"=:contactId then "requested_to" when "requested_to"=:contactId then "requested_by" end from "tblChannelJCT" where ("requested_to"=:contactId or "requested_by"=:contactId) and "deletedat" is null and  "connectionStatusTypeId" in(1,2,7,10,11)) end', {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                rejectStatus: [app_constant_1.appconstant.DISMISS, app_constant_1.appconstant.DISMISS_OTHER_REASON],
                channelId: +channelId,
                contactId: +contactId
            }
        }).then((result) => {
            let res = [];
            res = result.map(x => +x.a);
            res = _.uniq(res);
            return res;
        });
    }
    async verifyRejectedChannels(user, channelId) {
        let rejectedChannels = await this.getRejectedChannelIds(+user.channelId, +user.contactId);
        if (rejectedChannels.includes('' + channelId)) {
            throw new Process_exception_1.ProcessException('channelHub:channel:rejected');
        }
    }
    async getChannelType(channelId, field) {
        let channel = await Channel_entity_1.Channel.findOne({
            attributes: ['channelTypeId', 'signUpStatusId', 'subscriptionId', 'planId', 'isActive'],
            where: {
                channelId: +channelId,
                isActive: '1',
                signUpStatusId: app_constant_1.appconstant.CHANNEL_APPROVED,
                deletedAt: null,
            }
        });
        if (!channel) {
            throw new Auth_exception_1.AuthException('Not allowed');
        }
        let output = {
            channelId: channel.channelId,
            channelTypeId: channel.channelTypeId,
            suggestionType: app_constant_1.appconstant.CHANNELTYPES[+channel.channelTypeId]
        };
        return (field) ? output[field] : output;
    }
}
exports.BaseController = BaseController;
//# sourceMappingURL=base.controller.js.map