"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.databaseProviders = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Application_entity_1 = require("../../modules/auth/models/Application.entity");
const User_entity_1 = require("../../modules/user/models/User.entity");
const Contact_entity_1 = require("../../modules/user/models/Contact.entity");
const UserRole_entity_1 = require("../../modules/user/models/UserRole.entity");
const Role_entity_1 = require("../../modules/user/models/Role.entity");
const UserAccessPermission_entity_1 = require("../../modules/user/models/UserAccessPermission.entity");
const AccessPermission_entity_1 = require("../../modules/user/models/AccessPermission.entity");
const Channel_entity_1 = require("../../modules/channel/models/Channel.entity");
const OldChannel_entity_1 = require("../../modules/channel/models/OldChannel.entity");
const ContactProductGroup_entity_1 = require("../../modules/user/models/ContactProductGroup.entity");
const ContactProductCategory_entity_1 = require("../../modules/user/models/ContactProductCategory.entity");
const ContactInterestedProductCategory_entity_1 = require("../../modules/user/models/ContactInterestedProductCategory.entity");
const ContactInterestedProductGroup_entity_1 = require("../../modules/user/models/ContactInterestedProductGroup.entity");
const Responsibility_entity_1 = require("../../modules/user/models/Responsibility.entity");
const ContactSocialLink_entity_1 = require("../../modules/user/models/ContactSocialLink.entity");
const ContactLocation_entity_1 = require("../../modules/user/models/ContactLocation.entity");
const SignUpStatus_entity_1 = require("../../modules/user/models/SignUpStatus.entity");
const SignUpHistory_entity_1 = require("../../modules/user/models/SignUpHistory.entity");
const ReferenceContact_entity_1 = require("../../modules/user/models/ReferenceContact.entity");
const UserActivity_entity_1 = require("../../modules/activity/models/UserActivity.entity");
const NonUserActivity_entity_1 = require("../../modules/activity/models/NonUserActivity.entity");
const ProductGroup_entity_1 = require("../../modules/product/models/ProductGroup.entity");
const ProductCategory_entity_1 = require("../../modules/product/models/ProductCategory.entity");
const Brand_entity_1 = require("../../modules/product/models/Brand.entity");
const Media_entity_1 = require("../../modules/media/models/Media.entity");
const MediaType_entity_1 = require("../../modules/media/models/MediaType.entity");
const Country_entity_1 = require("../../modules/common/models/Country.entity");
const ZoneRegionJCT_entity_1 = require("../../modules/common/models/ZoneRegionJCT.entity");
const Zone_entity_1 = require("../../modules/common/models/Zone.entity");
const Region_entity_1 = require("../../modules/common/models/Region.entity");
const RegionCountryJCT_entity_1 = require("../../modules/common/models/RegionCountryJCT.entity");
const ChannelContactSuggestion_entity_1 = require("../../modules/channel/models/ChannelContactSuggestion.entity");
const SubscriptionPlan_entity_1 = require("../../modules/channel/models/SubscriptionPlan.entity");
const Subscription_entity_1 = require("../../modules/channel/models/Subscription.entity");
const ProfileType_entity_1 = require("../../modules/channel/models/ProfileType.entity");
const ChannelType_entity_1 = require("../../modules/channel/models/ChannelType.entity");
const ChannelSubscription_entity_1 = require("../../modules/channel/models/ChannelSubscription.entity");
const Address_entity_1 = require("../../modules/channel/models/Address.entity");
const OldAddress_entity_1 = require("../../modules/channel/models/OldAddress.entity");
const ChannelCertificate_entity_1 = require("../../modules/channel/models/ChannelCertificate.entity");
const ChannelSocialLink_entity_1 = require("../../modules/channel/models/ChannelSocialLink.entity");
const ChannelB2B_entity_1 = require("../../modules/channel/models/ChannelB2B.entity");
const ChannelAward_entity_1 = require("../../modules/channel/models/ChannelAward.entity");
const ChannelDetail_entity_1 = require("../../modules/channel/models/ChannelDetail.entity");
const ChannelSpeciality_entity_1 = require("../../modules/channel/models/ChannelSpeciality.entity");
const ChannelCustomerProfile_entity_1 = require("../../modules/channel/models/ChannelCustomerProfile.entity");
const ChannelProductCategorie_entity_1 = require("../../modules/channel/models/ChannelProductCategorie.entity");
const ChannelProductGroup_entity_1 = require("../../modules/channel/models/ChannelProductGroup.entity");
const ChannelLocation_entity_1 = require("../../modules/channel/models/ChannelLocation.entity");
const ChannelServiceList_entity_1 = require("../../modules/channel/models/ChannelServiceList.entity");
const ChannelBrand_entity_1 = require("../../modules/channel/models/ChannelBrand.entity");
const ChannelPaymentOptionType_entity_1 = require("../../modules/channel/models/ChannelPaymentOptionType.entity");
const PaymentOptionType_entity_1 = require("../../modules/channel/models/PaymentOptionType.entity");
const ChannelPaymentTerm_entity_1 = require("../../modules/channel/models/ChannelPaymentTerm.entity");
const PaymentTerm_entity_1 = require("../../modules/channel/models/PaymentTerm.entity");
const ServiceList_entity_1 = require("../../modules/channel/models/ServiceList.entity");
const ShareType_entity_1 = require("../../modules/channel/models/ShareType.entity");
const ChannelJCT_entity_1 = require("../../modules/channel/models/ChannelJCT.entity");
const ChannelSharePreference_entity_1 = require("../../modules/channel/models/ChannelSharePreference.entity");
const Claim_entity_1 = require("../../modules/channel/models/Claim.entity");
const SocialSite_entity_1 = require("../../modules/channel/models/SocialSite.entity");
const SubscriptionDetail_entity_1 = require("../../modules/channel/models/SubscriptionDetail.entity");
const SubscriptionPeriod_entity_1 = require("../../modules/channel/models/SubscriptionPeriod.entity");
const ChannelDocument_entity_1 = require("../../modules/channel/models/ChannelDocument.entity");
const ProfileTypeClassification_entity_1 = require("../../modules/channel/models/ProfileTypeClassification.entity");
const SubscriptionType_entity_1 = require("../../modules/channel/models/SubscriptionType.entity");
const Coupon_entity_1 = require("../../modules/channel/models/Coupon.entity");
const CertificateType_entity_1 = require("../../modules/channel/models/CertificateType.entity");
const AutoRenewalTracking_entity_1 = require("../../modules/channel/models/AutoRenewalTracking.entity");
const ChannelSuggestion_entity_1 = require("../../modules/channel/models/ChannelSuggestion.entity");
const Currency_entity_1 = require("../../modules/channel/models/Currency.entity");
const ConnectionStatusType_entity_1 = require("../../modules/channel/models/ConnectionStatusType.entity");
const PaymentTransaction_entity_1 = require("../../modules/channel/models/PaymentTransaction.entity");
const ContactJCT_entity_1 = require("../../modules/channel/models/ContactJCT.entity");
const ClaimDocument_entity_1 = require("../../modules/channel/models/ClaimDocument.entity");
const SubscriptionFeatures_entity_1 = require("../../modules/channel/models/SubscriptionFeatures.entity");
const PaymentType_entity_1 = require("../../modules/channel/models/PaymentType.entity");
const SubscriptionFeatureCategory_entity_1 = require("../../modules/channel/models/SubscriptionFeatureCategory.entity");
const ChannelKeyPartner_entity_1 = require("../../modules/channel/models/ChannelKeyPartner.entity");
const ProductKeyPartnerJCT_entity_1 = require("../../modules/product/models/ProductKeyPartnerJCT.entity");
const KeyPartnerJCT_entity_1 = require("../../modules/channel/models/KeyPartnerJCT.entity");
const constants_1 = require("../constants");
const database_config_1 = require("./database.config");
const OldContact_entity_1 = require("../../modules/channel/models/OldContact.entity");
const OldChannelDetail_entity_1 = require("../../modules/channel/models/OldChannelDetail.entity");
const AdminUserAccess_entity_1 = require("../../modules/admin/models/AdminUserAccess.entity");
const AdminMenu_entity_1 = require("../../modules/admin/models/AdminMenu.entity");
const AdminUserCountries_entity_1 = require("../../modules/admin/models/AdminUserCountries.entity");
const AdminUsers_entity_1 = require("../../modules/admin/models/AdminUsers.entity");
const AdminUserChanneltype_entity_1 = require("../../modules/admin/models/AdminUserChanneltype.entity");
const ProfileCreationRating_entity_1 = require("../../modules/channel/models/ProfileCreationRating.entity");
const ProfileList_entity_1 = require("../../modules/channel/models/ProfileList.entity");
const CompanyMedia_entity_1 = require("../../modules/channel/models/CompanyMedia.entity");
const Product_entity_1 = require("../../modules/product/models/Product.entity");
const ProductDetail_entity_1 = require("../../modules/product/models/ProductDetail.entity");
const ProductTag_entity_1 = require("../../modules/product/models/ProductTag.entity");
const ProductArticleReview_entity_1 = require("../../modules/product/models/ProductArticleReview.entity");
const ProductAward_entity_1 = require("../../modules/product/models/ProductAward.entity");
const ProductChannelCustomerProfile_entity_1 = require("../../modules/product/models/ProductChannelCustomerProfile.entity");
const ProductCompeting_entity_1 = require("../../modules/product/models/ProductCompeting.entity");
const ProductEvaluationRating_entity_1 = require("../../modules/product/models/ProductEvaluationRating.entity");
const ProductExistRating_entity_1 = require("../../modules/product/models/ProductExistRating.entity");
const ProductPackageInfo_entity_1 = require("../../modules/product/models/ProductPackageInfo.entity");
const ProductPriceDetail_entity_1 = require("../../modules/product/models/ProductPriceDetail.entity");
const ProductImage_entity_1 = require("../../modules/product/models/ProductImage.entity");
const ProductSharePreference_entity_1 = require("../../modules/product/models/ProductSharePreference.entity");
const ProductUniversalCode_entity_1 = require("../../modules/product/models/ProductUniversalCode.entity");
const ProductLocation_entity_1 = require("../../modules/product/models/ProductLocation.entity");
const ProductReject_entity_1 = require("../../modules/product/models/ProductReject.entity");
const Unit_entity_1 = require("../../modules/product/models/Unit.entity");
const DiscountUnit_entity_1 = require("../../modules/product/models/DiscountUnit.entity");
const ProductMediaLibrary_entity_1 = require("../../modules/product/models/ProductMediaLibrary.entity");
const SubscriptionExtraFeature_entity_1 = require("../../modules/channel/models/SubscriptionExtraFeature.entity");
const SubscriptionExtraFeatureCategories_entity_1 = require("../../modules/channel/models/SubscriptionExtraFeatureCategories.entity");
const SampleOrder_entity_1 = require("../../modules/order/models/SampleOrder.entity");
const OrderAddress_entity_1 = require("../../modules/order/models/OrderAddress.entity");
const OrderStatus_entity_1 = require("../../modules/order/models/OrderStatus.entity");
const ProductEvaluation_entity_1 = require("../../modules/product/models/ProductEvaluation.entity");
const SampleOrderDetail_entity_1 = require("../../modules/order/models/SampleOrderDetail.entity");
const OrderShipment_entity_1 = require("../../modules/order/models/OrderShipment.entity");
const RatingAttribute_entity_1 = require("../../modules/channel/models/RatingAttribute.entity");
const EvaluationAttribute_entity_1 = require("../../modules/channel/models/EvaluationAttribute.entity");
const DismissReason_entity_1 = require("../../modules/channel/models/DismissReason.entity");
const ChannelDismissReason_entity_1 = require("../../modules/channel/models/ChannelDismissReason.entity");
const MeetingReq_entity_1 = require("../../modules/meeting/models/MeetingReq.entity");
const Setting_entity_1 = require("../../modules/common/models/Setting.entity");
const ProductQuote_entity_1 = require("../../modules/cart/models/ProductQuote.entity");
const Cart_entity_1 = require("../../modules/cart/models/Cart.entity");
const Channelgroup_entity_1 = require("../../modules/wishlist/models/Channelgroup.entity");
const Wishlist_entity_1 = require("../../modules/wishlist/models/Wishlist.entity");
const EmailTemplate_entity_1 = require("../../modules/notification/models/EmailTemplate.entity");
const InterestedProductCategory_entity_1 = require("../../modules/user/models/InterestedProductCategory.entity");
const InterestedProductGroup_entity_1 = require("../../modules/user/models/InterestedProductGroup.entity");
const ProductJCT_entity_1 = require("../../modules/product/models/ProductJCT.entity");
const UserWalletAmount_entity_1 = require("../../modules/walletRecharge/models/UserWalletAmount.entity");
const OtherPayment_entity_1 = require("../../modules/channel/models/OtherPayment.entity");
const WalletTransaction_entity_1 = require("../../modules/walletRecharge/models/WalletTransaction.entity");
const WalletUsageType_entity_1 = require("../../modules/walletRecharge/models/WalletUsageType.entity");
const MyAddressBook_entity_1 = require("../../modules/user/models/MyAddressBook.entity");
const BuyerReqCategory_entity_1 = require("../../modules/channel/models/BuyerReqCategory.entity");
const BuyerNeed_entity_1 = require("../../modules/channel/models/BuyerNeed.entity");
const ComplaintCategory_entity_1 = require("../../complains/models/ComplaintCategory.entity");
const ComplaintReplyContent_entity_1 = require("../../complains/models/ComplaintReplyContent.entity");
const ComplaintAttachment_entity_1 = require("../../complains/models/ComplaintAttachment.entity");
const Complain_entity_1 = require("../../complains/models/Complain.entity");
const FailureTransaction_entity_1 = require("../../modules/channel/models/FailureTransaction.entity");
const Error_entity_1 = require("../../error/model/Error.entity");
const DashboardReport_entity_1 = require("../../modules/channel/models/DashboardReport.entity");
const Dashboard_entity_1 = require("../../modules/channel/models/Dashboard.entity");
const CompanyMediaImages_1 = require("../../modules/channel/models/CompanyMediaImages");
const EndCustomersB2bType_1 = require("../../modules/channel/models/EndCustomersB2bType");
const EndCustomerB2b_1 = require("../../modules/channel/models/EndCustomerB2b");
const CertificateTag_entity_1 = require("../../modules/channel/models/CertificateTag.entity");
const GuestRequirement_entity_1 = require("../../modules/channel/models/GuestRequirement.entity");
const EventBo_entity_1 = require("../../modules/channel/models/EventBo.entity");
const EventPackage_entity_1 = require("../../modules/channel/models/EventPackage.entity");
const EventParticipants_entity_1 = require("../../modules/channel/models/EventParticipants.entity");
const EventChannel_entity_1 = require("../../modules/channel/models/EventChannel.entity");
const bucketErrorLog_entity_1 = require("../../modules/media/models/bucketErrorLog.entity");
const AdminUserNotification_entity_1 = require("../../modules/admin/models/AdminUserNotification.entity");
const OldChannelSocialLink_entity_1 = require("../../modules/channel/models/OldChannelSocialLink.entity");
const AlgmChannelJCT_entity_1 = require("../../algorithm/models/AlgmChannelJCT.entity");
const AlgmProductJCT_entity_1 = require("../../algorithm/models/AlgmProductJCT.entity");
const ChannelMatching_entity_1 = require("../../algorithm/models/ChannelMatching.entity");
const ProductMatching_entity_1 = require("../../algorithm/models/ProductMatching.entity");
const OldChannelCustomerProfile_entity_1 = require("../../modules/channel/models/OldChannelCustomerProfile.entity");
const OldChannelSpeciality_entity_1 = require("../../modules/channel/models/OldChannelSpeciality.entity");
exports.databaseProviders = [{
        provide: 'SequelizeInstance',
        useFactory: async () => {
            let config;
            switch (process.env.NODE_ENV) {
                case constants_1.DEVELOPMENT:
                    config = database_config_1.databaseConfig.development;
                    break;
                case constants_1.TEST:
                    config = database_config_1.databaseConfig.test;
                    break;
                case constants_1.PRODUCTION:
                    config = database_config_1.databaseConfig.production;
                    break;
                default:
                    config = database_config_1.databaseConfig.development;
            }
            const sequelize = new sequelize_typescript_1.Sequelize(config);
            sequelize.addModels([Application_entity_1.Application, User_entity_1.User, Contact_entity_1.Contact, OldContact_entity_1.OldContact, Channel_entity_1.Channel, OldChannel_entity_1.OldChannel, UserRole_entity_1.UserRole, Role_entity_1.Role, UserActivity_entity_1.UserActivity, NonUserActivity_entity_1.NonUserActivity,
                UserAccessPermission_entity_1.UserAccessPermission, AccessPermission_entity_1.AccessPermission, ContactProductGroup_entity_1.ContactProductGroup, ProductGroup_entity_1.ProductGroup, ContactProductCategory_entity_1.ContactProductCategory,
                ProductCategory_entity_1.ProductCategory, Responsibility_entity_1.Responsibility, Media_entity_1.Media, Country_entity_1.Country, ContactSocialLink_entity_1.ContactSocialLink, ContactLocation_entity_1.ContactLocation, RegionCountryJCT_entity_1.RegionCountryJCT,
                SubscriptionDetail_entity_1.SubscriptionDetail, ProfileTypeClassification_entity_1.ProfileTypeClassification, SubscriptionType_entity_1.SubscriptionType, Coupon_entity_1.Coupon, PaymentTransaction_entity_1.PaymentTransaction, ChannelSuggestion_entity_1.ChannelSuggestion,
                ChannelContactSuggestion_entity_1.ChannelContactSuggestion, ContactInterestedProductGroup_entity_1.ContactInterestedProductGroup, ContactInterestedProductCategory_entity_1.ContactInterestedProductCategory, SignUpStatus_entity_1.SignUpStatus,
                SubscriptionPlan_entity_1.SubscriptionPlan, Subscription_entity_1.Subscription, ProfileType_entity_1.ProfileType, ChannelType_entity_1.ChannelType, ChannelSubscription_entity_1.ChannelSubscription, Address_entity_1.Address, OldAddress_entity_1.OldAddress, SignUpHistory_entity_1.SignUpHistory, ChannelCertificate_entity_1.ChannelCertificate,
                ChannelSocialLink_entity_1.ChannelSocialLink, ChannelB2B_entity_1.ChannelB2B, ChannelAward_entity_1.ChannelAward, ChannelDetail_entity_1.ChannelDetail, OldChannelDetail_entity_1.OldChannelDetail, ChannelSpeciality_entity_1.ChannelSpeciality, ChannelCustomerProfile_entity_1.ChannelCustomerProfile,
                ChannelProductCategorie_entity_1.ChannelProductCategorie, ChannelLocation_entity_1.ChannelLocation, ChannelServiceList_entity_1.ChannelServiceList, ChannelBrand_entity_1.ChannelBrand, ChannelProductGroup_entity_1.ChannelProductGroup,
                ChannelPaymentOptionType_entity_1.ChannelPaymentOptionType, PaymentOptionType_entity_1.PaymentOptionType, ChannelPaymentTerm_entity_1.ChannelPaymentTerm, PaymentTerm_entity_1.PaymentTerm, ServiceList_entity_1.ServiceList, Brand_entity_1.Brand, ChannelSharePreference_entity_1.ChannelSharePreference,
                ShareType_entity_1.ShareType, ChannelJCT_entity_1.ChannelJCT, ReferenceContact_entity_1.ReferenceContact, Claim_entity_1.Claim, ChannelDocument_entity_1.ChannelDocument, MediaType_entity_1.MediaType, Region_entity_1.Region, SocialSite_entity_1.SocialSite, SubscriptionPeriod_entity_1.SubscriptionPeriod,
                ChannelKeyPartner_entity_1.ChannelKeyPartner, ProductKeyPartnerJCT_entity_1.ProductKeyPartnerJCT, KeyPartnerJCT_entity_1.KeyPartnerJCT,
                AutoRenewalTracking_entity_1.AutoRenewalTracking, CertificateType_entity_1.CertificateType, Currency_entity_1.Currency, ConnectionStatusType_entity_1.ConnectionStatusType, ContactJCT_entity_1.ContactJCT, ClaimDocument_entity_1.ClaimDocument, ZoneRegionJCT_entity_1.ZoneRegionJCT,
                Zone_entity_1.Zone, SubscriptionFeatures_entity_1.SubscriptionFeatures, PaymentType_entity_1.PaymentType, SubscriptionFeatureCategory_entity_1.SubscriptionFeatureCategory, SubscriptionExtraFeature_entity_1.SubscriptionExtraFeature, SubscriptionExtraFeatureCategories_entity_1.SubscriptionExtraFeatureCategory,
                Product_entity_1.Product, ProductDetail_entity_1.ProductDetail, ProductTag_entity_1.ProductTag, ProductArticleReview_entity_1.ProductArticleReview, ProductLocation_entity_1.ProductLocation, ProductMediaLibrary_entity_1.ProductMediaLibrary,
                ProductAward_entity_1.ProductAward, ProductChannelCustomerProfile_entity_1.ProductChannelCustomerProfile, ProductExistRating_entity_1.ProductExistRating, ProductPackageInfo_entity_1.ProductPackageInfo, ProductPriceDetail_entity_1.ProductPriceDetail,
                ProductImage_entity_1.ProductImage, ProductSharePreference_entity_1.ProductSharePreference, ProductUniversalCode_entity_1.ProductUniversalCode, ProductCompeting_entity_1.ProductCompeting, ProductReject_entity_1.ProductReject, Unit_entity_1.Unit, DiscountUnit_entity_1.DiscountUnit,
                AdminUsers_entity_1.AdminUsers, AdminUserAccess_entity_1.AdminUserAccess, AdminMenu_entity_1.AdminMenu, AdminUserCountries_entity_1.AdminUserCountries, AdminUserChanneltype_entity_1.AdminUserChanneltype, AdminUserNotification_entity_1.AdminUserNotification, ProfileCreationRating_entity_1.ProfileRatings, ProfileList_entity_1.ProfileList, CompanyMedia_entity_1.CompanyMedia,
                Channelgroup_entity_1.Channelgroup, Wishlist_entity_1.Wishlist,
                SampleOrder_entity_1.SampleOrder, OrderAddress_entity_1.OrderAddress, OrderStatus_entity_1.OrderStatus, SampleOrderDetail_entity_1.SampleOrderDetail, OrderShipment_entity_1.OrderShipment,
                ProductEvaluation_entity_1.ProductEvaluation, ProductEvaluationRating_entity_1.ProductEvaluationRating, RatingAttribute_entity_1.RatingAttribute, EvaluationAttribute_entity_1.EvaluationAttribute, DismissReason_entity_1.DismissReason, ChannelDismissReason_entity_1.ChannelDismissReason,
                MeetingReq_entity_1.MeetingReq, Setting_entity_1.Setting, ProductQuote_entity_1.ProductQuote, Cart_entity_1.Cart, EmailTemplate_entity_1.EmailTemplate,
                InterestedProductGroup_entity_1.InterestedProductGroup, InterestedProductCategory_entity_1.InterestedProductCategory, ProductJCT_entity_1.ProductJCT, OtherPayment_entity_1.OtherPayment, UserWalletAmount_entity_1.UserWalletAmount, WalletTransaction_entity_1.WalletTransaction, WalletUsageType_entity_1.WalletUsageType, MyAddressBook_entity_1.MyAddressBook,
                BuyerNeed_entity_1.BuyerNeed, BuyerReqCategory_entity_1.BuyerReqCategory, ComplaintCategory_entity_1.ComplaintCategory, ComplaintReplyContent_entity_1.ComplaintReplyContent, ComplaintAttachment_entity_1.ComplaintAttachment, Complain_entity_1.Complain, FailureTransaction_entity_1.FailureTransaction, Error_entity_1.Errors,
                Dashboard_entity_1.Dashboard, DashboardReport_entity_1.DashboardReport, CompanyMediaImages_1.CompanyMediaImages, EndCustomerB2b_1.EndCustomersB2b, EndCustomersB2bType_1.EndCustomersB2bType,
                CertificateTag_entity_1.CertificateTag, GuestRequirement_entity_1.GuestRequirement, EventBo_entity_1.EventBo, EventPackage_entity_1.EventPackage, EventParticipants_entity_1.EventParticipants, EventChannel_entity_1.EventChannel, bucketErrorLog_entity_1.BucketErrorLog, OldChannelSocialLink_entity_1.OldChannelSocialLink,
                OldChannelCustomerProfile_entity_1.OldChannelCustomerProfile, OldChannelSpeciality_entity_1.OldChannelSpeciality,
                AlgmChannelJCT_entity_1.AlgmChannelJCT, ChannelMatching_entity_1.ChannelMatching, ProductMatching_entity_1.ProductMatching, AlgmProductJCT_entity_1.AlgmProductJCT
            ]);
            return sequelize;
        },
    }];
//# sourceMappingURL=database.providers.js.map