"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseHelper = void 0;
const lodash_1 = require("lodash");
class BaseHelper {
    constructor() {
    }
    GenerateRandomString(len) {
        var text = "";
        var charset = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
        for (var i = 0; i < len; i++)
            text += charset.charAt(Math.floor(Math.random() * charset.length));
        return text;
    }
    async lazyload(entity, association, options, force) {
        if (!lodash_1.isUndefined(entity[association]) && !force) {
            return Promise.resolve(entity);
        }
        const loader = 'get' + lodash_1.upperFirst('' + association);
        if (options) {
            entity[association] = await entity[loader](options);
        }
        else {
            entity[association] = await entity[loader]();
        }
        return entity;
    }
}
exports.BaseHelper = BaseHelper;
//# sourceMappingURL=BaseHelper.js.map