"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PaginationTransform = void 0;
const BaseTransformation_1 = require("./BaseTransformation");
class PaginationTransform extends BaseTransformation_1.BaseTransformation {
    constructor() {
        super();
    }
    make(list, pagination, total, aggregations, others) {
        let base = {
            pagination: {
                limit: pagination.limit,
                page: pagination.page,
                total: total
            },
            results: list
        };
        if (aggregations) {
            base = Object.assign(base, { aggregations: aggregations });
        }
        if (others) {
            base = Object.assign(base, { others: others });
        }
        return PaginationTransform.makeStaticResponse(list, pagination, total, aggregations, others);
    }
    static makeStaticResponse(list, pagination, total, aggregations, others) {
        let base = {
            pagination: {
                limit: pagination.limit,
                page: pagination.page,
                total: total
            },
            results: list
        };
        if (aggregations) {
            base = Object.assign(base, { aggregations: aggregations });
        }
        if (others) {
            base = Object.assign(base, { others: others });
        }
        return base;
    }
}
exports.PaginationTransform = PaginationTransform;
//# sourceMappingURL=paginationTransformation.js.map