'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HubspotController = void 0;
const common_1 = require("@nestjs/common");
const signup_dto_1 = require("../../modules/account/dto/signup.dto");
const account_service_1 = require("../../modules/account/service/account.service");
const hubspotImport_helper_1 = require("../helper/hubspotImport.helper");
let HubspotController = class HubspotController {
    constructor(accountService) {
        this.accountService = accountService;
    }
    async getCompanyDetails(companyId, res) {
        let hubspotClient = new hubspotImport_helper_1.HubspotImportHelper();
        let responseData = await hubspotClient.getContactWithThisEmail(companyId);
        let hubspotData = JSON.parse(responseData.data);
        if (responseData.response != 200)
            return res.status(common_1.HttpStatus.BAD_REQUEST).send(hubspotData);
        let email = hubspotData.properties.email.value;
        let cheackmail = await this.accountService.checkEmail(email);
        let data;
        if (!cheackmail) {
            console.log('already exist');
            return res.status(common_1.HttpStatus.BAD_REQUEST).send({ code: 1413, message: 'Given mail id already exist' });
        }
        else {
            let company = [];
            if (hubspotData.properties.associatedcompanyid)
                company = await hubspotClient.getCompanyDetails(hubspotData.properties.associatedcompanyid.value);
            data = {
                contactVid: hubspotData.vid,
                is_contact: hubspotData.iscontact,
                properties: hubspotData.properties,
                company: company
            };
        }
        return res.status(common_1.HttpStatus.OK).send(data);
    }
    async createCompany(signUpData, res) {
        let hubspotClient = new hubspotImport_helper_1.HubspotImportHelper();
        let companyId = await hubspotClient.createCompany(signUpData);
        let contactId = await hubspotClient.impotContactToHubSpot(signUpData);
        let data = await hubspotClient.mergeContactToCompany(contactId, companyId);
        return res.status(common_1.HttpStatus.CREATED).send(data);
    }
    async getCompanyWithId(companyId, res) {
        let hubspotClient = new hubspotImport_helper_1.HubspotImportHelper();
        let companyData = await hubspotClient.getCompanyDetails(companyId);
        return res.status(common_1.HttpStatus.OK).send(companyData);
    }
    async getCompanyList(res) {
        let hubspotClient = new hubspotImport_helper_1.HubspotImportHelper();
        let url = 'https://api.hubapi.com/crm/v3/objects/companies';
        let data = [];
        let check = false;
        for (var i = 0; i < 100; i++) {
            if (check)
                break;
            let value = await hubspotClient.getCompanyList(url);
            if (value.paging && value.paging.next) {
                url = value.paging.next.link;
            }
            else {
                check = true;
            }
            data.push(...value.results);
        }
        let result = [];
        if (data && data.length) {
            result = data;
            result = result.map(x => {
                return { id: x.id, name: x.properties.name, type: 2 };
            });
        }
        return res.status(common_1.HttpStatus.OK).send(result);
    }
};
__decorate([
    common_1.Get('getCompany/:companyId'),
    __param(0, common_1.Param('companyId')), __param(1, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], HubspotController.prototype, "getCompanyDetails", null);
__decorate([
    common_1.Post('createCompany'),
    __param(0, common_1.Body()), __param(1, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [signup_dto_1.SignupDto, Object]),
    __metadata("design:returntype", Promise)
], HubspotController.prototype, "createCompany", null);
__decorate([
    common_1.Get('getCompanyWithId/:companyId'),
    __param(0, common_1.Param('companyId')), __param(1, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], HubspotController.prototype, "getCompanyWithId", null);
__decorate([
    common_1.Get('getCompanyList'),
    __param(0, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], HubspotController.prototype, "getCompanyList", null);
HubspotController = __decorate([
    common_1.Controller('Hubspot'),
    __metadata("design:paramtypes", [account_service_1.AccountService])
], HubspotController);
exports.HubspotController = HubspotController;
//# sourceMappingURL=hubspot.controller.js.map