'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HubspotImportHelper = void 0;
const common_1 = require("@nestjs/common");
const Channel_entity_1 = require("../../modules/channel/models/Channel.entity");
const Contact_entity_1 = require("./../../modules/user/models/Contact.entity");
const Product_entity_1 = require("./../../modules/product/models/Product.entity");
const ChannelJCT_entity_1 = require("../../modules/channel/models/ChannelJCT.entity");
const User_entity_1 = require("../../modules/user/models/User.entity");
const sequelize_1 = require("sequelize");
let HubspotImportHelper = class HubspotImportHelper {
    async createCompany(result) {
        let request = require('request');
        let last_login = '-';
        let oem = "B2B;B2C";
        if (result.isOEM == 1)
            oem = "B2C";
        if (result.isOEM == 2)
            oem = "B2B";
        if (result.isOEM == 2)
            oem = "B2B;B2C";
        var options = { method: 'POST',
            url: 'https://api.hubapi.com/companies/v2/companies',
            qs: { hapikey: process.env.HUBSPOT_API },
            headers: { 'Content-Type': 'application/json' },
            body: { properties: [{ name: 'name', value: result.companyName },
                    { name: 'website', value: result.websiteurl },
                    { name: 'channelTypeId', value: +result.channelTypeId },
                    { name: 'address', value: result.address },
                    { name: 'city', value: result.city },
                    { name: 'state', value: result.state },
                    { name: 'country', value: result.country },
                    { name: 'zip', value: result.postalCode },
                    { name: 'oem', value: result.isOEM },
                    { name: 'phone', value: result.mobile },
                    { name: 'b2b_b2c', value: oem },
                ] },
            json: true };
        return await new Promise(function (resolve, reject) {
            request(options, function (error, response, body) {
                if (error) {
                    console.log('err', error);
                    throw new Error(error);
                }
                console.log(body);
                resolve(body.companyId);
            });
        });
    }
    async updateCompany(result, companyId) {
        let oem = "B2B;B2C";
        if (result.isOEM == 1)
            oem = "B2C";
        if (result.isOEM == 2)
            oem = "B2B";
        if (result.isOEM == 2)
            oem = "B2B;B2C";
        let request = require('request');
        var options = {
            method: 'PUT',
            url: 'https://api.hubapi.com/companies/v2/companies/' + companyId,
            qs: {
                hapikey: process.env.HUBSPOT_API
            },
            headers: {
                'Content-Type': 'application/json'
            },
            body: {
                portalId: process.env.HUBSPOT_PortalId,
                companyId: companyId,
                isDeleted: false,
                properties: [{ name: 'name', value: result.companyName },
                    { name: 'website', value: result.websiteurl },
                    { name: 'channelTypeId', value: +result.channelTypeId },
                    { name: 'address', value: result.address },
                    { name: 'city', value: result.city },
                    { name: 'state', value: result.state },
                    { name: 'country', value: result.country },
                    { name: 'zip', value: result.postalCode },
                    { name: 'oem', value: result.isOEM },
                    { name: 'phone', value: result.mobile },
                    { name: 'b2b_b2c', value: oem },
                ]
            },
            json: true
        };
        return await new Promise(function (resolve, reject) {
            request(options, function (error, response, body) {
                if (error)
                    throw new Error(error);
                resolve(body);
            });
        });
    }
    async impotContactToHubSpot(result) {
        let request = require('request');
        var options = {
            method: 'POST',
            url: 'https://api.hubapi.com/contacts/v1/contact/',
            qs: {
                hapikey: process.env.HUBSPOT_API
            },
            headers: {
                'Content-Type': 'application/json'
            },
            body: {
                properties: [
                    {
                        "property": "email",
                        "value": result.email
                    },
                    {
                        "property": "phone",
                        "value": result.switchPhone
                    },
                    {
                        "property": "firstname",
                        "value": result.firstName
                    },
                    {
                        "property": "lastname",
                        "value": result.lastName
                    },
                    { "property": 'jobtitle',
                        "value": result.jobPosition
                    },
                    { 'property': 'product_categorie', 'value': result.productCat.toString() },
                    { 'property': 'product_family', 'value': result.productFamily.toString() },
                ]
            },
            json: true
        };
        return await new Promise(function (resolve, reject) {
            console.log('*********');
            request(options, function (error, response, body) {
                console.log('body', body);
                if (response.statusCode == 200) {
                    resolve(body.vid);
                }
                else {
                    console.log('error', error);
                    throw new Error(error);
                }
            });
        });
    }
    async UpdateContactToHubSpot(result, vid) {
        let request = require('request');
        var options = {
            method: 'POST',
            url: 'https://api.hubapi.com/contacts/v1/contact/vid/' + vid + '/profile',
            qs: {
                hapikey: process.env.HUBSPOT_API
            },
            headers: {
                'Content-Type': 'application/json'
            },
            body: {
                properties: [
                    {
                        "property": "email",
                        "value": result.email
                    },
                    {
                        "property": "phone",
                        "value": result.switchPhone
                    },
                    {
                        "property": "firstname",
                        "value": result.firstName
                    },
                    {
                        "property": "lastname",
                        "value": result.lastName
                    },
                    {
                        "property": 'jobtitle',
                        "value": result.jobPosition
                    },
                    { 'property': 'product_categorie', 'value': result.productCat.toString() },
                    { 'property': 'product_family', 'value': result.productFamily.toString() },
                ]
            },
            json: true
        };
        return await new Promise(function (resolve, reject) {
            console.log('*********');
            request(options, function (error, response, body) {
                if (error)
                    throw new Error(error);
                resolve(body);
            });
        });
    }
    async mergeContactToCompany(contactId, companyId) {
        let request = require('request');
        var options = {
            method: 'PUT',
            url: 'https://api.hubapi.com/companies/v2/companies/' + companyId + '/contacts/' + contactId,
            qs: {
                hapikey: process.env.HUBSPOT_API
            },
            headers: {
                'Content-Type': 'application/json'
            },
            body: {},
            json: true
        };
        request(options, function (error, response, body) {
            if (error) {
            }
            else {
            }
        });
    }
    async getContactWithThisEmail(email) {
        let request = require('request');
        var options = {
            method: 'GET',
            url: 'https://api.hubapi.com/contacts/v1/contact/email/' + email + '/profile',
            qs: {
                hapikey: process.env.HUBSPOT_API
            }
        };
        return await new Promise(function (resolve, reject) {
            request(options, function (error, response, body) {
                console.log(response.statusCode);
                if (response.statusCode == 200) {
                    resolve({ response: response.statusCode, data: body });
                }
                else {
                    resolve({ response: response.statusCode, data: body });
                }
            });
        });
    }
    async getCompanyDetails(companyId) {
        let request = require('request');
        var options = {
            method: 'GET',
            url: 'https://api.hubapi.com/companies/v2/companies/' + companyId,
            qs: {
                hapikey: process.env.HUBSPOT_API
            },
            headers: {
                'Content-Type': 'application/json'
            },
            json: true,
        };
        return await new Promise(function (resolve, reject) {
            request(options, function (error, response, body, channelId, companyId) {
                if (error) {
                }
                else {
                    resolve(body);
                }
            });
        });
    }
    async getCompanyList(url) {
        var request = require("request");
        var options = {
            method: 'GET',
            url: url,
            qs: { limit: 100, hapikey: process.env.HUBSPOT_API },
            headers: {
                'Content-Type': 'application/json'
            },
            json: true,
        };
        return await new Promise(function (resolve, reject) {
            request(options, function (error, response, body) {
                if (error) {
                }
                else {
                    resolve(body);
                }
            });
        });
    }
    getHubspotCompanyId(channelId) {
        let query = 'select * FROM "tblChannel" where "channelId" = ' + channelId;
        return Channel_entity_1.Channel.sequelize.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true
        }).then(async (results) => {
            return results;
        });
    }
    getHubspotContactId(contractId) {
        let query = 'select * FROM "tblContact" where "channelId" = ' + contractId;
        return Contact_entity_1.Contact.sequelize.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true
        }).then(async (results) => {
            return results;
        });
    }
    getProductCount(channelId) {
        let query = 'SELECT count(*) FROM public."tblProduct" where "channelId" = ' + channelId;
        return Product_entity_1.Product.sequelize.query(query, {
            type: sequelize_1.QueryTypes.UPDATE,
            raw: true
        }).then(async (results) => {
            return results[0][0].count;
        });
    }
    getInBoundRequest(contactId) {
        let query = 'SELECT count(*) as inbound FROM public."tblChannelJCT" as cjct LEFT JOIN "tblChannel" as ch ON ch."channelId" = cjct."partnerChannelId" where cjct."requested_to" = ' + contactId + ' AND cjct."connectionStatusTypeId" = \'7\' AND cjct."deletedat" isnull AND ch."deletedAt" isnull';
        return ChannelJCT_entity_1.ChannelJCT.sequelize.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true
        }).then(async (results) => {
            return results[0].inbound;
        });
    }
    getOutBoundRequest(contactId) {
        let query = 'SELECT count(*) as outbound FROM public."tblChannelJCT" as cjct LEFT JOIN "tblChannel" as ch ON ch."channelId" = cjct."partnerChannelId" where cjct."requested_by" = ' + contactId + ' AND cjct."connectionStatusTypeId" = \'7\' AND cjct."deletedat" isnull  AND ch."deletedAt" isnull';
        return ChannelJCT_entity_1.ChannelJCT.sequelize.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true
        }).then(async (results) => {
            return results[0].outbound;
        });
    }
    getConfirmedConnnection(channelId) {
        let query = 'SELECT count(*)  FROM public."tblChannelJCT" where ("channelId" = ' + channelId + ' OR "partnerChannelId" = ' + channelId + ') AND "connectionStatusTypeId" = \'2\' AND "deletedat" isnull';
        return ChannelJCT_entity_1.ChannelJCT.sequelize.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true
        }).then(async (results) => {
            return results[0].count;
        });
    }
    getHubspotProperties(userId) {
        let query = 'SELECT "loggedAt" FROM "tblUserActivity" where "userId" = ' + userId + ' AND action =\'LOGIN\' order by "userActivityId" DESC LIMIT 1 ';
        return ChannelJCT_entity_1.ChannelJCT.sequelize.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true
        }).then(async (results) => {
            if (results.length != 0) {
                var timestamp = results[0].loggedAt;
                var todate = new Date(timestamp).getDate();
                var tomonth = new Date(timestamp).getMonth() + 1;
                var toyear = new Date(timestamp).getFullYear();
                var original_date = todate + '/' + tomonth + '/' + toyear;
                return original_date;
            }
            else {
                return null;
            }
        });
    }
    async getSubscriptionProperties(channelId) {
        return await new Promise(function (resolve, reject) {
            let query = 'select cs."endAt", sp."subscriptionPlanType" from "tblChannelSubscription"  AS cs INNER JOIN "tblSubscription" AS s ON s."subscriptionId" = cs."subscriptionId" INNER JOIN "tblSubscriptionPlan" AS sp ON sp."subscriptionPlanId" = s."subscriptionPlanId" where cs."channelId" = ' + channelId + ' AND cs."isActive" = \'1\' ';
            Channel_entity_1.Channel.sequelize.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true
            }).then(async (results) => {
                resolve(results);
            });
        });
    }
    async cronImportCompany() {
    }
};
HubspotImportHelper = __decorate([
    common_1.Injectable()
], HubspotImportHelper);
exports.HubspotImportHelper = HubspotImportHelper;
//# sourceMappingURL=hubspotImport.helper.js.map