'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HubspotModule = void 0;
const common_1 = require("@nestjs/common");
const hubspot_controller_1 = require("./controller/hubspot.controller");
const user_module_1 = require("../modules/user/user.module");
const channel_module_1 = require("../modules/channel/channel.module");
const database_module_1 = require("../core/database/database.module");
const account_service_1 = require("../modules/account/service/account.service");
const channel_provider_1 = require("../modules/channel/provider/channel.provider");
const emailer_module_1 = require("../modules/emailer/emailer.module");
const event_provider_1 = require("../modules/channel/provider/event.provider");
let HubspotModule = class HubspotModule {
};
HubspotModule = __decorate([
    common_1.Module({
        controllers: [
            hubspot_controller_1.HubspotController
        ],
        providers: [
            account_service_1.AccountService,
            ...channel_provider_1.oldChannelProvider,
            ...event_provider_1.eventProvider
        ],
        imports: [
            database_module_1.DatabaseModule,
            user_module_1.UserModule,
            channel_module_1.ChannelModule,
            emailer_module_1.EmailerModule
        ],
        exports: [
            account_service_1.AccountService
        ],
    })
], HubspotModule);
exports.HubspotModule = HubspotModule;
//# sourceMappingURL=hubspot.module.js.map