'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
exports.FetchUploadS3 = void 0;
const AWS = require("aws-sdk");
const Process_exception_1 = require("../middleware/exception/Process.exception");
const sharp = require('sharp');
class FetchUploadS3 {
    constructor() {
        this.fs = require('fs');
        this.options = {
            accessKeyId: process.env.AWS_ACCESS_KEY,
            secretAccessKey: process.env.AWS_SECRET_ACCESS_KEY,
            region: process.env.AWS_REGION,
            params: {
                Bucket: process.env.TEM_AWS_BUCKET
            }
        };
        this.s3lib = new AWS.S3(this.options);
    }
    async upload(file, key, width, height, bucket) {
        console.log('upload buffer');
        let buffer = await sharp(file).resize({ width: width, height: height }).toBuffer();
        let params = { Body: buffer, Bucket: bucket, Key: key, ACL: "public-read" };
        return await this.s3lib.putObject(params, (e, d) => {
            if (e) {
                throw new Process_exception_1.ProcessException('Soming went wrong');
            }
            return true;
        }).promise();
    }
    async getS3urlToBuffer(Key, Bucket) {
        var params = { Bucket: Bucket, Key: Key };
        try {
            const data = await this.s3lib.getObject(params).promise();
            return data.Body;
        }
        catch (error) {
            throw new Process_exception_1.ProcessException('Soming went wrong');
        }
    }
}
exports.FetchUploadS3 = FetchUploadS3;
//# sourceMappingURL=FetchUploadS3.js.map