"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MailerserviceController = void 0;
const common_1 = require("@nestjs/common");
const context_service_1 = require("../context/context.service");
const mailerservice_service_1 = require("./mailerservice.service");
const sequelize_1 = require("sequelize");
let fs = require('fs');
let MailerserviceController = class MailerserviceController {
    constructor(mailService, sequelizeInstance) {
        this.mailService = mailService;
        this.sequelizeInstance = sequelizeInstance;
    }
    async Add_Product_Mail(req, data) {
        let query = 'select "firstName" as name,email from "tblContact" where "contactId"=(select "contactId" from "tblUser" where "userId"=:userId) ';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                userId: data.userId
            }
        });
        let msg = {
            to: result[0].email,
            cc: process.env.MAIL_CC,
            from: process.env.EMAIL_FROM,
            templateId: 'd-aa5e57c256a641fdbfbd7486722165e1',
            dynamicTemplateData: {
                name: result[0].name,
            }
        };
        return this.mailService.sendEmail(msg);
    }
    async After_Signup_Mail(req, data) {
        let msg = {
            to: data.to,
            cc: process.env.MAIL_CC,
            from: process.env.EMAIL_FROM,
            templateId: 'd-a20e8735754e47edb328e72b9c650772',
            dynamicTemplateData: {
                name: data.name,
            }
        };
        return this.mailService.sendEmail(msg);
    }
    async Pending_Approval_Mail(req, data) {
        let bquery = 'select "companyName",case when "channelTypeId"=3 then \'Distributor\' when "channelTypeId"=4 then \'Retailer\' when "channelTypeId"=5 then \'Reseller\' end as "companyType", '
            + '(select "country" from "tblCountry" where "countryId"=tc."countryId"), '
            + '(select concat(\'' + process.env.REACT_APP_CDN_URL + '\',"documentPath") from "tblDocument" where "documentId" in (select "channelLogoId" from "tblChannelDetail" where "channelId"=tc."channelId")) as "companyLogo" '
            + 'from "tblChannel" as tc where "channelId" in(select "channelId" from "tblUser" where "email"=:email) ';
        let channel = await this.sequelizeInstance.query(bquery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                email: data.email
            }
        });
        console.log("channels:", channel);
        let msg = {
            to: data.to,
            cc: process.env.MAIL_CC,
            from: process.env.EMAIL_FROM,
            templateId: 'd-a20e8735754e47edb328e72b9c650772',
            dynamicTemplateData: {
                companyName: channel[0].companyName,
                companyType: channel[0].companyType,
                country: channel[0].country,
                companyLogo: channel[0].companyLogo,
            }
        };
        return this.mailService.sendEmail(msg);
    }
    async Buyer_Following_Vendor(req, data) {
        let query = 'select "email","firstName" as name from "tblContact" where "channelId"=:channelId and "isActive"=\'1\'  and "deletedAt" is null ';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: data.channelId
            }
        });
        result.map(x => {
            let msg = {
                to: x.email,
                cc: process.env.MAIL_CC,
                from: process.env.EMAIL_FROM,
                templateId: 'd-b3517a78038c43839b0e267f0b62dfa0',
                dynamicTemplateData: {
                    name: x.name,
                }
            };
            this.mailService.sendEmail(msg);
        });
        return true;
    }
    async Reset_Password_Mail(req, data) {
        let msg = {
            to: data.email,
            cc: process.env.MAIL_CC,
            from: process.env.EMAIL_FROM,
            templateId: 'd-bf3f35948d4e4154aa22239acd8b0b66',
            dynamicTemplateData: {
                name: data.name,
                profileurl: data.url
            }
        };
        return this.mailService.sendEmail(msg);
    }
    async Buyer_Favorites_Product(req, data) {
        let query = 'select "email","firstName" as name from "tblContact" where "channelId"=(select "channelId" from "tblProduct" where "productId"=:productId) and "isActive"=\'1\'  and "deletedAt" is null ';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                productId: data.productId
            }
        });
        result.map(x => {
            let msg = {
                to: x.email,
                cc: process.env.MAIL_CC,
                from: process.env.EMAIL_FROM,
                templateId: 'd-5b41e3fb45424532b5957d5e3eb943ce',
                dynamicTemplateData: {
                    name: x.name,
                }
            };
            this.mailService.sendEmail(msg);
        });
        return true;
    }
    async Channel_Approval_Mail(req, data) {
        let query = 'select "firstName" as name from "tblContact" where "contactId"=:contactId ';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                contactId: data.contactId
            }
        });
        let msg = {
            to: data.to,
            cc: process.env.MAIL_CC,
            from: process.env.EMAIL_FROM,
            templateId: 'd-fadcddce4e6a41e9a73c027c7ca6ed95',
            dynamicTemplateData: {
                name: result[0].name,
                profileurl: data.profileurl
            }
        };
        return this.mailService.sendEmail(msg);
    }
    async Channel_Dismiss_Mail(req, data) {
        let query = 'select "firstName" as name from "tblContact" where "contactId"=:contactId ';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                contactId: data.contactId
            }
        });
        let msg = {
            to: data.to,
            cc: process.env.MAIL_CC,
            from: process.env.EMAIL_FROM,
            templateId: 'd-e5136f3dba5044e4b8e87e2b160d61a4',
            dynamicTemplateData: {
                name: result[0].name,
            }
        };
        return this.mailService.sendEmail(msg);
    }
    async Add_User_Mail(req, data) {
        let query;
        if (data.accountOwner == 0)
            query = 'select "firstName" as name from "tblContact" where "isDefaultContact"=\'1\' ';
        else
            query = 'select "firstName" as name from "tblContact" where "contactId"=:contactId ';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                contactId: data.accountOwner
            }
        });
        let msg = {
            to: data.to,
            cc: process.env.MAIL_CC,
            from: process.env.EMAIL_FROM,
            templateId: 'd-959d91d142794da6b90e11b37933d4ec',
            dynamicTemplateData: {
                name: data.name,
                profileurl: data.profileurl,
                userId: data.userId,
                password: data.password,
                accountOwner: result[0].name
            }
        };
        return this.mailService.sendEmail(msg);
    }
    async Add_BO_User(req, data) {
        let msg = {
            to: data.result.to,
            cc: process.env.MAIL_CC,
            from: process.env.EMAIL_FROM,
            templateId: 'd-f83af20e08f94e2aad9d4f2899f7b7b4',
            dynamicTemplateData: {
                name: data.result.name,
                profileurl: data.result.profileurl,
                userId: data.result.userId,
                password: data.result.password,
                accountOwner: data.result.accountOwner
            }
        };
        return this.mailService.sendEmail(msg);
    }
    async Product_Suggestion_Mail(req, data) {
        let bquery = 'select pc."productCategorie",concat(tcon."firstName",\' \',tcon."lastName") as name,tcon."email" from "tblInterestedProductCategory" as ipc inner join "tblProductCategories" as pc '
            + 'on pc."productCategorieId"=ipc."productCategorieId" inner join "tblContact" as tcon on tcon."contactId"=ipc."contactId" '
            + 'where ipc."contactId"=:contactId and ipc."deletedAt" is null';
        let productCat = await this.sequelizeInstance.query(bquery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                contactId: data.contactId,
            }
        });
        let name, email, matchedProducts, more = 1;
        productCat.map(x => {
            name = x.name;
            email = x.email;
            if (more <= 4 && more > 1)
                matchedProducts = matchedProducts + " - " + x.productCategorie;
            if (more == 1)
                matchedProducts = x.productCategorie;
            more = more + 1;
        });
        let query = 'select tp."product" as "productName",tp."productSKU",(select "companyName" from "tblChannel" where "channelId"="partnerChannelId"), '
            + '(select "country" from "tblCountry" where "countryId" in(select "countryId" from "tblChannel" where "channelId"="partnerChannelId")), '
            + '(select regexp_replace("detailDesc", E\'<[^>]+>\', \'\', \'gi\') as "tweetPitch" from "tblChannelDetail" where "channelId"="partnerChannelId"), '
            + '(select "documentPath" from "tblDocument" where "documentId"=tp."defaultimageid") as "productImage", '
            + '(select "retailerprice" from "tblproductpricedetail" where "productId"=tp."productId") as price, '
            + '(select sum("existproductrating")/count(*) from "tblproductexistrating" where "productId"=tp."productId") as rating '
            + 'from "tblProductJCT" as pjct inner join "tblProduct" as tp on tp."productId"=pjct."productId" '
            + 'where "requested_by"=:contactId limit 3';
        let product = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                contactId: data.contactId
            }
        });
        if (product && product.length > 0) {
            product.map(x => {
                Object.assign(x, {
                    productUrl: process.env.DOMAIN + "/productDetailView/" + x.productSKU,
                    keyRetailer: "Amazon, Flipkart, Acuchen, Carrefour"
                });
                if (x.rating) {
                    let rat = "";
                    for (let i = 0; i < x.rating; i++)
                        rat += "*";
                    x.rating = rat;
                }
                x.productImage = process.env.REACT_APP_CDN_URL + x.productImage;
            });
            let result = {
                name: name,
                matchedProducts: matchedProducts,
                more: more - 1 > 4 ? more - 1 : 0,
                product: product
            };
            let msg = {
                to: email,
                cc: process.env.MAIL_CC,
                from: process.env.EMAIL_FROM,
                templateId: 'd-452c8584e1584a06ba59e8cce363cb51',
                dynamicTemplateData: result
            };
            this.mailService.sendEmail(msg);
        }
        return true;
    }
    async Connection_Request_Mail(req, data) {
        var _a, _b;
        let query;
        let tempId;
        if (data.typeId == 3) {
            tempId = 'd-68e4ffef524849958a0ac8a55ee4381d';
            query = 'select concat(\'' + process.env.DOMAIN + '/admin/channel/channelDetail/\',cd."channelId") as "companyUrl","companyName",regexp_replace("detailDesc", E\'<[^>]+>\', \'\', \'gi\') as detailDesc,(select concat(\'' + process.env.REACT_APP_CDN_URL + '\',"documentPath") from "tblDocument" where "documentId"=cd."channelLogoId")as "companyLogo","firstName"as name,"jobTitle",(select "country" from "tblCountry" where "countryId"=tc."countryId"), '
                + '(select array_to_json(array_agg(row_to_json(br))) from (select tb."brandName" as item_name,concat(\'' + process.env.REACT_APP_CDN_URL + '\',td."documentPath") as image_Url from "tblBrand" tb inner join "tblDocument" td on td."documentId"=tb."documentId" where "id" in(select "brandId" from "tblChannelBrand" where "channelId"=:req_channelId and "deletedAt" is null))br) as brand,'
                + '(select array_to_json(array_agg(row_to_json(x))) from (Select concat(pc."productCategorie",\' \',\'- \') as item_name from "tblChannelProductCategorie" cpc inner join "tblProductCategories" pc on pc."productCategorieId" = cpc."productCategorieId" where cpc."channelId"=:req_channelId  and cpc."deletedAt" is null)x) as company_cat, '
                + '(select array_to_json(array_agg(row_to_json(z))) from (Select concat(pt."profileType",\' \',\'- \') as item_name from "tblProfileType" pt where "profileTypeId" in (select "profileTypeId" from "tblChannelCustomerProfile" cp where cp."channelId"=:req_channelId and cp."deletedAt" is null))z) as retail_customer_profile '
                + 'from "tblContact" as tc inner join "tblChannel" as ch on ch."channelId"=tc."channelId" inner join "tblChannelDetail" as cd on cd."channelId"=tc."channelId" where "contactId"=:req_contactId ';
        }
        else if (data.typeId == 4 || data.typeId == 5) {
            tempId = 'd-d565f18e12514d4c9491cdad31c43116';
            query = 'select concat(\'' + process.env.DOMAIN + '/admin/channel/channelDetail/\',cd."channelId") as "companyUrl","companyName",regexp_replace("detailDesc", E\'<[^>]+>\', \'\', \'gi\') as detailDesc,(select concat(\'' + process.env.REACT_APP_CDN_URL + '\',"documentPath") from "tblDocument" where "documentId"=cd."channelLogoId")as "companyLogo","firstName"as name,"jobTitle",(select "country" from "tblCountry" where "countryId"=tc."countryId"), '
                + '(select array_to_json(array_agg(row_to_json(x))) from (Select concat(pc."productCategorie",\' \',\'- \') as item_name from "tblChannelProductCategorie" cpc inner join "tblProductCategories" pc on pc."productCategorieId" = cpc."productCategorieId" where cpc."channelId"=:req_channelId  and cpc."deletedAt" is null)x) as company_cat, '
                + 'from "tblContact" as tc inner join "tblChannel" as ch on ch."channelId"=tc."channelId" inner join "tblChannelDetail" as cd on cd."channelId"=tc."channelId" where "contactId"=:req_contactId ';
        }
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                req_contactId: data.req_contact,
                req_channelId: data.req_channel
            }
        });
        let templateData = result[0];
        if (((_a = templateData === null || templateData === void 0 ? void 0 : templateData.company_cat) === null || _a === void 0 ? void 0 : _a.length) > 0) {
            let lastCategory = templateData.company_cat[templateData.company_cat.length - 1];
            templateData.company_cat[templateData.company_cat.length - 1].item_name = lastCategory.item_name.trim().slice(0, -1);
        }
        if (data.typeId == 3 && ((_b = templateData === null || templateData === void 0 ? void 0 : templateData.retail_customer_profile) === null || _b === void 0 ? void 0 : _b.length) > 0) {
            let lastProfile = templateData.retail_customer_profile[templateData.retail_customer_profile.length - 1];
            templateData.retail_customer_profile[templateData.retail_customer_profile.length - 1].item_name = lastProfile.item_name.trim().slice(0, -1);
        }
        Object.assign(templateData, {
            message: data.note, receiver_name: data.receiver_name,
            receiver_photo: data.receiver_photo, connect_url: process.env.DOMAIN + '/admin/mynetwork'
        });
        let msg = {
            to: data.receiver_mail,
            cc: process.env.MAIL_CC,
            from: process.env.EMAIL_FROM,
            templateId: tempId,
            dynamicTemplateData: templateData
        };
        return this.mailService.sendEmail(msg);
    }
    async Connection_Dismiss_Mail(req, data) {
        let query = 'select "companyName",(select concat(\'' + process.env.REACT_APP_CDN_URL + '\',"documentPath") from "tblDocument" where "documentId"=cd."channelLogoId")as "companyLogo","firstName"as "contactName","jobTitle",(select "country" from "tblCountry" where "countryId"=tc."countryId") '
            + 'from "tblContact" as tc inner join "tblChannel" as ch on ch."channelId"=tc."channelId" inner join "tblChannelDetail" as cd on cd."channelId"=tc."channelId" where "contactId"=:req_contactId ';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                req_contactId: data.req_contact
            }
        });
        let templateData = result[0];
        Object.assign(templateData, {
            receiver_name: data.receiver_name,
            companyType: 'VENDOR'
        });
        let msg = {
            to: data.receiver_mail,
            cc: process.env.MAIL_CC,
            from: process.env.EMAIL_FROM,
            templateId: 'd-1313b0cf495d449284e98e982ebc3c73',
            dynamicTemplateData: templateData
        };
        return this.mailService.sendEmail(msg);
    }
    async Connection_Approve_Mail(req, data) {
        let query = 'select concat(\'' + process.env.DOMAIN + '/admin/channel/channelDetail/\',tc."channelId") as "companyUrl","companyName",(select concat(\'' + process.env.REACT_APP_CDN_URL + '\',"documentPath") from "tblDocument" where "documentId"=tc."documentId")as "profile_url","firstName"as "contactName","jobTitle",(select "country" from "tblCountry" where "countryId"=tc."countryId") '
            + 'from "tblContact" as tc inner join "tblChannel" as ch on ch."channelId"=tc."channelId"  where "contactId"=:req_contactId ';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                req_contactId: data.req_contact
            }
        });
        let templateData = result[0];
        Object.assign(templateData, {
            receiver_name: data.receiver_name,
            companyType: 'VENDOR'
        });
        let msg = {
            to: data.receiver_mail,
            cc: process.env.MAIL_CC,
            from: process.env.EMAIL_FROM,
            templateId: 'd-3a0481920ac04363a7be12a935ed20c2',
            dynamicTemplateData: templateData
        };
        return this.mailService.sendEmail(msg);
    }
    async Guest_Product_Enquiry(Req, data) {
        let query = 'select "product" from "tblProduct" where "productId"=:productId';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                productId: data.productId
            }
        }).then(res => {
            return res[0];
        });
        let msg = {
            to: data.email,
            cc: process.env.MAIL_CC,
            from: process.env.EMAIL_FROM,
            templateId: 'd-61f83a7b6627419cbbe8361f6188e343',
            dynamicTemplateData: {
                name: data.email.split('@')[0],
                productname: result.product
            }
        };
        this.mailService.sendEmail(msg);
        return true;
    }
    async subscriptionEmail(Req, data) {
        let query = 'select u."email", con."firstName",p."transactionNumber", p."cardLastFourDigit", p."cardType", p."invoiceno" , p."amount" , sp."subscriptionPlanType", spr."periodDesc" from "tblChannel" c ';
        query += ' left join "tblUser" u on u."channelId" = c."channelId" ';
        query += ' left join "tblChannelSubscription" cs on cs."channelId" = c."channelId" AND cs."isActive" =:isActive';
        query += ' left join "tblSubscription" s on cs."subscriptionId" = s."subscriptionId" ';
        query += ' left join "tblSubscriptionPeriod" spr on spr."subscriptionPeriodId" = s."subscriptionPeriodId" ';
        query += ' left join "tblSubscriptionPlan" sp on sp."subscriptionPlanId" = c."planId" ';
        query += ' left join "tblPaymentTransaction" p on p."paymentTransactionId" = cs."paymentTransactionId"  ';
        query += ' left join "tblContact" con on con."channelId" = c."channelId" where c."channelId"=:channelId ';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: data.id,
                isActive: '1'
            }
        });
        if (result.length > 0) {
            let receiptURL = process.env.CDN_URL + 'invoice/' + data.id + '/' + result.channelSubscriptionId + '-' + result.subscriptionId + '.pdf';
            let msg = {
                to: result[0].email,
                cc: process.env.MAIL_CC,
                from: process.env.EMAIL_FROM,
                templateId: 'd-30bb5ef59bd04f7d9622d153105514fe',
                dynamicTemplateData: {
                    receiver_name: result[0].firstName,
                    plan: result[0].subscriptionPlanType,
                    receipt: result[0].invoiceno,
                    channel_type: 'Vendor',
                    transaction_id: result[0].transactionNumber,
                    card_number: result[0].cardLastFourDigit,
                    amount: result[0].amount,
                    period: result[0].periodDesc,
                    receipt_url: receiptURL,
                    login_url: process.env.HOST_URL
                }
            };
            this.mailService.sendEmail(msg);
            return true;
        }
    }
    async OtherpaymentEmail(Req, data) {
        let query = 'select u."email", con."firstName",p."transactionNumber", p."cardLastFourDigit", p."cardType", p."invoiceno" , p."amount" , sp."subscriptionPlanType", spr."periodDesc" from "tblChannel" c ';
        query += ' left join "tblUser" u on u."channelId" = c."channelId" ';
        query += ' left join "tblChannelSubscription" cs on cs."channelId" = c."channelId" AND cs."isActive" =:isActive';
        query += ' left join "tblSubscription" s on cs."subscriptionId" = s."subscriptionId" ';
        query += ' left join "tblSubscriptionPeriod" spr on spr."subscriptionPeriodId" = s."subscriptionPeriodId" ';
        query += ' left join "tblSubscriptionPlan" sp on sp."subscriptionPlanId" = c."planId" ';
        query += ' left join "tblPaymentTransaction" p on p."paymentTransactionId" = cs."paymentTransactionId"  ';
        query += ' left join "tblContact" con on con."channelId" = c."channelId" where c."channelId"=:channelId ';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: data.id,
                isActive: '1'
            }
        });
        if (result.length > 0) {
            let msg = {
                to: result[0].email,
                cc: process.env.MAIL_CC,
                from: process.env.EMAIL_FROM,
                templateId: 'd-9172ba27165e4308af67962675327289',
                dynamicTemplateData: {
                    receivrecharge_amounter_name: result[0].firstName,
                    transaction_id: result[0].subscriptionPlanType,
                    user_balance: result[0].invoiceno,
                    receipt_url: 'Vendor',
                    name: result[0].transactionNumber,
                    login_url: process.env.HOST_URL
                }
            };
            return this.mailService.sendEmail(msg);
        }
    }
};
__decorate([
    common_1.Post('Add_Product_Mail'),
    __param(0, common_1.Req()), __param(1, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MailerserviceController.prototype, "Add_Product_Mail", null);
__decorate([
    common_1.Post('After_Signup_Mail'),
    __param(0, common_1.Req()), __param(1, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MailerserviceController.prototype, "After_Signup_Mail", null);
__decorate([
    common_1.Post('Pending_Approval_Mail'),
    __param(0, common_1.Req()), __param(1, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MailerserviceController.prototype, "Pending_Approval_Mail", null);
__decorate([
    common_1.Post('Buyer_Following_Vendor'),
    __param(0, common_1.Req()), __param(1, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MailerserviceController.prototype, "Buyer_Following_Vendor", null);
__decorate([
    common_1.Post('Reset_Password_Mail'),
    __param(0, common_1.Req()), __param(1, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MailerserviceController.prototype, "Reset_Password_Mail", null);
__decorate([
    common_1.Post('Buyer_Favorites_Product'),
    __param(0, common_1.Req()), __param(1, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MailerserviceController.prototype, "Buyer_Favorites_Product", null);
__decorate([
    common_1.Post('Channel_Approval_Mail'),
    __param(0, common_1.Req()), __param(1, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MailerserviceController.prototype, "Channel_Approval_Mail", null);
__decorate([
    common_1.Post('Channel_Dismiss_Mail'),
    __param(0, common_1.Req()), __param(1, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MailerserviceController.prototype, "Channel_Dismiss_Mail", null);
__decorate([
    common_1.Post('Add_User_Mail'),
    __param(0, common_1.Req()), __param(1, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MailerserviceController.prototype, "Add_User_Mail", null);
__decorate([
    common_1.Post('Add_BO_User'),
    __param(0, common_1.Req()), __param(1, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MailerserviceController.prototype, "Add_BO_User", null);
__decorate([
    common_1.Post('Product_Suggestion_Mail'),
    __param(0, common_1.Req()), __param(1, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MailerserviceController.prototype, "Product_Suggestion_Mail", null);
__decorate([
    common_1.Post('Connection_Request_Mail'),
    __param(0, common_1.Req()), __param(1, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MailerserviceController.prototype, "Connection_Request_Mail", null);
__decorate([
    common_1.Post('Connection_Dismiss_Mail'),
    __param(0, common_1.Req()), __param(1, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MailerserviceController.prototype, "Connection_Dismiss_Mail", null);
__decorate([
    common_1.Post('Connection_Approve_Mail'),
    __param(0, common_1.Req()), __param(1, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MailerserviceController.prototype, "Connection_Approve_Mail", null);
__decorate([
    common_1.Post('Guest_Product_Enquiry'),
    __param(0, common_1.Req()), __param(1, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MailerserviceController.prototype, "Guest_Product_Enquiry", null);
__decorate([
    common_1.Post('subscriptionEmail'),
    __param(0, common_1.Req()), __param(1, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MailerserviceController.prototype, "subscriptionEmail", null);
__decorate([
    common_1.Post('OtherpaymentEmail'),
    __param(0, common_1.Req()), __param(1, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MailerserviceController.prototype, "OtherpaymentEmail", null);
MailerserviceController = __decorate([
    common_1.Controller('mailerservice'),
    __param(1, common_1.Inject('SequelizeInstance')),
    __metadata("design:paramtypes", [mailerservice_service_1.MailerService, Object])
], MailerserviceController);
exports.MailerserviceController = MailerserviceController;
//# sourceMappingURL=mailerservice.controller.js.map