"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MailerService = void 0;
const common_1 = require("@nestjs/common");
const sgMail = require('@sendgrid/mail');
let MailerService = class MailerService {
    constructor(channelMatchingRepository, productMatchingRepository) {
        this.channelMatchingRepository = channelMatchingRepository;
        this.productMatchingRepository = productMatchingRepository;
        sgMail.setApiKey(process.env.SENDGRID_API_KEY);
    }
    async sendEmail(data) {
        console.log("data:", data);
        sgMail.send(data, (error, result) => {
            if (error) {
                console.log(error);
            }
            else {
                console.log("That's wassup!");
                return true;
            }
        });
    }
    async sendChannelSuggestion(data, suggestion) {
        sgMail.send(data, (error, result) => {
            if (error) {
                console.log(error);
            }
            else {
                this.channelMatchingRepository.bulkCreate(suggestion);
            }
        });
    }
    async sendProductSuggestion(data, suggestion) {
        sgMail.send(data, (error, result) => {
            if (error) {
                console.log(error);
            }
            else {
                this.productMatchingRepository.bulkCreate(suggestion);
            }
        });
    }
};
MailerService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject('ChannelMatchingRepository')),
    __param(1, common_1.Inject('ProductMatchingRepository')),
    __metadata("design:paramtypes", [Object, Object])
], MailerService);
exports.MailerService = MailerService;
//# sourceMappingURL=mailerservice.service.js.map