"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@nestjs/core");
const app_module_1 = require("./app.module");
const validation_pipe_1 = require("./middleware/pipe/validation.pipe");
const express_1 = require("express");
const contextService = require('request-context');
async function bootstrap() {
    const nestOptions = {
        cors: {
            origin: '*',
            methods: 'GET,HEAD,PUT,PATCH,POST,DELETE,OPTIONS',
            maxAge: 86400,
            preflightContinue: false,
            optionsSuccessStatus: 204,
        }, bodyParser: true
    };
    const app = await core_1.NestFactory.create(app_module_1.AppModule, nestOptions);
    app.useGlobalPipes(new validation_pipe_1.ValidationPipe());
    app.enableCors({
        allowedHeaders: ['*']
    });
    app.setGlobalPrefix('api/v2');
    app.use(express_1.json({ limit: '50mb' }));
    app.use(contextService.middleware('request'));
    await app.listen(process.env.PORT || 3000);
}
bootstrap().then(() => console.log('Application is listening on port 3000'));
//# sourceMappingURL=main.js.map