'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageCodeError = void 0;
const moduleErrorMessage = require("./errorMessages");
class MessageCodeError extends Error {
    constructor(messageCode, httpStatus, lang) {
        super();
        const errorMessageConfig = this.getMessageFromMessageCode(messageCode);
        Error.captureStackTrace(this, this.constructor);
        if (!errorMessageConfig.code) {
            errorMessageConfig.code = 0;
            errorMessageConfig.message = messageCode;
        }
        this.code = errorMessageConfig.code;
        this.message = errorMessageConfig.message;
    }
    getMessageFromMessageCode(messageCode) {
        let errorMessageConfig = {};
        if (typeof messageCode == "string") {
            var message = messageCode.split(":");
            if (moduleErrorMessage[message[0]]) {
                Object.keys(moduleErrorMessage[message[0]]).forEach(key => {
                    if (key === messageCode) {
                        errorMessageConfig = moduleErrorMessage[message[0]][key];
                        return true;
                    }
                });
            }
        }
        return errorMessageConfig;
    }
}
exports.MessageCodeError = MessageCodeError;
//# sourceMappingURL=MessageCodeError.js.map