"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccountModule = void 0;
const common_1 = require("@nestjs/common");
const database_providers_1 = require("../../core/database/database.providers");
const address_provider_1 = require("../channel/provider/address.provider");
const channel_provider_1 = require("../channel/provider/channel.provider");
const emailer_module_1 = require("../emailer/emailer.module");
const emailer_service_1 = require("../emailer/services/emailer.service");
const SignUpHistory_providers_1 = require("../user/provider/SignUpHistory.providers");
const user_provider_1 = require("../user/provider/user.provider");
const userRole_providers_1 = require("../user/provider/userRole.providers");
const user_module_1 = require("../user/user.module");
const account_controller_1 = require("./controller/account.controller");
const account_service_1 = require("./service/account.service");
const event_provider_1 = require("../channel/provider/event.provider");
let AccountModule = class AccountModule {
};
AccountModule = __decorate([
    common_1.Module({
        controllers: [account_controller_1.AccountController],
        providers: [
            account_service_1.AccountService,
            emailer_service_1.EmailerService,
            ...database_providers_1.databaseProviders,
            ...user_provider_1.UserProviders,
            ...userRole_providers_1.UserRoleProviders,
            ...SignUpHistory_providers_1.SignUpHistoryProviders,
            ...address_provider_1.addressProvider,
            ...address_provider_1.oldAddressProvider,
            ...channel_provider_1.channelDetailProvider,
            ...channel_provider_1.channelProductGroupProvider,
            ...channel_provider_1.channelProductCatProvider,
            ...channel_provider_1.oldChannelProvider,
            ...event_provider_1.eventProvider
        ],
        exports: [
            account_service_1.AccountService
        ],
        imports: [user_module_1.UserModule, emailer_module_1.EmailerModule]
    })
], AccountModule);
exports.AccountModule = AccountModule;
//# sourceMappingURL=account.module.js.map