"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccountController = void 0;
const common_1 = require("@nestjs/common");
const database_config_1 = require("../../../core/database/database.config");
const account_service_1 = require("../service/account.service");
const signup_dto_1 = require("../dto/signup.dto");
const hubspotImport_helper_1 = require("../../../hubspot/helper/hubspotImport.helper");
const validation_pipe_1 = require("../../../middleware/pipe/validation.pipe");
const account_pipe_1 = require("../pipe/account.pipe");
const forgotPassword_dto_1 = require("../dto/forgotPassword.dto");
const resetPassword_dto_1 = require("../dto/resetPassword.dto");
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
const resetPasswordBo_dto_1 = require("../dto/resetPasswordBo.dto");
var request = require('request');
let AccountController = class AccountController {
    constructor(accountService) {
        this.accountService = accountService;
    }
    async signUp(signUpData, res) {
        let hubspotClient = new hubspotImport_helper_1.HubspotImportHelper();
        if (!signUpData.hubspotCompanyId) {
            signUpData.hubspotCompanyId = await hubspotClient.createCompany(signUpData);
            console.log('signUpData.hubspotCompanyId', signUpData.hubspotCompanyId);
            if (!signUpData.hubspotCompanyId)
                throw new Process_exception_1.ProcessException('creating hubspot error');
        }
        else {
            await hubspotClient.updateCompany(signUpData, signUpData.hubspotCompanyId);
        }
        if (!signUpData.hubspot_contact_id) {
            signUpData.hubspot_contact_id = await hubspotClient.impotContactToHubSpot(signUpData);
            console.log('signUpData.hubspot_contact_id', signUpData.hubspot_contact_id);
            if (!signUpData.hubspot_contact_id)
                throw new Process_exception_1.ProcessException('creating hubspot contact error');
        }
        else {
            await hubspotClient.UpdateContactToHubSpot(signUpData, signUpData.hubspot_contact_id);
        }
        await hubspotClient.mergeContactToCompany(signUpData.hubspot_contact_id, signUpData.hubspotCompanyId);
        let cheackmail = await this.accountService.checkEmail(signUpData.email);
        if (!cheackmail) {
            res.status(common_1.HttpStatus.BAD_REQUEST).send({ code: 1413, message: 'Given mail id already exist' });
        }
        else {
            await this.accountService.create(signUpData);
            res.status(common_1.HttpStatus.CREATED).send('ok');
        }
    }
    async checkmail(email, res) {
        let result = await this.accountService.checkEmail(email.trim());
        console.log('email', email);
        res.status(common_1.HttpStatus.OK).send({
            isavialble: result
        });
    }
    async checkCompanyName(data, res) {
        let result = await this.accountService.checkCompanyName(data.name.trim());
        res.status(common_1.HttpStatus.OK).send({
            isavialble: result
        });
    }
    async getCompanyData(data, res) {
        let result = await this.accountService.getCompanyData(data.name.trim());
        res.status(common_1.HttpStatus.OK).send(result);
    }
    async forgotPassword(res, forgotPasswordDto) {
        console.log('forgotPasswordDto', forgotPasswordDto);
        let result = await this.accountService.forgotPassword(forgotPasswordDto.email);
        console.log('result', result);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async resetPassword(token, res) {
        let result = await this.accountService.resetPassword(token);
        return res.status(common_1.HttpStatus.OK).send({
            valid: result
        });
    }
    async resetPasswordUpdate(token, res, resetPasswordDto) {
        await this.accountService.resetPasswordUpdate(token, resetPasswordDto.password);
        return res.status(common_1.HttpStatus.OK).send({
            'message': 'New Password updated successfully'
        });
    }
    async resetPasswordUpdateBO(res, resetPasswordDto) {
        await this.accountService.updatePasswordFrom_BO(resetPasswordDto);
        return res.status(common_1.HttpStatus.OK).send({
            'message': 'New Password updated successfully'
        });
    }
    async getEventRegister(data, res) {
        var options = {
            'method': 'GET',
            'url': data.url,
            'headers': {
                'Authorization': data.token.token_type + ' ' + data.token.access_token
            }
        };
        request(options, function (error, response) {
            if (error)
                throw new Error(error);
            return res.status(common_1.HttpStatus.OK).send(response.body);
        });
    }
    async postEventRegister(data, res) {
        var options = {
            'method': 'POST',
            'url': data.url,
            'headers': {
                'Authorization': data.token.token_type + ' ' + data.token.access_token,
                'Content-Type': 'application/json'
            },
            body: JSON.stringify(data.body)
        };
        request(options, function (error, response) {
            if (error)
                throw new Error(error);
            return res.status(common_1.HttpStatus.OK).send(response.body);
        });
    }
    async eventcatalystToken(data, res) {
        let body = new URLSearchParams();
        body.set('grant_type', process.env.EVENTCAT_GRANT_TYPE);
        body.set('username', process.env.EVENTCAT_USERNAME);
        body.set('password', process.env.EVENTCAT_PASSWORD);
        var options = {
            'method': 'POST',
            'url': data.url,
            'headers': {
                'Content-Type': 'application/x-www-form-urlencoded'
            },
            body: body.toString()
        };
        request(options, function (error, response) {
            if (error)
                throw new Error(error);
            return res.status(common_1.HttpStatus.OK).send(response.body);
        });
    }
    async getPublicToken(id, res) {
        let token = await this.accountService.encryptAuth(id);
        return res.status(common_1.HttpStatus.OK).send({
            token: token
        });
    }
    async checkPublicAuth(token, res) {
        let id = await this.accountService.decryptAuth(token);
        return res.status(common_1.HttpStatus.OK).send({
            id: id
        });
    }
    async setEventContact(id, res) {
        await this.accountService.isEvent(id, '1');
        return res.status(common_1.HttpStatus.OK).send();
    }
};
__decorate([
    common_1.Post(),
    __param(0, common_1.Body(new validation_pipe_1.ValidationPipe())), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [signup_dto_1.SignupDto, Object]),
    __metadata("design:returntype", Promise)
], AccountController.prototype, "signUp", null);
__decorate([
    common_1.Get('checkmail/:email'),
    __param(0, common_1.Param('email', new account_pipe_1.CheckEmailPipe())), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], AccountController.prototype, "checkmail", null);
__decorate([
    common_1.Post('checkCompanyName'),
    __param(0, common_1.Body()), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], AccountController.prototype, "checkCompanyName", null);
__decorate([
    common_1.Post('getCompanyData'),
    __param(0, common_1.Body()), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], AccountController.prototype, "getCompanyData", null);
__decorate([
    common_1.Post('forgotPassword'),
    __param(0, common_1.Res()), __param(1, common_1.Body(new validation_pipe_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, forgotPassword_dto_1.ForgotPasswordDto]),
    __metadata("design:returntype", Promise)
], AccountController.prototype, "forgotPassword", null);
__decorate([
    common_1.Get('resetPassword/:token'),
    __param(0, common_1.Param('token')), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], AccountController.prototype, "resetPassword", null);
__decorate([
    common_1.Post('resetPassword/:token'),
    __param(0, common_1.Param('token')), __param(1, common_1.Res()), __param(2, common_1.Body(new validation_pipe_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, resetPassword_dto_1.ResetPasswordDto]),
    __metadata("design:returntype", Promise)
], AccountController.prototype, "resetPasswordUpdate", null);
__decorate([
    common_1.Post('resetPasswordBO'),
    __param(0, common_1.Res()), __param(1, common_1.Body(new validation_pipe_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, resetPasswordBo_dto_1.ResetPasswordBoDto]),
    __metadata("design:returntype", Promise)
], AccountController.prototype, "resetPasswordUpdateBO", null);
__decorate([
    common_1.Post('getEventRegister'),
    __param(0, common_1.Body(new validation_pipe_1.ValidationPipe())), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], AccountController.prototype, "getEventRegister", null);
__decorate([
    common_1.Post('postEventRegister'),
    __param(0, common_1.Body(new validation_pipe_1.ValidationPipe())), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], AccountController.prototype, "postEventRegister", null);
__decorate([
    common_1.Post('eventcatalystToken'),
    __param(0, common_1.Body(new validation_pipe_1.ValidationPipe())), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], AccountController.prototype, "eventcatalystToken", null);
__decorate([
    common_1.Get('getPublicToken/:id'),
    __param(0, common_1.Param('id')), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], AccountController.prototype, "getPublicToken", null);
__decorate([
    common_1.Get('checkAuth/:token'),
    __param(0, common_1.Param('token')), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], AccountController.prototype, "checkPublicAuth", null);
__decorate([
    common_1.Get('setEventContact/:id'),
    __param(0, common_1.Param('id')), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], AccountController.prototype, "setEventContact", null);
AccountController = __decorate([
    common_1.Controller('account'),
    __metadata("design:paramtypes", [account_service_1.AccountService])
], AccountController);
exports.AccountController = AccountController;
//# sourceMappingURL=account.controller.js.map