"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SignupDto = void 0;
const class_validator_1 = require("class-validator");
const swagger_1 = require("@nestjs/swagger");
class SignupDto {
}
__decorate([
    class_validator_1.MinLength(2, { message: "account:singup:fisrtNameMinLeng" }),
    class_validator_1.MaxLength(30, { message: "account:singup:fisrtNameMaxLeng" }),
    class_validator_1.IsNotEmpty({ message: "account:singup:fisrtNameIsNotEmpty" }),
    class_validator_1.IsString({ message: "account:singup:firstnameonlyacceptStringOnly" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SignupDto.prototype, "firstName", void 0);
__decorate([
    class_validator_1.MaxLength(30, { message: "account:singup:lastNameMaxLeng" }),
    class_validator_1.IsNotEmpty({ message: "account:singup:lastNameIsNotEmpty" }),
    class_validator_1.IsString({ message: "account:singup:lastnameonlyacceptStringOnly" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SignupDto.prototype, "lastName", void 0);
__decorate([
    class_validator_1.IsEmail({}, { message: "account:singup:emailInvalide" }),
    class_validator_1.IsNotEmpty({ message: "account:singup:emailIsNotEmpty" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SignupDto.prototype, "email", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "account:singup:passwordIsNotEmpty" }),
    class_validator_1.MinLength(8, { message: "account:singup:passwordMinLen" }),
    class_validator_1.MaxLength(25, { message: "account:singup:passwordMaxLen" }),
    class_validator_1.Matches(RegExp("^(?=.*?[A-Z])(?=.*?[a-z])(?=.*?[0-9])(?=.*?[#?!@$%^&*-]).{8,25}$"), { message: "account:singup:passwordMatches" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SignupDto.prototype, "password", void 0);
__decorate([
    class_validator_1.MinLength(2, { message: "account:singup:companyNameMinLeng" }),
    class_validator_1.IsNotEmpty({ message: "account:singup:companyNameIsNotEmpty" }),
    class_validator_1.IsString({ message: "account:singup:companynameonlyacceptStringOnly" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SignupDto.prototype, "companyName", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "account:singup:companyAddressIsNotEmpty" }),
    class_validator_1.MaxLength(255, { message: "account:singup:companyAddressMaxLeng" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SignupDto.prototype, "address", void 0);
__decorate([
    class_validator_1.MinLength(1, { message: "account:singup:jobPositionMinLeng" }),
    class_validator_1.MaxLength(80, { message: "account:singup:jobPositionMaxLeng" }),
    class_validator_1.IsNotEmpty({ message: "account:singup:jobPositionIsNotEmpty" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SignupDto.prototype, "jobPosition", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "account:singup:cityIsNotEmpty" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SignupDto.prototype, "city", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "account:singup:stateIsNotEmpty" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SignupDto.prototype, "state", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "account:singup:countryIdIsNotEmpty" }),
    class_validator_1.IsNumber({}, { message: "account:singup:countryIdonlyacceptInt" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], SignupDto.prototype, "countryId", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "account:singup:postalcodeIsNotEmpty" }),
    class_validator_1.MinLength(3, { message: "account:singup:postalcodeMinLen" }),
    class_validator_1.MaxLength(12, { message: "account:singup:postalcodeMaxLen" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SignupDto.prototype, "postalCode", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "account:singup:websiteurlIsNotEmpty" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SignupDto.prototype, "websiteurl", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "account:singup:mobileIsNotEmpty" }),
    class_validator_1.MinLength(4, { message: "account:singup:mobileMinLen" }),
    class_validator_1.MaxLength(20, { message: "account:singup:mobileMaxLen" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SignupDto.prototype, "mobile", void 0);
__decorate([
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], SignupDto.prototype, "channelTypeId", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], SignupDto.prototype, "oldChannelId", void 0);
__decorate([
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], SignupDto.prototype, "hubspot_contact_id", void 0);
__decorate([
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], SignupDto.prototype, "hubspotCompanyId", void 0);
__decorate([
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SignupDto.prototype, "switchPhone", void 0);
__decorate([
    class_validator_1.ArrayNotEmpty({ message: "validate:field:shouldBeArray" }),
    class_validator_1.IsNumber({}, {
        each: true,
        message: "validate:field:shouldBeInt"
    }),
    swagger_1.ApiProperty({ type: 'number', isArray: true }),
    __metadata("design:type", Array)
], SignupDto.prototype, "productFamilies", void 0);
__decorate([
    class_validator_1.ArrayNotEmpty({ message: "validate:field:shouldBeArray" }),
    class_validator_1.IsNumber({}, {
        each: true,
        message: "validate:field:shouldBeInt"
    }),
    swagger_1.ApiProperty({ type: 'number', isArray: true }),
    __metadata("design:type", Array)
], SignupDto.prototype, "productCategories", void 0);
__decorate([
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SignupDto.prototype, "isOEM", void 0);
__decorate([
    class_validator_1.IsOptional(),
    __metadata("design:type", Number)
], SignupDto.prototype, "eventId", void 0);
__decorate([
    class_validator_1.IsOptional(),
    __metadata("design:type", Number)
], SignupDto.prototype, "participantType", void 0);
exports.SignupDto = SignupDto;
//# sourceMappingURL=signup.dto.js.map