import { Address } from 'src/modules/channel/models/Address.entity';
import { Channel } from 'src/modules/channel/models/Channel.entity';
import { ChannelDetail } from 'src/modules/channel/models/ChannelDetail.entity';
import { ChannelProductGroup } from 'src/modules/channel/models/ChannelProductGroup.entity';
import { Contact } from 'src/modules/user/models/Contact.entity';
import { SignUpHistory } from 'src/modules/user/models/SignUpHistory.entity';
import { User } from 'src/modules/user/models/User.entity';
import { UserRole } from 'src/modules/user/models/UserRole.entity';
import { SignupDto } from '../dto/signup.dto';
import { ChannelProductCategorie } from 'src/modules/channel/models/ChannelProductCategorie.entity';
import { OldChannel } from 'src/modules/channel/models/OldChannel.entity';
import { EmailerService } from 'src/modules/emailer/services/emailer.service';
import { EventParticipants } from 'src/modules/channel/models/EventParticipants.entity';
import { EventChannel } from 'src/modules/channel/models/EventChannel.entity';
export declare class AccountService {
    private readonly emailerService;
    private readonly userRepository;
    private readonly sequelizeInstance;
    private readonly contactRepository;
    private readonly userRoleRepository;
    private readonly channelRepository;
    private readonly signUpHistorylRepository;
    private readonly addressRepository;
    private readonly channelDetailRepository;
    private readonly channelProductGroupRepository;
    private readonly channelCatRepository;
    private readonly oldChannelRepository;
    private readonly eventParticipantRepository;
    private readonly eventChannelRepository;
    private utility;
    constructor(emailerService: EmailerService, userRepository: typeof User, sequelizeInstance: any, contactRepository: typeof Contact, userRoleRepository: typeof UserRole, channelRepository: typeof Channel, signUpHistorylRepository: typeof SignUpHistory, addressRepository: typeof Address, channelDetailRepository: typeof ChannelDetail, channelProductGroupRepository: typeof ChannelProductGroup, channelCatRepository: typeof ChannelProductCategorie, oldChannelRepository: typeof OldChannel, eventParticipantRepository: typeof EventParticipants, eventChannelRepository: typeof EventChannel);
    create(user: SignupDto, skipVerify?: boolean): Promise<any>;
    setSignUpObject(user: SignupDto, pin: string, signUpStatus: number): Promise<User>;
    checkEmail(email: string): Promise<boolean>;
    checkCompanyName(name: string): Promise<boolean>;
    setProductGroup(productFamilies: any, channelId: number): Promise<ChannelProductGroup[]>;
    setChannelProductGroup(productGroup: any, channelId: number): Promise<ChannelProductGroup[]>;
    setChannelProductCat(productCat: any, channelId: number): Promise<ChannelProductCategorie[]>;
    getCompanyData(name: string): Promise<OldChannel>;
    forgotPassword(email: string): Promise<any>;
    resetPassword(token: string): Promise<any>;
    resetPasswordUpdate(token: string, password: string): Promise<any>;
    updatePasswordFrom_BO(updatePasswordDto: any): Promise<boolean>;
    encryptAuth(token: any): Promise<any>;
    decryptAuth(token: any): Promise<any>;
    isEvent(ContactId: any, isEvent: any): Promise<[number, Contact[]]>;
}
