"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccountOutBound = void 0;
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
const config_1 = require("../../../config");
class AccountOutBound {
    async setLoginResponse(user, token, productCount = 0, signUpStatusId, isAnyInbound) {
        try {
            let returnObject = {};
            returnObject.token = 'Bearer ' + token;
            returnObject.channelId = parseInt(user.channelId.toString());
            returnObject.currency = (user.contact.channel.channelDetail) ? +user.contact.channel.channelDetail.currencyid : null;
            returnObject.contactId = parseInt(user.contactId.toString());
            returnObject.role = (user.roles) ? user.roles[0] : null;
            returnObject.permissions = user.permissions;
            returnObject.profile = user.contact;
            let channel = user.contact.channel;
            returnObject.oldChannel = !!(user.contact.channel.oldChannelId);
            returnObject.channelStatusId = (signUpStatusId && signUpStatusId > 0) ? signUpStatusId : parseInt(channel.signUpStatusId.toString());
            returnObject.sourcingProfile = config_1.appconstant.SOURCING_CONTACT;
            returnObject.sellingProfile = config_1.appconstant.SELLING_CONTACT;
            returnObject.otherProfile = config_1.appconstant.OTHER_CONTACT;
            returnObject.isAnyInbound = (isAnyInbound != undefined) ? isAnyInbound : false;
            returnObject.productCount = (user.contact.channel.actAsDistributor === '1') ? (productCount === 0) ? 1 : productCount : productCount;
            return returnObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('account:objectCreation:userResponse');
        }
    }
}
exports.AccountOutBound = AccountOutBound;
//# sourceMappingURL=accountOutBound.js.map