'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccountSerivceInBound = void 0;
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
const Channel_entity_1 = require("../../channel/models/Channel.entity");
const Role_entity_1 = require("../../user/models/Role.entity");
const config_1 = require("../../../config");
class AccountSerivceInBound {
    async setPayload(user) {
        try {
            let returnObject = {};
            returnObject.id = user.userId;
            returnObject.email = user.email;
            returnObject.channelId = user.channelId;
            returnObject.contactId = user.contactId;
            returnObject.tokenModifiedAt = user.tokenModifiedAt.getTime();
            return returnObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('account:objectCreation:userToken');
        }
    }
    async setDataSession(user) {
        let returnObject = {};
        let channel = user.channel || user.contact.channel;
        returnObject.channelTypeId = (channel) ? channel.channelTypeId : null;
        returnObject.role = (user.roles) ? user.roles[0].toJSON() : null;
        returnObject.plan = (channel) ? channel.planId : null;
        returnObject.workNatureId = (user.contact) ? user.contact.workNatureId : null;
        returnObject.permissions = (user.permissions) ? user.permissions.map(a => +a.accesspermissionid) : null;
        return returnObject;
    }
    async setSignUpObject(user, pin, signUpStatus) {
        try {
            let signUpHistory = {};
            signUpHistory.signUpStatusId = signUpStatus;
            signUpHistory.createdAt = new Date();
            let channel = {};
            channel.signUpStatusId = signUpStatus;
            channel.channelTypeId = Channel_entity_1.Channel.CHANNEL_TYPE_SIGNUP;
            channel.isActive = '1';
            channel.createdAt = new Date();
            channel.signUpHistory = signUpHistory;
            if (+signUpStatus == config_1.appconstant.SUBSCRIPTION) {
                channel.isAdminCreated = '1';
            }
            let contact = {};
            contact.firstName = user.firstName;
            contact.lastName = user.lastName;
            contact.email = user.email;
            contact.hubspotContactId = (user.hubspot_contact_id) ? user.hubspot_contact_id : null;
            contact.isActive = '1';
            contact.isDefaultContact = '1';
            contact.createdAt = new Date();
            let userRole = {};
            userRole.roleId = Role_entity_1.Role.ROLE_ACCOUNT_USER;
            let returnObject = {};
            returnObject.contact = contact;
            returnObject.channel = channel;
            returnObject.role = userRole;
            returnObject.email = user.email;
            returnObject.password = user.password;
            returnObject.verificationCode = pin;
            returnObject.verificationSentAt = new Date();
            returnObject.isActive = '1';
            returnObject.createdAt = new Date();
            return returnObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('account:objectCreation:User');
        }
    }
    async setMailObject(email, pin) {
        let returnObject = {};
        returnObject.pin = pin;
        returnObject.email = email;
        returnObject.tokenExpires = Date.now() + 3600000 * 24;
        return returnObject;
    }
}
exports.AccountSerivceInBound = AccountSerivceInBound;
//# sourceMappingURL=accountSerivceInBound.js.map