'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActivityService = void 0;
const common_1 = require("@nestjs/common");
const context_service_1 = require("../../../context/context.service");
const sequelize_typescript_1 = require("sequelize-typescript");
let ActivityService = class ActivityService {
    constructor(context, userActivityRepository, nonUserActivityRepository) {
        this.context = context;
        this.userActivityRepository = userActivityRepository;
        this.nonUserActivityRepository = nonUserActivityRepository;
    }
    async UserLogActivity(action, token, req, otherInfo = null) {
        var parser = require('ua-parser-js');
        let logActivity = {};
        logActivity.userId = 1761;
        logActivity.action = action;
        logActivity.token = token;
        logActivity.loggedAt = sequelize_typescript_1.Sequelize.fn('NOW');
        logActivity.ipaddress = req.ip;
        logActivity.deviceInfo = JSON.stringify(parser(req.headers['user-agent']), null, '  ');
        logActivity.otherInfo = otherInfo;
        this.userActivityRepository.create(logActivity).then(() => {
            console.log('saving... user log');
        });
    }
    async NonUserLogActivity(action, userId, req, otherInfo = null) {
        var parser = require('ua-parser-js');
        let logActivity = {};
        logActivity.userID = userId;
        if (otherInfo == 1)
            action = "User Details";
        else if (otherInfo == 2)
            action = "Company Details";
        else if (otherInfo == 3)
            action = "Verify OTP";
        else if (otherInfo == 4)
            action = "Confirm Password";
        logActivity.action = action;
        logActivity.loggedAt = sequelize_typescript_1.Sequelize.fn('NOW');
        logActivity.ipaddress = req.ip;
        logActivity.deviceInfo = JSON.stringify(parser(req.headers['user-agent']), null, '  ');
        logActivity.otherInfo = otherInfo;
        this.nonUserActivityRepository.findOrCreate({ where: { userID: logActivity.userID }, defaults: logActivity }).then((result) => {
            if (!result[1]) {
                result[0].update(logActivity).then((result) => {
                    console.log('Updated...');
                });
            }
            else {
                console.log('created');
            }
        });
    }
};
ActivityService = __decorate([
    common_1.Injectable(),
    __param(1, common_1.Inject('UserActivityRepository')),
    __param(2, common_1.Inject('NonUserActivityRepository')),
    __metadata("design:paramtypes", [context_service_1.ContextService, Object, Object])
], ActivityService);
exports.ActivityService = ActivityService;
//# sourceMappingURL=activity.service.js.map