"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminController = void 0;
const common_1 = require("@nestjs/common");
const admin_service_1 = require("../service/admin.service");
let AdminController = class AdminController {
    constructor(adminService) {
        this.adminService = adminService;
    }
    async userListing(req, res, data) {
        let result = await this.adminService.userListing(data);
        if (result) {
            res.status(common_1.HttpStatus.OK).json(result);
        }
        else {
        }
    }
    async updateContact(data, res, req, contactId) {
        let result = await this.adminService.updateContact(contactId, data);
        res.status(common_1.HttpStatus.OK).send({
            result: result
        });
    }
    async userCountry(req, res, data) {
        let result = await this.adminService.userCountries();
        if (result) {
            res.status(common_1.HttpStatus.OK).json(result);
        }
        else {
        }
    }
    async searchList(req, res, data) {
        let result = await this.adminService.searchList();
        if (result) {
            res.status(common_1.HttpStatus.OK).json(result);
        }
        else {
        }
    }
    async menuListing(accessId, req, res) {
        let result = await this.adminService.menuListing(accessId);
        if (result) {
            res.status(common_1.HttpStatus.OK).json(result);
        }
        else {
        }
    }
};
__decorate([
    common_1.Post('userListing'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], AdminController.prototype, "userListing", null);
__decorate([
    common_1.Patch('updateContact/:contactId'),
    __param(0, common_1.Body(new common_1.ValidationPipe())), __param(1, common_1.Response()), __param(2, common_1.Request()), __param(3, common_1.Param('contactId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object, Object]),
    __metadata("design:returntype", Promise)
], AdminController.prototype, "updateContact", null);
__decorate([
    common_1.Post('userCountry'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], AdminController.prototype, "userCountry", null);
__decorate([
    common_1.Get('searchList'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], AdminController.prototype, "searchList", null);
__decorate([
    common_1.Get('menuListing/:accessId'),
    __param(0, common_1.Param('accessId')), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], AdminController.prototype, "menuListing", null);
AdminController = __decorate([
    common_1.Controller('admin'),
    __metadata("design:paramtypes", [admin_service_1.AdminService])
], AdminController);
exports.AdminController = AdminController;
//# sourceMappingURL=admin.controller.js.map