"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminUsers = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const AdminUserChanneltype_entity_1 = require("./AdminUserChanneltype.entity");
const AdminUserCountries_entity_1 = require("./AdminUserCountries.entity");
const AdminUserNotification_entity_1 = require("./AdminUserNotification.entity");
const crypto = require("crypto");
const tableOptions = { tableName: 'tblAdminUsers' };
let AdminUsers = class AdminUsers extends sequelize_typescript_1.Model {
    static async hashPassword(user, options) {
        if (user.password) {
            var hash = crypto.createHmac('sha512', process.env.USER_PASSWORD_SALT_ROUNT);
            hash.update(user.password);
            user.password = hash.digest('hex');
        }
    }
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], AdminUsers.prototype, "adminUserId", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], AdminUsers.prototype, "fName", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], AdminUsers.prototype, "lName", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], AdminUsers.prototype, "jobTitle", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], AdminUsers.prototype, "role", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], AdminUsers.prototype, "emailId", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], AdminUsers.prototype, "password", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], AdminUsers.prototype, "isVerified", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], AdminUsers.prototype, "isActive", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", Date)
], AdminUsers.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], AdminUsers.prototype, "reportingTo", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], AdminUsers.prototype, "accessId", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => AdminUserCountries_entity_1.AdminUserCountries, 'adminUserId'),
    __metadata("design:type", Array)
], AdminUsers.prototype, "managedCountries", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => AdminUserNotification_entity_1.AdminUserNotification, 'adminUserId'),
    __metadata("design:type", Array)
], AdminUsers.prototype, "preference", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => AdminUserChanneltype_entity_1.AdminUserChanneltype, 'adminUserId'),
    __metadata("design:type", Array)
], AdminUsers.prototype, "managedChannelTypes", void 0);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [AdminUsers, Object]),
    __metadata("design:returntype", Promise)
], AdminUsers, "hashPassword", null);
AdminUsers = __decorate([
    sequelize_typescript_1.Table(tableOptions),
    sequelize_typescript_1.Scopes(() => ({
        userLogInInfom: {
            attributes: ['adminUserId', 'jobTitle', 'permissions', 'password', 'emailId']
        }
    }))
], AdminUsers);
exports.AdminUsers = AdminUsers;
//# sourceMappingURL=AdminUsers.entity.js.map