"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AdminService = void 0;
const common_1 = require("@nestjs/common");
const sequelize_1 = require("sequelize");
const AdminUserCountries_entity_1 = require("../models/AdminUserCountries.entity");
const AdminUserChanneltype_entity_1 = require("../models/AdminUserChanneltype.entity");
const Country_entity_1 = require("../../common/models/Country.entity");
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
const AdminUserNotification_entity_1 = require("../models/AdminUserNotification.entity");
let AdminService = class AdminService {
    constructor(sequelizeInstance, adminUserRepository, adminUserCountryRepository, AdminUserChannelRepository, adminUserNotificationRepository) {
        this.sequelizeInstance = sequelizeInstance;
        this.adminUserRepository = adminUserRepository;
        this.adminUserCountryRepository = adminUserCountryRepository;
        this.AdminUserChannelRepository = AdminUserChannelRepository;
        this.adminUserNotificationRepository = adminUserNotificationRepository;
        this.specialChars = ['@', '#', '%', '$', '*'];
    }
    async userListing(data) {
        try {
            let filter = data.filter;
            const users = await this.adminUserRepository.scope().findAndCountAll({
                limit: data.limit,
                offset: data.page,
                where: (data.search) ? { adminUserId: +data.search } : {},
                distinct: true,
                include: [{
                        model: AdminUserCountries_entity_1.AdminUserCountries,
                        attributes: [['countryId', 'id']],
                        required: (filter.countryId) ? true : false,
                        where: (filter.countryId) ? { countryId: { [sequelize_1.Op.in]: filter.countryId } } : {},
                        include: [{
                                model: Country_entity_1.Country,
                                attributes: [['countryId', 'id'], ['country', 'name']],
                                required: false,
                            }],
                    },
                    {
                        model: AdminUserChanneltype_entity_1.AdminUserChanneltype,
                        attributes: [['typeId', 'id'], ['channelType', 'name']],
                        required: (filter.channelTypeId) ? true : false,
                        where: (filter.channelTypeId) ? { typeId: +filter.channelTypeId } : {},
                    },
                    {
                        model: AdminUserNotification_entity_1.AdminUserNotification,
                        attributes: [['notificationId', 'id']],
                        required: false,
                    }
                ]
            });
            return users;
        }
        catch (e) {
            console.log(e);
        }
    }
    async updateContact(contactId, data) {
        var _a, _b;
        let contactData = data.userData;
        let preference = data.preference;
        console.log("contactData:", contactData);
        console.log("preference:", preference);
        let result;
        let contact = await this.adminUserRepository.findOne({
            where: {
                adminUserId: contactId
            }
        });
        if (!contact && contactData) {
            let password = await this.getPassword();
            let contact = {};
            let managedCty = [];
            let managedType = [];
            let notification = [];
            if (contactData.firstName)
                contact['fName'] = contactData.firstName;
            if (contactData.lastName)
                contact['lName'] = contactData.lastName;
            if (contactData.email)
                contact['emailId'] = contactData.email;
            if (contactData.role)
                contact['role'] = contactData.role.name;
            contact['accessId'] = contactData.role.id;
            contact['isActive'] = '1';
            contact['password'] = password;
            if (contactData.role.id == 2) {
                let ven = contactData.managedChannelType.filter(x => x.id == 2);
                if (ven.length > 0)
                    contact['accessId'] = 2;
                else
                    contact['accessId'] = 3;
            }
            await this.adminUserRepository.create(contact).then((results) => {
                var _a, _b;
                contactId = results['dataValues'].adminUserId;
                result = {
                    name: contactData.firstName + ' ' + contactData.lastName,
                    profileurl: process.env.DOMAIN,
                    userId: contactData.email,
                    to: contactData.email,
                    password: password,
                    accountOwner: 'ChannelHub'
                };
                if (contactData.managedChannelType && ((_a = contactData.managedChannelType) === null || _a === void 0 ? void 0 : _a.length) > 0) {
                    contactData.managedChannelType.map(x => {
                        managedType.push({ adminUserId: contactId, typeId: x.id, channelType: x.name });
                    });
                }
                if (contactData.managedCountry && ((_b = contactData.managedCountry) === null || _b === void 0 ? void 0 : _b.length) > 0) {
                    contactData.managedCountry.map(x => {
                        managedCty.push({ adminUserId: contactId, countryId: x.id });
                    });
                }
                if (preference && preference.length > 0) {
                    preference.map(x => {
                        notification.push({ adminUserId: contactId, notificationId: x });
                    });
                }
            });
            if (managedCty)
                await this.adminUserCountryRepository.bulkCreate(managedCty);
            if (managedType)
                await this.AdminUserChannelRepository.bulkCreate(managedType);
            if (notification)
                await this.adminUserNotificationRepository.bulkCreate(notification);
        }
        else if (contactData) {
            let contact = {};
            let managedCty = [];
            let managedType = [];
            let notification = [];
            if (contactData.firstName)
                contact['fName'] = contactData.firstName;
            if (contactData.lastName)
                contact['lName'] = contactData.lastName;
            if (contactData.email)
                contact['emailId'] = contactData.email;
            if (contactData.role)
                contact['role'] = contactData.role.name;
            contact['accessId'] = contactData.role.id;
            if (contactData.role.id == 2) {
                let ven = contactData.managedChannelType.filter(x => x.id == 2);
                if (ven.length > 0)
                    contact['accessId'] = 2;
                else
                    contact['accessId'] = 3;
            }
            if (contactData.managedChannelType && ((_a = contactData.managedChannelType) === null || _a === void 0 ? void 0 : _a.length) > 0) {
                contactData.managedChannelType.map(x => {
                    managedType.push({ adminUserId: contactId, typeId: x.id, channelType: x.name });
                });
            }
            if (contactData.managedCountry && ((_b = contactData.managedCountry) === null || _b === void 0 ? void 0 : _b.length) > 0) {
                contactData.managedCountry.map(x => {
                    managedCty.push({ adminUserId: contactId, countryId: x.id });
                });
            }
            if (preference && preference.length > 0) {
                preference.map(x => {
                    notification.push({ adminUserId: contactId, notificationId: x });
                });
            }
            await this.adminUserRepository.update(contact, {
                where: {
                    adminUserId: contactId
                }
            });
            await this.adminUserCountryRepository.destroy({
                where: {
                    adminUserId: contactId
                }
            });
            if (managedCty)
                await this.adminUserCountryRepository.bulkCreate(managedCty);
            await this.AdminUserChannelRepository.destroy({
                where: {
                    adminUserId: contactId
                }
            });
            if (managedType)
                await this.AdminUserChannelRepository.bulkCreate(managedType);
            await this.adminUserNotificationRepository.destroy({
                where: {
                    adminUserId: contactId
                }
            });
            if (notification)
                await this.adminUserNotificationRepository.bulkCreate(notification);
        }
        return result;
    }
    async userCountries() {
        const countries = await this.adminUserCountryRepository.scope().findAll({
            include: [{
                    model: Country_entity_1.Country,
                    attributes: [['countryId', 'id'], ['country', 'name']],
                    required: false,
                }],
            attributes: []
        });
        return countries;
    }
    async searchList() {
        const nameList = await this.adminUserRepository.scope().findAll({
            attributes: [['adminUserId', 'id'], 'fName', 'lName'],
            where: { isActive: '1', deletedAt: null },
        });
        return nameList;
    }
    async menuListing(accessId) {
        let routes = [];
        let cquery = 'select * from "tblAdminUserAccess" as aua inner join "tblAdminMenu" as am on am."moduleId"=aua."moduleId" where aua."accessId"=:accessId order by am."moduleId"';
        await this.sequelizeInstance.query(cquery, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                accessId: accessId
            }
        }).then((results) => {
            results.map(x => {
                let menu = {};
                if (x.allowView === '1') {
                    if (x.parentMenuId == 0 && x.isParent == '0') {
                        menu = {
                            collapse: x.collapse,
                            name: x.menuName,
                            icon: x.icon,
                            state: x.state,
                            path: x.path,
                            miniName: x.miniName,
                            component: x.component,
                            layout: x.layout
                        };
                    }
                    else if (x.parentMenuId == 0 && x.isParent == '1') {
                        let childviews = [];
                        let child = results.filter(p => p.parentMenuId == x.moduleId);
                        child.map(c => {
                            if (c.allowView === '1') {
                                let view = {
                                    path: c.path,
                                    name: c.menuName,
                                    miniName: c.miniName,
                                    component: c.component,
                                    layout: c.layout
                                };
                                childviews.push(view);
                            }
                        });
                        menu = {
                            collapse: x.collapse,
                            name: x.menuName,
                            icon: x.icon,
                            state: x.state,
                            views: childviews
                        };
                    }
                    routes.push(menu);
                }
            });
        });
        return routes;
    }
    async getPassword() {
        var generator = require('generate-password');
        var password = generator.generate({
            length: 9,
            numbers: true,
            uppercase: true,
            strict: true
        });
        return password + this.specialChars[Math.floor(Math.random() * this.specialChars.length)];
    }
};
AdminService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject('SequelizeInstance')),
    __param(1, common_1.Inject('AdminUserRepository')),
    __param(2, common_1.Inject('AdminUserCountryRepository')),
    __param(3, common_1.Inject('AdminUserChannelRepository')),
    __param(4, common_1.Inject('AdminUserNotificationRepository')),
    __metadata("design:paramtypes", [Object, Object, Object, Object, Object])
], AdminService);
exports.AdminService = AdminService;
//# sourceMappingURL=admin.service.js.map