'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiController = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("../../../core");
class ApiController extends core_1.BaseController {
    constructor() {
        super();
    }
    async assignService(service) {
        this.apiService = service;
    }
    async getAll(req, res) {
        let total = 0;
        this.apiService.getCount().then(function (c) {
            total = c;
        });
        let pagination = {
            page: 1,
            limit: 20
        };
        const list = await this.apiService.findAll(pagination);
        res.setHeader('app-pagination-page', pagination.page);
        res.setHeader('app-pagination-limit', pagination.limit);
        res.setHeader('app-pagination-total', total);
        return res.status(common_1.HttpStatus.OK).json(list);
    }
    async getById(id, req, res) {
        const row = await this.apiService.findById(id);
        return res.status(common_1.HttpStatus.OK).json(row);
    }
    async create(req, res, data) {
        let result = await this.apiService.create(data);
        return res.status(common_1.HttpStatus.CREATED).send(result);
    }
    async update(id, data, req, res) {
        const row = await this.apiService.update(id, data);
        return res.status(common_1.HttpStatus.OK).json(row);
    }
    async delete(id, req, res) {
        const row = await this.apiService.delete(id);
        if (row) {
            return res.status(common_1.HttpStatus.NO_CONTENT).json();
        }
        else {
            return res.status(common_1.HttpStatus.NOT_FOUND).send();
        }
    }
}
__decorate([
    common_1.Get('/'),
    __param(0, common_1.Request()), __param(1, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], ApiController.prototype, "getAll", null);
__decorate([
    common_1.Get('/:id'),
    __param(0, common_1.Param('id')), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ApiController.prototype, "getById", null);
__decorate([
    common_1.Post('/'),
    __param(0, common_1.Request()), __param(1, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ApiController.prototype, "create", null);
__decorate([
    common_1.Put('/:id'),
    __param(2, common_1.Request()), __param(3, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ApiController.prototype, "update", null);
__decorate([
    common_1.Delete('/:id'),
    __param(0, common_1.Param('id')), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ApiController.prototype, "delete", null);
exports.ApiController = ApiController;
//# sourceMappingURL=api.controller.js.map