'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthModule = void 0;
const common_1 = require("@nestjs/common");
const passport_1 = require("@nestjs/passport");
const auth_service_1 = require("./service/auth/auth.service");
const auth_controller_1 = require("./controller/auth/auth.controller");
const local_strategy_1 = require("./local.strategy");
const user_module_1 = require("../user/user.module");
const application_providers_1 = require("./provider/application.providers");
const jwt_1 = require("@nestjs/jwt");
const jwt_strategy_1 = require("./jwt.strategy");
const channel_module_1 = require("../channel/channel.module");
let AuthModule = class AuthModule {
};
AuthModule = __decorate([
    common_1.Module({
        controllers: [
            auth_controller_1.AuthController
        ],
        providers: [
            auth_service_1.AuthService,
            local_strategy_1.LocalStrategy,
            jwt_strategy_1.JwtStrategy,
            ...application_providers_1.ApplicationProviders,
        ],
        exports: [
            auth_service_1.AuthService
        ],
        imports: [
            passport_1.PassportModule,
            user_module_1.UserModule,
            channel_module_1.ChannelModule,
            jwt_1.JwtModule.register({
                secret: process.env.JWTKEY,
                signOptions: { expiresIn: process.env.TOKEN_EXPIRATION },
            })
        ]
    })
], AuthModule);
exports.AuthModule = AuthModule;
//# sourceMappingURL=auth.module.js.map