"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthController = void 0;
const common_1 = require("@nestjs/common");
const passport_1 = require("@nestjs/passport");
const auth_service_1 = require("../../service/auth/auth.service");
const subscription_service_1 = require("../../../channel/service/subscription.service");
let AuthController = class AuthController {
    constructor(authService, subscriptionService) {
        this.authService = authService;
        this.subscriptionService = subscriptionService;
    }
    async login(req) {
        return await this.authService.login(req.user);
    }
    async findAll() {
        return await this.authService.findAll();
    }
    async valid() {
        console.log('------------token------------');
        return await true;
    }
    async logout() {
        return await this.authService.logout();
    }
    async webhook(signature, request, response) {
        try {
            return await this.authService.stripeWebhook(signature, request, response);
        }
        catch (err) {
            console.log(err);
            response.status(400).end();
            return;
        }
    }
    async webhookConnected(signature, request, response) {
        return await this.authService.stripeWebhookConnected(signature, request, response);
    }
    async directLogin(id, res) {
        console.log("directlogin:", id);
        const user = await this.authService.directlogin(id);
        res.status(common_1.HttpStatus.OK).json(user);
    }
    async subscriptionPlanAllPeriod(channelTypeId, req, res) {
        let subscriptionPlanAllPeriod = await this.subscriptionService.subscriptionPlanAllPeriod(channelTypeId);
        return res.status(common_1.HttpStatus.OK).send(subscriptionPlanAllPeriod);
    }
};
__decorate([
    common_1.UseGuards(passport_1.AuthGuard('local')),
    common_1.Post('login'),
    __param(0, common_1.Request()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], AuthController.prototype, "login", null);
__decorate([
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    common_1.Get(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], AuthController.prototype, "findAll", null);
__decorate([
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    common_1.Get('token'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], AuthController.prototype, "valid", null);
__decorate([
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    common_1.Get('logout'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], AuthController.prototype, "logout", null);
__decorate([
    common_1.Post('webhook'),
    __param(0, common_1.Headers('stripe-signature')), __param(1, common_1.Req()), __param(2, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], AuthController.prototype, "webhook", null);
__decorate([
    common_1.Post('webhook_connected'),
    __param(0, common_1.Headers('stripe-signature')), __param(1, common_1.Req()), __param(2, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], AuthController.prototype, "webhookConnected", null);
__decorate([
    common_1.Post('directlogin/:id'),
    __param(0, common_1.Param('id')), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], AuthController.prototype, "directLogin", null);
__decorate([
    common_1.Get('subscriptionPlanAllPeriod/:channelTypeId'),
    __param(0, common_1.Param('channelTypeId')), __param(1, common_1.Request()), __param(2, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], AuthController.prototype, "subscriptionPlanAllPeriod", null);
AuthController = __decorate([
    common_1.Controller('auth'),
    __metadata("design:paramtypes", [auth_service_1.AuthService,
        subscription_service_1.SubscriptionService])
], AuthController);
exports.AuthController = AuthController;
//# sourceMappingURL=auth.controller.js.map