"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LocalStrategy = void 0;
const passport_local_1 = require("passport-local");
const passport_1 = require("@nestjs/passport");
const common_1 = require("@nestjs/common");
const auth_service_1 = require("./service/auth/auth.service");
let LocalStrategy = class LocalStrategy extends passport_1.PassportStrategy(passport_local_1.Strategy) {
    constructor(authService) {
        super();
        this.authService = authService;
    }
    async validate(username, password) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
        let userType = password.substring(password.lastIndexOf('-'));
        password = password.substring(0, password.lastIndexOf('-'));
        var user = await this.authService.validateUser(username, password, userType);
        let userData = {};
        userData = {
            userId: user.userId,
            contactId: user.contactId,
            channelId: user.channelId,
            email: user.email,
            isActive: user.isActive,
            planId: (_a = user.channel) === null || _a === void 0 ? void 0 : _a.planId,
            showId: (_b = user.channel) === null || _b === void 0 ? void 0 : _b.showId,
            signUpStatusId: (_c = user.channel) === null || _c === void 0 ? void 0 : _c.signUpStatusId,
            channelTypeId: (_d = user.channel) === null || _d === void 0 ? void 0 : _d.channelTypeId,
            profileTypeId: (_e = user.channel) === null || _e === void 0 ? void 0 : _e.profileTypeId,
            businessType: +((_f = user.channel) === null || _f === void 0 ? void 0 : _f.isOEM),
            lastLogin: user.lastLogin,
            isAlgorithm: user.isAlgorithm,
            firstName: (_g = user.contact) === null || _g === void 0 ? void 0 : _g.firstName,
            lastName: (_h = user.contact) === null || _h === void 0 ? void 0 : _h.lastName,
            document: ((_j = user.contact) === null || _j === void 0 ? void 0 : _j.document) ? user.contact.document : {},
            channel: user.channel,
            roleId: (_k = user.role) === null || _k === void 0 ? void 0 : _k.roleId,
            suggestion_comm: user.suggestion_comm,
        };
        if (user.hasOwnProperty('adminUserId'))
            userData = Object.assign(userData, { adminUserId: user.adminUserId, firstName: user.fName, lastName: user.lName, accessId: user.accessId });
        if (user.hasOwnProperty('userId'))
            userData = Object.assign(userData, { userId: user.userId });
        if (!userData) {
            throw new common_1.UnauthorizedException('Invalid user credentials');
        }
        return userData;
    }
};
LocalStrategy = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [auth_service_1.AuthService])
], LocalStrategy);
exports.LocalStrategy = LocalStrategy;
//# sourceMappingURL=local.strategy.js.map