import { Application } from '../../models/Application.entity';
import { JwtService } from '@nestjs/jwt';
import { UserService } from '../../../user/service/user.service';
import { ContextService } from '../../../../context/context.service';
import { AutoRenewalTracking } from '../../../channel/models/AutoRenewalTracking.entity';
import { SubscriptionService } from '../../../channel/service/subscription.service';
export declare class AuthService {
    private readonly applicationRepository;
    private readonly autoRenewalTrackingRepository;
    private readonly userService;
    private readonly jwtService;
    private readonly contextService;
    private readonly subscriptionService;
    private isAdmin;
    constructor(applicationRepository: typeof Application, autoRenewalTrackingRepository: typeof AutoRenewalTracking, userService: UserService, jwtService: JwtService, contextService: ContextService, subscriptionService: SubscriptionService);
    validateUser(username: string, pass: string, userType: string): Promise<any>;
    directlogin(id: any): Promise<{
        token: string;
        user: any;
    }>;
    private comparePassword;
    login(user: any): Promise<{
        user: any;
        token: string;
    }>;
    findAll(): Promise<Application[]>;
    private generateToken;
    logout(): Promise<void>;
    stripeWebhook(signature: any, request: any, response: any): Promise<void>;
    stripeWebhookConnected(signature: any, request: any, response: any): Promise<void>;
}
