"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthService = void 0;
const common_1 = require("@nestjs/common");
const jwt_1 = require("@nestjs/jwt");
const user_service_1 = require("../../../user/service/user.service");
const crypto = require("crypto");
const context_service_1 = require("../../../../context/context.service");
const User_entity_1 = require("../../../user/models/User.entity");
const Stripe_1 = require("../../../../lib/Stripe");
const PaymentTransaction_entity_1 = require("../../../channel/models/PaymentTransaction.entity");
const ChannelSubscription_entity_1 = require("../../../channel/models/ChannelSubscription.entity");
const sequelize_typescript_1 = require("sequelize-typescript");
const app_constant_1 = require("../../../../config/app.constant");
const subscription_service_1 = require("../../../channel/service/subscription.service");
const Channel_entity_1 = require("../../../channel/models/Channel.entity");
let AuthService = class AuthService {
    constructor(applicationRepository, autoRenewalTrackingRepository, userService, jwtService, contextService, subscriptionService) {
        this.applicationRepository = applicationRepository;
        this.autoRenewalTrackingRepository = autoRenewalTrackingRepository;
        this.userService = userService;
        this.jwtService = jwtService;
        this.contextService = contextService;
        this.subscriptionService = subscriptionService;
        this.isAdmin = false;
    }
    async validateUser(username, pass, userType) {
        let user;
        if (userType === "-user") {
            user = await this.userService.findUser(username);
            if (!user)
                return null;
        }
        else if (userType === "-admin") {
            user = await this.userService.findAdmin(username);
            this.isAdmin = true;
            if (!user)
                return null;
        }
        else
            return null;
        const match = await this.comparePassword(pass, user.password);
        if (!match) {
            return null;
        }
        const _a = user['dataValues'], { password } = _a, result = __rest(_a, ["password"]);
        return result;
    }
    async directlogin(id) {
        let user = await this.userService.boUser(id);
        const token = await this.generateToken(user);
        let result = {
            token: token,
            user: user
        };
        return result;
    }
    async comparePassword(enteredPassword, dbPassword) {
        let hash = crypto.createHmac('sha512', process.env.USER_PASSWORD_SALT_ROUNT);
        hash.update(enteredPassword.trim());
        console.log("lp:", enteredPassword);
        console.log("dtap:", dbPassword);
        let passwordHash = hash.digest('hex');
        if (dbPassword.trim() != passwordHash) {
            console.log("ep:", passwordHash);
            console.log("dp:", dbPassword);
            return false;
        }
        return true;
    }
    async login(user) {
        const token = await this.generateToken(user);
        console.log('setting', user);
        this.isAdmin = false;
        return { user, token };
    }
    async findAll() {
        return await this.applicationRepository.findAll({
            attributes: ['id', 'secretKey'],
        });
    }
    async generateToken(user) {
        const token = await this.jwtService.signAsync(user);
        return token;
    }
    async logout() {
        return this.contextService.set('user', {});
    }
    async stripeWebhook(signature, request, response) {
        let event = null;
        const stripe = new Stripe_1.StripeV2();
        let intent = null;
        switch (request.body.type) {
            case 'payment_intent.succeeded':
                intent = request.body.data.object;
                console.log("Succeeded:", intent.id);
                PaymentTransaction_entity_1.PaymentTransaction.findOne({
                    where: {
                        paymentIntent: intent.id,
                        status: '0'
                    }
                }).then((transaction) => {
                    console.log("transaction.entity ============>", transaction.entity);
                    console.log(" transaction.entityId ============>", transaction.entityId);
                    console.log(" transaction.couponCode ============>", transaction.couponCode);
                    try {
                        if (transaction) {
                            transaction.status = "1";
                            transaction.transactionNumber = intent.charges.data[0].id;
                            transaction.cardLastFourDigit = intent.charges.data[0].payment_method_details.card.last4;
                            transaction.cardType = intent.charges.data[0].payment_method_details.card.brand;
                            transaction.save().then(async () => {
                                let user = await User_entity_1.User.findOne({ where: { userId: +transaction.updatedBy } });
                                let channel = await Channel_entity_1.Channel.findOne({ where: { channelId: user.channelId } });
                                let stripePaymentMethodId = intent.charges.data[0].payment_method;
                                if (transaction.entity == 'subscription') {
                                    ChannelSubscription_entity_1.ChannelSubscription.findOne({
                                        where: {
                                            paymentTransactionId: transaction.paymentTransactionId
                                        }
                                    }).then(async (channelsubscription) => {
                                        channelsubscription.isActive = "1";
                                        channelsubscription.isPaid = "1";
                                        channelsubscription.save();
                                        let oldSubscriptionId = this.subscriptionService.updateOldTransac(channelsubscription.oldChannelSubscriptionId);
                                    });
                                }
                                else if (transaction.entity == 'subscription_autorenewal') {
                                    let autoRenewal = await this.autoRenewalTrackingRepository.findByPk(transaction.couponCode);
                                    console.log("channel subscription created");
                                    autoRenewal.update({
                                        statusid: app_constant_1.appconstant.AUTO_RENEWAL_TRACKING_STATUS.COMPLETED,
                                        updatedat: sequelize_typescript_1.Sequelize.fn('NOW'),
                                        paymenttransactionid: transaction.paymentTransactionId
                                    });
                                }
                            });
                        }
                    }
                    catch (e) {
                        console.log(e);
                    }
                });
                break;
            case 'payment_intent.payment_failed':
                intent = event.data.object;
                const message = intent.last_payment_error && intent.last_payment_error.message;
                console.log('Failed:', intent.id, message);
                PaymentTransaction_entity_1.PaymentTransaction.findOne({
                    where: {
                        paymentIntent: intent.id,
                        status: '0',
                        message: message
                    }
                }).then((transaction) => {
                    if (transaction) {
                        console.log("============>", transaction.entity);
                        console.log("============>", transaction.entityId);
                        console.log("============>", transaction.couponCode);
                        transaction.invoiceno = null;
                        transaction.cardLastFourDigit = intent.last_payment_error.payment_method.card.last4;
                        transaction.cardType = intent.last_payment_error.payment_method.card.brand;
                        transaction.message = message;
                        transaction.save().then(async () => {
                            if (transaction.entity == 'subscription_autorenewal') {
                                let autoRenewal = await this.autoRenewalTrackingRepository.findByPk(transaction.couponCode);
                                autoRenewal.update({ statusid: app_constant_1.appconstant.AUTO_RENEWAL_TRACKING_STATUS.FAILED });
                            }
                        });
                    }
                });
                break;
        }
        console.log('============= webhook done =====================');
        response.sendStatus(200);
    }
    async stripeWebhookConnected(signature, request, response) {
        let event = null;
        const stripe = new Stripe_1.StripeV2();
        try {
            event = await stripe.processWebHook(signature, request.rawBody, true);
        }
        catch (err) {
            response.status(400).end();
            return;
        }
        let intent = null;
        switch (event['type']) {
            case 'payment_intent.succeeded':
                intent = event.data.object;
                console.log("Succeeded:", intent.id);
                PaymentTransaction_entity_1.PaymentTransaction.findOne({
                    where: {
                        paymentIntent: intent.id,
                        status: '0'
                    }
                }).then((transaction) => {
                    if (transaction) {
                        console.log("============>", transaction.entity);
                        console.log("============>", transaction.entityId);
                        console.log("============>", transaction.couponCode);
                        transaction.status = "1";
                        transaction.transactionNumber = intent.charges.data[0].id;
                        transaction.cardLastFourDigit = intent.charges.data[0].payment_method_details.card.last4;
                        transaction.cardType = intent.charges.data[0].payment_method_details.card.brand;
                        transaction.save().then(async () => {
                            let user = await User_entity_1.User.findOne({ where: { userId: +transaction.updatedBy } });
                        });
                    }
                });
                break;
            case 'payment_intent.payment_failed':
                intent = event.data.object;
                const message = intent.last_payment_error && intent.last_payment_error.message;
                console.log('Failed:', intent.id, message);
                PaymentTransaction_entity_1.PaymentTransaction.findOne({
                    where: {
                        paymentIntent: intent.id,
                        status: '0'
                    }
                }).then((transaction) => {
                    if (transaction) {
                        console.log("============>", transaction.entity);
                        console.log("============>", transaction.entityId);
                        console.log("============>", transaction.couponCode);
                        transaction.invoiceno = null;
                        transaction.cardLastFourDigit = intent.last_payment_error.payment_method.card.last4;
                        transaction.cardType = intent.last_payment_error.payment_method.card.brand;
                        transaction.message = message;
                        transaction.save();
                    }
                });
                break;
        }
        response.sendStatus(200);
    }
};
AuthService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject('ApplicationRepository')),
    __param(1, common_1.Inject('AutoRenewalTrackingRepository')),
    __metadata("design:paramtypes", [Object, Object, user_service_1.UserService,
        jwt_1.JwtService,
        context_service_1.ContextService,
        subscription_service_1.SubscriptionService])
], AuthService);
exports.AuthService = AuthService;
//# sourceMappingURL=auth.service.js.map