"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChannelModule = void 0;
const common_1 = require("@nestjs/common");
const common_provider_1 = require("../common/provider/common.provider");
const user_provider_1 = require("../user/provider/user.provider");
const channel_admin_controller_1 = require("./controller/channel.admin.controller");
const address_provider_1 = require("./provider/address.provider");
const settting_provider_1 = require("./provider/settting.provider");
const channel_provider_1 = require("./provider/channel.provider");
const channel_admin_service_1 = require("./service/channel.admin.service");
const channel_setting_service_1 = require("./service/channel.setting.service");
const channel_settings_controller_1 = require("./controller/channel.settings.controller");
const context_service_1 = require("../../context/context.service");
const context_module_1 = require("../../context/context.module");
const media_module_1 = require("../media/media.module");
const database_providers_1 = require("../../core/database/database.providers");
const product_module_1 = require("../product/product.module");
const subscription_controller_1 = require("./controller/subscription.controller");
const subscription_service_1 = require("./service/subscription.service");
const subscription_provider_1 = require("./provider/subscription.provider");
const channel_controller_1 = require("./controller/channel.controller");
const channel_service_1 = require("./service/channel.service");
const paymentTransaction_provider_1 = require("./provider/paymentTransaction.provider");
const channelHub_provider_1 = require("./provider/channelHub.provider");
const SignUpStatus_providers_1 = require("../user/provider/SignUpStatus.providers");
const product_providers_1 = require("../product/provider/product.providers");
const channelKeyPartner_service_1 = require("./service/channelKeyPartner.service");
const channelHub_service_1 = require("./service/channelHub.service");
const user_module_1 = require("../user/user.module");
const mailer_provider_1 = require("../../mailer/mailer.provider");
const serviceList_provider_1 = require("./provider/serviceList.provider");
const tradeLocation_service_1 = require("./service/tradeLocation.service");
const tradeLocation_controller_1 = require("./controller/tradeLocation.controller");
const location_provider_1 = require("../common/provider/location.provider");
const channelKeyPartner_controller_1 = require("./controller/channelKeyPartner.controller");
const channelRelation_controller_1 = require("./controller/channelRelation.controller");
const algorithm_module_1 = require("../../algorithm/algorithm.module");
const algorithm_provider_1 = require("./provider/algorithm.provider");
const guest_controller_1 = require("./controller/guest.controller");
const walletRecharge_providers_1 = require("../walletRecharge/provider/walletRecharge.providers");
const public_channel_controller_1 = require("./controller/public.channel.controller");
const public_channel_service_1 = require("./service/public.channel.service");
const event_provider_1 = require("./provider/event.provider");
let ChannelModule = class ChannelModule {
};
ChannelModule = __decorate([
    common_1.Module({
        controllers: [channel_controller_1.ChannelController, channel_admin_controller_1.ChannelAdminController, channel_settings_controller_1.ChannelSettingController, subscription_controller_1.SubscriptionController, tradeLocation_controller_1.TradeLocationController, channelKeyPartner_controller_1.ChannelKeyPartnerController, channelRelation_controller_1.ChannelRelationController, guest_controller_1.GuestController, public_channel_controller_1.PublicChannelController],
        imports: [context_module_1.ContextModule, media_module_1.MediaModule, product_module_1.ProductModule, user_module_1.UserModule, algorithm_module_1.AlgorithmModule],
        providers: [context_service_1.ContextService,
            channelKeyPartner_service_1.ChannelKeyPartnerService,
            public_channel_service_1.PublicChannelService,
            ...address_provider_1.addressProvider,
            ...address_provider_1.oldAddressProvider,
            ...paymentTransaction_provider_1.CurrencyProviders,
            ...channel_provider_1.channelDetailProvider,
            ...channel_provider_1.channelProductGroupProvider,
            ...channel_provider_1.channelProvider,
            ...common_provider_1.CountryProviders,
            ...common_provider_1.CommonProviders,
            ...user_provider_1.UserProviders,
            ...settting_provider_1.settingProvider,
            ...channel_provider_1.CompanyMediaProvider,
            ...channel_provider_1.CompanyMediaImagesProvider,
            ...database_providers_1.databaseProviders,
            ...channel_provider_1.ChannelDocumentProvider,
            ...subscription_provider_1.SubscriptionProviders,
            ...subscription_provider_1.SubscriptionPeriodProviders,
            ...subscription_provider_1.SubscriptionPlanProviders,
            ...subscription_provider_1.SubscriptionExtraFeatureProviders,
            ...subscription_provider_1.SubscriptionExtraFeatureCategoryProviders,
            ...subscription_provider_1.AutoRenewalTrackingProviders,
            ...subscription_provider_1.SubscriptionDetailProviders,
            ...paymentTransaction_provider_1.PaymentTransactionProviders,
            ...channel_provider_1.ChannelSubscriptionProviders,
            ...channelHub_provider_1.ConnectionStatusTypeProvider,
            ...channelHub_provider_1.ChannelJCTProvider,
            ...channelHub_provider_1.ContactJCTProvider,
            ...channelHub_provider_1.DismissReasonProvider,
            ...channelHub_provider_1.ChannelDismissReasonProvider,
            ...SignUpStatus_providers_1.SignUpStatusProviders,
            ...channelHub_provider_1.ChannelJCTProvider,
            ...channel_provider_1.ChannelTypeProviders,
            ...channel_provider_1.channelCertificateTypeProvider,
            ...product_providers_1.productProvider,
            ...subscription_provider_1.CouponProviders,
            ...channel_provider_1.channelSocialLinkProvider,
            ...channel_provider_1.channelAwardProvider,
            ...channel_provider_1.channelProductCategorieProvider,
            ...channel_provider_1.channelServiceListProvider,
            ...channel_provider_1.channelSpecialityProvider,
            ...channel_provider_1.channelB2BProvider,
            ...serviceList_provider_1.serviceListProvider,
            ...channel_provider_1.ChannelPaymentOptionTypeProvider,
            ...channel_provider_1.ChannelPaymentTermProvider,
            ...channel_provider_1.ChannelSharePreferenceProvider,
            ...channel_provider_1.sharetypeProvider,
            ...location_provider_1.ZoneProvider,
            ...channel_provider_1.profileTypeClassificationProvider,
            ...channel_provider_1.channelSuggestionProvider,
            ...algorithm_provider_1.algorithmProvider,
            ...walletRecharge_providers_1.UserWalletAmountProviders,
            ...channel_provider_1.buyerNeedProvider,
            ...channel_provider_1.buyerReqCategoryProvider,
            ...channelHub_provider_1.EndCustomersB2bTypeProvider,
            ...channelHub_provider_1.EndCustomersB2bProvider,
            ...channel_provider_1.GuestRequirementProvider,
            ...event_provider_1.eventProvider,
            mailer_provider_1.MailerProvider,
            channel_admin_service_1.ChannelAdminService, channel_setting_service_1.ChannelSettingService, subscription_service_1.SubscriptionService, channel_service_1.ChannelService, channelHub_service_1.ChannelHubService, tradeLocation_service_1.TradeLocationService,
        ],
        exports: [channelHub_service_1.ChannelHubService,
            channel_service_1.ChannelService,
            subscription_service_1.SubscriptionService,
            channelKeyPartner_service_1.ChannelKeyPartnerService,
            ...address_provider_1.addressProvider,
            ...address_provider_1.oldAddressProvider,
            ...channel_provider_1.channelDetailProvider,
            ...channel_provider_1.channelProductCatProvider,
            ...channel_provider_1.channelProductGroupProvider,
            ...paymentTransaction_provider_1.PaymentTransactionProviders,
            ...channel_provider_1.ChannelSubscriptionProviders,
            ...channelHub_provider_1.ConnectionStatusTypeProvider,
            ...subscription_provider_1.AutoRenewalTrackingProviders,
            ...channelHub_provider_1.ChannelJCTProvider,
            ...channelHub_provider_1.ContactJCTProvider,
            ...channelHub_provider_1.DismissReasonProvider,
            ...channelHub_provider_1.ChannelDismissReasonProvider,
            ...subscription_provider_1.CouponProviders,
            ...channel_provider_1.sharetypeProvider,
            ...channel_provider_1.channelSuggestionProvider,
            ...algorithm_provider_1.algorithmProvider,
            ...walletRecharge_providers_1.UserWalletAmountProviders,
            ...channel_provider_1.GuestRequirementProvider,
            ...event_provider_1.eventProvider,
            mailer_provider_1.MailerProvider
        ]
    })
], ChannelModule);
exports.ChannelModule = ChannelModule;
//# sourceMappingURL=channel.module.js.map