import { ContextService } from 'src/context/context.service';
import { ChannelAdminService } from '../service/channel.admin.service';
import { ChannelSettingService } from '../service/channel.setting.service';
import { UserService } from '../../user/service/user.service';
import { AdminCouponAddDto } from '../dto/adminCoupon.dto';
import { SubscriptionService } from '../service/subscription.service';
import { SubscriptionFilterBODto } from '../dto/subscriptionFilter.dto';
import { TradeLocationService } from '../service/tradeLocation.service';
import { UpdateUserDto } from 'src/modules/user/dto/updateUser.dto';
import { BoUpdateSubscriptionDto } from '../dto/updateSubscription.dto';
import { ChannelService } from '../service/channel.service';
import { ProductService } from 'src/modules/product/service/product.service';
export declare class ChannelAdminController {
    private channelAdminService;
    private channelSettingService;
    private channelService;
    private readonly subscriptionService;
    private userService;
    private tradeLocationService;
    private productService;
    private readonly sequelizeInstance;
    private context;
    private channelDetailOutBound;
    constructor(channelAdminService: ChannelAdminService, channelSettingService: ChannelSettingService, channelService: ChannelService, subscriptionService: SubscriptionService, userService: UserService, tradeLocationService: TradeLocationService, productService: ProductService, sequelizeInstance: any, context: ContextService);
    pendingApproval(data: any, req: any, res: any): Promise<any>;
    channelSubscriptionList(req: any, res: any, SubscriptionFilterDto: SubscriptionFilterBODto): Promise<void>;
    pendingChannelsList(userId: any, req: any, res: any): Promise<any>;
    oldChannelsList(userId: any, req: any, res: any): Promise<any>;
    oldChannels(data: any, req: any, res: any): Promise<any>;
    channelApproval(data: any, req: any, res: any): Promise<any>;
    getFilterCountry(data: any, req: any, res: any): Promise<any>;
    getProductCat(data: any, res: any): Promise<any>;
    getSubscriptionPlan(res: any): Promise<any>;
    introVideoUpload(OldIntro: any, res: any): Promise<void>;
    medialibraryByContact(req: any, res: any): Promise<void>;
    deleteMediaVideo(res: any, data: any): Promise<void>;
    deleteCompanyLogo(res: any, data: any): Promise<void>;
    getInitialProfile(req: any, res: any, data: any): Promise<void>;
    tradeinfo(req: any, res: any, data: any): Promise<void>;
    tradelocation(req: any, res: any, data: any): Promise<void>;
    getUsers(req: any, res: any, data: any): Promise<void>;
    getDefaultContact(res: any, req: any, data: any): Promise<any>;
    getAllContacts(res: any, req: any, data: any): Promise<any>;
    settings(res: any, req: any, data: any): Promise<any>;
    getProfileAndSpeciality(req: any, res: any, data: any): Promise<void>;
    setDefaultContact(contactId: any, res: any, req: any, data: any): Promise<any>;
    update_Company_Profile(profileData: any, req: any, res: any): Promise<any>;
    update_company_profile(req: any, res: any, data: any): Promise<any>;
    update_Trade_Info(profileData: any, req: any, res: any): Promise<any>;
    updateChannelLocation1(channelLocationDto: any, req: any, res: any): Promise<any>;
    updateSettings(req: any, res: any, settingsDto: any): Promise<any>;
    update_channel_profile(req: any, res: any, data: any): Promise<any>;
    addNewUser(res: any, req: any, addUserDto: any): Promise<void>;
    getUserProfile(req: any, res: any, data: any): Promise<void>;
    getContactLocation(contactId: any, channelTypeId: any, req: any, res: any): Promise<void>;
    getCouponList(req: any, res: any, couponFilterDto: any): Promise<void>;
    getCouponByID(id: any, req: any, res: any): Promise<any>;
    AddChannelCoupon(req: any, res: any, adminCouponAddDto: AdminCouponAddDto): Promise<any>;
    UpdateChannelCoupon(id: any, req: any, res: any, adminCouponAddDto: AdminCouponAddDto): Promise<any>;
    existingKeyRetailerCheck(req: any, res: any, KeyRetailer: any): Promise<void>;
    searchRegion(searchRegionDto: any, req: any, res: any): Promise<any>;
    getBuyerNeed(req: any, res: any, reqneed: any): Promise<void>;
    getAllRequestIntro(channelid: any, req: any, res: any): Promise<void>;
    approveChannel(req: any, res: any, updateChannelDto: any): Promise<any>;
    getPublicCompanyFlages(req: any, res: any, channelId: any): Promise<any>;
    setCompanyPublicFlags(Req: any, res: any, data: any): Promise<any>;
    getChannelDetail(req: any, res: any, data: any): Promise<void>;
    company(req: any, res: any, data: any): Promise<void>;
    getChannelCertificateTags(req: any, res: any, data: any): Promise<void>;
    getChannelProduct(req: any, res: any, data: any): Promise<void>;
    getChannelBrand(req: any, res: any, data: any): Promise<void>;
    getKeyPartnerOptions(req: any, res: any, data: any): Promise<any>;
    getChannelProfile(req: any, res: any, data: any): Promise<any>;
    getChannelLocation(channelId: any, req: any, res: any): Promise<any>;
    getContactLocationBo(contactId: any, req: any, res: any, data: any): Promise<void>;
    getContactProduct(contactId: any, channelId: any, req: any, res: any): Promise<void>;
    reporting(profileData: any, req: any, res: any, data: any): Promise<any>;
    generalInfo(contactId: any, req: any, res: any): Promise<any>;
    getUserPreference(contactId: any, channelId: any, res: any, req: any): Promise<any>;
    getPreference(res: any, req: any, typeId: any): Promise<any>;
    userProfileUpdate(id: any, userDto: UpdateUserDto, res: any, req: any, channelId: any, userId: any): Promise<void>;
    boEventCreate(req: any, res: any, data: any): Promise<void>;
    getEventListing(Req: any, res: any, data: any): Promise<void>;
    getEventById(req: any, res: any, eventId: any): Promise<void>;
    getEventDetailsById(req: any, res: any, eventId: any): Promise<void>;
    eventAvailabilityCheck(req: any, res: any, eventCatId: any, eventId: any): Promise<void>;
    getEventChannelDetails(req: any, res: any, eventId: any, channelId: any): Promise<void>;
    boEventUsersManage(req: any, res: any, data: any): Promise<void>;
    boToEventCatalyst(req: any, res: any, data: any): Promise<void>;
    setEventContact(id: any, res: any): Promise<any>;
    setEventParticipantStatus(req: any, res: any, data: any): Promise<any>;
    offlinePayment(id: any, updateSubscriptionDto: BoUpdateSubscriptionDto, res: any): Promise<any>;
    companyNameList(req: any, res: any, data: any): Promise<void>;
    getContactSearchList(req: any, res: any, data: any): Promise<void>;
    getContact(data: any, contactId: any, res: any): Promise<any>;
    updateContact(data: any, res: any, req: any, contactId: any): Promise<void>;
    channelDetail(channelId: any, req: any, res: any): Promise<void>;
    myProduct(req: any, res: any, productFilters: any): Promise<void>;
    myProductsAgg(req: any, res: any, isActive: number, data: any): Promise<void>;
    oldChannelDetail(channelId: any, req: any, res: any): Promise<void>;
    oldChannelDetailView(channelId: any, req: any, res: any): Promise<void>;
    testPar(channelId: any, req: any, res: any): Promise<void>;
    test(req: any, res: any): Promise<void>;
    testPost(data: any, req: any, res: any): Promise<void>;
    getPendingEventPayment(req: any, res: any): Promise<any>;
    updateEventPayment(req: any, res: any): Promise<any>;
    getChannelCountry(req: any, res: any, channelId: any): Promise<any>;
    checkVat(req: any, res: any, data: any): Promise<void>;
    getOldFacts(req: any, res: any, oldChannelId: any): Promise<any>;
    getOldProducts(req: any, res: any, oldChannelId: any): Promise<any>;
    getOldChannelBrand(req: any, res: any, oldChannelId: any): Promise<any>;
    getOldInitialProfile(req: any, res: any, data: any): Promise<any>;
    channelProfileOld(Req: any, res: any, data: any): Promise<any>;
    editBasicOldCompanyProfile(profileData: any, req: any, res: any): Promise<any>;
    saveOldChannelFacts(req: any, res: any, data: any): Promise<any>;
    updateBannerImage(bannerImg: any, req: any, res: any): Promise<any>;
}
