import { ChannelService } from '../service/channel.service';
import { BaseController } from 'src/core';
import { ContextService } from 'src/context/context.service';
import { ChannelHubService } from '../service/channelHub.service';
import { UpdateChannelDto } from '../dto/updateChannel.dto';
export declare class ChannelController extends BaseController {
    private channelService;
    private channelHubService;
    private readonly sequelizeInstance;
    private context;
    private channelHubDetailOutBound;
    constructor(channelService: ChannelService, channelHubService: ChannelHubService, sequelizeInstance: any, context: ContextService);
    getSearchList(req: any, res: any, viewId: number, planId: number, data: any): Promise<any>;
    getNonMember(req: any, res: any, viewId: number, planId: number, data: any): Promise<any>;
    getTopCompany(req: any, res: any, keyword: any): Promise<any>;
    getTopProduct(req: any, res: any, keyword: any): Promise<any>;
    getSearchAggregation(req: any, res: any, viewId: number): Promise<any>;
    chFilter(req: any, res: any, viewId: number, channelType: number, data: any): Promise<any>;
    channeltype(req: any, res: any): Promise<any>;
    brandFilter(req: any, res: any, data: any): Promise<any>;
    locationFilter(req: any, res: any, data: any): Promise<any>;
    countryFilter(req: any, res: any, data: any): Promise<any>;
    specialFilter(req: any, res: any, data: any): Promise<any>;
    productFilter(req: any, res: any, data: any): Promise<any>;
    interestedProductFilter(req: any, res: any, data: any): Promise<any>;
    retailFilter(req: any, res: any, data: any): Promise<any>;
    targetFilter(req: any, res: any, data: any): Promise<any>;
    conFilter(req: any, res: any): Promise<any>;
    conSpecialFilter(req: any, res: any, data: any): Promise<any>;
    conCountryFilter(req: any, res: any, data: any): Promise<any>;
    conNameList(req: any, res: any): Promise<any>;
    getTapCount(req: any, res: any, contactId: number): Promise<void>;
    getDashboard(req: any, res: any): Promise<void>;
    getFoCompanyList(req: any, res: any, viewId: number, planId: number): Promise<void>;
    getChannelDetailView(channelId: any, req: any, res: any): Promise<void>;
    getContacts(channelId: any, res: any, contactFilter: any, req: any): Promise<void>;
    updateChannel(channelId: any, req: any, res: any, updateChannelDto: UpdateChannelDto): Promise<any>;
    dimissReasons(req: any, res: any): Promise<any>;
    channelBrands(channelId: any, res: any, req: any): Promise<void>;
    getSugOutboundcount(contactId: any, req: any, res: any): Promise<void>;
    getChannelFavorite(req: any, groupid: number, res: any, channelFilter: any): Promise<void>;
    getChannelFavoriteList(req: any, groupid: number, res: any, channelFilter: any, isVariableWidth: any, planId: any): Promise<void>;
    shareTypeList(req: any, res: any): Promise<any>;
    getAllContacts(res: any, req: any, data: any): Promise<any>;
    buyerNeed(req: any, res: any, reqneed: any): Promise<void>;
    profileView(req: any, res: any, data: any, viewId: any): Promise<void>;
    getBillingAddress(res: any, req: any): Promise<void>;
    eventRegister(contactId: any, req: any, res: any): Promise<any>;
    setEventContact(id: any, res: any): Promise<any>;
    getEventListing(req: any, res: any): Promise<any>;
    getEventPackages(eventId: any, req: any, res: any): Promise<any>;
    getEventChannelDetails(req: any, res: any, eventId: any): Promise<void>;
    postEventRegistration(req: any, res: any, data: any): Promise<void>;
    foToEventCatalyst(req: any, res: any, data: any): Promise<void>;
    setEventParticipantStatus(req: any, res: any, data: any): Promise<any>;
    getSelectedEventDetails(req: any, res: any, eventId: any): Promise<any>;
    eventpaymentTransaction(req: any, res: any): Promise<any>;
    getChannelCountry(req: any, res: any): Promise<any>;
    getContactProfile(contactId: any, req: any, res: any): Promise<void>;
}
