'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChannelKeyPartnerController = void 0;
const common_1 = require("@nestjs/common");
const passport_1 = require("@nestjs/passport");
const core_1 = require("../../../core");
const tradeInformationInBound_1 = require("../transformation/tradeInformationInBound");
const channelKeyPartner_service_1 = require("../service/channelKeyPartner.service");
const config_1 = require("../../../config");
const Auth_exception_1 = require("../../../middleware/exception/Auth.exception");
const ChannelDetail_entity_1 = require("../models/ChannelDetail.entity");
let ChannelKeyPartnerController = class ChannelKeyPartnerController extends core_1.BaseController {
    constructor(channelKeyPartnerService) {
        super();
        this.channelKeyPartnerService = channelKeyPartnerService;
        this.tradeInformationInBound = new tradeInformationInBound_1.TradeInformationInBound();
    }
    async distributorChannelSearch(type, req, res) {
        let user = req.user;
        console.log('type', type);
        if (user.channel.channelTypeId == config_1.appconstant.CHANNEL_TYPE_RETAILER) {
            throw new Auth_exception_1.AuthException('Not allowed ');
        }
        if (![config_1.appconstant.CHANNEL_TYPE_RETAILER, config_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR, config_1.appconstant.CHANNEL_TYPE_RESELLER].includes(+type)) {
            throw new Auth_exception_1.AuthException('Not allowed by type ' + type);
        }
        let result = await this.channelKeyPartnerService.searchRetailer({ limit: 50, offset: 1 }, +type);
        res.status(common_1.HttpStatus.OK).json(result);
    }
    async distributorChannelSearchBO(req, res) {
        let user = req.query.channelTypeId;
        if (user.channelTypeId == config_1.appconstant.CHANNEL_TYPE_RETAILER) {
            throw new Auth_exception_1.AuthException('Not allowed');
        }
        if (![config_1.appconstant.CHANNEL_TYPE_RETAILER, config_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR, config_1.appconstant.CHANNEL_TYPE_RESELLER].includes(+req.query.partner_type)) {
            throw new Auth_exception_1.AuthException('Not allowed');
        }
        let result = await this.channelKeyPartnerService.searchRetailer({ limit: 50, offset: 1 }, +req.query.partner_type);
        res.status(common_1.HttpStatus.OK).json(result);
    }
    async getAllMyKeyRetailer(channelId, req, res) {
        let result = await this.channelKeyPartnerService.getKeyRetailers(channelId, +req.query.partner_type);
        let keyRetailerValues = [];
        if (result === null || result === void 0 ? void 0 : result.length) {
            result.map(x => {
                var _a, _b, _c, _d, _e, _f, _g, _h;
                let logo = x.active ? (_b = (_a = x.active) === null || _a === void 0 ? void 0 : _a.logo) === null || _b === void 0 ? void 0 : _b.documentPath : x.old ? (_c = x.old.logo) === null || _c === void 0 ? void 0 : _c.documentPath : x.new ? (_d = x.new.logo) === null || _d === void 0 ? void 0 : _d.logo_name : '';
                let imageid = x.active ? (_f = (_e = x.active) === null || _e === void 0 ? void 0 : _e.logo) === null || _f === void 0 ? void 0 : _f.logo_id : x.old ? (_g = x.old.logo) === null || _g === void 0 ? void 0 : _g.logo_id : x.new ? (_h = x.new.logo) === null || _h === void 0 ? void 0 : _h.logo_id : '';
                let companyName = x.active ? x.active.company_name : x.old ? x.old.company_name : x.new ? x.new.company_name : '';
                let id = x.active ? x.active.id : x.old ? x.old.id : x.new ? x.new.id : '';
                let brand = {
                    id: id,
                    name: companyName,
                    channelId: x.active ? x.active.id : null,
                    oldchannelid: x.old ? x.old.id : null,
                    newChannelId: x.new ? x.new.id : null,
                    documentpath: process.env.CDN_URL + logo,
                    image: logo,
                    imageid: imageid,
                    countryid: x.active ? x.active.country.country_id : x.old ? x.old.country.country_id : x.new ? x.new.country.country_id : '',
                    isNew: 0
                };
                keyRetailerValues.push(Object.assign(x, brand));
            });
        }
        let keyretailerDescription = await ChannelDetail_entity_1.ChannelDetail.findOne({
            where: {
                channelId: +channelId
            }
        });
        res.status(common_1.HttpStatus.OK).json({
            keyretailerDescription: (keyretailerDescription) ? keyretailerDescription.keyretailers : '',
            channelKeyRetailers: keyRetailerValues
        });
    }
};
__decorate([
    common_1.Get('partnerChannelSearch/:type'),
    __param(0, common_1.Param('type')), __param(1, common_1.Req()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ChannelKeyPartnerController.prototype, "distributorChannelSearch", null);
__decorate([
    common_1.Get('partnerChannelSearchBo'),
    __param(0, common_1.Request()), __param(1, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], ChannelKeyPartnerController.prototype, "distributorChannelSearchBO", null);
__decorate([
    common_1.Get('keyPartners/:channelId'),
    __param(0, common_1.Param('channelId')), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ChannelKeyPartnerController.prototype, "getAllMyKeyRetailer", null);
ChannelKeyPartnerController = __decorate([
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    common_1.Controller(''),
    __metadata("design:paramtypes", [channelKeyPartner_service_1.ChannelKeyPartnerService])
], ChannelKeyPartnerController);
exports.ChannelKeyPartnerController = ChannelKeyPartnerController;
//# sourceMappingURL=channelKeyPartner.controller.js.map