'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChannelRelationController = void 0;
const common_1 = require("@nestjs/common");
const channel_service_1 = require("./../service/channel.service");
const productServiceOutBound_1 = require("../../product/transformation/productServiceOutBound");
const context_service_1 = require("../../../context/context.service");
const core_1 = require("../../../core");
const Query_pipe_1 = require("../../../middleware/pipe/Query.pipe");
const passport_1 = require("@nestjs/passport");
let ChannelRelationController = class ChannelRelationController extends core_1.BaseController {
    constructor(channelService, context) {
        super();
        this.channelService = channelService;
        this.context = context;
        this.productServiceOutBound = new productServiceOutBound_1.ProductServiceOutBound();
    }
    async getRelations(req, res, filter) {
        let user = req.user;
        let channelId = user.channelId;
        let productFilter = false;
        let resultOject = "";
        (!filter.productFilter) ? productFilter = false : productFilter = filter.productFilter;
        let result = await this.channelService.findById(channelId, productFilter);
        resultOject = await this.productServiceOutBound.customerProfile(result);
        return res.status(common_1.HttpStatus.OK).json(resultOject);
    }
    async getRelationsBo(channelId, req, res, filter) {
        let productFilter = false;
        let resultOject = "";
        (!filter.productFilter) ? productFilter = false : productFilter = filter.productFilter;
        let result = await this.channelService.findById(+channelId, productFilter);
        resultOject = await this.productServiceOutBound.customerProfile(result);
        return res.status(common_1.HttpStatus.OK).json(resultOject);
    }
};
__decorate([
    common_1.Get('channel-infos'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Query(new Query_pipe_1.QueryPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ChannelRelationController.prototype, "getRelations", null);
__decorate([
    common_1.Get('channel-infos-bo/:channelId'),
    __param(0, common_1.Param('channelId')), __param(1, common_1.Request()), __param(2, common_1.Response()), __param(3, common_1.Query(new Query_pipe_1.QueryPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ChannelRelationController.prototype, "getRelationsBo", null);
ChannelRelationController = __decorate([
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    common_1.Controller(''),
    __metadata("design:paramtypes", [channel_service_1.ChannelService,
        context_service_1.ContextService])
], ChannelRelationController);
exports.ChannelRelationController = ChannelRelationController;
//# sourceMappingURL=channelRelation.controller.js.map