"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GuestController = void 0;
const common_1 = require("@nestjs/common");
const channel_setting_service_1 = require("../service/channel.setting.service");
const product_service_1 = require("../../product/service/product.service");
const sequelize_1 = require("sequelize");
const user_service_1 = require("../../user/service/user.service");
let GuestController = class GuestController {
    constructor(channelSettingService, productService, userService, sequelizeInstance) {
        this.channelSettingService = channelSettingService;
        this.productService = productService;
        this.userService = userService;
        this.sequelizeInstance = sequelizeInstance;
    }
    async BuyersHighlight(viewId, Req, res) {
        let result = await this.channelSettingService.buyerHighlights(viewId);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async buyersaggr(viewId, parent, Req, res, data) {
        let result = await this.channelSettingService.buyersaggr(viewId, parent, data.data);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async productsaggr(parent, Req, res, data) {
        let result = await this.channelSettingService.productsaggr(parent, data.data);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async ProductsHighlight(btype, Req, res) {
        let result = await this.channelSettingService.productsHighlights(btype);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async getSearchList(req, res, viewId, data) {
        let channel = await this.channelSettingService.getBuyerSearchList(viewId, data);
        return res.status(common_1.HttpStatus.OK).send(channel);
    }
    async getCategories(req, res, data) {
        let categorie = await this.channelSettingService.getCategoriesFilter(data);
        return res.status(common_1.HttpStatus.OK).send(categorie);
    }
    async getBrands(req, res, data) {
        let brand = await this.channelSettingService.getBrandFilter(data);
        return res.status(common_1.HttpStatus.OK).send(brand);
    }
    async getCountry(req, res, data) {
        let country = await this.channelSettingService.getCountryFilter(data);
        return res.status(common_1.HttpStatus.OK).send(country);
    }
    async myProduct(req, res, productFilters) {
        console.log('productFilters', productFilters);
        let order = productFilters.order ? productFilters.order : 'asc';
        let limit = ' LIMIT ' + productFilters.limit;
        let offset = ' OFFSET ' + productFilters.offset;
        let orderby = ' order by "' + productFilters.orderby + '" ';
        console.log('productFilters', productFilters);
        let query = 'select count(*) OVER() AS total, tp."productId",tp."businessType",(select "brandName" from "tblBrand" where "id"=tp."brandId"), tp."product",tp."productSKU", tp."isactive", tp."productqualitylevel", pr."businesscurrencyid",pr."retailerprice",(select concat( \'' + process.env.CDN_URL + '\',"documentPath") as "documentUrl" from "tblDocument" where "documentId" in(select "imageid" from "tblproductimage" where "productimageid"=tp."defaultimageid")), (select sum("existproductrating")/count(*) as existproductrating from "tblproductexistrating" where "productId"=tp."productId"), (select "country" from "tblCountry" where "countryId" = (select "countryId" from "tblChannel" where "channelId" = tp."channelId" limit 1) limit 1) as country ' +
            'from "tblProduct" as tp inner join "tblproductpricedetail" as pr on pr."productId"=tp."productId" where tp."deletedat" is null and "isactive"=:isactive';
        if (productFilters.search)
            query += ' and tp."productId"=' + +productFilters.search;
        if (productFilters.filter.brandId)
            query += ' and tp."brandId" in(' + productFilters.filter.brandId + ')';
        if (productFilters.filter.family)
            query += ' and tp."productGroupId" in(' + productFilters.filter.family + ')';
        if (productFilters.filter.productCategoryId)
            query += ' and tp."productCategorieId" in(' + productFilters.filter.productCategoryId + ')';
        if (productFilters.filter.businessType)
            query += ' and tp."businessType" in(' + productFilters.filter.businessType + ')';
        if (productFilters.filter.position)
            query += ' and tp."productqualitylevel" =:quality';
        if (productFilters.filter.hot_topic) {
            if (productFilters.filter.hot_topic.includes(1))
                query += ' and tp."eco_friendly"=\'1\' ';
            if (productFilters.filter.hot_topic.includes(2))
                query += ' and tp."work_from_home"=\'1\' ';
            if (productFilters.filter.hot_topic.includes(3))
                query += ' and tp."life_style"=\'1\' ';
            if (productFilters.filter.hot_topic.includes(4))
                query += ' and tp."french_tech"=\'1\' ';
            if (productFilters.filter.hot_topic.includes(5))
                query += ' and tp."taiwan_excellence"=\'1\' ';
        }
        if (productFilters.featured) {
            query += ' and tp."isFeatured"=\'1\' ';
        }
        if (productFilters.orderby)
            query += orderby + order + limit + offset;
        else
            query += ' order by tp."product" ' + order + limit + offset;
        let results;
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                isactive: '1',
                quality: productFilters.filter.position
            }
        });
        let active = await this.sequelizeInstance.query('select count(*) from "tblProduct" where "deletedat" is null and "isactive"=:isactive', {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                isactive: '1'
            }
        });
        let inActive = await this.sequelizeInstance.query('select count(*) from "tblProduct" where "deletedat" is null and "isactive"=:isactive', {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                isactive: '0'
            }
        });
        let tabCount = {
            active: active ? active[0].count : 0,
            inActive: active ? inActive[0].count : 0
        };
        if (result.length != 0) {
            results = {
                total: result[0].total,
                result: result,
                tabCount: tabCount
            };
        }
        else {
            results = {
                total: 0,
                result: [],
                tabCount: tabCount
            };
        }
        res.status(common_1.HttpStatus.OK).send(results);
    }
    async myProductSlider(req, res, productFilters) {
        let order = productFilters.order ? productFilters.order : 'asc';
        let limit = ' LIMIT ' + productFilters.limit;
        let offset = ' OFFSET ' + productFilters.offset;
        let orderby = ' order by random()';
        let query = 'select count(*) OVER() AS total, tp."productId",(select "brandName" from "tblBrand" where "id"=tp."brandId"), tp."product",tp."productSKU", tp."isactive", tp."productqualitylevel", pr."businesscurrencyid",pr."retailerprice",(select concat( \'' + process.env.CDN_URL + '\',"documentPath") as "documentUrl" from "tblDocument" where "documentId" in(select "imageid" from "tblproductimage" where "productimageid"=tp."defaultimageid")), (select sum("existproductrating")/count(*) as existproductrating from "tblproductexistrating" where "productId"=tp."productId"), (select "country" from "tblCountry" where "countryId" = (select "countryId" from "tblChannel" where "channelId" = tp."channelId" limit 1) limit 1) as country ' +
            'from "tblProduct" as tp inner join "tblproductpricedetail" as pr on pr."productId"=tp."productId" where tp."deletedat" is null and "isactive"=:isactive';
        if (productFilters.search)
            query += ' and tp."productId"=' + +productFilters.search;
        if (productFilters.filter.brandId)
            query += ' and tp."brandId" in(' + productFilters.filter.brandId + ')';
        if (productFilters.filter.family)
            query += ' and tp."productGroupId" in(' + productFilters.filter.family + ')';
        if (productFilters.filter.productCategoryId)
            query += ' and tp."productCategorieId" in(' + productFilters.filter.productCategoryId + ')';
        if (productFilters.filter.position)
            query += ' and tp."productqualitylevel" =:quality';
        if (productFilters.featured) {
            query += ' and tp."isFeatured"=\'1\' ';
        }
        if (productFilters.orderby)
            query += orderby + order + limit + offset;
        else
            query += ' order by tp."product" ' + order + limit + offset;
        let results;
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                isactive: '1',
            }
        });
        if (result.length != 0) {
            results = {
                total: result[0].total,
                result: result,
            };
        }
        else {
            results = {
                total: 0,
                result: [],
            };
        }
        res.status(common_1.HttpStatus.OK).send(results);
    }
    async brandFilter(req, res, data) {
        let result = await this.productService.getBrandFilter(data.data);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async categoryFilter(req, res, data) {
        let result = await this.productService.getCategoryFilter(data.data);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async categoryGuestFilter(req, res, data) {
        let result = await this.productService.getCategoryGuestFilter(data.data);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async familyFilter(req, res, data) {
        let result = await this.channelSettingService.getFamilyFilter(data.data);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async userCountry(req, res) {
        let result = await this.userService.Countries();
        if (result) {
            res.status(common_1.HttpStatus.OK).json(result);
        }
        else {
        }
    }
    async categoryDetails(Req, res, groupId) {
        let result = await this.channelSettingService.getCategoryDetails(groupId);
    }
    async getProducts(req, data, res) {
        let result = await this.channelSettingService.getProducts(+data.businessType);
        if (result) {
            res.status(common_1.HttpStatus.OK).json(result);
        }
        else {
        }
    }
    async getCategorieList(req, data, res) {
        let result = await this.channelSettingService.getCategories(+data.businessType);
        if (result) {
            res.status(common_1.HttpStatus.OK).json(result);
        }
        else {
        }
    }
    async getProductByGroup(res, filter) {
        let query = 'select * from (select pc."productCategorieId", pc."productCategorie", pc."businessType", pc."image", (select count("productCategorieId") as total from "tblProduct" where "productCategorieId"=pc."productCategorieId") as total from "tblProductCategories" as pc where pc."productGroupId"=:groupId and pc."businessType" in(:type) and pc."isActive"=\'1\') as productgroup where total > 0 ';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                groupId: filter.groupId,
                type: [filter.type, 3]
            }
        });
        res.status(common_1.HttpStatus.OK).json(result);
    }
    async guestUserRequirement(res, data) {
        let result = await this.channelSettingService.guestUserRequirement(data);
        res.status(common_1.HttpStatus.OK).json(result);
    }
    async getTopCompany(req, res, keyword, btype) {
        let channel = await this.channelSettingService.getTopCompany(keyword, btype);
        return res.status(common_1.HttpStatus.OK).send(channel);
    }
    async getMatchingVendors(req, res, data) {
        let result = await this.channelSettingService.getMatchingVendors(data.channelId, data);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async getMatchingBrands(req, res, data) {
        let result = await this.channelSettingService.getMatchingBrands(data.channelId, data);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async getFeaturedVendors(req, res, data) {
        let result = await this.channelSettingService.getFeaturedVendors(data.data);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async buyerSearchCount(req, res, data) {
        let result = await this.channelSettingService.getBuyerSearchCount(data);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
};
__decorate([
    common_1.Get('buyershighlight/:viewId'),
    __param(0, common_1.Param('viewId')), __param(1, common_1.Req()), __param(2, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "BuyersHighlight", null);
__decorate([
    common_1.Post('buyersaggr/:viewId/:parent'),
    __param(0, common_1.Param('viewId')), __param(1, common_1.Param('parent')), __param(2, common_1.Req()), __param(3, common_1.Res()), __param(4, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "buyersaggr", null);
__decorate([
    common_1.Post('productsaggr/:parent'),
    __param(0, common_1.Param('parent')), __param(1, common_1.Req()), __param(2, common_1.Res()), __param(3, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "productsaggr", null);
__decorate([
    common_1.Get('productshighlight/:btype'),
    __param(0, common_1.Param('btype')), __param(1, common_1.Req()), __param(2, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "ProductsHighlight", null);
__decorate([
    common_1.Post('getBuyerSearchList/:viewId'),
    __param(0, common_1.Req()), __param(1, common_1.Res()), __param(2, common_1.Param('viewId', new common_1.ParseIntPipe())), __param(3, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Number, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "getSearchList", null);
__decorate([
    common_1.Post('categoriesFilter'),
    __param(0, common_1.Req()), __param(1, common_1.Res()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "getCategories", null);
__decorate([
    common_1.Post('brandsFilter'),
    __param(0, common_1.Req()), __param(1, common_1.Res()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "getBrands", null);
__decorate([
    common_1.Post('countryFilter'),
    __param(0, common_1.Req()), __param(1, common_1.Res()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "getCountry", null);
__decorate([
    common_1.Post('my-products'),
    __param(0, common_1.Req()), __param(1, common_1.Res()), __param(2, common_1.Body(new common_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "myProduct", null);
__decorate([
    common_1.Post('my-products-slider'),
    __param(0, common_1.Req()), __param(1, common_1.Res()), __param(2, common_1.Body(new common_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "myProductSlider", null);
__decorate([
    common_1.Post('brandFilter'),
    __param(0, common_1.Req()), __param(1, common_1.Res()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "brandFilter", null);
__decorate([
    common_1.Post('categoryFilter'),
    __param(0, common_1.Req()), __param(1, common_1.Res()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "categoryFilter", null);
__decorate([
    common_1.Post('categoryGuestFilter'),
    __param(0, common_1.Req()), __param(1, common_1.Res()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "categoryGuestFilter", null);
__decorate([
    common_1.Post('familyFilter'),
    __param(0, common_1.Req()), __param(1, common_1.Res()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "familyFilter", null);
__decorate([
    common_1.Get('country'),
    __param(0, common_1.Req()), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "userCountry", null);
__decorate([
    common_1.Get('categoryDetails/:groupId'),
    __param(0, common_1.Req()), __param(1, common_1.Res()), __param(2, common_1.Param('groupId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "categoryDetails", null);
__decorate([
    common_1.Get('getProducts/:businessType'),
    __param(0, common_1.Req()), __param(1, common_1.Param()), __param(2, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "getProducts", null);
__decorate([
    common_1.Get('getCategories/:businessType'),
    __param(0, common_1.Req()), __param(1, common_1.Param()), __param(2, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "getCategorieList", null);
__decorate([
    common_1.Post('getProductByGroup'),
    __param(0, common_1.Res()), __param(1, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "getProductByGroup", null);
__decorate([
    common_1.Post('guestUserRequirement'),
    __param(0, common_1.Res()), __param(1, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "guestUserRequirement", null);
__decorate([
    common_1.Get('topcompany/:keyword/:btype'),
    __param(0, common_1.Req()), __param(1, common_1.Res()), __param(2, common_1.Param('keyword')), __param(3, common_1.Param('btype')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "getTopCompany", null);
__decorate([
    common_1.Post('matchingVendors'),
    __param(0, common_1.Req()), __param(1, common_1.Res()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "getMatchingVendors", null);
__decorate([
    common_1.Post('matchingBrands'),
    __param(0, common_1.Req()), __param(1, common_1.Res()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "getMatchingBrands", null);
__decorate([
    common_1.Post('featuredVendors'),
    __param(0, common_1.Req()), __param(1, common_1.Res()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "getFeaturedVendors", null);
__decorate([
    common_1.Post('buyerSearchCount'),
    __param(0, common_1.Req()), __param(1, common_1.Res()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], GuestController.prototype, "buyerSearchCount", null);
GuestController = __decorate([
    common_1.Controller('guest'),
    __param(3, common_1.Inject('SequelizeInstance')),
    __metadata("design:paramtypes", [channel_setting_service_1.ChannelSettingService,
        product_service_1.ProductService,
        user_service_1.UserService, Object])
], GuestController);
exports.GuestController = GuestController;
//# sourceMappingURL=guest.controller.js.map