"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PublicChannelController = void 0;
const common_1 = require("@nestjs/common");
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
const core_1 = require("../../../core");
const public_channel_service_1 = require("../service/public.channel.service");
let PublicChannelController = class PublicChannelController extends core_1.BaseController {
    constructor(channelService, sequelizeInstance) {
        super();
        this.channelService = channelService;
        this.sequelizeInstance = sequelizeInstance;
    }
    async getChannelDetailView(channelId, req, res) {
        let channelDetail = await this.channelService.getChannel(channelId);
        if (!channelDetail) {
            throw new Process_exception_1.ProcessException('channel:getChannel:channelNotFound');
        }
        res.status(common_1.HttpStatus.OK).send(channelDetail);
    }
    async channelBrands(channelId, res, req) {
        let user = req.user;
        let channelBrands = await this.channelService.channelBrands(+channelId);
        res.status(common_1.HttpStatus.OK).send(channelBrands);
    }
    async getEventChannelDetailView(channelId, req, res) {
        let channelDetail = await this.channelService.getChannel(channelId);
        if (!channelDetail) {
            throw new Process_exception_1.ProcessException('channel:getChannel:channelNotFound');
        }
        res.status(common_1.HttpStatus.OK).send(channelDetail);
    }
    async eventMatching(req, res, contactData) {
        if (req.headers.eventtoken == "VBzL1GQPiotFRTbgUSWP") {
            let result = await this.channelService.eventMatching(contactData);
            return res.status(common_1.HttpStatus.CREATED).send(result);
        }
    }
    async eventListing(typeId, req, res) {
        let result = await this.channelService.eventListing(typeId);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async getPassword(contactId, req, res) {
        if (req.headers.eventtoken == "VBzL1GQPiotFRTbgUSWP") {
            let result = await this.channelService.getPassword(contactId);
            return res.status(common_1.HttpStatus.OK).send(result);
        }
    }
};
__decorate([
    common_1.Get('channelDetailView/:channelId'),
    __param(0, common_1.Param('channelId')), __param(1, common_1.Req()), __param(2, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], PublicChannelController.prototype, "getChannelDetailView", null);
__decorate([
    common_1.Post('channelBrands/:channelId'),
    __param(0, common_1.Param('channelId')), __param(1, common_1.Res()), __param(2, common_1.Req()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], PublicChannelController.prototype, "channelBrands", null);
__decorate([
    common_1.Get('eventChannelDetailView/:channelId'),
    __param(0, common_1.Param('channelId')), __param(1, common_1.Req()), __param(2, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], PublicChannelController.prototype, "getEventChannelDetailView", null);
__decorate([
    common_1.Post('eventMatching'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body(new common_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], PublicChannelController.prototype, "eventMatching", null);
__decorate([
    common_1.Get('eventListing/:typeId'),
    __param(0, common_1.Param('typeId')), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], PublicChannelController.prototype, "eventListing", null);
__decorate([
    common_1.Get('getPassword/:contactId'),
    __param(0, common_1.Param('contactId')), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], PublicChannelController.prototype, "getPassword", null);
PublicChannelController = __decorate([
    common_1.Controller('publicChannel'),
    __param(1, common_1.Inject('SequelizeInstance')),
    __metadata("design:paramtypes", [public_channel_service_1.PublicChannelService, Object])
], PublicChannelController);
exports.PublicChannelController = PublicChannelController;
//# sourceMappingURL=public.channel.controller.js.map