'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TradeLocationController = void 0;
const common_1 = require("@nestjs/common");
const passport_1 = require("@nestjs/passport");
const core_1 = require("../../../core");
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
const channel_service_1 = require("../service/channel.service");
const tradeLocation_service_1 = require("../service/tradeLocation.service");
let TradeLocationController = class TradeLocationController extends core_1.BaseController {
    constructor(tradeLocationService, channelService, sequelizeInstance) {
        super();
        this.tradeLocationService = tradeLocationService;
        this.channelService = channelService;
        this.sequelizeInstance = sequelizeInstance;
    }
    async getChannelLocation(channelId, req, res) {
        let getChannelLocation = await this.tradeLocationService.getChannelLocation(req.user);
        if (getChannelLocation) {
            return res.status(common_1.HttpStatus.OK).json(getChannelLocation);
        }
        throw new Process_exception_1.ProcessException('channel:channelLocation:noLocations');
    }
};
__decorate([
    common_1.Get('getChannelLocation/:channelId'),
    __param(0, common_1.Param('channelId')), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], TradeLocationController.prototype, "getChannelLocation", null);
TradeLocationController = __decorate([
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    common_1.Controller(''),
    __param(2, common_1.Inject('SequelizeInstance')),
    __metadata("design:paramtypes", [tradeLocation_service_1.TradeLocationService,
        channel_service_1.ChannelService, Object])
], TradeLocationController);
exports.TradeLocationController = TradeLocationController;
//# sourceMappingURL=tradeLocation.controller.js.map