"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CompanyUpdateDto = void 0;
const class_validator_1 = require("class-validator");
const class_transformer_1 = require("class-transformer");
const companycertificate_dto_1 = require("./companycertificate.dto");
const companyawards_dto_1 = require("./companyawards.dto");
const companyB2B_dto_1 = require("./companyB2B.dto");
const channelDocument_dto_1 = require("./channelDocument.dto");
class CompanyUpdateDto {
}
__decorate([
    class_validator_1.IsNumber({}, { message: "channel:companyProfile:companyImageIdIsNumber" }),
    class_validator_1.IsOptional(),
    __metadata("design:type", Number)
], CompanyUpdateDto.prototype, "company_image_id", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:companyProfile:companyLogoUrlIsNotEmpty" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "company_logo_url", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.MaxLength(255, { message: "channel:subscription:companyNameMaxLen" }),
    class_validator_1.IsNotEmpty({ message: "channel:subscription:companyNameIsNotEmpty" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "company_name", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsEmail({}, { message: "channel:subscription:companyMailInvalid" }),
    class_validator_1.MaxLength(255, { message: "channel:subscription:companyMailMaxLen" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "company_email", void 0);
__decorate([
    class_validator_1.MinLength(5, { message: "channel:subscription:comapanyWebSideMinLen" }),
    class_validator_1.MaxLength(255, { message: "channel:subscription:comapanyWebSideMaxLen" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "company_website_url", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateIf(o => o.company_phone1 !== ""),
    class_validator_1.IsNotEmpty({ message: "channel:subscription:companyPhoneIsNotEmpty" }),
    class_validator_1.MinLength(5, { message: "channel:subscription:companyPhoneMinLen" }),
    class_validator_1.MaxLength(30, { message: "channel:subscription:companyPhoneMaxLen" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "company_phone1", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateIf(o => o.company_phone2 !== ""),
    class_validator_1.IsNotEmpty({ message: "channel:subscription:companyPhone2IsNotEmpty" }),
    class_validator_1.MinLength(5, { message: "channel:subscription:companyPhone2MinLen" }),
    class_validator_1.MaxLength(30, { message: "channel:subscription:companyPhone2MaxLen" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "company_phone2", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateIf(o => o.company_mobile_no !== ""),
    class_validator_1.MinLength(5, { message: "channel:companyProfile:companyMobileNoMinLen" }),
    class_validator_1.MaxLength(30, { message: "channel:companyProfile:companyMobileNoMaxLen" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "company_mobile_no", void 0);
__decorate([
    class_validator_1.MinLength(5, { message: "channel:subscription:describtionMinLen" }),
    class_validator_1.MaxLength(5000, { message: "channel:subscription:describtionMaxLen" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "company_about", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.MinLength(5, { message: "channel:subscription:describtionMinLen" }),
    class_validator_1.MaxLength(5000, { message: "channel:subscription:describtionMaxLen" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "company_expectation", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.Max(9999, {
        message: 'channel:companyProfile:shouldBeFourDigitNumber'
    }),
    class_validator_1.IsNumber({}, { message: "channel:companyProfile:shouldBeNumber" }),
    __metadata("design:type", Number)
], CompanyUpdateDto.prototype, "year_of_estabilishment", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "channel:companyProfile:companyRegAddressIdIsNotEmpty" }),
    class_validator_1.IsNumber({}, { message: "channel:companyProfile:companyRegAddressIdIsNumber" }),
    __metadata("design:type", Number)
], CompanyUpdateDto.prototype, "reg_address_id", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "channel:companyProfile:companyRegCityIsNotEmpty" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "reg_city", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "channel:companyProfile:companyAddresscountryIdIsNotEmpty" }),
    class_validator_1.IsNumber({}, { message: "channel:companyProfile:companyAddresscountryIdonlyacceptInt" }),
    __metadata("design:type", Number)
], CompanyUpdateDto.prototype, "reg_country_id", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "channel:companyProfile:companyAddresspostalcodeIsNotEmpty" }),
    __metadata("design:type", Number)
], CompanyUpdateDto.prototype, "reg_postal_code", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNumber({}, { message: "channel:companyProfile:companyBillAddressIdIsNumber" }),
    __metadata("design:type", Number)
], CompanyUpdateDto.prototype, "bill_address_id", void 0);
__decorate([
    class_validator_1.IsOptional(),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "bill_address", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:companyProfile:companyBillCityIsNotEmpty" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "bill_city", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:companyProfile:companyAddresscountryIdIsNotEmpty" }),
    class_validator_1.IsNumber({}, { message: "channel:companyProfile:companyAddresscountryIdonlyacceptInt" }),
    __metadata("design:type", Number)
], CompanyUpdateDto.prototype, "bill_country_id", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:companyProfile:companyAddresspostalcodeIsNotEmpty" }),
    __metadata("design:type", Number)
], CompanyUpdateDto.prototype, "bill_postal_code", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "channel:companyProfile:isSameAddressIsNotEmpty" }),
    class_validator_1.IsNumber({}, { message: "channel:companyProfile:isSameAddressIsNumber" }),
    __metadata("design:type", Number)
], CompanyUpdateDto.prototype, "is_same_address", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNumber({}, { message: "channel:companyProfile:companySocialLinkedinIdIsNumber" }),
    __metadata("design:type", Number)
], CompanyUpdateDto.prototype, "social_linkedin_id", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateIf(o => o.social_linkedin_url !== ""),
    class_validator_1.IsNotEmpty({ message: "channel:companyProfile:companySocialLinkedinUrlIsNotEmpty" }),
    class_validator_1.MaxLength(255, { message: "channel:companyProfile:companySocialLinkedinUrlMaxLen" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "social_linkedin_url", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNumber({}, { message: "channel:companyProfile:companySocialGoogleplusIdIsNumber" }),
    __metadata("design:type", Number)
], CompanyUpdateDto.prototype, "social_googleplus_id", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateIf(o => o.social_googleplus_url !== ""),
    class_validator_1.IsNotEmpty({ message: "channel:companyProfile:companySocialGoogleplusUrlIsNotEmpty" }),
    class_validator_1.MinLength(5, { message: "channel:companyProfile:companySocialGoogleplusUrlMinLen" }),
    class_validator_1.MaxLength(255, { message: "channel:companyProfile:companySocialGoogleplusUrlMaxLen" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "social_googleplus_url", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNumber({}, { message: "channel:companyProfile:companySocialInstagramIdIsNumber" }),
    __metadata("design:type", Number)
], CompanyUpdateDto.prototype, "social_instagram_id", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateIf(o => o.social_instagram_url !== ""),
    class_validator_1.IsNotEmpty({ message: "channel:companyProfile:companySocialInstagramUrlIsNotEmpty" }),
    class_validator_1.MinLength(5, { message: "channel:companyProfile:companySocialInstagramUrlMinLen" }),
    class_validator_1.MaxLength(255, { message: "channel:companyProfile:companySocialInstagramUrlMaxLen" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "social_instagram_url", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNumber({}, { message: "channel:companyProfile:companySocialfacebookIdIsNumber" }),
    __metadata("design:type", Number)
], CompanyUpdateDto.prototype, "social_facebook_id", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateIf(o => o.social_facebook_url !== ""),
    class_validator_1.IsNotEmpty({ message: "channel:companyProfile:companySocialfacebookUrlIsNotEmpty" }),
    class_validator_1.MinLength(5, { message: "channel:companyProfile:companySocialfacebookUrlMinLen" }),
    class_validator_1.MaxLength(255, { message: "channel:companyProfile:companySocialfacebookUrlMaxLen" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "social_facebook_url", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNumber({}, { message: "channel:companyProfile:companySocialtwitterIdIsNumber" }),
    __metadata("design:type", Number)
], CompanyUpdateDto.prototype, "social_twitter_id", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateIf(o => o.social_twitter_url !== ""),
    class_validator_1.IsNotEmpty({ message: "channel:companyProfile:companySocialtwitterUrlIsNotEmpty" }),
    class_validator_1.MinLength(5, { message: "channel:companyProfile:companySocialtwitterUrlMinLen" }),
    class_validator_1.MaxLength(255, { message: "channel:companyProfile:companySocialtwitterUrlMaxLen" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "social_twitter_url", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:subscription:firstNameNotEmpty" }),
    class_validator_1.MinLength(1, { message: "channel:subscription:firstNameMinLen" }),
    class_validator_1.MaxLength(30, { message: "channel:subscription:firstNameMaxLen" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "contact_first_name", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:subscription:lastNameIsNotEmpty" }),
    class_validator_1.MinLength(1, { message: "channel:subscription:lastNameMinLen" }),
    class_validator_1.MaxLength(30, { message: "channel:subscription:lastNameMaxLen" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "contact_last_name", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateIf(o => o.contact_phone1 !== ""),
    class_validator_1.IsNotEmpty({ message: "channel:subscription:phoneIsNotEmpty" }),
    class_validator_1.MinLength(5, { message: "channel:subscription:phoneMinLen" }),
    class_validator_1.MaxLength(30, { message: "channel:subscription:phoneMaxLen" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "contact_phone1", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateIf(o => o.contact_phone2 !== ""),
    class_validator_1.MinLength(5, { message: "channel:subscription:phoneMinLen" }),
    class_validator_1.MaxLength(30, { message: "channel:subscription:phoneMaxLen" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "contact_phone2", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:companyProfile:companyContactMobileNoIsNotEmpty" }),
    class_validator_1.MinLength(5, { message: "channel:companyProfile:companyContactMobileNoMinLen" }),
    class_validator_1.MaxLength(30, { message: "channel:companyProfile:companyContactMobileNoMaxLen" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "contact_mobile_no", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:subscription:jobTitleIsNotEmpty" }),
    class_validator_1.MinLength(2, { message: "channel:subscription:jobTitleMinLen" }),
    class_validator_1.MaxLength(255, { message: "channel:subscription:jobTitleMaxLen" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "contact_job_title", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNumber({}, { message: "channel:companyProfile:contactLinkedIdIsNumber" }),
    __metadata("design:type", Number)
], CompanyUpdateDto.prototype, "contact_linkedin_id", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateIf(o => o.contact_linkedin_url !== ""),
    class_validator_1.IsNotEmpty({ message: "channel:companyProfile:linkedInIsNotEmpty" }),
    class_validator_1.MaxLength(255, { message: "channel:companyProfile:linkedInMaxLen" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "contact_linkedin_url", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNumber({}, { message: "channel:companyProfile:contactProfileImageIdIsNumber" }),
    __metadata("design:type", Number)
], CompanyUpdateDto.prototype, "contact_profile_image_id", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:companyProfile:imageIsNotEmpty" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "contact_profile_image_url", void 0);
__decorate([
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => companycertificate_dto_1.CompanyCertificateDto),
    __metadata("design:type", Array)
], CompanyUpdateDto.prototype, "registration_certificate", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:companyProfile:companyTaxCertificateIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => companycertificate_dto_1.CompanyCertificateDto),
    __metadata("design:type", Array)
], CompanyUpdateDto.prototype, "tax_certificate", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => companyawards_dto_1.CompanyAwardsDto),
    __metadata("design:type", Array)
], CompanyUpdateDto.prototype, "award_details", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:companyProfile:companyB2BUrlIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => companyB2B_dto_1.CompanyB2BDto),
    __metadata("design:type", Array)
], CompanyUpdateDto.prototype, "B2B_url", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:companyProfile:companyDeletedRegistrationCertificateIsNotEmpty" }),
    __metadata("design:type", Array)
], CompanyUpdateDto.prototype, "deleted_registration_certificate", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:companyProfile:companyDeletedTaxCertificateIsNotEmpty" }),
    __metadata("design:type", Array)
], CompanyUpdateDto.prototype, "deleted_tax_certificate", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:companyProfile:companyDeletedAwardDetailsIsNotEmpty" }),
    __metadata("design:type", Array)
], CompanyUpdateDto.prototype, "deleted_award_details", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:companyProfile:companyDeletedB2BIsNotEmpty" }),
    __metadata("design:type", Array)
], CompanyUpdateDto.prototype, "deleted_B2B", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "validate:field:shouldBeEmptyArray" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => channelDocument_dto_1.ChannelDocumentDto),
    __metadata("design:type", Array)
], CompanyUpdateDto.prototype, "channel_document", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "validate:field:shouldBeEmptyArray" }),
    __metadata("design:type", Array)
], CompanyUpdateDto.prototype, "companyImages", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "validate:field:shouldBeEmptyArray" }),
    __metadata("design:type", Array)
], CompanyUpdateDto.prototype, "deleted_channel_documents", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "validate:field:shouldBeEmptyArray" }),
    __metadata("design:type", Object)
], CompanyUpdateDto.prototype, "deleted_companyImages", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.MaxLength(1000, { message: "validate:field:validateMaxLength" }),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "reason", void 0);
__decorate([
    class_validator_1.IsOptional(),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "company_introvideo", void 0);
__decorate([
    class_validator_1.IsOptional(),
    __metadata("design:type", Object)
], CompanyUpdateDto.prototype, "bannerImage", void 0);
__decorate([
    class_validator_1.IsOptional(),
    __metadata("design:type", Array)
], CompanyUpdateDto.prototype, "certificatesList", void 0);
__decorate([
    class_validator_1.IsOptional(),
    __metadata("design:type", Array)
], CompanyUpdateDto.prototype, "deletedTags", void 0);
__decorate([
    class_validator_1.IsOptional(),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "companyDesc", void 0);
__decorate([
    class_validator_1.IsOptional(),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "isOEM", void 0);
__decorate([
    class_validator_1.IsOptional(),
    __metadata("design:type", String)
], CompanyUpdateDto.prototype, "is_company_public", void 0);
__decorate([
    class_validator_1.IsOptional(),
    __metadata("design:type", Number)
], CompanyUpdateDto.prototype, "ratingId", void 0);
exports.CompanyUpdateDto = CompanyUpdateDto;
//# sourceMappingURL=company.update.dto.js.map