"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SearchRegionDto = exports.locationType = void 0;
const class_validator_1 = require("class-validator");
const swagger_1 = require("@nestjs/swagger");
var locationType;
(function (locationType) {
    locationType[locationType["SELLING"] = 0] = "SELLING";
    locationType[locationType["TARGET"] = 1] = "TARGET";
    locationType[locationType["RETAIL"] = 2] = "RETAIL";
})(locationType = exports.locationType || (exports.locationType = {}));
class SearchRegionDto {
}
__decorate([
    class_validator_1.IsNotEmpty({ message: "common:regionCountry:zoneNotEmpty" }),
    class_validator_1.IsArray({ message: "common:regionCountry:zoneNotArray" }),
    swagger_1.ApiProperty({ type: 'number', isArray: true }),
    __metadata("design:type", Array)
], SearchRegionDto.prototype, "zone", void 0);
__decorate([
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SearchRegionDto.prototype, "region", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "channel:channelLocation:locationTypeIsNotEmpty" }),
    class_validator_1.IsEnum(locationType, { message: "channel:channelLocation:locationTypeIsEnum" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SearchRegionDto.prototype, "locationType", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    class_validator_1.IsBoolean({ message: "validate:field:shouldBeBoolean" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Boolean)
], SearchRegionDto.prototype, "exclude", void 0);
exports.SearchRegionDto = SearchRegionDto;
//# sourceMappingURL=searchRegion.dto.js.map