"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SettingDto = void 0;
const class_validator_1 = require("class-validator");
const swagger_1 = require("@nestjs/swagger");
const class_transformer_1 = require("class-transformer");
const ChannelProfile_dto_1 = require("./SaveProfile/ChannelProfile.dto");
class SettingDto {
}
__decorate([
    class_validator_1.IsNotEmpty({ message: "channel:companyProfile:yearOfEstabilishmentIsNotEmpty" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], SettingDto.prototype, "yearEstablished", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:startupIsNotEmpty" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SettingDto.prototype, "areYouStartUp", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:employeesRangeNotEmpty" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SettingDto.prototype, "no_of_staffs", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:annualTurnoverRangeNotEmpty" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SettingDto.prototype, "annualTurnOver", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "channel:profile:registrationNumberNotEmpty" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SettingDto.prototype, "companyRegNumber", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SettingDto.prototype, "vatNumber", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SettingDto.prototype, "companyLogo", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "channel:profile:tweetPitchNotEmpty" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SettingDto.prototype, "tweetPitch", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SettingDto.prototype, "introVideo", void 0);
__decorate([
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SettingDto.prototype, "companyDescription", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SettingDto.prototype, "productBrand", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "validate:field:shouldBeArray" }),
    class_validator_1.IsNumber({}, {
        each: true,
        message: "validate:field:shouldBeInt"
    }),
    swagger_1.ApiProperty({ type: 'number', isArray: true }),
    __metadata("design:type", Array)
], SettingDto.prototype, "productGroup", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "validate:field:shouldBeArray" }),
    class_validator_1.IsNumber({}, {
        each: true,
        message: "validate:field:shouldBeInt"
    }),
    swagger_1.ApiProperty({ type: 'number', isArray: true }),
    __metadata("design:type", Array)
], SettingDto.prototype, "productCat", void 0);
__decorate([
    swagger_1.ApiProperty({ type: ChannelProfile_dto_1.ChannelProfileDto }),
    class_validator_1.IsNotEmpty({ message: "channel:product:channelProfileIsNotEmpty" }),
    class_transformer_1.Type(() => ChannelProfile_dto_1.ChannelProfileDto),
    __metadata("design:type", ChannelProfile_dto_1.ChannelProfileDto)
], SettingDto.prototype, "relevantChannelProfile", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNumber({}, {
        each: true,
        message: "validate:field:shouldBeInt"
    }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], SettingDto.prototype, "no_of_skus", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty({ type: ChannelProfile_dto_1.ChannelProfileDto }),
    class_validator_1.IsNotEmpty({ message: "channel:product:channelProfileIsNotEmpty" }),
    class_transformer_1.Type(() => ChannelProfile_dto_1.ChannelProfileDto),
    __metadata("design:type", ChannelProfile_dto_1.ChannelProfileDto)
], SettingDto.prototype, "relevantDistributorProfile", void 0);
exports.SettingDto = SettingDto;
//# sourceMappingURL=setting.dto.js.map