"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SettingsDto = void 0;
const class_validator_1 = require("class-validator");
const class_transformer_1 = require("class-transformer");
const paymentType_dto_1 = require("./paymentType.dto");
const paymentTerms_dto_1 = require("./paymentTerms.dto");
const share_dto_1 = require("./share.dto");
class SettingsDto {
}
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:settings:paymentTypeArrayIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => paymentType_dto_1.PaymentTypeDto),
    __metadata("design:type", Array)
], SettingsDto.prototype, "paymentType", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:settings:paymentTermsArrayIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => paymentTerms_dto_1.PaymentTermsDto),
    __metadata("design:type", Array)
], SettingsDto.prototype, "paymentTerms", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "channel:settings:currencyIdIsNotEmpty" }),
    class_validator_1.IsNumber({}, { message: "channel:settings:currencyIdIsNumber" }),
    __metadata("design:type", String)
], SettingsDto.prototype, "currencyId", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "channel:settings:shareStatusIsNotEmpty" }),
    class_validator_1.IsBoolean({ message: "channel:settings:shareStatusIsBoolean" }),
    __metadata("design:type", Boolean)
], SettingsDto.prototype, "shareStatus", void 0);
__decorate([
    class_validator_1.ValidateIf(o => o.shareStatus === true),
    class_validator_1.ArrayNotEmpty({ message: "channel:settings:shareArrayIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => share_dto_1.ShareDto),
    __metadata("design:type", Array)
], SettingsDto.prototype, "share", void 0);
__decorate([
    class_validator_1.IsNumber({}, { message: "channel:tradeinformation:channelTypeIsNumber" }),
    __metadata("design:type", Number)
], SettingsDto.prototype, "channelType", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.MaxLength(1000, { message: "validate:field:validateMaxLength" }),
    __metadata("design:type", String)
], SettingsDto.prototype, "reason", void 0);
exports.SettingsDto = SettingsDto;
//# sourceMappingURL=settings.dto.js.map