"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TradeInformationDto = void 0;
const class_validator_1 = require("class-validator");
const class_transformer_1 = require("class-transformer");
const swagger_1 = require("@nestjs/swagger");
const app_constant_1 = require("../../../config/app.constant");
const tradeInformation_Product_Families_dto_1 = require("./tradeInformation_Product_Families.dto");
const tradeInformation_Product_Categories_dto_1 = require("./tradeInformation_Product_Categories.dto");
const tradeInformation_Customer_Profiles_dto_1 = require("./tradeInformation_Customer_Profiles.dto");
const tradeInformation_Vendor_dto_1 = require("./tradeInformation_Vendor.dto");
const tradeInformation_Distributor_dto_1 = require("./tradeInformation_Distributor.dto");
const tradeInformation_Retailer_dto_1 = require("./tradeInformation_Retailer.dto");
class TradeInformationDto {
}
__decorate([
    swagger_1.ApiProperty({ type: tradeInformation_Product_Families_dto_1.TradeInformation_Product_FamiliesDto, isArray: true }),
    class_validator_1.ArrayNotEmpty({ message: "channel:tradeinformation:productFamiliesArray" }),
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:productFamiliesArrayNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Product_Families_dto_1.TradeInformation_Product_FamiliesDto),
    __metadata("design:type", Array)
], TradeInformationDto.prototype, "productFamilies", void 0);
__decorate([
    swagger_1.ApiProperty({ type: tradeInformation_Product_Categories_dto_1.TradeInformation_Product_CategoriesDto, isArray: true }),
    class_validator_1.ArrayNotEmpty({ message: "channel:tradeinformation:productCategoriesArray" }),
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:productCategoriesNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Product_Categories_dto_1.TradeInformation_Product_CategoriesDto),
    __metadata("design:type", Array)
], TradeInformationDto.prototype, "productCategories", void 0);
__decorate([
    class_validator_1.ValidateIf(o => o.channelType !== app_constant_1.appconstant.CHANNEL_TYPE_RETAILER),
    swagger_1.ApiProperty({ type: tradeInformation_Customer_Profiles_dto_1.TradeInformation_Customer_ProfilesDto, isArray: true }),
    class_validator_1.ArrayNotEmpty({ message: "channel:tradeinformation:customerProfilesArray" }),
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:customerProfilesNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Customer_Profiles_dto_1.TradeInformation_Customer_ProfilesDto),
    __metadata("design:type", Array)
], TradeInformationDto.prototype, "customerProfiles", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:channelTypeNotEmpty" }),
    class_validator_1.IsNumber({}, { message: "channel:tradeinformation:channelTypeIsNumber" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], TradeInformationDto.prototype, "channelType", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    class_validator_1.IsString({ message: "validate:field:shouldBeString" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], TradeInformationDto.prototype, "is_french_tech", void 0);
__decorate([
    class_validator_1.ValidateIf(o => o.channelType === app_constant_1.appconstant.CHANNEL_TYPE_VENDOR),
    swagger_1.ApiProperty({ type: tradeInformation_Vendor_dto_1.TradeInformation_VendorDto }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Vendor_dto_1.TradeInformation_VendorDto),
    __metadata("design:type", tradeInformation_Vendor_dto_1.TradeInformation_VendorDto)
], TradeInformationDto.prototype, "tradeInformationVendor", void 0);
__decorate([
    class_validator_1.ValidateIf(o => o.channelType === app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR),
    swagger_1.ApiProperty({ type: tradeInformation_Distributor_dto_1.TradeInformation_DistributorDto }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Distributor_dto_1.TradeInformation_DistributorDto),
    __metadata("design:type", tradeInformation_Distributor_dto_1.TradeInformation_DistributorDto)
], TradeInformationDto.prototype, "tradeInformationDistributor", void 0);
__decorate([
    class_validator_1.ValidateIf(o => o.channelType === app_constant_1.appconstant.CHANNEL_TYPE_RETAILER),
    swagger_1.ApiProperty({ type: tradeInformation_Retailer_dto_1.TradeInformation_RetailerDto }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Retailer_dto_1.TradeInformation_RetailerDto),
    __metadata("design:type", tradeInformation_Retailer_dto_1.TradeInformation_RetailerDto)
], TradeInformationDto.prototype, "tradeInformationRetailer", void 0);
exports.TradeInformationDto = TradeInformationDto;
//# sourceMappingURL=tradeInformation.dto.js.map