"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TradeInformationUpdateDto = void 0;
const class_validator_1 = require("class-validator");
const class_transformer_1 = require("class-transformer");
const swagger_1 = require("@nestjs/swagger");
const app_constant_1 = require("../../../config/app.constant");
const tradeInformation_Product_Families_update_dto_1 = require("./tradeInformation_Product_Families.update.dto");
const tradeInformation_Product_Categories_update_dto_1 = require("./tradeInformation_Product_Categories.update.dto");
const tradeInformation_Customer_Profiles_update_dto_1 = require("./tradeInformation_Customer_Profiles.update.dto");
const tradeInformation_Vendor_Update_dto_1 = require("./tradeInformation_Vendor.Update.dto");
const tradeInformation_Distributor_update_dto_1 = require("./tradeInformation_Distributor.update.dto");
const tradeInformation_Retailer_update_dto_1 = require("./tradeInformation_Retailer.update.dto");
class TradeInformationUpdateDto {
}
__decorate([
    swagger_1.ApiProperty({ type: tradeInformation_Product_Families_update_dto_1.TradeInformation_Product_FamiliesUpdateDto, isArray: true }),
    class_validator_1.IsOptional(),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Product_Families_update_dto_1.TradeInformation_Product_FamiliesUpdateDto),
    __metadata("design:type", Array)
], TradeInformationUpdateDto.prototype, "productFamilies", void 0);
__decorate([
    swagger_1.ApiProperty({ type: tradeInformation_Product_Categories_update_dto_1.TradeInformation_Product_CategoriesUpdateDto, isArray: true }),
    class_validator_1.IsOptional(),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Product_Categories_update_dto_1.TradeInformation_Product_CategoriesUpdateDto),
    __metadata("design:type", Array)
], TradeInformationUpdateDto.prototype, "productCategories", void 0);
__decorate([
    swagger_1.ApiProperty({ type: tradeInformation_Customer_Profiles_update_dto_1.TradeInformation_Customer_ProfilesUpdateDto, isArray: true }),
    class_validator_1.IsOptional(),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Customer_Profiles_update_dto_1.TradeInformation_Customer_ProfilesUpdateDto),
    __metadata("design:type", Array)
], TradeInformationUpdateDto.prototype, "customerProfiles", void 0);
__decorate([
    class_validator_1.IsNumber({}, { message: "channel:tradeinformation:channelTypeIsNumber" }),
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], TradeInformationUpdateDto.prototype, "channelType", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    class_validator_1.IsString({ message: "validate:field:shouldBeString" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], TradeInformationUpdateDto.prototype, "is_french_tech", void 0);
__decorate([
    class_validator_1.ValidateIf(o => o.channelType === app_constant_1.appconstant.CHANNEL_TYPE_VENDOR),
    swagger_1.ApiProperty({ type: tradeInformation_Vendor_Update_dto_1.TradeInformation_VendorUpdateDto }),
    class_validator_1.IsOptional(),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Vendor_Update_dto_1.TradeInformation_VendorUpdateDto),
    __metadata("design:type", tradeInformation_Vendor_Update_dto_1.TradeInformation_VendorUpdateDto)
], TradeInformationUpdateDto.prototype, "tradeInformationVendor", void 0);
__decorate([
    class_validator_1.ValidateIf(o => o.channelType === app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR),
    swagger_1.ApiProperty({ type: tradeInformation_Distributor_update_dto_1.TradeInformation_DistributorUpdateDto }),
    class_validator_1.IsOptional(),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Distributor_update_dto_1.TradeInformation_DistributorUpdateDto),
    __metadata("design:type", tradeInformation_Distributor_update_dto_1.TradeInformation_DistributorUpdateDto)
], TradeInformationUpdateDto.prototype, "tradeInformationDistributor", void 0);
__decorate([
    class_validator_1.ValidateIf(o => o.channelType === app_constant_1.appconstant.CHANNEL_TYPE_RETAILER),
    swagger_1.ApiProperty({ type: tradeInformation_Retailer_update_dto_1.TradeInformation_RetailerUpdateDto }),
    class_validator_1.IsOptional(),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Retailer_update_dto_1.TradeInformation_RetailerUpdateDto),
    __metadata("design:type", tradeInformation_Retailer_update_dto_1.TradeInformation_RetailerUpdateDto)
], TradeInformationUpdateDto.prototype, "tradeInformationRetailer", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.MaxLength(1000, { message: "validate:field:validateMaxLength" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], TradeInformationUpdateDto.prototype, "reason", void 0);
exports.TradeInformationUpdateDto = TradeInformationUpdateDto;
//# sourceMappingURL=tradeInformation.update.dto.js.map