"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TradeInformation_RetailerDto = exports.maturityLevel = void 0;
const class_validator_1 = require("class-validator");
const class_transformer_1 = require("class-transformer");
const swagger_1 = require("@nestjs/swagger");
const tradeInformation_Retailer_Speciality_dto_1 = require("./tradeInformation_Retailer_Speciality.dto");
var maturityLevel;
(function (maturityLevel) {
    maturityLevel[maturityLevel["PROTOTYPE"] = 0] = "PROTOTYPE";
    maturityLevel[maturityLevel["S_BACKER"] = 1] = "S_BACKER";
    maturityLevel[maturityLevel["S_VOLUME"] = 2] = "S_VOLUME";
})(maturityLevel = exports.maturityLevel || (exports.maturityLevel = {}));
class TradeInformation_RetailerDto {
}
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty({ type: tradeInformation_Retailer_Speciality_dto_1.TradeInformation_Retailer_SpecialityDto, isArray: true }),
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:retailerSpecialityNotEmpty" }),
    class_validator_1.ArrayNotEmpty({ message: "channel:tradeinformation:retailerSpecialityArrayNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Retailer_Speciality_dto_1.TradeInformation_Retailer_SpecialityDto),
    __metadata("design:type", Array)
], TradeInformation_RetailerDto.prototype, "speciality", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:profileTypeIdNotEmpty" }),
    class_validator_1.IsNumber({}, { message: "channel:subscription:profileTypeIdonlyacceptInt" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], TradeInformation_RetailerDto.prototype, "profileTypeId", void 0);
__decorate([
    class_validator_1.ValidateIf(o => o.employeesCount === undefined),
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:employeesRangeNotEmpty" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], TradeInformation_RetailerDto.prototype, "employeesRange", void 0);
__decorate([
    class_validator_1.ValidateIf(o => o.employeesRange === undefined),
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:employeesCountNotEmpty" }),
    class_validator_1.Min(1, { message: "channel:tradeinformationVendor:minEmployeesCount" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], TradeInformation_RetailerDto.prototype, "employeesCount", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateIf(o => o.annualTurnover === undefined),
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:annualTurnoverRangeNotEmpty" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], TradeInformation_RetailerDto.prototype, "annualTurnoverRange", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateIf(o => o.annualTurnoverRange === undefined),
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:annualTurnoverNotEmpty" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], TradeInformation_RetailerDto.prototype, "annualTurnover", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], TradeInformation_RetailerDto.prototype, "physicalStore", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], TradeInformation_RetailerDto.prototype, "OnlineStore", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:startupIsNotEmpty" }),
    class_validator_1.IsString({ message: "channel:tradeinformation:startupIsString" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], TradeInformation_RetailerDto.prototype, "startup", void 0);
__decorate([
    class_validator_1.ValidateIf(o => o.startup === '1'),
    class_validator_1.IsEnum(maturityLevel, {
        each: true,
        message: "channel:tradeinformation:maturityLevelIsEnum"
    }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Array)
], TradeInformation_RetailerDto.prototype, "maturitylevel", void 0);
__decorate([
    class_validator_1.Min(1, { message: "channel:tradeinformation:minStoreCount" }),
    class_validator_1.Max(999999999, { message: "channel:tradeinformation:maxStoreCount" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], TradeInformation_RetailerDto.prototype, "storeCount", void 0);
exports.TradeInformation_RetailerDto = TradeInformation_RetailerDto;
//# sourceMappingURL=tradeInformation_Retailer.dto.js.map