"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TradeInformation_VendorDto = exports.maturityLevel = void 0;
const class_validator_1 = require("class-validator");
const class_transformer_1 = require("class-transformer");
const tradeInformation_Brand_Name_dto_1 = require("./tradeInformation_Brand_Name.dto");
const swagger_1 = require("@nestjs/swagger");
const channelkeyretailer_dto_1 = require("./channelkeyretailer.dto");
var maturityLevel;
(function (maturityLevel) {
    maturityLevel[maturityLevel["PROTOTYPE"] = 0] = "PROTOTYPE";
    maturityLevel[maturityLevel["S_BACKER"] = 1] = "S_BACKER";
    maturityLevel[maturityLevel["S_VOLUME"] = 2] = "S_VOLUME";
})(maturityLevel = exports.maturityLevel || (exports.maturityLevel = {}));
class TradeInformation_VendorDto {
}
__decorate([
    swagger_1.ApiProperty({ type: tradeInformation_Brand_Name_dto_1.TradeInformation_Brand_NameDto, isArray: true }),
    class_validator_1.ArrayNotEmpty({ message: "channel:tradeinformation:BrandArray" }),
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:BrandNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Brand_Name_dto_1.TradeInformation_Brand_NameDto),
    __metadata("design:type", Array)
], TradeInformation_VendorDto.prototype, "brand", void 0);
__decorate([
    class_validator_1.ValidateIf(o => o.employeesCount === undefined),
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:employeesRangeNotEmpty" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], TradeInformation_VendorDto.prototype, "employeesRange", void 0);
__decorate([
    class_validator_1.ValidateIf(o => o.employeesRange === undefined),
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:employeesCountNotEmpty" }),
    class_validator_1.Min(1, { message: "channel:tradeinformationVendor:minEmployeesCount" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], TradeInformation_VendorDto.prototype, "employeesCount", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:profileTypeIdNotEmpty" }),
    class_validator_1.IsNumber({}, { message: "channel:subscription:profileTypeIdonlyacceptInt" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], TradeInformation_VendorDto.prototype, "profileTypeId", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.Min(1, { message: "channel:tradeinformationVendor:mindomesticSales" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], TradeInformation_VendorDto.prototype, "domesticSales", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.Min(1, { message: "channel:tradeinformationVendor:mininternationalSales" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], TradeInformation_VendorDto.prototype, "internationalSales", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.Min(1, { message: "channel:tradeinformationVendor:mindomesticMarketing" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], TradeInformation_VendorDto.prototype, "domesticMarketing", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.Min(1, { message: "channel:tradeinformationVendor:mininternationalMarketing" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], TradeInformation_VendorDto.prototype, "internationalMarketing", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateIf(o => o.annualTurnover === undefined),
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:annualTurnoverRangeNotEmpty" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], TradeInformation_VendorDto.prototype, "annualTurnoverRange", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateIf(o => o.annualTurnoverRange === undefined),
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:annualTurnoverNotEmpty" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], TradeInformation_VendorDto.prototype, "annualTurnover", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], TradeInformation_VendorDto.prototype, "domesticRevenue", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], TradeInformation_VendorDto.prototype, "internationalRevenue", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:startupIsNotEmpty" }),
    class_validator_1.IsString({ message: "channel:tradeinformation:startupIsString" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], TradeInformation_VendorDto.prototype, "startup", void 0);
__decorate([
    class_validator_1.ValidateIf(o => o.startup === '1'),
    class_validator_1.IsEnum(maturityLevel, {
        each: true,
        message: "channel:tradeinformation:maturityLevelIsEnum"
    }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Array)
], TradeInformation_VendorDto.prototype, "maturitylevel", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty({ type: channelkeyretailer_dto_1.ChannelKeyRetailerDto, isArray: true }),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:productKeyRetailerArrayNotEmpty" }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productKeyRetailerIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => channelkeyretailer_dto_1.ChannelKeyRetailerDto),
    __metadata("design:type", Array)
], TradeInformation_VendorDto.prototype, "channelKeyRetailer", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:deletedkeyretailerIsNotEmpty" }),
    swagger_1.ApiProperty({ type: 'number', isArray: true }),
    __metadata("design:type", Array)
], TradeInformation_VendorDto.prototype, "deletedkeyretailer", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.MaxLength(2000, {
        message: "validate:field:validateMaxLength"
    }),
    class_validator_1.IsString({ message: "validate:field:shouldBeString" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], TradeInformation_VendorDto.prototype, "keyretailers", void 0);
__decorate([
    class_validator_1.Max(9999, { message: "validate:field:validateMaxLength" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], TradeInformation_VendorDto.prototype, "no_of_skus", void 0);
__decorate([
    class_validator_1.Max(9999999, { message: "validate:field:validateMaxLength" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], TradeInformation_VendorDto.prototype, "no_of_distributors", void 0);
__decorate([
    class_validator_1.Max(9999999, { message: "validate:field:validateMaxLength" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], TradeInformation_VendorDto.prototype, "no_of_retailers", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty({ type: channelkeyretailer_dto_1.ChannelKeyRetailerDto, isArray: true }),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:productKeyRetailerArrayNotEmpty" }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productKeyRetailerIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => channelkeyretailer_dto_1.ChannelKeyRetailerDto),
    __metadata("design:type", Array)
], TradeInformation_VendorDto.prototype, "channelKeyDistributor", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:deletedkeyretailerIsNotEmpty" }),
    swagger_1.ApiProperty({ type: 'number', isArray: true }),
    __metadata("design:type", Array)
], TradeInformation_VendorDto.prototype, "deletedkeydistributor", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.MaxLength(2000, {
        message: "validate:field:validateMaxLength"
    }),
    class_validator_1.IsString({ message: "validate:field:shouldBeString" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], TradeInformation_VendorDto.prototype, "keydistributors", void 0);
exports.TradeInformation_VendorDto = TradeInformation_VendorDto;
//# sourceMappingURL=tradeInformation_Vendor.dto.js.map