"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AutoRenewalTracking = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const swagger_1 = require("@nestjs/swagger");
const Channel_entity_1 = require("./Channel.entity");
const PaymentTransaction_entity_1 = require("./PaymentTransaction.entity");
const AutoRenewalTrackingStatus_entity_1 = require("./AutoRenewalTrackingStatus.entity");
const ChannelSubscription_entity_1 = require("./ChannelSubscription.entity");
var Sequelize = require('sequelize');
let AutoRenewalTracking = class AutoRenewalTracking extends sequelize_typescript_1.Model {
    static async dateUpdate(autoRenewalTracking, options) {
        autoRenewalTracking.updatedat = Sequelize.fn('NOW');
    }
};
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.INTEGER,
        allowNull: false,
        unique: true,
        primaryKey: true,
    }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], AutoRenewalTracking.prototype, "autorenewaltrackingid", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], AutoRenewalTracking.prototype, "channelid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel),
    __metadata("design:type", Channel_entity_1.Channel)
], AutoRenewalTracking.prototype, "channel", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => ChannelSubscription_entity_1.ChannelSubscription),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], AutoRenewalTracking.prototype, "channelsubscriptionid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => ChannelSubscription_entity_1.ChannelSubscription),
    __metadata("design:type", ChannelSubscription_entity_1.ChannelSubscription)
], AutoRenewalTracking.prototype, "channelSubscription", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.INTEGER,
    }),
    sequelize_typescript_1.ForeignKey(() => AutoRenewalTrackingStatus_entity_1.AutoRenewalTrackingStatus),
    __metadata("design:type", Number)
], AutoRenewalTracking.prototype, "statusid", void 0);
__decorate([
    swagger_1.ApiProperty(),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], AutoRenewalTracking.prototype, "remindercount", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => PaymentTransaction_entity_1.PaymentTransaction),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], AutoRenewalTracking.prototype, "paymenttransactionid", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.TIME),
    __metadata("design:type", Number)
], AutoRenewalTracking.prototype, "endat", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => PaymentTransaction_entity_1.PaymentTransaction),
    __metadata("design:type", PaymentTransaction_entity_1.PaymentTransaction)
], AutoRenewalTracking.prototype, "paymentTransaction", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], AutoRenewalTracking.prototype, "createdat", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], AutoRenewalTracking.prototype, "updatedat", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], AutoRenewalTracking.prototype, "deletedat", void 0);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    sequelize_typescript_1.BeforeUpdate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [AutoRenewalTracking, Object]),
    __metadata("design:returntype", Promise)
], AutoRenewalTracking, "dateUpdate", null);
AutoRenewalTracking = __decorate([
    sequelize_typescript_1.Table({
        tableName: "tblautorenewaltracking"
    })
], AutoRenewalTracking);
exports.AutoRenewalTracking = AutoRenewalTracking;
//# sourceMappingURL=AutoRenewalTracking.entity.js.map