import { Model } from 'sequelize-typescript';
import { Address } from './Address.entity';
import { ProfileType } from './ProfileType.entity';
import { SignUpHistory } from '../../user/models/SignUpHistory.entity';
import { ChannelType } from './ChannelType.entity';
import { ChannelDetail } from './ChannelDetail.entity';
import { ChannelSubscription } from './ChannelSubscription.entity';
import { Contact } from '../../user/models/Contact.entity';
import { ChannelCertificate } from './ChannelCertificate.entity';
import { ChannelSocialLink } from './ChannelSocialLink.entity';
import { ChannelB2B } from './ChannelB2B.entity';
import { ChannelAward } from './ChannelAward.entity';
import { User } from '../../user/models/User.entity';
import { ChannelProductCategorie } from '../models/ChannelProductCategorie.entity';
import { ChannelProductGroup } from '../models/ChannelProductGroup.entity';
import { ChannelServiceList } from '../models/ChannelServiceList.entity';
import { ChannelSpeciality } from '../models/ChannelSpeciality.entity';
import { SignUpStatus } from '../../user/models/SignUpStatus.entity';
import { Country } from '../../common/models/Country.entity';
import { ChannelBrand } from '../models/ChannelBrand.entity';
import { ChannelCustomerProfile } from '../models/ChannelCustomerProfile.entity';
import { ChannelLocation } from '../models/ChannelLocation.entity';
import { ProductGroup } from './../../product/models/ProductGroup.entity';
import { ProductCategory } from './../../product/models/ProductCategory.entity';
import { RegionCountryJCT } from './../../common/models/RegionCountryJCT.entity';
import { ServiceList } from './ServiceList.entity';
import { Brand } from '../../product/models/Brand.entity';
import { ChannelJCT } from './ChannelJCT.entity';
import { ShareType } from './ShareType.entity';
import { SubscriptionPlan } from './SubscriptionPlan.entity';
import { Subscription } from './Subscription.entity';
import { PaymentOptionType } from './PaymentOptionType.entity';
import { PaymentTerm } from './PaymentTerm.entity';
import { ReferenceContact } from './../../user/models/ReferenceContact.entity';
import { Claim } from './Claim.entity';
import { ChannelDocument } from './ChannelDocument.entity';
import { EventParticipants } from './EventParticipants.entity';
export declare class Channel extends Model<Channel> {
    static CHANNEL_TYPE_HUB: number;
    static CHANNEL_TYPE_VENDOR: number;
    static CHANNEL_TYPE_DISTRIBUTOR: number;
    static CHANNEL_TYPE_RETAILER: number;
    static CHANNEL_TYPE_SALESREP: number;
    static CHANNEL_TYPE_SIGNUP: number;
    static REDIS_KEY: string;
    static FRONTEND_CHANNEL: number[];
    static BACKEND_CHANNEL: number[];
    channelId: number;
    signUpStatusId: number;
    signUpStatus: SignUpStatus;
    planId: number;
    hubspotCompanyId: number;
    plan: SubscriptionPlan;
    subscriptionId: number;
    subscription: Subscription;
    companyName: string;
    companyMail: string;
    countryId: number;
    country: Country;
    showId: string;
    oldChannelId: number;
    profileTypeId: number;
    profileType: ProfileType;
    channelTypeId: number;
    channelType: ChannelType[];
    channelSubscription: ChannelSubscription;
    regAddressId: number;
    regAddress: Address;
    billAddressId: number;
    billAddress: Address;
    isActive: string;
    deletedAt: Date;
    createdAt: Date;
    updatedAt: Date;
    slug: string;
    isFrenchTech: string;
    isCompanyPublic: string;
    isAdminCreated: string;
    actAsDistributor: string;
    signUpHistory: SignUpHistory;
    channelCertificate: ChannelCertificate[];
    channelSocial: ChannelSocialLink[];
    channelB2B: ChannelB2B[];
    channelAward: ChannelAward[];
    channelDetail: ChannelDetail;
    channelSpeciality: ChannelSpeciality[];
    channelCustomerProfile: ChannelCustomerProfile[];
    channelProductCategorie: ChannelProductCategorie[];
    channelLocation: ChannelLocation[];
    channelServiceList: ChannelServiceList[];
    contact: Contact;
    contacts: Contact[];
    channelBrand: ChannelBrand[];
    channelProductGroup: ChannelProductGroup[];
    channelPaymentOptionType: PaymentOptionType[];
    channelPaymentTerm: PaymentTerm[];
    profileStrength: number;
    user: User;
    productGroup: ProductGroup[];
    productCategory: ProductCategory[];
    customerProfile: ProfileType[];
    serviceList: ServiceList[];
    speciality: ProductGroup[];
    brand: Brand[];
    shareType: ShareType[];
    locations: RegionCountryJCT[];
    channelJCT: ChannelJCT[];
    channelJCTPartner: ChannelJCT[];
    salesrepReference: ReferenceContact[];
    claim: Claim;
    stripeCustomerId: string;
    stripePaymentMethodId: string;
    autoRenewalOff: string;
    channelDocument: ChannelDocument[];
    participants: EventParticipants[];
    get channelLabel(): string;
    static removeRedisKey(instance: any): Promise<void>;
    isOEM: string;
    isPublic: string;
    isFeatured: string;
}
