"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var Channel_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Channel = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Address_entity_1 = require("./Address.entity");
const ProfileType_entity_1 = require("./ProfileType.entity");
const SignUpHistory_entity_1 = require("../../user/models/SignUpHistory.entity");
const ChannelType_entity_1 = require("./ChannelType.entity");
const ChannelDetail_entity_1 = require("./ChannelDetail.entity");
const ChannelSubscription_entity_1 = require("./ChannelSubscription.entity");
const Contact_entity_1 = require("../../user/models/Contact.entity");
const ChannelCertificate_entity_1 = require("./ChannelCertificate.entity");
const ChannelSocialLink_entity_1 = require("./ChannelSocialLink.entity");
const ChannelB2B_entity_1 = require("./ChannelB2B.entity");
const ChannelAward_entity_1 = require("./ChannelAward.entity");
const User_entity_1 = require("../../user/models/User.entity");
const ChannelProductCategorie_entity_1 = require("../models/ChannelProductCategorie.entity");
const ChannelProductGroup_entity_1 = require("../models/ChannelProductGroup.entity");
const ChannelServiceList_entity_1 = require("../models/ChannelServiceList.entity");
const ChannelSpeciality_entity_1 = require("../models/ChannelSpeciality.entity");
const SignUpStatus_entity_1 = require("../../user/models/SignUpStatus.entity");
const Country_entity_1 = require("../../common/models/Country.entity");
const ChannelBrand_entity_1 = require("../models/ChannelBrand.entity");
const ChannelCustomerProfile_entity_1 = require("../models/ChannelCustomerProfile.entity");
const ChannelLocation_entity_1 = require("../models/ChannelLocation.entity");
const ProductGroup_entity_1 = require("./../../product/models/ProductGroup.entity");
const ProductCategory_entity_1 = require("./../../product/models/ProductCategory.entity");
const RegionCountryJCT_entity_1 = require("./../../common/models/RegionCountryJCT.entity");
const ServiceList_entity_1 = require("./ServiceList.entity");
const Brand_entity_1 = require("../../product/models/Brand.entity");
const ChannelPaymentOptionType_entity_1 = require("./ChannelPaymentOptionType.entity");
const ChannelPaymentTerm_entity_1 = require("./ChannelPaymentTerm.entity");
const ChannelJCT_entity_1 = require("./ChannelJCT.entity");
const ShareType_entity_1 = require("./ShareType.entity");
const ChannelSharePreference_entity_1 = require("./ChannelSharePreference.entity");
const SubscriptionPlan_entity_1 = require("./SubscriptionPlan.entity");
const Subscription_entity_1 = require("./Subscription.entity");
const PaymentOptionType_entity_1 = require("./PaymentOptionType.entity");
const PaymentTerm_entity_1 = require("./PaymentTerm.entity");
const ReferenceContact_entity_1 = require("./../../user/models/ReferenceContact.entity");
const Claim_entity_1 = require("./Claim.entity");
const ChannelDocument_entity_1 = require("./ChannelDocument.entity");
const EventParticipants_entity_1 = require("./EventParticipants.entity");
const tableOptions = { tableName: 'tblChannel' };
let Channel = Channel_1 = class Channel extends sequelize_typescript_1.Model {
    get channelLabel() {
        var label = '';
        if (this.channelTypeId == Channel_1.CHANNEL_TYPE_HUB) {
            label = 'Hub';
        }
        else if (this.channelTypeId == Channel_1.CHANNEL_TYPE_VENDOR) {
            label = 'Vendor';
        }
        else if (this.channelTypeId == Channel_1.CHANNEL_TYPE_DISTRIBUTOR) {
            label = 'Distributor';
        }
        else if (this.channelTypeId == Channel_1.CHANNEL_TYPE_RETAILER) {
            label = 'Retailer';
        }
        else if (this.channelTypeId == Channel_1.CHANNEL_TYPE_SALESREP) {
            label = 'Salesrep';
        }
        else if (this.channelTypeId == Channel_1.CHANNEL_TYPE_SIGNUP) {
            label = 'Signup';
        }
        return label;
    }
    static async removeRedisKey(instance) {
        let channelId = +instance.channelId || null;
        if (instance.type == 'BULKUPDATE') {
            channelId = +instance.where.channelId || null;
        }
        if (channelId) {
        }
    }
};
Channel.CHANNEL_TYPE_HUB = 1;
Channel.CHANNEL_TYPE_VENDOR = 2;
Channel.CHANNEL_TYPE_DISTRIBUTOR = 3;
Channel.CHANNEL_TYPE_RETAILER = 4;
Channel.CHANNEL_TYPE_SALESREP = 5;
Channel.CHANNEL_TYPE_SIGNUP = 6;
Channel.REDIS_KEY = 'CHANNEL';
Channel.FRONTEND_CHANNEL = [
    Channel_1.CHANNEL_TYPE_VENDOR,
    Channel_1.CHANNEL_TYPE_DISTRIBUTOR,
    Channel_1.CHANNEL_TYPE_RETAILER,
    Channel_1.CHANNEL_TYPE_SALESREP,
    Channel_1.CHANNEL_TYPE_SIGNUP
];
Channel.BACKEND_CHANNEL = [
    Channel_1.CHANNEL_TYPE_HUB
];
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Channel.prototype, "channelId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => SignUpStatus_entity_1.SignUpStatus),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Channel.prototype, "signUpStatusId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => SignUpStatus_entity_1.SignUpStatus),
    __metadata("design:type", SignUpStatus_entity_1.SignUpStatus)
], Channel.prototype, "signUpStatus", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => SubscriptionPlan_entity_1.SubscriptionPlan),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Channel.prototype, "planId", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Channel.prototype, "hubspotCompanyId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => SubscriptionPlan_entity_1.SubscriptionPlan),
    __metadata("design:type", SubscriptionPlan_entity_1.SubscriptionPlan)
], Channel.prototype, "plan", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Subscription_entity_1.Subscription),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Channel.prototype, "subscriptionId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Subscription_entity_1.Subscription),
    __metadata("design:type", Subscription_entity_1.Subscription)
], Channel.prototype, "subscription", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], Channel.prototype, "companyName", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], Channel.prototype, "companyMail", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Country_entity_1.Country),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Channel.prototype, "countryId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Country_entity_1.Country),
    __metadata("design:type", Country_entity_1.Country)
], Channel.prototype, "country", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], Channel.prototype, "showId", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Channel.prototype, "oldChannelId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => ProfileType_entity_1.ProfileType),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Channel.prototype, "profileTypeId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => ProfileType_entity_1.ProfileType),
    __metadata("design:type", ProfileType_entity_1.ProfileType)
], Channel.prototype, "profileType", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => ChannelType_entity_1.ChannelType),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Channel.prototype, "channelTypeId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => ChannelType_entity_1.ChannelType),
    __metadata("design:type", Array)
], Channel.prototype, "channelType", void 0);
__decorate([
    sequelize_typescript_1.HasOne(() => ChannelSubscription_entity_1.ChannelSubscription),
    __metadata("design:type", ChannelSubscription_entity_1.ChannelSubscription)
], Channel.prototype, "channelSubscription", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Address_entity_1.Address),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Channel.prototype, "regAddressId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Address_entity_1.Address, 'regAddressId'),
    __metadata("design:type", Address_entity_1.Address)
], Channel.prototype, "regAddress", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Address_entity_1.Address),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Channel.prototype, "billAddressId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Address_entity_1.Address, 'billAddressId'),
    __metadata("design:type", Address_entity_1.Address)
], Channel.prototype, "billAddress", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Channel.prototype, "isActive", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Channel.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Channel.prototype, "createdAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Channel.prototype, "updatedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], Channel.prototype, "slug", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Channel.prototype, "isFrenchTech", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Channel.prototype, "isCompanyPublic", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Channel.prototype, "isAdminCreated", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Channel.prototype, "actAsDistributor", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => SignUpHistory_entity_1.SignUpHistory, 'signupId'),
    __metadata("design:type", SignUpHistory_entity_1.SignUpHistory)
], Channel.prototype, "signUpHistory", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ChannelCertificate_entity_1.ChannelCertificate, 'channelId'),
    __metadata("design:type", Array)
], Channel.prototype, "channelCertificate", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ChannelSocialLink_entity_1.ChannelSocialLink, 'channelId'),
    __metadata("design:type", Array)
], Channel.prototype, "channelSocial", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ChannelB2B_entity_1.ChannelB2B, 'channelId'),
    __metadata("design:type", Array)
], Channel.prototype, "channelB2B", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ChannelAward_entity_1.ChannelAward, 'channelId'),
    __metadata("design:type", Array)
], Channel.prototype, "channelAward", void 0);
__decorate([
    sequelize_typescript_1.HasOne(() => ChannelDetail_entity_1.ChannelDetail, 'channelId'),
    __metadata("design:type", ChannelDetail_entity_1.ChannelDetail)
], Channel.prototype, "channelDetail", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ChannelSpeciality_entity_1.ChannelSpeciality, 'channelId'),
    __metadata("design:type", Array)
], Channel.prototype, "channelSpeciality", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ChannelCustomerProfile_entity_1.ChannelCustomerProfile, 'channelId'),
    __metadata("design:type", Array)
], Channel.prototype, "channelCustomerProfile", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ChannelProductCategorie_entity_1.ChannelProductCategorie, 'channelId'),
    __metadata("design:type", Array)
], Channel.prototype, "channelProductCategorie", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ChannelLocation_entity_1.ChannelLocation, 'channelId'),
    __metadata("design:type", Array)
], Channel.prototype, "channelLocation", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ChannelServiceList_entity_1.ChannelServiceList, 'channelId'),
    __metadata("design:type", Array)
], Channel.prototype, "channelServiceList", void 0);
__decorate([
    sequelize_typescript_1.HasOne(() => Contact_entity_1.Contact),
    __metadata("design:type", Contact_entity_1.Contact)
], Channel.prototype, "contact", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => Contact_entity_1.Contact, 'channelId'),
    __metadata("design:type", Array)
], Channel.prototype, "contacts", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ChannelBrand_entity_1.ChannelBrand, 'channelId'),
    __metadata("design:type", Array)
], Channel.prototype, "channelBrand", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ChannelProductGroup_entity_1.ChannelProductGroup, 'channelId'),
    __metadata("design:type", Array)
], Channel.prototype, "channelProductGroup", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => PaymentOptionType_entity_1.PaymentOptionType, {
        through: {
            model: () => ChannelPaymentOptionType_entity_1.ChannelPaymentOptionType,
            scope: {
                deletedat: null
            }
        }
    }),
    __metadata("design:type", Array)
], Channel.prototype, "channelPaymentOptionType", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => PaymentTerm_entity_1.PaymentTerm, {
        through: {
            model: () => ChannelPaymentTerm_entity_1.ChannelPaymentTerm,
            scope: {
                deletedat: null
            }
        }
    }),
    __metadata("design:type", Array)
], Channel.prototype, "channelPaymentTerm", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], Channel.prototype, "profileStrength", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => User_entity_1.User, 'channelId'),
    __metadata("design:type", User_entity_1.User)
], Channel.prototype, "user", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => ProductGroup_entity_1.ProductGroup, {
        through: {
            model: () => ChannelProductGroup_entity_1.ChannelProductGroup,
            scope: {
                deletedAt: null
            }
        }
    }),
    __metadata("design:type", Array)
], Channel.prototype, "productGroup", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => ProductCategory_entity_1.ProductCategory, {
        through: {
            model: () => ChannelProductCategorie_entity_1.ChannelProductCategorie,
            scope: {
                deletedAt: null
            }
        }
    }),
    __metadata("design:type", Array)
], Channel.prototype, "productCategory", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => ProfileType_entity_1.ProfileType, {
        through: {
            model: () => ChannelCustomerProfile_entity_1.ChannelCustomerProfile,
            scope: {
                deletedAt: null
            }
        }
    }),
    __metadata("design:type", Array)
], Channel.prototype, "customerProfile", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => ServiceList_entity_1.ServiceList, {
        through: {
            model: () => ChannelServiceList_entity_1.ChannelServiceList,
            scope: {
                deletedAt: null
            }
        }
    }),
    __metadata("design:type", Array)
], Channel.prototype, "serviceList", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => ProductGroup_entity_1.ProductGroup, {
        through: {
            model: () => ChannelSpeciality_entity_1.ChannelSpeciality,
            scope: {
                deletedAt: null
            }
        }
    }),
    __metadata("design:type", Array)
], Channel.prototype, "speciality", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => Brand_entity_1.Brand, {
        through: {
            model: () => ChannelBrand_entity_1.ChannelBrand,
            scope: {
                deletedAt: null
            }
        }
    }),
    __metadata("design:type", Array)
], Channel.prototype, "brand", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => ShareType_entity_1.ShareType, {
        through: {
            model: () => ChannelSharePreference_entity_1.ChannelSharePreference,
            scope: {
                deletedat: null
            }
        }
    }),
    __metadata("design:type", Array)
], Channel.prototype, "shareType", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => RegionCountryJCT_entity_1.RegionCountryJCT, {
        through: {
            model: () => ChannelLocation_entity_1.ChannelLocation,
            scope: {
                deletedAt: null
            }
        }
    }),
    __metadata("design:type", Array)
], Channel.prototype, "locations", void 0);
__decorate([
    sequelize_typescript_1.HasOne(() => ChannelJCT_entity_1.ChannelJCT, 'partnerChannelId'),
    __metadata("design:type", Array)
], Channel.prototype, "channelJCT", void 0);
__decorate([
    sequelize_typescript_1.HasOne(() => ChannelJCT_entity_1.ChannelJCT, 'channelId'),
    __metadata("design:type", Array)
], Channel.prototype, "channelJCTPartner", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ReferenceContact_entity_1.ReferenceContact, 'channelid'),
    __metadata("design:type", Array)
], Channel.prototype, "salesrepReference", void 0);
__decorate([
    sequelize_typescript_1.HasOne(() => Claim_entity_1.Claim, 'channelId'),
    __metadata("design:type", Claim_entity_1.Claim)
], Channel.prototype, "claim", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], Channel.prototype, "stripeCustomerId", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], Channel.prototype, "stripePaymentMethodId", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Channel.prototype, "autoRenewalOff", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ChannelDocument_entity_1.ChannelDocument, 'channelId'),
    __metadata("design:type", Array)
], Channel.prototype, "channelDocument", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => EventParticipants_entity_1.EventParticipants, 'channelId'),
    __metadata("design:type", Array)
], Channel.prototype, "participants", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], Channel.prototype, "isOEM", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Channel.prototype, "isPublic", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Channel.prototype, "isFeatured", void 0);
__decorate([
    sequelize_typescript_1.AfterUpdate,
    sequelize_typescript_1.AfterBulkUpdate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], Channel, "removeRedisKey", null);
Channel = Channel_1 = __decorate([
    sequelize_typescript_1.Table(tableOptions),
    sequelize_typescript_1.Scopes(() => ({
        basicInfom: {
            attributes: ['companyName', 'showId', 'channelId', 'planId', 'signUpStatusId', 'channelTypeId', 'profileTypeId', 'regAddressId', 'createdAt', 'updatedAt', 'isOEM', 'hubspotCompanyId', 'billAddressId', 'stripeCustomerId']
        },
        basicInfomWithStripeCustomer: {
            attributes: ['channelId', 'signUpStatusId', 'channelTypeId', 'profileTypeId', 'isFrenchTech', 'regAddressId', 'stripeCustomerId']
        },
        subscription: {
            include: [ChannelSubscription_entity_1.ChannelSubscription]
        },
        profileInfom: {
            attributes: ['channelId', 'signUpStatusId', 'channelTypeId', 'companyName', 'companyName', 'companyMail', 'countryId', 'showId', 'profileTypeId', 'regAddressId', 'billAddressId', 'isActive', 'isFrenchTech']
        },
        channelDetail: {
            attributes: ['channelId', 'companyName', 'companyMail', 'signUpStatusId', 'channelTypeId', 'countryId', 'profileTypeId', 'isActive', 'oldChannelId', 'deletedAt', 'isFrenchTech', 'createdAt', 'isOEM']
        },
        orderInfo: {
            attributes: ['channelId', 'companyName', 'companyMail', 'countryId', 'showId', 'profileTypeId', 'channelTypeId', 'isActive', 'oldChannelId', 'profileStrength', 'isFrenchTech']
        }
    }))
], Channel);
exports.Channel = Channel;
//# sourceMappingURL=Channel.entity.js.map