"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChannelDetail = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Channel_entity_1 = require("./Channel.entity");
const Media_entity_1 = require("../../media/models/Media.entity");
const Currency_entity_1 = require("./Currency.entity");
const tableOptions = { timestamp: true, tableName: 'tblChannelDetail' };
let ChannelDetail = class ChannelDetail extends sequelize_typescript_1.Model {
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "channelDetailId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "channelId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel),
    __metadata("design:type", Array)
], ChannelDetail.prototype, "channel", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Media_entity_1.Media),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "channelLogoId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Media_entity_1.Media, 'channelLogoId'),
    __metadata("design:type", Media_entity_1.Media)
], ChannelDetail.prototype, "channelLogo", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Media_entity_1.Media),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "channelIconId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Media_entity_1.Media, 'channelIconId'),
    __metadata("design:type", Media_entity_1.Media)
], ChannelDetail.prototype, "channelIcon", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Media_entity_1.Media),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "channelBannerId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Media_entity_1.Media, 'channelBannerId'),
    __metadata("design:type", Media_entity_1.Media)
], ChannelDetail.prototype, "channelBanner", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], ChannelDetail.prototype, "phone1", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], ChannelDetail.prototype, "phone2", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], ChannelDetail.prototype, "mobileNo", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], ChannelDetail.prototype, "webSiteUrl", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "estYear", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "regYear", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(80000)),
    __metadata("design:type", String)
], ChannelDetail.prototype, "detailDesc", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(2000)),
    __metadata("design:type", String)
], ChannelDetail.prototype, "keyretailers", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(2000)),
    __metadata("design:type", String)
], ChannelDetail.prototype, "keydistributors", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(80000)),
    __metadata("design:type", String)
], ChannelDetail.prototype, "expectations", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(10000)),
    __metadata("design:type", String)
], ChannelDetail.prototype, "companyDesc", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(100)),
    __metadata("design:type", String)
], ChannelDetail.prototype, "empCntRange", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "empCnt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "empCntDSale", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "empCntISale", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "empCntDMar", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "empCntIMar", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(100)),
    __metadata("design:type", String)
], ChannelDetail.prototype, "turnoverRange", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DECIMAL(50, 2)),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "turnover", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "revD", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "revI", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "turnoverPhyStore", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "turnoverOnStore", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ChannelDetail.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ChannelDetail.prototype, "createdAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ChannelDetail.prototype, "updatedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], ChannelDetail.prototype, "stripeConnectId", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], ChannelDetail.prototype, "paymentoptionothers", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Currency_entity_1.Currency),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "currencyid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Currency_entity_1.Currency),
    __metadata("design:type", Array)
], ChannelDetail.prototype, "currency", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], ChannelDetail.prototype, "ownerFirstName", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], ChannelDetail.prototype, "ownerLastName", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], ChannelDetail.prototype, "startup", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.ARRAY({
            type: sequelize_typescript_1.DataType.ENUM('PROTOTYPE', 'S_BACKER', 'S_VOLUME')
        })
    }),
    __metadata("design:type", Array)
], ChannelDetail.prototype, "maturitylevel", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "storeCount", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "no_of_skus", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "no_of_vendors", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "no_of_distributors", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "no_of_retailers", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Media_entity_1.Media),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "introvideoId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Media_entity_1.Media, 'introvideoId'),
    __metadata("design:type", Media_entity_1.Media)
], ChannelDetail.prototype, "introvideo", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.STRING),
    __metadata("design:type", String)
], ChannelDetail.prototype, "isPhysicalSales", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "physicalSales", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(2000)),
    __metadata("design:type", String)
], ChannelDetail.prototype, "keyresellers", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelDetail.prototype, "no_of_resellers", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BOOLEAN),
    __metadata("design:type", Boolean)
], ChannelDetail.prototype, "shareStatus", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.STRING),
    __metadata("design:type", String)
], ChannelDetail.prototype, "bannerURL", void 0);
ChannelDetail = __decorate([
    sequelize_typescript_1.Table(tableOptions),
    sequelize_typescript_1.Scopes(() => ({
        basicInfom: {
            attributes: ['channelDetailId', 'channelLogoId', 'channelIconId', 'estYear', 'regYear', 'detailDesc', 'webSiteUrl', 'expectations', 'storeCount', 'no_of_retailers', 'no_of_skus', 'no_of_distributors', 'no_of_vendors']
        },
        channelDetail: {
            attributes: ['channelLogoId', 'channelIconId', 'webSiteUrl', 'estYear', 'regYear', 'detailDesc', 'expectations', 'empCntRange', 'empCnt', 'empCntDSale', 'empCntISale', 'empCntDMar', 'empCntIMar', 'turnoverRange', 'turnover', 'revD', 'revI', 'deletedAt', 'updatedAt', 'turnoverPhyStore', 'turnoverOnStore', 'startup', 'storeCount', 'maturitylevel', 'no_of_retailers', 'no_of_skus', 'no_of_distributors', 'no_of_vendors', 'introvideoId']
        },
        tradeinfo: {
            attributes: {
                exclude: ['deletedAt', 'createdAt', 'updatedAt']
            }
        },
        orderInfo: {
            attributes: ['channelLogoId']
        },
        settings: {
            attributes: ['shareStatus']
        }
    }))
], ChannelDetail);
exports.ChannelDetail = ChannelDetail;
//# sourceMappingURL=ChannelDetail.entity.js.map