"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChannelLocation = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Channel_entity_1 = require("./Channel.entity");
const RegionCountryJCT_entity_1 = require("../../common/models/RegionCountryJCT.entity");
const User_entity_1 = require("./../../user/models/User.entity");
var Sequelize = require('sequelize');
const tableOptions = { tableName: 'tblChannelLocation' };
let ChannelLocation = class ChannelLocation extends sequelize_typescript_1.Model {
    static async dateUpdate(channelLocation, options) {
        channelLocation.updatedAt = Sequelize.fn('NOW');
    }
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelLocation.prototype, "channelLocationId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelLocation.prototype, "channelId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel),
    __metadata("design:type", Array)
], ChannelLocation.prototype, "Channel", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], ChannelLocation.prototype, "locationType", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => RegionCountryJCT_entity_1.RegionCountryJCT),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelLocation.prototype, "regionCountryJCTId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => RegionCountryJCT_entity_1.RegionCountryJCT),
    __metadata("design:type", Array)
], ChannelLocation.prototype, "RegionCountryJCT", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ChannelLocation.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ChannelLocation.prototype, "createdAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ChannelLocation.prototype, "updatedAt", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => User_entity_1.User),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelLocation.prototype, "updatedBy", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => User_entity_1.User),
    __metadata("design:type", User_entity_1.User)
], ChannelLocation.prototype, "User", void 0);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    sequelize_typescript_1.BeforeUpdate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [ChannelLocation, Object]),
    __metadata("design:returntype", Promise)
], ChannelLocation, "dateUpdate", null);
ChannelLocation = __decorate([
    sequelize_typescript_1.Table(tableOptions),
    sequelize_typescript_1.Scopes(() => ({
        regionCountryJCT: {
            attributes: ['regionCountryJCTId', 'locationType']
        },
        channelDetail: {
            attributes: ['channelLocationId', 'locationType', 'regionCountryJCTId', 'deletedAt']
        }
    }))
], ChannelLocation);
exports.ChannelLocation = ChannelLocation;
//# sourceMappingURL=ChannelLocation.entity.js.map