"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var ChannelRecommended_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChannelRecommended = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Channel_entity_1 = require("./Channel.entity");
const Country_entity_1 = require("../../common/models/Country.entity");
const Address_entity_1 = require("./Address.entity");
const User_entity_1 = require("../../user/models/User.entity");
const ChannelType_entity_1 = require("./ChannelType.entity");
const tableOptions = { timestamp: true, tableName: 'tblchannelrecommended' };
let ChannelRecommended = ChannelRecommended_1 = class ChannelRecommended extends sequelize_typescript_1.Model {
};
ChannelRecommended.CHANNEL_TAG_NEW = 'New';
ChannelRecommended.CHANNEL_TAG_ACTIVE = 'Active';
ChannelRecommended.CHANNEL_TAG_EXISTING = 'Existing';
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelRecommended.prototype, "channelrecommendid", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelRecommended.prototype, "existchannelid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel, 'existchannelid'),
    __metadata("design:type", Channel_entity_1.Channel)
], ChannelRecommended.prototype, "existchannel", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelRecommended.prototype, "oldchannelid", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: new sequelize_typescript_1.DataType.VIRTUAL(sequelize_typescript_1.DataType.CHAR(255), ['existchannelid', 'oldchannelid']),
        get: function () {
            if (this.get('existchannelid')) {
                return ChannelRecommended_1.CHANNEL_TAG_ACTIVE;
            }
            else if (this.get('oldchannelid')) {
                return ChannelRecommended_1.CHANNEL_TAG_EXISTING;
            }
            else {
                return ChannelRecommended_1.CHANNEL_TAG_NEW;
            }
        }
    }),
    __metadata("design:type", String)
], ChannelRecommended.prototype, "tag", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], ChannelRecommended.prototype, "companyname", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], ChannelRecommended.prototype, "contactname", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Country_entity_1.Country),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelRecommended.prototype, "countryid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Country_entity_1.Country, 'countryid'),
    __metadata("design:type", Country_entity_1.Country)
], ChannelRecommended.prototype, "country", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], ChannelRecommended.prototype, "city", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], ChannelRecommended.prototype, "mail", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], ChannelRecommended.prototype, "mobileno", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Address_entity_1.Address),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelRecommended.prototype, "addressid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Address_entity_1.Address, 'addressid'),
    __metadata("design:type", Address_entity_1.Address)
], ChannelRecommended.prototype, "address", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], ChannelRecommended.prototype, "websiteurl", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelRecommended.prototype, "updatedby", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ChannelRecommended.prototype, "createdat", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ChannelRecommended.prototype, "updatedat", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ChannelRecommended.prototype, "deletedat", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelRecommended.prototype, "suggestedto", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel, 'suggestedto'),
    __metadata("design:type", Channel_entity_1.Channel)
], ChannelRecommended.prototype, "suggestedtochannel", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => ChannelType_entity_1.ChannelType),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelRecommended.prototype, "suggestedto_type", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => User_entity_1.User),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelRecommended.prototype, "suggestedby", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelRecommended.prototype, "suggestedby_channelid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel, 'suggestedby_channelid'),
    __metadata("design:type", Channel_entity_1.Channel)
], ChannelRecommended.prototype, "suggestedbychannel", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => ChannelType_entity_1.ChannelType),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelRecommended.prototype, "suggestedby_type", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => ChannelType_entity_1.ChannelType),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelRecommended.prototype, "suggested_type", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelRecommended.prototype, "active_id", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel, 'active_id'),
    __metadata("design:type", Channel_entity_1.Channel)
], ChannelRecommended.prototype, "active_channel", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ChannelRecommended.prototype, "last_remainder_sent_at", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelRecommended.prototype, "no_of_remainders_sent", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], ChannelRecommended.prototype, "partner_request", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => ChannelRecommended_1),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelRecommended.prototype, "child_invitation", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], ChannelRecommended.prototype, "occasion", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], ChannelRecommended.prototype, "note", void 0);
ChannelRecommended = ChannelRecommended_1 = __decorate([
    sequelize_typescript_1.Table(tableOptions)
], ChannelRecommended);
exports.ChannelRecommended = ChannelRecommended;
//# sourceMappingURL=ChannelRecommended.entity.js.map