import { Model } from 'sequelize-typescript';
import { Channel } from './Channel.entity';
import { PaymentTransaction } from './PaymentTransaction.entity';
import { Subscription } from './Subscription.entity';
import { SubscriptionType } from './SubscriptionType.entity';
import { Contact } from '../../user/models/Contact.entity';
import { Coupon } from './Coupon.entity';
import { ChannelSuggestion } from './ChannelSuggestion.entity';
import { AutoRenewalTracking } from './AutoRenewalTracking.entity';
export declare class ChannelSubscription extends Model<ChannelSubscription> {
    channelSubscriptionId: number;
    channelId: number;
    channel: Channel;
    contact: Contact[];
    subscriptionId: number;
    subscription: Subscription;
    subscriptionTypeId: number;
    subscriptionType: SubscriptionType;
    actualAmount: number;
    taxAmount: number;
    taxNumber: string;
    carryForwardAmount: number;
    couponId: number;
    coupon: Coupon;
    couponAmount: number;
    totalDiscountedAmount: number;
    finalAmount: number;
    paymentTransactionId: number;
    paymentTransaction: PaymentTransaction;
    startedAt: any;
    additionalDays: number;
    endAt: any;
    isActive: string;
    isPaid: string;
    changedAt: number;
    oldChannelSubscriptionId: number;
    oldChannelSubscription: ChannelSubscription;
    suggestions: ChannelSuggestion[];
    autoRenewalTracking: AutoRenewalTracking;
    updatedBy: number;
    keyFeature: string;
    static deactiveOldRecords(instance: ChannelSubscription): Promise<void>;
}
