"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var ChannelSubscription_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChannelSubscription = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Channel_entity_1 = require("./Channel.entity");
const PaymentTransaction_entity_1 = require("./PaymentTransaction.entity");
const Subscription_entity_1 = require("./Subscription.entity");
const SubscriptionType_entity_1 = require("./SubscriptionType.entity");
const Contact_entity_1 = require("../../user/models/Contact.entity");
const Coupon_entity_1 = require("./Coupon.entity");
const ChannelSuggestion_entity_1 = require("./ChannelSuggestion.entity");
const AutoRenewalTracking_entity_1 = require("./AutoRenewalTracking.entity");
const tableOptions = { timestamps: false, tableName: 'tblChannelSubscription' };
let ChannelSubscription = ChannelSubscription_1 = class ChannelSubscription extends sequelize_typescript_1.Model {
    static async deactiveOldRecords(instance) {
        if (instance.oldChannelSubscriptionId && instance.isPaid == '1') {
            let oldChannelSubscription = await ChannelSubscription_1.findByPk(instance.oldChannelSubscriptionId);
            if (oldChannelSubscription) {
                oldChannelSubscription.isActive = '0';
                await oldChannelSubscription.save();
            }
        }
    }
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelSubscription.prototype, "channelSubscriptionId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelSubscription.prototype, "channelId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel),
    __metadata("design:type", Channel_entity_1.Channel)
], ChannelSubscription.prototype, "channel", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => Contact_entity_1.Contact, 'channelId'),
    __metadata("design:type", Array)
], ChannelSubscription.prototype, "contact", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Subscription_entity_1.Subscription),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelSubscription.prototype, "subscriptionId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Subscription_entity_1.Subscription),
    __metadata("design:type", Subscription_entity_1.Subscription)
], ChannelSubscription.prototype, "subscription", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => SubscriptionType_entity_1.SubscriptionType),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelSubscription.prototype, "subscriptionTypeId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => SubscriptionType_entity_1.SubscriptionType),
    __metadata("design:type", SubscriptionType_entity_1.SubscriptionType)
], ChannelSubscription.prototype, "subscriptionType", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DECIMAL(15, 2)),
    __metadata("design:type", Number)
], ChannelSubscription.prototype, "actualAmount", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DECIMAL(15, 2)),
    __metadata("design:type", Number)
], ChannelSubscription.prototype, "taxAmount", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(100)),
    __metadata("design:type", String)
], ChannelSubscription.prototype, "taxNumber", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DECIMAL(15, 2)),
    __metadata("design:type", Number)
], ChannelSubscription.prototype, "carryForwardAmount", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Coupon_entity_1.Coupon),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelSubscription.prototype, "couponId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Coupon_entity_1.Coupon),
    __metadata("design:type", Coupon_entity_1.Coupon)
], ChannelSubscription.prototype, "coupon", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DECIMAL(15, 2)),
    __metadata("design:type", Number)
], ChannelSubscription.prototype, "couponAmount", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DECIMAL(15, 2)),
    __metadata("design:type", Number)
], ChannelSubscription.prototype, "totalDiscountedAmount", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DECIMAL(15, 2)),
    __metadata("design:type", Number)
], ChannelSubscription.prototype, "finalAmount", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => PaymentTransaction_entity_1.PaymentTransaction),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelSubscription.prototype, "paymentTransactionId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => PaymentTransaction_entity_1.PaymentTransaction),
    __metadata("design:type", PaymentTransaction_entity_1.PaymentTransaction)
], ChannelSubscription.prototype, "paymentTransaction", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.TIME),
    __metadata("design:type", Object)
], ChannelSubscription.prototype, "startedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelSubscription.prototype, "additionalDays", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.TIME),
    __metadata("design:type", Object)
], ChannelSubscription.prototype, "endAt", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], ChannelSubscription.prototype, "isActive", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], ChannelSubscription.prototype, "isPaid", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.TIME),
    __metadata("design:type", Number)
], ChannelSubscription.prototype, "changedAt", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => ChannelSubscription_1),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ChannelSubscription.prototype, "oldChannelSubscriptionId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => ChannelSubscription_1),
    __metadata("design:type", ChannelSubscription)
], ChannelSubscription.prototype, "oldChannelSubscription", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ChannelSuggestion_entity_1.ChannelSuggestion),
    __metadata("design:type", Array)
], ChannelSubscription.prototype, "suggestions", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => AutoRenewalTracking_entity_1.AutoRenewalTracking),
    __metadata("design:type", AutoRenewalTracking_entity_1.AutoRenewalTracking)
], ChannelSubscription.prototype, "autoRenewalTracking", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ChannelSubscription.prototype, "updatedBy", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.JSON),
    __metadata("design:type", String)
], ChannelSubscription.prototype, "keyFeature", void 0);
__decorate([
    sequelize_typescript_1.AfterCreate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [ChannelSubscription]),
    __metadata("design:returntype", Promise)
], ChannelSubscription, "deactiveOldRecords", null);
ChannelSubscription = ChannelSubscription_1 = __decorate([
    sequelize_typescript_1.Table({
        tableName: "tblChannelSubscription",
        timestamps: false
    }),
    sequelize_typescript_1.Scopes(() => ({
        channelDetail: {
            attributes: ['subscriptionId', 'actualAmount', 'finalAmount', 'paymentTransactionId', 'startedAt', 'startedAt', 'endAt', 'isActive']
        }
    }))
], ChannelSubscription);
exports.ChannelSubscription = ChannelSubscription;
//# sourceMappingURL=ChannelSubscription.entity.js.map