"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Claim = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Channel_entity_1 = require("./Channel.entity");
const ClaimDocument_entity_1 = require("./ClaimDocument.entity");
const SignUpStatus_entity_1 = require("../../user/models/SignUpStatus.entity");
const tableOptions = { tableName: 'tblClaim' };
let Claim = class Claim extends sequelize_typescript_1.Model {
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Claim.prototype, "claimId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Claim.prototype, "channelId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel, 'channelId'),
    __metadata("design:type", Channel_entity_1.Channel)
], Claim.prototype, "channel", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Claim.prototype, "claimChannelId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel, 'claimChannelId'),
    __metadata("design:type", Channel_entity_1.Channel)
], Claim.prototype, "claimChannel", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ClaimDocument_entity_1.ClaimDocument, 'claimId'),
    __metadata("design:type", Array)
], Claim.prototype, "claimDocument", void 0);
__decorate([
    sequelize_typescript_1.Length({ max: 8000 }),
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Claim.prototype, "claimDesc", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => SignUpStatus_entity_1.SignUpStatus),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Claim.prototype, "claimStatusId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => SignUpStatus_entity_1.SignUpStatus),
    __metadata("design:type", SignUpStatus_entity_1.SignUpStatus)
], Claim.prototype, "claimStatus", void 0);
__decorate([
    sequelize_typescript_1.Length({ max: 1000 }),
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Claim.prototype, "dismissReason", void 0);
Claim = __decorate([
    sequelize_typescript_1.Table(tableOptions)
], Claim);
exports.Claim = Claim;
//# sourceMappingURL=Claim.entity.js.map