"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var Coupon_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Coupon = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Sequelize = require('sequelize');
const ChannelType_entity_1 = require("./ChannelType.entity");
const SubscriptionPlan_entity_1 = require("./SubscriptionPlan.entity");
const SubscriptionType_entity_1 = require("../models/SubscriptionType.entity");
const SubscriptionPeriod_entity_1 = require("./SubscriptionPeriod.entity");
const tableOptions = { timestamp: true, tableName: 'tblChannelSubscription' };
let Coupon = Coupon_1 = class Coupon extends sequelize_typescript_1.Model {
    async getDiscountedAmount(amount) {
        return amount - await this.getOfferAmount(amount);
    }
    async getOfferAmount(amount) {
        if (this.discountUnit == Coupon_1.DISCOUNT_UNIT_AMT) {
            return this.couponOfferValue;
        }
        else if (this.discountUnit == Coupon_1.DISCOUNT_UNIT_PER) {
            return amount * (this.couponOfferValue / 100);
        }
    }
    static async dateUpdate(coupon, options) {
        coupon.updatedAt = Sequelize.fn('NOW');
    }
};
Coupon.DISCOUNT_UNIT_AMT = 1;
Coupon.DISCOUNT_UNIT_PER = 2;
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Coupon.prototype, "couponId", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], Coupon.prototype, "couponDesc", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(100)),
    __metadata("design:type", String)
], Coupon.prototype, "couponCode", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], Coupon.prototype, "couponOfferValue", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", Number)
], Coupon.prototype, "isActive", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.TIME),
    __metadata("design:type", Object)
], Coupon.prototype, "fromDate", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.TIME),
    __metadata("design:type", Object)
], Coupon.prototype, "toDate", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.ForeignKey(() => SubscriptionType_entity_1.SubscriptionType),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Coupon.prototype, "subscriptionTypeId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => SubscriptionType_entity_1.SubscriptionType),
    __metadata("design:type", SubscriptionType_entity_1.SubscriptionType)
], Coupon.prototype, "subscriptionType", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => ChannelType_entity_1.ChannelType),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Coupon.prototype, "channelTypeId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => ChannelType_entity_1.ChannelType),
    __metadata("design:type", ChannelType_entity_1.ChannelType)
], Coupon.prototype, "channelType", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => SubscriptionPlan_entity_1.SubscriptionPlan),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Coupon.prototype, "subscriptionPlanId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => SubscriptionPlan_entity_1.SubscriptionPlan),
    __metadata("design:type", SubscriptionPlan_entity_1.SubscriptionPlan)
], Coupon.prototype, "subscriptionPlan", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => SubscriptionPeriod_entity_1.SubscriptionPeriod),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Coupon.prototype, "subscriptionPeriodId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => SubscriptionPeriod_entity_1.SubscriptionPeriod),
    __metadata("design:type", SubscriptionPeriod_entity_1.SubscriptionPeriod)
], Coupon.prototype, "subscriptionPeriod", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], Coupon.prototype, "discountUnit", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], Coupon.prototype, "userThreshold", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], Coupon.prototype, "usageThreshold", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Coupon.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Coupon.prototype, "updatedAt", void 0);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    sequelize_typescript_1.BeforeUpdate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Coupon, Object]),
    __metadata("design:returntype", Promise)
], Coupon, "dateUpdate", null);
Coupon = Coupon_1 = __decorate([
    sequelize_typescript_1.Table({
        tableName: "tblCoupon"
    }),
    sequelize_typescript_1.Scopes(() => ({
        channelDetail: {
            attributes: ['couponDesc', 'couponCode', 'couponOfferValue', 'discountUnit']
        },
        couponCheck: {
            attributes: ['couponId', 'couponDesc', 'couponOfferValue', 'discountUnit']
        }
    }))
], Coupon);
exports.Coupon = Coupon;
//# sourceMappingURL=Coupon.entity.js.map