"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventBo = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Country_entity_1 = require("../../common/models/Country.entity");
const models_1 = require("../../media/models");
const EventChannel_entity_1 = require("./EventChannel.entity");
const EventPackage_entity_1 = require("./EventPackage.entity");
const EventParticipants_entity_1 = require("./EventParticipants.entity");
const tableOptions = { timestamp: true, tableName: 'tblevents' };
let EventBo = class EventBo extends sequelize_typescript_1.Model {
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], EventBo.prototype, "id", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], EventBo.prototype, "name", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], EventBo.prototype, "description", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], EventBo.prototype, "createdAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], EventBo.prototype, "updatedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], EventBo.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], EventBo.prototype, "type", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], EventBo.prototype, "fromDate", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], EventBo.prototype, "toDate", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.TIME),
    __metadata("design:type", Date)
], EventBo.prototype, "fromTime", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.TIME),
    __metadata("design:type", Date)
], EventBo.prototype, "toTime", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], EventBo.prototype, "timezone", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(500)),
    __metadata("design:type", String)
], EventBo.prototype, "address", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], EventBo.prototype, "city", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Country_entity_1.Country),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], EventBo.prototype, "countryId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Country_entity_1.Country),
    __metadata("design:type", Country_entity_1.Country)
], EventBo.prototype, "country", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(10)),
    __metadata("design:type", String)
], EventBo.prototype, "zipcode", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], EventBo.prototype, "eventLogoId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => models_1.Media, { as: 'logo', foreignKey: 'eventLogoId' }),
    __metadata("design:type", models_1.Media)
], EventBo.prototype, "logo", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], EventBo.prototype, "eventBannerId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => models_1.Media, { as: 'banner', foreignKey: 'eventBannerId' }),
    __metadata("design:type", models_1.Media)
], EventBo.prototype, "banner", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => EventPackage_entity_1.EventPackage, 'eventId'),
    __metadata("design:type", Array)
], EventBo.prototype, "packages", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => EventParticipants_entity_1.EventParticipants, 'eventId'),
    __metadata("design:type", Array)
], EventBo.prototype, "participants", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => EventChannel_entity_1.EventChannel, 'eventId'),
    __metadata("design:type", Array)
], EventBo.prototype, "channels", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(500)),
    __metadata("design:type", String)
], EventBo.prototype, "eventCatalystId", void 0);
EventBo = __decorate([
    sequelize_typescript_1.Table(tableOptions)
], EventBo);
exports.EventBo = EventBo;
//# sourceMappingURL=EventBo.entity.js.map