"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventChannel = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Contact_entity_1 = require("../../user/models/Contact.entity");
const Channel_entity_1 = require("./Channel.entity");
const EventBo_entity_1 = require("./EventBo.entity");
const EventPackage_entity_1 = require("./EventPackage.entity");
const EventParticipants_entity_1 = require("./EventParticipants.entity");
const tableOptions = { timestamp: true, tableName: 'tblEventChannel' };
let EventChannel = class EventChannel extends sequelize_typescript_1.Model {
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], EventChannel.prototype, "id", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], EventChannel.prototype, "channelId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel, { foreignKey: 'channelId' }),
    __metadata("design:type", Array)
], EventChannel.prototype, "channel", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => EventBo_entity_1.EventBo),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], EventChannel.prototype, "eventId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => EventPackage_entity_1.EventPackage),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], EventChannel.prototype, "packageId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => EventPackage_entity_1.EventPackage, { foreignKey: 'packageId' }),
    __metadata("design:type", EventPackage_entity_1.EventPackage)
], EventChannel.prototype, "package", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => EventBo_entity_1.EventBo, { foreignKey: 'eventId' }),
    __metadata("design:type", EventBo_entity_1.EventBo)
], EventChannel.prototype, "event", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], EventChannel.prototype, "isNew", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], EventChannel.prototype, "createdAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], EventChannel.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], EventChannel.prototype, "updatedAt", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => EventParticipants_entity_1.EventParticipants, { foreignKey: 'eventId' }),
    __metadata("design:type", Array)
], EventChannel.prototype, "participants", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], EventChannel.prototype, "additionalMembers", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], EventChannel.prototype, "paymenttransactionId", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], EventChannel.prototype, "paymentstatus", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], EventChannel.prototype, "paymentMethod", void 0);
EventChannel = __decorate([
    sequelize_typescript_1.Table(tableOptions)
], EventChannel);
exports.EventChannel = EventChannel;
//# sourceMappingURL=EventChannel.entity.js.map