"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventParticipants = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Contact_entity_1 = require("../../user/models/Contact.entity");
const Channel_entity_1 = require("./Channel.entity");
const EventBo_entity_1 = require("./EventBo.entity");
const EventPackage_entity_1 = require("./EventPackage.entity");
const tableOptions = { timestamp: true, tableName: 'tblEventParticipants' };
let EventParticipants = class EventParticipants extends sequelize_typescript_1.Model {
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], EventParticipants.prototype, "eventParticipantId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Contact_entity_1.Contact),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], EventParticipants.prototype, "contactId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Contact_entity_1.Contact, { foreignKey: 'contactId' }),
    __metadata("design:type", Array)
], EventParticipants.prototype, "contacts", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], EventParticipants.prototype, "channelId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel, { foreignKey: 'channelId' }),
    __metadata("design:type", Array)
], EventParticipants.prototype, "channels", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => EventBo_entity_1.EventBo),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], EventParticipants.prototype, "eventId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => EventPackage_entity_1.EventPackage),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], EventParticipants.prototype, "packageId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => EventPackage_entity_1.EventPackage, { foreignKey: 'packageId' }),
    __metadata("design:type", Array)
], EventParticipants.prototype, "package", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], EventParticipants.prototype, "createdAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], EventParticipants.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.NUMBER),
    __metadata("design:type", Number)
], EventParticipants.prototype, "participantType", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.NUMBER),
    __metadata("design:type", Number)
], EventParticipants.prototype, "channelType", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], EventParticipants.prototype, "users", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], EventParticipants.prototype, "status", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => Channel_entity_1.Channel, { foreignKey: 'channelId' }),
    __metadata("design:type", Array)
], EventParticipants.prototype, "participants", void 0);
EventParticipants = __decorate([
    sequelize_typescript_1.Table(tableOptions)
], EventParticipants);
exports.EventParticipants = EventParticipants;
//# sourceMappingURL=EventParticipants.entity.js.map