"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FailureTransaction = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const sequelize_typescript_2 = require("sequelize-typescript");
const PaymentTransaction_entity_1 = require("./PaymentTransaction.entity");
const Channel_entity_1 = require("./Channel.entity");
let FailureTransaction = class FailureTransaction extends sequelize_typescript_1.Model {
};
FailureTransaction.PAYMENT_TYPE_SUBSCRIPTION = 1;
FailureTransaction.PAYMENT_TYPE_TRADESHOW = 2;
FailureTransaction.PAYMENT_TYPE_SAMPLES = 3;
FailureTransaction.PAYMENT_TYPE_SALESREPPAY = 4;
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.INTEGER,
        allowNull: false,
        autoIncrement: true,
        unique: true,
        primaryKey: true,
    }),
    __metadata("design:type", Number)
], FailureTransaction.prototype, "failureTransactionId", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.INTEGER,
        allowNull: false,
        autoIncrement: false,
        unique: false,
        primaryKey: false
    }),
    __metadata("design:type", Number)
], FailureTransaction.prototype, "paymentMethodId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => PaymentTransaction_entity_1.PaymentTransaction),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], FailureTransaction.prototype, "paymentTransactionId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], FailureTransaction.prototype, "channelId", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(true),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], FailureTransaction.prototype, "response", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.DATE,
        allowNull: false,
        autoIncrement: false,
        unique: false,
        primaryKey: false,
        defaultValue: sequelize_typescript_2.Sequelize.literal('CURRENT_TIMESTAMP')
    }),
    __metadata("design:type", String)
], FailureTransaction.prototype, "createdAt", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => PaymentTransaction_entity_1.PaymentTransaction),
    __metadata("design:type", Array)
], FailureTransaction.prototype, "paymentTransaction", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel),
    __metadata("design:type", Array)
], FailureTransaction.prototype, "channel", void 0);
FailureTransaction = __decorate([
    sequelize_typescript_1.Table({
        timestamps: false,
        tableName: "tblFailureTransaction"
    })
], FailureTransaction);
exports.FailureTransaction = FailureTransaction;
//# sourceMappingURL=FailureTransaction.entity.js.map