"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OldChannel = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const OldAddress_entity_1 = require("./OldAddress.entity");
const Channel_entity_1 = require("./Channel.entity");
const OldContact_entity_1 = require("./OldContact.entity");
const OldChannelDetail_entity_1 = require("./OldChannelDetail.entity");
const Country_entity_1 = require("../../common/models/Country.entity");
const OldChannelCustomerProfile_entity_1 = require("./OldChannelCustomerProfile.entity");
const ProfileType_entity_1 = require("./ProfileType.entity");
const OldChannelSpeciality_entity_1 = require("./OldChannelSpeciality.entity");
const ProductGroup_entity_1 = require("../../product/models/ProductGroup.entity");
const tableOptions = { tableName: 'tblOldChannel' };
let OldChannel = class OldChannel extends sequelize_typescript_1.Model {
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], OldChannel.prototype, "oldChannelId", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], OldChannel.prototype, "companyName", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], OldChannel.prototype, "companyMail", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.ForeignKey(() => Country_entity_1.Country),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", String)
], OldChannel.prototype, "countryId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Country_entity_1.Country),
    __metadata("design:type", Country_entity_1.Country)
], OldChannel.prototype, "country", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], OldChannel.prototype, "channelTypeId", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], OldChannel.prototype, "regAddressId", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], OldChannel.prototype, "billAddressId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => OldAddress_entity_1.OldAddress, {
        as: 'regAddress',
        foreignKey: 'regAddressId',
        targetKey: 'oldAddressId'
    }),
    __metadata("design:type", Array)
], OldChannel.prototype, "regAddress", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => OldAddress_entity_1.OldAddress, {
        as: 'billAddress',
        foreignKey: 'billAddressId',
        targetKey: 'oldAddressId'
    }),
    __metadata("design:type", Array)
], OldChannel.prototype, "billAddress", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => Channel_entity_1.Channel, 'oldChannelId'),
    __metadata("design:type", Channel_entity_1.Channel)
], OldChannel.prototype, "channel", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => OldContact_entity_1.OldContact, 'oldChannelId'),
    __metadata("design:type", Array)
], OldChannel.prototype, "oldContacts", void 0);
__decorate([
    sequelize_typescript_1.HasOne(() => OldChannelDetail_entity_1.OldChannelDetail, 'oldChannelId'),
    __metadata("design:type", OldChannelDetail_entity_1.OldChannelDetail)
], OldChannel.prototype, "oldChannelDetail", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], OldChannel.prototype, "isActive", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], OldChannel.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], OldChannel.prototype, "profileTypeId", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => OldChannelCustomerProfile_entity_1.OldChannelCustomerProfile, 'oldChannelId'),
    __metadata("design:type", Array)
], OldChannel.prototype, "channelCustomerProfile", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => ProfileType_entity_1.ProfileType, {
        through: {
            model: () => OldChannelCustomerProfile_entity_1.OldChannelCustomerProfile,
            scope: {
                deletedAt: null
            }
        }
    }),
    __metadata("design:type", Array)
], OldChannel.prototype, "customerProfile", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => OldChannelSpeciality_entity_1.OldChannelSpeciality, 'oldChannelId'),
    __metadata("design:type", Array)
], OldChannel.prototype, "channelSpeciality", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => ProductGroup_entity_1.ProductGroup, {
        through: {
            model: () => OldChannelSpeciality_entity_1.OldChannelSpeciality,
            scope: {
                deletedAt: null
            }
        }
    }),
    __metadata("design:type", Array)
], OldChannel.prototype, "speciality", void 0);
OldChannel = __decorate([
    sequelize_typescript_1.Table(tableOptions),
    sequelize_typescript_1.Scopes(() => ({
        basicInform: {
            attributes: ['companyName', 'oldChannelId']
        }
    }))
], OldChannel);
exports.OldChannel = OldChannel;
//# sourceMappingURL=OldChannel.entity.js.map