"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OldChannelCustomerProfile = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const OldChannel_entity_1 = require("./OldChannel.entity");
const ProfileType_entity_1 = require("./ProfileType.entity");
const ProfileTypeClassification_entity_1 = require("./ProfileTypeClassification.entity");
var Sequelize = require('sequelize');
const tableOptions = { timestamp: true, tableName: 'tblOldChannelCustomerProfile' };
let OldChannelCustomerProfile = class OldChannelCustomerProfile extends sequelize_typescript_1.Model {
    static async dateUpdate(oldChannelCustomerProfile, options) {
        oldChannelCustomerProfile.updatedAt = Sequelize.fn('NOW');
    }
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], OldChannelCustomerProfile.prototype, "oldCustomerProfileId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => OldChannel_entity_1.OldChannel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], OldChannelCustomerProfile.prototype, "oldChannelId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => OldChannel_entity_1.OldChannel),
    __metadata("design:type", Array)
], OldChannelCustomerProfile.prototype, "channel", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => ProfileType_entity_1.ProfileType),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], OldChannelCustomerProfile.prototype, "profileTypeId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => ProfileType_entity_1.ProfileType),
    __metadata("design:type", ProfileType_entity_1.ProfileType)
], OldChannelCustomerProfile.prototype, "profileType", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => ProfileTypeClassification_entity_1.ProfileTypeClassification),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], OldChannelCustomerProfile.prototype, "profileTypeClassificationId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => ProfileTypeClassification_entity_1.ProfileTypeClassification),
    __metadata("design:type", ProfileTypeClassification_entity_1.ProfileTypeClassification)
], OldChannelCustomerProfile.prototype, "pTClas", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], OldChannelCustomerProfile.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], OldChannelCustomerProfile.prototype, "createdAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], OldChannelCustomerProfile.prototype, "updatedAt", void 0);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    sequelize_typescript_1.BeforeUpdate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [OldChannelCustomerProfile, Object]),
    __metadata("design:returntype", Promise)
], OldChannelCustomerProfile, "dateUpdate", null);
OldChannelCustomerProfile = __decorate([
    sequelize_typescript_1.Table(tableOptions),
    sequelize_typescript_1.Scopes(() => ({
        channelDetail: {
            attributes: ['oldCustomerProfileId', 'profileTypeId', 'profileTypeClassificationId', 'deletedAt']
        },
        tradeinfo: {
            attributes: {
                exclude: ['deletedAt', 'createdAt', 'updatedAt']
            }
        }
    }))
], OldChannelCustomerProfile);
exports.OldChannelCustomerProfile = OldChannelCustomerProfile;
//# sourceMappingURL=OldChannelCustomerProfile.entity.js.map