"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OldContact = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Country_entity_1 = require("../../common/models/Country.entity");
const Media_entity_1 = require("../../media/models/Media.entity");
const Responsibility_entity_1 = require("../../user/models/Responsibility.entity");
const OldChannel_entity_1 = require("./OldChannel.entity");
const tableOptions = { timestamp: true, tableName: 'tblOldContact' };
let OldContact = class OldContact extends sequelize_typescript_1.Model {
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], OldContact.prototype, "oldContactId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => OldChannel_entity_1.OldChannel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], OldContact.prototype, "oldChannelId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => OldChannel_entity_1.OldChannel),
    __metadata("design:type", OldChannel_entity_1.OldChannel)
], OldContact.prototype, "oldChannel", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], OldContact.prototype, "firstName", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], OldContact.prototype, "lastName", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], OldContact.prototype, "phone1", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], OldContact.prototype, "phone2", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], OldContact.prototype, "mobileNo", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.CHAR(255),
        allowNull: false,
        unique: { name: 'email', msg: 'account:singup:emailAleradytaken' }
    }),
    __metadata("design:type", String)
], OldContact.prototype, "email", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Responsibility_entity_1.Responsibility),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], OldContact.prototype, "responsibilityId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Responsibility_entity_1.Responsibility),
    __metadata("design:type", Media_entity_1.Media)
], OldContact.prototype, "responsibility", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], OldContact.prototype, "workNatureId", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], OldContact.prototype, "jobTitle", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], OldContact.prototype, "linkedIn", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], OldContact.prototype, "googleplus", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Media_entity_1.Media),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], OldContact.prototype, "documentId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Media_entity_1.Media, 'documentId'),
    __metadata("design:type", Media_entity_1.Media)
], OldContact.prototype, "document", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Country_entity_1.Country),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], OldContact.prototype, "countryId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Country_entity_1.Country),
    __metadata("design:type", Country_entity_1.Country)
], OldContact.prototype, "country", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], OldContact.prototype, "isDefaultContact", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], OldContact.prototype, "isShared", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], OldContact.prototype, "isActive", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], OldContact.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], OldContact.prototype, "createdAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], OldContact.prototype, "updatedAt", void 0);
OldContact = __decorate([
    sequelize_typescript_1.Table(tableOptions)
], OldContact);
exports.OldContact = OldContact;
//# sourceMappingURL=OldContact.entity.js.map