"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OtherPayment = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const swagger_1 = require("@nestjs/swagger");
const User_entity_1 = require("../../user/models/User.entity");
const sequelize_typescript_2 = require("sequelize-typescript");
const Channel_entity_1 = require("./Channel.entity");
const Currency_entity_1 = require("./Currency.entity");
const channelValidation = {
    isAvailable: async (value, next) => {
        const isExist = await Channel_entity_1.Channel.findOne({ where: { channelId: value } });
        if (!isExist) {
            next('channel:notFound');
        }
        next();
    },
};
const tableOptions = { timestamps: false, tableName: 'tblOtherPayment' };
let OtherPayment = class OtherPayment extends sequelize_typescript_1.Model {
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], OtherPayment.prototype, "otherPaymentId", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.INTEGER,
        allowNull: false,
        autoIncrement: false,
        unique: false,
        primaryKey: false,
        validate: channelValidation
    }),
    __metadata("design:type", Number)
], OtherPayment.prototype, "payerChannelId", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.INTEGER,
        allowNull: false,
        autoIncrement: false,
        unique: false,
        primaryKey: false,
        validate: channelValidation
    }),
    __metadata("design:type", Number)
], OtherPayment.prototype, "payeeChannelId", void 0);
__decorate([
    swagger_1.ApiProperty(),
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DECIMAL(15, 2)),
    __metadata("design:type", Number)
], OtherPayment.prototype, "amount", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(true),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], OtherPayment.prototype, "transactionNumber", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(true),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], OtherPayment.prototype, "secretKey", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(true),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], OtherPayment.prototype, "cardType", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(true),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], OtherPayment.prototype, "cardLastFourDigit", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], OtherPayment.prototype, "status", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(true),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], OtherPayment.prototype, "message", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.INTEGER,
        allowNull: false,
        autoIncrement: false,
        unique: false,
        primaryKey: false,
        validate: {
            isAvailable: async (value, next) => {
                const isExist = await User_entity_1.User.findOne({ where: { userId: value } });
                if (!isExist) {
                    next('account:resetPassword:userNotFound');
                }
                next();
            },
        }
    }),
    __metadata("design:type", Number)
], OtherPayment.prototype, "updatedBy", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.DATE,
        allowNull: false,
        autoIncrement: false,
        unique: false,
        primaryKey: false,
        defaultValue: sequelize_typescript_2.Sequelize.literal('CURRENT_TIMESTAMP')
    }),
    __metadata("design:type", String)
], OtherPayment.prototype, "paymentTransactionAt", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.INTEGER,
        allowNull: false,
        autoIncrement: false,
        unique: false,
        primaryKey: false,
        validate: {
            isAvailable: async (value, next) => {
                const isExist = await Currency_entity_1.Currency.findOne({ where: { currencyid: value } });
                if (!isExist) {
                    next('currency:notFound');
                }
                next();
            },
        }
    }),
    sequelize_typescript_1.ForeignKey(() => Currency_entity_1.Currency),
    __metadata("design:type", Number)
], OtherPayment.prototype, "currencyid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Currency_entity_1.Currency),
    __metadata("design:type", Currency_entity_1.Currency)
], OtherPayment.prototype, "currency", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(true),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], OtherPayment.prototype, "invoiceno", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(true),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], OtherPayment.prototype, "entity", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(true),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], OtherPayment.prototype, "paymentIntent", void 0);
OtherPayment = __decorate([
    sequelize_typescript_1.Table(tableOptions),
    sequelize_typescript_1.Scopes(() => ({
        channelDetail: {
            attributes: ['payerChannelId', 'payeeChannelId', 'amount', 'currencyid', 'paymentIntent', 'entity', 'updatedBy']
        },
    }))
], OtherPayment);
exports.OtherPayment = OtherPayment;
//# sourceMappingURL=OtherPayment.entity.js.map