"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PaymentTransaction = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const swagger_1 = require("@nestjs/swagger");
const PaymentType_entity_1 = require("./PaymentType.entity");
const Channel_entity_1 = require("./Channel.entity");
const User_entity_1 = require("./../../user/models/User.entity");
const sequelize_typescript_2 = require("sequelize-typescript");
const Currency_entity_1 = require("./Currency.entity");
const channelValidation = {
    isAvailable: async (value, next) => {
        const isExist = await Channel_entity_1.Channel.findOne({ where: { channelId: value } });
        if (!isExist) {
            next('channel:notFound');
        }
        next();
    },
};
let PaymentTransaction = class PaymentTransaction extends sequelize_typescript_1.Model {
};
PaymentTransaction.PAYMENT_TYPE_SUBSCRIPTION = 1;
PaymentTransaction.PAYMENT_TYPE_TRADESHOW = 2;
PaymentTransaction.PAYMENT_TYPE_SAMPLES = 3;
PaymentTransaction.PAYMENT_TYPE_SALESREPPAY = 4;
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.INTEGER,
        allowNull: false,
        autoIncrement: true,
        unique: true,
        primaryKey: true,
    }),
    __metadata("design:type", Number)
], PaymentTransaction.prototype, "paymentTransactionId", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.INTEGER,
        allowNull: false,
        autoIncrement: false,
        unique: false,
        primaryKey: false,
        validate: {
            isAvailable: async (value, next) => {
                const isExist = await PaymentType_entity_1.PaymentType.findOne({ where: { paymentTypeId: value } });
                if (!isExist) {
                    next('channel:subscription:paymentType:notFound');
                }
                next();
            },
        }
    }),
    sequelize_typescript_1.ForeignKey(() => PaymentType_entity_1.PaymentType),
    __metadata("design:type", Number)
], PaymentTransaction.prototype, "paymentTypeId", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.INTEGER,
        allowNull: false,
        autoIncrement: false,
        unique: false,
        primaryKey: false
    }),
    __metadata("design:type", Number)
], PaymentTransaction.prototype, "paymentMethodId", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.INTEGER,
        allowNull: false,
        autoIncrement: false,
        unique: false,
        primaryKey: false,
        validate: channelValidation
    }),
    __metadata("design:type", Number)
], PaymentTransaction.prototype, "payerChannelId", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.INTEGER,
        allowNull: false,
        autoIncrement: false,
        unique: false,
        primaryKey: false,
        validate: channelValidation
    }),
    __metadata("design:type", Number)
], PaymentTransaction.prototype, "payeeChannelId", void 0);
__decorate([
    swagger_1.ApiProperty(),
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DECIMAL(15, 2)),
    __metadata("design:type", Number)
], PaymentTransaction.prototype, "amount", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(true),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], PaymentTransaction.prototype, "transactionNumber", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(true),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], PaymentTransaction.prototype, "cardType", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(true),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], PaymentTransaction.prototype, "cardLastFourDigit", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], PaymentTransaction.prototype, "status", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(true),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], PaymentTransaction.prototype, "message", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.INTEGER,
        allowNull: false,
        autoIncrement: false,
        unique: false,
        primaryKey: false,
        validate: {
            isAvailable: async (value, next) => {
                const isExist = await User_entity_1.User.findOne({ where: { userId: value } });
                if (!isExist) {
                    next('account:resetPassword:userNotFound');
                }
                next();
            },
        }
    }),
    __metadata("design:type", Number)
], PaymentTransaction.prototype, "updatedBy", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.DATE,
        allowNull: false,
        autoIncrement: false,
        unique: false,
        primaryKey: false,
        defaultValue: sequelize_typescript_2.Sequelize.literal('CURRENT_TIMESTAMP')
    }),
    __metadata("design:type", String)
], PaymentTransaction.prototype, "paymentTransactionAt", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => PaymentType_entity_1.PaymentType),
    __metadata("design:type", PaymentType_entity_1.PaymentType)
], PaymentTransaction.prototype, "paymentType", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.INTEGER,
        allowNull: false,
        autoIncrement: false,
        unique: false,
        primaryKey: false,
        validate: {
            isAvailable: async (value, next) => {
                const isExist = await Currency_entity_1.Currency.findOne({ where: { currencyid: value } });
                if (!isExist) {
                    next('currency:notFound');
                }
                next();
            },
        }
    }),
    sequelize_typescript_1.ForeignKey(() => Currency_entity_1.Currency),
    __metadata("design:type", Number)
], PaymentTransaction.prototype, "currencyid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Currency_entity_1.Currency),
    __metadata("design:type", Currency_entity_1.Currency)
], PaymentTransaction.prototype, "currency", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(true),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], PaymentTransaction.prototype, "invoiceno", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(true),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], PaymentTransaction.prototype, "entity", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(true),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], PaymentTransaction.prototype, "entityId", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(true),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], PaymentTransaction.prototype, "couponCode", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(true),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], PaymentTransaction.prototype, "paymentIntent", void 0);
PaymentTransaction = __decorate([
    sequelize_typescript_1.Table({
        timestamps: false,
        tableName: "tblPaymentTransaction"
    }),
    sequelize_typescript_1.Scopes(() => ({
        channelDetail: {
            attributes: ['paymentTransactionId', 'paymentTransactionAt', 'amount', 'transactionNumber', 'cardType', 'cardLastFourDigit', 'status', 'message']
        },
    }))
], PaymentTransaction);
exports.PaymentTransaction = PaymentTransaction;
//# sourceMappingURL=PaymentTransaction.entity.js.map