"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProfileList = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const swagger_1 = require("@nestjs/swagger");
const Channel_entity_1 = require("./Channel.entity");
const ProfileCreationRating_entity_1 = require("./ProfileCreationRating.entity");
var Sequelize = require('sequelize');
let ProfileList = class ProfileList extends sequelize_typescript_1.Model {
    static async dateUpdate(rating, options) {
        rating.updatedAt = Sequelize.fn('NOW');
    }
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.Column,
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], ProfileList.prototype, "listId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProfileList.prototype, "channelId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel),
    __metadata("design:type", Array)
], ProfileList.prototype, "channel", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => ProfileCreationRating_entity_1.ProfileRatings),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProfileList.prototype, "ratingId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => ProfileCreationRating_entity_1.ProfileRatings),
    __metadata("design:type", Array)
], ProfileList.prototype, "profilelist", void 0);
__decorate([
    sequelize_typescript_1.Column({ type: sequelize_typescript_1.DataType.BIGINT }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], ProfileList.prototype, "value", void 0);
__decorate([
    sequelize_typescript_1.Column({ type: sequelize_typescript_1.DataType.BOOLEAN }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Boolean)
], ProfileList.prototype, "isCompleted", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.DATE,
        allowNull: false,
        autoIncrement: false,
        unique: false,
        primaryKey: false,
        defaultValue: Sequelize.literal('CURRENT_TIMESTAMP')
    }),
    __metadata("design:type", String)
], ProfileList.prototype, "createdAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProfileList.prototype, "updatedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProfileList.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    sequelize_typescript_1.BeforeUpdate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [ProfileList, Object]),
    __metadata("design:returntype", Promise)
], ProfileList, "dateUpdate", null);
ProfileList = __decorate([
    sequelize_typescript_1.Table({
        tableName: "tblProfileList"
    }),
    sequelize_typescript_1.Scopes(() => ({
        basicList: {
            attributes: ['ratingId', 'channelId', 'isCompleted', 'value']
        }
    }))
], ProfileList);
exports.ProfileList = ProfileList;
//# sourceMappingURL=ProfileList.entity.js.map