"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var ProfileType_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProfileType = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const ProfileTypeClassification_entity_1 = require("./ProfileTypeClassification.entity");
const swagger_1 = require("@nestjs/swagger");
var Sequelize = require('sequelize');
const Validation_exception_1 = require("./../../../middleware/exception/Validation.exception");
let ProfileType = ProfileType_1 = class ProfileType extends sequelize_typescript_1.Model {
    static async dateUpdate(instance, options) {
        instance.updatedAt = Sequelize.fn('NOW');
        let woptions = {
            where: {
                profileType: {
                    $ilike: instance.profileType.trim()
                },
                deletedAt: null
            }
        };
        if (instance.profileTypeId) {
            woptions['where']['profileTypeId'] = {
                $not: instance.profileTypeId
            };
        }
        if (await ProfileType_1.count(woptions)) {
            throw new Validation_exception_1.ValidationException([{
                    value: instance.profileType.trim(),
                    property: 'profileType',
                    children: [],
                    constraints: { unique: 'validate:field:shouldBeUnique' }
                }]);
        }
    }
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], ProfileType.prototype, "profileTypeId", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.CHAR(255),
        allowNull: false,
        unique: { name: 'profileType', msg: 'validate:field:shouldBeUnique' }
    }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], ProfileType.prototype, "profileType", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ProfileTypeClassification_entity_1.ProfileTypeClassification, 'profileTypeId'),
    __metadata("design:type", Array)
], ProfileType.prototype, "profileTypeClass", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProfileType.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProfileType.prototype, "createdAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProfileType.prototype, "updatedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], ProfileType.prototype, "businessType", void 0);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    sequelize_typescript_1.BeforeUpdate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [ProfileType, Object]),
    __metadata("design:returntype", Promise)
], ProfileType, "dateUpdate", null);
ProfileType = ProfileType_1 = __decorate([
    sequelize_typescript_1.Table({
        tableName: "tblProfileType"
    }),
    sequelize_typescript_1.Scopes(() => ({
        profileTypeInfom: {
            attributes: [['profileTypeId', 'id'], ['profileType', 'name']]
        },
        channelDetail: {
            attributes: ['profileTypeId', 'profileType', 'deletedAt']
        },
        tradeinfo: {
            attributes: {
                exclude: ['deletedAt', 'createdAt', 'updatedAt']
            }
        },
        profileTypeMaster: {
            where: {
                deletedAt: null
            },
            attributes: {
                exclude: ['deletedAt', 'createdAt', 'updatedAt']
            }
        }
    }))
], ProfileType);
exports.ProfileType = ProfileType;
//# sourceMappingURL=ProfileType.entity.js.map