"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var ProfileTypeClassification_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProfileTypeClassification = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const ProfileType_entity_1 = require("./ProfileType.entity");
const ChannelType_entity_1 = require("./ChannelType.entity");
const swagger_1 = require("@nestjs/swagger");
var Sequelize = require('sequelize');
const Validation_exception_1 = require("./../../../middleware/exception/Validation.exception");
let ProfileTypeClassification = ProfileTypeClassification_1 = class ProfileTypeClassification extends sequelize_typescript_1.Model {
    static async dateUpdate(instance, options) {
        instance.updatedAt = Sequelize.fn('NOW');
        let woptions = {
            where: {
                channelTypeId: +instance.channelTypeId,
                profileTypeId: +instance.profileTypeId,
                deletedAt: null
            }
        };
        if (instance.profileTypeClassificationId) {
            woptions['where']['profileTypeClassificationId'] = {
                $not: instance.profileTypeClassificationId
            };
        }
        if (await ProfileTypeClassification_1.count(woptions)) {
            throw new Validation_exception_1.ValidationException([{
                    value: +instance.profileTypeId,
                    property: 'profileTypeId',
                    children: [],
                    constraints: { unique: 'validate:field:shouldBeUnique' }
                },
                {
                    value: +instance.channelTypeId,
                    property: 'channelTypeId',
                    children: [],
                    constraints: { unique: 'validate:field:shouldBeUnique' }
                }]);
        }
    }
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], ProfileTypeClassification.prototype, "profileTypeClassificationId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => ProfileType_entity_1.ProfileType),
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.BIGINT,
        allowNull: false,
        unique: { name: 'profileType', msg: 'validate:field:shouldBeUnique' }
    }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], ProfileTypeClassification.prototype, "profileTypeId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => ProfileType_entity_1.ProfileType),
    __metadata("design:type", ProfileType_entity_1.ProfileType)
], ProfileTypeClassification.prototype, "profileType", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => ChannelType_entity_1.ChannelType),
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.BIGINT,
        allowNull: false,
        unique: { name: 'profileType', msg: 'validate:field:shouldBeUnique' }
    }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], ProfileTypeClassification.prototype, "channelTypeId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => ChannelType_entity_1.ChannelType),
    __metadata("design:type", ChannelType_entity_1.ChannelType)
], ProfileTypeClassification.prototype, "channelType", void 0);
__decorate([
    sequelize_typescript_1.Column,
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], ProfileTypeClassification.prototype, "isDefault", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProfileTypeClassification.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProfileTypeClassification.prototype, "createdAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProfileTypeClassification.prototype, "updatedAt", void 0);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    sequelize_typescript_1.BeforeUpdate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [ProfileTypeClassification, Object]),
    __metadata("design:returntype", Promise)
], ProfileTypeClassification, "dateUpdate", null);
ProfileTypeClassification = ProfileTypeClassification_1 = __decorate([
    sequelize_typescript_1.Table({
        tableName: "tblProfileTypeClassification"
    }),
    sequelize_typescript_1.Scopes(() => ({
        profileTypeClassificationInfom: {
            attributes: ['profileTypeClassificationId', 'profileTypeId', 'channelTypeId', 'isDefault']
        },
        profileTypeClassificationMaster: {
            where: {
                deletedAt: null
            },
            attributes: {
                exclude: ['deletedAt', 'createdAt', 'updatedAt']
            },
            include: [
                {
                    model: ProfileType_entity_1.ProfileType,
                    attributes: ['profileTypeId', 'profileType'],
                },
                {
                    model: ChannelType_entity_1.ChannelType,
                }
            ]
        }
    }))
], ProfileTypeClassification);
exports.ProfileTypeClassification = ProfileTypeClassification;
//# sourceMappingURL=ProfileTypeClassification.entity.js.map