import { Model } from 'sequelize-typescript';
import { SubscriptionPeriod } from './SubscriptionPeriod.entity';
import { SubscriptionPlan } from './SubscriptionPlan.entity';
import { ChannelType } from './ChannelType.entity';
import { SubscriptionDetail } from './SubscriptionDetail.entity';
import { ChannelSubscription } from './ChannelSubscription.entity';
import { SubscriptionExtraFeature } from './SubscriptionExtraFeature.entity';
export declare class Subscription extends Model<Subscription> {
    static SUBSCRIPTION_TYPE_NEW: number;
    static SUBSCRIPTION_TYPE_RENEWAL: number;
    static SUBSCRIPTION_TYPE_UPGRADE: number;
    static SUBSCRIPTION_TYPE_DOWNGRADE: number;
    static SUBSCRIPTION_PERIOD_MONTH: number;
    static SUBSCRIPTION_PERIOD_YEAR: number;
    subscriptionId: number;
    channelTypeId: number;
    channelType: ChannelType;
    subscriptionPeriodId: number;
    subscriptionPeriod: SubscriptionPeriod;
    subscriptionPlanId: number;
    subscriptionPlan: SubscriptionPlan;
    amount: number;
    subscriptionDetail: SubscriptionDetail[];
    channelSubscription: ChannelSubscription[];
    subscriptionExtraFeature: SubscriptionExtraFeature[];
    get finalAmount(): number;
    offerDesc: string;
    offerPerc: number;
    isActive: number;
    deletedAt: Date;
    updatedAt: Date;
    updatedBy: number;
    static dateUpdate(instance: Subscription): Promise<void>;
}
