"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var Subscription_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Subscription = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const SubscriptionPeriod_entity_1 = require("./SubscriptionPeriod.entity");
const SubscriptionPlan_entity_1 = require("./SubscriptionPlan.entity");
const ChannelType_entity_1 = require("./ChannelType.entity");
const SubscriptionDetail_entity_1 = require("./SubscriptionDetail.entity");
const ChannelSubscription_entity_1 = require("./ChannelSubscription.entity");
const SubscriptionExtraFeature_entity_1 = require("./SubscriptionExtraFeature.entity");
var Sequelize = require('sequelize');
const Validation_exception_1 = require("./../../../middleware/exception/Validation.exception");
const tableOptions = { timestamp: true, tableName: 'tblSubscription' };
let Subscription = Subscription_1 = class Subscription extends sequelize_typescript_1.Model {
    get finalAmount() {
        let amount = +this.amount;
        if (this.offerPerc > 0 && amount > 0) {
            return +(amount - (amount * (this.offerPerc / 100))).toFixed(2);
        }
        return +(amount).toFixed(2);
    }
    static async dateUpdate(instance) {
        instance.updatedAt = Sequelize.fn('NOW');
        let options = {
            where: {
                channelTypeId: +instance.channelTypeId,
                subscriptionPeriodId: +instance.subscriptionPeriodId,
                subscriptionPlanId: +instance.subscriptionPlanId
            }
        };
        if (instance.subscriptionId) {
            options['where']['subscriptionId'] = {
                $not: instance.subscriptionId
            };
        }
        if (await Subscription_1.count(options)) {
            throw new Validation_exception_1.ValidationException([
                {
                    value: +instance.channelTypeId,
                    property: 'channelTypeId',
                    children: [],
                    constraints: { unique: 'validate:field:shouldBeUnique' }
                },
                {
                    value: +instance.subscriptionPeriodId,
                    property: 'subscriptionPeriodId',
                    children: [],
                    constraints: { unique: 'validate:field:shouldBeUnique' }
                },
                {
                    value: +instance.subscriptionPlanId,
                    property: 'subscriptionPlanId',
                    children: [],
                    constraints: { unique: 'validate:field:shouldBeUnique' }
                }
            ]);
        }
    }
};
Subscription.SUBSCRIPTION_TYPE_NEW = 1;
Subscription.SUBSCRIPTION_TYPE_RENEWAL = 2;
Subscription.SUBSCRIPTION_TYPE_UPGRADE = 3;
Subscription.SUBSCRIPTION_TYPE_DOWNGRADE = 4;
Subscription.SUBSCRIPTION_PERIOD_MONTH = 1;
Subscription.SUBSCRIPTION_PERIOD_YEAR = 2;
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Subscription.prototype, "subscriptionId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => ChannelType_entity_1.ChannelType),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Subscription.prototype, "channelTypeId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => ChannelType_entity_1.ChannelType),
    __metadata("design:type", ChannelType_entity_1.ChannelType)
], Subscription.prototype, "channelType", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => SubscriptionPeriod_entity_1.SubscriptionPeriod),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Subscription.prototype, "subscriptionPeriodId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => SubscriptionPeriod_entity_1.SubscriptionPeriod),
    __metadata("design:type", SubscriptionPeriod_entity_1.SubscriptionPeriod)
], Subscription.prototype, "subscriptionPeriod", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => SubscriptionPlan_entity_1.SubscriptionPlan),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Subscription.prototype, "subscriptionPlanId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => SubscriptionPlan_entity_1.SubscriptionPlan),
    __metadata("design:type", SubscriptionPlan_entity_1.SubscriptionPlan)
], Subscription.prototype, "subscriptionPlan", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DECIMAL(15, 2)),
    __metadata("design:type", Number)
], Subscription.prototype, "amount", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => SubscriptionDetail_entity_1.SubscriptionDetail, 'subscriptionId'),
    __metadata("design:type", Array)
], Subscription.prototype, "subscriptionDetail", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ChannelSubscription_entity_1.ChannelSubscription, 'subscriptionId'),
    __metadata("design:type", Array)
], Subscription.prototype, "channelSubscription", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => SubscriptionExtraFeature_entity_1.SubscriptionExtraFeature, 'subscriptionId'),
    __metadata("design:type", Array)
], Subscription.prototype, "subscriptionExtraFeature", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], Subscription.prototype, "offerDesc", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DECIMAL(5, 2)),
    __metadata("design:type", Number)
], Subscription.prototype, "offerPerc", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BOOLEAN),
    __metadata("design:type", Number)
], Subscription.prototype, "isActive", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Subscription.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Subscription.prototype, "updatedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Subscription.prototype, "updatedBy", void 0);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    sequelize_typescript_1.BeforeUpdate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Subscription]),
    __metadata("design:returntype", Promise)
], Subscription, "dateUpdate", null);
Subscription = Subscription_1 = __decorate([
    sequelize_typescript_1.Table({
        tableName: "tblSubscription"
    }),
    sequelize_typescript_1.Scopes(() => ({
        all: {
            include: [SubscriptionPeriod_entity_1.SubscriptionPeriod, SubscriptionPlan_entity_1.SubscriptionPlan]
        },
        withPeriod: {
            include: [SubscriptionPeriod_entity_1.SubscriptionPeriod]
        },
        channelDetail: {
            attributes: ['subscriptionPlanId', 'isActive', 'deletedAt']
        }
    }))
], Subscription);
exports.Subscription = Subscription;
//# sourceMappingURL=Subscription.entity.js.map