"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var SubscriptionPeriod_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.SubscriptionPeriod = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
var Sequelize = require('sequelize');
const Validation_exception_1 = require("./../../../middleware/exception/Validation.exception");
const tableOptions = { timestamp: true, tableName: 'tblSubscriptionPeriod' };
let SubscriptionPeriod = SubscriptionPeriod_1 = class SubscriptionPeriod extends sequelize_typescript_1.Model {
    static async dateUpdate(instance) {
        instance.updatedAt = Sequelize.fn('NOW');
        let options = {
            where: {
                periodDesc: {
                    $ilike: instance.periodDesc.trim()
                },
                deletedAt: null
            }
        };
        if (instance.subscriptionPeriodId) {
            options['where']['subscriptionPeriodId'] = {
                $not: instance.subscriptionPeriodId
            };
        }
        if (await SubscriptionPeriod_1.count(options)) {
            throw new Validation_exception_1.ValidationException([{
                    value: instance.periodDesc.trim(),
                    property: 'periodDesc',
                    children: [],
                    constraints: { unique: 'validate:field:shouldBeUnique' }
                }]);
        }
    }
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SubscriptionPeriod.prototype, "subscriptionPeriodId", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], SubscriptionPeriod.prototype, "periodDesc", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], SubscriptionPeriod.prototype, "periodValueInDays", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], SubscriptionPeriod.prototype, "isActive", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], SubscriptionPeriod.prototype, "order", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], SubscriptionPeriod.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], SubscriptionPeriod.prototype, "updatedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SubscriptionPeriod.prototype, "updatedBy", void 0);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    sequelize_typescript_1.BeforeUpdate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [SubscriptionPeriod]),
    __metadata("design:returntype", Promise)
], SubscriptionPeriod, "dateUpdate", null);
SubscriptionPeriod = SubscriptionPeriod_1 = __decorate([
    sequelize_typescript_1.Table({
        timestamps: true,
        tableName: "tblSubscriptionPeriod"
    }),
    sequelize_typescript_1.Scopes(() => ({
        subscriptionPeriodMaster: {
            attributes: ['subscriptionPeriodId', 'periodDesc', 'periodValueInDays', 'isActive', 'updatedAt']
        }
    }))
], SubscriptionPeriod);
exports.SubscriptionPeriod = SubscriptionPeriod;
//# sourceMappingURL=SubscriptionPeriod.entity.js.map