"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var SubscriptionPlan_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.SubscriptionPlan = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const swagger_1 = require("@nestjs/swagger");
var Sequelize = require('sequelize');
const Validation_exception_1 = require("./../../../middleware/exception/Validation.exception");
const tableOptions = { timestamp: true, tableName: 'tblSubscriptionPlan' };
let SubscriptionPlan = SubscriptionPlan_1 = class SubscriptionPlan extends sequelize_typescript_1.Model {
    static async dateUpdate(instance) {
        instance.updatedAt = Sequelize.fn('NOW');
        let options = {
            where: {
                subscriptionPlanType: {
                    $ilike: instance.subscriptionPlanType.trim()
                },
                deletedAt: null
            }
        };
        if (instance.subscriptionPlanId) {
            options['where']['subscriptionPlanId'] = {
                $not: instance.subscriptionPlanId
            };
        }
        if (await SubscriptionPlan_1.count(options)) {
            throw new Validation_exception_1.ValidationException([{
                    value: instance.subscriptionPlanType.trim(),
                    property: 'subscriptionPlanType',
                    children: [],
                    constraints: { unique: 'validate:field:shouldBeUnique' }
                }]);
        }
    }
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.BIGINT,
        allowNull: false,
        unique: true,
        primaryKey: true,
    }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], SubscriptionPlan.prototype, "subscriptionPlanId", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.CHAR(255),
        allowNull: false,
        unique: { name: 'subscriptionPlanType', msg: 'validate:field:shouldBeUnique' }
    }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SubscriptionPlan.prototype, "subscriptionPlanType", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    __metadata("design:type", Number)
], SubscriptionPlan.prototype, "rankOrder", void 0);
__decorate([
    sequelize_typescript_1.Column,
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], SubscriptionPlan.prototype, "isActive", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], SubscriptionPlan.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], SubscriptionPlan.prototype, "updatedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SubscriptionPlan.prototype, "updatedBy", void 0);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    sequelize_typescript_1.BeforeUpdate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [SubscriptionPlan]),
    __metadata("design:returntype", Promise)
], SubscriptionPlan, "dateUpdate", null);
SubscriptionPlan = SubscriptionPlan_1 = __decorate([
    sequelize_typescript_1.Table({
        tableName: "tblSubscriptionPlan"
    }),
    sequelize_typescript_1.Scopes(() => ({
        channelDetail: {
            attributes: ['subscriptionPlanType', 'isActive', 'deletedAt']
        },
        orderInfo: {
            attributes: ['subscriptionPlanType']
        },
        subscriptionPlanMaster: {
            attributes: ['subscriptionPlanId', 'subscriptionPlanType', 'rankOrder', 'isActive']
        }
    }))
], SubscriptionPlan);
exports.SubscriptionPlan = SubscriptionPlan;
//# sourceMappingURL=SubscriptionPlan.entity.js.map