import { Country } from 'src/modules/common/models/Country.entity';
import { ProductGroup } from 'src/modules/product/models/ProductGroup.entity';
import { Contact } from 'src/modules/user/models/Contact.entity';
import { Address } from '../models/Address.entity';
import { Channel } from '../models/Channel.entity';
import { ChannelDetail } from '../models/ChannelDetail.entity';
import { ChannelProductGroup } from '../models/ChannelProductGroup.entity';
import { Media } from '../../media/models/index';
import { CompanyMedia } from '../models/CompanyMedia.entity';
import { ChannelDocument } from '../models/ChannelDocument.entity';
import { ChannelJCT } from '../models/ChannelJCT.entity';
import { ChannelDismissReason } from '../models/ChannelDismissReason.entity';
import { Coupon } from '../models/Coupon.entity';
import { SubscriptionPlan } from '../models/SubscriptionPlan.entity';
import { EventParticipants } from '../models/EventParticipants.entity';
import { EventChannel } from '../models/EventChannel.entity';
import { CertificateType } from '../models/CertificateType.entity';
import { Product } from 'src/modules/product/models/Product.entity';
import { ChannelKeyPartnerService } from './channelKeyPartner.service';
import { Subscription } from '../models/Subscription.entity';
import { ProductCategory } from 'src/modules/product/models/ProductCategory.entity';
import { CompanyMediaImages } from '../models/CompanyMediaImages';
import { OldChannel } from '../models/OldChannel.entity';
export declare class ChannelAdminService {
    private readonly sequelizeInstance;
    private readonly channelRepository;
    private readonly channelDetailRepository;
    private readonly contactRepository;
    private readonly addressRepository;
    private readonly channelProductGroupRepository;
    private readonly countryRepository;
    private readonly productGroupRepository;
    private readonly companyMediaRepository;
    private readonly mediaRepository;
    private readonly channelDocumentRepository;
    private readonly couponRepository;
    private readonly channelJCTRepository;
    private readonly channelDismissReasonRepository;
    private readonly eventParticipantRepository;
    private readonly eventChannelRepository;
    private readonly productRepository;
    private readonly subscriptionRepository;
    private readonly productCategoryRepository;
    private readonly channelCertificateTypeRepository;
    private readonly companyMediaImagesRepository;
    private readonly oldChannelRepository;
    private readonly channelKeyPartnerService;
    private channelDetailOutBound;
    private tradeInformationInBound;
    constructor(sequelizeInstance: any, channelRepository: typeof Channel, channelDetailRepository: typeof ChannelDetail, contactRepository: typeof Contact, addressRepository: typeof Address, channelProductGroupRepository: typeof ChannelProductGroup, countryRepository: typeof Country, productGroupRepository: typeof ProductGroup, companyMediaRepository: typeof CompanyMedia, mediaRepository: typeof Media, channelDocumentRepository: typeof ChannelDocument, couponRepository: typeof Coupon, channelJCTRepository: typeof ChannelJCT, channelDismissReasonRepository: typeof ChannelDismissReason, eventParticipantRepository: typeof EventParticipants, eventChannelRepository: typeof EventChannel, productRepository: typeof Product, subscriptionRepository: typeof Subscription, productCategoryRepository: typeof ProductCategory, channelCertificateTypeRepository: typeof CertificateType, companyMediaImagesRepository: typeof CompanyMediaImages, oldChannelRepository: typeof OldChannel, channelKeyPartnerService: ChannelKeyPartnerService);
    getPendingApprovelChannels(data: any): Promise<{
        rows: Channel[];
        count: number;
    }>;
    pendingChannelsList(userId: any): Promise<Channel[]>;
    channelApproval(data: any): Promise<[number, Channel[]]>;
    getFilterCountry(data: any): Promise<Country[]>;
    getProductCat(data: any): Promise<ProductGroup[]>;
    getSubscriptionPlan(): Promise<SubscriptionPlan[]>;
    medialibraryByContact(user: any): Promise<CompanyMedia[]>;
    saveDocument(reqVideo: any): Promise<Media>;
    deleteMediaVideo(data: any): Promise<[number, CompanyMedia[]]>;
    saveUploadedVideo(reqVideo: any, user: any): Promise<any>;
    deleteCompanyLogo(data: any): Promise<[number, ChannelDocument[]]>;
    getCompanyProfile(user: any): Promise<any>;
    getCouponList(couponFilterDto: any): Promise<any>;
    getCouponByID(couponid: number): Promise<any>;
    addChannelCoupon(adminCouponAddDto: any): Promise<any>;
    UpdateChannelCoupon(couponid: number, adminCouponAddDto: any): Promise<any>;
    getBuyerNeed(filter: any): Promise<{
        result: any[];
        total: any;
    }>;
    getRequestIntro(channelid: any): Promise<any>;
    updateChannelConnect(channelId: any, updateChannelDto: any, user: any, suggest_Channel: any): Promise<any>;
    getPublicCompanyFlags(channelId: any): Promise<any>;
    setCompanyPublicFlags(data: any): Promise<[number, Channel[]]>;
    boEventCreate(data: any): Promise<true | {
        error: string;
    }>;
    getEventListing(eventFilter: any): Promise<any>;
    getEventById(eventId: any): Promise<any>;
    getEventDetailsById(eventId: any): Promise<any>;
    eventAvailabilityCheck(eventCatId: any, eventId: any): Promise<boolean>;
    getEventChannelDetails(channelId: any, eventId: any): Promise<any>;
    boEventUserManage(data: any): Promise<boolean>;
    boToEventCatalyst(contacts: any): Promise<any>;
    companyNameList(search: string): Promise<Channel[]>;
    contactNameList(search: string): Promise<Contact[]>;
    getContact(contactId: any): Promise<Contact>;
    getChannel(channelId: number): Promise<any>;
    getSampleOrderCount(channelId: number): Promise<number>;
    getSampleEvaluationCount(channelId: number): Promise<number>;
    oldChannelsList(userId: any): Promise<OldChannel[]>;
    oldChannels(data: any): Promise<{
        results: any[];
        aggregation: {};
        total: any;
    }>;
    getOldChannelDetailView(oldChannelId: any): Promise<any>;
    getOldChannelDetails(oldChannelId: number): Promise<any>;
    getOldChannelFacts(oldChannelId: number): Promise<any>;
    getOldProducts(oldChannelId: any): Promise<{
        productGroup: any[];
    }>;
    getOldChannelBrand(oldChannelId: any): Promise<{
        brand: any[];
    }>;
    channelProfileOld(oldChannelId: any): Promise<OldChannel[]>;
    specialityOld(data: any): Promise<{
        specialityOptions: any;
    }>;
    getOldInitialProfile(data: any): Promise<{
        productGroup: any;
        productBrand: any;
        profileList: any;
        distProfile: any;
        country: any;
    }>;
    editBasicCompanyOld(requestObject: any): Promise<any>;
    saveOldChannelFacts(data: any): Promise<any>;
    updateBannerImage(requestObject: any): Promise<boolean>;
    mapOrder(array: any, order: any, key: any): Promise<any>;
}
