"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChannelAdminService = void 0;
const common_1 = require("@nestjs/common");
const Country_entity_1 = require("../../common/models/Country.entity");
const ProductGroup_entity_1 = require("../../product/models/ProductGroup.entity");
const Contact_entity_1 = require("../../user/models/Contact.entity");
const Address_entity_1 = require("../models/Address.entity");
const Channel_entity_1 = require("../models/Channel.entity");
const sequelize_1 = require("sequelize");
const index_1 = require("../../media/models/index");
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
const ContactProductGroup_entity_1 = require("../../user/models/ContactProductGroup.entity");
const User_entity_1 = require("../../user/models/User.entity");
const UserRole_entity_1 = require("../../user/models/UserRole.entity");
const notificaton_constant_1 = require("./../../../config/notificaton.constant");
const config_1 = require("../../../config");
const Coupon_entity_1 = require("../models/Coupon.entity");
const SubscriptionPlan_entity_1 = require("../models/SubscriptionPlan.entity");
const ChannelType_entity_1 = require("../models/ChannelType.entity");
const SubscriptionType_entity_1 = require("../models/SubscriptionType.entity");
const Validation_exception_1 = require("../../../middleware/exception/Validation.exception");
const EventBo_entity_1 = require("../models/EventBo.entity");
const EventPackage_entity_1 = require("../models/EventPackage.entity");
const EventParticipants_entity_1 = require("../models/EventParticipants.entity");
const EventChannel_entity_1 = require("../models/EventChannel.entity");
const ChannelB2B_entity_1 = require("../models/ChannelB2B.entity");
const ProfileType_entity_1 = require("../models/ProfileType.entity");
const Brand_entity_1 = require("../../product/models/Brand.entity");
const ChannelAward_entity_1 = require("../models/ChannelAward.entity");
const RegionCountryJCT_entity_1 = require("../../common/models/RegionCountryJCT.entity");
const ContactSocialLink_entity_1 = require("../../user/models/ContactSocialLink.entity");
const SocialSite_entity_1 = require("../models/SocialSite.entity");
const Product_entity_1 = require("../../product/models/Product.entity");
const SampleOrder_entity_1 = require("../../order/models/SampleOrder.entity");
const ProductEvaluation_entity_1 = require("../../product/models/ProductEvaluation.entity");
const channelKeyPartner_service_1 = require("./channelKeyPartner.service");
const utility_1 = require("./../helper/utility");
const ProductCategory_entity_1 = require("../../product/models/ProductCategory.entity");
const Role_entity_1 = require("../../user/models/Role.entity");
const channelDetailOutBound_1 = require("../transformation/channelDetailOutBound");
const OldChannel_entity_1 = require("../models/OldChannel.entity");
const OldContact_entity_1 = require("../models/OldContact.entity");
const tradeInformationInBound_1 = require("../transformation/tradeInformationInBound");
const OldChannelDetail_entity_1 = require("../models/OldChannelDetail.entity");
const OldAddress_entity_1 = require("../models/OldAddress.entity");
const OldChannelSocialLink_entity_1 = require("../models/OldChannelSocialLink.entity");
const lodash_1 = require("lodash");
const OldChannelSpeciality_entity_1 = require("../models/OldChannelSpeciality.entity");
const OldChannelCustomerProfile_entity_1 = require("../models/OldChannelCustomerProfile.entity");
var _ = require('lodash');
let ChannelAdminService = class ChannelAdminService {
    constructor(sequelizeInstance, channelRepository, channelDetailRepository, contactRepository, addressRepository, channelProductGroupRepository, countryRepository, productGroupRepository, companyMediaRepository, mediaRepository, channelDocumentRepository, couponRepository, channelJCTRepository, channelDismissReasonRepository, eventParticipantRepository, eventChannelRepository, productRepository, subscriptionRepository, productCategoryRepository, channelCertificateTypeRepository, companyMediaImagesRepository, oldChannelRepository, channelKeyPartnerService) {
        this.sequelizeInstance = sequelizeInstance;
        this.channelRepository = channelRepository;
        this.channelDetailRepository = channelDetailRepository;
        this.contactRepository = contactRepository;
        this.addressRepository = addressRepository;
        this.channelProductGroupRepository = channelProductGroupRepository;
        this.countryRepository = countryRepository;
        this.productGroupRepository = productGroupRepository;
        this.companyMediaRepository = companyMediaRepository;
        this.mediaRepository = mediaRepository;
        this.channelDocumentRepository = channelDocumentRepository;
        this.couponRepository = couponRepository;
        this.channelJCTRepository = channelJCTRepository;
        this.channelDismissReasonRepository = channelDismissReasonRepository;
        this.eventParticipantRepository = eventParticipantRepository;
        this.eventChannelRepository = eventChannelRepository;
        this.productRepository = productRepository;
        this.subscriptionRepository = subscriptionRepository;
        this.productCategoryRepository = productCategoryRepository;
        this.channelCertificateTypeRepository = channelCertificateTypeRepository;
        this.companyMediaImagesRepository = companyMediaImagesRepository;
        this.oldChannelRepository = oldChannelRepository;
        this.channelKeyPartnerService = channelKeyPartnerService;
        this.channelDetailOutBound = new channelDetailOutBound_1.ChannelDetailOutBound();
        this.tradeInformationInBound = new tradeInformationInBound_1.TradeInformationInBound();
    }
    async getPendingApprovelChannels(data) {
        try {
            let cquery = 'select "typeId" from "tblAdminUserChanneltype" where "adminUserId"=:userId';
            let chtypes = await this.sequelizeInstance.query(cquery, {
                type: sequelize_1.QueryTypes.SELECT,
                replacements: {
                    userId: data.userId
                }
            }).then((results) => {
                return results.map(x => +x.typeId);
            });
            cquery = 'select "countryId" from "tblAdminUserCountries" where "adminUserId"=:userId';
            let countries = await this.sequelizeInstance.query(cquery, {
                type: sequelize_1.QueryTypes.SELECT,
                replacements: {
                    userId: data.userId
                }
            }).then((results) => {
                return results.map(x => +x.countryId);
            });
            let filter = data.filter;
            let channelFilter = {
                signUpStatusId: {
                    [sequelize_1.Op.in]: [14, 15]
                },
                isActive: '1',
                deletedAt: null
            };
            if (countries && countries.length > 0) {
                channelFilter['countryId'] = { [sequelize_1.Op.in]: countries };
            }
            if (chtypes && chtypes.length > 0) {
                channelFilter['channelTypeId'] = { [sequelize_1.Op.in]: chtypes };
            }
            if (data.search) {
                channelFilter['channelId'] = +data.search;
            }
            if (filter.channelTypeId) {
                channelFilter['channelTypeId'] = { [sequelize_1.Op.in]: [+filter.channelTypeId] };
            }
            if (filter.is_OEM) {
                channelFilter['isOEM'] = filter.is_OEM;
            }
            if (filter.countryId) {
                channelFilter['countryId'] = { [sequelize_1.Op.in]: filter.countryId };
            }
            if (filter.planId) {
                channelFilter['planId'] = { [sequelize_1.Op.in]: filter.planId };
            }
            let product_Categories_Filter = {
                deletedAt: null
            };
            if (filter.product_Categories) {
                product_Categories_Filter['productGroupId'] = { [sequelize_1.Op.in]: filter.product_Categories };
            }
            let channel = await this.channelRepository.scope('basicInfom').findAndCountAll({
                limit: data.limit,
                offset: data.page,
                where: channelFilter,
                distinct: true,
                attributes: ['isFeatured', 'isPublic'],
                order: [
                    ['signUpStatusId', 'ASC'],
                    ['updatedAt', 'desc']
                ],
                include: [
                    {
                        model: User_entity_1.User,
                        attributes: ['userId', 'contactId'],
                        where: { deletedAt: null },
                    },
                    {
                        model: this.contactRepository.scope('contactInfo'),
                        as: 'contacts',
                        where: { deletedAt: null },
                        required: true,
                        include: [
                            {
                                model: index_1.Media,
                                attributes: ['documentPath', 'documentId', 'thumbnailPath'],
                                required: false,
                            },
                            {
                                model: ContactProductGroup_entity_1.ContactProductGroup,
                                where: {
                                    deletedAt: null
                                },
                                include: [{
                                        model: ProductGroup_entity_1.ProductGroup,
                                        attributes: ['productGroup']
                                    }],
                                required: false,
                            },
                            {
                                model: this.countryRepository,
                                attributes: ['country'],
                                required: false,
                            },
                            {
                                model: User_entity_1.User,
                                attributes: ['contactId', 'userId', 'lastLogin'],
                                include: [{
                                        model: UserRole_entity_1.UserRole,
                                        attributes: ['roleId']
                                    }]
                            },
                            {
                                model: EventParticipants_entity_1.EventParticipants,
                                required: false,
                                where: {
                                    deletedAt: null
                                }
                            }
                        ]
                    },
                    { model: this.countryRepository.scope('regionCountryJCT'),
                        as: 'country',
                        where: { deletedAt: null },
                        required: true },
                    {
                        model: this.channelDetailRepository,
                        attributes: ['webSiteUrl', 'phone1'],
                        where: { deletedAt: null },
                        required: true
                    },
                    {
                        model: this.addressRepository,
                        as: 'regAddress',
                        required: true
                    },
                    {
                        model: this.channelProductGroupRepository,
                        attributes: ['channelProductGroupId'],
                        where: product_Categories_Filter,
                        required: true,
                        include: [{
                                model: this.productGroupRepository.scope('productInfo'),
                                where: { deletedAt: null },
                                required: false
                            }]
                    }
                ]
            });
            return channel;
        }
        catch (e) {
            console.log(e);
        }
    }
    async pendingChannelsList(userId) {
        let cquery = 'select "typeId" from "tblAdminUserChanneltype" where "adminUserId"=:userId';
        let chtypes = await this.sequelizeInstance.query(cquery, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                userId: userId
            }
        }).then((results) => {
            return results.map(x => +x.typeId);
        });
        cquery = 'select "countryId" from "tblAdminUserCountries" where "adminUserId"=:userId';
        let countries = await this.sequelizeInstance.query(cquery, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                userId: userId
            }
        }).then((results) => {
            return results.map(x => +x.countryId);
        });
        let channelFilter = {
            signUpStatusId: {
                [sequelize_1.Op.in]: [14, 15]
            },
            isActive: '1',
            deletedAt: null
        };
        if (countries && countries.length > 0) {
            channelFilter['countryId'] = { [sequelize_1.Op.in]: countries };
        }
        if (chtypes && chtypes.length > 0) {
            channelFilter['channelTypeId'] = { [sequelize_1.Op.in]: chtypes };
        }
        return await this.channelRepository.findAll({
            where: channelFilter,
            attributes: [["companyName", "name"], ["channelId", "id"]],
            include: [{
                    model: this.contactRepository,
                    as: 'contacts',
                    where: { deletedAt: null, isDefaultContact: '1' },
                    required: true,
                    attributes: ["firstName", "lastName", "contactId"],
                }]
        });
    }
    async channelApproval(data) {
        if (data.signUpStatusId == 0)
            return await this.channelRepository.update({ isActive: '0', deletedAt: Date() }, {
                where: {
                    channelId: +data.channelId
                }
            });
        else
            return await this.channelRepository.update({ signUpStatusId: data.signUpStatusId }, {
                where: {
                    channelId: +data.channelId
                }
            });
    }
    async getFilterCountry(data) {
        let cquery = 'select "countryId" from "tblAdminUserCountries" where "adminUserId"=:userId';
        let countries = await this.sequelizeInstance.query(cquery, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                userId: data.userId
            }
        }).then((results) => {
            return results.map(x => +x.countryId);
        });
        let channelFilter = {
            deletedAt: null
        };
        if (countries && countries.length > 0) {
            channelFilter['countryId'] = { [sequelize_1.Op.in]: countries };
        }
        return await this.countryRepository.scope('regionCountryJCT').findAll({
            where: channelFilter,
            order: [
                ['priority', 'ASC']
            ]
        });
    }
    async getProductCat(data) {
        let channels = [];
        if (data.accessId == 3 || data.accessId == 4) {
            if (data.accessId == 4) {
                let cquery = 'select "countryId" from "tblAdminUserCountries" where "adminUserId"=:userId';
                await this.sequelizeInstance.query(cquery, {
                    type: sequelize_1.QueryTypes.SELECT,
                    replacements: {
                        userId: data.userId
                    }
                }).then(async (results) => {
                    cquery = 'select "channelId" from "tblChannel" where "isActive"=\'1\' and "deletedAt" is null and "signUpStatusId" in(14,15) and "countryId" in(:countries) and "channelTypeId" in(select "typeId" from "tblAdminUserChanneltype" where "adminUserId"=:userId)';
                    await this.sequelizeInstance.query(cquery, {
                        type: sequelize_1.QueryTypes.SELECT,
                        replacements: {
                            userId: data.userId,
                            countries: results.map(x => +x.countryId)
                        }
                    }).then((results) => {
                        channels.push(...results.map(x => +x.channelId));
                    });
                });
            }
            else {
                let cquery = 'select "channelId" from "tblChannel" where "isActive"=\'1\' and "deletedAt" is null and "signUpStatusId" in(14,15) and "channelTypeId" in(select "typeId" from "tblAdminUserChanneltype" where "adminUserId"=:userId)';
                await this.sequelizeInstance.query(cquery, {
                    type: sequelize_1.QueryTypes.SELECT,
                    replacements: {
                        userId: data.userId
                    }
                }).then((results) => {
                    channels.push(...results.map(x => +x.channelId));
                });
            }
        }
        let channelFilter = {
            deletedAt: null
        };
        if (channels && channels.length > 0) {
            channelFilter['channelId'] = { [sequelize_1.Op.in]: channels };
        }
        let productIds = [];
        productIds = await this.channelProductGroupRepository.findAll({
            where: channelFilter,
            attributes: ["productGroupId"],
            include: [{
                    model: this.channelRepository,
                    required: true,
                    where: {
                        signUpStatusId: {
                            [sequelize_1.Op.in]: data.signupstatusid
                        },
                        isActive: '1',
                        deletedAt: null
                    },
                    attributes: []
                }]
        });
        if (productIds) {
            productIds = productIds.map(x => x.productGroupId);
            let result = await this.productGroupRepository.findAll({
                where: {
                    productGroupId: { [sequelize_1.Op.in]: productIds }
                },
                attributes: [["productGroup", "name"], ["productGroupId", "id"]]
            });
            return result;
        }
        else {
            return [];
        }
    }
    async getSubscriptionPlan() {
        return await SubscriptionPlan_entity_1.SubscriptionPlan.findAll({
            attributes: [['subscriptionPlanId', 'id'], ['subscriptionPlanType', 'name']]
        });
    }
    async medialibraryByContact(user) {
        let cond = Object.assign(Object.assign(Object.assign(Object.assign({}, (user.channelId && { channelId: +user.channelId })), (user.contactId && { contactId: +user.contactId })), (user.oldChannelId && { oldChannelId: +user.oldChannelId })), { deletedAt: null });
        return await this.companyMediaRepository.findAll({
            where: cond,
            include: [{
                    model: index_1.Media,
                    as: 'document',
                    where: { deletedAt: null },
                    required: false
                },
                {
                    model: index_1.Media,
                    as: 'snap',
                    where: { deletedAt: null },
                    required: false
                },],
            order: [['companyMediaId', 'DESC']]
        });
    }
    async saveDocument(reqVideo) {
        let updatedDocument = await this.mediaRepository.create({
            documentPath: reqVideo.Key,
            documentTypeId: 3,
            dirName: 'connectionVideos'
        });
        await this.companyMediaRepository.update({
            snapId: updatedDocument.documentId
        }, { where: {
                documentId: reqVideo.mediaId
            }
        });
        return updatedDocument;
    }
    async deleteMediaVideo(data) {
        return await this.companyMediaRepository.update({
            deletedAt: Date()
        }, { where: {
                documentId: data.documentId
            }
        });
    }
    async saveUploadedVideo(reqVideo, user) {
        let cond = Object.assign(Object.assign(Object.assign({}, (user.channelId && { channelId: +user.channelId })), (user.contactId && { contactId: +user.contactId })), (user.oldChannelId && { oldChannelId: +user.oldChannelId }));
        return this.sequelizeInstance.transaction(async (transaction) => {
            let updatedDocument = await this.mediaRepository.create({
                documentPath: reqVideo.Key,
                documentTypeId: 3,
                dirName: 'introVideos'
            }, transaction);
            let companyMedia = await this.companyMediaRepository.create(Object.assign(Object.assign({ documentId: updatedDocument.documentId }, cond), { snapId: null }), transaction);
            let data = {
                documentId: companyMedia.documentId,
                contactId: companyMedia.contactId,
                channelId: companyMedia.channelId,
                oldChannelId: companyMedia.oldChannelId,
                snapId: companyMedia.snapId,
                companyMediaId: companyMedia.companyMediaId,
                document: updatedDocument
            };
            return data;
        })
            .catch((err) => {
            console.log(err);
            throw new Process_exception_1.ProcessException('account:singup:tryAgain');
        });
    }
    async deleteCompanyLogo(data) {
        return await this.channelDocumentRepository.update({
            deletedAt: Date()
        }, { where: {
                channelDocumentId: data.channelDocumentId
            }
        });
    }
    async getCompanyProfile(user) {
        let companyProfile = '';
        let channelAward = [];
        let data = '';
        let channelStatusArray = [config_1.appconstant.ACCOUNTSETUP, config_1.appconstant.ACCOUNTSETUP_COMPANYPROFILE, config_1.appconstant.ACCOUNTSETUP_TRADEINFORMATION, config_1.appconstant.ACCOUNTSETUP_TRADELOCATION, config_1.appconstant.CHANNEL_APPROVAL, config_1.appconstant.CHANNEL_APPROVED, config_1.appconstant.CLAIM_APPROVED];
        try {
            let userSignUpStatus = channelStatusArray.includes(parseInt(user.signUpStatusId));
            if (userSignUpStatus) {
                companyProfile = await this.sequelizeInstance.query("select * from fngetchannelprofile(" + user.userId + "," + parseInt(user.signUpStatusId) + ",'" + process.env.CDN_URL + "');");
                companyProfile = companyProfile[0][0].fngetchannelprofile;
                console.log('companyProfle', companyProfile);
                if (companyProfile.channel.channelAward) {
                    channelAward = await Promise.all(companyProfile.channel.channelAward.map(async (x) => {
                        if (x.documentId) {
                            let data = await this.sequelizeInstance.query('select "documentId","documentPath" from "tblDocument" where "documentId"=' + x.documentId, {
                                type: sequelize_1.QueryTypes.SELECT,
                                raw: true,
                            }).then(y => {
                                console.log('img', x, y);
                                return Object.assign(x, { awardImg: y[0].documentPath, isOld: true, lifeTime: x.lifeTime == '1' ? true : false });
                            });
                            return data;
                        }
                        else {
                            return Object.assign(x, { awardImg: null, isOld: true, lifeTime: x.lifeTime == '1' ? true : false });
                        }
                    }));
                }
                let bannerImg = [];
                console.log('banner', companyProfile.channel.channelDetail.channelBannerId);
                if (companyProfile.channel.channelDetail.channelBannerId) {
                    bannerImg = await this.sequelizeInstance.query('select "documentId","documentPath" from "tblDocument" where "documentId"=' + companyProfile.channel.channelDetail.channelBannerId, {
                        type: sequelize_1.QueryTypes.SELECT,
                        raw: true,
                    }).then(y => {
                        console.log('img', y);
                        return y[0];
                    });
                }
                companyProfile['bannerImg'] = bannerImg;
                companyProfile['channelAward'] = channelAward;
            }
        }
        catch (e) {
            console.log("Error+", e);
        }
        if (!companyProfile) {
            throw new Process_exception_1.ProcessException('channel:getCompanyProfile:companyNotFound');
        }
        return companyProfile;
    }
    async getCouponList(couponFilterDto) {
        let where = {
            deletedAt: null,
        };
        let options = {
            include: [{
                    model: SubscriptionPlan_entity_1.SubscriptionPlan,
                    attributes: ['subscriptionPlanId', 'subscriptionPlanType']
                }, {
                    model: ChannelType_entity_1.ChannelType,
                    attributes: ['channelTypeId', 'channelType']
                },
                {
                    model: SubscriptionType_entity_1.SubscriptionType,
                    attributes: ['subscriptionTypeId', 'subscriptionType']
                }],
            where: where
        };
        let result = {};
        result.count = await Coupon_entity_1.Coupon.count(options);
        result.aggregation = await Coupon_entity_1.Coupon.findAll({
            attributes: [[this.sequelizeInstance.literal('json_build_object(\'plan\',to_json(array_agg(distinct("subscriptionPlan".*))), \'channel_type\',to_json(array_agg(distinct("channelType".*))), \'subscription_type\',to_json(array_agg(distinct("subscriptionType".*))))'), 'filters']],
            include: [{
                    model: SubscriptionPlan_entity_1.SubscriptionPlan,
                    required: true,
                    attributes: []
                }, {
                    model: ChannelType_entity_1.ChannelType,
                    required: true,
                    attributes: []
                },
                {
                    model: SubscriptionType_entity_1.SubscriptionType,
                    required: true,
                    attributes: []
                }],
            where: where,
            raw: true
        }).then((result) => {
            var _a;
            if ((_a = result.filters) === null || _a === void 0 ? void 0 : _a.plan) {
                result.filters.plan = result.filters.plan.map((record) => {
                    return {
                        subscriptionPlanId: record.subscriptionPlanId,
                        subscriptionPlanType: record.subscriptionPlanType
                    };
                });
            }
            return result.filters;
        });
        options['limit'] = couponFilterDto.limit;
        options['offset'] = couponFilterDto.page;
        result.rows = await Coupon_entity_1.Coupon.findAll(options);
        return result;
    }
    async getCouponByID(couponid) {
        try {
            let result = await Coupon_entity_1.Coupon.findAll({
                include: [{
                        model: SubscriptionPlan_entity_1.SubscriptionPlan,
                        attributes: ['subscriptionPlanId', 'subscriptionPlanType']
                    }, {
                        model: ChannelType_entity_1.ChannelType,
                        attributes: ['channelTypeId', 'channelType']
                    },
                    {
                        model: SubscriptionType_entity_1.SubscriptionType,
                        attributes: ['subscriptionTypeId', 'subscriptionType']
                    }],
                where: {
                    couponId: couponid
                }
            });
            return result;
        }
        catch (e) {
        }
    }
    async addChannelCoupon(adminCouponAddDto) {
        if (await this.couponRepository.count({
            where: {
                couponCode: {
                    [sequelize_1.Op.iLike]: adminCouponAddDto.couponCode.trim()
                },
                channelTypeId: +adminCouponAddDto.channelTypeId,
                deletedAt: null
            }
        })) {
            throw new Validation_exception_1.ValidationException([{
                    value: adminCouponAddDto.couponCode.trim(),
                    property: 'couponCode',
                    children: [],
                    constraints: { unique: 'validate:field:shouldBeUnique' }
                }]);
        }
        try {
            let coupon = [];
            if (adminCouponAddDto.subscriptionPlans && adminCouponAddDto.subscriptionPlans.length > 0) {
                for (var i = 0; i < adminCouponAddDto.subscriptionPlans.length; i++) {
                    for (var j = 0; j < adminCouponAddDto.subscriptionPeriods.length; j++) {
                        let couponObject = {};
                        couponObject['couponDesc'] = adminCouponAddDto.couponDesc;
                        couponObject['couponCode'] = adminCouponAddDto.couponCode;
                        couponObject['couponOfferValue'] = adminCouponAddDto.couponOfferValue;
                        couponObject['isActive'] = adminCouponAddDto.isActive;
                        couponObject['fromDate'] = adminCouponAddDto.fromDate;
                        couponObject['toDate'] = adminCouponAddDto.toDate;
                        couponObject['subscriptionTypeId'] = adminCouponAddDto.subscriptionTypeId;
                        couponObject['discountUnit'] = adminCouponAddDto.discountUnit;
                        couponObject['userThreshold'] = (adminCouponAddDto.userThreshold) ? adminCouponAddDto.userThreshold : 0;
                        couponObject['usageThreshold'] = (adminCouponAddDto.usageThreshold) ? adminCouponAddDto.usageThreshold : 0;
                        couponObject['channelTypeId'] = adminCouponAddDto.channelTypeId;
                        couponObject['subscriptionPlanId'] = adminCouponAddDto.subscriptionPlans[i];
                        couponObject['subscriptionPeriodId'] = adminCouponAddDto.subscriptionPeriods[j];
                        coupon.push(couponObject);
                    }
                }
            }
            else {
                coupon.push(adminCouponAddDto);
            }
            return await this.couponRepository.bulkCreate(coupon);
        }
        catch (e) {
            console.log("cerr:", e);
        }
    }
    async UpdateChannelCoupon(couponid, adminCouponAddDto) {
        if (await this.couponRepository.count({
            where: {
                couponCode: {
                    [sequelize_1.Op.iLike]: adminCouponAddDto.couponCode.trim()
                },
                channelTypeId: +adminCouponAddDto.channelTypeId,
                subscriptionPlanId: +adminCouponAddDto.subscriptionPlanId,
                subscriptionPeriodId: +adminCouponAddDto.subscriptionPeriodId,
                deletedAt: null,
                couponId: {
                    [sequelize_1.Op.not]: couponid
                }
            }
        })) {
            throw new Validation_exception_1.ValidationException([{
                    value: adminCouponAddDto.couponCode.trim(),
                    property: 'couponCode',
                    children: [],
                    constraints: { unique: 'validate:field:shouldBeUnique' }
                }]);
        }
        let result = await this.couponRepository.update(adminCouponAddDto, {
            where: {
                couponId: couponid
            }
        });
        return result;
    }
    async getBuyerNeed(filter) {
        let limit = ' LIMIT ' + filter.limit;
        let offset = ' OFFSET ' + filter.offset;
        let query = 'select count(*) OVER() AS total, bn."id",bn."channelid",bn."contactid",bn."requirements",tc."companyName",tcon."firstName",tcon."lastName", '
            + '(select td."documentPath" from "tblContact" utc inner join "tblDocument" td on td."documentId" = utc."documentId" where utc."contactId" = tcon."contactId") as con_image '
            + 'from "buyingneed" as bn inner join "tblChannel" tc on tc."channelId"=bn."channelid" inner join "tblContact" tcon on tcon."contactId"=bn."contactid"';
        query += limit + offset;
        let list = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT
        });
        let result = [];
        if (list) {
            for (var i = 0; i < list.length; i++) {
                query = 'select "productCategorie" from "tblProductCategories" where "productCategorieId" in(select "categoryid" from "buyerreqcategory" where "buyerreqid"=:ids group by "categoryid")';
                let category = await this.sequelizeInstance.query(query, {
                    type: sequelize_1.QueryTypes.SELECT,
                    replacements: {
                        ids: list[i].id
                    }
                });
                let obj = Object.assign(Object.assign({}, list[i]), { category: category.map(x => x.productCategorie) });
                result.push(obj);
            }
            return { result: result, total: list[0].total };
        }
        else {
            return { result: result, total: 0 };
        }
    }
    async getRequestIntro(channelid) {
        let Request_Intro = await this.sequelizeInstance.query('select * from requestintro(' + channelid + ')');
        return Request_Intro;
    }
    async updateChannelConnect(channelId, updateChannelDto, user, suggest_Channel) {
        let result = await this.channelJCTRepository.findOne({
            where: {
                channelJCTId: updateChannelDto.channelJCTId,
                deletedat: null
            },
            include: [
                {
                    model: this.channelRepository,
                    as: 'partnerChannel',
                    where: { deletedAt: null },
                },
                {
                    model: this.channelRepository,
                    as: 'Channel',
                    where: { deletedAt: null },
                },
            ]
        });
        let beforeStatus = result.connectionStatusTypeId;
        let query = 'UPDATE "tblChannelJCT" SET "channelId" = ' + user.channelId + ', "partnerChannelId" = ' + channelId + ', "connectionStatusTypeId" = ' + updateChannelDto.connectionStatusTypeId + ', "updatedAt" = now(), "requested_by" = ' + user.contactId + ', "requested_to" = ' + updateChannelDto.contactid + ', "request_sent_at" = now() WHERE "channelJCTId" = ' + updateChannelDto.channelJCTId;
        let count = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT
        }).then(async (res) => {
            console.log('this is test');
            if (+updateChannelDto.connectionStatusTypeId == config_1.appconstant.REQUEST_INTRO || +updateChannelDto.connectionStatusTypeId == config_1.appconstant.PENDINGMYPROSPECT || +updateChannelDto.connectionStatusTypeId == config_1.appconstant.DISMISS) {
                let delQuery = 'DELETE FROM "tblChannelJCT" WHERE "requested_by" = ' + user.contactId + ' AND "requested_to" = ' + updateChannelDto.contactid + ' AND "connectionStatusTypeId" = 1';
                await this.sequelizeInstance.query(delQuery, {
                    type: sequelize_1.QueryTypes.DELETE
                });
            }
            if (+updateChannelDto.connectionStatusTypeId == config_1.appconstant.DISMISS) {
                let otherReasons = (updateChannelDto.otherreasons) ? updateChannelDto.otherreasons : null;
                await this.channelDismissReasonRepository.create({
                    channelJCTId: result.channelJCTId,
                    dismissreasonid: updateChannelDto.dismissreasonid,
                    otherreasons: otherReasons,
                    updatedby: user.userId
                });
            }
            let updateObject = {
                subscription_queued: '0'
            };
            if (suggest_Channel && +updateChannelDto.connectionStatusTypeId == config_1.appconstant.PENDINGMYPROSPECT) {
                updateObject['suggestion_connect_flag'] = '1';
            }
            if (updateChannelDto.leadManagementTag) {
                if (result.channelId == +user.channelId) {
                    updateObject['leadManagementTag'] = updateChannelDto.leadManagementTag;
                }
                else if (result.partnerChannelId == +user.channelId) {
                    updateObject['partnerLeadManagementTag'] = updateChannelDto.leadManagementTag;
                }
            }
            if (+updateChannelDto.connectionStatusTypeId == config_1.appconstant.PENDINGMYPROSPECT || updateChannelDto.connectionStatusTypeId == config_1.appconstant.REQUEST_INTRO) {
                updateObject['last_remainder_sent_at'] = this.sequelizeInstance.fn('NOW');
                updateObject['no_of_remainders_sent'] = '1';
                updateObject['introVideo'] = updateChannelDto.videoUrl;
            }
            await result.update(updateObject);
            let notificationObject = {
                senderId: user.contactId,
                receiverId: updateChannelDto.contactid,
                note: updateChannelDto.note
            };
            let status = updateChannelDto.connectionStatusTypeId;
            let notificationAction = null;
            switch (status) {
                case config_1.appconstant.PENDINGMYPROSPECT:
                    notificationAction = notificaton_constant_1.notification.REQUEST_TO_MYPROSPECT;
                    break;
                case config_1.appconstant.MAYBELATER:
                    notificationAction = notificaton_constant_1.notification.MAYBE_LATER;
                    break;
                case config_1.appconstant.DISMISS:
                    if (beforeStatus == config_1.appconstant.PENDINGMYPROSPECT) {
                        notificationAction = notificaton_constant_1.notification.MYPROSPECT_DECLINE;
                    }
                    else if (beforeStatus == config_1.appconstant.MYCHANNEL) {
                        notificationAction = notificaton_constant_1.notification.DISMISS_CHANNEL;
                    }
                    else if (beforeStatus == config_1.appconstant.PENDINGAPPROVAL) {
                        notificationAction = notificaton_constant_1.notification.MYCHANNEL_DECLINE;
                    }
                    break;
                case config_1.appconstant.MYPROSPECT:
                    notificationAction = notificaton_constant_1.notification.MYPROSPECT_APPROVAL;
                    break;
                case config_1.appconstant.PENDINGAPPROVAL:
                    notificationAction = notificaton_constant_1.notification.REQUEST_TO_MYCHANNEL;
                    break;
                case config_1.appconstant.MYCHANNEL:
                    notificationAction = notificaton_constant_1.notification.MYCHANNEL_APPROVAL;
                    break;
                default:
                    break;
            }
            return updateChannelDto;
        });
        return updateChannelDto;
    }
    async getPublicCompanyFlags(channelId) {
        let query = 'Select "channelId", "isFeatured", "isPublic" from "tblChannel" where "channelId"=:channelId';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: channelId
            }
        }).then(res => res[0]);
        return result;
    }
    async setCompanyPublicFlags(data) {
        let save = {
            isPublic: data.isPublic,
            isFeatured: data.isFeatured
        };
        let result = await this.channelRepository.update(save, { where: {
                channelId: data.channelId
            } }).then(res => res);
        return result;
    }
    async boEventCreate(data) {
        let event = data.event;
        var eventId;
        let availability = false;
        if (event.eventCatalystId) {
            let available = 'select "id" from "tblevents" where "eventCatalystId"=:eventCatId and "deletedAt" is null limit 1';
            let ifAvailable = await this.sequelizeInstance.query(available, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    eventCatId: event.eventCatalystId
                }
            });
            console.log('ifAvailable', ifAvailable);
            if (event.eventId) {
                if (ifAvailable.length && ifAvailable[0].id != event.eventId) {
                    return { error: 'Event already Registered' };
                }
                else {
                    eventId = event.eventId;
                    await EventBo_entity_1.EventBo.update(event, {
                        where: {
                            id: event.eventId,
                        }
                    });
                }
            }
            else {
                eventId = await EventBo_entity_1.EventBo.create(event).then(res => res.id);
            }
        }
        else {
            if (event.eventId) {
                eventId = event.eventId;
                await EventBo_entity_1.EventBo.update(event, {
                    where: {
                        id: event.eventId
                    }
                });
            }
            else {
                eventId = await EventBo_entity_1.EventBo.create(event).then(res => res.id);
            }
        }
        let bannerId = null;
        let companyBanner;
        if (event.eventBannerId) {
            bannerId = event.eventBannerId;
        }
        else {
            let oldBanner = await EventBo_entity_1.EventBo.findOne({
                where: { id: eventId },
                attributes: ['eventBannerId']
            }).then(res => {
                console.log('banner', res.eventBannerId);
                return res.eventBannerId;
            }).catch(err => console.log('banner error', err));
            if (oldBanner) {
                await this.mediaRepository.update({ deletedAt: new Date() }, { where: {
                        documentId: +oldBanner
                    } });
            }
            companyBanner = await this.mediaRepository.create({
                documentPath: event.eventBanner,
                documentTypeId: config_1.appconstant.DOCUMENTTYPE_IMAGE,
                dirName: config_1.appconstant.FOLDER_PATH_COMPANY_BANNER
            });
            console.log('banner', companyBanner);
            bannerId = companyBanner.documentId;
        }
        let logoId = null;
        if (event.eventLogoId) {
            logoId = event.eventLogoId;
        }
        else {
            let oldBanner = await EventBo_entity_1.EventBo.findOne({
                where: { id: eventId },
                attributes: ['eventLogoId']
            }).then(res => {
                console.log('banner', res.eventLogoId);
                return res.eventLogoId;
            }).catch(err => console.log('banner error', err));
            if (oldBanner) {
                await this.mediaRepository.update({ deletedAt: new Date() }, { where: {
                        documentId: +oldBanner
                    } });
            }
            companyBanner = await this.mediaRepository.create({
                documentPath: event.eventLogo,
                documentTypeId: config_1.appconstant.DOCUMENTTYPE_IMAGE,
                dirName: config_1.appconstant.FOLDER_PATH_COMPANY_LOGO
            });
            console.log('banner', companyBanner);
            logoId = companyBanner.documentId;
        }
        await EventBo_entity_1.EventBo.update({
            eventLogoId: logoId,
            eventBannerId: bannerId,
            updatedAt: new Date()
        }, { where: {
                id: eventId,
                deletedAt: null
            } });
        let oldPackages = await EventPackage_entity_1.EventPackage.findAll({
            where: {
                eventId: eventId,
                deletedAt: null
            },
            attributes: ['packageId']
        }).then(res => { console.log(res); return _.map(res, (x) => x.packageId); });
        if (oldPackages === null || oldPackages === void 0 ? void 0 : oldPackages.length) {
            console.log('oldPacks', oldPackages);
            let activeIds = [];
            data.packages.map(x => {
                oldPackages.map(y => {
                    if (x.packageId == y)
                        activeIds.push(x.packageId);
                });
            });
            await EventPackage_entity_1.EventPackage.update({
                deletedAt: new Date(),
                updatedAt: new Date()
            }, {
                where: {
                    eventId: eventId,
                    packageId: {
                        [sequelize_1.Op.notIn]: activeIds
                    }
                }
            }).then(res => console.log('cleared inactive packs', res)).catch(e => console.log('error ', e, activeIds));
        }
        data.packages.map(async (x) => {
            if (x.packageId) {
                await EventPackage_entity_1.EventPackage.update(Object.assign(Object.assign({}, x), { updatedAt: new Date() }), {
                    where: {
                        packageId: x.packageId,
                        deletedAt: null
                    }
                });
            }
            else {
                await EventPackage_entity_1.EventPackage.create(Object.assign(Object.assign({}, x), { eventId: eventId }));
            }
        });
        return true;
    }
    async getEventListing(eventFilter) {
        let where = {
            deletedAt: null,
        };
        let options = {
            include: [
                {
                    model: EventPackage_entity_1.EventPackage,
                    where: {
                        deletedAt: null
                    },
                    required: false
                },
                {
                    model: Country_entity_1.Country,
                    attributes: ['countryId', 'country'],
                    required: false
                },
                {
                    model: index_1.Media,
                    as: 'logo',
                    where: {
                        deletedAt: null
                    },
                    required: false
                },
                {
                    model: index_1.Media,
                    as: 'banner',
                    where: {
                        deletedAt: null
                    },
                    required: false
                }
            ]
        };
        let result = {};
        result.count = await EventBo_entity_1.EventBo.count(options);
        console.log('result.count', result.count);
        result.aggregation = await EventBo_entity_1.EventBo.findAll({
            include: [
                {
                    model: EventPackage_entity_1.EventPackage,
                    where: {
                        deletedAt: null
                    },
                    required: false
                },
                {
                    model: Country_entity_1.Country,
                    attributes: ['countryId', 'country'],
                    required: false
                },
                {
                    model: index_1.Media,
                    as: 'logo',
                    where: {
                        deletedAt: null
                    },
                    required: false
                },
                {
                    model: index_1.Media,
                    as: 'banner',
                    where: {
                        deletedAt: null
                    },
                    required: false
                }
            ]
        });
        options['limit'] = eventFilter.limit;
        options['offset'] = eventFilter.page;
        result.rows = await EventBo_entity_1.EventBo.findAll(options);
        return result;
    }
    async getEventById(eventId) {
        let result = {};
        result = await EventBo_entity_1.EventBo.findAll({
            where: {
                id: eventId,
                deletedAt: null
            },
            include: [
                {
                    model: EventPackage_entity_1.EventPackage,
                    where: {
                        deletedAt: null
                    },
                    required: false
                },
                {
                    model: Country_entity_1.Country,
                    attributes: ['countryId', 'country'],
                    required: false
                },
                {
                    model: index_1.Media,
                    as: 'logo',
                    attributes: ['documentId', 'documentPath'],
                    where: {
                        deletedAt: null
                    },
                    required: false
                },
                {
                    model: index_1.Media,
                    as: 'banner',
                    attributes: ['documentId', 'documentPath'],
                    where: {
                        deletedAt: null
                    },
                    required: false
                }
            ]
        });
        return result;
    }
    async getEventDetailsById(eventId) {
        let result = {};
        result.eventDetails = await EventBo_entity_1.EventBo.findAll({
            where: {
                id: eventId,
                deletedAt: null
            },
            include: [
                {
                    model: EventPackage_entity_1.EventPackage,
                    where: {
                        deletedAt: null
                    },
                    required: false
                },
                {
                    model: Country_entity_1.Country,
                    attributes: ['countryId', 'country'],
                    required: false
                },
                {
                    model: index_1.Media,
                    as: 'logo',
                    attributes: ['documentId', 'documentPath'],
                    where: {
                        deletedAt: null
                    },
                    required: false
                },
                {
                    model: index_1.Media,
                    as: 'banner',
                    attributes: ['documentId', 'documentPath'],
                    where: {
                        deletedAt: null
                    },
                    required: false
                },
            ]
        }).then(res => res[0]);
        let eventChannels = await EventChannel_entity_1.EventChannel.findAll({
            where: {
                eventId: eventId,
                deletedAt: null
            },
            include: [
                {
                    model: Channel_entity_1.Channel,
                    include: [
                        {
                            model: Contact_entity_1.Contact,
                            as: 'contacts',
                            include: [{
                                    model: EventParticipants_entity_1.EventParticipants,
                                    required: false,
                                    include: [
                                        {
                                            model: EventPackage_entity_1.EventPackage,
                                            required: false
                                        }
                                    ]
                                },
                                {
                                    model: index_1.Media,
                                    required: false
                                }
                            ]
                        }
                    ]
                },
            ]
        });
        result.eventChannels = eventChannels;
        return result;
    }
    async eventAvailabilityCheck(eventCatId, eventId) {
        let result = [];
        let available = 'select * from "tblevents" where "eventCatalystId"=:eventCatId and "deletedAt" is null limit 1';
        if (eventId) {
            available = 'select "id" from "tblevents" where "eventCatalystId"=:eventCatId and "deletedAt" is null limit 1';
        }
        result = await this.sequelizeInstance.query(available, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                eventCatId: eventCatId,
            }
        });
        if (result.length) {
            if (result[0].id == eventId)
                return true;
            else
                return false;
        }
        else
            return true;
    }
    async getEventChannelDetails(channelId, eventId) {
        let result = { participants: [], contacts: [] };
        let participantQuery = 'select tc."contactId" as "id", concat(tc."firstName",  \' \', tc."lastName") as "name", td."documentPath", tpar."eventParticipantId" from "tblEventParticipants" tpar inner join "tblContact" tc on tc."contactId"=tpar."contactId" left join "tblDocument" td on td."documentId"=tc."documentId" where tpar."channelId"=:channelId and tpar."eventId"=:eventId';
        result.participants = await this.sequelizeInstance.query(participantQuery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: channelId,
                eventId: eventId
            }
        }).then(res => res);
        let contactsQuery = 'select tc."contactId" as "id", concat(tc."firstName", \' \', tc."lastName") as "name", td."documentPath"  from "tblContact" tc left join "tblDocument" td on td."documentId"=tc."documentId" where tc."channelId"=:channelId and tc."deletedAt" is null';
        result.contacts = await this.sequelizeInstance.query(contactsQuery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: channelId,
            }
        });
        return result;
    }
    async boEventUserManage(data) {
        console.log(data);
        let contactId = data.contactId;
        let channelId = data.channelId;
        let eventId = data.eventId;
        let participantType = data.pType;
        let channelType = data.cType;
        let registeredQuery = 'select "contactId", "eventParticipantId", status from "tblEventParticipants" where "channelId"=:channelId and "eventId"=:eventId  and "deletedAt" is null';
        let oldIds = await this.sequelizeInstance.query(registeredQuery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: channelId,
                eventId: eventId
            }
        });
        let activeId = [];
        oldIds.map(x => {
            contactId.map(y => {
                if (x.contactId == y)
                    activeId.push(y);
            });
        });
        await this.eventParticipantRepository.destroy({ where: {
                eventId: eventId,
                channelId: channelId,
                contactId: {
                    [sequelize_1.Op.notIn]: activeId
                }
            } });
        console.log('activeId', activeId);
        let newRegisteredUsers = [];
        if (activeId.length)
            contactId.map(x => {
                if (activeId.filter(y => x == y).length == 0)
                    newRegisteredUsers.push(x);
            });
        else
            newRegisteredUsers = contactId;
        if (newRegisteredUsers.length) {
            let newContacts = newRegisteredUsers.map(x => {
                let data = { contactId: +x, channelId: +channelId, eventId: +eventId, channelType: +channelType, participantType: +participantType };
                return data;
            });
            console.log('new users', newContacts);
            await this.eventParticipantRepository.bulkCreate(newContacts);
        }
        return true;
    }
    async boToEventCatalyst(contacts) {
        let query = 'select (select concat(\'https://d35w8j22j5uly8.cloudfront.net\',"documentPath") from "tblDocument" where "documentId"=tcon."documentId") as profileImage, '
            + ' "firstName","lastName","jobTitle","contactId",tcon."mobileNo",tcon."email",tc."companyName",tc."channelId" as companyId, cd."detailDesc",case when tc."channelTypeId"=2 then \'Vendor\' when tc."channelTypeId"=3 then \'Distributor\' when tc."channelTypeId"=4 then \'Retailer\' end as channelType, '
            + ' (select concat(\'https://d35w8j22j5uly8.cloudfront.net\',"documentPath") from "tblDocument" where "documentId"=cd."channelLogoId") as companyLogo, '
            + '\'3e683a61-992b-47d2-8ecf-f88c9849f499\' as eventId,\'Confirmed\' as status, '
            + ' case when tc."channelTypeId"=2 then \'Vendor\' when tc."channelTypeId" in(3,4) then \'Buyer\' end as type, '
            + ' (select "country" from "tblCountry" where "countryId"=tc."countryId"),'
            + ' (select "isoCode" from "tblCountry" where "countryId"=tc."countryId"),(select string_agg("productCategorie",\',\') from "tblProductCategories" where "productCategorieId" in '
            + '(Select cpc."productCategorieId" from "tblContactInterestedProductCategory" cpc where cpc."contactId" = tcon."contactId"))as "IntrestedCategory", '
            + '(select string_agg("productCategorie",\',\') from "tblProductCategories" where "productCategorieId" in '
            + '(Select cpc."productCategorieId" from "tblContactProductCategorie" cpc where cpc."contactId" = tcon."contactId")) as "ExistingCategory", '
            + '(select "profileType" from "tblProfileType" where "profileTypeId"=tc."profileTypeId") as "ProfileType", '
            + '(select string_agg(pt."profileType",\',\') from "tblProfileType" pt where "profileTypeId" in (select "profileTypeId" from "tblChannelCustomerProfile" as ccp where ccp."channelId"=tc."channelId")) as "Retail_Customer_Profile", '
            + '(select "password" from "tblUser" where "contactId"=tcon."contactId") '
            + 'from "tblContact" tcon inner join "tblChannel" tc on tc."channelId"=tcon."channelId"	inner join "tblChannelDetail" cd on cd."channelId"=tcon."channelId" where tcon."contactId" in (:contactId)';
        let result;
        if (contacts.length) {
            result = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                replacements: {
                    contactId: contacts
                }
            });
        }
        return result;
    }
    async companyNameList(search) {
        return await this.channelRepository.findAll({
            where: {
                companyName: { [sequelize_1.Op.iLike]: '%' + search + '%' },
                deletedAt: null,
                isActive: '1'
            },
            attributes: ['companyName', 'channelId', 'channelTypeId', 'isOEM'],
            include: [
                {
                    model: Country_entity_1.Country,
                    attributes: ['country']
                },
                {
                    model: this.channelDetailRepository,
                    attributes: ['channelLogoId'],
                    where: { deletedAt: null },
                    required: true,
                    include: [
                        {
                            model: this.mediaRepository,
                            as: 'channelLogo',
                            attributes: ['documentUrl', 'documentPath'],
                            required: false
                        }
                    ]
                },
                {
                    model: User_entity_1.User,
                    attributes: ['userId', 'contactId'],
                    include: [{
                            model: UserRole_entity_1.UserRole,
                            attributes: ['roleId'],
                            where: {
                                roleId: 1
                            },
                            required: true
                        }]
                }
            ],
            limit: 10
        });
    }
    async contactNameList(search) {
        return await this.contactRepository.findAll({
            where: {
                [sequelize_1.Op.or]: {
                    firstName: { [sequelize_1.Op.iLike]: '%' + search + '%' },
                    lastName: { [sequelize_1.Op.iLike]: '%' + search + '%' }
                },
                deletedAt: null,
                isActive: '1'
            },
            attributes: ['firstName', 'lastName', 'contactId', 'jobTitle'],
            include: [
                {
                    model: index_1.Media,
                    attributes: ['documentUrl', 'documentPath']
                },
                {
                    model: Country_entity_1.Country,
                    attributes: ['country']
                },
                {
                    model: this.channelRepository,
                    attributes: ['companyName', 'channelId', 'channelTypeId'],
                    where: { deletedAt: null },
                    required: true,
                }
            ],
            limit: 10
        });
    }
    async getContact(contactId) {
        return await this.contactRepository.scope('contactInfo').findOne({
            where: {
                contactId: contactId,
                deletedAt: null
            },
            include: [
                {
                    model: index_1.Media,
                    attributes: ['documentPath', 'documentId', 'thumbnailPath'],
                    required: false,
                },
                {
                    model: ContactProductGroup_entity_1.ContactProductGroup,
                    where: {
                        deletedAt: null
                    },
                    include: [{
                            model: ProductGroup_entity_1.ProductGroup,
                            attributes: ['productGroup']
                        }],
                    required: false,
                },
                {
                    model: this.countryRepository,
                    attributes: ['country'],
                    required: false,
                },
                {
                    model: User_entity_1.User,
                    attributes: ['contactId', 'userId'],
                    include: [{
                            model: UserRole_entity_1.UserRole,
                            attributes: ['roleId']
                        }]
                }
            ]
        });
    }
    async getChannel(channelId) {
        try {
            let channel = await this.channelRepository.scope('channelDetail').findOne({
                where: {
                    channelId: channelId,
                    deletedAt: null
                },
                include: [
                    {
                        model: ChannelB2B_entity_1.ChannelB2B,
                        as: 'channelB2B',
                        attributes: ['channelB2BId', 'channelId', 'channelB2B'],
                        where: { deletedAt: null },
                        required: false,
                    },
                    { model: Country_entity_1.Country, as: 'country', where: { deletedAt: null }, required: false },
                    { model: Address_entity_1.Address, as: 'regAddress' },
                    { model: ProfileType_entity_1.ProfileType.scope('channelDetail'), as: 'profileType', attributes: ['profileType'], where: { deletedAt: null }, required: false },
                    {
                        model: this.productGroupRepository,
                        as: 'speciality',
                        attributes: ['productGroupId', 'productGroup'],
                        required: false,
                        where: { isActive: '1' },
                        through: { attributes: [], where: { deletedAt: null } }
                    },
                    {
                        model: this.productCategoryRepository,
                        as: 'productCategory',
                        attributes: ['productCategorieId', 'productCategorie'],
                        required: false,
                        where: { isActive: '1' },
                        order: 'productCategorie',
                        through: { attributes: [], where: { deletedAt: null } }
                    },
                    {
                        model: ChannelAward_entity_1.ChannelAward,
                        attributes: ['awardDetail', 'issuedBy', 'validUpto', 'isLifeTime'],
                        where: { deletedAt: null },
                        required: false
                    }
                ]
            });
            if (!channel)
                return false;
            if (!channel.channelDetail) {
                await new utility_1.Utility().lazyload(channel, 'channelDetail', {
                    where: { deletedAt: null },
                    required: false,
                    attributes: ['channelLogoId', 'channelIconId', 'webSiteUrl', 'estYear', 'regYear', 'detailDesc', 'expectations', 'companyDesc', 'empCntRange', 'empCnt', 'empCntDSale', 'empCntISale', 'empCntDMar', 'empCntIMar', 'turnoverRange', 'turnover', 'revD', 'revI', 'deletedAt', 'turnoverPhyStore', 'turnoverOnStore', 'startup', 'storeCount', 'maturitylevel', 'keyretailers', 'keyresellers', 'keydistributors', 'no_of_retailers', 'no_of_resellers', 'no_of_skus', 'no_of_distributors', 'no_of_vendors', 'introvideoId', 'channelBannerId', 'phone1', 'mobileNo'],
                    include: [{
                            model: index_1.Media,
                            as: 'channelLogo',
                            attributes: ['documentUrl', 'documentPath'],
                            where: { deletedAt: null },
                            required: false
                        },
                        {
                            model: index_1.Media,
                            as: 'channelIcon',
                            where: { deletedAt: null },
                            attributes: ['documentUrl'],
                            required: false
                        },
                        {
                            model: index_1.Media,
                            as: 'introvideo',
                            where: { deletedAt: null },
                            required: false
                        },
                        {
                            model: index_1.Media,
                            as: 'channelBanner',
                            where: { deletedAt: null },
                            required: false
                        }
                    ],
                });
            }
            if (!channel.serviceList) {
                await new utility_1.Utility().lazyload(channel, 'serviceList', {
                    through: { attributes: [], where: { deletedAt: null } },
                    required: false,
                    attributes: ['serviceListId', 'serviceList']
                });
            }
            if (!channel.channelLocation) {
                await new utility_1.Utility().lazyload(channel, 'channelLocation', {
                    where: { deletedAt: null },
                    required: false,
                    attributes: ['locationType'],
                    include: [{
                            model: RegionCountryJCT_entity_1.RegionCountryJCT,
                            where: { deletedAt: null },
                            required: false,
                            include: [
                                {
                                    model: Country_entity_1.Country,
                                    where: { deletedAt: null },
                                    attributes: ['countryId', 'country', 'priority'],
                                    required: false
                                }
                            ],
                        }]
                });
            }
            if (!channel.channelBrand) {
                await new utility_1.Utility().lazyload(channel, 'channelBrand', {
                    where: { deletedAt: null },
                    required: false,
                    include: [{
                            model: Brand_entity_1.Brand.scope('channelDetail'),
                            as: 'brand',
                            where: { deletedAt: null, isActive: '1' },
                            required: false,
                            include: [{
                                    model: index_1.Media,
                                    as: 'document',
                                    where: { deletedAt: null },
                                    required: false
                                }]
                        }]
                });
            }
            if (!channel.contacts) {
                await new utility_1.Utility().lazyload(channel, 'contacts', {
                    where: { deletedAt: null, isActive: '1' },
                    required: true,
                    attributes: ['contactId', 'firstName', 'lastName', 'phone1', 'mobileNo', 'email', 'responsibilityId', 'linkedIn', 'jobTitle', 'googleplus', 'isDefaultContact', 'empId', 'isActive', 'deletedAt', 'documentId', 'countryId'],
                    include: [
                        {
                            model: User_entity_1.User.scope('channelDetail'),
                            where: { deletedAt: null },
                            required: true,
                            include: [
                                {
                                    model: UserRole_entity_1.UserRole,
                                    where: {
                                        roleId: Role_entity_1.Role.ROLE_ACCOUNT_USER
                                    },
                                    required: true,
                                }
                            ]
                        },
                        {
                            model: ContactSocialLink_entity_1.ContactSocialLink,
                            where: { deletedAt: null },
                            required: false,
                            include: [{
                                    model: SocialSite_entity_1.SocialSite.scope('channelDetail'),
                                    where: { deletedAt: null },
                                    required: false
                                }]
                        },
                        {
                            model: index_1.Media,
                            as: 'document',
                            required: false,
                        },
                        {
                            model: this.productCategoryRepository.scope('contactProductInfom'),
                            as: 'IntProductCategories',
                            where: { deletedAt: null, isActive: "1" },
                            required: false,
                            through: { attributes: [], where: { deletedAt: null } }
                        },
                        { model: Country_entity_1.Country, as: 'country', where: { deletedAt: null }, required: false },
                    ]
                });
            }
            if (!channel.channelSocial) {
                await new utility_1.Utility().lazyload(channel, 'channelSocial', {
                    where: { deletedAt: null },
                    required: false,
                    include: [{
                            model: SocialSite_entity_1.SocialSite.scope('channelDetail'),
                            where: { deletedAt: null },
                            attributes: ['socialSite'],
                            required: false
                        }]
                });
            }
            if (!channel.channelCertificate) {
                await new utility_1.Utility().lazyload(channel, 'channelCertificate', {
                    where: { deletedAt: null },
                    attributes: ['cerificateTypeId', 'cerificateName', 'cerificateNumber', 'cerificateDesc'],
                    required: false
                });
            }
            if (!channel.channelSubscription) {
                await new utility_1.Utility().lazyload(channel, 'channelSubscription', {
                    where: { isActive: '1' },
                    required: false,
                    include: [{
                            model: this.subscriptionRepository.scope('channelDetail'),
                            as: 'subscription',
                            where: { deletedAt: null, isActive: '1' },
                            required: false,
                            include: [{
                                    model: SubscriptionPlan_entity_1.SubscriptionPlan.scope('channelDetail'),
                                    as: 'subscriptionPlan',
                                    where: { deletedAt: null, isActive: '1' },
                                    required: false
                                }],
                        }]
                });
            }
            if (!channel.channelDocument) {
                await new utility_1.Utility().lazyload(channel, 'channelDocument', {
                    attributes: ['channelDocumentId', 'documentId', 'name', 'description'],
                    where: { deletedAt: null },
                    required: false,
                    include: [{
                            attributes: ['documentId', 'documentPath', 'documentUrl'],
                            where: { deletedAt: null, documentTypeId: 2 },
                            model: this.mediaRepository,
                            required: true,
                        }]
                });
            }
            channel.toJSON();
            channel['channelKeyRetailer'] = await this.channelKeyPartnerService.getKeyRetailers(+channel.channelId, config_1.appconstant.CHANNEL_TYPE_RETAILER);
            channel['channelKeyReseller'] = await this.channelKeyPartnerService.getKeyRetailers(+channel.channelId, config_1.appconstant.CHANNEL_TYPE_RESELLER);
            channel['channelKeyDistributor'] = await this.channelKeyPartnerService.getKeyRetailers(+channel.channelId, config_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR);
            let custquery = 'select tpt."profileType", tptc."channelTypeId" from "tblChannelCustomerProfile" tcp inner join "tblProfileTypeClassification" tptc on tcp."profileTypeClassificationId"=tptc."profileTypeClassificationId" inner join "tblProfileType" tpt on tpt."profileTypeId"=tptc."profileTypeId" where tcp."channelId"=:channelId and tcp."deletedAt" is null';
            channel['customerProfile'] = await await this.sequelizeInstance.query(custquery, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelId: +channel.channelId
                }
            });
            if (channel.channelTypeId == config_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR || channel.channelTypeId == config_1.appconstant.CHANNEL_TYPE_RETAILER) {
                channel['sampleOrderCount'] = await this.getSampleOrderCount(channelId);
                channel['sampleEvaluationCount'] = await this.getSampleEvaluationCount(channelId);
            }
            channel['productCount'] = await this.productRepository.count({
                where: {
                    channelId: channelId,
                    isactive: '1',
                    deletedat: null
                }
            });
            channel['certificateType'] = await this.channelCertificateTypeRepository.findAll({
                where: { deletedAt: null }
            });
            let query = 'select "productCategorieId", "productCategorie" from "tblProductCategories" where "productCategorieId" in(select "productCategorieId" from "tblInterestedProductCategory" where "channelId"=:channelId and "deletedAt" is null) order by "productCategorie"';
            let userProductCat = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelId: channelId
                }
            });
            let companyImages = await this.companyMediaImagesRepository.findAll({
                where: {
                    channelId: +channel.channelId,
                    deletedAt: null
                },
                include: [{
                        model: index_1.Media,
                        where: {
                            documentTypeId: 1,
                            deletedAt: null
                        },
                        required: true
                    }],
                order: [['companyMediaId', 'DESC']]
            });
            let resultObject = await this.channelDetailOutBound.channelDetail(channel, userProductCat, companyImages);
            return resultObject;
        }
        catch (e) {
            console.log("Error+ ", e);
            throw new common_1.InternalServerErrorException();
        }
    }
    async getSampleOrderCount(channelId) {
        try {
            return await SampleOrder_entity_1.SampleOrder.count({
                where: {
                    buyerchannelid: channelId,
                    statusid: { [sequelize_1.Op.ne]: config_1.appconstant.ORDER_STATUS_CANCELED }
                }
            });
        }
        catch (e) {
            console.log("Error+ ", e);
            throw new common_1.InternalServerErrorException();
        }
    }
    async getSampleEvaluationCount(channelId) {
        try {
            return await ProductEvaluation_entity_1.ProductEvaluation.count({
                where: {
                    channelid: channelId,
                    deletedat: null
                }
            });
        }
        catch (e) {
            console.log("Error+ ", e);
            throw new common_1.InternalServerErrorException();
        }
    }
    async oldChannelsList(userId) {
        let cquery = 'select "typeId" from "tblAdminUserChanneltype" where "adminUserId"=:userId';
        let chtypes = await this.sequelizeInstance.query(cquery, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                userId: userId
            }
        }).then((results) => {
            return results.map(x => +x.typeId);
        });
        cquery = 'select "countryId" from "tblAdminUserCountries" where "adminUserId"=:userId';
        let countries = await this.sequelizeInstance.query(cquery, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                userId: userId
            }
        }).then((results) => {
            return results.map(x => +x.countryId);
        });
        let channelFilter = {
            isActive: '1',
            deletedAt: null
        };
        if (countries && countries.length > 0) {
            channelFilter['countryId'] = { [sequelize_1.Op.in]: countries };
        }
        if (chtypes && chtypes.length > 0) {
            channelFilter['channelTypeId'] = { [sequelize_1.Op.in]: chtypes };
        }
        return await this.oldChannelRepository.findAll({
            where: channelFilter,
            attributes: [["companyName", "name"], ["oldChannelId", "id"]],
            include: [{
                    model: OldContact_entity_1.OldContact,
                    as: 'oldContacts',
                    where: { deletedAt: null, isDefaultContact: '1' },
                    required: false,
                    attributes: ["firstName", "lastName", "oldContactId"],
                }]
        });
    }
    async oldChannels(data) {
        let channelFilter = data.filter;
        let userId = 1;
        let filterch = [];
        let channeltype = [2, 3, 4];
        let aggregation = {};
        let channelquery;
        let order = data.order;
        channelquery = 'select "oldChannelId" as channel_id from "tblOldChannel" where "channelTypeId" in(:channelTypeId) and "isActive"=\'1\' and "deletedAt" is null';
        let result = await this.sequelizeInstance.query(channelquery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelTypeId: channeltype
            }
        }).then(x => {
            return _.uniqBy(x, 'channel_id');
        });
        if (data.search) {
            let searchchannellist = await this.sequelizeInstance.query('select "oldChannelId" as channel_id from "tblOldChannel" where "oldChannelId" = (:search)', {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    search: +data.search,
                }
            });
            let chl = searchchannellist.map(x => x.channel_id);
            result = result.filter(ch => { return chl.includes(ch.channel_id); });
        }
        if (channelFilter.typeId && result) {
            let chlist = result.map(x => +x.channel_id);
            let ctype = 'select array_agg("oldChannelId") as ch from "tblOldChannel" where "channelTypeId" in(:channeltypeid) and "oldChannelId" in(:channelid)';
            await this.sequelizeInstance.query(ctype, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelid: chlist,
                    channeltypeid: +channelFilter.typeId
                }
            }).then((result) => {
                if (result[0].ch)
                    filterch.push(...result[0].ch);
            });
            result = result.filter(ch => { return filterch.includes(ch.channel_id); });
        }
        if ((channelFilter.turnOver || channelFilter.brandId || channelFilter.locationId || channelFilter.countryId || channelFilter.specialityId || channelFilter.productCategoryId || channelFilter.retailerprofileId) && result) {
            let chlist = result.map(x => +x.channel_id);
            if (channelFilter.turnOver) {
                let query;
                if (channelFilter.turnOver == '<1M€') {
                    query = 'select array_agg("oldChannelId") as ch from "tblOldChannelDetail" where "oldChannelId" in(:channelid) and case when "turnoverRange"=\'<1M€\' or cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)<1 or "turnover"<1 then cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)<1 or "turnoverRange"=\'<1M€\' or "turnover"<1 end';
                }
                else if (channelFilter.turnOver == '1-10M€') {
                    query = 'select  array_agg("oldChannelId") as ch from "tblOldChannelDetail" where "oldChannelId" in(:channelid) and case when "turnoverRange"=\'1-10M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\'))as int)>1 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<10) or ("turnover">1 and "turnover"<10) then "turnoverRange"=\'1-10M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\'))as int)>1 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<10) or ("turnover">1 and "turnover"<10) end';
                }
                else if (channelFilter.turnOver == '10-100M€') {
                    query = 'select  array_agg("oldChannelId") as ch from "tblOldChannelDetail" where "oldChannelId" in(:channelid) and "turnoverRange"!=\'>100M€\' and case when "turnoverRange"=\'10-100M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\')) as int)>10 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<=100) or ("turnover">10 and "turnover"<=100) then "turnoverRange"=\'10-100M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\')) as int)>10 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<=100) or ("turnover">10 and "turnover"<=100) end';
                }
                else if (channelFilter.turnOver == '>100M€') {
                    query = 'select array_agg("oldChannelId") as ch from "tblOldChannelDetail" where "oldChannelId" in(:channelid) and case when "turnoverRange"=\'>100M€\' or cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)>100 or "turnover">100 then cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)>100 or "turnoverRange"=\'>100M€\' or "turnover">100 end';
                }
                await this.sequelizeInstance.query(query, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.brandId) {
                let brand = 'select array_agg("oldChannelId") as ch from "tblOldChannelBrand" where "brandId" in(:brandid) and "oldChannelId" in(:channelid)';
                await this.sequelizeInstance.query(brand, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist,
                        brandid: channelFilter.brandId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.productCategoryId) {
                await this.sequelizeInstance.query('select array_agg("oldChannelId") as ch from "tblOldChannelProductCategorie" cpc where cpc."productCategorieId" in(:productcatid) and "oldChannelId" in(:channelid) ', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        productcatid: channelFilter.productCategoryId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.retailerprofileId) {
                await this.sequelizeInstance.query('select array_agg("oldChannelId") as ch from "tblOldChannelCustomerProfile" where "profileTypeId" in(:retailprofileid) and "oldChannelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        retailprofileid: channelFilter.retailerprofileId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.countryId) {
                await this.sequelizeInstance.query('select array_agg("oldChannelId") as ch from "tblOldChannel" where "countryId" in(:countryid) and "oldChannelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        countryid: channelFilter.countryId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.specialityId) {
                await this.sequelizeInstance.query('select array_agg(distinct "oldChannelId") as ch from "tblOldContact" where "oldContactId" in(Select "oldContactId" from "tblContactInterestedProductCategory" where "productCategorieId" in(:specialityid)) and "oldChannelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        specialityid: channelFilter.specialityId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.locationId) {
                await this.sequelizeInstance.query('select array_agg("oldChannelId") as ch from "tblOldChannel" where "countryId" in(:locationid) and "oldChannelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        locationid: channelFilter.locationId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            result = result.filter(ch => { return filterch.includes(ch.channel_id); });
        }
        let total = result ? result.length : 0;
        let final = [];
        if (result) {
            let ordered = await this.sequelizeInstance.query('select "oldChannelId" from "tblOldChannel" where "oldChannelId" in(:channelid)  order by "companyName" asc', {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelid: result.map(x => x.channel_id),
                }
            }).then(res => {
                return res.map(x => x.oldChannelId);
            });
            result = await this.mapOrder(result, ordered, 'channel_id');
            result = result.slice(data.page).slice(0, data.limit);
            for (let i = 0; i < result.length; i++) {
                let status = 'Non Suggestion';
                let mscore = null;
                let relation_status = null;
                let isConfidential = 1;
                let channeljct = null;
                let transToContact = null;
                let note = null;
                let companyquery;
                try {
                    companyquery = 'Select ' + mscore + ' as matchingScore,' + relation_status + ' as relation_status,\'Non Member\' as status,' + isConfidential + ' as isConfidential,' + channeljct + ' as channel_jct_id,' + transToContact + ' as transToContact,' + note + ' as note,ch."oldChannelId" as cid,case when chd."turnover" is null then chd."turnoverRange" when chd."turnover" is not null then cast(chd."turnover" as text) end as turnover,ch."companyName" as companyname,ch."countryId" as countryid, tc."country" as country, tc."isoCode", pt."profileType" as profiletype, cht."channelType" as channeltype,ch."channelTypeId" as channeltypeid,'
                        + 'chd."detailDesc" as detaildesc, chd."webSiteUrl" as websiteurl, chd."startup",(select array_to_json(array_agg(row_to_json(a))) from (select SUBSTRING ( cast(chd."maturitylevel" as TEXT) ,2 , length(cast(chd."maturitylevel" as TEXT))-2) as item_name)a) as looking_startups, '
                        + '(select distinct channelgroupid as favorite from "tblproductwishlist" fav where fav."userid"=' + userId + ' and fav."channelid"=ch."oldChannelId" and "productid" is null and "deletedat" is null fetch first row only), '
                        + '(Select td."documentPath" as logo from "tblOldChannelDetail" chd inner join "tblDocument" td on td."documentId" in(chd."channelLogoId") where chd."oldChannelId"=ch."oldChannelId"), '
                        + '(select array_to_json(array_agg(row_to_json(c))) from (Select td."documentPath",con."isDefaultContact",con."firstName",con."lastName",con."jobTitle" from "tblOldContact" con left join "tblDocument" td on td."documentId" in(con."documentId") where con."oldChannelId"=ch."oldChannelId")c)as contacts, '
                        + '(select array_to_json(array_agg(row_to_json(x))) from (Select pc."productCategorie" as item_name from "tblOldChannelProductCategorie" cpc inner join "tblProductCategories" pc on pc."productCategorieId" = cpc."productCategorieId" where cpc."oldChannelId"=ch."oldChannelId")x) as company_cat, '
                        + '(select array_to_json(array_agg(row_to_json(z))) from (Select pt."profileType" as item_name from "tblProfileType" pt where "profileTypeId" in (select "profileTypeId" from "tblOldChannelCustomerProfile" as ccp where ccp."oldChannelId"=ch."oldChannelId"))z) as retail_customer_profile '
                        + 'from "tblOldChannel" ch inner join "tblOldChannelDetail" chd on chd."oldChannelId" = ch."oldChannelId" inner join "tblCountry" tc on tc."countryId" = ch."countryId" '
                        + 'inner join "tblProfileType"pt on pt."profileTypeId" = ch."profileTypeId" inner join "tblChannelType" as cht on cht."channelTypeId" = ch."channelTypeId" where ch."oldChannelId" in(:channelid)';
                    let res = await this.sequelizeInstance.query(companyquery, {
                        type: sequelize_1.QueryTypes.SELECT,
                        raw: true,
                        replacements: {
                            channelid: result[i].channel_id,
                        }
                    });
                    final.push(...res);
                }
                catch (e) {
                    console.log("error:", e);
                }
            }
        }
        else
            result = [];
        let resultformat = {
            results: final,
            aggregation: aggregation,
            total: total
        };
        return resultformat;
    }
    async getOldChannelDetailView(oldChannelId) {
        var _a;
        let result;
        let oldchanneldetails = await this.getOldChannelDetails(oldChannelId);
        let facts = await this.getOldChannelFacts(oldChannelId);
        let socialLinks = [];
        if ((_a = oldchanneldetails.channelSocial) === null || _a === void 0 ? void 0 : _a.length) {
            socialLinks = oldchanneldetails.channelSocial.map(x => {
                var _a;
                return { social: (_a = x.socialSite) === null || _a === void 0 ? void 0 : _a.socialSite, link: x.channelSocialLink };
            });
        }
        result = Object.assign(Object.assign(Object.assign({}, oldchanneldetails), facts), (socialLinks.length && { socialLinks: socialLinks }));
        return result;
    }
    async getOldChannelDetails(oldChannelId) {
        let result;
        let query = `select (select json_build_object('addressId', "oldAddressId", 'address', "address", 'city', "city",'countryId', "countryId",'postalCode', "postalCode") as "regAddress" from "tblOldAddress" where "oldAddressId"=ch."regAddressId"),

     (select (array_agg(to_json(q))) from (select 
        ocs.*, to_json(s.*) "socialSite" from "tblOldChannelSocialLink" ocs inner join "tblSocialSite" s on s."socialSiteId"= ocs."socialSiteId" where ocs."oldChannelId"= ch."oldChannelId" )q) as "channelSocial",

    (select "documentPath" from "tblDocument" where "documentId"=chd."channelLogoId") as "channelLogo",
    (select "documentPath" from "tblDocument" where "documentId"=chd."introvideoId") as "introVideo",
    (select "documentPath" from "tblDocument" where "documentId"=chd."channelBannerId") as "banner",
    case when ch."channelTypeId"=2 then 'VENDOR'
    when ch."channelTypeId"=3 then 'DISTRIBUTOR'
    when ch."channelTypeId"=4 then 'RETAILER'
    when ch."channelTypeId"=5 then 'RESELLER' end as "channelType",
    cc."country", cc."phoneCode", cc."isoCode", 
    ch."companyName",ch."companyMail", "detailDesc","webSiteUrl","phone1" as  "phoneno","estYear" ,"mobileNo", "empCntRange", "empCnt",
     "turnover", "turnoverRange", "startup", "storeCount", "introvideoId", "channelBannerId", ch."channelTypeId",ch."oldChannelId" from "tblOldChannelDetail" as chd
    inner join "tblOldChannel" as ch on ch."oldChannelId"=chd."oldChannelId" inner join "tblCountry" as cc on cc."countryId"=ch."countryId" where ch."oldChannelId"=:oldChannelId`;
        try {
            result = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    oldChannelId: oldChannelId,
                }
            }).then(res => res[0]);
        }
        catch (e) {
            console.log("error", e);
        }
        return result;
    }
    async getOldChannelFacts(oldChannelId) {
        let result;
        let query = `select 
    "estYear" , "empCntRange", "empCnt", "maturitylevel",
     "turnover", "turnoverRange", "startup", "storeCount", ch."channelTypeId",ch."oldChannelId" from "tblOldChannelDetail" as chd
    inner join "tblOldChannel" as ch on ch."oldChannelId"=chd."oldChannelId" inner join "tblCountry" as cc on cc."countryId"=ch."countryId" where ch."oldChannelId"=:oldChannelId`;
        try {
            result = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    oldChannelId: oldChannelId,
                }
            }).then(res => res[0]);
        }
        catch (e) {
            console.log("error", e);
        }
        return result;
    }
    async getOldProducts(oldChannelId) {
        let result = { productGroup: [] };
        let query = `select pg."productGroupId" as groupId,pg."productGroup" as groupname,pc."productCategorieId" as childId,pc."productCategorie" as childname,cast(false as boolean) as status from "tblProductGroup" as pg inner join
    "tblProductCategories" as pc on pg."productGroupId"=pc."productGroupId" where pc."productCategorieId" in(select "productCategorieId" from "tblOldChannelProductCategorie" where "oldChannelId"=:oldChannelId)`;
        try {
            result.productGroup = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    oldChannelId: oldChannelId,
                }
            }).then(res => res);
        }
        catch (e) {
            console.log("error", e);
        }
        return result;
    }
    async getOldChannelBrand(oldChannelId) {
        let result = { brand: [] };
        let query = `select "brandName","id",json_build_object('document', doc.*) as document, doc."documentId" as doc_id,doc."documentPath" as documentPath from "tblBrand" as br inner join "tblDocument" as doc on doc."documentId"=br."documentId" where br."id" in
    (select "brandId" from "tblOldChannelBrand" where "oldChannelId"=:oldChannelId)`;
        try {
            result.brand = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    oldChannelId: oldChannelId,
                }
            }).then(res => res);
        }
        catch (e) {
            console.log("error", e);
        }
        return result;
    }
    async channelProfileOld(oldChannelId) {
        let tradeinfo = await OldChannel_entity_1.OldChannel.findAll({
            attributes: ['oldChannelId', 'profileTypeId'],
            where: {
                oldChannelId: oldChannelId
            },
            include: [
                {
                    model: OldChannelCustomerProfile_entity_1.OldChannelCustomerProfile,
                    as: 'channelCustomerProfile',
                    attributes: ['profileTypeId', 'profileTypeClassificationId'],
                    where: {
                        deletedAt: null
                    }
                },
                {
                    model: OldChannelSpeciality_entity_1.OldChannelSpeciality,
                    as: 'channelSpeciality',
                    where: { deletedAt: null },
                    required: false,
                    include: [
                        {
                            model: this.productGroupRepository,
                            as: 'productGroup',
                            attributes: [['productGroupId', 'id'], ['productGroup', 'name']]
                        }
                    ]
                },
            ]
        });
        let query = 'select * from "tblProductGroup" where "deletedAt" is null and "isActive"=\'1\'';
        let specialityOptions = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT
        }).then(res => res);
        tradeinfo = Object.assign(tradeinfo, { specialityOptions: specialityOptions });
        return tradeinfo;
    }
    async specialityOld(data) {
        let tradeinfo = {};
        let query = 'select * from "tblProductGroup" where "deletedAt" is null and "isActive"=\'1\'';
        let specialityOptions = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT
        }).then(res => res);
        let final = Object.assign(tradeinfo, { specialityOptions: specialityOptions });
        return final;
    }
    async getOldInitialProfile(data) {
        let user = data;
        let distProfile;
        let channelTypeId = user.channelTypeId;
        let channelId = +user.oldChannelId;
        let type = [];
        let btype = [];
        console.log('userdata', data);
        let query = 'select pg."productGroupId" as groupId,pg."productGroup" as groupname,pc."productCategorieId" as childId,pc."productCategorie" as childname,cast(false as boolean) as status from "tblProductGroup" as pg inner join'
            + ' "tblProductCategories" as pc on pg."productGroupId"=pc."productGroupId" where pg."deletedAt" is null and pg."productGroup"!=\'\'';
        let productGroup = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
        }).then(results => {
            return results;
        });
        let url = 'https://d35w8j22j5uly8.cloudfront.net/';
        query = 'select "brandName" as name,"id",doc."documentId" as doc_id,concat(\'' + url + '\',doc."documentPath") as documentPath from "tblBrand" as br inner join "tblDocument" as doc on doc."documentId"=br."documentId" where br."deletedAt" is null';
        let brand = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
        }).then(results => {
            return results;
        });
        if (channelTypeId == 4 || channelTypeId == 5) {
            query = 'select case when ptc."channelTypeId"=3 then \'Distributor\' when ptc."channelTypeId"=4 then \'Retailer\' '
                + 'when ptc."channelTypeId"=2 then \'vendor\' when ptc."channelTypeId"=5 then \'Reseller\' end as groupname,pt."profileType" as childname,'
                + 'pt."profileTypeId" as childId,cast(false as boolean) as status,ptc."profileTypeClassificationId" as profileTypeClassificationId from "tblProfileType" as pt inner join "tblProfileTypeClassification" as ptc on pt."profileTypeId"=ptc."profileTypeId"';
        }
        else {
            query = 'select case when ptc."channelTypeId"=3 then \'Distributor\' when ptc."channelTypeId"=4 then \'Retailer\' '
                + 'when ptc."channelTypeId"=2 then \'vendor\' when ptc."channelTypeId"=5 then \'Reseller\' end as groupname,pt."profileType" as childname,'
                + 'pt."profileTypeId" as childId,cast(false as boolean) as status,ptc."profileTypeClassificationId" as profileTypeClassificationId from "tblProfileType" as pt inner join "tblProfileTypeClassification" as ptc on pt."profileTypeId"=ptc."profileTypeId"';
        }
        let profileList = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {}
        }).then(results => {
            return results;
        });
        if (channelTypeId == 3) {
            query = 'select case when ptc."channelTypeId"=3 then \'Distributor\' when ptc."channelTypeId"=4 then \'Retailer\' '
                + 'when ptc."channelTypeId"=2 then \'vendor\' when ptc."channelTypeId"=5 then \'Reseller\' end as groupname,pt."profileType" as childname,'
                + 'pt."profileTypeId" as childId,cast(false as boolean) as status,ptc."profileTypeClassificationId" as profileTypeClassificationId from "tblProfileType" as pt inner join "tblProfileTypeClassification" as ptc on pt."profileTypeId"=ptc."profileTypeId";';
            distProfile = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                replacements: {}
            }).then(results => {
                return results;
            });
        }
        query = 'select "registrationcertificate","isVat" from "tblCountry" as cty inner join "tblOldChannel" as ch on ch."countryId"=cty."countryId" where ch."oldChannelId"=:channelId';
        let country = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: channelId
            }
        }).then(results => {
            return results;
        });
        let result = {
            productGroup: productGroup,
            productBrand: brand,
            profileList: profileList,
            distProfile: distProfile,
            country: country
        };
        return result;
    }
    async editBasicCompanyOld(requestObject) {
        let companyProfile = '';
        let companyProfileJson = '';
        let user = requestObject.user;
        console.log('log', user);
        let result = await this.oldChannelRepository.findOne({
            where: {
                companyName: requestObject.company_name.trim(),
                oldChannelId: {
                    [sequelize_1.Op.not]: +user.oldChannelId
                }
            }
        });
        if (result) {
            throw new Process_exception_1.ProcessException('channel:profile:companyNameAlreadyExist');
        }
        try {
            let result = '';
            let compQuery = `select (select json_build_object('addressId', "oldAddressId", 'address', "address", 'city', "city",'countryId', "countryId",'postalCode', "postalCode") as "regAddress" from "tblOldAddress" where "oldAddressId"=ch."regAddressId"),

                (select (array_agg(to_json(q))) from (select 
                   ocs.*, to_json(s.*) "socialSite" from "tblOldChannelSocialLink" ocs inner join "tblSocialSite" s on s."socialSiteId"= ocs."socialSiteId" where ocs."oldChannelId"= ch."oldChannelId" )q) as "channelSocial",
           
               (select "documentPath" from "tblDocument" where "documentId"=chd."channelLogoId") as "channelLogo",
               (select "documentPath" from "tblDocument" where "documentId"=chd."introvideoId") as "introVideo",
               (select "documentPath" from "tblDocument" where "documentId"=chd."channelBannerId") as "banner",
               case when ch."channelTypeId"=2 then 'VENDOR'
               when ch."channelTypeId"=3 then 'DISTRIBUTOR'
               when ch."channelTypeId"=4 then 'RETAILER'
               when ch."channelTypeId"=5 then 'RESELLER' end as "channelType",
               cc."country", cc."phoneCode", cc."isoCode", 
               ch."companyName",ch."companyMail", "detailDesc","webSiteUrl","phone1" as  "phoneno","estYear" ,"mobileNo", "empCntRange", "empCnt",
                "turnover", "turnoverRange", "startup", "storeCount", "introvideoId", "channelBannerId", ch."channelTypeId",ch."oldChannelId" from "tblOldChannelDetail" as chd
               inner join "tblOldChannel" as ch on ch."oldChannelId"=chd."oldChannelId" inner join "tblCountry" as cc on cc."countryId"=ch."countryId" where ch."oldChannelId"=:oldChannelId`;
            companyProfile = await this.sequelizeInstance.query(compQuery, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    oldChannelId: +user.oldChannelId,
                }
            }).then(res => res[0]);
            console.log('companyProfile', companyProfile);
            if (companyProfile) {
                companyProfileJson = companyProfile;
                result = await this.sequelizeInstance.transaction(async (transaction) => {
                    let comapnyLogoId = null;
                    let comapnyRegAddressId = null;
                    if (requestObject.reg_address_id) {
                        await OldAddress_entity_1.OldAddress.update({
                            address: requestObject.reg_address,
                            city: requestObject.reg_city,
                            countryId: requestObject.reg_country_id,
                            postalCode: requestObject.reg_postal_code,
                        }, {
                            where: { oldAddressId: companyProfile.regAddress.addressId },
                            returning: true, transaction,
                        });
                        comapnyRegAddressId = companyProfile.regAddress.addressId;
                    }
                    let companyInfoUpdate = {
                        companyMail: requestObject.company_email || null,
                        regAddressId: comapnyRegAddressId,
                        countryId: +requestObject.reg_country_id,
                        companyName: requestObject.company_name.trim()
                    };
                    await this.oldChannelRepository.update(companyInfoUpdate, {
                        where: { oldChannelId: companyProfile.oldChannelId }, returning: true, transaction,
                    });
                    if (requestObject.social_linkedin_id) {
                        await OldChannelSocialLink_entity_1.OldChannelSocialLink.update({
                            socialSiteId: config_1.appconstant.SOCIAL_SITE_TYPE_LINKEDIN,
                            oldChannelId: companyProfile.oldChannelId,
                            channelSocialLink: requestObject.social_linkedin_url
                        }, {
                            where: { oldChannelSocialLinkId: requestObject.social_linkedin_id },
                            returning: true, transaction,
                        });
                    }
                    else {
                        if (requestObject.social_linkedin_url && Object.keys(requestObject.social_linkedin_url).length > 0) {
                            await OldChannelSocialLink_entity_1.OldChannelSocialLink.create({
                                socialSiteId: config_1.appconstant.SOCIAL_SITE_TYPE_LINKEDIN,
                                oldChannelId: companyProfile.oldChannelId,
                                channelSocialLink: requestObject.social_linkedin_url
                            }, {
                                transaction
                            });
                        }
                    }
                    if (requestObject.social_googleplus_id) {
                        await OldChannelSocialLink_entity_1.OldChannelSocialLink.update({
                            socialSiteId: config_1.appconstant.SOCIAL_SITE_TYPE_GOOGLEPLUS,
                            oldChannelId: companyProfile.oldChannelId,
                            channelSocialLink: requestObject.social_googleplus_url
                        }, {
                            where: { oldChannelSocialLinkId: requestObject.social_googleplus_id },
                            returning: true, transaction,
                        });
                    }
                    else {
                        if (requestObject.social_googleplus_url && Object.keys(requestObject.social_googleplus_url).length > 0) {
                            await OldChannelSocialLink_entity_1.OldChannelSocialLink.create({
                                socialSiteId: config_1.appconstant.SOCIAL_SITE_TYPE_GOOGLEPLUS,
                                oldChannelId: companyProfile.oldChannelId,
                                channelSocialLink: requestObject.social_googleplus_url
                            }, {
                                transaction
                            });
                        }
                    }
                    if (requestObject.social_instagram_id) {
                        await OldChannelSocialLink_entity_1.OldChannelSocialLink.update({
                            oldChannelId: companyProfile.oldChannelId,
                            channelSocialLink: requestObject.social_instagram_url
                        }, {
                            where: { oldChannelSocialLinkId: requestObject.social_instagram_id },
                            returning: true, transaction,
                        });
                    }
                    else {
                        if (requestObject.social_instagram_url && Object.keys(requestObject.social_instagram_url).length > 0) {
                            await OldChannelSocialLink_entity_1.OldChannelSocialLink.create({
                                socialSiteId: config_1.appconstant.SOCIAL_SITE_TYPE_INSTAGRAM,
                                oldChannelId: companyProfile.oldChannelId,
                                channelSocialLink: requestObject.social_instagram_url
                            }, {
                                transaction
                            });
                        }
                    }
                    if (requestObject.social_twitter_id) {
                        await OldChannelSocialLink_entity_1.OldChannelSocialLink.update({
                            oldChannelId: companyProfile.oldChannelId,
                            channelSocialLink: requestObject.social_twitter_url
                        }, {
                            where: { oldChannelSocialLinkId: requestObject.social_twitter_id },
                            returning: true, transaction,
                        });
                    }
                    else {
                        if (requestObject.social_twitter_url && Object.keys(requestObject.social_twitter_url).length > 0) {
                            await OldChannelSocialLink_entity_1.OldChannelSocialLink.create({
                                socialSiteId: config_1.appconstant.SOCIAL_SITE_TYPE_TWITTER,
                                oldChannelId: companyProfile.oldChannelId,
                                channelSocialLink: requestObject.social_twitter_url
                            }, {
                                transaction
                            });
                        }
                    }
                    if (requestObject.social_facebook_id) {
                        await OldChannelSocialLink_entity_1.OldChannelSocialLink.update({
                            oldChannelId: companyProfile.oldChannelId,
                            channelSocialLink: requestObject.social_facebook_url
                        }, {
                            where: { oldChannelSocialLinkId: requestObject.social_facebook_id },
                            returning: true, transaction,
                        });
                    }
                    else {
                        if (requestObject.social_facebook_url && Object.keys(requestObject.social_facebook_url).length > 0) {
                            await OldChannelSocialLink_entity_1.OldChannelSocialLink.create({
                                socialSiteId: config_1.appconstant.SOCIAL_SITE_TYPE_FACEBOOK,
                                oldChannelId: companyProfile.oldChannelId,
                                channelSocialLink: requestObject.social_facebook_url
                            }, {
                                transaction
                            });
                        }
                    }
                    if (companyProfileJson.channelLogo) {
                        comapnyLogoId = companyProfileJson.channelLogoId;
                    }
                    if (requestObject.company_logo_url) {
                        comapnyLogoId = +requestObject.company_logo_url;
                    }
                    return await OldChannelDetail_entity_1.OldChannelDetail.update({
                        channelLogoId: comapnyLogoId,
                        phone1: requestObject.company_phone1,
                        phone2: (lodash_1.isUndefined(requestObject.company_phone2)) ? null : requestObject.company_phone2,
                        mobileNo: (lodash_1.isUndefined(requestObject.company_mobile_no)) ? null : requestObject.company_mobile_no,
                        webSiteUrl: requestObject.company_website_url,
                        introvideoId: requestObject.company_introvideo,
                        detailDesc: requestObject.company_about,
                    }, {
                        where: { oldChannelId: companyProfile.oldChannelId }, returning: true, transaction,
                    });
                });
                if (result) {
                    return true;
                }
                else {
                    return false;
                }
            }
        }
        catch (e) {
            console.log("Error+", e);
            throw new common_1.InternalServerErrorException();
        }
        if (!companyProfile) {
            throw new Process_exception_1.ProcessException('channel:getCompanyProfile:companyNotFound');
        }
        return true;
    }
    async saveOldChannelFacts(data) {
        console.log('data to be saved...', data);
        let user = data.user;
        try {
            return await this.sequelizeInstance.transaction(async (transaction) => {
                let contacts = [];
                let ChannelDetailObject = {};
                ChannelDetailObject = await this.tradeInformationInBound.setFactsOldChannelDetail(data);
                if (ChannelDetailObject) {
                    return await OldChannelDetail_entity_1.OldChannelDetail.update(ChannelDetailObject, { where: { oldChannelId: user.oldChannelId, deletedAt: null }, returning: true, transaction });
                }
            });
        }
        catch (e) {
            console.log("Error+", e);
            throw new common_1.InternalServerErrorException();
        }
        return true;
    }
    async updateBannerImage(requestObject) {
        let user = requestObject.user;
        let bannerId = null;
        let companyBanner;
        let oldBanner = await OldChannelDetail_entity_1.OldChannelDetail.findOne({
            where: { oldChannelId: user.oldChannelId },
            attributes: ['channelBannerId']
        });
        return await this.sequelizeInstance.transaction(async (transaction) => {
            console.log('oldBanner', oldBanner);
            if (oldBanner) {
                await this.mediaRepository.update({ deletedAt: new Date() }, { where: {
                        documentId: +oldBanner.channelBannerId
                    }, returning: true, transaction });
            }
            companyBanner = await this.mediaRepository.create({
                documentPath: requestObject.bannerUrl,
                documentTypeId: config_1.appconstant.DOCUMENTTYPE_IMAGE,
                dirName: config_1.appconstant.FOLDER_PATH_COMPANY_BANNER
            }, {
                transaction,
            });
            bannerId = companyBanner.documentId;
            await OldChannelDetail_entity_1.OldChannelDetail.update({ channelBannerId: bannerId }, {
                where: { oldChannelId: user.oldChannelId }, returning: true, transaction
            });
            return companyBanner;
        });
    }
    async mapOrder(array, order, key) {
        array.sort(function (a, b) {
            var A = a[key], B = b[key];
            if (order.indexOf(A) > order.indexOf(B)) {
                return 1;
            }
            else {
                return -1;
            }
        });
        return array;
    }
    ;
};
ChannelAdminService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject('SequelizeInstance')),
    __param(1, common_1.Inject('ChannelRepository')),
    __param(2, common_1.Inject('ChannelDetailRepository')),
    __param(3, common_1.Inject('ContactRepository')),
    __param(4, common_1.Inject('AddressRepository')),
    __param(5, common_1.Inject('ChannelProductGroupRepository')),
    __param(6, common_1.Inject('CountryRepository')),
    __param(7, common_1.Inject('ProductGroupRepository')),
    __param(8, common_1.Inject('CompanyMediaRepository')),
    __param(9, common_1.Inject('MediaRepository')),
    __param(10, common_1.Inject('ChannelDocumentRepository')),
    __param(11, common_1.Inject('CouponRepository')),
    __param(12, common_1.Inject('ChannelJCTRepository')),
    __param(13, common_1.Inject('ChannelDismissReasonRepository')),
    __param(14, common_1.Inject('EventParticipantRepository')),
    __param(15, common_1.Inject('EventChannelRepository')),
    __param(16, common_1.Inject('ProductRepository')),
    __param(17, common_1.Inject('SubscriptionRepository')),
    __param(18, common_1.Inject('ProductCategoryRepository')),
    __param(19, common_1.Inject('ChannelCertificateTypeRepository')),
    __param(20, common_1.Inject('CompanyMediaImagesRepository')),
    __param(21, common_1.Inject('OldChannelRepository')),
    __metadata("design:paramtypes", [Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, channelKeyPartner_service_1.ChannelKeyPartnerService])
], ChannelAdminService);
exports.ChannelAdminService = ChannelAdminService;
//# sourceMappingURL=channel.admin.service.js.map