import { Country } from 'src/modules/common/models/Country.entity';
import { Media } from 'src/modules/media/models/Media.entity';
import { Brand } from 'src/modules/product/models/Brand.entity';
import { Product } from 'src/modules/product/models/Product.entity';
import { ProductCategory } from 'src/modules/product/models/ProductCategory.entity';
import { ProductGroup } from 'src/modules/product/models/ProductGroup.entity';
import { SignUpStatus } from 'src/modules/user/models/SignUpStatus.entity';
import { CertificateType } from '../models/CertificateType.entity';
import { Channel } from '../models/Channel.entity';
import { ChannelType } from '../models/ChannelType.entity';
import { ContactJCT } from '../models/ContactJCT.entity';
import { ProfileType } from '../models/ProfileType.entity';
import { Subscription } from '../models/Subscription.entity';
import { ChannelKeyPartnerService } from './channelKeyPartner.service';
import { Contact } from 'src/modules/user/models/Contact.entity';
import { ShareType } from '../models/ShareType.entity';
import { ChannelCustomerProfile } from '../models/ChannelCustomerProfile.entity';
import { ProfileTypeClassification } from '../models/ProfileTypeClassification.entity';
import { CompanyMediaImages } from '../models/CompanyMediaImages';
import { EventParticipants } from '../models/EventParticipants.entity';
import { EventChannel } from '../models/EventChannel.entity';
export declare class ChannelService {
    private readonly sequelizeInstance;
    private readonly channelRepository;
    private readonly signUpStatusRepository;
    private readonly channelTypeRepository;
    private readonly productGroupRepository;
    private readonly productCategoryRepository;
    private readonly profileTypeRepository;
    private readonly contactJCTRepository;
    private readonly subscriptionRepository;
    private readonly mediaRepository;
    private readonly channelCertificateTypeRepository;
    private readonly productRepository;
    private readonly sharetypeRepository;
    private readonly channelCustomerProfileRepository;
    private readonly profileTypeClassificationRepository;
    private readonly brandRepository;
    private readonly contactRepository;
    private readonly channelKeyPartnerService;
    private readonly companyMediaImagesRepository;
    private readonly countryRepository;
    private channelHubDetailOutBound;
    constructor(sequelizeInstance: any, channelRepository: typeof Channel, signUpStatusRepository: typeof SignUpStatus, channelTypeRepository: typeof ChannelType, productGroupRepository: typeof ProductGroup, productCategoryRepository: typeof ProductCategory, profileTypeRepository: typeof ProfileType, contactJCTRepository: typeof ContactJCT, subscriptionRepository: typeof Subscription, mediaRepository: typeof Media, channelCertificateTypeRepository: typeof CertificateType, productRepository: typeof Product, sharetypeRepository: typeof ShareType, channelCustomerProfileRepository: typeof ChannelCustomerProfile, profileTypeClassificationRepository: typeof ProfileTypeClassification, brandRepository: typeof Brand, contactRepository: typeof Contact, channelKeyPartnerService: ChannelKeyPartnerService, companyMediaImagesRepository: typeof CompanyMediaImages, countryRepository: typeof Country);
    getTopCompany(keyword: any, typeId: any, btype: any): Promise<{
        company: any;
        product: any;
        type: number;
        btype: number;
    }>;
    getTopProduct(keyword: any): Promise<any>;
    getSearchList(viewId: any, planId: any, data: any, userData: any): Promise<{
        results: any;
        master: any[];
        aggregation: {};
        total: any;
    }>;
    nonMemberList(viewId: any, planId: any, data: any, userData: any): Promise<{
        results: any[];
        aggregation: {};
        total: any;
    }>;
    getSearchAggregation(viewId: any, data: any): Promise<any>;
    chFilterBase(viewId: any, channelType: any, user: any, data: any): Promise<any>;
    getchannelTypes(type: any): Promise<any[]>;
    getBrandFilter(chlist: any): Promise<any>;
    getLocationFilter(chlist: any): Promise<any>;
    getSpecialFilter(chlist: any): Promise<any>;
    getProductFilter(chlist: any, channelId: any): Promise<any>;
    getInterestedProduct(chlist: any, contactId: any): Promise<any>;
    getCountryFilter(chlist: any): Promise<any>;
    getRetailFilter(chlist: any): Promise<any>;
    getTargetFilter(user: any, chlist: any): Promise<any>;
    contactFilterBase(data: any): Promise<any>;
    contactFilterBase1(userData: any, data: any, order: any): Promise<any>;
    getContactSpecialFilter(chlist: any): Promise<any>;
    getContactCountryFilter(chlist: any): Promise<any>;
    conNameListFilter(chlist: any): Promise<any>;
    getFoCompanyList(viewId: any, planId: any, data: any): Promise<{
        results: any;
    }>;
    getChannel(channelId: number, user: any): Promise<any>;
    getSampleOrderCount(channelId: number): Promise<number>;
    getSampleEvaluationCount(channelId: number): Promise<number>;
    getChannelContactCount(channelId: number, pagination: any, contactFilter: any, validateVisibility?: any): Promise<any>;
    getChannelContactsList(channelId: number, pagination: any, contactFilter: any, validateVisibility?: any): Promise<any>;
    getConnectedContactsList(contactList: any): Promise<any>;
    getDefaultContact(partnerChannelId: number, user?: any, channelContactFilter?: any, onlyCompanyDefault?: any): Promise<any>;
    getrequestid(conlist: any, user: any): Promise<any[]>;
    getShareTypeList(): Promise<any>;
    findById(id: number, productFilter: any): Promise<Channel | null>;
    getAllContacts(contact: any): Promise<Contact[]>;
    getDashboardcount(user: any): Promise<any>;
    getSearchList1(data: any, userData: any): Promise<{
        result: any;
        total: any;
    }>;
    getSearchListProfile(data: any, userData: any): Promise<{
        result: any[];
        total: number;
    }>;
    billingAddress(user: any): Promise<Channel[]>;
    mapOrder(array: any, order: any, key: any): Promise<any>;
    isEvent(ContactId: any, isEvent: any): Promise<[number, Contact[]]>;
    setEventParticipantStatus(eventId: any, channelId: any, ContactId: any): Promise<[number, EventParticipants[]]>;
    getEventListing(channelId: any, contactId: any): Promise<any>;
    getEventPackages(user: any, eventId: any): Promise<any>;
    getEventChannelDetails(channelId: any, eventId: any): Promise<any>;
    postEventRegistraion(user: any, data: any): Promise<boolean>;
    foToEventCatalyst(contacts: any): Promise<any>;
    getSelectedEventDetails(user: any, eventId: any): Promise<any>;
    eventRegistration(user: any): Promise<void>;
    getPendingEvent(): Promise<{
        rows: EventChannel[];
        count: number;
    }>;
    updateEventChannel(req: any): Promise<[number, EventChannel[]]>;
    getContactDetail(contactId: number): Promise<any>;
}
