import { ProfileRatings } from '../models/ProfileCreationRating.entity';
import { ProfileList } from '../models/ProfileList.entity';
import { ContextService } from '../../../context/context.service';
import { ChannelDetail } from '../models/ChannelDetail.entity';
import { ChannelBrand } from '../models/ChannelBrand.entity';
import { ChannelCertificate } from '../models/ChannelCertificate.entity';
import { ChannelCustomerProfile } from '../models/ChannelCustomerProfile.entity';
import { ProductGroup } from 'src/modules/product/models/ProductGroup.entity';
import { Brand } from 'src/modules/product/models/Brand.entity';
import { ProductCategory } from 'src/modules/product/models/ProductCategory.entity';
import { ProfileType } from '../models/ProfileType.entity';
import { ProfileTypeClassification } from '../models/ProfileTypeClassification.entity';
import { Country } from 'src/modules/common/models/Country.entity';
import { Region } from 'src/modules/common/models/Region.entity';
import { RegionCountryJCT } from 'src/modules/common/models/RegionCountryJCT.entity';
import { ChannelProductGroup } from '../models/ChannelProductGroup.entity';
import { ChannelProductCategorie } from '../models/ChannelProductCategorie.entity';
import { ChannelDocument } from '../models/ChannelDocument.entity';
import { Media, MediaType } from '../../media/models/index';
import { ChannelLocation } from '../models/ChannelLocation.entity';
import { ContactInterestedProductGroup } from 'src/modules/user/models/ContactInterestedProductGroup.entity';
import { ContactInterestedProductCategory } from 'src/modules/user/models/ContactInterestedProductCategory.entity';
import { User } from 'src/modules/user/models/User.entity';
import { Contact } from 'src/modules/user/models/Contact.entity';
import { ProductService } from 'src/modules/product/service/product.service';
import { Channel } from '../models/Channel.entity';
import { ContactLocation } from 'src/modules/user/models/ContactLocation.entity';
import { ChannelLocationDto } from '../dto/channelLocation.dto';
import { ChannelSocialLink } from '../models/ChannelSocialLink.entity';
import { Address } from '../models/Address.entity';
import { ChannelAward } from '../models/ChannelAward.entity';
import { ChannelSpeciality } from '../models/ChannelSpeciality.entity';
import { ChannelServiceList } from '../models/ChannelServiceList.entity';
import { CompanyUpdateDto } from '../dto/company.update.dto';
import { ChannelB2B } from '../models/ChannelB2B.entity';
import { KeyPartnerJCT } from '../models/KeyPartnerJCT.entity';
import { Currency } from '../models/Currency.entity';
import { ServiceList } from '../models/ServiceList.entity';
import { ChannelPaymentOptionType } from '../models/ChannelPaymentOptionType.entity';
import { ChannelPaymentTerm } from '../models/ChannelPaymentTerm.entity';
import { ChannelSharePreference } from '../models/ChannelSharePreference.entity';
import { SettingsDto } from '../dto/settings.dto';
import { ChannelSubscription } from '../models/ChannelSubscription.entity';
import { SubscriptionPlan } from '../models/SubscriptionPlan.entity';
import { Subscription } from '../models/Subscription.entity';
import { SearchRegionDto } from '../dto/searchRegion.dto';
import { Zone } from 'src/modules/common/models/Zone.entity';
import { Product } from 'src/modules/product/models/Product.entity';
import { UserWalletAmount } from '../../walletRecharge/models/UserWalletAmount.entity';
import { InterestedProductGroup } from 'src/modules/user/models/InterestedProductGroup.entity';
import { InterestedProductCategory } from 'src/modules/user/models/InterestedProductCategory.entity';
import { CompanyMediaImages } from '../models/CompanyMediaImages';
import { EndCustomersB2b } from '../models/EndCustomerB2b';
import { CertificateTag } from '../models/CertificateTag.entity';
import { GuestRequirement } from '../models/GuestRequirement.entity';
export declare class ChannelSettingService {
    private readonly productService;
    private readonly sequelizeInstance;
    private readonly channelRepository;
    private readonly channelDetailRepository;
    private readonly channelBrandRepository;
    private readonly channelCustProfileRepository;
    private readonly channelCertiRepository;
    private readonly settingRepository;
    private readonly profileRepository;
    private readonly userRepository;
    private readonly contactRepository;
    private readonly channelProductGroupRepository;
    private readonly productGroupRepository;
    private readonly brandRepository;
    private readonly productCatRepository;
    private readonly channelCatRepository;
    private readonly contactGroupRepository;
    private readonly contactCatRepository;
    private readonly intrestedGroupRepository;
    private readonly intrestedCatRepository;
    private readonly profileTypeRepository;
    private readonly profileTypeClassiRepository;
    private readonly countryRepository;
    private readonly regionRepository;
    private readonly regCtyJCTRepository;
    private readonly channelLocationRepository;
    private readonly contactLocationRepository;
    private readonly channelDocumentRepository;
    private readonly mediaRepository;
    private readonly socialLinkRepository;
    private readonly addressRepository;
    private readonly awardRepository;
    private readonly channelProductCategorieRepository;
    private readonly channelCustomerProfileRepository;
    private readonly channelServiceListRepository;
    private readonly channelSpecialityRepository;
    private readonly serviceListRepository;
    private readonly mediaTypeRepository;
    private readonly channelB2BRepository;
    private readonly currencyRepository;
    private readonly channelPaymentOptionTypeRepository;
    private readonly channelPaymentTermRepository;
    private readonly channelSharePreferenceRepository;
    private readonly channelSubscriptionRepository;
    private readonly subscriptionPlanRepository;
    private readonly subscriptionRepository;
    private readonly zoneRepository;
    private readonly userWalletAmountRepository;
    private readonly productRepository;
    private readonly companyMediaImagesRepository;
    private readonly endCustomersB2bRepository;
    private readonly guestRequirementRepository;
    private context;
    private tradeInformationInBound;
    constructor(productService: ProductService, sequelizeInstance: any, channelRepository: typeof Channel, channelDetailRepository: typeof ChannelDetail, channelBrandRepository: typeof ChannelBrand, channelCustProfileRepository: typeof ChannelCustomerProfile, channelCertiRepository: typeof ChannelCertificate, settingRepository: typeof ProfileRatings, profileRepository: typeof ProfileList, userRepository: typeof User, contactRepository: typeof Contact, channelProductGroupRepository: typeof ChannelProductGroup, productGroupRepository: typeof ProductGroup, brandRepository: typeof Brand, productCatRepository: typeof ProductCategory, channelCatRepository: typeof ChannelProductCategorie, contactGroupRepository: typeof ContactInterestedProductGroup, contactCatRepository: typeof ContactInterestedProductCategory, intrestedGroupRepository: typeof InterestedProductGroup, intrestedCatRepository: typeof InterestedProductCategory, profileTypeRepository: typeof ProfileType, profileTypeClassiRepository: typeof ProfileTypeClassification, countryRepository: typeof Country, regionRepository: typeof Region, regCtyJCTRepository: typeof RegionCountryJCT, channelLocationRepository: typeof ChannelLocation, contactLocationRepository: typeof ContactLocation, channelDocumentRepository: typeof ChannelDocument, mediaRepository: typeof Media, socialLinkRepository: typeof ChannelSocialLink, addressRepository: typeof Address, awardRepository: typeof ChannelAward, channelProductCategorieRepository: typeof ChannelProductCategorie, channelCustomerProfileRepository: typeof ChannelCustomerProfile, channelServiceListRepository: typeof ChannelServiceList, channelSpecialityRepository: typeof ChannelSpeciality, serviceListRepository: typeof ServiceList, mediaTypeRepository: typeof MediaType, channelB2BRepository: typeof ChannelB2B, currencyRepository: typeof Currency, channelPaymentOptionTypeRepository: typeof ChannelPaymentOptionType, channelPaymentTermRepository: typeof ChannelPaymentTerm, channelSharePreferenceRepository: typeof ChannelSharePreference, channelSubscriptionRepository: typeof ChannelSubscription, subscriptionPlanRepository: typeof SubscriptionPlan, subscriptionRepository: typeof Subscription, zoneRepository: typeof Zone, userWalletAmountRepository: typeof UserWalletAmount, productRepository: typeof Product, companyMediaImagesRepository: typeof CompanyMediaImages, endCustomersB2bRepository: typeof EndCustomersB2b, guestRequirementRepository: typeof GuestRequirement, context: ContextService);
    getProfileList(typeId: any, channelId: any): Promise<any>;
    getUserStatus(channelId: any, typeId: any): Promise<any>;
    save_Company_Profile(data: any): Promise<any>;
    save_User_Profile(data: any): Promise<any>;
    setChannelBrand(channelBrand: any, channelId: number): Promise<ChannelBrand[]>;
    setChannelProfile(channelProfile: any, channelId: number): Promise<ChannelCustomerProfile[]>;
    setContactProductGroup(productGroup: any, contactId: number, channelId: number): Promise<InterestedProductGroup[]>;
    setContactProductCat(productCat: any, contactId: number, channelId: number): Promise<InterestedProductCategory[]>;
    setChannelProductGroup(productGroup: any, channelId: number): Promise<ChannelProductGroup[]>;
    setChannelProductCat(productCat: any, channelId: number): Promise<ChannelProductCategorie[]>;
    getInitialProfile(data: any): Promise<{
        productGroup: any;
        productBrand: any;
        profileList: any;
        distProfile: any;
        country: any;
    }>;
    getVat(countryId: any): Promise<{
        country: any;
    }>;
    getContactProduct(contactId: any, channelId: any): Promise<{
        productGroup: any;
    }>;
    getContactLocation(user: any): Promise<{
        contactLocation: any;
    }>;
    getUserProfile(channelId: any, channelTypeId: any): Promise<{
        productGroup: any;
        regions: any;
        regions1: any;
    }>;
    getChannelProduct(channelId: any, businessType: any): Promise<{
        productGroup: any;
    }>;
    getChannelBrand(channelId: any): Promise<{
        brand: any;
    }>;
    getChannelDetail(channelId: any): Promise<any>;
    getProfileAndSpeciality(channelId: any): Promise<any[] & {
        specialityOptions: any;
    }>;
    getProductProfile(channelId: any): Promise<{
        productCat: any;
        productBrand: any;
        activeProduct: number;
    }>;
    getCompanyMediaLibrary(channelId: any, type: any): Promise<ChannelDocument[]>;
    getCompanyImages(channelId: any): Promise<CompanyMediaImages[]>;
    getCompanyDocument(channelId: any): Promise<ChannelDocument[]>;
    createCompanyLogo(doc: any, user: any): Promise<any>;
    existingBrandCheck(brand: any): Promise<any>;
    saveBrand(brand: any, channelId: number, transaction: any): Promise<any>;
    setChannelBrands(brandId: number, channelId: number): Promise<ChannelBrand>;
    setDocumentObject(docTempPath: string, doctype: number, folderPath?: string): Promise<Media>;
    getCompanyProfile(user: any): Promise<any>;
    getTradeInfo(user: any): Promise<any>;
    getTradeLocation(user: any): Promise<any>;
    updateChannelLocation(channelLocationDto: ChannelLocationDto, user: any, subscriptionFeatureKeys: any): Promise<any>;
    getuserLimits(user: any): Promise<any>;
    getUsers(user: any): Promise<any>;
    deleteUser(contactId: any): Promise<any>;
    imageCreate(image: any, transaction: any): Promise<Media>;
    update_Company_Profile(data: any): Promise<any>;
    updateUserCompanyProfile(requestObject: CompanyUpdateDto, user: any): Promise<boolean>;
    imageUpdate(imageId: any, image: any, transaction: any): Promise<Media>;
    updatetradeInformation(params: any, user: any): Promise<boolean>;
    reportingusers(user: any): Promise<any>;
    generalInfo(req: any): Promise<any>;
    searchRetailer(pagination: any, partner_type: any): Promise<any>;
    getKeyRetailers(channelId: any, partnerType: any): Promise<any>;
    existingKeyRetailerCheck(KeyRetailer: any, CountryId: any, channelId: any, partner_type: any, partner_id: any): Promise<boolean>;
    getKeyPartner(partnerId: any): Promise<KeyPartnerJCT>;
    getPaymentOption(): Promise<any>;
    getCurrency(): Promise<any>;
    getServiceList(): Promise<Array<ServiceList>>;
    updateSettings(settingsDto: SettingsDto, user: any): Promise<any>;
    updateIndividualSetting(data: any, settingId: any, repository: any, user: any): Promise<any>;
    settings(user: any): Promise<any>;
    searchRegion(searchRegionDto: SearchRegionDto, user: any): Promise<any>;
    buyerHighlights(viewId: any): Promise<any[]>;
    buyersaggr(viewId: any, parent: any, data: any): Promise<any[]>;
    productsHighlights(btype: any): Promise<any>;
    productsaggr(parent: any, data: any): Promise<any>;
    getBuyerSearchList(viewId: any, data: any): Promise<{
        data: any[];
        total: number;
    }>;
    getCategoriesFilter(data: any): Promise<any[]>;
    getBrandFilter(data: any): Promise<any[]>;
    getCountryFilter(data: any): Promise<any[]>;
    editBasicCompany(requestObject: any, user: any): Promise<boolean>;
    updateBannerImage(requestObject: any, user: any): Promise<boolean>;
    editProfileSave(user: any, params: any): Promise<boolean>;
    updateFacts(params: any, user: any): Promise<any>;
    getFacts(user: any): Promise<ChannelDetail>;
    getKeyPartnerOptions(user: any): Promise<any>;
    getChannelProfile(user: any): Promise<any>;
    update_company_new(user: any, data: any): Promise<boolean>;
    save_company_registration(data: any, companyProfile: any, realUser: any): Promise<boolean>;
    save_trade_information(data: any, companyProfile: any, user: any): Promise<boolean>;
    save_channel_info(data: any, companyProfile: any, user: any): Promise<boolean>;
    save_marketing_info(data: any, companyProfile: any, user: any): Promise<boolean>;
    save_facts_figures(data: any, companyProfile: any, user: any): Promise<boolean>;
    save_settingsdocuments(data: any, companyProfile: any, user: any): Promise<boolean>;
    getChannelCertificateTags(user: any): Promise<CertificateTag[]>;
    getCategoryDetails(groupId: any): Promise<void>;
    getProducts(businessType: any): Promise<{
        productGroup: any[];
    }>;
    getCategories(businessType: any): Promise<{
        productCat: any;
    }>;
    guestUserRequirement(data: any): Promise<GuestRequirement>;
    getTopCompany(keyword: any, typeId: any): Promise<{
        company: any;
        product: any;
        type: number;
    }>;
    getMatchingVendors(channelId: any, data: any): Promise<{
        result: any[];
    }>;
    getMatchingBrands(channelId: any, data: any): Promise<{
        result: any[];
    }>;
    getFeaturedVendors(data: any): Promise<{
        result: any[];
    }>;
    getBuyerSearchCount(data: any): Promise<{
        result: {};
        product: number;
    }>;
    getFamilyFilter(data: any): Promise<any>;
    getChannelAwards(user: any): Promise<any>;
    getProductAwards(user: any): Promise<any>;
    deleteChannelAwards(data: any): Promise<any>;
    deleteProductAwards(data: any): Promise<any>;
}
