'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChannelKeyPartnerService = void 0;
const common_1 = require("@nestjs/common");
const lodash_1 = require("lodash");
const sequelize_1 = require("sequelize");
let ChannelKeyPartnerService = class ChannelKeyPartnerService {
    constructor(sequelizeInstance) {
        this.sequelizeInstance = sequelizeInstance;
    }
    async searchRetailer(pagination, partner_type) {
        return await this.sequelizeInstance.query('select * from "fnfindkeyretailer"(:keyword, :channelType,\':limit\', \':offset\', :cdnUrl)', {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                keyword: (pagination.search) ? pagination.search : '',
                channelType: partner_type,
                limit: pagination.limit,
                offset: pagination.offset,
                cdnUrl: process.env.CDN_URL
            }
        }).then((results) => {
            return results[0].fnfindkeyretailer;
        });
    }
    async getKeyRetailers(channelId, partnerType) {
        return await this.sequelizeInstance.query('select * from "fnGetKeyPartnersbyChannelId"(:channelId, :partnerType, :productId, :cdnUrl)', {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: channelId,
                productId: null,
                cdnUrl: process.env.CDN_URL,
                partnerType: partnerType
            }
        }).then((results) => {
            return (results && results[0] && lodash_1.isArray(results[0].fnGetKeyPartnersbyChannelId) && results[0].fnGetKeyPartnersbyChannelId.length > 0) ? results[0].fnGetKeyPartnersbyChannelId.map((x) => {
                if (x.active != null) {
                    x.weight = 3;
                }
                else if (x.old != null) {
                    x.weight = 2;
                }
                else {
                    x.weight = 1;
                }
                return x;
            }).sort((a, b) => (a.weight > b.weight) ? -1 : 1) : results[0].fnGetKeyPartnersbyChannelId;
        });
    }
};
ChannelKeyPartnerService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject('SequelizeInstance')),
    __metadata("design:paramtypes", [Object])
], ChannelKeyPartnerService);
exports.ChannelKeyPartnerService = ChannelKeyPartnerService;
//# sourceMappingURL=channelKeyPartner.service.js.map