import { Media } from 'src/modules/media/models/Media.entity';
import { Brand } from 'src/modules/product/models/Brand.entity';
import { Product } from 'src/modules/product/models/Product.entity';
import { ProductCategory } from 'src/modules/product/models/ProductCategory.entity';
import { ProductGroup } from 'src/modules/product/models/ProductGroup.entity';
import { SignUpStatus } from 'src/modules/user/models/SignUpStatus.entity';
import { CertificateType } from '../models/CertificateType.entity';
import { Channel } from '../models/Channel.entity';
import { ChannelType } from '../models/ChannelType.entity';
import { ContactJCT } from '../models/ContactJCT.entity';
import { ProfileType } from '../models/ProfileType.entity';
import { Subscription } from '../models/Subscription.entity';
import { ChannelKeyPartnerService } from './channelKeyPartner.service';
import { Contact } from 'src/modules/user/models/Contact.entity';
import { ShareType } from '../models/ShareType.entity';
import { ChannelCustomerProfile } from '../models/ChannelCustomerProfile.entity';
import { ProfileTypeClassification } from '../models/ProfileTypeClassification.entity';
import { CompanyMediaImages } from '../models/CompanyMediaImages';
import { ChannelBrand } from '../models/ChannelBrand.entity';
export declare class PublicChannelService {
    private readonly sequelizeInstance;
    private readonly channelRepository;
    private readonly signUpStatusRepository;
    private readonly channelTypeRepository;
    private readonly productGroupRepository;
    private readonly productCategoryRepository;
    private readonly profileTypeRepository;
    private readonly contactJCTRepository;
    private readonly subscriptionRepository;
    private readonly mediaRepository;
    private readonly channelCertificateTypeRepository;
    private readonly productRepository;
    private readonly sharetypeRepository;
    private readonly channelCustomerProfileRepository;
    private readonly profileTypeClassificationRepository;
    private readonly brandRepository;
    private readonly contactRepository;
    private readonly channelBrandRepository;
    private readonly channelKeyPartnerService;
    private readonly companyMediaImagesRepository;
    private channelHubDetailOutBound;
    constructor(sequelizeInstance: any, channelRepository: typeof Channel, signUpStatusRepository: typeof SignUpStatus, channelTypeRepository: typeof ChannelType, productGroupRepository: typeof ProductGroup, productCategoryRepository: typeof ProductCategory, profileTypeRepository: typeof ProfileType, contactJCTRepository: typeof ContactJCT, subscriptionRepository: typeof Subscription, mediaRepository: typeof Media, channelCertificateTypeRepository: typeof CertificateType, productRepository: typeof Product, sharetypeRepository: typeof ShareType, channelCustomerProfileRepository: typeof ChannelCustomerProfile, profileTypeClassificationRepository: typeof ProfileTypeClassification, brandRepository: typeof Brand, contactRepository: typeof Contact, channelBrandRepository: typeof ChannelBrand, channelKeyPartnerService: ChannelKeyPartnerService, companyMediaImagesRepository: typeof CompanyMediaImages);
    getChannel(channelId: number): Promise<any>;
    getSampleOrderCount(channelId: number): Promise<number>;
    getSampleEvaluationCount(channelId: number): Promise<number>;
    channelBrands(channelId: number): Promise<any>;
    eventMatching(contactData: any): Promise<any[] | {
        companyId: any;
        contactId: any;
        participant: any[];
    }>;
    eventListing(typeid: any): Promise<any[]>;
    getPassword(contactId: any): Promise<any>;
}
