"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PublicChannelService = void 0;
const common_1 = require("@nestjs/common");
const sequelize_1 = require("sequelize");
const app_constant_1 = require("../../../config/app.constant");
const Country_entity_1 = require("../../common/models/Country.entity");
const RegionCountryJCT_entity_1 = require("../../common/models/RegionCountryJCT.entity");
const Media_entity_1 = require("../../media/models/Media.entity");
const Brand_entity_1 = require("../../product/models/Brand.entity");
const Product_entity_1 = require("../../product/models/Product.entity");
const ProductCategory_entity_1 = require("../../product/models/ProductCategory.entity");
const ProductGroup_entity_1 = require("../../product/models/ProductGroup.entity");
const SignUpStatus_entity_1 = require("../../user/models/SignUpStatus.entity");
const utility_1 = require("../helper/utility");
const Channel_entity_1 = require("../models/Channel.entity");
const ChannelAward_entity_1 = require("../models/ChannelAward.entity");
const ProfileType_entity_1 = require("../models/ProfileType.entity");
const SocialSite_entity_1 = require("../models/SocialSite.entity");
const SubscriptionPlan_entity_1 = require("../models/SubscriptionPlan.entity");
const channelHubDetailOutBound_1 = require("../transformation/channelHubDetailOutBound");
const channelKeyPartner_service_1 = require("./channelKeyPartner.service");
const Contact_entity_1 = require("../../user/models/Contact.entity");
const Address_entity_1 = require("../models/Address.entity");
const ChannelB2B_entity_1 = require("../models/ChannelB2B.entity");
const Auth_exception_1 = require("../../../middleware/exception/Auth.exception");
const SampleOrder_entity_1 = require("../../order/models/SampleOrder.entity");
const ProductEvaluation_entity_1 = require("../../product/models/ProductEvaluation.entity");
const Cryptr = require('cryptr');
var _ = require('lodash');
let PublicChannelService = class PublicChannelService {
    constructor(sequelizeInstance, channelRepository, signUpStatusRepository, channelTypeRepository, productGroupRepository, productCategoryRepository, profileTypeRepository, contactJCTRepository, subscriptionRepository, mediaRepository, channelCertificateTypeRepository, productRepository, sharetypeRepository, channelCustomerProfileRepository, profileTypeClassificationRepository, brandRepository, contactRepository, channelBrandRepository, channelKeyPartnerService, companyMediaImagesRepository) {
        this.sequelizeInstance = sequelizeInstance;
        this.channelRepository = channelRepository;
        this.signUpStatusRepository = signUpStatusRepository;
        this.channelTypeRepository = channelTypeRepository;
        this.productGroupRepository = productGroupRepository;
        this.productCategoryRepository = productCategoryRepository;
        this.profileTypeRepository = profileTypeRepository;
        this.contactJCTRepository = contactJCTRepository;
        this.subscriptionRepository = subscriptionRepository;
        this.mediaRepository = mediaRepository;
        this.channelCertificateTypeRepository = channelCertificateTypeRepository;
        this.productRepository = productRepository;
        this.sharetypeRepository = sharetypeRepository;
        this.channelCustomerProfileRepository = channelCustomerProfileRepository;
        this.profileTypeClassificationRepository = profileTypeClassificationRepository;
        this.brandRepository = brandRepository;
        this.contactRepository = contactRepository;
        this.channelBrandRepository = channelBrandRepository;
        this.channelKeyPartnerService = channelKeyPartnerService;
        this.companyMediaImagesRepository = companyMediaImagesRepository;
        this.channelHubDetailOutBound = new channelHubDetailOutBound_1.ChannelHubDetailOutBound();
    }
    async getChannel(channelId) {
        console.log('channelId', +channelId);
        let channel = await this.channelRepository.scope('channelDetail').findOne({
            where: {
                channelId: +channelId,
                deletedAt: null,
                signUpStatusId: app_constant_1.appconstant.CHANNEL_APPROVED,
                isActive: '1',
                channelTypeId: {
                    [sequelize_1.Op.in]: [app_constant_1.appconstant.CHANNEL_TYPE_VENDOR, app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR, app_constant_1.appconstant.CHANNEL_TYPE_RETAILER, app_constant_1.appconstant.CHANNEL_TYPE_RESELLER]
                }
            },
            include: [
                {
                    model: ChannelB2B_entity_1.ChannelB2B,
                    as: 'channelB2B',
                    attributes: ['channelB2BId', 'channelId', 'channelB2B'],
                    where: { deletedAt: null },
                    required: false,
                },
                { model: this.signUpStatusRepository },
                { model: this.channelTypeRepository },
                { model: Country_entity_1.Country, as: 'country', where: { deletedAt: null } },
                { model: Address_entity_1.Address, as: 'regAddress' },
                { model: ProfileType_entity_1.ProfileType.scope('channelDetail'), as: 'profileType', attributes: ['profileType'], where: { deletedAt: null }, required: false },
                {
                    model: this.productGroupRepository,
                    as: 'speciality',
                    attributes: ['productGroupId', 'productGroup'],
                    required: false,
                    where: { isActive: '1' },
                    through: { attributes: [], where: { deletedAt: null } }
                },
                {
                    model: this.productCategoryRepository,
                    as: 'productCategory',
                    attributes: ['productCategorieId', 'productCategorie'],
                    required: false,
                    where: { isActive: '1' },
                    order: 'productCategorie',
                    through: { attributes: [], where: { deletedAt: null } }
                },
                {
                    model: ChannelAward_entity_1.ChannelAward,
                    attributes: ['awardDetail', 'issuedBy', 'validUpto', 'isLifeTime'],
                    where: { deletedAt: null },
                    required: false
                }
            ]
        });
        if (!channel)
            return false;
        console.log('.......channel,,,,,,,,,');
        try {
            if (!channel.channelDetail) {
                await new utility_1.Utility().lazyload(channel, 'channelDetail', {
                    where: { deletedAt: null },
                    required: false,
                    attributes: ['channelLogoId', 'channelIconId', 'webSiteUrl', 'estYear', 'regYear', 'detailDesc', 'expectations', 'companyDesc', 'empCntRange', 'empCnt', 'empCntDSale', 'empCntISale', 'empCntDMar', 'empCntIMar', 'turnoverRange', 'turnover', 'revD', 'revI', 'deletedAt', 'turnoverPhyStore', 'turnoverOnStore', 'startup', 'storeCount', 'maturitylevel', 'keyretailers', 'keyresellers', 'keydistributors', 'no_of_retailers', 'no_of_resellers', 'no_of_skus', 'no_of_distributors', 'no_of_vendors', 'introvideoId', 'channelBannerId', 'phone1', 'mobileNo', 'bannerURL'],
                    include: [{
                            model: Media_entity_1.Media,
                            as: 'channelLogo',
                            attributes: ['documentUrl', 'documentPath'],
                            where: { deletedAt: null },
                            required: false
                        },
                        {
                            model: Media_entity_1.Media,
                            as: 'channelIcon',
                            where: { deletedAt: null },
                            attributes: ['documentUrl'],
                            required: false
                        },
                        {
                            model: Media_entity_1.Media,
                            as: 'introvideo',
                            where: { deletedAt: null },
                            required: false
                        },
                        {
                            model: Media_entity_1.Media,
                            as: 'channelBanner',
                            where: { deletedAt: null },
                            required: false
                        }
                    ],
                });
            }
            if (!channel.serviceList) {
                await new utility_1.Utility().lazyload(channel, 'serviceList', {
                    through: { attributes: [], where: { deletedAt: null } },
                    required: false,
                    attributes: ['serviceListId', 'serviceList']
                });
            }
            if (!channel.channelLocation) {
                await new utility_1.Utility().lazyload(channel, 'channelLocation', {
                    where: { deletedAt: null },
                    required: false,
                    attributes: ['locationType'],
                    include: [{
                            model: RegionCountryJCT_entity_1.RegionCountryJCT,
                            where: { deletedAt: null },
                            required: false,
                            include: [
                                {
                                    model: Country_entity_1.Country,
                                    where: { deletedAt: null },
                                    attributes: ['countryId', 'country', 'priority'],
                                    required: false
                                }
                            ],
                        }]
                });
            }
            if (!channel.channelBrand) {
                await new utility_1.Utility().lazyload(channel, 'channelBrand', {
                    where: { deletedAt: null },
                    required: false,
                    include: [{
                            model: Brand_entity_1.Brand.scope('channelDetail'),
                            as: 'brand',
                            where: { deletedAt: null, isActive: '1' },
                            required: false,
                            include: [{
                                    model: Media_entity_1.Media,
                                    as: 'document',
                                    where: { deletedAt: null },
                                    required: false
                                }]
                        }]
                });
            }
            if (!channel.channelSocial) {
                await new utility_1.Utility().lazyload(channel, 'channelSocial', {
                    where: { deletedAt: null },
                    required: false,
                    include: [{
                            model: SocialSite_entity_1.SocialSite.scope('channelDetail'),
                            where: { deletedAt: null },
                            attributes: ['socialSite'],
                            required: false
                        }]
                });
            }
            if (!channel.channelCertificate) {
                await new utility_1.Utility().lazyload(channel, 'channelCertificate', {
                    where: { deletedAt: null },
                    attributes: ['cerificateTypeId', 'cerificateName', 'cerificateNumber', 'cerificateDesc'],
                    required: false
                });
            }
            if (!channel.channelSubscription) {
                await new utility_1.Utility().lazyload(channel, 'channelSubscription', {
                    where: { isActive: '1' },
                    required: false,
                    include: [{
                            model: this.subscriptionRepository.scope('channelDetail'),
                            as: 'subscription',
                            where: { deletedAt: null, isActive: '1' },
                            required: false,
                            include: [{
                                    model: SubscriptionPlan_entity_1.SubscriptionPlan.scope('channelDetail'),
                                    as: 'subscriptionPlan',
                                    where: { deletedAt: null, isActive: '1' },
                                    required: false
                                }],
                        }]
                });
            }
            if (!channel.channelDocument) {
                await new utility_1.Utility().lazyload(channel, 'channelDocument', {
                    attributes: ['channelDocumentId', 'documentId', 'name', 'description'],
                    where: { deletedAt: null },
                    required: false,
                    include: [{
                            attributes: ['documentId', 'documentPath', 'documentUrl'],
                            where: { deletedAt: null, documentTypeId: 2 },
                            model: this.mediaRepository,
                            required: true,
                        }]
                });
            }
            channel.toJSON();
            channel['channelKeyRetailer'] = await this.channelKeyPartnerService.getKeyRetailers(+channel.channelId, app_constant_1.appconstant.CHANNEL_TYPE_RETAILER);
            channel['channelKeyReseller'] = await this.channelKeyPartnerService.getKeyRetailers(+channel.channelId, app_constant_1.appconstant.CHANNEL_TYPE_RESELLER);
            channel['channelKeyDistributor'] = await this.channelKeyPartnerService.getKeyRetailers(+channel.channelId, app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR);
            let custquery = 'select tpt."profileType", tptc."channelTypeId" from "tblChannelCustomerProfile" tcp inner join "tblProfileTypeClassification" tptc on tcp."profileTypeClassificationId"=tptc."profileTypeClassificationId" inner join "tblProfileType" tpt on tpt."profileTypeId"=tptc."profileTypeId" where tcp."channelId"=:channelId and tcp."deletedAt" is null';
            channel['customerProfile'] = await await this.sequelizeInstance.query(custquery, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelId: +channel.channelId
                }
            });
            if (channel.channelTypeId == app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR || channel.channelTypeId == app_constant_1.appconstant.CHANNEL_TYPE_RETAILER) {
                channel['sampleOrderCount'] = await this.getSampleOrderCount(channelId);
                channel['sampleEvaluationCount'] = await this.getSampleEvaluationCount(channelId);
            }
            channel['productCount'] = await this.productRepository.count({
                where: {
                    channelId: channelId,
                    isactive: '1',
                    deletedat: null
                }
            });
            channel['certificateType'] = await this.channelCertificateTypeRepository.findAll({
                where: { deletedAt: null }
            });
            let query = 'select "productCategorieId", "productCategorie" from "tblProductCategories" where "productCategorieId" in(select "productCategorieId" from "tblInterestedProductCategory" where "channelId"=:channelId and "deletedAt" is null) order by "productCategorie"';
            let userProductCat = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelId: channelId
                }
            });
            let companyImages = await this.companyMediaImagesRepository.findAll({
                where: {
                    channelId: +channel.channelId,
                    deletedAt: null
                },
                include: [{
                        model: Media_entity_1.Media,
                        where: {
                            documentTypeId: 1,
                            deletedAt: null
                        },
                        required: true
                    }],
                order: [['companyMediaId', 'DESC']]
            });
            let channelTransformed = await this.channelHubDetailOutBound.publicChannelDetail(channel, userProductCat, companyImages);
            return channelTransformed;
        }
        catch (e) {
            console.log("Error+ ", e);
            throw new common_1.InternalServerErrorException();
        }
    }
    async getSampleOrderCount(channelId) {
        try {
            return await SampleOrder_entity_1.SampleOrder.count({
                where: {
                    buyerchannelid: channelId,
                    statusid: { [sequelize_1.Op.ne]: app_constant_1.appconstant.ORDER_STATUS_CANCELED }
                }
            });
        }
        catch (e) {
            console.log("Error+ ", e);
            throw new common_1.InternalServerErrorException();
        }
    }
    async getSampleEvaluationCount(channelId) {
        try {
            return await ProductEvaluation_entity_1.ProductEvaluation.count({
                where: {
                    channelid: channelId,
                    deletedat: null
                }
            });
        }
        catch (e) {
            console.log("Error+ ", e);
            throw new common_1.InternalServerErrorException();
        }
    }
    async channelBrands(channelId) {
        var whereOptions = {
            channelId: channelId,
            isActive: '1',
            signUpStatusId: app_constant_1.appconstant.CHANNEL_APPROVED,
            deletedAt: null
        };
        let channel = await Channel_entity_1.Channel.findOne({
            where: whereOptions
        });
        if (!channel) {
            throw new Auth_exception_1.AuthException('Not allowed');
        }
        let veifiedBrands = [];
        if (channel.channelTypeId == Channel_entity_1.Channel.CHANNEL_TYPE_DISTRIBUTOR) {
        }
        let option = {
            include: [
                {
                    model: this.channelBrandRepository,
                    where: { deletedAt: null, channelId: channelId },
                    required: true
                },
                {
                    model: this.mediaRepository,
                    where: { deletedAt: null },
                    required: true
                }
            ]
        };
        let whereOption = {
            isActive: '1',
            deletedAt: null
        };
        option['where'] = whereOption;
        let channelBrandCount = await this.brandRepository.count(option);
        if (channelBrandCount == 0) {
            return {
                "channelBrand": [],
                "total": 0
            };
        }
        let query = 'SELECT "Brand"."id", "Brand"."brandName", json_build_object(\'documentId\', "document"."documentId", \'documentPath\', "document"."documentPath", \'documentUrl\', :CDN_URL || "document"."documentPath") as "document" FROM "tblBrand" AS "Brand" INNER JOIN "tblChannelBrand" AS "channelBrand" ON "Brand"."id" = "channelBrand"."brandId" AND "channelBrand"."deletedAt" IS NULL AND "channelBrand"."channelId" = :channelId INNER JOIN "tblDocument" AS "document" ON "Brand"."documentId" = "document"."documentId" AND "document"."deletedAt" IS NULL WHERE "Brand"."isActive" = \'1\' AND "Brand"."deletedAt" IS NULL ';
        query += ' ORDER BY "Brand"."id" asc';
        let channelBrand = await this.sequelizeInstance.query(query, {
            type: this.sequelizeInstance.QueryTypes.SELECT,
            model: Brand_entity_1.Brand,
            mapToModel: true,
            replacements: {
                channelId: channelId,
                CDN_URL: process.env.CDN_URL,
            }
        }).then((results) => {
            let formatedBrands = results;
            if (results) {
                formatedBrands = [];
                results.forEach((brand) => {
                    let verified = false;
                    formatedBrands.push(Object.assign(brand.toJSON(), { verified }));
                });
            }
            return formatedBrands;
        });
        let channelBrands;
        if (channelBrand && channelBrand.length == 0) {
            return [];
        }
        channelBrands = {
            "channelBrand": channelBrand,
            "total": +channelBrandCount
        };
        return channelBrands;
    }
    async eventMatching(contactData) {
        let event = [];
        let channelId;
        let contactId;
        let contactIds;
        let channelIds;
        let channeltype = [];
        channelId = contactData.companyId;
        contactId = contactData.contactId;
        try {
            let chtype = await this.sequelizeInstance.query('select "channelTypeId" from "tblChannel" where "channelId"=:chid ', {
                type: sequelize_1.QueryTypes.SELECT,
                replacements: {
                    chid: channelId
                }
            });
            let typeid = chtype.map(x => x.channelTypeId);
            if (typeid == 2)
                channeltype = [3, 4];
            else if (typeid == 3)
                channeltype = [2];
            else if (typeid == 4)
                channeltype = [2];
            let contacts = await this.sequelizeInstance.query('select * from "tblContact" where "isActive"=\'1\' and "isEvent"=\'1\' and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "deletedAt" is null and "signUpStatusId"=15) ', {
                type: sequelize_1.QueryTypes.SELECT,
                replacements: {
                    channelTypeId: channeltype
                }
            });
            contactIds = contacts.map(x => x.contactId);
            channelIds = contacts.map(x => x.channelId);
            let contactids = contactIds.toString();
            let channelids = channelIds.toString();
            let result = await this.sequelizeInstance.query('select * from "EventMatchingAlgm"(:chid,:conid,:plan,:conids,:chids)', {
                type: sequelize_1.QueryTypes.SELECT,
                replacements: {
                    conid: contactId,
                    chid: channelId,
                    plan: 0,
                    conids: contactids,
                    chids: channelids
                }
            });
            let i = 1;
            let results = [];
            let mscore;
            if (result[0].EventMatchingAlgm != null) {
                if (result[0].EventMatchingAlgm.intmatched != null) {
                    result[0].EventMatchingAlgm.intmatched.map(x => {
                        if (x.profile_strength > 75)
                            mscore = 80 + 20;
                        else if (x.profile_strength >= 70 && x.profile_strength <= 75)
                            mscore = 80 + 15;
                        else if (x.profile_strength >= 65 && x.profile_strength < 70)
                            mscore = 80 + 10;
                        else if (x.profile_strength < 65)
                            mscore = 80 + 8;
                        Object.assign(x, { isInterested: true, isMatched: true, rank: i++, matchingScore: mscore });
                    });
                    results.push(...result[0].EventMatchingAlgm.intmatched);
                }
                if (result[0].EventMatchingAlgm.matched != null) {
                    result[0].EventMatchingAlgm.matched.map(x => {
                        if (x.profile_strength > 75)
                            mscore = 70 + 20;
                        else if (x.profile_strength >= 70 && x.profile_strength <= 75)
                            mscore = 70 + 15;
                        else if (x.profile_strength >= 65 && x.profile_strength < 70)
                            mscore = 70 + 10;
                        else if (x.profile_strength < 65)
                            mscore = 70 + 8;
                        Object.assign(x, { isInterested: false, isMatched: true, rank: i++, matchingScore: mscore });
                    });
                    results.push(...result[0].EventMatchingAlgm.matched);
                }
                if (result[0].EventMatchingAlgm.nonmatched != null) {
                    result[0].EventMatchingAlgm.nonmatched.map(x => {
                        if (x.profile_strength > 75)
                            mscore = 60 + 20;
                        else if (x.profile_strength >= 70 && x.profile_strength <= 75)
                            mscore = 60 + 15;
                        else if (x.profile_strength >= 65 && x.profile_strength < 70)
                            mscore = 60 + 10;
                        else if (x.profile_strength < 65)
                            mscore = 60 + 8;
                        Object.assign(x, { isInterested: false, isMatched: false, rank: i++, matchingScore: mscore });
                    });
                    results.push(...result[0].EventMatchingAlgm.nonmatched);
                }
            }
            let data = {
                companyId: channelId,
                contactId: contactId,
                participant: results.length > 0 ? results : []
            };
            return data;
        }
        catch (e) {
            return [];
        }
    }
    async eventListing(typeid) {
        let channeltype = [];
        let result = [];
        if (typeid == 2)
            channeltype = [2];
        else if (typeid == 3)
            channeltype = [3];
        else if (typeid == 4)
            channeltype = [4];
        else if (typeid == 1)
            channeltype = [3, 4];
        try {
            let query = 'select tc."channelId",tc."companyName",(select "country" from "tblCountry" where "countryId"=tc."countryId") as "Country",cd."detailDesc" as tweetpitch, cd."webSiteUrl" as websiteurl, '
                + '(select concat(\'https://d35w8j22j5uly8.cloudfront.net/\',"documentPath") from "tblDocument" where "documentId"=cd."channelLogoId") as companyLogo, '
                + 'case when tc."channelTypeId"=2 then \'Vendor\' when tc."channelTypeId"=3 then \'Distributor\' when tc."channelTypeId"=4 then \'Retailer\' end as channelType, '
                + '(select array_to_json(array_agg(row_to_json(c))) from(select concat("firstName",\' \',"lastName",\',\',"jobTitle") as contact,(Select array_to_json(array_agg(row_to_json(x))) from(select pc."productCategorie" as item_name from "tblContactInterestedProductCategory" cpc inner join "tblProductCategories" pc on pc."productCategorieId" = cpc."productCategorieId" where cpc."contactId"=tcon."contactId" and "isEvent"=\'1\')x) as intcat, '
                + '(select array_to_json(array_agg(row_to_json(x))) from (Select pc."productCategorie" as item_name from "tblContactProductCategorie" cpc inner join "tblProductCategories" pc on pc."productCategorieId" = cpc."productCategorieId" where cpc."contactId"=tcon."contactId")x) as cat '
                + ' from "tblContact" where "channelId"=tc."channelId" and tcon."isEvent"=\'1\')c) as contact, '
                + '(select array_to_json(array_agg(row_to_json(z))) from (Select pt."profileType" as item_name from "tblProfileType" pt where "profileTypeId" in (select "profileTypeId" from "tblChannelCustomerProfile" as ccp where ccp."channelId"=tc."channelId"))z) as retail_customer_profile, '
                + 'tc."profileStrength" as "profileScore" from "tblContact" tcon inner join "tblChannel" tc on tc."channelId"=tcon."channelId" and tc."channelTypeId" in(:channelTypeId) '
                + 'inner join "tblChannelDetail" cd on cd."channelId"=tcon."channelId" where tcon."isEvent"=\'1\' and tcon."isActive"=\'1\' order by tc."companyName" asc';
            result = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                replacements: {
                    channelTypeId: channeltype
                }
            });
        }
        catch (e) {
            console.log("error:", e);
        }
        return result;
    }
    async getPassword(contactId) {
        let query = 'select "password" from "tblUser" where "contactId"=:contactId';
        let password = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                contactId: contactId
            }
        }).then(x => {
            return x[0].password;
        });
        return password;
    }
};
PublicChannelService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject('SequelizeInstance')),
    __param(1, common_1.Inject('ChannelRepository')),
    __param(2, common_1.Inject('SignUpStatusRepository')),
    __param(3, common_1.Inject('ChannelTypeRepository')),
    __param(4, common_1.Inject('ProductGroupRepository')),
    __param(5, common_1.Inject('ProductCategoryRepository')),
    __param(6, common_1.Inject('ProfileTypeRepository')),
    __param(7, common_1.Inject('ContactJCTRepository')),
    __param(8, common_1.Inject('SubscriptionRepository')),
    __param(9, common_1.Inject('MediaRepository')),
    __param(10, common_1.Inject('ChannelCertificateTypeRepository')),
    __param(11, common_1.Inject('ProductRepository')),
    __param(12, common_1.Inject('SharetypeRepository')),
    __param(13, common_1.Inject('ChannelCustomerProfileRepository')),
    __param(14, common_1.Inject('ProfileTypeClassificationRepository')),
    __param(15, common_1.Inject('BrandRepository')),
    __param(16, common_1.Inject('ContactRepository')),
    __param(17, common_1.Inject('ChannelBrandRepository')),
    __param(19, common_1.Inject('CompanyMediaImagesRepository')),
    __metadata("design:paramtypes", [Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, channelKeyPartner_service_1.ChannelKeyPartnerService, Object])
], PublicChannelService);
exports.PublicChannelService = PublicChannelService;
//# sourceMappingURL=public.channel.service.js.map