import { Subscription } from '../models/Subscription.entity';
import { SubscriptionPeriod } from '../models/SubscriptionPeriod.entity';
import { SubscriptionPlan } from '../models/SubscriptionPlan.entity';
import { SubscriptionExtraFeature } from '../models/SubscriptionExtraFeature.entity';
import { SubscriptionExtraFeatureCategory } from '../models/SubscriptionExtraFeatureCategories.entity';
import { ChannelSubscription } from './../models/ChannelSubscription.entity';
import { PaymentTransaction } from './../models/PaymentTransaction.entity';
import { SubscriptionDetail } from '../models/SubscriptionDetail.entity';
import { SubscribeDto } from './../dto/subscribe.dto';
import { Address } from '../models/Address.entity';
import { Coupon } from '../models/Coupon.entity';
import { Channel } from '../models/Channel.entity';
import { User } from '../../user/models/User.entity';
import { ChannelSuggestion } from './../models/ChannelSuggestion.entity';
import { ClientProxy } from '@nestjs/microservices';
import { FailureTransaction } from '../models/FailureTransaction.entity';
export declare class SubscriptionService {
    private readonly sequelizeInstance;
    private readonly subscriptionPeriodRepository;
    private readonly subscriptionRepository;
    private readonly subscriptionPlanRepository;
    private readonly subscriptionExtraFeatureRepository;
    private readonly subscriptionExtraFeatureCategoryRepository;
    private readonly paymentTransactionRepository;
    private readonly channelSubscriptionRepository;
    private readonly addressRepository;
    private readonly couponRepository;
    private readonly userRepository;
    private readonly mailerProvider;
    private readonly subscriptionDetailRepository;
    private readonly channelSuggestion;
    private readonly channelRepository;
    private algorithmService;
    private utility;
    constructor(sequelizeInstance: any, subscriptionPeriodRepository: typeof SubscriptionPeriod, subscriptionRepository: typeof Subscription, subscriptionPlanRepository: typeof SubscriptionPlan, subscriptionExtraFeatureRepository: typeof SubscriptionExtraFeature, subscriptionExtraFeatureCategoryRepository: typeof SubscriptionExtraFeatureCategory, paymentTransactionRepository: typeof PaymentTransaction, channelSubscriptionRepository: typeof ChannelSubscription, addressRepository: typeof Address, couponRepository: typeof Coupon, userRepository: typeof User, mailerProvider: any, subscriptionDetailRepository: typeof SubscriptionDetail, channelSuggestion: typeof ChannelSuggestion, channelRepository: typeof Channel, algorithmService: ClientProxy);
    subscriptionPlanAllPeriod(channelTypeId: number): Promise<any>;
    isOfflineRequestInProcess(user: any): Promise<{
        rows: ChannelSubscription[];
        count: number;
    }>;
    getSubscriptionDetails(subscriptionId: any): Promise<Subscription[]>;
    getSubscriptionType(user: any, subscriptionId: any): Promise<any>;
    getSubscriptiondetails(subscriptionId: any): Promise<Subscription>;
    calculateAmount(subscribeDto: SubscribeDto, subscriptionType: any, user: any): Promise<{
        totalAmount: number;
        couponDiscount: number;
        remainingAmount: number;
        taxAmount: number;
        vat: number;
        finalAmount: number;
    }>;
    private calculateTotalRemainingAmount;
    coupanValidate(subscribeDto: any, user: any, subscriptionType: any): Promise<{
        payableAmt: number;
        couponDiscount: number;
        couponOfferValue: number;
    }>;
    private _validateCoupon;
    getTransactionId(amount: any, transactionTypeId: any, payeeChannelId: any, payerChannelId: any, userId: any, subscribeObj: SubscribeDto, entity?: string): Promise<PaymentTransaction>;
    createChannelSubscription(user: any, subscriptionId: any, couponcode: any, paymentTransactionId: any, paymentStatus: any, subscriptionTypeId: any, transaction: any, cardLastFourDigit: any): Promise<ChannelSubscription>;
    private subscriptionAckMail;
    uploadInvoicePdf(originPath: any, channelId: any, filename: any): Promise<void>;
    getAccountOwner(channelId: any): Promise<User>;
    unsubscribe_token(contactId: any): Promise<any>;
    private processSuggesstionQueue;
    updateOldTransac(oldSubscriptionId: any): Promise<ChannelSubscription>;
    getAllList(pagination: any, search: any, filters: any, sort?: any): Promise<{
        count: number;
        rows: any[];
        aggregations: {};
    }>;
    insertKeyFeature(categories: any, subscriptionId: any): Promise<any>;
    getAllKeyFeatures(channelTypeId: any, subscriptionPeriodId: any): Promise<any>;
    updateKeyFeatureForchannel(channelId: any, subscriptionId: any): Promise<void>;
    getPlansforAdmin(): Promise<Subscription[]>;
    getPlansDetailsById(subscriptionId: any): Promise<Subscription>;
    updateSubscription(data: any, subscriptionId: any): Promise<number>;
    failedTransaction(data: any): Promise<FailureTransaction>;
    getFeaterListId(channelId: any): Promise<ChannelSubscription>;
    getFeaterCategoryList(keyFeature: any): Promise<any[]>;
    updateChannelFeatureList(extraFeature: any, channelId: any): Promise<void>;
    updateOfflinrPayment(id: any, dto: any): Promise<any>;
    UpdateTransactionById(transId: any, alipaySourceId: any): Promise<void>;
}
