'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SubscriptionService = void 0;
const common_1 = require("@nestjs/common");
const Subscription_entity_1 = require("../models/Subscription.entity");
const SubscriptionPeriod_entity_1 = require("../models/SubscriptionPeriod.entity");
const SubscriptionPlan_entity_1 = require("../models/SubscriptionPlan.entity");
const SubscriptionExtraFeature_entity_1 = require("../models/SubscriptionExtraFeature.entity");
const SubscriptionExtraFeatureCategories_entity_1 = require("../models/SubscriptionExtraFeatureCategories.entity");
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
const lodash_1 = require("lodash");
const sequelize_typescript_1 = require("sequelize-typescript");
const utility_1 = require("../helper/utility");
const ChannelSubscription_entity_1 = require("./../models/ChannelSubscription.entity");
const PaymentTransaction_entity_1 = require("./../models/PaymentTransaction.entity");
const app_constant_1 = require("../../../config/app.constant");
const esearch_1 = require("../../../config/esearch");
const Country_entity_1 = require("../../common/models/Country.entity");
const Address_entity_1 = require("../models/Address.entity");
const ChannelJCT_entity_1 = require("../models/ChannelJCT.entity");
const Channel_entity_1 = require("../models/Channel.entity");
const UserRole_entity_1 = require("../../user/models/UserRole.entity");
const User_entity_1 = require("../../user/models/User.entity");
const Role_entity_1 = require("../../user/models/Role.entity");
const Contact_entity_1 = require("./../../user/models/Contact.entity");
const moment = require("moment");
const ejs_1 = require("ejs");
const S3Lib_1 = require("../../../lib/S3Lib");
let fs = require('fs');
const path_1 = require("path");
const ChannelSuggestion_entity_1 = require("./../models/ChannelSuggestion.entity");
const microservices_1 = require("@nestjs/microservices");
const ChannelDetail_entity_1 = require("../models/ChannelDetail.entity");
const ChannelType_entity_1 = require("../models/ChannelType.entity");
const models_1 = require("../../media/models");
const SubscriptionType_entity_1 = require("../models/SubscriptionType.entity");
const FailureTransaction_entity_1 = require("../models/FailureTransaction.entity");
const sequelize_1 = require("sequelize");
let SubscriptionService = class SubscriptionService {
    constructor(sequelizeInstance, subscriptionPeriodRepository, subscriptionRepository, subscriptionPlanRepository, subscriptionExtraFeatureRepository, subscriptionExtraFeatureCategoryRepository, paymentTransactionRepository, channelSubscriptionRepository, addressRepository, couponRepository, userRepository, mailerProvider, subscriptionDetailRepository, channelSuggestion, channelRepository, algorithmService) {
        this.sequelizeInstance = sequelizeInstance;
        this.subscriptionPeriodRepository = subscriptionPeriodRepository;
        this.subscriptionRepository = subscriptionRepository;
        this.subscriptionPlanRepository = subscriptionPlanRepository;
        this.subscriptionExtraFeatureRepository = subscriptionExtraFeatureRepository;
        this.subscriptionExtraFeatureCategoryRepository = subscriptionExtraFeatureCategoryRepository;
        this.paymentTransactionRepository = paymentTransactionRepository;
        this.channelSubscriptionRepository = channelSubscriptionRepository;
        this.addressRepository = addressRepository;
        this.couponRepository = couponRepository;
        this.userRepository = userRepository;
        this.mailerProvider = mailerProvider;
        this.subscriptionDetailRepository = subscriptionDetailRepository;
        this.channelSuggestion = channelSuggestion;
        this.channelRepository = channelRepository;
        this.algorithmService = algorithmService;
        this.utility = new utility_1.Utility();
    }
    async subscriptionPlanAllPeriod(channelTypeId) {
        let self = this;
        let obj = [];
        let subscriptionPlanTransform = {};
        let subsPlan = {};
        let featureCat = {};
        let levelOne = {};
        try {
            let subscriptionPeriod = await self.subscriptionPeriodRepository.findAll({
                where: {
                    isActive: '1',
                },
            }).then(async (results) => {
                return results;
            });
            let featureListValues = {};
            let appliedChannelType = null;
            if (channelTypeId == 2) {
                appliedChannelType = 'VENDOR';
            }
            let featureCat = {};
            let res = [];
            let featureLabel = await this.subscriptionExtraFeatureCategoryRepository.findAll({
                attributes: ['subscriptionExtraFeatureCategoryId', 'subscriptionExtraFeatureCategory', 'FeatureCategoryId'],
                where: {
                    isActive: '1',
                    appliedChannelType: appliedChannelType,
                    FeatureCategoryId: null
                },
                order: [['order', 'asc']]
            }).then(async (arrresults) => {
                return arrresults;
            });
            for (var k = 0; k < featureLabel.length; k++) {
                featureCat[featureLabel[k].subscriptionExtraFeatureCategory.trim()] = {};
                featureCat[featureLabel[k].subscriptionExtraFeatureCategory.trim()]['values'] = {};
                let query = ' select se."subscriptionExtraFeatureCategory", se."subscriptionExtraFeatureCategoryId", sf."subscriptionId", sf."feature_label", sf."feature_value" from "tblSubscriptionExtraFeature" sf '
                    + '  join "tblSubscriptionExtraFeatureCategories" se on sf."subscriptionExtraFeatureCategoryId" = se."subscriptionExtraFeatureCategoryId" '
                    + ' where  se."FeatureCategoryId" = :subscriptionExtraFeatureCategoryId AND sf."isActive" = :isActive AND sf."deletedAt" is null '
                    + ' order by sf."subscriptionExtraFeatureCategoryId" asc ';
                res = await this.sequelizeInstance.query(query, {
                    type: sequelize_1.QueryTypes.SELECT,
                    replacements: {
                        subscriptionExtraFeatureCategoryId: featureLabel[k].subscriptionExtraFeatureCategoryId,
                        isActive: '1'
                    }
                }).then(result => {
                    let categoryIdArr = [];
                    for (var j = 0; j < result.length; j++) {
                        let lcId = result[j].subscriptionExtraFeatureCategoryId;
                        if (categoryIdArr.indexOf(result[j].subscriptionExtraFeatureCategoryId) === -1) {
                            featureCat[featureLabel[k].subscriptionExtraFeatureCategory.trim()]['values'][lcId] = {};
                            featureCat[featureLabel[k].subscriptionExtraFeatureCategory.trim()]['values'][lcId]['label'] = {};
                            featureCat[featureLabel[k].subscriptionExtraFeatureCategory.trim()]['values'][lcId]['label'] = result[j].subscriptionExtraFeatureCategory.trim();
                            if (result[j].subscriptionId == 1) {
                                featureCat[featureLabel[k].subscriptionExtraFeatureCategory.trim()]['values'][lcId]['free'] = result[j].feature_value;
                            }
                            else {
                                featureCat[featureLabel[k].subscriptionExtraFeatureCategory.trim()]['values'][lcId]['premium'] = result[j].feature_value;
                            }
                            categoryIdArr.push(result[j].subscriptionExtraFeatureCategoryId);
                        }
                        else {
                            if (result[j].subscriptionId == 1) {
                                featureCat[featureLabel[k].subscriptionExtraFeatureCategory.trim()]['values'][lcId]['free'] = result[j].feature_value;
                            }
                            else {
                                featureCat[featureLabel[k].subscriptionExtraFeatureCategory.trim()]['values'][lcId]['premium'] = result[j].feature_value;
                            }
                        }
                    }
                });
            }
            let subscriptionObj = [];
            for (var i = 0; i < subscriptionPeriod.length; i++) {
                subscriptionPlanTransform[+i] = {};
                subscriptionPlanTransform[+i]['period'] = subscriptionPeriod[i];
                subscriptionPlanTransform[+i]['planDetails'] = [];
                let subscription = await this.subscriptionRepository.findAll({
                    include: [{
                            model: SubscriptionPlan_entity_1.SubscriptionPlan,
                            required: true,
                            where: { isActive: '1' }
                        }],
                    where: {
                        isActive: '1',
                        subscriptionPeriodId: subscriptionPeriod[i].subscriptionPeriodId,
                        channelTypeId: channelTypeId,
                    },
                    order: [['subscriptionId', 'asc']]
                });
                for (var k = 0; k < subscription.length; k++) {
                    let subscriptionExtraFeature = await this.subscriptionExtraFeatureRepository.findAll({
                        where: {
                            isActive: '1',
                            subscriptionId: subscription[k].subscriptionId
                        },
                        order: [['subscriptionId', 'asc']]
                    });
                    subscriptionPlanTransform[+i]['planDetails'][k] = [];
                    subscriptionPlanTransform[+i]['planDetails'][k] = subscription[k];
                }
            }
            subsPlan = { 'featureLabel': featureCat, "subscriptionPlans": subscriptionPlanTransform };
            return subsPlan;
        }
        catch (e) {
            console.log("Error+", e);
            throw new common_1.InternalServerErrorException();
        }
    }
    async isOfflineRequestInProcess(user) {
        let filter = {};
        if (user.channel.channelSubscription && user.channel.channelSubscription.channelSubscriptionId) {
            filter['oldChannelSubscriptionId'] = user.channel.channelSubscription.channelSubscriptionId;
        }
        filter['channelId'] = +user.channelId;
        filter['isPaid'] = '0';
        filter['isActive'] = '0';
        filter['$"paymentTransaction"."status"$'] = '0';
        filter['$"paymentTransaction"."paymentMethodId"$'] = app_constant_1.appconstant.PAYMENT_METHOD.OFFLINE_WIRE_TRANSFER;
        let channelSubscription = await ChannelSubscription_entity_1.ChannelSubscription.findAndCountAll({
            where: filter,
            include: [
                {
                    model: PaymentTransaction_entity_1.PaymentTransaction,
                    as: 'paymentTransaction',
                    required: true,
                    where: {
                        paymentMethodId: app_constant_1.appconstant.PAYMENT_METHOD.OFFLINE_WIRE_TRANSFER,
                        status: '0'
                    }
                }
            ]
        });
        console.log(channelSubscription);
        return channelSubscription;
    }
    async getSubscriptionDetails(subscriptionId) {
        let subscription = await this.subscriptionRepository.findAll({
            include: [
                {
                    model: SubscriptionPlan_entity_1.SubscriptionPlan
                }, {
                    model: SubscriptionPeriod_entity_1.SubscriptionPeriod
                },
            ],
            where: {
                isActive: '1',
                deletedAt: null,
                subscriptionId: subscriptionId
            },
        });
        if (!subscription) {
            throw new Process_exception_1.ProcessException('channel:subscription:notFound');
        }
        return subscription;
    }
    async getSubscriptionType(user, subscriptionId) {
        var subscriptionType;
        if (user.channel.channelSubscription == null || (user.channel.channelSubscription && user.channel.channelSubscription.subscriptionId == null)) {
            subscriptionType = Subscription_entity_1.Subscription.SUBSCRIPTION_TYPE_NEW;
        }
        else if (+user.channel.channelSubscription.subscriptionId == subscriptionId) {
            subscriptionType = Subscription_entity_1.Subscription.SUBSCRIPTION_TYPE_RENEWAL;
        }
        else if (+user.channel.channelSubscription.subscriptionId != subscriptionId) {
            let subscription = await this.subscriptionRepository.findByPk(subscriptionId);
            if (!subscription) {
                throw new Process_exception_1.ProcessException('channel:subscription:notFound');
            }
            if (+user.channel.planId == +subscription.subscriptionPlanId) {
                subscriptionType = Subscription_entity_1.Subscription.SUBSCRIPTION_TYPE_RENEWAL;
            }
            else {
                let isUpgrade = await this.subscriptionPlanRepository.findAll({
                    attributes: ['subscriptionPlanId', 'rankOrder', 'subscriptionPlanType', 'isActive'],
                    where: {
                        subscriptionPlanId: {
                            [sequelize_1.Op.in]: [user.channel.planId, subscription.subscriptionPlanId]
                        },
                        isActive: '1'
                    }
                }).then((data) => {
                    if (data[0] && data[1]) {
                        if (+user.channel.planId == +data[0].subscriptionPlanId && data[1].rankOrder > data[0].rankOrder) {
                            return true;
                        }
                        else if (+user.channel.planId == +data[1].subscriptionPlanId && data[1].rankOrder < data[0].rankOrder) {
                            return true;
                        }
                        else {
                            return false;
                        }
                    }
                    else {
                        return true;
                    }
                });
                if (!isUpgrade) {
                    subscriptionType = Subscription_entity_1.Subscription.SUBSCRIPTION_TYPE_DOWNGRADE;
                }
                else {
                    subscriptionType = Subscription_entity_1.Subscription.SUBSCRIPTION_TYPE_UPGRADE;
                }
            }
        }
        return subscriptionType;
    }
    async getSubscriptiondetails(subscriptionId) {
        return await this.subscriptionRepository.scope('all').findByPk(subscriptionId);
    }
    async calculateAmount(subscribeDto, subscriptionType, user) {
        console.log(subscribeDto.subscriptionId);
        let subscription = await this.subscriptionRepository.findByPk(subscribeDto.subscriptionId);
        if (!subscription) {
            throw new Process_exception_1.ProcessException('channel:subscription:notFound');
        }
        var finalAmount = subscription.finalAmount;
        var couponDiscount = 0;
        var discountedAmount = 0;
        var remainingAmount = 0;
        discountedAmount = +finalAmount.toFixed(2);
        if (subscriptionType == Subscription_entity_1.Subscription.SUBSCRIPTION_TYPE_UPGRADE) {
            if (user.channel.channelSubscription.subscription.subscriptionPeriodId == Subscription_entity_1.Subscription.SUBSCRIPTION_PERIOD_YEAR && subscription.subscriptionPeriodId == Subscription_entity_1.Subscription.SUBSCRIPTION_PERIOD_YEAR) {
                remainingAmount = +await this.channelSubscriptionRepository.findOne({
                    attributes: ['isActive', 'endAt', 'finalAmount', 'actualAmount'],
                    where: {
                        channelId: user.channelId,
                        isActive: '1'
                    },
                    order: [
                        ['channelSubscriptionId', 'DESC']
                    ],
                    raw: true
                }).then(this.calculateTotalRemainingAmount(user));
            }
            discountedAmount = discountedAmount - remainingAmount;
        }
        let taxAmount = 0;
        var addressRepo = await this.addressRepository.findOne({
            attributes: ['countryId'],
            include: [
                {
                    model: Country_entity_1.Country,
                    attributes: ['isVat'],
                    as: 'country',
                    required: true
                }
            ],
            where: {
                addressId: user.channel.regAddressId
            },
            order: [
                ['addressId', 'DESC']
            ]
        });
        if (addressRepo.isVat == '1' && +addressRepo.countryId == +process.env.VAT_FRANCE_COUNTRY) {
            taxAmount = +(discountedAmount * (app_constant_1.appconstant.VAT_PERCENTAGE / 100)).toFixed(2);
            discountedAmount = discountedAmount + taxAmount;
        }
        return {
            totalAmount: +finalAmount.toFixed(2),
            couponDiscount: +couponDiscount.toFixed(2),
            remainingAmount: +remainingAmount.toFixed(2),
            taxAmount: +taxAmount.toFixed(2),
            vat: app_constant_1.appconstant.VAT_PERCENTAGE,
            finalAmount: (discountedAmount > 0) ? +discountedAmount.toFixed(2) : 0
        };
    }
    calculateTotalRemainingAmount(user) {
        return async (result) => {
            var totalRemainingAmount = 0;
            if (result.isActive == 1) {
                let remain_months = Math.floor(result.remaining_days / 30);
                let monthAmount = result.actualAmount / 12;
                if (monthAmount) {
                    totalRemainingAmount = monthAmount * +remain_months;
                }
            }
            return (totalRemainingAmount > 0) ? totalRemainingAmount : 0;
        };
    }
    async coupanValidate(subscribeDto, user, subscriptionType) {
        var couponDiscount = 0;
        var finalAmount = subscribeDto.finalAmount;
        var discountedAmount = 0;
        var couponOfferValue = 0;
        if (subscribeDto.couponCode) {
            let coupon = await this.couponRepository.findOne({
                where: {
                    couponCode: subscribeDto.couponCode,
                    subscriptionTypeId: +subscriptionType,
                    channelTypeId: +user.channel.channelTypeId,
                    subscriptionPlanId: +subscribeDto.subscriptionPlanId,
                    subscriptionPeriodId: +subscribeDto.subscriptionPeriodId,
                    fromDate: {
                        [sequelize_1.Op.lt]: moment().toDate()
                    },
                    toDate: {
                        [sequelize_1.Op.gte]: moment().toDate()
                    }
                }
            });
            if (!coupon) {
                throw new Process_exception_1.ProcessException('channel:coupon:notValidCoupon');
            }
            if (coupon) {
                if (!await this._validateCoupon(coupon.couponId, user.channelId, coupon.userThreshold, coupon.usageThreshold)) {
                    throw new Process_exception_1.ProcessException('channel:coupon:exceedUserLimit');
                }
            }
            couponDiscount = await coupon.getOfferAmount(parseFloat(finalAmount).toFixed(2));
            discountedAmount = +await coupon.getDiscountedAmount(parseFloat(finalAmount).toFixed(2));
            couponOfferValue = coupon.couponOfferValue;
        }
        else {
            discountedAmount = +finalAmount.parseFloat(finalAmount).toFixed(2);
        }
        return { 'payableAmt': discountedAmount, 'couponDiscount': couponDiscount, 'couponOfferValue': couponOfferValue };
    }
    async _validateCoupon(couponId, channelId, userThreshold, usageThreshold) {
        var query = 'select count(DISTINCT cs."channelId") from "tblChannelSubscription" cs inner join "tblCoupon" c on c."couponId" = cs."couponId" where c."couponId" = :couponId';
        var nextquery = 'select count(c."couponId")  from "tblChannelSubscription" cs inner join "tblCoupon" c on c."couponId" = cs."couponId" where c."couponId" = :couponId  and  cs."channelId" = :channelId';
        return await this.sequelizeInstance.query(query, {
            type: this.sequelizeInstance.QueryTypes.SELECT,
            replacements: {
                couponId: couponId,
            }
        }).then(userCount => {
            if (userCount[0].count >= userThreshold) {
                return false;
            }
            return this.sequelizeInstance.query(nextquery, {
                type: this.sequelizeInstance.QueryTypes.SELECT,
                replacements: {
                    couponId: couponId,
                    channelId: channelId,
                }
            }).then(usageCount => {
                if (usageCount[0].count >= usageThreshold) {
                    return false;
                }
                return true;
            });
        });
    }
    async getTransactionId(amount, transactionTypeId, payeeChannelId, payerChannelId, userId, subscribeObj, entity = 'subscription') {
        try {
            return await this.paymentTransactionRepository.create({
                paymentTypeId: transactionTypeId,
                paymentMethodId: subscribeObj.paymentMethodId,
                payerChannelId: payerChannelId,
                payeeChannelId: payeeChannelId,
                amount: amount,
                updatedBy: userId,
                currencyid: app_constant_1.appconstant.CHANNELHUB_CURRENCY,
                paymentIntent: subscribeObj.paymentIntent,
                entity: entity,
                entityId: subscribeObj.subscriptionId,
                couponCode: (subscribeObj.couponCode) ? subscribeObj.couponCode : null
            }).then(async (invoice) => {
                let invoicenumber;
                if (amount == 0 || subscribeObj.paymentMethodId == 2) {
                    invoicenumber = null;
                    invoice.invoiceno = null;
                }
                else {
                    invoicenumber = await this.sequelizeInstance.query('select \'CH\' || to_char(now(),\'YYMM\')  || \'-9\' || case when ((count(*)+1) < 9) then \'0\' else \'\' end || (count(*) + 1) :: varchar(16) as number from "tblPaymentTransaction" where "invoiceno" like CONCAT(\'CH\',to_char(now(),\'YYMM\'),\'%\') and to_char("paymentTransactionAt", \'mm/yyyy\') = to_char(now(), \'mm/yyyy\') and "paymentTransactionId" < ' + invoice.paymentTransactionId, {
                        type: this.sequelizeInstance.QueryTypes.SELECT,
                        raw: true,
                    });
                    invoice.invoiceno = invoicenumber[0].number;
                }
                await invoice.save();
                return invoice;
            });
        }
        catch (e) {
            console.log(e);
        }
    }
    async createChannelSubscription(user, subscriptionId, couponcode, paymentTransactionId, paymentStatus, subscriptionTypeId, transaction, cardLastFourDigit) {
        let subscription = await this.subscriptionRepository.scope('all').findByPk(subscriptionId);
        if (!subscription) {
            throw new Process_exception_1.ProcessException('channel:subscription:notFound');
        }
        let extraFeature = {};
        let subscriptionExtraFeature = await this.subscriptionExtraFeatureRepository.findAll({
            attributes: ['subscriptionId', 'feature_value', 'subscriptionExtraFeatureCategoryId'],
            where: {
                subscriptionId: subscriptionId,
                isActive: '1'
            }
        }).then(async (Featuredata) => {
            Featuredata.forEach(async (data) => {
                extraFeature[data['subscriptionExtraFeatureCategoryId']] = data['feature_value'];
            });
            return extraFeature;
        });
        let actualAmount = +subscription.amount;
        let finalAmount = +subscription.finalAmount;
        let discountAmount = +actualAmount - +finalAmount;
        var remainingAmount = 0;
        var couponAmount = 0;
        var coupon = null;
        if (couponcode) {
            coupon = await this.couponRepository.findOne({
                where: {
                    couponCode: couponcode,
                    subscriptionTypeId: subscriptionTypeId,
                    channelTypeId: user.channel.channelTypeId,
                    subscriptionPlanId: subscription.subscriptionPlanId,
                    subscriptionPeriodId: subscription.subscriptionPeriodId,
                    fromDate: {
                        [sequelize_1.Op.lt]: moment().toDate()
                    },
                    toDate: {
                        [sequelize_1.Op.gte]: moment().toDate()
                    }
                }
            });
            console.log('im in channel subscription');
            console.log(coupon);
            if (!coupon) {
                throw new Process_exception_1.ProcessException('channel:coupon:notValidCoupon');
            }
            if (!await this._validateCoupon(coupon.couponId, user.channelId, coupon.userThreshold, coupon.usageThreshold)) {
                throw new Process_exception_1.ProcessException('channel:coupon:exceedUserLimit');
            }
            couponAmount = await coupon.getOfferAmount(finalAmount).then(function (result) {
                return result;
            });
            console.log('couponAmount', couponAmount);
        }
        discountAmount = +discountAmount + +couponAmount;
        finalAmount = +finalAmount - +couponAmount;
        if (subscriptionTypeId == Subscription_entity_1.Subscription.SUBSCRIPTION_TYPE_UPGRADE) {
            let rdays = sequelize_typescript_1.Sequelize.literal('extract(day from "endAt"::timestamp - now()) as remaining_days');
            if (user.channel.channelSubscription.subscription.subscriptionPeriodId == Subscription_entity_1.Subscription.SUBSCRIPTION_PERIOD_YEAR && subscription.subscriptionPeriodId == Subscription_entity_1.Subscription.SUBSCRIPTION_PERIOD_YEAR) {
                remainingAmount = +await this.channelSubscriptionRepository.findOne({
                    attributes: ['isActive', 'endAt', 'finalAmount', 'actualAmount'],
                    where: {
                        channelId: user.channelId
                    },
                    order: [
                        ['channelSubscriptionId', 'DESC']
                    ],
                    raw: true
                }).then(this.calculateTotalRemainingAmount(user));
            }
            discountAmount = discountAmount + remainingAmount;
            finalAmount = +finalAmount - +remainingAmount;
        }
        var periodInDays = 0;
        var additionalDays = 0;
        if (subscription.subscriptionPeriod !== undefined) {
            periodInDays = +subscription.subscriptionPeriod.periodValueInDays;
        }
        let endAt = sequelize_typescript_1.Sequelize.literal("CURRENT_TIMESTAMP + interval '" + +periodInDays + "' day");
        let taxAmount = 0;
        var addressRepo = await this.addressRepository.findOne({
            attributes: ['countryId'],
            include: [
                {
                    model: Country_entity_1.Country,
                    attributes: ['isVat'],
                    as: 'country',
                    required: true
                }
            ],
            where: {
                addressId: user.channel.regAddressId
            },
            order: [
                ['addressId', 'DESC']
            ]
        });
        if (addressRepo.isVat == '1' && +addressRepo.countryId == +process.env.VAT_FRANCE_COUNTRY) {
            taxAmount = +(finalAmount * (app_constant_1.appconstant.VAT_PERCENTAGE / 100)).toFixed(2);
            finalAmount = +finalAmount + +taxAmount;
        }
        let taxNumber = null;
        if (taxAmount > 0) {
            if (user.channel && user.channel.channelCertificate && user.channel.channelCertificate[0] && user.channel.channelCertificate[0].cerificateNumber) {
                taxNumber = user.channel.channelCertificate[0].cerificateNumber;
            }
        }
        try {
            var oldChannelSubscription = await this.channelSubscriptionRepository.findOne({
                where: {
                    channelId: user.channel.channelId,
                    isActive: '1'
                },
                order: [
                    ['channelSubscriptionId', 'DESC']
                ],
                raw: true
            });
            let startedAt = sequelize_typescript_1.Sequelize.literal('CURRENT_TIMESTAMP');
            if (+subscriptionTypeId === Subscription_entity_1.Subscription.SUBSCRIPTION_TYPE_RENEWAL) {
                let dateEndAt = await this.sequelizeInstance.query('select case when "endAt" > CURRENT_TIMESTAMP THEN "endAt" + interval ' + "'" + +periodInDays + "'" + ' day when "endAt" < CURRENT_TIMESTAMP then CURRENT_TIMESTAMP + interval ' + "'" + +periodInDays + "'" + ' day END as date from "tblChannelSubscription" where "channelSubscriptionId" = ' + oldChannelSubscription.channelSubscriptionId + ' limit 1', {
                    type: this.sequelizeInstance.QueryTypes.SELECT,
                    raw: true,
                });
                endAt = dateEndAt[0].date;
            }
            let ststFlag = '1';
            if (transaction.paymentMethodId == app_constant_1.appconstant.PAYMENT_METHOD.OFFLINE_WIRE_TRANSFER || transaction.paymentMethodId == app_constant_1.appconstant.PAYMENT_METHOD.ONLINE_CREDIT_DEBIT_CART && actualAmount > 0) {
                ststFlag = '0';
            }
            else if (transaction.paymentMethodId == app_constant_1.appconstant.PAYMENT_METHOD.PAYPAL_TRANSFER && paymentStatus == 0) {
                ststFlag = '0';
            }
            var channelSubscription = await this.channelSubscriptionRepository.create({
                channelId: user.channel.channelId,
                subscriptionId: subscriptionId,
                subscriptionTypeId: subscriptionTypeId,
                actualAmount: actualAmount.toFixed(2),
                carryForwardAmount: remainingAmount,
                totalDiscountedAmount: (+discountAmount > 0) ? +discountAmount : 0,
                couponId: coupon ? coupon.couponId : null,
                couponAmount: couponAmount.toFixed(2),
                finalAmount: (+finalAmount.toFixed(2) > 0) ? finalAmount.toFixed(2) : 0,
                taxAmount: taxAmount,
                taxNumber: taxNumber,
                paymentTransactionId: paymentTransactionId,
                startedAt: startedAt,
                additionalDays: additionalDays,
                endAt: endAt,
                isActive: ststFlag,
                isPaid: ststFlag,
                oldChannelSubscriptionId: oldChannelSubscription ? oldChannelSubscription.channelSubscriptionId : null,
                keyFeature: subscriptionExtraFeature,
                changedAt: sequelize_typescript_1.Sequelize.literal('CURRENT_TIMESTAMP'),
                updatedBy: +user.userId
            });
            if (transaction.paymentMethodId == app_constant_1.appconstant.PAYMENT_METHOD.STRIPE_ALIPAY || transaction.paymentMethodId == app_constant_1.appconstant.PAYMENT_METHOD.PAYPAL_TRANSFER || transaction.paymentMethodId == app_constant_1.appconstant.PAYMENT_METHOD.ONLINE_CREDIT_DEBIT_CART) {
                let channelObject = {};
                channelObject['planId'] = subscription.subscriptionPlanId;
                channelObject['subscriptionId'] = subscriptionId;
                channelObject['autoRenewalOff'] = '0';
                await Channel_entity_1.Channel.update(channelObject, { where: { channelId: user.channel.channelId } });
                let is_confidential = '1';
                if (+subscription.subscriptionPlanId > 1) {
                    is_confidential = '0';
                }
                let channelJCTConnect = {};
                channelJCTConnect['isConfidential'] = is_confidential;
                await ChannelJCT_entity_1.ChannelJCT.update(channelJCTConnect, {
                    where: { partnerChannelId: user.channel.channelId,
                        connectionStatusTypeId: 1,
                        deletedat: null }
                });
            }
            let free = true;
            if (channelSubscription && channelSubscription.finalAmount > 0) {
                free = false;
            }
            this.subscriptionAckMail(user.email, user.channel, subscription, transaction, free, channelSubscription, user.contactId);
            return channelSubscription;
        }
        catch (e) {
            console.log(e);
        }
    }
    async subscriptionAckMail(email, channel, subscription, transaction, free, channelSubscription, contactId) {
        try {
            let AccountOwner = await this.getAccountOwner(channel.channelId);
            const to = AccountOwner.contact.email;
            let cc = '';
            if (email && email != to)
                cc = email;
            if (channel.billAddressId) {
                var billAddress = await this.addressRepository.findOne({
                    attributes: ['countryId', 'address', 'city', 'postalCode'],
                    include: [
                        {
                            model: Country_entity_1.Country,
                            attributes: ['country'],
                            as: 'country',
                            required: true
                        }
                    ],
                    where: {
                        addressId: channel.billAddressId
                    },
                    order: [
                        ['addressId', 'DESC']
                    ]
                });
            }
            var taxNumber = null;
            if (channel && channel.channelCertificate && channel.channelCertificate[0] && channel.channelCertificate[0].cerificateNumber) {
                taxNumber = channel.channelCertificate[0].cerificateNumber;
            }
            let address = '';
            if (billAddress) {
                address += '<b>' + channel.companyName + '</b>';
                address += '<br/>';
                address += AccountOwner.contact.firstName + ' ' + AccountOwner.contact.lastName;
                address += '<br/>';
                address += billAddress.address;
                address += '<br/>';
                address += billAddress.city;
                address += '<br/>';
                address += billAddress.country.country;
                address += ', ' + billAddress.postalCode;
                if (taxNumber) {
                    address += '<br/>';
                    address += 'VAT No : ' + taxNumber;
                }
            }
            let type = '';
            if (channelSubscription.subscriptionTypeId == Subscription_entity_1.Subscription.SUBSCRIPTION_TYPE_NEW) {
                type = 'New';
            }
            else if (channelSubscription.subscriptionTypeId == Subscription_entity_1.Subscription.SUBSCRIPTION_TYPE_RENEWAL) {
                type = 'Renew';
            }
            else if (channelSubscription.subscriptionTypeId == Subscription_entity_1.Subscription.SUBSCRIPTION_TYPE_UPGRADE) {
                type = 'Upgrade';
            }
            else if (channelSubscription.subscriptionTypeId == Subscription_entity_1.Subscription.SUBSCRIPTION_TYPE_DOWNGRADE) {
                type = 'Downgrade';
            }
            let unsub_token = await this.unsubscribe_token(contactId);
            let pdfName = channelSubscription.channelSubscriptionId + '-' + subscription.subscriptionId + '.pdf';
            if (channelSubscription.finalAmount != 0) {
                var filename = '.tmp/pdf/invoice-' + pdfName;
                if (channelSubscription.isPaid == '1') {
                    filename = '.tmp/pdf/receipt-' + pdfName;
                }
                let invoiceContent = '';
                await ejs_1.renderFile(path_1.join(process.cwd(), './public/templates', 'SUBSCRIPTION_PDF.ejs'), {
                    title: "Subscription",
                    cdnUrl: process.env.CDN_URL,
                    banner: process.env.EMAIL_BANNER,
                    home_url: process.env.FRONTEND_BASE,
                    full_name: AccountOwner.contact.firstName,
                    channel_type: channel.channelLabel,
                    plan: subscription.subscriptionPlan.subscriptionPlanType,
                    period: subscription.subscriptionPeriod.periodDesc,
                    amount: channelSubscription.finalAmount,
                    card_number: transaction.cardLastFourDigit,
                    transaction_id: transaction.transactionNumber,
                    invoiceno: transaction.invoiceno,
                    login_url: process.env.FRONTEND_BASE + "/" + app_constant_1.appconstant.FRONTEND_PROFILE_URI,
                    free: free,
                    type: type,
                    address: address,
                    login_url_path: "/" + app_constant_1.appconstant.FRONTEND_PROFILE_URI,
                    currency_symbol: '‎€',
                    actualAmount: Number.parseFloat(channelSubscription.actualAmount).toFixed(2),
                    carryForwardAmount: Number.parseFloat(channelSubscription.carryForwardAmount).toFixed(2),
                    couponAmount: Number.parseFloat(channelSubscription.couponAmount).toFixed(2),
                    finalAmount: Number.parseFloat(channelSubscription.finalAmount).toFixed(2),
                    taxAmount: Number.parseFloat(channelSubscription.taxAmount || 0).toFixed(2),
                    totalDiscountedAmount: Number.parseFloat(channelSubscription.totalDiscountedAmount || 0).toFixed(2),
                    date: moment(channelSubscription.createdAt).format('DD-MM-YYYY'),
                    endAt: moment(channelSubscription.endAt).format('DD-MM-YYYY'),
                    isPaid: channelSubscription.isPaid,
                    unsub_url: process.env.FRONTEND_BASE + '/auth/unsubscribe/' + contactId + '?token=' + unsub_token,
                }, (err, body) => {
                    if (err) {
                        console.log(err, 'Checking Error list*************');
                    }
                    invoiceContent = body;
                });
                var pdf = require('html-pdf');
                var fs = require('fs');
                var options = { format: 'Letter' };
                pdf.create(invoiceContent).toFile(filename, function (err, res) {
                    console.log(res.filename);
                });
                this.uploadInvoicePdf(filename, channel.channelId, pdfName);
            }
            const delay = ms => new Promise(_ => setTimeout(_, ms));
            return await delay(30000).then(async () => {
                let mailOptions;
                if (channelSubscription.finalAmount != 0) {
                    mailOptions = {
                        to: to,
                        cc: cc,
                        from: process.env.EMAIL_FROM,
                        subject: 'ChannelHub: Subscription plan Details',
                        template: 'SUBSCRIPTION_MAIL',
                        context: {
                            title: "ChannelHub: Subscription plan Details",
                            cdnUrl: process.env.CDN_URL,
                            banner: process.env.EMAIL_BANNER,
                            home_url: process.env.FRONTEND_BASE,
                            full_name: AccountOwner.contact.firstName,
                            channel_type: channel.channelLabel,
                            plan: subscription.subscriptionPlan.subscriptionPlanType,
                            period: subscription.subscriptionPeriod.periodDesc,
                            amount: transaction.amount,
                            invoiceno: transaction.invoiceno,
                            card_number: transaction.cardLastFourDigit,
                            transaction_id: transaction.transactionNumber,
                            login_url: process.env.FRONTEND_BASE + "/" + app_constant_1.appconstant.FRONTEND_PROFILE_URI,
                            free: free,
                            login_url_path: "/" + app_constant_1.appconstant.FRONTEND_PROFILE_URI,
                            isPaid: channelSubscription.isPaid,
                            unsub_url: process.env.FRONTEND_BASE + '/auth/unsubscribe/' + contactId + '?token=' + unsub_token,
                        },
                        attachments: [
                            {
                                path: filename
                            }
                        ]
                    };
                }
                else {
                    mailOptions = {
                        to: to,
                        cc: cc,
                        from: process.env.EMAIL_FROM,
                        subject: 'ChannelHub: Subscription plan confirmation',
                        template: 'SUBSCRIPTION_MAIL',
                        context: {
                            title: "ChannelHub: Subscription plan confirmation",
                            cdnUrl: process.env.CDN_URL,
                            banner: process.env.EMAIL_BANNER,
                            home_url: process.env.FRONTEND_BASE,
                            full_name: AccountOwner.contact.firstName,
                            channel_type: channel.channelLabel,
                            plan: subscription.subscriptionPlan.subscriptionPlanType,
                            period: subscription.subscriptionPeriod.periodDesc,
                            amount: transaction.amount,
                            invoiceno: transaction.invoiceno,
                            card_number: transaction.cardLastFourDigit,
                            transaction_id: transaction.transactionNumber,
                            login_url: process.env.FRONTEND_BASE + "/" + app_constant_1.appconstant.FRONTEND_PROFILE_URI,
                            free: free,
                            login_url_path: "/" + app_constant_1.appconstant.FRONTEND_PROFILE_URI,
                            isPaid: channelSubscription.isPaid,
                            unsub_url: process.env.FRONTEND_BASE + '/auth/unsubscribe/' + contactId + '?token=' + unsub_token,
                        }
                    };
                }
                this.uploadInvoicePdf(filename, channel.channelId, pdfName);
                const delay = ms => new Promise(_ => setTimeout(_, ms));
                delay(50000).then(async () => {
                    fs.unlink(filename, function (err, data) {
                        if (err) {
                            console.log("error while file delete");
                            return false;
                        }
                        return true;
                    });
                });
            });
        }
        catch (e) {
            console.log("Error + ", e);
        }
        return false;
    }
    async uploadInvoicePdf(originPath, channelId, filename) {
        var s3 = new S3Lib_1.S3Lib();
        if (originPath) {
            console.log('done');
            let s3path = 'invoice/' + channelId + '/' + filename;
            let url = process.env.AWS_BUCKET_KEY_PREFIX + '/' + s3path;
            await s3.moveFromLocal(originPath, url, 1);
        }
    }
    async getAccountOwner(channelId) {
        return await this.userRepository.findOne({
            where: {
                channelId: channelId
            },
            include: [
                {
                    model: UserRole_entity_1.UserRole,
                    where: {
                        roleId: Role_entity_1.Role.ROLE_ACCOUNT_USER
                    },
                    required: true
                },
                {
                    model: Contact_entity_1.Contact,
                    as: 'contact',
                    required: true,
                }
            ]
        });
    }
    async unsubscribe_token(contactId) {
        return null;
    }
    async processSuggesstionQueue(channelTypeId, subscriptionTypeId, channelSubscription, oldChannelSubscription) {
        let insert = [];
        let suggestionfor = esearch_1.esearch.suggestionTypes[channelTypeId];
        console.log(' subscriptionTypeId ====> ', subscriptionTypeId);
        console.log(' oldChannelSubscription.channelSubscriptionId ===> ', oldChannelSubscription.channelSubscriptionId);
        if (+subscriptionTypeId === Subscription_entity_1.Subscription.SUBSCRIPTION_TYPE_RENEWAL) {
            await this.channelSuggestion.findAll({
                attributes: ['endat', 'suggestionfor', 'suggestioncount', 'limit'],
                where: {
                    channelsubscriptionid: oldChannelSubscription.channelSubscriptionId,
                    startedat: {
                        $lt: this.sequelizeInstance.fn('now'),
                    },
                    endat: {
                        $gte: this.sequelizeInstance.fn('now'),
                    }
                },
                raw: true
            }).then(async (results) => {
                console.log('++++++++++++++++++++++');
                console.log(results);
                await results.forEach(async (data) => {
                    insert.push({
                        channelsubscriptionid: channelSubscription.channelSubscriptionId,
                        startedat: sequelize_typescript_1.Sequelize.literal('CURRENT_TIMESTAMP'),
                        endat: sequelize_typescript_1.Sequelize.literal("CURRENT_TIMESTAMP + interval '" + (sequelize_typescript_1.Sequelize.literal('extract(epoch from ' + data.remaining_seconds + ':: timestamp - now())')) + "' second"),
                        suggestionfor: data.suggestionfor,
                        suggestioncount: data.suggestioncount,
                        limit: data.limit,
                        createdat: sequelize_typescript_1.Sequelize.literal('CURRENT_TIMESTAMP'),
                    });
                });
            });
        }
        if (insert.length == 0 || +subscriptionTypeId == Subscription_entity_1.Subscription.SUBSCRIPTION_TYPE_NEW || +subscriptionTypeId == Subscription_entity_1.Subscription.SUBSCRIPTION_TYPE_UPGRADE || +subscriptionTypeId == Subscription_entity_1.Subscription.SUBSCRIPTION_TYPE_DOWNGRADE) {
            let limits = {};
            console.log('*************************');
            console.log(suggestionfor);
            console.log('*************************');
            await suggestionfor.forEach((suggession) => {
                insert.push({
                    channelsubscriptionid: channelSubscription.channelSubscriptionId,
                    startedat: sequelize_typescript_1.Sequelize.literal('CURRENT_TIMESTAMP'),
                    endat: sequelize_typescript_1.Sequelize.literal("CURRENT_TIMESTAMP + interval '" + 30 + "' day"),
                    suggestionfor: suggession.type,
                    suggestioncount: 0,
                    limit: suggession.limit,
                    createdat: sequelize_typescript_1.Sequelize.literal('CURRENT_TIMESTAMP'),
                });
            });
        }
        if (oldChannelSubscription && oldChannelSubscription.channelSubscriptionId) {
            await ChannelSuggestion_entity_1.ChannelSuggestion.update({
                isexpired: '1'
            }, {
                where: {
                    channelsubscriptionid: {
                        [sequelize_1.Op.in]: [+oldChannelSubscription.channelSubscriptionId]
                    },
                    isexpired: '0'
                }
            });
        }
        await this.channelSuggestion.bulkCreate(insert);
    }
    async updateOldTransac(oldSubscriptionId) {
        let oldChannelSubscription = await ChannelSubscription_entity_1.ChannelSubscription.findByPk(oldSubscriptionId);
        if (oldChannelSubscription) {
            oldChannelSubscription.isActive = '0';
            return await oldChannelSubscription.save();
        }
    }
    async getAllList(pagination, search, filters, sort) {
        let sstatus = filters.subscription_status;
        let filter = (filters.subscription_status !== undefined && sstatus.length == 1) ? (filters.subscription_status[0]) ? {
            isActive: '1'
        } : {
            isActive: '0'
        } : {};
        if (filters.start) {
            filter['startedAt'] = {
                $gte: filters.start
            };
        }
        if (filters.end) {
            filter['startedAt'] = {
                $lte: filters.end + ' 23:59:59'
            };
        }
        if (filters.start && filters.end) {
            filter['startedAt'] = {
                $and: [
                    { $gte: filters.start },
                    { $lte: filters.end + ' 23:59:59' }
                ]
            };
        }
        if (filters.isPaid && ['1', '0'].includes(filters.isPaid)) {
            filter['isPaid'] = filters.isPaid;
            if (filters.isPaid == '0') {
                filter['$"paymentTransaction"."status"$'] = '0';
            }
        }
        if (filters.paymentMethodId) {
            filter['$"paymentTransaction"."paymentMethodId"$'] = filters.paymentMethodId;
        }
        let channelFilter = (filters.channel_status !== undefined) ? (filters.channel_status) ? {
            signUpStatusId: app_constant_1.appconstant.CHANNEL_APPROVED
        } : {
            signUpStatusId: {
                [sequelize_1.Op.not]: app_constant_1.appconstant.CHANNEL_APPROVED
            }
        } : {};
        if (search && search.length) {
            filter[sequelize_1.Op.or] = {
                '$"channel"."companyName"$': { $ilike: '%' + lodash_1.trim(search) + '%' },
                '$"paymentTransaction"."invoiceno"$': { $ilike: '%' + lodash_1.trim(search) + '%' },
            };
        }
        if (filters.invoiceno) {
            filter[sequelize_1.Op.and] = {
                finalAmount: { [sequelize_1.Op.gt]: 0 }
            };
        }
        return await this.channelSubscriptionRepository.findAndCountAll({
            limit: pagination.limit,
            offset: pagination.offset,
            attributes: ['channelSubscriptionId', 'channelId', 'subscriptionId', 'subscriptionTypeId', 'actualAmount', 'taxAmount', 'taxNumber', 'carryForwardAmount', 'couponAmount', 'totalDiscountedAmount', 'finalAmount', 'startedAt', 'endAt', 'isPaid'],
            where: filter,
            include: [
                {
                    model: Channel_entity_1.Channel,
                    as: 'channel',
                    attributes: ['channelId', 'channelTypeId', 'signUpStatusId', 'companyName', 'companyMail'],
                    required: true,
                    include: [
                        {
                            model: ChannelDetail_entity_1.ChannelDetail,
                            as: 'channelDetail',
                            required: false,
                            attributes: ['channelLogoId', 'phone1', 'mobileNo'],
                            include: [{
                                    model: models_1.Media,
                                    as: 'channelLogo',
                                    attributes: ['documentPath']
                                }],
                        },
                        {
                            model: ChannelType_entity_1.ChannelType,
                            as: 'channelType',
                            required: true,
                            where: (filters.channelTypeId) ? {
                                channelTypeId: {
                                    [sequelize_1.Op.in]: filters.channelTypeId
                                }
                            } : {}
                        },
                        {
                            model: Address_entity_1.Address,
                            as: 'billAddress',
                            required: false,
                            include: [
                                {
                                    model: Country_entity_1.Country,
                                    as: 'country',
                                    attributes: ['countryId', 'country'],
                                    required: false
                                }
                            ]
                        },
                        {
                            model: Address_entity_1.Address,
                            as: 'regAddress',
                            required: false,
                            include: [
                                {
                                    model: Country_entity_1.Country,
                                    as: 'country',
                                    attributes: ['countryId', 'country'],
                                    required: false
                                }
                            ]
                        }
                    ],
                    where: channelFilter
                },
                {
                    model: PaymentTransaction_entity_1.PaymentTransaction,
                    as: 'paymentTransaction',
                    required: false,
                    attributes: ['transactionNumber', 'cardType', 'cardLastFourDigit', 'status', 'amount', 'message', 'invoiceno', 'paymentMethodId', 'paymentTransactionAt']
                },
                {
                    model: SubscriptionType_entity_1.SubscriptionType,
                    as: 'subscriptionType',
                    required: false,
                },
                {
                    model: Subscription_entity_1.Subscription,
                    as: 'subscription',
                    required: true,
                    attributes: ['subscriptionId', 'channelTypeId', 'subscriptionPeriodId', 'subscriptionPlanId', 'amount'],
                    include: [
                        {
                            model: SubscriptionPeriod_entity_1.SubscriptionPeriod,
                            as: 'subscriptionPeriod',
                            required: true,
                            attributes: ['subscriptionPeriodId', 'periodDesc', 'periodValueInDays'],
                            where: (filters.periodId) ? {
                                subscriptionPeriodId: {
                                    [sequelize_1.Op.in]: filters.periodId
                                }
                            } : {}
                        },
                        {
                            model: SubscriptionPlan_entity_1.SubscriptionPlan,
                            as: 'subscriptionPlan',
                            required: true,
                            attributes: ['subscriptionPlanId', 'subscriptionPlanType'],
                            where: (filters.planId) ? {
                                subscriptionPlanId: {
                                    [sequelize_1.Op.in]: filters.planId
                                }
                            } : {}
                        }
                    ]
                },
            ],
            order: [
                ['channelSubscriptionId', sort || 'desc'],
            ]
        }).then(async (subscriptions) => {
            let data = {
                count: subscriptions.count,
                rows: [],
                aggregations: {}
            };
            if (subscriptions.count > 0) {
                for (let i = 0; i < subscriptions.rows.length; i++) {
                    let row = subscriptions.rows[i].toJSON();
                    if (subscriptions.rows[i].channelId) {
                        let defaultContact = await Contact_entity_1.Contact.findOne({
                            where: {
                                'channelId': subscriptions.rows[i].channelId
                            },
                            attributes: ['firstName', 'lastName', 'countryId', 'jobTitle', 'documentId', 'phone1', 'mobileNo', 'email', 'contactId'],
                            include: [
                                {
                                    model: User_entity_1.User,
                                    required: true,
                                    attributes: ['userId'],
                                    include: [
                                        {
                                            model: UserRole_entity_1.UserRole,
                                            attributes: ['roleId'],
                                            where: {
                                                roleId: Role_entity_1.Role.ROLE_ACCOUNT_USER
                                            },
                                            required: true
                                        }
                                    ]
                                },
                                {
                                    model: models_1.Media,
                                    as: 'document',
                                    required: false,
                                    attributes: ['documentPath']
                                }, {
                                    model: Country_entity_1.Country,
                                    as: 'country',
                                    attributes: ['countryId', 'country']
                                }
                            ],
                        });
                        row['channel'] = Object.assign(row['channel'], { 'contact': (defaultContact) ? defaultContact.toJSON() : null });
                    }
                    data.rows.push(row);
                }
            }
            let aggregationsQuery = 'select json_build_object(\'plans\', to_json(array_agg(distinct(tsp.*))),\'periods\', to_json(array_agg(distinct(tspr.*))),\'channeltypes\', to_json(array_agg(distinct(tct.*))),\'subsciptionstatus\', to_json(array_agg(distinct(tcs."isActive"))),\'channelstatus\', to_json(array_agg(distinct(tc."signUpStatusId"))) ) as subsciptionFilters from "tblChannelSubscription" tcs inner join "tblSubscription" ts on ts."subscriptionId" = tcs."subscriptionId"	inner join "tblChannel" tc on tc."channelId" = tcs."channelId" inner join "tblChannelType" tct on tct."channelTypeId" = tc."channelTypeId" inner join(select "subscriptionPlanId", "subscriptionPlanType" from "tblSubscriptionPlan") tsp on tsp."subscriptionPlanId" = ts."subscriptionPlanId" inner join(select "subscriptionPeriodId", "periodDesc" from "tblSubscriptionPeriod") tspr on tspr."subscriptionPeriodId" = ts."subscriptionPeriodId" where 1=1';
            if (search && search.length) {
                aggregationsQuery += ' and tc."companyName" ILIKE :search';
            }
            if (filters.subscription_status !== undefined && filters.subscription_status.length == 1) {
                if (filters.subscription_status[0]) {
                    aggregationsQuery += ' and tcs."isActive" = \'1\'';
                }
                else {
                    aggregationsQuery += ' and tcs."isActive" = \'0\'';
                }
            }
            if (filters.start) {
                aggregationsQuery += ' and tcs."startedAt" >= :start';
            }
            if (filters.end) {
                aggregationsQuery += ' and tcs."startedAt" <= :end';
            }
            if (filters.channel_status !== undefined) {
                if (filters.channel_status) {
                    aggregationsQuery += ' and tc."signUpStatusId" = :approved';
                }
                else {
                    aggregationsQuery += ' and tc."signUpStatusId" != :approved';
                }
            }
            if (filters.channelTypeId) {
                aggregationsQuery += ' and tct."channelTypeId" IN (:channelTypeId)';
            }
            if (filters.periodId) {
                aggregationsQuery += ' and tspr."subscriptionPeriodId" IN (:periodId)';
            }
            if (filters.planId) {
                aggregationsQuery += ' and tsp."subscriptionPlanId" IN (:planId)';
            }
            data.aggregations = await this.sequelizeInstance.query(aggregationsQuery, {
                type: this.sequelizeInstance.QueryTypes.SELECT,
                replacements: {
                    search: '%' + search + '%',
                    start: filters.start,
                    end: filters.end,
                    approved: app_constant_1.appconstant.CHANNEL_APPROVED,
                    channelTypeId: filters.channelTypeId || null,
                    periodId: filters.periodId || null,
                    planId: filters.planId || null
                }
            }).then(filters => {
                if (filters[0].subsciptionfilters['subsciptionstatus']) {
                    let status = filters[0].subsciptionfilters['subsciptionstatus'].map((data) => {
                        if (data == '1')
                            return { 'id': 1, 'name': 'Active' };
                        if (data == '0')
                            return { 'id': 0, 'name': 'InActive' };
                    });
                    let chtypes = filters[0].subsciptionfilters['channeltypes'].map((data) => {
                        return { 'id': data.channelTypeId, 'name': data.channelType };
                    });
                    let period = filters[0].subsciptionfilters['periods'].map((data) => {
                        return { 'id': data.subscriptionPeriodId, 'name': data.periodDesc };
                    });
                    let plan = filters[0].subsciptionfilters['plans'].map((data) => {
                        return { 'id': data.subscriptionPlanId, 'name': data.subscriptionPlanType };
                    });
                    let channelstatus = [];
                    let processed = {};
                    filters[0].subsciptionfilters['channelstatus'].map((data) => {
                        if (data == '15' && processed[15] === undefined) {
                            processed[15] = true;
                            channelstatus.push({ 'id': 1, 'name': 'Approved' });
                        }
                        if (data != '15' && processed[14] === undefined) {
                            processed[14] = true;
                            channelstatus.push({ 'id': 0, 'name': 'Pending' });
                        }
                    });
                    filters[0].subsciptionfilters = Object.assign(filters[0].subsciptionfilters, { 'subsciptionstatus': status, 'channelstatus': channelstatus, 'periods': period, 'plans': plan, channeltypes: chtypes });
                }
                return filters;
            });
            return data;
        });
    }
    async insertKeyFeature(categories, subscriptionId) {
        var totalcategories = Object.keys(categories).length;
        let extraFeatures = [];
        for (var i = 0; i < totalcategories; i++) {
            extraFeatures.push({
                subscriptionId: +subscriptionId,
                subscriptionExtraFeatureCategoryId: +categories[i].id,
                feature_value: categories[i].value
            });
        }
        console.log(extraFeatures);
        try {
            let extrafeatureUpload = await this.subscriptionExtraFeatureRepository.bulkCreate(extraFeatures);
        }
        catch (err) {
            console.log(err);
            return err;
        }
    }
    async getAllKeyFeatures(channelTypeId, subscriptionPeriodId) {
        try {
            let subscriptionFeature = await this.subscriptionRepository.findAll({
                where: {
                    isActive: '1',
                    deletedAt: null,
                    channelTypeId: channelTypeId,
                    subscriptionPeriodId: subscriptionPeriodId
                },
                include: [{
                        model: SubscriptionExtraFeature_entity_1.SubscriptionExtraFeature,
                        required: true,
                        where: { isActive: '1' }
                    }]
            });
            return subscriptionFeature;
        }
        catch (err) {
            console.log(err);
            return err;
        }
    }
    async updateKeyFeatureForchannel(channelId, subscriptionId) {
        let channel = await this.channelRepository.findAll({
            attributes: ['subscriptionId', 'channelId'],
            include: [{
                    model: ChannelSubscription_entity_1.ChannelSubscription,
                    required: true,
                    where: { keyFeatureupdateDate: null }
                }],
            where: {
                isActive: '1'
            }
        }).then(async (channelData) => {
            channelData.forEach(async (channel) => {
                let subscriptionId = channel.subscriptionId;
                let channelId = channel.channelId;
                let extraFeature = {};
                let subscriptionExtraFeature = await this.subscriptionExtraFeatureRepository.findAll({
                    attributes: ['subscriptionId', 'feature_value', 'subscriptionExtraFeatureCategoryId'],
                    where: {
                        subscriptionId: subscriptionId
                    }
                }).then(async (Featuredata) => {
                    Featuredata.forEach(async (data) => {
                        extraFeature[data['subscriptionExtraFeatureCategoryId']] = data['feature_value'];
                    });
                });
                console.log(' testing data here ', subscriptionId, channelId);
                console.log(' testing data here ', extraFeature);
                if (extraFeature) {
                    await ChannelSubscription_entity_1.ChannelSubscription.update({
                        keyFeature: extraFeature,
                        keyFeatureupdateDate: new Date().toUTCString()
                    }, {
                        where: { channelId: channelId,
                            isActive: '1'
                        }
                    });
                }
            });
        });
    }
    async getPlansforAdmin() {
        return await this.subscriptionRepository.findAll({
            attributes: ['subscriptionId', 'channelTypeId', 'amount', 'isActive'],
            include: [
                {
                    model: SubscriptionPeriod_entity_1.SubscriptionPeriod,
                    required: true,
                    attributes: ['periodDesc']
                },
                {
                    model: SubscriptionPlan_entity_1.SubscriptionPlan,
                    required: true,
                    attributes: ['subscriptionPlanType'],
                }
            ],
            where: {},
            order: [['channelTypeId', 'asc']]
        }).then(async (channelData) => {
            return channelData;
        });
    }
    async getPlansDetailsById(subscriptionId) {
        return await this.subscriptionRepository.findAll({
            attributes: ['subscriptionId', 'channelTypeId', 'amount', 'isActive'],
            include: [
                {
                    model: SubscriptionExtraFeature_entity_1.SubscriptionExtraFeature,
                    required: true,
                    attributes: ['subscriptionExtraFeatureId', 'feature_value', 'feature_label', 'subscriptionExtraFeatureCategoryId'],
                    include: [
                        {
                            model: SubscriptionExtraFeatureCategories_entity_1.SubscriptionExtraFeatureCategory,
                            required: true,
                            where: {
                                isActive: '1',
                                FeatureCategoryId: {
                                    [sequelize_1.Op.not]: null,
                                }
                            }
                        }
                    ],
                    where: {
                        isActive: '1'
                    }
                }
            ],
            where: {
                deletedAt: null,
                subscriptionId: subscriptionId
            }
        }).then(async (channelData) => {
            return channelData[0];
        });
    }
    async updateSubscription(data, subscriptionId) {
        let feature = data.feature;
        feature.forEach((res) => {
            let featureObj = [];
            featureObj['feature_value'] = res.feature_value;
            featureObj['feature_label'] = res.feature_label;
            console.log(featureObj, res.subscriptionExtraFeatureCategoryId);
            SubscriptionExtraFeature_entity_1.SubscriptionExtraFeature.update(featureObj, {
                where: {
                    subscriptionExtraFeatureId: res.subscriptionExtraFeatureId
                },
            });
        });
        return Subscription_entity_1.Subscription.update(data, {
            where: {
                subscriptionId: subscriptionId
            },
        }).then(async (channelData) => {
            return channelData[0];
        });
    }
    async failedTransaction(data) {
        let failureObj = {};
        failureObj['paymentMethodId'] = data.paymentType;
        failureObj['paymentTransactionId'] = +data.transactionId;
        failureObj['response'] = data.response;
        console.log('failureObj');
        console.log(failureObj);
        return FailureTransaction_entity_1.FailureTransaction.create(failureObj)
            .then(async (channelData) => {
            return channelData;
        });
    }
    async getFeaterListId(channelId) {
        console.log('channelId for key feature');
        console.log(channelId);
        return await this.channelSubscriptionRepository.findAll({
            attributes: ['keyFeature'],
            where: {
                isActive: '1',
                isPaid: '1',
                channelId: channelId
            }
        }).then(async (ChannelSubscription) => {
            console.log(ChannelSubscription);
            if (ChannelSubscription) {
                return ChannelSubscription[0];
            }
        });
    }
    async getFeaterCategoryList(keyFeature) {
        let extraFeature = [];
        return await this.subscriptionExtraFeatureCategoryRepository.findAll({
            where: {
                isActive: '1',
                FeatureCategoryId: {
                    [sequelize_1.Op.not]: null,
                }
            }
        }).then(async (channelData) => {
            channelData.forEach(async (data, index) => {
                if (data['subscriptionExtraFeatureCategoryId'] > 0) {
                    extraFeature[index] = {};
                    extraFeature[index]['id'] = data['subscriptionExtraFeatureCategoryId'];
                    extraFeature[index]['title'] = data['subscriptionExtraFeatureCategory'];
                    extraFeature[index]['value'] = keyFeature[data['subscriptionExtraFeatureCategoryId']];
                }
            });
            return extraFeature;
        });
    }
    async updateChannelFeatureList(extraFeature, channelId) {
        if (extraFeature) {
            await ChannelSubscription_entity_1.ChannelSubscription.update({
                keyFeature: extraFeature,
                keyFeatureupdateDate: new Date().toUTCString()
            }, {
                where: { channelId: channelId,
                    isActive: '1',
                    isPaid: '1'
                }
            });
        }
    }
    async updateOfflinrPayment(id, dto) {
        let filter = {};
        filter['channelSubscriptionId'] = id;
        filter['isPaid'] = '0';
        filter['$"paymentTransaction"."status"$'] = '0';
        let channelSubscription = null;
        channelSubscription = await ChannelSubscription_entity_1.ChannelSubscription.findAll({
            where: filter,
            include: [
                {
                    model: PaymentTransaction_entity_1.PaymentTransaction,
                    as: 'paymentTransaction',
                    required: true
                },
                {
                    model: Channel_entity_1.Channel,
                    as: 'channel',
                    required: true
                },
                {
                    model: Subscription_entity_1.Subscription,
                    as: 'subscription',
                    required: true,
                    attributes: ['subscriptionId', 'channelTypeId', 'subscriptionPeriodId', 'subscriptionPlanId', 'amount'],
                    include: [
                        {
                            model: SubscriptionPeriod_entity_1.SubscriptionPeriod,
                            as: 'subscriptionPeriod',
                            required: true,
                            attributes: ['subscriptionPeriodId', 'periodDesc', 'periodValueInDays']
                        },
                        {
                            model: SubscriptionPlan_entity_1.SubscriptionPlan,
                            as: 'subscriptionPlan',
                            required: true,
                            attributes: ['subscriptionPlanId', 'subscriptionPlanType']
                        }
                    ]
                },
            ]
        });
        if (!channelSubscription) {
            throw new Process_exception_1.ProcessException('channel:subscription:notFound');
        }
        if (dto.status == false) {
            channelSubscription[0].paymentTransaction.status = '1';
            channelSubscription[0].paymentTransaction.message = dto.reason;
            await channelSubscription[0].paymentTransaction.save().then(async () => {
            });
        }
        else {
            channelSubscription[0].paymentTransaction.status = '1';
            channelSubscription[0].paymentTransaction.message = dto.reason;
            let invoicenumber = await this.sequelizeInstance.query('select \'CH\' || to_char(now(),\'YYMM\')  || \'-9\' || case when ((count(*)+1) < 9) then \'0\' else \'\' end || (count(*) + 1) :: varchar(16) as number from "tblPaymentTransaction" where "invoiceno" like CONCAT(\'CH\',to_char(now(),\'YYMM\'),\'%\') and to_char("paymentTransactionAt", \'mm/yyyy\') = to_char(now(), \'mm/yyyy\') and "paymentTransactionId" < ' + channelSubscription[0].paymentTransaction.paymentTransactionId, {
                type: this.sequelizeInstance.QueryTypes.SELECT,
                raw: true,
            });
            channelSubscription[0].paymentTransaction.invoiceno = invoicenumber[0].number;
            await channelSubscription[0].paymentTransaction.save().then(async () => {
                var periodInDays = 0;
                var additionalDays = 0;
                if (channelSubscription[0].subscription.subscriptionPeriod !== undefined) {
                    periodInDays = +channelSubscription[0].subscription.subscriptionPeriod.periodValueInDays;
                }
                if (channelSubscription[0].additionalDays) {
                    periodInDays += +channelSubscription[0].additionalDays;
                }
                var oldChannelSubscription = await this.channelSubscriptionRepository.findOne({
                    where: {
                        channelSubscriptionId: channelSubscription[0].oldChannelSubscriptionId,
                        isActive: '1'
                    },
                    order: [
                        ['channelSubscriptionId', 'DESC']
                    ],
                    raw: true
                });
                let startedAt = sequelize_typescript_1.Sequelize.literal('CURRENT_TIMESTAMP');
                let endAt = sequelize_typescript_1.Sequelize.literal("CURRENT_TIMESTAMP + interval '" + +periodInDays + "' day");
                if (+channelSubscription[0].subscriptionTypeId === Subscription_entity_1.Subscription.SUBSCRIPTION_TYPE_RENEWAL) {
                    let dateEndAt = await this.sequelizeInstance.query('select case when "endAt" > CURRENT_TIMESTAMP THEN "endAt" + interval ' + "'" + +periodInDays + "'" + ' day when "endAt" < CURRENT_TIMESTAMP then CURRENT_TIMESTAMP + interval ' + "'" + +periodInDays + "'" + ' day END as date from "tblChannelSubscription" where "channelSubscriptionId" = ' + oldChannelSubscription.channelSubscriptionId + ' limit 1', {
                        type: this.sequelizeInstance.QueryTypes.SELECT,
                        raw: true,
                    });
                    endAt = dateEndAt[0].date;
                }
                channelSubscription[0].isPaid = '1';
                channelSubscription[0].isActive = '1';
                channelSubscription[0].startedAt = startedAt;
                channelSubscription[0].endAt = endAt;
                await channelSubscription[0].save().then(async () => {
                    let channelObject = {};
                    if (channelSubscription[0].oldChannelSubscriptionId > 0) {
                        await ChannelSubscription_entity_1.ChannelSubscription.update({
                            "isActive": '0'
                        }, {
                            where: {
                                channelSubscriptionId: channelSubscription[0].oldChannelSubscriptionId,
                                "isActive": '1'
                            }
                        });
                    }
                    channelObject['stripeCustomerId'] = null,
                        channelObject['stripePaymentMethodId'] = null,
                        channelObject['autoRenewalOff'] = '1';
                    channelObject['planId'] = channelSubscription[0].subscription.subscriptionPlanId;
                    channelObject['subscriptionId'] = channelSubscription[0].subscriptionId;
                    await Channel_entity_1.Channel.update(channelObject, { where: { channelId: channelSubscription[0].channelId } });
                });
            });
        }
        return channelSubscription;
    }
    async UpdateTransactionById(transId, alipaySourceId) {
        try {
            let transObject = [];
            transObject['paymentIntent'] = alipaySourceId;
            this.paymentTransactionRepository.update(transObject, { where: { paymentTransactionId: transId } });
        }
        catch (e) {
            console.log("Error:", e);
        }
    }
};
SubscriptionService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject('SequelizeInstance')),
    __param(1, common_1.Inject('SubscriptionPeriodRepository')),
    __param(2, common_1.Inject('SubscriptionRepository')),
    __param(3, common_1.Inject('SubscriptionPlanRepository')),
    __param(4, common_1.Inject('SubscriptionExtraFeatureRepository')),
    __param(5, common_1.Inject('SubscriptionExtraFeatureCategoryRepository')),
    __param(6, common_1.Inject('PaymentTransactionRepository')),
    __param(7, common_1.Inject('ChannelSubscriptionRepository')),
    __param(8, common_1.Inject('AddressRepository')),
    __param(9, common_1.Inject('CouponRepository')),
    __param(10, common_1.Inject('UserRepository')),
    __param(11, common_1.Inject('MailerProvider')),
    __param(12, common_1.Inject('SubscriptionDetailRepository')),
    __param(13, common_1.Inject('ChannelSuggestionRepository')),
    __param(14, common_1.Inject('ChannelRepository')),
    __param(15, common_1.Inject('ALGORITHM_SERVICE')),
    __metadata("design:paramtypes", [Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, microservices_1.ClientProxy])
], SubscriptionService);
exports.SubscriptionService = SubscriptionService;
//# sourceMappingURL=subscription.service.js.map