'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TradeLocationService = void 0;
const common_1 = require("@nestjs/common");
const Region_entity_1 = require("../../common/models/Region.entity");
const Zone_entity_1 = require("../../common/models/Zone.entity");
const sequelize_1 = require("sequelize");
const ContactLocation_entity_1 = require("../../user/models/ContactLocation.entity");
const Country_entity_1 = require("../../common/models/Country.entity");
let TradeLocationService = class TradeLocationService {
    constructor(sequelizeInstance, channelLocationRepository, contactLocationRepository, zoneRepository) {
        this.sequelizeInstance = sequelizeInstance;
        this.channelLocationRepository = channelLocationRepository;
        this.contactLocationRepository = contactLocationRepository;
        this.zoneRepository = zoneRepository;
    }
    async getChannelLocation(user) {
        try {
            let locations = {};
            let channelLocation = await this.contactLocationRepository.scope('contactLocationInfo').findAll({
                where: {
                    channelId: user.channelId,
                    deletedAt: null
                }
            });
            var newLocations = { 'TARGET': [], 'SELLING': [], 'RETAIL': [] };
            if (channelLocation && channelLocation.length > 0) {
                channelLocation.forEach(function (obj) {
                    newLocations[obj.locationType].push(obj.regionCountryJCTId);
                });
                for (var i in newLocations) {
                    let locationObj = await this.getZoneObject(newLocations[i]);
                    newLocations[i] = locationObj;
                }
            }
            locations['currentLocation'] = newLocations;
            let oldLocations = { 'TARGET': [], 'SELLING': [], 'RETAIL': [] };
            if (+user.channel.oldChannelId) {
                let query = 'select to_json( array_agg((d.*))) from( '
                    + 'select "locationType", array_to_json( array_agg(to_json(c.loc))) from( '
                    + '		select  "locationType", json_build_object ( \'zoneId\', "zoneId" ,\'zone\' ,zone ,\'region\', region ) loc from( '
                    + '		select '
                    + '		"locationType", '
                    + '		z."zoneId", '
                    + '		z.zone, '
                    + '			(select array_to_json(array_agg(to_json(q))) from ( '
                    + '				select '
                    + '					r1."regionId", '
                    + '					r1."region", '
                    + '					zr1."zoneRegionJCTId", '
                    + '					json_build_object(\'zoneRegionJCTId\', zr1."zoneRegionJCTId")  "ZoneRegionJCT",	'
                    + '					(select to_json(array_agg(a.* )) from '
                    + '					   (select c1.* , '
                    + '							(select to_json(b.*) from (select * from "tblRegionCountryJCT" rc2 where rc2."regionCountryJCTId" =rc1."regionCountryJCTId"  )b) "RegionCountryJCT" '
                    + '							from "tblCountry" c1 where c1."countryId" = rc1."countryId")a) country '
                    + '					from '
                    + '					"tblOldChannelLocation"  ocl1 '
                    + '					inner join "tblRegionCountryJCT" rc1   on rc1."regionCountryJCTId" = ocl1."regionCountryJCTId" '
                    + '					inner join "tblZoneRegionJCT" zr1 ON rc1."regionId" = zr1."regionId" '
                    + '					JOIN "tblRegion" r1 ON r1."regionId" = zr1."regionId" '
                    + '					where zr1."zoneId" = z."zoneId" and ocl1."locationType" = ocl."locationType" '
                    + '					and ocl1."oldChannelId" = ocl."oldChannelId" '
                    + '				)q '
                    + '			)region '
                    + '		from  '
                    + '		"tblOldChannelLocation"  ocl '
                    + '		inner join "tblRegionCountryJCT" rc   on rc."regionCountryJCTId" = ocl."regionCountryJCTId" '
                    + '		inner join "tblZoneRegionJCT" zr ON rc."regionId" = zr."regionId" '
                    + '		JOIN "tblZone" z ON z."zoneId" = zr."zoneId" '
                    + '		where ocl."oldChannelId" = :oldChannelId '
                    + '		Group by "locationType",z."zoneId",ocl."oldChannelId"  '
                    + '		)b  '
                    + ')c group by "locationType" )d ;';
                let result = await this.sequelizeInstance.query(query, {
                    type: sequelize_1.QueryTypes.SELECT,
                    replacements: {
                        oldChannelId: +user.channel.oldChannelId,
                    }
                }).then((result) => {
                    return result[0].to_json;
                });
                if (result && result.length > 0) {
                    for (var j = 0; j < result.length; j++) {
                        oldLocations[result[j].locationType] = result[j].array_to_json;
                    }
                }
            }
            locations['oldLocation'] = oldLocations;
            return locations;
        }
        catch (e) {
            console.log("Error+", e);
            throw new common_1.InternalServerErrorException();
        }
    }
    async getZoneObject(locations) {
        return await this.zoneRepository.scope('zones').findAll({
            include: [{
                    model: Region_entity_1.Region,
                    as: 'region',
                    where: {
                        deletedAt: null,
                    },
                    through: {
                        attributes: ['zoneRegionJCTId'],
                        where: { deletedAt: null }
                    },
                    include: [{
                            model: Country_entity_1.Country,
                            as: 'country',
                            where: {
                                deletedAt: null
                            },
                            through: {
                                attributes: ['regionCountryJCTId', 'regionId', 'countryId', 'deletedAt'],
                                where: {
                                    deletedAt: null,
                                    regionCountryJCTId: { [sequelize_1.Op.in]: locations }
                                }
                            },
                        }]
                }],
            where: {
                deletedAt: null
            }
        });
    }
};
TradeLocationService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject('SequelizeInstance')),
    __param(1, common_1.Inject('ChannelLocationRepository')),
    __param(2, common_1.Inject('ContactLocationRepository')),
    __param(3, common_1.Inject('ZoneRepository')),
    __metadata("design:paramtypes", [Object, Object, Object, Object])
], TradeLocationService);
exports.TradeLocationService = TradeLocationService;
//# sourceMappingURL=tradeLocation.service.js.map