'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
exports.TradeInformationInBound = void 0;
const Media_entity_1 = require("../../media/models/Media.entity");
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
const ChannelKeyPartner_entity_1 = require("../models/ChannelKeyPartner.entity");
const ProductKeyPartnerJCT_entity_1 = require("./../../product/models/ProductKeyPartnerJCT.entity");
const lodash_1 = require("lodash");
const KeyPartnerJCT_entity_1 = require("../models/KeyPartnerJCT.entity");
const app_constant_1 = require("../../../config/app.constant");
const sequelize_1 = require("sequelize");
class TradeInformationInBound {
    async setProductGroup(productFamilies, channelId) {
        try {
            let resultObject = [];
            if (productFamilies) {
                for (let ii = 0; ii < productFamilies.length; ii++) {
                    let innerObject = {};
                    innerObject.channelId = parseInt(channelId.toString());
                    innerObject.productGroupId = productFamilies[ii].id;
                    innerObject.createdAt = new Date();
                    resultObject.push(innerObject);
                }
            }
            return resultObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:productGroup');
        }
    }
    async setProductCategories(productCategories, channelId) {
        try {
            let resultObject = [];
            if (productCategories) {
                for (let ii = 0; ii < productCategories.length; ii++) {
                    let innerObject = {};
                    innerObject.channelId = parseInt(channelId.toString());
                    innerObject.productCategorieId = productCategories[ii].productCategoriesId;
                    innerObject.createdAt = new Date();
                    resultObject.push(innerObject);
                }
            }
            return resultObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:ProductCategories');
        }
    }
    async setContactProductGroup(productFamilies, contactId) {
        try {
            let resultObject = [];
            if (productFamilies) {
                for (let ii = 0; ii < productFamilies.length; ii++) {
                    let innerObject = {};
                    innerObject.contactId = parseInt(contactId.toString());
                    innerObject.productGroupId = productFamilies[ii].id;
                    innerObject.createdAt = new Date();
                    resultObject.push(innerObject);
                }
            }
            return resultObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:productGroup');
        }
    }
    async setContactProductCategories(productCategories, contactId) {
        try {
            let resultObject = [];
            if (productCategories) {
                for (let ii = 0; ii < productCategories.length; ii++) {
                    let innerObject = {};
                    innerObject.contactId = parseInt(contactId.toString());
                    innerObject.productCategorieId = productCategories[ii].productCategoriesId;
                    innerObject.createdAt = new Date();
                    resultObject.push(innerObject);
                }
            }
            return resultObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:ProductCategories');
        }
    }
    async setCustomerProfiles(customerProfiles, channelId) {
        try {
            let resultObject = [];
            if (customerProfiles) {
                for (let ii = 0; ii < customerProfiles.length; ii++) {
                    let innerObject = {};
                    innerObject.channelId = parseInt(channelId.toString());
                    innerObject.profileTypeId = customerProfiles[ii].profileTypeId;
                    innerObject.profileTypeClassificationId = customerProfiles[ii].profileTypeClassificationId;
                    innerObject.createdAt = new Date();
                    resultObject.push(innerObject);
                }
            }
            return resultObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:CustomerProfiles');
        }
    }
    async setSpeciality(speciality, channelId) {
        try {
            let resultObject = [];
            if (speciality) {
                for (let ii = 0; ii < speciality.length; ii++) {
                    let innerObject = {};
                    innerObject.channelId = parseInt(channelId.toString());
                    innerObject.productGroupId = speciality[ii].specialityId;
                    innerObject.createdAt = new Date();
                    resultObject.push(innerObject);
                }
            }
            return resultObject;
        }
        catch (e) {
            console.log(e);
            throw new Process_exception_1.ProcessException('channel:objectCreation:Speciality');
        }
    }
    async setServiceList(listOfServices, channelId) {
        try {
            let resultObject = [];
            if (listOfServices) {
                for (let ii = 0; ii < listOfServices.length; ii++) {
                    let innerObject = {};
                    innerObject.channelId = parseInt(channelId.toString());
                    innerObject.serviceListId = listOfServices[ii].id;
                    innerObject.createdAt = new Date();
                    resultObject.push(innerObject);
                }
            }
            return resultObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:serviceList');
        }
    }
    async keyRetailers(partner_type, retailerList, channelId, userId, deletedKeys) {
        try {
            if (deletedKeys) {
                await KeyPartnerJCT_entity_1.KeyPartnerJCT.update({
                    deletedat: new Date()
                }, {
                    where: {
                        keypartnerid: {
                            [sequelize_1.Op.in]: deletedKeys
                        },
                        partner_type: partner_type,
                        channelid: +channelId,
                        deletedat: null
                    },
                    returning: true
                }).then(async (datas) => {
                    if (!lodash_1.isUndefined(datas[1])) {
                        let deletedCKeys = [];
                        let deletedProductKeys = [];
                        datas[1].forEach((row) => {
                            if (row.channelkeypartnerid)
                                deletedCKeys.push(row.channelkeypartnerid);
                            deletedProductKeys.push(row.keypartnerid);
                        });
                        if (deletedCKeys.length) {
                            await ChannelKeyPartner_entity_1.ChannelKeyPartner.update({
                                deletedat: new Date()
                            }, {
                                where: {
                                    channelkeypartnerid: {
                                        [sequelize_1.Op.in]: deletedCKeys
                                    },
                                    channelId: +channelId,
                                    deletedat: null
                                }
                            });
                        }
                        if (deletedProductKeys.length) {
                            await ProductKeyPartnerJCT_entity_1.ProductKeyPartnerJCT.destroy({
                                where: {
                                    keypartnerid: {
                                        [sequelize_1.Op.in]: deletedProductKeys
                                    }
                                }
                            });
                        }
                    }
                });
            }
            if (retailerList) {
                var newKeyRetailers = [];
                for (let ii = 0; ii < retailerList.length; ii++) {
                    if (lodash_1.isUndefined(retailerList[ii].existchannelid) && lodash_1.isUndefined(retailerList[ii].oldchannelid) && lodash_1.isUndefined(retailerList[ii].keypartnerid)) {
                        let innerObject = new ChannelKeyPartner_entity_1.ChannelKeyPartner;
                        if (retailerList[ii].channelkeypartnerid) {
                            innerObject = await ChannelKeyPartner_entity_1.ChannelKeyPartner.findByPk(+retailerList[ii].channelkeypartnerid);
                            if (innerObject) {
                                innerObject.channelkeypartnerid = retailerList[ii].channelkeypartnerid;
                                innerObject.updatedat = new Date();
                            }
                            else {
                                innerObject = new ChannelKeyPartner_entity_1.ChannelKeyPartner;
                                innerObject.partner_type = partner_type;
                                innerObject.createdat = new Date();
                            }
                        }
                        else {
                            innerObject.partner_type = partner_type;
                            innerObject.createdat = new Date();
                        }
                        innerObject.updatedby = userId;
                        innerObject.channelId = +channelId;
                        innerObject.partnername = retailerList[ii].partnername;
                        innerObject.countryid = retailerList[ii].countryid;
                        if (retailerList[ii].image) {
                            let media = new Media_entity_1.Media;
                            media.documentTypeId = app_constant_1.appconstant.DOCUMENTTYPE_IMAGE;
                            media.documentPath = (retailerList[ii].image) ? retailerList[ii].image : null;
                            media.dirName = app_constant_1.appconstant.FOLDER_PATH_CHANNEL_KEY_RETAILER_IMAGE;
                            await media.save();
                            innerObject.documentid = media.documentId;
                        }
                        else if (retailerList[ii].imageid) {
                            innerObject.documentid = retailerList[ii].imageid;
                        }
                        await innerObject.save();
                        retailerList[ii].channelkeypartnerid = innerObject.channelkeypartnerid;
                    }
                    if (lodash_1.isUndefined(retailerList[ii].keypartnerid)) {
                        let keyRetailer = new KeyPartnerJCT_entity_1.KeyPartnerJCT;
                        let verify = {
                            channelid: +channelId,
                            partner_type: partner_type,
                            deletedat: null
                        };
                        keyRetailer.channelid = +channelId;
                        keyRetailer.partner_type = partner_type;
                        keyRetailer.createdat = new Date();
                        if (retailerList[ii].channelkeypartnerid) {
                            keyRetailer.channelkeypartnerid = retailerList[ii].channelkeypartnerid;
                            verify.channelkeypartnerid = +retailerList[ii].channelkeypartnerid;
                        }
                        if (retailerList[ii].existchannelid) {
                            keyRetailer.existchannelid = retailerList[ii].existchannelid;
                            verify.existchannelid = +retailerList[ii].existchannelid;
                        }
                        if (retailerList[ii].oldchannelid) {
                            keyRetailer.oldchannelid = retailerList[ii].oldchannelid;
                            verify.oldchannelid = +retailerList[ii].oldchannelid;
                        }
                        let verifyResult = await KeyPartnerJCT_entity_1.KeyPartnerJCT.findOne({
                            where: verify
                        });
                        if (verifyResult) {
                            keyRetailer = verifyResult;
                        }
                        else {
                            await keyRetailer.save();
                        }
                        newKeyRetailers.push(+keyRetailer.keypartnerid);
                    }
                    if (!lodash_1.isUndefined(retailerList[ii].keypartnerid) && !lodash_1.isUndefined(retailerList[ii].channelkeypartnerid) && lodash_1.isUndefined(retailerList[ii].imageid)) {
                        console.log("Key Pater", retailerList[ii].channelkeypartnerid);
                        let keyRetailer = new KeyPartnerJCT_entity_1.KeyPartnerJCT;
                        let verify = {
                            channelid: +channelId,
                            partner_type: partner_type,
                            deletedat: null
                        };
                        keyRetailer.channelid = +channelId;
                        keyRetailer.partner_type = partner_type;
                        keyRetailer.createdat = new Date();
                        if (retailerList[ii].channelkeypartnerid) {
                            console.log("channelkeypartnerid", retailerList[ii].channelkeypartnerid);
                            keyRetailer.channelkeypartnerid = retailerList[ii].channelkeypartnerid;
                            verify.channelkeypartnerid = +retailerList[ii].channelkeypartnerid;
                        }
                        if (retailerList[ii].existchannelid) {
                            keyRetailer.existchannelid = retailerList[ii].existchannelid;
                            verify.existchannelid = +retailerList[ii].existchannelid;
                        }
                        if (retailerList[ii].oldchannelid) {
                            keyRetailer.oldchannelid = retailerList[ii].oldchannelid;
                            verify.oldchannelid = +retailerList[ii].oldchannelid;
                        }
                        let verifyResult = await KeyPartnerJCT_entity_1.KeyPartnerJCT.findOne({
                            where: verify
                        });
                        console.log("verifyResult", verifyResult);
                        if (verifyResult) {
                            keyRetailer = verifyResult;
                        }
                        else {
                            await keyRetailer.save();
                        }
                        newKeyRetailers.push(+keyRetailer.keypartnerid);
                    }
                }
            }
            return newKeyRetailers;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:keyretailers' + e);
        }
    }
    async setChannelDetail(channelDetail, channelId, channelTypeId) {
        try {
            let resultObject = {};
            if (channelDetail.employeesRange && !channelDetail.employeesCount) {
                resultObject.empCntRange = channelDetail.employeesRange;
            }
            else if (channelDetail.employeesCount) {
                resultObject.empCntRange = '';
            }
            if (channelDetail.employeesCount && !channelDetail.employeesRange) {
                resultObject.empCnt = channelDetail.employeesCount;
            }
            else if (channelDetail.employeesRange) {
                resultObject.empCnt = null;
            }
            if (channelTypeId == 2 || channelTypeId == 3 || channelTypeId == 4 || channelTypeId == 5) {
                if (channelDetail.domesticSales) {
                    resultObject.empCntDSale = channelDetail.domesticSales;
                }
                if (channelDetail.internationalSales) {
                    resultObject.empCntISale = channelDetail.internationalSales;
                }
                if (channelDetail.domesticMarketing) {
                    resultObject.empCntDMar = channelDetail.domesticMarketing;
                }
                if (channelDetail.internationalMarketing) {
                    resultObject.empCntIMar = channelDetail.internationalMarketing;
                }
                if (channelDetail.startup) {
                    resultObject.startup = channelDetail.startup;
                }
                if (channelDetail.startup == '1' && channelDetail.maturitylevel) {
                    resultObject.maturitylevel = channelDetail.maturitylevel;
                }
            }
            if (channelDetail.annualTurnoverRange && !channelDetail.annualTurnover) {
                resultObject.turnoverRange = channelDetail.annualTurnoverRange;
            }
            else if (channelDetail.annualTurnover) {
                resultObject.turnoverRange = '';
            }
            if (channelDetail.annualTurnover && !channelDetail.annualTurnoverRange) {
                resultObject.turnover = channelDetail.annualTurnover;
            }
            else if (channelDetail.annualTurnoverRange) {
                resultObject.turnover = null;
            }
            if (!lodash_1.isUndefined(channelDetail.domesticRevenue)) {
                resultObject.revD = channelDetail.domesticRevenue;
            }
            if (!lodash_1.isUndefined(channelDetail.internationalRevenue)) {
                resultObject.revI = channelDetail.internationalRevenue;
            }
            if (!lodash_1.isUndefined(channelDetail.physicalStore)) {
                resultObject.turnoverPhyStore = channelDetail.physicalStore;
            }
            if (channelDetail.OnlineStore) {
                resultObject.turnoverOnStore = channelDetail.OnlineStore;
            }
            if (!lodash_1.isUndefined(channelDetail.storeCount)) {
                resultObject.storeCount = channelDetail.storeCount;
            }
            if (!lodash_1.isUndefined(channelDetail.no_of_retailers)) {
                resultObject.no_of_retailers = channelDetail.no_of_retailers;
            }
            if (!lodash_1.isUndefined(channelDetail.no_of_skus)) {
                resultObject.no_of_skus = channelDetail.no_of_skus;
            }
            if (!lodash_1.isUndefined(channelDetail.no_of_distributors)) {
                resultObject.no_of_distributors = channelDetail.no_of_distributors;
            }
            if (!lodash_1.isUndefined(channelDetail.no_of_resellers)) {
                resultObject.no_of_resellers = +channelDetail.no_of_resellers;
            }
            if (!lodash_1.isUndefined(channelDetail.no_of_vendors)) {
                resultObject.no_of_vendors = channelDetail.no_of_vendors;
            }
            if (!lodash_1.isUndefined(channelDetail.keyretailers)) {
                resultObject.keyretailers = channelDetail.keyretailers;
            }
            if (!lodash_1.isUndefined(channelDetail.keyresellers)) {
                resultObject.keyresellers = channelDetail.keyresellers;
            }
            if (!lodash_1.isUndefined(channelDetail.keydistributors)) {
                resultObject.keydistributors = channelDetail.keydistributors;
            }
            if (!lodash_1.isUndefined(channelDetail.year_of_estabilishment)) {
                resultObject.estYear = +channelDetail.year_of_estabilishment;
            }
            resultObject.updatedAt = new Date();
            return resultObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:ChannelDetail');
        }
    }
    async setDocumentObject(docTempPath, doctype, folderPath) {
        try {
            let mediaObject = {};
            mediaObject.documentPath = docTempPath;
            mediaObject.documentTypeId = doctype;
            if (folderPath) {
                mediaObject.dirName = folderPath;
            }
            return mediaObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:media');
        }
    }
    async setProductGroupIds(productGroup) {
        try {
            let ProductGroupIds = [];
            if (productGroup) {
                for (let ii = 0; ii < productGroup.length; ii++) {
                    ProductGroupIds.push(parseInt(productGroup[ii].productGroupId));
                }
            }
            return ProductGroupIds;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:media');
        }
    }
    async setChannelBrand(brandId, channelId) {
        try {
            let resultObject = {};
            resultObject.brandId = brandId;
            resultObject.channelId = channelId;
            resultObject.createdAt = new Date();
            return resultObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:channelBrand');
        }
    }
    async setProductCategoryIds(ProductGroupCategore) {
        try {
            let ProductCategoreIds = [];
            if (ProductGroupCategore) {
                for (let ii = 0; ii < ProductGroupCategore.length; ii++) {
                    ProductCategoreIds.push(parseInt(ProductGroupCategore[ii].productCategorieId));
                }
            }
            return ProductCategoreIds;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:media');
        }
    }
    async setCustomerProfilesIds(customerProfiles) {
        try {
            let CustomerProfilesIds = [];
            if (customerProfiles) {
                for (let ii = 0; ii < customerProfiles.length; ii++) {
                    CustomerProfilesIds.push(parseInt(customerProfiles[ii].profileTypeId));
                }
            }
            return CustomerProfilesIds;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:media');
        }
    }
    async setServiceListIds(serviceList) {
        try {
            let ServiceListIds = [];
            if (serviceList) {
                for (let ii = 0; ii < serviceList.length; ii++) {
                    ServiceListIds.push(parseInt(serviceList[ii].serviceListId));
                }
            }
            return ServiceListIds;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:media');
        }
    }
    async setbrandIds(channelBrand) {
        try {
            let brandIds = [];
            if (channelBrand) {
                for (let ii = 0; ii < channelBrand.length; ii++) {
                    brandIds.push(parseInt(channelBrand[ii].id));
                }
            }
            return brandIds;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:media');
        }
    }
    async setchannelbrandIds(channelBrand) {
        try {
            let brandIds = [];
            if (channelBrand) {
                for (let ii = 0; ii < channelBrand.length; ii++) {
                    brandIds.push(parseInt(channelBrand[ii].brandId));
                }
            }
            return brandIds;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:media');
        }
    }
    async setFactsChannelDetail(channelDetail) {
        try {
            let resultObject = {};
            if (channelDetail.employeesRange && !channelDetail.employeesCount) {
                resultObject.empCntRange = channelDetail.employeesRange;
            }
            else if (channelDetail.employeesCount) {
                resultObject.empCntRange = '';
            }
            if (channelDetail.employeesCount && !channelDetail.employeesRange) {
                resultObject.empCnt = channelDetail.employeesCount;
            }
            else if (channelDetail.employeesRange) {
                resultObject.empCnt = null;
            }
            if (channelDetail.annualTurnoverRange && !channelDetail.annualTurnover) {
                resultObject.turnoverRange = channelDetail.annualTurnoverRange;
            }
            else if (channelDetail.annualTurnover) {
                resultObject.turnoverRange = '';
            }
            if (channelDetail.annualTurnover && !channelDetail.annualTurnoverRange) {
                resultObject.turnover = channelDetail.annualTurnover;
            }
            else if (channelDetail.annualTurnoverRange) {
                resultObject.turnover = null;
            }
            if (channelDetail.startup) {
                resultObject.startup = channelDetail.startup;
            }
            if (channelDetail.year_of_estabilishment) {
                resultObject.estYear = channelDetail.year_of_estabilishment;
            }
            if (channelDetail.startup == '1' && channelDetail.maturitylevel) {
                resultObject.maturitylevel = channelDetail.maturitylevel;
            }
            if (!lodash_1.isUndefined(channelDetail.storeCount)) {
                resultObject.storeCount = channelDetail.storeCount;
            }
            if (!lodash_1.isUndefined(channelDetail.no_of_skus)) {
                resultObject.no_of_skus = channelDetail.no_of_skus;
            }
            resultObject.updatedAt = new Date();
            return resultObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:ChannelDetail');
        }
    }
    async setFactsOldChannelDetail(channelDetail) {
        try {
            let resultObject = {};
            if (channelDetail.employeesRange && !channelDetail.employeesCount) {
                resultObject.empCntRange = channelDetail.employeesRange;
            }
            else if (channelDetail.employeesCount) {
                resultObject.empCntRange = '';
            }
            if (channelDetail.employeesCount && !channelDetail.employeesRange) {
                resultObject.empCnt = channelDetail.employeesCount;
            }
            else if (channelDetail.employeesRange) {
                resultObject.empCnt = null;
            }
            if (channelDetail.annualTurnoverRange && !channelDetail.annualTurnover) {
                resultObject.turnoverRange = channelDetail.annualTurnoverRange;
            }
            else if (channelDetail.annualTurnover) {
                resultObject.turnoverRange = '';
            }
            if (channelDetail.annualTurnover && !channelDetail.annualTurnoverRange) {
                resultObject.turnover = channelDetail.annualTurnover;
            }
            else if (channelDetail.annualTurnoverRange) {
                resultObject.turnover = null;
            }
            if (channelDetail.startup) {
                resultObject.startup = channelDetail.startup;
            }
            if (channelDetail.year_of_estabilishment) {
                resultObject.estYear = channelDetail.year_of_estabilishment;
            }
            if (channelDetail.startup == '1' && channelDetail.maturitylevel) {
                resultObject.maturitylevel = channelDetail.maturitylevel;
            }
            if (!lodash_1.isUndefined(channelDetail.storeCount)) {
                resultObject.storeCount = channelDetail.storeCount;
            }
            if (!lodash_1.isUndefined(channelDetail.no_of_skus)) {
                resultObject.no_of_skus = channelDetail.no_of_skus;
            }
            resultObject.updatedAt = new Date();
            return resultObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:ChannelDetail');
        }
    }
}
exports.TradeInformationInBound = TradeInformationInBound;
//# sourceMappingURL=tradeInformationInBound.js.map