"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Country = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const swagger_1 = require("@nestjs/swagger");
const Region_entity_1 = require("./Region.entity");
const RegionCountryJCT_entity_1 = require("./RegionCountryJCT.entity");
let Country = class Country extends sequelize_typescript_1.Model {
};
Country.REDIS_KEY = 'country';
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.Column,
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], Country.prototype, "countryId", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.CHAR(255),
        allowNull: false,
        unique: { name: 'country', msg: 'validate:field:shouldBeUnique' }
    }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], Country.prototype, "country", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Country.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Country.prototype, "isVat", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Country.prototype, "registrationcertificate", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Country.prototype, "phoneCode", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Country.prototype, "isoCode", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", Number)
], Country.prototype, "priority", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => Region_entity_1.Region, { through: () => RegionCountryJCT_entity_1.RegionCountryJCT }),
    __metadata("design:type", Array)
], Country.prototype, "region", void 0);
__decorate([
    sequelize_typescript_1.HasOne(() => RegionCountryJCT_entity_1.RegionCountryJCT, 'countryId'),
    __metadata("design:type", RegionCountryJCT_entity_1.RegionCountryJCT)
], Country.prototype, "regionCountryJCT", void 0);
Country = __decorate([
    sequelize_typescript_1.Table({ timestamps: false,
        tableName: "tblCountry"
    }),
    sequelize_typescript_1.Scopes(() => ({
        regionCountryJCT: {
            attributes: [['country', 'name'], ['countryId', 'id'], ['isoCode', 'countryCode'], 'priority', 'phoneCode']
        },
        orderInfo: {
            attributes: ['country']
        },
        country: {
            where: { deletedAt: null },
            attributes: ['countryId', 'country'],
            include: [
                {
                    model: Region_entity_1.Region,
                    required: false,
                    attributes: ['regionId', 'region'],
                    where: { deletedAt: null },
                }
            ]
        },
    }))
], Country);
exports.Country = Country;
//# sourceMappingURL=Country.entity.js.map