"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Region = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Country_entity_1 = require("./Country.entity");
const Zone_entity_1 = require("./Zone.entity");
const Channel_entity_1 = require("../../channel/models/Channel.entity");
const RegionCountryJCT_entity_1 = require("./RegionCountryJCT.entity");
const ZoneRegionJCT_entity_1 = require("./ZoneRegionJCT.entity");
const swagger_1 = require("@nestjs/swagger");
let Region = class Region extends sequelize_typescript_1.Model {
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.Column,
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], Region.prototype, "regionId", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.CHAR(150),
        allowNull: false,
        unique: { name: 'region', msg: 'validate:field:shouldBeUnique' }
    }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], Region.prototype, "region", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column,
    __metadata("design:type", Number)
], Region.prototype, "channelId", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => Country_entity_1.Country, { through: () => RegionCountryJCT_entity_1.RegionCountryJCT }),
    __metadata("design:type", Array)
], Region.prototype, "country", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => Zone_entity_1.Zone, { through: () => ZoneRegionJCT_entity_1.ZoneRegionJCT }),
    __metadata("design:type", Array)
], Region.prototype, "zone", void 0);
__decorate([
    sequelize_typescript_1.HasOne(() => ZoneRegionJCT_entity_1.ZoneRegionJCT, 'regionId'),
    __metadata("design:type", ZoneRegionJCT_entity_1.ZoneRegionJCT)
], Region.prototype, "zoneRegionJCT", void 0);
Region = __decorate([
    sequelize_typescript_1.Table({
        tableName: "tblRegion", timestamps: false
    }),
    sequelize_typescript_1.Scopes(() => ({
        zoneRegionJCT: {
            attributes: ['regionId', 'region', 'channelId']
        },
        region: {
            where: { deletedAt: null },
            attributes: ['regionId', 'region'],
            include: [
                {
                    model: Zone_entity_1.Zone,
                    required: false,
                    attributes: ['zoneId', 'zone'],
                    where: { deletedAt: null }
                }
            ]
        },
    }))
], Region);
exports.Region = Region;
//# sourceMappingURL=Region.entity.js.map