"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommonService = void 0;
const common_1 = require("@nestjs/common");
const Brand_entity_1 = require("../../product/models/Brand.entity");
const ProductGroup_entity_1 = require("../../product/models/ProductGroup.entity");
const sequelize_1 = require("sequelize");
const ProductCategory_entity_1 = require("../../product/models/ProductCategory.entity");
const ProfileType_entity_1 = require("../../channel/models/ProfileType.entity");
const ProfileTypeClassification_entity_1 = require("../../channel/models/ProfileTypeClassification.entity");
let CommonService = class CommonService {
    constructor(sequelizeInstance, oldChannelRepository, productGroupRepository, countryRepository) {
        this.sequelizeInstance = sequelizeInstance;
        this.oldChannelRepository = oldChannelRepository;
        this.productGroupRepository = productGroupRepository;
        this.countryRepository = countryRepository;
    }
    async getSignup(channelTypeId) {
        let company = await this.oldChannelRepository.scope('basicInform').findAll({
            where: {
                deletedAt: null,
                channelTypeId: channelTypeId
            }
        });
        let query = 'select pg."productGroupId" as groupId,pg."productGroup" as groupname,pc."productCategorieId" as childId,pc."productCategorie" as childname,cast(false as boolean) as status from "tblProductGroup" as pg inner join'
            + ' "tblProductCategories" as pc on pg."productGroupId"=pc."productGroupId" where pg."deletedAt" is null and pg."productGroup"!=\'\' and pg."businessType"=3 ';
        let productGroup = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
        }).then((results) => {
            return results;
        });
        let country = await this.countryRepository.scope('regionCountryJCT').findAll({
            where: {
                deletedAt: null
            },
            order: [
                ['priority', 'ASC']
            ]
        });
        let companyList = [];
        if (company && company.length) {
            companyList = company.map(x => {
                return { id: x.oldChannelId, name: x.companyName, type: 1 };
            });
        }
        let data = {
            productGroup: productGroup,
            company: companyList,
            country: country
        };
        return data;
    }
    async getProducts(businessType) {
        let type = [];
        if (businessType == 1)
            type = ['1', '3'];
        if (businessType == 2)
            type = ['2', '3'];
        if (businessType == 3)
            type = ['1', '2', '3'];
        let query = 'select pg."productGroupId" as groupId,pg."productGroup" as groupname,pc."productCategorieId" as childId,pc."productCategorie" as childname,cast(false as boolean) as status from "tblProductGroup" as pg inner join'
            + ' "tblProductCategories" as pc on pg."productGroupId"=pc."productGroupId" where pg."deletedAt" is null and pg."productGroup"!=\'\' and pg."businessType" in (:businessType) ';
        let productGroup = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                businessType: type
            }
        }).then((results) => {
            return results;
        });
        let data = {
            productGroup: productGroup,
        };
        return data;
    }
    async getOldChannelProductGroup(email) {
        let query = 'select pg."productGroup" as "firstLetter",pg."productGroupId" as groupId,pg."productGroup" as groupname,pc."productCategorieId" as childId,pc."productCategorie" as childname,cast(true as boolean) as status from "tblProductGroup" as pg inner join "tblProductCategories" as pc on pg."productGroupId"=pc."productGroupId" '
            + 'and pg."productGroupId" in(select "productGroupId" from "tblOldContact" as oc inner join "tblOldChannelProductGroup" as pg on oc."oldChannelId"=pg."oldChannelId" where oc."email" like :mail) '
            + 'and pc."productCategorieId" in(select "productCategorieId" from "tblOldContact" as oc inner join "tblOldChannelProductCategorie" as pg on oc."oldChannelId"=pg."oldChannelId" where oc."email" like :mail)';
        let productGroup = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                mail: '%' + email + '%'
            }
        }).then((results) => {
            return results;
        });
        let cquery = 'select "companyName" as name,oc."oldChannelId" as id,"jobTitle","address","postalCode",ad."city","country",oc."countryId",oc."firstName",oc."lastName","isoCode","webSiteUrl" from "tblOldContact" as oc inner join "tblOldChannel" as ch on oc."oldChannelId"=ch."oldChannelId" inner join "tblOldAddress" as ad on ad."oldAddressId"=ch."regAddressId" inner join "tblCountry" as cty on cty."countryId"=oc."countryId" inner join "tblOldChannelDetail" as cd on cd."oldChannelId"=oc."oldChannelId"  where oc."email" like :mail';
        let companyAddress = await this.sequelizeInstance.query(cquery, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                mail: '%' + email + '%'
            }
        }).then((results) => {
            return results;
        });
        let result = {
            productGroup: productGroup,
            companyAddress: companyAddress
        };
        return result;
    }
    async findAllCountry() {
        return await this.countryRepository.scope('regionCountryJCT').findAll({
            where: {
                deletedAt: null
            },
            order: [
                ['priority', 'ASC']
            ]
        });
    }
};
CommonService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject('SequelizeInstance')),
    __param(1, common_1.Inject('OldChannelRepository')),
    __param(2, common_1.Inject('ProductGroupRepository')),
    __param(3, common_1.Inject('CountryRepository')),
    __metadata("design:paramtypes", [Object, Object, Object, Object])
], CommonService);
exports.CommonService = CommonService;
//# sourceMappingURL=common.service.js.map