"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DigitalWalletController = void 0;
const common_1 = require("@nestjs/common");
const passport_1 = require("@nestjs/passport");
const FetchUploadS3_1 = require("../../../lib/FetchUploadS3");
const digitalWallet_service_1 = require("../service/digitalWallet.service");
const S3Lib_1 = require("../../../lib/S3Lib");
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
let DigitalWalletController = class DigitalWalletController {
    constructor(digitalWalletService) {
        this.digitalWalletService = digitalWalletService;
    }
    async getWalletAmount(data, req, res) {
        let user = req.user;
        let walletAmount = await this.digitalWalletService.getWalletAmount(user);
        return res.status(common_1.HttpStatus.OK).send(walletAmount);
    }
    async processWalletPayment(req, res) {
        let user = req.user;
        let transactionId = null;
        console.log('test herer');
        console.log(req.body);
        let result = await this.digitalWalletService.processWalletPayment(req.body, user);
        if (result) {
            return res.status(common_1.HttpStatus.OK).json({ sent: 'success' });
        }
        else {
            return res.status(common_1.HttpStatus.OK).json({ sent: 'error' });
        }
    }
};
__decorate([
    common_1.Get('getWalletAmount'),
    __param(0, common_1.Body()), __param(1, common_1.Req()), __param(2, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], DigitalWalletController.prototype, "getWalletAmount", null);
__decorate([
    common_1.Post('processWalletPayment'),
    __param(0, common_1.Req()), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], DigitalWalletController.prototype, "processWalletPayment", null);
DigitalWalletController = __decorate([
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    common_1.Controller('digitalWallet'),
    __metadata("design:paramtypes", [digitalWallet_service_1.DigitalWalletService])
], DigitalWalletController);
exports.DigitalWalletController = DigitalWalletController;
//# sourceMappingURL=digitalWallet.controller.js.map