"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DigitalWalletService = void 0;
const common_1 = require("@nestjs/common");
const UserWalletAmount_entity_1 = require("../models/UserWalletAmount.entity");
const ChannelJCT_entity_1 = require("../../channel/models/ChannelJCT.entity");
const config_1 = require("../../../config");
let DigitalWalletService = class DigitalWalletService {
    constructor(userWalletAmountRepository, otherPaymentRepository, walletTransactionRepository, walletUsageTypeRepository) {
        this.userWalletAmountRepository = userWalletAmountRepository;
        this.otherPaymentRepository = otherPaymentRepository;
        this.walletTransactionRepository = walletTransactionRepository;
        this.walletUsageTypeRepository = walletUsageTypeRepository;
    }
    async getWalletAmount(user) {
        console.log(user.userId);
        console.log(user.channelId);
        return await this.userWalletAmountRepository.findOne({
            where: {
                userId: user.userId,
                channelId: user.channelId
            }
        });
    }
    async processWalletPayment(req, user) {
        try {
            console.log('dfdsfsdfdsfdsfdsfdsfdsfdsfdsf');
            return await UserWalletAmount_entity_1.UserWalletAmount.findOne({
                where: {
                    channelId: user.channelId,
                    userId: user.userId
                }
            }).then(async (userAmount) => {
                console.log(userAmount);
                let walletTransactions = {};
                walletTransactions.payerUserId = +user.userId;
                walletTransactions.payeeChannelId = req.req_cid;
                walletTransactions.amount = req.amt;
                walletTransactions.currencyid = 1;
                walletTransactions.walletUsageTypeId = 1;
                walletTransactions.updatedAt = Date.now();
                userAmount.amount = +userAmount.amount - 10;
                userAmount.save();
                if (req.jctId == null) {
                    await ChannelJCT_entity_1.ChannelJCT.create({
                        isConfidential: '0',
                        channelId: +req.req_cid,
                        partnerChannelId: +user.channelId,
                        createdAt: Date.now(),
                        connectionStatusTypeId: +config_1.appconstant.REMOVE_CONFIDENTIAL
                    });
                }
                else {
                    await ChannelJCT_entity_1.ChannelJCT.update({
                        isConfidential: '0'
                    }, {
                        where: {
                            channelId: user.channelId,
                            partnerChannelId: +req.req_cid,
                            deletedat: null
                        }
                    });
                    await ChannelJCT_entity_1.ChannelJCT.update({
                        isConfidential: '0'
                    }, {
                        where: {
                            channelJCTId: +req.jctId,
                            channelId: +req.req_cid,
                            partnerChannelId: user.channelId,
                            deletedat: null
                        }
                    });
                    console.log('wallet rc confirmation');
                    console.log(req.jctId);
                }
                this.walletTransactionRepository.create(walletTransactions);
                return userAmount;
            });
        }
        catch (e) {
            console.log(e);
        }
    }
};
DigitalWalletService = __decorate([
    __param(0, common_1.Inject('UserWalletAmountRepository')),
    __param(1, common_1.Inject('OtherPaymentRepository')),
    __param(2, common_1.Inject('WalletTransactionRepository')),
    __param(3, common_1.Inject('WalletUsageTypeRepository')),
    __metadata("design:paramtypes", [Object, Object, Object, Object])
], DigitalWalletService);
exports.DigitalWalletService = DigitalWalletService;
//# sourceMappingURL=digitalWallet.service.js.map