"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MediaController = void 0;
const common_1 = require("@nestjs/common");
const passport_1 = require("@nestjs/passport");
const platform_express_1 = require("@nestjs/platform-express");
const FetchUploadS3_1 = require("../../../lib/FetchUploadS3");
const S3Lib_1 = require("../../../lib/S3Lib");
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
const utility_1 = require("../helper/utility");
let MediaController = class MediaController {
    constructor() {
        this.fs = require('fs');
    }
    uploadFiles(files) {
        console.log(files);
    }
    async uploadFile(file, res, dirName) {
        if (file.originalname) {
            var s3 = new S3Lib_1.S3Lib();
            let helper = new utility_1.Utility();
            let newPath = await helper.getNewMediaPath({
                documentPath: file.originalname,
                dirName: this.getDirName(dirName)
            });
            const sharp = require('sharp');
            let response = await s3.moveFromLocal(file.buffer, newPath, 1);
            let path = await helper.getMediaPath({
                documentPath: newPath,
                dirName: this.getDirName(dirName)
            });
            var fus3 = new FetchUploadS3_1.FetchUploadS3();
            let url = process.env.AWS_BUCKET_KEY_PREFIX + '/' + path;
            if (dirName != 'introVideo' && dirName !== 'broucher' && dirName !== 'banner') {
                const size = await sharp(file.buffer).metadata();
                console.log('size', size);
                if (size.width > 300) {
                    await fus3.upload(file.buffer, url, 300, 300, process.env.TEM_AWS_BUCKET);
                }
                else {
                    await s3.moveFromLocal(file.buffer, url, 2);
                }
            }
            else {
                await s3.moveFromLocal(file.buffer, url, 2);
            }
            res.status(common_1.HttpStatus.OK).json({ url: url });
        }
        else {
            throw new Process_exception_1.ProcessException('Soming went wrong');
        }
    }
    getDirName(id) {
        switch (id) {
            case 'introVideo':
                return 'introVideo';
            case 'CompanyLogo':
                return 'account-s3';
            case 'brandlogo':
                return 'brand-s3';
            case 'broucher':
                return 'product/broucher';
            case 'display':
                return 'product/display';
            case 'packing':
                return 'product/packing';
            case 'image':
                return 'product/image';
            case 'image':
                return 'product/banner';
            case 'productImportCSV':
                return 'product-import-csv-s3';
            case 'productImportZIP':
                return 'product-import-zip-s3';
            default:
                return 'media';
        }
    }
    async productFile(file, res, dirName) {
        if (file.originalname) {
            var s3 = new S3Lib_1.S3Lib();
            let helper = new utility_1.Utility();
            let s3Path = this.getDirName(dirName);
            let newPath = s3Path + '/' + file.originalname;
            let response = await s3.moveFromLocal(file.buffer, newPath, 1);
            let result = null;
            if (response) {
                result = file.originalname;
            }
            else {
                result = 'error';
            }
            res.status(common_1.HttpStatus.OK).json({ url: result });
        }
        else {
            throw new Process_exception_1.ProcessException('Soming went wrong');
        }
    }
};
__decorate([
    common_1.Post('uploadImage'),
    common_1.UseInterceptors(platform_express_1.FilesInterceptor('files')),
    __param(0, common_1.UploadedFiles()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", void 0)
], MediaController.prototype, "uploadFiles", null);
__decorate([
    common_1.Post('upload/:dirName'),
    common_1.UseInterceptors(platform_express_1.FileInterceptor('file')),
    __param(0, common_1.UploadedFile()), __param(1, common_1.Res()), __param(2, common_1.Param('dirName')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], MediaController.prototype, "uploadFile", null);
__decorate([
    common_1.Post('productFile/:dirName'),
    common_1.UseInterceptors(platform_express_1.FileInterceptor('file')),
    __param(0, common_1.UploadedFile()), __param(1, common_1.Res()), __param(2, common_1.Param('dirName')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], MediaController.prototype, "productFile", null);
MediaController = __decorate([
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    common_1.Controller('mediaupload')
], MediaController);
exports.MediaController = MediaController;
//# sourceMappingURL=media.controller.js.map