"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Utility = void 0;
const path_1 = require("path");
class Utility {
    async getNewMediaPath(instance) {
        let parsedData = path_1.parse(instance.documentPath);
        let extName = parsedData.ext;
        return (instance.dirName ? instance.dirName : 'media') + '/' + new Date().getTime() + extName;
    }
    async getThambnailPath(instance) {
        let parsedData = path_1.parse(instance.documentPath);
        let extName = parsedData.ext;
        return (instance.dirName ? instance.dirName : 'media') + '/thambnail_' + new Date().getTime() + extName;
    }
    async getMediaPath(instance) {
        let parsedData = path_1.parse(instance.documentPath);
        let baseName = parsedData.name.trim().replace(/\s/g, '-');
        let extName = parsedData.ext;
        return (instance.dirName ? instance.dirName : 'media') + '/' + baseName + '_' + new Date().getTime() + extName;
    }
}
exports.Utility = Utility;
//# sourceMappingURL=utility.js.map