'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var Media_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Media = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const swagger_1 = require("@nestjs/swagger");
const MediaType_entity_1 = require("./MediaType.entity");
const S3Lib_1 = require("./../../../lib/S3Lib");
const utility_1 = require("./../helper/utility");
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
const FetchUploadS3_1 = require("../../../lib/FetchUploadS3");
let Media = Media_1 = class Media extends sequelize_typescript_1.Model {
    constructor() {
        super(...arguments);
        this.updatedId = null;
    }
    static async moveFromPublicBucket(instance) {
        let s3 = new S3Lib_1.S3Lib();
        var fus3 = new FetchUploadS3_1.FetchUploadS3();
        let helper = new utility_1.Utility();
        let path = instance.documentPath;
        let newPath = await helper.getMediaPath(instance);
        let destinationPath = process.env.AWS_BUCKET_KEY_PREFIX + '/' + newPath;
        let moveAction = await s3.CopyObjectTempToPlublic("/" + encodeURI(instance.documentPath.trim()), destinationPath);
        if (moveAction) {
            instance.documentPath = destinationPath;
        }
        if (instance.documentTypeId == 1) {
            let thambnailPath = await helper.getThambnailPath(instance);
            let destinationThamnailPath = 'thambnail/' + thambnailPath;
            let buffer = await fus3.getS3urlToBuffer(path, process.env.TEM_AWS_BUCKET);
            await fus3.upload(buffer, destinationThamnailPath, 100, 100, process.env.PUBLIC_AWS_BUCKET);
            instance.thumbnailPath = destinationThamnailPath;
        }
    }
    static async blockMediaUpdate(instance) {
        let newMedia = new Media_1();
        newMedia.documentTypeId = instance.documentTypeId;
        newMedia.documentPath = instance.documentPath;
        newMedia.dirName = instance.dirName;
        await newMedia.save();
        instance.updatedId = newMedia.documentId;
        if (instance.documentId === 1) {
            instance.deletedAt = new Date();
            instance.documentPath = instance.previous('documentPath');
        }
    }
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Media.prototype, "documentId", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.INTEGER),
    sequelize_typescript_1.ForeignKey(() => MediaType_entity_1.MediaType),
    __metadata("design:type", Number)
], Media.prototype, "documentTypeId", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.CHAR(255),
        allowNull: false,
        unique: false
    }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], Media.prototype, "documentPath", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => MediaType_entity_1.MediaType),
    __metadata("design:type", MediaType_entity_1.MediaType)
], Media.prototype, "documentType", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Media.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Media.prototype, "createdAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Media.prototype, "updatedAt", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.CHAR(255),
        unique: false
    }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], Media.prototype, "thumbnailPath", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: new sequelize_typescript_1.DataType.VIRTUAL(sequelize_typescript_1.DataType.CHAR(255), ['documentPath']),
        get: function () {
            return process.env.CDN_URL + this.get('documentPath');
        }
    }),
    __metadata("design:type", String)
], Media.prototype, "documentUrl", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: new sequelize_typescript_1.DataType.VIRTUAL(sequelize_typescript_1.DataType.CHAR(255), ['thumbnailPath']),
        get: function () {
            if (this.get('documentTypeId') == 1)
                return process.env.CDN_URL + this.get('thumbnailPath');
        }
    }),
    __metadata("design:type", String)
], Media.prototype, "thumbnailUrl", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: new sequelize_typescript_1.DataType.VIRTUAL(sequelize_typescript_1.DataType.CHAR(255), ['dirName']),
        set: function (value) {
            this.setDataValue('dirName', value);
        }
    }),
    __metadata("design:type", String)
], Media.prototype, "dirName", void 0);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Media]),
    __metadata("design:returntype", Promise)
], Media, "moveFromPublicBucket", null);
__decorate([
    sequelize_typescript_1.BeforeUpdate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Media]),
    __metadata("design:returntype", Promise)
], Media, "blockMediaUpdate", null);
Media = Media_1 = __decorate([
    sequelize_typescript_1.Table({
        tableName: "tblDocument"
    }),
    sequelize_typescript_1.Scopes(() => ({
        profileInfo: {
            attributes: ['documentId', 'documentTypeId', 'documentPath', 'documentUrl']
        },
        orderInfo: {
            attributes: ['documentUrl']
        }
    }))
], Media);
exports.Media = Media;
//# sourceMappingURL=Media.entity.js.map