'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MeetingController = void 0;
const common_1 = require("@nestjs/common");
const validation_pipe_1 = require("../../../middleware/pipe/validation.pipe");
const meetingReq_dto_1 = require("../dto/meetingReq.dto");
const context_service_1 = require("./../../../context/context.service");
const meeting_service_1 = require("../service/meeting.service");
const meetingConfirm_dto_1 = require("../dto/meetingConfirm.dto");
let MeetingController = class MeetingController {
    constructor(meetingService, context) {
        this.meetingService = meetingService;
        this.context = context;
    }
    async addNewUser(res, addUserDto) {
        let result = await this.meetingService.addMeetingReq(addUserDto);
        res.status(common_1.HttpStatus.CREATED).send({
            created: result
        });
    }
    async listMeeting(res, req) {
        let result = await this.meetingService.getMeetingList(req.query);
        res.status(common_1.HttpStatus.CREATED).send(result);
    }
    async updateMeeting(res, updateMeeting) {
        await this.meetingService.updateMeeting(updateMeeting);
        res.status(common_1.HttpStatus.CREATED).send({
            status: true
        });
    }
};
__decorate([
    common_1.Post(),
    __param(0, common_1.Response()), __param(1, common_1.Body(new validation_pipe_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, meetingReq_dto_1.MeetingReqDto]),
    __metadata("design:returntype", Promise)
], MeetingController.prototype, "addNewUser", null);
__decorate([
    common_1.Get(),
    __param(0, common_1.Response()), __param(1, common_1.Request()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MeetingController.prototype, "listMeeting", null);
__decorate([
    common_1.Post('updateMeeting'),
    __param(0, common_1.Response()), __param(1, common_1.Body(new validation_pipe_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, meetingConfirm_dto_1.MeetingConfirmDto]),
    __metadata("design:returntype", Promise)
], MeetingController.prototype, "updateMeeting", null);
MeetingController = __decorate([
    common_1.Controller('Meeting'),
    __metadata("design:paramtypes", [meeting_service_1.MeetingService,
        context_service_1.ContextService])
], MeetingController);
exports.MeetingController = MeetingController;
//# sourceMappingURL=meeting.controller.js.map