'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MeetingModule = void 0;
const common_1 = require("@nestjs/common");
const meeting_controller_1 = require("./controller/meeting.controller");
const meeting_service_1 = require("./service/meeting.service");
const meeting_providers_1 = require("./provider/meeting.providers");
const common_module_1 = require("../common/common.module");
const media_module_1 = require("../media/media.module");
const notification_module_1 = require("../notification/notification.module");
const channel_provider_1 = require("../channel/provider/channel.provider");
const user_provider_1 = require("../user/provider/user.provider");
const database_module_1 = require("../../core/database/database.module");
let MeetingModule = class MeetingModule {
};
MeetingModule = __decorate([
    common_1.Module({
        controllers: [
            meeting_controller_1.MeetingController
        ],
        providers: [
            meeting_service_1.MeetingService,
            ...meeting_providers_1.MeetingReqProviders,
            ...user_provider_1.UserProviders,
            ...channel_provider_1.channelProvider
        ],
        imports: [
            database_module_1.DatabaseModule,
            common_module_1.CommonModule,
            media_module_1.MediaModule,
            notification_module_1.NotificationModule
        ],
        exports: [
            meeting_service_1.MeetingService,
            ...meeting_providers_1.MeetingReqProviders
        ],
    })
], MeetingModule);
exports.MeetingModule = MeetingModule;
//# sourceMappingURL=meeting.module.js.map