'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MeetingService = void 0;
const common_1 = require("@nestjs/common");
const meetingInBound_1 = require("./../transformation/meetingInBound");
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
const sequelize_1 = require("sequelize");
let MeetingService = class MeetingService {
    constructor(meetingRepository, contactRepository, channelRepository, sequelizeInstance) {
        this.meetingRepository = meetingRepository;
        this.contactRepository = contactRepository;
        this.channelRepository = channelRepository;
        this.sequelizeInstance = sequelizeInstance;
        this.meetingInBound = new meetingInBound_1.MeetingInBound();
    }
    async addMeetingReq(meetingDto) {
        let meetingObject = await this.meetingInBound.setAddMeetingObject(meetingDto);
        let result = await this.sequelizeInstance.transaction(async (transaction) => {
            await this.meetingRepository.create(meetingObject);
        }).then(function (result) {
            return result;
        }).catch(function (e) {
            console.log(e);
            throw new Process_exception_1.ProcessException(e.message);
        });
        return true;
    }
    async getMeetingList(filter) {
        let limit = ' LIMIT ' + filter.limit;
        let offset = ' OFFSET ' + filter.offset;
        let q = 'select count(*) OVER() AS full_count, mr."mettingReqId" as meetingReqId, mr."isMeetingConfirm", ch."companyName" as Requester_Company,tc."firstName" as Requester_Username,tc."email" as Requester_Email,rch."companyName" as Receiver_Company,rtc."firstName" as Receiver_Username,rtc."email" as Receiver_Email from "tblMeetingReq" as mr inner join "tblContact" as tc on  mr."senderContactId"=tc."contactId" inner join "tblChannel" as ch on mr."senderChannelId"=ch."channelId" inner join "tblContact" as rtc on  mr."receiverContactId"=rtc."contactId"  inner join "tblChannel" as rch on mr."receiverChannelId"=rch."channelId" where mr."mettingReqId"=mr."mettingReqId" and mr."isMeetingConfirm" != 1 and mr."deletedAt" is null';
        q += limit + offset;
        return await this.sequelizeInstance.query(q, {
            type: sequelize_1.QueryTypes.SELECT
        });
    }
    async updateMeeting(confirmMeeting) {
        await this.meetingRepository.update({ meeting_Scheduled_At: confirmMeeting.meeting_Scheduled_At, isMeetingConfirm: confirmMeeting.isMeetingConfirm }, {
            where: {
                mettingReqId: confirmMeeting.meetingReqId,
                deletedAt: null
            }
        });
    }
    async getContactMail(contactId) {
        return await this.contactRepository.findOne({
            where: {
                contactId: contactId
            },
        });
    }
    async getCompanyMail(channelId) {
        return await this.channelRepository.findOne({
            where: {
                channelId: channelId
            },
        });
    }
};
MeetingService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject('MeetingRepository')),
    __param(1, common_1.Inject('ContactRepository')),
    __param(2, common_1.Inject('ChannelRepository')),
    __param(3, common_1.Inject('SequelizeInstance')),
    __metadata("design:paramtypes", [Object, Object, Object, Object])
], MeetingService);
exports.MeetingService = MeetingService;
//# sourceMappingURL=meeting.service.js.map