"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NotificationController = void 0;
const common_1 = require("@nestjs/common");
const context_service_1 = require("./../../../context/context.service");
const notification_service_1 = require("../service/notification.service");
const passport_1 = require("@nestjs/passport");
let NotificationController = class NotificationController {
    constructor(context, notificationService) {
        this.context = context;
        this.notificationService = notificationService;
    }
    async getDashboard(req, res) {
        let user = req.user;
        let result = await this.notificationService.getDashboardcount(user);
        if (result) {
            res.status(common_1.HttpStatus.OK).json(result);
        }
        else {
        }
    }
    async sendSMS(req, res, message) {
        let result = await this.notificationService.sendSMS(message);
        if (result) {
            res.status(common_1.HttpStatus.OK).json(result);
        }
        else {
        }
    }
};
__decorate([
    common_1.Get('getDashboardcount'),
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    __param(0, common_1.Request()), __param(1, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], NotificationController.prototype, "getDashboard", null);
__decorate([
    common_1.Post('message'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], NotificationController.prototype, "sendSMS", null);
NotificationController = __decorate([
    common_1.Controller('notification'),
    __metadata("design:paramtypes", [context_service_1.ContextService,
        notification_service_1.NotificationService])
], NotificationController);
exports.NotificationController = NotificationController;
//# sourceMappingURL=notification.controller.js.map