"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NotificationService = void 0;
const common_1 = require("@nestjs/common");
const database_config_1 = require("../../../core/database/database.config");
let NotificationService = class NotificationService {
    constructor(sequelizeInstance) {
        this.sequelizeInstance = sequelizeInstance;
    }
    async getDashboardcount(user) {
        let query = 'select count(q.productid) as product_count from tblproductquote q inner join tblcart c on c.cartid = q.cartid where q.deletedat IS NULL and c.deletedat IS NULL and c.userid = :userId ';
        let cart_count = await this.sequelizeInstance.query(query, {
            type: this.sequelizeInstance.QueryTypes.SELECT,
            raw: true,
            replacements: {
                userId: user.userId,
            }
        }).then((data) => {
            return data[0].product_count;
        });
        query = 'select count("productwishlistid") as fav_count from "tblproductwishlist" where "deletedat" is null and "userid"=:userId';
        let fav_count = await this.sequelizeInstance.query(query, {
            type: this.sequelizeInstance.QueryTypes.SELECT,
            raw: true,
            replacements: {
                userId: user.userId,
            }
        }).then((data) => {
            return data[0].fav_count;
        });
        let data = { cart_count: cart_count,
            fav_count: fav_count };
        return data;
    }
    async sendSMS(message) {
        console.log("phone:", message.phoneno);
        let sendMsg = require('aws-sns-sms');
        let awsConfig = {
            accessKeyId: process.env.AWS_SMS_ACCESS_KEY,
            secretAccessKey: process.env.AWS_SMS_SECRET_ACCESS_KEY,
            region: 'eu-west-1'
        };
        let otp = Math.floor(100000 + Math.random() * 900000);
        let msg = {
            "message": "ChannelHub:Your Verification Code is:" + otp,
            "sender": "CHANNELHUB",
            "phoneNumber": message.phoneno
        };
        sendMsg(awsConfig, msg).then(data => {
            console.log("Message sent");
        })
            .catch(err => {
            console.log(err);
        });
        return otp;
    }
};
NotificationService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject('SequelizeInstance')),
    __metadata("design:paramtypes", [Object])
], NotificationService);
exports.NotificationService = NotificationService;
//# sourceMappingURL=notification.service.js.map