'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CheckoutController = void 0;
const common_1 = require("@nestjs/common");
const validation_pipe_1 = require("../../../middleware/pipe/validation.pipe");
const Channel_entity_1 = require("./../../channel/models/Channel.entity");
const checkout_dto_1 = require("./../dto/checkout.dto");
const checkout_service_1 = require("./../service/checkout.service");
const config_1 = require("./../../../config");
const channel_service_1 = require("./../../channel/service/channel.service");
const sequelize_1 = require("sequelize");
const passport_1 = require("@nestjs/passport");
let CheckoutController = class CheckoutController {
    constructor(service, channelService) {
        this.service = service;
        this.channelService = channelService;
    }
    async verifyRejectedChannels(user, channelId) {
        let rejectedChannels = await this.getRejectedChannelIds(+user.channelId, +user.contactId);
        if (rejectedChannels.includes('' + channelId)) {
        }
    }
    async getRejectedChannelIds(channelId, contactId) {
        return await Channel_entity_1.Channel.sequelize.query('select case when "channelId"=:channelId then "partnerChannelId" when  "partnerChannelId"=:channelId then "channelId" end as a  from "tblChannelJCT" where "connectionStatusTypeId" in (:rejectStatus) and ("channelId"=:channelId or "partnerChannelId"=:channelId) and case when "requested_to" = :contactId then "requested_by" not in(select case when "requested_by"=:contactId then "requested_to" when "requested_to"=:contactId then "requested_by" end from "tblChannelJCT" where ("requested_to"=:contactId or "requested_by"=:contactId) and "deletedat" is null and  "connectionStatusTypeId" in(1,2,7,10,11)) when "requested_by" = :contactId then "requested_to" not in(select case when "requested_by"=:contactId then "requested_to" when "requested_to"=:contactId then "requested_by" end from "tblChannelJCT" where ("requested_to"=:contactId or "requested_by"=:contactId) and "deletedat" is null and  "connectionStatusTypeId" in(1,2,7,10,11)) end', {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                rejectStatus: [config_1.appconstant.DISMISS, config_1.appconstant.DISMISS_OTHER_REASON],
                channelId: +channelId,
                contactId: +contactId
            }
        }).then((result) => {
            let res = [];
            return res;
        });
    }
    async checkout(req, res, dto) {
        let user = req.user;
        var relation_queued = '0';
        let cart = await this.service.validateAndCollectCart(dto, user);
        var counted = false;
        let updateChannel = false;
        let orderNo = await this.service.makeOrder(cart, Object.assign(dto, {
            relation_queued
        }), user);
        return res.status(common_1.HttpStatus.OK).json({
            status: true,
            order: orderNo
        });
    }
};
__decorate([
    common_1.Post('/'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body(new validation_pipe_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, checkout_dto_1.CheckoutDto]),
    __metadata("design:returntype", Promise)
], CheckoutController.prototype, "checkout", null);
CheckoutController = __decorate([
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    common_1.Controller('checkout'),
    __metadata("design:paramtypes", [checkout_service_1.CheckoutService,
        channel_service_1.ChannelService])
], CheckoutController);
exports.CheckoutController = CheckoutController;
//# sourceMappingURL=checkout.controller.js.map