"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SampleOrder = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Channel_entity_1 = require("../../channel/models/Channel.entity");
const User_entity_1 = require("../../user/models/User.entity");
const DiscountUnit_entity_1 = require("../../product/models/DiscountUnit.entity");
const PaymentTransaction_entity_1 = require("../../channel/models/PaymentTransaction.entity");
const OrderShipment_entity_1 = require("./OrderShipment.entity");
const OrderStatus_entity_1 = require("./OrderStatus.entity");
const SampleOrderDetail_entity_1 = require("./SampleOrderDetail.entity");
const OrderAddress_entity_1 = require("./OrderAddress.entity");
const Currency_entity_1 = require("../../channel/models/Currency.entity");
const tableOptions = { timestamps: false, tableName: 'tblsampleorder' };
let SampleOrder = class SampleOrder extends sequelize_typescript_1.Model {
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SampleOrder.prototype, "sampleorderid", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], SampleOrder.prototype, "ordernumber", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => User_entity_1.User),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SampleOrder.prototype, "userid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => User_entity_1.User),
    __metadata("design:type", User_entity_1.User)
], SampleOrder.prototype, "user", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SampleOrder.prototype, "sellerchannelid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel, 'sellerchannelid'),
    __metadata("design:type", Channel_entity_1.Channel)
], SampleOrder.prototype, "sellerchannel", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SampleOrder.prototype, "buyerchannelid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel, 'buyerchannelid'),
    __metadata("design:type", Channel_entity_1.Channel)
], SampleOrder.prototype, "buyerchannel", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => OrderAddress_entity_1.OrderAddress),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SampleOrder.prototype, "billingaddressid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => OrderAddress_entity_1.OrderAddress, 'billingaddressid'),
    __metadata("design:type", OrderAddress_entity_1.OrderAddress)
], SampleOrder.prototype, "billingaddress", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => OrderAddress_entity_1.OrderAddress),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SampleOrder.prototype, "shippingaddressid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => OrderAddress_entity_1.OrderAddress, 'shippingaddressid'),
    __metadata("design:type", OrderAddress_entity_1.OrderAddress)
], SampleOrder.prototype, "shippingaddress", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => OrderStatus_entity_1.OrderStatus),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SampleOrder.prototype, "statusid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => OrderStatus_entity_1.OrderStatus),
    __metadata("design:type", OrderStatus_entity_1.OrderStatus)
], SampleOrder.prototype, "status", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Currency_entity_1.Currency),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SampleOrder.prototype, "currencyid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Currency_entity_1.Currency),
    __metadata("design:type", Currency_entity_1.Currency)
], SampleOrder.prototype, "currency", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SampleOrder.prototype, "subtotalprice", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SampleOrder.prototype, "shippingprice", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SampleOrder.prototype, "discount", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => DiscountUnit_entity_1.DiscountUnit),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SampleOrder.prototype, "discountunitid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => DiscountUnit_entity_1.DiscountUnit, 'discountunitid'),
    __metadata("design:type", DiscountUnit_entity_1.DiscountUnit)
], SampleOrder.prototype, "discountunitdetail", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SampleOrder.prototype, "othercharge", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SampleOrder.prototype, "ordertotalprice", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => PaymentTransaction_entity_1.PaymentTransaction),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SampleOrder.prototype, "paymenttranscationid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => PaymentTransaction_entity_1.PaymentTransaction),
    __metadata("design:type", PaymentTransaction_entity_1.PaymentTransaction)
], SampleOrder.prototype, "paymenttranscation", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], SampleOrder.prototype, "requestfreesample", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(5000)),
    __metadata("design:type", String)
], SampleOrder.prototype, "comments", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], SampleOrder.prototype, "orderdate", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], SampleOrder.prototype, "updatedat", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => SampleOrderDetail_entity_1.SampleOrderDetail, 'sampleorderid'),
    __metadata("design:type", Array)
], SampleOrder.prototype, "orderDetails", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => OrderShipment_entity_1.OrderShipment, 'orderid'),
    __metadata("design:type", Array)
], SampleOrder.prototype, "shipments", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SampleOrder.prototype, "canceledby", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel, 'canceledby'),
    __metadata("design:type", Channel_entity_1.Channel)
], SampleOrder.prototype, "canceled", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], SampleOrder.prototype, "transferred", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SampleOrder.prototype, "transferredto", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel, 'transferredto'),
    __metadata("design:type", Number)
], SampleOrder.prototype, "transferredChannel", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], SampleOrder.prototype, "transferredat", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], SampleOrder.prototype, "relation_queued", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], SampleOrder.prototype, "subscription_queued", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], SampleOrder.prototype, "queueprocessedat", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], SampleOrder.prototype, "invoiced", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(256)),
    __metadata("design:type", String)
], SampleOrder.prototype, "paymentDetail", void 0);
SampleOrder = __decorate([
    sequelize_typescript_1.Table(tableOptions)
], SampleOrder);
exports.SampleOrder = SampleOrder;
//# sourceMappingURL=SampleOrder.entity.js.map