'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrderModule = void 0;
const common_1 = require("@nestjs/common");
const database_providers_1 = require("../../core/database/database.providers");
const order_providers_1 = require("./provider/order.providers");
const channel_module_1 = require("../channel/channel.module");
const user_module_1 = require("../user/user.module");
const cart_module_1 = require("./../cart/cart.module");
const checkout_service_1 = require("./service/checkout.service");
const checkout_controller_1 = require("./controller/checkout.controller");
const myAddressBook_providers_1 = require("../user/provider/myAddressBook.providers");
const database_module_1 = require("../../core/database/database.module");
let OrderModule = class OrderModule {
};
OrderModule = __decorate([
    common_1.Module({
        controllers: [
            checkout_controller_1.CheckoutController
        ],
        imports: [
            database_module_1.DatabaseModule,
            channel_module_1.ChannelModule,
            user_module_1.UserModule,
            cart_module_1.CartModule,
        ],
        providers: [
            checkout_service_1.CheckoutService,
            ...myAddressBook_providers_1.MyAddressBookProviders,
            ...database_providers_1.databaseProviders,
            ...order_providers_1.orderStatusProvider,
            ...order_providers_1.orderProvider,
            ...order_providers_1.orderDetailProvider,
            ...order_providers_1.orderShipmentProvider,
            ...order_providers_1.orderAddressProvider
        ],
        exports: [
            ...order_providers_1.orderStatusProvider,
            ...order_providers_1.orderProvider,
            ...order_providers_1.orderDetailProvider,
            ...order_providers_1.orderShipmentProvider
        ],
    })
], OrderModule);
exports.OrderModule = OrderModule;
//# sourceMappingURL=order.module.js.map