'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductAdminController = void 0;
const common_1 = require("@nestjs/common");
const passport_1 = require("@nestjs/passport");
const createBrand_dto_1 = require("../dto/createBrand.dto");
const UpdateBrand_dto_1 = require("../dto/UpdateBrand.dto");
const product_admin_service_1 = require("../service/product.admin.service");
let ProductAdminController = class ProductAdminController {
    constructor(productAdminService) {
        this.productAdminService = productAdminService;
    }
    async brandCreate(req, res, createBrandDto) {
        let result = await this.productAdminService.createBrand(createBrandDto);
        return res.status(common_1.HttpStatus.CREATED).send(result);
    }
    async getBrands(req, res) {
        console.log('req', req);
        let result = await this.productAdminService.getBrands(req.query);
        res.status(common_1.HttpStatus.OK).json(result);
    }
    async getBrand(id, req, res) {
        const row = await this.productAdminService.getBrand(id);
        return res.status(common_1.HttpStatus.OK).json(row);
    }
    async brandUpdate(id, req, res, updateBrandDto) {
        let result = await this.productAdminService.updateBrand(id, updateBrandDto);
        return res.status(common_1.HttpStatus.CREATED).send(result);
    }
};
__decorate([
    common_1.Post('/brand'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body(new common_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, createBrand_dto_1.CreateBrandDto]),
    __metadata("design:returntype", Promise)
], ProductAdminController.prototype, "brandCreate", null);
__decorate([
    common_1.Get('getBrands'),
    __param(0, common_1.Req()), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], ProductAdminController.prototype, "getBrands", null);
__decorate([
    common_1.Get('/brand/:id'),
    __param(0, common_1.Param('id')), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductAdminController.prototype, "getBrand", null);
__decorate([
    common_1.Put('/brand/:id'),
    __param(0, common_1.Param('id')), __param(1, common_1.Request()), __param(2, common_1.Response()), __param(3, common_1.Body(new common_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object, UpdateBrand_dto_1.UpdateBrandDto]),
    __metadata("design:returntype", Promise)
], ProductAdminController.prototype, "brandUpdate", null);
ProductAdminController = __decorate([
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    common_1.Controller('master'),
    __metadata("design:paramtypes", [product_admin_service_1.ProductAdminService])
], ProductAdminController);
exports.ProductAdminController = ProductAdminController;
//# sourceMappingURL=product.admin.controller.js.map