import { ProductService } from '../service/product.service';
import { AddProductDto } from '../dto/addProduct.dto';
import { UpdateProductDto } from '../dto/updateProduct.dto';
import { Product } from '../models/Product.entity';
export declare class ProductController {
    private productService;
    private readonly sequelizeInstance;
    private readonly productRepository;
    private productServiceOutBound;
    constructor(productService: ProductService, sequelizeInstance: any, productRepository: typeof Product);
    _validateProductModule(user: any): Promise<void>;
    productLimit(req: any, res: any): Promise<void>;
    saveProduct(ratingId: any, addProductDto: AddProductDto, req: any, res: any): Promise<void>;
    updateProduct(sku: any, addProductDto: UpdateProductDto, req: any, res: any): Promise<void>;
    saveProductMediaLib(medialab: any, req: any, res: any): Promise<void>;
    deleteProductMediaLib(medialab: any, res: any): Promise<void>;
    getBrochurMedialib(channelId: any, req: any, res: any): Promise<void>;
    getSuggestedProduct(viewId: number, req: any, res: any, data: any): Promise<void>;
    getProductAggregation(viewId: number, req: any, res: any, data: any): Promise<void>;
    brandFilter(req: any, res: any, data: any): Promise<any>;
    familyFilter(req: any, res: any, data: any): Promise<any>;
    categoryFilter(req: any, res: any, data: any): Promise<any>;
    locationFilter(req: any, res: any, data: any): Promise<any>;
    priceFilter(req: any, res: any, data: any): Promise<any>;
    profileFilter(req: any, res: any, data: any): Promise<any>;
    searchFilter(req: any, res: any, data: any): Promise<any>;
    getProductSearch(viewId: number, req: any, res: any): Promise<void>;
    getProduct(sku: any, req: any, res: any): Promise<any>;
    getAdminProduct(sku: any, channelId: any, req: any, res: any): Promise<any>;
    getUser(channelId: any): Promise<any>;
    getProductInfo(sku: any, req: any, res: any): Promise<void>;
    _validateProductView(productDetail: any, user: any): Promise<void>;
    index(sku: any, req: any, res: any): Promise<void>;
    channelProductFindAll(req: any, channelId: number, res: any, productFilters: any): Promise<void>;
    setProductPublicView(req: any, res: any, data: any): Promise<void>;
    setProductPublicFlags(req: any, res: any, data: any): Promise<void>;
    setProductOrder(req: any, res: any, data: any): Promise<void>;
    validateProductLimit(user: any): Promise<void>;
    myProduct(req: any, res: any, productFilters: any): Promise<void>;
    getPublicProductFlags(req: any, res: any, productId: any): Promise<void>;
    allProduct(req: any, res: any, productFilters: any): Promise<void>;
    myProductsAgg(req: any, res: any, isActive: number): Promise<void>;
    allProductsAgg(req: any, res: any, isActive: number): Promise<void>;
    productDelete(sku: any, req: any, res: any): Promise<void>;
    channelSimilarProduct(req: any, channelId: number, res: any): Promise<void>;
    getProductSearchList(req: any, res: any, data: any): Promise<void>;
}
