'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductController = void 0;
const common_1 = require("@nestjs/common");
const product_service_1 = require("../service/product.service");
const validation_pipe_1 = require("../../../middleware/pipe/validation.pipe");
const addProduct_dto_1 = require("../dto/addProduct.dto");
const passport_1 = require("@nestjs/passport");
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
const app_constant_1 = require("../../../config/app.constant");
const Upgrade_exception_1 = require("../../../middleware/exception/Upgrade.exception");
const esearch_1 = require("../../../config/esearch");
const ProductReject_entity_1 = require("../models/ProductReject.entity");
const productServiceOutBound_1 = require("../transformation/productServiceOutBound");
const sequelize_1 = require("sequelize");
const updateProduct_dto_1 = require("../dto/updateProduct.dto");
const Auth_exception_1 = require("../../../middleware/exception/Auth.exception");
var _ = require('lodash');
let fs = require('fs');
let path = require("path");
var http = require('http');
let ProductController = class ProductController {
    constructor(productService, sequelizeInstance, productRepository) {
        this.productService = productService;
        this.sequelizeInstance = sequelizeInstance;
        this.productRepository = productRepository;
        this.productServiceOutBound = new productServiceOutBound_1.ProductServiceOutBound();
    }
    async _validateProductModule(user) {
        if (+user.channel.channelTypeId != +app_constant_1.appconstant.CHANNEL_TYPE_VENDOR) {
            throw new Auth_exception_1.AuthException('Not allowed');
        }
    }
    async productLimit(req, res) {
        let user = req.user;
        let product = await this.productService.getProductLimit(user);
        if (product) {
            res.status(common_1.HttpStatus.OK).json(product.feature_value);
        }
    }
    async saveProduct(ratingId, addProductDto, req, res) {
        let user = req.user;
        console.log("User:", user);
        let product = await this.productService.addProduct(addProductDto, user, ratingId);
        res.status(common_1.HttpStatus.OK).json(product);
    }
    async updateProduct(sku, addProductDto, req, res) {
        let user = req.user;
        if (req.user.hasOwnProperty('adminUserId'))
            user = Object.assign(user, { userId: 1 });
        let product = await this.productService.updateProduct(addProductDto, user, sku);
        res.status(common_1.HttpStatus.OK).json(product);
    }
    async saveProductMediaLib(medialab, req, res) {
        let product = await this.productService.saveProductMediaLib(medialab, +medialab.user.channelId, medialab.type);
        res.status(common_1.HttpStatus.OK).json(product);
    }
    async deleteProductMediaLib(medialab, res) {
        let product = await this.productService.deleteProductMediaLib(medialab);
        res.status(common_1.HttpStatus.OK).json(product);
    }
    async getBrochurMedialib(channelId, req, res) {
        let userMedia = await this.productService.getBrochurMedialib(channelId);
        if (userMedia) {
            res.status(common_1.HttpStatus.OK).send(userMedia);
        }
    }
    async getSuggestedProduct(viewId, req, res, data) {
        let user = req.user;
        let contactId = user.contactId;
        let typeid = user.channelTypeId;
        let channelId = user.channelId;
        let profileTypeId = user.profileTypeId;
        let result = [];
        let innovation = [];
        let order = data.order;
        try {
            if (viewId == 22) {
                result = await this.sequelizeInstance.query('select "productId",(select "productSKU" from "tblProduct" as tp where tp."productId"=pj."productId") from "tblProductJCT" as pj where "productId" not in(select "productid" from "tblproductrejection" where "channelid"=:channelId) and "productId" in(select "productId" from "tblProduct" where "deletedat" is null and "isactive"=\'1\') and "requested_by"=:contactId order by "rank" asc ', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        contactId: contactId,
                        channelId: channelId
                    }
                }).then(x => {
                    return _.uniqBy(x, 'productId');
                });
            }
            else if (viewId == 21) {
                let product = 'select "productId","productSKU" from "tblProduct" where "deletedat" is null and "isactive"=\'1\' and "productId" not in(select "productid" from "tblproductrejection" where "channelid"=:channelId) and "productId" not in(select "productId" from "tblProductJCT" where "requested_by"=:contactId) ';
                result = await this.sequelizeInstance.query(product, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelId: channelId,
                        contactId: contactId
                    }
                }).then(x => {
                    return _.uniqBy(x, 'productId');
                });
            }
            else if (viewId == 31) {
                let product = 'select "productId","productSKU" from "tblProduct" where "deletedat" is null and "isactive"=\'1\' and "productId" not in(select "productid" from "tblproductrejection" where "channelid"=:channelId) ';
                result = await this.sequelizeInstance.query(product, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelId: channelId
                    }
                }).then(x => {
                    return _.uniqBy(x, 'productId');
                });
            }
        }
        catch (e) {
            console.log("error:", e);
        }
        let filter = data.filter;
        let filterid = [];
        let filterFlag = false;
        if (data.search) {
            let searchchannellist = await this.sequelizeInstance.query('select "productId" from "tblProduct" where "productId" = :id', {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    id: +data.search,
                }
            });
            let chl = searchchannellist.map(x => +x.productId);
            result = result.filter(ch => { return chl.includes(+ch.productId); });
        }
        if (filter.brand) {
            let brand = 'select array_agg("productId") as id from "tblProduct" where "brandId" in(:brand) and "productId" in(:productId) ';
            await this.sequelizeInstance.query(brand, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    productId: (filterid.length > 0) ? filterid : result.map(x => x.productId),
                    brand: filter.brand
                }
            }).then((result) => {
                if (result[0].id) {
                    filterid = [];
                    filterid.push(...result[0].id);
                }
                else
                    filterid = [];
            });
            filterFlag = true;
        }
        if (filter.family) {
            let family = 'select array_agg("productId") as id from "tblProduct" where "productGroupId" in(:family) and "productId" in(:productId) ';
            await this.sequelizeInstance.query(family, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    productId: (filterid.length > 0) ? filterid : result.map(x => x.productId),
                    family: filter.family
                }
            }).then((result) => {
                if (result[0].id) {
                    filterid = [];
                    filterid.push(...result[0].id);
                }
                else
                    filterid = [];
            });
            filterFlag = true;
        }
        if (filter.category) {
            let category = 'select array_agg("productId") as id from "tblProduct" where "productCategorieId" in(:category) and "productId" in(:productId) ';
            await this.sequelizeInstance.query(category, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    productId: (filterid.length > 0) ? filterid : result.map(x => x.productId),
                    category: filter.category
                }
            }).then((result) => {
                if (result[0].id) {
                    filterid = [];
                    filterid.push(...result[0].id);
                }
                else
                    filterid = [];
            });
            filterFlag = true;
        }
        if (filter.country) {
            let location = 'select array_agg(tp."productId") as id from "tblProduct" as tp inner join "tblproductlocation" as pc on pc."productId"=tp."productId" and pc."regionCountryJCTId" in '
                + '(select "regionCountryJCTId" from "tblRegionCountryJCT" where "countryId" in(select "countryId" from "tblCountry" where "countryId" in (:location))) where tp."productId" in(:productId) ';
            await this.sequelizeInstance.query(location, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    productId: (filterid.length > 0) ? filterid : result.map(x => x.productId),
                    location: filter.country
                }
            }).then((result) => {
                if (result[0].id) {
                    filterid = [];
                    filterid.push(...result[0].id);
                }
                else
                    filterid = [];
            });
            filterFlag = true;
        }
        if ((filter.toPrice != null && filter.toPrice < 1000) || (filter.fromPrice != null && filter.fromPrice > 1)) {
            console.log("filter.fromPrice:", filter.fromPrice);
            console.log("filter.toPrice:", filter.toPrice);
            let location = 'select array_agg("productId") as id from "tblproductpricedetail" where "retailerprice">=:fromPrice and "retailerprice"<=:toPrice and "productId" in(:productId)';
            await this.sequelizeInstance.query(location, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    fromPrice: filter.fromPrice,
                    toPrice: filter.toPrice,
                    productId: (filterid.length > 0) ? filterid : result.map(x => x.productId),
                }
            }).then((result) => {
                if (result[0].id) {
                    filterid = [];
                    filterid.push(...result[0].id);
                }
                else
                    filterid = [];
            });
            filterFlag = true;
        }
        if (filter.profile || filter.resellerprofile) {
            let ids = filter.profile ? filter.profile : filter.resellerprofile;
            let profile = 'select array_agg(tp."productId") as id from "tblProduct" as tp inner join "tblproductchannelcustomerprofile" as pc on pc."productId"=tp."productId" and pc."customerProfileId" in '
                + '(select "customerProfileId" from "tblChannelCustomerProfile" where "profileTypeId" in(select "profileTypeId" from "tblProfileType" where "profileTypeId" in (:profile))) where tp."productId" in(:productId) ';
            await this.sequelizeInstance.query(profile, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    productId: (filterid.length > 0) ? filterid : result.map(x => x.productId),
                    profile: (filter.profile && filter.resellerprofile) ? filter.profile.concat(filter.resellerprofile) : ids
                }
            }).then((result) => {
                if (result[0].id) {
                    filterid = [];
                    filterid.push(...result[0].id);
                }
                else
                    filterid = [];
            });
            filterFlag = true;
        }
        filterid = _.uniq(filterid);
        if (filterid.length > 0 || filterFlag == true)
            result = result.filter(ch => { return filterid.includes(+ch.productId); });
        let total = result.length;
        let master = result.map(x => x.productSKU);
        result = result.map(x => x.productId);
        if (viewId == 22 || viewId == 20) {
            result = result.slice(data.offset).slice(0, data.limit);
        }
        else if (viewId == 21 || viewId == 31) {
            let ordered = await this.productRepository.findAll({
                type: sequelize_1.QueryTypes.SELECT,
                attributes: ['productId'],
                where: {
                    productId: {
                        [sequelize_1.Op.in]: result
                    }
                },
                order: [['productId', 'asc']]
            }).then(res => { return res.map(x => x.productId); });
            result = ordered.slice(data.offset).slice(0, data.limit);
        }
        let product = await this.productService.getSuggestedProduct(result, data, user);
        if (viewId == 22)
            product = _.sortBy(product, (e) => {
                return +e.productJCT[0].rank;
            });
        else if (viewId == 20) {
            let rankp = product.filter(p => p.productJCT.length > 0);
            rankp = _.sortBy(rankp, (e) => {
                return +e.productJCT[0].rank;
            });
            let namep = product.filter(p => p.productJCT.length === 0);
            namep = _.sortBy(namep, (e) => {
                return e.product;
            });
            product = [];
            product.push(...rankp);
            product.push(...namep);
        }
        else
            product = _.sortBy(product, (e) => {
                return +e.productId;
            });
        if (product) {
            let result = { product: product, total: total, master: master };
            res.status(common_1.HttpStatus.OK).send(result);
        }
    }
    async getProductAggregation(viewId, req, res, data) {
        let user = req.user;
        let contactId = user.contactId;
        let typeid = user.channelTypeId;
        let channelId = user.channelId;
        let profileTypeId = user.profileTypeId;
        let result = [];
        let innovation = [];
        try {
            if (viewId == 22) {
                result = await this.sequelizeInstance.query('select "productId","partnerChannelId" as "channelId" from "tblProductJCT" where "productId" in(select "productId" from "tblProduct" where "deletedat" is null and "isactive"=\'1\') and "productId" not in(select "productid" from "tblproductrejection" where "channelid"=:channelId) and "requested_by"=:contactId order by "rank" asc ', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        contactId: contactId,
                        channelId: channelId
                    }
                }).then(x => {
                    return _.uniqBy(x, 'productId');
                });
            }
            else if (viewId == 21) {
                let product = 'select "productId","channelId" from "tblProduct" where "deletedat" is null and "isactive"=\'1\' and "productId" not in(select "productid" from "tblproductrejection" where "channelid"=:channelId) and "productId" not in(select "productId" from "tblProductJCT" where "requested_by"=:contactId)';
                result = await this.sequelizeInstance.query(product, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelId: channelId,
                        contactId: contactId
                    }
                }).then(x => {
                    return _.uniqBy(x, 'productId');
                });
            }
            else if (viewId == 31) {
                let product = 'select "productId","channelId" from "tblProduct" where "deletedat" is null and "isactive"=\'1\' and "productId" not in(select "productid" from "tblproductrejection" where "channelid"=:channelId) ';
                result = await this.sequelizeInstance.query(product, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelId: channelId
                    }
                }).then(x => {
                    return _.uniqBy(x, 'productId');
                });
            }
        }
        catch (e) {
            console.log("error:", e);
        }
        let filter = data.filter;
        let filterid = [];
        let plist = result.map(x => +x.productId);
        if (filter.brand) {
            let brand = 'select array_agg("productId") as id from "tblProduct" where "brandId" in(:brand) and "productId" in(:productId) ';
            await this.sequelizeInstance.query(brand, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    productId: plist,
                    brand: filter.brand
                }
            }).then((result) => {
                if (result[0].id) {
                    filterid = [];
                    filterid.push(...result[0].id);
                }
                else
                    filterid = [];
            });
            result = result.filter(ch => { return filterid.includes(ch.productId); });
        }
        if (filter.family) {
            let family = 'select array_agg("productId") as id from "tblProduct" where "productGroupId" in(:family) and "productId" in(:productId) ';
            await this.sequelizeInstance.query(family, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    productId: plist,
                    family: filter.family
                }
            }).then((result) => {
                if (result[0].id) {
                    filterid = [];
                    filterid.push(...result[0].id);
                }
                else
                    filterid = [];
            });
            result = result.filter(ch => { return filterid.includes(ch.productId); });
        }
        if (filter.category) {
            let category = 'select array_agg("productId") as id from "tblProduct" where "productCategorieId" in(:category) and "productId" in(:productId) ';
            await this.sequelizeInstance.query(category, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    productId: plist,
                    category: filter.category
                }
            }).then((result) => {
                if (result[0].id) {
                    filterid = [];
                    filterid.push(...result[0].id);
                }
                else
                    filterid = [];
            });
            result = result.filter(ch => { return filterid.includes(ch.productId); });
        }
        if (filter.country) {
            let location = 'select array_agg(tp."productId") as id from "tblProduct" as tp inner join "tblproductlocation" as pc on pc."productId"=tp."productId" and pc."regionCountryJCTId" in '
                + '(select "regionCountryJCTId" from "tblRegionCountryJCT" where "countryId" in(select "countryId" from "tblCountry" where "countryId" in (:location))) where tp."productId" in(:productId) ';
            await this.sequelizeInstance.query(location, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    productId: plist,
                    location: filter.country
                }
            }).then((result) => {
                if (result[0].id) {
                    filterid = [];
                    filterid.push(...result[0].id);
                }
                else
                    filterid = [];
            });
            result = result.filter(ch => { return filterid.includes(ch.productId); });
        }
        if ((filter.toPrice != null && filter.toPrice < 1000) || (filter.fromPrice != null && filter.fromPrice > 1)) {
            let location = 'select array_agg("productId") as id from "tblproductpricedetail" where "retailerprice">=:fromPrice and "retailerprice"<=:toPrice and "productId" in(:productId)';
            await this.sequelizeInstance.query(location, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    fromPrice: filter.fromPrice,
                    toPrice: filter.toPrice,
                    productId: plist,
                }
            }).then((result) => {
                if (result[0].id) {
                    filterid = [];
                    filterid.push(...result[0].id);
                }
                else
                    filterid = [];
            });
            result = result.filter(ch => { return filterid.includes(ch.productId); });
        }
        if (filter.profile || filter.resellerprofile) {
            let ids = filter.profile ? filter.profile : filter.resellerprofile;
            let profile = 'select array_agg(tp."productId") as id from "tblProduct" as tp inner join "tblproductchannelcustomerprofile" as pc on pc."productId"=tp."productId" and pc."customerProfileId" in '
                + '(select "customerProfileId" from "tblChannelCustomerProfile" where "profileTypeId" in(select "profileTypeId" from "tblProfileType" where "profileTypeId" in (:profile))) where tp."productId" in(:productId) ';
            await this.sequelizeInstance.query(profile, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    productId: plist,
                    profile: (filter.profile && filter.resellerprofile) ? filter.profile.concat(filter.resellerprofile) : ids
                }
            }).then((result) => {
                if (result[0].id) {
                    filterid = [];
                    filterid.push(...result[0].id);
                }
                else
                    filterid = [];
            });
            result = result.filter(ch => { return filterid.includes(ch.productId); });
        }
        res.status(common_1.HttpStatus.OK).send(result);
    }
    async brandFilter(req, res, data) {
        let result = await this.productService.getBrandFilter(data.productIds);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async familyFilter(req, res, data) {
        let result = await this.productService.getFamilyFilter(data.productIds);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async categoryFilter(req, res, data) {
        let result = await this.productService.getCategoryFilter(data.productIds);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async locationFilter(req, res, data) {
        let result = await this.productService.getLocationFilter(data.productIds);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async priceFilter(req, res, data) {
        let result = await this.productService.getPriceFilter(data.productIds);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async profileFilter(req, res, data) {
        let result = await this.productService.getProfileFilter(data.channelIds);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async searchFilter(req, res, data) {
        let result = await this.productService.getSearchFilter(data.data);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async getProductSearch(viewId, req, res) {
        let user = req.user;
        let contactId = user.contactId;
        let typeid = user.channelTypeId;
        let channelId = user.channelId;
        let profileTypeId = user.profileTypeId;
        let data = [];
        let result = [];
        let innovation = [];
        if (data.length == 0) {
            let query;
            if (typeid == 3) {
                if (viewId == 20) {
                    query = 'select tp."productId" from "tblChannelCustomerProfile" as tcp inner join "tblProduct" as tp on tp."deletedat" is null and  tp."channelId"=tcp."channelId" and tp."isSuggestion"=\'1\' '
                        + ' and tp."isInovation" = \'1\' and tp."productId" in(select "productId" from "tblproductsharepreference" where "sharetypeid"=2 and "deletedat" is null) '
                        + 'and tp."productCategorieId" in(select "productCategorieId" from "tblContactInterestedProductCategory" where "contactId"=' + contactId + ' '
                        + 'and "deletedAt" is null union select "productCategorieId" from "tblContactProductCategorie" where "contactId"=' + contactId + 'and "deletedAt" is null) '
                        + 'and tp."productId" in (select "productId" from "tblproductlocation" where "locationtype"=\'TARGET\' and "deletedat" is null '
                        + 'and "regionCountryJCTId" in (select "regionCountryJCTId" from "tblContactLocation" where "contactId"=' + contactId + ' and "deletedAt" is null '
                        + 'and CAST("locationType" AS text)=\'SELLING\')) '
                        + 'and tcp."channelId" in(select "channelId" from "tblChannel" where "channelTypeId"=2 '
                        + 'and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" where "startup"=\'0\' and "deletedAt" is null) union '
                        + 'select "channelId" from "tblChannel" where "channelTypeId"=2 and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" '
                        + 'where "deletedAt" is null and "startup"=(select "startup" from "tblChannelDetail" where "channelId"=' + channelId + '))) '
                        + 'and tcp."profileTypeId" in(select "profileTypeId" from "tblChannelCustomerProfile" where "deletedAt" is null and "channelId"=' + channelId + ') where tcp."deletedAt" is null order by tp."updatedat" desc';
                }
                else if (viewId == 22) {
                    query = 'select tp."productId" from "tblChannelCustomerProfile" as tcp inner join "tblProduct" as tp on tp."deletedat" is null and  tp."channelId"=tcp."channelId" and tp."isSuggestion"=\'1\' '
                        + 'and tp."productId" in(select "productId" from "tblproductsharepreference" where "sharetypeid"=2 and "deletedat" is null) '
                        + 'and tp."productCategorieId" in(select "productCategorieId" from "tblContactInterestedProductCategory" where "contactId"=' + contactId + ' '
                        + 'and "deletedAt" is null union select "productCategorieId" from "tblContactProductCategorie" where "contactId"=' + contactId + 'and "deletedAt" is null) '
                        + 'and tp."productId" in (select "productId" from "tblproductlocation" where "locationtype"=\'TARGET\' and "deletedat" is null '
                        + 'and "regionCountryJCTId" in (select "regionCountryJCTId" from "tblContactLocation" where "contactId"=' + contactId + ' and "deletedAt" is null '
                        + 'and CAST("locationType" AS text)=\'SELLING\')) '
                        + 'and tcp."channelId" in(select "channelId" from "tblChannel" where "channelTypeId"=2 '
                        + 'and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" where "startup"=\'0\' and "deletedAt" is null) union '
                        + 'select "channelId" from "tblChannel" where "channelTypeId"=2 and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" '
                        + 'where "deletedAt" is null and "startup"=(select "startup" from "tblChannelDetail" where "channelId"=' + channelId + '))) '
                        + 'and tcp."profileTypeId" in(select "profileTypeId" from "tblChannelCustomerProfile" where "deletedAt" is null and "channelId"=' + channelId + ') where tcp."deletedAt" is null order by tp."updatedat" desc';
                }
            }
            else if (typeid == 4) {
                if (viewId == 20) {
                    query = 'select tp."productId" from "tblChannelCustomerProfile" as tcp inner join "tblProduct" as tp on tp."deletedat" is null and  tp."channelId"=tcp."channelId" and tp."isSuggestion"=\'1\' '
                        + 'and tp."isInovation" = \'1\' and tp."productId" in(select "productId" from "tblproductsharepreference" where "sharetypeid"=2 and "deletedat" is null) '
                        + 'and tp."productCategorieId" in(select "productCategorieId" from "tblContactInterestedProductCategory" where "contactId"=' + contactId + ' '
                        + 'and "deletedAt" is null union select "productCategorieId" from "tblContactProductCategorie" where "contactId"=' + contactId + 'and "deletedAt" is null) '
                        + 'and tp."productId" in (select "productId" from "tblproductlocation" where "locationtype"=\'TARGET\' and "deletedat" is null '
                        + 'and "regionCountryJCTId" in (select "regionCountryJCTId" from "tblContactLocation" where "contactId"=' + contactId + ' and "deletedAt" is null '
                        + 'and CAST("locationType" AS text)=\'RETAIL\')) '
                        + 'and tcp."channelId" in(select "channelId" from "tblChannel" where "channelTypeId"=2 '
                        + 'and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" where "startup"=\'0\' and "deletedAt" is null) union '
                        + 'select "channelId" from "tblChannel" where "channelTypeId"=2 and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" '
                        + 'where "deletedAt" is null and "startup"=(select "startup" from "tblChannelDetail" where "channelId"=' + channelId + '))) '
                        + 'and tcp."profileTypeId"=' + profileTypeId + 'where tcp."deletedAt" is null order by tp."updatedat" desc';
                }
                else if (viewId == 22) {
                    query = 'select tp."productId" from "tblChannelCustomerProfile" as tcp inner join "tblProduct" as tp on tp."deletedat" is null and  tp."channelId"=tcp."channelId" and tp."isSuggestion"=\'1\' '
                        + 'and tp."productId" in(select "productId" from "tblproductsharepreference" where "sharetypeid"=2 and "deletedat" is null) '
                        + 'and tp."productCategorieId" in(select "productCategorieId" from "tblContactInterestedProductCategory" where "contactId"=' + contactId + ' '
                        + 'and "deletedAt" is null union select "productCategorieId" from "tblContactProductCategorie" where "contactId"=' + contactId + 'and "deletedAt" is null) '
                        + 'and tp."productId" in (select "productId" from "tblproductlocation" where "locationtype"=\'TARGET\' and "deletedat" is null '
                        + 'and "regionCountryJCTId" in (select "regionCountryJCTId" from "tblContactLocation" where "contactId"=' + contactId + ' and "deletedAt" is null '
                        + 'and CAST("locationType" AS text)=\'RETAIL\')) '
                        + 'and tcp."channelId" in(select "channelId" from "tblChannel" where "channelTypeId"=2 '
                        + 'and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" where "startup"=\'0\' and "deletedAt" is null) union '
                        + 'select "channelId" from "tblChannel" where "channelTypeId"=2 and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" '
                        + 'where "deletedAt" is null and "startup"=(select "startup" from "tblChannelDetail" where "channelId"=' + channelId + '))) '
                        + 'and tcp."profileTypeId"=' + profileTypeId + 'where tcp."deletedAt" is null order by tp."updatedat" desc';
                }
            }
            try {
                if (viewId == 22) {
                    result = await this.sequelizeInstance.query('select "productId" from "tblProductJCT" as pj where "productId" not in(select "productid" from "tblproductrejection" where "channelid"=:channelId) and "productId" in(select "productId" from "tblProduct" where "deletedat" is null and "isactive"=\'1\') and "requested_by"=:contactId order by "rank" asc ', {
                        type: sequelize_1.QueryTypes.SELECT,
                        raw: true,
                        replacements: {
                            contactId: contactId,
                            channelId: channelId
                        }
                    }).then(x => {
                        return x.map(p => +p.productId);
                    });
                }
                else if (viewId == 20) {
                    let product = 'select "productId" from "tblProduct" where "deletedat" is null and "isInovation"=\'1\' and "isactive"=\'1\' ';
                    innovation = await this.sequelizeInstance.query(product, {
                        type: sequelize_1.QueryTypes.SELECT,
                        raw: true,
                    }).then(x => {
                        return x.map(p => +p.productId);
                    });
                    result.push(...innovation);
                }
                else if (viewId == 21 || viewId == 31) {
                    let product = 'select "productId" from "tblProduct" where "deletedat" is null and "isactive"=\'1\' and "productId" not in(select "productid" from "tblproductrejection" where "channelid"=:channelId) and "productId" not in(select "productId" from "tblProductJCT" where "requested_by"=:contactId) ';
                    result = await this.sequelizeInstance.query(product, {
                        type: sequelize_1.QueryTypes.SELECT,
                        raw: true,
                        replacements: {
                            channelId: channelId,
                            contactId: contactId
                        }
                    }).then(x => {
                        return x.map(p => +p.productId);
                    });
                }
            }
            catch (e) {
                console.log("error:", e);
            }
        }
        let product = await this.productService.getProductSearch(result);
        if (product) {
            res.status(common_1.HttpStatus.OK).send(product);
        }
    }
    async getProduct(sku, req, res) {
        let user = req.user;
        let productDetail = await this.productService.getProductBySKU(sku);
        await this._validateProductView(productDetail, user);
        return res.status(common_1.HttpStatus.OK).json(await this.productServiceOutBound.productCustomerProfile(await this.productService.getProduct(sku, user), user));
    }
    async getAdminProduct(sku, channelId, req, res) {
        let user = await this.getUser(channelId);
        let productDetail = await this.productService.getProductBySKU(sku);
        await this._validateProductView(productDetail, user);
        return res.status(common_1.HttpStatus.OK).json(await this.productServiceOutBound.productCustomerProfile(await this.productService.getProduct(sku, user), user));
    }
    async getUser(channelId) {
        let query = 'select "firstName","lastName",tc."email",tc."channelId",tc."contactId",tch."planId",tch."subscriptionId",tch."channelTypeId",tu."userId", '
            + 'case when tch."isOEM"=\'1\' then \'B2C\' when tch."isOEM"=\'2\' then \'B2B\' when tch."isOEM"=\'3\' then \'Both\' end, '
            + '(select "documentPath" from "tblDocument" where "documentId"=tc."documentId"), '
            + '(select "roleId" from "tblUserRole" where "userId"=tu."userId") '
            + 'from "tblContact" as tc inner join "tblChannel" as tch on tch."channelId"=tc."channelId" inner join "tblUser" as tu on tu."contactId"=tc."contactId"  where "isDefaultContact"=\'1\' and tc."channelId"=:channelId ';
        let user = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: channelId
            }
        }).then(result => {
            return result[0];
        }).catch(err => {
            console.log("getUserErr:", err);
        });
        return user;
    }
    async getProductInfo(sku, req, res) {
        let user = req.user;
        let productDetail = await this.productService.getProductBySKU(sku);
        await this._validateProductView(productDetail, user);
        let productData = await this.productService.getProductInfo(sku, user);
        res.status(common_1.HttpStatus.OK).send(productData);
    }
    async _validateProductView(productDetail, user) {
        if (+user.channelTypeId != +app_constant_1.appconstant.CHANNEL_TYPE_HUB && +productDetail.channelId != +user.channelId) {
            if (productDetail.isactive != '1') {
                console.log("not active");
                throw new common_1.NotFoundException('NotFound');
            }
            await ProductReject_entity_1.ProductReject.count({
                where: {
                    productid: +productDetail.productId,
                    channelid: +user.channelId
                }
            }).then((result) => {
                if (result != 0) {
                    console.log("productrejected");
                    throw new Process_exception_1.ProcessException('product:reject:rejectedProduct');
                }
            });
        }
    }
    async index(sku, req, res) {
        let user = req.user;
        let result = await this.productService.productActions(user, sku);
        res.status(common_1.HttpStatus.OK).send(result);
    }
    async channelProductFindAll(req, channelId, res, productFilters) {
        let user = req.user;
        if (user.hasOwnProperty('adminUserId')) {
            user = {
                channelTypeId: 1,
                channelId: 1,
                contactId: 1,
                userId: 1
            };
        }
        let type = +user.channelTypeId;
        let query = 'select tp."brandId",tp."productId",tp."product", tp."productSKU", tp."productqualitylevel", pr."businesscurrencyid",pr."retailerprice", br."brandName",(select concat( \'' + process.env.CDN_URL + '\',"documentPath") as "brandDocumentUrl" from "tblDocument" where "documentId" = br."documentId"),(select concat( \'' + process.env.CDN_URL + '\',"documentPath") as "documentUrl" from "tblDocument" where "documentId" in(select "imageid" from "tblproductimage" where "productimageid"=tp."defaultimageid"))from "tblProduct" as tp inner join "tblBrand" as br on br."id"=tp."brandId" inner join "tblproductpricedetail" as pr on pr."productId"=tp."productId" where "channelId"= :channelId and tp."deletedat" is null and "isactive"=\'1\'';
        query += ' and tp."productId" not in(select "productid" as "productId" from "tblproductrejection" where channelid = ' + user.channelId + ')';
        if (productFilters.excludedProductSku)
            query += ' and tp."productSKU" !=:excludedProductSku';
        if (type != 2)
            query += ' and tp."productId" in(select "productId" from "tblproductsharepreference" where sharetypeid = :sharedId and "productId" = tp."productId" and "deletedat" IS NULL)';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: channelId,
                excludedProductSku: productFilters.excludedProductSku ? productFilters.excludedProductSku : null,
                sharedId: type == 2 ? 1 : type == 3 ? 2 : type == 4 ? 3 : 4
            }
        });
        res.status(common_1.HttpStatus.OK).send(result);
    }
    async setProductPublicView(req, res, data) {
        let result = await this.productService.setProductPublicView(data);
        res.status(common_1.HttpStatus.OK).send(result);
    }
    async setProductPublicFlags(req, res, data) {
        let result = await this.productService.setProductPublicFlags(data);
        res.status(common_1.HttpStatus.OK).send(result);
    }
    async setProductOrder(req, res, data) {
        let result = await this.productService.setProductOrder(data);
        res.status(common_1.HttpStatus.OK).send(result);
    }
    async validateProductLimit(user) {
        let query = 'select count(*) as "activeProducts" from "tblProduct" as tp  where tp."channelId"= :channelId and tp."deletedat" is null and "isactive"=:isactive ';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: user.channelId,
                isactive: '1'
            }
        });
        let allowedProductCount = +(user.channel.channelSubscription.keyFeature[app_constant_1.appconstant.SubscriptionCharcteristicFeature['NO_OF_PRODUCT']]);
        let activeProducts = +(result[0].activeProducts);
        if (activeProducts > allowedProductCount) {
            let updQuery = 'update "tblProduct" set "isactive"=:inActive where "productId" in (select "productId" from "tblProduct" as tp  where tp."channelId"= :channelId and tp."deletedat" is null and "isactive"=:isactive) ';
            await this.sequelizeInstance.query(updQuery, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelId: user.channelId,
                    isactive: '1',
                    inActive: '0',
                }
            });
            let updAllowedProduct = 'update "tblProduct" set "isactive"=:isactive where "productId" IN (select "productId" from "tblProduct" where "channelId"= :channelId and "deletedat" is null and "isactive"=:inactive  order by "updatedat" desc limit  :limit )';
            await this.sequelizeInstance.query(updAllowedProduct, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelId: user.channelId,
                    isactive: '1',
                    inactive: '0',
                    limit: allowedProductCount
                }
            });
        }
    }
    async myProduct(req, res, productFilters) {
        console.log('productFilters', productFilters);
        let user = req.user;
        this.validateProductLimit(user);
        let order = productFilters.order ? productFilters.order : 'asc';
        let limit = ' LIMIT ' + productFilters.limit;
        let offset = ' OFFSET ' + productFilters.offset;
        let query = 'select count(*) OVER() AS total,tp."product_rank_order",tp."isPublic",tp."productId",(select "brandName" from "tblBrand" where "id"=tp."brandId"), tp."product",tp."productSKU", tp."isactive", tp."productqualitylevel", pr."businesscurrencyid",pr."retailerprice",(select concat( \'' + process.env.CDN_URL + '\',"documentPath") as "documentUrl" from "tblDocument" where "documentId" in(select "imageid" from "tblproductimage" where "productimageid"=tp."defaultimageid"))from "tblProduct" as tp inner join "tblproductpricedetail" as pr on pr."productId"=tp."productId" where "channelId"= :channelId and tp."deletedat" is null and "isactive"=:isactive ';
        if (productFilters.search)
            query += ' and tp."productId"=' + +productFilters.search;
        if (productFilters.filter.brand)
            query += ' and tp."brandId" in(' + productFilters.filter.brand + ')';
        if (productFilters.filter.family)
            query += ' and tp."productGroupId" in(' + productFilters.filter.family + ')';
        if (productFilters.filter.category)
            query += ' and tp."productCategorieId" in(' + productFilters.filter.category + ')';
        if (productFilters.filter.position)
            query += ' and tp."productqualitylevel" =:quality';
        query += ' order by tp."product_rank_order" ' + order + limit + offset;
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: user.channelId,
                isactive: productFilters.isactive.toString(),
                quality: productFilters.filter.position
            }
        });
        let master = result.map(x => x.productSKU);
        let active = await this.sequelizeInstance.query('select count(*) from "tblProduct" where "channelId"=:channelId and "deletedat" is null and "isactive"=:isactive', {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: user.channelId,
                isactive: '1'
            }
        });
        let inActive = await this.sequelizeInstance.query('select count(*) from "tblProduct" where "channelId"=:channelId and "deletedat" is null and "isactive"=:isactive', {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: user.channelId,
                isactive: '0'
            }
        });
        let tabCount = {
            active: active ? active[0].count : 0,
            inActive: active ? inActive[0].count : 0
        };
        let results;
        if (result.length != 0) {
            results = {
                total: result[0].total,
                result: result,
                tabCount: tabCount,
                master: master
            };
        }
        else {
            results = {
                total: 0,
                result: [],
                master: [],
                tabCount: tabCount
            };
        }
        res.status(common_1.HttpStatus.OK).send(results);
    }
    async getPublicProductFlags(req, res, productId) {
        let query = 'select "productId", "channelId", "isFeatured", "eco_friendly", "work_from_home", "life_style", "french_tech", "taiwan_excellence", "show_in_home_page", "isPublic" from "tblProduct" where "productId" = :productId';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                productId: productId,
            }
        }).then(res => res[0]);
        res.status(common_1.HttpStatus.OK).send(result);
    }
    async allProduct(req, res, productFilters) {
        console.log('productFilters', productFilters);
        let order = productFilters.order ? productFilters.order : 'asc';
        let limit = ' LIMIT ' + productFilters.limit;
        let offset = ' OFFSET ' + productFilters.offset;
        console.log('productFilters', productFilters);
        let query = 'select (select array_to_json(array_agg(row_to_json(x))) from (select count(*) OVER() AS total, tp."product_rank_order",tp."productId",tp."isPublic",(select "companyName" from "tblChannel" where "channelId"=tp."channelId"),tp."channelId",(select "brandName" from "tblBrand" where "id"=tp."brandId"), tp."product",tp."productSKU", tp."isactive", tp."productqualitylevel", pr."businesscurrencyid",pr."retailerprice",(select concat( \'' + process.env.CDN_URL + '\',"documentPath") as "documentUrl" from "tblDocument" where "documentId" in(select "imageid" from "tblproductimage" where "productimageid"=tp."defaultimageid"))from "tblProduct" as tp inner join "tblproductpricedetail" as pr on pr."productId"=tp."productId" and pr."deletedat" is null where tp."deletedat" is null and "isactive"=:isactive ';
        if (productFilters.search)
            query += ' and tp."productId"=' + +productFilters.search;
        if (productFilters.filter.brand)
            query += ' and tp."brandId" in(' + productFilters.filter.brand + ')';
        if (productFilters.filter.family)
            query += ' and tp."productGroupId" in(' + productFilters.filter.family + ')';
        if (productFilters.filter.category)
            query += ' and tp."productCategorieId" in(' + productFilters.filter.category + ')';
        if (productFilters.filter.position)
            query += ' and tp."productqualitylevel" =:quality';
        if (productFilters.filter.tags) {
            if (productFilters.filter.tags.includes(1))
                query += ' and tp."show_in_home_page"=\'1\' ';
            if (productFilters.filter.tags.includes(2))
                query += ' and tp."isFeatured"=\'1\' ';
        }
        if (productFilters.filter.hot_topic) {
            if (productFilters.filter.hot_topic.includes(1))
                query += ' and tp."eco_friendly"=\'1\' ';
            if (productFilters.filter.hot_topic.includes(2))
                query += ' and tp."work_from_home"=\'1\' ';
            if (productFilters.filter.hot_topic.includes(3))
                query += ' and tp."life_style"=\'1\' ';
            if (productFilters.filter.hot_topic.includes(4))
                query += ' and tp."french_tech"=\'1\' ';
            if (productFilters.filter.hot_topic.includes(5))
                query += ' and tp."taiwan_excellence"=\'1\' ';
        }
        query += ' order by tp."product_rank_order" ' + order + ')x) as product';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                isactive: (productFilters === null || productFilters === void 0 ? void 0 : productFilters.isactive) ? productFilters === null || productFilters === void 0 ? void 0 : productFilters.isactive : '1',
            }
        });
        let active = await this.sequelizeInstance.query('select count(*) from "tblProduct" where "deletedat" is null and "isactive"=:isactive', {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                isactive: '1'
            }
        });
        let inActive = await this.sequelizeInstance.query('select count(*) from "tblProduct" where "deletedat" is null and "isactive"=:isactive', {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                isactive: '0'
            }
        });
        let tabCount = {
            active: active ? active[0].count : 0,
            inActive: active ? inActive[0].count : 0
        };
        let results;
        if (result.length != 0) {
            results = {
                total: result[0].total,
                result: result[0].product,
                tabCount: tabCount
            };
        }
        else {
            results = {
                total: 0,
                result: [],
                tabCount: tabCount
            };
        }
        res.status(common_1.HttpStatus.OK).send(results);
    }
    async myProductsAgg(req, res, isActive) {
        let user = req.user;
        let result = await this.sequelizeInstance.query('select "productId" from "tblProduct" where "channelId"=:channelId and "deletedat" is null and "isactive"=:isactive', {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: user.channelId,
                isactive: isActive.toString()
            }
        }).then(x => {
            return x.map(p => +p.productId);
        });
        console.log('result', result);
        let product = await this.productService.getProductAggr(result);
        if (product) {
            res.status(common_1.HttpStatus.OK).send(product);
        }
    }
    async allProductsAgg(req, res, isActive) {
        let result = await this.sequelizeInstance.query('select "productId" from "tblProduct" where  "deletedat" is null and "isactive"=:isactive', {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                isactive: isActive.toString()
            }
        }).then(x => {
            return x.map(p => +p.productId);
        });
        let product = await this.productService.getProductAggr(result);
        if (product) {
            res.status(common_1.HttpStatus.OK).send(product);
        }
    }
    async productDelete(sku, req, res) {
        let user = req.user;
        if (user.isAdmin == false)
            await this._validateProductModule(user);
        let productData = await this.productService.productDelete(sku, user);
        res.status(common_1.HttpStatus.OK).json(productData);
    }
    async channelSimilarProduct(req, channelId, res) {
        let user = req.user;
        let type = +user.channelTypeId;
        let products = [];
        if (type === 2) {
            throw new Auth_exception_1.AuthException('Not allowed');
        }
        let query = 'select tp."brandId" from "tblProduct" as tp where "channelId"= :channelId and tp."deletedat" is null and "isactive"=\'1\'';
        query += ' and tp."productId" not in(select "productid" as "productId" from "tblproductrejection" where channelid = ' + user.channelId + ')';
        query += ' and tp."productId" in(select "productId" from "tblproductsharepreference" where sharetypeid = :sharedId and "productId" = tp."productId" and "deletedat" IS NULL)';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: channelId,
                sharedId: type == 2 ? 1 : type == 3 ? 2 : type == 4 ? 3 : 4
            }
        });
        if (result.length > 0) {
            let brandIds = result.map(x => +x.brandId);
            console.log('brandIds', brandIds);
            let query = 'select tp."brandId",tp."productId",tp."product", tp."productSKU", tp."productqualitylevel", pr."businesscurrencyid",pr."retailerprice", br."brandName",(select concat( \'' + process.env.CDN_URL + '\',"documentPath") as "brandDocumentUrl" from "tblDocument" where "documentId" = br."documentId"),(select concat( \'' + process.env.CDN_URL + '\',"documentPath") as "documentUrl" from "tblDocument" where "documentId" in(select "imageid" from "tblproductimage" where "productimageid"=tp."defaultimageid"))from "tblProduct" as tp inner join "tblBrand" as br on br."id"=tp."brandId" inner join "tblproductpricedetail" as pr on pr."productId"=tp."productId" where "channelId"!= :channelId and "brandId" in(:brandIds) and tp."deletedat" is null and "isactive"=\'1\'';
            query += ' and tp."productId" not in(select "productid" as "productId" from "tblproductrejection" where channelid = ' + user.channelId + ')';
            query += ' and tp."productId" in(select "productId" from "tblproductsharepreference" where sharetypeid = :sharedId and "productId" = tp."productId" and "deletedat" IS NULL)';
            products = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelId: channelId,
                    sharedId: type == 2 ? 1 : type == 3 ? 2 : type == 4 ? 3 : 4,
                    brandIds: brandIds
                }
            });
        }
        res.status(common_1.HttpStatus.OK).send(products);
    }
    async getProductSearchList(req, res, data) {
        console.log('data', data);
        let result = await this.productService.getProductSearchList(data.search);
        res.status(common_1.HttpStatus.OK).json(result);
    }
};
__decorate([
    common_1.Get('getProductLimitForDialog'),
    __param(0, common_1.Request()), __param(1, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "productLimit", null);
__decorate([
    common_1.Post('Product/:ratingId'),
    __param(0, common_1.Param('ratingId')), __param(1, common_1.Body(new validation_pipe_1.ValidationPipe())), __param(2, common_1.Request()), __param(3, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, addProduct_dto_1.AddProductDto, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "saveProduct", null);
__decorate([
    common_1.Post('updateProduct/:sku'),
    __param(0, common_1.Param('sku')), __param(1, common_1.Body(new validation_pipe_1.ValidationPipe())), __param(2, common_1.Request()), __param(3, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, updateProduct_dto_1.UpdateProductDto, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "updateProduct", null);
__decorate([
    common_1.Post('productmedialib'),
    __param(0, common_1.Body()), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "saveProductMediaLib", null);
__decorate([
    common_1.Post('deleteProductMediaLib'),
    __param(0, common_1.Body()), __param(1, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "deleteProductMediaLib", null);
__decorate([
    common_1.Get('getBrochurMedialib/:channelId'),
    __param(0, common_1.Param('channelId')), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "getBrochurMedialib", null);
__decorate([
    common_1.Post('suggestion/:viewId'),
    __param(0, common_1.Param('viewId', new common_1.ParseIntPipe())), __param(1, common_1.Request()), __param(2, common_1.Response()), __param(3, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "getSuggestedProduct", null);
__decorate([
    common_1.Post('productaggr/:viewId'),
    __param(0, common_1.Param('viewId', new common_1.ParseIntPipe())), __param(1, common_1.Request()), __param(2, common_1.Response()), __param(3, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "getProductAggregation", null);
__decorate([
    common_1.Post('brandFilter'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "brandFilter", null);
__decorate([
    common_1.Post('familyFilter'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "familyFilter", null);
__decorate([
    common_1.Post('categoryFilter'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "categoryFilter", null);
__decorate([
    common_1.Post('locationFilter'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "locationFilter", null);
__decorate([
    common_1.Post('priceFilter'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "priceFilter", null);
__decorate([
    common_1.Post('profileFilter'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "profileFilter", null);
__decorate([
    common_1.Post('searchFilter'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "searchFilter", null);
__decorate([
    common_1.Get('productSearch/:viewId'),
    __param(0, common_1.Param('viewId', new common_1.ParseIntPipe())), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Number, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "getProductSearch", null);
__decorate([
    common_1.Get(':sku'),
    __param(0, common_1.Param('sku')), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "getProduct", null);
__decorate([
    common_1.Get('getAdminProduct/:sku/:channelId'),
    __param(0, common_1.Param('sku')), __param(1, common_1.Param('channelId')), __param(2, common_1.Request()), __param(3, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "getAdminProduct", null);
__decorate([
    common_1.Get('info/:sku'),
    __param(0, common_1.Param('sku')), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "getProductInfo", null);
__decorate([
    common_1.Get('productActionInfo/:sku'),
    __param(0, common_1.Param('sku')), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "index", null);
__decorate([
    common_1.Post('channel-products/:channelId'),
    __param(0, common_1.Request()), __param(1, common_1.Param('channelId', new common_1.ParseIntPipe())), __param(2, common_1.Response()), __param(3, common_1.Body(new validation_pipe_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "channelProductFindAll", null);
__decorate([
    common_1.Put('setProductPublicView'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "setProductPublicView", null);
__decorate([
    common_1.Post('setProductPublicFlags'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "setProductPublicFlags", null);
__decorate([
    common_1.Put('setProductOrder'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "setProductOrder", null);
__decorate([
    common_1.Post('my-products'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body(new validation_pipe_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "myProduct", null);
__decorate([
    common_1.Get('getPublicProductFlags/:productId'),
    __param(0, common_1.Request()), __param(1, common_1.Res()), __param(2, common_1.Param('productId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "getPublicProductFlags", null);
__decorate([
    common_1.Post('all-products'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body(new validation_pipe_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "allProduct", null);
__decorate([
    common_1.Get('myProductsAgg/:isActive'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Param('isActive', new common_1.ParseIntPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Number]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "myProductsAgg", null);
__decorate([
    common_1.Get('allProductsAgg/:isActive'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Param('isActive', new common_1.ParseIntPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Number]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "allProductsAgg", null);
__decorate([
    common_1.Delete(':sku'),
    __param(0, common_1.Param('sku')), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "productDelete", null);
__decorate([
    common_1.Get('channel-similarproducts/:channelId'),
    __param(0, common_1.Request()), __param(1, common_1.Param('channelId', new common_1.ParseIntPipe())), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "channelSimilarProduct", null);
__decorate([
    common_1.Post('getProductSearchList'),
    __param(0, common_1.Req()), __param(1, common_1.Res()), __param(2, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductController.prototype, "getProductSearchList", null);
ProductController = __decorate([
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    common_1.Controller('Product'),
    __param(1, common_1.Inject('SequelizeInstance')),
    __param(2, common_1.Inject('ProductRepository')),
    __metadata("design:paramtypes", [product_service_1.ProductService, Object, Object])
], ProductController);
exports.ProductController = ProductController;
//# sourceMappingURL=product.controller.js.map