'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductImportController = void 0;
const common_1 = require("@nestjs/common");
const productImport_service_1 = require("../service/productImport.service");
const validation_pipe_1 = require("../../../middleware/pipe/validation.pipe");
const importProduct_dto_1 = require("../dto/importProduct.dto");
const importProductImage_dto_1 = require("../dto/importProductImage.dto");
const passport_1 = require("@nestjs/passport");
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
const app_constant_1 = require("../../../config/app.constant");
const Upgrade_exception_1 = require("../../../middleware/exception/Upgrade.exception");
const esearch_1 = require("../../../config/esearch");
const Auth_exception_1 = require("../../../middleware/exception/Auth.exception");
const platform_express_1 = require("@nestjs/platform-express");
const S3Lib_1 = require("../../../lib/S3Lib");
var _ = require('lodash');
let path = require("path");
var http = require('http');
let ProductImportController = class ProductImportController {
    constructor(sequelizeInstance, productImportService) {
        this.sequelizeInstance = sequelizeInstance;
        this.productImportService = productImportService;
        this.fs = require('fs');
    }
    async _validateProductModule(req) {
    }
    async productImageUpload(req, res, importProductImageDto) {
        let productImageUpload = await this.productImportService.productImageUpload(importProductImageDto);
        res.status(common_1.HttpStatus.OK).json(productImageUpload);
    }
    async productImportSample(req, res) {
        let user = req.user;
        let productImportSample = await this.productImportService.productImportSample(user);
        res.setHeader('sampleFileName', productImportSample.sampleFileName);
        res.status(common_1.HttpStatus.OK).json(productImportSample);
    }
    async productSampleDownload(fileName, req, res) {
        let user = req.user;
        var file = path.resolve(__dirname, '..', '..', '..', '..') + '/.tmp/upload_s3/' + fileName;
        res.setHeader('fileName', fileName);
        res.sendFile(file);
    }
    async productFileUpload(file, res) {
        console.log('file ccc', file);
        if (file) {
            res.status(common_1.HttpStatus.OK).json({ url: 'url' });
        }
        else {
            throw new Process_exception_1.ProcessException('Soming went wrong');
        }
        res.status(common_1.HttpStatus.OK).json('dirName');
    }
    async productImport(req, res, importProductDto) {
        let user = req.user;
        let s3 = new S3Lib_1.S3Lib();
        let fileName = req.body.fileName;
        let filePath = req.body.filePath;
        let imageFolder = req.body.newImageFolder;
        let fileExtenstion = path.extname(fileName);
        if (fileExtenstion != '.xlsx') {
            throw new Process_exception_1.ProcessException('product:productImport:invalidFileFormat');
        }
        if (!fileName || !filePath) {
            throw new Process_exception_1.ProcessException('product:productImport:fileName');
        }
        await s3.callforUnzip(req.body.newImageFolder);
        if (fileName) {
            let moveAction = await s3.downloadFromTempBucket(filePath, fileName);
            if (moveAction) {
                return req.body = new Promise(resolve => {
                    var localFilePath;
                    try {
                        localFilePath = path.resolve(__dirname, '..', '..', '..', '..') + '/.tmp/upload_s3/' + fileName;
                    }
                    catch (e) {
                        throw new Process_exception_1.ProcessException('media:not:moveable');
                    }
                    resolve(localFilePath);
                }).then(async (path) => {
                    let result = [];
                    let XLSX = require('xlsx');
                    var wb = XLSX.readFile(path);
                    var js = XLSX.utils.sheet_to_json(wb.Sheets[wb.SheetNames[0]], { raw: true, header: 1 });
                    console.log('**************************');
                    let importCount = (+js.length > 0) ? +js.length - 1 : 0;
                    console.log('importCount', importCount);
                    if (importCount > 0) {
                        var header = js[0];
                        for (let i = 1; i < js.length; i++) {
                            let product = {};
                            js[i].forEach((rdata, index) => {
                                product[header[index]] = '' + js[i][index];
                            });
                            result.push(product);
                        }
                    }
                    req.body = { result, fileName: fileName, imageFolder: imageFolder };
                    let productImport = await this.productImportService.productImport(req.body, user);
                    if (productImport) {
                        let uninsertedFileName = (productImport.uninsertedFileName) ? productImport.uninsertedFileName : '';
                        res.setHeader('uninsertedFileName', uninsertedFileName);
                        res.status(common_1.HttpStatus.OK).json(productImport);
                    }
                    else {
                        throw new common_1.InternalServerErrorException();
                    }
                });
            }
            else {
                throw new Process_exception_1.ProcessException('media:not:moveable');
            }
        }
    }
};
__decorate([
    common_1.Post('imageUpload'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body(new validation_pipe_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, importProductImage_dto_1.ImportProductImageDto]),
    __metadata("design:returntype", Promise)
], ProductImportController.prototype, "productImageUpload", null);
__decorate([
    common_1.Get('productImportSample'),
    __param(0, common_1.Request()), __param(1, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], ProductImportController.prototype, "productImportSample", null);
__decorate([
    common_1.Get('sampleDwn/:fileName'),
    __param(0, common_1.Param('fileName')), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], ProductImportController.prototype, "productSampleDownload", null);
__decorate([
    common_1.Post('productFileUpload'),
    common_1.UseInterceptors(platform_express_1.FileInterceptor('file')),
    __param(0, common_1.UploadedFile()), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], ProductImportController.prototype, "productFileUpload", null);
__decorate([
    common_1.Post('import'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body(new validation_pipe_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, importProduct_dto_1.ImportProductDto]),
    __metadata("design:returntype", Promise)
], ProductImportController.prototype, "productImport", null);
ProductImportController = __decorate([
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    common_1.Controller('productImport'),
    common_1.UseInterceptors(platform_express_1.FilesInterceptor('files')),
    __param(0, common_1.Inject('SequelizeInstance')),
    __metadata("design:paramtypes", [Object, productImport_service_1.ProductImportService])
], ProductImportController);
exports.ProductImportController = ProductImportController;
//# sourceMappingURL=productImport.controller.js.map