'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PublicProductController = void 0;
const common_1 = require("@nestjs/common");
const product_service_1 = require("../service/product.service");
const productServiceOutBound_1 = require("../transformation/productServiceOutBound");
const sequelize_1 = require("sequelize");
let PublicProductController = class PublicProductController {
    constructor(productService, sequelizeInstance) {
        this.productService = productService;
        this.sequelizeInstance = sequelizeInstance;
        this.productServiceOutBound = new productServiceOutBound_1.ProductServiceOutBound();
    }
    async getProduct(sku, req, res) {
        let productDetail = await this.productService.getProductBySKU(sku);
        console.log('productDetail', productDetail);
        return res.status(common_1.HttpStatus.OK).json(await this.productServiceOutBound.publicProductCustomerProfile(await this.productService.getPublicProduct(sku)));
    }
    async channelProductFindAll(req, channelId, res, productFilters) {
        let query = 'select tp."brandId",tp."productId",tp."product", tp."productSKU", tp."productqualitylevel", pr."businesscurrencyid",pr."retailerprice", br."brandName",(select concat( \'' + process.env.CDN_URL + '\',"documentPath") as "brandDocumentUrl" from "tblDocument" where "documentId" = br."documentId"),(select concat( \'' + process.env.CDN_URL + '\',"documentPath") as "documentUrl" from "tblDocument" where "documentId" in(select "imageid" from "tblproductimage" where "productimageid"=tp."defaultimageid"))from "tblProduct" as tp inner join "tblBrand" as br on br."id"=tp."brandId" inner join "tblproductpricedetail" as pr on pr."productId"=tp."productId" where "channelId"= :channelId and tp."deletedat" is null and "isactive"=\'1\' and "isPublic"=\'1\'';
        if (productFilters.excludedProductSku)
            query += ' and tp."productSKU" !=:excludedProductSku';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: channelId,
                excludedProductSku: productFilters.excludedProductSku ? productFilters.excludedProductSku : null,
            }
        });
        res.status(common_1.HttpStatus.OK).send(result);
    }
    async channelSimilarProduct(req, channelId, res) {
        let products = [];
        let query = 'select tp."brandId" from "tblProduct" as tp where "channelId"= :channelId and tp."deletedat" is null and "isactive"=\'1\'';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: channelId
            }
        });
        if (result.length > 0) {
            let brandIds = result.map(x => +x.brandId);
            console.log('brandIds', brandIds);
            let query = 'select tp."brandId",tp."productId",tp."product", tp."productSKU", tp."productqualitylevel", pr."businesscurrencyid",pr."retailerprice", br."brandName",(select concat( \'' + process.env.CDN_URL + '\',"documentPath") as "brandDocumentUrl" from "tblDocument" where "documentId" = br."documentId"),(select concat( \'' + process.env.CDN_URL + '\',"documentPath") as "documentUrl" from "tblDocument" where "documentId" in(select "imageid" from "tblproductimage" where "productimageid"=tp."defaultimageid"))from "tblProduct" as tp inner join "tblBrand" as br on br."id"=tp."brandId" inner join "tblproductpricedetail" as pr on pr."productId"=tp."productId" where "channelId"!= :channelId and "brandId" in(:brandIds) and tp."deletedat" is null and "isactive"=\'1\' and "isPublic"=\'1\'';
            products = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelId: channelId,
                    brandIds: brandIds
                }
            });
        }
        res.status(common_1.HttpStatus.OK).send(products);
    }
};
__decorate([
    common_1.Get('Product/:sku'),
    __param(0, common_1.Param('sku')), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], PublicProductController.prototype, "getProduct", null);
__decorate([
    common_1.Post('channel-products/:channelId'),
    __param(0, common_1.Request()), __param(1, common_1.Param('channelId', new common_1.ParseIntPipe())), __param(2, common_1.Response()), __param(3, common_1.Body(new common_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number, Object, Object]),
    __metadata("design:returntype", Promise)
], PublicProductController.prototype, "channelProductFindAll", null);
__decorate([
    common_1.Get('channel-similarproducts/:channelId'),
    __param(0, common_1.Request()), __param(1, common_1.Param('channelId', new common_1.ParseIntPipe())), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number, Object]),
    __metadata("design:returntype", Promise)
], PublicProductController.prototype, "channelSimilarProduct", null);
PublicProductController = __decorate([
    common_1.Controller('public'),
    __param(1, common_1.Inject('SequelizeInstance')),
    __metadata("design:paramtypes", [product_service_1.ProductService, Object])
], PublicProductController);
exports.PublicProductController = PublicProductController;
//# sourceMappingURL=public.product.controller.js.map