'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RejectController = void 0;
const common_1 = require("@nestjs/common");
const validation_pipe_1 = require("../../../middleware/pipe/validation.pipe");
const rejectReason_service_1 = require("../service/rejectReason.service");
const context_service_1 = require("./../../../context/context.service");
const Auth_exception_1 = require("./../../../middleware/exception/Auth.exception");
const Channel_entity_1 = require("./../../channel/models/Channel.entity");
const passport_1 = require("@nestjs/passport");
const reject_dto_1 = require("../dto/reject.dto");
let RejectController = class RejectController {
    constructor(rejectReasonService, context) {
        this.rejectReasonService = rejectReasonService;
        this.context = context;
    }
    async create(req, res, dto) {
        let user = req.user;
        if (user.channelTypeId == Channel_entity_1.Channel.CHANNEL_TYPE_VENDOR) {
            throw new Auth_exception_1.AuthException('Not allowed');
        }
        await this.rejectReasonService.reject(dto, user);
        res.status(common_1.HttpStatus.CREATED).json({
            "status": true
        });
    }
};
__decorate([
    common_1.Post('reject'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body(new validation_pipe_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, reject_dto_1.RejectDto]),
    __metadata("design:returntype", Promise)
], RejectController.prototype, "create", null);
RejectController = __decorate([
    common_1.Controller('Product'),
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    __metadata("design:paramtypes", [rejectReason_service_1.RejectReasonService,
        context_service_1.ContextService])
], RejectController);
exports.RejectController = RejectController;
//# sourceMappingURL=reject.controller.js.map