"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AddProductBasicInfoDto = void 0;
const class_validator_1 = require("class-validator");
const class_transformer_1 = require("class-transformer");
const swagger_1 = require("@nestjs/swagger");
const productTag_dto_1 = require("./productTag.dto");
class AddProductBasicInfoDto {
}
__decorate([
    class_validator_1.IsNotEmpty({
        message: "channel:product:productNameIsNotEmpty",
        groups: ["import"]
    }),
    class_validator_1.MinLength(3, {
        message: "channel:product:productNameMinLen",
        groups: ["import"]
    }),
    class_validator_1.MaxLength(256, {
        message: "channel:product:productNameMaxLen",
        groups: ["import"]
    }),
    class_validator_1.IsString({ message: "channel:product:productNameIsString" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], AddProductBasicInfoDto.prototype, "productname", void 0);
__decorate([
    class_validator_1.IsString({ message: "channel:product:productNameIsString" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], AddProductBasicInfoDto.prototype, "productshortdec", void 0);
__decorate([
    class_validator_1.IsNotEmpty({ message: "channel:product:productStatusIsNotEmpty" }),
    class_validator_1.IsString({ message: "channel:product:productStatusIsString" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], AddProductBasicInfoDto.prototype, "productstatus", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsString({ message: "channel:product:productPitchAwardIsString" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], AddProductBasicInfoDto.prototype, "product_pitch_award", void 0);
__decorate([
    class_validator_1.IsNotEmpty({
        message: "channel:product:productGroupIsNotEmpty",
        groups: ["import"]
    }),
    class_validator_1.IsNumber({}, { message: "channel:product:productGroupIsNumber" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], AddProductBasicInfoDto.prototype, "productgroup", void 0);
__decorate([
    class_validator_1.IsNotEmpty({
        message: "channel:product:productCategoryIsNotEmpty",
        groups: ["import"]
    }),
    class_validator_1.IsNumber({}, { message: "channel:product:productCategoryIsNumber" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], AddProductBasicInfoDto.prototype, "productcategory", void 0);
__decorate([
    class_validator_1.IsNotEmpty({
        message: "channel:product:productBrandIsNotEmpty",
        groups: ["import"]
    }),
    class_validator_1.IsNumber({}, { message: "channel:product:productBrandIsNumber" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], AddProductBasicInfoDto.prototype, "productbrand", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsString({ message: "channel:product:productDescIsString" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], AddProductBasicInfoDto.prototype, "productdesc", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.MaxLength(2000, {
        message: "validate:field:validateMaxLength"
    }),
    class_validator_1.IsString({ message: "validate:field:shouldBeString" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], AddProductBasicInfoDto.prototype, "keyretailers", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.MaxLength(2000, {
        message: "validate:field:validateMaxLength"
    }),
    class_validator_1.IsString({ message: "validate:field:shouldBeString" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], AddProductBasicInfoDto.prototype, "keydistributors", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.MaxLength(2000, {
        message: "validate:field:validateMaxLength"
    }),
    class_validator_1.IsString({ message: "validate:field:shouldBeString" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], AddProductBasicInfoDto.prototype, "keyresellers", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsString({ message: "channel:product:productUspIsString" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], AddProductBasicInfoDto.prototype, "productusp", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty({ type: productTag_dto_1.ProductTagDto, isArray: true }),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:productTagArrayNotEmpty" }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productTagIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => productTag_dto_1.ProductTagDto),
    __metadata("design:type", Array)
], AddProductBasicInfoDto.prototype, "producttag", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNumber({}, { message: "channel:product:productBusinessTypeIsNumber" }),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], AddProductBasicInfoDto.prototype, "businessType", void 0);
exports.AddProductBasicInfoDto = AddProductBasicInfoDto;
//# sourceMappingURL=addProductBasicInfo.dto.js.map