"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AddProductDto = void 0;
const class_validator_1 = require("class-validator");
const class_transformer_1 = require("class-transformer");
const addProductBasicInfo_dto_1 = require("./AddProduct/addProductBasicInfo.dto");
const addProductArticleReview_dto_1 = require("./AddProduct/addProductArticleReview.dto");
const addProductImage_dto_1 = require("./AddProduct/addProductImage.dto");
const addProductBrochure_dto_1 = require("./AddProduct/addProductBrochure.dto");
const addProductPreferences_dto_1 = require("./AddProduct/addProductPreferences.dto");
const addProductCode_dto_1 = require("./AddProduct/addProductCode.dto");
const addProductPrice_dto_1 = require("./AddProduct/addProductPrice.dto");
const addProductPackageInfo_dto_1 = require("./AddProduct/addProductPackageInfo.dto");
const addProductCompeting_dto_1 = require("./AddProduct/addProductCompeting.dto");
const addProductPosition_dto_1 = require("./AddProduct/addProductPosition.dto");
const addProductRelevantChannel_dto_1 = require("./AddProduct/addProductRelevantChannel.dto");
const addProductSellingLocation_dto_1 = require("./AddProduct/addProductSellingLocation.dto");
const addProductTargetLocation_dto_1 = require("./AddProduct/addProductTargetLocation.dto");
const addProductAvailability_dto_1 = require("./AddProduct/addProductAvailability.dto");
const productAwards_dto_1 = require("./productAwards.dto");
const channelkeyretailer_dto_1 = require("../../channel/dto/channelkeyretailer.dto");
const swagger_1 = require("@nestjs/swagger");
class AddProductDto {
}
__decorate([
    swagger_1.ApiProperty({ type: addProductBasicInfo_dto_1.AddProductBasicInfoDto }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productBasicInfoIsNotEmpty" }),
    class_validator_1.ValidateNested({ groups: ["import"] }),
    class_transformer_1.Type(() => addProductBasicInfo_dto_1.AddProductBasicInfoDto),
    __metadata("design:type", addProductBasicInfo_dto_1.AddProductBasicInfoDto)
], AddProductDto.prototype, "productBasicInfo", void 0);
__decorate([
    swagger_1.ApiProperty(),
    class_validator_1.IsNotEmpty({ message: "channel:product:productBasicInfoIsNotEmpty" }),
    class_validator_1.ValidateNested({ groups: ["import"] }),
    __metadata("design:type", Object)
], AddProductDto.prototype, "ProductInfo", void 0);
__decorate([
    class_validator_1.IsOptional({ groups: ["import"] }),
    swagger_1.ApiProperty({ type: addProductArticleReview_dto_1.AddProductArticleReviewDto }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productArticleReviewIsNotEmpty" }),
    class_validator_1.ValidateNested({ groups: ["import"] }),
    class_transformer_1.Type(() => addProductArticleReview_dto_1.AddProductArticleReviewDto),
    __metadata("design:type", addProductArticleReview_dto_1.AddProductArticleReviewDto)
], AddProductDto.prototype, "productArticleReview", void 0);
__decorate([
    swagger_1.ApiProperty({ type: addProductImage_dto_1.AddProductImageDto }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productImagesIsNotEmpty" }),
    class_transformer_1.Type(() => addProductImage_dto_1.AddProductImageDto),
    __metadata("design:type", addProductImage_dto_1.AddProductImageDto)
], AddProductDto.prototype, "productImages", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty({ type: addProductBrochure_dto_1.AddProductBrochureDto }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productBrochureIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductBrochure_dto_1.AddProductBrochureDto),
    __metadata("design:type", addProductBrochure_dto_1.AddProductBrochureDto)
], AddProductDto.prototype, "productBrochure", void 0);
__decorate([
    swagger_1.ApiProperty({ type: addProductPreferences_dto_1.AddProductPreferencesDto, isArray: true }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productPreferencesIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductPreferences_dto_1.AddProductPreferencesDto),
    __metadata("design:type", addProductPreferences_dto_1.AddProductPreferencesDto)
], AddProductDto.prototype, "productPreferences", void 0);
__decorate([
    swagger_1.ApiProperty({ type: addProductCode_dto_1.AddProductCodeDto }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productCodesIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductCode_dto_1.AddProductCodeDto),
    __metadata("design:type", addProductCode_dto_1.AddProductCodeDto)
], AddProductDto.prototype, "productCode", void 0);
__decorate([
    swagger_1.ApiProperty({ type: addProductPrice_dto_1.AddProductPriceDto }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productPriceIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductPrice_dto_1.AddProductPriceDto),
    __metadata("design:type", addProductPrice_dto_1.AddProductPriceDto)
], AddProductDto.prototype, "productPrice", void 0);
__decorate([
    swagger_1.ApiProperty({ type: addProductPackageInfo_dto_1.AddProductPackageInfoDto }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productPackageInfoIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductPackageInfo_dto_1.AddProductPackageInfoDto),
    __metadata("design:type", addProductPackageInfo_dto_1.AddProductPackageInfoDto)
], AddProductDto.prototype, "productPackageInfo", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty({ type: addProductCompeting_dto_1.AddProductCompetingDto }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productCompetingIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductCompeting_dto_1.AddProductCompetingDto),
    __metadata("design:type", addProductCompeting_dto_1.AddProductCompetingDto)
], AddProductDto.prototype, "productCompeting", void 0);
__decorate([
    swagger_1.ApiProperty({ type: addProductPosition_dto_1.AddProductPositionDto }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productPositionIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductPosition_dto_1.AddProductPositionDto),
    __metadata("design:type", addProductPosition_dto_1.AddProductPositionDto)
], AddProductDto.prototype, "productPosition", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty({ type: addProductRelevantChannel_dto_1.AddProductRelevantChannelDto }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productRelevantChannelIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductRelevantChannel_dto_1.AddProductRelevantChannelDto),
    __metadata("design:type", addProductRelevantChannel_dto_1.AddProductRelevantChannelDto)
], AddProductDto.prototype, "productRelevantChannel", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty({ type: addProductSellingLocation_dto_1.AddProductSellingLocationDto }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productSellingLocationIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductSellingLocation_dto_1.AddProductSellingLocationDto),
    __metadata("design:type", addProductSellingLocation_dto_1.AddProductSellingLocationDto)
], AddProductDto.prototype, "productSellingLocation", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty({ type: addProductTargetLocation_dto_1.AddProductTargetLocationDto }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productTargetLocationIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductTargetLocation_dto_1.AddProductTargetLocationDto),
    __metadata("design:type", addProductTargetLocation_dto_1.AddProductTargetLocationDto)
], AddProductDto.prototype, "productTargetLocation", void 0);
__decorate([
    swagger_1.ApiProperty({ type: addProductAvailability_dto_1.AddProductAvailabilityDto }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productAvailabilityIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductAvailability_dto_1.AddProductAvailabilityDto),
    __metadata("design:type", addProductAvailability_dto_1.AddProductAvailabilityDto)
], AddProductDto.prototype, "productAvailability", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty({ type: productAwards_dto_1.ProductAwardsDto, description: "product awards", isArray: true }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => productAwards_dto_1.ProductAwardsDto),
    __metadata("design:type", Array)
], AddProductDto.prototype, "award_details", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty({ type: channelkeyretailer_dto_1.ChannelKeyRetailerDto, isArray: true }),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:productKeyRetailerArrayNotEmpty" }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productKeyRetailerIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => channelkeyretailer_dto_1.ChannelKeyRetailerDto),
    __metadata("design:type", Array)
], AddProductDto.prototype, "keyRetailers", void 0);
__decorate([
    class_validator_1.IsOptional(),
    swagger_1.ApiProperty({ type: channelkeyretailer_dto_1.ChannelKeyRetailerDto, isArray: true }),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:productKeyRetailerArrayNotEmpty" }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productKeyRetailerIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => channelkeyretailer_dto_1.ChannelKeyRetailerDto),
    __metadata("design:type", Array)
], AddProductDto.prototype, "keyDistributors", void 0);
exports.AddProductDto = AddProductDto;
//# sourceMappingURL=addProduct.dto.js.map