"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateProductDto = void 0;
const class_validator_1 = require("class-validator");
const class_transformer_1 = require("class-transformer");
const addProductBasicInfo_dto_1 = require("./AddProduct/addProductBasicInfo.dto");
const addProductArticleReview_dto_1 = require("./AddProduct/addProductArticleReview.dto");
const updateProductImage_dto_1 = require("./UpdateProduct/updateProductImage.dto");
const addProductPreferences_dto_1 = require("./AddProduct/addProductPreferences.dto");
const addProductCode_dto_1 = require("./AddProduct/addProductCode.dto");
const addProductPrice_dto_1 = require("./AddProduct/addProductPrice.dto");
const addProductPackageInfo_dto_1 = require("./AddProduct/addProductPackageInfo.dto");
const addProductCompeting_dto_1 = require("./AddProduct/addProductCompeting.dto");
const addProductPosition_dto_1 = require("./AddProduct/addProductPosition.dto");
const addProductRelevantChannel_dto_1 = require("./AddProduct/addProductRelevantChannel.dto");
const addProductSellingLocation_dto_1 = require("./AddProduct/addProductSellingLocation.dto");
const addProductTargetLocation_dto_1 = require("./AddProduct/addProductTargetLocation.dto");
const addProductAvailability_dto_1 = require("./AddProduct/addProductAvailability.dto");
const updateProductBrochure_dto_1 = require("./UpdateProduct/updateProductBrochure.dto");
const productAwards_dto_1 = require("./productAwards.dto");
const channelkeyretailer_dto_1 = require("../../channel/dto/channelkeyretailer.dto");
class UpdateProductDto {
}
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:product:productBasicInfoIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductBasicInfo_dto_1.AddProductBasicInfoDto),
    __metadata("design:type", addProductBasicInfo_dto_1.AddProductBasicInfoDto)
], UpdateProductDto.prototype, "productBasicInfo", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:product:productBasicInfoIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    __metadata("design:type", Object)
], UpdateProductDto.prototype, "ProductInfo", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:product:productArticleReviewIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductArticleReview_dto_1.AddProductArticleReviewDto),
    __metadata("design:type", addProductArticleReview_dto_1.AddProductArticleReviewDto)
], UpdateProductDto.prototype, "productArticleReview", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:product:productImagesIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => updateProductImage_dto_1.UpdateProductImageDto),
    __metadata("design:type", updateProductImage_dto_1.UpdateProductImageDto)
], UpdateProductDto.prototype, "productImages", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:product:productBrochureIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => updateProductBrochure_dto_1.UpdateProductBrochureDto),
    __metadata("design:type", updateProductBrochure_dto_1.UpdateProductBrochureDto)
], UpdateProductDto.prototype, "productBrochure", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:product:productPreferencesIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductPreferences_dto_1.AddProductPreferencesDto),
    __metadata("design:type", addProductPreferences_dto_1.AddProductPreferencesDto)
], UpdateProductDto.prototype, "productPreferences", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:product:productCodesIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductCode_dto_1.AddProductCodeDto),
    __metadata("design:type", addProductCode_dto_1.AddProductCodeDto)
], UpdateProductDto.prototype, "productCode", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:product:productPriceIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductPrice_dto_1.AddProductPriceDto),
    __metadata("design:type", addProductPrice_dto_1.AddProductPriceDto)
], UpdateProductDto.prototype, "productPrice", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:product:productPackageInfoIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductPackageInfo_dto_1.AddProductPackageInfoDto),
    __metadata("design:type", addProductPackageInfo_dto_1.AddProductPackageInfoDto)
], UpdateProductDto.prototype, "productPackageInfo", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:product:productCompetingIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductCompeting_dto_1.AddProductCompetingDto),
    __metadata("design:type", addProductCompeting_dto_1.AddProductCompetingDto)
], UpdateProductDto.prototype, "productCompeting", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:product:productPositionIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductPosition_dto_1.AddProductPositionDto),
    __metadata("design:type", addProductPosition_dto_1.AddProductPositionDto)
], UpdateProductDto.prototype, "productPosition", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:product:productRelevantChannelIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductRelevantChannel_dto_1.AddProductRelevantChannelDto),
    __metadata("design:type", addProductRelevantChannel_dto_1.AddProductRelevantChannelDto)
], UpdateProductDto.prototype, "productRelevantChannel", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:product:productSellingLocationIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductSellingLocation_dto_1.AddProductSellingLocationDto),
    __metadata("design:type", addProductSellingLocation_dto_1.AddProductSellingLocationDto)
], UpdateProductDto.prototype, "productSellingLocation", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:product:productTargetLocationIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductTargetLocation_dto_1.AddProductTargetLocationDto),
    __metadata("design:type", addProductTargetLocation_dto_1.AddProductTargetLocationDto)
], UpdateProductDto.prototype, "productTargetLocation", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "channel:product:productAvailabilityIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => addProductAvailability_dto_1.AddProductAvailabilityDto),
    __metadata("design:type", addProductAvailability_dto_1.AddProductAvailabilityDto)
], UpdateProductDto.prototype, "productAvailability", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:deletedproducttagIsNotEmpty" }),
    __metadata("design:type", Array)
], UpdateProductDto.prototype, "deletedproducttag", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:deletedarticlereviewIsNotEmpty" }),
    __metadata("design:type", Array)
], UpdateProductDto.prototype, "deletedarticlereview", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:deletedexistingratingIsNotEmpty" }),
    __metadata("design:type", Array)
], UpdateProductDto.prototype, "deletedexistingrating", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:deletedproductimageIsNotEmpty" }),
    __metadata("design:type", Array)
], UpdateProductDto.prototype, "deletedproductimage", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:deletedproductdisplayimageIsNotEmpty" }),
    __metadata("design:type", Array)
], UpdateProductDto.prototype, "deletedproductdisplayimage", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:deletedproductpackageimageIsNotEmpty" }),
    __metadata("design:type", Array)
], UpdateProductDto.prototype, "deletedproductpackageimage", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:deletedproductbrochureIsNotEmpty" }),
    __metadata("design:type", Array)
], UpdateProductDto.prototype, "deletedproductbrochure", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:deletedcompetingproductIsNotEmpty" }),
    __metadata("design:type", Array)
], UpdateProductDto.prototype, "deletedcompetingproduct", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:deletedkeyretailerIsNotEmpty" }),
    __metadata("design:type", Array)
], UpdateProductDto.prototype, "deletedkeyretailer", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:deletedkeyretailerIsNotEmpty" }),
    __metadata("design:type", Array)
], UpdateProductDto.prototype, "deletedkeydistributor", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:deletedkeyresellerIsNotEmpty" }),
    __metadata("design:type", Array)
], UpdateProductDto.prototype, "deletedkeyreseller", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => productAwards_dto_1.ProductAwardsDto),
    __metadata("design:type", Array)
], UpdateProductDto.prototype, "award_details", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "product:productDeletedAwardDetailsIsNotEmpty" }),
    __metadata("design:type", Array)
], UpdateProductDto.prototype, "deleted_award_details", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:productKeyRetailerArrayNotEmpty" }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productKeyRetailerIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => channelkeyretailer_dto_1.ChannelKeyRetailerDto),
    __metadata("design:type", Array)
], UpdateProductDto.prototype, "keyRetailers", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:productKeyRetailerArrayNotEmpty" }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productKeyRetailerIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => channelkeyretailer_dto_1.ChannelKeyRetailerDto),
    __metadata("design:type", Array)
], UpdateProductDto.prototype, "keyDistributors", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:product:productKeyResellerArrayNotEmpty" }),
    class_validator_1.IsNotEmpty({ message: "channel:product:productKeyResellerIsNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => channelkeyretailer_dto_1.ChannelKeyRetailerDto),
    __metadata("design:type", Array)
], UpdateProductDto.prototype, "keyResellers", void 0);
exports.UpdateProductDto = UpdateProductDto;
//# sourceMappingURL=updateProduct.dto.js.map