"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AwardResult = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const swagger_1 = require("@nestjs/swagger");
const Product_entity_1 = require("./Product.entity");
const Event_entity_1 = require("./Event.entity");
const Media_entity_1 = require("./../../media/models/Media.entity");
const Brand_entity_1 = require("./Brand.entity");
const ProductCategory_entity_1 = require("./ProductCategory.entity");
const ProductImage_entity_1 = require("./ProductImage.entity");
const tableOptions = { timestamp: true, tableName: 'Award_Results' };
let AwardResult = class AwardResult extends sequelize_typescript_1.Model {
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], AwardResult.prototype, "id", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Product_entity_1.Product),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], AwardResult.prototype, "product_id", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Product_entity_1.Product),
    __metadata("design:type", Product_entity_1.Product)
], AwardResult.prototype, "product", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.CHAR(255),
        allowNull: false,
    }),
    swagger_1.ApiProperty(),
    __metadata("design:type", String)
], AwardResult.prototype, "result", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Event_entity_1.Event),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    swagger_1.ApiProperty(),
    __metadata("design:type", Number)
], AwardResult.prototype, "event_id", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], AwardResult.prototype, "created_at", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], AwardResult.prototype, "updated_at", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], AwardResult.prototype, "deleted_at", void 0);
AwardResult = __decorate([
    sequelize_typescript_1.Scopes(() => ({
        productInfo: {
            attributes: ['productId', 'channelId', 'productGroupId', 'productCategorieId', 'product', 'brandId', 'productSKU', 'productkey', 'isshowtofreesub', 'isactive', 'hasanyvariant', 'variantdetails', 'productqualitylevel', 'defaultimageid', 'updatedBy', 'deletedat', 'product_pitch_award']
        },
        orderInfo: {
            attributes: ['productId', 'product', 'productSKU', 'productGroupId', 'productCategorieId', 'brandId', 'defaultimageid']
        },
        productRatingInfo: {
            attributes: ['productId', 'channelId', 'productGroupId', 'productCategorieId', 'product', 'brandId', 'productSKU', 'productkey', 'isactive', 'defaultimageid', 'productqualitylevel']
        },
        productReject: {
            attributes: {
                exclude: ['deletedat', 'createdat', 'updatedat', 'updatedby']
            },
            include: [
                {
                    model: Brand_entity_1.Brand,
                    as: 'brand'
                },
                {
                    model: ProductCategory_entity_1.ProductCategory,
                    as: 'productCategory'
                },
                {
                    model: ProductImage_entity_1.ProductImage,
                    as: 'defaultImage',
                    include: [{
                            model: Media_entity_1.Media,
                            as: 'image'
                        }]
                }
            ]
        }
    }))
], AwardResult);
exports.AwardResult = AwardResult;
//# sourceMappingURL=AwardResult.entity.js.map