'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Brand = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Media_entity_1 = require("../../media/models/Media.entity");
const ChannelBrand_entity_1 = require("../../channel/models/ChannelBrand.entity");
var Sequelize = require('sequelize');
const tableOptions = { timestamps: false, tableName: 'tblBrand' };
let Brand = class Brand extends sequelize_typescript_1.Model {
    static async dateUpdate(brand, options) {
        brand.updatedAt = Sequelize.fn('NOW');
    }
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Brand.prototype, "id", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.CHAR(255),
        allowNull: false,
        unique: { name: 'brandName', msg: 'validate:field:shouldBeUnique' }
    }),
    __metadata("design:type", String)
], Brand.prototype, "brandName", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Media_entity_1.Media),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Brand.prototype, "documentId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Media_entity_1.Media),
    __metadata("design:type", Media_entity_1.Media)
], Brand.prototype, "document", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Brand.prototype, "isAssigned", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Brand.prototype, "isVerified", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Brand.prototype, "isActive", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Brand.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Brand.prototype, "createdAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Brand.prototype, "updatedAt", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ChannelBrand_entity_1.ChannelBrand, 'brandId'),
    __metadata("design:type", ChannelBrand_entity_1.ChannelBrand)
], Brand.prototype, "channelBrand", void 0);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    sequelize_typescript_1.BeforeUpdate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Brand, Object]),
    __metadata("design:returntype", Promise)
], Brand, "dateUpdate", null);
Brand = __decorate([
    sequelize_typescript_1.Table(tableOptions),
    sequelize_typescript_1.Scopes(() => ({
        basicInfom: {
            attributes: ['id', ['brandName', 'name'], 'isAssigned', 'isVerified'],
        },
        channelDetail: {
            attributes: ['id', 'brandName', 'isActive', 'isVerified', 'deletedAt']
        },
        tradeinfo: {
            attributes: {
                exclude: ['deletedAt', 'createdAt', 'updatedAt']
            }
        },
        brandMaster: {
            where: {
                deletedAt: null
            },
            attributes: {
                exclude: ['deletedAt', 'createdAt', 'updatedAt']
            },
            include: [
                {
                    model: Media_entity_1.Media,
                    attributes: ['documentId', 'documentPath', 'thumbnailUrl', 'documentUrl'],
                    required: false
                }
            ]
        },
        orderInfo: {
            attributes: ['brandName']
        }
    }))
], Brand);
exports.Brand = Brand;
//# sourceMappingURL=Brand.entity.js.map