import { Model } from 'sequelize-typescript';
import { Channel } from '../../channel/models/Channel.entity';
import { ProductGroup } from './ProductGroup.entity';
import { ProductCategory } from './ProductCategory.entity';
import { Brand } from './Brand.entity';
import { ProductPriceDetail } from './ProductPriceDetail.entity';
import { ProductImage } from './ProductImage.entity';
import { ProductDetail } from './ProductDetail.entity';
import { ProductTag } from './ProductTag.entity';
import { ProductArticleReview } from './ProductArticleReview.entity';
import { ProductExistRating } from './ProductExistRating.entity';
import { ProductUniversalCode } from './ProductUniversalCode.entity';
import { ProductPackageInfo } from './ProductPackageInfo.entity';
import { ProductCompeting } from './ProductCompeting.entity';
import { ProductChannelCustomerProfile } from './ProductChannelCustomerProfile.entity';
import { ProductLocation } from './ProductLocation.entity';
import { ProductSharePreference } from './ProductSharePreference.entity';
import { Media } from './../../media/models/Media.entity';
import { RegionCountryJCT } from './../../common/models/RegionCountryJCT.entity';
import { ShareType } from './../../channel/models/ShareType.entity';
import { ProductReject } from './ProductReject.entity';
import { ProductAward } from './ProductAward.entity';
import { ProductJCT } from './ProductJCT.entity';
import { Wishlist } from 'src/modules/wishlist/models/Wishlist.entity';
export declare class Product extends Model<Product> {
    productId: number;
    channelId: number;
    channel: Channel;
    productGroupId: number;
    productGroup: ProductGroup;
    productCategorieId: number;
    productCategory: ProductCategory;
    product: string;
    brandId: number;
    brand: Brand;
    productSKU: string;
    productkey: string;
    isshowtofreesub: string;
    isactive: string;
    hasanyvariant: string;
    variantdetails: string;
    productqualitylevel: string;
    product_pitch_award: string;
    isSuggestion: string;
    isInovation: string;
    isPublic: string;
    isFeatured: string;
    eco_friendly: string;
    life_style: string;
    work_from_home: string;
    french_tech: string;
    taiwan_excellence: string;
    show_in_home_page: string;
    product_rank_order: number;
    productPriceDetail: ProductPriceDetail;
    productImage: ProductImage[];
    productAwards: ProductAward[];
    productJCT: ProductJCT[];
    wishList: Wishlist[];
    defaultimageid: number;
    defaultImage: ProductImage;
    updatedBy: number;
    businessType: number;
    createdat: Date;
    updatedat: Date;
    deletedat: Date;
    slug: string;
    productDetail: ProductDetail;
    productTag: ProductTag[];
    productArticleReview: ProductArticleReview[];
    productExistRating: ProductExistRating[];
    productSharePreference: ProductSharePreference[];
    productUniversalCode: ProductUniversalCode[];
    productPackageInfo: ProductPackageInfo;
    productCompeting: ProductCompeting[];
    productChannelCustomerProfile: ProductChannelCustomerProfile[];
    productLocation: ProductLocation[];
    locations: RegionCountryJCT[];
    selling_locations: RegionCountryJCT[];
    target_locations: RegionCountryJCT[];
    images: Media[];
    shareType: ShareType[];
    productReject: ProductReject[];
    static dateUpdate(product: Product, options: any): Promise<void>;
}
