"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Product = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Channel_entity_1 = require("../../channel/models/Channel.entity");
const ProductGroup_entity_1 = require("./ProductGroup.entity");
const ProductCategory_entity_1 = require("./ProductCategory.entity");
const Brand_entity_1 = require("./Brand.entity");
const ProductPriceDetail_entity_1 = require("./ProductPriceDetail.entity");
const ProductImage_entity_1 = require("./ProductImage.entity");
const ProductDetail_entity_1 = require("./ProductDetail.entity");
const ProductTag_entity_1 = require("./ProductTag.entity");
const ProductArticleReview_entity_1 = require("./ProductArticleReview.entity");
const ProductExistRating_entity_1 = require("./ProductExistRating.entity");
const ProductUniversalCode_entity_1 = require("./ProductUniversalCode.entity");
const ProductPackageInfo_entity_1 = require("./ProductPackageInfo.entity");
const ProductCompeting_entity_1 = require("./ProductCompeting.entity");
const ProductChannelCustomerProfile_entity_1 = require("./ProductChannelCustomerProfile.entity");
const ProductLocation_entity_1 = require("./ProductLocation.entity");
const ProductSharePreference_entity_1 = require("./ProductSharePreference.entity");
const Media_entity_1 = require("./../../media/models/Media.entity");
const RegionCountryJCT_entity_1 = require("./../../common/models/RegionCountryJCT.entity");
const ShareType_entity_1 = require("./../../channel/models/ShareType.entity");
const app_constant_1 = require("../../../config/app.constant");
const ProductReject_entity_1 = require("./ProductReject.entity");
const ProductAward_entity_1 = require("./ProductAward.entity");
const ProductJCT_entity_1 = require("./ProductJCT.entity");
const Wishlist_entity_1 = require("../../wishlist/models/Wishlist.entity");
var Sequelize = require('sequelize');
const tableOptions = { timestamps: false, tableName: 'tblProduct' };
let Product = class Product extends sequelize_typescript_1.Model {
    static async dateUpdate(product, options) {
        product.updatedat = Sequelize.fn('NOW');
    }
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Product.prototype, "productId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Product.prototype, "channelId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel),
    __metadata("design:type", Channel_entity_1.Channel)
], Product.prototype, "channel", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => ProductGroup_entity_1.ProductGroup),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Product.prototype, "productGroupId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => ProductGroup_entity_1.ProductGroup),
    __metadata("design:type", ProductGroup_entity_1.ProductGroup)
], Product.prototype, "productGroup", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => ProductCategory_entity_1.ProductCategory),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Product.prototype, "productCategorieId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => ProductCategory_entity_1.ProductCategory),
    __metadata("design:type", ProductCategory_entity_1.ProductCategory)
], Product.prototype, "productCategory", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], Product.prototype, "product", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Brand_entity_1.Brand),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Product.prototype, "brandId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Brand_entity_1.Brand),
    __metadata("design:type", Brand_entity_1.Brand)
], Product.prototype, "brand", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], Product.prototype, "productSKU", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], Product.prototype, "productkey", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Product.prototype, "isshowtofreesub", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Product.prototype, "isactive", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Product.prototype, "hasanyvariant", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], Product.prototype, "variantdetails", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Product.prototype, "productqualitylevel", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Product.prototype, "product_pitch_award", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Product.prototype, "isSuggestion", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Product.prototype, "isInovation", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Product.prototype, "isPublic", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Product.prototype, "isFeatured", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Product.prototype, "eco_friendly", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Product.prototype, "life_style", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Product.prototype, "work_from_home", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Product.prototype, "french_tech", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Product.prototype, "taiwan_excellence", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Product.prototype, "show_in_home_page", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Product.prototype, "product_rank_order", void 0);
__decorate([
    sequelize_typescript_1.HasOne(() => ProductPriceDetail_entity_1.ProductPriceDetail, 'productId'),
    __metadata("design:type", ProductPriceDetail_entity_1.ProductPriceDetail)
], Product.prototype, "productPriceDetail", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ProductImage_entity_1.ProductImage, 'productId'),
    __metadata("design:type", Array)
], Product.prototype, "productImage", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ProductAward_entity_1.ProductAward, 'productId'),
    __metadata("design:type", Array)
], Product.prototype, "productAwards", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ProductJCT_entity_1.ProductJCT, 'productId'),
    __metadata("design:type", Array)
], Product.prototype, "productJCT", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => Wishlist_entity_1.Wishlist, 'productid'),
    __metadata("design:type", Array)
], Product.prototype, "wishList", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => ProductImage_entity_1.ProductImage),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Product.prototype, "defaultimageid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => ProductImage_entity_1.ProductImage, 'defaultimageid'),
    __metadata("design:type", ProductImage_entity_1.ProductImage)
], Product.prototype, "defaultImage", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Product.prototype, "updatedBy", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Product.prototype, "businessType", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Product.prototype, "createdat", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Product.prototype, "updatedat", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Product.prototype, "deletedat", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], Product.prototype, "slug", void 0);
__decorate([
    sequelize_typescript_1.HasOne(() => ProductDetail_entity_1.ProductDetail, 'productId'),
    __metadata("design:type", ProductDetail_entity_1.ProductDetail)
], Product.prototype, "productDetail", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ProductTag_entity_1.ProductTag, 'productId'),
    __metadata("design:type", Array)
], Product.prototype, "productTag", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ProductArticleReview_entity_1.ProductArticleReview, 'productId'),
    __metadata("design:type", Array)
], Product.prototype, "productArticleReview", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ProductExistRating_entity_1.ProductExistRating, 'productId'),
    __metadata("design:type", Array)
], Product.prototype, "productExistRating", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ProductSharePreference_entity_1.ProductSharePreference, 'productId'),
    __metadata("design:type", Array)
], Product.prototype, "productSharePreference", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ProductUniversalCode_entity_1.ProductUniversalCode, 'productId'),
    __metadata("design:type", Array)
], Product.prototype, "productUniversalCode", void 0);
__decorate([
    sequelize_typescript_1.HasOne(() => ProductPackageInfo_entity_1.ProductPackageInfo, 'productId'),
    __metadata("design:type", ProductPackageInfo_entity_1.ProductPackageInfo)
], Product.prototype, "productPackageInfo", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ProductCompeting_entity_1.ProductCompeting, 'productId'),
    __metadata("design:type", Array)
], Product.prototype, "productCompeting", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ProductChannelCustomerProfile_entity_1.ProductChannelCustomerProfile, 'productId'),
    __metadata("design:type", Array)
], Product.prototype, "productChannelCustomerProfile", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ProductLocation_entity_1.ProductLocation, 'productId'),
    __metadata("design:type", Array)
], Product.prototype, "productLocation", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => RegionCountryJCT_entity_1.RegionCountryJCT, {
        through: {
            model: () => ProductLocation_entity_1.ProductLocation,
            scope: {
                deletedat: null
            }
        }
    }),
    __metadata("design:type", Array)
], Product.prototype, "locations", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => RegionCountryJCT_entity_1.RegionCountryJCT, {
        through: {
            model: () => ProductLocation_entity_1.ProductLocation,
            scope: {
                deletedat: null,
                locationtype: app_constant_1.appconstant.LOCATION_TYPE_SELLING
            }
        }
    }),
    __metadata("design:type", Array)
], Product.prototype, "selling_locations", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => RegionCountryJCT_entity_1.RegionCountryJCT, {
        through: {
            model: () => ProductLocation_entity_1.ProductLocation,
            scope: {
                deletedat: null,
                locationtype: app_constant_1.appconstant.LOCATION_TYPE_TARGET
            }
        }
    }),
    __metadata("design:type", Array)
], Product.prototype, "target_locations", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => Media_entity_1.Media, {
        through: {
            model: () => ProductImage_entity_1.ProductImage,
            scope: {
                deletedat: null
            }
        }
    }),
    __metadata("design:type", Array)
], Product.prototype, "images", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => ShareType_entity_1.ShareType, {
        through: {
            model: () => ProductSharePreference_entity_1.ProductSharePreference,
            scope: {
                deletedat: null
            }
        }
    }),
    __metadata("design:type", Array)
], Product.prototype, "shareType", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ProductReject_entity_1.ProductReject, 'productid'),
    __metadata("design:type", Array)
], Product.prototype, "productReject", void 0);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    sequelize_typescript_1.BeforeUpdate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Product, Object]),
    __metadata("design:returntype", Promise)
], Product, "dateUpdate", null);
Product = __decorate([
    sequelize_typescript_1.Table(tableOptions),
    sequelize_typescript_1.Scopes(() => ({
        productInfo: {
            attributes: ['productId', 'channelId', 'productGroupId', 'productCategorieId', 'product', 'brandId', 'productSKU', 'productkey', 'isshowtofreesub', 'isactive', 'hasanyvariant', 'variantdetails', 'productqualitylevel', 'defaultimageid', 'updatedBy', 'deletedat', 'product_pitch_award', 'product_rank_order', 'isSuggestion', 'isInovation', 'businessType']
        },
        orderInfo: {
            attributes: ['productId', 'product', 'productSKU', 'productGroupId', 'productCategorieId', 'brandId', 'defaultimageid']
        },
        productRatingInfo: {
            attributes: ['productId', 'channelId', 'productGroupId', 'productCategorieId', 'product', 'brandId', 'productSKU', 'productkey', 'isactive', 'defaultimageid', 'productqualitylevel']
        },
        productReject: {
            attributes: {
                exclude: ['deletedat', 'createdat', 'updatedat', 'updatedby']
            },
            include: [
                {
                    model: Brand_entity_1.Brand,
                    as: 'brand'
                },
                {
                    model: ProductCategory_entity_1.ProductCategory,
                    as: 'productCategory'
                },
                {
                    model: ProductImage_entity_1.ProductImage,
                    as: 'defaultImage',
                    include: [{
                            model: Media_entity_1.Media,
                            as: 'image'
                        }]
                }
            ]
        }
    }))
], Product);
exports.Product = Product;
//# sourceMappingURL=Product.entity.js.map