'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var ProductCategory_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductCategory = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const ProductGroup_entity_1 = require("./ProductGroup.entity");
const Validation_exception_1 = require("./../../../middleware/exception/Validation.exception");
const tableOptions = { timestamp: true, tableName: 'tblProductCategories' };
let ProductCategory = ProductCategory_1 = class ProductCategory extends sequelize_typescript_1.Model {
    static async makeUniqueValidation(instance) {
        let options = {
            where: {
                productCategorie: {
                    $ilike: instance.productCategorie.trim()
                },
                productGroupId: instance.productGroupId,
                deletedAt: null
            }
        };
        if (instance.productCategorieId) {
            options['where']['productCategorieId'] = {
                $not: instance.productCategorieId
            };
        }
        if (await ProductCategory_1.count(options)) {
            throw new Validation_exception_1.ValidationException([{
                    value: instance.productCategorie.trim(),
                    property: 'productCategorie',
                    children: [],
                    constraints: { unique: 'validate:field:shouldBeUnique' }
                }]);
        }
    }
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProductCategory.prototype, "productCategorieId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => ProductGroup_entity_1.ProductGroup),
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.BIGINT,
        allowNull: false,
        unique: { name: 'productCategories', msg: 'validate:field:shouldBeUnique' }
    }),
    __metadata("design:type", Number)
], ProductCategory.prototype, "productGroupId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => ProductGroup_entity_1.ProductGroup),
    __metadata("design:type", ProductGroup_entity_1.ProductGroup)
], ProductCategory.prototype, "productGroup", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.CHAR(255),
        allowNull: false,
        unique: { name: 'productCategories', msg: 'validate:field:shouldBeUnique' }
    }),
    __metadata("design:type", String)
], ProductCategory.prototype, "productCategorie", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], ProductCategory.prototype, "isActive", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProductCategory.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProductCategory.prototype, "createdAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProductCategory.prototype, "updatedAt", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], ProductCategory.prototype, "businessType", void 0);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    sequelize_typescript_1.BeforeUpdate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [ProductCategory]),
    __metadata("design:returntype", Promise)
], ProductCategory, "makeUniqueValidation", null);
ProductCategory = ProductCategory_1 = __decorate([
    sequelize_typescript_1.Table(tableOptions),
    sequelize_typescript_1.Scopes(() => ({
        productCategoryInfo: {
            attributes: [['productCategorieId', 'id'], ['productCategorie', 'name']]
        },
        channelDetail: {
            attributes: ['productCategorieId', 'productGroupId', 'productCategorie', 'deletedAt', 'isActive']
        },
        contactProductInfom: {
            attributes: ['productCategorieId', 'productGroupId', 'productCategorie', 'isActive']
        },
        tradeinfo: {
            attributes: {
                include: [['productCategorieId', 'productCategorieId'], 'productGroupId', 'productCategorie', 'isActive'],
                exclude: ['deletedAt', 'createdAt', 'updatedAt']
            }
        },
        channelDetailList: {
            attributes: ['productCategorie']
        },
        excludeDeleted: {
            where: {
                deletedAt: null
            },
            attributes: ['productCategorieId', 'productGroupId', 'productCategorie', 'isActive']
        }
    }))
], ProductCategory);
exports.ProductCategory = ProductCategory;
//# sourceMappingURL=ProductCategory.entity.js.map