"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductEvaluation = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const SampleOrderDetail_entity_1 = require("../../order/models/SampleOrderDetail.entity");
const Product_entity_1 = require("./Product.entity");
const Contact_entity_1 = require("../../user/models/Contact.entity");
const ProductEvaluationRating_entity_1 = require("./ProductEvaluationRating.entity");
const Channel_entity_1 = require("../../channel/models/Channel.entity");
const tableOptions = { tableName: 'tblproductevaluation' };
let ProductEvaluation = class ProductEvaluation extends sequelize_typescript_1.Model {
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProductEvaluation.prototype, "productevaluationid", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    sequelize_typescript_1.ForeignKey(() => SampleOrderDetail_entity_1.SampleOrderDetail),
    __metadata("design:type", Number)
], ProductEvaluation.prototype, "sampleorderdetailid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => SampleOrderDetail_entity_1.SampleOrderDetail),
    __metadata("design:type", SampleOrderDetail_entity_1.SampleOrderDetail)
], ProductEvaluation.prototype, "sampleOrderDetail", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    sequelize_typescript_1.ForeignKey(() => Product_entity_1.Product),
    __metadata("design:type", Number)
], ProductEvaluation.prototype, "productid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Product_entity_1.Product),
    __metadata("design:type", Product_entity_1.Product)
], ProductEvaluation.prototype, "product", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    sequelize_typescript_1.ForeignKey(() => Contact_entity_1.Contact),
    __metadata("design:type", Number)
], ProductEvaluation.prototype, "evaluatedby", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Contact_entity_1.Contact),
    __metadata("design:type", Contact_entity_1.Contact)
], ProductEvaluation.prototype, "contact", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", String)
], ProductEvaluation.prototype, "review", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProductEvaluation.prototype, "createdat", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProductEvaluation.prototype, "updatedat", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProductEvaluation.prototype, "deletedat", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    __metadata("design:type", Number)
], ProductEvaluation.prototype, "channelid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel),
    __metadata("design:type", Channel_entity_1.Channel)
], ProductEvaluation.prototype, "channel", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ProductEvaluationRating_entity_1.ProductEvaluationRating, 'productevaluationid'),
    __metadata("design:type", Array)
], ProductEvaluation.prototype, "productEvaluationRating", void 0);
ProductEvaluation = __decorate([
    sequelize_typescript_1.Table(tableOptions),
    sequelize_typescript_1.Scopes(() => ({
        productInfo: {
            attributes: ['productevaluationid', 'productid', 'review', 'evaluatedby', 'createdat']
        }
    }))
], ProductEvaluation);
exports.ProductEvaluation = ProductEvaluation;
//# sourceMappingURL=ProductEvaluation.entity.js.map