'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var ProductGroup_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductGroup = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Validation_exception_1 = require("./../../../middleware/exception/Validation.exception");
const ProductCategory_entity_1 = require("./ProductCategory.entity");
const tableOptions = { timestamp: true, tableName: 'tblProductGroup' };
let ProductGroup = ProductGroup_1 = class ProductGroup extends sequelize_typescript_1.Model {
    static async makeUniqueValidation(instance) {
        let options = {
            where: {
                productGroup: {
                    $ilike: instance.productGroup.trim()
                },
                deletedAt: null
            }
        };
        if (instance.productGroupId) {
            options['where']['productGroupId'] = {
                $not: instance.productGroupId
            };
        }
        if (await ProductGroup_1.count(options)) {
            throw new Validation_exception_1.ValidationException([{
                    value: instance.productGroup.trim(),
                    property: 'productGroup',
                    children: [],
                    constraints: { unique: 'validate:field:shouldBeUnique' }
                }]);
        }
    }
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProductGroup.prototype, "productGroupId", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.CHAR(255),
        allowNull: false,
        unique: { name: 'productGroup', msg: 'validate:field:shouldBeUnique' }
    }),
    __metadata("design:type", String)
], ProductGroup.prototype, "productGroup", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], ProductGroup.prototype, "isActive", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProductGroup.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProductGroup.prototype, "createdAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProductGroup.prototype, "updatedAt", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], ProductGroup.prototype, "businessType", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ProductCategory_entity_1.ProductCategory),
    __metadata("design:type", Array)
], ProductGroup.prototype, "categories", void 0);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    sequelize_typescript_1.BeforeUpdate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [ProductGroup]),
    __metadata("design:returntype", Promise)
], ProductGroup, "makeUniqueValidation", null);
ProductGroup = ProductGroup_1 = __decorate([
    sequelize_typescript_1.Table(tableOptions),
    sequelize_typescript_1.Scopes(() => ({
        productInfo: {
            attributes: [['productGroupId', 'id'], ['productGroup', 'name']]
        },
        channelDetail: {
            attributes: ['productGroupId', 'productGroup', 'deletedAt', 'isActive']
        },
        contactProductInfom: {
            attributes: ['productGroupId', 'productGroup']
        },
        tradeinfo: {
            attributes: {
                include: [['productGroupId', 'productGroupId'], ['productGroup', 'productGroup'], ['isActive', 'isActive']],
                exclude: ['deletedAt', 'createdAt', 'updatedAt']
            }
        },
        channelDetailList: {
            attributes: ['productGroup']
        },
        excludeDeleted: {
            where: {
                deletedAt: null
            },
            attributes: ['productGroupId', 'productGroup', 'isActive']
        },
    }))
], ProductGroup);
exports.ProductGroup = ProductGroup;
//# sourceMappingURL=ProductGroup.entity.js.map