"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductPackageInfo = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Product_entity_1 = require("./Product.entity");
const Unit_entity_1 = require("./Unit.entity");
const tableOptions = { timestamps: false, tableName: 'tblproductpackageinfo' };
let ProductPackageInfo = class ProductPackageInfo extends sequelize_typescript_1.Model {
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProductPackageInfo.prototype, "productpackageinfoid", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Product_entity_1.Product),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProductPackageInfo.prototype, "productId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Product_entity_1.Product),
    __metadata("design:type", Array)
], ProductPackageInfo.prototype, "product", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.FLOAT(10, 2)),
    __metadata("design:type", Number)
], ProductPackageInfo.prototype, "minorderquantity", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Unit_entity_1.Unit),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProductPackageInfo.prototype, "orderunitid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Unit_entity_1.Unit, 'orderunitid'),
    __metadata("design:type", Unit_entity_1.Unit)
], ProductPackageInfo.prototype, "orderunitdetail", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.FLOAT(10, 2)),
    __metadata("design:type", Number)
], ProductPackageInfo.prototype, "packagesize", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Unit_entity_1.Unit),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProductPackageInfo.prototype, "packageunit", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Unit_entity_1.Unit, 'packageunit'),
    __metadata("design:type", Unit_entity_1.Unit)
], ProductPackageInfo.prototype, "packageunitdetail", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.FLOAT(10, 2)),
    __metadata("design:type", Number)
], ProductPackageInfo.prototype, "noofpackageinbox", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Unit_entity_1.Unit),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProductPackageInfo.prototype, "noofpackageinboxunitid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Unit_entity_1.Unit, 'noofpackageinboxunitid'),
    __metadata("design:type", Unit_entity_1.Unit)
], ProductPackageInfo.prototype, "noofpackageinboxunitdetail", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.FLOAT(10, 2)),
    __metadata("design:type", Number)
], ProductPackageInfo.prototype, "noofboxinpallet", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Unit_entity_1.Unit),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProductPackageInfo.prototype, "noofboxinpalletunitid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Unit_entity_1.Unit, 'noofboxinpalletunitid'),
    __metadata("design:type", Unit_entity_1.Unit)
], ProductPackageInfo.prototype, "noofboxinpalletunitdetail", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.FLOAT(10, 2)),
    __metadata("design:type", Number)
], ProductPackageInfo.prototype, "approximateweightofpallet", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Unit_entity_1.Unit),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProductPackageInfo.prototype, "approximateweightofpalletunitid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Unit_entity_1.Unit, 'approximateweightofpalletunitid'),
    __metadata("design:type", Unit_entity_1.Unit)
], ProductPackageInfo.prototype, "approximateweightofpalletunitdetail", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.FLOAT(10, 2)),
    __metadata("design:type", Number)
], ProductPackageInfo.prototype, "length", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.FLOAT(10, 2)),
    __metadata("design:type", Number)
], ProductPackageInfo.prototype, "breadth", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.FLOAT(10, 2)),
    __metadata("design:type", Number)
], ProductPackageInfo.prototype, "height", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.FLOAT(10, 2)),
    __metadata("design:type", Number)
], ProductPackageInfo.prototype, "weight", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProductPackageInfo.prototype, "updatedby", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProductPackageInfo.prototype, "createdat", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProductPackageInfo.prototype, "updatedat", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProductPackageInfo.prototype, "deletedat", void 0);
ProductPackageInfo = __decorate([
    sequelize_typescript_1.Table(tableOptions),
    sequelize_typescript_1.Scopes(() => ({
        productInfo: {
            attributes: ['productpackageinfoid', 'productId', 'minorderquantity', 'orderunitid', 'packagesize', 'packageunit', 'noofboxinpallet', 'noofboxinpalletunitid', 'noofpackageinbox', 'noofpackageinboxunitid', 'approximateweightofpallet', 'approximateweightofpalletunitid', 'length', 'breadth', 'height', 'weight', 'updatedby', 'deletedat']
        }
    }))
], ProductPackageInfo);
exports.ProductPackageInfo = ProductPackageInfo;
//# sourceMappingURL=ProductPackageInfo.entity.js.map