"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductPriceDetail = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Product_entity_1 = require("./Product.entity");
const Currency_entity_1 = require("../../channel/models/Currency.entity");
const Unit_entity_1 = require("./Unit.entity");
const DiscountUnit_entity_1 = require("./DiscountUnit.entity");
const tableOptions = { timestamps: false, tableName: 'tblproductpricedetail' };
let ProductPriceDetail = class ProductPriceDetail extends sequelize_typescript_1.Model {
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProductPriceDetail.prototype, "productpricedetailid", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Product_entity_1.Product),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProductPriceDetail.prototype, "productId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Product_entity_1.Product),
    __metadata("design:type", Array)
], ProductPriceDetail.prototype, "product", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Currency_entity_1.Currency),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProductPriceDetail.prototype, "businesscurrencyid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Currency_entity_1.Currency),
    __metadata("design:type", Currency_entity_1.Currency)
], ProductPriceDetail.prototype, "businesscurrency", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.FLOAT(15, 2)),
    __metadata("design:type", Number)
], ProductPriceDetail.prototype, "retailerprice", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Unit_entity_1.Unit),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProductPriceDetail.prototype, "retailerpriceunitid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Unit_entity_1.Unit, 'retailerpriceunitid'),
    __metadata("design:type", Unit_entity_1.Unit)
], ProductPriceDetail.prototype, "retailerpriceunitdetail", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], ProductPriceDetail.prototype, "issamplefree", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.FLOAT(15, 2)),
    __metadata("design:type", Number)
], ProductPriceDetail.prototype, "sampleprice", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Unit_entity_1.Unit),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProductPriceDetail.prototype, "samplepriceunitid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Unit_entity_1.Unit, 'samplepriceunitid'),
    __metadata("design:type", Unit_entity_1.Unit)
], ProductPriceDetail.prototype, "samplepriceunitdetail", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType["DOUBLE PRECISION"]),
    __metadata("design:type", Number)
], ProductPriceDetail.prototype, "distributormarginpercent", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => DiscountUnit_entity_1.DiscountUnit),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProductPriceDetail.prototype, "distributormarginpercentunitid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => DiscountUnit_entity_1.DiscountUnit, 'distributormarginpercentunitid'),
    __metadata("design:type", DiscountUnit_entity_1.DiscountUnit)
], ProductPriceDetail.prototype, "distributorunitdetail", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType["DOUBLE PRECISION"]),
    __metadata("design:type", Number)
], ProductPriceDetail.prototype, "retailermarginpercent", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => DiscountUnit_entity_1.DiscountUnit),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProductPriceDetail.prototype, "retailermarginpercentunitid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => DiscountUnit_entity_1.DiscountUnit, 'retailermarginpercentunitid'),
    __metadata("design:type", DiscountUnit_entity_1.DiscountUnit)
], ProductPriceDetail.prototype, "retailerunitdetail", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.FLOAT(15, 2)),
    __metadata("design:type", Number)
], ProductPriceDetail.prototype, "samplethreshold", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], ProductPriceDetail.prototype, "isunlimitsample", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ProductPriceDetail.prototype, "updatedby", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProductPriceDetail.prototype, "createdat", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProductPriceDetail.prototype, "updatedat", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ProductPriceDetail.prototype, "deletedat", void 0);
ProductPriceDetail = __decorate([
    sequelize_typescript_1.Table(tableOptions),
    sequelize_typescript_1.Scopes(() => ({
        productInfo: {
            attributes: ['productpricedetailid', 'productId', 'businesscurrencyid', 'retailerprice', 'retailerpriceunitid', 'issamplefree', 'sampleprice', 'samplepriceunitid', 'distributormarginpercent', 'distributormarginpercentunitid', 'retailermarginpercent', 'retailermarginpercentunitid', 'samplethreshold', 'isunlimitsample', 'updatedby', 'deletedat']
        },
        productExclude: {
            attributes: {
                exclude: ['deletedat', 'createdat', 'updatedat', 'updatedby']
            }
        },
        productPriceInfo: {
            attributes: {
                exclude: ['deletedat', 'createdat', 'updatedat', 'updatedby']
            },
            include: [
                {
                    model: Unit_entity_1.Unit,
                    as: 'retailerpriceunitdetail'
                },
                {
                    model: Unit_entity_1.Unit,
                    as: 'distributorunitdetail'
                },
                {
                    model: Unit_entity_1.Unit,
                    as: 'retailerunitdetail'
                }
            ]
        }
    }))
], ProductPriceDetail);
exports.ProductPriceDetail = ProductPriceDetail;
//# sourceMappingURL=ProductPriceDetail.entity.js.map