"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SpotDeals = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Channel_entity_1 = require("../../channel/models/Channel.entity");
const SpotDealBrand_entity_1 = require("./SpotDealBrand.entity");
const SpotDealImages_entity_1 = require("./SpotDealImages.entity");
const Media_entity_1 = require("./../../media/models/Media.entity");
const Unit_entity_1 = require("./Unit.entity");
const Currency_entity_1 = require("../../channel/models/Currency.entity");
var Sequelize = require('sequelize');
const tableOptions = { timestamp: true, tableName: 'tblSpotDeals' };
let SpotDeals = class SpotDeals extends sequelize_typescript_1.Model {
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SpotDeals.prototype, "id", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], SpotDeals.prototype, "product", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(500)),
    __metadata("design:type", String)
], SpotDeals.prototype, "productcategory", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SpotDeals.prototype, "channelId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel),
    __metadata("design:type", Channel_entity_1.Channel)
], SpotDeals.prototype, "brand", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(500)),
    __metadata("design:type", String)
], SpotDeals.prototype, "keywords", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(6000)),
    __metadata("design:type", String)
], SpotDeals.prototype, "spotdealdesc", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SpotDeals.prototype, "quantity", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Unit_entity_1.Unit),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SpotDeals.prototype, "samplepriceunitid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Unit_entity_1.Unit, 'samplepriceunitid'),
    __metadata("design:type", Unit_entity_1.Unit)
], SpotDeals.prototype, "samplepriceunitdetail", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.FLOAT(15, 2)),
    __metadata("design:type", Number)
], SpotDeals.prototype, "price", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Currency_entity_1.Currency),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SpotDeals.prototype, "businesscurrencyid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Currency_entity_1.Currency),
    __metadata("design:type", Currency_entity_1.Currency)
], SpotDeals.prototype, "businesscurrency", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], SpotDeals.prototype, "startduration", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], SpotDeals.prototype, "endduration", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(6000)),
    __metadata("design:type", String)
], SpotDeals.prototype, "shippingdetail", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(6000)),
    __metadata("design:type", String)
], SpotDeals.prototype, "paymentdetail", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(6000)),
    __metadata("design:type", String)
], SpotDeals.prototype, "productlocation", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Media_entity_1.Media),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], SpotDeals.prototype, "spotimageid", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Media_entity_1.Media),
    __metadata("design:type", Media_entity_1.Media)
], SpotDeals.prototype, "image", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => SpotDealBrand_entity_1.SpotDealBrand, 'spotId'),
    __metadata("design:type", Array)
], SpotDeals.prototype, "spotBrand", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => SpotDealImages_entity_1.SpotDealImages, 'spotId'),
    __metadata("design:type", Array)
], SpotDeals.prototype, "spotImage", void 0);
SpotDeals = __decorate([
    sequelize_typescript_1.Table(tableOptions)
], SpotDeals);
exports.SpotDeals = SpotDeals;
//# sourceMappingURL=SpotDeals.entity.js.map