"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductModule = void 0;
const common_1 = require("@nestjs/common");
const database_providers_1 = require("../../core/database/database.providers");
const media_module_1 = require("../media/media.module");
const product_controller_1 = require("./controller/product.controller");
const brand_providers_1 = require("./provider/brand.providers");
const product_providers_1 = require("./provider/product.providers");
const evaluation_providers_1 = require("./provider/evaluation.providers");
const productGroup_providers_1 = require("./provider/productGroup.providers");
const product_service_1 = require("./service/product.service");
const channel_service_1 = require("../channel/service/channel.service");
const channel_provider_1 = require("../channel/provider/channel.provider");
const subscription_provider_1 = require("../channel/provider/subscription.provider");
const SignUpStatus_providers_1 = require("../user/provider/SignUpStatus.providers");
const settting_provider_1 = require("../channel/provider/settting.provider");
const channelHub_provider_1 = require("../channel/provider/channelHub.provider");
const channelKeyPartner_service_1 = require("../channel/service/channelKeyPartner.service");
const common_provider_1 = require("../common/provider/common.provider");
const location_provider_1 = require("../common/provider/location.provider");
const rejectReason_service_1 = require("./service/rejectReason.service");
const reject_controller_1 = require("./controller/reject.controller");
const unit_controller_1 = require("./controller/unit.controller");
const unit_services_1 = require("./service/unit.services");
const productImport_controller_1 = require("./controller/productImport.controller");
const productImport_service_1 = require("./service/productImport.service");
const public_product_controller_1 = require("./controller/public.product.controller");
const subscription_provider_2 = require("../channel/provider/subscription.provider");
const product_admin_controller_1 = require("./controller/product.admin.controller");
const product_admin_service_1 = require("./service/product.admin.service");
let ProductModule = class ProductModule {
};
ProductModule = __decorate([
    common_1.Module({
        controllers: [product_controller_1.ProductController, reject_controller_1.RejectController, unit_controller_1.UnitController, productImport_controller_1.ProductImportController, public_product_controller_1.PublicProductController, product_admin_controller_1.ProductAdminController],
        imports: [media_module_1.MediaModule],
        providers: [product_service_1.ProductService,
            channel_service_1.ChannelService,
            channelKeyPartner_service_1.ChannelKeyPartnerService,
            rejectReason_service_1.RejectReasonService,
            unit_services_1.UnitService,
            productImport_service_1.ProductImportService,
            product_admin_service_1.ProductAdminService,
            ...product_providers_1.productJctProvider,
            ...channel_provider_1.channelProvider,
            ...product_providers_1.productProvider, ...database_providers_1.databaseProviders,
            ...product_providers_1.productAwardProvider,
            ...subscription_provider_1.SubscriptionProviders,
            ...channel_provider_1.PaymentOptionTypeProvider,
            ...productGroup_providers_1.ProductRejectProviders,
            ...SignUpStatus_providers_1.SignUpStatusProviders,
            ...productGroup_providers_1.RejectReasonProviders,
            ...channel_provider_1.ChannelSubscriptionProviders,
            ...settting_provider_1.settingProvider,
            ...channelHub_provider_1.ContactJCTProvider,
            ...channel_provider_1.channelCertificateTypeProvider,
            ...subscription_provider_1.SubscriptionPlanProviders,
            ...channel_provider_1.PaymentTermProvider,
            ...common_provider_1.CountryProviders,
            ...location_provider_1.RegionCountryJCTProvider,
            ...productGroup_providers_1.productGroupProviders,
            ...product_providers_1.ProductMediaLibraryProvider,
            ...brand_providers_1.brandProvider,
            ...product_providers_1.ProfileProgressProvider,
            ...product_providers_1.awardResultProvider,
            ...product_providers_1.productDetailProvider,
            ...product_providers_1.productTagProvider,
            ...product_providers_1.productArticleReviewProvider,
            ...product_providers_1.productExistRatingProvider,
            ...product_providers_1.discountUnitProvider,
            ...product_providers_1.productChannelCustomerProfileProvider,
            ...product_providers_1.productCompetingProvider,
            ...product_providers_1.productImageProvider,
            ...product_providers_1.productKeyPartnerJCTProvider,
            ...product_providers_1.productLocationProvider,
            ...product_providers_1.productPackageInfoProvider,
            ...product_providers_1.productPriceDetailProvider,
            ...product_providers_1.productSharePreferenceProvider,
            ...product_providers_1.productUniversalCodeProvider,
            ...product_providers_1.unitProvider,
            ...product_providers_1.channelTypeProvider,
            ...product_providers_1.profileTypeProvider,
            ...product_providers_1.profileTypeClassificationProvider,
            ...evaluation_providers_1.productEvaluationProvider,
            ...evaluation_providers_1.productEvaluationRatingProvider,
            ...channel_provider_1.sharetypeProvider,
            ...channel_provider_1.channelProductCategorieProvider,
            ...channel_provider_1.CompanyMediaImagesProvider,
            ...subscription_provider_2.SubscriptionExtraFeatureProviders
        ],
        exports: [product_service_1.ProductService, ...brand_providers_1.brandProvider, ...evaluation_providers_1.productEvaluationProvider,
            ...evaluation_providers_1.productEvaluationRatingProvider, ...product_providers_1.productProvider]
    })
], ProductModule);
exports.ProductModule = ProductModule;
//# sourceMappingURL=product.module.js.map