'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductService = void 0;
const common_1 = require("@nestjs/common");
const Product_entity_1 = require("../models/Product.entity");
const Channel_entity_1 = require("../../channel/models/Channel.entity");
const index_1 = require("../../media/models/index");
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
const productSerivceInBound_1 = require("../transformation/productSerivceInBound");
const Wishlist_entity_1 = require("./../../wishlist/models/Wishlist.entity");
const lodash_1 = require("lodash");
const _ = require("lodash");
const app_constant_1 = require("../../../config/app.constant");
const ProfileList_entity_1 = require("../../channel/models/ProfileList.entity");
const sequelize_1 = require("sequelize");
const utility_1 = require("../../channel/helper/utility");
const tradeInformationInBound_1 = require("../../channel/transformation/tradeInformationInBound");
const ProductKeyPartnerJCT_entity_1 = require("../models/ProductKeyPartnerJCT.entity");
const features_constants_1 = require("../../../config/features.constants");
const base_service_1 = require("../../../core/service/base.service");
const channel_service_1 = require("../../channel/service/channel.service");
const Contact_entity_1 = require("../../user/models/Contact.entity");
const ChannelCustomerProfile_entity_1 = require("../../channel/models/ChannelCustomerProfile.entity");
const ProfileTypeClassification_entity_1 = require("../../channel/models/ProfileTypeClassification.entity");
const ProfileType_entity_1 = require("../../channel/models/ProfileType.entity");
const RegionCountryJCT_entity_1 = require("../../common/models/RegionCountryJCT.entity");
const Auth_exception_1 = require("../../../middleware/exception/Auth.exception");
const DashboardReport_entity_1 = require("../../channel/models/DashboardReport.entity");
const Dashboard_entity_1 = require("../../channel/models/Dashboard.entity");
const SubscriptionExtraFeature_entity_1 = require("../../channel/models/SubscriptionExtraFeature.entity");
let fs = require('fs');
let path = require("path");
let ProductService = class ProductService extends base_service_1.BaseService {
    constructor(channelService, productCategoryRepository, productGroupRepository, brandRepository, sequelizeInstance, productRepository, profileRepository, channelRepository, productPriceDetailRepository, productImageRepository, mediaRepository, productDetailRepository, productTagRepository, productArticleReviewRepository, productExistRatingRepository, productSharePreferenceRepository, productUniversalCodeRepository, productPackageInfoRepository, productChannelCustomerProfileRepository, productLocationRepository, productMediaLibraryRepository, channelSubscriptionRepository, subscriptionRepository, subscriptionPlanRepository, countryRepository, regionCountryJCTRepository, paymentOptionTypeRepository, paymentTermRepository, unitRepository, discountUnitRepository, profileTypeClassificationRepository, profileTypeRepository, channelTypeRepository, channelCustomerProfileRepository, productAwardRepository, productJctRepository, subscriptionExtraFeatureRepository) {
        super();
        this.channelService = channelService;
        this.productCategoryRepository = productCategoryRepository;
        this.productGroupRepository = productGroupRepository;
        this.brandRepository = brandRepository;
        this.sequelizeInstance = sequelizeInstance;
        this.productRepository = productRepository;
        this.profileRepository = profileRepository;
        this.channelRepository = channelRepository;
        this.productPriceDetailRepository = productPriceDetailRepository;
        this.productImageRepository = productImageRepository;
        this.mediaRepository = mediaRepository;
        this.productDetailRepository = productDetailRepository;
        this.productTagRepository = productTagRepository;
        this.productArticleReviewRepository = productArticleReviewRepository;
        this.productExistRatingRepository = productExistRatingRepository;
        this.productSharePreferenceRepository = productSharePreferenceRepository;
        this.productUniversalCodeRepository = productUniversalCodeRepository;
        this.productPackageInfoRepository = productPackageInfoRepository;
        this.productChannelCustomerProfileRepository = productChannelCustomerProfileRepository;
        this.productLocationRepository = productLocationRepository;
        this.productMediaLibraryRepository = productMediaLibraryRepository;
        this.channelSubscriptionRepository = channelSubscriptionRepository;
        this.subscriptionRepository = subscriptionRepository;
        this.subscriptionPlanRepository = subscriptionPlanRepository;
        this.countryRepository = countryRepository;
        this.regionCountryJCTRepository = regionCountryJCTRepository;
        this.paymentOptionTypeRepository = paymentOptionTypeRepository;
        this.paymentTermRepository = paymentTermRepository;
        this.unitRepository = unitRepository;
        this.discountUnitRepository = discountUnitRepository;
        this.profileTypeClassificationRepository = profileTypeClassificationRepository;
        this.profileTypeRepository = profileTypeRepository;
        this.channelTypeRepository = channelTypeRepository;
        this.channelCustomerProfileRepository = channelCustomerProfileRepository;
        this.productAwardRepository = productAwardRepository;
        this.productJctRepository = productJctRepository;
        this.subscriptionExtraFeatureRepository = subscriptionExtraFeatureRepository;
        this.productServiceInBound = new productSerivceInBound_1.ProductSerivceInBound();
        this.tradeInformationInBound = new tradeInformationInBound_1.TradeInformationInBound();
        this.utility = new utility_1.Utility();
    }
    async addProduct(addProductDto, user, ratingId, subscriptionFeatureKeys, importFlag) {
        let product = "";
        let productUpdate = "";
        let result = { error: true };
        let key = +user.channel.subscriptionId + '-' + +features_constants_1.features.PRODUCT_SHEET;
        if (subscriptionFeatureKeys && subscriptionFeatureKeys[key]) {
            let productCount = await this.productRepository.count({ where: { channelId: +user.channelId, deletedat: null } });
            if (productCount >= +subscriptionFeatureKeys[key]) {
                throw new Process_exception_1.ProcessException({ message: 'Based on your Subscription, you are eligible to add ' + +subscriptionFeatureKeys[key] + ' products. Already you have ' + productCount + ' products.', eligibleCount: subscriptionFeatureKeys[key], exitCount: productCount });
            }
        }
        key = +user.channel.subscriptionId + '-' + +features_constants_1.features.PRODUCT_VIDEO_BY_SHEET;
        if (subscriptionFeatureKeys && subscriptionFeatureKeys[key]) {
            let videoUrl = (addProductDto.productImages && addProductDto.productImages.videourl && addProductDto.productImages.videourl.length > 0);
            if (!subscriptionFeatureKeys[key] && videoUrl) {
                throw new Process_exception_1.ProcessException({ message: 'Based on your Subscription, you are not eligible to add videos in product.' });
            }
        }
        let productObject = await this.productServiceInBound.setProductObject(addProductDto, user);
        productUpdate = await this.sequelizeInstance.transaction(async (transaction) => {
            product = await this.productRepository.create(productObject, {
                include: [
                    {
                        model: this.productDetailRepository
                    },
                    {
                        model: this.productTagRepository
                    },
                    {
                        model: this.productImageRepository,
                        as: "productImage",
                        include: [
                            {
                                model: this.mediaRepository
                            }
                        ]
                    },
                    {
                        model: this.productSharePreferenceRepository
                    },
                    {
                        model: this.productUniversalCodeRepository
                    },
                    {
                        model: this.productArticleReviewRepository,
                        include: [
                            {
                                model: this.mediaRepository
                            }
                        ]
                    },
                    {
                        model: this.productExistRatingRepository,
                        include: [
                            {
                                model: this.mediaRepository
                            }
                        ]
                    },
                    {
                        model: this.productPriceDetailRepository
                    },
                    {
                        model: this.productPackageInfoRepository
                    },
                    {
                        model: this.productChannelCustomerProfileRepository
                    }
                ],
                transaction,
            });
            if (addProductDto.productBrochure && addProductDto.productBrochure.productpdf && addProductDto.productBrochure.productpdf.length > 0) {
                let broucher = [];
                addProductDto.productBrochure.productpdf.map(x => {
                    broucher.push({ imageid: x.imageid,
                        productimagetype: app_constant_1.appconstant.PRODUCT_BROUCHER_IMAGE_TYPE,
                        name: lodash_1.defaultTo(x.documentName, ''),
                        description: lodash_1.defaultTo(x.documentDescription, ''),
                        updatedby: +user.userId,
                        createdat: new Date(),
                        productId: product.productId
                    });
                });
                await this.productImageRepository.bulkCreate(broucher, { returning: true, transaction });
            }
            if (addProductDto.award_details && Object.keys(addProductDto.award_details).length > 0) {
                for (let ii = 0; ii < addProductDto.award_details.length; ii++) {
                    if (addProductDto.award_details[ii].image) {
                        let media = {};
                        media.documentTypeId = app_constant_1.appconstant.DOCUMENTTYPE_IMAGE;
                        media.documentPath = (addProductDto.award_details[ii].image) ? addProductDto.award_details[ii].image : null;
                        media.dirName = app_constant_1.appconstant.FOLDER_PATH_PRODUCT_AWARDS;
                        let logo = await this.imageCreate(media, transaction);
                        addProductDto.award_details[ii].imageId = logo.documentId;
                    }
                    else {
                        addProductDto.award_details[ii].imageId = null;
                    }
                    await this.productAwardRepository.create({
                        productId: product.productId,
                        awardDetail: 'product',
                        issuedBy: 'ch',
                        documentId: (+addProductDto.award_details[ii].imageId > 0) ? +addProductDto.award_details[ii].imageId : null
                    }, {
                        transaction
                    });
                }
            }
            await this.productLocationRepository.bulkCreate(lodash_1.map(productObject.productLocation, (locitem) => {
                return lodash_1.assign(locitem, { "productId": +product.productId });
            }), {
                transaction
            });
            let productUpdateObject = await this.productServiceInBound.setProductUpdateObject(addProductDto, product);
            if (product.isactive == '1') {
                await this.productImageRepository.count({
                    where: {
                        productId: product.productId,
                        deletedat: null,
                        productimagetype: {
                            [sequelize_1.Op.in]: [app_constant_1.appconstant.PRODUCT_IMAGE_TYPE]
                        },
                    },
                    group: ['productimagetype'],
                    transaction
                }).then((count) => {
                    if (count && count.length != 1) {
                        productUpdateObject.isactive = '0';
                    }
                });
            }
            productUpdate = await this.productRepository.update(productUpdateObject, {
                where: { productId: product.productId },
                returning: true,
                transaction
            });
            if (+ratingId != 0) {
                await this.profileRepository.create({
                    channelId: user.channelId,
                    ratingId: ratingId,
                    isCompleted: true,
                    createdAt: new Date()
                }, { transaction });
            }
            return productUpdate;
        }).then(async (productUpdate) => {
            return productUpdate;
        }).catch(function (e) {
            console.log("Error+", e);
            if (importFlag) {
                return false;
            }
            else {
                throw new Process_exception_1.ProcessException(e.message);
            }
        });
        if (productUpdate) {
            if (productUpdate[1] && productUpdate[1][0]) {
                let productReturnData = productUpdate[1][0];
                productUpdate = await this.setProductDefaultImage(productReturnData);
                await this.updateKeyRetailers(productReturnData, addProductDto, user, app_constant_1.appconstant.CHANNEL_TYPE_RETAILER);
                await this.updateKeyRetailers(productReturnData, addProductDto, user, app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR);
                result = { success: true, data: productReturnData };
            }
        }
        else {
            result = productUpdate;
        }
        return result;
    }
    async setProductDefaultImage(product) {
        let productDefaultImage = {};
        let productDefaultImageId = "";
        try {
            productDefaultImage = await this.productImageRepository.scope('productInfo').findOne({
                where: { productId: parseInt(product.productId), productimagetype: app_constant_1.appconstant.PRODUCT_IMAGE_TYPE, isdefault: '1', deletedat: null }
            });
            if (productDefaultImage) {
                if (productDefaultImage && productDefaultImage.productimageid) {
                    productDefaultImageId = productDefaultImage.productimageid;
                    product.defaultimageid = productDefaultImageId;
                    await product.save();
                }
            }
        }
        catch (e) {
            console.log("Error+ setProductDefaultImage", e);
            throw new Process_exception_1.ProcessException(e.message);
        }
        return product;
    }
    async updateKeyRetailers(product, dto, user, partner_type) {
        let keyRetailers = await this.getKeyRetailerIds(+product.channelId, partner_type);
        let dtoKeyPartners = (+partner_type == +app_constant_1.appconstant.CHANNEL_TYPE_RETAILER) ? dto.keyRetailers : (+partner_type == +app_constant_1.appconstant.CHANNEL_TYPE_RESELLER) ? dto.keyResellers : dto.keyDistributors;
        let dtoDeleteKeyPartners = (+partner_type == +app_constant_1.appconstant.CHANNEL_TYPE_RETAILER) ? dto.deletedkeyretailer : (+partner_type == +app_constant_1.appconstant.CHANNEL_TYPE_RESELLER) ? dto.deletedkeyreseller : dto.deletedkeydistributor;
        if (dtoKeyPartners) {
            var receivedNewKeyRetailers = await this.tradeInformationInBound.keyRetailers(partner_type, dtoKeyPartners, +product.channelId, +user.userId);
            let validRetailers = lodash_1.map(lodash_1.filter(dtoKeyPartners, (key) => {
                return (key.keypartnerid && keyRetailers.includes('' + key.keypartnerid));
            }), 'keypartnerid');
            await ProductKeyPartnerJCT_entity_1.ProductKeyPartnerJCT.destroy({
                where: {
                    productid: product.productId,
                    keypartnerid: {
                        [sequelize_1.Op.in]: keyRetailers
                    }
                }
            }).then(async () => {
                let keyretailers = [];
                validRetailers.forEach((retailer) => {
                    keyretailers.push({
                        productid: +product.productId,
                        channelid: +product.channelId,
                        keypartnerid: retailer
                    });
                });
                console.log(receivedNewKeyRetailers);
                if (receivedNewKeyRetailers.length > 0) {
                    receivedNewKeyRetailers.forEach((retailer) => {
                        keyretailers.push({
                            productid: +product.productId,
                            channelid: +product.channelId,
                            keypartnerid: retailer
                        });
                    });
                }
                if (keyretailers) {
                    await ProductKeyPartnerJCT_entity_1.ProductKeyPartnerJCT.bulkCreate(keyretailers);
                }
            });
        }
        else if (dtoDeleteKeyPartners) {
            let validDeletedRetailers = lodash_1.filter(dtoDeleteKeyPartners, (key) => {
                return keyRetailers.includes('' + key);
            });
            await ProductKeyPartnerJCT_entity_1.ProductKeyPartnerJCT.destroy({
                where: {
                    productid: product.productId,
                    keypartnerid: {
                        [sequelize_1.Op.in]: validDeletedRetailers
                    }
                }
            });
        }
    }
    async getKeyRetailerIds(channelId, partnerType) {
        return await this.sequelizeInstance.query('select array_agg(keypartnerid) as ids from "tblKeyPartnerJCT" where channelid = :channelId and partner_type = :partnerType and deletedat is null', {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: channelId,
                partnerType: partnerType
            }
        }).then((result) => {
            return (result[0].ids) ? result[0].ids : [];
        });
    }
    async saveBrand(brandObject, transaction) {
        return await this.brandRepository.create(brandObject, {
            transaction
        }).catch((e) => {
            throw new Process_exception_1.ProcessException('validate:sql:internalError');
        });
    }
    async saveProductMediaLib(productImage, channelId, type) {
        let document;
        try {
            let libObject = {};
            if (productImage.documentpath && type == 4) {
                return this.sequelizeInstance.transaction(async (transaction) => {
                    let mediaObject = await this.setDocumentObject(productImage.documentpath, app_constant_1.appconstant.DOCUMENTTYPE_DOC, app_constant_1.appconstant.FOLDER_PATH_PRODUCT_BROUCHER);
                    document = await this.mediaRepository.create(mediaObject);
                    libObject.documentId = document.documentId;
                    libObject.libTypeId = 4;
                    libObject.createdAt = new Date();
                    libObject.channelId = channelId;
                    libObject.name = productImage.name;
                    let productMedia = await this.productMediaLibraryRepository.create(libObject);
                    let data = {
                        documentId: productMedia.documentId,
                        channelId: productMedia.channelId,
                        libTypeId: productMedia.libTypeId,
                        libId: productMedia.libId,
                        productId: productMedia.productId,
                        name: productMedia.name,
                        document: document
                    };
                    return data;
                });
            }
            return document;
        }
        catch (e) {
            console.log("Error+ ", e);
            throw new Process_exception_1.ProcessException("channel:");
        }
    }
    async deleteProductMediaLib(data) {
        return await this.productMediaLibraryRepository.update({
            deletedAt: Date()
        }, { where: {
                libId: +data.libId
            }
        });
    }
    async setDocumentObject(docTempPath, doctype, folderPath) {
        try {
            let mediaObject = {};
            mediaObject.documentPath = docTempPath;
            mediaObject.documentTypeId = doctype;
            mediaObject.dirName = folderPath ? folderPath : 'media';
            return mediaObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:media');
        }
    }
    async getBrochurMedialib(channelId) {
        return await this.productMediaLibraryRepository.findAll({
            where: {
                channelId: +channelId,
                deletedAt: null
            },
            include: [{
                    model: index_1.Media,
                    where: {
                        documentTypeId: 2,
                        deletedAt: null
                    },
                    required: true
                }],
            order: [['libId', 'DESC']]
        });
    }
    async imageCreate(image, transaction) {
        return await this.mediaRepository.create(image, {
            transaction,
        });
    }
    async getSuggestedProduct(ids, data, user) {
        let product = await this.productRepository.scope('productInfo').findAll({
            where: {
                deletedat: null,
                productId: {
                    [sequelize_1.Op.in]: ids
                }
            },
            include: [
                {
                    model: Wishlist_entity_1.Wishlist,
                    as: 'wishList',
                    attributes: ['productid'],
                    where: { userid: user.userId },
                    required: false,
                },
                {
                    model: this.productJctRepository,
                    as: 'productJCT',
                    attributes: ['rank'],
                    where: { requested_by: user.contactId },
                    required: false,
                },
                {
                    model: this.productImageRepository,
                    as: 'defaultImage',
                    attributes: ['productimageid', 'imageid', 'productimagetype', 'name', 'description'],
                    where: { deletedat: null },
                    required: false,
                    include: [{
                            model: this.mediaRepository,
                            attributes: ['documentUrl', 'documentPath'],
                            where: { deletedAt: null },
                            required: false,
                        }]
                },
                {
                    model: this.productAwardRepository,
                    attributes: ['awardDetail'],
                    required: false,
                    where: {
                        deletedAt: null,
                    },
                    include: [
                        {
                            model: this.mediaRepository,
                            attributes: ['documentPath'],
                            required: true,
                        }
                    ]
                },
                {
                    model: this.brandRepository,
                    attributes: ['brandName'],
                    required: false,
                    where: {
                        deletedAt: null,
                    },
                    include: [
                        {
                            model: this.mediaRepository,
                            attributes: ['documentPath'],
                            required: false,
                        }
                    ]
                },
            ]
        });
        return product;
    }
    async getProductAggr(data) {
        let product = await this.productRepository.findAll({
            attributes: ['product', 'productId'],
            where: {
                deletedat: null,
                productId: {
                    [sequelize_1.Op.in]: data
                }
            },
            include: [
                {
                    model: this.productGroupRepository,
                    as: 'productGroup',
                    attributes: ['productGroupId', 'productGroup'],
                    where: { deletedAt: null },
                    required: false,
                },
                {
                    model: this.productCategoryRepository,
                    as: 'productCategory',
                    attributes: ['productCategorieId', 'productCategorie'],
                    required: false,
                    where: {
                        deletedAt: null,
                    }
                },
                {
                    model: this.brandRepository,
                    attributes: ['brandName', 'id'],
                    required: false,
                    where: {
                        deletedAt: null,
                    },
                },
            ]
        });
        let brand = [];
        let category = [];
        let family = [];
        let profile = [];
        let location = [];
        let search = [];
        product.map(x => {
            search.push({ id: x.productId, name: x.product }),
                brand.push({ name: x.brand.brandName, id: x.brand.id });
            family.push({ name: x.productGroup.productGroup, id: x.productGroup.productGroupId });
            category.push({ name: x.productCategory.productCategorie, id: x.productCategory.productCategorieId });
        });
        let aggregation = {
            search: search,
            brand: _.uniqBy(brand, 'id'),
            category: _.uniqBy(category, 'id'),
            family: _.uniqBy(family, 'id'),
        };
        return aggregation;
    }
    async getSearchFilter(data) {
        let product = await this.productRepository.findAll({
            attributes: ['product', 'productId'],
            where: {
                deletedat: null,
                productId: {
                    [sequelize_1.Op.in]: data
                }
            }
        });
        let search = [];
        product.map(x => {
            search.push({ id: x.productId, name: x.product });
        });
        return search;
    }
    async getBrandFilter(data) {
        let product = await this.productRepository.findAll({
            attributes: ['product', 'productId'],
            where: {
                deletedat: null,
                productId: {
                    [sequelize_1.Op.in]: data
                }
            },
            include: [
                {
                    model: this.brandRepository,
                    attributes: ['brandName', 'id'],
                    required: false,
                    where: {
                        deletedAt: null,
                    },
                }
            ]
        });
        let brand = [];
        product.map(x => {
            brand.push({ name: x.brand.brandName, id: x.brand.id });
        });
        brand = _.uniqBy(brand, 'id');
        return brand;
    }
    async getCategoryFilter(data) {
        let productIds;
        try {
            if (data.length > 0) {
                let productcatquery = 'select pg."productGroupId" as groupId,pg."productGroup" as groupname,pc."productCategorieId" as childId,pc."productCategorie" as childname,cast(false as boolean) as status from "tblProductGroup" as pg inner join'
                    + ' "tblProductCategories" as pc on pg."productGroupId"=pc."productGroupId" and pc."productCategorieId" in '
                    + '(select cpc."productCategorieId" from "tblProduct" as cpc where "productId" in(:productId)) '
                    + 'where pg."deletedAt" is null and pg."productGroup"!=\'\' ';
                productIds = await this.sequelizeInstance.query(productcatquery, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        productId: data
                    }
                });
            }
        }
        catch (e) {
            console.log("productFilter:", e);
        }
        return productIds;
    }
    async getCategoryGuestFilter(data) {
        let productIds;
        try {
            if (data.length > 0) {
                let productcatquery = 'select pc."productCategorieId" as id,pc."productCategorie" as name from'
                    + ' "tblProductCategories" as pc where pc."productCategorieId" in '
                    + '(select cpc."productCategorieId" from "tblProduct" as cpc where "productId" in(:productId)) ';
                productIds = await this.sequelizeInstance.query(productcatquery, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        productId: data
                    }
                });
            }
        }
        catch (e) {
            console.log("productFilter:", e);
        }
        return productIds;
    }
    async getFamilyFilter(data) {
        let product = await this.productRepository.findAll({
            attributes: ['product', 'productId'],
            where: {
                deletedat: null,
                productId: {
                    [sequelize_1.Op.in]: data
                }
            },
            include: [
                {
                    model: this.productGroupRepository,
                    as: 'productGroup',
                    attributes: ['productGroupId', 'productGroup'],
                    where: { deletedAt: null },
                    required: false,
                }
            ]
        });
        let family = [];
        product.map(x => {
            family.push({ name: x.productGroup.productGroup, id: x.productGroup.productGroupId });
        });
        family = _.uniqBy(family, 'id');
        return family;
    }
    async getLocationFilter(data) {
        let location;
        try {
            if (data.length > 0) {
                let countryquery = 'select distinct on(cty."country")cty."country" as name,cty."countryId" as id from "tblproductlocation" as pl inner join "tblRegionCountryJCT" as rc on pl."regionCountryJCTId"=rc."regionCountryJCTId" '
                    + 'inner join "tblCountry" as cty  on cty."countryId"=rc."countryId" where pl."locationtype"=\'TARGET\' and pl."productId" in(:productid) and pl."deletedat" is null ';
                location = await this.sequelizeInstance.query(countryquery, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        productid: data
                    }
                });
            }
        }
        catch (e) {
            console.log("countryFilter:", e);
        }
        return location;
    }
    async getPriceFilter(data) {
        let priceRange;
        try {
            if (data.length > 0) {
                let pricequery = 'select min("retailerprice") as "minPrice",max("retailerprice") as "maxPrice" from "tblproductpricedetail" where "productId" in(:productid)';
                priceRange = await this.sequelizeInstance.query(pricequery, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        productid: data
                    }
                });
            }
        }
        catch (e) {
            console.log("countryFilter:", e);
        }
        return priceRange;
    }
    async getProfileFilter(data) {
        let product;
        try {
            if (data.length > 0) {
                let retailcustquery = 'Select distinct on(pt."profileType")pt."profileType" as name,pt."profileTypeId" as id,(select "channelTypeId" from "tblProfileTypeClassification" as pc where pc."profileTypeId"=pt."profileTypeId") from "tblProfileType" pt where "profileTypeId" not in(38,37) and "profileTypeId" in '
                    + '(select "profileTypeId" from "tblChannelCustomerProfile" where "channelId" in(:channelid) and "customerProfileId" in(select "customerProfileId" from "tblproductchannelcustomerprofile" where "channelId" in(:channelid))) order by pt."profileType" ';
                product = await this.sequelizeInstance.query(retailcustquery, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: data
                    }
                });
            }
        }
        catch (e) {
            console.log("retailFilter:", e);
        }
        return product;
    }
    async getProductSearch(data) {
        let product = await this.productRepository.findAll({
            attributes: ['product', 'productId'],
            where: {
                deletedat: null,
                productId: {
                    [sequelize_1.Op.in]: data
                }
            }
        });
        let search = [];
        product.map(x => {
            search.push({ id: x.productId, name: x.product });
        });
        return search;
    }
    async channelRejectedCheck(product, user) {
        return await this.validateRejectedChannels(+user.channelId, +product.channelId);
    }
    async getProduct(sku, user) {
        let product;
        try {
            product = await this.productRepository.scope('productInfo').findOne({
                include: [
                    {
                        model: this.productGroupRepository,
                        as: 'productGroup',
                        where: { deletedAt: null },
                        required: true
                    },
                    {
                        model: this.productCategoryRepository,
                        as: 'productCategory',
                        where: { deletedAt: null },
                        required: true
                    },
                    {
                        model: this.brandRepository,
                        where: { deletedAt: null },
                        include: [
                            {
                                model: this.mediaRepository,
                                where: { deletedAt: null },
                                required: false
                            }
                        ],
                        required: true
                    },
                    {
                        model: this.productDetailRepository.scope('productInfo'),
                        where: { deletedat: null },
                        required: true
                    },
                    {
                        model: this.productTagRepository.scope('productInfo'),
                        where: { deletedat: null },
                        required: false
                    },
                    {
                        model: this.productArticleReviewRepository.scope('productInfo'),
                        where: { deletedat: null },
                        include: [
                            {
                                model: this.mediaRepository,
                                where: { deletedAt: null },
                                required: false
                            }
                        ],
                        required: false,
                    },
                    {
                        model: this.productExistRatingRepository.scope('productInfo'),
                        where: { deletedat: null },
                        include: [
                            {
                                model: this.mediaRepository,
                                where: { deletedAt: null },
                                required: false
                            }
                        ],
                        required: false
                    },
                    {
                        model: this.productImageRepository.scope('productInfo'),
                        as: "productImage",
                        where: { deletedat: null },
                        include: [
                            {
                                model: this.mediaRepository,
                                where: { deletedAt: null },
                                required: false
                            }
                        ],
                        required: false
                    },
                    {
                        model: this.productImageRepository.scope('productInfo'),
                        as: "defaultImage",
                        where: { deletedat: null },
                        include: [
                            {
                                model: this.mediaRepository,
                                where: { deletedAt: null },
                                required: false
                            }
                        ],
                        required: false
                    },
                    {
                        model: this.productSharePreferenceRepository.scope('productInfo'),
                        where: { deletedat: null },
                        required: false
                    },
                    {
                        model: this.productUniversalCodeRepository.scope('productInfo'),
                        where: { deletedat: null },
                        required: false
                    },
                    {
                        model: this.productPriceDetailRepository.scope('productInfo'),
                        where: { deletedat: null },
                        required: true
                    },
                    {
                        model: this.productPackageInfoRepository.scope('productInfo'),
                        where: { deletedat: null },
                        required: false
                    },
                    {
                        model: this.productChannelCustomerProfileRepository.scope('productInfo'),
                        where: { deletedat: null },
                        required: false,
                        include: [
                            {
                                model: this.channelCustomerProfileRepository.scope('channelDetail'),
                                where: { deletedAt: null, profileTypeClassificationId: { [sequelize_1.Op.ne]: null } },
                                required: false,
                                include: [
                                    {
                                        model: this.profileTypeClassificationRepository.scope('profileTypeClassificationInfom'),
                                        where: { deletedAt: null },
                                        required: false,
                                        include: [
                                            {
                                                model: this.profileTypeRepository.scope('profileTypeInfom'),
                                                where: { deletedAt: null },
                                                required: false,
                                            },
                                            {
                                                model: this.channelTypeRepository.scope('channelTypeInfom')
                                            }
                                        ]
                                    }
                                ]
                            },
                        ]
                    }
                ],
                where: { productSKU: sku, deletedat: null }
            });
            console.log('product', product);
            if (!product) {
                throw new Process_exception_1.ProcessException('channel:product:notFound');
            }
            if (!product.productAwards) {
                await new utility_1.Utility().lazyload(product, 'productAwards', {
                    where: { deletedAt: null },
                    attributes: ['productAwardId', 'documentId', 'awardDetail', 'issuedBy', 'validUpto', 'isLifeTime'],
                    required: false,
                    include: [
                        {
                            model: index_1.Media,
                            attributes: ['documentId', 'documentPath', 'documentUrl'],
                            required: false
                        }
                    ]
                });
            }
            if (!product.productLocation) {
                await new utility_1.Utility().lazyload(product, 'productLocation', {
                    where: { deletedat: null },
                    include: [
                        {
                            model: this.regionCountryJCTRepository,
                            where: { deletedAt: null },
                            include: [
                                {
                                    model: this.countryRepository.scope('country'),
                                    where: { deletedAt: null },
                                    required: false
                                }
                            ],
                            required: false
                        }
                    ],
                    required: true
                });
            }
            if (!product.channel) {
                await new utility_1.Utility().lazyload(product, 'channel', {
                    attributes: ['channelId', 'companyName', 'channelTypeId', 'isOEM']
                });
            }
        }
        catch (e) {
            console.log("Error+ getProduct", e);
            throw new Process_exception_1.ProcessException(e.message);
        }
        if (!product) {
            throw new Process_exception_1.ProcessException('channel:product:notFound');
        }
        product.toJSON();
        product['other_info'] = {
            rating: 0,
            no_of_evaluations: 0,
            no_of_orders: 0
        };
        await Product_entity_1.Product.sequelize.query('select count(DISTINCT PE.sampleorderdetailid) as no_of_evaluations , avg(PER.rating) rating from tblproductevaluation PE inner join tblproductevaluationrating PER on PE.productevaluationid = PER.productevaluationid where PE.productid= :productId GROUP BY PE.productid', {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                productId: +product.productId
            }
        }).then((result) => {
            if (result[0]) {
                product['other_info']['rating'] = +Number.parseFloat(result[0].rating).toFixed(2);
                product['other_info']['no_of_evaluations'] = result[0].no_of_evaluations;
            }
        });
        await Product_entity_1.Product.sequelize.query('select count(DISTINCT SOD.sampleorderdetailid) as no_of_orders  from tblsampleorderdetail SOD where SOD.productid= :productId GROUP BY SOD.productid', {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                productId: +product.productId
            }
        }).then((result) => {
            if (result[0]) {
                product['other_info']['no_of_orders'] = result[0].no_of_orders;
            }
        });
        product['productKeyRetailer'] = await this.getProductKeyRetailers(product.channelId, product.productId, app_constant_1.appconstant.CHANNEL_TYPE_RETAILER);
        product['productKeyDistributor'] = await this.getProductKeyRetailers(product.channelId, product.productId, app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR);
        product['productKeyReseller'] = await this.getProductKeyRetailers(product.channelId, product.productId, app_constant_1.appconstant.CHANNEL_TYPE_RESELLER);
        product['unit'] = await this.unitRepository.findAll();
        console.log('productkeyret', product['productKeyRetailer'], product['productKeyDistributor']);
        if (user.userId != 5 && user.userId != 1) {
            let viewcount = await Dashboard_entity_1.Dashboard.count({
                where: {
                    user_id: user.userId,
                    channelid: product.channelId,
                    visitid: product.productId,
                    visittype: 2
                }
            });
            if (viewcount > 0) {
                await Dashboard_entity_1.Dashboard.update({ count: viewcount + 1 }, {
                    where: {
                        user_id: user.userId,
                        channelid: product.channelId,
                        visitid: product.productId,
                        visittype: 2
                    }
                });
            }
            else {
                let defaultData = {
                    user_id: user.userId,
                    channelid: product.channelId,
                    visitid: product.productId,
                    visittype: '2',
                    count: 1,
                    day: new Date().getDay(),
                    month: new Date().getMonth(),
                    year: new Date().getFullYear(),
                };
                await Dashboard_entity_1.Dashboard.create(defaultData);
            }
        }
        return product;
    }
    async getProductInfo(sku, user) {
        let product = await this.productRepository.scope('productInfo').findOne({
            include: [
                {
                    model: this.channelRepository.scope('channelDetail'),
                    where: { deletedAt: null },
                    include: [
                        { model: this.channelTypeRepository },
                        {
                            model: this.countryRepository.scope('regionCountryJCT'),
                            where: { deletedAt: null }
                        },
                        {
                            model: this.brandRepository,
                            where: { deletedAt: null },
                            include: [
                                {
                                    model: this.mediaRepository,
                                    where: { deletedAt: null },
                                    required: false
                                }
                            ],
                            required: false
                        },
                        {
                            model: this.channelSubscriptionRepository.scope('channelDetail'),
                            where: { isActive: '1' },
                            include: [
                                {
                                    model: this.subscriptionRepository.scope('channelDetail'),
                                    where: { deletedAt: null },
                                    include: [
                                        {
                                            model: this.subscriptionPlanRepository.scope('channelDetail'),
                                            where: { deletedAt: null }
                                        }
                                    ]
                                }
                            ],
                        },
                        {
                            model: this.paymentOptionTypeRepository,
                            as: "channelPaymentOptionType",
                            required: false,
                            through: {
                                attributes: []
                            }
                        },
                        {
                            model: this.paymentTermRepository,
                            as: "channelPaymentTerm",
                            required: false,
                            through: {
                                attributes: []
                            }
                        }
                    ]
                }
            ],
            where: { productSKU: sku, deletedat: null }
        });
        if (!product || (product && product.channelId != +user.channelId && product.isactive == '0' && user.channelTypeId != app_constant_1.appconstant.CHANNEL_TYPE_HUB)) {
            throw new Process_exception_1.ProcessException('channel:product:notFound');
        }
        let productJsonObject = product;
        let skip = true;
        let channelContactFilter = {};
        if (user.channelTypeId == Channel_entity_1.Channel.CHANNEL_TYPE_HUB || +user.channelId == +product.channelId) {
            skip = false;
        }
        if (skip) {
            let ChannelTypeId = product.channel.channelTypeId;
            if (ChannelTypeId == Channel_entity_1.Channel.CHANNEL_TYPE_VENDOR || (ChannelTypeId == Channel_entity_1.Channel.CHANNEL_TYPE_DISTRIBUTOR && user.channelTypeId == +Channel_entity_1.Channel.CHANNEL_TYPE_RETAILER)) {
                channelContactFilter.contactType = 'SELLING';
            }
            else if (ChannelTypeId == Channel_entity_1.Channel.CHANNEL_TYPE_RETAILER || (ChannelTypeId == Channel_entity_1.Channel.CHANNEL_TYPE_DISTRIBUTOR && user.channelTypeId == +Channel_entity_1.Channel.CHANNEL_TYPE_VENDOR)) {
                channelContactFilter.contactType = 'SOURCING';
            }
        }
        let contactId = await this.channelService.getDefaultContact(product.channelId, user, channelContactFilter);
        productJsonObject.channel.contact = await Contact_entity_1.Contact.scope('productInfo').findByPk(contactId, {
            include: [
                {
                    model: this.mediaRepository,
                    required: false,
                    attributes: ['documentPath']
                }
            ]
        });
        return productJsonObject;
    }
    async getProductBySKU(sku) {
        return await this.getProductByInfo({
            productSKU: sku,
        });
    }
    async getProductByInfo(where) {
        let product = await this.productRepository.findOne({
            where: Object.assign(where, {
                deletedat: null
            })
        });
        if (!product) {
            throw new common_1.NotFoundException('NotFound');
        }
        return product;
    }
    async getProductKeyRetailers(channelId, productId, partnerType) {
        return await this.sequelizeInstance.query('select * from "fnGetKeyPartnersbyChannelId"(:channelId, :partnerType, :productId, :cdnUrl)', {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: channelId,
                productId: productId,
                cdnUrl: process.env.CDN_URL,
                partnerType: partnerType
            }
        }).then((results) => {
            return results[0].fnGetKeyPartnersbyChannelId;
        });
    }
    async productActions(user, sku) {
        let wishlistQuery = 'select count(pw.productid) from "tblproductwishlist" pw inner join "tblProduct" p on p."productId" = pw.productid where channelgroupid is null and pw.type = \'WISHLIST\' and pw.userid = :userId and p."productSKU"= :productSKU';
        let wishlist = await this.sequelizeInstance.query(wishlistQuery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                productSKU: sku,
                userId: user.userId
            }
        }).then(result => {
            return !!(+result[0].count);
        });
        let cartQuery = 'select pq.quantity from "tblproductquote" pq inner join "tblProduct" p on p."productId" = pq.productid inner join "tblcart" c on c."cartid" = pq.cartid where pq.deletedAt is null and c.deletedAt is null and c.userid = :userId and p."productSKU"= :productSKU';
        let cart = await this.sequelizeInstance.query(cartQuery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                productSKU: sku,
                userId: user.userId
            }
        }).then(result => {
            return (result[0]) ? result[0].quantity : 0;
        });
        let evaluateQuery = 'select count(pe.productid) from "tblproductevaluation" pe inner join "tblProduct" p on p."productId" = pe.productid where pe.channelid = :cahnnelId and p."productSKU"= :productSKU';
        let evaluate = await this.sequelizeInstance.query(evaluateQuery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                productSKU: sku,
                cahnnelId: user.channelId
            }
        }).then(result => {
            return !!(+result[0].count);
        });
        let businessQuery = 'select count(pw.productid) from "tblproductwishlist" pw inner join "tblProduct" p on p."productId" = pw.productid where channelgroupid is null and pw.type = \'BUSINESS\' and pw.channelid = :cahnnelId and p."productSKU"= :productSKU';
        let business = await this.sequelizeInstance.query(businessQuery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                productSKU: sku,
                cahnnelId: user.channelId
            }
        }).then(result => {
            return !!(+result[0].count);
        });
        return {
            wishlist: wishlist,
            cart: +cart,
            evaluated: evaluate,
            business: business
        };
    }
    async setProductPublicView(data) {
        return await this.productRepository.update({ isPublic: data.isPublic }, {
            where: {
                productId: data.productId,
            }
        });
    }
    async setProductPublicFlags(data) {
        let save = {
            eco_friendly: data.eco_friendly,
            work_from_home: data.work_from_home,
            life_style: data.life_style,
            french_tech: data.french_tech,
            taiwan_excellence: data.taiwan_excellence,
            isFeatured: data.isFeatured,
            show_in_home_page: data.show_in_home_page,
            isPublic: data.isPublic
        };
        return await this.productRepository.update(save, {
            where: {
                productId: data.productId,
            }
        });
    }
    async setProductOrder(data) {
        data.map(async (x) => {
            await this.productRepository.update({ product_rank_order: x.order ? x.order : x.product_rank_order, updatedat: Date() }, {
                where: {
                    productId: x.productId,
                }
            });
        });
        return true;
    }
    async updateProduct(addProductDto, user, sku) {
        let productUpdate = "";
        let result = { error: true };
        let product = await this.getProduct(sku, user);
        if (+product.channelId != +user.channelId && user.userId != '1') {
            throw new Auth_exception_1.AuthException('Not allowed');
        }
        let productObject = await this.productServiceInBound.setUpdateProductObject(addProductDto, user, product);
        let productRelationObject = await this.productServiceInBound.setUpdateProductRelationObject(addProductDto, user, product);
        product = await this.sequelizeInstance.transaction(async (transaction) => {
            var activeIds = [];
            let productInfo = productObject;
            if (productRelationObject.productSharePreference) {
                let nin = [];
                productRelationObject.productSharePreference.forEach((r) => {
                    nin.push(r.sharetypeid);
                });
                await this.productSharePreferenceRepository.update({
                    deletedat: new Date()
                }, {
                    where: {
                        productId: product.productId,
                        sharetypeid: {
                            [sequelize_1.Op.notIn]: nin
                        }
                    }, transaction: transaction
                });
                await this.productSharePreferenceRepository.findAll({
                    where: {
                        productId: product.productId,
                        deletedat: null
                    }
                }).then((r) => {
                    r.forEach((d) => {
                        activeIds.push(+d.sharetypeid);
                    });
                });
                let productSharePreferenceObject = await this.productServiceInBound.setProductSharePreference(addProductDto, product, user, activeIds);
                if (productSharePreferenceObject.length) {
                    await this.productSharePreferenceRepository.bulkCreate(productSharePreferenceObject, { returning: true, transaction });
                }
            }
            if (addProductDto.productPrice) {
                await productInfo.productPriceDetail.save({
                    transaction
                });
            }
            if (addProductDto.productPackageInfo) {
                await productInfo.productPackageInfo.save({
                    transaction
                });
            }
            if (productRelationObject.productImage) {
                for (let ii = 0; ii < productRelationObject.productImage.length; ii++) {
                    if (productRelationObject.productImage[ii].productimageid) {
                        if (productRelationObject.productImage[ii].imageid) {
                            let logo = await this.imageUpdate(productRelationObject.productImage[ii].imageid, productRelationObject.productImage[ii].image, transaction);
                            productRelationObject.productImage[ii].imageid = logo.documentId;
                        }
                        await this.productImageRepository.update(productRelationObject.productImage[ii], {
                            where: { productimageid: productRelationObject.productImage[ii].productimageid },
                            returning: true,
                            transaction
                        });
                    }
                    else {
                        let logo = await this.imageCreate(productRelationObject.productImage[ii].image, transaction);
                        productRelationObject.productImage[ii].imageid = logo.documentId;
                        await this.productImageRepository.create(productRelationObject.productImage[ii], {
                            transaction
                        });
                    }
                }
            }
            if (addProductDto.productBrochure && addProductDto.productBrochure.productpdf && addProductDto.productBrochure.productpdf.length > 0) {
                addProductDto.productBrochure.productpdf.map(async (x) => {
                    if (x.productimageid) {
                        await this.productImageRepository.update({
                            name: lodash_1.defaultTo(x.documentName, ''),
                            description: lodash_1.defaultTo(x.documentDescription, ''),
                            updatedby: +user.userId,
                        }, {
                            where: { productimageid: +x.productimageid },
                            returning: true,
                            transaction
                        });
                    }
                    else {
                        let broucher = { imageid: x.imageid,
                            productimagetype: app_constant_1.appconstant.PRODUCT_BROUCHER_IMAGE_TYPE,
                            name: lodash_1.defaultTo(x.documentName, ''),
                            description: lodash_1.defaultTo(x.documentDescription, ''),
                            updatedby: +user.userId,
                            createdat: new Date(),
                            productId: product.productId
                        };
                        await this.productImageRepository.create(broucher, { transaction });
                    }
                });
            }
            if (productInfo.isactive == '1') {
                await this.productImageRepository.count({
                    where: {
                        productId: product.productId,
                        deletedat: null,
                        productimagetype: {
                            [sequelize_1.Op.in]: [app_constant_1.appconstant.PRODUCT_IMAGE_TYPE]
                        },
                    },
                    group: ['productimagetype'],
                    transaction
                }).then((count) => {
                    if (count && count.length != 1) {
                        productInfo.isactive = '0';
                    }
                });
            }
            if (addProductDto.productBasicInfo || addProductDto.productAvailability || addProductDto.ProductInfo) {
                await productInfo.productDetail.save({
                    transaction
                });
                await productInfo.save({
                    transaction
                });
            }
            if (productRelationObject.productTag) {
                for (let ii = 0; ii < productRelationObject.productTag.length; ii++) {
                    if (productRelationObject.productTag[ii].producttagid) {
                        await this.productTagRepository.update(productRelationObject.productTag[ii], {
                            where: { producttagid: productRelationObject.productTag[ii].producttagid },
                            returning: true,
                            transaction
                        });
                    }
                    else {
                        await this.productTagRepository.create(productRelationObject.productTag[ii], {
                            transaction
                        });
                    }
                }
            }
            if (productRelationObject.productArticleReview) {
                for (let ii = 0; ii < productRelationObject.productArticleReview.length; ii++) {
                    if (productRelationObject.productArticleReview[ii].productarticlereviewid) {
                        if (productRelationObject.productArticleReview[ii].reviewmagazinelogoid && productRelationObject.productArticleReview[ii].reviewmagazinelogo) {
                            let logo = await this.imageUpdate(productRelationObject.productArticleReview[ii].reviewmagazinelogoid, productRelationObject.productArticleReview[ii].reviewmagazinelogo, transaction);
                            productRelationObject.productArticleReview[ii].reviewmagazinelogoid = logo.documentId;
                        }
                        else if (productRelationObject.productArticleReview[ii].reviewmagazinelogo) {
                            let logo = await this.imageCreate(productRelationObject.productArticleReview[ii].reviewmagazinelogo, transaction);
                            productRelationObject.productArticleReview[ii].reviewmagazinelogoid = logo.documentId;
                        }
                        await this.productArticleReviewRepository.update(productRelationObject.productArticleReview[ii], {
                            where: { productarticlereviewid: productRelationObject.productArticleReview[ii].productarticlereviewid },
                            returning: true,
                            transaction
                        });
                    }
                    else {
                        if (productRelationObject.productArticleReview[ii].reviewmagazinelogo) {
                            let logo = await this.imageCreate(productRelationObject.productArticleReview[ii].reviewmagazinelogo, transaction);
                            productRelationObject.productArticleReview[ii].reviewmagazinelogoid = logo.documentId;
                        }
                        await this.productArticleReviewRepository.create(productRelationObject.productArticleReview[ii], {
                            transaction
                        });
                    }
                }
            }
            if (productRelationObject.productExistRating) {
                for (let ii = 0; ii < productRelationObject.productExistRating.length; ii++) {
                    if (productRelationObject.productExistRating[ii].productexistratingid) {
                        if (productRelationObject.productExistRating[ii].ratingproofvalidationlogoid && productRelationObject.productExistRating[ii].ratingproofvalidationlogo) {
                            let logo = await this.imageUpdate(productRelationObject.productExistRating[ii].ratingproofvalidationlogoid, productRelationObject.productExistRating[ii].ratingproofvalidationlogo, transaction);
                            productRelationObject.productExistRating[ii].ratingproofvalidationlogoid = logo.documentId;
                        }
                        else if (productRelationObject.productExistRating[ii].ratingproofvalidationlogo) {
                            let logo = await this.imageCreate(productRelationObject.productExistRating[ii].ratingproofvalidationlogo, transaction);
                            productRelationObject.productExistRating[ii].ratingproofvalidationlogoid = logo.documentId;
                        }
                        await this.productExistRatingRepository.update(productRelationObject.productExistRating[ii], {
                            where: { productexistratingid: productRelationObject.productExistRating[ii].productexistratingid },
                            returning: true,
                            transaction
                        });
                    }
                    else {
                        if (productRelationObject.productExistRating[ii].ratingproofvalidationlogo) {
                            let logo = await this.imageCreate(productRelationObject.productExistRating[ii].ratingproofvalidationlogo, transaction);
                            productRelationObject.productExistRating[ii].ratingproofvalidationlogoid = logo.documentId;
                        }
                        await this.productExistRatingRepository.create(productRelationObject.productExistRating[ii], {
                            transaction
                        });
                    }
                }
            }
            await this.productUniversalCodeRepository.update({
                deletedat: this.sequelizeInstance.fn('NOW')
            }, {
                where: {
                    productId: +product.productId
                }
            });
            if (productRelationObject.productUniversalCode) {
                for (let ii = 0; ii < productRelationObject.productUniversalCode.length; ii++) {
                    if (productRelationObject.productUniversalCode[ii].productuniversalcodeid) {
                        await this.productUniversalCodeRepository.update(productRelationObject.productUniversalCode[ii], {
                            where: { productuniversalcodeid: productRelationObject.productUniversalCode[ii].productuniversalcodeid },
                            returning: true,
                            transaction
                        });
                    }
                    else {
                        await this.productUniversalCodeRepository.create(productRelationObject.productUniversalCode[ii], {
                            transaction
                        });
                    }
                }
            }
            if (lodash_1.isUndefined(productRelationObject.productChannelCustomerProfile)) {
                productRelationObject.productChannelCustomerProfile = [];
            }
            activeIds = [];
            let nin = [];
            productRelationObject.productChannelCustomerProfile.forEach((r) => {
                nin.push(r.customerProfileId);
            });
            await this.productChannelCustomerProfileRepository.update({
                deletedat: new Date()
            }, {
                where: {
                    productId: product.productId,
                    customerProfileId: {
                        [sequelize_1.Op.notIn]: nin
                    }
                }, transaction: transaction
            });
            await this.productChannelCustomerProfileRepository.findAll({
                where: {
                    productId: product.productId,
                    deletedat: null
                }
            }).then((r) => {
                r.forEach((d) => {
                    activeIds.push(+d.customerProfileId);
                });
            });
            let productChannelCustomerProfileObject = await this.productServiceInBound.setProductChannelCustomerProfile(addProductDto, product, user, activeIds);
            if (productChannelCustomerProfileObject.length) {
                await this.productChannelCustomerProfileRepository.bulkCreate(productChannelCustomerProfileObject, { returning: true, transaction });
            }
            if (addProductDto.productTargetLocation && addProductDto.productTargetLocation.targetlocation && addProductDto.productTargetLocation.targetlocation.length > 0) {
                activeIds = [];
                let nin = [];
                addProductDto.productTargetLocation.targetlocation.forEach((r) => {
                    nin.push(r.regioncountryjctid);
                });
                await this.productLocationRepository.update({
                    deletedat: new Date()
                }, {
                    where: {
                        productId: product.productId,
                        locationtype: "TARGET",
                        regionCountryJCTId: {
                            [sequelize_1.Op.notIn]: nin
                        }
                    }, transaction: transaction
                });
                await this.productLocationRepository.findAll({
                    where: {
                        productId: product.productId,
                        locationtype: "TARGET",
                        deletedat: null
                    }
                }).then((r) => {
                    r.forEach((d) => {
                        activeIds.push(+d.regionCountryJCTId);
                    });
                });
                let productLocationObject = await this.productServiceInBound.setProductTargetLocation(addProductDto, product, user, activeIds);
                if (productLocationObject.length) {
                    await this.productLocationRepository.bulkCreate(productLocationObject, { returning: true, transaction });
                }
            }
            if (addProductDto.award_details && Object.keys(addProductDto.award_details).length > 0) {
                for (let ii = 0; ii < addProductDto.award_details.length; ii++) {
                    await this.productAwardRepository.create({
                        productId: product.productId,
                        awardDetail: 'product',
                        issuedBy: 'ch',
                        documentId: addProductDto.award_details[ii].documentId,
                    }, {
                        transaction
                    });
                }
            }
            if (addProductDto.deleted_award_details && addProductDto.deleted_award_details.length > 0) {
                for (let ii = 0; ii < addProductDto.deleted_award_details.length; ii++) {
                    if (addProductDto.deleted_award_details[ii]) {
                        await this.productAwardRepository.update({
                            productId: product.productId,
                            deletedAt: new Date()
                        }, {
                            where: { deletedAt: null, productAwardId: addProductDto.deleted_award_details[ii] },
                            returning: true, transaction,
                        });
                    }
                }
            }
            return product;
        }).then(async (product) => {
            await this.updateKeyRetailers(product, addProductDto, user, app_constant_1.appconstant.CHANNEL_TYPE_RETAILER);
            await this.updateKeyRetailers(product, addProductDto, user, app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR);
            await this.updateKeyRetailers(product, addProductDto, user, app_constant_1.appconstant.CHANNEL_TYPE_RESELLER);
            return product;
        }).catch(function (e) {
            console.log("Error+", e);
            throw new Process_exception_1.ProcessException(e.message);
        });
        if (product) {
            product = await this.setProductDefaultImage(product);
            result = { success: true, data: product };
        }
        return result;
    }
    async imageUpdate(imageId, image, transaction) {
        let logo = await this.mediaRepository.update({ deletedAt: new Date() }, {
            where: { documentId: imageId },
            returning: true, transaction,
        }).then(async () => {
            return await this.imageCreate(image, transaction);
        });
        return logo;
    }
    async imageDelete(imageId, image, transaction) {
        let logo = await this.mediaRepository.update({ deletedAt: new Date() }, {
            where: { documentId: imageId },
            returning: true, transaction,
        });
        return logo;
    }
    async productDelete(sku, user) {
        let product = await this.productRepository.scope('productInfo').findOne({
            where: {
                productSKU: sku,
                deletedat: null,
            }
        });
        if (!product) {
            throw new Process_exception_1.ProcessException('channel:product:notFound');
        }
        let result = true;
        try {
            product.deletedat = this.sequelizeInstance.fn('NOW');
            await product.save();
        }
        catch (e) {
            result = false;
        }
        await Wishlist_entity_1.Wishlist.destroy({
            where: {
                productid: +product.productId
            }
        });
        return {
            success: result
        };
    }
    async getProductLimit(user) {
        return await this.subscriptionExtraFeatureRepository.findOne({
            where: {
                isActive: '1',
                subscriptionId: +user.channel.plan.subscriptionPlanId,
                subscriptionExtraFeatureCategoryId: app_constant_1.appconstant.SubscriptionCharcteristicFeature.NO_OF_PRODUCT
            }
        });
    }
    async getPublicProduct(sku) {
        let product;
        try {
            product = await this.productRepository.scope('productInfo').findOne({
                include: [
                    {
                        model: this.productGroupRepository,
                        as: 'productGroup',
                        where: { deletedAt: null },
                        required: true
                    },
                    {
                        model: this.productCategoryRepository,
                        as: 'productCategory',
                        where: { deletedAt: null },
                        required: true
                    },
                    {
                        model: this.brandRepository,
                        where: { deletedAt: null },
                        include: [
                            {
                                model: this.mediaRepository,
                                where: { deletedAt: null },
                                required: false
                            }
                        ],
                        required: true
                    },
                    {
                        model: this.productDetailRepository.scope('productInfo'),
                        where: { deletedat: null },
                        required: true
                    },
                    {
                        model: this.productTagRepository.scope('productInfo'),
                        where: { deletedat: null },
                        required: false
                    },
                    {
                        model: this.productArticleReviewRepository.scope('productInfo'),
                        where: { deletedat: null },
                        include: [
                            {
                                model: this.mediaRepository,
                                where: { deletedAt: null },
                                required: false
                            }
                        ],
                        required: false,
                    },
                    {
                        model: this.productExistRatingRepository.scope('productInfo'),
                        where: { deletedat: null },
                        include: [
                            {
                                model: this.mediaRepository,
                                where: { deletedAt: null },
                                required: false
                            }
                        ],
                        required: false
                    },
                    {
                        model: this.productImageRepository.scope('productInfo'),
                        as: "productImage",
                        where: { deletedat: null },
                        include: [
                            {
                                model: this.mediaRepository,
                                where: { deletedAt: null },
                                required: false
                            }
                        ],
                        required: false
                    },
                    {
                        model: this.productImageRepository.scope('productInfo'),
                        as: "defaultImage",
                        where: { deletedat: null },
                        include: [
                            {
                                model: this.mediaRepository,
                                where: { deletedAt: null },
                                required: false
                            }
                        ],
                        required: false
                    },
                    {
                        model: this.productSharePreferenceRepository.scope('productInfo'),
                        where: { deletedat: null },
                        required: false
                    },
                    {
                        model: this.productUniversalCodeRepository.scope('productInfo'),
                        where: { deletedat: null },
                        required: false
                    },
                    {
                        model: this.productPriceDetailRepository.scope('productInfo'),
                        where: { deletedat: null },
                        required: true
                    },
                    {
                        model: this.productPackageInfoRepository.scope('productInfo'),
                        where: { deletedat: null },
                        required: false
                    },
                    {
                        model: this.productChannelCustomerProfileRepository.scope('productInfo'),
                        where: { deletedat: null },
                        required: false,
                        include: [
                            {
                                model: this.channelCustomerProfileRepository.scope('channelDetail'),
                                where: { deletedAt: null, profileTypeClassificationId: { [sequelize_1.Op.ne]: null } },
                                required: false,
                                include: [
                                    {
                                        model: this.profileTypeClassificationRepository.scope('profileTypeClassificationInfom'),
                                        where: { deletedAt: null },
                                        required: false,
                                        include: [
                                            {
                                                model: this.profileTypeRepository.scope('profileTypeInfom'),
                                                where: { deletedAt: null },
                                                required: false,
                                            },
                                            {
                                                model: this.channelTypeRepository.scope('channelTypeInfom')
                                            }
                                        ]
                                    }
                                ]
                            },
                        ]
                    }
                ],
                where: { productSKU: sku, deletedat: null }
            });
            console.log('product', product);
            if (!product) {
                throw new Process_exception_1.ProcessException('channel:product:notFound');
            }
            if (!product.productAwards) {
                await new utility_1.Utility().lazyload(product, 'productAwards', {
                    where: { deletedAt: null },
                    attributes: ['productAwardId', 'documentId', 'awardDetail', 'issuedBy', 'validUpto', 'isLifeTime'],
                    required: false,
                    include: [
                        {
                            model: index_1.Media,
                            attributes: ['documentId', 'documentPath', 'documentUrl'],
                            required: false
                        }
                    ]
                });
            }
            if (!product.channel) {
                await new utility_1.Utility().lazyload(product, 'channel', {
                    attributes: ['channelId', 'companyName', 'channelTypeId']
                });
            }
        }
        catch (e) {
            console.log("Error+ getProduct", e);
            throw new Process_exception_1.ProcessException(e.message);
        }
        if (!product) {
            throw new Process_exception_1.ProcessException('channel:product:notFound');
        }
        product.toJSON();
        product['productKeyRetailer'] = await this.getProductKeyRetailers(product.channelId, product.productId, app_constant_1.appconstant.CHANNEL_TYPE_RETAILER);
        product['productKeyReseller'] = await this.getProductKeyRetailers(product.channelId, product.productId, app_constant_1.appconstant.CHANNEL_TYPE_RESELLER);
        product['unit'] = await this.unitRepository.findAll();
        return product;
    }
    async getProductSearchList(search) {
        let product = await this.productRepository.findAll({
            attributes: ['product', 'productId', 'productSKU', 'channelId'],
            where: {
                deletedat: null,
                isactive: '1',
                product: { [sequelize_1.Op.iLike]: '%' + search + '%' },
            },
            include: [
                {
                    model: this.productImageRepository,
                    as: 'defaultImage',
                    attributes: ['productimageid', 'imageid'],
                    where: { deletedat: null },
                    required: false,
                    include: [{
                            model: this.mediaRepository,
                            attributes: ['documentUrl', 'documentPath'],
                            where: { deletedAt: null },
                            required: false,
                        },
                    ]
                },
                {
                    model: this.brandRepository,
                    where: { deletedAt: null },
                    attributes: ['id', 'brandName'],
                    required: true
                },
            ],
            limit: 10
        });
        let result = [];
        product.map(x => {
            result.push({ channelId: x.channelId, id: x.productId, name: x.product, productSKU: x.productSKU, logo: x.defaultImage, brand: x.brand });
        });
        return result;
    }
};
ProductService = __decorate([
    common_1.Injectable(),
    __param(1, common_1.Inject('ProductCategoryRepository')),
    __param(2, common_1.Inject('ProductGroupRepository')),
    __param(3, common_1.Inject('BrandRepository')),
    __param(4, common_1.Inject('SequelizeInstance')),
    __param(5, common_1.Inject('ProductRepository')),
    __param(6, common_1.Inject('ProfileRepository')),
    __param(7, common_1.Inject('ChannelRepository')),
    __param(8, common_1.Inject('ProductPriceDetailRepository')),
    __param(9, common_1.Inject('ProductImageRepository')),
    __param(10, common_1.Inject('MediaRepository')),
    __param(11, common_1.Inject('ProductDetailRepository')),
    __param(12, common_1.Inject('ProductTagRepository')),
    __param(13, common_1.Inject('ProductArticleReviewRepository')),
    __param(14, common_1.Inject('ProductExistRatingRepository')),
    __param(15, common_1.Inject('ProductSharePreferenceRepository')),
    __param(16, common_1.Inject('ProductUniversalCodeRepository')),
    __param(17, common_1.Inject('ProductPackageInfoRepository')),
    __param(18, common_1.Inject('ProductChannelCustomerProfileRepository')),
    __param(19, common_1.Inject('ProductLocationRepository')),
    __param(20, common_1.Inject('ProductMediaLibraryRepository')),
    __param(21, common_1.Inject('ChannelSubscriptionRepository')),
    __param(22, common_1.Inject('SubscriptionRepository')),
    __param(23, common_1.Inject('SubscriptionPlanRepository')),
    __param(24, common_1.Inject('CountryRepository')),
    __param(25, common_1.Inject('RegionCountryJCTRepository')),
    __param(26, common_1.Inject('PaymentOptionTypeRepository')),
    __param(27, common_1.Inject('PaymentTermRepository')),
    __param(28, common_1.Inject('UnitRepository')),
    __param(29, common_1.Inject('DiscountUnitRepository')),
    __param(30, common_1.Inject('ProfileTypeClassificationRepository')),
    __param(31, common_1.Inject('ProfileTypeRepository')),
    __param(32, common_1.Inject('ChannelTypeRepository')),
    __param(33, common_1.Inject('ChannelCustomerProfileRepository')),
    __param(34, common_1.Inject('ProductAwardRepository')),
    __param(35, common_1.Inject('ProductJctRepository')),
    __param(36, common_1.Inject('SubscriptionExtraFeatureRepository')),
    __metadata("design:paramtypes", [channel_service_1.ChannelService, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object])
], ProductService);
exports.ProductService = ProductService;
//# sourceMappingURL=product.service.js.map