import { Product } from '../models/Product.entity';
import { Channel } from '../../channel/models/Channel.entity';
import { ProductPriceDetail } from '../models/ProductPriceDetail.entity';
import { ProductImage } from '../models/ProductImage.entity';
import { Media } from '../../media/models/index';
import { AddProductDto } from '../dto/addProduct.dto';
import { ProductDetail } from '../models/ProductDetail.entity';
import { ProductTag } from '../models/ProductTag.entity';
import { ProductArticleReview } from '../models/ProductArticleReview.entity';
import { ProductExistRating } from '../models/ProductExistRating.entity';
import { ProductSharePreference } from '../models/ProductSharePreference.entity';
import { ProductUniversalCode } from '../models/ProductUniversalCode.entity';
import { ProductPackageInfo } from '../models/ProductPackageInfo.entity';
import { ProductChannelCustomerProfile } from '../models/ProductChannelCustomerProfile.entity';
import { ProductLocation } from '../models/ProductLocation.entity';
import { ChannelSubscription } from '../../channel/models/ChannelSubscription.entity';
import { Subscription } from '../../channel/models/Subscription.entity';
import { SubscriptionPlan } from '../../channel/models/SubscriptionPlan.entity';
import { Country } from '../../common/models/Country.entity';
import { PaymentOptionType } from '../../channel/models/PaymentOptionType.entity';
import { PaymentTerm } from '../../channel/models/PaymentTerm.entity';
import { DiscountUnit } from '../models/DiscountUnit.entity';
import { ChannelType } from '../../channel/models/ChannelType.entity';
import { ProfileList } from 'src/modules/channel/models/ProfileList.entity';
import { Brand } from '../models/Brand.entity';
import { ProductMediaLibrary } from '../models/ProductMediaLibrary.entity';
import { BaseService } from 'src/core/service/base.service';
import { ChannelService } from 'src/modules/channel/service/channel.service';
import { ProductGroup } from '../models/ProductGroup.entity';
import { ProductCategory } from '../models/ProductCategory.entity';
import { ChannelCustomerProfile } from 'src/modules/channel/models/ChannelCustomerProfile.entity';
import { ProfileTypeClassification } from 'src/modules/channel/models/ProfileTypeClassification.entity';
import { ProfileType } from 'src/modules/channel/models/ProfileType.entity';
import { RegionCountryJCT } from 'src/modules/common/models/RegionCountryJCT.entity';
import { Unit } from '../models/Unit.entity';
import { ProductAward } from './../models/ProductAward.entity';
import { ImportProductImageDto } from '../dto/importProductImage.dto';
export declare class ProductImportService extends BaseService {
    private channelService;
    private readonly productCategoryRepository;
    private readonly productGroupRepository;
    private readonly brandRepository;
    private readonly sequelizeInstance;
    private readonly productRepository;
    private readonly profileRepository;
    private readonly channelRepository;
    private readonly productPriceDetailRepository;
    private readonly productImageRepository;
    private readonly mediaRepository;
    private readonly productDetailRepository;
    private readonly productTagRepository;
    private readonly productArticleReviewRepository;
    private readonly productExistRatingRepository;
    private readonly productSharePreferenceRepository;
    private readonly productUniversalCodeRepository;
    private readonly productPackageInfoRepository;
    private readonly productChannelCustomerProfileRepository;
    private readonly productLocationRepository;
    private readonly productMediaLibraryRepository;
    private readonly channelSubscriptionRepository;
    private readonly subscriptionRepository;
    private readonly subscriptionPlanRepository;
    private readonly countryRepository;
    private readonly regionCountryJCTRepository;
    private readonly paymentOptionTypeRepository;
    private readonly paymentTermRepository;
    private readonly unitRepository;
    private readonly discountUnitRepository;
    private readonly profileTypeClassificationRepository;
    private readonly profileTypeRepository;
    private readonly channelTypeRepository;
    private readonly channelCustomerProfileRepository;
    private readonly productAwardRepository;
    private productServiceInBound;
    private tradeInformationInBound;
    private utility;
    private productServiceOutBound;
    constructor(channelService: ChannelService, productCategoryRepository: typeof ProductCategory, productGroupRepository: typeof ProductGroup, brandRepository: typeof Brand, sequelizeInstance: any, productRepository: typeof Product, profileRepository: typeof ProfileList, channelRepository: typeof Channel, productPriceDetailRepository: typeof ProductPriceDetail, productImageRepository: typeof ProductImage, mediaRepository: typeof Media, productDetailRepository: typeof ProductDetail, productTagRepository: typeof ProductTag, productArticleReviewRepository: typeof ProductArticleReview, productExistRatingRepository: typeof ProductExistRating, productSharePreferenceRepository: typeof ProductSharePreference, productUniversalCodeRepository: typeof ProductUniversalCode, productPackageInfoRepository: typeof ProductPackageInfo, productChannelCustomerProfileRepository: typeof ProductChannelCustomerProfile, productLocationRepository: typeof ProductLocation, productMediaLibraryRepository: typeof ProductMediaLibrary, channelSubscriptionRepository: typeof ChannelSubscription, subscriptionRepository: typeof Subscription, subscriptionPlanRepository: typeof SubscriptionPlan, countryRepository: typeof Country, regionCountryJCTRepository: typeof RegionCountryJCT, paymentOptionTypeRepository: typeof PaymentOptionType, paymentTermRepository: typeof PaymentTerm, unitRepository: typeof Unit, discountUnitRepository: typeof DiscountUnit, profileTypeClassificationRepository: typeof ProfileTypeClassification, profileTypeRepository: typeof ProfileType, channelTypeRepository: typeof ChannelType, channelCustomerProfileRepository: typeof ChannelCustomerProfile, productAwardRepository: typeof ProductAward);
    productImport(products: any, user: any): Promise<any>;
    productImageUpload(importProductImageDto: ImportProductImageDto): Promise<any>;
    productImportSample(user: any): Promise<{
        sampleFileName: string;
    }>;
    cloneSampleProductsImportSht(data: any, fileName: any, type: any, channelId: any): Promise<any>;
    channelSettings(user: any): Promise<Channel>;
    productFileUpload(): Promise<void>;
    sampleOrUninsertedProducts(data: any, fileName: any, type: any): Promise<any>;
    addProduct(addProductDto: AddProductDto, user: any, subscriptionFeatureKeys?: any, importFlag?: any): Promise<any>;
    setProductDefaultImage(product: any): Promise<any>;
    getKeyRetailerIds(channelId: any, partnerType: any): Promise<any>;
    updateKeyRetailers(product: any, dto: any, user: any, partner_type: any): Promise<void>;
    productImportCheck(products: any, masters: any): Promise<any>;
}
