'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductImportService = void 0;
const common_1 = require("@nestjs/common");
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
const addProduct_dto_1 = require("../dto/addProduct.dto");
const productSerivceInBound_1 = require("../transformation/productSerivceInBound");
const app_constant_1 = require("../../../config/app.constant");
const ProfileList_entity_1 = require("../../channel/models/ProfileList.entity");
const Brand_entity_1 = require("../models/Brand.entity");
const sequelize_1 = require("sequelize");
const utility_1 = require("../../channel/helper/utility");
const tradeInformationInBound_1 = require("../../channel/transformation/tradeInformationInBound");
const features_constants_1 = require("../../../config/features.constants");
const base_service_1 = require("../../../core/service/base.service");
const channel_service_1 = require("../../channel/service/channel.service");
const Contact_entity_1 = require("../../user/models/Contact.entity");
const ProductGroup_entity_1 = require("../models/ProductGroup.entity");
const ProductCategory_entity_1 = require("../models/ProductCategory.entity");
const ChannelCustomerProfile_entity_1 = require("../../channel/models/ChannelCustomerProfile.entity");
const ProfileTypeClassification_entity_1 = require("../../channel/models/ProfileTypeClassification.entity");
const ProfileType_entity_1 = require("../../channel/models/ProfileType.entity");
const RegionCountryJCT_entity_1 = require("../../common/models/RegionCountryJCT.entity");
const class_transformer_1 = require("class-transformer");
const productServiceOutBound_1 = require("../transformation/productServiceOutBound");
const Currency_entity_1 = require("../../channel/models/Currency.entity");
const ShareType_entity_1 = require("../../channel/models/ShareType.entity");
const S3Lib_1 = require("../../../lib/S3Lib");
const class_validator_1 = require("class-validator");
const Validation_exception_1 = require("./../../../middleware/exception/Validation.exception");
let fs = require('fs');
let path = require("path");
let ProductImportService = class ProductImportService extends base_service_1.BaseService {
    constructor(channelService, productCategoryRepository, productGroupRepository, brandRepository, sequelizeInstance, productRepository, profileRepository, channelRepository, productPriceDetailRepository, productImageRepository, mediaRepository, productDetailRepository, productTagRepository, productArticleReviewRepository, productExistRatingRepository, productSharePreferenceRepository, productUniversalCodeRepository, productPackageInfoRepository, productChannelCustomerProfileRepository, productLocationRepository, productMediaLibraryRepository, channelSubscriptionRepository, subscriptionRepository, subscriptionPlanRepository, countryRepository, regionCountryJCTRepository, paymentOptionTypeRepository, paymentTermRepository, unitRepository, discountUnitRepository, profileTypeClassificationRepository, profileTypeRepository, channelTypeRepository, channelCustomerProfileRepository, productAwardRepository) {
        super();
        this.channelService = channelService;
        this.productCategoryRepository = productCategoryRepository;
        this.productGroupRepository = productGroupRepository;
        this.brandRepository = brandRepository;
        this.sequelizeInstance = sequelizeInstance;
        this.productRepository = productRepository;
        this.profileRepository = profileRepository;
        this.channelRepository = channelRepository;
        this.productPriceDetailRepository = productPriceDetailRepository;
        this.productImageRepository = productImageRepository;
        this.mediaRepository = mediaRepository;
        this.productDetailRepository = productDetailRepository;
        this.productTagRepository = productTagRepository;
        this.productArticleReviewRepository = productArticleReviewRepository;
        this.productExistRatingRepository = productExistRatingRepository;
        this.productSharePreferenceRepository = productSharePreferenceRepository;
        this.productUniversalCodeRepository = productUniversalCodeRepository;
        this.productPackageInfoRepository = productPackageInfoRepository;
        this.productChannelCustomerProfileRepository = productChannelCustomerProfileRepository;
        this.productLocationRepository = productLocationRepository;
        this.productMediaLibraryRepository = productMediaLibraryRepository;
        this.channelSubscriptionRepository = channelSubscriptionRepository;
        this.subscriptionRepository = subscriptionRepository;
        this.subscriptionPlanRepository = subscriptionPlanRepository;
        this.countryRepository = countryRepository;
        this.regionCountryJCTRepository = regionCountryJCTRepository;
        this.paymentOptionTypeRepository = paymentOptionTypeRepository;
        this.paymentTermRepository = paymentTermRepository;
        this.unitRepository = unitRepository;
        this.discountUnitRepository = discountUnitRepository;
        this.profileTypeClassificationRepository = profileTypeClassificationRepository;
        this.profileTypeRepository = profileTypeRepository;
        this.channelTypeRepository = channelTypeRepository;
        this.channelCustomerProfileRepository = channelCustomerProfileRepository;
        this.productAwardRepository = productAwardRepository;
        this.productServiceInBound = new productSerivceInBound_1.ProductSerivceInBound();
        this.tradeInformationInBound = new tradeInformationInBound_1.TradeInformationInBound();
        this.utility = new utility_1.Utility();
        this.productServiceOutBound = new productServiceOutBound_1.ProductServiceOutBound();
    }
    async productImport(products, user) {
        let pcnt = 0;
        if (products.result.length > 0) {
            for (let i = 0; i < products.result.length; i++) {
                if ((products.result[i].product) && products.result[i].product != '') {
                    pcnt = pcnt + 1;
                }
            }
        }
        console.log('Product Import count', pcnt);
        if (products && pcnt > 0) {
            let key = +user.channel.subscriptionId + '-' + +features_constants_1.features.PRODUCT_SHEET;
            let subscriptionFeatureKeys = user.productCount;
            if (subscriptionFeatureKeys && subscriptionFeatureKeys[key]) {
                let productCount = await this.productRepository.count({ where: { channelId: +user.channelId, deletedat: null } });
                if (productCount >= +subscriptionFeatureKeys[key]) {
                    throw new Process_exception_1.ProcessException({ message: ' Based on your Subscription, you are eligible to add ' + +subscriptionFeatureKeys[key] + ' products. Already you have ' + productCount + ' products.', eligibleCount: subscriptionFeatureKeys[key], exitCount: productCount });
                }
                if (((+pcnt + +productCount) > +subscriptionFeatureKeys[key])) {
                    let eligible = ((+subscriptionFeatureKeys[key] - productCount) >= 1) ? 'You are able to add only ' + (+subscriptionFeatureKeys[key] - productCount) + ' products' : '';
                    throw new Process_exception_1.ProcessException({ message: 'Based on your Subscription, you are eligible to add ' + +subscriptionFeatureKeys[key] + ' products. Already you have ' + productCount + ' products and uploading product count is ' + pcnt + '. ' + eligible, eligibleCount: +subscriptionFeatureKeys[key], exitCount: +productCount, uploadCount: +pcnt });
                }
            }
            try {
                let premaster = await this.channelSettings(user);
                let masters = await this.productServiceOutBound.getProductMasters(premaster);
                let returnObject = { 'uploaded': [], 'totalCount': pcnt, 'uploadedCount': 0, 'uninsertedCount': 0, 'uninsertedFileName': '' };
                let unInsertedProducts = [];
                for (let i = 0; i < pcnt; i++) {
                    let message = '';
                    let product = products.result[i];
                    var productCheck = await this.productImportCheck(product, masters);
                    if (productCheck.status) {
                        let productObject = await this.productServiceInBound.setProductImportObject(product, masters, products.imageFolder);
                        const object = class_transformer_1.plainToClass(addProduct_dto_1.AddProductDto, productObject);
                        var error = await class_validator_1.validate(object, {
                            groups: ["import"]
                        }).then(errors => {
                            return new Validation_exception_1.ValidationException(errors);
                        });
                        let productAdd = false;
                        if (!error || !error.messages || error.messages.length === 0) {
                            try {
                                productAdd = await this.addProduct(productObject, user, null, true);
                            }
                            catch (e) {
                                console.log('product upload error ', e);
                                error = e;
                            }
                            if (productAdd) {
                                returnObject.uploaded.push({ productId: productAdd.data.productId, productSKU: productAdd.data.productSKU });
                                returnObject.uploadedCount = returnObject.uploadedCount + 1;
                            }
                        }
                        if (!productAdd) {
                            let matchingFields = {
                                'productname': 'product',
                                'productgroup': 'productGroup',
                                'productcategory': 'productCategory',
                                'productbrand': 'productBrand',
                                'productdesc': 'productDesc',
                                'productusp': 'tweetPitch',
                                'reviewername': 'productArticleReview_Name',
                                'articleurl': 'productArticleReview_URL',
                                'logo': 'productArticleReview_Logo',
                                '0': '1',
                                '1': '2',
                                '2': '3',
                                '3': '4'
                            };
                            if (!message) {
                                message = 'Validate uploaded image names with input OR Re-download the samplesheet and try again.';
                                if (error && error.messages && error.messages.length > 0) {
                                    message = '\n';
                                    error.messages.forEach((data) => {
                                        if (data.errors) {
                                            if (matchingFields[data.property]) {
                                                message += '\n  ' + matchingFields[data.property] + '\n';
                                            }
                                            data.errors.forEach((sdata) => {
                                                if (sdata.errors) {
                                                    if (matchingFields[sdata.property]) {
                                                        message += '\n  ' + matchingFields[sdata.property] + '\n';
                                                    }
                                                    sdata.errors.forEach((tdata) => {
                                                        if (tdata.errors) {
                                                            if (matchingFields[tdata.property]) {
                                                                message += '\n  ' + matchingFields[tdata.property] + '\n';
                                                            }
                                                            tdata.errors.forEach((fdata) => {
                                                                if (fdata.errors) {
                                                                    if (matchingFields[fdata.property]) {
                                                                        message += '\n   ' + matchingFields[fdata.property] + '\n';
                                                                    }
                                                                    fdata.errors.forEach((fidata) => {
                                                                        if (fidata.errors) {
                                                                            if (matchingFields[fidata.property]) {
                                                                                message += '\n   ' + matchingFields[fidata.property] + '\n';
                                                                            }
                                                                        }
                                                                        else {
                                                                            message += '    * ' + fidata.message + '\n';
                                                                        }
                                                                    });
                                                                }
                                                                else {
                                                                    message += '    * ' + fdata.message + '\n';
                                                                }
                                                            });
                                                        }
                                                        else {
                                                            message += '    * ' + tdata.message + '\n';
                                                        }
                                                    });
                                                }
                                                else {
                                                    message += '    * ' + sdata.message + '\n';
                                                }
                                            });
                                        }
                                        else {
                                            message += '    * ' + data.message + '\n';
                                        }
                                    });
                                }
                            }
                            product['errors'] = message;
                            unInsertedProducts.push(product);
                            returnObject.uninsertedCount = returnObject.uninsertedCount + 1;
                        }
                    }
                    else {
                        product['errors'] = productCheck.errors;
                        if (productCheck.productRowCheck) {
                            unInsertedProducts.push(product);
                            returnObject.uninsertedCount = returnObject.uninsertedCount + 1;
                        }
                        else {
                            returnObject.totalCount = +returnObject.totalCount - 1;
                        }
                    }
                }
                if (unInsertedProducts.length > 0) {
                    let fileName = 'uninserted_products_' + user.channelId + '.xlsx';
                    await this.sampleOrUninsertedProducts(unInsertedProducts, fileName, 'uninserted');
                    returnObject.uninsertedFileName = fileName;
                }
                fs.unlink(path.resolve(__dirname, '..', '..', '..', '..') + '/.tmp/upload_s3/' + products.fileName, function (err) {
                    if (err) {
                        console.log("error while file delete");
                        return false;
                    }
                    return true;
                });
                return returnObject;
            }
            catch (e) {
                console.log("Error+ ", e);
                throw new common_1.InternalServerErrorException();
            }
        }
        else {
            throw new Process_exception_1.ProcessException('product:productImport:zeroRows');
        }
    }
    async productImageUpload(importProductImageDto) {
        let imageFolder = 'product-import-zip-s3';
        console.log(importProductImageDto.fileName);
        if (!importProductImageDto.fileName) {
            throw new Process_exception_1.ProcessException('product:productImport:imageFolderName');
        }
        if (importProductImageDto.fileName) {
            let s3 = new S3Lib_1.S3Lib();
            let moveAction = await s3.downloadFromTempBucket(imageFolder, importProductImageDto.fileName);
            if (moveAction) {
                let moveImages = await s3.uploadZipToTempBucket(imageFolder, importProductImageDto.fileName);
                if (moveImages) {
                    return moveImages;
                }
            }
        }
        {
            return 'Something went Wrong';
        }
    }
    async productImportSample(user) {
        try {
            let masters = await this.productServiceOutBound.getProductMasters(await this.channelSettings(user));
            let fileName = 'sample_products_' + user.channelId + '.xlsm';
            await this.cloneSampleProductsImportSht(masters, fileName, 'sample', user.channelId);
            return { 'sampleFileName': fileName };
        }
        catch (e) {
            console.log("Error+ ", e);
            throw new common_1.InternalServerErrorException();
        }
    }
    async cloneSampleProductsImportSht(data, fileName, type, channelId) {
        var fs = require('fs');
        var cpyfilename = 'sample_products_import.xlsm';
        var newfilename = fileName;
        fs.copyFile(path.resolve(__dirname, '..', '..', '..', '..') + '/public/templates/' + cpyfilename, path.resolve(__dirname, '..', '..', '..', '..') + '/.tmp/upload_s3/' + newfilename, function (err) {
            if (err) {
                console.log(err);
                return false;
            }
            else {
                console.log('brand');
                var pt = path.resolve(__dirname, '..', '..', '..', '..') + '/.tmp/upload_s3/' + newfilename;
                const XLSX = require('xlsx');
                var productCat = [];
                var brand = [];
                var currency = [];
                var shareType = [];
                const workbook = XLSX.readFile(pt, { bookVBA: true });
                var ws_name = "Masters";
                for (let i = 0; i < data.productCategory.length; i++) {
                    productCat.push(data.productCategory[i]);
                }
                for (let i = 0; i < data.brand.length; i++) {
                    brand.push(data.brand[i]);
                }
                if (data.currency.length > 0) {
                    for (let i = 0; i < data.currency.length; i++) {
                        currency.push(data.currency[i].currency);
                    }
                }
                if (data.shareType.length > 0) {
                    for (let i = 0; i < data.shareType.length; i++) {
                        console.log(data.shareType[i]);
                        shareType.push(data.shareType[i]);
                    }
                    shareType.push(data.shareType.all);
                }
                console.log(brand);
                var ws_data = [
                    productCat,
                    brand,
                    currency,
                    shareType,
                    [data.productCategory.length],
                    [data.brand.length],
                    [data.currency.length],
                    [data.shareType.length]
                ];
                var ws = XLSX.utils.aoa_to_sheet(ws_data);
                XLSX.utils.book_append_sheet(workbook, ws, ws_name);
                XLSX.writeFile(workbook, path.resolve(__dirname, '..', '..', '..', '..') + '/.tmp/upload_s3/' + newfilename);
                console.log('Completed ...');
            }
            return true;
        });
    }
    async channelSettings(user) {
        try {
            let result = await this.channelRepository.findOne({
                where: {
                    channelId: user.channelId,
                    deletedAt: null
                },
                include: [
                    {
                        model: ProductGroup_entity_1.ProductGroup.scope('defaultScope'), as: 'productGroup', required: false, where: { deletedAt: null }, through: { attributes: [], where: { deletedAt: null } }, attributes: ['productGroupId', 'productGroup']
                    },
                    {
                        model: ProductCategory_entity_1.ProductCategory, as: 'productCategory', required: false, where: { deletedAt: null }, through: { attributes: [], where: { deletedAt: null } }, attributes: ['productCategorieId', 'productGroupId', 'productCategorie']
                    },
                    {
                        model: Brand_entity_1.Brand, as: 'brand', required: false, where: { deletedAt: null }, through: { attributes: [], where: { deletedAt: null } }, attributes: ['id', 'brandName']
                    },
                    {
                        model: ShareType_entity_1.ShareType, as: 'shareType', required: false, through: { attributes: [], where: { deletedat: null } }, attributes: ['sharetypeid', 'sharetype']
                    },
                ],
                attributes: ['channelId']
            });
            result['unit'] = await this.unitRepository.findAll();
            result['discountUnit'] = await this.discountUnitRepository.findAll();
            result['currency'] = await Currency_entity_1.Currency.findAll();
            return result;
        }
        catch (e) {
            console.log("Error+ ", e);
            throw new common_1.InternalServerErrorException();
        }
    }
    async productFileUpload() {
    }
    async sampleOrUninsertedProducts(data, fileName, type) {
        const fields = ['product', 'productCategory', 'productBrand', 'productDesc', 'tweetPitch', 'EAN', 'inventoryCode', 'hasAnyVariant', 'variantDetails', 'retailerPrice', 'retailerPriceUnit', 'isSampleFree', 'samplePrice', 'samplePriceUnit', 'isUnlimitSample', 'sampleThreshold', 'productQualityLevel', 'minOrderQuantity', 'minOrderQuantityUnit', 'isAvailabelImmediate', 'availabelFrom', 'availabilityComment', 'productImage', 'productDisplayImage', 'productPackagingImage'];
        var xl = require('excel4node');
        var wb = new xl.Workbook();
        var ws = wb.addWorksheet('Products');
        var ws2 = wb.addWorksheet('Masters');
        wb.createStyle({
            font: {
                size: 10
            }
        });
        if (type == 'sample') {
            for (let i = 0; i < fields.length; i++) {
                ws.cell(1, i + 1).string(fields[i]);
            }
            ws2.cell(1, 1).string('Product Category').style({ font: { bold: true } });
            for (let i = 0; i < data.productCategory.length; i++) {
                ws2.cell(i + 2, 1).string(data.productCategory[i]);
            }
            ws2.cell(1, 2).string('Product Brand').style({ font: { bold: true } });
            for (let i = 0; i < data.brand.length; i++) {
                ws2.cell(i + 2, 2).string(data.brand[i]);
            }
            if (data.unit.length > 0) {
                ws2.cell(1, 3).string('Units').style({ font: { bold: true } });
                for (let i = 0; i < data.unit.length; i++) {
                    ws2.cell(i + 2, 3).string(data.unit[i]);
                }
            }
            if (data.discountUnit.length > 0) {
                ws2.cell(1, 4).string('Discount Units').style({ font: { bold: true } });
                for (let i = 0; i < data.discountUnit.length; i++) {
                    ws2.cell(i + 2, 4).string(data.discountUnit[i]);
                }
            }
            ws.addDataValidation({
                type: 'list',
                prompt: 'Choose from dropdown',
                error: 'Invalid choice was chosen',
                showDropDown: true,
                sqref: 'B2:B5000',
                allowBlank: false,
                formulas: ["=Masters!$A$2:$A$100"]
            });
            ws.addDataValidation({
                type: 'list',
                prompt: 'Choose from dropdown',
                error: 'Invalid choice was chosen',
                showDropDown: true,
                sqref: 'C2:C5000',
                formulas: ["=Masters!$B$2:$B$100"]
            });
            ws.addDataValidation({
                type: 'list',
                prompt: 'Choose from dropdown',
                error: 'Invalid choice was chosen',
                showDropDown: true,
                sqref: 'H2:H5000',
                formulas: ["no,yes"]
            });
            ws.addDataValidation({
                type: 'list',
                prompt: 'Choose from dropdown',
                error: 'Invalid choice was chosen',
                showDropDown: true,
                sqref: 'K2:K5000',
                formulas: [
                    data.unitNames
                ]
            });
            ws.addDataValidation({
                type: 'list',
                prompt: 'Choose from dropdown',
                error: 'Invalid choice was chosen',
                showDropDown: true,
                sqref: 'L2:L5000',
                formulas: ["yes,no"]
            });
            ws.addDataValidation({
                type: 'list',
                prompt: 'Choose from dropdown',
                error: 'Invalid choice was chosen',
                showDropDown: true,
                sqref: 'N2:N5000',
                formulas: [
                    data.unitNames
                ]
            });
            ws.addDataValidation({
                type: 'list',
                prompt: 'Choose from dropdown',
                error: 'Invalid choice was chosen',
                showDropDown: true,
                sqref: 'O2:O5000',
                formulas: ["yes,no"]
            });
            ws.addDataValidation({
                type: 'list',
                prompt: 'Choose from dropdown',
                error: 'Invalid choice was chosen',
                showDropDown: true,
                sqref: 'Q2:Q5000',
                formulas: [
                    app_constant_1.appconstant.PRODUCT_QUALITY_LEVEL_TYPE
                ]
            });
            ws.addDataValidation({
                type: 'list',
                prompt: 'Choose from dropdown',
                error: 'Invalid choice was chosen',
                showDropDown: true,
                sqref: 'S2:S5000',
                formulas: [
                    data.unitNames
                ]
            });
            ws.addDataValidation({
                type: 'list',
                prompt: 'Choose from dropdown',
                error: 'Invalid choice was chosen',
                showDropDown: true,
                sqref: 'T2:T5000',
                formulas: ["yes,no"]
            });
        }
        else {
            const uifields = ['product', 'errors'];
            data.map(function (data, index) {
                if (!data.errors) {
                    data.errors = 'Invalid Images or Master data';
                }
                else {
                    data.errors = 'Invalid columns : ' + data.errors;
                }
                for (var j = 0; j < uifields.length; j++) {
                    if (index == 0) {
                        ws.cell(1, j + 1).string(uifields[j]);
                    }
                    ws.cell(2 + index, 1 + j).string((data[uifields[j]]) ? data[uifields[j]] : '');
                }
            });
            ws.cell(2, 2, 5000, 2).style({ font: { color: '#FF0000' } });
        }
        await wb.writeToBuffer().then(function (buffer) {
            fs.writeFileSync(path.resolve(__dirname, '..', '..', '..', '..') + '/.tmp/upload_s3/' + fileName, buffer, 'utf-8', function (err) {
                if (err)
                    throw err;
                return true;
            });
        });
    }
    async addProduct(addProductDto, user, subscriptionFeatureKeys, importFlag) {
        let product = "";
        let productUpdate = "";
        let result = { error: true };
        let key = +user.channel.subscriptionId + '-' + +features_constants_1.features.PRODUCT_SHEET;
        if (subscriptionFeatureKeys && subscriptionFeatureKeys[key]) {
            let productCount = await this.productRepository.count({ where: { channelId: +user.channelId, deletedat: null } });
            if (productCount >= +subscriptionFeatureKeys[key]) {
                throw new Process_exception_1.ProcessException({ message: 'Based on your Subscription, you are eligible to add ' + +subscriptionFeatureKeys[key] + ' products. Already you have ' + productCount + ' products.', eligibleCount: subscriptionFeatureKeys[key], exitCount: productCount });
            }
        }
        key = +user.channel.subscriptionId + '-' + +features_constants_1.features.PRODUCT_VIDEO_BY_SHEET;
        if (subscriptionFeatureKeys && subscriptionFeatureKeys[key]) {
            let videoUrl = (addProductDto.productImages && addProductDto.productImages.videourl && addProductDto.productImages.videourl.length > 0);
            if (!subscriptionFeatureKeys[key] && videoUrl) {
                throw new Process_exception_1.ProcessException({ message: 'Based on your Subscription, you are not eligible to add videos in product.' });
            }
        }
        let productObject = await this.productServiceInBound.setProductObject(addProductDto, user);
        productObject['slug'] = await this.setSlugName(this.productRepository, addProductDto.productBasicInfo.productname);
        productUpdate = await this.sequelizeInstance.transaction(async (transaction) => {
            console.log('productObjectproductObjectproductObjectproductObject');
            console.log(productObject.productImage);
            product = await this.productRepository.create(productObject, {
                include: [
                    {
                        model: this.productDetailRepository
                    },
                    {
                        model: this.productTagRepository
                    },
                    {
                        model: this.productImageRepository,
                        as: "productImage",
                        include: [
                            {
                                model: this.mediaRepository
                            }
                        ]
                    },
                    {
                        model: this.productSharePreferenceRepository
                    },
                    {
                        model: this.productUniversalCodeRepository
                    },
                    {
                        model: this.productArticleReviewRepository,
                        include: [
                            {
                                model: this.mediaRepository
                            }
                        ]
                    },
                    {
                        model: this.productExistRatingRepository,
                        include: [
                            {
                                model: this.mediaRepository
                            }
                        ]
                    },
                    {
                        model: this.productPriceDetailRepository
                    },
                    {
                        model: this.productPackageInfoRepository
                    },
                    {
                        model: this.productChannelCustomerProfileRepository
                    }
                ],
                transaction,
            });
            let productUpdateObject = await this.productServiceInBound.setProductUpdateObject(addProductDto, product);
            if (product.isactive == '1') {
                await this.productImageRepository.count({
                    where: {
                        productId: product.productId,
                        deletedat: null,
                        productimagetype: {
                            [sequelize_1.Op.in]: [app_constant_1.appconstant.PRODUCT_IMAGE_TYPE]
                        },
                    },
                    group: ['productimagetype'],
                    transaction
                }).then((count) => {
                    if (count && count.length != 1) {
                        productUpdateObject.isactive = '0';
                    }
                });
            }
            productUpdate = await this.productRepository.update(productUpdateObject, {
                where: { productId: product.productId },
                returning: true,
                transaction
            });
            return productUpdate;
        }).then(async (productUpdate) => {
            return productUpdate;
        }).catch(function (e) {
            console.log("Error+", e);
            if (importFlag) {
                return false;
            }
            else {
                throw new Process_exception_1.ProcessException(e.message);
            }
        });
        if (productUpdate) {
            if (productUpdate[1] && productUpdate[1][0]) {
                let productReturnData = productUpdate[1][0];
                productUpdate = await this.setProductDefaultImage(productReturnData);
                await this.updateKeyRetailers(productReturnData, addProductDto, user, app_constant_1.appconstant.CHANNEL_TYPE_RETAILER);
                await this.updateKeyRetailers(productReturnData, addProductDto, user, app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR);
                result = { success: true, data: productReturnData };
            }
        }
        else {
            result = productUpdate;
        }
        return result;
    }
    async setProductDefaultImage(product) {
        let productDefaultImage = {};
        let productDefaultImageId = "";
        try {
            productDefaultImage = await this.productImageRepository.scope('productInfo').findOne({
                where: { productId: parseInt(product.productId), productimagetype: app_constant_1.appconstant.PRODUCT_IMAGE_TYPE, isdefault: '1', deletedat: null }
            });
            if (productDefaultImage) {
                if (productDefaultImage && productDefaultImage.productimageid) {
                    productDefaultImageId = productDefaultImage.productimageid;
                    product.defaultimageid = productDefaultImageId;
                    await product.save();
                }
            }
        }
        catch (e) {
            console.log("Error+ setProductDefaultImage", e);
            throw new Process_exception_1.ProcessException(e.message);
        }
        return product;
    }
    async getKeyRetailerIds(channelId, partnerType) {
        return await this.sequelizeInstance.query('select array_agg(keypartnerid) as ids from "tblKeyPartnerJCT" where channelid = :channelId and partner_type = :partnerType and deletedat is null', {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: channelId,
                partnerType: partnerType
            }
        }).then((result) => {
            return (result[0].ids) ? result[0].ids : [];
        });
    }
    async updateKeyRetailers(product, dto, user, partner_type) {
        let keyRetailers = await this.getKeyRetailerIds(+product.channelId, partner_type);
        let dtoKeyPartners = (+partner_type == +app_constant_1.appconstant.CHANNEL_TYPE_RETAILER) ? dto.keyRetailers : dto.keyDistributors;
        let dtoDeleteKeyPartners = (+partner_type == +app_constant_1.appconstant.CHANNEL_TYPE_RETAILER) ? dto.deletedkeyretailer : dto.deletedkeydistributor;
        if (dtoKeyPartners) {
            var receivedNewKeyRetailers = await this.tradeInformationInBound.keyRetailers(partner_type, dtoKeyPartners, +product.channelId, +user.userId);
        }
        else if (dtoDeleteKeyPartners) {
        }
    }
    async productImportCheck(products, masters) {
        try {
            let errors = '';
            errors += (!products.tweetPitch) ? '\n  tweetPitch \n    * Can\'t be to empty,' : '';
            errors += (products.tweetPitch && products.tweetPitch.trim().length >= 140) ? '\n  tweetPitch \n    * Can\'t be greater than 140,' : '';
            errors += (products.inventoryCode && (products.inventoryCode.trim().length < 3 || products.inventoryCode.trim().length > 38)) ? '\n  inventoryCode  \n    * should have 3 to 38 characters' : '';
            errors += (!products.hasAnyVariant) ? '\n  hasAnyVariant \n    * Can\'t be to empty,' : '';
            errors += (products.hasAnyVariant && products.hasAnyVariant.toLowerCase().trim() == 'yes' && !products.variantDetails) ? '\n  variantDetails \n    * Can\'t be to empty when hasAnyVariant set "yes",' : '';
            errors += (!products.retailerPrice) ? '\n retailerPrice \n    * Can\'t be to empty,' : '';
            errors += (!products.isSampleFree) ? '\n isSampleFree \n    * Can\'t be to empty,' : '';
            errors += (products.isSampleFree && products.isSampleFree.toLowerCase().trim() == 'no' && !products.samplePrice) ? '\n samplePrice \n    * Can\'t be to empty when isSampleFree set "no",' : '';
            errors += (!products.isUnlimitSample) ? '\n isUnlimitSample \n    * Can\'t be to empty,' : '';
            errors += (!products.productQualityLevel) ? '\n productQualityLevel \n    * Can\'t be to empty,' : '';
            errors += (!products.minOrderQuantity) ? '\n minOrderQuantity \n    * Can\'t be to empty,' : '';
            errors += (!products.minOrderQuantityUnit) ? '\n minOrderQuantityUnit \n    * Can\'t be to empty,' : '';
            errors += (!products.isAvailabelImmediate) ? '\n isAvailabelImmediate \n    * Can\'t be to empty,' : '';
            errors += (products.isAvailabelImmediate && products.isAvailabelImmediate.toLowerCase().trim() == 'no' && !products.availabelFrom) ? 'availabelFrom,' : '';
            if (products.product) {
                let productcheck = await this.productRepository.findAll({
                    where: {
                        product: products.product.trim(),
                        deletedat: null
                    }
                });
                if (productcheck && productcheck.length > 0) {
                    errors += 'Product Name already exist in ChannelHub ' + products.product.trim();
                }
            }
            let productRowCheck = (!products.product) ? 0 : 1;
            if (errors != '') {
                return { status: false, errors: errors, productRowCheck: productRowCheck };
            }
            return { status: true };
        }
        catch (e) {
            console.log("Error+ ", e);
            throw new common_1.InternalServerErrorException();
        }
    }
};
ProductImportService = __decorate([
    common_1.Injectable(),
    __param(1, common_1.Inject('ProductCategoryRepository')),
    __param(2, common_1.Inject('ProductGroupRepository')),
    __param(3, common_1.Inject('BrandRepository')),
    __param(4, common_1.Inject('SequelizeInstance')),
    __param(5, common_1.Inject('ProductRepository')),
    __param(6, common_1.Inject('ProfileRepository')),
    __param(7, common_1.Inject('ChannelRepository')),
    __param(8, common_1.Inject('ProductPriceDetailRepository')),
    __param(9, common_1.Inject('ProductImageRepository')),
    __param(10, common_1.Inject('MediaRepository')),
    __param(11, common_1.Inject('ProductDetailRepository')),
    __param(12, common_1.Inject('ProductTagRepository')),
    __param(13, common_1.Inject('ProductArticleReviewRepository')),
    __param(14, common_1.Inject('ProductExistRatingRepository')),
    __param(15, common_1.Inject('ProductSharePreferenceRepository')),
    __param(16, common_1.Inject('ProductUniversalCodeRepository')),
    __param(17, common_1.Inject('ProductPackageInfoRepository')),
    __param(18, common_1.Inject('ProductChannelCustomerProfileRepository')),
    __param(19, common_1.Inject('ProductLocationRepository')),
    __param(20, common_1.Inject('ProductMediaLibraryRepository')),
    __param(21, common_1.Inject('ChannelSubscriptionRepository')),
    __param(22, common_1.Inject('SubscriptionRepository')),
    __param(23, common_1.Inject('SubscriptionPlanRepository')),
    __param(24, common_1.Inject('CountryRepository')),
    __param(25, common_1.Inject('RegionCountryJCTRepository')),
    __param(26, common_1.Inject('PaymentOptionTypeRepository')),
    __param(27, common_1.Inject('PaymentTermRepository')),
    __param(28, common_1.Inject('UnitRepository')),
    __param(29, common_1.Inject('DiscountUnitRepository')),
    __param(30, common_1.Inject('ProfileTypeClassificationRepository')),
    __param(31, common_1.Inject('ProfileTypeRepository')),
    __param(32, common_1.Inject('ChannelTypeRepository')),
    __param(33, common_1.Inject('ChannelCustomerProfileRepository')),
    __param(34, common_1.Inject('ProductAwardRepository')),
    __metadata("design:paramtypes", [channel_service_1.ChannelService, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object])
], ProductImportService);
exports.ProductImportService = ProductImportService;
//# sourceMappingURL=productImport.service.js.map