'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnitService = void 0;
const common_1 = require("@nestjs/common");
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
let UnitService = class UnitService {
    constructor(repository, sequelizeInstance) {
        this.repository = repository;
        this.sequelizeInstance = sequelizeInstance;
    }
    async create(data) {
        return await this.repository.create(this._buildObject(new Object(), data));
    }
    async findAll(pagination) {
        return await this.repository.findAll({
            limit: pagination.limit,
            offset: pagination.offset,
            order: [['unitid', 'DESC']]
        });
    }
    async findOne(options) {
        let result = await this.repository.findOne(options);
        if (!result) {
            throw new Process_exception_1.ProcessException('validate:field:notFound');
        }
        return result;
    }
    async findByPk(id) {
        let result = await this.repository.findByPk(id);
        if (!result) {
            throw new Process_exception_1.ProcessException('validate:field:notFound');
        }
        return result;
    }
    async update(id, newValue) {
        let result = await this.repository.findByPk(id);
        if (!result) {
            throw new Process_exception_1.ProcessException('validate:field:notFound');
        }
        await this._buildObject(result, newValue).save();
        return result;
    }
    async delete(id) {
        let result = await this.repository.findByPk(id);
        if (!result) {
            throw new Process_exception_1.ProcessException('media:documentTypeId:notFound');
        }
        return await result.destroy();
    }
    async getCount() {
        return await this.repository.count();
    }
    _buildObject(entity, dto) {
        entity.unit = dto.unit;
        return entity;
    }
};
UnitService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject('UnitRepository')),
    __param(1, common_1.Inject('SequelizeInstance')),
    __metadata("design:paramtypes", [Object, Object])
], UnitService);
exports.UnitService = UnitService;
//# sourceMappingURL=unit.services.js.map