'use strict';
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProductSerivceInBound = void 0;
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
const lodash_1 = require("lodash");
const app_constant_1 = require("../../../config/app.constant");
const sanitizeHtml = require('sanitize-html');
class ProductSerivceInBound {
    constructor() {
    }
    async setDocumentObject(docTempPath, doctype, folderPath) {
        try {
            let mediaObject = {};
            mediaObject.documentPath = docTempPath;
            mediaObject.documentTypeId = doctype;
            if (folderPath) {
                mediaObject.dirName = folderPath;
            }
            return mediaObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:media');
        }
    }
    async setProductObject(product, user) {
        try {
            let returnObject = {};
            let productDetail = {};
            if (product.productBasicInfo) {
                productDetail.videourl = (product.productImages.videourl) ? product.productImages.videourl : null;
                productDetail.productdesc = (product.productBasicInfo.productdesc) ? sanitizeHtml(product.productBasicInfo.productdesc, app_constant_1.appconstant.SANITIZE_HTML) : null;
                productDetail.keyretailers = (!lodash_1.isUndefined(product.productBasicInfo.keyretailers)) ? sanitizeHtml(product.productBasicInfo.keyretailers, app_constant_1.appconstant.SANITIZE_HTML) : null;
                productDetail.keydistributors = (!lodash_1.isUndefined(product.productBasicInfo.keydistributors)) ? sanitizeHtml(product.productBasicInfo.keydistributors, app_constant_1.appconstant.SANITIZE_HTML) : null;
                productDetail.usp = (product.productBasicInfo.productusp) ? sanitizeHtml(product.productBasicInfo.productusp, app_constant_1.appconstant.SANITIZE_HTML) : null;
                productDetail.isavaialbleimmediate = (product.productAvailability.isavaialbleimmediate) ? product.productAvailability.isavaialbleimmediate : null;
                productDetail.avaialblefrom = (product.productAvailability.avaialblefrom) ? product.productAvailability.avaialblefrom : null;
                productDetail.avaialbilitycomment = (product.productAvailability.avaialbilitycomment) ? product.productAvailability.avaialbilitycomment : null;
                productDetail.updatedby = +user.userId;
                productDetail.createdat = new Date();
                productDetail.productshortdec = (product.productBasicInfo.productshortdec) ? product.productBasicInfo.productshortdec : null;
                returnObject.productDetail = productDetail;
            }
            if (product.ProductInfo) {
                productDetail.productCertifi = (product.ProductInfo.productCertifi) ? product.ProductInfo.productCertifi : null;
                productDetail.productWarranty = (product.ProductInfo.productWarranty) ? product.ProductInfo.productWarranty : null;
                productDetail.productLocal = (product.ProductInfo.productLocal) ? product.ProductInfo.productLocal : null;
                returnObject.productDetail = productDetail;
            }
            let productTagResultObject = [];
            if (product.productBasicInfo.producttag && product.productBasicInfo.producttag.length) {
                for (let ii = 0; ii < product.productBasicInfo.producttag.length; ii++) {
                    let productTag = {};
                    productTag.tag = (product.productBasicInfo.producttag[ii].tag) ? product.productBasicInfo.producttag[ii].tag : null;
                    productTag.updatedby = +user.userId;
                    productTag.createdat = new Date();
                    productTagResultObject.push(productTag);
                }
                returnObject.productTag = productTagResultObject;
            }
            let productArticleReviewObject = [];
            if (product.productArticleReview && product.productArticleReview.review && product.productArticleReview.review.length) {
                for (let ii = 0; ii < product.productArticleReview.review.length; ii++) {
                    let productArticleReview = {};
                    productArticleReview.productreviewername = (product.productArticleReview.review[ii].reviewername) ? product.productArticleReview.review[ii].reviewername : null;
                    productArticleReview.articleurl = (product.productArticleReview.review[ii].articleurl) ? product.productArticleReview.review[ii].articleurl : null;
                    if (product.productArticleReview.review[ii].logo) {
                        let media = {};
                        media.documentTypeId = app_constant_1.appconstant.DOCUMENTTYPE_IMAGE;
                        media.documentPath = (product.productArticleReview.review[ii].logo) ? product.productArticleReview.review[ii].logo : null;
                        media.dirName = app_constant_1.appconstant.FOLDER_PATH_PRODUCT_ARTICLE;
                        productArticleReview.reviewmagazinelogo = media;
                    }
                    productArticleReview.updatedby = +user.userId;
                    productArticleReview.createdat = new Date();
                    productArticleReviewObject.push(productArticleReview);
                }
                returnObject.productArticleReview = productArticleReviewObject;
            }
            let productExistRatingObject = [];
            if (product.productArticleReview && product.productArticleReview.productexistingrating && product.productArticleReview.productexistingrating.length) {
                for (let ii = 0; ii < product.productArticleReview.productexistingrating.length; ii++) {
                    let productExistRating = {};
                    productExistRating.existproductrating = (product.productArticleReview.productexistingrating[ii].existproductrating) ? product.productArticleReview.productexistingrating[ii].existproductrating : null;
                    productExistRating.ratingproofvalidationurl = (product.productArticleReview.productexistingrating[ii].ratingproofvalidationurl) ? product.productArticleReview.productexistingrating[ii].ratingproofvalidationurl : null;
                    productExistRating.ratingproofvalidationname = (product.productArticleReview.productexistingrating[ii].ratingproofvalidationname) ? product.productArticleReview.productexistingrating[ii].ratingproofvalidationname : null;
                    if (product.productArticleReview.productexistingrating[ii].ratingproofvalidationlogo) {
                        let media = {};
                        media.documentTypeId = app_constant_1.appconstant.DOCUMENTTYPE_IMAGE;
                        media.documentPath = (product.productArticleReview.productexistingrating[ii].ratingproofvalidationlogo) ? product.productArticleReview.productexistingrating[ii].ratingproofvalidationlogo : null;
                        media.dirName = app_constant_1.appconstant.FOLDER_PATH_PRODUCT_EXISTING_RATING_LOGO;
                        productExistRating.ratingproofvalidationlogo = media;
                    }
                    productExistRating.updatedby = +user.userId;
                    productExistRating.createdat = new Date();
                    productExistRatingObject.push(productExistRating);
                }
                returnObject.productExistRating = productExistRatingObject;
            }
            let productImageObject = [];
            if (product.productImages.productimage && product.productImages.productimage.length) {
                for (let ii = 0; ii < product.productImages.productimage.length; ii++) {
                    let productImage = {};
                    let media = {};
                    media.documentTypeId = app_constant_1.appconstant.DOCUMENTTYPE_IMAGE;
                    media.documentPath = (product.productImages.productimage[ii].image) ? product.productImages.productimage[ii].image : null;
                    media.dirName = app_constant_1.appconstant.FOLDER_PATH_PRODUCT_IMAGE;
                    productImage.image = media;
                    productImage.productimagetype = app_constant_1.appconstant.PRODUCT_IMAGE_TYPE;
                    productImage.updatedby = +user.userId;
                    productImage.isdefault = (product.productImages.productimage[ii].isdefault) ? product.productImages.productimage[ii].isdefault : "0";
                    productImage.sortorder = (product.productImages.productimage[ii].sortorder) ? product.productImages.productimage[ii].sortorder : null;
                    productImage.createdat = new Date();
                    productImageObject.push(productImage);
                }
                returnObject.productImage = productImageObject;
            }
            if (product.productImages.productdisplayimage && product.productImages.productdisplayimage.length) {
                for (let ii = 0; ii < product.productImages.productdisplayimage.length; ii++) {
                    let productImage = {};
                    let media = {};
                    media.documentTypeId = app_constant_1.appconstant.DOCUMENTTYPE_IMAGE;
                    media.documentPath = (product.productImages.productdisplayimage[ii].image) ? product.productImages.productdisplayimage[ii].image : null;
                    media.dirName = app_constant_1.appconstant.FOLDER_PATH_PRODUCT_DISPLAY_IMAGE;
                    productImage.image = media;
                    productImage.productimagetype = app_constant_1.appconstant.PRODUCT_DISPLAY_IMAGE_TYPE;
                    productImage.updatedby = +user.userId;
                    productImage.createdat = new Date();
                    productImageObject.push(productImage);
                }
                returnObject.productImage = productImageObject;
            }
            if (product.productImages.productpackagingimage && product.productImages.productpackagingimage.length) {
                for (let ii = 0; ii < product.productImages.productpackagingimage.length; ii++) {
                    let productImage = {};
                    let media = {};
                    media.documentTypeId = app_constant_1.appconstant.DOCUMENTTYPE_IMAGE;
                    media.documentPath = (product.productImages.productpackagingimage[ii].image) ? product.productImages.productpackagingimage[ii].image : null;
                    media.dirName = app_constant_1.appconstant.FOLDER_PATH_PRODUCT_PACKING_IMAGE;
                    productImage.image = media;
                    productImage.productimagetype = app_constant_1.appconstant.PRODUCT_PACKING_IMAGE_TYPE;
                    productImage.updatedby = +user.userId;
                    productImage.createdat = new Date();
                    productImageObject.push(productImage);
                }
                returnObject.productImage = productImageObject;
            }
            let productPreferencesObject = [];
            if (product.productPreferences && product.productPreferences.preferences) {
                for (let ii = 0; ii < product.productPreferences.preferences.length; ii++) {
                    let productPreferences = {};
                    productPreferences.sharetypeid = (product.productPreferences.preferences[ii].sharetypeid) ? product.productPreferences.preferences[ii].sharetypeid : null;
                    productPreferences.updatedby = +user.userId;
                    productPreferences.createdat = new Date();
                    productPreferencesObject.push(productPreferences);
                }
                returnObject.productSharePreference = productPreferencesObject;
            }
            let productCodeTypeObject = [];
            if (product.productCode.productCodeTypes && product.productCode.productCodeTypes.length) {
                for (let ii = 0; ii < product.productCode.productCodeTypes.length; ii++) {
                    let productUniversalCode = {};
                    productUniversalCode.productuniversalcodetype = (product.productCode.productCodeTypes[ii].productuniversalcodetype) ? product.productCode.productCodeTypes[ii].productuniversalcodetype : null;
                    productUniversalCode.code = (product.productCode.productCodeTypes[ii].code) ? product.productCode.productCodeTypes[ii].code : null;
                    productUniversalCode.updatedby = +user.userId;
                    productUniversalCode.createdat = new Date();
                    productCodeTypeObject.push(productUniversalCode);
                }
                returnObject.productUniversalCode = productCodeTypeObject;
            }
            let productPriceDetail = {};
            if (product.productPrice) {
                productPriceDetail.businesscurrencyid = (product.productPrice.currencyid) ? product.productPrice.currencyid : +user.channel.channelDetail.currencyid;
                productPriceDetail.retailerprice = (product.productPrice.retailerprice) ? product.productPrice.retailerprice : null;
                productPriceDetail.retailerpriceunitid = (product.productPrice.retailerpriceunitid) ? product.productPrice.retailerpriceunitid : null;
                productPriceDetail.sampleprice = (product.productPrice.sampleprice) ? product.productPrice.sampleprice : null;
                productPriceDetail.samplepriceunitid = (product.productPrice.samplepriceunitid) ? product.productPrice.samplepriceunitid : null;
                productPriceDetail.issamplefree = (product.productPrice.issamplefree) ? product.productPrice.issamplefree : null;
                productPriceDetail.samplethreshold = (product.productPrice.samplethreshold) ? product.productPrice.samplethreshold : null;
                productPriceDetail.isunlimitsample = (product.productPrice.isunlimitsample) ? product.productPrice.isunlimitsample : null;
                productPriceDetail.updatedby = +user.userId;
                productPriceDetail.createdat = new Date();
                returnObject.productPriceDetail = productPriceDetail;
            }
            let productPackageInfo = {};
            if (product.productPackageInfo) {
                productPackageInfo.minorderquantity = (product.productPackageInfo.minorderquantity) ? product.productPackageInfo.minorderquantity : null;
                productPackageInfo.orderunitid = (product.productPackageInfo.orderunitid) ? product.productPackageInfo.orderunitid : null;
                productPackageInfo.packagesize = (product.productPackageInfo.packagesize) ? product.productPackageInfo.packagesize : null;
                productPackageInfo.packageunit = (product.productPackageInfo.packageunit) ? product.productPackageInfo.packageunit : null;
                productPackageInfo.noofpackageinbox = (product.productPackageInfo.noofpackageinbox) ? product.productPackageInfo.noofpackageinbox : null;
                productPackageInfo.noofpackageinboxunitid = (product.productPackageInfo.noofpackageinboxunitid) ? product.productPackageInfo.noofpackageinboxunitid : null;
                productPackageInfo.noofboxinpallet = (product.productPackageInfo.noofboxinpallet) ? product.productPackageInfo.noofboxinpallet : null;
                productPackageInfo.noofboxinpalletunitid = (product.productPackageInfo.noofboxinpalletunitid) ? product.productPackageInfo.noofboxinpalletunitid : null;
                productPackageInfo.approximateweightofpallet = (product.productPackageInfo.approximateweightofpallet) ? product.productPackageInfo.approximateweightofpallet : null;
                productPackageInfo.approximateweightofpalletunitid = (product.productPackageInfo.approximateweightofpalletunitid) ? product.productPackageInfo.approximateweightofpalletunitid : null;
                productPackageInfo.length = (product.productPackageInfo.length) ? product.productPackageInfo.length : null;
                productPackageInfo.breadth = (product.productPackageInfo.breadth) ? product.productPackageInfo.breadth : null;
                productPackageInfo.height = (product.productPackageInfo.height) ? product.productPackageInfo.height : null;
                productPackageInfo.weight = (product.productPackageInfo.weight) ? product.productPackageInfo.weight : null;
                productPackageInfo.updatedby = +user.userId;
                productPackageInfo.createdat = new Date();
                returnObject.productPackageInfo = productPackageInfo;
            }
            let productCompetingObject = [];
            if (product.productCompeting && product.productCompeting.productcompeting.length) {
                for (let ii = 0; ii < product.productCompeting.productcompeting.length; ii++) {
                    let productCompeting = {};
                    productCompeting.competingproduct = (product.productCompeting.productcompeting[ii].competingproduct) ? product.productCompeting.productcompeting[ii].competingproduct : null;
                    productCompeting.competitor = (product.productCompeting.productcompeting[ii].competitor) ? product.productCompeting.productcompeting[ii].competitor : null;
                    productCompeting.competitorproducturl = (product.productCompeting.productcompeting[ii].competitorproducturl) ? product.productCompeting.productcompeting[ii].competitorproducturl : null;
                    productCompeting.updatedby = +user.userId;
                    productCompeting.createdat = new Date();
                    productCompetingObject.push(productCompeting);
                }
                returnObject.productCompeting = productCompetingObject;
            }
            let productChannelCustomerProfileObject = [];
            if (product.productRelevantChannel && product.productRelevantChannel.distributionchannel && product.productRelevantChannel.distributionchannel.length > 0) {
                for (let ii = 0; ii < product.productRelevantChannel.distributionchannel.length; ii++) {
                    let productChannelCustomerProfile = {};
                    productChannelCustomerProfile.channelId = +user.channelId;
                    productChannelCustomerProfile.customerProfileId = (product.productRelevantChannel.distributionchannel[ii].customerProfileId) ? product.productRelevantChannel.distributionchannel[ii].customerProfileId : null;
                    productChannelCustomerProfile.updatedby = +user.userId;
                    productChannelCustomerProfile.createdat = new Date();
                    productChannelCustomerProfileObject.push(productChannelCustomerProfile);
                }
                returnObject.productChannelCustomerProfile = productChannelCustomerProfileObject;
            }
            if (product.productRelevantChannel && product.productRelevantChannel.retailchannel && product.productRelevantChannel.retailchannel.length > 0) {
                for (let ii = 0; ii < product.productRelevantChannel.retailchannel.length; ii++) {
                    let productChannelCustomerProfile = {};
                    productChannelCustomerProfile.channelId = +user.channelId;
                    productChannelCustomerProfile.customerProfileId = (product.productRelevantChannel.retailchannel[ii].customerProfileId) ? product.productRelevantChannel.retailchannel[ii].customerProfileId : null;
                    productChannelCustomerProfile.updatedby = +user.userId;
                    productChannelCustomerProfile.createdat = new Date();
                    productChannelCustomerProfileObject.push(productChannelCustomerProfile);
                }
                returnObject.productChannelCustomerProfile = productChannelCustomerProfileObject;
            }
            let productlocationObject = [];
            if (product.productSellingLocation && product.productSellingLocation.sellinglocation && product.productSellingLocation.sellinglocation.length) {
                for (let ii = 0; ii < product.productSellingLocation.sellinglocation.length; ii++) {
                    let productLocation = {};
                    productLocation.locationtype = app_constant_1.appconstant.LOCATION_TYPE_SELLING;
                    productLocation.regionCountryJCTId = (product.productSellingLocation.sellinglocation[ii].regioncountryjctid) ? product.productSellingLocation.sellinglocation[ii].regioncountryjctid : null;
                    productLocation.updatedby = +user.userId;
                    productLocation.createdat = new Date();
                    productlocationObject.push(productLocation);
                }
                returnObject.productLocation = productlocationObject;
            }
            if (product.productTargetLocation && product.productTargetLocation.targetlocation && product.productTargetLocation.targetlocation.length) {
                for (let ii = 0; ii < product.productTargetLocation.targetlocation.length; ii++) {
                    let productLocation = {};
                    productLocation.locationtype = app_constant_1.appconstant.LOCATION_TYPE_TARGET;
                    productLocation.regionCountryJCTId = (product.productTargetLocation.targetlocation[ii].regioncountryjctid) ? product.productTargetLocation.targetlocation[ii].regioncountryjctid : null;
                    productLocation.updatedby = +user.userId;
                    productLocation.createdat = new Date();
                    productlocationObject.push(productLocation);
                }
                returnObject.productLocation = productlocationObject;
            }
            if (product.productBasicInfo) {
                returnObject.channelId = +user.channelId;
                returnObject.productGroupId = (+product.productBasicInfo.productgroup) ? +product.productBasicInfo.productgroup : null;
                returnObject.productCategorieId = (+product.productBasicInfo.productcategory) ? +product.productBasicInfo.productcategory : null;
                returnObject.brandId = (+product.productBasicInfo.productbrand) ? +product.productBasicInfo.productbrand : null;
                returnObject.product = (product.productBasicInfo.productname) ? product.productBasicInfo.productname : null;
                returnObject.isshowtofreesub = (product.productPreferences.isshowtofreesub) ? product.productPreferences.isshowtofreesub : null;
                returnObject.hasanyvariant = (product.productCode.hasanyvariant) ? product.productCode.hasanyvariant : null;
                returnObject.variantdetails = (product.productCode.variantdetails) ? product.productCode.variantdetails : null;
                returnObject.productqualitylevel = (product.productPosition.productqualitylevel) ? product.productPosition.productqualitylevel : null;
                returnObject.isactive = (product.productBasicInfo.productstatus) ? product.productBasicInfo.productstatus : '0';
                returnObject.businessType = (product.productBasicInfo.businessType) ? +product.productBasicInfo.businessType : 3;
                returnObject.updatedBy = +user.userId;
                returnObject.createdat = new Date();
            }
            return returnObject;
        }
        catch (e) {
            console.log("error setProductObject " + e.message);
            throw new Process_exception_1.ProcessException('channel:product:objectCreation');
        }
    }
    async setProductUpdateObject(product, productData) {
        try {
            let productObject = {};
            productObject.productId = productData.productId;
            productObject.isSuggestion = '1';
            productObject.productSKU = "SKU000" + productData.channelId + productData.productId;
            productObject.productkey = productData.product.split(" ").join("-").toLowerCase() + "-" + productData.productId;
            return productObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:product:objectCreation');
        }
    }
    async setUpdateProductObject(product, user, productData) {
        try {
            let returnObject = {};
            if (product.productBasicInfo) {
                productData.productGroupId = (+product.productBasicInfo.productgroup) ? +product.productBasicInfo.productgroup : productData.productGroupId;
                productData.productCategorieId = (+product.productBasicInfo.productcategory) ? +product.productBasicInfo.productcategory : productData.productCategorieId;
                productData.brandId = (+product.productBasicInfo.productbrand) ? +product.productBasicInfo.productbrand : productData.brandId;
                productData.product = (product.productBasicInfo.productname) ? product.productBasicInfo.productname : productData.product;
                productData.product_pitch_award = (product.productBasicInfo.product_pitch_award) ? product.productBasicInfo.product_pitch_award : productData.product_pitch_award;
                productData.isactive = (product.productBasicInfo.productstatus) ? product.productBasicInfo.productstatus : productData.isactive;
                productData.businessType = (product.productBasicInfo.businessType) ? +product.productBasicInfo.businessType : productData.businessType;
                productData.updatedBy = +user.userId;
                productData.productDetail.productId = (productData.productId) ? productData.productId : productData.productDetail.productId;
                productData.productDetail.productdesc = (product.productBasicInfo.productdesc) ? sanitizeHtml(product.productBasicInfo.productdesc, app_constant_1.appconstant.SANITIZE_HTML) : productData.productDetail.productdesc;
                productData.productDetail.keyretailers = (!lodash_1.isUndefined(product.productBasicInfo.keyretailers)) ? sanitizeHtml(product.productBasicInfo.keyretailers, app_constant_1.appconstant.SANITIZE_HTML) : productData.productDetail.keyretailers;
                productData.productDetail.keyresellers = (!lodash_1.isUndefined(product.productBasicInfo.keyresellers)) ? sanitizeHtml(product.productBasicInfo.keyresellers, app_constant_1.appconstant.SANITIZE_HTML) : productData.productDetail.keyresellers;
                productData.productDetail.keydistributors = (!lodash_1.isUndefined(product.productBasicInfo.keydistributors)) ? sanitizeHtml(product.productBasicInfo.keydistributors, app_constant_1.appconstant.SANITIZE_HTML) : productData.productDetail.keydistributors;
                productData.productDetail.usp = (product.productBasicInfo.productusp) ? sanitizeHtml(product.productBasicInfo.productusp, app_constant_1.appconstant.SANITIZE_HTML) : productData.productDetail.usp;
                productData.productDetail.updatedby = +user.userId;
                productData.productDetail.productshortdec = product.productBasicInfo.productshortdec ? product.productBasicInfo.productshortdec : productData.productBasicInfo.productshortdec;
            }
            if (product.ProductInfo) {
                productData.productDetail.productCertifi = product.ProductInfo.productCertifi ? product.ProductInfo.productCertifi : productData.productDetail.productCertifi;
                productData.productDetail.productWarranty = product.ProductInfo.productWarranty ? product.ProductInfo.productWarranty : productData.productDetail.productWarranty;
                productData.productDetail.productLocal = product.ProductInfo.productLocal ? product.ProductInfo.productLocal : productData.productDetail.productLocal;
            }
            if (product.productPosition && product.productPosition.productqualitylevel) {
                productData.productqualitylevel = (product.productPosition.productqualitylevel) ? product.productPosition.productqualitylevel : productData.productqualitylevel;
            }
            if (product.productPreferences && product.productPreferences.isshowtofreesub) {
                productData.isshowtofreesub = (product.productPreferences.isshowtofreesub) ? product.productPreferences.isshowtofreesub : productData.isshowtofreesub;
            }
            if (product.productCode && product.productCode.hasanyvariant) {
                productData.hasanyvariant = (product.productCode.hasanyvariant) ? product.productCode.hasanyvariant : productData.hasanyvariant;
            }
            if (product.productCode && product.productCode.variantdetails) {
                productData.variantdetails = (product.productCode.variantdetails) ? product.productCode.variantdetails : productData.variantdetails;
            }
            productData.productDetail.videourl = (product.productImages && product.productImages.videourl) ? product.productImages.videourl : null;
            if (product.productAvailability) {
                productData.productDetail.isavaialbleimmediate = (product.productAvailability.isavaialbleimmediate) ? product.productAvailability.isavaialbleimmediate : productData.productDetail.isavaialbleimmediate;
                if (productData.productDetail.isavaialbleimmediate == '1') {
                    productData.productDetail.avaialblefrom = null;
                    productData.productDetail.avaialbilitycomment = null;
                }
                else {
                    productData.productDetail.avaialblefrom = (product.productAvailability.avaialblefrom) ? product.productAvailability.avaialblefrom : productData.productDetail.avaialblefrom;
                    productData.productDetail.avaialbilitycomment = (product.productAvailability.avaialbilitycomment) ? product.productAvailability.avaialbilitycomment : productData.productDetail.avaialbilitycomment;
                }
            }
            if (product.productPrice) {
                productData.productPriceDetail.productId = +productData.productId;
                productData.productPriceDetail.businesscurrencyid = (product.productPrice.currencyid) ? product.productPrice.currencyid : productData.productPriceDetail.businesscurrencyid;
                productData.productPriceDetail.retailerprice = (product.productPrice.retailerprice) ? product.productPrice.retailerprice : productData.productPriceDetail.retailerprice;
                productData.productPriceDetail.retailerpriceunitid = (product.productPrice.retailerpriceunitid) ? product.productPrice.retailerpriceunitid : productData.productPriceDetail.retailerpriceunitid;
                productData.productPriceDetail.sampleprice = (product.productPrice.sampleprice) ? product.productPrice.sampleprice : productData.productPriceDetail.sampleprice;
                productData.productPriceDetail.samplepriceunitid = (product.productPrice.samplepriceunitid) ? product.productPrice.samplepriceunitid : productData.productPriceDetail.samplepriceunitid;
                productData.productPriceDetail.issamplefree = (product.productPrice.issamplefree) ? product.productPrice.issamplefree : productData.productPriceDetail.issamplefree;
                productData.productPriceDetail.samplethreshold = (product.productPrice.samplethreshold) ? product.productPrice.samplethreshold : productData.productPriceDetail.samplethreshold;
                productData.productPriceDetail.isunlimitsample = (product.productPrice.isunlimitsample) ? product.productPrice.isunlimitsample : productData.productPriceDetail.isunlimitsample;
                productData.productPriceDetail.updatedby = +user.userId;
            }
            if (product.productPackageInfo) {
                productData.productPackageInfo.productId = +productData.productId;
                productData.productPackageInfo.minorderquantity = (product.productPackageInfo.minorderquantity) ? product.productPackageInfo.minorderquantity : productData.productPackageInfo.minorderquantity;
                productData.productPackageInfo.orderunitid = (product.productPackageInfo.orderunitid) ? product.productPackageInfo.orderunitid : productData.productPackageInfo.orderunitid;
                productData.productPackageInfo.packagesize = (product.productPackageInfo.packagesize) ? product.productPackageInfo.packagesize : productData.productPackageInfo.packagesize;
                productData.productPackageInfo.packageunit = (product.productPackageInfo.packageunit) ? product.productPackageInfo.packageunit : productData.productPackageInfo.packageunit;
                productData.productPackageInfo.noofpackageinbox = (product.productPackageInfo.noofpackageinbox || product.productPackageInfo.noofpackageinbox == null) ? product.productPackageInfo.noofpackageinbox : productData.productPackageInfo.noofpackageinbox;
                productData.productPackageInfo.noofpackageinboxunitid = (product.productPackageInfo.noofpackageinboxunitid || product.productPackageInfo.noofpackageinboxunitid == null) ? product.productPackageInfo.noofpackageinboxunitid : productData.productPackageInfo.noofpackageinboxunitid;
                productData.productPackageInfo.noofboxinpallet = (product.productPackageInfo.noofboxinpallet || product.productPackageInfo.noofboxinpallet == null) ? product.productPackageInfo.noofboxinpallet : productData.productPackageInfo.noofboxinpallet;
                productData.productPackageInfo.noofboxinpalletunitid = (product.productPackageInfo.noofboxinpalletunitid || product.productPackageInfo.noofboxinpalletunitid == null) ? product.productPackageInfo.noofboxinpalletunitid : productData.productPackageInfo.noofboxinpalletunitid;
                productData.productPackageInfo.approximateweightofpallet = (product.productPackageInfo.approximateweightofpallet) ? product.productPackageInfo.approximateweightofpallet : productData.productPackageInfo.approximateweightofpallet;
                productData.productPackageInfo.approximateweightofpalletunitid = (product.productPackageInfo.approximateweightofpalletunitid) ? product.productPackageInfo.approximateweightofpalletunitid : productData.productPackageInfo.approximateweightofpalletunitid;
                productData.productPackageInfo.length = (product.productPackageInfo.length) ? product.productPackageInfo.length : productData.productPackageInfo.length;
                productData.productPackageInfo.breadth = (product.productPackageInfo.breadth) ? product.productPackageInfo.breadth : productData.productPackageInfo.breadth;
                productData.productPackageInfo.height = (product.productPackageInfo.height) ? product.productPackageInfo.height : productData.productPackageInfo.height;
                productData.productPackageInfo.weight = (product.productPackageInfo.weight) ? product.productPackageInfo.weight : productData.productPackageInfo.weight;
                productData.productPackageInfo.updatedby = +user.userId;
            }
            return productData;
        }
        catch (e) {
            console.log("error setUpdateProductObject " + e.message);
            throw new Process_exception_1.ProcessException('channel:product:objectCreation');
        }
    }
    async setProductSellingLocation(product, productData, user, activeIds) {
        try {
            let resultObject = [];
            let sellinglocation = product.productSellingLocation.sellinglocation;
            for (let ii = 0; ii < sellinglocation.length; ii++) {
                if (!activeIds.includes(sellinglocation[ii].regioncountryjctid)) {
                    let innerObject = {};
                    innerObject.productId = +productData.productId;
                    innerObject.locationtype = app_constant_1.appconstant.LOCATION_TYPE_SELLING;
                    innerObject.regionCountryJCTId = sellinglocation[ii].regioncountryjctid;
                    innerObject.updatedby = +user.userId;
                    innerObject.createdat = new Date();
                    resultObject.push(innerObject);
                }
            }
            return resultObject;
        }
        catch (e) {
            console.log("error setProductLocation " + e.message);
            throw new Process_exception_1.ProcessException('channel:objectCreation:productLocation');
        }
    }
    async setProductTargetLocation(product, productData, user, activeIds) {
        try {
            let resultObject = [];
            let targetlocation = product.productTargetLocation.targetlocation;
            for (let ii = 0; ii < targetlocation.length; ii++) {
                if (!activeIds.includes(targetlocation[ii].regioncountryjctid)) {
                    let innerObject = {};
                    innerObject.productId = +productData.productId;
                    innerObject.locationtype = app_constant_1.appconstant.LOCATION_TYPE_TARGET;
                    innerObject.regionCountryJCTId = targetlocation[ii].regioncountryjctid;
                    innerObject.updatedby = +user.userId;
                    innerObject.createdat = new Date();
                    resultObject.push(innerObject);
                }
            }
            return resultObject;
        }
        catch (e) {
            console.log("error setProductLocation " + e.message);
            throw new Process_exception_1.ProcessException('channel:objectCreation:productLocation');
        }
    }
    async setProductImportObject(product, masters, imageFolder) {
        let productObject = {};
        productObject.productBasicInfo = {};
        productObject.productBasicInfo.productname = product.product;
        productObject.productBasicInfo.productdesc = sanitizeHtml(product.productDesc, app_constant_1.appconstant.SANITIZE_HTML);
        productObject.productBasicInfo.productusp = sanitizeHtml(product.tweetPitch, app_constant_1.appconstant.SANITIZE_HTML);
        productObject.productBasicInfo.productstatus = '1';
        if (product.productCategory) {
            masters.master.productCategory.map(function (data, index) {
                if (data.productCategorie.toLowerCase().trim() == product.productCategory.toLowerCase().trim()) {
                    productObject.productBasicInfo.productcategory = +data.productCategorieId;
                    productObject.productBasicInfo.productgroup = +data.productGroupId;
                }
            });
        }
        if (product.productBrand) {
            masters.master.brand.map(function (data, index) {
                if (data.brandName.toLowerCase().trim() == product.productBrand.toLowerCase().trim()) {
                    productObject.productBasicInfo.productbrand = data.id;
                }
            });
        }
        productObject.productTargetLocation = {};
        productObject.productSellingLocation = {};
        productObject.productTargetLocation.targetlocation = [];
        productObject.productSellingLocation.sellinglocation = [];
        masters.master.channelLocation.map(function (data, index) {
            if (data.locationType == app_constant_1.appconstant.LOCATION_TYPE_TARGET) {
                productObject.productTargetLocation.targetlocation.push({ "regioncountryjctid": +data.regionCountryJCTId });
            }
            if (data.locationType == app_constant_1.appconstant.LOCATION_TYPE_SELLING) {
                productObject.productSellingLocation.sellinglocation.push({ "regioncountryjctid": +data.regionCountryJCTId });
            }
        });
        if (product.productRelevantDistributorChannel || product.productRelevantRetailerChannel) {
            let productRelevantDistributorSplit = (product.productRelevantDistributorChannel) ? product.productRelevantDistributorChannel.toLowerCase().split("|") : [];
            let productRelevantRetailerSplit = (product.productRelevantRetailerChannel) ? product.productRelevantRetailerChannel.toLowerCase().split("|") : [];
            productObject.productRelevantChannel = {};
            masters.master.channelCustomerProfile.map(function (data, index) {
                if (data.pTClas.channelType.dataValues.name == app_constant_1.appconstant.PROFILE_TYPE_DISTRIBUTOR) {
                    productRelevantDistributorSplit.map(function (profileType, index) {
                        if (data.pTClas.profileType.dataValues.name.toLowerCase().trim() == profileType.toLowerCase().trim()) {
                            if (!productObject.productRelevantChannel.distributionchannel || (productObject.productRelevantChannel.distributionchannel && productObject.productRelevantChannel.distributionchannel.length === 0)) {
                                productObject.productRelevantChannel.distributionchannel = [];
                            }
                            productObject.productRelevantChannel.distributionchannel.push({ "customerProfileId": +data.customerProfileId });
                        }
                    });
                }
                if (data.pTClas.channelType.dataValues.name == app_constant_1.appconstant.PROFILE_TYPE_RETAILER) {
                    productRelevantRetailerSplit.map(function (profileType, index) {
                        if (data.pTClas.profileType.dataValues.name.toLowerCase().trim() == profileType.toLowerCase().trim()) {
                            if (!productObject.productRelevantChannel.retailchannel || (productObject.productRelevantChannel.retailchannel && productObject.productRelevantChannel.retailchannel.length === 0)) {
                                productObject.productRelevantChannel.retailchannel = [];
                            }
                            productObject.productRelevantChannel.retailchannel.push({ "customerProfileId": +data.customerProfileId });
                        }
                    });
                }
            });
        }
        productObject.productPreferences = {};
        productObject.productPreferences.isshowtofreesub = (product.isShowToFreeSub && product.isShowToFreeSub.toLowerCase().trim() == 'yes') ? '1' : '0';
        productObject.productPreferences.preferences = [];
        masters.master.shareType.map(function (data, index) {
            productObject.productPreferences.preferences.push({ 'sharetypeid': +data.sharetypeid });
        });
        if (product.productArticleReview_Name_1 || product.productArticleReview_Name_2 || product.productArticleReview_Name_3 || product.productArticleReview_Name_4) {
            productObject.productArticleReview = {};
            productObject.productArticleReview.review = [];
            if (product.productArticleReview_Name_1) {
                productObject.productArticleReview.review.push(await this.setReviewArticles(imageFolder, product.productArticleReview_Name_1, product.productArticleReview_Logo_1, product.productArticleReview_URL_1));
            }
            if (product.productArticleReview_Name_2) {
                productObject.productArticleReview.review.push(await this.setReviewArticles(imageFolder, product.productArticleReview_Name_2, product.productArticleReview_Logo_2, product.productArticleReview_URL_2));
            }
            if (product.productArticleReview_Name_3) {
                productObject.productArticleReview.review.push(await this.setReviewArticles(imageFolder, product.productArticleReview_Name_3, product.productArticleReview_Logo_3, product.productArticleReview_URL_3));
            }
            if (product.productArticleReview_Name_4) {
                productObject.productArticleReview.review.push(await this.setReviewArticles(imageFolder, product.productArticleReview_Name_4, product.productArticleReview_Logo_4, product.productArticleReview_URL_4));
            }
        }
        productObject.productImages = {};
        if (product.productImage) {
            productObject.productImages.productimage = [];
            productObject.productImages.productimage.push({
                "image": 'product-import-zip-s3' + imageFolder + '/' + product.productImage,
                "isdefault": "1",
                "sortorder": 1
            });
        }
        if (product.productDisplayImage && product.productDisplayImage.trim().length) {
            productObject.productImages.productdisplayimage = [];
            productObject.productImages.productdisplayimage.push({
                "image": 'product-import-zip-s3' + imageFolder + '/' + product.productDisplayImage
            });
        }
        if (product.productPackagingImage && product.productPackagingImage.trim().length) {
            productObject.productImages.productpackagingimage = [];
            productObject.productImages.productpackagingimage.push({
                "image": 'product-import-zip-s3' + imageFolder + '/' + product.productPackagingImage
            });
        }
        if (productObject.productImages && (lodash_1.isUndefined(productObject.productImages.productimage) || lodash_1.isUndefined(productObject.productImages.productpackagingimage))) {
            productObject.productBasicInfo.productstatus = '0';
        }
        if (product.productBrochure_1 && product.productBrochure_1.trim().length || product.productBrochure_2 && product.productBrochure_2.trim().length || product.productBrochure_3 && product.productBrochure_3.trim().length) {
            productObject.productBrochure = {};
            productObject.productBrochure.productpdf = [];
            if (product.productBrochure_1 && product.productBrochure_1.trim().length) {
                productObject.productBrochure.productpdf.push({
                    "image": imageFolder + '/' + product.productBrochure_1
                });
            }
            if (product.productBrochure_2 && product.productBrochure_2.trim().length) {
                productObject.productBrochure.productpdf.push({
                    "image": imageFolder + '/' + product.productBrochure_2
                });
            }
            if (product.productBrochure_3 && product.productBrochure_3.trim().length) {
                productObject.productBrochure.productpdf.push({
                    "image": imageFolder + '/' + product.productBrochure_3
                });
            }
        }
        productObject.productCode = {};
        productObject.productCode.productCodeTypes = [];
        if (product.EAN) {
            productObject.productCode.productCodeTypes.push({
                "productuniversalcodetype": "EAN",
                "code": '' + product.EAN
            });
        }
        if (product.inventoryCode) {
            productObject.productCode.productCodeTypes.push({
                "productuniversalcodetype": "HSN",
                "code": '' + product.inventoryCode
            });
        }
        if (product.UPC) {
            productObject.productCode.productCodeTypes.push({
                "productuniversalcodetype": "UPC",
                "code": '' + product.UPC
            });
        }
        if (product.hasAnyVariant) {
            productObject.productCode.hasanyvariant = (product.hasAnyVariant.toLowerCase().trim() == 'no') ? '0' : '1';
        }
        if (product.variantDetails) {
            productObject.productCode.variantdetails = product.variantDetails;
        }
        if (product.productCertifi) {
            productObject.productCertifi = (product.productCertifi) ? product.productCertifi : null;
        }
        if (product.productWarranty) {
            productObject.productWarranty = (product.productWarranty) ? product.productWarranty : null;
        }
        productObject.productPrice = {};
        productObject.productPrice.retailerprice = +product.retailerPrice;
        if (product.currency) {
            masters.master.currency.map(function (data, index) {
                if (data.currency.toLowerCase().trim() == product.currency.toLowerCase().trim()) {
                    productObject.productPrice.currencyid = +data.currencyid;
                }
            });
        }
        productObject.productPrice.issamplefree = (product.isSampleFree.toLowerCase().trim() == 'yes') ? '1' : '0';
        productObject.productPrice.sampleprice = +product.samplePrice;
        productObject.productPrice.isunlimitsample = (product.isUnlimitSample.toLowerCase().trim() == 'no') ? '0' : '1';
        productObject.productPrice.samplethreshold = +product.sampleThreshold;
        productObject.productPackageInfo = {};
        productObject.productPackageInfo.minorderquantity = +product.minOrderQuantity;
        if (product.retailerPriceUnit || product.samplePriceUnit || product.minOrderQuantityUnit || product.packageSizeUnit || product.approximateWeightOfPalletUnit) {
            masters.master.unit.map(function (data, index) {
                if (product.retailerPriceUnit && data.unit.toLowerCase().trim() == product.retailerPriceUnit.toLowerCase().trim()) {
                    productObject.productPrice.retailerpriceunitid = +data.unitid;
                }
                if (product.samplePriceUnit && data.unit.toLowerCase().trim() == product.samplePriceUnit.toLowerCase().trim()) {
                    productObject.productPrice.samplepriceunitid = +data.unitid;
                }
                if (product.minOrderQuantityUnit && data.unit.toLowerCase().trim() == product.minOrderQuantityUnit.toLowerCase().trim()) {
                    productObject.productPackageInfo.orderunitid = +data.unitid;
                }
            });
        }
        productObject.productPosition = {
            "productqualitylevel": product.productQualityLevel
        };
        productObject.productAvailability = {
            "isavaialbleimmediate": (product.isAvailabelImmediate.toLowerCase().trim() == 'no') ? '0' : '1',
            "avaialblefrom": product.availabelFrom,
            "avaialbilitycomment": product.availabilityComment
        };
        return productObject;
    }
    async setReviewArticles(imageFolder, name, logo, url) {
        let object = {
            "reviewername": name,
            "articleurl": url
        };
        if (logo && logo.trim().length) {
            object['logo'] = imageFolder + '/' + logo;
        }
        return object;
    }
    async setProductChannelCustomerProfile(product, productData, user, activeIds) {
        try {
            let resultObject = [];
            let distributionchannel = product.productRelevantChannel.distributionchannel;
            let retailchannel = product.productRelevantChannel.retailchannel;
            let resellerchannel = product.productRelevantChannel.resellerchannel;
            if (distributionchannel && distributionchannel.length > 0) {
                for (let ii = 0; ii < distributionchannel.length; ii++) {
                    if (!activeIds.includes(distributionchannel[ii].customerProfileId)) {
                        let innerObject = {};
                        innerObject.productId = +productData.productId;
                        innerObject.channelId = +user.channelId;
                        innerObject.customerProfileId = distributionchannel[ii].customerProfileId;
                        innerObject.updatedby = +user.userId;
                        innerObject.createdat = new Date();
                        resultObject.push(innerObject);
                    }
                }
            }
            if (retailchannel && retailchannel.length > 0) {
                for (let ii = 0; ii < retailchannel.length; ii++) {
                    if (!activeIds.includes(retailchannel[ii].customerProfileId)) {
                        let innerObject = {};
                        innerObject.productId = +productData.productId;
                        innerObject.channelId = +user.channelId;
                        innerObject.customerProfileId = retailchannel[ii].customerProfileId;
                        innerObject.updatedby = +user.userId;
                        innerObject.createdat = new Date();
                        resultObject.push(innerObject);
                    }
                }
            }
            if (resellerchannel && resellerchannel.length > 0) {
                for (let ii = 0; ii < resellerchannel.length; ii++) {
                    if (!activeIds.includes(resellerchannel[ii].customerProfileId)) {
                        let innerObject = {};
                        innerObject.productId = +productData.productId;
                        innerObject.channelId = +user.channelId;
                        innerObject.customerProfileId = resellerchannel[ii].customerProfileId;
                        innerObject.updatedby = +user.userId;
                        innerObject.createdat = new Date();
                        resultObject.push(innerObject);
                    }
                }
            }
            return resultObject;
        }
        catch (e) {
            console.log("error setProductChannelCustomerProfile " + e.message);
            throw new Process_exception_1.ProcessException('channel:objectCreation:productRelevantChannel');
        }
    }
    async setUpdateProductRelationObject(product, user, productData) {
        try {
            let returnObject = {};
            let productTagResultObject = [];
            if (product.productBasicInfo && product.productBasicInfo.producttag && product.productBasicInfo.producttag.length > 0) {
                for (let ii = 0; ii < product.productBasicInfo.producttag.length; ii++) {
                    let productTag = {};
                    if (product.productBasicInfo.producttag[ii].producttagid) {
                        productTag.producttagid = +product.productBasicInfo.producttag[ii].producttagid;
                    }
                    productTag.productId = +productData.productId;
                    productTag.tag = (product.productBasicInfo.producttag[ii].tag) ? product.productBasicInfo.producttag[ii].tag : null;
                    productTag.updatedby = +user.userId;
                    if (!product.productBasicInfo.producttag[ii].producttagid) {
                        productTag.createdat = new Date();
                    }
                    productTagResultObject.push(productTag);
                }
                returnObject.productTag = productTagResultObject;
            }
            if (product.deletedproducttag) {
                for (let ii = 0; ii < product.deletedproducttag.length; ii++) {
                    if (product.deletedproducttag[ii]) {
                        let productTag = {};
                        productTag.producttagid = +product.deletedproducttag[ii];
                        productTag.deletedat = new Date();
                        productTagResultObject.push(productTag);
                    }
                }
                returnObject.productTag = productTagResultObject;
            }
            let productArticleReviewObject = [];
            if (product.productArticleReview && product.productArticleReview.review && product.productArticleReview.review.length > 0) {
                for (let ii = 0; ii < product.productArticleReview.review.length; ii++) {
                    let productArticleReview = {};
                    if (product.productArticleReview.review[ii].productarticlereviewid) {
                        productArticleReview.productarticlereviewid = +product.productArticleReview.review[ii].productarticlereviewid;
                    }
                    productArticleReview.productId = +productData.productId;
                    productArticleReview.productreviewername = (product.productArticleReview.review[ii].reviewername) ? product.productArticleReview.review[ii].reviewername : null;
                    productArticleReview.articleurl = (product.productArticleReview.review[ii].articleurl) ? product.productArticleReview.review[ii].articleurl : null;
                    if (product.productArticleReview.review[ii].imageid) {
                        productArticleReview.reviewmagazinelogoid = +product.productArticleReview.review[ii].imageid;
                    }
                    if (product.productArticleReview.review[ii].logo) {
                        let media = {};
                        media.documentTypeId = app_constant_1.appconstant.DOCUMENTTYPE_IMAGE;
                        media.documentPath = (product.productArticleReview.review[ii].logo) ? product.productArticleReview.review[ii].logo : null;
                        media.dirName = app_constant_1.appconstant.FOLDER_PATH_PRODUCT_ARTICLE;
                        productArticleReview.reviewmagazinelogo = media;
                    }
                    productArticleReview.updatedby = +user.userId;
                    if (!product.productArticleReview.review[ii].productarticlereviewid) {
                        productArticleReview.createdat = new Date();
                    }
                    productArticleReviewObject.push(productArticleReview);
                }
                returnObject.productArticleReview = productArticleReviewObject;
            }
            if (product.deletedarticlereview) {
                for (let ii = 0; ii < product.deletedarticlereview.length; ii++) {
                    if (product.deletedarticlereview[ii]) {
                        let productArticleReview = {};
                        productArticleReview.productarticlereviewid = +product.deletedarticlereview[ii];
                        productArticleReview.deletedat = new Date();
                        productArticleReviewObject.push(productArticleReview);
                    }
                }
                returnObject.productArticleReview = productArticleReviewObject;
            }
            let productExistRatingObject = [];
            if (product.productArticleReview && product.productArticleReview.productexistingrating && product.productArticleReview.productexistingrating.length > 0) {
                for (let ii = 0; ii < product.productArticleReview.productexistingrating.length; ii++) {
                    let productExistRating = {};
                    if (product.productArticleReview.productexistingrating[ii].productexistratingid) {
                        productExistRating.productexistratingid = +product.productArticleReview.productexistingrating[ii].productexistratingid;
                    }
                    productExistRating.productId = +productData.productId;
                    productExistRating.existproductrating = (product.productArticleReview.productexistingrating[ii].existproductrating) ? product.productArticleReview.productexistingrating[ii].existproductrating : null;
                    productExistRating.ratingproofvalidationurl = (product.productArticleReview.productexistingrating[ii].ratingproofvalidationurl) ? product.productArticleReview.productexistingrating[ii].ratingproofvalidationurl : null;
                    productExistRating.ratingproofvalidationname = (product.productArticleReview.productexistingrating[ii].ratingproofvalidationname) ? product.productArticleReview.productexistingrating[ii].ratingproofvalidationname : null;
                    if (product.productArticleReview.productexistingrating[ii].ratingproofvalidationlogo) {
                        let media = {};
                        media.documentTypeId = app_constant_1.appconstant.DOCUMENTTYPE_IMAGE;
                        media.documentPath = (product.productArticleReview.productexistingrating[ii].ratingproofvalidationlogo) ? product.productArticleReview.productexistingrating[ii].ratingproofvalidationlogo : null;
                        media.dirName = app_constant_1.appconstant.FOLDER_PATH_PRODUCT_EXISTING_RATING_LOGO;
                        productExistRating.ratingproofvalidationlogo = media;
                    }
                    productExistRating.updatedby = +user.userId;
                    if (!product.productArticleReview.productexistingrating[ii].productexistratingid) {
                        productExistRating.createdat = new Date();
                    }
                    productExistRatingObject.push(productExistRating);
                }
                returnObject.productExistRating = productExistRatingObject;
            }
            if (product.deletedexistingrating) {
                for (let ii = 0; ii < product.deletedexistingrating.length; ii++) {
                    if (product.deletedexistingrating[ii]) {
                        let productExistRating = {};
                        productExistRating.productexistratingid = +product.deletedexistingrating[ii];
                        productExistRating.deletedat = new Date();
                        productExistRatingObject.push(productExistRating);
                    }
                }
                returnObject.productExistRating = productExistRatingObject;
            }
            let productImageObject = [];
            if (product.productImages && product.productImages.productimage && product.productImages.productimage.length > 0) {
                for (let ii = 0; ii < product.productImages.productimage.length; ii++) {
                    let productImage = {};
                    if (product.productImages.productimage[ii].productimageid) {
                        productImage.productimageid = +product.productImages.productimage[ii].productimageid;
                    }
                    if (product.productImages.productimage[ii].imageid) {
                        productImage.imageid = +product.productImages.productimage[ii].imageid;
                    }
                    let media = {};
                    media.documentTypeId = app_constant_1.appconstant.DOCUMENTTYPE_IMAGE;
                    media.documentPath = (product.productImages.productimage[ii].image) ? product.productImages.productimage[ii].image : null;
                    media.dirName = app_constant_1.appconstant.FOLDER_PATH_PRODUCT_IMAGE;
                    productImage.image = media;
                    productImage.productId = +productData.productId;
                    productImage.productimagetype = app_constant_1.appconstant.PRODUCT_IMAGE_TYPE;
                    productImage.updatedby = +user.userId;
                    if (product.productImages.productimage[ii].isdefault) {
                        productImage.isdefault = product.productImages.productimage[ii].isdefault;
                    }
                    if (product.productImages.productimage[ii].sortorder) {
                        productImage.sortorder = product.productImages.productimage[ii].sortorder;
                    }
                    if (!product.productImages.productimage[ii].productimageid) {
                        productImage.createdat = new Date();
                    }
                    productImageObject.push(productImage);
                }
                returnObject.productImage = productImageObject;
            }
            if (product.deletedproductimage) {
                for (let ii = 0; ii < product.deletedproductimage.length; ii++) {
                    if (product.deletedproductimage[ii]) {
                        let productImage = {};
                        productImage.productimageid = +product.deletedproductimage[ii];
                        productImage.deletedat = new Date();
                        productImageObject.push(productImage);
                    }
                }
                returnObject.productImage = productImageObject;
            }
            if (product.productImages && product.productImages.productdisplayimage && product.productImages.productdisplayimage.length > 0) {
                for (let ii = 0; ii < product.productImages.productdisplayimage.length; ii++) {
                    let productImage = {};
                    if (product.productImages.productdisplayimage[ii].productimageid) {
                        productImage.productimageid = +product.productImages.productdisplayimage[ii].productimageid;
                    }
                    if (product.productImages.productdisplayimage[ii].imageid) {
                        productImage.imageid = +product.productImages.productdisplayimage[ii].imageid;
                    }
                    let media = {};
                    media.documentTypeId = app_constant_1.appconstant.DOCUMENTTYPE_IMAGE;
                    media.documentPath = (product.productImages.productdisplayimage[ii].image) ? product.productImages.productdisplayimage[ii].image : null;
                    media.dirName = app_constant_1.appconstant.FOLDER_PATH_PRODUCT_DISPLAY_IMAGE;
                    productImage.image = media;
                    productImage.productId = +productData.productId;
                    productImage.productimagetype = app_constant_1.appconstant.PRODUCT_DISPLAY_IMAGE_TYPE;
                    productImage.updatedby = +user.userId;
                    if (!product.productImages.productdisplayimage[ii].productimageid) {
                        productImage.createdat = new Date();
                    }
                    productImageObject.push(productImage);
                }
                returnObject.productImage = productImageObject;
            }
            if (product.deletedproductdisplayimage) {
                for (let ii = 0; ii < product.deletedproductdisplayimage.length; ii++) {
                    if (product.deletedproductdisplayimage[ii]) {
                        let productImage = {};
                        productImage.productimageid = +product.deletedproductdisplayimage[ii];
                        productImage.deletedat = new Date();
                        productImageObject.push(productImage);
                    }
                }
                returnObject.productImage = productImageObject;
            }
            if (product.productImages && product.productImages.productpackagingimage && product.productImages.productpackagingimage.length > 0) {
                for (let ii = 0; ii < product.productImages.productpackagingimage.length; ii++) {
                    let productImage = {};
                    if (product.productImages.productpackagingimage[ii].productimageid) {
                        productImage.productimageid = +product.productImages.productpackagingimage[ii].productimageid;
                    }
                    if (product.productImages.productpackagingimage[ii].imageid) {
                        productImage.imageid = +product.productImages.productpackagingimage[ii].imageid;
                    }
                    let media = {};
                    media.documentTypeId = app_constant_1.appconstant.DOCUMENTTYPE_IMAGE;
                    media.documentPath = (product.productImages.productpackagingimage[ii].image) ? product.productImages.productpackagingimage[ii].image : null;
                    media.dirName = app_constant_1.appconstant.FOLDER_PATH_PRODUCT_PACKING_IMAGE;
                    productImage.image = media;
                    productImage.productId = +productData.productId;
                    productImage.productimagetype = app_constant_1.appconstant.PRODUCT_PACKING_IMAGE_TYPE;
                    productImage.updatedby = +user.userId;
                    if (!product.productImages.productpackagingimage[ii].productimageid) {
                        productImage.createdat = new Date();
                    }
                    productImageObject.push(productImage);
                }
                returnObject.productImage = productImageObject;
            }
            if (product.deletedproductpackageimage) {
                for (let ii = 0; ii < product.deletedproductpackageimage.length; ii++) {
                    if (product.deletedproductpackageimage[ii]) {
                        let productImage = {};
                        productImage.productimageid = +product.deletedproductpackageimage[ii];
                        productImage.deletedat = new Date();
                        productImageObject.push(productImage);
                    }
                }
                returnObject.productImage = productImageObject;
            }
            if (product.deletedproductbrochure) {
                for (let ii = 0; ii < product.deletedproductbrochure.length; ii++) {
                    if (product.deletedproductbrochure[ii]) {
                        let productImage = {};
                        productImage.productimageid = +product.deletedproductbrochure[ii];
                        productImage.deletedat = new Date();
                        productImageObject.push(productImage);
                    }
                }
                returnObject.productImage = productImageObject;
            }
            let productPreferencesObject = [];
            if (product.productPreferences && product.productPreferences.preferences && product.productPreferences.preferences.length > 0) {
                let preferences = product.productPreferences.preferences;
                for (let ii = 0; ii < preferences.length; ii++) {
                    let productPreferences = {};
                    productPreferences.sharetypeid = (preferences[ii].sharetypeid) ? preferences[ii].sharetypeid : null;
                    productPreferences.updatedby = +user.userId;
                    productPreferences.createdat = new Date();
                    productPreferencesObject.push(productPreferences);
                }
                returnObject.productSharePreference = productPreferencesObject;
            }
            let productCodeTypeObject = [];
            if (product.productCode && product.productCode.productCodeTypes && product.productCode.productCodeTypes.length > 0) {
                for (let ii = 0; ii < product.productCode.productCodeTypes.length; ii++) {
                    let productUniversalCode = {};
                    if (product.productCode.productCodeTypes[ii].productuniversalcodeid) {
                        productUniversalCode.productuniversalcodeid = +product.productCode.productCodeTypes[ii].productuniversalcodeid;
                        productUniversalCode.deletedat = null;
                    }
                    productUniversalCode.productId = +productData.productId;
                    productUniversalCode.productuniversalcodetype = (product.productCode.productCodeTypes[ii].productuniversalcodetype) ? product.productCode.productCodeTypes[ii].productuniversalcodetype : null;
                    productUniversalCode.code = (product.productCode.productCodeTypes[ii].code) ? product.productCode.productCodeTypes[ii].code : null;
                    productUniversalCode.updatedby = +user.userId;
                    if (!product.productCode.productCodeTypes[ii].productuniversalcodeid) {
                        productUniversalCode.createdat = new Date();
                    }
                    productCodeTypeObject.push(productUniversalCode);
                }
                returnObject.productUniversalCode = productCodeTypeObject;
            }
            let productCompetingObject = [];
            if (product.productCompeting && product.productCompeting.productcompeting && product.productCompeting.productcompeting.length > 0) {
                for (let ii = 0; ii < product.productCompeting.productcompeting.length; ii++) {
                    let productCompeting = {};
                    if (product.productCompeting.productcompeting[ii].productcompetingid) {
                        productCompeting.productcompetingid = +product.productCompeting.productcompeting[ii].productcompetingid;
                    }
                    productCompeting.productId = +productData.productId;
                    productCompeting.competingproduct = (product.productCompeting.productcompeting[ii].competingproduct) ? product.productCompeting.productcompeting[ii].competingproduct : null;
                    productCompeting.competitor = (product.productCompeting.productcompeting[ii].competitor) ? product.productCompeting.productcompeting[ii].competitor : null;
                    productCompeting.competitorproducturl = (product.productCompeting.productcompeting[ii].competitorproducturl) ? product.productCompeting.productcompeting[ii].competitorproducturl : null;
                    productCompeting.updatedby = +user.userId;
                    if (!product.productCompeting.productcompeting[ii].productcompetingid) {
                        productCompeting.createdat = new Date();
                    }
                    productCompetingObject.push(productCompeting);
                }
                returnObject.productCompeting = productCompetingObject;
            }
            if (product.deletedcompetingproduct) {
                for (let ii = 0; ii < product.deletedcompetingproduct.length; ii++) {
                    if (product.deletedcompetingproduct[ii]) {
                        let productCompeting = {};
                        productCompeting.productcompetingid = +product.deletedcompetingproduct[ii];
                        productCompeting.deletedat = new Date();
                        productCompetingObject.push(productCompeting);
                    }
                }
                returnObject.productCompeting = productCompetingObject;
            }
            let productChannelCustomerProfileObject = [];
            if (product.productRelevantChannel && product.productRelevantChannel.distributionchannel && product.productRelevantChannel.distributionchannel.length > 0) {
                for (let ii = 0; ii < product.productRelevantChannel.distributionchannel.length; ii++) {
                    let productChannelCustomerProfile = {};
                    productChannelCustomerProfile.productId = +productData.productId;
                    productChannelCustomerProfile.channelId = +user.channelId;
                    productChannelCustomerProfile.customerProfileId = (product.productRelevantChannel.distributionchannel[ii].customerProfileId) ? product.productRelevantChannel.distributionchannel[ii].customerProfileId : null;
                    productChannelCustomerProfile.updatedby = +user.userId;
                    productChannelCustomerProfile.createdat = new Date();
                    productChannelCustomerProfileObject.push(productChannelCustomerProfile);
                }
                returnObject.productChannelCustomerProfile = productChannelCustomerProfileObject;
            }
            if (product.productRelevantChannel && product.productRelevantChannel.retailchannel && product.productRelevantChannel.retailchannel.length > 0) {
                for (let ii = 0; ii < product.productRelevantChannel.retailchannel.length; ii++) {
                    let productChannelCustomerProfile = {};
                    productChannelCustomerProfile.productId = +productData.productId;
                    productChannelCustomerProfile.channelId = +user.channelId;
                    productChannelCustomerProfile.customerProfileId = (product.productRelevantChannel.retailchannel[ii].customerProfileId) ? product.productRelevantChannel.retailchannel[ii].customerProfileId : null;
                    productChannelCustomerProfile.updatedby = +user.userId;
                    productChannelCustomerProfile.createdat = new Date();
                    productChannelCustomerProfileObject.push(productChannelCustomerProfile);
                }
                returnObject.productChannelCustomerProfile = productChannelCustomerProfileObject;
            }
            if (product.productRelevantChannel && product.productRelevantChannel.resellerchannel && product.productRelevantChannel.resellerchannel.length > 0) {
                for (let ii = 0; ii < product.productRelevantChannel.resellerchannel.length; ii++) {
                    let productChannelCustomerProfile = {};
                    productChannelCustomerProfile.productId = +productData.productId;
                    productChannelCustomerProfile.channelId = +user.channelId;
                    productChannelCustomerProfile.customerProfileId = (product.productRelevantChannel.resellerchannel[ii].customerProfileId) ? product.productRelevantChannel.resellerchannel[ii].customerProfileId : null;
                    productChannelCustomerProfile.updatedby = +user.userId;
                    productChannelCustomerProfile.createdat = new Date();
                    productChannelCustomerProfileObject.push(productChannelCustomerProfile);
                }
                returnObject.productChannelCustomerProfile = productChannelCustomerProfileObject;
            }
            let productlocationObject = [];
            if (product.productSellingLocation && product.productSellingLocation.sellinglocation && product.productSellingLocation.sellinglocation.length > 0) {
                for (let ii = 0; ii < product.productSellingLocation.sellinglocation.length; ii++) {
                    let productLocation = {};
                    productLocation.productId = +productData.productId;
                    productLocation.locationtype = app_constant_1.appconstant.LOCATION_TYPE_SELLING;
                    productLocation.regionCountryJCTId = (product.productSellingLocation.sellinglocation[ii].regioncountryjctid) ? product.productSellingLocation.sellinglocation[ii].regioncountryjctid : null;
                    productLocation.updatedby = +user.userId;
                    productLocation.createdat = new Date();
                    productlocationObject.push(productLocation);
                }
                returnObject.productLocation = productlocationObject;
            }
            if (product.productTargetLocation && product.productTargetLocation.targetlocation && product.productTargetLocation.targetlocation.length > 0) {
                for (let ii = 0; ii < product.productTargetLocation.targetlocation.length; ii++) {
                    let productLocation = {};
                    productLocation.productId = +productData.productId;
                    productLocation.locationtype = app_constant_1.appconstant.LOCATION_TYPE_TARGET;
                    productLocation.regionCountryJCTId = (product.productTargetLocation.targetlocation[ii].regioncountryjctid) ? product.productTargetLocation.targetlocation[ii].regioncountryjctid : null;
                    productLocation.updatedby = +user.userId;
                    productLocation.createdat = new Date();
                    productlocationObject.push(productLocation);
                }
                returnObject.productLocation = productlocationObject;
            }
            return returnObject;
        }
        catch (e) {
            console.log("error setUpdateProductRelationObject " + e.message);
            throw new Process_exception_1.ProcessException('channel:product:objectCreation');
        }
    }
    async setProductSharePreference(product, productData, user, activeIds) {
        try {
            let resultObject = [];
            let productPreferences = product.productPreferences.preferences;
            for (let ii = 0; ii < productPreferences.length; ii++) {
                if (!activeIds.includes(productPreferences[ii].sharetypeid)) {
                    let innerObject = {};
                    innerObject.productId = +productData.productId;
                    innerObject.sharetypeid = +productPreferences[ii].sharetypeid;
                    innerObject.updatedby = +user.userId;
                    innerObject.createdat = new Date();
                    resultObject.push(innerObject);
                }
            }
            return resultObject;
        }
        catch (e) {
            console.log("error setProductSharePreference " + e.message);
            throw new Process_exception_1.ProcessException('channel:objectCreation:productSharePreference');
        }
    }
}
exports.ProductSerivceInBound = ProductSerivceInBound;
//# sourceMappingURL=productSerivceInBound.js.map