"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReportController = void 0;
const common_1 = require("@nestjs/common");
const passport_1 = require("@nestjs/passport");
const report_service_1 = require("../service/report.service");
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
let ReportController = class ReportController {
    constructor(reportService) {
        this.reportService = reportService;
    }
    async getTransactionReport(req, res) {
        let user = req.user;
        let reqKey = req.body;
        let result = await this.reportService.getFailureTransaction(reqKey);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async getInvoice(req, res) {
        let user = req.user;
        let reqKey = req.body;
        let result = await this.reportService.getAllInvoices();
        console.log(result);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
};
__decorate([
    common_1.Post('getTransactionReport'),
    __param(0, common_1.Req()), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], ReportController.prototype, "getTransactionReport", null);
__decorate([
    common_1.Get('searchinvoice'),
    __param(0, common_1.Req()), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], ReportController.prototype, "getInvoice", null);
ReportController = __decorate([
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    common_1.Controller('report'),
    __metadata("design:paramtypes", [report_service_1.ReportService])
], ReportController);
exports.ReportController = ReportController;
//# sourceMappingURL=report.controller.js.map