"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReportService = void 0;
const common_1 = require("@nestjs/common");
const PaymentTransaction_entity_1 = require("../../channel/models/PaymentTransaction.entity");
const sequelize_1 = require("sequelize");
const Channel_entity_1 = require("../../channel/models/Channel.entity");
let ReportService = class ReportService {
    constructor(failureTransactionRepository, paymentTransactionRepository) {
        this.failureTransactionRepository = failureTransactionRepository;
        this.paymentTransactionRepository = paymentTransactionRepository;
    }
    async getFailureTransaction(data) {
        if (data.methodId == '2') {
            return await this.paymentTransactionRepository.findAndCountAll({
                where: {
                    paymentMethodId: 2,
                    transactionNumber: null
                },
                raw: true,
                limit: data.limit,
                offset: data.page,
            });
        }
        else {
            return await this.failureTransactionRepository.findAndCountAll({
                attributes: ['failureTransactionId', 'response', 'paymentTransaction.paymentTransactionId', "channel.channelTypeId", "channel.companyName",
                    "paymentTransaction.paymentTransactionAt"],
                include: [{
                        model: PaymentTransaction_entity_1.PaymentTransaction,
                    },
                    {
                        model: Channel_entity_1.Channel,
                    }
                ],
                where: {
                    paymentMethodId: {
                        [sequelize_1.Op.in]: [data.methodId]
                    }
                },
                raw: true,
                limit: data.limit,
                offset: data.page,
            });
        }
    }
    async getAllInvoices() {
        return await this.paymentTransactionRepository.findAll({
            attributes: ['invoice'],
            where: {
                paymentMethodId: 2
            }
        });
    }
};
ReportService = __decorate([
    __param(0, common_1.Inject('FailureTransactionRepository')),
    __param(1, common_1.Inject('PaymentTransactionRepository')),
    __metadata("design:paramtypes", [Object, Object])
], ReportService);
exports.ReportService = ReportService;
//# sourceMappingURL=report.service.js.map