'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AddressBookController = void 0;
const common_1 = require("@nestjs/common");
const validation_pipe_1 = require("../../../middleware/pipe/validation.pipe");
const myAddressBook_service_1 = require("./../service/myAddressBook.service");
const myAddressBook_dto_1 = require("./../dto/myAddressBook.dto");
const passport_1 = require("@nestjs/passport");
let AddressBookController = class AddressBookController {
    constructor(service) {
        this.service = service;
    }
    async getAll(req, res) {
        let user = req.user;
        let total = 0;
        this.service.getCount(user, (req.query.type) ? req.query.type : null).then(function (c) {
            total = c;
        });
        const list = await this.service.findAll(user, (req.query.type) ? req.query.type : null);
        return res.status(common_1.HttpStatus.OK).send(list);
    }
    async getById(id, req, res) {
        let user = req.user;
        const row = await this.service.findById(id, user);
        return res.status(common_1.HttpStatus.OK).json(row);
    }
    async create(req, res, dto) {
        let user = req.user;
        let result = await this.service.create(dto, user);
        return res.status(common_1.HttpStatus.CREATED).send(result);
    }
    async update(id, req, res, dto) {
        let user = req.user;
        const row = await this.service.update(id, dto, user);
        return res.status(common_1.HttpStatus.OK).json(row);
    }
    async delete(id, req, res) {
        let user = req.user;
        let row = await this.service.delete(id, user);
        return res.status(common_1.HttpStatus.OK).send();
    }
};
__decorate([
    common_1.Get('/'),
    __param(0, common_1.Request()), __param(1, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], AddressBookController.prototype, "getAll", null);
__decorate([
    common_1.Get('/:id'),
    __param(0, common_1.Param('id')), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], AddressBookController.prototype, "getById", null);
__decorate([
    common_1.Post('/'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body(new validation_pipe_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, myAddressBook_dto_1.MyAddressBookDto]),
    __metadata("design:returntype", Promise)
], AddressBookController.prototype, "create", null);
__decorate([
    common_1.Put('/:id'),
    __param(0, common_1.Param('id')), __param(1, common_1.Request()), __param(2, common_1.Response()), __param(3, common_1.Body(new validation_pipe_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object, myAddressBook_dto_1.MyAddressBookDto]),
    __metadata("design:returntype", Promise)
], AddressBookController.prototype, "update", null);
__decorate([
    common_1.Delete('/:id'),
    __param(0, common_1.Param('id')), __param(1, common_1.Request()), __param(2, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], AddressBookController.prototype, "delete", null);
AddressBookController = __decorate([
    common_1.Controller('addressbook'),
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    __metadata("design:paramtypes", [myAddressBook_service_1.MyAddressBookService])
], AddressBookController);
exports.AddressBookController = AddressBookController;
//# sourceMappingURL=myAddressBook.controller.js.map