"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserController = void 0;
const common_1 = require("@nestjs/common");
const passport_1 = require("@nestjs/passport");
const context_service_1 = require("../../../context/context.service");
const app_constant_1 = require("../../../config/app.constant");
const user_service_1 = require("../service/user.service");
const addUser_dto_1 = require("../dto/addUser.dto");
const updateUser_dto_1 = require("../dto/updateUser.dto");
const account_pipe_1 = require("../../account/pipe/account.pipe");
let UserController = class UserController {
    constructor(userService, sequelizeInstance, context) {
        this.userService = userService;
        this.sequelizeInstance = sequelizeInstance;
        this.context = context;
    }
    async addNewUser(res, req, addUserDto) {
        let nonsuggestion = [];
        let count;
        let user = req.user;
        try {
            let result = await this.userService.addUser(addUserDto, user.channelId, user.showId, user.userId, user.channelTypeId);
            let userId = result.userId;
            let channelId = user.channelId;
            let contactId = result.contactId;
            let channelTypeId = user.channelTypeId;
            res.status(common_1.HttpStatus.CREATED).send({
                created: result
            });
        }
        catch (e) {
            console.log("adduser:", e);
        }
    }
    async userProfileUpdate(id, userDto, res, req) {
        let nonsuggestion = [];
        let count;
        let real_user = req.user;
        if (Object.keys(userDto).length) {
            let user = await this.userService.getUser(id, req.user.channelId);
            let allowToModifyInterestedCategory = true;
            await this.userService.updateUser(userDto, user, allowToModifyInterestedCategory, real_user);
        }
        res.status(common_1.HttpStatus.OK).send({
            updated: true
        });
    }
    async getPreference(res, req) {
        let user = req.user;
        let result = await this.userService.getPreference(user.channelTypeId);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async getMailPreference(res, req) {
        let result = await this.userService.getMailPreference();
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async getUserPreference(contactId, res, req) {
        let user = req.user;
        let result = await this.userService.getUserPreference(contactId, user.channelId);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async getUserPrevilege(contactId, res, req) {
        let user = req.user;
        let result = await this.userService.getUserPrevilege(contactId);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async getDefaultContact(res, req) {
        let user = req.user;
        let result = await this.userService.getDefaultContact(user.channelId);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async getAllContacts(res, req) {
        let user = req.user;
        let result = await this.userService.getAllContacts(user.channelId);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async setDefaultContact(contactId, res, req) {
        let user = req.user;
        let result = await this.userService.setDefaultContact(user.channelId, contactId);
        return res.status(common_1.HttpStatus.OK).send(result);
    }
    async userCountry(req, res) {
        let result = await this.userService.Countries();
        if (result) {
            res.status(common_1.HttpStatus.OK).json(result);
        }
        else {
        }
    }
    async getContact(id, res) {
        let contact = await this.userService.getContact(id);
        res.status(common_1.HttpStatus.OK).send(contact);
    }
    async getLogedUserFeatreList(req, res) {
        let keyId = app_constant_1.appconstant.SubscriptionCharcteristicFeature;
        let ids = req.body.keys;
        let respon = req.user.channel.channelSubscription.keyFeature[keyId[ids]];
        res.status(common_1.HttpStatus.OK).json({ key: ids, value: respon });
    }
    async isAlgorithm(id, res) {
        let contact = await this.userService.isAlgorithm(id);
        res.status(common_1.HttpStatus.OK).send(contact);
    }
    async checkmail(email, data, res) {
        let result = await this.userService.checkEmail(email.trim(), data.userId);
        console.log('email', email);
        res.status(common_1.HttpStatus.OK).send({
            isavialble: result
        });
    }
};
__decorate([
    common_1.Post('add'),
    __param(0, common_1.Res()), __param(1, common_1.Req()), __param(2, common_1.Body(new common_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, addUser_dto_1.AddUserDto]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "addNewUser", null);
__decorate([
    common_1.Patch('profile/:id'),
    __param(0, common_1.Param('id', new common_1.ParseIntPipe())), __param(1, common_1.Body(new common_1.ValidationPipe())), __param(2, common_1.Res()), __param(3, common_1.Req()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, updateUser_dto_1.UpdateUserDto, Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "userProfileUpdate", null);
__decorate([
    common_1.Get('preference'),
    __param(0, common_1.Res()), __param(1, common_1.Req()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "getPreference", null);
__decorate([
    common_1.Get('mailpreference'),
    __param(0, common_1.Res()), __param(1, common_1.Req()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "getMailPreference", null);
__decorate([
    common_1.Get('userpreference/:contactId'),
    __param(0, common_1.Param('contactId')), __param(1, common_1.Res()), __param(2, common_1.Req()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "getUserPreference", null);
__decorate([
    common_1.Get('userprevilege/:contactId'),
    __param(0, common_1.Param('contactId')), __param(1, common_1.Res()), __param(2, common_1.Req()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "getUserPrevilege", null);
__decorate([
    common_1.Get('defaultcontact'),
    __param(0, common_1.Res()), __param(1, common_1.Req()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "getDefaultContact", null);
__decorate([
    common_1.Get('allcontacts'),
    __param(0, common_1.Res()), __param(1, common_1.Req()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "getAllContacts", null);
__decorate([
    common_1.Get('setDefaultContact/:contactId'),
    __param(0, common_1.Param('contactId')), __param(1, common_1.Res()), __param(2, common_1.Req()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "setDefaultContact", null);
__decorate([
    common_1.Get('country'),
    __param(0, common_1.Req()), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "userCountry", null);
__decorate([
    common_1.Get('contact/:id'),
    __param(0, common_1.Param('id', new common_1.ParseIntPipe())), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "getContact", null);
__decorate([
    common_1.Post('getUserFeatureType'),
    __param(0, common_1.Req()), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "getLogedUserFeatreList", null);
__decorate([
    common_1.Put('isAlgorithm/:id'),
    __param(0, common_1.Param('id', new common_1.ParseIntPipe())), __param(1, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "isAlgorithm", null);
__decorate([
    common_1.Post('checkusermail/:email'),
    __param(0, common_1.Param('email', new account_pipe_1.CheckEmailPipe())), __param(1, common_1.Body()), __param(2, common_1.Res()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object]),
    __metadata("design:returntype", Promise)
], UserController.prototype, "checkmail", null);
UserController = __decorate([
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    common_1.Controller('user'),
    __param(1, common_1.Inject('SequelizeInstance')),
    __metadata("design:paramtypes", [user_service_1.UserService, Object, context_service_1.ContextService])
], UserController);
exports.UserController = UserController;
//# sourceMappingURL=user.controller.js.map