'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateContactDto = void 0;
const class_validator_1 = require("class-validator");
class UpdateContactDto {
}
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.MinLength(1, { message: "validate:field:validateMinLength" }),
    class_validator_1.MaxLength(30, { message: "validate:field:validateMaxLength" }),
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    class_validator_1.IsString({ message: "validate:field:shouldBeString" }),
    __metadata("design:type", String)
], UpdateContactDto.prototype, "firstName", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.MinLength(1, { message: "validate:field:validateMinLength" }),
    class_validator_1.MaxLength(30, { message: "validate:field:validateMaxLength" }),
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    __metadata("design:type", String)
], UpdateContactDto.prototype, "lastName", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsEmail({}, { message: "validate:field:shouldBeValidEmail" }),
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    class_validator_1.MinLength(5, { message: "validate:field:validateMinLength" }),
    class_validator_1.MaxLength(254, { message: "validate:field:validateMaxLength" }),
    __metadata("design:type", String)
], UpdateContactDto.prototype, "email", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    class_validator_1.IsNumber({}, { message: "validate:field:shouldBeInt" }),
    __metadata("design:type", Number)
], UpdateContactDto.prototype, "countryId", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    class_validator_1.IsNumber({}, { message: "validate:field:shouldBeInt" }),
    __metadata("design:type", Number)
], UpdateContactDto.prototype, "role", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsString({ message: "validate:field:shouldBeString" }),
    __metadata("design:type", String)
], UpdateContactDto.prototype, "avatar", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    class_validator_1.MinLength(5, { message: "validate:field:validateMinLength" }),
    class_validator_1.MaxLength(30, { message: "validate:field:validateMinLength" }),
    __metadata("design:type", String)
], UpdateContactDto.prototype, "phoneNo", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    class_validator_1.MinLength(5, { message: "validate:field:validateMinLength" }),
    class_validator_1.MaxLength(30, { message: "validate:field:validateMinLength" }),
    __metadata("design:type", String)
], UpdateContactDto.prototype, "mobileNo", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    class_validator_1.MinLength(2, { message: "validate:field:validateMinLength" }),
    class_validator_1.MaxLength(50, { message: "validate:field:validateMaxLength" }),
    __metadata("design:type", String)
], UpdateContactDto.prototype, "jobTitle", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    class_validator_1.IsNumber({}, { message: "validate:field:shouldBeInt" }),
    __metadata("design:type", Number)
], UpdateContactDto.prototype, "rptContactId", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsString({ message: "validate:field:shouldBeUrl" }),
    __metadata("design:type", String)
], UpdateContactDto.prototype, "linkedInUrl", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsString({ message: "validate:field:shouldBeUrl" }),
    __metadata("design:type", String)
], UpdateContactDto.prototype, "googlePlusUrl", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsNumber({}, { message: "validate:field:shouldBeInt" }),
    __metadata("design:type", Number)
], UpdateContactDto.prototype, "workNatureId", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsString({ message: "validate:field:shouldBeString" }),
    __metadata("design:type", String)
], UpdateContactDto.prototype, "isShared", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsString({ message: "validate:field:shouldBeString" }),
    __metadata("design:type", String)
], UpdateContactDto.prototype, "isDefaultContact", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.IsString({ message: "validate:field:shouldBeString" }),
    __metadata("design:type", String)
], UpdateContactDto.prototype, "isActive", void 0);
exports.UpdateContactDto = UpdateContactDto;
//# sourceMappingURL=contact.dto.js.map