"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AddUserDto = void 0;
const class_validator_1 = require("class-validator");
const contact_dto_1 = require("./AddUser/contact.dto");
const class_transformer_1 = require("class-transformer");
const tradeInformation_Product_Families_dto_1 = require("./../../channel/dto/tradeInformation_Product_Families.dto");
const tradeInformation_Product_Categories_dto_1 = require("./../../channel/dto/tradeInformation_Product_Categories.dto");
const accesspermission_dto_1 = require("./AddUser/accesspermission.dto");
const channelLocation_dto_1 = require("./../../channel/dto/channelLocation.dto");
const lodash_1 = require("lodash");
const app_constant_1 = require("../../../config/app.constant");
class AddUserDto {
}
__decorate([
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => contact_dto_1.AddContactDto),
    __metadata("design:type", contact_dto_1.AddContactDto)
], AddUserDto.prototype, "contact", void 0);
__decorate([
    class_validator_1.ValidateIf(o => (lodash_1.includes(app_constant_1.appconstant.SOURCING_CONTACT, o.contact.workNatureId) && o.channelTypeId == app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR) || o.channelTypeId == app_constant_1.appconstant.CHANNEL_TYPE_VENDOR || o.channelTypeId == app_constant_1.appconstant.CHANNEL_TYPE_RETAILER),
    class_validator_1.ArrayNotEmpty({ message: "channel:tradeinformation:productFamiliesArray" }),
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:productFamiliesArrayNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Product_Families_dto_1.TradeInformation_Product_FamiliesDto),
    __metadata("design:type", Array)
], AddUserDto.prototype, "productFamilies", void 0);
__decorate([
    class_validator_1.ValidateIf(o => (lodash_1.includes(app_constant_1.appconstant.SOURCING_CONTACT, o.contact.workNatureId) && o.channelTypeId == app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR) || o.channelTypeId == app_constant_1.appconstant.CHANNEL_TYPE_VENDOR || o.channelTypeId == app_constant_1.appconstant.CHANNEL_TYPE_RETAILER),
    class_validator_1.ArrayNotEmpty({ message: "channel:tradeinformation:productCategoriesArray" }),
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:productCategoriesNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Product_Categories_dto_1.TradeInformation_Product_CategoriesDto),
    __metadata("design:type", Array)
], AddUserDto.prototype, "productCategories", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateIf(o => (lodash_1.includes(app_constant_1.appconstant.SOURCING_CONTACT, o.contact.workNatureId) && o.channelTypeId == app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR) || o.channelTypeId == app_constant_1.appconstant.CHANNEL_TYPE_VENDOR || o.channelTypeId == app_constant_1.appconstant.CHANNEL_TYPE_RETAILER),
    class_validator_1.ArrayNotEmpty({ message: "validate:field:shouldBeEmptyArray" }),
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Product_Families_dto_1.TradeInformation_Product_FamiliesDto),
    __metadata("design:type", Array)
], AddUserDto.prototype, "interestedProductFamilies", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateIf(o => (lodash_1.includes(app_constant_1.appconstant.SOURCING_CONTACT, o.contact.workNatureId) && o.channelTypeId == app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR) || o.channelTypeId == app_constant_1.appconstant.CHANNEL_TYPE_VENDOR || o.channelTypeId == app_constant_1.appconstant.CHANNEL_TYPE_RETAILER),
    class_validator_1.ArrayNotEmpty({ message: "validate:field:shouldBeEmptyArray" }),
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Product_Categories_dto_1.TradeInformation_Product_CategoriesDto),
    __metadata("design:type", Array)
], AddUserDto.prototype, "interestedProductCategories", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "validate:field:shouldBeArray" }),
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => accesspermission_dto_1.AccessPermissionDto),
    __metadata("design:type", Array)
], AddUserDto.prototype, "accessPermissions", void 0);
__decorate([
    class_validator_1.ValidateIf(o => (lodash_1.includes([...app_constant_1.appconstant.SELLING_CONTACT, ...app_constant_1.appconstant.OTHER_CONTACT], o.contact.workNatureId) && o.channelTypeId == app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR) || (o.channelTypeId == app_constant_1.appconstant.CHANNEL_TYPE_VENDOR)),
    class_validator_1.ArrayNotEmpty({ message: "validate:field:shouldBeArray" }),
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => channelLocation_dto_1.ChannelLocationDto),
    __metadata("design:type", Array)
], AddUserDto.prototype, "locations", void 0);
__decorate([
    class_validator_1.IsNumber({}, { message: "validate:field:shouldBeNumber" }),
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    __metadata("design:type", Number)
], AddUserDto.prototype, "channelTypeId", void 0);
exports.AddUserDto = AddUserDto;
//# sourceMappingURL=addUser.dto.js.map