"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateUserDto = void 0;
const class_validator_1 = require("class-validator");
const contact_dto_1 = require("./UpdateUser/contact.dto");
const class_transformer_1 = require("class-transformer");
const tradeInformation_Product_Families_dto_1 = require("./../../channel/dto/tradeInformation_Product_Families.dto");
const tradeInformation_Product_Categories_dto_1 = require("./../../channel/dto/tradeInformation_Product_Categories.dto");
const accesspermission_dto_1 = require("./AddUser/accesspermission.dto");
const channelLocation_dto_1 = require("./../../channel/dto/channelLocation.dto");
class UpdateUserDto {
}
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => contact_dto_1.UpdateContactDto),
    __metadata("design:type", contact_dto_1.UpdateContactDto)
], UpdateUserDto.prototype, "contact", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:tradeinformation:productFamiliesArray" }),
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:productFamiliesArrayNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Product_Families_dto_1.TradeInformation_Product_FamiliesDto),
    __metadata("design:type", Array)
], UpdateUserDto.prototype, "productFamilies", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "channel:tradeinformation:productCategoriesArray" }),
    class_validator_1.IsNotEmpty({ message: "channel:tradeinformation:productCategoriesNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Product_Categories_dto_1.TradeInformation_Product_CategoriesDto),
    __metadata("design:type", Array)
], UpdateUserDto.prototype, "productCategories", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "validate:field:shouldBeEmptyArray" }),
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Product_Families_dto_1.TradeInformation_Product_FamiliesDto),
    __metadata("design:type", Array)
], UpdateUserDto.prototype, "interestedProductFamilies", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "validate:field:shouldBeEmptyArray" }),
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => tradeInformation_Product_Categories_dto_1.TradeInformation_Product_CategoriesDto),
    __metadata("design:type", Array)
], UpdateUserDto.prototype, "interestedProductCategories", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "validate:field:shouldBeArray" }),
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => channelLocation_dto_1.ChannelLocationDto),
    __metadata("design:type", Array)
], UpdateUserDto.prototype, "locations", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.ArrayNotEmpty({ message: "validate:field:shouldBeArray" }),
    class_validator_1.IsNotEmpty({ message: "validate:field:shouldNotEmpty" }),
    class_validator_1.ValidateNested(),
    class_transformer_1.Type(() => accesspermission_dto_1.AccessPermissionDto),
    __metadata("design:type", Array)
], UpdateUserDto.prototype, "accessPermissions", void 0);
__decorate([
    class_validator_1.IsOptional(),
    class_validator_1.MaxLength(1000, { message: "validate:field:validateMaxLength" }),
    __metadata("design:type", String)
], UpdateUserDto.prototype, "reason", void 0);
__decorate([
    class_validator_1.IsOptional(),
    __metadata("design:type", Number)
], UpdateUserDto.prototype, "ratingId", void 0);
exports.UpdateUserDto = UpdateUserDto;
//# sourceMappingURL=updateUser.dto.js.map