import { Model } from 'sequelize-typescript';
import { Channel } from '../../channel/models/Channel.entity';
import { Country } from '../../common/models/Country.entity';
import { Media } from '../../media/models/Media.entity';
import { ContactProductGroup } from './ContactProductGroup.entity';
import { ContactProductCategory } from './ContactProductCategory.entity';
import { ProductGroup } from './../../product/models/ProductGroup.entity';
import { ProductCategory } from './../../product/models/ProductCategory.entity';
import { ContactSocialLink } from './ContactSocialLink.entity';
import { ContactLocation } from './ContactLocation.entity';
import { ChannelContactSuggestion } from '../../channel/models/ChannelContactSuggestion.entity';
import { User } from './../models/User.entity';
import { RegionCountryJCT } from './../../common/models/RegionCountryJCT.entity';
import { ContactInterestedProductGroup } from './ContactInterestedProductGroup.entity';
import { ContactInterestedProductCategory } from './ContactInterestedProductCategory.entity';
import { EventParticipants } from 'src/modules/channel/models/EventParticipants.entity';
export declare class Contact extends Model<Contact> {
    contactId: number;
    productGroups: ProductGroup[];
    productCategories: ProductCategory[];
    rptContactId: number;
    reportPerson: Contact;
    channelId: number;
    channel: Channel;
    firstName: string;
    lastName: string;
    phone1: string;
    phone2: string;
    mobileNo: string;
    email: string;
    responsibilityId: number;
    responsibility: Media;
    workNatureId: number;
    hubspotContactId: number;
    jobTitle: string;
    linkedIn: string;
    googleplus: string;
    documentId: number;
    document: Media;
    countryId: number;
    country: Country;
    isDefaultContact: string;
    isShared: string;
    isActive: string;
    deletedAt: Date;
    createdAt: Date;
    updatedAt: Date;
    contactSocialLink: ContactSocialLink[];
    contactLocation: ContactLocation[];
    locations: RegionCountryJCT[];
    selling_locations: RegionCountryJCT[];
    target_locations: RegionCountryJCT[];
    retail_locations: RegionCountryJCT[];
    channelContactSuggestion: ChannelContactSuggestion[];
    user: User;
    productGroup: ContactProductGroup[];
    productCategory: ContactProductCategory[];
    IntProductGroup: ContactInterestedProductGroup[];
    IntProductCategory: ContactInterestedProductCategory[];
    IntProductCategories: ProductCategory[];
    IntProductGroups: ProductGroup[];
    userId: number;
    empId: string;
    showId: string;
    static buildEmpIdLogic(instance: Contact): Promise<void>;
    static empIdLogic(showId: any, userId: any): string;
    static dateUpdate(contact: Contact, options: any): Promise<void>;
    isEvent: string;
    isConnectionMail: string;
    isSuggestMail: string;
    isFeatureMail: string;
    isProfileMail: string;
    eventParticipants: EventParticipants[];
}
