"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var Contact_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Contact = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Channel_entity_1 = require("../../channel/models/Channel.entity");
const ChannelType_entity_1 = require("../../channel/models/ChannelType.entity");
const ProfileType_entity_1 = require("../../channel/models/ProfileType.entity");
const ChannelSubscription_entity_1 = require("./../../channel/models/ChannelSubscription.entity");
const Country_entity_1 = require("../../common/models/Country.entity");
const Media_entity_1 = require("../../media/models/Media.entity");
const ContactProductGroup_entity_1 = require("./ContactProductGroup.entity");
const ContactProductCategory_entity_1 = require("./ContactProductCategory.entity");
const ProductGroup_entity_1 = require("./../../product/models/ProductGroup.entity");
const ProductCategory_entity_1 = require("./../../product/models/ProductCategory.entity");
const Responsibility_entity_1 = require("../../user/models/Responsibility.entity");
const ContactSocialLink_entity_1 = require("./ContactSocialLink.entity");
const ContactLocation_entity_1 = require("./ContactLocation.entity");
const ChannelContactSuggestion_entity_1 = require("../../channel/models/ChannelContactSuggestion.entity");
const User_entity_1 = require("./../models/User.entity");
const UserRole_entity_1 = require("./../models/UserRole.entity");
const RegionCountryJCT_entity_1 = require("./../../common/models/RegionCountryJCT.entity");
const ContactInterestedProductGroup_entity_1 = require("./ContactInterestedProductGroup.entity");
const ContactInterestedProductCategory_entity_1 = require("./ContactInterestedProductCategory.entity");
const SubscriptionPlan_entity_1 = require("./../../channel/models/SubscriptionPlan.entity");
const ChannelDetail_entity_1 = require("../../channel/models/ChannelDetail.entity");
const Role_entity_1 = require("./Role.entity");
const EventParticipants_entity_1 = require("../../channel/models/EventParticipants.entity");
var Sequelize = require('sequelize');
const tableOptions = { timestamp: true, tableName: 'tblContact' };
let Contact = Contact_1 = class Contact extends sequelize_typescript_1.Model {
    static async buildEmpIdLogic(instance) {
        if (instance.showId && instance.userId) {
            instance.empId = Contact_1.empIdLogic(instance.showId, instance.userId);
        }
    }
    static empIdLogic(showId, userId) {
        return "#" + showId + userId;
    }
    static async dateUpdate(contact, options) {
        contact.updatedAt = Sequelize.fn('NOW');
    }
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Contact.prototype, "contactId", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => ProductGroup_entity_1.ProductGroup, {
        through: () => ContactProductGroup_entity_1.ContactProductGroup
    }),
    __metadata("design:type", Array)
], Contact.prototype, "productGroups", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => ProductCategory_entity_1.ProductCategory, {
        through: () => ContactProductCategory_entity_1.ContactProductCategory
    }),
    __metadata("design:type", Array)
], Contact.prototype, "productCategories", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Contact_1),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Contact.prototype, "rptContactId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Contact_1, 'rptContactId'),
    __metadata("design:type", Contact)
], Contact.prototype, "reportPerson", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Contact.prototype, "channelId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel),
    __metadata("design:type", Channel_entity_1.Channel)
], Contact.prototype, "channel", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(true),
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Contact.prototype, "firstName", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(true),
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Contact.prototype, "lastName", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Contact.prototype, "phone1", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Contact.prototype, "phone2", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Contact.prototype, "mobileNo", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.CHAR(255),
        allowNull: false,
        unique: { name: 'email', msg: 'account:singup:emailAleradytaken' }
    }),
    __metadata("design:type", String)
], Contact.prototype, "email", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Responsibility_entity_1.Responsibility),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Contact.prototype, "responsibilityId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Responsibility_entity_1.Responsibility),
    __metadata("design:type", Media_entity_1.Media)
], Contact.prototype, "responsibility", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Contact.prototype, "workNatureId", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Contact.prototype, "hubspotContactId", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Contact.prototype, "jobTitle", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Contact.prototype, "linkedIn", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Contact.prototype, "googleplus", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Media_entity_1.Media),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Contact.prototype, "documentId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Media_entity_1.Media, 'documentId'),
    __metadata("design:type", Media_entity_1.Media)
], Contact.prototype, "document", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Country_entity_1.Country),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], Contact.prototype, "countryId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Country_entity_1.Country),
    __metadata("design:type", Country_entity_1.Country)
], Contact.prototype, "country", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Contact.prototype, "isDefaultContact", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Contact.prototype, "isShared", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Contact.prototype, "isActive", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Contact.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Contact.prototype, "createdAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], Contact.prototype, "updatedAt", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ContactSocialLink_entity_1.ContactSocialLink, 'contactId'),
    __metadata("design:type", Array)
], Contact.prototype, "contactSocialLink", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ContactLocation_entity_1.ContactLocation, 'contactId'),
    __metadata("design:type", Array)
], Contact.prototype, "contactLocation", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => RegionCountryJCT_entity_1.RegionCountryJCT, {
        through: () => ContactLocation_entity_1.ContactLocation
    }),
    __metadata("design:type", Array)
], Contact.prototype, "locations", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => RegionCountryJCT_entity_1.RegionCountryJCT, {
        through: () => ContactLocation_entity_1.ContactLocation
    }),
    __metadata("design:type", Array)
], Contact.prototype, "selling_locations", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => RegionCountryJCT_entity_1.RegionCountryJCT, {
        through: () => ContactLocation_entity_1.ContactLocation,
    }),
    __metadata("design:type", Array)
], Contact.prototype, "target_locations", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => RegionCountryJCT_entity_1.RegionCountryJCT, {
        through: () => ContactLocation_entity_1.ContactLocation,
    }),
    __metadata("design:type", Array)
], Contact.prototype, "retail_locations", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ChannelContactSuggestion_entity_1.ChannelContactSuggestion, 'contactid'),
    __metadata("design:type", Array)
], Contact.prototype, "channelContactSuggestion", void 0);
__decorate([
    sequelize_typescript_1.HasOne(() => User_entity_1.User, 'contactId'),
    __metadata("design:type", User_entity_1.User)
], Contact.prototype, "user", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ContactProductGroup_entity_1.ContactProductGroup, 'contactId'),
    __metadata("design:type", Array)
], Contact.prototype, "productGroup", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ContactProductCategory_entity_1.ContactProductCategory, 'contactId'),
    __metadata("design:type", Array)
], Contact.prototype, "productCategory", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ContactInterestedProductGroup_entity_1.ContactInterestedProductGroup, 'contactId'),
    __metadata("design:type", Array)
], Contact.prototype, "IntProductGroup", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => ContactInterestedProductCategory_entity_1.ContactInterestedProductCategory, 'contactId'),
    __metadata("design:type", Array)
], Contact.prototype, "IntProductCategory", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => ProductCategory_entity_1.ProductCategory, {
        through: () => ContactInterestedProductCategory_entity_1.ContactInterestedProductCategory
    }),
    __metadata("design:type", Array)
], Contact.prototype, "IntProductCategories", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => ProductGroup_entity_1.ProductGroup, {
        through: () => ContactInterestedProductGroup_entity_1.ContactInterestedProductGroup
    }),
    __metadata("design:type", Array)
], Contact.prototype, "IntProductGroups", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: new sequelize_typescript_1.DataType.VIRTUAL(sequelize_typescript_1.DataType.INTEGER, ['userId']),
        set: function (value) {
            this.setDataValue('userId', value);
        }
    }),
    __metadata("design:type", Number)
], Contact.prototype, "userId", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Contact.prototype, "empId", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: new sequelize_typescript_1.DataType.VIRTUAL(sequelize_typescript_1.DataType.CHAR(255), ['showId']),
        set: function (value) {
            this.setDataValue('showId', value);
        }
    }),
    __metadata("design:type", String)
], Contact.prototype, "showId", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Contact.prototype, "isEvent", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Contact.prototype, "isConnectionMail", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Contact.prototype, "isSuggestMail", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Contact.prototype, "isFeatureMail", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], Contact.prototype, "isProfileMail", void 0);
__decorate([
    sequelize_typescript_1.HasMany(() => EventParticipants_entity_1.EventParticipants, { foreignKey: 'contactId' }),
    __metadata("design:type", Array)
], Contact.prototype, "eventParticipants", void 0);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Contact]),
    __metadata("design:returntype", Promise)
], Contact, "buildEmpIdLogic", null);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    sequelize_typescript_1.BeforeUpdate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Contact, Object]),
    __metadata("design:returntype", Promise)
], Contact, "dateUpdate", null);
Contact = Contact_1 = __decorate([
    sequelize_typescript_1.Table(tableOptions),
    sequelize_typescript_1.Scopes(() => ({
        basicInfom: {
            attributes: ['contactId', 'channelId']
        },
        contactInfo: {
            attributes: ['contactId', 'firstName', 'lastName', 'phone1', 'phone2', 'mobileNo', 'email', 'jobTitle', 'linkedIn', 'googleplus', 'workNatureId', 'isShared', 'isActive', 'countryId', 'documentId', 'empId', 'hubspotContactId', 'rptContactId']
        },
        senderContactMail: {
            attributes: ['contactId', 'channelId', 'rptContactId', 'firstName', 'lastName', 'phone1', 'phone2', 'mobileNo', 'email', 'jobTitle', 'workNatureId', 'documentId', 'countryId', 'isConnectionMail', 'isSuggestMail', 'isFeatureMail', 'isProfileMail'],
            include: [
                {
                    model: Channel_entity_1.Channel,
                    include: [
                        {
                            model: ChannelType_entity_1.ChannelType,
                        },
                        {
                            model: ProfileType_entity_1.ProfileType,
                            as: 'profileType'
                        },
                        {
                            model: User_entity_1.User,
                            attributes: ["userId", "email"],
                            include: [{
                                    model: UserRole_entity_1.UserRole,
                                    attributes: [],
                                    where: {
                                        roleId: Role_entity_1.Role.ROLE_ACCOUNT_USER
                                    }
                                }, {
                                    model: Contact_1,
                                    attributes: ['contactId', 'channelId', 'firstName', 'lastName', 'email']
                                }]
                        }
                    ]
                }, {
                    model: Country_entity_1.Country,
                    attributes: ['countryId', 'country'],
                },
                {
                    model: Media_entity_1.Media,
                }
            ]
        },
        ReceverContactMail: {
            attributes: ['contactId', 'channelId', 'rptContactId', 'firstName', 'lastName', 'phone1', 'phone2', 'mobileNo', 'email', 'jobTitle', 'workNatureId', 'documentId', 'countryId', 'isConnectionMail', 'isSuggestMail', 'isFeatureMail', 'isProfileMail'],
        },
        companyWithActivePlan: {
            attributes: {
                exclude: ['deletedAt', 'createdAt', 'updatedAt']
            },
            include: [
                {
                    model: Channel_entity_1.Channel,
                    where: {
                        deletedAt: null
                    },
                    attributes: {
                        exclude: ['deletedAt', 'createdAt', 'updatedAt', 'stripeCustomerId']
                    },
                    include: [
                        {
                            model: SubscriptionPlan_entity_1.SubscriptionPlan,
                            as: 'plan',
                            attributes: ['subscriptionPlanId', 'subscriptionPlanType', 'rankOrder']
                        },
                        {
                            model: Country_entity_1.Country,
                            required: false,
                            attributes: ['country', 'countryId']
                        },
                        {
                            model: ChannelSubscription_entity_1.ChannelSubscription,
                            attributes: ['isActive', 'subscriptionId', 'startedAt', 'endAt'],
                            where: { isActive: '1' },
                            required: false
                        },
                        {
                            model: ChannelType_entity_1.ChannelType,
                            required: true
                        },
                        {
                            model: ChannelDetail_entity_1.ChannelDetail,
                            required: false,
                            attributes: {
                                exclude: ['channelDetailId', 'channelId', 'deletedAt', 'createdAt', 'updatedAt']
                            },
                            include: [{
                                    model: Media_entity_1.Media,
                                    as: 'channelLogo',
                                    where: { deletedAt: null },
                                    required: false,
                                    attributes: ['documentId', 'documentPath']
                                },
                                {
                                    model: Media_entity_1.Media,
                                    as: 'channelIcon',
                                    where: { deletedAt: null },
                                    required: false,
                                    attributes: ['documentId', 'documentPath']
                                }]
                        }
                    ]
                },
                {
                    model: Media_entity_1.Media,
                    attributes: ['documentId', 'documentPath'],
                    required: false
                }
            ]
        },
        channelDetail: {
            attributes: ['contactId', 'firstName', 'lastName', 'phone1', 'mobileNo', 'email', 'responsibilityId', 'linkedIn', 'jobTitle', 'googleplus', 'isDefaultContact', 'empId', 'isActive', 'deletedAt', 'documentId', 'isEvent']
        },
        orderInfo: {
            attributes: ['firstName', 'lastName', 'jobTitle', 'countryId']
        },
        productInfo: {
            attributes: ['contactId', 'firstName', 'lastName', 'jobTitle', 'isDefaultContact', 'deletedAt', 'documentId']
        }
    }))
], Contact);
exports.Contact = Contact;
//# sourceMappingURL=Contact.entity.js.map