"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContactLocation = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const Channel_entity_1 = require("./../../channel/models/Channel.entity");
const Contact_entity_1 = require("./Contact.entity");
const RegionCountryJCT_entity_1 = require("./../../common/models/RegionCountryJCT.entity");
const User_entity_1 = require("./../../user/models/User.entity");
var Sequelize = require('sequelize');
const tableOptions = { tableName: 'tblContactLocation' };
let ContactLocation = class ContactLocation extends sequelize_typescript_1.Model {
    static async dateUpdate(contactLocation, options) {
        contactLocation.updatedAt = Sequelize.fn('NOW');
    }
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ContactLocation.prototype, "contactLocationId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ContactLocation.prototype, "channelId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel),
    __metadata("design:type", Array)
], ContactLocation.prototype, "Channel", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Contact_entity_1.Contact),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ContactLocation.prototype, "contactId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Contact_entity_1.Contact),
    __metadata("design:type", Array)
], ContactLocation.prototype, "Contact", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], ContactLocation.prototype, "locationType", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => RegionCountryJCT_entity_1.RegionCountryJCT),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ContactLocation.prototype, "regionCountryJCTId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => RegionCountryJCT_entity_1.RegionCountryJCT),
    __metadata("design:type", Array)
], ContactLocation.prototype, "RegionCountryJCT", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ContactLocation.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ContactLocation.prototype, "createdAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], ContactLocation.prototype, "updatedAt", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => User_entity_1.User),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], ContactLocation.prototype, "updatedBy", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => User_entity_1.User, 'updatedBy'),
    __metadata("design:type", User_entity_1.User)
], ContactLocation.prototype, "User", void 0);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    sequelize_typescript_1.BeforeUpdate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [ContactLocation, Object]),
    __metadata("design:returntype", Promise)
], ContactLocation, "dateUpdate", null);
ContactLocation = __decorate([
    sequelize_typescript_1.Table(tableOptions),
    sequelize_typescript_1.Scopes({
        contactLocationInfo: {
            attributes: ['contactLocationId', 'channelId', 'contactId', 'locationType', 'regionCountryJCTId']
        }
    })
], ContactLocation);
exports.ContactLocation = ContactLocation;
//# sourceMappingURL=ContactLocation.entity.js.map