import { Model } from 'sequelize-typescript';
import { Channel } from '../../channel/models/Channel.entity';
import { Contact } from './Contact.entity';
import { Role } from './Role.entity';
import { UserRole } from './UserRole.entity';
import { AccessPermission } from './AccessPermission.entity';
export declare class User extends Model<User> {
    userId: number;
    contactId: number;
    contact: Contact;
    channelId: number;
    channel: Channel;
    tries: number;
    email: string;
    password: string;
    password1: string;
    password2: string;
    password3: string;
    password4: string;
    password5: string;
    verificationCode: string;
    verificationSentAt: Date;
    resetPasswordToken: string;
    resetPasswordExpires: number;
    suggestion_comm: number;
    invitation_comm: number;
    isActive: string;
    deletedAt: Date;
    createdAt: Date;
    lastLogin: Date;
    isAlgorithm: string;
    updatedAt: Date;
    tokenModifiedAt: Date;
    role: UserRole;
    roles: Role[];
    permissions: AccessPermission[];
    static hashPassword(user: User, options: any): Promise<void>;
    static dateUpdate(user: User, options: any): Promise<void>;
}
