"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.User = void 0;
const sequelize_typescript_1 = require("sequelize-typescript");
const crypto = require("crypto");
const Channel_entity_1 = require("../../channel/models/Channel.entity");
const Contact_entity_1 = require("./Contact.entity");
const Role_entity_1 = require("./Role.entity");
const UserRole_entity_1 = require("./UserRole.entity");
const AccessPermission_entity_1 = require("./AccessPermission.entity");
const UserAccessPermission_entity_1 = require("./UserAccessPermission.entity");
const tableOptions = { timestamp: true, tableName: 'tblUser' };
var Sequelize = require('sequelize');
let User = class User extends sequelize_typescript_1.Model {
    static async hashPassword(user, options) {
        if (user.password) {
            var hash = crypto.createHmac('sha512', process.env.USER_PASSWORD_SALT_ROUNT);
            hash.update(user.password);
            user.password = hash.digest('hex');
        }
    }
    static async dateUpdate(user, options) {
        user.updatedAt = Sequelize.fn('NOW');
    }
};
__decorate([
    sequelize_typescript_1.PrimaryKey,
    sequelize_typescript_1.AutoIncrement,
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], User.prototype, "userId", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Contact_entity_1.Contact),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], User.prototype, "contactId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Contact_entity_1.Contact),
    __metadata("design:type", Contact_entity_1.Contact)
], User.prototype, "contact", void 0);
__decorate([
    sequelize_typescript_1.ForeignKey(() => Channel_entity_1.Channel),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], User.prototype, "channelId", void 0);
__decorate([
    sequelize_typescript_1.BelongsTo(() => Channel_entity_1.Channel),
    __metadata("design:type", Channel_entity_1.Channel)
], User.prototype, "channel", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.SMALLINT),
    __metadata("design:type", Number)
], User.prototype, "tries", void 0);
__decorate([
    sequelize_typescript_1.Column({
        type: sequelize_typescript_1.DataType.CHAR(255),
        allowNull: false,
        unique: { name: 'email', msg: 'account:singup:emailAleradytaken' }
    }),
    __metadata("design:type", String)
], User.prototype, "email", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], User.prototype, "password", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], User.prototype, "password1", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], User.prototype, "password2", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], User.prototype, "password3", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], User.prototype, "password4", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], User.prototype, "password5", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], User.prototype, "verificationCode", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], User.prototype, "verificationSentAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.CHAR(255)),
    __metadata("design:type", String)
], User.prototype, "resetPasswordToken", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], User.prototype, "resetPasswordExpires", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], User.prototype, "suggestion_comm", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.BIGINT),
    __metadata("design:type", Number)
], User.prototype, "invitation_comm", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], User.prototype, "isActive", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], User.prototype, "deletedAt", void 0);
__decorate([
    sequelize_typescript_1.AllowNull(false),
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], User.prototype, "createdAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], User.prototype, "lastLogin", void 0);
__decorate([
    sequelize_typescript_1.Column,
    __metadata("design:type", String)
], User.prototype, "isAlgorithm", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], User.prototype, "updatedAt", void 0);
__decorate([
    sequelize_typescript_1.Column(sequelize_typescript_1.DataType.DATE),
    __metadata("design:type", Date)
], User.prototype, "tokenModifiedAt", void 0);
__decorate([
    sequelize_typescript_1.HasOne(() => UserRole_entity_1.UserRole, 'userId'),
    __metadata("design:type", UserRole_entity_1.UserRole)
], User.prototype, "role", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => Role_entity_1.Role, {
        through: () => UserRole_entity_1.UserRole
    }),
    __metadata("design:type", Array)
], User.prototype, "roles", void 0);
__decorate([
    sequelize_typescript_1.BelongsToMany(() => AccessPermission_entity_1.AccessPermission, {
        through: {
            model: () => UserAccessPermission_entity_1.UserAccessPermission,
            scope: {
                deletedat: null
            }
        },
    }),
    __metadata("design:type", Array)
], User.prototype, "permissions", void 0);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    sequelize_typescript_1.BeforeUpdate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [User, Object]),
    __metadata("design:returntype", Promise)
], User, "hashPassword", null);
__decorate([
    sequelize_typescript_1.BeforeCreate,
    sequelize_typescript_1.BeforeUpdate,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [User, Object]),
    __metadata("design:returntype", Promise)
], User, "dateUpdate", null);
User = __decorate([
    sequelize_typescript_1.Table(tableOptions),
    sequelize_typescript_1.Scopes(() => ({
        userBasicInfom: {
            attributes: ['userId', 'contactId', 'channelId', 'email']
        },
        userChannelContactId: {
            attributes: ['userId', 'contactId', 'channelId']
        },
        userLogInInfom: {
            attributes: ['userId', 'contactId', 'channelId', 'email', 'password', 'isActive', 'tokenModifiedAt', 'lastLogin', 'isAlgorithm', 'suggestion_comm']
        },
        withChannel: {
            include: [Channel_entity_1.Channel]
        },
        withContact: {
            include: [Contact_entity_1.Contact]
        },
        channelDetail: {
            attributes: ['userId', 'contactId', 'channelId', 'email', 'isActive']
        },
        orderInfo: {
            attributes: ['contactId', 'channelId']
        }
    }))
], User);
exports.User = User;
//# sourceMappingURL=User.entity.js.map