import { User } from '../models/User.entity';
import { ContextService } from './../../../context/context.service';
import { AdminUsers } from '../../admin/models/AdminUsers.entity';
import { AdminUserAccess } from '../../admin/models/AdminUserAccess.entity';
import { Channel } from '../../channel/models/Channel.entity';
import { Country } from 'src/modules/common/models/Country.entity';
import { Contact } from '../models/Contact.entity';
import { Media } from '../../media/models/Media.entity';
import { UserRole } from '../models/UserRole.entity';
import { ContactProductGroup } from '../models/ContactProductGroup.entity';
import { ContactInterestedProductGroup } from '../models/ContactInterestedProductGroup.entity';
import { ContactInterestedProductCategory } from '../models/ContactInterestedProductCategory.entity';
import { ContactSocialLink } from '../models/ContactSocialLink.entity';
import { ContactProductCategory } from '../models/ContactProductCategory.entity';
import { UserAccessPermission } from '../models/UserAccessPermission.entity';
import { ContactLocation } from '../models/ContactLocation.entity';
import { ChannelContactSuggestion } from 'src/modules/channel/models/ChannelContactSuggestion.entity';
import { InterestedProductGroup } from '../models/InterestedProductGroup.entity';
import { InterestedProductCategory } from '../models/InterestedProductCategory.entity';
export declare class UserService {
    private readonly sequelizeInstance;
    private readonly userRoleRepository;
    private readonly contactLocationRepository;
    private readonly userRepository;
    private readonly contactRepository;
    private readonly channelRepository;
    private readonly adminUserRepository;
    private readonly adminUserAccessRepository;
    private readonly mediaRepository;
    private readonly contactProductGroupRepository;
    private readonly contactInterestedProductGroupRepository;
    private readonly contactInterestedProductCategoryRepository;
    private readonly interestedProductGroupRepository;
    private readonly interestedProductCategoryRepository;
    private readonly contactSocialLinkRepository;
    private readonly contactProductCategoryRepository;
    private readonly userAccessPermissionRepository;
    private readonly contactSuggestionRepository;
    private readonly countryRepository;
    private context;
    private userInBound;
    private specialChars;
    constructor(sequelizeInstance: any, userRoleRepository: typeof UserRole, contactLocationRepository: typeof ContactLocation, userRepository: typeof User, contactRepository: typeof Contact, channelRepository: typeof Channel, adminUserRepository: typeof AdminUsers, adminUserAccessRepository: typeof AdminUserAccess, mediaRepository: typeof Media, contactProductGroupRepository: typeof ContactProductGroup, contactInterestedProductGroupRepository: typeof ContactInterestedProductGroup, contactInterestedProductCategoryRepository: typeof ContactInterestedProductCategory, interestedProductGroupRepository: typeof InterestedProductGroup, interestedProductCategoryRepository: typeof InterestedProductCategory, contactSocialLinkRepository: typeof ContactSocialLink, contactProductCategoryRepository: typeof ContactProductCategory, userAccessPermissionRepository: typeof UserAccessPermission, contactSuggestionRepository: typeof ChannelContactSuggestion, countryRepository: typeof Country, context: ContextService);
    findUser(email: string): Promise<any>;
    findUserById(userId: any, channelId: any): Promise<any>;
    boUser(id: number): Promise<any>;
    findAdmin(email: string): Promise<any>;
    findOneById(payload: any): Promise<any>;
    addUser(userDto: any, channelId: any, showId: any, userId: any, channelTypeId: any): Promise<any>;
    updateUser(userDto: any, user: any, interestedFamily: boolean, real_user: any): Promise<boolean>;
    getPassword(): Promise<string>;
    relations(transaction: any, userDto: any, user: any, action: any, interestedFamily?: boolean): Promise<void>;
    getPreference(typeid: any): Promise<{
        left: any[];
        right: any[];
    }>;
    getMailPreference(): Promise<{
        left: any[];
        right: any[];
    }>;
    getUserPreference(contactId: any, channelId: any): Promise<any>;
    getUserPrevilege(contactId: any): Promise<any>;
    getUser(id: any, channelId: any): Promise<User>;
    getDefaultContact(channelId: any): Promise<{
        user: Contact;
        userCount: number;
    }>;
    getAllContacts(channelId: any): Promise<Contact[]>;
    setDefaultContact(channelId: any, contactId: any): Promise<void>;
    Countries(): Promise<Country[]>;
    getContact(Id: number): Promise<Contact>;
    updateContact(contactId: any, contactData: any): Promise<void>;
    isAlgorithm(userId: any): Promise<void>;
    checkEmail(email: string, userId: any): Promise<boolean>;
}
