"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserModule = void 0;
const common_1 = require("@nestjs/common");
const user_service_1 = require("./service/user.service");
const context_service_1 = require("../../context/context.service");
const user_provider_1 = require("./provider/user.provider");
const userRole_providers_1 = require("./provider/userRole.providers");
const SignUpHistory_providers_1 = require("./provider/SignUpHistory.providers");
const SignUpStatus_providers_1 = require("./provider/SignUpStatus.providers");
const user_controller_1 = require("./controller/user.controller");
const database_providers_1 = require("../../core/database/database.providers");
const contact_providers_1 = require("./provider/contact.providers");
const preference_providers_1 = require("./provider/preference.providers");
const contactLocation_providers_1 = require("./provider/contactLocation.providers");
const myAddressBook_service_1 = require("./service/myAddressBook.service");
const myAddressBook_controller_1 = require("./controller/myAddressBook.controller");
const myAddressBook_providers_1 = require("./provider/myAddressBook.providers");
const common_provider_1 = require("../common/provider/common.provider");
let UserModule = class UserModule {
};
UserModule = __decorate([
    common_1.Module({
        controllers: [user_controller_1.UserController, myAddressBook_controller_1.AddressBookController],
        providers: [user_service_1.UserService, myAddressBook_service_1.MyAddressBookService,
            context_service_1.ContextService,
            ...database_providers_1.databaseProviders,
            ...user_provider_1.UserProviders,
            ...userRole_providers_1.UserRoleProviders,
            ...SignUpHistory_providers_1.SignUpHistoryProviders,
            ...SignUpStatus_providers_1.SignUpStatusProviders, ...contact_providers_1.ContactProductCategoryProvider,
            ...contact_providers_1.ContactProductGroupProvider,
            ...contact_providers_1.ContactInterestedProductCategoryProvider,
            ...contact_providers_1.ContactInterestedProductGroupProvider,
            ...contact_providers_1.InterestedProductCategoryProvider,
            ...contact_providers_1.InterestedProductGroupProvider,
            ...preference_providers_1.PreferenceProviders,
            ...preference_providers_1.UserAccessPermissionProviders,
            ...contactLocation_providers_1.ContactLocationProviders,
            ...contact_providers_1.ContactSocialLinkProvider,
            ...contact_providers_1.ContactSuggestionProvider,
            ...myAddressBook_providers_1.MyAddressBookProviders,
            ...preference_providers_1.ChannelTypeAccessPermissionProviders,
            ...common_provider_1.CountryProviders],
        exports: [
            user_service_1.UserService,
            ...user_provider_1.UserProviders,
            ...userRole_providers_1.UserRoleProviders,
            ...SignUpHistory_providers_1.SignUpHistoryProviders,
            ...SignUpStatus_providers_1.SignUpStatusProviders,
            ...contact_providers_1.ContactProductCategoryProvider,
            ...contact_providers_1.ContactProductGroupProvider,
            ...contact_providers_1.ContactInterestedProductCategoryProvider,
            ...contact_providers_1.ContactInterestedProductGroupProvider,
            ...contact_providers_1.InterestedProductCategoryProvider,
            ...contact_providers_1.InterestedProductGroupProvider,
            ...preference_providers_1.PreferenceProviders,
            ...preference_providers_1.UserAccessPermissionProviders,
            ...contactLocation_providers_1.ContactLocationProviders,
            ...contact_providers_1.ContactSocialLinkProvider,
            ...contact_providers_1.ContactSuggestionProvider,
            ...preference_providers_1.ChannelTypeAccessPermissionProviders,
            ...myAddressBook_providers_1.MyAddressBookProviders
        ]
    })
], UserModule);
exports.UserModule = UserModule;
//# sourceMappingURL=user.module.js.map