"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.walletRechargeController = void 0;
const common_1 = require("@nestjs/common");
const passport_1 = require("@nestjs/passport");
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
const validation_pipe_1 = require("../../../middleware/pipe/validation.pipe");
const app_constant_1 = require("../../../config/app.constant");
const Stripe_1 = require("../../../lib/Stripe");
const walletRecharge_service_1 = require("./../service/walletRecharge.service");
const walletRecharge_dto_1 = require("./../dto/walletRecharge.dto");
let walletRechargeController = class walletRechargeController {
    constructor(walletRechargeService) {
        this.walletRechargeService = walletRechargeService;
    }
    async getWallet(req, res) {
        let transactionId = null;
        let user = req.user;
        let result = await this.walletRechargeService.getWalletRecharge(user);
        return res.status(common_1.HttpStatus.OK).json({ wallet: result, confidentialAmt: +process.env.IS_CONFIDENTIAL_AMT });
    }
    async processWalletPayment(req, res) {
        let transactionId = null;
        let user = req.user;
        let result = await this.walletRechargeService.processWalletPayment(req.body, user);
        if (result) {
            return res.status(common_1.HttpStatus.OK).json({ sent: 'success' });
        }
        else {
            return res.status(common_1.HttpStatus.OK).json({ sent: 'error' });
        }
    }
    async completeRecharge(req, res) {
        let user = req.user;
        let transactionId = null;
        let result = null;
        result = await this.walletRechargeService.completeWalletRecharge(req.body, user);
        if (req.body.paymentType === 'wallet') {
            console.log(req.body.paymentType);
            result = await this.walletRechargeService.getWalletRecharge(user);
        }
        return res.status(common_1.HttpStatus.OK).json({
            sent: "ok",
            result: result
        });
    }
    async confirmWalletRecharge(req, res, walletRechargeDto) {
        let user = req.user;
        let amount = walletRechargeDto.amount;
        let paymentId = walletRechargeDto.paymentId;
        let transactionId = null;
        let paymentIntentSecret = null;
        let stripe = new Stripe_1.StripeV2();
        if (paymentId == 1) {
            paymentIntentSecret = await stripe.createPaymentIntend(+(amount * 100).toFixed(2), app_constant_1.appconstant.CHANNELHUB_CURRENCY_CODE, 'wallet_recharge', +user.channelId);
            paymentIntentSecret = paymentIntentSecret.client_secret;
        }
        else if (paymentId == 4) {
            paymentIntentSecret = walletRechargeDto.captureid;
            const charge = await stripe.createchargesForSource(amount, 'eur', paymentIntentSecret);
            console.log(charge);
            console.log('charge');
        }
        console.log(paymentIntentSecret);
        console.log('paymentIntentSecret');
        let transaction = await this.walletRechargeService.getTransactionIdForWalletRecharge(amount, app_constant_1.appconstant.CHANNELHUB_CHANNEL_ID, user.channel.channelId, user.userId, paymentIntentSecret);
        return res.status(common_1.HttpStatus.OK).json({
            secret: paymentIntentSecret,
            amount: +(amount * 100).toFixed(2),
            transaction: transaction,
        });
    }
};
__decorate([
    common_1.Get('getWallet'),
    __param(0, common_1.Request()), __param(1, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], walletRechargeController.prototype, "getWallet", null);
__decorate([
    common_1.Post('processWalletPayment'),
    __param(0, common_1.Request()), __param(1, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], walletRechargeController.prototype, "processWalletPayment", null);
__decorate([
    common_1.Post('completeRecharge'),
    __param(0, common_1.Request()), __param(1, common_1.Response()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], walletRechargeController.prototype, "completeRecharge", null);
__decorate([
    common_1.Post('confirmWalletRecharge'),
    __param(0, common_1.Request()), __param(1, common_1.Response()), __param(2, common_1.Body(new validation_pipe_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, walletRecharge_dto_1.walletRechargeDto]),
    __metadata("design:returntype", Promise)
], walletRechargeController.prototype, "confirmWalletRecharge", null);
walletRechargeController = __decorate([
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    common_1.Controller('walletRecharge'),
    __metadata("design:paramtypes", [walletRecharge_service_1.walletRechargeService])
], walletRechargeController);
exports.walletRechargeController = walletRechargeController;
//# sourceMappingURL=walletRecharge.controller.js.map