'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.walletRechargeService = void 0;
const common_1 = require("@nestjs/common");
const sequelize_typescript_1 = require("sequelize-typescript");
const app_constant_1 = require("../../../config/app.constant");
const S3Lib_1 = require("../../../lib/S3Lib");
let fs = require('fs');
const { Op } = require('sequelize');
const ChannelJCT_entity_1 = require("../../channel/models/ChannelJCT.entity");
const UserWalletAmount_entity_1 = require("../models/UserWalletAmount.entity");
const base_service_1 = require("../../../core/service/base.service");
let walletRechargeService = class walletRechargeService extends base_service_1.BaseService {
    constructor(otherPaymentRepository, userWalletAmountRepository, walletTransactionRepository, walletUsageTypeRepository) {
        super();
        this.otherPaymentRepository = otherPaymentRepository;
        this.userWalletAmountRepository = userWalletAmountRepository;
        this.walletTransactionRepository = walletTransactionRepository;
        this.walletUsageTypeRepository = walletUsageTypeRepository;
    }
    async getTransactionIdForWalletRecharge(amount, payeeChannelId, payerChannelId, userId, secretKey, paymentIntentId = null, entity = 'wallet_recharge') {
        console.log('create transaction id and return the amount and Id');
        console.log(secretKey);
        console.log('charge');
        try {
            return await this.otherPaymentRepository.create({
                payerChannelId: payerChannelId,
                payeeChannelId: payeeChannelId,
                amount: amount,
                updatedBy: userId,
                currencyid: app_constant_1.appconstant.CHANNELHUB_CURRENCY,
                paymentIntent: (paymentIntentId) ? paymentIntentId : null,
                entity: entity,
                secretKey: secretKey
            }).then(async (invoice) => {
                let invoicenumber;
                invoice.invoiceno = null;
                await invoice.save();
                return invoice;
            });
        }
        catch (e) {
            console.log(e);
        }
    }
    async completeWalletRecharge(req, user) {
        try {
            let paymentIntent = null;
            let reqAmount = 0;
            console.log(req);
            if (req.paymentMethod == 3) {
                paymentIntent = req.paymentIntent.client_secret;
                reqAmount = +req.amount;
            }
            else if (req.paymentMethod == 1) {
                paymentIntent = req.id;
                reqAmount = +req.purchase_units[0].amount.value;
            }
            return await this.otherPaymentRepository.update({
                paymentIntent: (req.id) ? req.id : null,
                message: req.status,
                transactionNumber: (req.payment_method) ? req.payment_method : null
            }, {
                where: {
                    secretKey: paymentIntent
                }
            }).then(async (invoice) => {
                if (req.paymentType == 'wallet') {
                    let amountInfo = await this.userWalletAmountRepository.findOne({ where: {
                            userId: user.userId,
                            channelId: user.channelId
                        } });
                    if (amountInfo == null) {
                        await this.userWalletAmountRepository.create({
                            userId: user.userId,
                            channelId: user.channelId,
                            amount: +req.amount,
                            updatedAt: sequelize_typescript_1.Sequelize.fn('NOW')
                        });
                    }
                    else {
                        let totalamt = [];
                        let existamt = +amountInfo.amount;
                        let reqAmt = +req.amount;
                        totalamt['amount'] = (existamt + reqAmt);
                        amountInfo.update(totalamt);
                    }
                }
                else {
                    console.log('++++++++', paymentIntent);
                    return await this.otherPaymentRepository.findOne({
                        where: {
                            secretKey: paymentIntent
                        }
                    });
                }
                return invoice;
            });
        }
        catch (e) {
            console.log(e);
        }
    }
    async getWalletRecharge(user) {
        try {
            return await UserWalletAmount_entity_1.UserWalletAmount.findOne({
                where: {
                    channelId: user.channelId,
                    userId: user.userId
                }
            }).then(async (res) => {
                return res;
            });
        }
        catch (e) {
            console.log(e);
        }
    }
    async processWalletPayment(req, user) {
        try {
            return await UserWalletAmount_entity_1.UserWalletAmount.findOne({
                where: {
                    channelId: user.channelId,
                    userId: user.userId
                }
            }).then(async (userAmount) => {
                let walletTransactions = {};
                walletTransactions.payerUserId = +user.userId;
                walletTransactions.payeeChannelId = req.req_cid;
                walletTransactions.amount = req.amt;
                walletTransactions.currencyid = 1;
                walletTransactions.walletUsageTypeId = 1;
                walletTransactions.updatedAt = Date.now();
                userAmount.amount = +userAmount.amount - 10;
                userAmount.save();
                if (req.jctId == null) {
                    await ChannelJCT_entity_1.ChannelJCT.create({
                        isConfidential: '0',
                        channelId: +req.req_cid,
                        partnerChannelId: +user.channelId,
                        createdAt: Date.now(),
                        connectionStatusTypeId: +app_constant_1.appconstant.REMOVE_CONFIDENTIAL
                    });
                }
                else {
                    await ChannelJCT_entity_1.ChannelJCT.update({
                        isConfidential: '0'
                    }, {
                        where: {
                            deletedat: null,
                            channelJCTId: req.jctId
                        }
                    });
                    await ChannelJCT_entity_1.ChannelJCT.update({
                        isConfidential: '0'
                    }, {
                        where: {
                            channelId: +req.req_cid,
                            partnerChannelId: user.channelId,
                        }
                    });
                    console.log('wallet rc confirmation rrrrr');
                    console.log(req.jctId);
                }
                return userAmount;
            });
        }
        catch (e) {
            console.log(e);
        }
    }
};
walletRechargeService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject('OtherPaymentRepository')),
    __param(1, common_1.Inject('UserWalletAmountRepository')),
    __param(2, common_1.Inject('WalletTransactionRepository')),
    __param(3, common_1.Inject('WalletUsageTypeRepository')),
    __metadata("design:paramtypes", [Object, Object, Object, Object])
], walletRechargeService);
exports.walletRechargeService = walletRechargeService;
//# sourceMappingURL=walletRecharge.service.js.map