'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChannelgroupController = void 0;
const common_1 = require("@nestjs/common");
const validation_pipe_1 = require("./../../../middleware/pipe/validation.pipe");
const wishlist_service_1 = require("./../service/wishlist.service");
const group_dto_1 = require("../dto/group.dto");
const passport_1 = require("@nestjs/passport");
const base_controller_1 = require("../../../core/controller/base.controller");
let ChannelgroupController = class ChannelgroupController extends base_controller_1.BaseController {
    constructor(wishlistService) {
        super();
        this.wishlistService = wishlistService;
    }
    async addChannelGroup(req, res, group) {
        let user = req.user;
        await this.wishlistService.createChannelGroup({
            userId: +user.userId,
            channelId: +user.channelId,
            groupName: group.groupName
        }, user);
        res.status(common_1.HttpStatus.CREATED).json({
            "status": true
        });
    }
};
__decorate([
    common_1.Post('channelgroup/group'),
    __param(0, common_1.Req()), __param(1, common_1.Res()), __param(2, common_1.Body(new validation_pipe_1.ValidationPipe())),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, group_dto_1.GroupDto]),
    __metadata("design:returntype", Promise)
], ChannelgroupController.prototype, "addChannelGroup", null);
ChannelgroupController = __decorate([
    common_1.UseGuards(passport_1.AuthGuard('jwt')),
    common_1.Controller('favorite'),
    __metadata("design:paramtypes", [wishlist_service_1.WishlistService])
], ChannelgroupController);
exports.ChannelgroupController = ChannelgroupController;
//# sourceMappingURL=channelgroup.controller.js.map