import { Wishlist } from '../models/Wishlist.entity';
import { Channelgroup } from '../models/Channelgroup.entity';
import { ProductEvaluation } from './../../product/models/ProductEvaluation.entity';
import { Product } from './../../product/models/Product.entity';
import { BaseService } from 'src/core/service/base.service';
import { ProductImage } from 'src/modules/product/models/ProductImage.entity';
import { Media } from 'src/modules/media/models';
import { ProductAward } from 'src/modules/product/models/ProductAward.entity';
import { Brand } from 'src/modules/product/models/Brand.entity';
export declare class WishlistService extends BaseService {
    private readonly repository;
    private readonly grouprepository;
    private readonly evaluation;
    private readonly sequelizeInstance;
    private readonly productRepository;
    private readonly productImageRepository;
    private readonly mediaRepository;
    private readonly productAwardRepository;
    private readonly brandRepository;
    constructor(repository: typeof Wishlist, grouprepository: typeof Channelgroup, evaluation: typeof ProductEvaluation, sequelizeInstance: any, productRepository: typeof Product, productImageRepository: typeof ProductImage, mediaRepository: typeof Media, productAwardRepository: typeof ProductAward, brandRepository: typeof Brand);
    create(data: any, user: any): Promise<any>;
    createChannelGroup(data: any, user: any): Promise<any>;
    createFavoriteChannel(data: any, user: any, list_type: any): Promise<any>;
    removeFavoriteChannel(data: any, user: any, list_type: any): Promise<any>;
    removeFavoriteGroup(id: number): Promise<any>;
    getGroupList(user: any): Promise<{
        result: any[];
        gtotal: number;
    }>;
    findAll(userId: any, type: any, channelId: any, rejectedProductIds?: any): Promise<Array<Wishlist>>;
    move(channelId: any, userId: any, product: any, user: any): Promise<void>;
    delete(id: number, type: string, user: any): Promise<void>;
    private _buildObject;
    private _groupObject;
    private _favoriteObject;
    count(type: any, userId: any): Promise<number>;
    channelcount(user: any): Promise<number>;
    productcount(user: any, productId: any): Promise<number>;
    getSuggestedProduct(ids: any, data: any, user: any): Promise<Product[]>;
}
