'use strict';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WishlistModule = void 0;
const common_1 = require("@nestjs/common");
const product_module_1 = require("./../product/product.module");
const index_controller_1 = require("./controller/index.controller");
const channelgroup_controller_1 = require("./controller/channelgroup.controller");
const wishlist_provider_1 = require("./provider/wishlist.provider");
const wishlist_service_1 = require("./service/wishlist.service");
const notification_module_1 = require("../notification/notification.module");
const database_module_1 = require("../../core/database/database.module");
const product_providers_1 = require("../product/provider/product.providers");
const media_provider_1 = require("../media/providers/media.provider");
let WishlistModule = class WishlistModule {
};
WishlistModule = __decorate([
    common_1.Module({
        imports: [
            product_module_1.ProductModule,
            database_module_1.DatabaseModule,
            notification_module_1.NotificationModule
        ],
        controllers: [
            index_controller_1.IndexController,
            channelgroup_controller_1.ChannelgroupController
        ],
        providers: [
            ...wishlist_provider_1.wishlistProvider,
            ...wishlist_provider_1.channelGroupProvider,
            ...product_providers_1.productImageProvider,
            ...media_provider_1.MediaProviders,
            ...product_providers_1.productAwardProvider,
            wishlist_service_1.WishlistService
        ]
    })
], WishlistModule);
exports.WishlistModule = WishlistModule;
//# sourceMappingURL=wishlist.module.js.map