import { Controller, Get, Inject, Param, Post, Req, UseGuards } from '@nestjs/common';
import { ClientProxy } from '@nestjs/microservices';
import { AuthGuard } from '@nestjs/passport';
import { ContextService } from 'src/context/context.service';
import { AlgorithmService } from './algorithm.service';

@UseGuards(AuthGuard('jwt'))
@Controller('algorithm')
export class AlgorithmController {
    
    // constructor(
    //     @Inject('ALGORITHM_SERVICE') private algorithmService: ClientProxy,
    //     private context: ContextService,
    //   ) {}

    constructor(
      private readonly algorithmService: AlgorithmService,
    ) { }

  //Micro
  // @Get('channel')
  //   async channelAlgm(@Req() req) {
  //     let user = req.user;        		
  //   return this.algorithmService.send({
  //     cmd: 'channel-algm'
  //   },JSON.stringify(user))
  // }

  //Non Micro
  @Get('channel')
    async channelAlgm(@Req() req) {
      let user = req.user;        		
    this.algorithmService.channelAlgm1(user);
  }
  
  @Get('channel/:contactId')
  async contactUpdateAlgm(@Param('contactId') contactId,@Req() req) {
    //let user = {contactId:contactId,channelId:req.user.channelId,channelTypeId:req.user.channelTypeId};  		
    // return await this.algorithmService.send({
    //   cmd: 'channel-algm'
    // },JSON.stringify(req.user))
    let user = req.user;
    this.algorithmService.channelAlgm1(user);
}

  //Micro
  // @Get('product/:contactId')
  //   async productAlgm(@Param('contactId') contactId,@Req() req) {

  //     let user = {contactId:contactId,channelId:req.user.channelId,channelTypeId:req.user.channelTypeId,profileTypeId:req.user.profileTypeId};  		

  //   return this.algorithmService.send({
  //     cmd: 'product-algm'
  //   },JSON.stringify(user))
  // }

  //Non Micro
  @Get('product/:contactId')
  async productAlgm(@Param('contactId') contactId, @Req() req) {
      let user = {contactId:contactId,channelId:req.user.channelId,channelTypeId:req.user.channelTypeId,profileTypeId:req.user.profileTypeId};  		
    return this.algorithmService.productAlgm(user);
  }

  // added by manue for admin wiretransfer
  @Post('channel/admin')
  async channelUpdateAlgmAdmin(@Req() req) {
        
    if(req.body)    {
      this.algorithmService.channelAlgm1(req.body);
      return true;
    } else {
      return false;
    }
}

}
