import { Module } from '@nestjs/common';
import { ConfigModule, ConfigService } from '@nestjs/config';
import { ClientProxyFactory, Transport } from '@nestjs/microservices';
import { AlgorithmController } from './algorithm.controller';
import { AlgorithmService } from './algorithm.service';
import { databaseProviders } from '../core/database/database.providers';
import { channelJctProvider, channelMatchingProvider, productJctProvider, productMatchingProvider } from './provider/channelJCT.provider';

@Module({
  imports: [ConfigModule],
  controllers: [AlgorithmController],
  providers: [
    // {
    //   provide: 'ALGORITHM_SERVICE',
    //   useFactory: (configService: ConfigService) => (
    //     ClientProxyFactory.create({
    //       transport: Transport.TCP,
    //       options: {
    //         host: process.env.ALGORITHM_SERVICE,
    //         port: 8888
    //       }
    //     })
    //   ),
    //   inject: [ConfigService],
    // }
    AlgorithmService, ...channelJctProvider, ...productJctProvider, ...productMatchingProvider, ...channelMatchingProvider,
    ...databaseProviders
  ]
})
export class AlgorithmModule {}
