'use strict';

import { Module , RequestMethod } from '@nestjs/common';
import { ComplainService } from './service/complain.service';
import { ComplainProvider,ComplaintAttachmentProvider , ComplaintCategoryProvider, ComplaintReplyContentProvider } from './provider/complain.providers';
import { ComplainAdminController } from './controller/complain.admin.controller';
import { ComplainController } from './controller/complain.controller';
import { DatabaseModule } from 'src/core/database/database.module';
import { UserModule } from 'src/modules/user/user.module';
import { MediaModule } from 'src/modules/media/media.module';
import { ChannelModule } from 'src/modules/channel/channel.module';

@Module({
	controllers: [
		ComplainAdminController,
		ComplainController
	],
	providers: [
		ComplainService,
		...ComplainProvider,
		...ComplaintAttachmentProvider,
		...ComplaintCategoryProvider,
		...ComplaintReplyContentProvider
	],
	imports: [
		DatabaseModule,
		UserModule,
		MediaModule,
		ChannelModule,
		// NotificationModule
	],
	exports: [],
})

export class ComplainModule {
	constructor() {
		// super();
	}

	// configure(consumer: MiddlewaresConsumer): void {
	// 	consumer.apply(UserAuthMiddleware).forRoutes(ComplainAdminController);
	// 	consumer.apply(SharedAuthMiddleware).forRoutes(
	// 		{ path: '/v1/complain/category/:complaintype', method: RequestMethod.GET },
	// 		{ path: '/v1/complain', method: RequestMethod.POST }
	// 	);
	// }
}
