import { IsEnum, ValidateIf, ValidateNested, IsNotEmpty } from 'class-validator';
import { Type } from 'class-transformer';
import { CompalaintReplyDto } from '../dto/complaintreply.dto';

export enum ComplainActions {
    pending,
    replied,
    closed
}

export class ComplainActionDto {
    
    @IsEnum(ComplainActions, { message: "Please choose anyone action from the list ( pending, replied, closed )" })
    readonly action: string;


    @ValidateIf(o => o.action == 'replied')
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@ValidateNested()
	@Type(() => CompalaintReplyDto)
	readonly compalaintreply: CompalaintReplyDto;
    
    
}
