'use strict';
import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, ForeignKey, BelongsTo } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Media } from 'src/modules/media/models/Media.entity';
import { Complain } from './Complain.entity';

const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblcomplaintattachment' } as IDefineOptions;
@Table(tableOptions)

export class ComplaintAttachment extends Model<ComplaintAttachment>{
    
    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    complaintattachmentid: number

    @ForeignKey(() => Complain)
    @AllowNull(false)
    @Column(DataType.BIGINT)
    complaintid: number;

    @BelongsTo(() => Complain)
    complain: Complain;

    @ForeignKey(() => Media)
    @AllowNull(false)
    @Column(DataType.BIGINT)
    attachmentid: number;

    @BelongsTo(() => Media)
    document: Media;

    @Column(DataType.DATE)
    createdat: Date;

}