'use strict';
import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, Scopes } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';

const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblcomplaintcategory' } as IDefineOptions;
@Table(tableOptions)

@Scopes({ 
    baseDetail: {
        attributes: [['complaintcategoryid','id'], ['complaintcategory','name'], 'isactive', 'complainttype','createdat','deletedat']
    }
})

export class ComplaintCategory extends Model<ComplaintCategory>{
    
    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    complaintcategoryid: number

    @AllowNull(false)
    @Column(DataType.CHAR(150))
    complaintcategory: string;

    @Column
    isactive: string;

    @Column(DataType.ENUM('ContactType','Complaint','IPR'))
    complainttype: string;

    @Column(DataType.DATE)
    createdat: Date;

    @Column(DataType.DATE)
    deletedat: Date;

    @Column(DataType.DATE)
    updatedat: Date;
}