'use strict';
import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, ForeignKey, BelongsTo } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { User } from 'src/modules/user/models/User.entity';
import { Complain } from './Complain.entity';


const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblcomplaintreplycontent' } as IDefineOptions;
@Table(tableOptions)

export class ComplaintReplyContent extends Model<ComplaintReplyContent>{
    
    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    complaintreplycontentid: number

    @ForeignKey(() => Complain)
    @Column(DataType.BIGINT)
    complaintid: number;

    @BelongsTo(() => Complain)
    complain: Complain;

    @Column
    content: string;
    
    @ForeignKey(() => User)
    @Column(DataType.BIGINT)
    replyedby: number;

    @BelongsTo(() => User)
    user: User;

    @Column(DataType.DATE)
    createdat: Date;

}