'use strict'

import { appconstant } from "src/config/app.constant";
import { ProcessException } from "src/middleware/exception/Process.exception";
import { QueryTypes } from "sequelize";
import { Channel } from "src/modules/channel/models/Channel.entity";
import _ = require('lodash');
import { AuthException } from "src/middleware/exception/Auth.exception";
export abstract class BaseController {

	public redisInstance;

	constructor() {

	}
	async getRejectedChannelIds(channelId,contactId) {
		
		return await Channel.sequelize.query('select case when "channelId"=:channelId then "partnerChannelId" when  "partnerChannelId"=:channelId then "channelId" end as a  from "tblChannelJCT" where "connectionStatusTypeId" in (:rejectStatus) and ("channelId"=:channelId or "partnerChannelId"=:channelId) and case when "requested_to" = :contactId then "requested_by" not in(select case when "requested_by"=:contactId then "requested_to" when "requested_to"=:contactId then "requested_by" end from "tblChannelJCT" where ("requested_to"=:contactId or "requested_by"=:contactId) and "deletedat" is null and  "connectionStatusTypeId" in(1,2,7,10,11)) when "requested_by" = :contactId then "requested_to" not in(select case when "requested_by"=:contactId then "requested_to" when "requested_to"=:contactId then "requested_by" end from "tblChannelJCT" where ("requested_to"=:contactId or "requested_by"=:contactId) and "deletedat" is null and  "connectionStatusTypeId" in(1,2,7,10,11)) end', {
			type: QueryTypes.SELECT,
			raw: true,
			replacements: {
				rejectStatus: [appconstant.DISMISS, appconstant.DISMISS_OTHER_REASON],
				channelId: +channelId,
				contactId: +contactId
			}
		}).then((result:any) => {
			let res = [];
			
			res=result.map(x => +x.a);
			res=_.uniq(res);
			//if (result[0]) { res = [...new Set([...result[0].a || []])]; }
			//console.log("aaaa:",res);
			return res;
		});
	}

	async verifyRejectedChannels(user, channelId) {
		let rejectedChannels = await this.getRejectedChannelIds(+user.channelId,+user.contactId);
		if (rejectedChannels.includes('' + channelId)) {
			throw new ProcessException('channelHub:channel:rejected');
		}
	}
	
	async getChannelType(channelId, field?) {
		let channel = await Channel.findOne({
			attributes: ['channelTypeId', 'signUpStatusId', 'subscriptionId', 'planId', 'isActive'],
			where: {
				channelId: +channelId,
				isActive: '1',
				signUpStatusId: appconstant.CHANNEL_APPROVED,
				deletedAt: null,
			}
		});

		if (!channel) {
			throw new AuthException('Not allowed');
		}

		let output = {
			channelId: channel.channelId,
			channelTypeId: channel.channelTypeId,
			suggestionType: appconstant.CHANNELTYPES[+channel.channelTypeId]
		};

		return (field) ? output[field] : output;
	}
}
