import { Sequelize } from 'sequelize-typescript';
import { Application } from 'src/modules/auth/models/Application.entity';
import { User } from 'src/modules/user/models/User.entity';
import { Contact } from 'src/modules/user/models/Contact.entity';
import { UserRole } from 'src/modules/user/models/UserRole.entity';
import { Role } from 'src/modules/user/models/Role.entity';
import { UserAccessPermission } from 'src/modules/user/models/UserAccessPermission.entity';
import { AccessPermission } from 'src/modules/user/models/AccessPermission.entity';
import { Channel } from 'src/modules/channel/models/Channel.entity';
import { OldChannel } from 'src/modules/channel/models/OldChannel.entity';
import { ContactProductGroup } from 'src/modules/user/models/ContactProductGroup.entity';
import { ContactProductCategory } from 'src/modules/user/models/ContactProductCategory.entity';
import { ContactInterestedProductCategory } from 'src/modules/user/models/ContactInterestedProductCategory.entity';
import { ContactInterestedProductGroup } from 'src/modules/user/models/ContactInterestedProductGroup.entity';
import { Responsibility } from 'src/modules/user/models/Responsibility.entity';
import { ContactSocialLink } from 'src/modules/user/models/ContactSocialLink.entity';
import { ContactLocation } from 'src/modules/user/models/ContactLocation.entity';
import { SignUpStatus } from 'src/modules/user/models/SignUpStatus.entity';
import { SignUpHistory } from 'src/modules/user/models/SignUpHistory.entity';
import { ReferenceContact } from 'src/modules/user/models/ReferenceContact.entity';
import { UserActivity } from 'src/modules/activity/models/UserActivity.entity';
import { NonUserActivity } from 'src/modules/activity/models/NonUserActivity.entity';

import { ProductGroup } from 'src/modules/product/models/ProductGroup.entity';
import { ProductCategory } from 'src/modules/product/models/ProductCategory.entity';
import { Brand } from 'src/modules/product/models/Brand.entity';

import { Media } from 'src/modules/media/models/Media.entity';
import { MediaType } from 'src/modules/media/models/MediaType.entity';
import { Country } from 'src/modules/common/models/Country.entity';
import { ZoneRegionJCT } from 'src/modules/common/models/ZoneRegionJCT.entity';
import { Zone } from 'src/modules/common/models/Zone.entity';
import { Region } from 'src/modules/common/models/Region.entity';
import { RegionCountryJCT } from 'src/modules/common/models/RegionCountryJCT.entity';

import { ChannelContactSuggestion } from 'src/modules/channel/models/ChannelContactSuggestion.entity';
import { SubscriptionPlan } from 'src/modules/channel/models/SubscriptionPlan.entity';
import { Subscription } from 'src/modules/channel/models/Subscription.entity';
import { ProfileType } from 'src/modules/channel/models/ProfileType.entity';
import { ChannelType } from 'src/modules/channel/models/ChannelType.entity';
import { ChannelSubscription } from 'src/modules/channel/models/ChannelSubscription.entity';
import { Address } from 'src/modules/channel/models/Address.entity';
import { OldAddress } from 'src/modules/channel/models/OldAddress.entity';
import { ChannelCertificate } from 'src/modules/channel/models/ChannelCertificate.entity';
import { ChannelSocialLink } from 'src/modules/channel/models/ChannelSocialLink.entity';
import { ChannelB2B } from 'src/modules/channel/models/ChannelB2B.entity';
import { ChannelAward } from 'src/modules/channel/models/ChannelAward.entity';
import { ChannelDetail } from 'src/modules/channel/models/ChannelDetail.entity';
import { ChannelSpeciality } from 'src/modules/channel/models/ChannelSpeciality.entity';
import { ChannelCustomerProfile } from 'src/modules/channel/models/ChannelCustomerProfile.entity';
import { ChannelProductCategorie } from 'src/modules/channel/models/ChannelProductCategorie.entity';
import { ChannelProductGroup } from 'src/modules/channel/models/ChannelProductGroup.entity';
import { ChannelLocation } from 'src/modules/channel/models/ChannelLocation.entity';
import { ChannelServiceList } from 'src/modules/channel/models/ChannelServiceList.entity';
import { ChannelBrand } from 'src/modules/channel/models/ChannelBrand.entity';
import { ChannelPaymentOptionType } from 'src/modules/channel/models/ChannelPaymentOptionType.entity';
import { PaymentOptionType } from 'src/modules/channel/models/PaymentOptionType.entity';
import { ChannelPaymentTerm } from 'src/modules/channel/models/ChannelPaymentTerm.entity';
import { PaymentTerm } from 'src/modules/channel/models/PaymentTerm.entity';
import { ServiceList } from 'src/modules/channel/models/ServiceList.entity';
import { ShareType } from 'src/modules/channel/models/ShareType.entity';
import { ChannelJCT } from 'src/modules/channel/models/ChannelJCT.entity';
import { ChannelSharePreference } from 'src/modules/channel/models/ChannelSharePreference.entity';
import { Claim } from 'src/modules/channel/models/Claim.entity';
import { SocialSite } from 'src/modules/channel/models/SocialSite.entity';
import { SubscriptionDetail } from 'src/modules/channel/models/SubscriptionDetail.entity';
import { SubscriptionPeriod } from 'src/modules/channel/models/SubscriptionPeriod.entity';
import { ChannelDocument } from 'src/modules/channel/models/ChannelDocument.entity';
import { ProfileTypeClassification } from 'src/modules/channel/models/ProfileTypeClassification.entity';
import { SubscriptionType } from 'src/modules/channel/models/SubscriptionType.entity';
import { Coupon } from 'src/modules/channel/models/Coupon.entity';
import { CertificateType } from 'src/modules/channel/models/CertificateType.entity';
import { AutoRenewalTracking } from 'src/modules/channel/models/AutoRenewalTracking.entity';
import { ChannelSuggestion } from 'src/modules/channel/models/ChannelSuggestion.entity';
import { Currency } from 'src/modules/channel/models/Currency.entity';
import { ConnectionStatusType } from 'src/modules/channel/models/ConnectionStatusType.entity';
import { PaymentTransaction } from 'src/modules/channel/models/PaymentTransaction.entity';
import { ContactJCT } from 'src/modules/channel/models/ContactJCT.entity';
import { ClaimDocument } from 'src/modules/channel/models/ClaimDocument.entity';
import { SubscriptionFeatures } from 'src/modules/channel/models/SubscriptionFeatures.entity';
import { PaymentType } from 'src/modules/channel/models/PaymentType.entity';
import { SubscriptionFeatureCategory } from 'src/modules/channel/models/SubscriptionFeatureCategory.entity';
import { ChannelKeyPartner } from 'src/modules/channel/models/ChannelKeyPartner.entity';
import { ProductKeyPartnerJCT } from 'src/modules/product/models/ProductKeyPartnerJCT.entity';
import { KeyPartnerJCT } from 'src/modules/channel/models/KeyPartnerJCT.entity';

import { SEQUELIZE, DEVELOPMENT, TEST, PRODUCTION } from '../constants';
import { databaseConfig } from './database.config';
import { OldContact } from 'src/modules/channel/models/OldContact.entity';
import { OldChannelDetail } from 'src/modules/channel/models/OldChannelDetail.entity';
import { AdminUserAccess } from 'src/modules/admin/models/AdminUserAccess.entity';
import { AdminMenu } from 'src/modules/admin/models/AdminMenu.entity';
import { AdminUserCountries } from 'src/modules/admin/models/AdminUserCountries.entity';
import { AdminUsers } from 'src/modules/admin/models/AdminUsers.entity';
import { AdminUserChanneltype } from 'src/modules/admin/models/AdminUserChanneltype.entity';
import { ProfileRatings } from 'src/modules/channel/models/ProfileCreationRating.entity';
import { ProfileList } from 'src/modules/channel/models/ProfileList.entity';
import { CompanyMedia } from 'src/modules/channel/models/CompanyMedia.entity';
import { Product } from 'src/modules/product/models/Product.entity';
import { ProductDetail } from 'src/modules/product/models/ProductDetail.entity';
import { ProductTag } from 'src/modules/product/models/ProductTag.entity';
import { ProductArticleReview } from 'src/modules/product/models/ProductArticleReview.entity';
import { ProductAward } from 'src/modules/product/models/ProductAward.entity';
import { ProductChannelCustomerProfile } from 'src/modules/product/models/ProductChannelCustomerProfile.entity';
import { ProductCompeting } from 'src/modules/product/models/ProductCompeting.entity';
import { ProductEvaluationRating } from 'src/modules/product/models/ProductEvaluationRating.entity';
import { ProductExistRating } from 'src/modules/product/models/ProductExistRating.entity';
import { ProductPackageInfo } from 'src/modules/product/models/ProductPackageInfo.entity';
import { ProductPriceDetail } from 'src/modules/product/models/ProductPriceDetail.entity';
import { ProductImage } from 'src/modules/product/models/ProductImage.entity';
import { ProductSharePreference } from 'src/modules/product/models/ProductSharePreference.entity';
import { ProductUniversalCode } from 'src/modules/product/models/ProductUniversalCode.entity';
import { ProductLocation } from 'src/modules/product/models/ProductLocation.entity';
import { ProductReject } from 'src/modules/product/models/ProductReject.entity';
import { Unit } from 'src/modules/product/models/Unit.entity';
import { DiscountUnit } from 'src/modules/product/models/DiscountUnit.entity';
import { ProductMediaLibrary } from 'src/modules/product/models/ProductMediaLibrary.entity';
import { SubscriptionExtraFeature } from 'src/modules/channel/models/SubscriptionExtraFeature.entity';
import { SubscriptionExtraFeatureCategory } from 'src/modules/channel/models/SubscriptionExtraFeatureCategories.entity';
import { SampleOrder } from 'src/modules/order/models/SampleOrder.entity';
import { OrderAddress } from 'src/modules/order/models/OrderAddress.entity';
import { OrderStatus } from 'src/modules/order/models/OrderStatus.entity';
import { ProductEvaluation } from 'src/modules/product/models/ProductEvaluation.entity';
import { SampleOrderDetail } from 'src/modules/order/models/SampleOrderDetail.entity';
import { OrderShipment } from 'src/modules/order/models/OrderShipment.entity';
import { RatingAttribute } from 'src/modules/channel/models/RatingAttribute.entity';
import { EvaluationAttribute } from 'src/modules/channel/models/EvaluationAttribute.entity';
import { DismissReason } from 'src/modules/channel/models/DismissReason.entity';
import { ChannelDismissReason } from 'src/modules/channel/models/ChannelDismissReason.entity';
import { MeetingReq } from 'src/modules/meeting/models/MeetingReq.entity';
import { Setting } from 'src/modules/common/models/Setting.entity';
import { ProductQuote } from 'src/modules/cart/models/ProductQuote.entity';
import { Cart } from 'src/modules/cart/models/Cart.entity';
import { Channelgroup } from 'src/modules/wishlist/models/Channelgroup.entity';
import { Wishlist } from 'src/modules/wishlist/models/Wishlist.entity';
import { EmailTemplate } from 'src/modules/notification/models/EmailTemplate.entity';
import { InterestedProductCategory } from 'src/modules/user/models/InterestedProductCategory.entity';
import { InterestedProductGroup } from 'src/modules/user/models/InterestedProductGroup.entity';
import { ProductJCT } from 'src/modules/product/models/ProductJCT.entity';

import { UserWalletAmount } from 'src/modules/walletRecharge/models/UserWalletAmount.entity';
import { OtherPayment } from 'src/modules/channel/models/OtherPayment.entity';
import { WalletTransaction } from 'src/modules/walletRecharge/models/WalletTransaction.entity';
import { WalletUsageType } from 'src/modules/walletRecharge/models/WalletUsageType.entity';
import { MyAddressBook } from 'src/modules/user/models/MyAddressBook.entity';
import { BuyerReqCategory } from 'src/modules/channel/models/BuyerReqCategory.entity';
import { BuyerNeed } from 'src/modules/channel/models/BuyerNeed.entity';
import { ComplaintCategory } from 'src/complains/models/ComplaintCategory.entity';
import { ComplaintReplyContent } from 'src/complains/models/ComplaintReplyContent.entity';
import { ComplaintAttachment } from 'src/complains/models/ComplaintAttachment.entity';
import { Complain } from 'src/complains/models/Complain.entity';
import { FailureTransaction } from 'src/modules/channel/models/FailureTransaction.entity';
import { Errors } from 'src/error/model/Error.entity';

import { DashboardReport } from 'src/modules/channel/models/DashboardReport.entity';
import { Dashboard } from 'src/modules/channel/models/Dashboard.entity';
import { CompanyMediaImages } from 'src/modules/channel/models/CompanyMediaImages';
import { EndCustomersB2bType } from 'src/modules/channel/models/EndCustomersB2bType';
import { EndCustomersB2b } from 'src/modules/channel/models/EndCustomerB2b';
import { CertificateTag } from 'src/modules/channel/models/CertificateTag.entity';
import { GuestRequirement } from 'src/modules/channel/models/GuestRequirement.entity';
import { EventBo } from 'src/modules/channel/models/EventBo.entity';
import { EventPackage } from 'src/modules/channel/models/EventPackage.entity';
import { EventParticipants } from 'src/modules/channel/models/EventParticipants.entity';
import { EventChannel } from 'src/modules/channel/models/EventChannel.entity';
import { BucketErrorLog } from 'src/modules/media/models/bucketErrorLog.entity';
import { AdminUserNotification } from 'src/modules/admin/models/AdminUserNotification.entity';
import { OldChannelSocialLink } from 'src/modules/channel/models/OldChannelSocialLink.entity';

import { AlgmChannelJCT } from 'src/algorithm/models/AlgmChannelJCT.entity';
import { AlgmProductJCT } from 'src/algorithm/models/AlgmProductJCT.entity';
import { ChannelMatching } from 'src/algorithm/models/ChannelMatching.entity';
import { ProductMatching } from 'src/algorithm/models/ProductMatching.entity';
import { OldChannelCustomerProfile } from 'src/modules/channel/models/OldChannelCustomerProfile.entity';
import { OldChannelSpeciality } from 'src/modules/channel/models/OldChannelSpeciality.entity';


export const databaseProviders = [{
   provide: 'SequelizeInstance',
   useFactory: async () => {
      let config;
      switch (process.env.NODE_ENV) {
         case DEVELOPMENT:
            config = databaseConfig.development;
            break;
         case TEST:
            config = databaseConfig.test;
            break;
         case PRODUCTION:
            config = databaseConfig.production;
            break;
         default:
            config = databaseConfig.development;
      }
      //let file_type = process.env.RUN_MODE == 'DEBUG' ? 'ts' : 'js';
      const sequelize = new Sequelize(config);
      sequelize.addModels([Application, User, Contact, OldContact, Channel, OldChannel, UserRole, Role, UserActivity, NonUserActivity,
         UserAccessPermission, AccessPermission, ContactProductGroup, ProductGroup, ContactProductCategory,
         ProductCategory, Responsibility, Media, Country, ContactSocialLink, ContactLocation, RegionCountryJCT,
         SubscriptionDetail, ProfileTypeClassification, SubscriptionType, Coupon, PaymentTransaction, ChannelSuggestion,
         ChannelContactSuggestion, ContactInterestedProductGroup, ContactInterestedProductCategory, SignUpStatus,
         SubscriptionPlan, Subscription, ProfileType, ChannelType, ChannelSubscription, Address, OldAddress, SignUpHistory, ChannelCertificate,
         ChannelSocialLink, ChannelB2B, ChannelAward, ChannelDetail, OldChannelDetail, ChannelSpeciality, ChannelCustomerProfile,
         ChannelProductCategorie, ChannelLocation, ChannelServiceList, ChannelBrand, ChannelProductGroup,
         ChannelPaymentOptionType, PaymentOptionType, ChannelPaymentTerm, PaymentTerm, ServiceList, Brand, ChannelSharePreference,
         ShareType, ChannelJCT, ReferenceContact, Claim, ChannelDocument, MediaType, Region, SocialSite, SubscriptionPeriod,
         ChannelKeyPartner, ProductKeyPartnerJCT, KeyPartnerJCT,

         AutoRenewalTracking, CertificateType, Currency, ConnectionStatusType, ContactJCT, ClaimDocument, ZoneRegionJCT,
         Zone, SubscriptionFeatures, PaymentType, SubscriptionFeatureCategory, SubscriptionExtraFeature, SubscriptionExtraFeatureCategory,

         Product, ProductDetail, ProductTag, ProductArticleReview, ProductLocation, ProductMediaLibrary,
         ProductAward, ProductChannelCustomerProfile, ProductExistRating, ProductPackageInfo, ProductPriceDetail,
         ProductImage, ProductSharePreference, ProductUniversalCode, ProductCompeting, ProductReject, Unit, DiscountUnit,

         AdminUsers, AdminUserAccess, AdminMenu, AdminUserCountries, AdminUserChanneltype, AdminUserNotification, ProfileRatings, ProfileList, CompanyMedia,

         Channelgroup, Wishlist,
         SampleOrder, OrderAddress, OrderStatus, SampleOrderDetail, OrderShipment,
         ProductEvaluation, ProductEvaluationRating, RatingAttribute, EvaluationAttribute, DismissReason, ChannelDismissReason,
         MeetingReq, Setting, ProductQuote, Cart, EmailTemplate,

         InterestedProductGroup, InterestedProductCategory, ProductJCT, OtherPayment, UserWalletAmount, WalletTransaction, WalletUsageType, MyAddressBook,
         BuyerNeed, BuyerReqCategory, ComplaintCategory, ComplaintReplyContent, ComplaintAttachment, Complain, FailureTransaction, Errors,

         Dashboard, DashboardReport, CompanyMediaImages, EndCustomersB2b, EndCustomersB2bType,

         CertificateTag, GuestRequirement, EventBo, EventPackage, EventParticipants, EventChannel, BucketErrorLog, OldChannelSocialLink,
         OldChannelCustomerProfile, OldChannelSpeciality,
         AlgmChannelJCT, ChannelMatching, ProductMatching, AlgmProductJCT
      ]);
      //sequelize.addModels([__dirname + '/../**/*.entity.' + file_type]);
      //await sequelize.sync();
      return sequelize;
   },
}];