import { upperFirst, isUndefined } from 'lodash';
import { Model } from 'sequelize-typescript';

export class BaseHelper {
	constructor() {
	}

	GenerateRandomString(len) {
		var text = "";
		var charset = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
		for (var i = 0; i < len; i++)
			text += charset.charAt(Math.floor(Math.random() * charset.length));
		return text;
	}

	async lazyload<T extends Model<any>>(entity: T, association: keyof T, options?: any, force?: any): Promise<T> {
		if (!isUndefined(entity[association]) && !force) {
			return Promise.resolve(entity);
		}

		const loader = 'get' + upperFirst('' + association);
		if (options) {
			entity[association] = await entity[loader](options);
		} else {
			entity[association] = await entity[loader]();
		}

		return entity;
	}

}
