import { BaseTransformation } from './BaseTransformation';

export class PaginationTransform extends BaseTransformation {

	constructor() {
		super();
	}

	public make(list: any, pagination: any, total: any, aggregations?, others?) {
		let base = {
			pagination: {
				limit: pagination.limit,
				page: pagination.page,
				total: total
			},
			results: list
		};

		if (aggregations) {
			base = Object.assign(base, { aggregations: aggregations });
		}

		if (others) {
			base = Object.assign(base, { others: others });
		}

		return PaginationTransform.makeStaticResponse(list, pagination, total, aggregations, others);
	}

	static makeStaticResponse(list: any, pagination: any, total: any, aggregations?, others?) {
		let base = {
			pagination: {
				limit: pagination.limit,
				page: pagination.page,
				total: total
			},
			results: list
		};

		if (aggregations) {
			base = Object.assign(base, { aggregations: aggregations });
		}

		if (others) {
			base = Object.assign(base, { others: others });
		}

		return base;
	}
}
