import { Body, Controller, HttpStatus, Post, Req, Res, UseGuards, ValidationPipe } from '@nestjs/common';
import { AuthGuard } from '@nestjs/passport';
import { ErrorDto } from './dto/errordto.dto';
import { ErrorService } from './error.service';

@UseGuards(AuthGuard('jwt'))
@Controller('error')
export class ErrorController {

    constructor(private readonly errorService : ErrorService){}

    @Post()
    async error(@Body(new ValidationPipe()) errorData:ErrorDto, @Res() res,@Req() req){

        Object.assign(errorData,{userId:req.user.userId})
        this.errorService.saveError(errorData);
        return res.status(HttpStatus.OK).send({status:true});
    }

}
