import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, BeforeCreate, AllowNull, BeforeUpdate, BelongsTo } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
var Sequelize = require('sequelize'); 

const tableOptions: IDefineOptions = {timestamps: false, tableName: 'tblErrorLog' } as IDefineOptions;

@Table(tableOptions)
export class Errors extends Model<Errors>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	errorId: number

	@Column(DataType.BIGINT)
	userId: number

    @Column(DataType.CHAR(255))
	reqUrl: string

    @Column(DataType.CHAR(255))
	service: string

	@Column(DataType.CHAR(500))
	err: string	

    @Column(DataType.DATE)
    createdAt:Date

    @BeforeCreate  	
	public static async dateUpdate(errors: Errors, options: any) {  
		errors.createdAt = Sequelize.fn('NOW');  
	}

}
