'use strict'

import { Inject, Injectable } from '@nestjs/common';
import { Sequelize } from 'sequelize-typescript';
import { Channel } from '../../modules/channel/models/Channel.entity';
import { Contact } from './../../modules/user/models/Contact.entity';
import { Product } from './../../modules/product/models/Product.entity';
import { ChannelJCT } from '../../modules/channel/models/ChannelJCT.entity';
import { User } from 'src/modules/user/models/User.entity';
import {Op, QueryTypes } from "sequelize";
@Injectable()
export class HubspotImportHelper {

    public async createCompany(result): Promise<any>{
    let request = require('request');
    // var timestamp  = Date();
    // var todate=new Date(timestamp).getDate();
    // var tomonth=new Date(timestamp).getMonth()+1;
    // var toyear=new Date(timestamp).getFullYear();
    // var expiry_at_date=todate+'/'+tomonth+'/'+toyear;

    // let expiry_at=  expiry_at_date;
    let last_login=  '-';
    let oem ="B2B;B2C";
    if(result.isOEM==1) oem="B2C";
    if(result.isOEM==2) oem="B2B";
    if(result.isOEM==2) oem="B2B;B2C";
        var options = { method: 'POST',
          url: 'https://api.hubapi.com/companies/v2/companies',
          qs: { hapikey:process.env.HUBSPOT_API },
          headers: 
          {'Content-Type': 'application/json' },
          body: 
          { properties: 
              [ { name: 'name', value: result.companyName},
              // { name: 'job_position', value: result.jobPosition },//add in prod
              { name: 'website', value: result.websiteurl },
              { name: 'channelTypeId', value: +result.channelTypeId }, //add in prod
              { name: 'address', value: result.address },
              { name: 'city', value: result.city },
              { name: 'state', value: result.state },
              { name: 'country', value: result.country },
              { name: 'zip', value: result.postalCode },
              { name: 'oem', value: result.isOEM }, //add in prod
              { name: 'phone', value: result.mobile },
              { name: 'b2b_b2c', value: oem },
              // { name: 'product_categorie', value: result.productCat.toString() },
              // { name: 'product_family', value: result.productFamily.toString() },
            ] },
              json: true };
        return await new Promise(function(resolve, reject) {      
            request(options, function (error, response, body) {
              if (error){ 
                console.log('err', error);
                throw new Error(error);
              }
              console.log(body);
              resolve(body.companyId);
            });
        });
    }
    public async updateCompany(result, companyId): Promise<any>{
      
    let oem ="B2B;B2C";
    if(result.isOEM==1) oem="B2C";
    if(result.isOEM==2) oem="B2B";
    if(result.isOEM==2) oem="B2B;B2C";
      let request = require('request');
        var options = { 
        method: 'PUT',
        url: 'https://api.hubapi.com/companies/v2/companies/'+companyId,
        qs: { 
              hapikey: process.env.HUBSPOT_API
            },
        headers: 
                {
                  'Content-Type': 'application/json' 
                },
                body: 
                { 
                  portalId: process.env.HUBSPOT_PortalId,
                  companyId: companyId,
                  isDeleted: false,
                  properties: 
                  [ { name: 'name', value: result.companyName},
                  // { name: 'job_position', value: result.jobPosition },
                  { name: 'website', value: result.websiteurl },
                  { name: 'channelTypeId', value: +result.channelTypeId },
                  { name: 'address', value: result.address },
                  { name: 'city', value: result.city },
                  { name: 'state', value: result.state },
                  { name: 'country', value: result.country },
                  { name: 'zip', value: result.postalCode },
                  { name: 'oem', value: result.isOEM },
                  { name: 'phone', value: result.mobile },
                  { name: 'b2b_b2c', value: oem },
                  // { name: 'product_categorie', value: result.productCat.toString() },
                  // { name: 'product_family', value: result.productFamily.toString() },
                ]
                },
                json: true 
        };
  
        return await new Promise(function(resolve, reject) {      
          request(options, function (error, response, body) {
            if (error) throw new Error(error);
            // console.log(body);
            resolve(body);
          });
      });
      }
    public async impotContactToHubSpot(result): Promise<any>{
      let request = require('request');
      var options = { 
        method: 'POST',
        url: 'https://api.hubapi.com/contacts/v1/contact/',
        qs: { 
              hapikey: process.env.HUBSPOT_API
            },
        headers: 
                {
                  'Content-Type': 'application/json' 
                },
                body: 
                { 
                  properties: 
                    [ 
                      {
                        "property": "email",
                        "value": result.email
                      },
                      {
                        "property": "phone",
                        "value": result.switchPhone
                      },
                      {
                        "property":"firstname",
                        "value": result.firstName
                      },
                      {
                        "property":"lastname",
                        "value": result.lastName
                      },
                      { "property": 'jobtitle', 
                        "value": result.jobPosition 
                      },
                      { 'property': 'product_categorie', 'value': result.productCat.toString() },
                      { 'property': 'product_family', 'value': result.productFamily.toString() },
                    ]
                },
                json: true 
        };
       
        return await new Promise(function(resolve, reject) {
           console.log('*********');
          request(options, function(error, response, body) {
            console.log('body',body);
              if (response.statusCode == 200){
                resolve(body.vid);
              } else {
                console.log('error',error);
                throw new Error(error);
              } 
          });
        });
  
    }
    public async UpdateContactToHubSpot(result, vid): Promise<any>{
      let request = require('request');
      var options = { 
        method: 'POST',
        url: 'https://api.hubapi.com/contacts/v1/contact/vid/'+vid+'/profile',
        qs: { 
              hapikey: process.env.HUBSPOT_API
            },
        headers: 
                {
                  'Content-Type': 'application/json' 
                },
                body: 
                { 
                  properties: 
                  [ 
                    {
                      "property": "email",
                      "value": result.email
                    },
                    {
                      "property": "phone",
                      "value": result.switchPhone
                    },
                    {
                      "property":"firstname",
                      "value": result.firstName
                    },
                    {
                      "property":"lastname",
                      "value": result.lastName
                    },
                    { 
                      "property": 'jobtitle', 
                    "value": result.jobPosition 
                    },
                    { 'property': 'product_categorie', 'value': result.productCat.toString() },
                    { 'property': 'product_family', 'value': result.productFamily.toString() },
                  ]
                },
                json: true 
        };
        
        return await new Promise(function(resolve, reject) {
          console.log('*********');
         request(options, function(error, response, body) {
          if (error) throw new Error(error);
          resolve(body)
         });
       });
  
    }
    public async mergeContactToCompany(contactId, companyId): Promise<any>{
    
    
      // if(companyId == null){
      //   let companyIds = await this.getHubspotCompanyId(channelId);
      //   let contactIds = await this.getHubspotContactId(channelId);
      //   console.log('in merge contact');
      //   console.log(contactId);
      //   console.log(companyId);
      // }
      
      let request = require('request');
      var options = { 
        method: 'PUT',
        url: 'https://api.hubapi.com/companies/v2/companies/'+companyId+'/contacts/'+contactId,
        qs: { 
              hapikey: process.env.HUBSPOT_API
            },
        headers: 
                {
                  'Content-Type': 'application/json' 
                },
                body: 
                {},
                json: true 
        };
        request(options, function(error, response, body) {
            if (error){
              //throw new Error(error);
            } else {
              //console.log('in merge contact');
              // console.log(body);
              
            } 
        });
    }
    public async getContactWithThisEmail(email): Promise<any>{
      let request = require('request');
      var options = { 
        method: 'GET',
        url: 'https://api.hubapi.com/contacts/v1/contact/email/'+email+'/profile',
        qs: { 
              hapikey: process.env.HUBSPOT_API
            }
        };
        return await new Promise(function(resolve, reject) { 
          request(options, function(error, response, body) {
            console.log(response.statusCode);
              if (response.statusCode == 200){
                resolve({response:response.statusCode,data: body});
              } else {
                resolve({response:response.statusCode,data: body});
              }
          });
        });
    }
    public async getCompanyDetails(companyId): Promise<any>{
        
        let request = require('request');
        var options = {
            method: 'GET',
            url: 'https://api.hubapi.com/companies/v2/companies/'+companyId,
            qs: {
                  hapikey: process.env.HUBSPOT_API
                },
            headers:
                    {
                      'Content-Type': 'application/json'
                    },
                    json: true,
            };
            return await new Promise(function(resolve, reject) {
              request(options, function (error, response, body, channelId, companyId){
                if (error){
                  //throw new Error(error);
                } else {
                  //console.log(body);
                  resolve(body);
                } 
              });
            });
    }
    
    public async getCompanyList(url): Promise<any>{
            var request = require("request");

            var options = {
              method: 'GET',
              url: url,
              qs: { limit:100, hapikey: process.env.HUBSPOT_API},
              headers:
              {
                'Content-Type': 'application/json'
              },
              json: true,
      };

            return await new Promise(function(resolve, reject) {
              request(options, function (error, response, body){
                if (error){
                  //throw new Error(error);
                } else {
                  //console.log(body);
                  resolve(body);
                } 
              });
            });

    }
    public getHubspotCompanyId(channelId){
      let query = 'select * FROM "tblChannel" where "channelId" = '+channelId;
      
      return Channel.sequelize.query(query, {
      type: QueryTypes.SELECT,
      raw: true
      }).then(async (results) => {
        // console.log(results) 
         return results;
      });
    }

    public getHubspotContactId(contractId){
      let query = 'select * FROM "tblContact" where "channelId" = '+contractId;
      return Contact.sequelize.query(query, {
      type: QueryTypes.SELECT,
      raw: true
      }).then(async (results) => {
         
         return results;
      });
    }

    public getProductCount(channelId){
      let query = 'SELECT count(*) FROM public."tblProduct" where "channelId" = '+channelId;
      return Product.sequelize.query(query, {
      type: QueryTypes.UPDATE,
      raw: true
      }).then(async (results:any) => {
         
         return results[0][0].count;
      });
    }

    public getInBoundRequest(contactId){
      let query = 'SELECT count(*) as inbound FROM public."tblChannelJCT" as cjct LEFT JOIN "tblChannel" as ch ON ch."channelId" = cjct."partnerChannelId" where cjct."requested_to" = '+contactId + ' AND cjct."connectionStatusTypeId" = \'7\' AND cjct."deletedat" isnull AND ch."deletedAt" isnull';
      
      return ChannelJCT.sequelize.query(query, {
      type: QueryTypes.SELECT,
      raw: true
      }).then(async (results:any) => {
        
         return results[0].inbound;
      });
    }

    public getOutBoundRequest(contactId){
      let query = 'SELECT count(*) as outbound FROM public."tblChannelJCT" as cjct LEFT JOIN "tblChannel" as ch ON ch."channelId" = cjct."partnerChannelId" where cjct."requested_by" = '+contactId + ' AND cjct."connectionStatusTypeId" = \'7\' AND cjct."deletedat" isnull  AND ch."deletedAt" isnull';
      
      return ChannelJCT.sequelize.query(query, {
      type: QueryTypes.SELECT,
      raw: true
      }).then(async (results:any) => {
         
         return results[0].outbound;
      });
    }
    
    public getConfirmedConnnection(channelId){

      let query = 'SELECT count(*)  FROM public."tblChannelJCT" where ("channelId" = '+channelId+' OR "partnerChannelId" = '+channelId+') AND "connectionStatusTypeId" = \'2\' AND "deletedat" isnull';
      
      return ChannelJCT.sequelize.query(query, {
      type: QueryTypes.SELECT,
      raw: true
      }).then(async (results:any) => {
         return results[0].count;
      });
    }

    public getHubspotProperties(userId){

      let query = 'SELECT "loggedAt" FROM "tblUserActivity" where "userId" = '+userId+' AND action =\'LOGIN\' order by "userActivityId" DESC LIMIT 1 ';
       
      
      return ChannelJCT.sequelize.query(query, {
      type: QueryTypes.SELECT,
      raw: true
      }).then(async (results:any) => {
         
        if(results.length != 0){
          
          var timestamp  = results[0].loggedAt;
          var todate=new Date(timestamp).getDate();
          var tomonth=new Date(timestamp).getMonth()+1;
          var toyear=new Date(timestamp).getFullYear();
          var original_date=todate+'/'+tomonth+'/'+toyear;
          
          return original_date;
        } else {
          return null;
        }
      });
    }
/*
    async getHubspotProperties(userId: number): Promise<any>{
		  return await new Promise(function(resolve, reject) {
      let query = 'SELECT "loggedAt" FROM "tblUserActivity" where "userId" = '+userId+' AND action =\'LOGIN\' order by "userActivityId" DESC LIMIT 1 ';
               
                UserActivity.sequelize.query(query, {
                type: Sequelize.QueryTypes.SELECT,
                raw: true
          }).then(async (results) => { 
            resolve(results); 
          });
        });    
    }*/

    async getSubscriptionProperties(channelId: number): Promise<any>{
      return await new Promise(function(resolve, reject) {
      let query = 'select cs."endAt", sp."subscriptionPlanType" from "tblChannelSubscription"  AS cs INNER JOIN "tblSubscription" AS s ON s."subscriptionId" = cs."subscriptionId" INNER JOIN "tblSubscriptionPlan" AS sp ON sp."subscriptionPlanId" = s."subscriptionPlanId" where cs."channelId" = '+channelId+' AND cs."isActive" = \'1\' ';
                
                Channel.sequelize.query(query, {
                type: QueryTypes.SELECT,
                raw: true
          }).then(async (results) => { 
            resolve(results); 
          });
        });    
    }

  public async cronImportCompany(){  
    //   let query = 'select *  from "tblChannel" as ch LEFT JOIN "tblContact" as con ON ch."channelId" = con."channelId" where ch."updatedAt" >=  NOW() - INTERVAL \'25\' DAY 	order by ch."updatedAt" DESC';
    //   //console.log(query);
    //   let channelIds = await Channel.sequelize.query(query, {
    //     type: Sequelize.QueryTypes.SELECT,
    //     raw: true
    //   }).then(async (results) => {
    //    // console.log('++++++++++++++++');
    //     //console.log(results);
    //     results.forEach((data) => {
    //       //console.log(data.channelId);
          
    //       let compny_Details = null;
    //       if(data.hubspotCompanyId ==null){
    //         // create company
    //           compny_Details =  this.createCompany(data);
    //       } else {
    //         console.log('come here');
    //          this.updateCompany(data, data.channelId);
    //       }
    //       if(data.hubspotContactId ==null){
    //         // create company
    //          console.log(compny_Details);
    //          //this.impotContactToHubSpot(data , data.channelId, 25);
    //          console.log('here triggr');
    //          //this.mergeContactToCompany(data.contactId , data.hubspotCompanyId, data.channelId);
    //       } else {
    //         console.log('come here');
    //          //this.updateCompany(data, data.channelId);
    //       }

    //     });
    //     //return results;
    //   });

    //   let intervel = 10000;	// elastic search timeout	
		//   const delay = ms => new Promise(_ => setTimeout(_, ms));

    //   await delay(intervel).then(async () => {
    //   let query1 = 'select *  from "tblChannel" as ch LEFT JOIN "tblContact" as con ON ch."channelId" = con."channelId" where ch."updatedAt" >=  NOW() - INTERVAL \'25\' DAY 	order by ch."updatedAt" DESC';
    //   //console.log(query);
    //   let channelId_in = await Channel.sequelize.query(query1, {
    //     type: Sequelize.QueryTypes.SELECT,
    //     raw: true
    //   }).then(async (results) => {
    //     console.log('************');
        
    //     results.forEach((datas) => {
    //       console.log(datas);
         
    //       if(datas.hubspotContactId !=null){
    //         // create company
             
    //          //this.impotContactToHubSpot(data , data.channelId, 25);
    //          //console.log('here triggr');
    //          this.mergeContactToCompany(datas.hubspotContactId , datas.hubspotCompanyId, datas.channelId);
    //       } 

    //     });
        
    //   });

    // });
  }

}
