'use strict';

import { Module } from '@nestjs/common';
// import { AccountService } from '../modules/account/service/account.service'
import { HubspotController } from './controller/hubspot.controller';
// import { BaseModule } from '../modules/core/module/base.module';
// import { AppAuthMiddleware } from '../middleware/auth/appauth.middleware';

import { UserModule } from '../modules/user/user.module';
// import { DatabaseModule } from '../database/database.module';
import { ChannelModule } from '../modules/channel/channel.module';
// import { HubspotService } from './helper/hubspot.service';
import { DatabaseModule } from 'src/core/database/database.module';
import { AccountService } from 'src/modules/account/service/account.service';
import {oldChannelProvider } from '../modules/channel/provider/channel.provider';
import { EmailerModule } from 'src/modules/emailer/emailer.module';
import { eventProvider } from 'src/modules/channel/provider/event.provider';

@Module({
	controllers: [
		HubspotController
	],
	providers: [
		AccountService,
		...oldChannelProvider,
		...eventProvider
	],
	imports: [
		DatabaseModule,
		UserModule,
		ChannelModule,
		EmailerModule
	],
	exports: [
		AccountService
	],
})
export class HubspotModule {
	// constructor() {
		// super();
	// }

	// configure(consumer: MiddlewaresConsumer): void {
	// 	consumer.apply('').forRoutes(HubspotController);
	// }
}
