import { Module } from '@nestjs/common';
import { ConfigModule, ConfigService } from '@nestjs/config';
import { ClientProxyFactory, Transport } from '@nestjs/microservices';
import { channelMatchingProvider, productMatchingProvider } from './provider/channelJCT.provider';

import { MailerserviceController } from './mailerservice.controller';
import { MailerService } from './mailerservice.service';
import { databaseProviders } from '../core/database/database.providers';

@Module({
  imports: [ConfigModule],
  controllers: [MailerserviceController],
  providers: [
    // {
    //   provide: 'MAIL_SERVICE',
    //   useFactory: (configService: ConfigService) => (
    //     ClientProxyFactory.create({
    //       transport: Transport.TCP,
    //       options: {
    //         host: process.env.MAIL_SERVICE,
    //         port: 9999
    //       }
    //     })
    //   ),
    //   inject: [ConfigService],
    // }
    MailerService, ...channelMatchingProvider, ...productMatchingProvider, ...databaseProviders
  ]
})

export class MailerserviceModule {}
