'use strict';

import { HttpException, HttpStatus } from '@nestjs/common';
import { MessageCodeError } from './MessageCodeError';

export class AuthException extends HttpException {
  public errors = new Array();

  constructor(errors) {
    super(errors, HttpStatus.UNAUTHORIZED);

    this.errors.push({
      property: false,
      errors: [
        new MessageCodeError(errors, HttpStatus.UNAUTHORIZED)
      ]
    });
  }
}
