'use strict';

import { HttpException, HttpStatus } from '@nestjs/common';
import { MessageCodeError } from './MessageCodeError';

export class PaymentException extends HttpException {
	public errors = [];

	constructor(errors) {
		super(errors, HttpStatus.BAD_REQUEST);

		this.errors.push({
			property: false,
			errors: [
				{
					'code': 0, // TODO: Finalize the error code for stripe errors
					'message': errors.message
				}
			]
		});
	}
}
