'use strict';

import { HttpException, HttpStatus } from '@nestjs/common';
import { MessageCodeError } from './MessageCodeError';

export class ProcessException extends HttpException {
	public errors = new Array();

	constructor(errors) {
		super(errors, HttpStatus.BAD_REQUEST);

		this.errors.push({
			property: false,
			errors: [
				new MessageCodeError(errors, HttpStatus.BAD_REQUEST)
			]
		});
	}
}
