'use strict';

import { HttpException, HttpStatus } from '@nestjs/common';
import { MessageCodeError } from './MessageCodeError';

export class UpgradeException extends HttpException {
	public errors = new Array();

	constructor(errors) {
		super(errors, HttpStatus.BAD_REQUEST);

		this.errors.push({
			property: 'SUBSCRIPTION',
			errors: [
				new MessageCodeError('channelHub:channel:upgrade', HttpStatus.BAD_REQUEST)
			]
		});
	}
}
