'use strict';

import { HttpStatus } from '@nestjs/common';
import { IErrorMessages } from './interface/IErrorMessages';

export const account: { [messageCode: string]: IErrorMessages } = {

	'account:emailCheck:notValideEmail': {
		code: 1401,
		message: 'Invalid email'
	},
	"account:singup:fisrtNameMinLeng": {
		code: 1414,
		message: 'First Name Must Have Min 2 Characters'
	},
	"account:singup:fisrtNameMaxLeng": {
		code: 1415,
		message: 'First Name Must Have Max 30 Characters'
	},
	"account:singup:fisrtNameIsNotEmpty": {
		code: 1416,
		message: 'Please Enter First Name'
	},
	"account:singup:firstnameonlyacceptStringOnly": {
		code: 1417,
		message: 'First name should be string'
	},
	"account:singup:lastNameMaxLeng": {
		code: 1419,
		message: 'Last Name Must Have Max 30 Characters'
	},
	"account:singup:lastNameIsNotEmpty": {
		code: 1420,
		message: 'Please Enter Last Name'
	},
	'account:singup:emailIsNotEmpty': {
		code: 1400,
		message: 'Please Enter Email Address'
	},
	'account:singup:emailInvalide': {
		code: 1401,
		message: 'Please Enter a valid Email Address'
	},
	"account:singup:passwordIsNotEmpty": {
		code: 1423,
		message: 'Please Enter Password'
	},
	'account:singup:passwordMinLen': {
		code: 1410,
		message: 'Password Must Have Min 8 Characters.'
	},
	'account:singup:passwordMaxLen': {
		code: 1411,
		message: 'Password Must Have Max 25 Characters'
	},
	'account:singup:passwordMatches': {
		code: 1412,
		message: 'Password must contain 1 Capital, Number & Special Character'
	},
	'account:singup:companyNameMinLeng': {
		code: 1410,
		message: 'Company name must be minimum 2 characters.'
	},
	'account:singup:companynameonlyacceptStringOnly': {
		code: 1410,
		message: 'Company name should be string.'
	},
	'account:singup:companyNameIsNotEmpty': {
		code: 1410,
		message: 'Please Enter Company name.'
	},
	'account:singup:companyAddressIsNotEmpty': {
		code: 1410,
		message: 'Please Enter Address'
	},
	'account:singup:companyAddressMaxLeng': {
		code: 1410,
		message: 'Address Must Have Max 255 Characters.'
	},
	"account:singup:jobPositionMinLeng": {
		code: 1414,
		message: 'Job Position Must Have Min 2 Characters'
	},
	"account:singup:jobPositionIsNotEmpty": {
		code: 1416,
		message: 'Please Enter Job Position'
	},
	"account:singup:cityIsNotEmpty": {
		code: 1416,
		message: 'Please Enter City'
	},
	"account:singup:stateIsNotEmpty": {
		code: 1416,
		message: 'Please Enter State'
	},
	"account:singup:countryIdIsNotEmpty": {
		code: 1416,
		message: 'Please Enter countryId'
	},
	"account:singup:countryIdonlyacceptInt": {
		code: 1416,
		message: 'countryId Should be number'
	},
	"account:singup:postalcodeIsNotEmpty": {
		code: 1416,
		message: 'Please Enter Postal Code'
	},
	"account:singup:postalcodeMinLen": {
		code: 1416,
		message: 'Postal Code Must Have Min 3 Characters'
	},
	"account:singup:postalcodeMaxLen": {
		code: 1416,
		message: 'Postal Code Must Have Max 12 Characters'
	},
	"account:singup:websiteurlIsNotEmpty": {
		code: 1416,
		message: 'Please Enter Company Website URL'
	},
	"account:singup:mobileIsNotEmpty": {
		code: 1416,
		message: 'Please Enter Phone No'
	},
	"account:singup:mobileMinLen": {
		code: 1416,
		message: 'Phone No Must Have Min 4 Numbers'
	},
	"account:singup:mobileMaxLen": {
		code: 1416,
		message: 'Phone No Must Have Max 20 Numbers'
	},



	'account:forgotPassword:invalidUser': {
		code: 1402,
		message: 'Entered mail id is incorrect.'
	},
	'account:resetPassword:notFound': {
		code: 1403,
		message: 'Token not found.'
	},
	'account:resetPassword:tokenExpired': {
		code: 1404,
		message: 'Token expired.'
	},
	'account:resetPassword:userNotFound': {
		code: 1405,
		message: 'User not found'
	},
	'account:login:emailInvalid': {
		code: 1406,
		message: 'Invalid email'
	},
	'account:login:emailIsNotEmpty': {
		code: 1407,
		message: 'Email is missing.'
	},
	'account:login:emailMinLen': {
		code: 1408,
		message: 'Email is too short.'
	},
	'account:login:emailMaxLen': {
		code: 1409,
		message: 'Email is too long'
	},

	'account:singup:emailAleradytaken': {
		code: 1413,
		message: 'Given mail id already exist'
	},





	"account:singup:countryonlyacceptInt": {
		code: 1424,
		message: 'Country only accept integer'
	},
	'account:resendmail:usernotfound': {
		code: 1425,
		message: 'Given user not fount in portal'
	},
	'account:signupverify:tokenexpired': {
		code: 1426,
		message: 'SignUp verification token expired'
	},
	'account:signupverify:invalideToken': {
		code: 1427,
		message: 'SignUp verification token invalid'
	},
	'account:signupverify:alreadyverify': {
		code: 1428,
		message: 'User already verified'
	},
	'account:role:NotEmpty': {
		code: 1429,
		message: 'Role should not be empty'
	},
	'account:role:shouldBeInt': {
		code: 1430,
		message: 'Role should be an integer'
	},
	'account:userCheck:userIdIsNotEmpty': {
		code: 1431,
		message: 'User id should not be empty'
	},
	'account:userCheck:userIdIsNumber': {
		code: 1432,
		message: 'User id should be number'
	},
	'account:userCheck:passwordIsNotEmpty': {
		code: 1433,
		message: 'Current user password should not be an empty'
	},
	'account:userCheck:currentPasswordIsNotEmpty': {
		code: 1434,
		message: 'Current user current password should not be an empty'
	},
	'account:alreadyActivated': {
		code: 1435,
		message: 'Account already activated'
	},
	'account:changeContactMail:emailNotFound': {
		code: 1403,
		message: 'User not found.'
	}

};
