'use strict';

import { HttpStatus } from '@nestjs/common';
import { IErrorMessages } from './interface/IErrorMessages';

export const auth: { [messageCode: string]: IErrorMessages } = {
	'auth:refreshtoken:missingRefreshtoken': {
		code: 1200,
		message: 'Refresh token not found.',
	},
	'auth:refreshtoken:refreshtokenInvalid': {
		code: 1201,
		message: 'Invalid refresh token.'
	},
	'auth:refreshtoken:userNotfound': {
		code: 1202,
		message: 'User not found.'
	},
	'auth:authorisation:clientKeyIsNotEmpty': {
		code: 1203,
		message: 'Client Key is missing.'
	},
	'auth:authorisation:secretKeyIsNotEmpty': {
		code: 1204,
		message: 'Secret Key is missing.'
	},
	'auth:app:secretKeyMismatch': {
		code: 1205,
		message: 'Secret and Token Keys are mismatching.'
	},
	'auth:login:missingInformation': {
		code: 1206,
		message: 'Login information is missing.'
	},
	'auth:login:missingEmail': {
		code: 1207,
		message: 'Email is missing.'
	},
	'auth:login:missingPassword': {
		code: 1208,
		message: 'Password is missing.'
	},
	'auth:user:notFound': {
		code: 1209,
		message: 'Please check your email and password.'
	},
	'common:input:constraint': {
		code: 1210,
		message: 'Input fields given is worng.'
	},
	'auth:singup:fisrtNameMinLeng': {
		code: 1211,
		message: 'Input fields given is worng.'
	},
	'auth:singup:fisrtNameMaxLeng': {
		code: 1212,
		message: 'Input fields given is worng.'
	},
	'auth:singup:fisrtNameIsNotEmpty': {
		code: 1213,
		message: 'Input fields given is worng.'
	},
	'auth:singup:firstnameonlyacceptStringOnly': {
		code: 1214,
		message: 'Input fields given is worng.'
	},
	'auth:singup:lastNameMinLeng': {
		code: 1215,
		message: 'Input fields given is worng.'
	},
	'auth:channel:inActive': {
		code: 1215,
		message: 'Channel Should be in active to login'
	},
	'auth:user:inActive': {
		code: 1215,
		message: 'User Should be in active to login'
	}
};
