'use strict';

import { HttpStatus } from '@nestjs/common';
import { IErrorMessages } from './interface/IErrorMessages';

export const media: { [messageCode: string]: IErrorMessages } = {
    'media:documentType:shouldBeUnique': {
        code: 1500,
        message: 'documentType should be unique',
    },
    'media:documentType:shouldNotEmpty': {
        code: 1501,
        message: 'documentType should not empty',
    },
    'media:documentType:shouldBeString': {
        code: 1502,
        message: 'documentType should be a string',
    },
    'media:documentType:maxLength': {
        code: 1503,
        message: 'documentType max length should be 30',
    },
    'media:documentTypeId:notFound': {
        code: 1504,
        message: 'documentType not found',
    },
    'media:path:shouldNotEmpty': {
        code: 1505,
        message: 'media path should not be empty',
    },
    'media:documentTypeId:shouldNotEmpty': {
        code: 1506,
        message: 'documentTypeId should not be empty',
    },
    'media:documentTypeId:shouldBeNumber': {
        code: 1507,
        message: 'documentTypeId should be a number',
    },
    'media:documentId:notFound': {
        code: 1508,
        message: 'document not found',
    },
    'media:not:moveable': {
        code: 1509,
        message: 'Document not found in public bucket or temp error while moving to s3 bucket',
    },
    'media:not:updatable': {
        code: 1510,
        message: 'Document should not be updatable',
    }
};
