'use strict';

import { HttpStatus } from '@nestjs/common';
import { IErrorMessages } from './interface/IErrorMessages';

export const order: { [messageCode: string]: IErrorMessages } = {
    'order:orderFilter:statusIsArray': {
        code: 7000,
        message: 'Order status should be an array'
    },
    'order:orderFilter:statusArrayNotEmpty': {
        code: 7001,
        message: 'Order status should be not an empty array'
    },
    'order:orderInfo:notFound': {
        code: 7002,
        message: 'Order Information not found'
    },
    'order:orderStatusChange:sampleorderidIsArray': {
        code: 7003,
        message: 'Order id should be an array'
    },
    'order:orderStatusChange:sampleorderidArrayNotEmpty': {
        code: 7004,
        message: 'Order id should be not an empty array'
    },
    'order:orderFilter:statusIsNotEmpty': {
        code: 7005,
        message: 'Order status should be not an empty'
    },
    'order:orderstatus:orderInSameStatus': {
        code: 7006,
        message: 'Order status is same'
    },
    'order:orderstatus:notFound': {
        code: 7007,
        message: 'Order not found'
    },
    'order:orderstatus:orderCannotCanceled': {
        code: 7008,
        message: 'Order already packed cannot be canceled'
    },
    'order:orderShipment:sampleorderidIsNotEmpty': {
        code: 7009,
        message: 'Order id should be not an empty'
    },
    'order:orderShipment:sampleorderidIsNumber': {
        code: 7010,
        message: 'Order id should be number'
    },
    'order:orderShipment:statusIsNotEmpty': {
        code: 7011,
        message: 'Order status should be an empty'
    },
    'order:orderShipment:statusIsNumber': {
        code: 7012,
        message: 'Order status should be number'
    },
    'order:orderShipment:nameIsNotEmpty': {
        code: 7013,
        message: 'Shipment name should be not empty'
    },
    'order:orderShipment:nameIsString': {
        code: 7014,
        message: 'Shipment name should be string'
    },
    'order:orderShipment:nameInMinLen': {
        code: 7015,
        message: 'Shipment name invalid minimum length'
    },
    'order:orderShipment:nameInMaxLen': {
        code: 7016,
        message: 'Shipment name invalid maximum length'
    },
    'order:orderShipment:trackingnoIsNotEmpty': {
        code: 7017,
        message: 'Shipment tracking no should be not empty'
    },
    'order:orderShipment:trackingnoIsString': {
        code: 7018,
        message: 'Shipment tracking no should be string'
    },
    'order:orderShipment:trackingnoInMinLen': {
        code: 7019,
        message: 'Shipment tracking no invalid minimum length'
    },
    'order:orderShipment:trackingnoInMaxLen': {
        code: 7020,
        message: 'Shipment tracking no invalid maximum length'
    },
    'order:orderShipment:trackingurlIsNotEmpty': {
        code: 7020,
        message: 'Shipment tracking url should be not empty'
    },
    'order:orderShipment:trackingurlIsString': {
        code: 7021,
        message: 'Shipment tracking url should be string'
    },
    'order:orderShipment:trackingurlInMinLen': {
        code: 7022,
        message: 'Shipment tracking url invalid minimum length'
    },
    'order:orderShipment:trackingurlInMaxLen': {
        code: 7022,
        message: 'Shipment tracking url invalid maximum length'
    },
    'order:orderShipment:commentsIsNotEmpty': {
        code: 7023,
        message: 'Shipment comments should be not empty'
    },
    'order:orderShipment:commentsIsString': {
        code: 7024,
        message: 'Shipment comments should string'
    },
    'order:orderShipment:commentsInMinLen': {
        code: 7025,
        message: 'Shipment comments invalid minimum length'
    },
    'order:orderShipment:commentsInMaxLen': {
        code: 7026,
        message: 'Shipment comments invalid maximum length'
    },
    'order:orderUpdate:sampleorderidIsNotEmpty': {
        code: 7027,
        message: 'Order id should be not empty'
    },
    'order:orderUpdate:sampleorderidIsNumber': {
        code: 7028,
        message: 'Order id should be number'
    },
    'order:orderUpdate:shipingpriceIsNotEmpty': {
        code: 7029,
        message: 'Shipping price should be not empty'
    },
    'order:orderUpdate:shipingpriceIsNumber': {
        code: 7030,
        message: 'Shipping price should be number'
    },
    'order:orderUpdate:discountIsNotEmpty': {
        code: 7031,
        message: 'Discount should be not empty'
    },
    'order:orderUpdate:discountIsNumber': {
        code: 7032,
        message: 'Discount should be number'
    },
    'order:orderUpdate:discountunitidIsNotEmpty': {
        code: 7033,
        message: 'Discount unit should be not empty'
    },
    'order:orderUpdate:discountunitidIsNumber': {
        code: 7034,
        message: 'Discount unit should be number'
    },
    'order:orderUpdate:otherchargeIsNotEmpty': {
        code: 7035,
        message: 'Other charge should be not empty'
    },
    'order:orderUpdate:otherchargeIsNumber': {
        code: 7036,
        message: 'Other charge should be number'
    },
    'order:orderUpdate:orderDetailArrayNotEmpty': {
        code: 7037,
        message: 'Order detail should be not an empty array'
    },
    'order:orderUpdate:orderDetailIsArray': {
        code: 7038,
        message: 'Order detail should be an array'
    },
    'order:orderUpdate:deletedproductIsNotEmpty': {
        code: 7039,
        message: 'Deleted ordered product should be not empty'
    },
    'order:orderDetailUpdate:finalquantityIsNotEmpty': {
        code: 7040,
        message: 'Final quantity should be not empty'
    },
    'order:orderDetailUpdate:finalquantityIsNumber': {
        code: 7041,
        message: 'Final quantity should be number'
    },
    'order:order:invalidOrderStatus': {
        code: 7042,
        message: 'Invalid order status'
    }
};
