'use strict';

import { HttpStatus } from '@nestjs/common';
import { IErrorMessages } from './interface/IErrorMessages';

export const product: { [messageCode: string]: IErrorMessages } = {
	'product:productFilter:brandIsArray': {
		code: 2000,
		message: 'Brand should be array',
	},
	'product:productFilter:brandArrayNotEmpty': {
		code: 2001,
		message: 'Brand should not be empty array',
	},
	'product:productFilter:productGroupIsArray': {
		code: 2002,
		message: 'Product Group should be array',
	},
	'product:productFilter:productGroupArrayNotEmpty': {
		code: 2003,
		message: 'Product Group should not be empty array',
	},
	'product:productFilter:productCategoryIsArray': {
		code: 2004,
		message: 'Product Category should be array',
	},
	'product:productFilter:productCategoryArrayNotEmpty': {
		code: 2005,
		message: 'Product Category should not be empty array',
	},
	'product:productFilter:isActiveIsNotEmpty': {
		code: 2006,
		message: 'Is Active should not be empty',
	},
	'product:productFilter:isActiveIsBoolean': {
		code: 2007,
		message: 'Is Active should be boolean',
	},
	'product:productFilter:productQualityLevelTypeIsEnum': {
		code: 2008,
		message: 'Position should be Entry or Mid or High',
	},
	'product:productFilter:excludedProductSkuIsArray': {
		code: 2009,
		message: 'Product sku should not be empty array',
	},
	'product:productFilter:excludedProductSkuArrayNotEmpty': {
		code: 2010,
		message: 'Product sku should not be empty',
	},
	'product:productFilter:channelIdIsNumber': {
		code: 2011,
		message: 'ChannelId should be number',
	},
	'product:productImport:zeroRows': {
		code: 2012,
		message: 'Empty worksheet data',
	},
	'product:productImport:fileName': {
		code: 2013,
		message: 'FileName and ImageFolder should not empty',
	},
	'product:productImport:imageFolderName': {
		code: 2013,
		message: 'Image Folder Name and Image Folder should not empty',
	},
	'product:reject:rejectedProduct': {
		code: 2014,
		message: 'Rejected Product',
	},
	'product:channel:stripeIdRequired': {
		code: 2015,
		message: "Please add Stripe connect Id in Settings"
	},
	'product:productImport:invalidFileFormat': {
		code: 2016,
		message: 'Invalid File format',
	},
	'product:companyAwardIdIsNumber': {
		code: 2017,
		message: 'message: "product:companyAwardIdIsNumber"'
	},
	'product:companyAwardDetailsIsNotEmpty': {
		code: 2018,
		message: 'message: "product:companyAwardDetailsIsNotEmpty"'
	},
	'product:companyAwardIssuedByIsNotEmpty': {
		code: 2019,
		message: 'message: "product:companyAwardIssuedByIsNotEmpty"'
	},
	'product:companyAwardValidUptoIsNotEmpty': {
		code: 2020,
		message: 'message: "product:companyAwardValidUptoIsNotEmpty"'
	},
};
