'use strict';

import { HttpStatus } from '@nestjs/common';
import { IErrorMessages } from './interface/IErrorMessages';

export const validate: { [messageCode: string]: IErrorMessages } = {
	'validate:field:shouldNotEmpty': {
		code: 1800,
		message: 'This property should not be empty'
	},
	'validate:field:shouldBeInt': {
		code: 1801,
		message: 'This property should be an integer'
	},
	'validate:field:shouldBeString': {
		code: 1802,
		message: 'This property should be an string'
	},
	'validate:field:shouldBeBoolean': {
		code: 1803,
		message: 'This property should be an boolean'
	},
	'validate:field:shouldBeUrl': {
		code: 1804,
		message: 'This property should be an url'
	},
	'validate:field:validateMinLength': {
		code: 1805,
		message: 'This property not meet the min length condition'
	},
	'validate:field:validateMaxLength': {
		code: 1806,
		message: 'This property not meet the max length condition'
	},
	'validate:field:shouldBeValidEmail': {
		code: 1807,
		message: 'This property be a valid email'
	},
	'validate:field:shouldBeUnique': {
		code: 1808,
		message: 'This property should be unique'
	},
	'validate:field:notFound': {
		code: 1809,
		message: 'Record not found'
	},
	'validate:field:shouldBeArray': {
		code: 1810,
		message: 'This property should be array'
	},
	'validate:field:statusIsBoolean': {
		code: 1811,
		message: 'This property should be boolean'
	},
	'validate:sql:internalError': {
		code: 1812,
		message: 'Internal Error'
	},
	'validate:field:shouldBeDateString': {
		code: 1813,
		message: 'This property should be an date'
	},
	'validate:field:shouldBeEmptyArray': {
		code: 1814,
		message: 'This property should not be empty array'
	},
	'validate:field:notValideFileOrSheet': {
		code: 1815,
		message: 'Not a valid File Excel file or Sheets'
	},
	'validate:field:notValidSlugName':{
		code: 1816,
		message: "Not a valid Slug Name"		
	},
	'validate:field:shouldBeNumber': {
		code: 1817,
		message: 'This property should be an number'
	},
	'validate:field:notValidObject': {
		code: 1818,
		message: 'Not valid Object'
	}
};
