import { IsEmail, IsNotEmpty, MinLength, MaxLength } from 'class-validator';

export class ForgotPasswordDto {

	@IsEmail({}, { message: "account:login:emailInvalid" })
	@IsNotEmpty({ message: "account:login:emailIsNotEmpty" })
	@MinLength(5, { message: "account:login:emailMinLen" })
	@MaxLength(254, { message: "account:login:emailMaxLen" })
	email: string;

}
