import { IsNotEmpty, MinLength, MaxLength, Matches } from 'class-validator';

export class ResetPasswordBoDto {

	@IsNotEmpty({ message: "account:login:passwordIsNotEmpty" })
	@MinLength(8, { message: "account:login:passwordMinLen" })
	@MaxLength(25, { message: "account:login:passwordMaxLen" })
	@Matches(RegExp("^(?=.*?[A-Z])(?=.*?[a-z])(?=.*?[0-9])(?=.*?[#?!@$%^&*-]).{8,25}$"), { message: "account:login:passwordMatches" })
	password: string;

	@IsNotEmpty({message: "account:channelIdIsNotId"})
	channelId: number;

	@IsNotEmpty({message: "account:userIdIsNotId"})
	userId: number;

	@IsNotEmpty({message: "account:contactIdIsNotId"})
	contactId: number;



}
