import { PipeTransform, Injectable, ArgumentMetadata } from '@nestjs/common';
import { ProcessException } from './../../../middleware/exception/Process.exception';

@Injectable()
export class CheckEmailPipe implements PipeTransform<string> {

	async transform(value: string, metadata: ArgumentMetadata) {
		var EMAIL_REGEXP = /^[a-z0-9!#$%&'*+\/=?^_`{|}~.-]+@[a-z0-9]([a-z0-9-]*[a-z0-9])?(\.[a-z0-9]([a-z0-9-]*[a-z0-9])?)*$/i;
		if (value != "" && !EMAIL_REGEXP.test(value)) {
			throw new ProcessException('account:emailCheck:notValideEmail');
		}
		return value;
	}

}
