//import { BaseTransformation } from "../../../core/transformation/BaseTransformation";
import { ProcessException } from '../../../../middleware/exception/Process.exception';
import { SignupDto } from '../../dto/signup.dto';
import { User } from '../../../user/models/User.entity';
import { Contact } from '../../../user/models/Contact.entity';

export interface IAccountSerivceInBound {


    /**
    * @description: user sign Up obejct return .
    * @param {user: User}
    * @return {Promise<IUserToken>}
    */
	setPayload(user: User): Promise<IUserToken>

    /**
    * @description: user sign Up obejct return .
    * @param { user: SignupDto }
    * @param { pin:string }
    * @param { signUpStatus:number }
    * @return {Promise<ILoginResponse>}
    */
	setSignUpObject(user: SignupDto, pin: string, signUpStatus: number): Promise<User>;

    /**
    * @description: user sign Up obejct return .
    * @param { email: string }
    * @param { pin:string }
    * @return {Promise<IMailObject>}
    */
	setMailObject(user: string, pin: string): Promise<IMailObject>;

}

export interface IUserToken {
	id: number;
	email: string,
	channelId: number,
	contactId: number,
	tokenModifiedAt: any
}

export interface IMailObject {
	email: string,
	pin: string,
	tokenExpires: number
}
