'use strict';

import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, ForeignKey } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { User } from '../../user/models/User.entity';

const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblNonUserActivity' } as IDefineOptions;

@Table(tableOptions)
export class NonUserActivity extends Model<NonUserActivity>
{
	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	userActivityId: number

	
	@Column(DataType.CHAR(255))
    userID: string
    
    @Column(DataType.CHAR(255))
    action: string

    @AllowNull(true)
	@Column(DataType.DATE)
	loggedAt: Date

	@Column(DataType.CHAR(64))
    ipaddress: string
    
	@Column(DataType.TEXT)
    deviceInfo: string
    
    @Column(DataType.TEXT)
	otherInfo: string
}
