'use strict';

import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, ForeignKey } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { User } from '../../user/models/User.entity';

const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblUserActivity' } as IDefineOptions;

@Table(tableOptions)
export class UserActivity extends Model<UserActivity>
{
	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	userActivityId: number

	@ForeignKey(() => User)
	@Column(DataType.BIGINT)
    userId: number
    
    @Column(DataType.CHAR(255))
    action: string

    @Column(DataType.CHAR(255))
    token: string

    @AllowNull(true)
	@Column(DataType.DATE)
	loggedAt: Date

	@Column(DataType.CHAR(64))
    ipaddress: string
    
	@Column(DataType.TEXT)
    deviceInfo: string
    
    @Column(DataType.TEXT)
	otherInfo: string
}
