'use strict';

import {Injectable, Inject} from '@nestjs/common';
import { UserActivity } from '../models/UserActivity.entity';
import { NonUserActivity } from '../models/NonUserActivity.entity';
import { ContextService } from '../../../context/context.service';
import { Sequelize } from 'sequelize-typescript';
import { Channel } from '../../channel/models/Channel.entity';

@Injectable()
export class ActivityService {
    constructor(
        private context: ContextService,
        @Inject('UserActivityRepository') private readonly userActivityRepository: typeof UserActivity,
        @Inject('NonUserActivityRepository') private readonly nonUserActivityRepository: typeof NonUserActivity,
    ) {}

    async UserLogActivity(action: string, token: string, req: any, otherInfo: any = null) {
        // let user = this.context.get('user');
        var parser = require('ua-parser-js');
        
        let logActivity: any = {};
        logActivity.userId = 1761;
        logActivity.action = action;
        logActivity.token = token;
        logActivity.loggedAt = Sequelize.fn('NOW');
        logActivity.ipaddress = req.ip;
        logActivity.deviceInfo = JSON.stringify(parser(req.headers['user-agent']), null, '  ');
        logActivity.otherInfo = otherInfo; 

        //console.log(logActivity);
        
        this.userActivityRepository.create(logActivity).then(() => {
            console.log('saving... user log');
            // if(action === 'LOGIN' && user.channel && +user.channel.channelTypeId != Channel.CHANNEL_TYPE_HUB) {
            
            // }
            // if (action === 'LOGIN' && user.contact.channel && +user.contact.channel.channelTypeId != Channel.CHANNEL_TYPE_HUB) {
            //     console.log('Last Login update on every login');
            // }
        });
    }

    async NonUserLogActivity(action: string, userId: string, req: any, otherInfo: any = null) {
        // let user = this.context.get('user');
        var parser = require('ua-parser-js');
        
        let logActivity: any = {};
        logActivity.userID = userId;

        if(otherInfo == 1)
            action = "User Details"
        else if(otherInfo == 2)
            action = "Company Details"
        else if(otherInfo == 3)
            action = "Verify OTP"
        else if (otherInfo == 4)
            action = "Confirm Password"

        logActivity.action = action;
        logActivity.loggedAt = Sequelize.fn('NOW');
        logActivity.ipaddress = req.ip;
        logActivity.deviceInfo = JSON.stringify(parser(req.headers['user-agent']), null, '  ');
        logActivity.otherInfo = otherInfo; 

        //console.log(logActivity);
        

        this.nonUserActivityRepository.findOrCreate({where: {userID : logActivity.userID}, defaults: logActivity}).then((result) => {
            //console.log('saving...', result[0], result[1]);  
            
            if(!result[1]){
                result[0].update(logActivity).then((result) => {
                    console.log('Updated...')
                })
            }
            else{
                console.log('created');
            }



            // if(action === 'LOGIN' && user.channel && +user.channel.channelTypeId != Channel.CHANNEL_TYPE_HUB) {
            
            // }
            // if (action === 'LOGIN' && user.contact.channel && +user.contact.channel.channelTypeId != Channel.CHANNEL_TYPE_HUB) {
            //     console.log('Last Login update on every login');
            // }
        });
    }

}