import { Controller, Post, Request, Patch, Response, Body, HttpStatus, Get, UseGuards, Param, ValidationPipe } from '@nestjs/common';
import { AuthGuard } from '@nestjs/passport';
import { AdminService } from '../service/admin.service';

//@UseGuards(AuthGuard('jwt'))
@Controller('admin')
export class AdminController {

    constructor(				        
        private readonly adminService: AdminService
    ) {}

    @Post('userListing')	
    public async userListing(@Request() req, @Response() res,@Body() data: any) {		

        let result = await this.adminService.userListing(data);
         if (result) {
            res.status(HttpStatus.OK).json(result);
         } else {
              //throw new ProcessException("notification:presetmail:listNotfound");
          }
    }

    @Patch('updateContact/:contactId')
    public async updateContact(@Body(new ValidationPipe()) data: any, @Response() res, @Request() req, @Param('contactId') contactId) {

        let result = await this.adminService.updateContact(contactId, data);

        res.status(HttpStatus.OK).send({
            result: result
        });
    }

    @Post('userCountry')	
    public async userCountry(@Request() req, @Response() res,@Body() data: any) {		

        let result = await this.adminService.userCountries();
         if (result) {
            res.status(HttpStatus.OK).json(result);
         } else {
              //throw new ProcessException("notification:presetmail:listNotfound");
          }
    }

    @Get('searchList')	
    public async searchList(@Request() req, @Response() res,@Body() data: any) {		
        let result = await this.adminService.searchList();
         if (result) {
            res.status(HttpStatus.OK).json(result);
         } else {
              //throw new ProcessException("notification:presetmail:listNotfound");
          }
    }

    @Get('menuListing/:accessId')	
    public async menuListing(@Param('accessId') accessId,@Request() req, @Response() res) {		

        let result = await this.adminService.menuListing(accessId);
         if (result) {
            res.status(HttpStatus.OK).json(result);
         } else {
              //throw new ProcessException("notification:presetmail:listNotfound");
          }
    }
}
