'use strict';

import { Table, Column, Model, DataType, ForeignKey, BelongsTo, BeforeCreate, BeforeUpdate, AutoIncrement, PrimaryKey, AllowNull } from 'sequelize-typescript';
import { AdminUsers } from './AdminUsers.entity';
import { AdminMenu } from './AdminMenu.entity';

var Sequelize = require('sequelize');

@Table({
	tableName: "tblAdminUserAccess"
})
export class AdminUserAccess extends Model<AdminUserAccess>{
	
	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
    adminUserAccessId: number	
	
	@Column(DataType.BIGINT)
	accessId: number

	@ForeignKey(() => AdminMenu)
	@Column(DataType.BIGINT)
	moduleId: number

	@BelongsTo(() => AdminMenu)
    moduleid: AdminMenu;
    
    @Column(DataType.BIGINT)
    allowView: number;

    @Column(DataType.BIGINT)
    allowModify: number;

    @Column(DataType.BIGINT)
    allowDelete: number;

	@Column(DataType.DATE)
	createdAt: Date;

	@Column(DataType.DATE)
    updatedAt: Date;
        

	@BeforeCreate 
	@BeforeUpdate 
	public static async dateUpdate(adminUserAccess: AdminUserAccess, options: any) { 
		adminUserAccess.updatedAt = Sequelize.fn('NOW'); 
	}
}
