import {Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, ForeignKey, HasOne, HasMany, Scopes, BelongsTo, BelongsToMany, AfterUpdate, AfterBulkUpdate } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Country } from './../../common/models/Country.entity';

const tableOptions: IDefineOptions = { tableName: 'tblAdminUserCountries' } as IDefineOptions;

@Table(tableOptions)

@Scopes(() => ({
	//Used

}))

export class AdminUserCountries extends Model<AdminUserCountries>{
	
	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	managedCountryId: number
	
	@Column(DataType.BIGINT)
	adminUserId: number;

    @ForeignKey(() => Country)
	@Column(DataType.BIGINT)
	countryId: number

	@BelongsTo(() => Country)
	countryid: Country;

	}
