import { IsString, IsNotEmpty, IsOptional } from 'class-validator';
import { ApiProperty } from '@nestjs/swagger';

export class AppAuthorisationDto {

    @IsNotEmpty({ message: "auth:authorisation:secretKeyIsNotEmpty" })
    @ApiProperty()
    readonly secretKey: string;

    @IsNotEmpty({ message: "auth:authorisation:clientKeyIsNotEmpty" })
    @ApiProperty()
    readonly clientKey: string;

    @IsOptional()
    @ApiProperty()
    isAdmin: boolean;
}