import { Strategy } from 'passport-local';
import { PassportStrategy } from '@nestjs/passport';
import { Injectable, UnauthorizedException } from '@nestjs/common';
import { AuthService } from './service/auth/auth.service';

@Injectable()
export class LocalStrategy extends PassportStrategy(Strategy) {
    constructor(private readonly authService: AuthService) {
        super();
    }

    async validate(username: string, password: string): Promise<any>{

        //console.log("vallidate:",password.substring(password.lastIndexOf('-')));
        let userType=password.substring(password.lastIndexOf('-'));

        password=password.substring(0,password.lastIndexOf('-'));
        //console.log("password:",password);
        var user = await this.authService.validateUser(username, password,userType);
        
        let userData = {};
        userData = { 
            userId: user.userId,
            contactId: user.contactId,
            channelId: user.channelId,
            email: user.email,
            isActive: user.isActive,
            planId: user.channel?.planId,
            showId:user.channel?.showId,
            signUpStatusId: user.channel?.signUpStatusId,
            channelTypeId: user.channel?.channelTypeId,
            profileTypeId: user.channel?.profileTypeId,
            businessType:+user.channel?.isOEM,
            lastLogin: user.lastLogin,
            isAlgorithm:user.isAlgorithm,
            firstName: user.contact?.firstName,
            lastName: user.contact?.lastName,
            document: user.contact?.document?user.contact.document:{},
            channel: user.channel,
            roleId: user.role?.roleId,
            suggestion_comm: user.suggestion_comm,
        };

        if(user.hasOwnProperty('adminUserId'))
            userData = Object.assign(userData, {adminUserId: user.adminUserId,firstName:user.fName,lastName:user.lName,accessId:user.accessId})
        
        if(user.hasOwnProperty('userId'))
            userData = Object.assign(userData, {userId: user.userId})

        if (!userData) {
         throw new UnauthorizedException('Invalid user credentials');
        }
        //console.log('userData', userData);
        return userData;
    }
}
