'use strict';

import { Module } from '@nestjs/common';
import { DatabaseModule } from 'src/core/database/database.module';
import { ProductModule } from './../product/product.module';
import { IndexController } from './controller/index.controller';
import { cartProvider, productQuoteProvider } from './provider/cart.provider';
import { CartService } from './service/cart.service';

@Module({
	imports: [
		ProductModule,
		DatabaseModule
	],
	controllers: [
		IndexController
	],
	providers: [
		...cartProvider,
		...productQuoteProvider,
		CartService
	],
	exports: [
		...cartProvider
	]
})
export class CartModule  { }
