'use strict';

import { IsEnum, IsNotEmpty, MaxLength, IsString, IsOptional, IsInt, IsBoolean } from 'class-validator';

export class AddToCartProductDto {

	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsInt({ message: "validate:field:shouldBeInt" })
	readonly id: number;

	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsInt({ message: "validate:field:shouldBeInt" })
	readonly quantity: number;

	@IsOptional()
	@IsString({ message: "validate:field:shouldBeString" })
	readonly action: string;

}
