'use strict';

import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, BelongsTo, BeforeCreate, BeforeUpdate } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Cart } from './Cart.entity';
import { Product } from './../../product/models/Product.entity';
var Sequelize = require('sequelize');

const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblproductquote' } as IDefineOptions;

@Table(tableOptions)
export class ProductQuote extends Model<ProductQuote>
{
	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	productquoteid: number

	@AllowNull(false)
	@Column(DataType.BIGINT)
	cartid: number

	@BelongsTo(() => Cart, 'cartid')
	cart: Cart

	@AllowNull(false)
	@Column(DataType.BIGINT)
	productid: number

	@BelongsTo(() => Product, 'productid')
	product: Product

	@AllowNull(false)
	@Column(DataType.BIGINT)
	quantity: number

	@Column(DataType.DECIMAL(15, 2))
	unitprice: number

	@Column(DataType.DATE)
	deletedat: Date;

	@AllowNull(false)
	@Column(DataType.DATE)
	createdat: Date;

	@Column(DataType.DATE)
	updatedat: Date;

	@BeforeCreate 
	@BeforeUpdate 
	public static async dateUpdate(productQuote: ProductQuote, options: any) { 
		productQuote.updatedat = Sequelize.fn('NOW'); 
	}
}
