'use strict';

import { Controller,Inject, Post, Get,Put, HttpStatus, Request, Response, Param, Query, Body, UsePipes, InternalServerErrorException, UseGuards, ValidationPipe } from '@nestjs/common';
import { AuthGuard } from '@nestjs/passport';
import { BaseController } from 'src/core';
import { ProcessException } from 'src/middleware/exception/Process.exception';
import { ChannelService } from '../service/channel.service';
import { TradeLocationService } from '../service/tradeLocation.service';

@UseGuards(AuthGuard('jwt'))
@Controller('')
export class TradeLocationController extends BaseController {
	constructor(
		private tradeLocationService: TradeLocationService,
		private channelService: ChannelService,
		@Inject('SequelizeInstance') private readonly sequelizeInstance,
	) {
		super();
	}

	// async _validateTradeLocationProfile() {
	// 	let currentUserPermissions = this.context.get('dataSession').permissions;
	// 	let currentUserRole = this.context.get('dataSession').role;

	// 	if (currentUserRole.roleId != Role.ROLE_ACCOUNT_USER) {
	// 		if (!currentUserPermissions.includes(permissions.PROFILE_TRADE_LOCATION_UPDATE)) {
	// 			throw new AuthException('Not allowed');
	// 		}
	// 	}
	// }

	// @Post('regionCountry')
	// public async regionCountry(@Body(new ValidationPipe()) regionCountryDto: RegionCountryDto, @Request() req, @Response() res) {
	// 	let user = req.user;
	// 	let showAll = false;
	// 	if (req.query.showall == 'true') {
	// 		showAll = true;
	// 	}

	// 	let regionCountryList = await this.tradeLocationService.getRegionCountry(regionCountryDto, user, showAll);
	// 	return res.status(HttpStatus.OK).send(regionCountryList);
	// }

	// @Post('searchRegion')
	// public async searchRegion(@Body(new ValidationPipe()) searchRegionDto: SearchRegionDto, @Request() req, @Response() res) {
	// 	let user = req.user;
	// 	let searchRegion = await this.tradeLocationService.searchRegion(searchRegionDto, user);
	// 	return res.status(HttpStatus.OK).send(searchRegion);
	// }

	// @Post('searchCountry')
	// public async searchCountry(@Body(new ValidationPipe()) searchCountryDto: SearchCountryDto, @Request() req, @Response() res) {
	// 	let user = req.user;
	// 	let searchRegion = await this.tradeLocationService.searchCountry(searchCountryDto, user);
	// 	return res.status(HttpStatus.OK).send(searchRegion);
	// }

	// @Post('createRegion')
	// public async createRegion(@Body(new ValidationPipe()) createRegionDto: CreateRegionDto, @Request() req, @Response() res) {
	// 	let user = req.user;
	// 	let searchRegion = await this.tradeLocationService.createRegion(createRegionDto, user);
	// 	return res.status(HttpStatus.OK).send(searchRegion);
	// }

	// @Post('updateChannelLocation')
	// public async updateChannelLocation(@Body(new ValidationPipe()) channelLocationDto: ChannelLocationDto, @Request() req, @Response() res) {
	// 	let user = req.user;
	// 	let subscriptionFeatureKeys = this.context.get('subscriptionFeatures');

	// 	// trade locations
	// 	await this._validateTradeLocationProfile();			

	// 	let channelLocation = await this.tradeLocationService.updateChannelLocation(channelLocationDto, user, subscriptionFeatureKeys);
	// 	if (channelLocation) {
	// 		this.channelService.profileScore(user.channelId, user.channel.channelTypeId, user.channel.profileStrength).then(() => {
	// 			// update company info to elastic search
	// 			this.channelIndexService.index(user.channelId);
	// 		});
			
	// 		// audit log
	// 		if (user.channel.signUpStatusId == appconstant.CHANNEL_APPROVED && this.context.get('real-user')) {
	// 			this.auditLog.addAuditLog((channelLocationDto && channelLocationDto.reason) ? channelLocationDto.reason : null, auditlog.MODULE.BO_TRADE_LOCATION, req);
	// 		}

	// 		return res.status(HttpStatus.OK).send(channelLocation);
	// 	}
	// }

	// @Put('updateChannelLocation')
	// public async updateChannelLocation1(@Body(new ValidationPipe()) channelLocationDto: ChannelLocationDto, @Request() req, @Response() res) {
	// 	let user = req.user;
	// 	let subscriptionFeatureKeys = this.context.get('subscriptionFeatures');

	// 	// trade locations
	// 	await this._validateTradeLocationProfile();

	// 	let nonsuggestion=[];let count;
	// 	let userId = user.userId;
	// 		let channelId = user.channelId;
	// 		let contactId =user.contactId;
	// 		let channelTypeId = user.channel.channelTypeId;
			

	// 	let channelLocation = await this.tradeLocationService.updateChannelLocation(channelLocationDto, user, subscriptionFeatureKeys);
	// 	if (channelLocation) {
	// 		this.channelService.profileScore(user.channelId, user.channel.channelTypeId, user.channel.profileStrength).then(() => {
	// 			// update company info to elastic search
	// 			this.channelIndexService.index(user.channelId);
	// 		});

	// 		this.tradeLocationService.getNonSuggestion(this.context.get('user').channelId,this.context.get('dataSession').plan,contactId,userId,channelTypeId);		

	// 		// audit log
	// 		if (user.channel.signUpStatusId == appconstant.CHANNEL_APPROVED && this.context.get('real-user')) {
	// 			this.auditLog.addAuditLog((channelLocationDto && channelLocationDto.reason) ? channelLocationDto.reason : null, auditlog.MODULE.BO_TRADE_LOCATION, req);
	// 		}

	// 		return res.status(HttpStatus.OK).send(channelLocation);
	// 	}
	// }

	@Get('getChannelLocation/:channelId')
	public async getChannelLocation(@Param('channelId') channelId, @Request() req, @Response() res) {
		let getChannelLocation = await this.tradeLocationService.getChannelLocation(req.user);
		if (getChannelLocation) {
			return res.status(HttpStatus.OK).json(getChannelLocation);
		}
		throw new ProcessException('channel:channelLocation:noLocations');
	}

	// @Get('getChannelLocation_bo/:channelId')
	// public async getChannelLocation_bo_admin(@Param('channelId') channelId, @Request() req, @Response() res) {
	// 	console.log('channelId',channelId);
	// 	let getChannelLocation = await this.tradeLocationService.getChannelLocation_bo(channelId);
	// 	console.log('getChannelLocation',getChannelLocation);
	// 	if (getChannelLocation) {
	// 		return res.status(HttpStatus.OK).json(getChannelLocation);
	// 	}
	// 	throw new ProcessException('channel:channelLocation:noLocations');
	// }

}
