import { IsNotEmpty, IsArray, IsNumber, ArrayNotEmpty, ValidateIf, IsPositive } from 'class-validator';
//import { ApiModelProperty } from '@nestjs/swagger';

export class AdminCouponAddDto {

	@IsNotEmpty({ message: "channel:addChannelCoupons:channelCouponsDescNotFound" })
//	@ApiModelProperty()
	readonly couponDesc: string;

	@IsNotEmpty({ message: "channel:addChannelCoupons:channelCouponsCodeNotFound" })
//	@ApiModelProperty()
	readonly couponCode: string;

	@IsNotEmpty({ message: "channel:addChannelCoupons:channelCouponsOfferValueNotFound" })
	@IsPositive({ message: "channel:addChannelCoupons:channelCouponsOfferValueIsNumber" })
//	@ApiModelProperty()
	readonly couponOfferValue: number;

	@IsNotEmpty({ message: "channel:addChannelCoupons:channelCouponsIsActiveNotFound" })
//	@ApiModelProperty()
	readonly isActive: number;

	@IsNotEmpty({ message: "channel:addChannelCoupons:channelCouponsFromDateNotFound" })
//	@ApiModelProperty()
	readonly fromDate: string;

	@IsNotEmpty({ message: "channel:addChannelCoupons:channelCouponsToDateNotFound" })
//	@ApiModelProperty()
	readonly toDate: string;

	@IsNotEmpty({ message: "channel:addChannelCoupons:channelCouponsSubscriptionTypeId" })
	@IsPositive({ message: "channel:addChannelCoupons:channelCouponsSubscriptionTypeIdIsNumber" })
//	@ApiModelProperty()
	readonly subscriptionTypeId: number;

	@IsNotEmpty({ message: "channel:addChannelCoupons:channelCouponsChannelTypeId" })
	@IsPositive({ message: "channel:addChannelCoupons:channelCouponsChannelTypeIdIsNumber" })
//	@ApiModelProperty()
	readonly channelTypeId: number;

	@ValidateIf(o => o.subscriptionPlans === undefined)
	@IsNotEmpty({ message: "channel:addChannelCoupons:channelCouponsSubscriptionPlanId" })
	@IsPositive({ message: "channel:addChannelCoupons:channelCouponsSubscriptionPlanIdIsNumber" })
//	@ApiModelProperty()
	readonly subscriptionPlanId: number;

	@ValidateIf(o => o.subscriptionPlanId === undefined)
	@IsArray({ message: "validate:field:shouldBeArray" })
	@ArrayNotEmpty({ message: "validate:field:shouldBeEmptyArray" })
//	@ApiModelProperty({ type: 'number', isArray: true })
	readonly subscriptionPlans: number[];


	@ValidateIf(o => o.subscriptionPeriods === undefined)
	@IsNotEmpty({ message: "channel:addChannelCoupons:channelCouponsSubscriptionPeriodId" })
	@IsPositive({ message: "channel:addChannelCoupons:channelCouponsSubscriptionPeriodIdIsNumber" })
//	@ApiModelProperty()
	readonly subscriptionPeriodId: number;

	@ValidateIf(o => o.subscriptionPeriodId === undefined)
	@IsArray({ message: "validate:field:shouldBeArray" })
	@ArrayNotEmpty({ message: "validate:field:shouldBeEmptyArray" })
//	@ApiModelProperty({ type: 'number', isArray: true })
	readonly subscriptionPeriods: number[];

	@IsNotEmpty({ message: "channel:addChannelCoupons:channelCouponsDiscountUnitNotFound" })
	@IsPositive({ message: "channel:addChannelCoupons:channelCouponsDiscountUnitIsNumber" })
//	@ApiModelProperty()
	readonly discountUnit: number;

	@IsNotEmpty({ message: "channel:addChannelCoupons:channelCouponsuserThresholdNotFound" })
	@IsNumber({}, { message: "channel:addChannelCoupons:channelCouponsuserThresholdIsNumber" })
//	@ApiModelProperty()
	readonly userThreshold: number;

	@IsNotEmpty({ message: "channel:addChannelCoupons:channelCouponsusageThresholdNotFound" })
	@IsNumber({}, { message: "channel:addChannelCoupons:channelCouponsusageThresholdIsNumber" })
//	@ApiModelProperty()
	readonly usageThreshold: number;
}
