import {
    IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	Min,
	Max,
	IsNumber,
	ArrayNotEmpty,
	ValidateIf,
	ValidateNested,
    IsOptional,
    IsDate,
    IsDateString
} from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';
export class CertificateTagDto {

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:certificatetagidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:certificatetagidIsNumber" })
	@ApiProperty()
    readonly certificatetagid: number;

    @IsNotEmpty({ message: "channel:product:tagIsNotEmpty" })
	@IsString({ message: "channel:product:tagIsString" })
	@ApiProperty()
    readonly tag: string;

    @IsOptional()
     channelId: number;

    @IsOptional()
     createdat: Date;

    @IsOptional()
     deletedat: Date;

}