import {
    IsNotEmpty,
    IsNumber,
    IsOptional,
    IsString,
	MaxLength
} from 'class-validator';
import { ApiProperty } from '@nestjs/swagger';

export class ChannelDocumentDto {

	@IsOptional()
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsNumber({}, { message: "validate:field:shouldBeNumber" })
	@ApiProperty()
	readonly channelDocumentId: number;
	
	@IsOptional()
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsNumber({}, { message: "validate:field:shouldBeNumber" })
	@ApiProperty()
    readonly documentId: number;

	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsString({ message: "validate:field:shouldBeString" })
	@ApiProperty()
	readonly document: string;

	@IsOptional()
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsString({ message: "validate:field:shouldBeString" })
	@MaxLength(255, { message: "validate:field:validateMaxLength" })
	@ApiProperty()
	readonly documentName: string;

	@IsOptional()
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsString({ message: "validate:field:shouldBeString" })
	@MaxLength(255, { message: "validate:field:validateMaxLength" })
	@ApiProperty()
	readonly documentDescription: string;
}