import { IsNotEmpty, ArrayNotEmpty, IsEnum, IsArray, IsBoolean, IsOptional, MaxLength } from 'class-validator';
import { Type } from 'class-transformer';


export enum locationType {
	SELLING,
	TARGET,
	RETAIL,
	RESELLING
}

export class ChannelLocationDto {

	@IsNotEmpty({ message: "channel:channelLocation:locationTypeIsNotEmpty" })
	@IsEnum(locationType, { message: "channel:channelLocation:locationTypeIsEnum" })	
	readonly locationType: string;

	@IsArray({ message: "channel:channelLocation:locationIsArray" })
	@ArrayNotEmpty({ message: "channel:channelLocation:locationArrayNotEmpty" })	
	readonly location: string[];

	@IsOptional()
	@IsBoolean({ message: "channel:channelLocation:isUpdateIsBoolean" })	
	readonly isUpdate: boolean;

	@IsOptional()
	@MaxLength(1000, { message: "validate:field:validateMaxLength" })	
	reason: string
}
