import { IsString, IsEmail, IsNotEmpty, MinLength, MaxLength, Min, Max, IsNumber, ArrayNotEmpty, ValidateIf, ValidateNested, IsOptional, IsDate, IsDateString } from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';
export class ChannelKeyRetailerDto {

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productkeyretaileridIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:productkeyretaileridIsNumber" })
	@ApiProperty()
	readonly keypartnerid: number;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productkeyretaileridIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:productkeyretaileridIsNumber" })
	@ApiProperty()
	readonly channelkeypartnerid: number;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productkeyretaileridIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:productkeyretaileridIsNumber" })
	@ApiProperty()
	readonly existchannelid: number;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productkeyretaileridIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:productkeyretaileridIsNumber" })
	@ApiProperty()
	readonly oldchannelid: number;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:retailernameIsNotEmpty" })
	@MinLength(2, { message: "channel:product:retailernameMinLen" })
	@MaxLength(256, { message: "channel:product:retailernameMaxLen" })
	@IsString({ message: "channel:product:retailernameIsString" })
	@ApiProperty()
	readonly partnername: string;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:countryidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:countryidIsNumber" })
	@ApiProperty()
	readonly countryid: number;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:imageidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:imageidIsNumber" })
	@ApiProperty()
	readonly imageid: number;

	@IsOptional()
	@ValidateIf(o => o.channelkeypartnerid == undefined && o.existchannelid == undefined && o.oldchannelid == undefined)
	@IsNotEmpty({ message: "channel:product:imageIsNotEmpty" })
	@IsString({ message: "channel:product:imageIsString" })
	@ApiProperty()
	readonly image: string;

}
