import {
    IsString,
    IsEmail,
    IsNotEmpty,
    MinLength,
    MaxLength,
    IsNumber,
    Min,
    Max,
    ValidateNested,
    IsOptional
} from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';

export class CompanyB2BDto {

    @IsOptional()
    @IsNumber({}, { message: "channel:companyProfile:companyB2BIdIsNumber" })
	@ApiProperty()
    readonly channel_B2B_id: number;

    @IsNotEmpty({ message: "channel:companyProfile:companyB2BUrlIsNotEmpty" })
    @MinLength(4, { message: "channel:companyProfile:companyB2BUrlMinLen" })
	@MaxLength(253, { message: "channel:companyProfile:companyB2BUrlMaxLen" })
	@ApiProperty()
    readonly B2B_url: string;

}