import {
    IsString,
    IsEmail,
    IsNotEmpty,
    MinLength,
    MaxLength,
    IsNumber,
    Min,
    Max,
    ValidateNested,
    IsOptional,
    IsDate,
    ValidateIf
} from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';

export class CompanyAwardsDto {

    @IsOptional()
    @IsNumber({}, { message: "channel:companyProfile:companyAwardIdIsNumber" })
	@ApiProperty()
    readonly channel_award_id: number;

    @IsOptional()
    @IsNumber({}, { message: "channel:companyProfile:documentId should be a number" })
	@ApiProperty()
    readonly documentId: number;

    @IsNotEmpty({ message: "channel:companyProfile:companyAwardDetailsIsNotEmpty" })
	@ApiProperty()
    readonly details: string;

    @IsNotEmpty({ message: "channel:companyProfile:companyAwardIssuedByIsNotEmpty" })
	@ApiProperty()
    readonly issued_by: string;

    @ValidateIf(o => o.isLifeTime == "0")
    @IsNotEmpty({ message: "channel:companyProfile:companyAwardValidUptoIsNotEmpty" })
	@ApiProperty()
    readonly valid_upto: string;

    @IsOptional()
    @IsNotEmpty({ message: "channel:companyProfile:companyAwardIsLifeTimeIsNotEmpty" })
	@ApiProperty()
    readonly isLifeTime: string;

    @IsOptional()
    @IsNotEmpty({ message: "channel:companyProfile:companyAwardIsLifeTimeIsNotEmpty" })
	@ApiProperty()
    readonly image: string;
}