import { IsString, IsEmail, IsNotEmpty, MinLength, IsNumber } from 'class-validator';

export class CouponDto {

    @IsNotEmpty({ message: "channel:coupon:couponCodeNotEmpty" })
    readonly couponCode: string;

    @IsNotEmpty({ message: "channel:coupon:subscriptionIdNotEmpty" })
    @IsNumber({}, { message: "channel:coupon:subscriptionIdNumber" })
    readonly subscriptionId: number;

    @IsNotEmpty({ message: "channel:coupon:subscriptionPlanIdNotEmpty" })
    @IsNumber({}, { message: "channel:coupon:subscriptionPlanIdNumber" })
    readonly subscriptionPlanId: number;

    @IsNotEmpty({ message: "channel:coupon:subscriptionPeriodIdNotEmpty" })
    @IsNumber({}, { message: "channel:coupon:subscriptionPeriodIdNumber" })
    readonly subscriptionPeriodId: number;
}