import { IsBoolean, IsNotEmpty, IsArray, IsOptional, IsEnum } from 'class-validator';
import { ApiProperty } from '@nestjs/swagger';

export enum locationType {
	SELLING,
	TARGET,
	RETAIL
}

export class SearchRegionDto {

	@IsNotEmpty({ message: "common:regionCountry:zoneNotEmpty" })
	@IsArray({ message: "common:regionCountry:zoneNotArray" })
	@ApiProperty({ type: 'number', isArray: true })
	readonly zone: number[];

	//@IsNotEmpty({ message: "common:searchRegion:regionNotEmpty" })
	//@MinLength(3, { message: "common:searchRegion:regionMinLength" })
	@ApiProperty()
	readonly region: string;

	@IsNotEmpty({ message: "channel:channelLocation:locationTypeIsNotEmpty" })
	@IsEnum(locationType, { message: "channel:channelLocation:locationTypeIsEnum" })
	@ApiProperty()
	readonly locationType: string;
	
	@IsOptional()
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
    @IsBoolean({ message: "validate:field:shouldBeBoolean" })
    @ApiProperty()
    readonly exclude: boolean;

}
