import { IsString, IsNumber, IsEmail, IsNotEmpty, MinLength, IsOptional, IsEnum } from 'class-validator';
import { appconstant } from '../../../config/app.constant';

export class SubscribeDto {

	@IsNumber()
	@IsNotEmpty()
	subscriptionId: number;

	@IsNumber()
	@IsOptional()
	@IsEnum([
		appconstant.PAYMENT_METHOD.OFFLINE_WIRE_TRANSFER,
		appconstant.PAYMENT_METHOD.ONLINE_CREDIT_DEBIT_CART,
		appconstant.PAYMENT_METHOD.PAYPAL_TRANSFER,
		appconstant.PAYMENT_METHOD.STRIPE_ALIPAY
	], { message: "Payment method should be any one from 'Wire transfer' and 'Credit / Debit cart' and PAYPAL" })
	paymentMethodId: number;

	@IsNumber()
	@IsOptional()
	transactionId: number;

	@IsOptional()
	paymentIntent: string

	@IsOptional()
	couponCode: string;

	@IsOptional()
	paymentStatus:number;
}
