import { ArrayNotEmpty, IsOptional, IsInt, IsString, IsEmail, IsNotEmpty, MinLength, IsNumber, IsBoolean } from 'class-validator';
//import { ApiModelProperty } from '@nestjs/swagger';

export class SubscriptionFilterBODto {

	@IsOptional()
	@ArrayNotEmpty({ message: "validate:field:shouldBeArray" })
	@IsInt({
		each: true,
		message: "validate:field:shouldBeInt"
	})
//	@ApiModelProperty({ type: 'number', isArray: true })
	readonly channelTypeId: number;

    @IsOptional()
//	@ApiModelProperty()
	readonly isPaid: string;

	@IsOptional()
	@ArrayNotEmpty({ message: "validate:field:shouldBeArray" })
	@IsInt({
		each: true,
		message: "validate:field:shouldBeInt"
	})
//	@ApiModelProperty({ type: 'number', isArray: true })
	readonly planId: number

	@IsOptional()
	@ArrayNotEmpty({ message: "validate:field:shouldBeArray" })
	@IsInt({
		each: true,
		message: "validate:field:shouldBeInt"
	})
//	@ApiModelProperty({ type: 'number', isArray: true })
	readonly periodId: number

	@IsOptional()
	@ArrayNotEmpty({ message: "validate:field:shouldBeArray" })
	@IsBoolean({
		each: true,
		message: "validate:field:shouldBeBoolean"
	})
//	@ApiModelProperty({ type: 'boolean', isArray: true })
	readonly subscription_status: boolean

	@IsOptional()
	@IsBoolean({ message: "validate:field:shouldBeBoolean" })
//	@ApiModelProperty()
	readonly channel_status: boolean

	@IsOptional()
	@IsString({ message: "validate:field:shouldBeString" })
//	@ApiModelProperty()
	readonly start: string

	@IsOptional()
	@IsString({ message: "validate:field:shouldBeString" })
//	@ApiModelProperty()
	readonly end: string

	@IsOptional()
	@IsString({ message: "validate:field:shouldBeString" })
//	@ApiModelProperty()
	readonly invoiceno: string


	@IsOptional()
	@IsInt({ message: "validate:field:shouldBeInt" })
//	@ApiModelProperty()
	readonly paymentMethodId: number
}
