import {
	IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	IsNumber,
	IsAlphanumeric,
	ValidateNested,
	IsOptional
} from 'class-validator';
import { ApiProperty } from '@nestjs/swagger';

export class TradeInformation_Brand_NameDto {


	@IsOptional()
	@ApiProperty()
	readonly id: number;

	@IsNotEmpty({ message: "channel:tradeinformation:brandNameNotEmpty" })
	@IsString({ message: "channel:tradeinformation:brandNameonlyIsString" })
	// @MinLength(1, { message: "channel:tradeinformation:brandNameMinlength" })
	@MaxLength(255, { message: "channel:tradeinformation:brandNameMaxlength" })
	@ApiProperty()
	readonly name: string;


	// @IsNotEmpty({ message: "channel:tradeinformation:imagePathNotEmpty" })
	@IsOptional()
	@ApiProperty()
	readonly documentPath: string;
}
