import {
	IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	IsNumber,
	IsAlphanumeric,
	ValidateNested,
	IsOptional
} from 'class-validator';
import { ApiProperty } from '@nestjs/swagger';

export class TradeInformation_Brand_NameUpdateDto {

	@IsNumber({}, { message: "channel:tradeinformation:channelTypeIsNumber" })
	@IsOptional()
	@ApiProperty()
	readonly id: number;

	@IsString({ message: "channel:tradeinformation:brandNameonlyIsString" })
	// @MinLength(2, { message: "channel:tradeinformation:brandNameMinlength" })
	@MaxLength(255, { message: "channel:tradeinformation:brandNameMaxlength" })
	@IsOptional()
	@ApiProperty()
	readonly name: string;

	@ApiProperty()
	@IsOptional()
	readonly documentPath: string;
}
