import { IsNotEmpty, IsEnum, IsNumber, ValidateIf, IsOptional, IsString } from 'class-validator';
import { appconstant } from 'src/config/app.constant';

export enum leadmanagementtagtype {
	High,
	Medium,
	Low
}

export class UpdateChannelDto {

	@IsNotEmpty({ message: "channelHub:channleHubFilter:connectionStatusTypeIdIsNotEmpty" })
	@IsNumber({}, { message: "channelHub:channleHubFilter:connectionStatusTypeIdIsNumber" })
	readonly connectionStatusTypeId: number;

	@IsOptional()
	@IsNotEmpty({ message: "channelHub:updateChannelDefaultContact:channelJCTIdIsNotEmpty" })
	@IsNumber({}, { message: "channelHub:updateChannelDefaultContact:channelJCTIdIsNumber" })
	channelJCTId: number;

	@ValidateIf(o => o.connectionStatusTypeId === appconstant.DISMISS)
	@IsNotEmpty({ message: "channelHub:channleHubFilter:dismissreasonidIsNotEmpty" })
	@IsNumber({}, { message: "channelHub:channleHubFilter:dismissreasonidIsNumber" })
	readonly dismissreasonid: number;

	@ValidateIf(o => o.dismissreasonid === appconstant.DISMISS_OTHER_REASON)
	@IsNotEmpty({ message: "channelHub:channleHubFilter:otherreasonsIsNotEmpty" })
	readonly otherreasons: string;

	@IsOptional()
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsEnum(leadmanagementtagtype, { message: "channelHub:channleHubFilter:leadmanagementtagtype" })
	readonly leadManagementTag: string;

	@IsOptional()
	@IsString({ message: "validate:field:shouldBeString" })
	readonly note: string;

	@IsOptional()
	readonly contactid: number;

	//
	@IsOptional()
	readonly introVideo: number;
}
