import {
    IsNotEmpty,
    IsBoolean,
    ValidateIf,
    MaxLength
} from 'class-validator';


export class BoUpdateSubscriptionDto {
  
    @IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
    @IsBoolean({ message: "validate:field:shouldBeBoolean" })
    
    readonly status: boolean;

    @ValidateIf(o => o.status === false)
    @MaxLength(255, { message: "validate:field:validateMaxLength" })
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
    
    readonly reason: string;

}