import { IsNotEmpty, IsEmail, MinLength, MaxLength, IsString, IsAlphanumeric, IsNumber, Matches, IsOptional, ArrayNotEmpty } from 'class-validator';
import { ApiProperty } from '@nestjs/swagger';

export class UserSettingDto {
	
    @IsOptional()
    @ArrayNotEmpty({ message: "validate:field:shouldBeArray" })
	@IsNumber({}, {
		each: true,
		message: "validate:field:shouldBeInt"
	})
	@ApiProperty({ type: 'number', isArray: true })
	readonly sellingRegion: number[];

	@IsOptional()
    @ArrayNotEmpty({ message: "validate:field:shouldBeArray" })
	@IsNumber({}, {
		each: true,
		message: "validate:field:shouldBeInt"
	})
	@ApiProperty({ type: 'number', isArray: true })
	readonly targetRegion: number[];

    @ArrayNotEmpty({ message: "validate:field:shouldBeArray" })
	@IsNumber({}, {
		each: true,
		message: "validate:field:shouldBeInt"
	})
	@ApiProperty({ type: 'number', isArray: true })
	readonly productGroup: number[];

	@ArrayNotEmpty({ message: "validate:field:shouldBeArray" })
	@IsNumber({}, {
		each: true,
		message: "validate:field:shouldBeInt"
	})
	@ApiProperty({ type: 'number', isArray: true })
	readonly productCat: number[];
   
    @IsNumber({}, {
		each: true,
		message: "validate:field:shouldBeInt"
	})
	@ApiProperty()
    suggestions: number;
    
    @IsNumber({}, {
		each: true,
		message: "validate:field:shouldBeInt"
	})
	@ApiProperty()
	networkInvitation: number;
    

}
