import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, BeforeCreate, AllowNull, BeforeUpdate, BelongsTo } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Country } from '../../common/models/Country.entity';
import { Channel } from './Channel.entity';

const tableOptions: IDefineOptions = {timestamps: false, tableName: 'tblAddress' } as IDefineOptions;

@Table(tableOptions)
export class Address extends Model<Address>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	addressId: number

	@Column(DataType.CHAR(255))
	address: string

	@Column(DataType.CHAR(255))
	city: string

	@Column(DataType.BIGINT)
	countryId: number

	@BelongsTo(() => Country, 'countryId')
	country: Country;

	@AllowNull(true)
	@Column(DataType.CHAR(255))
	postalCode: string
	
	@AllowNull(true)
	@Column(DataType.CHAR(255))
	state: string

}
