import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, BeforeCreate, AllowNull, BeforeUpdate, BelongsTo,ForeignKey } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Channel } from './Channel.entity';

const tableOptions: IDefineOptions = {timestamps: false, tableName: 'buyingneed' } as IDefineOptions;

@Table(tableOptions)
export class BuyerNeed extends Model<BuyerNeed>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	id: number

  @ForeignKey(() => Channel) 
  @Column(DataType.BIGINT)
  channelid:number

  @BelongsTo(() => Channel)
  channel: Channel[];

    
	@Column(DataType.BIGINT)
	contactid: number
    
	@Column(DataType.CHAR(280))
	requirements: string

	@Column(DataType.DATE)
	deletedat: Date

	@Column(DataType.DATE)
	createdat: Date
	
}
