import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, BeforeCreate, AllowNull, BeforeUpdate, BelongsTo,ForeignKey } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Channel } from './Channel.entity';
import { BuyerNeed } from './BuyerNeed.entity';

const tableOptions: IDefineOptions = {timestamps: false, tableName: 'buyerreqcategory' } as IDefineOptions;

@Table(tableOptions)
export class BuyerReqCategory extends Model<BuyerReqCategory>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	reqid: number

  @ForeignKey(() => BuyerNeed) 
  @Column(DataType.BIGINT)
  buyerreqid:number

  @BelongsTo(() => BuyerNeed)
  buyer: BuyerNeed[];
    
  @Column(DataType.BIGINT)
    categoryid: number    
	
}
