import {
	Table,
	Column,
	PrimaryKey,
	Model,
	AutoIncrement,
	DataType,
	AllowNull,
	ForeignKey,
	BelongsTo,
} from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Channel } from '../../channel/models/Channel.entity';

const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblChannelCertificateTag' } as IDefineOptions;

@Table(tableOptions)

export class CertificateTag extends Model<CertificateTag>{

    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    certificatetagid: number

    @ForeignKey(() => Channel)
    @Column(DataType.BIGINT)
    channelId: number

    @BelongsTo(() => Channel)
    product: Channel[];

    @Column(DataType.CHAR(6000))
    tag: string

    @AllowNull(false)
    @Column(DataType.DATE)
    createdat: Date

    @Column(DataType.DATE)
    deletedat: Date

}