import { Table, Column, PrimaryKey, Model, DataType, HasMany, Scopes } from 'sequelize-typescript';
import { ApiProperty } from '@nestjs/swagger';
import { UUIDV4 } from 'sequelize/types';

@Table({
	tableName: "tblCerificateType"
})

@Scopes(() => ({
	profileInfo: {
		attributes: ['cerificateTypeId', 'cerificateType']
	}
}))

export class CertificateType extends Model<CertificateType> {

	@Column({
		type: DataType.INTEGER,
		allowNull: false,
		// defaultValue:UUIDV4,//autoIncrement: true,
		unique: true,
		primaryKey: true,
	})
	@ApiProperty()
	cerificateTypeId: number

	@Column({
		type: DataType.CHAR(255),
		allowNull: false,
	})
	@ApiProperty()
    cerificateType: string
    
    @Column(DataType.DATE)
    deletedAt:Date

    @Column(DataType.DATE)
    createdAt:Date

    @Column(DataType.DATE)
    updatedAt:Date
}
