import { Table, 
    Column, 
    PrimaryKey, 
    Model, 
    AutoIncrement, 
    DataType, 
    BeforeCreate, 
    AllowNull, 
    BeforeUpdate,
    ForeignKey,
    HasMany,
    BelongsTo,
    Scopes  
  } from 'sequelize-typescript';
  import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
  // import { DataTypeTime } from 'sequelize';
  import { Channel } from './Channel.entity';
  
  
  const tableOptions: IDefineOptions = { timestamp: true, tableName: 'tblChannelB2B' } as IDefineOptions;
  
  @Table(tableOptions)

  @Scopes(() => ({
    profileInfo: {
      attributes: ['channelB2BId', 'channelId', 'channelB2B']
    }
  }))
  
  export class ChannelB2B extends Model<ChannelB2B>{
  
    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    channelB2BId:number
    
    @ForeignKey(() => Channel) 
    @Column(DataType.BIGINT)
    channelId:number
  
    @BelongsTo(() => Channel)
    channel: Channel[];
  
    @Column(DataType.CHAR(255))
    channelB2B:string

    @Column(DataType.DATE)
    deletedAt:Date
    
    @Column(DataType.DATE)
    createdAt:Date

    @Column(DataType.DATE)
    updatedAt:Date

  }