import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, BelongsTo, ForeignKey } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { ChannelJCT } from './ChannelJCT.entity';
import { User } from './../../user/models/User.entity';
import { DismissReason } from './DismissReason.entity';

const tableOptions: IDefineOptions = { tableName: 'tblchanneldismissreason', timestamps:false } as IDefineOptions;

@Table(tableOptions)

export class ChannelDismissReason extends Model<ChannelDismissReason>{
  
    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    channeldismissreasonid:number
    
    @ForeignKey(() => ChannelJCT)
    @Column(DataType.BIGINT)
    channelJCTId: number
  
    @BelongsTo(() => ChannelJCT)
    channelJCT: ChannelJCT;

    @ForeignKey(() => DismissReason)
    @Column(DataType.BIGINT)
    dismissreasonid: number
  
    @BelongsTo(() => DismissReason)
    dismissreason: DismissReason;

    @Column(DataType.CHAR(10000))
    otherreasons:string

    @ForeignKey(() => User)
	@Column(DataType.BIGINT)
	updatedby: number

	@BelongsTo(() => User, 'userId')
    User: User;
    
    @Column(DataType.DATE)
    createdat:Date

    @Column(DataType.DATE)
    updatedat:Date

    @Column(DataType.BIGINT)
    dismissedChId: number
    
    @Column(DataType.BIGINT)
	dismissedBy: number

}
