import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, BelongsTo, ForeignKey, Scopes } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Channel } from './Channel.entity';
import { User } from './../../user/models/User.entity';

const tableOptions: IDefineOptions = { tableName: 'tblchannelignorereasons' } as IDefineOptions;

@Table(tableOptions)

export class ChannelIgnoreReasons extends Model<ChannelIgnoreReasons>{
  
    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    channelignorereasonid:number
    
    @ForeignKey(() => Channel)
    @Column(DataType.BIGINT)
    channelid: number
  
    @BelongsTo(() => Channel)
    channel: Channel;

    @Column(DataType.CHAR(10000))
    ignorereason:string

    @ForeignKey(() => User)
	@Column(DataType.BIGINT)
	updatedby: number

	@BelongsTo(() => User, 'userId')
    User: User;
    
    @Column(DataType.DATE)
    deletedat:Date
    
    @Column(DataType.DATE)
    createdat:Date

    @Column(DataType.DATE)
    updatedat:Date

}
