import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, BelongsTo, ForeignKey, Scopes } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Channel } from './Channel.entity';
import { PaymentOptionType } from './PaymentOptionType.entity';
import { User } from './../../user/models/User.entity';

const tableOptions: IDefineOptions = { tableName: 'tblchannelpaymentoptiontype', timestamps:false } as IDefineOptions;

@Table(tableOptions)

@Scopes(() => ({
	settings: {
		attributes: ['paymentoptiontypeid']
	}
}))

export class ChannelPaymentOptionType extends Model<ChannelPaymentOptionType>{
  
    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    channelpaymenttypeid:number
    
    @ForeignKey(() => Channel)
    @Column(DataType.BIGINT)
    channelid: number
  
    @BelongsTo(() => Channel)
    channel: Channel;

    @ForeignKey(() => PaymentOptionType)
    @Column(DataType.BIGINT)
    paymentoptiontypeid: number
  
    @BelongsTo(() => PaymentOptionType)
    paymentoptiontype: PaymentOptionType[];

    @ForeignKey(() => User)
	@Column(DataType.BIGINT)
	updatedby: number

	@BelongsTo(() => User)
    User: User;
    
    @Column(DataType.DATE)
    deletedat:Date
    
    @Column(DataType.DATE)
    createdat:Date

    @Column(DataType.DATE)
    updatedat:Date

}
