import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, BelongsTo, ForeignKey, Scopes } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Channel } from './Channel.entity';
import { PaymentTerm } from './PaymentTerm.entity';
import { User } from './../../user/models/User.entity';

const tableOptions: IDefineOptions = { tableName: 'tblchannelpaymentterm', timestamps:false } as IDefineOptions;

@Table(tableOptions)

@Scopes(() => ({
	settings: {
		attributes: ['paymenttermid']
	}
}))

export class ChannelPaymentTerm extends Model<ChannelPaymentTerm>{
  
    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    channelpaymenttermid:number
    
    @ForeignKey(() => Channel)
    @Column(DataType.BIGINT)
    channelid: number
  
    @BelongsTo(() => Channel)
    channel: Channel;

    @ForeignKey(() => PaymentTerm)
    @Column(DataType.BIGINT)
    paymenttermid: number
  
    @BelongsTo(() => PaymentTerm)
    paymentterm: PaymentTerm[];

    @ForeignKey(() => User)
	@Column(DataType.BIGINT)
	updatedby: number

	@BelongsTo(() => User)
    User: User;
    
    @Column(DataType.DATE)
    deletedat:Date
    
    @Column(DataType.DATE)
    createdat:Date

    @Column(DataType.DATE)
    updatedat:Date

}
