import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, BelongsTo, ForeignKey, Scopes } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Channel } from './Channel.entity';
import { PreferenceType } from './PreferenceType.entity';
import { User } from './../../user/models/User.entity';

const tableOptions: IDefineOptions = { tableName: 'tblchannelsamplepreferencetype' } as IDefineOptions;

@Table(tableOptions)

@Scopes(() => ({
	settings: {
		attributes: ['preferencetypeid']
	}
}))

export class ChannelSamplePreferenceType extends Model<ChannelSamplePreferenceType>{
  
    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    channelsamplepreferencetypeid:number
    
    @ForeignKey(() => Channel)
    @Column(DataType.BIGINT)
    channelid: number
  
    @BelongsTo(() => Channel)
    channel: Channel;

    @ForeignKey(() => PreferenceType)
    @Column(DataType.BIGINT)
    preferencetypeid: number
  
    @BelongsTo(() => PreferenceType)
    preferencetype: PreferenceType[];

    @ForeignKey(() => User)
	@Column(DataType.BIGINT)
	updatedby: number

	@BelongsTo(() => User, 'userId')
    User: User;
    
    @Column(DataType.DATE)
    deletedat:Date
    
    @Column(DataType.DATE)
    createdat:Date

    @Column(DataType.DATE)
    updatedat:Date

}
