import { Table, 
    Column, 
    PrimaryKey, 
    Model, 
    AutoIncrement, 
    DataType, 
    BeforeCreate, 
    AllowNull, 
    BeforeUpdate,
    ForeignKey,
    HasMany,
    BelongsTo,
    Scopes
  } from 'sequelize-typescript';
  import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
  // import { DataTypeTime } from 'sequelize';
  import { Channel } from './Channel.entity';
  import { SocialSite } from './SocialSite.entity';
  
  
  const tableOptions: IDefineOptions = { timestamp: true, tableName: 'tblChannelSocialLink' } as IDefineOptions;
  
  @Table(tableOptions)

  @Scopes(() => ({
    channelDetail: {
      attributes: ['channelSocialLinkId', 'socialSiteId', 'channelSocialLink', 'channelId', 'deletedAt']
    }
  }))
  
  export class ChannelSocialLink extends Model<ChannelSocialLink>{
  
    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    channelSocialLinkId:number

    @ForeignKey(() => SocialSite) 
    @Column(DataType.BIGINT)
    socialSiteId:number
  
    @BelongsTo(() => SocialSite)
    socialSite: SocialSite[];
    
    @ForeignKey(() => Channel) 
    @Column(DataType.BIGINT)
    channelId:number
  
    @BelongsTo(() => Channel)
    channel: Channel[];
  
    @Column(DataType.CHAR(255))
    channelSocialLink:string

    @Column(DataType.DATE)
    deletedAt:Date
    
    @Column(DataType.DATE)
    createdAt:Date

    @Column(DataType.DATE)
    updatedAt:Date

  }