import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, BeforeCreate, AllowNull, BeforeUpdate, ForeignKey, HasOne, HasMany, Scopes, BelongsTo, BelongsToMany } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
// import { DataTypeTime } from 'sequelize';
import { ChannelSubscription } from './ChannelSubscription.entity';

const tableOptions: IDefineOptions = { timestamp: true, tableName: 'tblchannelsuggestions' } as IDefineOptions;

//@Table(tableOptions)
@Table({ timestamps: false, tableName: 'tblchannelsuggestions' } )
export class ChannelSuggestion extends Model<ChannelSuggestion> {

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	channelsuggestionsid: number;

	@ForeignKey(() => ChannelSubscription)
	@Column(DataType.BIGINT)
	channelsubscriptionid: number;

	@BelongsTo(() => ChannelSubscription)
	channelSubscription: ChannelSubscription;

	@Column
	suggestionfor: string

	@Column
	suggestioncount: number

	@Column
	limit: number

	@Column
	isfulfilled: string

	@Column
	isexpired: string

	@AllowNull(false)
	@Column(DataType.DATE)
	startedat: Date

	@AllowNull(false)
	@Column(DataType.DATE)
	endat: Date

	@AllowNull(false)
	@Column(DataType.DATE)
	createdat: Date

	@Column(DataType.DATE)
	updatedat: Date
}
