import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, BelongsTo, ForeignKey, Scopes } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Channel } from './Channel.entity';
import { UserVisibilityType } from './UserVisibilityType.entity';
import { User } from './../../user/models/User.entity';

const tableOptions: IDefineOptions = { tableName: 'tblchanneluservisibility' } as IDefineOptions;

@Table(tableOptions)

@Scopes(() => ({
	settings: {
		attributes: ['uservisibilitytypeid']
	}
}))


export class ChannelUserVisibility extends Model<ChannelUserVisibility>{
  
    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    channeluservisibilityid:number
    
    @ForeignKey(() => Channel)
    @Column(DataType.BIGINT)
    channelid: number
  
    @BelongsTo(() => Channel)
    channel: Channel;

    @ForeignKey(() => UserVisibilityType)
    @Column(DataType.BIGINT)
    uservisibilitytypeid: number
  
    @BelongsTo(() => UserVisibilityType)
    uservisibilitytype: UserVisibilityType[];

    @ForeignKey(() => User)
	@Column(DataType.BIGINT)
	updatedby: number

	@BelongsTo(() => User, 'userId')
    User: User;
    
    @Column(DataType.DATE)
    deletedat:Date
    
    @Column(DataType.DATE)
    createdat:Date

    @Column(DataType.DATE)
    updatedat:Date

}
