
import {
  Table,
  Column,
  PrimaryKey,
  Model,
  AutoIncrement,
  DataType,
  BeforeCreate,
  AllowNull,
  BeforeUpdate,
  ForeignKey,
  BelongsTo,
  Length
} from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Media } from '../../media/models/Media.entity';
import { Claim } from './Claim.entity';

const tableOptions: IDefineOptions = { tableName: 'tblClaimDocument' } as IDefineOptions;

@Table(tableOptions)

export class ClaimDocument extends Model<ClaimDocument>{

  @PrimaryKey
  @AutoIncrement
  @AllowNull(false)
  @Column(DataType.BIGINT)
  claimDocumentId: number

  @ForeignKey(() => Claim)
  @Column(DataType.BIGINT)
  claimId: number;

  @BelongsTo(() => Claim)
  claim: Claim;

  @ForeignKey(() => Media)
  @Column(DataType.BIGINT)
  documentId: number;

  @BelongsTo(() => Media)
  document: Media;
} 