import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, ForeignKey, BelongsTo } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Media } from '../../media/models';
const tableOptions: IDefineOptions = { tableName: 'tblCompanyMedia', timestamps:false} as IDefineOptions;

@Table(tableOptions)

export class CompanyMedia extends Model<CompanyMedia>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	companyMediaId: number

    @Column(DataType.DATE)
    createdAt: Date
    
    @Column(DataType.DATE)
    deletedAt: Date

    @ForeignKey(() => Media)
    @Column(DataType.BIGINT)
    documentId: number

    @BelongsTo(() => Media, 'documentId')
    document: Media;

    @Column(DataType.BIGINT)
    channelId: number;

    @Column(DataType.BIGINT)
    oldChannelId: number;
    
    @Column(DataType.BIGINT)
    contactId: number;
    
    @ForeignKey(() => Media)
    @Column(DataType.BIGINT)
    snapId: number

    @BelongsTo(() => Media, 'snapId')
    snap: Media;
}
