'use strict';

import { DataType, Table, Column, Model, ForeignKey, BelongsTo, Scopes, AutoIncrement, AllowNull, PrimaryKey } from 'sequelize-typescript';
import { Media } from 'src/modules/media/models';

@Table({
	timestamps: false,
	tableName: "tblCompanyMediaImages"
})

@Scopes(() => ({
}))

export class CompanyMediaImages extends Model<CompanyMediaImages>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	companyMediaId: number
	
	@Column(DataType.BIGINT)
	channelId: number

	@Column(DataType.BIGINT)
    contactId: number;

	@ForeignKey(() => Media)
	@Column(DataType.BIGINT)
	documentId: number

	@BelongsTo(() => Media)
	document: Media;

	@Column(DataType.BIGINT)
	typeId: number

	@Column(DataType.DATE)
	updatedBy: Date;

	@Column(DataType.DATE)
	deletedAt: Date;

	@Column(DataType.DATE)
	createdAt: Date;

}
