import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, ForeignKey, BelongsTo, AllowNull } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { ChannelJCT } from './ChannelJCT.entity';
import { Contact } from '../../user/models/Contact.entity';

const tableOptions: IDefineOptions = { tableName: 'tblContactJCT' } as IDefineOptions;

@Table(tableOptions)

export class ContactJCT extends Model<ContactJCT>{

  @PrimaryKey
  @AutoIncrement
  @AllowNull(false)
  @Column(DataType.BIGINT)
  contactJCTId: number;

  @ForeignKey(() => Contact)
  @Column(DataType.BIGINT)
  contactId: number;

  @BelongsTo(() => Contact, 'contactId')
  contact: Contact;

  @ForeignKey(() => Contact)
  @Column(DataType.BIGINT)
  partnerContactId: number;

  @BelongsTo(() => Contact, 'partnerContactId')
  partnerContact: Contact;

  @ForeignKey(() => ChannelJCT)
  @Column(DataType.BIGINT)
  channelJCTId: number;

  @BelongsTo(() => ChannelJCT, 'channelJCTId' )
  channelJCT: ChannelJCT;

}