import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, BeforeCreate, AllowNull, BeforeUpdate, BelongsTo, HasMany, ForeignKey } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { DashboardReport } from './DashboardReport.entity';

const tableOptions: IDefineOptions = {timestamps: false, tableName: 'dashboard' } as IDefineOptions;

@Table(tableOptions)
export class Dashboard extends Model<Dashboard>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.INTEGER)
	id: number

    @Column(DataType.INTEGER)
    user_id: number

    @Column(DataType.INTEGER)
    channelid: number

	@Column(DataType.INTEGER)
	visitid: number

	@Column(DataType.INTEGER)
	count: number
	
	@Column(DataType.INTEGER)
	visittype: number

	@Column(DataType.INTEGER)
	day: number

	@Column(DataType.INTEGER)
	month: number

	@Column(DataType.INTEGER)
	year: number

    // @ForeignKey(() => DashboardReport)
	// @Column(DataType.BIGINT)
	// dashboardReport: number

	// @BelongsTo(() => DashboardReport)
	// DashboardReport: DashboardReport;

}
