import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, BeforeCreate, AllowNull, BeforeUpdate, BelongsTo, HasMany } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Dashboard } from './Dashboard.entity';

const tableOptions: IDefineOptions = {timestamps: false, tableName: 'dashboardReport' } as IDefineOptions;

@Table(tableOptions)
export class DashboardReport extends Model<DashboardReport>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	reportId: number

    @Column(DataType.BIGINT)
    userId: number

    @Column(DataType.BIGINT)
    dashboardId: number

    @HasMany(() => Dashboard, 'id')
    dashboard: Dashboard[]

    @Column(DataType.BIGINT)
    yearId: number
    
    @Column
    month1: string
    
    
    @Column
    month2: string
    
    
    @Column
    month3: string
    
    
    @Column
    month4: string
    
    
    @Column
    month5: string
    
    
    @Column
    month6: string
    
    
    @Column
    month7: string
    
    
    @Column
    month8: string
    
    
    @Column
    month9: string
    
    
    @Column
    month10: string
    
    
    @Column
    month11: string
    
    
    @Column
    month12: string
    
    
}
