import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, Scopes, ForeignKey } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { ConnectionStatusType } from './ConnectionStatusType.entity';

const tableOptions: IDefineOptions = { tableName: 'tbldismissreasons', timestamps: false, } as IDefineOptions;

@Table(tableOptions)

@Scopes(() => ({
	dismissReason: {
		attributes: {
			exclude: ['createdat', 'updatedat']
		}
	}
}))

export class DismissReason extends Model<DismissReason>{

	public static REDIS_KEY = 'dismissreason';

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	dismissreasonid: number

	@Column(DataType.CHAR(500))
	dismissreason: string
	
	@ForeignKey(() => ConnectionStatusType)
	@Column(DataType.BIGINT)
	relationId: number

	@Column(DataType.DATE)
	createdat: Date;

	@Column(DataType.DATE)
	updatedat: Date;
}
