import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, BelongsTo, ForeignKey } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { EndCustomersB2bType } from './EndCustomersB2bType';
import { Channel } from './Channel.entity';

const tableOptions: IDefineOptions = { tableName: 'tblEndCustomersB2b', timestamps:false } as IDefineOptions;

@Table(tableOptions)

export class EndCustomersB2b extends Model<EndCustomersB2b>{
  
    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    customerId:number
    
    @ForeignKey(() => Channel)
    @Column(DataType.BIGINT)
    channelId: number
  
    @BelongsTo(() => Channel)
    channel: Channel;

    @ForeignKey(() => EndCustomersB2bType)
    @Column(DataType.BIGINT)
    customerTypeId: number
  
    @BelongsTo(() => EndCustomersB2bType)
    name: EndCustomersB2bType;

    @Column(DataType.CHAR(255))
    other:string
    
    @Column(DataType.DATE)
    deletedAt:Date

}
