import {
    Table,
    Column,
    PrimaryKey,
    Model,
    AutoIncrement,
    DataType,
    BeforeCreate,
    AllowNull,
    BeforeUpdate,
    ForeignKey,
    HasMany,
    BelongsTo,
    Scopes,
  } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { EventBo } from './EventBo.entity';
//import { DataTypeTime } from 'sequelize';

const tableOptions: IDefineOptions = { timestamp: true, tableName: 'tblEventPackage' } as IDefineOptions;

@Table(tableOptions)

export class EventPackage extends Model<EventPackage>{

    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    packageId: number

    @Column(DataType.CHAR(255))
    packageName: string

    @ForeignKey(() => EventBo)
	@Column(DataType.BIGINT)
	eventId: number

	// @BelongsTo(() => EventBo, 'id')
	// event: EventBo;

    @Column(DataType.CHAR(500))
    description: string

    @Column(DataType.FLOAT(15, 2))
	price: number

    @Column(DataType.DATE)
	createdAt: Date

	@Column(DataType.DATE)
	updatedAt: Date

    @Column(DataType.DATE)
	deletedAt: Date

    @Column(DataType.FLOAT(15, 2))
    boothSize: number

    @Column(DataType.BIGINT)
    no_of_meeting_allowed: number

    @Column(DataType.BIGINT)
    no_of_access_badge: number

    @Column(DataType.BIGINT)
    no_of_private_webinar: number

    @Column(DataType.BIGINT)
    no_of_fireside_chat: number

    @Column(DataType.BIGINT)
    membersAllowed: number

    @Column(DataType.FLOAT(15, 2))
    additionalMembersCosting: number


    @Column
    emailMarketing: string

    @Column
    subs_to_chPlatform: string

    @Column(DataType.BIGINT)
    channelType: number

    @Column
    isBuyer: string

    @Column
    isSeller: string


}