import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, BeforeCreate, AllowNull, BeforeUpdate, BelongsTo,ForeignKey } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';

const tableOptions: IDefineOptions = {tableName: 'tblGuestRequirement' } as IDefineOptions;

@Table(tableOptions)
export class GuestRequirement extends Model<GuestRequirement>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	id: number;

    @Column(DataType.CHAR(255))
    email:string;

	@Column(DataType.CHAR(255))
    productSKU:string;

	@Column(DataType.BIGINT)
    channelId:number;

	@Column(DataType.INTEGER)
    type:number;

    @Column(DataType.CHAR(2000))
    note:string;

	@Column(DataType.DATE)
	deletedAt: Date

	@Column(DataType.DATE)
	updatedAt: Date;

	@Column(DataType.BIGINT)
	updatedBy: number

}
