import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, ForeignKey, BelongsTo } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { ChannelKeyPartner } from './ChannelKeyPartner.entity';
import { Channel } from './Channel.entity';
import { OldChannel } from './OldChannel.entity';
import { ChannelType } from './ChannelType.entity';

const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblKeyPartnerJCT' } as IDefineOptions;

@Table(tableOptions)
export class KeyPartnerJCT extends Model<KeyPartnerJCT>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	keypartnerid: number

	@ForeignKey(() => Channel)
	@Column(DataType.BIGINT)
	channelid: number

	@BelongsTo(() => Channel)
	channel: Channel

	@ForeignKey(() => Channel)
	@Column(DataType.BIGINT)
	existchannelid: number

	@BelongsTo(() => Channel)
	existchannel: Channel

	@ForeignKey(() => OldChannel)
	@Column(DataType.BIGINT)
	oldchannelid: number

	@BelongsTo(() => OldChannel)
	oldchannel: OldChannel

	@ForeignKey(() => ChannelKeyPartner)
	@Column(DataType.BIGINT)
	channelkeypartnerid: number

	@BelongsTo(() => ChannelKeyPartner)
	channelkeypartner: ChannelKeyPartner

	@AllowNull(false)
	@Column(DataType.DATE)
	createdat: Date

	@Column(DataType.DATE)
	updatedat: Date;

	@Column(DataType.DATE)
	deletedat: Date

	@ForeignKey(() => ChannelType)
	@Column(DataType.BIGINT)
	partner_type: number

}
