import {
  Table,
  Column,
  PrimaryKey,
  Model,
  AutoIncrement,
  DataType,
  BeforeCreate,
  AllowNull,
  BeforeUpdate,
  ForeignKey,
  BelongsTo
} from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Country } from '../../common/models/Country.entity';

const tableOptions: IDefineOptions = { tableName: 'tblOldAddress' } as IDefineOptions;

@Table(tableOptions)

export class OldAddress extends Model<OldAddress>{

  @PrimaryKey
  @AutoIncrement
  @AllowNull(false)
  @Column(DataType.BIGINT)
  oldAddressId: number

  @Column(DataType.CHAR(255))
  address: string

  @ForeignKey(() => Country)
  @Column(DataType.BIGINT)
  countryId: number
  
	@BelongsTo(() => Country)
	country: Country;

  @Column(DataType.CHAR(255))
	city: string

  @AllowNull(false)
  @Column(DataType.CHAR(255))
  postalCode: string
}
