import { Table, 
    Column, 
    PrimaryKey, 
    Model, 
    AutoIncrement, 
    DataType, 
    BeforeCreate, 
    AllowNull, 
    BeforeUpdate,
    ForeignKey,
    HasMany,
    BelongsTo,
    Scopes
  } from 'sequelize-typescript';
  import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
  // import { DataTypeTime } from 'sequelize';
  import { OldChannel } from './OldChannel.entity';
  import { SocialSite } from './SocialSite.entity';
  
  
  const tableOptions: IDefineOptions = { timestamp: true, tableName: 'tblOldChannelSocialLink' } as IDefineOptions;
  
  @Table(tableOptions)

  @Scopes(() => ({
    channelDetail: {
      attributes: ['oldChannelSocialLinkId', 'socialSiteId', 'channelSocialLink', 'channelId', 'deletedAt']
    }
  }))
  
  export class OldChannelSocialLink extends Model<OldChannelSocialLink>{
  
    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    oldChannelSocialLinkId:number

    @ForeignKey(() => SocialSite) 
    @Column(DataType.BIGINT)
    socialSiteId:number
  
    @BelongsTo(() => SocialSite)
    socialSite: SocialSite[];
    
    @ForeignKey(() => OldChannel) 
    @Column(DataType.BIGINT)
    oldChannelId:number
  
    @BelongsTo(() => OldChannel)
    oldChannel: OldChannel[];
  
    @Column(DataType.CHAR(255))
    channelSocialLink:string

    @Column(DataType.DATE)
    deletedAt:Date
    
    @Column(DataType.DATE)
    createdAt:Date

    @Column(DataType.DATE)
    updatedAt:Date

  }