import { Table, Column, PrimaryKey, Model, DataType, HasMany } from 'sequelize-typescript';
import { ApiProperty } from '@nestjs/swagger';
import { PaymentTransaction } from './PaymentTransaction.entity';
import { UUIDV4 } from 'sequelize/types';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';

// const tableOptions: IDefineOptions = { timestamp: false, tableName: 'tblPaymentType' } as IDefineOptions;
// @Table(tableOptions)

@Table({ timestamps: false, tableName: 'tblPaymentType' } )

export class PaymentType extends Model<PaymentType> {

	@Column({
		type: DataType.INTEGER,
		allowNull: false,
		// defaultValue:UUIDV4,//autoIncrement: true,
		unique: true,
		primaryKey: true,
	})
	@ApiProperty()
	paymentTypeId: number

	@Column({
		type: DataType.CHAR(100),
		allowNull: false,
		unique: { name: 'paymentType', msg: 'channel:subscription:paymentType:shouldBeUnique' }
	})
	@ApiProperty()
	paymentType: string

	@HasMany(() => PaymentTransaction)
	payments: PaymentTransaction[];
}
