import { Table, Column, PrimaryKey, Model, DataType, HasMany } from 'sequelize-typescript';
import { UUIDV4 } from 'sequelize/types';

@Table({
	tableName: "tblPaypalTransction"
})

export class PaypalTransction extends Model<PaypalTransction> {

	@Column({
		type: DataType.INTEGER,
		allowNull: false,
		// defaultValue:UUIDV4,//autoIncrement: true,
		unique: true,
		primaryKey: true,
	})
	
	paypalTransctionId: number

    @Column(DataType.TEXT)
    orderId: string
    
    @Column(DataType.DATE)
    createdAt: Date
    
    @Column(DataType.DATE)
    updateAt: Date
    
    @Column(DataType.TEXT)
    paymentType: string

    @Column(DataType.TEXT)
    status: string

    @Column(DataType.JSON)
    response: string

    @Column(DataType.BIGINT)
    transId: number
}
