import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull,BelongsTo, ForeignKey } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { EvaluationAttribute } from './EvaluationAttribute.entity';
  
const tableOptions: IDefineOptions = { tableName: 'tblratingattribute' } as IDefineOptions;
  
@Table(tableOptions)
  
export class RatingAttribute extends Model<RatingAttribute>{
  
    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    ratingattributeid:number;
    
	@ForeignKey(() => EvaluationAttribute)
    @Column(DataType.BIGINT)
    evaluationattributeid:number;

    @BelongsTo(() => EvaluationAttribute)
	evaluationAttribute: EvaluationAttribute;

    @AllowNull(false)
	@Column(DataType.ENUM('VENDOR','DISTRIBUTOR','RETAILER' ,'SALESREP','PRODUCT'))
    rating

}
