import { Channel } from './Channel.entity';
import {
    Table,
    Column,
    PrimaryKey,
    Model,
    AutoIncrement,
    DataType,
    BeforeCreate,
    AllowNull,
    Scopes,
    BeforeUpdate
} from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';

const tableOptions: IDefineOptions = { tableName: 'tblServiceList' } as IDefineOptions;

@Table(tableOptions)

@Scopes(() => ({
    serviceListInfom: {
        attributes: [['serviceListId', 'id'], ['serviceList', 'name']]
    },
    tradeinfo: {
        attributes: {
            exclude: ['deletedAt', 'createdAt', 'updatedAt']
        }
    }
}))

export class ServiceList extends Model<ServiceList>{

    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    serviceListId: number

    @Column
    serviceList: string

    @Column(DataType.DATE)
    createdAt: Date;

    @Column(DataType.DATE)
    updatedAt: Date;

    @Column(DataType.DATE)
    deletedAt: Date;
}
