import { Table, Column, PrimaryKey, Model, DataType, HasMany, Scopes } from 'sequelize-typescript';
import { ApiProperty } from '@nestjs/swagger';
import { UUIDV4 } from 'sequelize/types';

@Table({
	tableName: "tblSocialSite"
})

@Scopes(() => ({
    channelDetail: {
      attributes: ['socialSiteId', 'socialSite']
    }
}))
	
export class SocialSite extends Model<SocialSite> {
	static SOCIALSITE_LINKEDIN = 1;
	static SOCIALSITE_GOOGLEPLUS = 2;
	static SOCIALSITE_INSTAGRAM = 3;

	@Column({
		type: DataType.INTEGER,
		allowNull: false,
		// defaultValue:UUIDV4,//autoIncrement: true,
		unique: true,
		primaryKey: true,
	})
	@ApiProperty()
	socialSiteId: number

	@Column({ type: DataType.CHAR(255) })
	@ApiProperty()
	socialSite: string

	@Column(DataType.DATE)
	deletedAt: Date

	@Column(DataType.DATE)
	createdAt: Date

	@Column(DataType.DATE)
	updatedAt: Date
}
