import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, BeforeCreate, BeforeUpdate } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { ValidationException } from './../../../middleware/exception/Validation.exception';
var Sequelize = require('sequelize');

const tableOptions: IDefineOptions = { timestamp: true, tableName: 'tblSubscriptionExtraFeatureCategories' } as IDefineOptions;

@Table({
	tableName: "tblSubscriptionExtraFeatureCategories"
})

export class SubscriptionExtraFeatureCategory extends Model<SubscriptionExtraFeatureCategory>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	subscriptionExtraFeatureCategoryId: number

	@AllowNull(false)
	@Column(DataType.CHAR(255))
	subscriptionExtraFeatureCategory: string

	@Column(DataType.BIGINT())
	order: number

	@Column(DataType.STRING())
	isActive: string
	
	@Column(DataType.BIGINT)
    FeatureCategoryId:number
	
	@BeforeCreate
	@BeforeUpdate
	public static async dateUpdate(instance: SubscriptionExtraFeatureCategory) {
		let options = {
			where: {
				subscriptionFeatureCategory: {
					$ilike: instance.subscriptionExtraFeatureCategory.trim()
				}
			}
		};

		if (instance.subscriptionExtraFeatureCategoryId) {
			options['where']['subscriptionExtraFeatureCategoryId'] = {
				$not: instance.subscriptionExtraFeatureCategoryId
			}
		}

		
	}
}
