import { Table, Column, PrimaryKey, Model, DataType, HasMany } from 'sequelize-typescript';

import { ApiProperty } from '@nestjs/swagger';
import { UUIDV4 } from 'sequelize/types';



@Table({ timestamps: false,
	tableName: "tblSubscriptionType"
})
export class SubscriptionType extends Model<SubscriptionType> {

	@Column({
		type: DataType.INTEGER,
		allowNull: false,
		// defaultValue:UUIDV4,//autoIncrement: true,
		unique: true,
		primaryKey: true,
	})
	@ApiProperty()
	subscriptionTypeId: number

	@Column({
		type: DataType.CHAR(255),
		allowNull: false,
	})
	@ApiProperty()
	subscriptionType: string
}
