import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, ForeignKey, BelongsTo } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { ChannelType } from './ChannelType.entity';
  
const tableOptions: IDefineOptions = { tableName: 'tbluservisibilitytype' } as IDefineOptions;
  
@Table(tableOptions)
  
export class UserVisibilityType extends Model<UserVisibilityType>{
  
    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    uservisibilitytypeid:number
    
    @Column(DataType.CHAR(255))
    uservisibilitytype:string

	@ForeignKey(() => ChannelType)
	@Column(DataType.BIGINT)
	channeltypeid: number

	@BelongsTo(() => ChannelType)
	channelType: ChannelType[];
}
