import { Table, Column, Model, DataType, BeforeCreate, BeforeUpdate } from 'sequelize-typescript';
import { ApiProperty } from '@nestjs/swagger';
import { UUIDV4 } from 'sequelize/types';
var Sequelize = require('sequelize');

@Table({
	tableName: "tblWorkNature"
})
export class WorkNature extends Model<WorkNature> {

	@Column({
		type: DataType.INTEGER,
		allowNull: false,
		// defaultValue:UUIDV4,//autoIncrement: true,
		unique: true,
		primaryKey: true,
	})
	@ApiProperty()
	workNatureId: number

	@Column({type: DataType.CHAR(255)})
	@ApiProperty()
    workNature: string
    
    @Column(DataType.DATE)
    deletedAt:Date

    @Column(DataType.DATE)
    createdAt:Date

    @Column(DataType.DATE)
	updatedAt:Date
	
	@BeforeCreate 
	@BeforeUpdate 
	public static async dateUpdate(workNature: WorkNature, options: any) { 
		workNature.updatedAt = Sequelize.fn('NOW'); 
	}
}
