import { Module } from '@nestjs/common';
import { ConfigModule, ConfigService } from '@nestjs/config';
import { ClientProxyFactory, Transport } from '@nestjs/microservices';


export const algorithmProvider = [
	{
		provide: 'ALGORITHM_SERVICE',
      useFactory: (configService: ConfigService) => (
        ClientProxyFactory.create({
          transport: Transport.TCP,
          options: {
            //host: configService.get('108.128.56.81'),
            host: configService.get('localhost'),
            port: configService.get('4000'),
          }
        })
      ),
      inject: [ConfigService],
	}
];


