'use strict';

import { Channel } from '../models/Channel.entity';
import { OldChannel } from '../models/OldChannel.entity';
import { ChannelType } from '../models/ChannelType.entity';
import { ChannelSubscription } from '../models/ChannelSubscription.entity';
import { ChannelDetail } from '../models/ChannelDetail.entity';
import { ProfileType } from "../models/ProfileType.entity";
import { ProfileTypeClassification } from '../models/ProfileTypeClassification.entity';
import { ChannelCertificate } from '../models/ChannelCertificate.entity';
import { ChannelSocialLink } from '../models/ChannelSocialLink.entity';
import { ChannelB2B } from '../models/ChannelB2B.entity';
import { ChannelAward } from '../models/ChannelAward.entity';
import { ChannelLocation } from '../models/ChannelLocation.entity';
import { ChannelServiceList } from '../models/ChannelServiceList.entity';
import { ChannelProductCategorie } from '../models/ChannelProductCategorie.entity';
import { ChannelProductGroup } from '../models/ChannelProductGroup.entity';
import { ChannelCustomerProfile } from '../models/ChannelCustomerProfile.entity';
import { ChannelSpeciality } from '../models/ChannelSpeciality.entity';
import { ChannelBrand } from '../models/ChannelBrand.entity';
import { CertificateType } from '../models/CertificateType.entity';
import { WorkNature } from '../models/WorkNature.entity';
import { ShareType } from '../models/ShareType.entity';
import { ChannelContactSuggestion } from '../models/ChannelContactSuggestion.entity';
import { ChannelSuggestion } from '../models/ChannelSuggestion.entity';
import { SocialSite } from '../models/SocialSite.entity';
import { ChannelPaymentOptionType } from '../models/ChannelPaymentOptionType.entity';
import { ChannelPaymentTerm } from '../models/ChannelPaymentTerm.entity';
import { ChannelSamplePreferenceType } from '../models/ChannelSamplePreferenceType.entity';
import { ChannelSharePreference } from '../models/ChannelSharePreference.entity';
import { ChannelUserVisibility } from '../models/ChannelUserVisibility.entity';
import { PaymentOptionType } from '../models/PaymentOptionType.entity';
import { PaymentTerm } from '../models/PaymentTerm.entity';
import { ChannelDocument } from '../models/ChannelDocument.entity';
import { ChannelRecommended } from '../models/ChannelRecommended.entity';
import { KeyPartnerJCT } from '../models/KeyPartnerJCT.entity';
import { PaypalTransction } from '../models/PaypalTransction.entity';
import { BuyerNeed } from '../models/BuyerNeed.entity';
import { BuyerReqCategory } from '../models/BuyerReqCategory.entity';
import { CompanyMedia } from '../models/CompanyMedia.entity';
import { CompanyMediaImages } from '../models/CompanyMediaImages';
import { GuestRequirement } from '../models/GuestRequirement.entity';

export const channelProvider = [
	{
		provide: 'ChannelRepository',
		useValue: Channel
	}
];

export const oldChannelProvider = [
	{
		provide: 'OldChannelRepository',
		useValue: OldChannel
	}
];

export const ChannelTypeProviders = [
	{
		provide: 'ChannelTypeRepository',
		useValue: ChannelType
	},
];

export const ChannelSubscriptionProviders = [
	{
		provide: 'ChannelSubscriptionRepository',
		useValue: ChannelSubscription
	},
];

export const channelDetailProvider = [
	{
		provide: 'ChannelDetailRepository',
		useValue: ChannelDetail
	}
];

export const profileTypeProvider = [
	{
		provide: 'ProfileTypeRepository',
		useValue: ProfileType
	}
];

export const profileTypeClassificationProvider = [
	{
		provide: 'ProfileTypeClassificationRepository',
		useValue: ProfileTypeClassification
	}
];

export const channelCertificateProvider = [
	{
		provide: 'ChannelCertificateRepository',
		useValue: ChannelCertificate
	}
];

export const channelCertificateTypeProvider = [
	{
		provide: 'ChannelCertificateTypeRepository',
		useValue: CertificateType,
	}
];

export const channelSocialLinkProvider = [
	{
		provide: 'ChannelSocialLinkRepository',
		useValue: ChannelSocialLink
	}
];

export const channelB2BProvider = [
	{
		provide: 'ChannelB2BRepository',
		useValue: ChannelB2B
	}
];

export const channelAwardProvider = [
	{
		provide: 'ChannelAwardRepository',
		useValue: ChannelAward
	}
];

export const channelServiceListProvider = [
	{
		provide: 'ChannelServiceListRepository',
		useValue: ChannelServiceList
	}
];

export const channelProductCategorieProvider = [
	{
		provide: 'ChannelProductCategorieRepository',
		useValue: ChannelProductCategorie
	}
];

export const channelProductGroupProvider = [
	{
		provide: 'ChannelProductGroupRepository',
		useValue: ChannelProductGroup
	}
];

export const channelProductCatProvider = [
	{
		provide: 'ChannelProductCategoryRepository',
		useValue: ChannelProductCategorie
	}
];


export const channelCustomerProfileProvider = [
	{
		provide: 'ChannelCustomerProfileRepository',
		useValue: ChannelCustomerProfile
	}
];

export const ChannelLocationProvider = [
	{
		provide: 'ChannelLocationRepository',
		useValue: ChannelLocation,
	}
];

export const channelSpecialityProvider = [
	{
		provide: 'ChannelSpecialityRepository',
		useValue: ChannelSpeciality
	}
];

export const channelBrandProvider = [
	{
		provide: 'ChannelBrandRepository',
		useValue: ChannelBrand
	}
];

export const workNatureProvider = [
	{
		provide: 'WorkNatureRepository',
		useValue: WorkNature
	}
];

export const sharetypeProvider = [
	{
		provide: 'SharetypeRepository',
		useValue: ShareType
	}
];

export const channelContactSuggestionProvider = [
	{
		provide: 'ChannelContactSuggestionRepository',
		useValue: ChannelContactSuggestion
	}
];

export const channelSuggestionProvider = [
	{
		provide: 'ChannelSuggestionRepository',
		useValue: ChannelSuggestion
	}
];

export const socialSiteProvider = [
	{
		provide: 'SocialSiteRepository',
		useValue: SocialSite
	}
];

export const ChannelPaymentOptionTypeProvider = [
	{
		provide: 'ChannelPaymentOptionTypeRepository',
		useValue: ChannelPaymentOptionType
	}
];

export const PaymentOptionTypeProvider = [
	{
		provide: 'PaymentOptionTypeRepository',
		useValue: PaymentOptionType
	}
];

export const ChannelPaymentTermProvider = [
	{
		provide: 'ChannelPaymentTermRepository',
		useValue: ChannelPaymentTerm
	}
];

export const PaymentTermProvider = [
	{
		provide: 'PaymentTermRepository',
		useValue: PaymentTerm
	}
];

export const ChannelSamplePreferenceTypeProvider = [
	{
		provide: 'ChannelSamplePreferenceTypeRepository',
		useValue: ChannelSamplePreferenceType
	},
];

export const ChannelSharePreferenceProvider = [
	{
		provide: 'ChannelSharePreferenceRepository',
		useValue: ChannelSharePreference
	},
];

export const ChannelUserVisibilityProvider = [
	{
		provide: 'ChannelUserVisibilityRepository',
		useValue: ChannelUserVisibility
	},
];

export const ChannelDocumentProvider = [
	{
		provide: 'ChannelDocumentRepository',
		useValue: ChannelDocument
	},
];

export const ChannelRecommendedProvider = [
	{
		provide: 'ChannelRecommendedRepository',
		useValue: ChannelRecommended
	},
];

export const KeyPartnerJCTProvider = [
	{
		provide: 'KeyPartnerJCTRepository',
		useValue: KeyPartnerJCT
	},
];
export const PaypalTransctionProvider = [
	{
		provide: 'PaypalTransctionRepository',
		useValue: PaypalTransction
	},
];	

export const buyerNeedProvider = [
	{
		provide: 'BuyerRepository',
		useValue: BuyerNeed
	}
];
export const buyerReqCategoryProvider = [
	{
		provide: 'BuyerCategoryRepository',
		useValue: BuyerReqCategory
	}
];
export const CompanyMediaProvider = [
	{
		provide: 'CompanyMediaRepository',
		useValue: CompanyMedia
	},
];
export const CompanyMediaImagesProvider = [
	{
		provide: 'CompanyMediaImagesRepository',
		useValue: CompanyMediaImages
	}
]

export const GuestRequirementProvider = [
	{
		provide: 'GuestRequirementRepository',
		useValue: GuestRequirement
	}
]