'use strict';

import { Region } from 'src/modules/common/models/Region.entity';
import { RegionCountryJCT } from 'src/modules/common/models/RegionCountryJCT.entity';
import { Brand } from 'src/modules/product/models/Brand.entity';
import { ProductCategory } from 'src/modules/product/models/ProductCategory.entity';
import { ProductGroup } from 'src/modules/product/models/ProductGroup.entity';
import { Contact } from 'src/modules/user/models/Contact.entity';
import { ContactInterestedProductCategory } from 'src/modules/user/models/ContactInterestedProductCategory.entity';
import { ContactInterestedProductGroup } from 'src/modules/user/models/ContactInterestedProductGroup.entity';
import { User } from 'src/modules/user/models/User.entity';
import { ChannelBrand } from '../models/ChannelBrand.entity';
import { ChannelCertificate } from '../models/ChannelCertificate.entity';
import { ChannelCustomerProfile } from '../models/ChannelCustomerProfile.entity';
import { ChannelDetail } from '../models/ChannelDetail.entity';
import { ChannelLocation } from '../models/ChannelLocation.entity';
import { ChannelProductCategorie } from '../models/ChannelProductCategorie.entity';
import { ChannelProductGroup } from '../models/ChannelProductGroup.entity';
import { ProfileRatings } from '../models/ProfileCreationRating.entity';
import { ProfileList } from '../models/ProfileList.entity';
import { ProfileType } from '../models/ProfileType.entity';
import { ProfileTypeClassification } from '../models/ProfileTypeClassification.entity';

export const settingProvider = [
  {
    provide: 'SettingRepository',
    useValue: ProfileRatings,
  },
  {
    provide: 'ProfileRepository',
    useValue: ProfileList,
  },

  {
    provide: 'ChannelDetailRepository',
    useValue: ChannelDetail,
  },
  {
    provide: 'ChannelCertiRepository',
    useValue: ChannelCertificate,
  },

  {
    provide: 'ChannelBrandRepository',
    useValue: ChannelBrand,
  },

  {
    provide: 'ChannelCustomerProfileRepository',
    useValue: ChannelCustomerProfile,
  },

  // {
	// 	provide: 'BrandRepository',
	// 	useValue: Brand,
	// },
	{
		provide: 'ProductGroupRepository',
		useValue: ProductGroup,
	},
	{
		provide: 'ProfileTypeRepository',
		useValue: ProfileType,
	},
	{
		provide: 'ProfileTypeClassiRepository',
		useValue: ProfileTypeClassification,
	},	
	{
		provide: 'ProductCategoryRepository',
		useValue: ProductCategory,
  },
  {
		provide: 'RegionRepository',
		useValue: Region,
  },
  {
		provide: 'RegionCtyJctRepository',
		useValue: RegionCountryJCT,
  },
  {
		provide: 'ChannelLocationRepository',
		useValue: ChannelLocation,
  },
  {
		provide: 'ChannelProductGroupRepository',
		useValue: ChannelProductGroup,
  },  
  {
		provide: 'ChannelProductCategoryRepository',
		useValue: ChannelProductCategorie,
  },

  {
		provide: 'ContactProductGroupRepository',
		useValue: ContactInterestedProductGroup,
  },
  
  {
		provide: 'ContactProductCategoryRepository',
		useValue: ContactInterestedProductCategory,
  },  

  {
		provide: 'UserRepository',
		useValue: User,
  },  

  {
		provide: 'ContactRepository',
		useValue: Contact,
  },  

  
  
  
  
];


