'use strict';

import { Subscription } from '../models/Subscription.entity';
import { SubscriptionType } from '../models/SubscriptionType.entity';
import { SubscriptionDetail } from '../models/SubscriptionDetail.entity';
import { SubscriptionFeatures } from '../models/SubscriptionFeatures.entity';
import { SubscriptionPlan } from '../models/SubscriptionPlan.entity';
import { SubscriptionPeriod } from '../models/SubscriptionPeriod.entity';
import { Coupon } from '../models/Coupon.entity';
import { AutoRenewalTracking } from '../models/AutoRenewalTracking.entity';
import { AutoRenewalTrackingStatus } from '../models/AutoRenewalTrackingStatus.entity';
import { SubscriptionFeatureCategory } from '../models/SubscriptionFeatureCategory.entity';
import { SubscriptionExtraFeature } from '../models/SubscriptionExtraFeature.entity';
import { SubscriptionExtraFeatureCategory } from '../models/SubscriptionExtraFeatureCategories.entity';

export const SubscriptionProviders = [
  {
    provide: 'SubscriptionRepository',
    useValue: Subscription,
  },
];

export const SubscriptionTypeProviders = [
  {
    provide: 'SubscriptionTypeRepository',
    useValue: SubscriptionType,
  }
];

export const SubscriptionDetailProviders = [
  {
    provide: 'SubscriptionDetailRepository',
    useValue: SubscriptionDetail,
  },
];

export const SubscriptionFeatureCategoryProviders = [
  {
    provide: 'SubscriptionFeatureCategoryRepository',
    useValue: SubscriptionFeatureCategory,
  },
];

export const SubscriptionFeaturesProviders = [
  {
    provide: 'SubscriptionFeaturesRepository',
    useValue: SubscriptionFeatures,
  },
];

export const SubscriptionPlanProviders = [
  {
    provide: 'SubscriptionPlanRepository',
    useValue: SubscriptionPlan,
  },
];

export const SubscriptionPeriodProviders = [
  {
    provide: 'SubscriptionPeriodRepository',
    useValue: SubscriptionPeriod,
  },
];

export const CouponProviders = [
  {
    provide: 'CouponRepository',
    useValue: Coupon,
  }
];

export const AutoRenewalTrackingStatusProviders = [
  {
    provide: 'AutoRenewalTrackingStatusRepository',
    useValue: AutoRenewalTrackingStatus,
  },
];

export const AutoRenewalTrackingProviders = [
  {
    provide: 'AutoRenewalTrackingRepository',
    useValue: AutoRenewalTracking,
  },
];

export const SubscriptionExtraFeatureProviders = [
  {
    provide: 'SubscriptionExtraFeatureRepository',
    useValue: SubscriptionExtraFeature,
  },
];

export const SubscriptionExtraFeatureCategoryProviders = [
  {
    provide: 'SubscriptionExtraFeatureCategoryRepository',
    useValue: SubscriptionExtraFeatureCategory,
  },
];

