'use strict';

import { Inject, Injectable } from '@nestjs/common';
import { isArray } from 'lodash';
import { QueryTypes } from "sequelize";
@Injectable()
export class ChannelKeyPartnerService {

	constructor(
		@Inject('SequelizeInstance') private readonly sequelizeInstance,
	) { }
	public async searchRetailer(pagination, partner_type) {
		return await this.sequelizeInstance.query('select * from "fnfindkeyretailer"(:keyword, :channelType,\':limit\', \':offset\', :cdnUrl)', {
			type: QueryTypes.SELECT,
			replacements: {
				keyword: (pagination.search) ? pagination.search : '',
				channelType: partner_type,
				limit: pagination.limit,
				offset: pagination.offset,
				cdnUrl: process.env.CDN_URL
			}
		}).then((results) => {
			return results[0].fnfindkeyretailer;
		});
	}

	public async getKeyRetailers(channelId, partnerType) {
		return await this.sequelizeInstance.query('select * from "fnGetKeyPartnersbyChannelId"(:channelId, :partnerType, :productId, :cdnUrl)', {
			type: QueryTypes.SELECT,
			replacements: {
				channelId: channelId,
				productId: null,
				cdnUrl: process.env.CDN_URL,
				partnerType: partnerType
			}
		}).then((results) => {
			return (results && results[0] && isArray(results[0].fnGetKeyPartnersbyChannelId) && results[0].fnGetKeyPartnersbyChannelId.length > 0) ? results[0].fnGetKeyPartnersbyChannelId.map((x) => {
				if(x.active != null) {
					x.weight = 3
				} else if(x.old != null) {
					x.weight = 2
				} else {
					x.weight = 1
				}

				return x;
			}).sort((a, b) => (a.weight > b.weight) ? -1 : 1) : results[0].fnGetKeyPartnersbyChannelId;
		});
	}
}
