//import { BaseTransformation } from "../../../core/transformation/BaseTransformation";
import { Media } from '../../../media/models/Media.entity';
import { ProcessException } from '../../../../middleware/exception/Process.exception';
import { Contact } from '../../../user/models/Contact.entity';
import { Claim } from '../../models/Claim.entity';
import { ClaimDocument } from '../../models/ClaimDocument.entity';
import { SignUpHistory } from '../../../user/models/SignUpHistory.entity';
import { Channel } from "../../models/Channel.entity";

export interface IChannelSerivceInBound {

    /**
    * @description: Document model obejct return .
    * @param {docTempPath:string}
    * @param {doctype:number}
    * @param {folderPath?:folderPath}
    * @return {Promise<Media>}
    */
	setDocumentObject(docTempPath: string, doctype: number, folderPath?: string): Promise<Media>;


    /**
    * @description: Contact model obejct return.
    * @param {contactPrams: any}
    * @param {documentId: number}
    * @return {Promise<Contact>}
    */
	setContactObject(contactPrams: any, documentId: number): Promise<Contact>;


    /**
    * @description: Claim model obejct return.
    * @param {channalPrams: any}
    * @param {channalId: number}
    * @return {Promise<Claim>}
    */
	setClaimObject(channalPrams: any, channalId: number): Promise<Claim>;


    /**
    * @description: ClaimDocument model obejct return.
    * @param {claimId: number}
    * @param {documentId: number}
    * @return {Promise<ClaimDocument>}
    */
	setClaimDocObject(claimId: number, documentId: number): Promise<ClaimDocument>;


    /**
    * @description: SignUpHistory model obejct return.
    * @param { claimId: number}
    * @param { channelId: number}
    * @return {Promise<SignUpHistory>}
    */
	setSingUpHistoryObject(claimId: number, channelId: number, userId: number): Promise<SignUpHistory>;


    /**
    * @description: Channel model obejct return.
    * @param {signUpStatus: number}
    * @param {channel:any}
    * @param {regAddressId: number}
    * @param {channelId: number}
    * @return {Promise<Channel>}
    */
	setchannalObject(signUpStatus: number, channel: any, regAddressId: number, channelId: number): Promise<Channel>;
}
