//import { BaseTransformation } from "../../../core/transformation/BaseTransformation";
import { Media } from '../../../media/models/Media.entity';
import { ProcessException } from '../../../../middleware/exception/Process.exception';
import { Contact } from '../../../user/models/Contact.entity';
import { Claim } from '../../models/Claim.entity';
import { ClaimDocument } from '../../models/ClaimDocument.entity';
import { SignUpHistory } from '../../../user/models/SignUpHistory.entity';
import { Channel } from "../../models/Channel.entity";
import { ChannelProductGroup } from '../../models/ChannelProductGroup.entity';
import { ChannelProductCategorie } from '../../models/ChannelProductCategorie.entity';
import { ChannelServiceList } from '../../models/ChannelServiceList.entity';
import { ChannelDetail } from '../../models/ChannelDetail.entity';

export interface ITradeInformationInBound {

    /**
    * @description: Document model obejct return .
    * @param {productFamilies:array}
    * @param {channelId:number}
    * @return {Promise<ChannelProductGroup>}
    */
	setProductGroup(productFamilies: any, channelId: number): Promise<ChannelProductGroup[]>;

    /**
    * @description: Document model obejct return .
    * @param {docTempPath:string}
    * @param {doctype:number}
    * @param {folderPath?:folderPath}
    * @return {Promise<Media>}
    */
	setDocumentObject(docTempPath: string, doctype: number, folderPath?: string): Promise<Media>;

}
