
// import { BaseTransformation } from "../../core/transformation/BaseTransformation";
import { User } from "../../user/models/User.entity";
import { join, defaultTo } from 'lodash';

export class ChannelHubDetailOutBound {
	constructor() {
	}

	async channelDetail(params, user, userProductCat, companyImages): Promise<any> {
		console.log('params.channelDetail.phone1',params.channelDetail)
		let returnObject = new Object;
		let channelImages=[];
		if(companyImages.length>0){
			companyImages.map(x=>{
			channelImages.push({documentId: x.documentId, companyMediaId: x.companyMediaId, documentUrl:x.document.documentUrl });
		})
		}
		returnObject['companyDesc'] = params.channelDetail.companyDesc;
		returnObject['companyImages'] = channelImages;
		returnObject['channelB2B'] = params.channelB2B;
		returnObject['createdAt'] = params.createdAt;
		returnObject['channelId'] = params.channelId;
		returnObject['regAddress'] = params.regAddress;
		returnObject['phoneno'] = params.channelDetail.phone1;
		returnObject['mobileNo'] =  params.channelDetail.mobileNo;
		returnObject['companyName'] = params.companyName;
		returnObject['companyMail'] = params.companyMail;
		returnObject['isActive'] = params.isActive;
		returnObject['isFrenchTech'] = params.isFrenchTech;
		returnObject['signUpStatus'] = params.signUpStatus.signUpStatus;
		returnObject['channelTypeId'] = params.channelTypeId;
		returnObject['channelType'] = params.channelType.channelType;
		returnObject['country'] = params.country.country;
		returnObject['phoneCode'] = params.country.phoneCode;
		returnObject['isoCode'] = params.country.isoCode;
		returnObject['profileType'] = (params.profileType) ? params.profileType.profileType : null;
		returnObject['oldChannelId'] = params.oldChannelId;
		returnObject['channelLogo'] = (params.channelDetail && params.channelDetail.channelLogo) ? params.channelDetail.channelLogo.documentUrl : null;
		returnObject['channelIcon'] = (params.channelDetail && params.channelDetail.channelIcon) ? params.channelDetail.channelIcon.documentUrl : null;
		returnObject['webSiteUrl'] = params.channelDetail.webSiteUrl;
		returnObject['estYear'] = params.channelDetail.estYear;
		returnObject['aboutUs'] = params.channelDetail.detailDesc;
		returnObject['expectations'] = (params.channelDetail.expectations) ? params.channelDetail.expectations : null;
		returnObject['empCntRange'] = params.channelDetail.empCntRange;
		returnObject['empCnt'] = params.channelDetail.empCnt;
		returnObject['channelBanner'] = (params.channelDetail && params.channelDetail.channelBanner) ? params.channelDetail.channelBanner.documentUrl : null;
		returnObject['linkedInBanner'] = (params.channelDetail && params.channelDetail.bannerURL) ? params.channelDetail.bannerURL : null;

		returnObject['no_of_skus'] = params.channelDetail.no_of_skus;
		returnObject['no_of_vendors'] = params.channelDetail.no_of_vendors;
		returnObject['no_of_distributors'] = params.channelDetail.no_of_distributors;
		returnObject['no_of_retailers'] = params.channelDetail.no_of_retailers;
		returnObject['no_of_resellers'] = params.channelDetail.no_of_resellers;

		returnObject['empCntDSale'] = params.channelDetail.empCntDSale;
		returnObject['empCntISale'] = params.channelDetail.empCntISale;
		returnObject['empCntDMar'] = params.channelDetail.empCntDMar;
		returnObject['empCntIMar'] = params.channelDetail.empCntIMar;
		returnObject['storeCount'] = params.channelDetail.storeCount;
		returnObject['revD'] = params.channelDetail.revD;
		returnObject['revI'] = params.channelDetail.revI;
		returnObject['turnoverRange'] = params.channelDetail.turnoverRange;
		returnObject['turnover'] = params.channelDetail.turnover;
		returnObject['regYear'] = params.channelDetail.regYear;
		returnObject['turnoverPhyStore'] = params.channelDetail.turnoverPhyStore;
		returnObject['turnoverOnStore'] = params.channelDetail.turnoverOnStore;
		returnObject['startup'] = params.channelDetail.startup;		
		returnObject['maturitylevel'] = join(params.channelDetail.maturitylevel, ',');
		returnObject['keyretailers'] = params.channelDetail.keyretailers;
		returnObject['keyresellers'] = params.channelDetail.keyresellers;
		returnObject['keydistributors'] = params.channelDetail.keydistributors;		
		returnObject['introvideo'] = (params.channelDetail && params.channelDetail.introvideo) ? params.channelDetail.introvideo.documentUrl : null;

		returnObject['isOEM'] = params.isOEM;

		if (params.retailerCount || params.retailerCount == 0) { returnObject['retailerCount'] = params.retailerCount; }
		if (params.distributorCount || params.distributorCount == 0) { returnObject['distributorCount'] = params.distributorCount; }
		if (params.vendorCount || params.vendorCount == 0) { returnObject['vendorCount'] = params.vendorCount; }
		if (params.productCount || params.productCount == 0) { returnObject['productCount'] = params.productCount; }
		if (params.sampleOrderCount || params.sampleOrderCount == 0) { returnObject['sampleOrderCount'] = params.sampleOrderCount; }
		if (params.sampleEvaluationCount || params.sampleEvaluationCount == 0) { returnObject['sampleEvaluationCount'] = params.sampleEvaluationCount; }

		returnObject['tradeInformationIds'] = {};
		returnObject['tradeInformationIds']['brand'] = [];

		if (params.channelBrand.length > 0) {
			returnObject['channelBrand'] = [];
				for (let ii = 0; ii < params.channelBrand.length; ii++) {
					if (params.channelBrand[ii].brand) {
					returnObject['channelBrand'].push(params.channelBrand[ii].brand.brandName);
					}
				}
		}

		/* Need to add when rating and review count added */
		returnObject['rating'] = 0;
		returnObject['reviewCount'] = 0;

		returnObject['subscriptionPlan'] = (params.channelSubscription && params.channelSubscription.subscription) ? params.channelSubscription.subscription.subscriptionPlan.dataValues.subscriptionPlanType : null;
		returnObject['subscriptionDetails'] = (params.channelSubscription) ? params.channelSubscription : null;
		//returnObject['subscriptionPlan'] = params.plan.subscriptionPlanType;

		returnObject['tradeInformation'] = {};

		returnObject['tradeInformation']['existingCategories'] = [];

		returnObject['tradeInformationIds']['productGroup'] = [];
		returnObject['tradeInformationIds']['productCategory'] = [];
		returnObject['tradeInformationIds']['speciality'] = [];
		returnObject['tradeInformationIds']['service'] = [];
		returnObject['tradeInformationIds']['locations'] = [];

		if (params.speciality.length > 0) {
			returnObject['tradeInformation']['speciality'] = [];
			for (let ii = 0; ii < params.speciality.length; ii++) {
				//for (let jj = 0; jj < params.channelSpeciality[ii].productGroup.length; jj++) {
				returnObject['tradeInformation']['speciality'].push(params.speciality[ii].productGroup);
				returnObject['tradeInformationIds']['speciality'].push(params.speciality[ii].productGroupId);
				//returnObject['tradeInformation']['existingCategories'].push(params.channelSpeciality[ii].productGroup.productGroup);
				returnObject['tradeInformationIds']['productGroup'].push(params.speciality[ii].productGroupId);
				//}
			}
		}

		/* Need to add the Interest Categories after approval */
		returnObject['tradeInformation']['userProductCategories'] = [];
		returnObject['tradeInformationIds']['userProductCategories']=[];
		if (userProductCat.length > 0) {
			for (let ii = 0; ii < userProductCat.length; ii++) {
				returnObject['tradeInformation']['userProductCategories'].push(userProductCat[ii].productCategorie);
				returnObject['tradeInformationIds']['userProductCategories'].push(userProductCat[ii].productCategorieId);
			}
		}

		returnObject['tradeInformation']['interestedCategories'] = [];

		if (params.productCategory.length > 0) {
			for (let ii = 0; ii < params.productCategory.length; ii++) {
				returnObject['tradeInformation']['existingCategories'].push(params.productCategory[ii].productCategorie);
				returnObject['tradeInformationIds']['productCategory'].push(params.productCategory[ii].productCategorieId);
				if( !returnObject['tradeInformationIds']['userProductCategories'].includes(params.productCategory[ii].productCategorieId)){
					returnObject['tradeInformation']['userProductCategories'].push(params.productCategory[ii].productCategorie);
				}
			}
		}

		if (params.customerProfile.length > 0) {

			let btype = [];
			let profiles;
			if ((params.channelTypeId == 2 || params.channelTypeId == 3) && (params.isOEM == 1 || params.isOEM == 3)) {
				profiles = params.customerProfile.filter(pro => { return [4].includes(+pro.channelTypeId) });
				returnObject['tradeInformation']['retailerProfile'] = [];
				for (let ii = 0; ii < profiles.length; ii++) {
					if (profiles[ii].profileType.trim()) {
						returnObject['tradeInformation']['retailerProfile'].push(profiles[ii].profileType);
					}
				}
			}
			if ((params.channelTypeId == 2 || params.channelTypeId == 3) && (params.isOEM == 2 || params.isOEM == 3)) {
				profiles = params.customerProfile.filter(pro => { return [5].includes(+pro.channelTypeId) });
				returnObject['tradeInformation']['resellerProfile'] = [];
				for (let ii = 0; ii < profiles.length; ii++) {
					if (profiles[ii].profileType) {
						returnObject['tradeInformation']['resellerProfile'].push(profiles[ii].profileType);
					}
				}
			}
			if((params.channelTypeId != 2 && params.channelTypeId != 3)) {
				profiles = params.customerProfile;
				returnObject['tradeInformation']['customerProfile'] = [];
				for (let ii = 0; ii < profiles.length; ii++) {
				if (profiles[ii].profileType) {
					returnObject['tradeInformation']['customerProfile'].push(profiles[ii].profileType);
				}
			}
		}
		}

		if (params.serviceList && params.serviceList.length > 0) {
			returnObject['tradeInformation']['service'] = [];
			for (let ii = 0; ii < params.serviceList.length; ii++) {
				if (params.serviceList[ii].serviceList) {
					returnObject['tradeInformation']['service'].push(params.serviceList[ii].serviceList);
					returnObject['tradeInformationIds']['service'].push(params.serviceList[ii].serviceListId);
				}
			}
		}

		params.channelLocation.sort(function (a, b) {
			return a.RegionCountryJCT.country.priority > b.RegionCountryJCT.country.priority ? 1 : -1;
		});

		if (params.channelLocation.length > 0) {
			returnObject['locations'] = {}; 
			returnObject['locations']['SELLING'] = [];
			returnObject['locations']['TARGET'] = [];
			returnObject['locations']['RETAIL'] = [];
			for (let ii = 0; ii < params.channelLocation.length; ii++) {
				if (params.channelLocation[ii].locationType == 'SELLING') {
					returnObject['locations']['SELLING'].push(params.channelLocation[ii].RegionCountryJCT.country.country);
					returnObject['tradeInformationIds']['locations'].push((params.channelLocation[ii].RegionCountryJCT.countryId));
				} else if (params.channelLocation[ii].locationType == 'TARGET') {
					returnObject['locations']['TARGET'].push(params.channelLocation[ii].RegionCountryJCT.country.country);
					returnObject['tradeInformationIds']['locations'].push((params.channelLocation[ii].RegionCountryJCT.countryId));
				} else if (params.channelLocation[ii].locationType == 'RETAIL') {
					returnObject['locations']['RETAIL'].push(params.channelLocation[ii].RegionCountryJCT.country.country);
					returnObject['tradeInformationIds']['locations'].push((params.channelLocation[ii].RegionCountryJCT.countryId));
				}
			}
		}

		if (returnObject['tradeInformationIds']['locations']) {
			returnObject['tradeInformationIds']['locations'] = returnObject['tradeInformationIds']['locations'].filter((obj, pos, arr) => {
				return arr.map(mapObj => mapObj).indexOf(obj) === pos;
			});
		}

		if (params.channelSocial.length > 0) {
			returnObject['socialLinks'] = [];
			for (let ii = 0; ii < params.channelSocial.length; ii++) {
				returnObject['socialLinks'].push({ 'social': params.channelSocial[ii].socialSite.socialSite, 'link': params.channelSocial[ii].channelSocialLink });
			}
		}
		if (returnObject['tradeInformationIds']['productGroup']) {
			returnObject['tradeInformationIds']['productGroup'] = returnObject['tradeInformationIds']['productGroup'].filter((obj, pos, arr) => {
				return arr.map(mapObj => mapObj).indexOf(obj) === pos;
			});
		}

		returnObject['awards'] = params.channelAward;

		if (params.channelCertificate.length > 0) {
			returnObject['certificate'] = {};
			returnObject['certificate']['Registration'] = [];
			returnObject['certificate']['Tax'] = [];
			for (let ii = 0; ii < params.channelCertificate.length; ii++) {
				let certificateType: string;
				params.certificateType.map(function(data, index) {
					if (data.cerificateTypeId == params.channelCertificate[ii].cerificateTypeId) {
						certificateType = data.cerificateType;
					}
				});
				returnObject['certificate'][certificateType].push(params.channelCertificate[ii]);
			}
		}

		returnObject['userDefaultContact'] = null;
		returnObject['channelJCT'] = null;
		returnObject['connectionStatusTypeId'] = null;
		returnObject['pendingApprovalInOutBound'] = null;

		if (params.channelJCT || params.channelJCTPartner) {
			if (params.channelJCT && params.channelJCT.channelId == user.channelId) {
				returnObject['channelJCT'] = params.channelJCT.channelJCTId;
				returnObject['connectionStatusTypeId'] = params.channelJCT.connectionStatusTypeId;
				returnObject['isConfidential'] = params.channelJCT.isConfidential;
				returnObject['pendingApprovalInOutBound'] = 'OUT';
				returnObject['relation_tag'] = params.channelJCT.leadManagementTag;
				if (params.channelJCT.contactJCT) {
					returnObject['userDefaultContact'] = params.channelJCT.contactJCT.partnerContactId;
				}
			} else if (params.channelJCTPartner && params.channelJCTPartner.partnerChannelId == user.channelId) {
				returnObject['channelJCT'] = params.channelJCTPartner.channelJCTId;
				returnObject['connectionStatusTypeId'] = params.channelJCTPartner.connectionStatusTypeId;
				returnObject['pendingApprovalInOutBound'] = 'IN';
				returnObject['relation_tag'] = params.channelJCTPartner.partnerLeadManagementTag;
				if (params.channelJCTPartner.contactJCT) {
					returnObject['userDefaultContact'] = params.channelJCTPartner.contactJCT.partnerContactId;
				}
			}
		}

		returnObject['channelKeyRetailer'] = params.channelKeyRetailer;
		returnObject['channelKeyReseller'] = params.channelKeyReseller;
		returnObject['channelKeyDistributor'] = params.channelKeyDistributor;
		returnObject['channelDocuments'] = defaultTo(params.channelDocument, []);

		return returnObject;
	}

	async publicChannelDetail(params, userProductCat, companyImages): Promise<any> {
		console.log('params.channelDetail.phone1',params.channelDetail)
		let returnObject = new Object;
	
		let channelImages=[];
		if(companyImages.length>0){
			companyImages.map(x=>{
			channelImages.push({documentId: x.documentId, companyMediaId: x.companyMediaId, documentUrl:x.document.documentUrl });
		})
		}
		returnObject['companyDesc'] = params.channelDetail.companyDesc;
		returnObject['companyImages'] = channelImages;
		returnObject['channelB2B'] = params.channelB2B;
		returnObject['createdAt'] = params.createdAt;
		returnObject['channelId'] = params.channelId;
		returnObject['regAddress'] = params.regAddress;
		returnObject['phoneno'] = params.channelDetail.phone1;
		returnObject['mobileNo'] =  params.channelDetail.mobileNo;
		returnObject['companyName'] = params.companyName;
		returnObject['companyMail'] = params.companyMail;
		returnObject['isActive'] = params.isActive;
		returnObject['isFrenchTech'] = params.isFrenchTech;
		returnObject['signUpStatus'] = params.signUpStatus.signUpStatus;
		returnObject['channelTypeId'] = params.channelTypeId;
		returnObject['channelType'] = params.channelType.channelType;
		returnObject['country'] = params.country.country;
		returnObject['phoneCode'] = params.country.phoneCode;
		returnObject['isoCode'] = params.country.isoCode;
		returnObject['profileType'] = (params.profileType) ? params.profileType.profileType : null;
		returnObject['oldChannelId'] = params.oldChannelId;
		returnObject['channelLogo'] = (params.channelDetail && params.channelDetail.channelLogo) ? params.channelDetail.channelLogo.documentUrl : null;
		returnObject['channelIcon'] = (params.channelDetail && params.channelDetail.channelIcon) ? params.channelDetail.channelIcon.documentUrl : null;
		returnObject['webSiteUrl'] = params.channelDetail.webSiteUrl;
		returnObject['estYear'] = params.channelDetail.estYear;
		returnObject['aboutUs'] = params.channelDetail.detailDesc;
		returnObject['expectations'] = (params.channelDetail.expectations) ? params.channelDetail.expectations : null;
		returnObject['empCntRange'] = params.channelDetail.empCntRange;
		returnObject['empCnt'] = params.channelDetail.empCnt;
		returnObject['channelBanner'] = (params.channelDetail && params.channelDetail.channelBanner) ? params.channelDetail.channelBanner.documentUrl : null;
		returnObject['linkedInBanner'] = (params.channelDetail && params.channelDetail.bannerURL) ? params.channelDetail.bannerURL : null;

		returnObject['no_of_skus'] = params.channelDetail.no_of_skus;
		returnObject['no_of_vendors'] = params.channelDetail.no_of_vendors;
		returnObject['no_of_distributors'] = params.channelDetail.no_of_distributors;
		returnObject['no_of_retailers'] = params.channelDetail.no_of_retailers;
		returnObject['no_of_resellers'] = params.channelDetail.no_of_resellers;

		returnObject['empCntDSale'] = params.channelDetail.empCntDSale;
		returnObject['empCntISale'] = params.channelDetail.empCntISale;
		returnObject['empCntDMar'] = params.channelDetail.empCntDMar;
		returnObject['empCntIMar'] = params.channelDetail.empCntIMar;
		returnObject['storeCount'] = params.channelDetail.storeCount;
		returnObject['revD'] = params.channelDetail.revD;
		returnObject['revI'] = params.channelDetail.revI;
		returnObject['turnoverRange'] = params.channelDetail.turnoverRange;
		returnObject['turnover'] = params.channelDetail.turnover;
		returnObject['regYear'] = params.channelDetail.regYear;
		returnObject['turnoverPhyStore'] = params.channelDetail.turnoverPhyStore;
		returnObject['turnoverOnStore'] = params.channelDetail.turnoverOnStore;
		returnObject['startup'] = params.channelDetail.startup;		
		returnObject['maturitylevel'] = join(params.channelDetail.maturitylevel, ',');
		returnObject['keyretailers'] = params.channelDetail.keyretailers;
		returnObject['keyresellers'] = params.channelDetail.keyresellers;
		returnObject['keydistributors'] = params.channelDetail.keydistributors;		
		returnObject['introvideo'] = (params.channelDetail && params.channelDetail.introvideo) ? params.channelDetail.introvideo.documentUrl : null;

		returnObject['isOEM'] = params.isOEM;

		if (params.retailerCount || params.retailerCount == 0) { returnObject['retailerCount'] = params.retailerCount; }
		if (params.distributorCount || params.distributorCount == 0) { returnObject['distributorCount'] = params.distributorCount; }
		if (params.vendorCount || params.vendorCount == 0) { returnObject['vendorCount'] = params.vendorCount; }
		if (params.productCount || params.productCount == 0) { returnObject['productCount'] = params.productCount; }
		if (params.sampleOrderCount || params.sampleOrderCount == 0) { returnObject['sampleOrderCount'] = params.sampleOrderCount; }
		if (params.sampleEvaluationCount || params.sampleEvaluationCount == 0) { returnObject['sampleEvaluationCount'] = params.sampleEvaluationCount; }

		returnObject['tradeInformationIds'] = {};
		returnObject['tradeInformationIds']['brand'] = [];

		if (params.channelBrand.length > 0) {
			returnObject['channelBrand'] = [];
				for (let ii = 0; ii < params.channelBrand.length; ii++) {
					if (params.channelBrand[ii].brand) {
					returnObject['channelBrand'].push(params.channelBrand[ii].brand.brandName);
					}
				}
		}

		/* Need to add when rating and review count added */
		returnObject['rating'] = 0;
		returnObject['reviewCount'] = 0;

		returnObject['subscriptionPlan'] = (params.channelSubscription && params.channelSubscription.subscription) ? params.channelSubscription.subscription.subscriptionPlan.dataValues.subscriptionPlanType : null;
		returnObject['subscriptionDetails'] = (params.channelSubscription) ? params.channelSubscription : null;
		//returnObject['subscriptionPlan'] = params.plan.subscriptionPlanType;

		returnObject['tradeInformation'] = {};

		returnObject['tradeInformation']['existingCategories'] = [];

		returnObject['tradeInformationIds']['productGroup'] = [];
		returnObject['tradeInformationIds']['productCategory'] = [];
		returnObject['tradeInformationIds']['speciality'] = [];
		returnObject['tradeInformationIds']['service'] = [];
		returnObject['tradeInformationIds']['locations'] = [];

		if (params.speciality.length > 0) {
			returnObject['tradeInformation']['speciality'] = [];
			for (let ii = 0; ii < params.speciality.length; ii++) {
				//for (let jj = 0; jj < params.channelSpeciality[ii].productGroup.length; jj++) {
				returnObject['tradeInformation']['speciality'].push(params.speciality[ii].productGroup);
				returnObject['tradeInformationIds']['speciality'].push(params.speciality[ii].productGroupId);
				//returnObject['tradeInformation']['existingCategories'].push(params.channelSpeciality[ii].productGroup.productGroup);
				returnObject['tradeInformationIds']['productGroup'].push(params.speciality[ii].productGroupId);
				//}
			}
		}

		/* Need to add the Interest Categories after approval */
		returnObject['tradeInformation']['userProductCategories'] = [];
		returnObject['tradeInformationIds']['userProductCategories']=[];
		if (userProductCat.length > 0) {
			for (let ii = 0; ii < userProductCat.length; ii++) {
				returnObject['tradeInformation']['userProductCategories'].push(userProductCat[ii].productCategorie);
				returnObject['tradeInformationIds']['userProductCategories'].push(userProductCat[ii].productCategorieId);
			}
		}

		returnObject['tradeInformation']['interestedCategories'] = [];

		if (params.productCategory.length > 0) {
			for (let ii = 0; ii < params.productCategory.length; ii++) {
				returnObject['tradeInformation']['existingCategories'].push(params.productCategory[ii].productCategorie);
				returnObject['tradeInformationIds']['productCategory'].push(params.productCategory[ii].productCategorieId);
				if( !returnObject['tradeInformationIds']['userProductCategories'].includes(params.productCategory[ii].productCategorieId)){
					returnObject['tradeInformation']['userProductCategories'].push(params.productCategory[ii].productCategorie);
				}
			}
		}

		if (params.customerProfile.length > 0) {

			let btype = [];
			let profiles;
			if ((params.channelTypeId == 2 || params.channelTypeId == 3) && (params.isOEM == 1 || params.isOEM == 3)) {
				profiles = params.customerProfile.filter(pro => { return [4].includes(+pro.channelTypeId) });
				returnObject['tradeInformation']['retailerProfile'] = [];
				for (let ii = 0; ii < profiles.length; ii++) {
					if (profiles[ii].profileType.trim()) {
						returnObject['tradeInformation']['retailerProfile'].push(profiles[ii].profileType);
					}
				}
			}
			if ((params.channelTypeId == 2 || params.channelTypeId == 3) && (params.isOEM == 2 || params.isOEM == 3)) {
				profiles = params.customerProfile.filter(pro => { return [5].includes(+pro.channelTypeId) });
				returnObject['tradeInformation']['resellerProfile'] = [];
				for (let ii = 0; ii < profiles.length; ii++) {
					if (profiles[ii].profileType) {
						returnObject['tradeInformation']['resellerProfile'].push(profiles[ii].profileType);
					}
				}
			}
			if((params.channelTypeId != 2 && params.channelTypeId != 3)) {
				profiles = params.customerProfile;
				returnObject['tradeInformation']['customerProfile'] = [];
				for (let ii = 0; ii < profiles.length; ii++) {
				if (profiles[ii].profileType) {
					returnObject['tradeInformation']['customerProfile'].push(profiles[ii].profileType);
				}
			}
		}
		}

		if (params.serviceList && params.serviceList.length > 0) {
			returnObject['tradeInformation']['service'] = [];
			for (let ii = 0; ii < params.serviceList.length; ii++) {
				if (params.serviceList[ii].serviceList) {
					returnObject['tradeInformation']['service'].push(params.serviceList[ii].serviceList);
					returnObject['tradeInformationIds']['service'].push(params.serviceList[ii].serviceListId);
				}
			}
		}

		params.channelLocation.sort(function (a, b) {
			return a.RegionCountryJCT.country.priority > b.RegionCountryJCT.country.priority ? 1 : -1;
		});

		if (params.channelLocation.length > 0) {
			returnObject['locations'] = {}; 
			returnObject['locations']['SELLING'] = [];
			returnObject['locations']['TARGET'] = [];
			returnObject['locations']['RETAIL'] = [];
			for (let ii = 0; ii < params.channelLocation.length; ii++) {
				if (params.channelLocation[ii].locationType == 'SELLING') {
					returnObject['locations']['SELLING'].push(params.channelLocation[ii].RegionCountryJCT.country.country);
					returnObject['tradeInformationIds']['locations'].push((params.channelLocation[ii].RegionCountryJCT.countryId));
				} else if (params.channelLocation[ii].locationType == 'TARGET') {
					returnObject['locations']['TARGET'].push(params.channelLocation[ii].RegionCountryJCT.country.country);
					returnObject['tradeInformationIds']['locations'].push((params.channelLocation[ii].RegionCountryJCT.countryId));
				} else if (params.channelLocation[ii].locationType == 'RETAIL') {
					returnObject['locations']['RETAIL'].push(params.channelLocation[ii].RegionCountryJCT.country.country);
					returnObject['tradeInformationIds']['locations'].push((params.channelLocation[ii].RegionCountryJCT.countryId));
				}
			}
		}

		if (returnObject['tradeInformationIds']['locations']) {
			returnObject['tradeInformationIds']['locations'] = returnObject['tradeInformationIds']['locations'].filter((obj, pos, arr) => {
				return arr.map(mapObj => mapObj).indexOf(obj) === pos;
			});
		}

		if (params.channelSocial.length > 0) {
			returnObject['socialLinks'] = [];
			for (let ii = 0; ii < params.channelSocial.length; ii++) {
				returnObject['socialLinks'].push({ 'social': params.channelSocial[ii].socialSite.socialSite, 'link': params.channelSocial[ii].channelSocialLink });
			}
		}
		if (returnObject['tradeInformationIds']['productGroup']) {
			returnObject['tradeInformationIds']['productGroup'] = returnObject['tradeInformationIds']['productGroup'].filter((obj, pos, arr) => {
				return arr.map(mapObj => mapObj).indexOf(obj) === pos;
			});
		}

		returnObject['awards'] = params.channelAward;

		if (params.channelCertificate.length > 0) {
			returnObject['certificate'] = {};
			returnObject['certificate']['Registration'] = [];
			returnObject['certificate']['Tax'] = [];
			for (let ii = 0; ii < params.channelCertificate.length; ii++) {
				let certificateType: string;
				params.certificateType.map(function(data, index) {
					if (data.cerificateTypeId == params.channelCertificate[ii].cerificateTypeId) {
						certificateType = data.cerificateType;
					}
				});
				returnObject['certificate'][certificateType].push(params.channelCertificate[ii]);
			}
		}
		returnObject['channelKeyRetailer'] = params.channelKeyRetailer;
		returnObject['channelKeyReseller'] = params.channelKeyReseller;
		returnObject['channelKeyDistributor'] = params.channelKeyDistributor;
		returnObject['channelDocuments'] = defaultTo(params.channelDocument, []);
		return returnObject;
	}

	async getChannelHub(channelHubs: any, user: User): Promise<any> {

		let returnObject = new Object;
		returnObject['total'] = channelHubs.total;
		returnObject['channelHubs'] = [];

		channelHubs.channelHubs.map(function(data, index) {
			let channelDetail = data.toJSON();
			if (channelDetail.partnerChannelId == user.channelId) {
				channelDetail.partnerChannel = data.Channel;
			}
			delete (channelDetail.Channel);
			returnObject['channelHubs'].push(channelDetail);
		});

		return returnObject;
	}

	async getOfficalDistributors(channelHubs: any, channel: any, channelHubsCount: any): Promise<any> {

		let returnObject = new Object;
		returnObject['total'] = channelHubsCount.length;
		returnObject['channels'] = [];

		channelHubs.map(function(data, index) {
			let channelDetail = data.toJSON();
			if (channelDetail.partnerChannel.channelId == channel.channelId) {
				channelDetail.partnerChannel = data.Channel;
			}
			delete (channelDetail.Channel);
			returnObject['channels'].push(channelDetail.partnerChannel);
		});

		return returnObject;
	}
	
	async channelDetailEvent(params): Promise<any> {

		let returnObject = new Object;
		returnObject['channelId'] = params.channelId;
		returnObject['companyName'] = params.companyName;
		returnObject['companyMail'] = params.companyMail;
		returnObject['isActive'] = params.isActive;
		returnObject['isFrenchTech'] = params.isFrenchTech;
		returnObject['signUpStatus'] = params.signUpStatus.signUpStatus;
		returnObject['channelTypeId'] = params.channelTypeId;
		returnObject['channelType'] = params.channelType.channelType;
		returnObject['country'] = params.country.country;
		returnObject['profileType'] = (params.profileType) ? params.profileType.profileType : null;
		returnObject['oldChannelId'] = params.oldChannelId;
		returnObject['channelLogo'] = (params.channelDetail && params.channelDetail.channelLogo) ? params.channelDetail.channelLogo.documentUrl : null;
		returnObject['channelIcon'] = (params.channelDetail && params.channelDetail.channelIcon) ? params.channelDetail.channelIcon.documentUrl : null;
		returnObject['webSiteUrl'] = params.channelDetail.webSiteUrl;
		returnObject['introvideo'] = (params.channelDetail && params.channelDetail.introvideo) ? params.channelDetail.introvideo.documentUrl : null;
		returnObject['estYear'] = params.channelDetail.estYear;
		returnObject['aboutUs'] = params.channelDetail.detailDesc;
		returnObject['expectations'] = (params.channelDetail.expectations) ? params.channelDetail.expectations : null;
		returnObject['empCntRange'] = params.channelDetail.empCntRange;
		returnObject['empCnt'] = params.channelDetail.empCnt;

		returnObject['no_of_skus'] = params.channelDetail.no_of_skus;
		returnObject['no_of_vendors'] = params.channelDetail.no_of_vendors;
		returnObject['no_of_distributors'] = params.channelDetail.no_of_distributors;
		returnObject['no_of_retailers'] = params.channelDetail.no_of_retailers;

		returnObject['empCntDSale'] = params.channelDetail.empCntDSale;
		returnObject['empCntISale'] = params.channelDetail.empCntISale;
		returnObject['empCntDMar'] = params.channelDetail.empCntDMar;
		returnObject['empCntIMar'] = params.channelDetail.empCntIMar;
		returnObject['storeCount'] = params.channelDetail.storeCount;
		returnObject['revD'] = params.channelDetail.revD;
		returnObject['revI'] = params.channelDetail.revI;
		returnObject['turnoverRange'] = params.channelDetail.turnoverRange;
		returnObject['turnover'] = params.channelDetail.turnover;
		returnObject['regYear'] = params.channelDetail.regYear;
		returnObject['turnoverPhyStore'] = params.channelDetail.turnoverPhyStore;
		returnObject['turnoverOnStore'] = params.channelDetail.turnoverOnStore;
		returnObject['startup'] = params.channelDetail.startup;		
		returnObject['maturitylevel'] = join(params.channelDetail.maturitylevel, ',');
		returnObject['keyretailers'] = params.channelDetail.keyretailers;
		//returnObject['keyresellers'] = params.channelDetail.keyresellers;
		returnObject['keydistributors'] = params.channelDetail.keydistributors;		

		if (params.retailerCount || params.retailerCount == 0) { returnObject['retailerCount'] = params.retailerCount; }
		if (params.distributorCount || params.distributorCount == 0) { returnObject['distributorCount'] = params.distributorCount; }
		if (params.vendorCount || params.vendorCount == 0) { returnObject['vendorCount'] = params.vendorCount; }
		if (params.productCount || params.productCount == 0) { returnObject['productCount'] = params.productCount; }
		if (params.sampleOrderCount || params.sampleOrderCount == 0) { returnObject['sampleOrderCount'] = params.sampleOrderCount; }
		if (params.sampleEvaluationCount || params.sampleEvaluationCount == 0) { returnObject['sampleEvaluationCount'] = params.sampleEvaluationCount; }

		returnObject['tradeInformationIds'] = {};
		returnObject['tradeInformationIds']['brand'] = [];

		if (params.channelBrand.length > 0) {
			returnObject['channelBrand'] = [];

			for (let ii = 0; ii < params.channelBrand.length; ii++) {
				if (params.channelBrand[ii].brand) {
					returnObject['channelBrand'].push({
						brandId: params.channelBrand[ii].brandId,
						brandName: params.channelBrand[ii].brand.brandName,
						brandImage: params.channelBrand[ii].brand.document.documentUrl,
						verified: params.channelBrand[ii].brand.isVerified
					});
					returnObject['tradeInformationIds']['brand'].push(params.channelBrand[ii].brandId);
				}
			}
		}

		/* Need to add when rating and review count added */
		returnObject['rating'] = 0;
		returnObject['reviewCount'] = 0;

		returnObject['subscriptionPlan'] = (params.channelSubscription && params.channelSubscription.subscription) ? params.channelSubscription.subscription.subscriptionPlan.dataValues.subscriptionPlanType : null;
		returnObject['subscriptionDetails'] = (params.channelSubscription) ? params.channelSubscription : null;
		//returnObject['subscriptionPlan'] = params.plan.subscriptionPlanType;

		returnObject['tradeInformation'] = {};

		returnObject['tradeInformation']['existingCategories'] = [];

		returnObject['tradeInformationIds']['productGroup'] = [];
		returnObject['tradeInformationIds']['productCategory'] = [];
		returnObject['tradeInformationIds']['speciality'] = [];
		returnObject['tradeInformationIds']['service'] = [];
		returnObject['tradeInformationIds']['locations'] = [];

		if (params.speciality.length > 0) {
			returnObject['tradeInformation']['speciality'] = [];
			for (let ii = 0; ii < params.speciality.length; ii++) {
				//for (let jj = 0; jj < params.channelSpeciality[ii].productGroup.length; jj++) {
				returnObject['tradeInformation']['speciality'].push(params.speciality[ii].productGroup);
				returnObject['tradeInformationIds']['speciality'].push(params.speciality[ii].productGroupId);
				//returnObject['tradeInformation']['existingCategories'].push(params.channelSpeciality[ii].productGroup.productGroup);
				returnObject['tradeInformationIds']['productGroup'].push(params.speciality[ii].productGroupId);
				//}
			}
		}

		/* Need to add the Interest Categories after approval */
		returnObject['tradeInformation']['interestedCategories'] = [];

		if (params.productCategory.length > 0) {
			for (let ii = 0; ii < params.productCategory.length; ii++) {
				returnObject['tradeInformation']['existingCategories'].push(params.productCategory[ii].productCategorie);
				returnObject['tradeInformationIds']['productCategory'].push(params.productCategory[ii].productCategorieId);
			}
		}

		if (params.productGroup.length > 0) {
			for (let ii = 0; ii < params.productGroup.length; ii++) {
				returnObject['tradeInformationIds']['productGroup'].push(params.productGroup[ii].productGroupId);
			}
		}

		if (params.customerProfile.length > 0) {
			returnObject['tradeInformation']['customerProfile'] = [];
			for (let ii = 0; ii < params.customerProfile.length; ii++) {
				if (params.customerProfile[ii].profileType) {
					returnObject['tradeInformation']['customerProfile'].push(params.customerProfile[ii].profileType);
				}
			}
		}

		if (params.serviceList && params.serviceList.length > 0) {
			returnObject['tradeInformation']['service'] = [];
			for (let ii = 0; ii < params.serviceList.length; ii++) {
				if (params.serviceList[ii].serviceList) {
					returnObject['tradeInformation']['service'].push(params.serviceList[ii].serviceList);
					returnObject['tradeInformationIds']['service'].push(params.serviceList[ii].serviceListId);
				}
			}
		}

		params.channelLocation.sort(function (a, b) {
			return a.RegionCountryJCT.country.priority > b.RegionCountryJCT.country.priority ? 1 : -1;
		});

		if (params.channelLocation.length > 0) {
			returnObject['locations'] = {}; 
			returnObject['locations']['SELLING'] = [];
			returnObject['locations']['TARGET'] = [];
			returnObject['locations']['RETAIL'] = [];
			for (let ii = 0; ii < params.channelLocation.length; ii++) {
				if (params.channelLocation[ii].locationType == 'SELLING') {
					returnObject['locations']['SELLING'].push(params.channelLocation[ii].RegionCountryJCT.country.country);
					returnObject['tradeInformationIds']['locations'].push((params.channelLocation[ii].RegionCountryJCT.countryId));
				} else if (params.channelLocation[ii].locationType == 'TARGET') {
					returnObject['locations']['TARGET'].push(params.channelLocation[ii].RegionCountryJCT.country.country);
					returnObject['tradeInformationIds']['locations'].push((params.channelLocation[ii].RegionCountryJCT.countryId));
				} else if (params.channelLocation[ii].locationType == 'RETAIL') {
					returnObject['locations']['RETAIL'].push(params.channelLocation[ii].RegionCountryJCT.country.country);
					returnObject['tradeInformationIds']['locations'].push((params.channelLocation[ii].RegionCountryJCT.countryId));
				}
			}
		}

		if (returnObject['tradeInformationIds']['locations']) {
			returnObject['tradeInformationIds']['locations'] = returnObject['tradeInformationIds']['locations'].filter((obj, pos, arr) => {
				return arr.map(mapObj => mapObj).indexOf(obj) === pos;
			});
		}

		if (params.channelSocial.length > 0) {
			returnObject['socialLinks'] = [];
			for (let ii = 0; ii < params.channelSocial.length; ii++) {
				returnObject['socialLinks'].push({ 'social': params.channelSocial[ii].socialSite.socialSite, 'link': params.channelSocial[ii].channelSocialLink });
			}
		}
		if (params.contacts.length > 0) {
			returnObject['contacts'] = [];
			for (let ii = 0; ii < params.contacts.length; ii++) {
				let contacts = params.contacts[ii].toJSON();
				// if (contacts && contacts.user && contacts.user.role) { contacts.user.role = contacts.user.role.role.role; }
				if (contacts.country.country) { contacts.country = contacts.country.country; }
				returnObject['contacts'][ii] = contacts;
				//returnObject['contacts'][ii]['role'] = contacts.user.role.role.role;
				returnObject['contacts'][ii]['documentUrl'] = (contacts.document) ? contacts.document.documentUrl : null;
				delete (returnObject['contacts'][ii]['document']);

				if (params.contacts[ii].contactSocialLink.length > 0) {
					returnObject['contacts'][ii]['contactSocialLink'] = [];
					for (let jj = 0; jj < params.contacts[ii].contactSocialLink.length; jj++) {
						returnObject['contacts'][ii]['contactSocialLink'].push({ 'social': params.contacts[ii].contactSocialLink[jj].socialSite.socialSite, 'link': params.contacts[ii].contactSocialLink[jj].contactSocialLink });
					}
				}

				if (params.contacts[ii].IntProductCategories.length > 0) {
					for (let jj = 0; jj < params.contacts[ii].IntProductCategories.length; jj++) {
						returnObject['tradeInformation']['interestedCategories'].push(params.contacts[ii].IntProductCategories[jj].productCategorie);
						returnObject['tradeInformationIds']['productCategory'].push(params.contacts[ii].IntProductCategories[jj].productCategorieId);
					}

					returnObject['tradeInformation']['interestedCategories'] = returnObject['tradeInformation']['interestedCategories'].filter((obj, pos, arr) => {
						return arr.map(mapObj => mapObj).indexOf(obj) === pos;
					});
					delete (returnObject['contacts'][ii]['IntProductCategory']);
				}
			}
		}

		if (returnObject['tradeInformationIds']['productGroup']) {
			returnObject['tradeInformationIds']['productGroup'] = returnObject['tradeInformationIds']['productGroup'].filter((obj, pos, arr) => {
				return arr.map(mapObj => mapObj).indexOf(obj) === pos;
			});
		}

		returnObject['awards'] = params.channelAward;

		if (params.channelCertificate.length > 0) {
			returnObject['certificate'] = {};
			returnObject['certificate']['Registration'] = [];
			returnObject['certificate']['Tax'] = [];
			for (let ii = 0; ii < params.channelCertificate.length; ii++) {
				let certificateType: string;
				params.certificateType.map(function(data, index) {
					if (data.cerificateTypeId == params.channelCertificate[ii].cerificateTypeId) {
						certificateType = data.cerificateType;
					}
				});
				returnObject['certificate'][certificateType].push(params.channelCertificate[ii]);
			}
		}

		returnObject['userDefaultContact'] = null;
		returnObject['channelJCT'] = null;
		returnObject['connectionStatusTypeId'] = null;
		returnObject['pendingApprovalInOutBound'] = null;
		returnObject['channelKeyRetailer'] = params.channelKeyRetailer;
		//returnObject['channelKeyReseller'] = params.channelKeyReseller;
		returnObject['channelKeyDistributor'] = params.channelKeyDistributor;
		returnObject['channelDocuments'] = defaultTo(params.channelDocument, []);

		return returnObject;
	}

	async getContactList(newlist:any,pagination, total, defaultContact: number = 0, aggregations?, active?: number): Promise<any> {
		let base = {
			pagination: {
				total: +total,
				offset: pagination.offset,
				limit: pagination.limit,
				page: pagination.page,
			},
			//records: contacts,
			records:newlist,
			defaultContact: defaultContact
		};

		if(active) {
			base = Object.assign(base, { active: active });
		}

		if (aggregations) {
			base = Object.assign(base, { aggregations: aggregations });
		}

		return base;
	}
}
