import { Module } from '@nestjs/common';
import { CommonController } from './controller/common.controller';
import { CommonService } from './service/common.service';
import { databaseProviders } from '../../core/database/database.providers';
import { CommonProviders, CountryProviders } from './provider/common.provider';
import { RegionCountryJCTProvider, ZoneProvider } from './provider/location.provider';

@Module({
  controllers: [CommonController],
  providers: [CommonService,...CommonProviders,...databaseProviders, ...CountryProviders, ...RegionCountryJCTProvider,...ZoneProvider]
})
export class CommonModule {}
