import { Body, Controller,Get,HttpStatus,Post,Request,Response, Param } from '@nestjs/common';
import { ChannelTypeProviders } from 'src/modules/channel/provider/channel.provider';
import { CommonService } from '../service/common.service';

@Controller('common')
export class CommonController {

    constructor(				        
        private readonly commonService: CommonService
    ) {}
        
     @Get('getSignup/:channelTypeId')	
     public async getSignup(@Request() req, @Param() data , @Response() res) {		
        let result = await this.commonService.getSignup(+data.channelTypeId);
         if (result) {
            res.status(HttpStatus.OK).json(result);
         } else {
              //throw new ProcessException("notification:presetmail:listNotfound");
          }
    }
    
    @Get('getProducts/:businessType')	
     public async getProducts(@Request() req, @Param() data , @Response() res) {		
        let result = await this.commonService.getProducts(+data.businessType);
         if (result) {
            res.status(HttpStatus.OK).json(result);
         } else {
              //throw new ProcessException("notification:presetmail:listNotfound");
          }
    }
    

    @Post('getOldProduct')	
    public async getOldProduct(@Request() req, @Response() res,@Body() data: any) {		
       let result = await this.commonService.getOldChannelProductGroup(data.email);
        if (result) {
           res.status(HttpStatus.OK).json(result);
        } else {
             //throw new ProcessException("notification:presetmail:listNotfound");
         }
   }   

   @Get('country')
	async findAll(@Request() request, @Response() res) {
		let result = await this.commonService.findAllCountry();
		res.status(HttpStatus.OK).json(result);
	}
}
