import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, Scopes, BelongsToMany } from 'sequelize-typescript';
import { Region } from './Region.entity';
import { ZoneRegionJCT } from './ZoneRegionJCT.entity';
import { ApiProperty } from '@nestjs/swagger';

@Table({
	tableName: "tblhomepagelogo"
})

export class HomePageLogo extends Model<HomePageLogo>{

	@PrimaryKey
	@AutoIncrement
	@Column
	@ApiProperty()
	homepagelogoid: number

	@Column(DataType.CHAR(255))
	name: string

	@Column(DataType.CHAR(255))
	logo: string

	@Column(DataType.CHAR(255))
	url: string

	@Column(DataType.DATE)
	deletedat: Date;

	@Column(DataType.DATE)
	createdat: Date;

	@Column(DataType.DATE)
	updatedat: Date;

}
