import { Table, Column, PrimaryKey, Model, AutoIncrement, BelongsTo, ForeignKey, DataType } from 'sequelize-typescript';
import { Zone } from './Zone.entity';
import { Region } from './Region.entity';
import { ApiProperty } from '@nestjs/swagger';

@Table({
	tableName: "tblZoneRegionJCT", timestamps:false
})
export class ZoneRegionJCT extends Model<ZoneRegionJCT>{

	@PrimaryKey
	@AutoIncrement
	@Column
	@ApiProperty()
	zoneRegionJCTId: number

	@ForeignKey(() => Zone)
	@Column({
		type: DataType.BIGINT,
		allowNull: false,
		unique: { name: 'zoneId_regionId', msg: 'validate:field:shouldBeUnique' }
	})
	@ApiProperty()
	zoneId: number;

	@BelongsTo(() => Zone)
	Zone: Zone[];

	@ForeignKey(() => Region)
	@Column({
		type: DataType.BIGINT,
		allowNull: false,
		unique: { name: 'zoneId_regionId', msg: 'validate:field:shouldBeUnique' }
	})
	@ApiProperty()
	regionId: number

	@BelongsTo(() => Region)
	Region: Region[];

	@Column(DataType.DATE)
	deletedAt: Date

}
