'use strict';

import { ProfileType } from 'src/modules/channel/models/ProfileType.entity';
import { ProfileTypeClassification } from 'src/modules/channel/models/ProfileTypeClassification.entity';
import { Brand } from 'src/modules/product/models/Brand.entity';
import { ProductCategory } from 'src/modules/product/models/ProductCategory.entity';
import { ProductGroup } from 'src/modules/product/models/ProductGroup.entity';
// import { User } from '../models/User.entity';
// import { Contact } from '../models/Contact.entity';
import { OldChannel } from '../../channel/models/OldChannel.entity';
import { Country } from '../models/Country.entity';

export const CommonProviders = [
	{
		provide: 'BrandRepository',
		useValue: Brand,
	},
	{
		provide: 'ProductGroupRepository',
		useValue: ProductGroup,
	},
	{
		provide: 'ProfileTypeRepository',
		useValue: ProfileType,
	},
	{
		provide: 'ProfileTypeClassiRepository',
		useValue: ProfileTypeClassification,
	},	
	{
		provide: 'ProductCategoryRepository',
		useValue: ProductCategory,
	},
	{
		provide: 'OldChannelRepository',
		useValue: OldChannel,
	}
];

export const CountryProviders = [
	{
		provide: 'CountryRepository',
		useValue: Country,
	},
];
