import { Body, Controller, HttpStatus, Param, Post, Get, Req, Res, UploadedFile, UploadedFiles, UseGuards, UseInterceptors } from "@nestjs/common";
import { AuthGuard } from "@nestjs/passport";
import { FileInterceptor, FilesInterceptor } from "@nestjs/platform-express";
import { FetchUploadS3 } from "src/lib/FetchUploadS3";
import { DigitalWalletService } from "../service/digitalWallet.service";
import { S3Lib } from "src/lib/S3Lib";
import { ProcessException } from "src/middleware/exception/Process.exception";


@UseGuards(AuthGuard('jwt'))
@Controller('digitalWallet')
export class DigitalWalletController {
  
  constructor(
    private digitalWalletService:DigitalWalletService,
    ) {}

  @Get('getWalletAmount')
    async getWalletAmount(@Body() data, @Req() req,@Res() res){
      let user = req.user;
        let walletAmount = await this.digitalWalletService.getWalletAmount(user);
		    return res.status(HttpStatus.OK).send(walletAmount);
    }

    @Post('processWalletPayment')
    public async processWalletPayment(@Req() req, @Res() res) {
      let user = req.user;
      // add to transaction table
      let transactionId = null;
      console.log('test herer')
      console.log(req.body);
      let result = await this.digitalWalletService.processWalletPayment(req.body, user);
      if(result){
        return res.status(HttpStatus.OK).json({ sent : 'success' });
      } else {
        return res.status(HttpStatus.OK).json({ sent : 'error' });
      }
      
    }


}
