import { Module } from '@nestjs/common';
import { DigitalWalletController } from './controller/digitalWallet.controller';
import { DigitalWalletService } from "./service/digitalWallet.service";

import { UserWalletAmountProviders,
  OtherPaymentProviders,
  WalletTransactionProviders,
  WalletUsageTypeProviders } from './providers/digitalWallet.provider';

@Module({
  controllers:[DigitalWalletController],
    providers:[
        ...UserWalletAmountProviders,
        ...OtherPaymentProviders,
        ...WalletTransactionProviders,
        ...WalletUsageTypeProviders,
        DigitalWalletService
    ],
    exports: [
      ...UserWalletAmountProviders,
      ...OtherPaymentProviders,
      ...WalletTransactionProviders,
      ...WalletUsageTypeProviders
	],
})
export class DigitalWalletModule {

}
