import { Inject, Injectable } from '@nestjs/common';

import { UserWalletAmount } from '../models/UserWalletAmount.entity';
import { OtherPayment } from '../../channel/models/OtherPayment.entity';
import { WalletTransaction } from '../models/WalletTransaction.entity';
import { WalletUsageType } from '../models/WalletUsageType.entity';
import { ChannelJCT } from '../../channel/models/ChannelJCT.entity';
import { appconstant } from '../../../config';
import { ConnectionStatusType } from '../../channel/models/ConnectionStatusType.entity';
export class DigitalWalletService {
	
    constructor(
		@Inject('UserWalletAmountRepository') private readonly userWalletAmountRepository: typeof UserWalletAmount,
		@Inject('OtherPaymentRepository') private readonly otherPaymentRepository: typeof OtherPayment,
		@Inject('WalletTransactionRepository') private readonly walletTransactionRepository: typeof WalletTransaction,
		@Inject('WalletUsageTypeRepository') private readonly walletUsageTypeRepository: typeof WalletUsageType	){
        }

	async getWalletAmount(user){

		console.log(user.userId);
		console.log(user.channelId);
		return await this.userWalletAmountRepository.findOne({
			//attributes: ['endAt',  'subscriptionPlanType'],
            where: {
                userId:user.userId,
				channelId: user.channelId
            }
        });
	}	


	
	public async processWalletPayment(req, user){
		try {
			console.log('dfdsfsdfdsfdsfdsfdsfdsfdsfdsf')
			return await UserWalletAmount.findOne({
				where: {
					channelId: user.channelId,
					userId: user.userId
				}
			}).then(async (userAmount) => {

				console.log(userAmount);

				let walletTransactions: any = {};
				walletTransactions.payerUserId = +user.userId;
				walletTransactions.payeeChannelId = req.req_cid;
				walletTransactions.amount = req.amt;
				walletTransactions.currencyid = 1;
				walletTransactions.walletUsageTypeId = 1;
				walletTransactions.updatedAt = Date.now();
        		userAmount.amount = +userAmount.amount - 10
				userAmount.save();


				if(req.jctId == null){
					await ChannelJCT.create({
						isConfidential: '0',
						channelId: +req.req_cid,
						partnerChannelId: +user.channelId,
						createdAt: Date.now(),
						connectionStatusTypeId:+appconstant.REMOVE_CONFIDENTIAL //suggestion
					});

				} else { 

					await ChannelJCT.update({
						isConfidential: '0'
					}, {
						where: {
							channelId: user.channelId,
							partnerChannelId: +req.req_cid,
							deletedat: null
						}						
					});


					await ChannelJCT.update({
						isConfidential: '0'
					}, {
							where: {
								channelJCTId: +req.jctId,
								channelId: +req.req_cid,
								partnerChannelId: user.channelId,
								deletedat: null
							}
					}); console.log('wallet rc confirmation');
					console.log(req.jctId);
			    }
				this.walletTransactionRepository.create(walletTransactions);
				return userAmount;
			});
		} catch (e) {
			console.log(e);
		}
	}
		
	
    
}
