import { Controller, Post, Body, HttpStatus, Res } from '@nestjs/common';
import { EmailerService } from '../services/emailer.service';
import Mail_Template from '../TemplateData';

@Controller('emailer')
export class EmailerController {

    constructor(private readonly emailService: EmailerService){}

    @Post()
    async sendMail(@Res() res, @Body() body){

        let templateData = Mail_Template.find(x => x.type == body.type);
        let subject = templateData.subject;
        let context = body.data;
        let template = templateData.template;

        let to = '';

        if(body.type == 'signup_bo')
            to = "<development@channel-hub.io>";
        else
            to = body.data.email;

        let data =  await this.emailService.email(subject, to,  template, context);


        console.log(body);
        console.log(body.companyName); 
        return await res.status(HttpStatus.OK).json(data);
    }

}
