import { Module } from '@nestjs/common';
import { EmailerService } from './services/emailer.service';
import { MailerModule } from '@nestjs-modules/mailer';
import { EjsAdapter } from '@nestjs-modules/mailer/dist/adapters/ejs.adapter';
import { EmailerController } from './controller/emailer.controller';

@Module({
  imports: [
    MailerModule.forRoot({
      transport: {
        service: 'gmail',
        port: 587,
        secure: false,
        auth:{
          user: 'parameshkins@gmail.com',
          pass: 'World@987!'
        },
        tls: {
          rejectUnauthorized: false
        }
      },
      defaults: {
        from:'"nest-modules" <modules@nestjs.com>',
      },
      template: {
        dir: __dirname + '../../../../public/templates',
        adapter: new EjsAdapter(),
        options: {
          strict: true,
        },
      },
    }),
  ],
  providers: [EmailerService],
  controllers: [EmailerController],
  exports: [EmailerService]
})
export class EmailerModule {}
