import { Injectable } from '@nestjs/common';
import { MailerService } from '@nestjs-modules/mailer'

@Injectable()
export class EmailerService {
    constructor(private readonly mailerService: MailerService){}

    public email(subject : string, to: string, template : string, data : any): void {
        this
          .mailerService
          .sendMail({
            to: to,
            from: 'parameshkins@gmail.com',
            subject: subject, //'Channel Hub - Team ✔',
            template: template+'.ejs',  //'SIGNUP_CONFIRMATION.ejs', // The `.pug`, `.ejs` or `.hbs` extension is appended automatically.
            context: {  // Data to be sent to template engine.
              ...data
            },
          })
          .then((success) => {
              console.log(success);
              return success;
          })
          .catch((err) => {
              console.log(err);
          });
        }
}
