import { Body, Controller, HttpStatus, Param, Post, Req, Res, UploadedFile, UploadedFiles, UseGuards, UseInterceptors } from "@nestjs/common";
import { AuthGuard } from "@nestjs/passport";
import { FileInterceptor, FilesInterceptor } from "@nestjs/platform-express";
import { FetchUploadS3 } from "src/lib/FetchUploadS3";
import { S3Lib } from "src/lib/S3Lib";
import { ProcessException } from "src/middleware/exception/Process.exception";
import { Utility } from "../helper/utility";

@UseGuards(AuthGuard('jwt'))
@Controller('mediaupload')
export class MediaController {
  public fs = require('fs');
@Post('uploadImage')
@UseInterceptors(FilesInterceptor('files'))
uploadFiles(@UploadedFiles() files) {
  console.log(files);
}

@Post('upload/:dirName')
@UseInterceptors(FileInterceptor('file'))
async uploadFile(@UploadedFile() file, @Res() res, @Param('dirName') dirName) {
  if (file.originalname) {
      var s3 = new S3Lib();

      let helper = new Utility();
      let newPath = await helper.getNewMediaPath({
          documentPath: file.originalname,
          dirName: this.getDirName(dirName)
      });
      const sharp = require('sharp')

      let response = await s3.moveFromLocal(file.buffer, newPath, 1)
    // if(response){
      let path = await helper.getMediaPath({
        documentPath: newPath,
        dirName: this.getDirName(dirName)
    });
      var fus3 = new FetchUploadS3();
      let url = process.env.AWS_BUCKET_KEY_PREFIX +'/' + path;
      if(dirName !='introVideo' && dirName !=='broucher' && dirName!=='banner'){
      const size = await sharp(file.buffer).metadata();
      console.log('size', size);
      if(size.width >300){
        await fus3.upload(file.buffer, url, 300, 300, process.env.TEM_AWS_BUCKET);
        }else{
          await s3.moveFromLocal(file.buffer, url, 2)
        }
      }else{
        await s3.moveFromLocal(file.buffer, url, 2)
      }
       res.status(HttpStatus.OK).json({url:url});
    }else{
      throw new ProcessException('Soming went wrong');
    }

  // }
}

getDirName(id){
    switch (id) {
      case 'introVideo':
        return 'introVideo';
      case 'CompanyLogo':
        return 'account-s3';
      case 'brandlogo':
        return 'brand-s3';
      case 'broucher':
        return 'product/broucher';
      case 'display':
          return 'product/display';
      case 'packing':
            return 'product/packing';
      case 'image':
          return 'product/image';
      case 'image':
        return 'product/banner';
      case 'productImportCSV':
        return 'product-import-csv-s3';
      case 'productImportZIP':
        return 'product-import-zip-s3';      
      default:
        return 'media';
    }
}

@Post('productFile/:dirName')
@UseInterceptors(FileInterceptor('file'))
async productFile(@UploadedFile() file, @Res() res, @Param('dirName') dirName) {
  if (file.originalname) {

      var s3 = new S3Lib();
      let helper = new Utility();
      let s3Path = this.getDirName(dirName)
      let newPath = s3Path+'/'+file.originalname;
      let response = await s3.moveFromLocal(file.buffer, newPath, 1);
      let result = null
      if(response){
        result = file.originalname
      } else {
        result = 'error'
      }
      res.status(HttpStatus.OK).json({url:result});

    }else{
      throw new ProcessException('Soming went wrong');
    }

  // }
}

}
