import { Module } from '@nestjs/common';
import { databaseProviders } from 'src/core/database/database.providers';
import { ErrorLogController } from './controller/errorLog.controller';
import { MediaController } from './controller/media.controller';
import { MediaProviders } from './providers/media.provider';
import { MediaErrorLogProviders, MediaTypeProviders } from './providers/mediatype.provider';
import { MediaService } from './service/media.service';

@Module({
  controllers:[MediaController, ErrorLogController],
    providers:[
        ...MediaProviders,
        ...MediaTypeProviders,
        ...MediaErrorLogProviders,
        ...databaseProviders,
        MediaService
    ],
    exports: [
		...MediaProviders,
		...MediaTypeProviders,
    ...MediaErrorLogProviders
	],
})
export class MediaModule {

}
