import {
	Table,
	Column,
	PrimaryKey,
	Model,
	AutoIncrement,
	DataType,
	AllowNull,
	ForeignKey,
} from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { MediaType } from './MediaType.entity';
const tableOptions: IDefineOptions = { timestamp: true, tableName: 'tblBucketErrorLog' } as IDefineOptions;

@Table(tableOptions)

export class BucketErrorLog extends Model<BucketErrorLog>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
    id: number;

	@Column(DataType.CHAR(255))
	name: string

	@Column(DataType.INTEGER)
	@ForeignKey(() => MediaType)
	documentTypeId: number

	@Column(DataType.CHAR(510))
	url: string

	@Column(DataType.DATE)
	deletedAt: Date;

	@Column(DataType.DATE)
	createdAt: Date;
	
	@Column(DataType.DATE)
	updatedAt: Date;
}
