'use strict';

import { Inject, Controller, Post, Get, Patch, HttpStatus, Response, Param, Body, Request } from '@nestjs/common';
import { ValidationPipe } from '../../../middleware/pipe/validation.pipe';
import { MeetingReqDto } from '../dto/meetingReq.dto';
import { ContextService } from './../../../context/context.service';
import { MeetingService } from '../service/meeting.service';
import { MeetingConfirmDto } from '../dto/meetingConfirm.dto';

@Controller('Meeting')
export class MeetingController {
	constructor(
		private meetingService: MeetingService,
		private context: ContextService,
	) {}

    @Post()
	public async addNewUser(@Response() res, @Body(new ValidationPipe()) addUserDto: MeetingReqDto) {

		// let user = this.context.get('user');
		
		let result = await this.meetingService.addMeetingReq(addUserDto);
		
		res.status(HttpStatus.CREATED).send({
			created: result
		});
	}

	@Get()
	public async listMeeting(@Response() res, @Request() req) {

		// let user = this.context.get('user');
				
		let result = await this.meetingService.getMeetingList(req.query);		
		// if(result)
		res.status(HttpStatus.CREATED).send(result);
	}

	@Post('updateMeeting')
	public async updateMeeting(@Response() res, @Body(new ValidationPipe()) updateMeeting: MeetingConfirmDto) {

		// let user = this.context.get('user');
				
		 await this.meetingService.updateMeeting(updateMeeting);	
		 
		 res.status(HttpStatus.CREATED).send({
			status:true
		});
		
	}


    
}