'use strict'

import { IsUrl, IsBoolean, IsOptional, Length, IsNotEmpty, IsEmail, MinLength, MaxLength, IsString, IsAlphanumeric, IsNumber, IsInt, Matches } from 'class-validator';
// import { ApiModelProperty } from '@nestjs/swagger';
import { isDate } from 'util';

export class MeetingReqDto {

	
	@IsNumber({}, { message: "validate:field:shouldBeInt" })
	senderChannelId: number;

	
    @IsNumber({}, { message: "validate:field:shouldBeInt" })
    senderContactId: number;
   
    @IsOptional()    
    @IsNumber({}, { message: "validate:field:shouldBeInt" })
    alt_senderContactId: number;

    @IsNumber({}, { message: "validate:field:shouldBeInt" })
	receiverChannelId: number

	@IsNumber({}, { message: "validate:field:shouldBeInt" })
    receiverContactId: number;
   
    @IsOptional()    
    @IsNumber({}, { message: "validate:field:shouldBeInt" })
    alt_receiverContactId: number;

    @IsOptional()	
    meeting_Scheduled_At: Date;
    
    @IsOptional()	
	req_Scheduled_At: Date;

    @IsOptional()	
	@IsNumber({}, { message: "validate:field:shouldBeInt" })
    isMeetingConfirm: number;
    
    @IsOptional()	
	@IsNumber({}, { message: "validate:field:shouldBeInt" })
    isMeetingCompleted: number;   
    
/*
	@IsNumber({}, { message: "validate:field:shouldBeInt" })
	@IsOptional()
	@ApiModelProperty()
	readonly rptContactId: number;*/

	
}
