import {
	IsOptional,
	IsNotEmpty,
	MaxLength,
	IsNumber,
} from 'class-validator';
// import { ApiModelProperty } from '@nestjs/swagger';

export class SendMailDto {

	@IsNotEmpty({ message: "notification:mail:subjectNotempty" })
	@MaxLength(255, { message: "notification:mail:subjectMaxlength" })
	readonly subject: string;

	@IsNotEmpty({ message: "notification:mail:messageNotempty" })
	@MaxLength(3000, { message: "notification:mail:messageMaxlength" })
	readonly message: string;

	@IsNotEmpty({ message: "notification:mail:receiverIdIsNotEmpty" })
	@IsNumber({}, { message: "notification:mail:receiverIdIsNumber" })
	receiverId: number;

	senderType: string;

}
