'use strict';

import { Module } from '@nestjs/common';
import { MeetingController } from './controller/meeting.controller';
import { MeetingService } from './service/meeting.service';
import { MeetingReqProviders } from './provider/meeting.providers';
import { CommonModule } from '../common/common.module';
import { MediaModule } from '../media/media.module';
import { NotificationModule } from '../notification/notification.module';
import { channelProvider } from '../channel/provider/channel.provider';
import { UserProviders } from '../user/provider/user.provider';
import { DatabaseModule } from 'src/core/database/database.module';

@Module({
	controllers: [
		MeetingController
	],
	providers: [
		MeetingService,		
		...MeetingReqProviders,
		...UserProviders,
		...channelProvider
		
	],
	imports: [
		DatabaseModule, 
		CommonModule, 
		MediaModule, 
		NotificationModule
	],
	exports: [
		MeetingService,		
		...MeetingReqProviders
	],
})
export class MeetingModule{}
