import {
	Table,
	Column,
	PrimaryKey,
	Model,
	AutoIncrement,
	DataType,
	BeforeCreate,
	AllowNull,
	BeforeUpdate,
	ForeignKey,
	Scopes,
	BelongsTo,
	HasOne,
	HasMany
} from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Channel } from '../../channel/models/Channel.entity';
import { Contact } from '../../user/models/Contact.entity';
const tableOptions: IDefineOptions = { timestamp: true, tableName: 'tblMeetingReq' } as IDefineOptions;

@Table(tableOptions)

export class MeetingReq extends Model<MeetingReq>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
    mettingReqId: number;
    
    @ForeignKey(() => Channel)
	@Column(DataType.BIGINT)
	senderChannelId: number

	@BelongsTo(() => Channel, 'channelId')
	channel: Channel;

	@ForeignKey(() => Contact)
	@Column(DataType.BIGINT)
	senderContactId: number;

	@BelongsTo(() => Contact, 'contactId')
	contact: Contact;

	//@ForeignKey(() => Contact)
	@Column(DataType.BIGINT)
	alt_senderContactId: number;

	//@BelongsTo(() => Contact, 'contactId')
	//alt_senderContact: Contact;

	@ForeignKey(() => Channel)
	@Column(DataType.BIGINT)
	receiverChannelId: number
	
	@BelongsTo(() => Channel, 'channelId')
	receiveChannel: Channel;

	@ForeignKey(() => Contact)
	@Column(DataType.BIGINT)
	receiverContactId: number;

	@BelongsTo(() => Contact, 'contactId')
	receiverContact: Contact;

	//@ForeignKey(() => Contact)
	@Column(DataType.BIGINT)
	alt_receiverContactId: number;

	//@BelongsTo(() => Contact, 'contactId')
	//alt_receiverContact: Contact;

	@Column(DataType.DATE)
	meeting_Scheduled_At: Date;

	@Column(DataType.DATE)
	req_Scheduled_At: Date;

	@Column(DataType.SMALLINT)
	isMeetingConfirm: number;

	@Column(DataType.SMALLINT)
	isMeetingCompleted: number;
	
	@Column(DataType.DATE)
	deletedAt: Date;

	@AllowNull(false)
	@Column(DataType.DATE)
	createdAt: Date;

	@Column(DataType.DATE)
	updatedAt: Date;
	
}
