import { Controller,Get,Request,Response,HttpStatus,Post,Body, UseGuards, Param } from '@nestjs/common';
import { ContextService } from './../../../context/context.service';
import { NotificationService } from '../service/notification.service';
import { AuthGuard } from '@nestjs/passport';

@Controller('notification')

export class NotificationController {
    constructor(				
        private context: ContextService,
        private readonly notificationService: NotificationService
    ) {}
    
	
    @Get('getDashboardcount')	
	@UseGuards(AuthGuard('jwt'))
	public async getDashboard(@Request() req, @Response() res) {
		let user = req.user;
		let result = await this.notificationService.getDashboardcount(user);
		if (result) {
			res.status(HttpStatus.OK).json(result);
		} else {
			//throw new ProcessException("notification:presetmail:listNotfound");
		}
	}

	@Post('message')	
	public async sendSMS(@Request() req, @Response() res,@Body() message: any) {		
		let result = await this.notificationService.sendSMS(message);
		if (result) {
			res.status(HttpStatus.OK).json(result);
		} else {
			//throw new ProcessException("notification:presetmail:listNotfound");
		}
	}

}
