import {
	Table,
	Column,
	PrimaryKey,
	Model,
	AutoIncrement,
	DataType,
	BeforeCreate,
	AllowNull,
	BeforeUpdate,
	Scopes
} from 'sequelize-typescript';
var Sequelize = require('sequelize');

@Table({
	tableName: "tblemailtemplate"
})

@Scopes({
	mailOpitionList: {
		attributes: [['emailtemplateid', 'id'], ['template', 'key'], ['templatecontent', 'content']]
	}
})
export class EmailTemplate extends Model<EmailTemplate> {

	@AutoIncrement
	@PrimaryKey
	@AllowNull(false)
	@Column
	emailtemplateid: number;

	@Column
	template: string

	@Column
	templatecontent: string

	@Column(DataType.DATE)
	createdat: Date;

	@Column(DataType.DATE)
	updatedat: Date;

	@Column(DataType.DATE)
	deletedat: Date;

	@BeforeCreate
	@BeforeUpdate
	public static async dateUpdate(emailTemplate: EmailTemplate, options: any) {
		emailTemplate.updatedat = Sequelize.fn('NOW');
	}
}
