import { Injectable,Inject } from '@nestjs/common';
import {Op, QueryTypes } from "sequelize";
import { databaseConfig } from 'src/core/database/database.config';

@Injectable()
export class NotificationService {
    constructor(
        @Inject('SequelizeInstance') private readonly sequelizeInstance
    ){}
    public async getDashboardcount(user) {

		let query = 'select count(q.productid) as product_count from tblproductquote q inner join tblcart c on c.cartid = q.cartid where q.deletedat IS NULL and c.deletedat IS NULL and c.userid = :userId ';
		
		//query += 'group by q.cartid';

		let cart_count = await this.sequelizeInstance.query(query, {
			type: this.sequelizeInstance.QueryTypes.SELECT,
			raw: true,
			replacements: {
				userId: user.userId,				
			}
		}).then((data) => {
			return data[0].product_count;
		});

		query='select count("productwishlistid") as fav_count from "tblproductwishlist" where "deletedat" is null and "userid"=:userId';

		let fav_count = await this.sequelizeInstance.query(query, {
			type: this.sequelizeInstance.QueryTypes.SELECT,
			raw: true,
			replacements: {
				userId: user.userId,				
			}
		}).then((data) => {
			return data[0].fav_count;
		});

		let data={cart_count:cart_count,
		fav_count:fav_count};

		return data;
	}

	public async sendSMS(message) {
		console.log("phone:",message.phoneno);
		let sendMsg = require('aws-sns-sms');
		let awsConfig = {
			accessKeyId: process.env.AWS_SMS_ACCESS_KEY,
			secretAccessKey: process.env.AWS_SMS_SECRET_ACCESS_KEY,
		region: 'eu-west-1'
		};
		let otp=Math.floor(100000 + Math.random() * 900000);
		
		let msg = {
			"message": "ChannelHub:Your Verification Code is:"+otp,
			"sender": "CHANNELHUB",
			"phoneNumber": message.phoneno // phoneNumber along with country code
		};
		sendMsg(awsConfig, msg).then(data => {
			console.log("Message sent");
		})
		.catch(err => {
			console.log(err);
		});
		return otp;
	}
}
