'use strict';

import { Inject, Controller, Post, Get, HttpStatus, Request, Response, Param, Body, UsePipes, Put, UseGuards } from '@nestjs/common';
//import { BaseController } from './../../core/controller/base.controller';
//import { ApiBearerAuth, ApiUseTags, ApiOperation, ApiImplicitParam, ApiImplicitHeader, ApiResponse } from '@nestjs/swagger';
import { ValidationPipe } from '../../../middleware/pipe/validation.pipe';
//import { RolesGuard } from './../../../middleware/guard/roles.guard';
import { Channel } from './../../channel/models/Channel.entity';
//import { Roles } from './../../../middleware/decorator/roles.decorator';
import { ContextService } from './../../../context/context.service';
import { CheckoutDto } from './../dto/checkout.dto';
import { CheckoutService } from './../service/checkout.service';
import { appconstant } from './../../../config';
import { ChannelHubService } from './../../channel/service/channelHub.service';
import { ChannelService } from './../../channel/service/channel.service';
import { UpdateChannelDto } from './../../channel/dto/updateChannel.dto';
import {Op, QueryTypes } from "sequelize";
import { isNull } from 'lodash';
import { AuthGuard } from '@nestjs/passport';

@UseGuards(AuthGuard('jwt'))
@Controller('checkout')
export class CheckoutController  {
	constructor(		
		//private channelHubService: ChannelHubService,
		private service: CheckoutService,
		private channelService: ChannelService		
	) {}

	async verifyRejectedChannels(user, channelId) {
		let rejectedChannels = await this.getRejectedChannelIds(+user.channelId,+user.contactId);
		if (rejectedChannels.includes('' + channelId)) {
			// new ProcessException('channelHub:channel:rejected');
		}
	}

	async getRejectedChannelIds(channelId,contactId) {
		
		return await Channel.sequelize.query('select case when "channelId"=:channelId then "partnerChannelId" when  "partnerChannelId"=:channelId then "channelId" end as a  from "tblChannelJCT" where "connectionStatusTypeId" in (:rejectStatus) and ("channelId"=:channelId or "partnerChannelId"=:channelId) and case when "requested_to" = :contactId then "requested_by" not in(select case when "requested_by"=:contactId then "requested_to" when "requested_to"=:contactId then "requested_by" end from "tblChannelJCT" where ("requested_to"=:contactId or "requested_by"=:contactId) and "deletedat" is null and  "connectionStatusTypeId" in(1,2,7,10,11)) when "requested_by" = :contactId then "requested_to" not in(select case when "requested_by"=:contactId then "requested_to" when "requested_to"=:contactId then "requested_by" end from "tblChannelJCT" where ("requested_to"=:contactId or "requested_by"=:contactId) and "deletedat" is null and  "connectionStatusTypeId" in(1,2,7,10,11)) end', {
			type: QueryTypes.SELECT,
			raw: true,
			replacements: {
				rejectStatus: [appconstant.DISMISS, appconstant.DISMISS_OTHER_REASON],
				channelId: +channelId,
				contactId: +contactId
			}
		}).then((result) => {
			let res = [];			
			// res=result.map(x => +x.a);
			// res=_.uniq(res);
			//if (result[0]) { res = [...new Set([...result[0].a || []])]; }
			//console.log("aaaa:",res);
			return res;
		});
	}

	@Post('/')
	//@Roles(Channel.FRONTEND_CHANNEL)
	async checkout(@Request() req, @Response() res, @Body(new ValidationPipe()) dto: CheckoutDto) {
		let user = req.user;
		//let subscriptionFeatureKeys = this.context.get('subscriptionFeatures');
		var relation_queued = '0';

		let cart = await this.service.validateAndCollectCart(dto, user);

		// verify if already rejected
		//await this.verifyRejectedChannels(user, +cart.sellerchannelid);

		// verify the relation
		// NOTE: seller relation should be unlimited
	//	let relatedIds = await this.getRelatedIds(user, null, null, null, null, null, null, +cart.sellerchannelid);

		// let updateChannelDto: UpdateChannelDto = {
		// 	connectionStatusTypeId: appconstant.PENDINGMYPROSPECT,
		// 	leadManagementTag: 'Low',
		// 	channelJCTId: null,
		// 	dismissreasonid: null,
		// 	otherreasons: null,
		// 	note: '',
		// 	contactid:null,
		// 	introVideo: null
		// }

		var counted = false;
		// if (Object.keys(relatedIds).length <= 0) {
		// 	let channelJct = await this.channelHubService.connectChannel(cart.seller, user);
		// 	if (channelJct) {
		// 		updateChannelDto.channelJCTId = +channelJct.channelJCTId;

		// 		if (channelJct.subscription_queued == '1') {
		// 			relation_queued = '1';
		// 		}

		// 		counted = true;
		// 	}
		// } else if (relatedIds[+cart.sellerchannelid]['status'] == appconstant.MYSUGGESTION) {
		// 	updateChannelDto.channelJCTId = +relatedIds[+cart.sellerchannelid]['channel_jct_id'];
		// }

		let updateChannel = false;
		// if (!isNull(updateChannelDto.channelJCTId)) {
		// 	await this.channelHubService.updateChannel(+cart.sellerchannelid, updateChannelDto, user, false, counted);

		// 	// profile score
		// 	this.channelService.profileScore(user.channelId, user.channel.channelTypeId, user.channel.profileStrength);
		// }

		let orderNo = await this.service.makeOrder(cart, Object.assign(dto, {
			relation_queued
		}), user);// subscriptionFeatureKeys);

		return res.status(HttpStatus.OK).json({
			status: true,
			order: orderNo
		});
	}
}
