import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, BeforeCreate, AllowNull, BeforeUpdate, ForeignKey, HasMany, BelongsTo, Scopes } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { UUIDV4 } from 'sequelize/types';
import { Country } from '../../common/models/Country.entity';
//import { DataTypeTime } from 'sequelize';

const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblorderaddress' } as IDefineOptions;
@Table(tableOptions)

@Scopes(() => ({
	orderInfo: {
		include: [
			{
				model:Country
			}
		]
	}
}))

export class OrderAddress extends Model<OrderAddress> {

	@Column({
		type: DataType.BIGINT,
		allowNull: false,
		autoIncrement: true,
		unique: true,
		primaryKey: true,
	})
	addressid: number

	@Column
	name: string

	@Column
	address: string

	@Column
	city: string

	@ForeignKey(() => Country)
	@Column(DataType.BIGINT)
	countryid: number

	@BelongsTo(() => Country)
	country: Country;

	@Column
	postalcode: string

	@Column
	contactno1: string

	@Column
	contactno2: string
}
