import {
    Table,
    Column,
    PrimaryKey,
    Model,
    AutoIncrement,
    DataType,
    BeforeCreate,
    AllowNull,
    BeforeUpdate,
    ForeignKey,
    HasMany,
    BelongsTo,
    Scopes,
  } from 'sequelize-typescript';
  import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
//import { DataTypeTime } from 'sequelize';

const tableOptions: IDefineOptions = { timestamp: true, tableName: 'tblorderstatus' } as IDefineOptions;

@Table(tableOptions)

@Scopes(() => ({
    orderInfo: {
        attributes: ['statusid', 'status']
    }
}))
  
export class OrderStatus extends Model<OrderStatus>{

    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    statusid: number

    @Column(DataType.CHAR(255))
    status: string
}