'use strict';

import { Module } from '@nestjs/common';
//import { BaseModule } from '../core/module/base.module';
import { databaseProviders } from 'src/core/database/database.providers';
// import { UserAuthMiddleware } from '../../middleware/auth/userauth.middleware';
// import { BuyerOrderController } from './controller/buyerorder.controller';
// import { SellerOrderController } from './controller/sellerorder.controller';
// import { OrderStatusService } from './service/orderStatus.services';
import { orderStatusProvider, orderProvider, orderDetailProvider, orderShipmentProvider, orderAddressProvider } from './provider/order.providers';
//import { OrderStatusController } from './controller/orderStatus.controller';
//import { OrderService } from './service/order.service';
import { ChannelModule } from '../channel/channel.module';
import { UserModule } from '../user/user.module';
// import { CommonModule } from '../common/common.module';
// import { MediaModule } from '../media/media.module';
// import { ProductModule } from '../product/product.module';
import { CartModule } from './../cart/cart.module';
import { CheckoutService } from './service/checkout.service';
import { CheckoutController } from './controller/checkout.controller';
// import { SampleService } from './service/sample.service';
// import { OrderController } from './controller/order.admin.controller';
// import { OrderAdminService } from './service/order.admin.service';
//import { NotificationModule } from '../notification/notification.module';
import { MyAddressBookProviders } from '../user/provider/myAddressBook.providers';
import { DatabaseModule } from 'src/core/database/database.module';


@Module({
	controllers: [
        
		// OrderController,
		// SellerOrderController,
		// BuyerOrderController,
		// OrderStatusController,
		CheckoutController
	],
    imports: [
		DatabaseModule,
		ChannelModule,
		 UserModule,
		// CommonModule,
		// MediaModule,
		// ProductModule,
		CartModule,
		//NotificationModule
	],
	providers: [
		// OrderService,
		// OrderStatusService,

		CheckoutService,
		// SampleService,
		// OrderAdminService,
		...MyAddressBookProviders,
        ...databaseProviders,
		...orderStatusProvider,
		...orderProvider,
		...orderDetailProvider,
		...orderShipmentProvider,
		...orderAddressProvider
	],
	exports: [
		// SampleService,
		// OrderService,
		// OrderStatusService,
		...orderStatusProvider,
		...orderProvider,
		...orderDetailProvider,
		...orderShipmentProvider
	],
	// modules: [
	// 	DatabaseModule,
	// 	ChannelModule,
	// 	UserModule,
	// 	CommonModule,
	// 	MediaModule,
	// 	ProductModule,
	// 	CartModule,
	// 	NotificationModule
	// ]
})
export class OrderModule{}
