'use strict';

import { Inject, UseGuards, Controller, Post, Put, Get, HttpStatus, Request, Response, Param, Body, Query, InternalServerErrorException, Patch, Delete, ParseIntPipe, NotFoundException, Res, Req } from '@nestjs/common';
// //import { BaseController } from '../../core';
 import { ProductService } from '../service/product.service';
// import { ProductServiceOutBound } from '../transformation/productServiceOutBound';
//import { ProductFilterDto } from '../dto/productFilter.dto';
import { ValidationPipe } from '../../../middleware/pipe/validation.pipe';
import { ApiBearerAuth, ApiOperation } from '@nestjs/swagger';
import { AddProductDto } from '../dto/addProduct.dto';
import { ContextService } from './../../../context/context.service';
import { AuthGuard } from '@nestjs/passport';
import { ProcessException } from 'src/middleware/exception/Process.exception';
import { appconstant } from 'src/config/app.constant';
import { UpgradeException } from 'src/middleware/exception/Upgrade.exception';
import { esearch } from 'src/config/esearch';
import { isEmpty } from 'lodash';
import { ProductReject } from '../models/ProductReject.entity';
import { Utility } from '../helper/utility';
import { ProductServiceOutBound } from '../transformation/productServiceOutBound';
import { Op, QueryTypes } from "sequelize";
import { UpdateProductDto } from '../dto/updateProduct.dto';
import { AuthException } from 'src/middleware/exception/Auth.exception';
import { Product } from '../models/Product.entity';

var _ = require('lodash');

let fs = require('fs');
let path = require("path");
var http = require('http');

//@ApiUseTags('Product')
//@ApiBearerAuth()
@UseGuards(AuthGuard('jwt'))
@Controller('Product')
//@UseGuards(PlanGuard)
export class ProductController { //extends BaseController {
	private productServiceOutBound = new ProductServiceOutBound();
	constructor(
//		@Inject('RedisInstance') public redisInstance,
		private productService: ProductService,
		@Inject('SequelizeInstance') private readonly sequelizeInstance,
		@Inject('ProductRepository') private readonly productRepository: typeof Product,
		//private productIndexService: ProductIndexService
	) {
		//super();
	}

	async _validateProductModule(user) {
		// let currentUserPermissions = this.context.get('dataSession').permissions;
		// let currentUserRole = this.context.get('dataSession').role;

		// if (currentUserRole.roleId != Role.ROLE_ACCOUNT_USER) {
		// 	if (!currentUserPermissions.includes(permissions.MY_PRODUCTS)) {
		// 		throw new AuthException('Not allowed');
		// 	}
		// }

		// let user = this.context.get('user');
		if (+user.channel.channelTypeId != +appconstant.CHANNEL_TYPE_VENDOR) {
			throw new AuthException('Not allowed');
		}
	}

	@Get('getProductLimitForDialog')
	async productLimit(@Request() req, @Response() res) {
		let user = req.user;
		let product = await this.productService.getProductLimit(user);
		if(product){
			res.status(HttpStatus.OK).json(
				product.feature_value
			);
		}
	}

	@Post('Product/:ratingId')
	public async saveProduct(@Param('ratingId') ratingId,@Body(new ValidationPipe()) addProductDto: AddProductDto, @Request() req, @Response() res) {

        
		// let user = {userId:userId , channelId:channelId,contactId:contactId,ratingId:ratingId};//this.context.get('user');
		let user = req.user;
		console.log("User:",user);
		//let subscriptionFeatureKeys = this.context.get('subscriptionFeatures');
		// my-product preference
		//await this._validateProductModule();

		let product = await this.productService.addProduct(addProductDto, user, ratingId);

		// update product info to elastic search
		// await this.productIndexService.index(product.data.productId).then(() => {
		// 	this.productService.indexChannel(+user.channelId);
		// });

		res.status(HttpStatus.OK).json(
			product
		);
	}
	@Post('updateProduct/:sku')
	public async updateProduct(@Param('sku') sku, @Body(new ValidationPipe()) addProductDto: UpdateProductDto, @Request() req, @Response() res) {
		let user = req.user;
		if(req.user.hasOwnProperty('adminUserId'))
			user = Object.assign(user, {userId: 1});
		// my-product preference
		// await this._validateProductModule();

		let product = await this.productService.updateProduct(addProductDto, user, sku);

		res.status(HttpStatus.OK).json(
			product
		);
	}
	@Post('productmedialib')	
	public async saveProductMediaLib(@Body() medialab, @Request() req, @Response() res) {
    let product = await this.productService.saveProductMediaLib(medialab,+medialab.user.channelId,medialab.type);
		res.status(HttpStatus.OK).json(product);
    }
	
	@Post('deleteProductMediaLib')
	public async deleteProductMediaLib(@Body() medialab, @Response() res) {
    let product = await this.productService.deleteProductMediaLib(medialab);
		res.status(HttpStatus.OK).json(product);
	}
	
	@Get('getBrochurMedialib/:channelId')
	public async getBrochurMedialib(@Param('channelId') channelId, @Request() req, @Response() res) {
	let userMedia = await this.productService.getBrochurMedialib(channelId);
		if(userMedia){
			res.status(HttpStatus.OK).send(userMedia);
		}
	}
	
	@Post('suggestion/:viewId')
	public async getSuggestedProduct(@Param('viewId', new ParseIntPipe()) viewId: number,@Request() req, @Response() res,@Body() data)
	{
		let user = req.user;//this.context.get('user');		
		let contactId=user.contactId;
		let typeid=user.channelTypeId;
		let channelId=user.channelId;
		let profileTypeId=user.profileTypeId;
		let result=[];let innovation=[];		


		let order = data.order;
		// let query='select "productId" from "tblProductJCT" where "contactId"=:contactId ';
    	// let existingIds=await this.sequelizeInstance.query(query, {
        // type: QueryTypes.SELECT,
        // raw: true,		
        // replacements: {
        //     contactId:user.contactId        
        // }
        // }).then(x=>{        
        // return x.map(item => +item.productId);
        // })
    
    // if(existingIds.length==0)
    // { 
	// 	let query;
	// 	if(typeid==3)
	// 	{
	// 	if(viewId==20)
	// 	{
	// 		query='select tp."productId" from "tblChannelCustomerProfile" as tcp inner join "tblProduct" as tp on tp."deletedat" is null and  tp."channelId"=tcp."channelId" and tp."isSuggestion"=\'1\' '
	// 		+ ' and tp."isInovation" = \'1\' and tp."productId" in(select "productId" from "tblproductsharepreference" where "sharetypeid"=2 and "deletedat" is null) '

	// 		+ 'and tp."productCategorieId" in(select "productCategorieId" from "tblInterestedProductCategory" where "contactId"=' + contactId + ' '
	// 		+ 'and "deletedAt" is null union select "productCategorieId" from "tblChannelProductCategorie" where "channelId"=' + channelId + 'and "deletedAt" is null) '

	// 		+ 'and tp."productId" in (select "productId" from "tblproductlocation" where "locationtype"=\'TARGET\' and "deletedat" is null '
	// 		+ 'and "regionCountryJCTId" in (select "regionCountryJCTId" from "tblContactLocation" where "contactId"=' + contactId + ' and "deletedAt" is null '
	// 		+ 'and CAST("locationType" AS text)=\'SELLING\')) '

	// 		+ 'and tcp."channelId" in(select "channelId" from "tblChannel" where "channelTypeId"=2 '
	// 		+ 'and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" where "startup"=\'0\' and "deletedAt" is null) union '
	// 		+ 'select "channelId" from "tblChannel" where "channelTypeId"=2 and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" '
	// 		+ 'where "deletedAt" is null and "startup"=(select "startup" from "tblChannelDetail" where "channelId"=' + channelId + '))) '

	// 		+ 'and tcp."profileTypeId" in(select "profileTypeId" from "tblChannelCustomerProfile" where "deletedAt" is null and "channelId"=' + channelId + ') where tcp."deletedAt" is null order by tp."updatedat" desc';

	// 	}
	// 	else if(viewId==22)
	// 	{
	// 		query='select tp."productId" from "tblChannelCustomerProfile" as tcp inner join "tblProduct" as tp on tp."deletedat" is null and  tp."channelId"=tcp."channelId" and tp."isSuggestion"=\'1\' '
	// 		+ 'and tp."productId" in(select "productId" from "tblproductsharepreference" where "sharetypeid"=2 and "deletedat" is null) '

	// 		+ 'and tp."productCategorieId" in(select "productCategorieId" from "tblInterestedProductCategory" where "contactId"=' + contactId + ' '
	// 		+ 'and "deletedAt" is null union select "productCategorieId" from "tblChannelProductCategorie" where "channelId"=' + channelId + 'and "deletedAt" is null) '

	// 		+ 'and tp."productId" in (select "productId" from "tblproductlocation" where "locationtype"=\'TARGET\' and "deletedat" is null '
	// 		+ 'and "regionCountryJCTId" in (select "regionCountryJCTId" from "tblContactLocation" where "contactId"=' + contactId + ' and "deletedAt" is null '
	// 		+ 'and CAST("locationType" AS text)=\'SELLING\')) '

	// 		+ 'and tcp."channelId" in(select "channelId" from "tblChannel" where "channelTypeId"=2 '
	// 		+ 'and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" where "startup"=\'0\' and "deletedAt" is null) union '
	// 		+ 'select "channelId" from "tblChannel" where "channelTypeId"=2 and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" '
	// 		+ 'where "deletedAt" is null and "startup"=(select "startup" from "tblChannelDetail" where "channelId"=' + channelId + '))) '

	// 		+ 'and tcp."profileTypeId" in(select "profileTypeId" from "tblChannelCustomerProfile" where "deletedAt" is null and "channelId"=' + channelId + ') where tcp."deletedAt" is null order by tp."updatedat" desc';
	// 	}		
	// 	}
	// 	else if(typeid==4)
	// 	{
		
	// 	if(viewId==20)
	// 	{
	// 		query='select tp."productId" from "tblChannelCustomerProfile" as tcp inner join "tblProduct" as tp on tp."deletedat" is null and  tp."channelId"=tcp."channelId" and tp."isSuggestion"=\'1\' '
	// 		+ 'and tp."isInovation" = \'1\' and tp."productId" in(select "productId" from "tblproductsharepreference" where "sharetypeid"=2 and "deletedat" is null) '

	// 		+ 'and tp."productCategorieId" in(select "productCategorieId" from "tblInterestedProductCategory" where "contactId"=' + contactId + ' '
	// 		+ 'and "deletedAt" is null union select "productCategorieId" from "tblChannelProductCategorie" where "channelId"=' + channelId + 'and "deletedAt" is null) '

	// 		+ 'and tp."productId" in (select "productId" from "tblproductlocation" where "locationtype"=\'TARGET\' and "deletedat" is null '
	// 		+ 'and "regionCountryJCTId" in (select "regionCountryJCTId" from "tblContactLocation" where "contactId"=' + contactId + ' and "deletedAt" is null '
	// 		+ 'and CAST("locationType" AS text)=\'RETAIL\')) '

	// 		+ 'and tcp."channelId" in(select "channelId" from "tblChannel" where "channelTypeId"=2 '
	// 		+ 'and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" where "startup"=\'0\' and "deletedAt" is null) union '
	// 		+ 'select "channelId" from "tblChannel" where "channelTypeId"=2 and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" '
	// 		+ 'where "deletedAt" is null and "startup"=(select "startup" from "tblChannelDetail" where "channelId"=' + channelId + '))) '

	// 		+ 'and tcp."profileTypeId"=' + profileTypeId + 'where tcp."deletedAt" is null order by tp."updatedat" desc';

	// 	}
	// 	else if(viewId==22)
	// 	{
	// 		query='select tp."productId" from "tblChannelCustomerProfile" as tcp inner join "tblProduct" as tp on tp."deletedat" is null and  tp."channelId"=tcp."channelId" and tp."isSuggestion"=\'1\' '
	// 		+ 'and tp."productId" in(select "productId" from "tblproductsharepreference" where "sharetypeid"=2 and "deletedat" is null) '

	// 		+ 'and tp."productCategorieId" in(select "productCategorieId" from "tblInterestedProductCategory" where "contactId"=' + contactId + ' '
	// 		+ 'and "deletedAt" is null union select "productCategorieId" from "tblChannelProductCategorie" where "channelId"=' + channelId + 'and "deletedAt" is null) '

	// 		+ 'and tp."productId" in (select "productId" from "tblproductlocation" where "locationtype"=\'TARGET\' and "deletedat" is null '
	// 		+ 'and "regionCountryJCTId" in (select "regionCountryJCTId" from "tblContactLocation" where "contactId"=' + contactId + ' and "deletedAt" is null '
	// 		+ 'and CAST("locationType" AS text)=\'RETAIL\')) '

	// 		+ 'and tcp."channelId" in(select "channelId" from "tblChannel" where "channelTypeId"=2 '
	// 		+ 'and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" where "startup"=\'0\' and "deletedAt" is null) union '
	// 		+ 'select "channelId" from "tblChannel" where "channelTypeId"=2 and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" '
	// 		+ 'where "deletedAt" is null and "startup"=(select "startup" from "tblChannelDetail" where "channelId"=' + channelId + '))) '

	// 		+ 'and tcp."profileTypeId"=' + profileTypeId + 'where tcp."deletedAt" is null order by tp."updatedat" desc';
	// 	}
		
	// 	}

		
		try{

		if(viewId==22){
			
			result = await this.sequelizeInstance.query('select "productId",(select "productSKU" from "tblProduct" as tp where tp."productId"=pj."productId") from "tblProductJCT" as pj where "productId" not in(select "productid" from "tblproductrejection" where "channelid"=:channelId) and "productId" in(select "productId" from "tblProduct" where "deletedat" is null and "isactive"=\'1\') and "requested_by"=:contactId order by "rank" asc ', {
		type: QueryTypes.SELECT,
		raw: true,
		replacements:{
			contactId: contactId,
			channelId: channelId
		}
			}).then(x => {
				return _.uniqBy(x, 'productId');
		});
		}
		//Data for Innovation Tab
		// else if(viewId==20){
		// 	let product = 'select "productId","productSKU","product",(select "rank" from "tblProductJCT" as jct where jct."productId"=tp."productId" and "requested_by"=:contactId) from "tblProduct" as tp where "deletedat" is null and "isInovation"=\'1\' and "isactive"=\'1\' and "productId" not in(select "productid" from "tblproductrejection" where "channelid"=:channelId)';
		// 	innovation=await this.sequelizeInstance.query(product, {
		// 		type: QueryTypes.SELECT,
		// 		raw: true,				
		// 		replacements: {
		// 			contactId: contactId,
		// 			channelId: channelId
		// 		}
		// 		}).then(x=>{							
		// 			return  _.uniqBy(x,'productId');
		// 		})
		// 	innovation = _.sortBy(innovation, (e) => {
		// 		return +e.rank
		// 	});

		// 	let sugg = innovation.filter(p => p.rank != null);
		// 	let nonsugg = innovation.filter(p => p.rank === null);
		// 	nonsugg = _.sortBy(nonsugg, (e) => {
		// 		return e.product
		// 	});

		// 	//console.log("inno:", sugg.map(p => +p.productId));

		// 	result.push(...sugg.map(p => +p.productId));
		// 	result.push(...nonsugg.map(p => +p.productId));
		// }
		else if (viewId == 21) {
			let product = 'select "productId","productSKU" from "tblProduct" where "deletedat" is null and "isactive"=\'1\' and "productId" not in(select "productid" from "tblproductrejection" where "channelid"=:channelId) and "productId" not in(select "productId" from "tblProductJCT" where "requested_by"=:contactId) ';
			result = await this.sequelizeInstance.query(product, {
				type: QueryTypes.SELECT,
				raw: true,
				replacements: {
					channelId: channelId,
					contactId: contactId
				}
			}).then(x => {
				//return x.map(p => +p.productId);
				return _.uniqBy(x, 'productId');
			})
		}
		else if (viewId == 31) {
			let product = 'select "productId","productSKU" from "tblProduct" where "deletedat" is null and "isactive"=\'1\' and "productId" not in(select "productid" from "tblproductrejection" where "channelid"=:channelId) ';
			result=await this.sequelizeInstance.query(product, {
				type: QueryTypes.SELECT,
				raw: true,				
				replacements: {
					channelId: channelId
				}
				}).then(x=>{		
					//return x.map(p => +p.productId);
					return _.uniqBy(x, 'productId');
				})		
		}

		
		}
		catch(e)
		{
			console.log("error:",e);
		}
	//	console.log("mictdata:",data);
	//} end of if existingids

		//result = _.uniq(result);
		//result = _.uniqBy(result, 'productId');

	let filter=data.filter;
		let filterid = []; let filterFlag = false;

	if(data.search)
	{
		//console.log("page",pagination.page);//console.log("searcg",pagination.search);
		let  searchchannellist=await this.sequelizeInstance.query('select "productId" from "tblProduct" where "productId" = :id', {
			type: QueryTypes.SELECT,
			raw: true,
			replacements: {
			id: +data.search,
			}
			})

		let chl = searchchannellist.map(x => +x.productId);
		result = result.filter(ch => { return chl.includes(+ch.productId); })

	}

    if(filter.brand)
	{
		let brand='select array_agg("productId") as id from "tblProduct" where "brandId" in(:brand) and "productId" in(:productId) ';
		await this.sequelizeInstance.query(brand, {
            type: QueryTypes.SELECT,
		raw: true,
		replacements: {
			productId: (filterid.length > 0) ? filterid : result.map(x => x.productId),
        //productId:result,
		brand:filter.brand
		}
		}).then((result) => {			
			if(result[0].id){
				filterid = [];
                filterid.push(...result[0].id);
            }else
            filterid = [];
		});
		filterFlag = true;
    }

    if(filter.family)
	{			
		let family='select array_agg("productId") as id from "tblProduct" where "productGroupId" in(:family) and "productId" in(:productId) ';
		await this.sequelizeInstance.query(family, {
            type: QueryTypes.SELECT,
		raw: true,
		replacements: {
			productId: (filterid.length > 0) ? filterid : result.map(x => x.productId),
		//productId:result,
		family:filter.family
		}
		}).then((result) => {

			if(result[0].id){
				filterid = [];
                filterid.push(...result[0].id);
            }else
            filterid = [];
		});
		filterFlag = true;
    }
    if(filter.category)
	{			
		let category='select array_agg("productId") as id from "tblProduct" where "productCategorieId" in(:category) and "productId" in(:productId) ';
		await this.sequelizeInstance.query(category, {
            type: QueryTypes.SELECT,
		raw: true,
		replacements: {
			productId: (filterid.length > 0) ? filterid : result.map(x => x.productId),
		// productId:result,
		category:filter.category
		}
		}).then((result) => {
			if(result[0].id){
				filterid = [];
                filterid.push(...result[0].id);
            }else
            filterid = [];
		});
		filterFlag = true;
    }

    if(filter.country){
        let location='select array_agg(tp."productId") as id from "tblProduct" as tp inner join "tblproductlocation" as pc on pc."productId"=tp."productId" and pc."regionCountryJCTId" in '
        + '(select "regionCountryJCTId" from "tblRegionCountryJCT" where "countryId" in(select "countryId" from "tblCountry" where "countryId" in (:location))) where tp."productId" in(:productId) ';
        
        await this.sequelizeInstance.query(location, {
            type: QueryTypes.SELECT,
		raw: true,
		replacements: {
			productId: (filterid.length > 0) ? filterid : result.map(x => x.productId),
		//productId:result,
		location:filter.country
		}
		}).then((result) => {
			if(result[0].id){
				filterid = [];
                filterid.push(...result[0].id);
            }else
            filterid = [];
		});
		filterFlag = true;
    }

		if ((filter.toPrice != null && filter.toPrice < 1000) || (filter.fromPrice != null && filter.fromPrice > 1)) {
			console.log("filter.fromPrice:", filter.fromPrice);
			console.log("filter.toPrice:", filter.toPrice);
			let location = 'select array_agg("productId") as id from "tblproductpricedetail" where "retailerprice">=:fromPrice and "retailerprice"<=:toPrice and "productId" in(:productId)';

			await this.sequelizeInstance.query(location, {
				type: QueryTypes.SELECT,
				raw: true,
				replacements: {
					fromPrice: filter.fromPrice,
					toPrice: filter.toPrice,
					productId: (filterid.length > 0) ? filterid : result.map(x => x.productId),
					//productId: result,
				}
			}).then((result) => {
				if (result[0].id) {
					filterid = [];
					filterid.push(...result[0].id);
				} else
					filterid = [];
			});
			filterFlag = true;
		}

		if (filter.profile || filter.resellerprofile) {
		let ids = filter.profile ? filter.profile : filter.resellerprofile;
		let profile = 'select array_agg(tp."productId") as id from "tblProduct" as tp inner join "tblproductchannelcustomerprofile" as pc on pc."productId"=tp."productId" and pc."customerProfileId" in '
        + '(select "customerProfileId" from "tblChannelCustomerProfile" where "profileTypeId" in(select "profileTypeId" from "tblProfileType" where "profileTypeId" in (:profile))) where tp."productId" in(:productId) ';
		await this.sequelizeInstance.query(profile, {
            type: QueryTypes.SELECT,
		raw: true,
		replacements: {
			productId: (filterid.length > 0) ? filterid : result.map(x => x.productId),
			profile: (filter.profile && filter.resellerprofile) ? filter.profile.concat(filter.resellerprofile) : ids
		//profile:filter.profile
		}
		}).then((result) => {
			if(result[0].id){
				filterid = [];
                filterid.push(...result[0].id);
            }else
            filterid = [];
		});
		filterFlag = true;
    }   		
		filterid = _.uniq(filterid);

		if (filterid.length > 0 || filterFlag == true)
			result = result.filter(ch => { return filterid.includes(+ch.productId); })



		//let total = (filterid.length > 0 || filterFlag == true) ? filterid.length : result.length;
		let total = result.length;

		let master = result.map(x => x.productSKU);
		result = result.map(x => x.productId);
		//console.log("fproducts:", result);


		// result=filterid.length>0?filterid.slice(data.offset).slice(0,data.limit):result.slice(data.offset).slice(0,data.limit);
		if (viewId == 22 || viewId == 20) {
			//if (filterid.length > 0 || filterFlag == true)
				//result = filterid.slice(data.offset).slice(0, data.limit);
			//else
				result = result.slice(data.offset).slice(0, data.limit);
		}
		else if (viewId == 21 || viewId == 31) {
			let ordered = await this.productRepository.findAll({
				type: QueryTypes.SELECT,
				attributes: ['productId'],
				where: {
					productId: {
						[Op.in]: result //(filterid.length || filterFlag == true) ? filterid : result
					}
				},
				order: [['productId', 'asc']]
			}).then(res => { return res.map(x => x.productId) });

			result = ordered.slice(data.offset).slice(0, data.limit);
		}

		let product = await this.productService.getSuggestedProduct(result,data,user);

		if(viewId==22)
			product=_.sortBy(product, (e) => { 
				return +e.productJCT[0].rank
			});
		else if (viewId == 20) {
			let rankp = product.filter(p => p.productJCT.length > 0);
			rankp = _.sortBy(rankp, (e) => {
				return +e.productJCT[0].rank
			});
			let namep = product.filter(p => p.productJCT.length === 0);
			namep = _.sortBy(namep, (e) => {
				return e.product
			});
			product = [];
			product.push(...rankp);
			product.push(...namep);
		}
		else
			product = _.sortBy(product, (e) => {
				return +e.productId
			});
		
		if(product){
			let result = { product: product, total: total, master: master }
			res.status(HttpStatus.OK).send(result);
		}	

	}

	// Product Filter Services
	@Post('productaggr/:viewId')
	public async getProductAggregation(@Param('viewId', new ParseIntPipe()) viewId: number, @Request() req, @Response() res, @Body() data)
	{
		let user = req.user;//this.context.get('user');
		let contactId=user.contactId;
		let typeid=user.channelTypeId;
		let channelId=user.channelId;
		let profileTypeId=user.profileTypeId;
		let result = []; let innovation = [];
		// let query='select "productId" from "tblProductMatching" where "contactId"=:contactId ';
    	// let data=await this.sequelizeInstance.query(query, {
        // type: QueryTypes.SELECT,
        // raw: true,		
        // replacements: {
        //     contactId:user.contactId        
        // }
        // }).then(x=>{        
        // return x.map(item => +item.productId);
        // })
    
		// if(data.length==0)
		// { 
		// 	let query;
		// 	if(typeid==3)
		// 	{
		// 	if(viewId==20)
		// 	{
		// 		query = 'select tp."productId",tp."channelId" from "tblChannelCustomerProfile" as tcp inner join "tblProduct" as tp on tp."deletedat" is null and  tp."channelId"=tcp."channelId" and tp."isSuggestion"=\'1\' '
		// 		+ ' and tp."isInovation" = \'1\' and tp."productId" in(select "productId" from "tblproductsharepreference" where "sharetypeid"=2 and "deletedat" is null) '
	
		// 		+ 'and tp."productCategorieId" in(select "productCategorieId" from "tblContactInterestedProductCategory" where "contactId"=' + contactId + ' '
		// 		+ 'and "deletedAt" is null union select "productCategorieId" from "tblContactProductCategorie" where "contactId"=' + contactId + 'and "deletedAt" is null) '
	
		// 		+ 'and tp."productId" in (select "productId" from "tblproductlocation" where "locationtype"=\'TARGET\' and "deletedat" is null '
		// 		+ 'and "regionCountryJCTId" in (select "regionCountryJCTId" from "tblContactLocation" where "contactId"=' + contactId + ' and "deletedAt" is null '
		// 		+ 'and CAST("locationType" AS text)=\'SELLING\')) '
	
		// 		+ 'and tcp."channelId" in(select "channelId" from "tblChannel" where "channelTypeId"=2 '
		// 		+ 'and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" where "startup"=\'0\' and "deletedAt" is null) union '
		// 		+ 'select "channelId" from "tblChannel" where "channelTypeId"=2 and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" '
		// 		+ 'where "deletedAt" is null and "startup"=(select "startup" from "tblChannelDetail" where "channelId"=' + channelId + '))) '
	
		// 		+ 'and tcp."profileTypeId" in(select "profileTypeId" from "tblChannelCustomerProfile" where "deletedAt" is null and "channelId"=' + channelId + ') where tcp."deletedAt" is null order by tp."updatedat" desc';
	
		// 	}
		// 	else if(viewId==22)
		// 	{
		// 		query = 'select tp."productId",tp."channelId" from "tblChannelCustomerProfile" as tcp inner join "tblProduct" as tp on tp."deletedat" is null and  tp."channelId"=tcp."channelId" and tp."isSuggestion"=\'1\' '
		// 		+ 'and tp."productId" in(select "productId" from "tblproductsharepreference" where "sharetypeid"=2 and "deletedat" is null) '
	
		// 		+ 'and tp."productCategorieId" in(select "productCategorieId" from "tblContactInterestedProductCategory" where "contactId"=' + contactId + ' '
		// 		+ 'and "deletedAt" is null union select "productCategorieId" from "tblContactProductCategorie" where "contactId"=' + contactId + 'and "deletedAt" is null) '
	
		// 		+ 'and tp."productId" in (select "productId" from "tblproductlocation" where "locationtype"=\'TARGET\' and "deletedat" is null '
		// 		+ 'and "regionCountryJCTId" in (select "regionCountryJCTId" from "tblContactLocation" where "contactId"=' + contactId + ' and "deletedAt" is null '
		// 		+ 'and CAST("locationType" AS text)=\'SELLING\')) '
	
		// 		+ 'and tcp."channelId" in(select "channelId" from "tblChannel" where "channelTypeId"=2 '
		// 		+ 'and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" where "startup"=\'0\' and "deletedAt" is null) union '
		// 		+ 'select "channelId" from "tblChannel" where "channelTypeId"=2 and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" '
		// 		+ 'where "deletedAt" is null and "startup"=(select "startup" from "tblChannelDetail" where "channelId"=' + channelId + '))) '
	
		// 		+ 'and tcp."profileTypeId" in(select "profileTypeId" from "tblChannelCustomerProfile" where "deletedAt" is null and "channelId"=' + channelId + ') where tcp."deletedAt" is null order by tp."updatedat" desc';
		// 	}		
		// 	}
		// 	else if(typeid==4)
		// 	{
			
		// 	if(viewId==20)
		// 	{
		// 		query = 'select tp."productId",tp."channelId" from "tblChannelCustomerProfile" as tcp inner join "tblProduct" as tp on tp."deletedat" is null and  tp."channelId"=tcp."channelId" and tp."isSuggestion"=\'1\' '
		// 		+ 'and tp."isInovation" = \'1\' and tp."productId" in(select "productId" from "tblproductsharepreference" where "sharetypeid"=2 and "deletedat" is null) '
	
		// 		+ 'and tp."productCategorieId" in(select "productCategorieId" from "tblContactInterestedProductCategory" where "contactId"=' + contactId + ' '
		// 		+ 'and "deletedAt" is null union select "productCategorieId" from "tblContactProductCategorie" where "contactId"=' + contactId + 'and "deletedAt" is null) '
	
		// 		+ 'and tp."productId" in (select "productId" from "tblproductlocation" where "locationtype"=\'TARGET\' and "deletedat" is null '
		// 		+ 'and "regionCountryJCTId" in (select "regionCountryJCTId" from "tblContactLocation" where "contactId"=' + contactId + ' and "deletedAt" is null '
		// 		+ 'and CAST("locationType" AS text)=\'RETAIL\')) '
	
		// 		+ 'and tcp."channelId" in(select "channelId" from "tblChannel" where "channelTypeId"=2 '
		// 		+ 'and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" where "startup"=\'0\' and "deletedAt" is null) union '
		// 		+ 'select "channelId" from "tblChannel" where "channelTypeId"=2 and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" '
		// 		+ 'where "deletedAt" is null and "startup"=(select "startup" from "tblChannelDetail" where "channelId"=' + channelId + '))) '
	
		// 		+ 'and tcp."profileTypeId"=' + profileTypeId + 'where tcp."deletedAt" is null order by tp."updatedat" desc';
	
		// 	}
		// 	else if(viewId==22)
		// 	{
		// 		query = 'select tp."productId",tp."channelId" from "tblChannelCustomerProfile" as tcp inner join "tblProduct" as tp on tp."deletedat" is null and  tp."channelId"=tcp."channelId" and tp."isSuggestion"=\'1\' '
		// 		+ 'and tp."productId" in(select "productId" from "tblproductsharepreference" where "sharetypeid"=2 and "deletedat" is null) '
	
		// 		+ 'and tp."productCategorieId" in(select "productCategorieId" from "tblContactInterestedProductCategory" where "contactId"=' + contactId + ' '
		// 		+ 'and "deletedAt" is null union select "productCategorieId" from "tblContactProductCategorie" where "contactId"=' + contactId + 'and "deletedAt" is null) '
	
		// 		+ 'and tp."productId" in (select "productId" from "tblproductlocation" where "locationtype"=\'TARGET\' and "deletedat" is null '
		// 		+ 'and "regionCountryJCTId" in (select "regionCountryJCTId" from "tblContactLocation" where "contactId"=' + contactId + ' and "deletedAt" is null '
		// 		+ 'and CAST("locationType" AS text)=\'RETAIL\')) '
	
		// 		+ 'and tcp."channelId" in(select "channelId" from "tblChannel" where "channelTypeId"=2 '
		// 		+ 'and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" where "startup"=\'0\' and "deletedAt" is null) union '
		// 		+ 'select "channelId" from "tblChannel" where "channelTypeId"=2 and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" '
		// 		+ 'where "deletedAt" is null and "startup"=(select "startup" from "tblChannelDetail" where "channelId"=' + channelId + '))) '
	
		// 		+ 'and tcp."profileTypeId"=' + profileTypeId + 'where tcp."deletedAt" is null order by tp."updatedat" desc';
		// 	}
			
		// 	}	
			
			try{
	
				if (viewId == 22) {

					result = await this.sequelizeInstance.query('select "productId","partnerChannelId" as "channelId" from "tblProductJCT" where "productId" in(select "productId" from "tblProduct" where "deletedat" is null and "isactive"=\'1\') and "productId" not in(select "productid" from "tblproductrejection" where "channelid"=:channelId) and "requested_by"=:contactId order by "rank" asc ', {
						type: QueryTypes.SELECT,
						raw: true,
						replacements: {
							contactId: contactId,
							channelId: channelId
						}
					}).then(x => {
						return _.uniqBy(x, 'productId');
					});
			}
			// else if(viewId==20){
			// 	let product = 'select "productId","channelId" from "tblProduct" where "deletedat" is null and "isInovation"=\'1\' and "isactive"=\'1\' ';
			// 	innovation=await this.sequelizeInstance.query(product, {
			// 		type: QueryTypes.SELECT,
			// 		raw: true,				
			// 		}).then(x=>{							
			// 			return x;//.map(p => +p.productId);
			// 		})
					
			// result.push(...innovation);
			// }
				else if (viewId == 21) {
					let product = 'select "productId","channelId" from "tblProduct" where "deletedat" is null and "isactive"=\'1\' and "productId" not in(select "productid" from "tblproductrejection" where "channelid"=:channelId) and "productId" not in(select "productId" from "tblProductJCT" where "requested_by"=:contactId)';
					result = await this.sequelizeInstance.query(product, {
						type: QueryTypes.SELECT,
						raw: true,
						replacements: {
							channelId: channelId,
							contactId: contactId
						}
					}).then(x => {
						return _.uniqBy(x, 'productId');
					})
				}
				else if (viewId == 31) {
					let product = 'select "productId","channelId" from "tblProduct" where "deletedat" is null and "isactive"=\'1\' and "productId" not in(select "productid" from "tblproductrejection" where "channelid"=:channelId) ';
				result=await this.sequelizeInstance.query(product, {
					type: QueryTypes.SELECT,
					raw: true,				
					replacements: {
						channelId: channelId
					}
					}).then(x=>{		
						//return x.map(p => +p.productId);
						return _.uniqBy(x, 'productId');
					})		
				}


			}
			catch(e)
			{
				console.log("error:",e);
			}
		//	console.log("mictdata:",data);
		//}			
		//result = _.uniq(result);
		//result = _.uniqBy(result, 'productId');

		//console.log("productids:", result);

		let filter = data.filter;
		let filterid = [];
		let plist = result.map(x => +x.productId);

		if (filter.brand) {

			let brand = 'select array_agg("productId") as id from "tblProduct" where "brandId" in(:brand) and "productId" in(:productId) ';
			await this.sequelizeInstance.query(brand, {
				type: QueryTypes.SELECT,
				raw: true,
				replacements: {
					productId: plist,
					brand: filter.brand
				}
			}).then((result) => {
				if (result[0].id) {
					filterid = [];
					filterid.push(...result[0].id);
				} else
					filterid = [];
			});
			result = result.filter(ch => { return filterid.includes(ch.productId); })
		}
		if (filter.family) {
			let family = 'select array_agg("productId") as id from "tblProduct" where "productGroupId" in(:family) and "productId" in(:productId) ';
			await this.sequelizeInstance.query(family, {
				type: QueryTypes.SELECT,
				raw: true,
				replacements: {
					productId: plist,
					family: filter.family
				}
			}).then((result) => {

				if (result[0].id) {
					filterid = [];
					filterid.push(...result[0].id);
				} else
					filterid = [];
			});
			result = result.filter(ch => { return filterid.includes(ch.productId); })
		}
		if (filter.category) {
			let category = 'select array_agg("productId") as id from "tblProduct" where "productCategorieId" in(:category) and "productId" in(:productId) ';
			await this.sequelizeInstance.query(category, {
				type: QueryTypes.SELECT,
				raw: true,
				replacements: {
					productId: plist,
					category: filter.category
				}
			}).then((result) => {
				if (result[0].id) {
					filterid = [];
					filterid.push(...result[0].id);
				} else
					filterid = [];
			});
			result = result.filter(ch => { return filterid.includes(ch.productId); })
		}
		if (filter.country) {
			let location = 'select array_agg(tp."productId") as id from "tblProduct" as tp inner join "tblproductlocation" as pc on pc."productId"=tp."productId" and pc."regionCountryJCTId" in '
				+ '(select "regionCountryJCTId" from "tblRegionCountryJCT" where "countryId" in(select "countryId" from "tblCountry" where "countryId" in (:location))) where tp."productId" in(:productId) ';

			await this.sequelizeInstance.query(location, {
				type: QueryTypes.SELECT,
				raw: true,
				replacements: {
					productId: plist,
					location: filter.country
				}
			}).then((result) => {
				if (result[0].id) {
					filterid = [];
					filterid.push(...result[0].id);
				} else
					filterid = [];
			});
			result = result.filter(ch => { return filterid.includes(ch.productId); })
		}

		if ((filter.toPrice != null && filter.toPrice < 1000) || (filter.fromPrice != null && filter.fromPrice > 1)) {
			// console.log("filter.fromPrice:", filter.fromPrice);
			// console.log("filter.toPrice:", filter.toPrice);
			let location = 'select array_agg("productId") as id from "tblproductpricedetail" where "retailerprice">=:fromPrice and "retailerprice"<=:toPrice and "productId" in(:productId)';

			await this.sequelizeInstance.query(location, {
				type: QueryTypes.SELECT,
				raw: true,
				replacements: {
					fromPrice: filter.fromPrice,
					toPrice: filter.toPrice,
					productId: plist,
				}
			}).then((result) => {
				if (result[0].id) {
					filterid = [];
					filterid.push(...result[0].id);
				} else
					filterid = [];
			});
			result = result.filter(ch => { return filterid.includes(ch.productId); })
		}

		if (filter.profile || filter.resellerprofile) {
			let ids = filter.profile ? filter.profile : filter.resellerprofile;
			let profile = 'select array_agg(tp."productId") as id from "tblProduct" as tp inner join "tblproductchannelcustomerprofile" as pc on pc."productId"=tp."productId" and pc."customerProfileId" in '
				+ '(select "customerProfileId" from "tblChannelCustomerProfile" where "profileTypeId" in(select "profileTypeId" from "tblProfileType" where "profileTypeId" in (:profile))) where tp."productId" in(:productId) ';
			await this.sequelizeInstance.query(profile, {
				type: QueryTypes.SELECT,
				raw: true,
				replacements: {
					productId: plist,
					profile: (filter.profile && filter.resellerprofile) ? filter.profile.concat(filter.resellerprofile) : ids
					//profile: filter.profile
				}
			}).then((result) => {
				if (result[0].id) {
					filterid = [];
					filterid.push(...result[0].id);
				} else
					filterid = [];
			});
			result = result.filter(ch => { return filterid.includes(ch.productId); })
		}

		res.status(HttpStatus.OK).send(result);
	}

	@Post('brandFilter')
	async brandFilter(@Request() req, @Response() res,@Body() data){
        //let channel = await this.channelService.chFilterBase(viewId,req.user);

		let result = await this.productService.getBrandFilter(data.productIds);
        return res.status(HttpStatus.OK).send(result);      
    }

	@Post('familyFilter')
	async familyFilter(@Request() req, @Response() res,@Body() data){

        //let channel = await this.channelService.chFilterBase(viewId,req.user);
		let result = await this.productService.getFamilyFilter(data.productIds);
        return res.status(HttpStatus.OK).send(result);      
    }

	@Post('categoryFilter')
	async categoryFilter(@Request() req, @Response() res,@Body() data){
        //let channel = await this.channelService.chFilterBase(viewId,req.user);
		let result = await this.productService.getCategoryFilter(data.productIds);
        return res.status(HttpStatus.OK).send(result);      
    }

	@Post('locationFilter')
	async locationFilter(@Request() req, @Response() res,@Body() data){
        //let channel = await this.channelService.chFilterBase(viewId,req.user);
		let result = await this.productService.getLocationFilter(data.productIds);
        return res.status(HttpStatus.OK).send(result);      
    }

	@Post('priceFilter')
	async priceFilter(@Request() req, @Response() res, @Body() data) {
		//let channel = await this.channelService.chFilterBase(viewId,req.user);
		let result = await this.productService.getPriceFilter(data.productIds);
		return res.status(HttpStatus.OK).send(result);
	}


	@Post('profileFilter')
	async profileFilter(@Request() req, @Response() res,@Body() data){
        //let channel = await this.channelService.chFilterBase(viewId,req.user);
		let result = await this.productService.getProfileFilter(data.channelIds);
        return res.status(HttpStatus.OK).send(result);      
    }

	@Post('searchFilter')
	async searchFilter(@Request() req, @Response() res,@Body() data){
        //let channel = await this.channelService.chFilterBase(viewId,req.user);
		let result = await this.productService.getSearchFilter(data.data);
        return res.status(HttpStatus.OK).send(result);      
    }

// End of Product Filter Services


	@Get('productSearch/:viewId')
	public async getProductSearch(@Param('viewId', new ParseIntPipe()) viewId: number,@Request() req, @Response() res)
	{
		let user = req.user;//this.context.get('user');
		let contactId=user.contactId;
		let typeid=user.channelTypeId;
		let channelId=user.channelId;
		let profileTypeId=user.profileTypeId;
		let data=[];let result=[];let innovation=[];	
    
		if(data.length==0)
		{ 
			let query;
			if(typeid==3)
			{
			if(viewId==20)
			{
				query='select tp."productId" from "tblChannelCustomerProfile" as tcp inner join "tblProduct" as tp on tp."deletedat" is null and  tp."channelId"=tcp."channelId" and tp."isSuggestion"=\'1\' '
				+ ' and tp."isInovation" = \'1\' and tp."productId" in(select "productId" from "tblproductsharepreference" where "sharetypeid"=2 and "deletedat" is null) '
	
				+ 'and tp."productCategorieId" in(select "productCategorieId" from "tblContactInterestedProductCategory" where "contactId"=' + contactId + ' '
				+ 'and "deletedAt" is null union select "productCategorieId" from "tblContactProductCategorie" where "contactId"=' + contactId + 'and "deletedAt" is null) '
	
				+ 'and tp."productId" in (select "productId" from "tblproductlocation" where "locationtype"=\'TARGET\' and "deletedat" is null '
				+ 'and "regionCountryJCTId" in (select "regionCountryJCTId" from "tblContactLocation" where "contactId"=' + contactId + ' and "deletedAt" is null '
				+ 'and CAST("locationType" AS text)=\'SELLING\')) '
	
				+ 'and tcp."channelId" in(select "channelId" from "tblChannel" where "channelTypeId"=2 '
				+ 'and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" where "startup"=\'0\' and "deletedAt" is null) union '
				+ 'select "channelId" from "tblChannel" where "channelTypeId"=2 and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" '
				+ 'where "deletedAt" is null and "startup"=(select "startup" from "tblChannelDetail" where "channelId"=' + channelId + '))) '
	
				+ 'and tcp."profileTypeId" in(select "profileTypeId" from "tblChannelCustomerProfile" where "deletedAt" is null and "channelId"=' + channelId + ') where tcp."deletedAt" is null order by tp."updatedat" desc';
	
			}
			else if(viewId==22)
			{
				query='select tp."productId" from "tblChannelCustomerProfile" as tcp inner join "tblProduct" as tp on tp."deletedat" is null and  tp."channelId"=tcp."channelId" and tp."isSuggestion"=\'1\' '
				+ 'and tp."productId" in(select "productId" from "tblproductsharepreference" where "sharetypeid"=2 and "deletedat" is null) '
	
				+ 'and tp."productCategorieId" in(select "productCategorieId" from "tblContactInterestedProductCategory" where "contactId"=' + contactId + ' '
				+ 'and "deletedAt" is null union select "productCategorieId" from "tblContactProductCategorie" where "contactId"=' + contactId + 'and "deletedAt" is null) '
	
				+ 'and tp."productId" in (select "productId" from "tblproductlocation" where "locationtype"=\'TARGET\' and "deletedat" is null '
				+ 'and "regionCountryJCTId" in (select "regionCountryJCTId" from "tblContactLocation" where "contactId"=' + contactId + ' and "deletedAt" is null '
				+ 'and CAST("locationType" AS text)=\'SELLING\')) '
	
				+ 'and tcp."channelId" in(select "channelId" from "tblChannel" where "channelTypeId"=2 '
				+ 'and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" where "startup"=\'0\' and "deletedAt" is null) union '
				+ 'select "channelId" from "tblChannel" where "channelTypeId"=2 and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" '
				+ 'where "deletedAt" is null and "startup"=(select "startup" from "tblChannelDetail" where "channelId"=' + channelId + '))) '
	
				+ 'and tcp."profileTypeId" in(select "profileTypeId" from "tblChannelCustomerProfile" where "deletedAt" is null and "channelId"=' + channelId + ') where tcp."deletedAt" is null order by tp."updatedat" desc';
			}		
			}
			else if(typeid==4)
			{
			
			if(viewId==20)
			{
				query='select tp."productId" from "tblChannelCustomerProfile" as tcp inner join "tblProduct" as tp on tp."deletedat" is null and  tp."channelId"=tcp."channelId" and tp."isSuggestion"=\'1\' '
				+ 'and tp."isInovation" = \'1\' and tp."productId" in(select "productId" from "tblproductsharepreference" where "sharetypeid"=2 and "deletedat" is null) '
	
				+ 'and tp."productCategorieId" in(select "productCategorieId" from "tblContactInterestedProductCategory" where "contactId"=' + contactId + ' '
				+ 'and "deletedAt" is null union select "productCategorieId" from "tblContactProductCategorie" where "contactId"=' + contactId + 'and "deletedAt" is null) '
	
				+ 'and tp."productId" in (select "productId" from "tblproductlocation" where "locationtype"=\'TARGET\' and "deletedat" is null '
				+ 'and "regionCountryJCTId" in (select "regionCountryJCTId" from "tblContactLocation" where "contactId"=' + contactId + ' and "deletedAt" is null '
				+ 'and CAST("locationType" AS text)=\'RETAIL\')) '
	
				+ 'and tcp."channelId" in(select "channelId" from "tblChannel" where "channelTypeId"=2 '
				+ 'and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" where "startup"=\'0\' and "deletedAt" is null) union '
				+ 'select "channelId" from "tblChannel" where "channelTypeId"=2 and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" '
				+ 'where "deletedAt" is null and "startup"=(select "startup" from "tblChannelDetail" where "channelId"=' + channelId + '))) '
	
				+ 'and tcp."profileTypeId"=' + profileTypeId + 'where tcp."deletedAt" is null order by tp."updatedat" desc';
	
			}
			else if(viewId==22)
			{
				query='select tp."productId" from "tblChannelCustomerProfile" as tcp inner join "tblProduct" as tp on tp."deletedat" is null and  tp."channelId"=tcp."channelId" and tp."isSuggestion"=\'1\' '
				+ 'and tp."productId" in(select "productId" from "tblproductsharepreference" where "sharetypeid"=2 and "deletedat" is null) '
	
				+ 'and tp."productCategorieId" in(select "productCategorieId" from "tblContactInterestedProductCategory" where "contactId"=' + contactId + ' '
				+ 'and "deletedAt" is null union select "productCategorieId" from "tblContactProductCategorie" where "contactId"=' + contactId + 'and "deletedAt" is null) '
	
				+ 'and tp."productId" in (select "productId" from "tblproductlocation" where "locationtype"=\'TARGET\' and "deletedat" is null '
				+ 'and "regionCountryJCTId" in (select "regionCountryJCTId" from "tblContactLocation" where "contactId"=' + contactId + ' and "deletedAt" is null '
				+ 'and CAST("locationType" AS text)=\'RETAIL\')) '
	
				+ 'and tcp."channelId" in(select "channelId" from "tblChannel" where "channelTypeId"=2 '
				+ 'and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" where "startup"=\'0\' and "deletedAt" is null) union '
				+ 'select "channelId" from "tblChannel" where "channelTypeId"=2 and "deletedAt" is null and "channelId" in(select "channelId" from "tblChannelDetail" '
				+ 'where "deletedAt" is null and "startup"=(select "startup" from "tblChannelDetail" where "channelId"=' + channelId + '))) '
	
				+ 'and tcp."profileTypeId"=' + profileTypeId + 'where tcp."deletedAt" is null order by tp."updatedat" desc';
			}
			
			}	
			
			try{
	
			if(viewId==22){
				result = await this.sequelizeInstance.query('select "productId" from "tblProductJCT" as pj where "productId" not in(select "productid" from "tblproductrejection" where "channelid"=:channelId) and "productId" in(select "productId" from "tblProduct" where "deletedat" is null and "isactive"=\'1\') and "requested_by"=:contactId order by "rank" asc ', {
					type: QueryTypes.SELECT,
					raw: true,
					replacements: {
						contactId: contactId,
						channelId: channelId
					}
				}).then(x => {
					return x.map(p => +p.productId);
				});
			}
			else if(viewId==20){
				let product = 'select "productId" from "tblProduct" where "deletedat" is null and "isInovation"=\'1\' and "isactive"=\'1\' ';
				innovation=await this.sequelizeInstance.query(product, {
					type: QueryTypes.SELECT,
					raw: true,				
					}).then(x=>{							
					return x.map(p => +p.productId);
					})
					
			result.push(...innovation);
			}
			else if(viewId==21||viewId==31){
				let product = 'select "productId" from "tblProduct" where "deletedat" is null and "isactive"=\'1\' and "productId" not in(select "productid" from "tblproductrejection" where "channelid"=:channelId) and "productId" not in(select "productId" from "tblProductJCT" where "requested_by"=:contactId) ';
				result=await this.sequelizeInstance.query(product, {
					type: QueryTypes.SELECT,
					raw: true,
					replacements: {
						channelId: channelId,
						contactId: contactId
					}
					}).then(x=>{		
					return x.map(p => +p.productId);
					})		
			}
	
			
			}
			catch(e)
			{
				console.log("error:",e);
			}
		//	console.log("mictdata:",data);
		}
		
		let product = await this.productService.getProductSearch(result);
		if(product){
			res.status(HttpStatus.OK).send(product);
		}
	}

	@Get(':sku')
	public async getProduct(@Param('sku') sku, @Request() req, @Response() res) {
		let user = req.user; //this.context.get('user');
		
		let productDetail = await this.productService.getProductBySKU(sku);
		//console.log('productDetail',productDetail);
		await this._validateProductView(productDetail, user);

		return res.status(HttpStatus.OK).json(
			await this.productServiceOutBound.productCustomerProfile(
				await this.productService.getProduct(sku, user), user
			)
		);
	}

	@Get('getAdminProduct/:sku/:channelId')
	public async getAdminProduct(@Param('sku') sku,@Param('channelId') channelId, @Request() req, @Response() res) {
		
		let user=await this.getUser(channelId);
		//console.log("bouser:",user);
		let productDetail = await this.productService.getProductBySKU(sku);
		
		await this._validateProductView(productDetail, user);
		
		return res.status(HttpStatus.OK).json(
			await this.productServiceOutBound.productCustomerProfile(
				await this.productService.getProduct(sku, user), user
			)
		);
	}


	public async getUser(channelId) {
		let query='select "firstName","lastName",tc."email",tc."channelId",tc."contactId",tch."planId",tch."subscriptionId",tch."channelTypeId",tu."userId", '
		+ 'case when tch."isOEM"=\'1\' then \'B2C\' when tch."isOEM"=\'2\' then \'B2B\' when tch."isOEM"=\'3\' then \'Both\' end, '
		+ '(select "documentPath" from "tblDocument" where "documentId"=tc."documentId"), '
		+ '(select "roleId" from "tblUserRole" where "userId"=tu."userId") '
		+ 'from "tblContact" as tc inner join "tblChannel" as tch on tch."channelId"=tc."channelId" inner join "tblUser" as tu on tu."contactId"=tc."contactId"  where "isDefaultContact"=\'1\' and tc."channelId"=:channelId ';


		let user = await this.sequelizeInstance.query(query, {
			type: QueryTypes.SELECT,
			raw: true,
			replacements: {
				channelId: channelId				
			}
		}).then(result => {
			//console.log("getUserResult:",result);
			return result[0];
		}).catch(err => {
			console.log("getUserErr:",err);
		});
	
		return user;
	}



	@Get('info/:sku')
	public async getProductInfo(@Param('sku') sku, @Request() req, @Response() res) {
		let user = req.user; //this.context.get('user');
		//console.log("user", user);
		let productDetail = await this.productService.getProductBySKU(sku);

		await this._validateProductView(productDetail, user);

		let productData = await this.productService.getProductInfo(sku, user);

		res.status(HttpStatus.OK).send(productData);
	}

	async _validateProductView(productDetail, user) {
		if (+user.channelTypeId != +appconstant.CHANNEL_TYPE_HUB && +productDetail.channelId != +user.channelId) {
			// validate is active
			if (productDetail.isactive != '1') {
				console.log("not active");
				throw new NotFoundException('NotFound');
			}

			// don't show this product to free plan users
			// if (productDetail.isshowtofreesub == '1' && user.planId == appconstant.FREE_PLANID) {
			// 	throw new UpgradeException('Upgrade you plan to access this page');
			// }

			// validate ProductSharePreference
			// await new Utility().lazyload(productDetail, 'shareType', {
			// 	where: {
			// 		sharetypeid: esearch.shareTypeId[+user.channelTypeId]
			// 	}
			// });


			// if (isEmpty(productDetail.shareType)) {
			// 	throw new NotFoundException('NotFound');
			// }

			// validate product already rejected
			await ProductReject.count({
				where: {
					productid: +productDetail.productId,
					channelid: +user.channelId
				}
			}).then((result) => {
				if (result != 0) {
					console.log("productrejected");
					throw new ProcessException('product:reject:rejectedProduct');
				}
			});

			// validate product channel already rejected
			// await this.productService.channelRejectedCheck(productDetail, user).then((result) => {
			// 	if (result) {
			// 		console.log("channelrejected");
			// 		throw new ProcessException('product:reject:rejectedProduct');
			// 	}
			// });
		}

	}
	@Get('productActionInfo/:sku')
	async index(@Param('sku') sku, @Request() req, @Response() res) {
		let user = req.user;

		let result = await this.productService.productActions(user, sku);

		res.status(HttpStatus.OK).send(result);
	}
	@Post('channel-products/:channelId')
	async channelProductFindAll(@Request() req, @Param('channelId', new ParseIntPipe()) channelId: number, @Response() res, @Body(new ValidationPipe()) productFilters: any) {
		let user = req.user;
		if(user.hasOwnProperty('adminUserId')){
			user={
				channelTypeId:1,
				channelId:1,
				contactId:1,
				userId:1
			}
		}
		let type = +user.channelTypeId;
		let query = 'select tp."brandId",tp."productId",tp."product", tp."productSKU", tp."productqualitylevel", pr."businesscurrencyid",pr."retailerprice", br."brandName",(select concat( \'' + process.env.CDN_URL + '\',"documentPath") as "brandDocumentUrl" from "tblDocument" where "documentId" = br."documentId"),(select concat( \'' + process.env.CDN_URL + '\',"documentPath") as "documentUrl" from "tblDocument" where "documentId" in(select "imageid" from "tblproductimage" where "productimageid"=tp."defaultimageid"))from "tblProduct" as tp inner join "tblBrand" as br on br."id"=tp."brandId" inner join "tblproductpricedetail" as pr on pr."productId"=tp."productId" where "channelId"= :channelId and tp."deletedat" is null and "isactive"=\'1\'';
		query += ' and tp."productId" not in(select "productid" as "productId" from "tblproductrejection" where channelid = ' + user.channelId+')';
		if(productFilters.excludedProductSku)
		query += ' and tp."productSKU" !=:excludedProductSku';
		if(type!=2)
		query += ' and tp."productId" in(select "productId" from "tblproductsharepreference" where sharetypeid = :sharedId and "productId" = tp."productId" and "deletedat" IS NULL)';
		let result=await this.sequelizeInstance.query(query, {
            type: QueryTypes.SELECT,
			raw: true,
		replacements: {
			channelId:channelId,
			excludedProductSku:productFilters.excludedProductSku?productFilters.excludedProductSku:null,
			sharedId:type==2?1:type==3?2:type==4?3:4
		}
		})
		res.status(HttpStatus.OK).send(result);
	}

	@Put('setProductPublicView')
	async setProductPublicView(@Request() req, @Response() res,  @Body() data: any) {
		let result = await this.productService.setProductPublicView(data);
		res.status(HttpStatus.OK).send(result);
	}

	@Post('setProductPublicFlags')
	async setProductPublicFlags(@Request() req, @Response() res,  @Body() data: any) {
		let result = await this.productService.setProductPublicFlags(data);
		res.status(HttpStatus.OK).send(result);
	}

	@Put('setProductOrder')
	async setProductOrder(@Request() req, @Response() res,  @Body() data: any) {
		let result = await this.productService.setProductOrder(data);
		res.status(HttpStatus.OK).send(result);
	}


	async validateProductLimit(user){

		let query = 'select count(*) as "activeProducts" from "tblProduct" as tp  where tp."channelId"= :channelId and tp."deletedat" is null and "isactive"=:isactive ';

		let result=await this.sequelizeInstance.query(query, {
            type: QueryTypes.SELECT,
			raw: true,
			replacements: {
				channelId:user.channelId,
				isactive:'1'
			}
		});
				
		let allowedProductCount = +(user.channel.channelSubscription.keyFeature[appconstant.SubscriptionCharcteristicFeature['NO_OF_PRODUCT']]);

		let activeProducts = +(result[0].activeProducts);
		
		if(activeProducts > allowedProductCount) {
			
			let updQuery = 'update "tblProduct" set "isactive"=:inActive where "productId" in (select "productId" from "tblProduct" as tp  where tp."channelId"= :channelId and tp."deletedat" is null and "isactive"=:isactive) ';
			await this.sequelizeInstance.query(updQuery, {
				type: QueryTypes.SELECT,
				raw: true,
					replacements: {
						channelId:user.channelId,
						isactive:'1',
						inActive:'0',
					}
			});

			let updAllowedProduct = 'update "tblProduct" set "isactive"=:isactive where "productId" IN (select "productId" from "tblProduct" where "channelId"= :channelId and "deletedat" is null and "isactive"=:inactive  order by "updatedat" desc limit  :limit )';
			
			await this.sequelizeInstance.query(updAllowedProduct, {
				type: QueryTypes.SELECT,
				raw: true,
					replacements: {
						channelId:user.channelId,
						isactive:'1',
						inactive:'0',
						limit:allowedProductCount
					}
			});
		}
		//console.log('+++++++++++++++++++++++++++++++++++++++++');
	}

	@Post('my-products')
	async myProduct(@Request() req, @Response() res, @Body(new ValidationPipe()) productFilters: any) {
		console.log('productFilters', productFilters);
		let user = req.user;
		this.validateProductLimit(user);
		let order=productFilters.order?productFilters.order:'asc'
		let limit = ' LIMIT ' + productFilters.limit;
		let offset = ' OFFSET ' + productFilters.offset;
		//console.log('productFilters', productFilters);
		let query = 'select count(*) OVER() AS total,tp."product_rank_order",tp."isPublic",tp."productId",(select "brandName" from "tblBrand" where "id"=tp."brandId"), tp."product",tp."productSKU", tp."isactive", tp."productqualitylevel", pr."businesscurrencyid",pr."retailerprice",(select concat( \'' + process.env.CDN_URL + '\',"documentPath") as "documentUrl" from "tblDocument" where "documentId" in(select "imageid" from "tblproductimage" where "productimageid"=tp."defaultimageid"))from "tblProduct" as tp inner join "tblproductpricedetail" as pr on pr."productId"=tp."productId" where "channelId"= :channelId and tp."deletedat" is null and "isactive"=:isactive ';
		if(productFilters.search)
		query += ' and tp."productId"='+ +productFilters.search ;
		if(productFilters.filter.brand)
		query += ' and tp."brandId" in('+ productFilters.filter.brand +')';
		if(productFilters.filter.family)
		query += ' and tp."productGroupId" in('+ productFilters.filter.family +')';
		if(productFilters.filter.category)
		query += ' and tp."productCategorieId" in('+ productFilters.filter.category +')';
		if(productFilters.filter.position)
		query += ' and tp."productqualitylevel" =:quality';

		query += ' order by tp."product_rank_order" '+order +limit+offset;

		let result=await this.sequelizeInstance.query(query, {
            type: QueryTypes.SELECT,
		raw: true,
		replacements: {
			channelId:user.channelId,
			isactive:productFilters.isactive.toString(),
			quality:productFilters.filter.position
		}
		});
		let master = result.map(x => x.productSKU);
		let active=await this.sequelizeInstance.query('select count(*) from "tblProduct" where "channelId"=:channelId and "deletedat" is null and "isactive"=:isactive', {
            type: QueryTypes.SELECT,
		raw: true,
		replacements: {
			channelId:user.channelId,
			isactive:'1'
		}
		})
		let inActive=await this.sequelizeInstance.query('select count(*) from "tblProduct" where "channelId"=:channelId and "deletedat" is null and "isactive"=:isactive', {
            type: QueryTypes.SELECT,
		raw: true,
		replacements: {
			channelId:user.channelId,
			isactive:'0'
		}
		})
			let tabCount={
				active: active?active[0].count:0,
				inActive: active?inActive[0].count:0
			}
		let results;
		if(result.length!=0){
			results={
				total:result[0].total,
				result:result,
				tabCount: tabCount,
				master: master
			}
		}else{
			results={
				total:0,
				result:[],
				master: [],
				tabCount:tabCount
			}
		}
		res.status(HttpStatus.OK).send(results);
	}

	@Get('getPublicProductFlags/:productId')
	async getPublicProductFlags(@Request() req, @Res() res, @Param('productId') productId){

		let query = 'select "productId", "channelId", "isFeatured", "eco_friendly", "work_from_home", "life_style", "french_tech", "taiwan_excellence", "show_in_home_page", "isPublic" from "tblProduct" where "productId" = :productId';
		let result=await this.sequelizeInstance.query(query, {
            type: QueryTypes.SELECT,
		raw: true,
		replacements: {
			productId:productId,
			//quality:productFilters.filter.position
		}
		}).then(res => res[0]);

		res.status(HttpStatus.OK).send(result);

	}

	@Post('all-products')
	async allProduct(@Request() req, @Response() res, @Body(new ValidationPipe()) productFilters: any) {
		console.log('productFilters', productFilters);

		let order = productFilters.order ? productFilters.order : 'asc'
		let limit = ' LIMIT ' + productFilters.limit;
		let offset = ' OFFSET ' + productFilters.offset;
		console.log('productFilters', productFilters);
		let query = 'select (select array_to_json(array_agg(row_to_json(x))) from (select count(*) OVER() AS total, tp."product_rank_order",tp."productId",tp."isPublic",(select "companyName" from "tblChannel" where "channelId"=tp."channelId"),tp."channelId",(select "brandName" from "tblBrand" where "id"=tp."brandId"), tp."product",tp."productSKU", tp."isactive", tp."productqualitylevel", pr."businesscurrencyid",pr."retailerprice",(select concat( \'' + process.env.CDN_URL + '\',"documentPath") as "documentUrl" from "tblDocument" where "documentId" in(select "imageid" from "tblproductimage" where "productimageid"=tp."defaultimageid"))from "tblProduct" as tp inner join "tblproductpricedetail" as pr on pr."productId"=tp."productId" and pr."deletedat" is null where tp."deletedat" is null and "isactive"=:isactive ';
		if(productFilters.search)
		query += ' and tp."productId"='+ +productFilters.search ;
		if(productFilters.filter.brand)
		query += ' and tp."brandId" in('+ productFilters.filter.brand +')';
		if(productFilters.filter.family)
		query += ' and tp."productGroupId" in('+ productFilters.filter.family +')';
		if(productFilters.filter.category)
		query += ' and tp."productCategorieId" in('+ productFilters.filter.category +')';
		if(productFilters.filter.position)
		query += ' and tp."productqualitylevel" =:quality';

		if (productFilters.filter.tags) {
			if (productFilters.filter.tags.includes(1))
				query += ' and tp."show_in_home_page"=\'1\' ';
			if (productFilters.filter.tags.includes(2))
				query += ' and tp."isFeatured"=\'1\' ';
		}

		if (productFilters.filter.hot_topic) {
			if (productFilters.filter.hot_topic.includes(1))
				query += ' and tp."eco_friendly"=\'1\' ';
			if (productFilters.filter.hot_topic.includes(2))
				query += ' and tp."work_from_home"=\'1\' ';
			if (productFilters.filter.hot_topic.includes(3))
				query += ' and tp."life_style"=\'1\' ';
			if (productFilters.filter.hot_topic.includes(4))
				query += ' and tp."french_tech"=\'1\' ';
			if (productFilters.filter.hot_topic.includes(5))
				query += ' and tp."taiwan_excellence"=\'1\' ';
		}

		query += ' order by tp."product_rank_order" ' + order + ')x) as product';
		let result=await this.sequelizeInstance.query(query, {
            type: QueryTypes.SELECT,
		raw: true,
		replacements: {
			isactive: productFilters?.isactive ? productFilters?.isactive : '1',
			//quality:productFilters.filter.position
		}
		});
		let active=await this.sequelizeInstance.query('select count(*) from "tblProduct" where "deletedat" is null and "isactive"=:isactive', {
            type: QueryTypes.SELECT,
		raw: true,
		replacements: {
			isactive:'1'
		}
		})
		let inActive=await this.sequelizeInstance.query('select count(*) from "tblProduct" where "deletedat" is null and "isactive"=:isactive', {
            type: QueryTypes.SELECT,
		raw: true,
		replacements: {
			isactive:'0'
		}
		})
			let tabCount={
				active: active?active[0].count:0,
				inActive: active?inActive[0].count:0
			}
		let results;
		if(result.length!=0){
			results={
				total:result[0].total,
				result:result[0].product,
				tabCount:tabCount
			}
		}else{
			results={
				total:0,
				result:[],
				tabCount:tabCount
			}
		}
		res.status(HttpStatus.OK).send(results);
	}

	@Get('myProductsAgg/:isActive')
	async myProductsAgg(@Request() req, @Response() res, @Param('isActive', new ParseIntPipe()) isActive: number) {
		let user = req.user;
		let result=await this.sequelizeInstance.query('select "productId" from "tblProduct" where "channelId"=:channelId and "deletedat" is null and "isactive"=:isactive', {
            type: QueryTypes.SELECT,
		raw: true,
		replacements: {
			channelId:user.channelId,
			isactive:isActive.toString()
		}
		}).then(x=>{	
			return x.map(p => +p.productId);
			})
		console.log('result', result);
		let product = await this.productService.getProductAggr(result);
		if(product){
			res.status(HttpStatus.OK).send(product);
		}
	}

	//BO Product List Filter Service
	@Get('allProductsAgg/:isActive')
	async allProductsAgg(@Request() req, @Response() res, @Param('isActive', new ParseIntPipe()) isActive: number) {
		//let user = req.user;
		let result=await this.sequelizeInstance.query('select "productId" from "tblProduct" where  "deletedat" is null and "isactive"=:isactive', {
            type: QueryTypes.SELECT,
		raw: true,
		replacements: {
			//channelId:user.channelId,
			isactive:isActive.toString()
		}
		}).then(x=>{	
			return x.map(p => +p.productId);
			})
		//console.log('result', result);
		let product = await this.productService.getProductAggr(result);
		if(product){
			res.status(HttpStatus.OK).send(product);
		}
	}
	
	@Delete(':sku')
	public async productDelete(@Param('sku') sku, @Request() req, @Response() res) {
		let user = req.user;

		// my-product preference
		if (user.isAdmin == false)
		await this._validateProductModule(user);

		let productData = await this.productService.productDelete(sku, user);

		res.status(HttpStatus.OK).json(productData);
	}

	@Get('channel-similarproducts/:channelId')
	async channelSimilarProduct(@Request() req, @Param('channelId', new ParseIntPipe()) channelId: number, @Response() res) {
		let user = req.user;
		let type = +user.channelTypeId;
		let products=[];
		if(type===2){
			throw new AuthException('Not allowed');
		}
		let query = 'select tp."brandId" from "tblProduct" as tp where "channelId"= :channelId and tp."deletedat" is null and "isactive"=\'1\'';
		query += ' and tp."productId" not in(select "productid" as "productId" from "tblproductrejection" where channelid = ' + user.channelId+')';
		query += ' and tp."productId" in(select "productId" from "tblproductsharepreference" where sharetypeid = :sharedId and "productId" = tp."productId" and "deletedat" IS NULL)';
		let result=await this.sequelizeInstance.query(query, {
            type: QueryTypes.SELECT,
			raw: true,
		replacements: {
			channelId:channelId,
			sharedId:type==2?1:type==3?2:type==4?3:4
		}
		})
		if(result.length>0){
			let brandIds=result.map(x=>+x.brandId);
			console.log('brandIds', brandIds);
			let query = 'select tp."brandId",tp."productId",tp."product", tp."productSKU", tp."productqualitylevel", pr."businesscurrencyid",pr."retailerprice", br."brandName",(select concat( \'' + process.env.CDN_URL + '\',"documentPath") as "brandDocumentUrl" from "tblDocument" where "documentId" = br."documentId"),(select concat( \'' + process.env.CDN_URL + '\',"documentPath") as "documentUrl" from "tblDocument" where "documentId" in(select "imageid" from "tblproductimage" where "productimageid"=tp."defaultimageid"))from "tblProduct" as tp inner join "tblBrand" as br on br."id"=tp."brandId" inner join "tblproductpricedetail" as pr on pr."productId"=tp."productId" where "channelId"!= :channelId and "brandId" in(:brandIds) and tp."deletedat" is null and "isactive"=\'1\'';
			query += ' and tp."productId" not in(select "productid" as "productId" from "tblproductrejection" where channelid = ' + user.channelId+')';
			query += ' and tp."productId" in(select "productId" from "tblproductsharepreference" where sharetypeid = :sharedId and "productId" = tp."productId" and "deletedat" IS NULL)';
			products=await this.sequelizeInstance.query(query, {
				type: QueryTypes.SELECT,
				raw: true,
			replacements: {
				channelId:channelId,
				sharedId:type==2?1:type==3?2:type==4?3:4,
				brandIds:brandIds
			}
			});
		}
		res.status(HttpStatus.OK).send(products);
	}

	@Post('getProductSearchList')
    public async getProductSearchList(@Req() req, @Res() res,@Body() data: any) {		
        console.log('data', data);
        let result = await this.productService.getProductSearchList(data.search);
            res.status(HttpStatus.OK).json(result);
    }
}
