'use strict';

import { Inject, UseGuards, Controller, Post, Put, Res, Get, HttpStatus, Request, Response, Param, Body, Query, UploadedFile, UploadedFiles,UseInterceptors, InternalServerErrorException, Patch, Delete, ParseIntPipe, NotFoundException } from '@nestjs/common';
// //import { BaseController } from '../../core';
 import { ProductImportService } from '../service/productImport.service';
// import { ProductServiceOutBound } from '../transformation/productServiceOutBound';
//import { ProductFilterDto } from '../dto/productFilter.dto';
import { ValidationPipe } from '../../../middleware/pipe/validation.pipe';
import { ApiBearerAuth, ApiOperation } from '@nestjs/swagger';
import { ImportProductDto } from '../dto/importProduct.dto';
import { ImportProductImageDto } from '../dto/importProductImage.dto';
import { ContextService } from '../../../context/context.service';
import { AuthGuard } from '@nestjs/passport';
import { ProcessException } from 'src/middleware/exception/Process.exception';
import { appconstant } from 'src/config/app.constant';
import { UpgradeException } from 'src/middleware/exception/Upgrade.exception';
import { esearch } from 'src/config/esearch';
import { isEmpty } from 'lodash';
import { ProductReject } from '../models/ProductReject.entity';
import { Utility } from '../helper/utility';
import { ProductServiceOutBound } from '../transformation/productServiceOutBound';
import { Op, QueryTypes } from "sequelize";
import { UpdateProductDto } from '../dto/updateProduct.dto';
import { AuthException } from 'src/middleware/exception/Auth.exception';
import { Product } from '../models/Product.entity';
import { FileInterceptor, FilesInterceptor } from "@nestjs/platform-express";
import { S3Lib } from "src/lib/S3Lib";


var _ = require('lodash');


let path = require("path");
var http = require('http');

@UseGuards(AuthGuard('jwt'))
@Controller('productImport')
@UseInterceptors(FilesInterceptor('files'))
export class ProductImportController {
	public fs = require('fs');
	constructor(
		@Inject('SequelizeInstance') private readonly sequelizeInstance,
		private productImportService: ProductImportService
	) {
		//super();
	}


    public async _validateProductModule(req) {
		
	}

	
	
	@Post('imageUpload')
	public async productImageUpload(@Request() req, @Response() res, @Body(new ValidationPipe()) importProductImageDto: ImportProductImageDto) {
		let productImageUpload = await this.productImportService.productImageUpload(importProductImageDto);
		res.status(HttpStatus.OK).json(productImageUpload);
	}

	@Get('productImportSample')
	public async productImportSample(@Request() req, @Response() res) {
		let user = req.user;

		// ask xavier for product upload validation
		//await this._validateProductModule(user);

		let productImportSample = await this.productImportService.productImportSample(user);
		res.setHeader('sampleFileName', productImportSample.sampleFileName);
		res.status(HttpStatus.OK).json(productImportSample);
	}

	
	@Get('sampleDwn/:fileName')
	public async productSampleDownload(@Param('fileName') fileName, @Request() req, @Response() res) {
		let user = req.user;
		
		var file = path.resolve(__dirname, '..', '..', '..', '..') + '/.tmp/upload_s3/' + fileName;
		res.setHeader('fileName', fileName);
		
		res.sendFile(file);

		
	}

	@Post('productFileUpload')
	@UseInterceptors(FileInterceptor('file'))
	public async productFileUpload(@UploadedFile() file, @Res() res) {
		
		//let productImageUpload = await this.productImportService.productFileUpload();
		
		console.log('file ccc' , file);
		//var file = req.body
		if (file) {
			//var s3 = new S3Lib();
			
		// 	const sharp = require('sharp')
	        //  let newPath = 'product_import'
		 	//  let response = await s3.moveFromLocal(file, newPath, 0);
			//   console.log('response');
			//   console.log(response);
		//   // if(response){
		// 	let path = await helper.getMediaPath({
		// 	  documentPath: newPath,
		// 	  dirName: this.getDirName(dirName)
		//   });
		// 	var fus3 = new FetchUploadS3();
		// 	let url = process.env.AWS_BUCKET_KEY_PREFIX +'/' + path;
		// 	if(dirName !='introVideo' && dirName !=='broucher' && dirName!=='banner'){
		// 	const size = await sharp(file.buffer).metadata();
		// 	console.log('size', size);
		// 	if(size.width >300){
		// 	  await fus3.upload(file.buffer, url, 300, 300, process.env.TEM_AWS_BUCKET);
		// 	  }else{
		// 		await s3.moveFromLocal(file.buffer, url, 2)
		// 	  }
		// 	}else{
		// 	  await s3.(file.buffer, url, 2)
		// 	}
			 res.status(HttpStatus.OK).json({url:'url'});
		  }else{
			throw new ProcessException('Soming went wrong');
		  }

		res.status(HttpStatus.OK).json('dirName');
	}


	@Post('import')
	public async productImport(@Request() req, @Response() res, @Body(new ValidationPipe()) importProductDto: ImportProductDto) {
		let user = req.user;
		let s3 = new S3Lib();
		//console.log('req : >>> ', req.body);
		let fileName = req.body.fileName;
			let filePath = req.body.filePath;
			let imageFolder = req.body.newImageFolder;

			let fileExtenstion = path.extname(fileName);

			if (fileExtenstion != '.xlsx') {
				throw new ProcessException('product:productImport:invalidFileFormat');
			}

			if (!fileName || !filePath) {
				throw new ProcessException('product:productImport:fileName');
			}
			await s3.callforUnzip(req.body.newImageFolder)
			if (fileName) {
				
				let moveAction = await s3.downloadFromTempBucket(filePath, fileName);
				if (moveAction) {
					return req.body = new Promise(resolve => {
						var localFilePath;
						try {
							localFilePath = path.resolve(__dirname, '..', '..', '..', '..') + '/.tmp/upload_s3/' + fileName;
						} catch (e) {
							throw new ProcessException('media:not:moveable');
						}

						resolve(localFilePath);

					}).then(async (path) => {
						let result: any = [];
						let XLSX = require('xlsx');
						var wb = XLSX.readFile(path);
						// /* generate array of arrays */
						var js = XLSX.utils.sheet_to_json(wb.Sheets[wb.SheetNames[0]], { raw: true, header: 1 });
						console.log('**************************');
						let importCount = (+js.length > 0) ? +js.length - 1 : 0;
						console.log('importCount', importCount);
						if (importCount > 0) {
							var header = js[0];

							for (let i = 1; i < js.length; i++) {
								let product: any = {};
								js[i].forEach((rdata, index) => {
									product[header[index]] = '' + js[i][index];
								});

								result.push(product);
							}
						}
						
						//return { result, fileName: fileName, imageFolder: imageFolder };
						req.body = { result, fileName: fileName, imageFolder: imageFolder };
						
					//	let user = req.user;
						let productImport = await this.productImportService.productImport(req.body, user);
						if (productImport) {
							let uninsertedFileName = (productImport.uninsertedFileName) ? productImport.uninsertedFileName : '';
							res.setHeader('uninsertedFileName', uninsertedFileName);
							res.status(HttpStatus.OK).json(productImport);
						} else {
							throw new InternalServerErrorException();
						}
						//next();
					}); 
				} else {
					throw new ProcessException('media:not:moveable');
				}
			}
	}

	


}
