'use strict';

import { Controller, Post, HttpStatus, Request, Response, Body, UseGuards } from '@nestjs/common';
import { ValidationPipe } from '../../../middleware/pipe/validation.pipe';
import { RejectReasonService } from '../service/rejectReason.service';
import { ContextService } from './../../../context/context.service';
import { AuthException } from './../../../middleware/exception/Auth.exception';
import { Channel } from './../../channel/models/Channel.entity';
import { AuthGuard } from '@nestjs/passport';
import { RejectDto } from '../dto/reject.dto';

@Controller('Product')
@UseGuards(AuthGuard('jwt'))
export class RejectController {
	constructor(
		private rejectReasonService: RejectReasonService,
		private context: ContextService
	) {
		// super();
	}

	@Post('reject')
	public async create(@Request() req, @Response() res, @Body(new ValidationPipe()) dto: RejectDto) {
		// let user = this.context.get('user');
		let user = req.user;

		if (user.channelTypeId == Channel.CHANNEL_TYPE_VENDOR) {
			throw new AuthException('Not allowed');
		}

		await this.rejectReasonService.reject(dto, user);

		res.status(HttpStatus.CREATED).json({
			"status": true
		});
	}
}
