'use strict';

import { UseGuards, Controller, Post, Request, Response, Param, Body, Put, ValidationPipe } from '@nestjs/common';
import { AuthGuard } from '@nestjs/passport';
import { ApiController } from 'src/modules/api/controllers/api.controller';
import { UnitDto } from '../dto/unit.dto';
import { UnitService } from '../service/unit.services';

@UseGuards(AuthGuard('jwt'))
@Controller('unit')

export class UnitController extends ApiController {
	constructor(
		private unitService: UnitService
	) {
		super();

		//assign service
		this.assignService(unitService);
	}

	@Post('/')
	public async create(@Request() req, @Response() res, @Body(new ValidationPipe()) dto: UnitDto) {
		return super.create(req, res, dto);
	}

	@Put('/:id')
	public async update(@Param('id') id, @Request() req, @Response() res, @Body(new ValidationPipe()) dto: UnitDto) {
		return super.update(id, dto, req, res);
	}
}
