import {
	IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	Min,
	Max,
	IsNumber,
	ArrayNotEmpty,
	ValidateIf,
	ValidateNested,
	IsOptional,
	IsDate,
	IsDateString,
	ArrayMaxSize
} from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';
import { ArticleReviewDto } from './articleReview.dto';
import { ProductExistingRatingDto } from './productExistingRatings.dto';
export class AddProductArticleReviewDto {
	@IsOptional({ groups: ["import"] })
	@ApiProperty({ type: ArticleReviewDto, isArray: true })
	@ArrayNotEmpty({ message: "channel:product:reviewArrayNotEmpty" })
	@ArrayMaxSize(4, { message: "channel:product:reviewArrayMaxSize" })
	@IsNotEmpty({ message: "channel:product:reviewIsNotEmpty" })
	@ValidateNested({ groups: ["import"] })
	@Type(() => ArticleReviewDto)
	readonly review: ArticleReviewDto[];

	@IsOptional()
	@ApiProperty({ type: ProductExistingRatingDto, isArray: true })
	@ArrayNotEmpty({ message: "channel:product:productRatingsArrayNotEmpty" })
	@ArrayMaxSize(4, { message: "channel:product:productexistingratingArrayMaxSize" })
	@IsNotEmpty({ message: "channel:product:productRatingsIsNotEmpty" })
	@ValidateNested()
	@Type(() => ProductExistingRatingDto)
	readonly productexistingrating: ProductExistingRatingDto[];

}
