import {
    IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	Min,
	Max,
	IsNumber,
	ArrayNotEmpty,
	ValidateIf,
	ValidateNested,
    IsOptional,
    IsDate,
    IsDateString
} from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';
export class AddProductAvailabilityDto {

    @IsOptional()
    @ValidateIf(o => o.isavaialbleimmediate !== "")
    @IsNotEmpty({ message: "channel:product:isavaialbleimmediateIsNotEmpty" })
    @IsString({ message: "channel:product:isavaialbleimmediateIsString" })
    @ApiProperty()
    readonly isavaialbleimmediate: string;

    @IsOptional()
    @ValidateIf(o => o.avaialblefrom !== "")
    @IsNotEmpty({ message: "channel:product:avaialblefromIsNotEmpty" })
    @IsString({ message: "channel:product:avaialblefromIsString" })
    @ApiProperty()
    readonly avaialblefrom: string;
    
    @IsOptional()
    @ValidateIf(o => o.avaialbilitycomment !== "")
    @IsNotEmpty({ message: "channel:product:avaialbilitycommentIsNotEmpty" })
    // @MinLength(10, { message: "channel:product:avaialbilitycommentMinLen" })
	@MaxLength(1000, { message: "channel:product:avaialbilitycommentMaxLen" })
    @IsString({ message: "channel:product:avaialbilitycommentIsString" })
    @ApiProperty()
    readonly avaialbilitycomment: string;
    
}