import {
	IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	Min,
	Max,
	IsNumber,
	ArrayNotEmpty,
	ValidateIf,
	ValidateNested,
	IsOptional,
	IsDate,
	IsDateString,
	ArrayMaxSize
} from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';
import { ProductImageDto } from './productImage.dto';
export class AddProductBrochureDto {

	@IsOptional()
	@ApiProperty({ type: ProductImageDto, isArray: true })
	@ArrayNotEmpty({ message: "channel:product:productpdfArrayNotEmpty" })
	@IsNotEmpty({ message: "channel:product:productpdfIsNotEmpty" })
	@ArrayMaxSize(5, { message: "channel:product:productpdfArrayMaxSize" })
	@ValidateNested()
	@Type(() => ProductImageDto)
	readonly productpdf: ProductImageDto[];

}
