import {
    IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	Min,
	Max,
	IsNumber,
	ArrayNotEmpty,
	ValidateIf,
	ValidateNested,
    IsOptional,
    IsDate,
    IsDateString
} from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';
import { ProductCodeDto } from './productCode.dto';
export class AddProductCodeDto {

	@IsOptional()
    @ApiProperty({ type: ProductCodeDto, isArray: true  })
	@IsNotEmpty({ message: "channel:product:productCodeTypesIsNotEmpty" })
	@ValidateNested()
	@Type(() => ProductCodeDto)
	readonly productCodeTypes: ProductCodeDto[];

    @IsNotEmpty({ message: "channel:product:hasanyvariantIsNotEmpty" })
	@IsString({ message: "channel:product:hasanyvariantIsString" })
	@ApiProperty()
    readonly hasanyvariant: string;

	@IsOptional()
	@ValidateIf(o => o.variantdetails !== "")
    @IsNotEmpty({ message: "channel:product:variantdetailsIsNotEmpty" })
	@IsString({ message: "channel:product:variantdetailsIsString" })
	@ApiProperty()
    readonly variantdetails: string;

}