import {
    IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	Min,
	Max,
	IsNumber,
	ArrayNotEmpty,
	ValidateIf,
	ValidateNested,
    IsOptional,
    IsDate,
    IsDateString
} from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';
import { ProductCompetingDto } from './productCompeting.dto';
export class AddProductCompetingDto {

	@IsOptional()
    @ApiProperty({ type: ProductCompetingDto, isArray: true })
	@ArrayNotEmpty({ message: "channel:product:productCompetingArrayNotEmpty" })
	@IsNotEmpty({ message: "channel:product:productCompetingIsNotEmpty" })
	@ValidateNested()
	@Type(() => ProductCompetingDto)
    readonly productcompeting: ProductCompetingDto[];

}