import {
    IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	Min,
	Max,
	IsNumber,
	ArrayNotEmpty,
	ValidateIf,
	ValidateNested,
    IsOptional,
    IsDate,
    IsDateString
} from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';
import { ProductImageDto } from './productImage.dto';
export class AddProductImageDto {

    @ApiProperty({ type: ProductImageDto, isArray: true })
	@ArrayNotEmpty({ message: "channel:product:productImageArrayNotEmpty" })
	@IsNotEmpty({ message: "channel:product:productImageIsNotEmpty" })
	@ValidateNested()
	@Type(() => ProductImageDto)
    readonly productimage: ProductImageDto[];
    
    @IsOptional()
    @ApiProperty({ type: ProductImageDto, isArray: true })
	@ArrayNotEmpty({ message: "channel:product:productDisplayImageArrayNotEmpty" })
	@IsNotEmpty({ message: "channel:product:productDisplayImageIsNotEmpty" })
	@ValidateNested()
	@Type(() => ProductImageDto)
    readonly productdisplayimage: ProductImageDto[];
    
    @IsOptional()
    @ApiProperty({ type: ProductImageDto, isArray: true })
	@ArrayNotEmpty({ message: "channel:product:productPackagingImageArrayNotEmpty" })
	@IsNotEmpty({ message: "channel:product:productPackagingImageIsNotEmpty" })
	@ValidateNested()
	@Type(() => ProductImageDto)
    readonly productpackagingimage: ProductImageDto[];
    
	@IsOptional()
	@ValidateIf(o => o.videourl !== "")
	@IsNotEmpty({ message: "channel:product:videoUrlIsNotEmpty" })
	@IsString({ message: "channel:product:videoUrlIsString" })
	@ApiProperty()
	readonly videourl: string;

}