import {
    IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	Min,
	Max,
	IsNumber,
	ArrayNotEmpty,
	ValidateIf,
	ValidateNested,
    IsOptional,
    IsDate,
    IsDateString
} from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';
export class AddProductPackageInfoDto {

    @IsNotEmpty({ message: "channel:product:minorderquantityIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:minorderquantityIsNumber" })
	@ApiProperty()
    readonly minorderquantity: number;

    @IsNotEmpty({ message: "channel:product:orderunitidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:orderunitidIsNumber" })
	@ApiProperty()
    readonly orderunitid: number;

	@IsOptional()
    @IsNotEmpty({ message: "channel:product:packagesizeIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:packagesizeIsNumber" })
	@ApiProperty()
    readonly packagesize: number;

	@IsOptional()
    @IsNotEmpty({ message: "channel:product:packageunitIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:packageunitIsNumber" })
	@ApiProperty()
	readonly packageunit: number;
	
	@IsOptional()
	@IsNotEmpty({ message: "channel:product:noofpackageinboxIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:noofpackageinboxIsNumber" })
	@ApiProperty()
	readonly noofpackageinbox: number;
	
	@IsOptional()
	@IsNotEmpty({ message: "channel:product:noofpackageinboxunitidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:noofpackageinboxunitidIsNumber" })
	@ApiProperty()
    readonly noofpackageinboxunitid: number;

	@IsOptional()
    @IsNotEmpty({ message: "channel:product:noofboxinpalletIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:noofboxinpalletIsNumber" })
	@ApiProperty()
	readonly noofboxinpallet: number;
	
	@IsOptional()
	@IsNotEmpty({ message: "channel:product:noofboxinpalletunitidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:noofboxinpalletunitidIsNumber" })
	@ApiProperty()
	readonly noofboxinpalletunitid: number;
	
	@IsOptional()
	@IsNotEmpty({ message: "channel:product:approximateweightofpalletIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:approximateweightofpalletIsNumber" })
	@ApiProperty()
	readonly approximateweightofpallet: number;
	
	@IsOptional()
	@IsNotEmpty({ message: "channel:product:approximateweightofpalletunitidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:approximateweightofpalletunitidIsNumber" })
	@ApiProperty()
	readonly approximateweightofpalletunitid: number;
	
	@IsOptional()
	@IsNotEmpty({ message: "channel:product:lengthIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:lengthIsNumber" })
	@ApiProperty()
	readonly length: number;
	
	@IsOptional()
	@IsNotEmpty({ message: "channel:product:breadthIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:breadthIsNumber" })
	@ApiProperty()
	readonly breadth: number;
	
	@IsOptional()
	@IsNotEmpty({ message: "channel:product:heightIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:heightIsNumber" })
	@ApiProperty()
	readonly height: number;
	
	@IsOptional()
	@IsNotEmpty({ message: "channel:product:weightIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:weightIsNumber" })
	@ApiProperty()
    readonly weight: number;

}