import {
    IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	Min,
	Max,
	IsNumber,
	ArrayNotEmpty,
	ValidateIf,
	ValidateNested,
    IsOptional,
    IsDate,
    IsDateString
} from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';
import { ProductPreferencesDto } from './productPreferences.dto';
export class AddProductPreferencesDto {

	@IsOptional()
    @ApiProperty({ type: ProductPreferencesDto, isArray: true  })
	@IsNotEmpty({ message: "channel:product:preferencesIsNotEmpty" })
	@ValidateNested()
	@Type(() => ProductPreferencesDto)
	readonly preferences: ProductPreferencesDto[];

	@IsOptional()
	@ValidateIf(o => o.isshowtofreesub !== "")
	@IsNotEmpty({ message: "channel:product:isshowtofreesubIsNotEmpty" })
	@IsString({ message: "channel:product:isshowtofreesubIsString" })
	@ApiProperty()
	readonly isshowtofreesub: string;	

}