import {
    IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	Min,
	Max,
	IsNumber,
	ArrayNotEmpty,
	ValidateIf,
	ValidateNested,
    IsOptional,
    IsDate,
    IsDateString
} from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';
export class AddProductPriceDto {

    @IsNotEmpty({ message: "channel:product:retailerpriceIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:retailerpriceIsNumber" })
	@ApiProperty()
    readonly retailerprice: number;

	@IsOptional()
    @IsNotEmpty({ message: "channel:product:retailerpriceunitidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:retailerpriceunitidIsNumber" })
	@ApiProperty()
    readonly retailerpriceunitid: number;

	@IsOptional()
    @IsNotEmpty({ message: "channel:product:samplepriceIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:samplepriceIsNumber" })
	@ApiProperty()
    readonly sampleprice: number;

	@IsOptional()
    @IsNotEmpty({ message: "channel:product:samplepriceunitidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:samplepriceunitidIsNumber" })
	@ApiProperty()
    readonly samplepriceunitid: number;

	@IsOptional()
    @IsNotEmpty({ message: "channel:product:issamplefreeIsNotEmpty" })
	@IsString({ message: "channel:product:issamplefreeIsString" })
	@ApiProperty()
    readonly issamplefree: string;

	@IsOptional()
    @IsNotEmpty({ message: "channel:product:distributormarginpercentIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:distributormarginpercentIsNumber" })
	@ApiProperty()
    readonly distributormarginpercent: number;

	@IsOptional()
    @IsNotEmpty({ message: "channel:product:distributormarginpercentunitidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:distributormarginpercentunitidIsNumber" })
	@ApiProperty()
    readonly distributormarginpercentunitid: number;

	@IsOptional()
    @IsNotEmpty({ message: "channel:product:retailermarginpercentIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:retailermarginpercentIsNumber" })
	@ApiProperty()
    readonly retailermarginpercent: number;

	@IsOptional()
    @IsNotEmpty({ message: "channel:product:retailermarginpercentunitidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:retailermarginpercentunitidIsNumber" })
	@ApiProperty()
    readonly retailermarginpercentunitid: number;

    @IsNotEmpty({ message: "channel:product:samplethresholdIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:samplethresholdIsNumber" })
	@ApiProperty()
    readonly samplethreshold: number;

    @IsNotEmpty({ message: "channel:product:isunlimitsampleIsNotEmpty" })
	@IsString({ message: "channel:product:isunlimitsampleIsString" })
	@ApiProperty()
	readonly isunlimitsample: string;
	
	@IsOptional()
	@ValidateIf(o => o.currencyid !== undefined)
    @IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsNumber({}, { message: "This property should be an integer" })
	@ApiProperty()
    readonly currencyid: number;

}