import {
    IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	Min,
	Max,
	IsNumber,
	ArrayNotEmpty,
	ValidateIf,
	ValidateNested,
    IsOptional,
    IsDate,
    IsDateString
} from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';
import { ProductRelevantChannelDto } from './productRelevantChannel.dto';
export class AddProductRelevantChannelDto {

	@IsOptional()
    @ApiProperty({ type: ProductRelevantChannelDto, isArray: true })
	@ArrayNotEmpty({ message: "channel:product:distributionChannelArrayNotEmpty" })
	@IsNotEmpty({ message: "channel:product:distributionChannelIsNotEmpty" })
	@ValidateNested()
	@Type(() => ProductRelevantChannelDto)
    readonly distributionchannel: ProductRelevantChannelDto[];

	@IsOptional()
    @ApiProperty({ type: ProductRelevantChannelDto, isArray: true })
	@ArrayNotEmpty({ message: "channel:product:retailChannelArrayNotEmpty" })
	@IsNotEmpty({ message: "channel:product:retailChannelIsNotEmpty" })
	@ValidateNested()
	@Type(() => ProductRelevantChannelDto)
    readonly retailchannel: ProductRelevantChannelDto[];

	@IsOptional()
    @ApiProperty({ type: ProductRelevantChannelDto, isArray: true })
	@ArrayNotEmpty({ message: "channel:product:resellerChannelArrayNotEmpty" })
	@IsNotEmpty({ message: "channel:product:resellerChannelIsNotEmpty" })
	@ValidateNested()
	@Type(() => ProductRelevantChannelDto)
    readonly resellerchannel: ProductRelevantChannelDto[];

}