import {
    IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	Min,
	Max,
	IsNumber,
	ArrayNotEmpty,
	ValidateIf,
	ValidateNested,
    IsOptional,
    IsDate,
    IsDateString
} from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';
import { ProductLocationDto } from './productLocation.dto';
export class AddProductTargetLocationDto {
    
    @ApiProperty({ type: ProductLocationDto, isArray: true })
	@ArrayNotEmpty({ message: "channel:product:targetLocationArrayNotEmpty" })
	@IsNotEmpty({ message: "channel:product:targetLocationIsNotEmpty" })
	@ValidateNested()
	@Type(() => ProductLocationDto)
    readonly targetlocation: ProductLocationDto[];

}