import {
	Matches,
	IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	Min,
	Max,
	IsNumber,
	ArrayNotEmpty,
	ValidateIf,
	ValidateNested,
	IsOptional,
	IsDate,
	IsDateString
} from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';
export class ArticleReviewDto {

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productarticlereviewidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:productarticlereviewidIsNumber" })
	@ApiProperty()
	readonly productarticlereviewid: number;

	@IsNotEmpty({
		message: "channel:product:reviewerNameIsNotEmpty",
		groups: ["import"]
	})
	@MaxLength(255, {
		message: "text must be shorter than or equal to 255 characters",
		groups: ["import"]
	})
	@IsString({ message: "channel:product:reviewerNameIsString" })
	@ApiProperty()
	readonly reviewername: string;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:imageidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:imageidIsNumber" })
	@ApiProperty()
	readonly imageid: number;

	@IsOptional({ groups: ["import"] })
	@IsNotEmpty({
		message: "channel:product:logoIsNotEmpty",
		groups: ["import"]
	})
	@IsString({ message: "channel:product:logoIsString" })
	@ApiProperty()
	readonly logo: string;

	// @IsOptional({ groups: ["import"] })
	@MaxLength(255, {
		message: "text must be shorter than or equal to 255 characters",
		groups: ["import"]
	})
	@IsNotEmpty({
		message: "channel:product:articleUrlIsNotEmpty",
		groups: ["import"]
	})
	// @Matches(new RegExp('^(https?://)?(www\\.)?([-a-z0-9]{1,63}\\.)*?[a-z0-9][-a-z0-9]{0,61}[a-z0-9]\\.[a-z]{2,6}(/[-\\w@\\+\\.~#\\?&/=%]*)?$'), {
	// 	message: "validate:field:shouldBeUrl",
	// 	groups: ["import"]
	// })
	@IsString({ message: "channel:product:articleUrlIsString" })
	@ApiProperty()
	readonly articleurl: string;

}
