import {
	IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	Min,
	Max,
	IsNumber,
	ArrayNotEmpty,
	ValidateIf,
	ValidateNested,
	IsOptional,
	IsDate,
	IsDateString
} from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';
export class ProductCodeDto {

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productuniversalcodeidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:productuniversalcodeidIsNumber" })
	@ApiProperty()
	readonly productuniversalcodeid: number;

	@IsNotEmpty({ message: "channel:product:productuniversalcodetypeIsNotEmpty" })
	@IsString({ message: "channel:product:productuniversalcodetypeIsString" })
	@ApiProperty()
	readonly productuniversalcodetype: string;

	@IsNotEmpty({ message: "channel:product:codeIsNotEmpty" })
	@IsString({ message: "channel:product:codeIsString" })
	@MinLength(3, { message: "channel:product:codeMinLength" })
	@MaxLength(38, { message: "channel:product:codeMaxLength" })
	@ApiProperty()
	readonly code: string;

}
