import {
    IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	Min,
	Max,
	IsNumber,
	ArrayNotEmpty,
	ValidateIf,
	ValidateNested,
    IsOptional,
    IsDate,
    IsDateString
} from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';
export class ProductCompetingDto {

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productcompetingidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:productcompetingidIsNumber" })
	@ApiProperty()
    readonly productcompetingid: number;

	@IsNotEmpty({ message: "channel:product:competingproductIsNotEmpty" })
    @MinLength(3, { message: "channel:product:competingproductMinLen" })
	@MaxLength(256, { message: "channel:product:competingproductMaxLen" })
	@IsString({ message: "channel:product:competingproductIsString" })
	@ApiProperty()
	readonly competingproduct: string;

    @IsNotEmpty({ message: "channel:product:competitorIsNotEmpty" })
    @MinLength(3, { message: "channel:product:competitorMinLen" })
	@MaxLength(256, { message: "channel:product:competitorMaxLen" })
	@IsString({ message: "channel:product:competitorIsString" })
	@ApiProperty()
	readonly competitor: string;

    @IsNotEmpty({ message: "channel:product:competitorproducturlIsNotEmpty" })
    @MinLength(3, { message: "channel:product:competitorproducturlMinLen" })
	@MaxLength(256, { message: "channel:product:competitorproducturlMaxLen" })
	@IsString({ message: "channel:product:competitorproducturlIsString" })
	@ApiProperty()
	readonly competitorproducturl: string;

}