import {
	IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	Min,
	Max,
	IsNumber,
	ArrayNotEmpty,
	ValidateIf,
	ValidateNested,
	IsOptional,
	IsDate,
	IsDateString
} from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';
export class ProductExistingRatingDto {

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productexistratingidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:productexistratingidIsNumber" })
	@ApiProperty()
	readonly productexistratingid: number;

	@IsNotEmpty({ message: "channel:product:existproductratingIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:existproductratingIsNumber" })
	@ApiProperty()
	readonly existproductrating: number;

	@IsNotEmpty({ message: "channel:product:ratingproofvalidationurlIsNotEmpty" })
	@IsString({ message: "channel:product:ratingproofvalidationurlIsString" })
	@ApiProperty()
	readonly ratingproofvalidationurl: string;

	@IsOptional()
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsString({ message: "validate:field:shouldBeString" })
	@ApiProperty()
	readonly ratingproofvalidationlogo: string;

	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsString({ message: "validate:field:shouldBeString" })
	@ApiProperty()
	readonly ratingproofvalidationname: string;

	@IsOptional()
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsNumber({}, { message: "channel:product:existproductratingIsNumber" })
	@ApiProperty()
	readonly ratingproofvalidationlogoid: number;

}
