import {
    IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	Min,
	Max,
	IsNumber,
	ArrayNotEmpty,
	ValidateIf,
	ValidateNested,
    IsOptional,
    IsDate,
    IsDateString
} from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';
export class ProductPreferencesDto {

	@IsOptional()
	@ValidateIf(o => o.sharetypeid !== "")
    @IsNotEmpty({ message: "channel:product:sharetypeidIsNotEmpty" })
    @IsNumber({},{ message: "channel:product:sharetypeidIsNumber" })
    @ApiProperty()
	readonly sharetypeid: number;

}