import {
    IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	Min,
	Max,
	IsNumber,
	ArrayNotEmpty,
	ValidateIf,
	ValidateNested,
    IsOptional,
    IsDate,
    IsDateString
} from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';
export class ProductTagDto {

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:producttagidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:producttagidIsNumber" })
	@ApiProperty()
    readonly producttagid: number;

    @IsNotEmpty({ message: "channel:product:tagIsNotEmpty" })
	@IsString({ message: "channel:product:tagIsString" })
	@ApiProperty()
    readonly tag: string;

}