'use strict';

import { IsNotEmpty, MaxLength, IsString, IsOptional, IsInt, IsBoolean } from 'class-validator';

export class UpdateBrandDto {

	@IsOptional()
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsString({ message: "validate:field:shouldBeString" })
	@MaxLength(255, { message: "validate:field:validateMaxLength" })
	readonly brandName: string;

	@IsOptional()
	@IsString({ message: "validate:field:shouldBeString" })
	readonly isActive: string;

	@IsOptional()
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	readonly brandImage: string;

}
