import {
    IsString,
	IsEmail,
	IsNotEmpty,
	MinLength,
	MaxLength,
	Min,
	Max,
	IsNumber,
	ArrayNotEmpty,
	ValidateIf,
	ValidateNested,
    IsOptional,
    IsDate,
    IsDateString
} from 'class-validator';
import { Type } from 'class-transformer';
export class ProductImageUpdateDto {

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productimageidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:productimageidIsNumber" })
	readonly productimageid: number;
	
	@IsOptional()
	@IsNotEmpty({ message: "channel:product:imageidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:imageidIsNumber" })
    readonly imageid: number;

	@IsOptional()
	// @ValidateIf(o => o.productimageid == undefined)
	@IsNotEmpty({ message: "channel:product:imageIsNotEmpty" })
	@IsString({ message: "channel:product:imageIsString" })
	readonly image: string;
	
	@IsOptional()
	@IsNotEmpty({ message: "channel:product:isdefaultIsNotEmpty" })
	@IsString({ message: "channel:product:isdefaultIsString" })
	readonly isdefault: string;
	
	@IsOptional()
	@IsNotEmpty({ message: "channel:product:sortorderIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:sortorderIsNumber" })
	readonly sortorder: number;
	
	@IsOptional()
	@IsString({ message: "validate:field:shouldBeString" })
	@MaxLength(255, { message: "validate:field:validateMaxLength" })
	readonly documentName: string;

	@IsOptional()
	@IsString({ message: "validate:field:shouldBeString" })
	@MaxLength(255, { message: "validate:field:validateMaxLength" })
	readonly documentDescription: string;

}