import {
	IsNotEmpty,
	ArrayNotEmpty,
	ValidateNested,
    IsOptional,
	ArrayMaxSize
} from 'class-validator';
import { Type } from 'class-transformer';
import { ProductImageUpdateDto } from '../UpdateProduct/productImageUpdate.dto';
export class UpdateProductBrochureDto {

    @IsOptional()
	@ArrayNotEmpty({ message: "channel:product:productpdfArrayNotEmpty" })
	@IsNotEmpty({ message: "channel:product:productpdfIsNotEmpty" })
	@ArrayMaxSize(5, { message: "channel:product:productpdfArrayMaxSize" })
	@ValidateNested()
	@Type(() => ProductImageUpdateDto)
    readonly productpdf: ProductImageUpdateDto[];

}