import {
    IsString,
	IsNotEmpty,
	ArrayNotEmpty,
	ValidateIf,
	ValidateNested,
    IsOptional,
} from 'class-validator';
import { Type } from 'class-transformer';
import { ProductImageUpdateDto } from '../UpdateProduct/productImageUpdate.dto';

export class UpdateProductImageDto {

	@IsOptional()
	@ArrayNotEmpty({ message: "channel:product:productImageArrayNotEmpty" })
	@IsNotEmpty({ message: "channel:product:productImageIsNotEmpty" })
	@ValidateNested()
	@Type(() => ProductImageUpdateDto)
    readonly productimage: ProductImageUpdateDto[];
    
    @IsOptional()
	@ArrayNotEmpty({ message: "channel:product:productDisplayImageArrayNotEmpty" })
	@IsNotEmpty({ message: "channel:product:productDisplayImageIsNotEmpty" })
	@ValidateNested()
	@Type(() => ProductImageUpdateDto)
    readonly productdisplayimage: ProductImageUpdateDto[];
    
    @IsOptional()
	@ArrayNotEmpty({ message: "channel:product:productPackagingImageArrayNotEmpty" })
	@IsNotEmpty({ message: "channel:product:productPackagingImageIsNotEmpty" })
	@ValidateNested()
	@Type(() => ProductImageUpdateDto)
    readonly productpackagingimage: ProductImageUpdateDto[];
    
	@IsOptional()
	@ValidateIf(o => o.videourl !== "")
	@IsNotEmpty({ message: "channel:product:videoUrlIsNotEmpty" })
	@IsString({ message: "channel:product:videoUrlIsString" })
	readonly videourl: string;

}