import { IsString, IsEmail, IsNotEmpty, MinLength, MaxLength, IsNumber, Min, Max, ValidateNested, IsOptional, IsDate, ValidateIf } from 'class-validator';
import { Type } from 'class-transformer';
import { ApiProperty } from '@nestjs/swagger';

export class ProductAwardsDto {

	@IsOptional()
	@IsNumber({}, { message: "product:productAwardIdIsNumber" })
	@ApiProperty()
	readonly product_award_id: number;

	@IsOptional()
	@IsNotEmpty({ message: "product:productAwardDetailsIsNotEmpty" })
	@ApiProperty()
	readonly details: string;

	@IsOptional()
	@IsNotEmpty({ message: "product:productAwardIssuedByIsNotEmpty" })
	@ApiProperty()
	readonly issued_by: string;

	@IsOptional()
	@ValidateIf(o => o.isLifeTime == "0")
	@IsNotEmpty({ message: "product:productAwardValidUptoIsNotEmpty" })
	@ApiProperty()
	readonly valid_upto: string;

	@IsOptional()
	@IsNotEmpty({ message: "product:productAwardIsLifeTimeIsNotEmpty" })
	@ApiProperty()
	readonly isLifeTime: string;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:imageidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:imageidIsNumber" })
	@ApiProperty()
	imageId: number;

	@IsOptional()
	@IsNotEmpty({message: "channel:product:logoIsNotEmpty"})
	@IsString({ message: "channel:product:logoIsString" })
	@ApiProperty()
	readonly image: string;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:imageidIsNotEmpty" })
	@IsNumber({}, { message: "channel:product:imageidIsNumber" })
	documentId: number;

}
