'use strict';

import { IsNotEmpty, MaxLength, IsString, IsOptional, IsInt, IsBoolean } from 'class-validator';

export class RejectDto {

	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsInt({ message: "validate:field:shouldBeInt" })
	readonly rejectreasonId: number;

	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsInt({ message: "validate:field:shouldBeInt" })
	readonly productId: number;

	@IsString({ message: "validate:field:shouldBeString" })
	@MaxLength(2000, { message: "validate:field:validateMaxLength" })
	readonly comment: string;

}
