import { IsNotEmpty, ArrayNotEmpty, ValidateNested, IsOptional, IsInt } from 'class-validator';
import { Type } from 'class-transformer';
import { AddProductBasicInfoDto } from './AddProduct/addProductBasicInfo.dto';
import { AddProductArticleReviewDto } from './AddProduct/addProductArticleReview.dto';
import { UpdateProductImageDto } from './UpdateProduct/updateProductImage.dto';
import { AddProductBrochureDto } from './AddProduct/addProductBrochure.dto';
import { AddProductPreferencesDto } from './AddProduct/addProductPreferences.dto';
import { AddProductCodeDto } from './AddProduct/addProductCode.dto';
import { AddProductPriceDto } from './AddProduct/addProductPrice.dto';
import { AddProductPackageInfoDto } from './AddProduct/addProductPackageInfo.dto';
import { AddProductCompetingDto } from './AddProduct/addProductCompeting.dto';

import { AddProductPositionDto } from './AddProduct/addProductPosition.dto';
import { AddProductRelevantChannelDto } from './AddProduct/addProductRelevantChannel.dto';
import { AddProductSellingLocationDto } from './AddProduct/addProductSellingLocation.dto';
import { AddProductTargetLocationDto } from './AddProduct/addProductTargetLocation.dto';
import { AddProductAvailabilityDto } from './AddProduct/addProductAvailability.dto';
import { UpdateProductBrochureDto } from './UpdateProduct/updateProductBrochure.dto';

import { ProductAwardsDto } from './productAwards.dto';
import { ChannelKeyRetailerDto } from '../../channel/dto/channelkeyretailer.dto';

export class UpdateProductDto {

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productBasicInfoIsNotEmpty" })
	@ValidateNested()
	@Type(() => AddProductBasicInfoDto)
	readonly productBasicInfo: AddProductBasicInfoDto;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productBasicInfoIsNotEmpty" })
	@ValidateNested()
	readonly ProductInfo:any;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productArticleReviewIsNotEmpty" })
	@ValidateNested()
	@Type(() => AddProductArticleReviewDto)
	readonly productArticleReview: AddProductArticleReviewDto;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productImagesIsNotEmpty" })
	@ValidateNested()
	@Type(() => UpdateProductImageDto)
	readonly productImages: UpdateProductImageDto;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productBrochureIsNotEmpty" })
	@ValidateNested()
	@Type(() => UpdateProductBrochureDto)
	readonly productBrochure: UpdateProductBrochureDto;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productPreferencesIsNotEmpty" })
	@ValidateNested()
	@Type(() => AddProductPreferencesDto)
	readonly productPreferences: AddProductPreferencesDto;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productCodesIsNotEmpty" })
	@ValidateNested()
	@Type(() => AddProductCodeDto)
	readonly productCode: AddProductCodeDto;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productPriceIsNotEmpty" })
	@ValidateNested()
	@Type(() => AddProductPriceDto)
	readonly productPrice: AddProductPriceDto;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productPackageInfoIsNotEmpty" })
	@ValidateNested()
	@Type(() => AddProductPackageInfoDto)
	readonly productPackageInfo: AddProductPackageInfoDto;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productCompetingIsNotEmpty" })
	@ValidateNested()
	@Type(() => AddProductCompetingDto)
	readonly productCompeting: AddProductCompetingDto;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productPositionIsNotEmpty" })
	@ValidateNested()
	@Type(() => AddProductPositionDto)
	readonly productPosition: AddProductPositionDto;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productRelevantChannelIsNotEmpty" })
	@ValidateNested()
	@Type(() => AddProductRelevantChannelDto)
	readonly productRelevantChannel: AddProductRelevantChannelDto;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productSellingLocationIsNotEmpty" })
	@ValidateNested()
	@Type(() => AddProductSellingLocationDto)
	readonly productSellingLocation: AddProductSellingLocationDto;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productTargetLocationIsNotEmpty" })
	@ValidateNested()
	@Type(() => AddProductTargetLocationDto)
	readonly productTargetLocation: AddProductTargetLocationDto;

	@IsOptional()
	@IsNotEmpty({ message: "channel:product:productAvailabilityIsNotEmpty" })
	@ValidateNested()
	@Type(() => AddProductAvailabilityDto)
	readonly productAvailability: AddProductAvailabilityDto;

	@IsOptional()
	@ArrayNotEmpty({ message: "channel:product:deletedproducttagIsNotEmpty" })
	readonly deletedproducttag: number[];

	@IsOptional()
	@ArrayNotEmpty({ message: "channel:product:deletedarticlereviewIsNotEmpty" })
	readonly deletedarticlereview: number[];

	@IsOptional()
	@ArrayNotEmpty({ message: "channel:product:deletedexistingratingIsNotEmpty" })
	readonly deletedexistingrating: number[];

	@IsOptional()
	@ArrayNotEmpty({ message: "channel:product:deletedproductimageIsNotEmpty" })
	readonly deletedproductimage: number[];

	@IsOptional()
	@ArrayNotEmpty({ message: "channel:product:deletedproductdisplayimageIsNotEmpty" })
	readonly deletedproductdisplayimage: number[];

	@IsOptional()
	@ArrayNotEmpty({ message: "channel:product:deletedproductpackageimageIsNotEmpty" })
	readonly deletedproductpackageimage: number[];

	@IsOptional()
	@ArrayNotEmpty({ message: "channel:product:deletedproductbrochureIsNotEmpty" })
	readonly deletedproductbrochure: number[];

	@IsOptional()
	@ArrayNotEmpty({ message: "channel:product:deletedcompetingproductIsNotEmpty" })
	readonly deletedcompetingproduct: number[];

	@IsOptional()
	@ArrayNotEmpty({ message: "channel:product:deletedkeyretailerIsNotEmpty" })
	readonly deletedkeyretailer: number[];

	@IsOptional()
	@ArrayNotEmpty({ message: "channel:product:deletedkeyretailerIsNotEmpty" })
	readonly deletedkeydistributor: number[];

	@IsOptional()
	@ArrayNotEmpty({ message: "channel:product:deletedkeyresellerIsNotEmpty" })
	readonly deletedkeyreseller: number[];

	@IsOptional()
	@ValidateNested()
	@Type(() => ProductAwardsDto)
	readonly award_details: ProductAwardsDto[];

	@IsOptional()
	@ArrayNotEmpty({ message: "product:productDeletedAwardDetailsIsNotEmpty" })
	readonly deleted_award_details: number[];

	@IsOptional()
	@ArrayNotEmpty({ message: "channel:product:productKeyRetailerArrayNotEmpty" })
	@IsNotEmpty({ message: "channel:product:productKeyRetailerIsNotEmpty" })
	@ValidateNested()
	@Type(() => ChannelKeyRetailerDto)
	readonly keyRetailers: ChannelKeyRetailerDto[];

	@IsOptional()
	@ArrayNotEmpty({ message: "channel:product:productKeyRetailerArrayNotEmpty" })
	@IsNotEmpty({ message: "channel:product:productKeyRetailerIsNotEmpty" })
	@ValidateNested()
	@Type(() => ChannelKeyRetailerDto)
	readonly keyDistributors: ChannelKeyRetailerDto[];

	@IsOptional()
	@ArrayNotEmpty({ message: "channel:product:productKeyResellerArrayNotEmpty" })
	@IsNotEmpty({ message: "channel:product:productKeyResellerIsNotEmpty" })
	@ValidateNested()
	@Type(() => ChannelKeyRetailerDto)
	readonly keyResellers: ChannelKeyRetailerDto[];

}
