import {
    Table,
    Column,
    PrimaryKey,
    Model,
    AutoIncrement,
    DataType,
    BeforeCreate,
    AllowNull,
    BeforeUpdate,
    ForeignKey,
    HasMany,
    BelongsTo,
    Scopes,
  } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
//import { DataTypeTime } from 'sequelize';


@Table({
	tableName: "tblDiscountUnit",
	timestamps:false
})


@Scopes(() => ({
    productInfo: {
        attributes: ['discountUnitId', 'discountUnit']
    }
}))

export class DiscountUnit extends Model<DiscountUnit>{

    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    discountUnitId: number

    @Column(DataType.CHAR(255))
    discountUnit: string

}