import {
    Table,
    Column,
    PrimaryKey,
    Model,
    AutoIncrement,
    DataType,
    BeforeCreate,
    AllowNull,
    BeforeUpdate,
    ForeignKey,
    HasMany,
    BelongsTo,
    Scopes,
  } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
//import { DataTypeTime } from 'sequelize';
import { Product } from './Product.entity';
import { Media } from '../../media/models';

const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblproductarticlereview' } as IDefineOptions;

@Table(tableOptions)

@Scopes(() => ({
    productInfo: {
        attributes: ['productarticlereviewid', 'productId', 'productreviewername', 'articleurl', 'reviewmagazinelogoid', 'updatedby', 'deletedat']
    }
}))
  
export class ProductArticleReview extends Model<ProductArticleReview>{

    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    productarticlereviewid: number

    @ForeignKey(() => Product)
    @Column(DataType.BIGINT)
    productId: number

    @BelongsTo(() => Product)
    product: Product[];

    @Column(DataType.CHAR(255))
    productreviewername: string

    @Column(DataType.CHAR(255))
    articleurl: string

    @ForeignKey(() => Media)
    @Column(DataType.BIGINT)
    reviewmagazinelogoid: number

    @BelongsTo(() => Media)
    reviewmagazinelogo: Media;

    @Column(DataType.BIGINT)
    updatedby: number

    @AllowNull(false)
    @Column(DataType.DATE)
    createdat: Date

    @Column(DataType.DATE)
    updatedat: Date;

    @Column(DataType.DATE)
    deletedat: Date

}