import {
    Table,
    Column,
    PrimaryKey,
    Model,
    AutoIncrement,
    DataType,
    BeforeCreate,
    AllowNull,
    BeforeUpdate,
    ForeignKey,
    HasMany,
    BelongsTo,
    Scopes,
  } from 'sequelize-typescript';
  import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
//import { DataTypeTime } from 'sequelize';
import { Product } from './Product.entity';
import { Channel } from '../../channel/models/Channel.entity';
import { ChannelCustomerProfile } from '../../channel/models/ChannelCustomerProfile.entity';

const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblproductchannelcustomerprofile' } as IDefineOptions;

@Table(tableOptions)

@Scopes(() => ({
    productInfo: {
        attributes: ['productchannelcustomerprofileid', 'productId', 'channelId', 'customerProfileId', 'updatedby', 'deletedat']
    }
}))
  
export class ProductChannelCustomerProfile extends Model<ProductChannelCustomerProfile>{

    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    productchannelcustomerprofileid: number

    @ForeignKey(() => Product)
    @Column(DataType.BIGINT)
    productId: number

    @BelongsTo(() => Product)
    product: Product[];

    @ForeignKey(() => Channel)
    @Column(DataType.BIGINT)
    channelId: number

    @BelongsTo(() => Channel)
    channel: Channel[];

    @ForeignKey(() => ChannelCustomerProfile)
    @Column(DataType.BIGINT)
    customerProfileId: number

    @BelongsTo(() => ChannelCustomerProfile)
    profile: ChannelCustomerProfile[];

    @Column(DataType.BIGINT)
    updatedby: number

    @AllowNull(false)
    @Column(DataType.DATE)
    createdat: Date

    @Column(DataType.DATE)
    updatedat: Date;

    @Column(DataType.DATE)
    deletedat: Date

}