import {
    Table,
    Column,
    PrimaryKey,
    Model,
    AutoIncrement,
    DataType,
    BeforeCreate,
    AllowNull,
    BeforeUpdate,
    ForeignKey,
    HasMany,
    BelongsTo,
    Scopes,
  } from 'sequelize-typescript';
  import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
//import { DataTypeTime } from 'sequelize';
import { Product } from './Product.entity';

const tableOptions: IDefineOptions = { timestamp: true, tableName: 'tblproductcompeting' } as IDefineOptions;

@Table(tableOptions)

@Scopes(() => ({
    productInfo: {
        attributes: ['productcompetingid', 'productId', 'competingproduct', 'competitor', 'competitorproducturl', 'updatedby', 'deletedat']
    }
}))
  
export class ProductCompeting extends Model<ProductCompeting>{

    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    productcompetingid: number

    @ForeignKey(() => Product)
    @Column(DataType.BIGINT)
    productId: number

    @BelongsTo(() => Product)
    product: Product[];

    @Column(DataType.CHAR(255))
    competingproduct: string

    @Column(DataType.CHAR(255))
    competitor: string

    @Column(DataType.CHAR(255))
    competitorproducturl: string

    @Column(DataType.BIGINT)
    updatedby: number

    @AllowNull(false)
    @Column(DataType.DATE)
    createdat: Date

    @Column(DataType.DATE)
    updatedat: Date;

    @Column(DataType.DATE)
    deletedat: Date

}