import {
	Table,
	Column,
	PrimaryKey,
	Model,
	AutoIncrement,
	DataType,
	BeforeCreate,
	AllowNull,
	BeforeUpdate,
	ForeignKey,
	HasMany,
	BelongsTo,
	Scopes,
} from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
//import { DataTypeTime } from 'sequelize';
import { Product } from './Product.entity';

const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblproductdetail' } as IDefineOptions;

@Table(tableOptions)

@Scopes(() => ({
	productInfo: {
		attributes: ['productdetailid', 'productId', 'videourl', 'productdesc', 'keyretailers', 'keydistributors', 'usp', 'isavaialbleimmediate', 'avaialblefrom', 'avaialbilitycomment', 'updatedby', 'deletedat','productshortdec','productCertifi','productWarranty','productLocal', 'keyresellers']
	}
}))

export class ProductDetail extends Model<ProductDetail>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	productdetailid: number

	@ForeignKey(() => Product)
	@Column(DataType.BIGINT)
	productId: number

	@BelongsTo(() => Product)
	product: Product[];

	@Column(DataType.CHAR(255))
	videourl: string

	@Column(DataType.CHAR(6000))
	productdesc: string

	@Column(DataType.CHAR(2000))
	keyretailers: string

	@Column(DataType.CHAR(2000))
	keydistributors: string

	@Column(DataType.CHAR(2000))
	keyresellers: string

	@Column(DataType.CHAR(6000))
	usp: string

	@Column
	isavaialbleimmediate: string;

	@Column
	avaialblefrom: string

	@Column(DataType.CHAR(6000))
	avaialbilitycomment: string

	@Column(DataType.BIGINT)
	updatedby: number

	@AllowNull(false)
	@Column(DataType.DATE)
	createdat: Date

	@Column(DataType.DATE)
	updatedat: Date;

	@Column(DataType.DATE)
	deletedat: Date

	@Column(DataType.CHAR(255))
	productshortdec: string

	@Column(DataType.CHAR(255))
	productCertifi: string

	@Column(DataType.CHAR(255))
	productWarranty: string

	@Column(DataType.CHAR(255))
	productLocal: string

}
