import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull,BelongsTo,ForeignKey } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { ProductEvaluation } from './ProductEvaluation.entity';
import { RatingAttribute } from '../../channel/models/RatingAttribute.entity';


const tableOptions: IDefineOptions = { tableName: 'tblproductevaluationrating' } as IDefineOptions;
  
@Table(tableOptions)
  
export class ProductEvaluationRating extends Model<ProductEvaluationRating>{
  
    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    productevaluationratingid:number;
    
    @Column(DataType.BIGINT)
    @ForeignKey(() => ProductEvaluation)
    productevaluationid:number;

    @BelongsTo(() => ProductEvaluation)
    productEvaluation: ProductEvaluation;
    
    @Column(DataType.BIGINT)
    @ForeignKey(() => RatingAttribute)
    ratingattributeid: number;

    @BelongsTo(() => RatingAttribute)
    ratingAttribute: RatingAttribute;

    @Column
    rating: number;

   
}
