import {
    Table,
    Column,
    PrimaryKey,
    Model,
    AutoIncrement,
    DataType,
    BeforeCreate,
    AllowNull,
    BeforeUpdate,
    ForeignKey,
    HasMany,
    BelongsTo,
    Scopes,
  } from 'sequelize-typescript';
  import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
//import { DataTypeTime } from 'sequelize';
import { Product } from './Product.entity';
import { Media } from '../../media/models';

const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblproductexistrating' } as IDefineOptions;

@Table(tableOptions)

@Scopes(() => ({
    productInfo: {
        attributes: ['productexistratingid', 'productId', 'existproductrating', 'ratingproofvalidationurl', 'updatedby', 'deletedat', 'ratingproofvalidationlogoid', 'ratingproofvalidationname']
    }
}))

export class ProductExistRating extends Model<ProductExistRating>{

    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    productexistratingid: number

    @ForeignKey(() => Product)
    @Column(DataType.BIGINT)
    productId: number

    @BelongsTo(() => Product)
    product: Product[];

    @Column(DataType.INTEGER)
    existproductrating: number

    @Column(DataType.CHAR(255))
    ratingproofvalidationurl: string

    @Column(DataType.CHAR(255))
    ratingproofvalidationname: string

    @ForeignKey(() => Media)
    @Column(DataType.BIGINT)
    ratingproofvalidationlogoid: number

    @BelongsTo(() => Media)
    ratingproofvalidationlogo: Media;

    @Column(DataType.BIGINT)
    updatedby: number

    @AllowNull(false)
    @Column(DataType.DATE)
    createdat: Date

    @Column(DataType.DATE)
    updatedat: Date;

    @Column(DataType.DATE)
    deletedat: Date

}