import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, ForeignKey, BelongsTo } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Channel } from '../../channel/models/Channel.entity';
import { Product } from './Product.entity';

const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblProductKeyPartnerJCT' } as IDefineOptions;

@Table(tableOptions)
export class ProductKeyPartnerJCT extends Model<ProductKeyPartnerJCT>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	productkeypartnerid: number

	@ForeignKey(() => Product)
	@Column(DataType.BIGINT)
	productid: number

	@BelongsTo(() => Product)
	product: Product;

	@ForeignKey(() => Channel)
	@Column(DataType.BIGINT)
	channelid: number

	@BelongsTo(() => Channel)
	channel: Channel;

	@Column(DataType.BIGINT)
	keypartnerid: number

	@AllowNull(false)
	@Column(DataType.DATE)
	createdat: Date

	@Column(DataType.DATE)
	updatedat: Date;

	@Column(DataType.DATE)
	deletedat: Date

}
