import {
    Table,
    Column,
    PrimaryKey,
    Model,
    AutoIncrement,
    DataType,
    BeforeCreate,
    AllowNull,
    BeforeUpdate,
    ForeignKey,
    HasMany,
    BelongsTo,
    Scopes,
  } from 'sequelize-typescript';
  import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
//import { DataTypeTime } from 'sequelize';
import { Product } from './Product.entity';
import { RegionCountryJCT } from '../../common/models/RegionCountryJCT.entity';

const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblproductlocation' } as IDefineOptions;

@Table(tableOptions)

@Scopes(() => ({
    productInfo: {
        attributes: ['productlocationid', 'productId', 'locationtype', 'regionCountryJCTId', 'updatedby', 'deletedat']
    }
}))
  
export class ProductLocation extends Model<ProductLocation>{

    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    productlocationid: number

    @ForeignKey(() => Product)
    @Column(DataType.BIGINT)
    productId: number

    @BelongsTo(() => Product)
    product: Product[];

    @Column
    locationtype: string

    @ForeignKey(() => RegionCountryJCT)
    @Column(DataType.BIGINT)
    regionCountryJCTId: number

    @BelongsTo(() => RegionCountryJCT)
    regionCountryJCT: RegionCountryJCT[];
    
    @Column(DataType.BIGINT)
    updatedby: number

    @AllowNull(false)
    @Column(DataType.DATE)
    createdat: Date

    @Column(DataType.DATE)
    updatedat: Date;

    @Column(DataType.DATE)
    deletedat: Date

}