'use strict';

import { DataType, Table, Column, Model, ForeignKey, BelongsTo, BeforeCreate, BeforeUpdate, Scopes, AutoIncrement, AllowNull, PrimaryKey } from 'sequelize-typescript';
// import { ProcessException } from './../../../middleware/exception/Process.exception';
import { Media } from 'src/modules/media/models';

@Table({
	timestamps: false,
	tableName: "tblProductMediaLibrary"
})

@Scopes(() => ({
}))

export class ProductMediaLibrary extends Model<ProductMediaLibrary>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)	
	libId: number
	
	@Column(DataType.BIGINT)
	channelId: number

	@Column(DataType.BIGINT)
	productId: number

	@ForeignKey(() => Media)
	@Column(DataType.BIGINT)
	documentId: number

	@BelongsTo(() => Media)
	document: Media;

	@Column(DataType.BIGINT)
	libTypeId: number

	@Column
	name: string;

	@Column(DataType.DATE)
	deletedAt: Date;

	@Column(DataType.DATE)
	createdAt: Date;

}
