import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, Scopes } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';

const tableOptions: IDefineOptions = { tableName: 'tblproductrejection', timestamps:false } as IDefineOptions;

@Table(tableOptions)

@Scopes(() => ({
	dismissReason: {
		attributes: {
			exclude: ['createdat']
		}
	}
}))

export class ProductReject extends Model<ProductReject>
{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	productrejectionid: number

	@Column(DataType.BIGINT)
	productid: number

	@Column(DataType.BIGINT)
	userid: number

	@Column(DataType.BIGINT)
	channelid: number

	@Column(DataType.BIGINT)
	rejectreasonid: number

	@Column(DataType.STRING)
	otherreasons: string

	@Column(DataType.DATE)
	createdat: Date;
}
