import {
    Table,
    Column,
    PrimaryKey,
    Model,
    AutoIncrement,
    DataType,
    BeforeCreate,
    AllowNull,
    BeforeUpdate,
    ForeignKey,
    HasMany,
    BelongsTo,
    Scopes,
  } from 'sequelize-typescript';
  import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
//import { DataTypeTime } from 'sequelize';
import { Product } from './Product.entity';

const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblproductuniversalcode' } as IDefineOptions;

@Table(tableOptions)

@Scopes(() => ({
    productInfo: {
        attributes: ['productuniversalcodeid', 'productId', 'productuniversalcodetype', 'code', 'updatedby', 'deletedat']
    }
}))

export class ProductUniversalCode extends Model<ProductUniversalCode>{

    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    productuniversalcodeid: number

    @ForeignKey(() => Product)
    @Column(DataType.BIGINT)
    productId: number

    @BelongsTo(() => Product)
    product: Product[];

    @Column
    productuniversalcodetype: string

    @Column(DataType.CHAR(13))
    code: string

    @Column(DataType.BIGINT)
    updatedby: number

    @AllowNull(false)
    @Column(DataType.DATE)
    createdat: Date

    @Column(DataType.DATE)
    updatedat: Date;

    @Column(DataType.DATE)
    deletedat: Date

}