import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, Scopes } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';

const tableOptions: IDefineOptions = { tableName: 'tblproductrejectreasons' } as IDefineOptions;

@Table(tableOptions)

@Scopes(() => ({
	dismissReason: {
		attributes: {
			exclude: ['createdat', 'updatedat']
		}
	}
}))

export class RejectReason extends Model<RejectReason>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	rejectreasonid: number

	@Column(DataType.CHAR(500))
	rejectreason: string

	@Column(DataType.DATE)
	createdat: Date;

	@Column(DataType.DATE)
	updatedat: Date;
}
