import {
    Table,
    Column,
    PrimaryKey,
    Model,
    AutoIncrement,
    DataType,
    BeforeCreate,
    AllowNull,
    BeforeUpdate,
    ForeignKey,
    HasMany,
    BelongsTo,
    HasOne,
    Scopes
} from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
//import { DataTypeTime } from 'sequelize';
import { Channel } from './../../channel/models/Channel.entity';
import { Brand } from '../../product/models/Brand.entity';
import { SpotDeals } from './SpotDeals.entity';

var Sequelize = require('sequelize');

const tableOptions: IDefineOptions = { timestamp: true, tableName: 'tblSpotDealBrand' } as IDefineOptions;

@Table(tableOptions)

// @Scopes({
//     channelDetail: {
//         attributes: ['channelId', 'brandId', 'deletedAt']
//     },
//     tradeinfo: {
//         attributes: {
//             exclude: ['deletedAt', 'createdAt', 'updatedAt']
//         }
//     }
// })

export class SpotDealBrand extends Model<SpotDealBrand>{

    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    id: number

    @ForeignKey(() => SpotDeals)
    @Column(DataType.BIGINT)
    spotId: number

    @BelongsTo(() => SpotDeals)
    SpotDeals: SpotDeals[];

    @ForeignKey(() => Brand)
    @Column(DataType.BIGINT)
    brandId: number

    @BelongsTo(() => Brand)
    brand: Brand;

    @Column(DataType.DATE)
    deletedAt: Date

    @Column(DataType.DATE)
    createdAt: Date

    @Column(DataType.DATE)
    updatedAt: Date

    @BeforeCreate
    @BeforeUpdate
    public static async dateUpdate(SpotDealBrand: SpotDealBrand, options: any) {
        SpotDealBrand.updatedAt = Sequelize.fn('NOW');
    }

}