import {
    Table,
    Column,
    PrimaryKey,
    Model,
    AutoIncrement,
    DataType,
    BeforeCreate,
    AllowNull,
    BeforeUpdate,
    ForeignKey,
    HasMany,
    BelongsTo,
    Scopes,
  } from 'sequelize-typescript';
  import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
//import { DataTypeTime } from 'sequelize';
import { Product } from './Product.entity';
import { Media } from '../../media/models';
import { SpotDeals } from './SpotDeals.entity';

const tableOptions: IDefineOptions = { timestamp: true, tableName: 'tblSpotDealImages' } as IDefineOptions;

@Table(tableOptions)

@Scopes(() => ({
    gallery: {
        attributes: ['id', 'spotId', 'imageid']
    },
    brochure: {
        attributes: ['id', 'spotId', 'imageid']
    }
}))

export class SpotDealImages extends Model<SpotDealImages>{

    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    id: number;

    @ForeignKey(() => SpotDeals)
    @Column(DataType.BIGINT)
    spotId: number;

    @BelongsTo(() => SpotDeals)
    SpotDeals: SpotDeals[];
    

    @ForeignKey(() => Media)
    @Column(DataType.BIGINT)
    imageid: number;

    @BelongsTo(() => Media)
    image: Media;
    
    @AllowNull(false)
    @Column
    productimagetype: string;


    @AllowNull(false)
    @Column(DataType.DATE)
    createdat: Date;

    @Column(DataType.DATE)
    updatedat: Date;

    @Column(DataType.DATE)
    deletedat: Date;

}