import {
    Table,
    Column,
    PrimaryKey,
    Model,
    AutoIncrement,
    DataType,
    BeforeCreate,
    AllowNull,
    BeforeUpdate,
    ForeignKey,
    HasMany,
    BelongsTo,
    Scopes,
  } from 'sequelize-typescript';
  import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
//import { DataTypeTime } from 'sequelize';

const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblunit' } as IDefineOptions;

@Table(tableOptions)

@Scopes(() => ({
    productInfo: {
        attributes: ['unitid', 'unit']
    }
}))
  
export class Unit extends Model<Unit>{

    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    unitid: number

    @Column(DataType.CHAR(255))
    unit: string

}