'use strict';

import { Product } from '../models/Product.entity';
import { ProductDetail } from '../models/ProductDetail.entity';
import { ProductTag } from '../models/ProductTag.entity';
import { ProductArticleReview } from '../models/ProductArticleReview.entity';
import { ProductExistRating } from '../models/ProductExistRating.entity';
import { DiscountUnit } from '../models/DiscountUnit.entity';
import { ProductChannelCustomerProfile } from '../models/ProductChannelCustomerProfile.entity';
import { ProductCompeting } from '../models/ProductCompeting.entity';
import { ProductImage } from '../models/ProductImage.entity';
import { ProductKeyPartnerJCT } from '../models/ProductKeyPartnerJCT.entity';
import { ProductLocation } from '../models/ProductLocation.entity';
import { ProductPackageInfo } from '../models/ProductPackageInfo.entity';
import { ProductPriceDetail } from '../models/ProductPriceDetail.entity';
import { ProductSharePreference } from '../models/ProductSharePreference.entity';
import { ProductUniversalCode } from '../models/ProductUniversalCode.entity';
import { Unit } from '../models/Unit.entity';
import { ProfileType } from '../../channel/models/ProfileType.entity';
import { ProfileTypeClassification } from '../../channel/models/ProfileTypeClassification.entity';
import { ChannelType } from '../../channel/models/ChannelType.entity';
import { ChannelCustomerProfile } from '../../channel/models/ChannelCustomerProfile.entity';
import { ProductAward } from './../models/ProductAward.entity';
import { AwardResult } from './../models/AwardResult.entity';
import { SpotDeals } from './../models/SpotDeals.entity';
import { SpotDealBrand } from './../models/SpotDealBrand.entity';
import { SpotDealImages } from './../models/SpotDealImages.entity';
import { ProfileList } from 'src/modules/channel/models/ProfileList.entity';
import { ProductMediaLibrary } from '../models/ProductMediaLibrary.entity';
import { ProductJCT } from '../models/ProductJCT.entity';

export const productProvider = [
	{
		provide: 'ProductRepository',
		useValue: Product
	}
];

export const productJctProvider = [
    {
        provide: 'ProductJctRepository',
        useValue: ProductJCT
    }
];


export const awardResultProvider = [
	{
		provide: 'AwardRepository',
		useValue: AwardResult
	}
];

export const productDetailProvider = [
	{
		provide: 'ProductDetailRepository',
		useValue: ProductDetail
	}
];

export const productTagProvider = [
	{
		provide: 'ProductTagRepository',
		useValue: ProductTag
	}
];

export const productArticleReviewProvider = [
	{
		provide: 'ProductArticleReviewRepository',
		useValue: ProductArticleReview
	}
];

export const productExistRatingProvider = [
	{
		provide: 'ProductExistRatingRepository',
		useValue: ProductExistRating
	}
];

export const discountUnitProvider = [
	{
		provide: 'DiscountUnitRepository',
		useValue: DiscountUnit
	}
];

export const productChannelCustomerProfileProvider = [
	{
		provide: 'ProductChannelCustomerProfileRepository',
		useValue: ProductChannelCustomerProfile
	}
];

export const productCompetingProvider = [
	{
		provide: 'ProductCompetingRepository',
		useValue: ProductCompeting
	}
];

export const productImageProvider = [
	{
		provide: 'ProductImageRepository',
		useValue: ProductImage
	}
];

export const productKeyPartnerJCTProvider = [
	{
		provide: 'ProductKeyPartnerJCTRepository',
		useValue: ProductKeyPartnerJCT
	}
];

export const productLocationProvider = [
	{
		provide: 'ProductLocationRepository',
		useValue: ProductLocation
	}
];

export const productPackageInfoProvider = [
	{
		provide: 'ProductPackageInfoRepository',
		useValue: ProductPackageInfo
	}
];

export const productPriceDetailProvider = [
	{
		provide: 'ProductPriceDetailRepository',
		useValue: ProductPriceDetail
	}
];

export const productSharePreferenceProvider = [
	{
		provide: 'ProductSharePreferenceRepository',
		useValue: ProductSharePreference
	}
];

export const productUniversalCodeProvider = [
	{
		provide: 'ProductUniversalCodeRepository',
		useValue: ProductUniversalCode
	}
];

export const unitProvider = [
	{
		provide: 'UnitRepository',
		useValue: Unit
	}
];

export const profileTypeProvider = [
	{
		provide: 'ProfileTypeRepository',
		useValue: ProfileType
	}
];

export const profileTypeClassificationProvider = [
	{
		provide: 'ProfileTypeClassificationRepository',
		useValue: ProfileTypeClassification
	}
];

export const channelTypeProvider = [
	{
		provide: 'ChannelTypeRepository',
		useValue: ChannelType
	},
];

export const channelCustomerProfileProvider = [
	{
		provide: 'ChannelCustomerProfileRepository',
		useValue: ChannelCustomerProfile
	}
];

export const productAwardProvider = [
	{
		provide: 'ProductAwardRepository',
		useValue: ProductAward
	}
];

export const spotDealsProvider = [
	{
		provide: 'SpotDealsRepository',
		useValue: SpotDeals
	}
];
export const spotDealBrandProvider = [
	{
		provide: 'SpotDealBrandRepository',
		useValue: SpotDealBrand
	}
];
	
export const spotDealImageProvider = [
	{
		provide: 'SpotDealImageRepository',
		useValue: SpotDealImages
	}
];

export const ProfileProgressProvider = [
	{
		provide: 'ProfileRepository',
		useValue: ProfileList,
	}
];

export const ProductMediaLibraryProvider= [
	{
		provide: 'ProductMediaLibraryRepository',
		useValue: ProductMediaLibrary,
	}
];



