'use strict';

import {  Inject, Injectable, InternalServerErrorException, NotFoundException } from '@nestjs/common';
import { Product } from '../models/Product.entity';
import { Channel } from '../../channel/models/Channel.entity';
import { ProductPriceDetail } from '../models/ProductPriceDetail.entity';
import { ProductImage } from '../models/ProductImage.entity';
//import { Currency } from '../../channel/models/Currency.entity';
import { Media } from '../../media/models/index';
// import { User } from '../../user/models/User.entity';
// import { AwardResult } from '../models/AwardResult.entity';
import { ProcessException } from '../../../middleware/exception/Process.exception';
//import { ProductFilterDto } from '../dto/productFilter.dto';
//import { Sequelize } from 'sequelize-typescript';
import { AddProductDto } from '../dto/addProduct.dto';
import { ProductSerivceInBound } from '../transformation/productSerivceInBound';
import { ProductDetail } from '../models/ProductDetail.entity';
import { ProductTag } from '../models/ProductTag.entity';
import { ProductArticleReview } from '../models/ProductArticleReview.entity';
import { ProductExistRating } from '../models/ProductExistRating.entity';
import { ProductSharePreference } from '../models/ProductSharePreference.entity';
import { ProductUniversalCode } from '../models/ProductUniversalCode.entity';
import { ProductPackageInfo } from '../models/ProductPackageInfo.entity';
// import { ProductCompeting } from '../models/ProductCompeting.entity';
import { ProductChannelCustomerProfile } from '../models/ProductChannelCustomerProfile.entity';
import { ProductLocation } from '../models/ProductLocation.entity';
//import { UpdateProductDto } from '../dto/updateProduct.dto';
//import { UserAccessPermission } from '../../user/models/UserAccessPermission.entity';
//import { AccessPermission } from '../../user/models/AccessPermission.entity';
import { ChannelSubscription } from '../../channel/models/ChannelSubscription.entity';
import { Subscription } from '../../channel/models/Subscription.entity';
import { SubscriptionPlan } from '../../channel/models/SubscriptionPlan.entity';
import { Country } from '../../common/models/Country.entity';
import { PaymentOptionType } from '../../channel/models/PaymentOptionType.entity';
import { PaymentTerm } from '../../channel/models/PaymentTerm.entity';
import { DiscountUnit } from '../models/DiscountUnit.entity';
// import { ShareType } from '../../channel/models/ShareType.entity';
// import { ProductServiceOutBound } from '../transformation/productServiceOutBound';
// import { ChannelLocation } from '../../channel/models/ChannelLocation.entity';
import { ChannelType } from '../../channel/models/ChannelType.entity';
// import { ChannelDetail } from '../../channel/models/ChannelDetail.entity';
// import { ProductEvaluation } from '../models/ProductEvaluation.entity';
// import { ProductEvaluationRating } from '../models/ProductEvaluationRating.entity';
// import { PaginationOptions } from './../../common/decorators/pagination.model';
// import { ProductEvaluationDto } from '../dto/productEvaluation.dto';
// import { productEvaluationUpdateDto } from '../dto/productEvaluationUpdate.dto';
// import { productEvaluationUpdateFilterDto } from '../dto/productEvaluationUpdateFilter.dto';
//import { ProductIndexService } from './productIndex.service';
// import { S3Lib } from '../../../lib/S3Lib';
 import { Wishlist } from './../../wishlist/models/Wishlist.entity';
//import * as moment from 'moment';
//import { ImportProductImageDto } from '../dto/importProductImage.dto';
//import { AuthException } from './../../../middleware/exception/Auth.exception';
// import { ProductReject } from '../models/ProductReject.entity';
// import { ContextService } from '../../../context/context.service';
// import { RatingAttribute } from './../../channel/models/RatingAttribute.entity';
// import { EvaluationAttribute } from './../../channel/models/EvaluationAttribute.entity';
import { ProductAward } from './../models/ProductAward.entity';
// import { validate } from "class-validator";
// import { plainToClass } from 'class-transformer';
// import { ValidationException } from './../../../middleware/exception/Validation.exception';
//import { ChannelHubService } from './../../channel/service/channelHub.service';
//import { NotFoundException } from './../../../middleware/exception/NotFound.exception';
import { filter, includes, assign, map, isBoolean, isUndefined, isNull, defaultTo } from 'lodash';
// import { ChannelIndexService } from '../../channel/service/channelIndex.service';
//import { SpotDeals } from '../models/SpotDeals.entity';
//import { SpotDealsDto } from '../dto/spotdeals.dto';
//import { SpotDealBrand } from './../models/SpotDealBrand.entity';
//import { SpotDealImages } from './../models/SpotDealImages.entity';
//import { IMailOption } from "../../notification/transformation/Interface/INotificatonSerivceInBound";
import _ = require('lodash');
import { appconstant } from 'src/config/app.constant';
import { ProfileList } from 'src/modules/channel/models/ProfileList.entity';
import { Brand } from '../models/Brand.entity';
import { ProductMediaLibrary } from '../models/ProductMediaLibrary.entity';
import {Op, QueryTypes } from "sequelize";
import { Utility } from 'src/modules/channel/helper/utility';
import { TradeInformationInBound } from 'src/modules/channel/transformation/tradeInformationInBound';
import { ProductKeyPartnerJCT } from '../models/ProductKeyPartnerJCT.entity';
import { features } from 'src/config/features.constants';
import { BaseService } from 'src/core/service/base.service';
import { ChannelService } from 'src/modules/channel/service/channel.service';
import { Contact } from 'src/modules/user/models/Contact.entity';
import { ProductGroup } from '../models/ProductGroup.entity';
import { ProductCategory } from '../models/ProductCategory.entity';
import { ChannelCustomerProfile } from 'src/modules/channel/models/ChannelCustomerProfile.entity';
import { ProfileTypeClassification } from 'src/modules/channel/models/ProfileTypeClassification.entity';
import { ProfileType } from 'src/modules/channel/models/ProfileType.entity';
import { RegionCountryJCT } from 'src/modules/common/models/RegionCountryJCT.entity';
import { Unit } from '../models/Unit.entity';
import { UpdateProductDto } from '../dto/updateProduct.dto';
import { AuthException } from 'src/middleware/exception/Auth.exception';
import { ProductJCT } from '../models/ProductJCT.entity';
import { DashboardReport } from 'src/modules/channel/models/DashboardReport.entity';
import { Dashboard } from 'src/modules/channel/models/Dashboard.entity';
import { SubscriptionExtraFeature } from 'src/modules/channel/models/SubscriptionExtraFeature.entity';
// var inArray = require('in-array');
let fs = require('fs');
let path = require("path");

@Injectable()
export class ProductService extends BaseService  {
    private productServiceInBound = new ProductSerivceInBound();
    private tradeInformationInBound = new TradeInformationInBound();
    private utility = new Utility();
	//private productServiceOutBound = new ProductServiceOutBound();
	//private tradeInformationInBound = new TradeInformationInBound();
	//private utility = new Utility();
	constructor(
		// private productIndex: ProductIndexService,
		private channelService: ChannelService,
		// private channelIndexService: ChannelIndexService,
         //private context: ContextService,
         
		@Inject('ProductCategoryRepository') private readonly productCategoryRepository: typeof ProductCategory,
		@Inject('ProductGroupRepository') private readonly productGroupRepository: typeof ProductGroup,
        @Inject('BrandRepository') private readonly brandRepository: typeof Brand,        
		@Inject('SequelizeInstance') private readonly sequelizeInstance,
        @Inject('ProductRepository') private readonly productRepository: typeof Product,
        @Inject('ProfileRepository') private readonly profileRepository: typeof ProfileList,
		// @Inject('AwardRepository') private readonly awardRepository: typeof AwardResult,
		@Inject('ChannelRepository') private readonly channelRepository: typeof Channel,
		//@Inject('ChannelLocationRepository') private readonly channelLocationRepository: typeof ChannelLocation,
		@Inject('ProductPriceDetailRepository') private readonly productPriceDetailRepository: typeof ProductPriceDetail,
		@Inject('ProductImageRepository') private readonly productImageRepository: typeof ProductImage,
		@Inject('MediaRepository') private readonly mediaRepository: typeof Media,
		@Inject('ProductDetailRepository') private readonly productDetailRepository: typeof ProductDetail,
		@Inject('ProductTagRepository') private readonly productTagRepository: typeof ProductTag,
		@Inject('ProductArticleReviewRepository') private readonly productArticleReviewRepository: typeof ProductArticleReview,
		@Inject('ProductExistRatingRepository') private readonly productExistRatingRepository: typeof ProductExistRating,
		@Inject('ProductSharePreferenceRepository') private readonly productSharePreferenceRepository: typeof ProductSharePreference,
		@Inject('ProductUniversalCodeRepository') private readonly productUniversalCodeRepository: typeof ProductUniversalCode,
		@Inject('ProductPackageInfoRepository') private readonly productPackageInfoRepository: typeof ProductPackageInfo,
		// @Inject('ProductCompetingRepository') private readonly productCompetingRepository: typeof ProductCompeting,
		@Inject('ProductChannelCustomerProfileRepository') private readonly productChannelCustomerProfileRepository: typeof ProductChannelCustomerProfile,
        @Inject('ProductLocationRepository') private readonly productLocationRepository: typeof ProductLocation,
        @Inject('ProductMediaLibraryRepository') private readonly productMediaLibraryRepository: typeof ProductMediaLibrary,
		//@Inject('UserAccessPermissionRepository') private readonly userAccessPermissionRepository: typeof UserAccessPermission,
		// @Inject('PreferenceRepository') private readonly preferenceRepository: typeof AccessPermission,
		// @Inject('ContactRepository') private readonly contactRepository: typeof Contact,
		@Inject('ChannelSubscriptionRepository') private readonly channelSubscriptionRepository: typeof ChannelSubscription,
		@Inject('SubscriptionRepository') private readonly subscriptionRepository: typeof Subscription,
		@Inject('SubscriptionPlanRepository') private readonly subscriptionPlanRepository: typeof SubscriptionPlan,
		@Inject('CountryRepository') private readonly countryRepository: typeof Country,
		@Inject('RegionCountryJCTRepository') private readonly regionCountryJCTRepository: typeof RegionCountryJCT,
		@Inject('PaymentOptionTypeRepository') private readonly paymentOptionTypeRepository: typeof PaymentOptionType,
		@Inject('PaymentTermRepository') private readonly paymentTermRepository: typeof PaymentTerm,
		@Inject('UnitRepository') private readonly unitRepository: typeof Unit,
		@Inject('DiscountUnitRepository') private readonly discountUnitRepository: typeof DiscountUnit,
		@Inject('ProfileTypeClassificationRepository') private readonly profileTypeClassificationRepository: typeof ProfileTypeClassification,
		@Inject('ProfileTypeRepository') private readonly profileTypeRepository: typeof ProfileType,
		@Inject('ChannelTypeRepository') private readonly channelTypeRepository: typeof ChannelType,
		@Inject('ChannelCustomerProfileRepository') private readonly channelCustomerProfileRepository: typeof ChannelCustomerProfile,
		// @Inject('ChannelDetailRepository') private readonly channelDetailRepository: typeof ChannelDetail,
		//@Inject('ProductEvaluationRepository') private readonly productEvaluationRepository: typeof ProductEvaluation,
		//@Inject('ProductEvaluationRatingRepository') private readonly productEvaluationRatingRepository: typeof ProductEvaluationRating,
		//@Inject('ProductRejectRepository') private readonly rejectRepository: typeof ProductReject,
		@Inject('ProductAwardRepository') private readonly productAwardRepository: typeof ProductAward,
        @Inject('ProductJctRepository') private readonly productJctRepository: typeof ProductJCT,
		// @Inject('SpotDealsRepository') private readonly spotDealsRepository: typeof SpotDeals,
		// @Inject('SpotDealImageRepository') private readonly spotDealImageRepository: typeof SpotDealImages,
		// @Inject('SpotDealBrandRepository') private readonly spotDealBrandRepository: typeof SpotDealBrand,
        @Inject('SubscriptionExtraFeatureRepository') private readonly subscriptionExtraFeatureRepository: typeof SubscriptionExtraFeature,
	) {
		super();
	}



public async addProduct(addProductDto: AddProductDto, user: any,ratingId:any, subscriptionFeatureKeys?, importFlag?): Promise<any> {
    let product: any = "";
    let productUpdate: any = "";
    let result: object = { error: true };

    let key = +user.channel.subscriptionId + '-' + +features.PRODUCT_SHEET;
    if (subscriptionFeatureKeys && subscriptionFeatureKeys[key]) {
        let productCount = await this.productRepository.count({ where: { channelId: +user.channelId, deletedat: null } });
        if (productCount >= +subscriptionFeatureKeys[key]) {
            throw new ProcessException({ message: 'Based on your Subscription, you are eligible to add ' + +subscriptionFeatureKeys[key] + ' products. Already you have ' + productCount + ' products.', eligibleCount: subscriptionFeatureKeys[key], exitCount: productCount });
        }
    }

    key = +user.channel.subscriptionId + '-' + +features.PRODUCT_VIDEO_BY_SHEET;
    if (subscriptionFeatureKeys && subscriptionFeatureKeys[key]) {
        let videoUrl = (addProductDto.productImages && addProductDto.productImages.videourl && addProductDto.productImages.videourl.length > 0);
        if (!subscriptionFeatureKeys[key] && videoUrl) {
            throw new ProcessException({ message: 'Based on your Subscription, you are not eligible to add videos in product.' });
        }
    }

//    load channel currency
    // if (user.channel.channelDetail === undefined) {
    //     await this.utility.lazyload(user.channel, 'channelDetail');
    // }

 let productObject = await this.productServiceInBound.setProductObject(addProductDto, user);

    //productObject['slug'] = await this.setSlugName(this.productRepository, addProductDto.productBasicInfo.productname);
    //console.log("DTO:",productObject);
    productUpdate = await this.sequelizeInstance.transaction(async transaction => {
        // Add product
        product = await this.productRepository.create(productObject, {
            
            include: [
                {
                    model: this.productDetailRepository
                },
                {
                    model: this.productTagRepository
                },
                {
                    model: this.productImageRepository,
                    as: "productImage",
                    include: [
                        {
                            model: this.mediaRepository

                        }
                    ]
                },
                {
                    model: this.productSharePreferenceRepository
                },
                {
                    model: this.productUniversalCodeRepository

                },
                {
                    model: this.productArticleReviewRepository,
                    include: [
                        {
                            model: this.mediaRepository

                        }
                    ]
                },
                {
                    model: this.productExistRatingRepository,
                    include: [
                        {
                            model: this.mediaRepository

                        }
                    ]

                },
                {
                    model: this.productPriceDetailRepository

                },
                {
                    model: this.productPackageInfoRepository

                },
                // {
                // 	model: this.productCompetingRepository
                //
                // },
                {
                    model: this.productChannelCustomerProfileRepository

                }
             ],
            //returning: true,
            transaction,
        });

        // add broucher
        if (addProductDto.productBrochure && addProductDto.productBrochure.productpdf && addProductDto.productBrochure.productpdf.length > 0) {
            let broucher= [];
            addProductDto.productBrochure.productpdf.map(x=>{
                broucher.push({ imageid: x.imageid,
                    productimagetype : appconstant.PRODUCT_BROUCHER_IMAGE_TYPE,
                    name : defaultTo(x.documentName, ''),
                    description : defaultTo(x.documentDescription, ''),
                    updatedby : +user.userId,
                    createdat : new Date(),
                    productId:product.productId
                })
            });
        await this.productImageRepository.bulkCreate(broucher, { returning: true, transaction });
            }
        // add product awards
        if (addProductDto.award_details && Object.keys(addProductDto.award_details).length > 0) {
            for (let ii = 0; ii < addProductDto.award_details.length; ii++) {
                // let valid_upto = (addProductDto.award_details[ii].valid_upto) ? addProductDto.award_details[ii].valid_upto : null;

                //save awards image
                if (addProductDto.award_details[ii].image) {
                    let media = <Media>{};
                    media.documentTypeId = appconstant.DOCUMENTTYPE_IMAGE;
                    media.documentPath = (addProductDto.award_details[ii].image) ? addProductDto.award_details[ii].image : null;
                    media.dirName = appconstant.FOLDER_PATH_PRODUCT_AWARDS;

                    let logo = await this.imageCreate(media, transaction);
                    addProductDto.award_details[ii].imageId = logo.documentId;
                } else {
                    addProductDto.award_details[ii].imageId = null
                }

                await this.productAwardRepository.create({
                    productId: product.productId,
                    awardDetail: 'product',
                    issuedBy: 'ch',
                    // validUpto: valid_upto,
                    // isLifeTime: addProductDto.award_details[ii].isLifeTime,
                    documentId: (+addProductDto.award_details[ii].imageId > 0) ? +addProductDto.award_details[ii].imageId : null
                },
                    {
                        //returning: true,
                        transaction
                    });
            }
        }

        //add product Location
        await this.productLocationRepository.bulkCreate(map(productObject.productLocation, (locitem) => {
            return assign(locitem, { "productId": +product.productId })
        }), {
            transaction
        });

        // Add product SKU and slug
        let productUpdateObject = await this.productServiceInBound.setProductUpdateObject(addProductDto, product);

        // check make product only active after image upload
        if (product.isactive == '1') {
            await this.productImageRepository.count({
                where: {
                    productId: product.productId,
                    deletedat: null,
                    productimagetype: {
                        [Op.in]: [appconstant.PRODUCT_IMAGE_TYPE]
                    },
                },
                group: ['productimagetype'],
                transaction
            }).then((count: any) => {
                if (count && count.length != 1) {
                    productUpdateObject.isactive = '0';
                }
            });
        }

        productUpdate = await this.productRepository.update(productUpdateObject,
            {
                where: { productId: product.productId },
                returning: true,
                transaction
            }
        );
            if(+ratingId!=0){
        // Code fof insert completed profile to increase profileStrength
        await this.profileRepository.create({
            channelId : user.channelId,
            ratingId : ratingId,
            isCompleted : true,
            createdAt : new Date()
        }, { transaction });
        }
        return productUpdate;
    }).then(async (productUpdate) => {
        return productUpdate;
    }).catch(function (e) {
        console.log("Error+", e);
        if (importFlag) {
            return false;
        } else {
            throw new ProcessException(e.message);
        }
    });

    if (productUpdate) {
        if (productUpdate[1] && productUpdate[1][0]) {
            let productReturnData = productUpdate[1][0];
            productUpdate = await this.setProductDefaultImage(productReturnData);

            // add key retailers
            await this.updateKeyRetailers(productReturnData, addProductDto, user, appconstant.CHANNEL_TYPE_RETAILER);
            await this.updateKeyRetailers(productReturnData, addProductDto, user, appconstant.CHANNEL_TYPE_DISTRIBUTOR);

            result = { success: true, data: productReturnData };
        }
    } else {
        result = productUpdate;
    }

    return result;
}

public async setProductDefaultImage(product) {
    let productDefaultImage = <ProductImage>{};
    let productDefaultImageId: any = "";
    try {
        productDefaultImage = await this.productImageRepository.scope('productInfo').findOne<ProductImage>({
            where: { productId: parseInt(product.productId), productimagetype: appconstant.PRODUCT_IMAGE_TYPE, isdefault: '1', deletedat: null }
        });
        if (productDefaultImage) {
            if (productDefaultImage && productDefaultImage.productimageid) {
                productDefaultImageId = productDefaultImage.productimageid;

                product.defaultimageid = productDefaultImageId

                // Add product default image
                await product.save();
            }
        }
    } catch (e) {
        console.log("Error+ setProductDefaultImage", e);
        throw new ProcessException(e.message);
    }
    return product;
}

async updateKeyRetailers(product, dto, user, partner_type) {
    // get key retailer list using channelId
    let keyRetailers = await this.getKeyRetailerIds(+product.channelId, partner_type);
    let dtoKeyPartners = (+partner_type == +appconstant.CHANNEL_TYPE_RETAILER) ? dto.keyRetailers : (+partner_type == +appconstant.CHANNEL_TYPE_RESELLER) ? dto.keyResellers : dto.keyDistributors;
    let dtoDeleteKeyPartners = (+partner_type == +appconstant.CHANNEL_TYPE_RETAILER) ? dto.deletedkeyretailer : (+partner_type == +appconstant.CHANNEL_TYPE_RESELLER) ? dto.deletedkeyreseller :  dto.deletedkeydistributor;

    if (dtoKeyPartners) {
        var receivedNewKeyRetailers = await this.tradeInformationInBound.keyRetailers(partner_type, dtoKeyPartners, +product.channelId, +user.userId);

        // filter valid keyretailerid
        let validRetailers = map(filter(dtoKeyPartners, (key) => {
            return (key.keypartnerid && keyRetailers.includes('' + key.keypartnerid))
        }), 'keypartnerid');

        // delete all the keyretailerIds and update
        await ProductKeyPartnerJCT.destroy({
            where: {
                productid: product.productId,
                keypartnerid: {
                    [Op.in]: keyRetailers
                }
            }
        }).then(async () => {
            let keyretailers = [];
            validRetailers.forEach((retailer) => {
                keyretailers.push({
                    productid: +product.productId,
                    channelid: +product.channelId,
                    keypartnerid: retailer
                })
            });

            console.log(receivedNewKeyRetailers);

            if (receivedNewKeyRetailers.length > 0) {
                receivedNewKeyRetailers.forEach((retailer) => {
                    keyretailers.push({
                        productid: +product.productId,
                        channelid: +product.channelId,
                        keypartnerid: retailer
                    })
                });
            }

            if (keyretailers) {
                await ProductKeyPartnerJCT.bulkCreate(keyretailers);
                // console.log(keyretailers);					
            }
        });
    } else if (dtoDeleteKeyPartners) {
        // filter valid keyretailerid
        let validDeletedRetailers = filter(dtoDeleteKeyPartners, (key) => {
            return keyRetailers.includes('' + key)
        });

        await ProductKeyPartnerJCT.destroy({
            where: {
                productid: product.productId,
                keypartnerid: {
                    [Op.in]: validDeletedRetailers
                }
            }
        });
    }
}

public async getKeyRetailerIds(channelId, partnerType) {
    return await this.sequelizeInstance.query('select array_agg(keypartnerid) as ids from "tblKeyPartnerJCT" where channelid = :channelId and partner_type = :partnerType and deletedat is null', {
        type: QueryTypes.SELECT,
        replacements: {
            channelId: channelId,
            partnerType: partnerType
        }
    }).then((result) => {
        return (result[0].ids) ? result[0].ids : [];
    });
}


public async saveBrand(brandObject: Brand, transaction): Promise<Brand> {
    
    return await this.brandRepository.create(brandObject, {
        transaction
    }).catch((e) => {
         //console.log("brandError:",e);
        throw new ProcessException('validate:sql:internalError');
    });
}

public async saveProductMediaLib(productImage: any, channelId: number,type:number): Promise<any> {
    let document;
    try {
        
        // for (let jj = 0; jj < productImage.length; jj++) {

                // create new product image
                let libObject = <ProductMediaLibrary>{};
                //brandObject.brandName = productImage[jj].name;
                
                if (productImage.documentpath&&type==4) {
                    return this.sequelizeInstance.transaction(async transaction => {
                    // save detail to document table
                    let mediaObject: Media = await this.setDocumentObject(productImage.documentpath, appconstant.DOCUMENTTYPE_DOC, appconstant.FOLDER_PATH_PRODUCT_BROUCHER);
                    
                    document = await this.mediaRepository.create(mediaObject);

                    //set brant image id
                    libObject.documentId = document.documentId;
                    libObject.libTypeId=4;
                    libObject.createdAt = new Date();
                    libObject.channelId=channelId;
                    libObject.name=productImage.name;
                    let productMedia = await this.productMediaLibraryRepository.create(libObject);
                    let data = {
                        documentId: productMedia.documentId,
                        channelId: productMedia.channelId,
                        libTypeId:productMedia.libTypeId,
                        libId:productMedia.libId,
                        productId:productMedia.productId,
                        name:productMedia.name,
                        document:document
                    };
                        return data;
                });
                // }
                
            }
        
        return document;
    } catch (e) {
        console.log("Error+ ", e);
        throw new ProcessException("channel:");
    }
}

async deleteProductMediaLib(data){
    return await this.productMediaLibraryRepository.update({
        deletedAt: Date()
    }, { where: {
        libId: +data.libId
        }
    });
}
public async setDocumentObject(docTempPath: string, doctype: number, folderPath?: string): Promise<Media> {
    try {
        let mediaObject = <Media>{};
        mediaObject.documentPath = docTempPath;
        mediaObject.documentTypeId = doctype;
        mediaObject.dirName = folderPath?folderPath:'media';
        return mediaObject;
    } catch (e) {
        throw new ProcessException('channel:objectCreation:media');
    }
}
async getBrochurMedialib(channelId){
    return await this.productMediaLibraryRepository.findAll<ProductMediaLibrary>({
        where: {
            channelId: +channelId,
            deletedAt: null
        },
        include: [{
            model: Media,
            where: { 
                documentTypeId:2,
                deletedAt: null 
            },
            required: true
        }],
        order: [['libId', 'DESC']]
    });	
}

async imageCreate(image, transaction) {
    return await this.mediaRepository.create(
        image,
        {
            //returning: true,
             transaction,
        }
    );
}

async getSuggestedProduct(ids,data,user)
{   
    //ids=_.sortBy(ids); 
    //console.log("ids:",ids);
    let product=await this.productRepository.scope('productInfo').findAll<Product>({
        where :{            
            //isInovation: (viewId==20)?'1':{[Op.or]:['0',null]},
            deletedat: null,
            productId: {
                [Op.in]:ids
            }
        },
        include: [
            {
                model: Wishlist,      
                as:'wishList',                  
                attributes: ['productid'],
                where: { userid: user.userId},
                required: false,
            },
            {
                model: this.productJctRepository,
                as: 'productJCT',
                attributes: ['rank'],
                where: { requested_by: user.contactId },
                required: false,
            },
            {
                model: this.productImageRepository,
                as: 'defaultImage',
                attributes: ['productimageid', 'imageid', 'productimagetype', 'name', 'description'],
                where: { deletedat: null },
                required: false,
                include: [{
                    model: this.mediaRepository,
                    attributes: ['documentUrl', 'documentPath'],
                    where: { deletedAt: null },
                    required: false,
                }]
            },
            {
                model: this.productAwardRepository,                
                attributes: ['awardDetail'],
                required: false,
                where: {
                    deletedAt: null,                          
                },
                include: [
                    {
                        model: this.mediaRepository,
                        attributes: ['documentPath'],
                        required: true,
                    }
                ]
            },
            {
                model: this.brandRepository,                
                attributes: ['brandName'],
                required: false,
                where: {
                    deletedAt: null,                          
                },
                include: [
                    {
                        model: this.mediaRepository,
                        attributes: ['documentPath'],
                        required: false,
                    }
                ]
            },
        ]

    })              
  

    return product;
}

// Product Filter Services
async getProductAggr(data)
{       
    
    
    let product=await this.productRepository.findAll<Product>({
        attributes: ['product','productId'],
        where :{            
            //isInovation: (viewId==20)?'1':{[Op.or]:['0',null]},
            deletedat: null,
            productId: {
                [Op.in]:data
            }
        },
        include: [
            {
                model: this.productGroupRepository,
                as: 'productGroup',
                attributes: ['productGroupId', 'productGroup'],
                where: { deletedAt: null },
                required: false,
            },
            {
                model: this.productCategoryRepository,                
                as: 'productCategory',
                attributes: ['productCategorieId','productCategorie'],
                required: false,
                where: {
                    deletedAt: null,                          
                }            
            },
            {
                model: this.brandRepository,                
                //as: 'productBrand',
                attributes: ['brandName','id'],
                required: false,
                where: {
                    deletedAt: null,                          
                },               
            },
            // {
            //     model: this.productLocationRepository,                
            //     as: 'productLocation',
            //     attributes: ['productlocationid','locationtype'],
            //     required: false,
            //     where: {
            //         locationtype:'TARGET',
            //         deletedat: null,                          
            //     },
            //     include: [
            //         {
            //             model: this.regionCountryJCTRepository,
            //             attributes: ['regionCountryJCTId','countryId'],
            //             required: false,
            //             include: [
            //                 {
            //                     model: this.countryRepository,
            //                     attributes: [['country','name'],['countryId','id']],
            //                     required: false,
            //                 }
            //             ]
            //         }
            //     ]               
            // },
            // {
            //     model: this.productChannelCustomerProfileRepository,
            //     //as: 'customerProfile',
            //     attributes: ['productchannelcustomerprofileid'],
            //     required: false,
            //     where: {
            //         deletedat: null,                          
            //     },               
            //     include: [
            //         {
            //             model: this.channelCustomerProfileRepository,
            //             attributes: ['profileTypeId'],
            //             required: false,
            //             include: [
            //                 {
            //                     model: this.profileTypeRepository,
            //                     attributes: [['profileType','name'],['profileTypeId','id']],
            //                     required: false,
            //                 }
            //             ]
            //         }
            //     ]
            // },
        ]

    })       

    let brand=[];let category=[];let family=[];let profile=[];let location=[];let search=[];
    
    product.map(x => {        

            search.push({id:x.productId,name:x.product}),
            brand.push({name:x.brand.brandName,id:x.brand.id});
            family.push({name:x.productGroup.productGroup,id:x.productGroup.productGroupId});
            category.push({name:x.productCategory.productCategorie,id:x.productCategory.productCategorieId});
            // x.productChannelCustomerProfile.map(p => {
            //     profile.push(p.profile['profileType']);
            // });
            // x.productLocation.map(loc => {
            //     location.push(loc.regionCountryJCT['country']);
            // })
    })

    let aggregation={
        search:search,
        brand:_.uniqBy(brand,'id'),
        category:_.uniqBy(category,'id'),
        family:_.uniqBy(family,'id'),
        // location:_.uniqBy(location,'id'),
        // profile:_.uniqBy(profile,'id'),
    }
    
    return aggregation;
}

async getSearchFilter(data)
{               
    let product=await this.productRepository.findAll<Product>({
        attributes: ['product','productId'],
        where :{            
            //isInovation: (viewId==20)?'1':{[Op.or]:['0',null]},
            deletedat: null,
            productId: {
                [Op.in]:data
            }
        } 
    })       

    let search=[];
    
    product.map(x => {        
            search.push({id:x.productId,name:x.product})    
    })   
    
    return search;
}

async getBrandFilter(data)
{   
    //console.log("product:",data.data);    
    let product=await this.productRepository.findAll<Product>({
        attributes: ['product','productId'],
        where :{            
            //isInovation: (viewId==20)?'1':{[Op.or]:['0',null]},
            deletedat: null,
            productId: {
                [Op.in]:data
            }
        },
        include: [            
            {
                model: this.brandRepository,                
                //as: 'productBrand',
                attributes: ['brandName','id'],
                required: false,
                where: {
                    deletedAt: null,                          
                },               
            }         
        ]
    })       

    let brand=[];
    
    product.map(x => {                    
        brand.push({name:x.brand.brandName,id:x.brand.id});            
    })

    brand=_.uniqBy(brand,'id');
     
    
    return brand;
}

async getCategoryFilter(data)
{         
    let productIds;

    try {

        if (data.length > 0) {

            let productcatquery = 'select pg."productGroupId" as groupId,pg."productGroup" as groupname,pc."productCategorieId" as childId,pc."productCategorie" as childname,cast(false as boolean) as status from "tblProductGroup" as pg inner join'
                + ' "tblProductCategories" as pc on pg."productGroupId"=pc."productGroupId" and pc."productCategorieId" in '
                + '(select cpc."productCategorieId" from "tblProduct" as cpc where "productId" in(:productId)) '
                + 'where pg."deletedAt" is null and pg."productGroup"!=\'\' ';

            // let productcatquery='Select distinct on(pc."productCategorie")pc."productCategorie" as name,pc."productCategorieId" as id from "tblChannelProductCategorie" cpc '
            // +'inner join "tblProductCategories" pc on pc."productCategorieId" = cpc."productCategorieId" '
            // +'where cpc."channelId" in(:channelid) order by pc."productCategorie"';

            productIds = await this.sequelizeInstance.query(productcatquery, {
                type: QueryTypes.SELECT,
                raw: true,
                replacements: {
                    //channelid:chlist.data
                    productId: data
                }
                })

            }

    }
    catch (e) {
        console.log("productFilter:", e);
    }

    return productIds;

}

    async getCategoryGuestFilter(data) {
        let productIds;

        try {

            if (data.length > 0) {

                let productcatquery = 'select pc."productCategorieId" as id,pc."productCategorie" as name from'
                    + ' "tblProductCategories" as pc where pc."productCategorieId" in '
                    + '(select cpc."productCategorieId" from "tblProduct" as cpc where "productId" in(:productId)) ';


                // let productcatquery='Select distinct on(pc."productCategorie")pc."productCategorie" as name,pc."productCategorieId" as id from "tblChannelProductCategorie" cpc '
                // +'inner join "tblProductCategories" pc on pc."productCategorieId" = cpc."productCategorieId" '
                // +'where cpc."channelId" in(:channelid) order by pc."productCategorie"';

                productIds = await this.sequelizeInstance.query(productcatquery, {
                    type: QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        //channelid:chlist.data
                        productId: data
                    }
                })

            }

        }
        catch (e) {
            console.log("productFilter:", e);
        }

        return productIds;

    }

async getFamilyFilter(data)
{         
    let product=await this.productRepository.findAll<Product>({
        attributes: ['product','productId'],
        where :{            
            //isInovation: (viewId==20)?'1':{[Op.or]:['0',null]},
            deletedat: null,
            productId: {
                [Op.in]:data
            }
        },
        include: [
            {
                model: this.productGroupRepository,
                as: 'productGroup',
                attributes: ['productGroupId', 'productGroup'],
                where: { deletedAt: null },
                required: false,
            }            
        ]

    })       

    let family=[];
    
    product.map(x => {                    
            family.push({name:x.productGroup.productGroup,id:x.productGroup.productGroupId});            
    })    
        
    family=_.uniqBy(family,'id');       
    
    
    return family;
}

async getLocationFilter(data)
{          

    let location;
    try {

        if (data.length > 0) {

            let countryquery = 'select distinct on(cty."country")cty."country" as name,cty."countryId" as id from "tblproductlocation" as pl inner join "tblRegionCountryJCT" as rc on pl."regionCountryJCTId"=rc."regionCountryJCTId" '
                + 'inner join "tblCountry" as cty  on cty."countryId"=rc."countryId" where pl."locationtype"=\'TARGET\' and pl."productId" in(:productid) and pl."deletedat" is null ';


            location = await this.sequelizeInstance.query(countryquery, {
                type: QueryTypes.SELECT,
                raw: true,
                replacements: {
                    productid: data
                }
        })

        }

    }
    catch (e) {
        console.log("countryFilter:", e);
    }
    // let product=await this.productRepository.findAll<Product>({
    //     attributes: ['product','productId'],
    //     where :{            
    //         //isInovation: (viewId==20)?'1':{[Op.or]:['0',null]},
    //         deletedat: null,
    //         productId: {
    //             [Op.in]:data
    //         }
    //     },
    //     include: [            
    //         {
    //             model: this.productLocationRepository,                
    //             as: 'productLocation',
    //             attributes: ['productlocationid','locationtype'],
    //             required: false,
    //             where: {
    //                 locationtype:'TARGET',
    //                 deletedat: null,                          
    //             },
    //             include: [
    //                 {
    //                     model: this.regionCountryJCTRepository,
    //                     attributes: ['regionCountryJCTId','countryId'],
    //                     required: false,
    //                     include: [
    //                         {
    //                             model: this.countryRepository,
    //                             attributes: [['country','name'],['countryId','id']],
    //                             required: false,
    //                         }
    //                     ]
    //                 }
    //             ]               
    //         },

    //     ]

    // })       

    //let location=[];

    // product.map(x => {            
    //         x.productLocation.map(loc => {
    //             location.push(loc.regionCountryJCT['country']);
    //         })
    //})


    //location=_.uniqBy(location,'id');
    
    
    return location;
}

    async getPriceFilter(data) {
        let priceRange;
        try {

            if (data.length > 0) {

                let pricequery = 'select min("retailerprice") as "minPrice",max("retailerprice") as "maxPrice" from "tblproductpricedetail" where "productId" in(:productid)';

                priceRange = await this.sequelizeInstance.query(pricequery, {
                    type: QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        productid: data
                    }
                })

            }

        }
        catch (e) {
            console.log("countryFilter:", e);
        }

        return priceRange;

    }

async getProfileFilter(data)
{

    let product;

    try {

        if (data.length > 0) {

            let retailcustquery = 'Select distinct on(pt."profileType")pt."profileType" as name,pt."profileTypeId" as id,(select "channelTypeId" from "tblProfileTypeClassification" as pc where pc."profileTypeId"=pt."profileTypeId") from "tblProfileType" pt where "profileTypeId" not in(38,37) and "profileTypeId" in '
                + '(select "profileTypeId" from "tblChannelCustomerProfile" where "channelId" in(:channelid) and "customerProfileId" in(select "customerProfileId" from "tblproductchannelcustomerprofile" where "channelId" in(:channelid))) order by pt."profileType" ';

            product = await this.sequelizeInstance.query(retailcustquery, {
                type: QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelid: data

                }
            })

        }

    }
    catch (e) {
        console.log("retailFilter:", e);
    }

		//return retailIds;


    // let product=await this.productRepository.findAll<Product>({
    //     attributes: ['product','productId'],
    //     where :{            
    //         //isInovation: (viewId==20)?'1':{[Op.or]:['0',null]},
    //         deletedat: null,
    //         productId: {
    //             [Op.in]:data
    //         }
    //     },
    //     include: [            
    //         {
    //             model: this.productChannelCustomerProfileRepository,
    //             //as: 'customerProfile',
    //             attributes: ['productchannelcustomerprofileid'],
    //             required: false,
    //             where: {
    //                 deletedat: null,                          
    //             },               
    //             include: [
    //                 {
    //                     model: this.channelCustomerProfileRepository,
    //                     attributes: ['profileTypeId'],
    //                     required: false,
    //                     include: [
    //                         {
    //                             model: this.profileTypeRepository,
    //                             attributes: [['profileType','name'],['profileTypeId','id']],
    //                             required: false,
    //                         }
    //                     ]
    //                 }
    //             ]
    //         },
    //     ]

    // })       

    //let profile = [];
    
    // product.map(x => {                    
    //         x.productChannelCustomerProfile.map(p => {
    //             profile.push(p.profile['profileType']);
    //         });            
    // })

    
    //let profile = _.uniqBy(product, 'id');
    
    
    return product;
}

// End of Product Filter Services

async getProductSearch(data){
    let product=await this.productRepository.findAll<Product>({
        attributes: ['product','productId'],
        where :{            
            //isInovation: (viewId==20)?'1':{[Op.or]:['0',null]},
            deletedat: null,
            productId: {
                [Op.in]:data
            }
        }
    })
    let search=[];
        product.map(x => {        
            search.push({id:x.productId,name:x.product})
        })
    return search;
}
public async channelRejectedCheck(product, user) {
    return await this.validateRejectedChannels(+user.channelId, +product.channelId);
}
public async getProduct(sku, user?) {
    let product: any;

    try {
        product = await this.productRepository.scope('productInfo').findOne<Product>({
            include: [
                {
                    model: this.productGroupRepository,
                    as: 'productGroup',
                    where: { deletedAt: null },
                    required: true
                },
                {
                    model: this.productCategoryRepository,
                    as: 'productCategory',
                    where: { deletedAt: null },
                    required: true
                },
                {
                    model: this.brandRepository,
                    where: { deletedAt: null },
                    include: [
                        {
                            model: this.mediaRepository,
                            where: { deletedAt: null },
                            required: false
                        }
                    ],
                    required: true
                },
                {
                    model: this.productDetailRepository.scope('productInfo'),
                    where: { deletedat: null },
                    required: true
                },
                {
                    model: this.productTagRepository.scope('productInfo'),
                    where: { deletedat: null },
                    required: false
                },
                {
                    model: this.productArticleReviewRepository.scope('productInfo'),
                    where: { deletedat: null },
                    include: [
                        {
                            model: this.mediaRepository,
                            where: { deletedAt: null },
                            required: false
                        }
                    ],
                    required: false,
                },
                {
                    model: this.productExistRatingRepository.scope('productInfo'),
                    where: { deletedat: null },
                    include: [
                        {
                            model: this.mediaRepository,
                            where: { deletedAt: null },
                            required: false
                        }
                    ],
                    required: false
                },
                {
                    model: this.productImageRepository.scope('productInfo'),
                    as: "productImage",
                    where: { deletedat: null },
                    include: [
                        {
                            model: this.mediaRepository,
                            where: { deletedAt: null },
                            required: false
                        }
                    ],
                    required: false
                },
                {
                    model: this.productImageRepository.scope('productInfo'),
                    as: "defaultImage",
                    where: { deletedat: null },
                    include: [
                        {
                            model: this.mediaRepository,
                            where: { deletedAt: null },
                            required: false
                        }
                    ],
                    required: false
                },
                {
                    model: this.productSharePreferenceRepository.scope('productInfo'),
                    where: { deletedat: null },
                    required: false
                },
                {
                    model: this.productUniversalCodeRepository.scope('productInfo'),
                    where: { deletedat: null },
                    required: false
                },
                {
                    model: this.productPriceDetailRepository.scope('productInfo'),
                    where: { deletedat: null },
                    required: true
                },
                {
                    model: this.productPackageInfoRepository.scope('productInfo'),
                    where: { deletedat: null },
                    required: false
                },
                {
                    model: this.productChannelCustomerProfileRepository.scope('productInfo'),
                    where: { deletedat: null },
                    required: false,
                    include: [
                        {
                            model: this.channelCustomerProfileRepository.scope('channelDetail'),
                            where: { deletedAt: null, profileTypeClassificationId: { [Op.ne]: null } },
                            required: false,
                            include: [
                                {
                                    model: this.profileTypeClassificationRepository.scope('profileTypeClassificationInfom'),
                                    where: { deletedAt: null },
                                    required: false,
                                    include: [
                                        {
                                            model: this.profileTypeRepository.scope('profileTypeInfom'),
                                            where: { deletedAt: null },
                                            required: false,
                                        },
                                        {
                                            model: this.channelTypeRepository.scope('channelTypeInfom')
                                        }
                                    ]
                                }
                            ]
                        },
                    ]
                }
            ],
            where: { productSKU: sku, deletedat: null }
        });
        console.log('product', product);
        if (!product) {
            throw new ProcessException('channel:product:notFound');
        }

        if (!product.productAwards) {
            await new Utility().lazyload(product, 'productAwards', {
                where: { deletedAt: null },
                attributes: ['productAwardId', 'documentId', 'awardDetail', 'issuedBy', 'validUpto', 'isLifeTime'],
                required: false,
                include: [
                    {
                        model: Media,
                        attributes: ['documentId', 'documentPath', 'documentUrl'],
                        required: false
                    }
                ]
            });
        }

        if (!product.productLocation) {
            await new Utility().lazyload(product, 'productLocation', {
                where: { deletedat: null },
                include: [
                    {
                        model: this.regionCountryJCTRepository,
                        where: { deletedAt: null },
                        include: [
                            {
                                model: this.countryRepository.scope('country'),
                                where: { deletedAt: null },
                                required: false
                            }
                        ],
                        required: false
                    }
                ],
                required: true
            });
        }

        if (!product.channel) {
            await new Utility().lazyload(product, 'channel', {
                attributes: ['channelId', 'companyName', 'channelTypeId', 'isOEM']
            });
        }

    } catch (e) {
        console.log("Error+ getProduct", e);
        throw new ProcessException(e.message);
    }

    if (!product) {
        throw new ProcessException('channel:product:notFound');
    }

    product.toJSON();

    product['other_info'] = {
        rating: 0,
        no_of_evaluations: 0,
        no_of_orders: 0
    };

    // add rating and no_of_evaluations
    await Product.sequelize.query('select count(DISTINCT PE.sampleorderdetailid) as no_of_evaluations , avg(PER.rating) rating from tblproductevaluation PE inner join tblproductevaluationrating PER on PE.productevaluationid = PER.productevaluationid where PE.productid= :productId GROUP BY PE.productid', {
        type: QueryTypes.SELECT,
        raw: true,
        replacements: {
            productId: +product.productId
        }
    }).then((result:any) => {
        if (result[0]) {
            product['other_info']['rating'] = +Number.parseFloat(result[0].rating).toFixed(2);
            product['other_info']['no_of_evaluations'] = result[0].no_of_evaluations;
        }
    });

    // add no_of_orders
    await Product.sequelize.query('select count(DISTINCT SOD.sampleorderdetailid) as no_of_orders  from tblsampleorderdetail SOD where SOD.productid= :productId GROUP BY SOD.productid', {
        type: QueryTypes.SELECT,
        raw: true,
        replacements: {
            productId: +product.productId
        }
    }).then((result:any) => {
        if (result[0]) {
            product['other_info']['no_of_orders'] = result[0].no_of_orders;
        }
    });

    product['productKeyRetailer'] = await this.getProductKeyRetailers(product.channelId, product.productId, appconstant.CHANNEL_TYPE_RETAILER);

    product['productKeyDistributor'] = await this.getProductKeyRetailers(product.channelId, product.productId, appconstant.CHANNEL_TYPE_DISTRIBUTOR);

    product['productKeyReseller'] = await this.getProductKeyRetailers(product.channelId, product.productId, appconstant.CHANNEL_TYPE_RESELLER);

    product['unit'] = await this.unitRepository.findAll();

    console.log('productkeyret', product['productKeyRetailer'], product['productKeyDistributor'])

    // product['discountUnit'] = await this.discountUnitRepository.findAll();

    //set profile viewer counts
    if(user.userId!=5 && user.userId!=1)
    {
        // this.sequelizeInstance.query('select * from "dashboard"(' + user.userId + ',' + product.channelId + ',' + product.productId +',2)', {
        //     type: QueryTypes.SELECT,
        //     raw: true
        // });

        let viewcount = await Dashboard.count({
            where: {
                user_id: user.userId,
                channelid: product.channelId,
                visitid: product.productId,
                visittype: 2
            }
        })

        if (viewcount > 0) {
            await Dashboard.update({ count: viewcount + 1 }, {
                where: {
                    user_id: user.userId,
                    channelid: product.channelId,
                    visitid: product.productId,
                    visittype: 2
                }
            })
        }
        else {
            let defaultData = {
                user_id: user.userId,
                channelid: product.channelId,
                visitid: product.productId,
                visittype: '2',
                count: 1,
                day: new Date().getDay(),
                month: new Date().getMonth(),
                year: new Date().getFullYear(),
            };
            await Dashboard.create(defaultData);
        }


        // let defaultData = {
        //     user_id: user.userId,
        //     channelid: product.channelId,
        //     visitid: product.productId,
        //     visittype: '1',
        //     count: 1
        // };

        // await Dashboard.findOrCreate({where: {
        //     user_id: user.userId,
        //     channelid: product.channelId,
        //     visitid: product.productId,
        // }, defaults: defaultData}).then(result => {
        //     if(!result[1]){
        //         console.log('result1', result);
        //         let month = new Date().getMonth()+1;
        //         let dashr = {
        //             userId: user.userId,
        //             dashboardId: result[0].id,
        //             ['month'+month] : '1',
        //             yearId: new Date().getFullYear()		
        //         }

        //         result[0].update({count: result[0].count+1}).then(dres => {
        //             if(dres.dashboardReport)
        //                 DashboardReport.update({['month'+month]:'1'}, {where: {
        //                     reportId: dres.dashboardReport,
        //                     dashboardId: dres.id,
        //                     yearId: new Date().getFullYear()
        //                 }}).then(res => 'updated Dashboard Report')
        //             else{
        //                 DashboardReport.create(dashr).then(res => dres.update({dashboardReport : res.reportId}));
        //                 console.log('dashboard report created');
        //             }

        //             // DashboardReport.findOrCreate({
        //             // 	where:{
        //             // 		reportId: result[0].dashboardReport
        //             // 	}, defaults: dashr
        //             // }).then(dres => {
        //             // 	if(!dres[1]){
        //             // 		dres[0].update({['month'+month] : '1'}).then(res => console.log('updated Dashboard Report'));
        //             // 	}else{
        //             // 		console.log('created');
        //             // 	}
        //             // })
        //         })
        //     }
        //     else{
        //         console.log('result2', result);

        //         let month = new Date().getMonth()+1;
        //         let year = new Date().getFullYear();

        //         DashboardReport.create({
        //             userId: user.userId,
        //             dashboardId: result[0].id,
        //             ['month'+month] : '1',
        //             yearId: year
        //         }).then(res => {
        //             console.log('created Dashbooard Report', res, result[0].id);
        //             result[0].update({dashboardReport: res.reportId})
        //         });
        //     }
        // })

    }
    return product;
}
public async getProductInfo(sku, user) {
    let product = await this.productRepository.scope('productInfo').findOne<Product>({
        include: [
            {
                model: this.channelRepository.scope('channelDetail'),
                where: { deletedAt: null },
                include: [
                    { model: this.channelTypeRepository },
                    {
                        model: this.countryRepository.scope('regionCountryJCT'),
                        where: { deletedAt: null }
                    },
                    {
                        model: this.brandRepository,
                        where: { deletedAt: null },
                        include: [
                            {
                                model: this.mediaRepository,
                                where: { deletedAt: null },
                                required: false
                            }
                        ],
                        required: false
                    },
                    {
                        model: this.channelSubscriptionRepository.scope('channelDetail'),
                        where: { isActive: '1' },
                        include: [
                            {
                                model: this.subscriptionRepository.scope('channelDetail'),
                                where: { deletedAt: null },
                                include: [
                                    {
                                        model: this.subscriptionPlanRepository.scope('channelDetail'),
                                        where: { deletedAt: null }
                                    }
                                ]
                            }
                        ],
                    },
                    {
                        model: this.paymentOptionTypeRepository,
                        as: "channelPaymentOptionType",
                        required: false,
                        through: {
                            attributes: []
                        }
                    },
                    {
                        model: this.paymentTermRepository,
                        as: "channelPaymentTerm",
                        required: false,
                        through: {
                            attributes: []
                        }
                    }
                ]
            }
        ],
        where: { productSKU: sku, deletedat: null }
    });

    if (!product || (product && product.channelId != +user.channelId && product.isactive == '0' && user.channelTypeId != appconstant.CHANNEL_TYPE_HUB)) {
        throw new ProcessException('channel:product:notFound');
    }

    let productJsonObject = product;

    // add my default contact
    let skip = true;
    let channelContactFilter: any = {};

    if (user.channelTypeId == Channel.CHANNEL_TYPE_HUB || +user.channelId == +product.channelId) {
        skip = false;
    }

    if (skip) {
        let ChannelTypeId = product.channel.channelTypeId;
        if (ChannelTypeId == Channel.CHANNEL_TYPE_VENDOR || (
            ChannelTypeId == Channel.CHANNEL_TYPE_DISTRIBUTOR && user.channelTypeId == +Channel.CHANNEL_TYPE_RETAILER
        )) {
            channelContactFilter.contactType = 'SELLING';
        } else if (ChannelTypeId == Channel.CHANNEL_TYPE_RETAILER || (
            ChannelTypeId == Channel.CHANNEL_TYPE_DISTRIBUTOR && user.channelTypeId == +Channel.CHANNEL_TYPE_VENDOR
        )) {
            channelContactFilter.contactType = 'SOURCING';
        }
    }

    let contactId = await this.channelService.getDefaultContact(product.channelId, user, channelContactFilter);
    productJsonObject.channel.contact = await Contact.scope('productInfo').findByPk(contactId, {
        include: [
            {
                model: this.mediaRepository,
                required: false,
                attributes: ['documentPath']
            }
        ]
    });

    return productJsonObject;
}
async getProductBySKU(sku): Promise<any> {
    return await this.getProductByInfo({
        productSKU: sku,
    });
}

async getProductByInfo(where) {
    let product = await this.productRepository.findOne({
        where: Object.assign(where, {
            deletedat: null
        })
    });
    
    if (!product) {
        throw new NotFoundException('NotFound');
    }

    return product;
}
public async getProductKeyRetailers(channelId, productId, partnerType) {
    return await this.sequelizeInstance.query('select * from "fnGetKeyPartnersbyChannelId"(:channelId, :partnerType, :productId, :cdnUrl)', {
        type: QueryTypes.SELECT,
        replacements: {
            channelId: channelId,
            productId: productId,
            cdnUrl: process.env.CDN_URL,
            partnerType: partnerType
        }
    }).then((results) => {
        return results[0].fnGetKeyPartnersbyChannelId;
    });
}
public async productActions(user, sku) {
    // let wishlist = false;

    let wishlistQuery = 'select count(pw.productid) from "tblproductwishlist" pw inner join "tblProduct" p on p."productId" = pw.productid where channelgroupid is null and pw.type = \'WISHLIST\' and pw.userid = :userId and p."productSKU"= :productSKU';
    let wishlist = await this.sequelizeInstance.query(wishlistQuery, {
        type: QueryTypes.SELECT,
        raw: true,
        replacements: {
            productSKU: sku,
            userId: user.userId
        }
    }).then(result => {
        return !!(+result[0].count);
    });

    let cartQuery = 'select pq.quantity from "tblproductquote" pq inner join "tblProduct" p on p."productId" = pq.productid inner join "tblcart" c on c."cartid" = pq.cartid where pq.deletedAt is null and c.deletedAt is null and c.userid = :userId and p."productSKU"= :productSKU';
    let cart = await this.sequelizeInstance.query(cartQuery, {
        type: QueryTypes.SELECT,
        raw: true,
        replacements: {
            productSKU: sku,
            userId: user.userId
        }
    }).then(result => {
        return (result[0]) ? result[0].quantity : 0;
    });

    let evaluateQuery = 'select count(pe.productid) from "tblproductevaluation" pe inner join "tblProduct" p on p."productId" = pe.productid where pe.channelid = :cahnnelId and p."productSKU"= :productSKU';
    let evaluate = await this.sequelizeInstance.query(evaluateQuery, {
        type: QueryTypes.SELECT,
        raw: true,
        replacements: {
            productSKU: sku,
            cahnnelId: user.channelId
        }
    }).then(result => {
        return !!(+result[0].count);
    });

    let businessQuery = 'select count(pw.productid) from "tblproductwishlist" pw inner join "tblProduct" p on p."productId" = pw.productid where channelgroupid is null and pw.type = \'BUSINESS\' and pw.channelid = :cahnnelId and p."productSKU"= :productSKU';
    let business = await this.sequelizeInstance.query(businessQuery, {
        type: QueryTypes.SELECT,
        raw: true,
        replacements: {
            productSKU: sku,
            cahnnelId: user.channelId
        }
    }).then(result => {
        return !!(+result[0].count);
    });

    return {
        wishlist: wishlist,
        cart: +cart,
        evaluated: evaluate,
        business: business
    };
}

async setProductPublicView(data:any): Promise<any> {
    return await this.productRepository.update({ isPublic: data.isPublic }, {
        where: {							
            productId: data.productId,            
        }
    });
}

async setProductPublicFlags(data:any): Promise<any> {

    let save = {
        eco_friendly: data.eco_friendly,
    work_from_home: data.work_from_home,
    life_style: data.life_style,
    french_tech: data.french_tech,
    taiwan_excellence: data.taiwan_excellence,
    isFeatured: data.isFeatured,
    show_in_home_page: data.show_in_home_page,
    isPublic: data.isPublic
    }

    return await this.productRepository.update(save, {
        where: {							
            productId: data.productId,            
        }
    });
}

async setProductOrder(data:any): Promise<any> {

    data.map(async(x) => {                
        await this.productRepository.update({ product_rank_order: x.order ? x.order : x.product_rank_order, updatedat: Date() }, {
            where: {							
                productId: x.productId,            
            }
        });
        
    })    

    return true;
}

public async updateProduct(addProductDto: UpdateProductDto, user: any, sku: string): Promise<any> {
    let productUpdate: any = "";
    let result: object = { error: true };
    let product = await this.getProduct(sku, user);

    if (+ product.channelId != +user.channelId && user.userId!='1') {
        throw new AuthException('Not allowed');
    }

    // let subscriptionFeatureKeys = this.context.get('subscriptionFeatures');
    // let key = +user.channel.subscriptionId + '-' + +features.PRODUCT_VIDEO_BY_SHEET;
    // if (subscriptionFeatureKeys && subscriptionFeatureKeys[key]) {
    //     let videoUrl = (addProductDto.productImages && addProductDto.productImages.videourl && addProductDto.productImages.videourl.length > 0);
    //     if (!subscriptionFeatureKeys[key] && videoUrl) {
    //         throw new ProcessException({ message: 'Based on your Subscription, you are not eligible to add videos in product.' });
    //     }
    // }

    //load channel currency
    /*if (user.channel.channelDetail === undefined) {
        await this.utility.lazyload(user.channel, 'channelDetail');
    }*/

    let productObject = await this.productServiceInBound.setUpdateProductObject(addProductDto, user, product);
    let productRelationObject = await this.productServiceInBound.setUpdateProductRelationObject(addProductDto, user, product);
    product = await this.sequelizeInstance.transaction(async transaction => {
        var activeIds = []
        let productInfo = productObject;

        if (productRelationObject.productSharePreference) {

            let nin = [];
            productRelationObject.productSharePreference.forEach((r) => {
                nin.push(r.sharetypeid)
            });

            // delete missing ids
            await this.productSharePreferenceRepository.update({
                deletedat: new Date()
            }, {
                where: {
                    productId: product.productId,
                    sharetypeid: {
                        [Op.notIn]: nin
                    }
                }, transaction: transaction
            });

            // collect activeIds
            await this.productSharePreferenceRepository.findAll({
                where: {
                    productId: product.productId,
                    deletedat: null
                }
            }).then((r) => {
                r.forEach((d) => {
                    activeIds.push(+d.sharetypeid);
                })
            });

            let productSharePreferenceObject: ProductSharePreference[] = await this.productServiceInBound.setProductSharePreference(addProductDto, product, user, activeIds);
            if (productSharePreferenceObject.length) {
                await this.productSharePreferenceRepository.bulkCreate(productSharePreferenceObject, { returning: true, transaction });
            }
        }

        if (addProductDto.productPrice) {
            // update product productPriceDetail
            await productInfo.productPriceDetail.save({
                transaction
            });
        }

        if (addProductDto.productPackageInfo) {
            // update product productPackageInfo
            await productInfo.productPackageInfo.save({
                transaction
            });
        }

        if (productRelationObject.productImage) {
            for (let ii = 0; ii < productRelationObject.productImage.length; ii++) {
                if (productRelationObject.productImage[ii].productimageid) {

                    if (productRelationObject.productImage[ii].imageid) {
                        // update product image to document table
                        let logo = await this.imageUpdate(productRelationObject.productImage[ii].imageid, productRelationObject.productImage[ii].image, transaction);
                        productRelationObject.productImage[ii].imageid = logo.documentId;
                    }

                    // update product image
                    await this.productImageRepository.update(productRelationObject.productImage[ii], {
                        where: { productimageid: productRelationObject.productImage[ii].productimageid },
                        returning: true,
                        transaction
                    });
                } else {

                    //save product image
                    let logo = await this.imageCreate(productRelationObject.productImage[ii].image, transaction);
                    productRelationObject.productImage[ii].imageid = logo.documentId;

                    // save product image
                    await this.productImageRepository.create(productRelationObject.productImage[ii], {
                        // returning: true,
                        transaction
                    });
                }
            }
        }
        // add broucher
        
        // add broucher
        if (addProductDto.productBrochure && addProductDto.productBrochure.productpdf && addProductDto.productBrochure.productpdf.length > 0) {
            addProductDto.productBrochure.productpdf.map(async x=>{
                if(x.productimageid){
						// update product image
						await this.productImageRepository.update({
                            name : defaultTo(x.documentName, ''),
                            description : defaultTo(x.documentDescription, ''),
                            updatedby : +user.userId,
                        }, {
							where: { productimageid:+x.productimageid },
							returning: true,
							transaction
						});
                }else{
                    let broucher={ imageid: x.imageid,
                        productimagetype : appconstant.PRODUCT_BROUCHER_IMAGE_TYPE,
                        name : defaultTo(x.documentName, ''),
                        description : defaultTo(x.documentDescription, ''),
                        updatedby : +user.userId,
                        createdat : new Date(),
                        productId:product.productId
                    }
                    await this.productImageRepository.create(broucher, { transaction });
                }
            });
            }
        // check make product only active after image upload
        if (productInfo.isactive == '1') {
            await this.productImageRepository.count({
                where: {
                    productId: product.productId,
                    deletedat: null,
                    productimagetype: {
                        [Op.in]: [ appconstant.PRODUCT_IMAGE_TYPE]
                    },
                },
                group: ['productimagetype'],
                transaction
            }).then((count: any) => {
                if (count && count.length != 1) {
                    productInfo.isactive = '0';
                }
            });
        }


        if (addProductDto.productBasicInfo || addProductDto.productAvailability || addProductDto.ProductInfo) {
            // update product details
            await productInfo.productDetail.save({
                transaction
            });

            // update product details
            await productInfo.save({
                transaction
            });
        }

        if (productRelationObject.productTag) {
            for (let ii = 0; ii < productRelationObject.productTag.length; ii++) {
                if (productRelationObject.productTag[ii].producttagid) {
                    // update product tag
                    await this.productTagRepository.update(productRelationObject.productTag[ii], {
                        where: { producttagid: productRelationObject.productTag[ii].producttagid },
                        returning: true,
                        transaction
                    });
                } else {
                    // save product tag
                    await this.productTagRepository.create(productRelationObject.productTag[ii], {
                        // returning: true,
                        transaction
                    });
                }
            }
        }

        if (productRelationObject.productArticleReview) {
            for (let ii = 0; ii < productRelationObject.productArticleReview.length; ii++) {
                if (productRelationObject.productArticleReview[ii].productarticlereviewid) {

                    // update article logo to document table
                    if (productRelationObject.productArticleReview[ii].reviewmagazinelogoid && productRelationObject.productArticleReview[ii].reviewmagazinelogo) {
                        let logo = await this.imageUpdate(productRelationObject.productArticleReview[ii].reviewmagazinelogoid, productRelationObject.productArticleReview[ii].reviewmagazinelogo, transaction);
                        productRelationObject.productArticleReview[ii].reviewmagazinelogoid = logo.documentId;
                    } else if (productRelationObject.productArticleReview[ii].reviewmagazinelogo) {
                        let logo = await this.imageCreate(productRelationObject.productArticleReview[ii].reviewmagazinelogo, transaction);
                        productRelationObject.productArticleReview[ii].reviewmagazinelogoid = logo.documentId;
                    }

                    // update product article review
                    await this.productArticleReviewRepository.update(productRelationObject.productArticleReview[ii], {
                        where: { productarticlereviewid: productRelationObject.productArticleReview[ii].productarticlereviewid },
                        returning: true,
                        transaction
                    });
                } else {

                    //save article logo
                    if (productRelationObject.productArticleReview[ii].reviewmagazinelogo) {
                        let logo = await this.imageCreate(productRelationObject.productArticleReview[ii].reviewmagazinelogo, transaction);
                        productRelationObject.productArticleReview[ii].reviewmagazinelogoid = logo.documentId;
                    }

                    // save product article review
                    await this.productArticleReviewRepository.create(productRelationObject.productArticleReview[ii], {
                        // returning: true,
                        transaction
                    });
                }
            }
        }

        if (productRelationObject.productExistRating) {
            for (let ii = 0; ii < productRelationObject.productExistRating.length; ii++) {
                if (productRelationObject.productExistRating[ii].productexistratingid) {

                    // update article logo to document table
                    if (productRelationObject.productExistRating[ii].ratingproofvalidationlogoid && productRelationObject.productExistRating[ii].ratingproofvalidationlogo) {
                        let logo = await this.imageUpdate(productRelationObject.productExistRating[ii].ratingproofvalidationlogoid, productRelationObject.productExistRating[ii].ratingproofvalidationlogo, transaction);
                        productRelationObject.productExistRating[ii].ratingproofvalidationlogoid = logo.documentId;
                    } else if (productRelationObject.productExistRating[ii].ratingproofvalidationlogo) {
                        let logo = await this.imageCreate(productRelationObject.productExistRating[ii].ratingproofvalidationlogo, transaction);
                        productRelationObject.productExistRating[ii].ratingproofvalidationlogoid = logo.documentId;
                    }

                    // update product existing rating
                    await this.productExistRatingRepository.update(productRelationObject.productExistRating[ii], {
                        where: { productexistratingid: productRelationObject.productExistRating[ii].productexistratingid },
                        returning: true,
                        transaction
                    });
                } else {

                    //save article logo
                    if (productRelationObject.productExistRating[ii].ratingproofvalidationlogo) {
                        let logo = await this.imageCreate(productRelationObject.productExistRating[ii].ratingproofvalidationlogo, transaction);
                        productRelationObject.productExistRating[ii].ratingproofvalidationlogoid = logo.documentId;
                    }

                    // save product existing rating
                    await this.productExistRatingRepository.create(productRelationObject.productExistRating[ii], {
                        // returning: true,
                        transaction
                    });
                }
            }
        }

        // delete old codes
        await this.productUniversalCodeRepository.update({
            deletedat:  this.sequelizeInstance.fn('NOW')
        }, {
            where: {
                productId: +product.productId
            }
        });

        if (productRelationObject.productUniversalCode) {
            for (let ii = 0; ii < productRelationObject.productUniversalCode.length; ii++) {
                if (productRelationObject.productUniversalCode[ii].productuniversalcodeid) {
                    // update product universal codes
                    await this.productUniversalCodeRepository.update(productRelationObject.productUniversalCode[ii], {
                        where: { productuniversalcodeid: productRelationObject.productUniversalCode[ii].productuniversalcodeid },
                        returning: true,
                        transaction
                    });
                } else {
                    // save product universal codes
                    await this.productUniversalCodeRepository.create(productRelationObject.productUniversalCode[ii], {
                        // returning: true,
                        transaction
                    });
                }
            }
        }

        // if (productRelationObject.productCompeting) {
        // 	for (let ii = 0; ii < productRelationObject.productCompeting.length; ii++) {
        // 		if (productRelationObject.productCompeting[ii].productcompetingid) {
        // 			// update product competing details
        // 			await this.productCompetingRepository.update(productRelationObject.productCompeting[ii], {
        // 				where: { productcompetingid: productRelationObject.productCompeting[ii].productcompetingid },
        // 				returning: true,
        // 				transaction
        // 			});
        // 		} else {
        // 			// save product competing details
        // 			await this.productCompetingRepository.create(productRelationObject.productCompeting[ii], {
        // 				returning: true,
        // 				transaction
        // 			});
        // 		}
        // 	}
        // }

        // productChannelCustomerProfile
        // console.log("-----------------------------------------------------------------------");
        if (isUndefined(productRelationObject.productChannelCustomerProfile)) {
            productRelationObject.productChannelCustomerProfile = [];
        }

        activeIds = []
        let nin = [];
        productRelationObject.productChannelCustomerProfile.forEach((r) => {
            nin.push(r.customerProfileId)
        });
        // console.log("===================================================================");
        // delete missing ids
        await this.productChannelCustomerProfileRepository.update({
            deletedat: new Date()
        }, {
            where: {
                productId: product.productId,
                customerProfileId: {
                    [Op.notIn]: nin
                }
            }, transaction: transaction
        });
        // console.log("===================================================================");
        // collect activeIds
        await this.productChannelCustomerProfileRepository.findAll({
            where: {
                productId: product.productId,
                deletedat: null
            }
        }).then((r) => {
            r.forEach((d) => {
                activeIds.push(+d.customerProfileId);
            })
        });

        let productChannelCustomerProfileObject: ProductChannelCustomerProfile[] = await this.productServiceInBound.setProductChannelCustomerProfile(addProductDto, product, user, activeIds);
        if (productChannelCustomerProfileObject.length) {
            await this.productChannelCustomerProfileRepository.bulkCreate(productChannelCustomerProfileObject, { returning: true, transaction });
        }
        // productChannelCustomerProfile
        // console.log("-----------------------------------------------------------------------");

        // if (addProductDto.productSellingLocation && addProductDto.productSellingLocation.sellinglocation && addProductDto.productSellingLocation.sellinglocation.length > 0) {
        //     activeIds = []
        //     let nin = [];
        //     addProductDto.productSellingLocation.sellinglocation.forEach((r) => {
        //         nin.push(r.regioncountryjctid)
        //     });

        //     // delete missing ids
        //     await this.productLocationRepository.update({
        //         deletedat: new Date()
        //     }, {
        //         where: {
        //             productId: product.productId,
        //             locationtype: "SELLING",
        //             regionCountryJCTId: {
        //                 [Op.notIn]: nin
        //             }
        //         }, transaction: transaction
        //     });

        //     // collect activeIds
        //     await this.productLocationRepository.findAll({
        //         where: {
        //             productId: product.productId,
        //             locationtype: "SELLING",
        //             deletedat: null
        //         }
        //     }).then((r) => {
        //         r.forEach((d) => {
        //             activeIds.push(+d.regionCountryJCTId);
        //         })
        //     });

        //     let productLocationObject: ProductLocation[] = await this.productServiceInBound.setProductSellingLocation(addProductDto, product, user, activeIds);
        //     if (productLocationObject.length) {
        //         await this.productLocationRepository.bulkCreate(productLocationObject, { returning: true, transaction });
        //     }
        // }

        if (addProductDto.productTargetLocation && addProductDto.productTargetLocation.targetlocation && addProductDto.productTargetLocation.targetlocation.length > 0) {
            activeIds = []
            let nin = [];
            addProductDto.productTargetLocation.targetlocation.forEach((r) => {
                nin.push(r.regioncountryjctid)
            });

            // delete missing ids
            await this.productLocationRepository.update({
                deletedat: new Date()
            }, {
                where: {
                    productId: product.productId,
                    locationtype: "TARGET",
                    regionCountryJCTId: {
                        [Op.notIn]: nin
                    }
                }, transaction: transaction
            });

            // collect activeIds
            await this.productLocationRepository.findAll({
                where: {
                    productId: product.productId,
                    locationtype: "TARGET",
                    deletedat: null
                }
            }).then((r) => {
                r.forEach((d) => {
                    activeIds.push(+d.regionCountryJCTId);
                })
            });

            let productLocationObject: ProductLocation[] = await this.productServiceInBound.setProductTargetLocation(addProductDto, product, user, activeIds);
            if (productLocationObject.length) {
                await this.productLocationRepository.bulkCreate(productLocationObject, { returning: true, transaction });
            }
        }

        // updateawards

        if (addProductDto.award_details && Object.keys(addProductDto.award_details).length > 0) {
            for (let ii = 0; ii < addProductDto.award_details.length; ii++) {
                                    // save award details to channel award table
                                    await this.productAwardRepository.create({
                                        productId: product.productId,
                                        awardDetail: 'product',
                                        issuedBy: 'ch',
                                        documentId: addProductDto.award_details[ii].documentId,
                                    },
                                        {
                                             transaction
                                        });
                                    }
                                }
        // if (addProductDto.award_details && Object.keys(addProductDto.award_details).length > 0) {
        //     for (let ii = 0; ii < addProductDto.award_details.length; ii++) {
        //         // let valid_upto = (addProductDto.award_details[ii].valid_upto) ? addProductDto.award_details[ii].valid_upto : null;
        //         if (addProductDto.award_details[ii].product_award_id) {

        //             // update article logo to document table
        //             if (addProductDto.award_details[ii].imageId && addProductDto.award_details[ii].image) {
        //                 let media = <Media>{};
        //                 media.documentTypeId = appconstant.DOCUMENTTYPE_IMAGE;
        //                 media.documentPath = (addProductDto.award_details[ii].image) ? addProductDto.award_details[ii].image : null;
        //                 media.dirName = appconstant.FOLDER_PATH_PRODUCT_AWARDS;

        //                 let logo = await this.imageUpdate(addProductDto.award_details[ii].imageId, media, transaction);
        //                 addProductDto.award_details[ii].imageId = logo.documentId;
        //             } else if (addProductDto.award_details[ii].image) {
        //                 let media = <Media>{};
        //                 media.documentTypeId = appconstant.DOCUMENTTYPE_IMAGE;
        //                 media.documentPath = (addProductDto.award_details[ii].image) ? addProductDto.award_details[ii].image : null;
        //                 media.dirName = appconstant.FOLDER_PATH_PRODUCT_AWARDS;

        //                 let logo = await this.imageCreate(media, transaction);
        //                 addProductDto.award_details[ii].imageId = logo.documentId;
        //             }


        //             // update award details to channel award table
        //             await this.productAwardRepository.update({
        //                 productId: product.productId,
        //                 awardDetail: 'product',
        //                 issuedBy: 'ch',
        //                 // validUpto: valid_upto,
        //                 // isLifeTime: addProductDto.award_details[ii].isLifeTime,
        //                 documentId: (+addProductDto.award_details[ii].imageId > 0) ? +addProductDto.award_details[ii].imageId : null
        //             },
        //                 {
        //                     where: { deletedAt: null, productAwardId: addProductDto.award_details[ii].product_award_id },
        //                     returning: true, transaction,
        //                 });
        //         } else {

        //             //save awards image
        //             if (addProductDto.award_details[ii].image) {
        //                 let media = <Media>{};
        //                 media.documentTypeId = appconstant.DOCUMENTTYPE_IMAGE;
        //                 media.documentPath = (addProductDto.award_details[ii].image) ? addProductDto.award_details[ii].image : null;
        //                 media.dirName = appconstant.FOLDER_PATH_PRODUCT_AWARDS;

        //                 let logo = await this.imageCreate(media, transaction);
        //                 addProductDto.award_details[ii].imageId = logo.documentId;
        //             } else {
        //                 addProductDto.award_details[ii].imageId = null
        //             }

        //             // save award details to channel award table
        //             await this.productAwardRepository.create({
        //                 productId: product.productId,
        //                 awardDetail: 'product',
        //                 issuedBy: 'ch',
        //                 // validUpto: valid_upto,
        //                 // isLifeTime: addProductDto.award_details[ii].isLifeTime,
        //                 documentId: (+addProductDto.award_details[ii].imageId > 0) ? +addProductDto.award_details[ii].imageId : null
        //             },
        //             {
        //                 //returning: true,
        //                 transaction
        //             });
        //         }
        //     }
        // }

        // updateawards
        if (addProductDto.deleted_award_details && addProductDto.deleted_award_details.length > 0) {
            for (let ii = 0; ii < addProductDto.deleted_award_details.length; ii++) {
                if (addProductDto.deleted_award_details[ii]) {
                    // update award details to channel award table
                    await this.productAwardRepository.update({
                        productId: product.productId,
                        deletedAt: new Date()
                    },
                        {
                            where: { deletedAt: null, productAwardId: addProductDto.deleted_award_details[ii] },
                            returning: true, transaction,
                        });
                }
            }
        }
        return product;
    }).then(async (product) => {
        // update key retailers
        await this.updateKeyRetailers(product, addProductDto, user, appconstant.CHANNEL_TYPE_RETAILER);
        await this.updateKeyRetailers(product, addProductDto, user, appconstant.CHANNEL_TYPE_DISTRIBUTOR);
        await this.updateKeyRetailers(product, addProductDto, user, appconstant.CHANNEL_TYPE_RESELLER);
        return product;
    }).catch(function (e) {
        console.log("Error+", e);
        throw new ProcessException(e.message);
    });


    if (product) {
        product = await this.setProductDefaultImage(product);
        result = { success: true, data: product };
    }

    return result;
}

async imageUpdate(imageId, image, transaction) {
    let logo = await this.mediaRepository.update(
        { deletedAt: new Date() },
        {
            where: { documentId: imageId },
            returning: true, transaction,
        }
    ).then(async () => {
        return await this.imageCreate(image, transaction);
    });
    return logo;
}

async imageDelete(imageId, image, transaction) {
    let logo = await this.mediaRepository.update(
        { deletedAt: new Date() },
        {
            where: { documentId: imageId },
            returning: true, transaction,
        }
    );
    return logo;
}
public async productDelete(sku, user) {

    let product = await this.productRepository.scope('productInfo').findOne<Product>({
        where: {
            productSKU: sku,
            deletedat: null,
            //channelId: user.channelId
        }
    });

    if (!product) {
        throw new ProcessException('channel:product:notFound');
    }

    let result = true;
    try {
        // update product details
        product.deletedat = this.sequelizeInstance.fn('NOW');
        await product.save();

    } catch (e) {
        result = false
    }

    // Remove the products from wishlist based on channelId
    await Wishlist.destroy({
        where: {
            productid: +product.productId
        }
    });

    return {
        success: result
    }
}

public async getProductLimit(user){
    return  await this.subscriptionExtraFeatureRepository.findOne({
        where: {
            isActive: '1',
            subscriptionId: +user.channel.plan.subscriptionPlanId,
            subscriptionExtraFeatureCategoryId: appconstant.SubscriptionCharcteristicFeature.NO_OF_PRODUCT
        }
    });
   
    
}
public async getPublicProduct(sku) {
    let product: any;
    try {
        product = await this.productRepository.scope('productInfo').findOne<Product>({
            include: [
                {
                    model: this.productGroupRepository,
                    as: 'productGroup',
                    where: { deletedAt: null },
                    required: true
                },
                {
                    model: this.productCategoryRepository,
                    as: 'productCategory',
                    where: { deletedAt: null },
                    required: true
                },
                {
                    model: this.brandRepository,
                    where: { deletedAt: null },
                    include: [
                        {
                            model: this.mediaRepository,
                            where: { deletedAt: null },
                            required: false
                        }
                    ],
                    required: true
                },
                {
                    model: this.productDetailRepository.scope('productInfo'),
                    where: { deletedat: null },
                    required: true
                },
                {
                    model: this.productTagRepository.scope('productInfo'),
                    where: { deletedat: null },
                    required: false
                },
                {
                    model: this.productArticleReviewRepository.scope('productInfo'),
                    where: { deletedat: null },
                    include: [
                        {
                            model: this.mediaRepository,
                            where: { deletedAt: null },
                            required: false
                        }
                    ],
                    required: false,
                },
                {
                    model: this.productExistRatingRepository.scope('productInfo'),
                    where: { deletedat: null },
                    include: [
                        {
                            model: this.mediaRepository,
                            where: { deletedAt: null },
                            required: false
                        }
                    ],
                    required: false
                },
                {
                    model: this.productImageRepository.scope('productInfo'),
                    as: "productImage",
                    where: { deletedat: null },
                    include: [
                        {
                            model: this.mediaRepository,
                            where: { deletedAt: null },
                            required: false
                        }
                    ],
                    required: false
                },
                {
                    model: this.productImageRepository.scope('productInfo'),
                    as: "defaultImage",
                    where: { deletedat: null },
                    include: [
                        {
                            model: this.mediaRepository,
                            where: { deletedAt: null },
                            required: false
                        }
                    ],
                    required: false
                },
                {
                    model: this.productSharePreferenceRepository.scope('productInfo'),
                    where: { deletedat: null },
                    required: false
                },
                {
                    model: this.productUniversalCodeRepository.scope('productInfo'),
                    where: { deletedat: null },
                    required: false
                },
                {
                    model: this.productPriceDetailRepository.scope('productInfo'),
                    where: { deletedat: null },
                    required: true
                },
                {
                    model: this.productPackageInfoRepository.scope('productInfo'),
                    where: { deletedat: null },
                    required: false
                },
                {
                    model: this.productChannelCustomerProfileRepository.scope('productInfo'),
                    where: { deletedat: null },
                    required: false,
                    include: [
                        {
                            model: this.channelCustomerProfileRepository.scope('channelDetail'),
                            where: { deletedAt: null, profileTypeClassificationId: { [Op.ne]: null } },
                            required: false,
                            include: [
                                {
                                    model: this.profileTypeClassificationRepository.scope('profileTypeClassificationInfom'),
                                    where: { deletedAt: null },
                                    required: false,
                                    include: [
                                        {
                                            model: this.profileTypeRepository.scope('profileTypeInfom'),
                                            where: { deletedAt: null },
                                            required: false,
                                        },
                                        {
                                            model: this.channelTypeRepository.scope('channelTypeInfom')
                                        }
                                    ]
                                }
                            ]
                        },
                    ]
                }
            ],
            where: { productSKU: sku, deletedat: null }
        });
        console.log('product', product);
        if (!product) {
            throw new ProcessException('channel:product:notFound');
        }

        if (!product.productAwards) {
            await new Utility().lazyload(product, 'productAwards', {
                where: { deletedAt: null },
                attributes: ['productAwardId', 'documentId', 'awardDetail', 'issuedBy', 'validUpto', 'isLifeTime'],
                required: false,
                include: [
                    {
                        model: Media,
                        attributes: ['documentId', 'documentPath', 'documentUrl'],
                        required: false
                    }
                ]
            });
        }

        if (!product.channel) {
            await new Utility().lazyload(product, 'channel', {
                attributes: ['channelId', 'companyName', 'channelTypeId']
            });
        }

    } catch (e) {
        console.log("Error+ getProduct", e);
        throw new ProcessException(e.message);
    }

    if (!product) {
        throw new ProcessException('channel:product:notFound');
    }

    product.toJSON();

    // product['other_info'] = {
    //     rating: 0,
    //     no_of_evaluations: 0,
    //     no_of_orders: 0
    // };

    // add rating and no_of_evaluations
    // await Product.sequelize.query('select count(DISTINCT PE.sampleorderdetailid) as no_of_evaluations , avg(PER.rating) rating from tblproductevaluation PE inner join tblproductevaluationrating PER on PE.productevaluationid = PER.productevaluationid where PE.productid= :productId GROUP BY PE.productid', {
    //     type: QueryTypes.SELECT,
    //     raw: true,
    //     replacements: {
    //         productId: +product.productId
    //     }
    // }).then((result:any) => {
    //     if (result[0]) {
    //         product['other_info']['rating'] = +Number.parseFloat(result[0].rating).toFixed(2);
    //         product['other_info']['no_of_evaluations'] = result[0].no_of_evaluations;
    //     }
    // });

    // // add no_of_orders
    // await Product.sequelize.query('select count(DISTINCT SOD.sampleorderdetailid) as no_of_orders  from tblsampleorderdetail SOD where SOD.productid= :productId GROUP BY SOD.productid', {
    //     type: QueryTypes.SELECT,
    //     raw: true,
    //     replacements: {
    //         productId: +product.productId
    //     }
    // }).then((result:any) => {
    //     if (result[0]) {
    //         product['other_info']['no_of_orders'] = result[0].no_of_orders;
    //     }
    // });

    product['productKeyRetailer'] = await this.getProductKeyRetailers(product.channelId, product.productId, appconstant.CHANNEL_TYPE_RETAILER);
    product['productKeyReseller'] = await this.getProductKeyRetailers(product.channelId, product.productId, appconstant.CHANNEL_TYPE_RESELLER);
    // product['productKeyDistributor'] = await this.getProductKeyRetailers(product.channelId, product.productId, appconstant.CHANNEL_TYPE_DISTRIBUTOR);

    product['unit'] = await this.unitRepository.findAll();
    return product;
}

async getProductSearchList(search){
    let product=await this.productRepository.findAll<Product>({
        attributes: ['product','productId', 'productSKU', 'channelId'],
        where :{
            deletedat : null,
            isactive : '1',
            product: { [Op.iLike]: '%' +search+ '%' },
        },
        include:[
            {
                model: this.productImageRepository,
                as: 'defaultImage',
                attributes: ['productimageid', 'imageid'],
                where: { deletedat: null },
                required: false,
                include: [{
                    model: this.mediaRepository,
                    attributes: ['documentUrl', 'documentPath'],
                    where: { deletedAt: null },
                    required: false,
                },
            ]
            },
            {
                model: this.brandRepository,
                where: { deletedAt: null },
                attributes: ['id','brandName'],
                required: true
            },
        ],
        limit : 10
    })
    let result=[];
        product.map(x => {        
            result.push({channelId:x.channelId,id:x.productId,name:x.product, productSKU:x.productSKU, logo: x.defaultImage, brand : x.brand })
        })
    return result;
}
}