import { Body, Controller, HttpStatus, Param, Post, Get, Req, Res, UploadedFile, UploadedFiles, UseGuards, UseInterceptors } from "@nestjs/common";
import { AuthGuard } from "@nestjs/passport";
import { ReportService } from "../service/report.service";
import { ProcessException } from "src/middleware/exception/Process.exception";

@UseGuards(AuthGuard('jwt'))
@Controller('report')
export class ReportController {
  
  constructor(
    private reportService:ReportService,
    ) {}

  @Post('getTransactionReport')
    async getTransactionReport(@Req() req,@Res() res){
      let user = req.user;
      let reqKey = req.body;
      
        let result = await this.reportService.getFailureTransaction(reqKey);
    
		    return res.status(HttpStatus.OK).send(result);
    }

    @Get('searchinvoice')
    async getInvoice(@Req() req,@Res() res){
      let user = req.user;
      let reqKey = req.body;
        let result = await this.reportService.getAllInvoices();
        console.log(result);
		    return res.status(HttpStatus.OK).send(result);
    }

    
}
