import { Inject, Injectable } from '@nestjs/common';
import { FailureTransaction } from '../../channel/models/FailureTransaction.entity';
import { PaymentTransaction } from '../../channel/models/PaymentTransaction.entity';
import { ChannelJCT } from '../../channel/models/ChannelJCT.entity';
import { appconstant } from '../../../config';
import { ConnectionStatusType } from '../../channel/models/ConnectionStatusType.entity';
import {Op, QueryTypes } from "sequelize";
import { Channel } from 'src/modules/channel/models/Channel.entity';
export class ReportService {
	
    constructor(
		@Inject('FailureTransactionRepository') private readonly failureTransactionRepository: typeof FailureTransaction,
		@Inject('PaymentTransactionRepository') private readonly paymentTransactionRepository: typeof PaymentTransaction,
	)
		{
        }

	async getFailureTransaction(data){
		if(data.methodId == '2'){
			return await this.paymentTransactionRepository.findAndCountAll<any>({
				where: {
					paymentMethodId: 2,
					transactionNumber:null
					
				},
				raw: true,
				limit: data.limit,
				offset: data.page,
			});
		} else {	
			return await this.failureTransactionRepository.findAndCountAll<any>({
				attributes:['failureTransactionId','response','paymentTransaction.paymentTransactionId', 
				"channel.channelTypeId" as 'channelTypeId', "channel.companyName" as  'companyName',
			"paymentTransaction.paymentTransactionAt" as "paymentTransactionAt"],
				include: [{
					model: PaymentTransaction,
				},
				{
					model: Channel,
				}
			   ],
				where: {
					paymentMethodId:{
						[Op.in]: [data.methodId]
						}
					
				},
				raw: true,
				limit: data.limit,
				offset: data.page,
			});

		}
	}	

	async getAllInvoices(){
		
		return await this.paymentTransactionRepository.findAll<any>({
			attributes:['invoice'],
			where: {
				paymentMethodId: 2				
			}
			
		});
		
	}	

	
		
    
}
