import { Body, Controller, Get, HttpStatus, Inject, Param, ParseIntPipe, Patch, Post, Put, Req, Res, UseGuards, ValidationPipe } from '@nestjs/common';
import { AuthGuard } from '@nestjs/passport';
import { ContextService } from '../../../context/context.service';
import {Op, QueryTypes } from "sequelize";
import { appconstant } from 'src/config/app.constant';
import { UserService } from '../service/user.service';
import { AddUserDto } from '../dto/addUser.dto';
import { UpdateMyProfileDto } from '../dto/updateMyProfile.dto';
import { UpdateUserDto } from '../dto/updateUser.dto';
import { CheckEmailPipe } from 'src/modules/account/pipe/account.pipe';


@UseGuards(AuthGuard('jwt'))
@Controller('user')
export class UserController {
constructor(private userService:UserService,
    @Inject('SequelizeInstance') private readonly sequelizeInstance,
    private context: ContextService) {}
    
    @Post('add')	
	public async addNewUser(@Res() res,@Req() req, @Body(new ValidationPipe()) addUserDto: AddUserDto) {

		let nonsuggestion=[];let count;
		let user = req.user;
			
		// user magt preference
		//await this._validateUserMgmtProfile();

		//await this._validateSubscriptionFeatures();
		
		try{
		let result = await this.userService.addUser(addUserDto, user.channelId, user.showId, user.userId, user.channelTypeId);
		//console.log(result);
		//update index
		//this.ChannelIndexService.index(user.channelId);		

		//if(Object.keys(result.userId).length != 0)
	

		let userId=result.userId;
		let channelId = user.channelId;
		let contactId = result.contactId;
		let channelTypeId = user.channelTypeId;

		// //update rank and custom_sort_order table
		// await this.sequelizeInstance.query('select * from "setrank"(' + contactId + ')', {
		// 	type: Sequelize.QueryTypes.SELECT
		// });

		//this.userService.getNonSuggestion(channelId,this.context.get('dataSession').plan,contactId,userId,channelTypeId);


		// if(result.userId != 0){
		// 	let hubspotCompanyId = user.channel.hubspotCompanyId;
		// 	console.log("end");

			
		// 	let contactData = await this.getHubspotContact(addUserDto, user.contactId, user.userId, user.channelId, hubspotCompanyId);
		// }
		
		res.status(HttpStatus.CREATED).send({
			created: result
		});
	}catch(e)
	{
		console.log("adduser:",e);
	}
    }
    
    // @Patch('profile')	
	// public async myProfileUpdate(@Body(new ValidationPipe()) userDto: UpdateMyProfileDto, @Res() res,@Req() req) {
    //     // contact profile
    //     let user=req.user;
	// 	//await this._validateContactProfile();
	// 	let nonsuggestion=[];let count;
	// 	if (Object.keys(userDto).length) {
	// 		await this.userService.updateUser(userDto, req.user, true);
	// 		//console.log();
	// 		let userId = user.userId;
	// 		let channelId = user.channelId;
	// 		let contactId = user.contactId;
	// 		let channelTypeId = user.channelTypeId;
			
	// 		// update index
	// 		//this.ChannelIndexService.index(this.context.get('user').channelId);

	// 		//this.userService.getNonSuggestion(channelId,this.context.get('dataSession').plan,contactId,userId,channelTypeId);

	// 		// let hubspotClient = new HubspotImportHelper();
	// 		// hubspotClient.getContactWithThisEmail(userDto.contact.email).then(async function(existContactDetails) {
	// 		// 	var obj = JSON.parse(existContactDetails);
	// 		// 	console.log(userId);
	// 		// 	console.log(channelId);
				
	// 		// 		if(obj.vid){
	// 		// 			hubspotClient.UpdateContactToHubSpot(userDto.contact, contactId,userId, channelId, obj.vid).then(async function(contactDetails) {
	// 		// 			}); 
	// 		// 		} else {
	// 		// 			hubspotClient.impotContactToHubSpot(userDto.contact, contactId, userId, channelId).then(async function(contactDetails) {
	// 		// 			}); 
	// 		// 		}
	// 		// 	}); 
	// 	}

	// 	res.status(HttpStatus.OK).send({
	// 		updated: true
	// 	});
	// }
	
	@Patch('profile/:id')	
	public async userProfileUpdate(@Param('id', new ParseIntPipe()) id, @Body(new ValidationPipe()) userDto: UpdateUserDto, @Res() res, @Req() req) {
		// user magt preference
	//	await this._validateUserMgmtProfile();
		let nonsuggestion=[];let count;	
	//	await this._validateSubscriptionFeatures(true);
		let real_user=req.user;
		if (Object.keys(userDto).length) {
			let user = await this.userService.getUser(id,req.user.channelId);
			

			let allowToModifyInterestedCategory = true;
			// check if the request from back office
			// if (this.context.get('real-user')) {
			// 	allowToModifyInterestedCategory = true
			// }

			await this.userService.updateUser(userDto, user, allowToModifyInterestedCategory,real_user);
			//let channelTypeId=this.context.get('user').channel.channelTypeId;
			// update index
			//this.ChannelIndexService.index(this.context.get('user').channelId);

			//this.userService.getNonSuggestion(user.channelId,this.context.get('dataSession').plan,id,user.userId,channelTypeId);

			// audit log
			// if (this.context.get('real-user')) {
			// 	this.auditLog.addAuditLog((userDto && userDto.reason) ? userDto.reason : null, auditlog.MODULE.BO_USER_MANAGEMENT, req);
			// }
			
			//let hubspotClient = new HubspotImportHelper();
			//let channelId = this.context.get('user').channelId;
			//let contactId = this.context.get('user').contactId;
			//console.log(userDto.contact.email);
			//hubspotClient.getContactWithThisEmail(userDto.contact.email).then(async function(existContactDetails) {
			//var obj = JSON.parse(existContactDetails);
			//console.log(obj.vid);
				// if(obj.vid){
				// 	hubspotClient.UpdateContactToHubSpot(userDto.contact, contactId, user.userId, channelId, obj.vid).then(async function(contactDetails) {
				// 	}); 
				// } else {
				// 	hubspotClient.impotContactToHubSpot(userDto.contact, contactId, user.userId, channelId).then(async function(contactDetails) {
				// 	}); 
				// }
			//}); 
		}

		res.status(HttpStatus.OK).send({
			updated: true
		});
	}
    
    @Get('preference')	
	public async getPreference(@Res() res,@Req() req) {
        let user=req.user;
        let result=await this.userService.getPreference(user.channelTypeId);		
		return res.status(HttpStatus.OK).send(result);
	}

	@Get('mailpreference')
	public async getMailPreference(@Res() res, @Req() req) {
		//let user=req.user;
		let result = await this.userService.getMailPreference();
		return res.status(HttpStatus.OK).send(result);
	}

	@Get('userpreference/:contactId')	
	public async getUserPreference(@Param('contactId') contactId,@Res() res,@Req() req) {
        let user=req.user;
        let result=await this.userService.getUserPreference(contactId, user.channelId);		
		return res.status(HttpStatus.OK).send(result);
    }

	@Get('userprevilege/:contactId')	
	public async getUserPrevilege(@Param('contactId') contactId,@Res() res,@Req() req) {
        let user=req.user;
        let result=await this.userService.getUserPrevilege(contactId);		
		return res.status(HttpStatus.OK).send(result);
    }

	

	@Get('defaultcontact')	
	public async getDefaultContact(@Res() res,@Req() req) {
        let user=req.user;
        let result=await this.userService.getDefaultContact(user.channelId);		
		return res.status(HttpStatus.OK).send(result);
    }

	@Get('allcontacts')	
	public async getAllContacts(@Res() res,@Req() req) {
        let user=req.user;
        let result=await this.userService.getAllContacts(user.channelId);		
		return res.status(HttpStatus.OK).send(result);
    }

	@Get('setDefaultContact/:contactId')	
	public async setDefaultContact(@Param('contactId') contactId,@Res() res,@Req() req) {
        let user=req.user;
        let result=await this.userService.setDefaultContact(user.channelId,contactId);		
		return res.status(HttpStatus.OK).send(result);
    }

	@Get('country')	
    public async userCountry(@Req() req, @Res() res) {		

        let result = await this.userService.Countries();
         if (result) {
            res.status(HttpStatus.OK).json(result);
         } else {
              //throw new ProcessException("notification:presetmail:listNotfound");
          }
    }

	@Get('contact/:id')
	public async getContact(@Param('id', new ParseIntPipe()) id, @Res() res) {
		let contact = await this.userService.getContact(id);
		res.status(HttpStatus.OK).send(contact);
	}

	@Post('getUserFeatureType')	
     public async getLogedUserFeatreList(@Req() req, @Res() res) {	
		let keyId =  appconstant.SubscriptionCharcteristicFeature;
		let ids = req.body.keys;
		let respon=req.user.channel.channelSubscription.keyFeature[keyId[ids]];
		
		res.status(HttpStatus.OK).json({key:ids,value:respon}); //.send(user);
    }

	@Put('isAlgorithm/:id')
	public async isAlgorithm(@Param('id', new ParseIntPipe()) id, @Res() res) {
		let contact = await this.userService.isAlgorithm(id);
		res.status(HttpStatus.OK).send(contact);
	}

	@Post('checkusermail/:email')
	public async checkmail(@Param('email', new CheckEmailPipe()) email, @Body() data, @Res() res) {
        let result = await this.userService.checkEmail(email.trim(), data.userId);
        console.log('email', email)

		res.status(HttpStatus.OK).send({
			isavialble: result
		});
    }
}