'use strict'

import { IsUrl, IsBoolean, IsOptional, Length, IsNotEmpty, IsEmail, MinLength, MaxLength, IsString, IsAlphanumeric, IsNumber, IsInt, Matches } from 'class-validator';
//import { ApiModelProperty } from '@nestjs/swagger';

export class AddContactDto {
	
	@MinLength(1, { message: "validate:field:validateMinLength" })
	@MaxLength(30, { message: "validate:field:validateMaxLength" })
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsString({ message: "validate:field:shouldBeString" })
	//@ApiModelProperty()
	firstName: string;

	@MinLength(1, { message: "validate:field:validateMinLength" })
	@MaxLength(30, { message: "validate:field:validateMaxLength" })
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
//	@ApiModelProperty()
	lastName: string;

	@IsEmail({}, { message: "validate:field:shouldBeValidEmail" })
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@MinLength(5, { message: "validate:field:validateMinLength" })
	@MaxLength(254, { message: "validate:field:validateMaxLength" })
//	@ApiModelProperty()
	email: string;

	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsNumber({}, { message: "validate:field:shouldBeInt" })
//	@ApiModelProperty()
	countryId: number;

	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsNumber({}, { message: "validate:field:shouldBeInt" })
//	@ApiModelProperty()
	role: number;

	@IsOptional()
	@IsString({ message: "validate:field:shouldBeString" })
//	@ApiModelProperty()
	avatar: string

	@IsOptional()
	@IsNumber({}, { message: "validate:field:shouldBeInt" })
//	@ApiModelProperty()
	documentId: number

	@IsOptional()
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@MinLength(4, { message: "validate:field:validateMinLength" })
	@MaxLength(30, { message: "validate:field:validateMinLength" })
//	@ApiModelProperty()
	phoneNo: string;

	@IsOptional()
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@MinLength(4, { message: "validate:field:validateMinLength" })
	@MaxLength(30, { message: "validate:field:validateMinLength" })
//	@ApiModelProperty()
	mobileNo: string;

	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@MinLength(2, { message: "validate:field:validateMinLength" })
	@MaxLength(50, { message: "validate:field:validateMinLength" })
//	@ApiModelProperty()
	jobTitle: string;

	@IsOptional()
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsNumber({}, { message: "validate:field:shouldBeInt" })
//	@ApiModelProperty()
	rptContactId: number;

	@IsOptional()
//	@ApiModelProperty()
	@IsString({ message: "validate:field:shouldBeUrl" })
	linkedInUrl: string;

	@IsOptional()
//	@ApiModelProperty()
	@IsString({ message: "validate:field:shouldBeUrl" })
	googlePlusUrl: string;

	@IsNumber({}, { message: "validate:field:shouldBeInt" })
//	@ApiModelProperty()
	workNatureId: number;

	@IsString({ message: "validate:field:shouldBeString" })
//	@ApiModelProperty()
	isShared: string

	@IsOptional()
	@IsString({ message: "validate:field:shouldBeString" })
//	@ApiModelProperty()
	isActive: string
}
