'use strict'

import { IsDefined, IsUrl, IsBoolean, IsOptional, Length, IsNotEmpty, IsEmail, MinLength, MaxLength, IsString, IsAlphanumeric, IsNumber, IsInt, Matches } from 'class-validator';
//import { ApiModelProperty } from '@nestjs/swagger';

export class UpdateProfileDto {

	@IsOptional()
	@MinLength(1, { message: "validate:field:validateMinLength" })
	@MaxLength(30, { message: "validate:field:validateMaxLength" })
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsString({ message: "validate:field:shouldBeString" })
//	@ApiModelProperty()
	firstName: string;

	@IsOptional()
	@MinLength(1, { message: "validate:field:validateMinLength" })
	@MaxLength(30, { message: "validate:field:validateMaxLength" })
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
//	@ApiModelProperty()
	lastName: string;

	@IsOptional()
	@IsEmail({}, { message: "validate:field:shouldBeValidEmail" })
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@MinLength(5, { message: "validate:field:validateMinLength" })
	@MaxLength(254, { message: "validate:field:validateMaxLength" })
//	@ApiModelProperty()
	email: string;

	@IsOptional()
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsNumber({}, { message: "validate:field:shouldBeInt" })
//	@ApiModelProperty()
	countryId: number;

	@IsOptional()
	@IsString({ message: "validate:field:shouldBeString" })
//	@ApiModelProperty()
	avatar: string

	@IsOptional()
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@MinLength(5, { message: "validate:field:validateMinLength" })
	@MaxLength(30, { message: "validate:field:validateMinLength" })
//	@ApiModelProperty()
	readonly phoneNo: string;

	@IsOptional()
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@MinLength(5, { message: "validate:field:validateMinLength" })
	@MaxLength(30, { message: "validate:field:validateMinLength" })
//	@ApiModelProperty()
	readonly mobileNo: string;

	@IsOptional()
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@MinLength(2, { message: "validate:field:validateMinLength" })
	@MaxLength(50, { message: "validate:field:validateMaxLength" })
//	@ApiModelProperty()
	readonly jobTitle: string;

	@IsOptional()
//	@ApiModelProperty()
	@IsString({ message: "validate:field:shouldBeUrl" })
	readonly linkedInUrl: string;

	@IsOptional()
//	@ApiModelProperty()
	@IsString({ message: "validate:field:shouldBeUrl" })
	readonly googlePlusUrl: string;

	@IsOptional()
	@IsNumber({}, { message: "validate:field:shouldBeInt" })
//	@ApiModelProperty()
	readonly workNatureId: number;

	@IsOptional()
	@IsString({ message: "validate:field:shouldBeString" })
//	@ApiModelProperty()
	readonly isShared: string
}
