'use strict';

import { IsNotEmpty, MaxLength, IsString, IsOptional, IsInt, IsBoolean, IsNumber } from 'class-validator';
//import { ApiModelProperty } from '@nestjs/swagger';

export class MyAddressBookDto {

	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	readonly name: string

	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	readonly primary_contactno: string

	@IsOptional()
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })	
	readonly alternative_contactno: string

	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })	
	readonly address: string;

	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsNumber({}, { message: "validate:field:shouldBeInt" })	
	readonly countryId: number;

	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })	
	readonly postalCode: string;

	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })	
	readonly city: string;

	@IsBoolean({ message: "validate:field:shouldBeBoolean" })	
	readonly isshippingaddress: boolean

	@IsBoolean({ message: "validate:field:shouldBeBoolean" })	
	readonly isbillingaddress: boolean
}
