import { ArrayNotEmpty, ValidateNested, IsOptional, Length, IsNotEmpty, IsEmail, MinLength, MaxLength, IsString, IsAlphanumeric, IsNumber, IsInt, Matches } from 'class-validator';
//import { ModelProperty } from '@nestjs/swagger';
import { UpdateProfileDto } from './UpdateUser/profile.dto';
import { Type } from 'class-transformer';
import { TradeInformation_Product_FamiliesDto } from './../../channel/dto/tradeInformation_Product_Families.dto';
import { TradeInformation_Product_CategoriesDto } from './../../channel/dto/tradeInformation_Product_Categories.dto';
import { AccessPermissionDto } from './AddUser/accesspermission.dto';
import { ChannelLocationDto } from './../../channel/dto/channelLocation.dto';
import { channelContactSuggestionDto } from './channelContactSuggestion.dto';

export class UpdateMyProfileDto {

	@IsOptional()
	@ValidateNested()
	@Type(() => UpdateProfileDto)
//	@ApiModelProperty({ type: UpdateProfileDto })
	readonly contact: UpdateProfileDto

	@IsOptional()
//	@ApiModelProperty({ type: TradeInformation_Product_FamiliesDto, isArray: true })
	@ArrayNotEmpty({ message: "channel:tradeinformation:productFamiliesArray" })
	@IsNotEmpty({ message: "channel:tradeinformation:productFamiliesArrayNotEmpty" })
	@ValidateNested()
	@Type(() => TradeInformation_Product_FamiliesDto)
	readonly productFamilies: TradeInformation_Product_FamiliesDto[];

	@IsOptional()
	//@ApiModelProperty({ type: TradeInformation_Product_CategoriesDto, isArray: true })
	@ArrayNotEmpty({ message: "channel:tradeinformation:productCategoriesArray" })
	@IsNotEmpty({ message: "channel:tradeinformation:productCategoriesNotEmpty" })
	@ValidateNested()
	@Type(() => TradeInformation_Product_CategoriesDto)
	readonly productCategories: TradeInformation_Product_CategoriesDto[];

	@IsOptional()
	//@ApiModelProperty({ type: TradeInformation_Product_FamiliesDto, isArray: true })
	@ArrayNotEmpty({ message: "channel:tradeinformation:productFamiliesArray" })
	@IsNotEmpty({ message: "channel:tradeinformation:productFamiliesArrayNotEmpty" })
	@ValidateNested()
	@Type(() => TradeInformation_Product_FamiliesDto)
	readonly interestedProductFamilies: TradeInformation_Product_FamiliesDto[];

	@IsOptional()
	//@ApiModelProperty({ type: TradeInformation_Product_CategoriesDto, isArray: true })
	@ArrayNotEmpty({ message: "channel:tradeinformation:productCategoriesArray" })
	@IsNotEmpty({ message: "channel:tradeinformation:productCategoriesNotEmpty" })
	@ValidateNested()
	@Type(() => TradeInformation_Product_CategoriesDto)
	readonly interestedProductCategories: TradeInformation_Product_CategoriesDto[];

	@IsOptional()
	//@ApiModelProperty({ type: ChannelLocationDto, isArray: true })
	@ArrayNotEmpty({ message: "validate:field:shouldBeArray" })
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@ValidateNested()
	@Type(() => ChannelLocationDto)
	readonly locations: ChannelLocationDto[];

	@IsOptional()
	//@ApiModelProperty({ type: channelContactSuggestionDto, isArray: true })
	@ArrayNotEmpty({ message: "channel:channelcontactcuggestion:sharetypeidArray" })
	@IsNotEmpty({ message: "channel:channelcontactcuggestion:sharetypeidArrayNotEmpty" })
	@ValidateNested()
	@Type(() => channelContactSuggestionDto)
	readonly channelContactSuggestion: channelContactSuggestionDto[];

}
