import { ArrayNotEmpty, ValidateNested, IsOptional, Length, IsNotEmpty, IsEmail, MinLength, MaxLength, IsString, IsAlphanumeric, IsNumber, IsInt, Matches } from 'class-validator';
//import { ApiModelProperty } from '@nestjs/swagger';
import { UpdateContactDto } from './UpdateUser/contact.dto';
import { Type } from 'class-transformer';
import { TradeInformation_Product_FamiliesDto } from './../../channel/dto/tradeInformation_Product_Families.dto';
import { TradeInformation_Product_CategoriesDto } from './../../channel/dto/tradeInformation_Product_Categories.dto';
import { AccessPermissionDto } from './AddUser/accesspermission.dto';
import { ChannelLocationDto } from './../../channel/dto/channelLocation.dto';

export class UpdateUserDto {

	@IsOptional()
	@ValidateNested()
	@Type(() => UpdateContactDto)
//	@ApiModelProperty({ type: UpdateContactDto })
	contact: UpdateContactDto

	@IsOptional()
//	@ApiModelProperty({ type: TradeInformation_Product_FamiliesDto, isArray: true })
	@ArrayNotEmpty({ message: "channel:tradeinformation:productFamiliesArray" })
	@IsNotEmpty({ message: "channel:tradeinformation:productFamiliesArrayNotEmpty" })
	@ValidateNested()
	@Type(() => TradeInformation_Product_FamiliesDto)
	readonly productFamilies: TradeInformation_Product_FamiliesDto[];

	@IsOptional()
//	@ApiModelProperty({ type: TradeInformation_Product_CategoriesDto, isArray: true })
	@ArrayNotEmpty({ message: "channel:tradeinformation:productCategoriesArray" })
	@IsNotEmpty({ message: "channel:tradeinformation:productCategoriesNotEmpty" })
	@ValidateNested()
	@Type(() => TradeInformation_Product_CategoriesDto)
	readonly productCategories: TradeInformation_Product_CategoriesDto[];

	@IsOptional()
//	@ApiModelProperty({ type: TradeInformation_Product_FamiliesDto, isArray: true })
	@ArrayNotEmpty({ message: "validate:field:shouldBeEmptyArray" })
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@ValidateNested()
	@Type(() => TradeInformation_Product_FamiliesDto)
	interestedProductFamilies: TradeInformation_Product_FamiliesDto[];

	@IsOptional()
//	@ApiModelProperty({ type: TradeInformation_Product_CategoriesDto, isArray: true })
	@ArrayNotEmpty({ message: "validate:field:shouldBeEmptyArray" })
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@ValidateNested()
	@Type(() => TradeInformation_Product_CategoriesDto)
	interestedProductCategories: TradeInformation_Product_CategoriesDto[];

	@IsOptional()
//	@ApiModelProperty({ type: ChannelLocationDto, isArray: true })
	@ArrayNotEmpty({ message: "validate:field:shouldBeArray" })
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@ValidateNested()
	@Type(() => ChannelLocationDto)
	readonly locations: ChannelLocationDto[];

	@IsOptional()
//	@ApiModelProperty({ type: AccessPermissionDto, isArray: true })
	@ArrayNotEmpty({ message: "validate:field:shouldBeArray" })
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@ValidateNested()
	@Type(() => AccessPermissionDto)
	readonly accessPermissions: AccessPermissionDto[];

	@IsOptional()
	@MaxLength(1000, { message: "validate:field:validateMaxLength" })
//	@ApiModelProperty()
	reason: string

	@IsOptional()
	ratingId: number
}
