'use strict';
import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, BeforeCreate, AllowNull, BeforeUpdate, HasMany, ForeignKey, Scopes, BelongsTo } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { AccessPermission } from './AccessPermission.entity';
import { ChannelType } from './../../channel/models/ChannelType.entity';
const tableOptions: IDefineOptions = { timestamp: true, tableName: 'tblchanneltypeaccesspermission' } as IDefineOptions;

@Scopes({
	getChannelTypeAccessPermission: {
		attributes: ['channeltypeaccesspermissionid', 'accesspermissionid', 'channeltypeid']
	}
})

@Table(tableOptions)
export class ChannelTypeAccessPermission extends Model<ChannelTypeAccessPermission>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	channeltypeaccesspermissionid: number

	@ForeignKey(() => AccessPermission)
	@Column(DataType.BIGINT)
	accesspermissionid: number

	@BelongsTo(() => AccessPermission)
	AccessPermission: AccessPermission;

	@ForeignKey(() => ChannelType)
	@Column(DataType.BIGINT)
	channeltypeid: number

	@BelongsTo(() => ChannelType)
	channelType: ChannelType;

	@Column(DataType.DATE)
	deletedat: Date;

	@Column(DataType.DATE)
	createdat: Date;
}
