import {
	Table,
	Column,
	PrimaryKey,
	Model,
	AutoIncrement,
	DataType,
	BeforeCreate,
	AllowNull,
	BeforeUpdate,
	ForeignKey,
	BelongsTo,
	Scopes
} from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Contact } from './../../user/models/Contact.entity';
import { ProductCategory } from '../../product/models/ProductCategory.entity';
import { Channel } from 'src/modules/channel/models/Channel.entity';
var Sequelize = require('sequelize');

const tableOptions: IDefineOptions = { timestamp: true, tableName: 'tblInterestedProductCategory' } as IDefineOptions;

@Table(tableOptions)

@Scopes({
	contactProductInfom: {
		attributes: ['InterestedProductCategoryId', 'contactId', 'productCategorieId','channelId']
	}
})

export class InterestedProductCategory extends Model<InterestedProductCategory>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	InterestedProductCategoryId: number

	@ForeignKey(() => Contact)
	@Column(DataType.BIGINT)
	contactId: number

	@BelongsTo(() => Contact)
    contact: Contact[];
    
    @ForeignKey(() => Channel)
	@Column(DataType.BIGINT)
	channelId: number

	@BelongsTo(() => Channel)
	channel: Channel[];

	@ForeignKey(() => ProductCategory)
	@Column(DataType.BIGINT)
	productCategorieId: number

	@BelongsTo(() => ProductCategory)
	productCategorie: ProductCategory;

	@Column(DataType.DATE)
	deletedAt: Date

	@Column(DataType.DATE)
	createdAt: Date

	@Column(DataType.DATE)
	updatedAt: Date

	@BeforeCreate 
	@BeforeUpdate 
	public static async dateUpdate(InterestedProductCategory: InterestedProductCategory, options: any) { 
		InterestedProductCategory.updatedAt = Sequelize.fn('NOW'); 
	}

}
