'use strict';

import { ForeignKey, BelongsTo, Table, Column, Model, DataType } from 'sequelize-typescript';
import { Country } from '../../common/models/Country.entity';
import { ApiProperty } from '@nestjs/swagger';
import { UUIDV4 } from 'sequelize/types';

@Table({
	timestamps:false,
	tableName: "tblmyaddressbook"
})
export class MyAddressBook extends Model<MyAddressBook>{

	@Column({
		type: DataType.BIGINT,
		allowNull: false,
		autoIncrement: true,
		unique: true,
		primaryKey: true,
	})
	@ApiProperty()
	addressid: number

	@Column(DataType.BIGINT)
	userid: number

	@Column(DataType.BIGINT)
	channelid: number

	@Column
	name: string

	@Column
	address: string

	@Column
	city: string

	@ForeignKey(() => Country)
	@Column(DataType.BIGINT)
	countryid: number

	@BelongsTo(() => Country)
	country: Country;

	@Column
	postalcode: string

	@Column
	contactno1: string

	@Column
	contactno2: string

	@Column
	isshippingaddress: string

	@Column
	isbillingaddress: string
}
