'use strict';

import { Table, Column, Model, DataType } from 'sequelize-typescript';
import { ApiProperty } from '@nestjs/swagger';
import { UUIDV4 } from 'sequelize/types';

@Table({
	tableName: "tblRole",
	timestamps:false
})
export class Role extends Model<Role>{
	static ROLE_ACCOUNT_USER = 1;
	static ROLE_ADMIN_USER = 2;
	static ROLE_PRIMARY_USER = 3;

	@Column({
		type: DataType.BIGINT,
		allowNull: false,
		// defaultValue:UUIDV4,//autoIncrement: true,
		unique: true,
		primaryKey: true,
	})
	@ApiProperty()
	roleId: number

	@Column({
		type: DataType.CHAR(30),
		allowNull: false,
		unique: { name: 'role', msg: 'user:role:shouldBeUnique' }
	})
	@ApiProperty()
	role: string
}
