import {
	Table,
	Column,
	PrimaryKey,
	Model,
	AutoIncrement,
	DataType,
	AllowNull,
	ForeignKey,
	BelongsTo
} from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Channel } from '../../channel/models/Channel.entity';
import { SignUpStatus } from './SignUpStatus.entity';
import { User } from '../models/User.entity';
const tableOptions: IDefineOptions = {"define": {
    "updatedBy":"updatedAt"
  }, timestamps: false, tableName: 'tblSignUpHistory' } as IDefineOptions;

@Table(tableOptions)

export class SignUpHistory extends Model<SignUpHistory>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	signupHistoryId: number;

	@ForeignKey(() => Channel)
	@Column(DataType.BIGINT)
	signupId: number

	@BelongsTo(() => Channel)
	signup: Channel;

	@ForeignKey(() => SignUpStatus)
	@Column(DataType.BIGINT)
	signUpStatusId: number

	@BelongsTo(() => SignUpStatus)
	status: SignUpStatus;

	@Column(DataType.DATE)
	createdAt: Date;

	@ForeignKey(() => User)
	@Column(DataType.BIGINT)
	updatedBy: number;

	@BelongsTo(() => User)
	user: User;
}
