'use strict';
import {
	Table,
	Column,
	PrimaryKey,
	Model,
	AutoIncrement,
	DataType,
	AllowNull,
	ForeignKey,
	BelongsTo
} from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tbluseraccesspermission' } as IDefineOptions;
import { User } from './User.entity';
import { AccessPermission } from './AccessPermission.entity';

@Table(tableOptions)
export class UserAccessPermission extends Model<UserAccessPermission>{

	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	useraccesspermissionid: number

	@ForeignKey(() => User)
	@Column(DataType.BIGINT)
	userid: number

	@BelongsTo(() => User)
	user: User;

	@ForeignKey(() => AccessPermission)
	@Column(DataType.BIGINT)
	accesspermissionid: number

	@BelongsTo(() => AccessPermission)
	AccessPermission: AccessPermission;

	@Column(DataType.DATE)
	deletedat: Date;

	@Column(DataType.DATE)
	createdat: Date;
}
