'use strict';

import { Table, Column, Model, DataType, ForeignKey, BelongsTo, BeforeCreate, BeforeUpdate, AutoIncrement, PrimaryKey, AllowNull } from 'sequelize-typescript';
import { User } from './User.entity';
import { Role } from './Role.entity';
import { ApiProperty } from '@nestjs/swagger';
import { UUIDV4 } from 'sequelize/types';
var Sequelize = require('sequelize');

@Table({
	tableName: "tblUserRole"
})
export class UserRole extends Model<UserRole>{
	
	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	userRoleId: number
	// @Column({
	// 	type: DataType.BIGINT,
	// 	allowNull: false,
	// 	// defaultValue:UUIDV4,//autoIncrement: true,
	// 	unique: true,
	// 	primaryKey: true,
	// })
	// @ApiProperty()


	@ForeignKey(() => User)
	@Column(DataType.BIGINT)
	userId: number

	@BelongsTo(() => User)
	user: User;

	@ForeignKey(() => Role)
	@Column(DataType.BIGINT)
	roleId: number

	@BelongsTo(() => Role)
	role: Role;

	@Column(DataType.DATE)
	createdAt: Date;

	@Column(DataType.DATE)
	updatedAt: Date;

	@BeforeCreate 
	@BeforeUpdate 
	public static async dateUpdate(userRole: UserRole, options: any) { 
		userRole.updatedAt = Sequelize.fn('NOW'); 
	}
}
