'use strict';
import { Contact } from '../models/Contact.entity';
import { ContactProductCategory } from './../models/ContactProductCategory.entity';
import { ContactProductGroup } from './../models/ContactProductGroup.entity';
import { ContactInterestedProductCategory } from './../models/ContactInterestedProductCategory.entity';
import { ContactInterestedProductGroup } from './../models/ContactInterestedProductGroup.entity';
import { ContactSocialLink } from './../models/ContactSocialLink.entity';
import { ChannelContactSuggestion } from '../../channel/models/ChannelContactSuggestion.entity';
import { ReferenceContact } from './../models/ReferenceContact.entity';
import { InterestedProductGroup } from '../models/InterestedProductGroup.entity';
import { InterestedProductCategory } from '../models/InterestedProductCategory.entity';

export const ContactProviders = [
	{
		provide: 'ContactRepository',
		useValue: Contact,
	},
];

export const ReferenceContactProviders = [
	{
		provide: 'ReferenceContactRepository',
		useValue: ReferenceContact,
	},
];

export const ContactProductCategoryProvider = [
	{
		provide: 'ContactProductCategoryRepository',
		useValue: ContactProductCategory
	}
];

export const ContactProductGroupProvider = [
	{
		provide: 'ContactProductGroupRepository',
		useValue: ContactProductGroup
	}
];

export const ContactInterestedProductCategoryProvider = [
	{
		provide: 'ContactInterestedProductCategoryRepository',
		useValue: ContactInterestedProductCategory
	}
];

export const InterestedProductCategoryProvider = [
	{
		provide: 'InterestedProductCategoryRepository',
		useValue: InterestedProductCategory
	}
];


export const ContactInterestedProductGroupProvider = [
	{
		provide: 'ContactInterestedProductGroupRepository',
		useValue: ContactInterestedProductGroup
	}
];

export const InterestedProductGroupProvider = [
	{
		provide: 'InterestedProductGroupRepository',
		useValue: InterestedProductGroup
	}
];




export const ContactSocialLinkProvider = [
	{
		provide: 'ContactSocialLinkRepository',
		useValue: ContactSocialLink
	}
];

export const ContactSuggestionProvider = [
	{
		provide: 'ContactSuggestionRepository',
		useValue: ChannelContactSuggestion
	}
];
