'use strict';

import { User } from '../models/User.entity';
import { AdminUsers } from '../../admin/models/AdminUsers.entity';
import { Contact } from '../models/Contact.entity';
import { Channel } from '../../channel/models/Channel.entity';
import { AdminUserAccess } from 'src/modules/admin/models/AdminUserAccess.entity';
import { Media } from '../../media/models/Media.entity';
import { ContactLocation } from '../models/ContactLocation.entity';

export const UserProviders = [
	{
		provide: 'UserRepository',
		useValue: User,
	},	
	{
		provide: 'AdminUserRepository',
		useValue: AdminUsers,
	},
	{
		provide: 'AdminUserAccessRepository',
		useValue: AdminUserAccess,
	},
	{
		provide: 'ContactRepository',
		useValue: Contact,
	},
	{
		provide: 'ChannelRepository',
		useValue: Channel,
	},
	{
		provide: 'MediaRepository',
		useValue: Media,
	},
	{
		provide: 'ContactLocationRepository',
		useValue: ContactLocation,
  },
];
