import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, Scopes } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';



const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblWalletUsageType' } as IDefineOptions;

@Table(tableOptions)

@Scopes({
  channelTypeInfom: {
    attributes: ['usedFor', 'isActive']
  }
})


export class WalletUsageType extends Model<WalletUsageType>{

  @PrimaryKey
  @AutoIncrement
  @AllowNull(false)
  @Column(DataType.BIGINT)
  walletUsageTypeId: number

  @AllowNull(false)
  @Column(DataType.CHAR(255))
  usedFor: string

  @Column
  isActive: string;

}