import { Module } from '@nestjs/common';
import { walletRechargeController } from './controller/walletRecharge.controller';
import { OtherPaymentProviders , UserWalletAmountProviders, WalletTransactionProviders, WalletUsageTypeProviders } from './provider/walletRecharge.providers';
import { walletRechargeService } from './service/walletRecharge.service';
@Module({
  controllers:[walletRechargeController],
    providers:[
        ...OtherPaymentProviders,
        ...UserWalletAmountProviders,
        ...WalletTransactionProviders,
        ...WalletUsageTypeProviders,
        walletRechargeService
    ],
    exports: [
		    ...OtherPaymentProviders,
        ...UserWalletAmountProviders,
        ...WalletTransactionProviders,
        ...WalletUsageTypeProviders
	]
})
export class WalletRechargeModule {

}
