'use strict';

import { ContextService } from './../../../context/context.service';
import { Controller, Post, HttpStatus, UseGuards, Res, Req, Body } from '@nestjs/common';
import { ValidationPipe } from './../../../middleware/pipe/validation.pipe';
import { WishlistService } from './../service/wishlist.service';
import { GroupDto } from '../dto/group.dto';
import { AuthGuard } from '@nestjs/passport';
import { BaseController } from 'src/core/controller/base.controller';

@UseGuards(AuthGuard('jwt'))
@Controller('favorite')
export class ChannelgroupController extends BaseController {
	constructor(
		private wishlistService: WishlistService
	) {
		super();
	}
	@Post('channelgroup/group')
	async addChannelGroup(@Req() req, @Res() res, @Body(new ValidationPipe()) group: GroupDto) {
		let user = req.user;
		await this.wishlistService.createChannelGroup({
			userId: +user.userId,
			channelId: +user.channelId,
			groupName: group.groupName			
		}, user);
		res.status(HttpStatus.CREATED).json({
			"status": true
		});
	}
}
