'use strict';

import { IsEnum, IsNotEmpty, MaxLength, IsString, IsOptional, IsInt, IsBoolean } from 'class-validator';

export class ProductDto {

	@IsOptional() 
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsInt({ message: "validate:field:shouldBeInt" })
	readonly id: number;

	@IsOptional() 
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsEnum([
		'WISHLIST',
		'BUSINESS',
		'EVALVATED',
		'CHANNEL'
	], { message: "Field 'type' should be any one from this list(WISHLIST)" })
	readonly type: string;

	@IsOptional() 
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsInt({ message: "validate:field:shouldBeInt" })
	readonly channelgroupid: number;

	@IsOptional() 
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsInt({ message: "validate:field:shouldBeInt" })
	readonly channelid: number;

	@IsOptional() 
	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsBoolean({ message: "validate:field:shouldBeBoolean" })
	readonly list_type: boolean;

}
