'use strict';

import { IsEnum, IsNotEmpty, IsInt } from 'class-validator';

export class ProductMoveDto {

	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsInt({ message: "validate:field:shouldBeInt" })
	readonly id: number;

	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsEnum([
		// 'WISHLIST',
		// 'BUSINESS',
		'EVALVATED'
	], { message: "Field 'type' should be any one from this list(EVALVATED)" })
	readonly from_type: string;

	@IsNotEmpty({ message: "validate:field:shouldNotEmpty" })
	@IsEnum([
		// 'WISHLIST',
		'BUSINESS',
		// 'EVALVATED'
	], { message: "Field 'type' should be any one from this list(BUSINESS)" })
	readonly to_type: string;

}
