'use strict';

import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, ForeignKey, BelongsTo } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Channel } from '../../channel/models/Channel.entity';

const tableOptions: IDefineOptions = { timestamp: true, tableName: 'tblChannelGroup' } as IDefineOptions;
@Table(tableOptions)
export class Channelgroup extends Model<Channelgroup>
{
	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	channelGroupId: number
	
	@ForeignKey(() => Channel)
	@Column(DataType.BIGINT)
	channelId: number

	@BelongsTo(() => Channel)
	channel: Channel;

	@Column(DataType.BIGINT)
    userId: number
    
    @Column(DataType.CHAR(255))
	channelName: string

	@Column(DataType.DATE)
    deletedAt: Date;  

	@AllowNull(false)
	@Column(DataType.DATE)
    createdAt: Date;
    
    @Column(DataType.DATE)
	updatedAt: Date;
}
