'use strict';

import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, ForeignKey, BelongsTo } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { Product } from '../../product/models/Product.entity';
import { Channelgroup } from '../models/Channelgroup.entity';
const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblproductwishlist' } as IDefineOptions;

@Table(tableOptions)
export class Wishlist extends Model<Wishlist>
{
	@PrimaryKey
	@AutoIncrement
	@AllowNull(false)
	@Column(DataType.BIGINT)
	productwishlistid: number

	@AllowNull(false)
	@Column(DataType.ENUM('WISHLIST', 'BUSINESS', 'EVALVATED','CHANNEL'))
	type: string

	@ForeignKey(() => Product)
	@Column(DataType.BIGINT)
	productid: number

	@BelongsTo(() => Product)
	product: Product;

	@Column(DataType.BIGINT)
	channelid: number

	@Column(DataType.BIGINT)
	userid: number

	@ForeignKey(() => Channelgroup)
	@Column(DataType.BIGINT)
	channelgroupid: number

	@BelongsTo(() => Channelgroup, 'channelGroupId')
	channelgroup: Channelgroup;


	@Column(DataType.DATE)
	deletedat: Date;

	@AllowNull(false)
	@Column(DataType.DATE)
	createdat: Date;
}
