'use strict';

import { Module, RequestMethod } from '@nestjs/common';
import { ProductModule } from './../product/product.module';
import { IndexController } from './controller/index.controller';
import { ChannelgroupController } from './controller/channelgroup.controller';
import { wishlistProvider, channelGroupProvider } from './provider/wishlist.provider';
import { WishlistService } from './service/wishlist.service';
import { NotificationModule } from '../notification/notification.module';
import { DatabaseModule } from 'src/core/database/database.module';
import { productAwardProvider, productImageProvider } from '../product/provider/product.providers';
import { MediaProviders } from '../media/providers/media.provider';

@Module({
	imports: [
		ProductModule,
		DatabaseModule,
		NotificationModule
	],
	controllers: [
		IndexController,
		ChannelgroupController
	],
	providers: [
		...wishlistProvider,
		...channelGroupProvider,
		...productImageProvider,
		...MediaProviders,
		...productAwardProvider,
		WishlistService
	]
})
export class WishlistModule {}
