"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChannelService = void 0;
const common_1 = require("@nestjs/common");
const sequelize_1 = require("sequelize");
const app_constant_1 = require("../../../config/app.constant");
const Auth_exception_1 = require("../../../middleware/exception/Auth.exception");
const Country_entity_1 = require("../../common/models/Country.entity");
const RegionCountryJCT_entity_1 = require("../../common/models/RegionCountryJCT.entity");
const Media_entity_1 = require("../../media/models/Media.entity");
const SampleOrder_entity_1 = require("../../order/models/SampleOrder.entity");
const Brand_entity_1 = require("../../product/models/Brand.entity");
const Product_entity_1 = require("../../product/models/Product.entity");
const ProductCategory_entity_1 = require("../../product/models/ProductCategory.entity");
const ProductEvaluation_entity_1 = require("../../product/models/ProductEvaluation.entity");
const ProductGroup_entity_1 = require("../../product/models/ProductGroup.entity");
const ContactSocialLink_entity_1 = require("../../user/models/ContactSocialLink.entity");
const Role_entity_1 = require("../../user/models/Role.entity");
const SignUpStatus_entity_1 = require("../../user/models/SignUpStatus.entity");
const User_entity_1 = require("../../user/models/User.entity");
const UserRole_entity_1 = require("../../user/models/UserRole.entity");
const utility_1 = require("../helper/utility");
const Channel_entity_1 = require("../models/Channel.entity");
const ChannelAward_entity_1 = require("../models/ChannelAward.entity");
const ProfileType_entity_1 = require("../models/ProfileType.entity");
const SocialSite_entity_1 = require("../models/SocialSite.entity");
const SubscriptionPlan_entity_1 = require("../models/SubscriptionPlan.entity");
const ChannelDetail_entity_1 = require("../models/ChannelDetail.entity");
const channelHubDetailOutBound_1 = require("../transformation/channelHubDetailOutBound");
const channelKeyPartner_service_1 = require("./channelKeyPartner.service");
const context_service_1 = require("../../../context/context.service");
const lodash_1 = require("lodash");
const Contact_entity_1 = require("../../user/models/Contact.entity");
const IProductSerivceOutBound_1 = require("../../product/transformation/interface/IProductSerivceOutBound");
const Region_entity_1 = require("../../common/models/Region.entity");
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
const Address_entity_1 = require("../models/Address.entity");
const Dashboard_entity_1 = require("../models/Dashboard.entity");
const ChannelB2B_entity_1 = require("../models/ChannelB2B.entity");
const EventParticipants_entity_1 = require("../models/EventParticipants.entity");
const EventBo_entity_1 = require("../models/EventBo.entity");
const EventPackage_entity_1 = require("../models/EventPackage.entity");
const EventChannel_entity_1 = require("../models/EventChannel.entity");
var _ = require('lodash');
let ChannelService = class ChannelService {
    constructor(sequelizeInstance, channelRepository, signUpStatusRepository, channelTypeRepository, productGroupRepository, productCategoryRepository, profileTypeRepository, contactJCTRepository, subscriptionRepository, mediaRepository, channelCertificateTypeRepository, productRepository, sharetypeRepository, channelCustomerProfileRepository, profileTypeClassificationRepository, brandRepository, contactRepository, channelKeyPartnerService, companyMediaImagesRepository, countryRepository) {
        this.sequelizeInstance = sequelizeInstance;
        this.channelRepository = channelRepository;
        this.signUpStatusRepository = signUpStatusRepository;
        this.channelTypeRepository = channelTypeRepository;
        this.productGroupRepository = productGroupRepository;
        this.productCategoryRepository = productCategoryRepository;
        this.profileTypeRepository = profileTypeRepository;
        this.contactJCTRepository = contactJCTRepository;
        this.subscriptionRepository = subscriptionRepository;
        this.mediaRepository = mediaRepository;
        this.channelCertificateTypeRepository = channelCertificateTypeRepository;
        this.productRepository = productRepository;
        this.sharetypeRepository = sharetypeRepository;
        this.channelCustomerProfileRepository = channelCustomerProfileRepository;
        this.profileTypeClassificationRepository = profileTypeClassificationRepository;
        this.brandRepository = brandRepository;
        this.contactRepository = contactRepository;
        this.channelKeyPartnerService = channelKeyPartnerService;
        this.companyMediaImagesRepository = companyMediaImagesRepository;
        this.countryRepository = countryRepository;
        this.channelHubDetailOutBound = new channelHubDetailOutBound_1.ChannelHubDetailOutBound();
    }
    async getTopCompany(keyword, typeId, btype) {
        let type = [];
        if (typeId == 2 && btype == 1)
            type = [3, 4];
        else if (typeId == 3 && btype == 2)
            type = [3, 5];
        else if (typeId == 2 && btype == 3)
            type = [3, 4, 5];
        else if (typeId == 3 || typeId == 4 || typeId == 5)
            type = [2];
        let query = 'select "channelId","companyName","channelTypeId" from "tblChannel" where "channelTypeId" in (:typeId) and unaccent("companyName") ILike :search and "deletedAt" is null and "isActive"=\'1\' ';
        let company = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                search: '' + keyword + '%',
                typeId: type,
            }
        });
        query = 'select "productId","product","productSKU" from "tblProduct" where unaccent("product") ILike :search and "deletedat" is null and "isactive"=\'1\' limit 4 ';
        let product = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                search: '' + keyword + '%',
            }
        });
        let result = {
            company: company,
            product: product,
            type: +typeId,
            btype: +btype
        };
        return result;
    }
    async getTopProduct(keyword) {
        let query = 'select "productId","product" from "tblProduct" where unaccent("companyName") ILike :search limit 4 ';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                search: '' + keyword + '%',
            }
        });
        return result;
    }
    async getSearchList(viewId, planId, data, userData) {
        let user = userData;
        let channelFilter = data.filter;
        let contactId = user.contactId;
        let channelId = user.channelId;
        let typeid = user.channelTypeId;
        let businessType = user.businessType;
        let userId = user.userId;
        let filterch = [];
        let channeltype = [];
        let aggregation = {};
        let channelquery;
        console.log("productId:", channelFilter.productId);
        if (typeid == 2 && businessType == 1)
            channeltype = [3, 4];
        else if (typeid == 2 && businessType == 2)
            channeltype = [3, 5];
        else if (typeid == 2 && businessType == 3)
            channeltype = [3, 4, 5];
        else if (typeid == 3)
            channeltype = [2];
        else if (typeid == 4)
            channeltype = [2];
        else if (typeid == 5)
            channeltype = [2];
        let order = data.order;
        if (viewId == 1 || (channelFilter.connectionStatusId && channelFilter.connectionStatusId == 1)) {
            channelquery = 'select "matchingScore","connectionStatusTypeId" as relation_status,\'Confirm\' as status,"channelJCTId" as channeljct,"transToContact","note",(select "documentPath" from "tblDocument" where "documentId"="introVideo") as "introVideo" ,"isConfidential",case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id,case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end as contact_id from "tblChannelJCT" where "connectionStatusTypeId"=2 and case when "requested_by"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" '
                + ' where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) '
                + ' when "requested_to"=' + contactId + ' then "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6))  end and "deletedat" is null order by "updatedAt" ' + data.order + '  ';
        }
        else if (viewId == 2 || (channelFilter.connectionStatusId && channelFilter.connectionStatusId == 2)) {
            channelquery = 'select "matchingScore","connectionStatusTypeId" as relation_status,\'OUT\' as status,"channelJCTId" as channeljct,"transToContact","note",(select "documentPath" from "tblDocument" where "documentId"="introVideo") as "introVideo" ,"isConfidential",case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id,case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end as contact_id from "tblChannelJCT"  where "connectionStatusTypeId" in(7,11) and case when "requested_to"=' + contactId + ' and "connectionStatusTypeId"=11 then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) when "requested_by"=' + contactId + ' and "connectionStatusTypeId"=7 then "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6))  end and "deletedat" is null order by "updatedAt" ' + data.order + ' ';
        }
        else if (viewId == 3 || (channelFilter.connectionStatusId && channelFilter.connectionStatusId == 3)) {
            channelquery = 'select "matchingScore","connectionStatusTypeId" as relation_status,\'IN\' as status,"channelJCTId" as channeljct,"transToContact","note",(select "documentPath" from "tblDocument" where "documentId"="introVideo") as "introVideo" ,"isConfidential",case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id,case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end as contact_id from "tblChannelJCT" where "connectionStatusTypeId" in(7,10) '
                + ' and case when "requested_to"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15  and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) end and "deletedat" is null order by "updatedAt" ' + data.order + ' ';
        }
        else if (viewId == 4) {
            channelquery = 'select "matchingScore","connectionStatusTypeId" as relation_status,\'RequestIntro\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential",case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id,case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end as contact_id,"updatedAt" from "tblChannelJCT" where "connectionStatusTypeId"=10 and "partnerChannelId" not in(select "partnerChannelId" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "deletedat" is null and "requested_by"=' + contactId + ' and "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') union all select "connectionStatusTypeId" as relation_status,\'RequestIntro\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential",case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id,case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end as contact_id,"updatedAt"  from "tblChannelJCT" where "connectionStatusTypeId"=11 and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "deletedat" is null and "requested_to"=' + contactId + ' and "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') order by "updatedAt" ' + data.order + '  ';
        }
        else if (viewId == 5) {
            channelquery = 'select "matchingScore","connectionStatusTypeId" as relation_status,\'Savelater\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential",case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id,case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end as contact_id from "tblChannelJCT" where "connectionStatusTypeId"=11 and case when "requested_by"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) end and "deletedat" is null order by "updatedAt" ' + data.order + ' ';
        }
        else if (viewId == 6 || (channelFilter.connectionStatusId && channelFilter.connectionStatusId == 6)) {
            channelquery = 'select "matchingScore","connectionStatusTypeId" as relation_status,\'Suggestion\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential","channelId" as channel_id,"requested_by" as contact_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) order by "updatedAt" ' + data.order + ' ';
        }
        else if (viewId == 8) {
            channelquery = 'select "matchingScore","connectionStatusTypeId" as relation_status,\'Suggestion\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential","channelId" as channel_id,"requested_by" as contact_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(2) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) order by "matchingScore" desc ';
        }
        else if (viewId == 9) {
            channelquery = 'select "matchingScore","connectionStatusTypeId" as relation_status,\'Suggestion\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential","channelId" as channel_id,"requested_by" as contact_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(3) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) order by "matchingScore" asc ';
        }
        else if (viewId == 10) {
            channelquery = 'select "matchingScore","connectionStatusTypeId" as relation_status,\'Suggestion\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential","channelId" as channel_id,"requested_by" as contact_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(4) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) order by "rank" asc ';
        }
        else if (viewId == 14) {
            channelquery = 'select "matchingScore","connectionStatusTypeId" as relation_status,\'Suggestion\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential","channelId" as channel_id,"requested_by" as contact_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(5) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) order by "rank" asc ';
        }
        else if (viewId == 30) {
            channelquery = 'select "matchingScore","connectionStatusTypeId" as relation_status,\'Confirm\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential",case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id,case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end as contact_id,"updatedAt" from "tblChannelJCT" where "connectionStatusTypeId"=2 and case when "requested_to"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" '
                + ' where  "channelTypeId" in(:channelTypeId) and "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) '
                + ' when "requested_by"=' + contactId + ' then "partnerChannelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6))  end and "deletedat" is null'
                + ' union all'
                + ' select "matchingScore","connectionStatusTypeId" as relation_status,\'Outbound\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential",case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id,case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end as contact_id,"updatedAt" from "tblChannelJCT"  where "connectionStatusTypeId" in(7,11) and case when "requested_to"=' + contactId + ' and "connectionStatusTypeId"=11 then "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) when "requested_by"=' + contactId + ' and "connectionStatusTypeId"=7 then "partnerChannelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6))  end and "deletedat" is null '
                + ' union all'
                + ' select "matchingScore","connectionStatusTypeId" as relation_status,\'Inbound\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential",case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id,case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end as contact_id,"updatedAt" from "tblChannelJCT" where "connectionStatusTypeId" in(7,10) '
                + ' and case when "requested_to"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "deletedAt" is null and "signUpStatusId" = 15  and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) end and "deletedat" is null  '
                + ' union all'
                + ' select "matchingScore","connectionStatusTypeId" as relation_status,\'RequestIntro\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential",case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id,case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end as contact_id,"updatedAt" from "tblChannelJCT" where "connectionStatusTypeId"=10 and "partnerChannelId" not in(select "partnerChannelId" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "deletedat" is null and "requested_by"=' + contactId + ' and "partnerChannelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') union all select "matchingScore","connectionStatusTypeId" as relation_status,\'RequestIntro\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential",case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id,case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end as contact_id,"updatedAt"  from "tblChannelJCT" where "connectionStatusTypeId"=11 and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "deletedat" is null and "requested_to"=' + contactId + ' and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\')  '
                + ' union all'
                + ' select "matchingScore","connectionStatusTypeId" as relation_status,\'Savelater\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential",case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id,case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end as contact_id,"updatedAt" from "tblChannelJCT" where "connectionStatusTypeId"=11 and case when "requested_by"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) end and "deletedat" is null'
                + ' union all'
                + ' select "matchingScore","connectionStatusTypeId" as relation_status,\'Suggestion\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential","channelId" as channel_id,"requested_by" as contact_id,"updatedAt" from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)'
                + ' union all'
                + ' select CAST( null AS bigint) as "matchingScore",CAST( null AS bigint) as relation_status,\'NonSuggestion\' as status,CAST( null AS bigint) as channeljct,CAST( null AS bigint) as "transToContact",CAST( null AS text) as "note",CAST( null AS bigint) as "introVideo",CAST( null AS bit) as "isConfidential",tc."channelId" as channel_id,CAST( null AS bigint)as contact_id,tc."updatedAt" from "tblChannel" as tc inner join "tblContact" as con on con."channelId"=tc."channelId" and con."isActive"=\'1\' and con."deletedAt" is null and con."contactId" not in(select case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end from "tblChannelJCT" as jct where ("requested_by"=' + contactId + ' or "requested_to"=' + contactId + ') and "connectionStatusTypeId" in(5,6,2,7,10,11,1)) where "signUpStatusId"=15 and  "channelTypeId" not in(6) and tc."isActive"=\'1\' and tc."deletedAt" is null and "channelTypeId" in(:channelTypeId) and tc."channelId" not in(select case when "dismissedBy"=' + channelId + ' then "dismissedChId" when "dismissedChId"=' + channelId + ' then "dismissedBy" end from "tblchanneldismissreason" where "dismissedBy"=' + channelId + ' or ("dismissedChId"=' + channelId + ' and "dismissedBy"=tc."channelId")) ';
        }
        let result = await this.sequelizeInstance.query(channelquery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                search: '%' + data.search + '%',
                channelTypeId: channeltype
            }
        }).then(x => {
            if (viewId == 3 || viewId == 1 || viewId == 2)
                return x;
            else
                return _.uniqBy(x, 'channel_id');
        });
        if (data.search) {
            let searchchannellist = await this.sequelizeInstance.query('select "channelId" as channel_id from "tblChannel" where "companyName" ILIKE :search', {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    search: '%' + data.search + '%',
                }
            });
            let chl = searchchannellist.map(x => x.channel_id);
            result = result.filter(ch => { return chl.includes(ch.channel_id); });
        }
        if (channelFilter.typeId && result.length > 0) {
            let chlist = result.map(x => +x.channel_id);
            let ctype = 'select array_agg("channelId") as ch from "tblChannel" where "channelTypeId" in(:channeltypeid) and "channelId" in(:channelid)';
            await this.sequelizeInstance.query(ctype, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelid: chlist,
                    channeltypeid: +channelFilter.typeId
                }
            }).then((result) => {
                if (result[0].ch)
                    filterch.push(...result[0].ch);
            });
            result = result.filter(ch => { return filterch.includes(ch.channel_id); });
        }
        if ((channelFilter.storeCount || channelFilter.turnOver || channelFilter.brandId || channelFilter.locationId || channelFilter.countryId || channelFilter.specialityId || channelFilter.intProductId || channelFilter.productId || channelFilter.retailerprofileId || channelFilter.resellerprofileId) && result.length > 0) {
            let chlist = result.map(x => +x.channel_id);
            if (channelFilter.turnOver) {
                let query;
                if (channelFilter.turnOver == '<1M€') {
                    query = 'select array_agg("channelId") as ch from "tblChannelDetail" where "channelId" in(:channelid) and case when "turnoverRange"=\'<1M€\' or cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)<1 or "turnover"<1 then cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)<1 or "turnoverRange"=\'<1M€\' or "turnover"<1 end';
                }
                else if (channelFilter.turnOver == '1-10M€') {
                    query = 'select  array_agg("channelId") as ch from "tblChannelDetail" where "channelId" in(:channelid) and case when "turnoverRange"=\'1-10M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\'))as int)>1 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<10) or ("turnover">1 and "turnover"<10) then "turnoverRange"=\'1-10M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\'))as int)>1 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<10) or ("turnover">1 and "turnover"<10) end';
                }
                else if (channelFilter.turnOver == '10-100M€') {
                    query = 'select  array_agg("channelId") as ch from "tblChannelDetail" where "channelId" in(:channelid) and "turnoverRange"!=\'>100M€\' and case when "turnoverRange"=\'10-100M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\')) as int)>10 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<=100) or ("turnover">10 and "turnover"<=100) then "turnoverRange"=\'10-100M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\')) as int)>10 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<=100) or ("turnover">10 and "turnover"<=100) end';
                }
                else if (channelFilter.turnOver == '>100M€') {
                    query = 'select array_agg("channelId") as ch from "tblChannelDetail" where "channelId" in(:channelid) and case when "turnoverRange"=\'>100M€\' or cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)>100 or "turnover">100 then cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)>100 or "turnoverRange"=\'>100M€\' or "turnover">100 end';
                }
                await this.sequelizeInstance.query(query, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.storeCount) {
                let store;
                if (channelFilter.storeCount == '5')
                    store = 'select array_agg("channelId") as ch from "tblChannelDetail" where "channelId" in(:channelid) and ("physicalSales"<=5 or "physicalSales" is null)';
                else
                    store = 'select array_agg("channelId") as ch from "tblChannelDetail" where "channelId" in(:channelid) and "physicalSales">:count';
                await this.sequelizeInstance.query(store, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        count: +channelFilter.storeCount
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.brandId) {
                let brand = 'select array_agg("channelId") as ch from "tblChannelBrand" where "brandId" in(:brandid) and "channelId" in(:channelid)';
                await this.sequelizeInstance.query(brand, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist,
                        brandid: channelFilter.brandId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.productId) {
                await this.sequelizeInstance.query('select array_agg("channelId") as ch from "tblChannelProductCategorie" cpc where cpc."productCategorieId" in(:productcatid) and "channelId" in(:channelid) ', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        productcatid: channelFilter.productId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.intProductId) {
                await this.sequelizeInstance.query('select array_agg("channelId") as ch from "tblInterestedProductCategory" cpc where cpc."productCategorieId" in(:productcatid) and "contactId" in(:contactid) and "channelId" in(:channelid) ', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        contactid: result.map(x => +x.contact_id),
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        productcatid: channelFilter.intProductId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.retailerprofileId || channelFilter.resellerprofileId) {
                let query;
                let ids = channelFilter.retailerprofileId ? channelFilter.retailerprofileId : channelFilter.resellerprofileId;
                if (viewId == 8 || viewId == 9)
                    query = 'select array_agg("channelId") as ch from "tblChannelCustomerProfile" as ccp where "profileTypeId" in(:retailprofileid) and "channelId" in(:channelid) and ccp."profileTypeId" in(select "profileTypeId" from "tblProfileTypeClassification" where ("channelTypeId" in(3,4) and ccp."channelId" in(select "channelId" from "tblChannel" where "channelId"=ccp."channelId" and "isOEM"=\'1\')) or '
                        + '("channelTypeId" in(3,5) and ccp."channelId" in(select "channelId" from "tblChannel" where "channelId"=ccp."channelId" and "isOEM"=\'2\')) or'
                        + '("channelTypeId" in(3,4,5) and ccp."channelId" in(select "channelId" from "tblChannel" where "channelId"=ccp."channelId" and "isOEM"=\'3\')))';
                if (viewId == 10 || viewId == 14)
                    query = 'select array_agg("channelId") as ch from "tblChannel" where "profileTypeId" in(:retailprofileid) and "channelId" in(:channelid)';
                await this.sequelizeInstance.query(query, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        retailprofileid: (channelFilter.retailerprofileId && channelFilter.resellerprofileId) ? channelFilter.resellerprofileId.concat(channelFilter.retailerprofileId) : ids
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.countryId) {
                await this.sequelizeInstance.query('select array_agg("channelId") as ch from "tblChannel" where "countryId" in(:countryid) and "channelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        countryid: channelFilter.countryId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.specialityId) {
                await this.sequelizeInstance.query('select array_agg(distinct "channelId") as ch from "tblContact" where "contactId" in(Select "contactId" from "tblContactInterestedProductCategory" where "productCategorieId" in(:specialityid)) and "channelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        specialityid: channelFilter.specialityId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.locationId) {
                let locationType = user.channelTypeId == 2 ? 'SELLING' : 'TARGET';
                let query = 'select array_agg("channelId") as ch  from "tblChannelLocation" where "locationType"=:locationType and "channelId" in(:channelid) and "deletedAt" is null and'
                    + '"regionCountryJCTId" in(select "regionCountryJCTId" from "tblRegionCountryJCT" where "countryId" in (:locationid)) ';
                await this.sequelizeInstance.query(query, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        locationType: locationType,
                        locationid: channelFilter.locationId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            result = result.filter(ch => { return filterch.includes(ch.channel_id); });
        }
        let total = result ? result.length : 0;
        let final = [];
        let master = [];
        if (result.length > 0) {
            let ordered = await this.channelRepository.findAll({
                type: sequelize_1.QueryTypes.SELECT,
                attributes: ['channelId'],
                raw: true,
                where: {
                    channelId: result.map(x => x.channel_id)
                },
                order: [['companyName', data.order]]
            }).then(res => {
                return res.map(x => x.channelId);
            });
            result.sort(function (a, b) {
                return ordered.indexOf(a) - ordered.indexOf(b);
            });
            result = await this.mapOrder(result, ordered, 'channel_id');
            result.sort((a, b) => b.matchingScore - a.matchingScore);
            master = result.map(x => +x.channel_id);
            if (viewId == 3 || viewId == 1 || viewId == 2) {
                result = result.slice(data.offset).slice(0, data.limit);
            }
            else
                result = result.slice(data.offset).slice(0, data.limit);
            if ((viewId == 3 || viewId == 1 || viewId == 2) && result.length > 0) {
                let clist = await this.getConnectedContactsList(result);
                let resultformat = {
                    results: clist,
                    master: master,
                    aggregation: aggregation,
                    total: total
                };
                return resultformat;
            }
            else if ((viewId == 3 || viewId == 1 || viewId == 2) && result.length == 0) {
                let resultformat = {
                    results: [],
                    master: [],
                    aggregation: aggregation,
                    total: 0
                };
                return resultformat;
            }
            else {
                for (let i = 0; i < result.length; i++) {
                    let status = result[i].status;
                    let companyquery;
                    try {
                        if (result[i].channeljct != null) {
                            companyquery = 'Select ' + result[i].matchingScore + ' as matchingScore,' + result[i].relation_status + ' as relation_status,:status as status,' + result[i].isConfidential + ' as isConfidential,' + result[i].channeljct + ' as channel_jct_id,' + result[i].transToContact + ' as transToContact,:note as note,ch."channelId" as cid,ch."companyName" as companyname,ch."countryId" as countryid, tc."country" as country, tc."isoCode", (select "profileType" from "tblProfileType" where "profileTypeId"=ch."profileTypeId"), cht."channelType" as channeltype,ch."channelTypeId" as channeltypeid,'
                                + 'chd."detailDesc" as detaildesc, chd."webSiteUrl" as websiteurl,chd."startup",chd."expectations" as sourcing,(select array_to_json(array_agg(row_to_json(a))) from (select SUBSTRING ( cast(chd."maturitylevel" as TEXT) ,2 , length(cast(chd."maturitylevel" as TEXT))-2) as item_name)a) as looking_startups, '
                                + '(select doc."documentPath" from "tblDocument" as doc  where doc."documentId"=' + result[i].introVideo + ' ) as introvideo, '
                                + '(select distinct channelgroupid as favorite from "tblproductwishlist" fav where fav."userid"=' + userId + ' and fav."channelid"=ch."channelId" and "productid" is null and "deletedat" is null fetch first row only), '
                                + '(Select td."documentPath" as logo from "tblChannelDetail" chd inner join "tblDocument" td on td."documentId" in(chd."channelLogoId") where chd."channelId"=ch."channelId"), '
                                + '(select array_to_json(array_agg(row_to_json(c))) from (Select td."documentPath",con."isDefaultContact",con."firstName",con."lastName",con."jobTitle" from "tblContact" con left join "tblDocument" td on td."documentId" in(con."documentId") where con."channelId"=ch."channelId")c)as contacts, '
                                + '(select array_to_json(array_agg(row_to_json(x))) from (Select pc."productCategorie" as item_name from "tblChannelProductCategorie" cpc inner join "tblProductCategories" pc on pc."productCategorieId" = cpc."productCategorieId" where cpc."channelId"=ch."channelId")x) as company_cat, '
                                + '(select array_to_json(array_agg(row_to_json(z))) from (Select pt."profileType" as item_name from "tblProfileType" pt where "profileTypeId" in (select "profileTypeId" from "tblChannelCustomerProfile" as ccp where ccp."channelId"=ch."channelId" and "profileTypeId" in(select "profileTypeId" from '
                                + '"tblProfileTypeClassification" where ("channelTypeId" in(3,4) and ccp."channelId" in(select "channelId" from "tblChannel" where "channelId"=ch."channelId" and "isOEM"=\'1\')) or '
                                + '("channelTypeId" in(3,5) and ccp."channelId" in(select "channelId" from "tblChannel" where "channelId"=ch."channelId" and "isOEM"=\'2\')) or '
                                + '("channelTypeId" in(3,4,5) and ccp."channelId" in(select "channelId" from "tblChannel" where "channelId"=ch."channelId" and "isOEM"=\'3\')))	))z) as retail_customer_profile '
                                + 'from "tblChannel" ch inner join "tblChannelDetail" chd on chd."channelId" = ch."channelId" inner join "tblCountry" tc on tc."countryId" = ch."countryId" '
                                + 'inner join "tblChannelType"cht on cht."channelTypeId" = ch."channelTypeId" where ch."channelId" in(:channelid)';
                        }
                        else {
                            companyquery = 'Select ' + result[i].matchingScore + ' as matchingScore,' + result[i].relation_status + ' as relation_status,:status as status,' + result[i].isConfidential + ' as isConfidential,' + result[i].channeljct + ' as channel_jct_id,' + result[i].transToContact + ' as transToContact,:note as note,ch."channelId" as cid,case when chd."turnover" is null then chd."turnoverRange" when chd."turnover" is not null then cast(chd."turnover" as text) end as turnover,ch."companyName" as companyname,ch."countryId" as countryid, tc."country" as country, tc."isoCode", (select "profileType" from "tblProfileType" where "profileTypeId"=ch."profileTypeId"), cht."channelType" as channeltype,ch."channelTypeId" as channeltypeid,'
                                + 'chd."detailDesc" as detaildesc, chd."webSiteUrl" as websiteurl, chd."startup",chd."expectations" as sourcing,(select array_to_json(array_agg(row_to_json(a))) from (select SUBSTRING ( cast(chd."maturitylevel" as TEXT) ,2 , length(cast(chd."maturitylevel" as TEXT))-2) as item_name)a) as looking_startups, '
                                + '(select doc."documentPath" from "tblDocument" as doc  where doc."documentId"=' + result[i].introVideo + ' ) as introvideo, '
                                + '(select distinct channelgroupid as favorite from "tblproductwishlist" fav where fav."userid"=' + userId + ' and fav."channelid"=ch."channelId" and "productid" is null and "deletedat" is null fetch first row only), '
                                + '(Select td."documentPath" as logo from "tblChannelDetail" chd inner join "tblDocument" td on td."documentId" in(chd."channelLogoId") where chd."channelId"=ch."channelId"), '
                                + '(select array_to_json(array_agg(row_to_json(c))) from (Select td."documentPath",con."isDefaultContact",con."firstName",con."lastName",con."jobTitle" from "tblContact" con left join "tblDocument" td on td."documentId" in(con."documentId") where con."channelId"=ch."channelId")c)as contacts, '
                                + '(select array_to_json(array_agg(row_to_json(x))) from (Select pc."productCategorie" as item_name from "tblChannelProductCategorie" cpc inner join "tblProductCategories" pc on pc."productCategorieId" = cpc."productCategorieId" where cpc."channelId"=ch."channelId")x) as company_cat, '
                                + '(select array_to_json(array_agg(row_to_json(z))) from (Select pt."profileType" as item_name from "tblProfileType" pt where "profileTypeId" in (select "profileTypeId" from "tblChannelCustomerProfile" as ccp where ccp."channelId"=ch."channelId" and "profileTypeId" in(select "profileTypeId" from '
                                + '"tblProfileTypeClassification" where ("channelTypeId" in(3,4) and ccp."channelId" in(select "channelId" from "tblChannel" where "channelId"=ch."channelId" and "isOEM"=\'1\')) or '
                                + '("channelTypeId" in(3,5) and ccp."channelId" in(select "channelId" from "tblChannel" where "channelId"=ch."channelId" and "isOEM"=\'2\')) or '
                                + '("channelTypeId" in(3,4,5) and ccp."channelId" in(select "channelId" from "tblChannel" where "channelId"=ch."channelId" and "isOEM"=\'3\')))	))z) as retail_customer_profile '
                                + 'from "tblChannel" ch inner join "tblChannelDetail" chd on chd."channelId" = ch."channelId" inner join "tblCountry" tc on tc."countryId" = ch."countryId" '
                                + 'inner join "tblChannelType"cht on cht."channelTypeId" = ch."channelTypeId" where ch."channelId" in(:channelid)';
                        }
                        let res = await this.sequelizeInstance.query(companyquery, {
                            type: sequelize_1.QueryTypes.SELECT,
                            raw: true,
                            replacements: {
                                channelid: result[i].channel_id,
                                contactid: result[i].contact_id,
                                status: result[i].status,
                                note: (result[i].note == '') ? null : result[i].note
                            }
                        });
                        final.push(...res);
                    }
                    catch (e) {
                        console.log("error:", e);
                    }
                }
            }
        }
        else
            result = [];
        final.map(x => {
            let flag = 0;
            if ((x.relation_status == null || x.relation_status == 1) && ((x.isconfidential == 1 && (viewId == 8 || viewId == 9 || viewId == 10 || viewId == 6 || viewId == 7) && planId == 1 && (typeid == 2)))) {
                if (planId == 1 && flag == 0) {
                    flag = 1;
                    return false;
                }
                else if ((flag == 1 && planId == 1) || (flag == 0)) {
                    x.logo = null;
                    x.companyname = 'XXXXXXXXXXXXXXXXX';
                    x.country = 'XXXXXXXXXXXXXXXXX';
                    x.contacts.map(c => {
                        c.firstName = 'XXXXXXXXXXXXXXXXX';
                        c.lastName = 'XXXXXXXXXXXXXXXXX';
                        c.jobTitle = 'XXXXXXXXXXXXXXXXX';
                    });
                }
            }
        });
        let resultformat = {
            results: final,
            master: master,
            aggregation: aggregation,
            total: total
        };
        return resultformat;
    }
    async nonMemberList(viewId, planId, data, userData) {
        let user = userData;
        let channelFilter = data.filter;
        let contactId = user.contactId;
        let channelId = user.channelId;
        let typeid = user.channelTypeId;
        let userId = user.userId;
        let filterch = [];
        let channeltype = [];
        let aggregation = {};
        let channelquery;
        if (typeid == 2)
            channeltype = [3, 4];
        if (typeid == 3 || typeid == 4 || typeid == 5)
            channeltype = [2];
        let order = data.order;
        channelquery = 'select "oldChannelId" as channel_id from "tblOldChannel" where "channelTypeId" in(:channelTypeId) and "isActive"=\'1\' and "deletedAt" is null';
        let result = await this.sequelizeInstance.query(channelquery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelTypeId: channeltype
            }
        }).then(x => {
            return _.uniqBy(x, 'channel_id');
        });
        if (data.search) {
            let searchchannellist = await this.sequelizeInstance.query('select "oldChannelId" as channel_id from "tblOldChannel" where "companyName" ILIKE :search', {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    search: '%' + data.search + '%',
                }
            });
            let chl = searchchannellist.map(x => x.channel_id);
            result = result.filter(ch => { return chl.includes(ch.channel_id); });
        }
        if (channelFilter.typeId && result) {
            let chlist = result.map(x => +x.channel_id);
            let ctype = 'select array_agg("oldChannelId") as ch from "tblOldChannel" where "channelTypeId" in(:channeltypeid) and "oldChannelId" in(:channelid)';
            await this.sequelizeInstance.query(ctype, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelid: chlist,
                    channeltypeid: +channelFilter.typeId
                }
            }).then((result) => {
                if (result[0].ch)
                    filterch.push(...result[0].ch);
            });
            result = result.filter(ch => { return filterch.includes(ch.channel_id); });
        }
        if ((channelFilter.turnOver || channelFilter.brandId || channelFilter.locationId || channelFilter.countryId || channelFilter.specialityId || channelFilter.productCategoryId || channelFilter.retailerprofileId) && result) {
            let chlist = result.map(x => +x.channel_id);
            if (channelFilter.turnOver) {
                let query;
                if (channelFilter.turnOver == '<1M€') {
                    query = 'select array_agg("oldChannelId") as ch from "tblOldChannelDetail" where "oldChannelId" in(:channelid) and case when "turnoverRange"=\'<1M€\' or cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)<1 or "turnover"<1 then cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)<1 or "turnoverRange"=\'<1M€\' or "turnover"<1 end';
                }
                else if (channelFilter.turnOver == '1-10M€') {
                    query = 'select  array_agg("oldChannelId") as ch from "tblOldChannelDetail" where "oldChannelId" in(:channelid) and case when "turnoverRange"=\'1-10M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\'))as int)>1 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<10) or ("turnover">1 and "turnover"<10) then "turnoverRange"=\'1-10M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\'))as int)>1 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<10) or ("turnover">1 and "turnover"<10) end';
                }
                else if (channelFilter.turnOver == '10-100M€') {
                    query = 'select  array_agg("oldChannelId") as ch from "tblOldChannelDetail" where "oldChannelId" in(:channelid) and "turnoverRange"!=\'>100M€\' and case when "turnoverRange"=\'10-100M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\')) as int)>10 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<=100) or ("turnover">10 and "turnover"<=100) then "turnoverRange"=\'10-100M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\')) as int)>10 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<=100) or ("turnover">10 and "turnover"<=100) end';
                }
                else if (channelFilter.turnOver == '>100M€') {
                    query = 'select array_agg("oldChannelId") as ch from "tblOldChannelDetail" where "oldChannelId" in(:channelid) and case when "turnoverRange"=\'>100M€\' or cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)>100 or "turnover">100 then cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)>100 or "turnoverRange"=\'>100M€\' or "turnover">100 end';
                }
                await this.sequelizeInstance.query(query, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.brandId) {
                let brand = 'select array_agg("oldChannelId") as ch from "tblOldChannelBrand" where "brandId" in(:brandid) and "oldChannelId" in(:channelid)';
                await this.sequelizeInstance.query(brand, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist,
                        brandid: channelFilter.brandId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.productCategoryId) {
                await this.sequelizeInstance.query('select array_agg("oldChannelId") as ch from "tblOldChannelProductCategorie" cpc where cpc."productCategorieId" in(:productcatid) and "oldChannelId" in(:channelid) ', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        productcatid: channelFilter.productCategoryId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.retailerprofileId) {
                await this.sequelizeInstance.query('select array_agg("oldChannelId") as ch from "tblOldChannelCustomerProfile" where "profileTypeId" in(:retailprofileid) and "oldChannelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        retailprofileid: channelFilter.retailerprofileId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.countryId) {
                await this.sequelizeInstance.query('select array_agg("oldChannelId") as ch from "tblOldChannel" where "countryId" in(:countryid) and "oldChannelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        countryid: channelFilter.countryId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.specialityId) {
                await this.sequelizeInstance.query('select array_agg(distinct "oldChannelId") as ch from "tblOldContact" where "oldContactId" in(Select "oldContactId" from "tblContactInterestedProductCategory" where "productCategorieId" in(:specialityid)) and "oldChannelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        specialityid: channelFilter.specialityId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.locationId) {
                await this.sequelizeInstance.query('select array_agg("oldChannelId") as ch from "tblOldChannel" where "countryId" in(:locationid) and "oldChannelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        locationid: channelFilter.locationId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            result = result.filter(ch => { return filterch.includes(ch.channel_id); });
        }
        let total = result ? result.length : 0;
        let final = [];
        if (result) {
            let ordered = await this.sequelizeInstance.query('select "oldChannelId" from "tblOldChannel" where "oldChannelId" in(:channelid)  order by "companyName" asc', {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelid: result.map(x => x.channel_id),
                }
            }).then(res => {
                return res.map(x => x.oldChannelId);
            });
            result = await this.mapOrder(result, ordered, 'channel_id');
            result = result.slice(data.offset).slice(0, data.limit);
            for (let i = 0; i < result.length; i++) {
                let status = 'Non Suggestion';
                let mscore = null;
                let relation_status = null;
                let isConfidential = 1;
                let channeljct = null;
                let transToContact = null;
                let note = null;
                let companyquery;
                try {
                    companyquery = 'Select ' + mscore + ' as matchingScore,' + relation_status + ' as relation_status,\'Non Member\' as status,' + isConfidential + ' as isConfidential,' + channeljct + ' as channel_jct_id,' + transToContact + ' as transToContact,' + note + ' as note,ch."oldChannelId" as cid,case when chd."turnover" is null then chd."turnoverRange" when chd."turnover" is not null then cast(chd."turnover" as text) end as turnover,ch."companyName" as companyname,ch."countryId" as countryid, tc."country" as country, tc."isoCode", pt."profileType" as profiletype, cht."channelType" as channeltype,ch."channelTypeId" as channeltypeid,'
                        + 'chd."detailDesc" as detaildesc, chd."webSiteUrl" as websiteurl, chd."startup",(select array_to_json(array_agg(row_to_json(a))) from (select SUBSTRING ( cast(chd."maturitylevel" as TEXT) ,2 , length(cast(chd."maturitylevel" as TEXT))-2) as item_name)a) as looking_startups, '
                        + '(select distinct channelgroupid as favorite from "tblproductwishlist" fav where fav."userid"=' + userId + ' and fav."channelid"=ch."oldChannelId" and "productid" is null and "deletedat" is null fetch first row only), '
                        + '(Select td."documentPath" as logo from "tblOldChannelDetail" chd inner join "tblDocument" td on td."documentId" in(chd."channelLogoId") where chd."oldChannelId"=ch."oldChannelId"), '
                        + '(select array_to_json(array_agg(row_to_json(c))) from (Select td."documentPath",con."isDefaultContact",con."firstName",con."lastName",con."jobTitle" from "tblOldContact" con left join "tblDocument" td on td."documentId" in(con."documentId") where con."oldChannelId"=ch."oldChannelId")c)as contacts, '
                        + '(select array_to_json(array_agg(row_to_json(x))) from (Select pc."productCategorie" as item_name from "tblOldChannelProductCategorie" cpc inner join "tblProductCategories" pc on pc."productCategorieId" = cpc."productCategorieId" where cpc."oldChannelId"=ch."oldChannelId")x) as company_cat, '
                        + '(select array_to_json(array_agg(row_to_json(z))) from (Select pt."profileType" as item_name from "tblProfileType" pt where "profileTypeId" in (select "profileTypeId" from "tblOldChannelCustomerProfile" as ccp where ccp."oldChannelId"=ch."oldChannelId"))z) as retail_customer_profile '
                        + 'from "tblOldChannel" ch inner join "tblOldChannelDetail" chd on chd."oldChannelId" = ch."oldChannelId" inner join "tblCountry" tc on tc."countryId" = ch."countryId" '
                        + 'inner join "tblProfileType"pt on pt."profileTypeId" = ch."profileTypeId" inner join "tblChannelType" as cht on cht."channelTypeId" = ch."channelTypeId" where ch."oldChannelId" in(:channelid)';
                    let res = await this.sequelizeInstance.query(companyquery, {
                        type: sequelize_1.QueryTypes.SELECT,
                        raw: true,
                        replacements: {
                            channelid: result[i].channel_id,
                        }
                    });
                    final.push(...res);
                }
                catch (e) {
                    console.log("error:", e);
                }
            }
        }
        else
            result = [];
        let resultformat = {
            results: final,
            aggregation: aggregation,
            total: total
        };
        return resultformat;
    }
    async getSearchAggregation(viewId, data) {
        let user = data;
        let contactId = user.contactId;
        let channelId = user.channelId;
        let typeid = user.channelTypeId;
        let channeltype = [];
        let aggregation = null;
        let channelquery;
        if (typeid == 2)
            channeltype = [3, 4];
        else if (typeid == 3)
            channeltype = [2, 4];
        else if (typeid == 4)
            channeltype = [2, 3];
        if (viewId == 1) {
            channelquery = 'select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=2 and case when "requested_to"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" '
                + ' where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) '
                + ' when "requested_by"=' + contactId + ' then "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6))  end and "deletedat" is null    ';
        }
        else if (viewId == 2) {
            channelquery = 'select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT"  where "connectionStatusTypeId" in(7,11) and case when "requested_to"=' + contactId + ' and "connectionStatusTypeId"=11 then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) when "requested_by"=' + contactId + ' and "connectionStatusTypeId"=7 then "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6))  end and "deletedat" is null ';
        }
        else if (viewId == 3) {
            channelquery = 'select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(7,10) '
                + ' and case when "requested_to"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15  and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) end and "deletedat" is null ';
        }
        else if (viewId == 4) {
            channelquery = 'select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=10 and "partnerChannelId" not in(select "partnerChannelId" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "deletedat" is null and "requested_by"=' + contactId + ' and "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') union all select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id  from "tblChannelJCT" where "connectionStatusTypeId"=11 and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "deletedat" is null and "requested_to"=' + contactId + ' and "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\')  ';
        }
        else if (viewId == 5) {
            channelquery = 'select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=11 and case when "requested_by"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) end and "deletedat" is null  ';
        }
        else if (viewId == 6) {
            channelquery = 'select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)  ';
        }
        else if (viewId == 8) {
            channelquery = 'select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(2) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) ';
        }
        else if (viewId == 9) {
            channelquery = 'select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(3) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)  ';
        }
        else if (viewId == 10) {
            channelquery = 'select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(4) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)  ';
        }
        else if (viewId == 7) {
            channelquery = 'select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=2 and case when "requested_to"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" '
                + ' where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) '
                + ' when "requested_by"=' + contactId + ' then "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6))  end and "deletedat" is null'
                + ' union all'
                + ' select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT"  where "connectionStatusTypeId" in(7,11) and case when "requested_to"=' + contactId + ' and "connectionStatusTypeId"=11 then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) when "requested_by"=' + contactId + ' and "connectionStatusTypeId"=7 then "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6))  end and "deletedat" is null '
                + ' union all'
                + ' select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(7,10) '
                + ' and case when "requested_to"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15  and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) end and "deletedat" is null  '
                + ' union all'
                + ' select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=10 and "partnerChannelId" not in(select "partnerChannelId" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "deletedat" is null and "requested_by"=' + contactId + ' and "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') union all select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id  from "tblChannelJCT" where "connectionStatusTypeId"=11 and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "deletedat" is null and "requested_to"=' + contactId + ' and "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\')  '
                + ' union all'
                + ' select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=11 and case when "requested_by"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) end and "deletedat" is null'
                + ' union all'
                + ' select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)'
                + ' union all'
                + ' select tc."channelId" as channel_id from "tblChannel" as tc inner join "tblContact" as con on con."channelId"=tc."channelId" and con."isActive"=\'1\' and con."deletedAt" is null and con."contactId" not in(select case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end from "tblChannelJCT" as jct where ("requested_by"=' + contactId + ' or "requested_to"=' + contactId + ') and "connectionStatusTypeId" in(5,6,2,7,10,11,1)) where "signUpStatusId"=15 and  "channelTypeId" not in(5,6) and tc."isActive"=\'1\' and tc."deletedAt" is null and "channelTypeId" in(:channelTypeId) and tc."channelId" not in(select case when "dismissedBy"=' + channelId + ' then "dismissedChId" when "dismissedChId"=' + channelId + ' then "dismissedBy" end from "tblchanneldismissreason" where "dismissedBy"=' + channelId + ' or ("dismissedChId"=' + channelId + ' and "dismissedBy"=tc."channelId")) ';
        }
        let result = await this.sequelizeInstance.query(channelquery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelTypeId: channeltype
            }
        }).then(x => {
            return _.uniqBy(x, 'channel_id');
        });
        if (result.length > 0) {
            let chlist = result.map(x => +x.channel_id);
            let brandquery = 'select distinct on(tb."brandName") tb."brandName" as name,tb."id" as id from "tblBrand" tb '
                + 'inner join "tblDocument" td on td."documentId"=tb."documentId" where id in (select "brandId" from "tblChannelBrand" where "channelId" in(:channelid)) order by tb."brandName" ';
            let productcatquery = 'Select distinct on(pc."productCategorie")pc."productCategorie" as name,pc."productCategorieId" as id from "tblChannelProductCategorie" cpc '
                + 'inner join "tblProductCategories" pc on pc."productCategorieId" = cpc."productCategorieId" '
                + 'where cpc."channelId" in(:channelid) order by pc."productCategorie"';
            let retailcustquery = 'Select distinct on(pt."profileType")pt."profileType" as name,pt."profileTypeId" as id from "tblProfileType" pt where "profileTypeId" in '
                + '(select "profileTypeId" from "tblChannelCustomerProfile" where "channelId" in(:channelid)) order by pt."profileType" ';
            let countryquery = 'select distinct on(tc."country")tc."country" as name, tc."priority", ch."countryId" as id from "tblChannel" ch inner join "tblCountry" tc on tc."countryId"=ch."countryId" '
                + 'where ch."channelId" in(:channelid) order by tc."country" ';
            let intcatquery = 'select distinct on("productCategorie")"productCategorie" as name,"productCategorieId" as id from "tblProductCategories" where "productCategorieId" in '
                + '(Select cpc."productCategorieId" from "tblContactInterestedProductCategory" cpc where cpc."contactId" in(select "contactId" from "tblContact" where "channelId" in(:channelid) and "deletedAt" is null)) order by "productCategorie" ';
            let lookupquery = 'select distinct on("country")"country" as name,"countryId" as id, "priority" from "tblCountry" where "countryId" in '
                + '(Select pc."countryId" from "tblContactLocation" cpc inner join "tblRegionCountryJCT" pc on pc."regionCountryJCTId" = cpc."regionCountryJCTId" '
                + 'inner join "tblChannel" ch on ch."channelId" in(:channelid) where cpc."channelId" in(:channelid) and cpc."locationType"=\'SELLING\') order by "country" ';
            let brandlist = await this.sequelizeInstance.query(brandquery, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelid: chlist
                }
            });
            let productcatlist = await this.sequelizeInstance.query(productcatquery, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelid: chlist
                }
            });
            let retailcustlist = await this.sequelizeInstance.query(retailcustquery, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelid: chlist
                }
            });
            let countrylist = await this.sequelizeInstance.query(countryquery, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelid: chlist
                }
            });
            let intcatlist = await this.sequelizeInstance.query(intcatquery, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelid: chlist
                }
            });
            let lookuplist = await this.sequelizeInstance.query(lookupquery, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelid: chlist
                }
            });
            aggregation = {
                brandIds: brandlist,
                locactionIds: lookuplist,
                specialIds: intcatlist,
                countryIds: countrylist,
                retailIds: retailcustlist,
                productIds: productcatlist
            };
        }
        return aggregation;
    }
    async chFilterBase(viewId, channelType, user, data) {
        let channelFilter = data === null || data === void 0 ? void 0 : data.filter;
        let chlist;
        let contactId = user.contactId;
        let channelId = user.channelId;
        let typeid = user.channelTypeId;
        let businessType = user.businessType;
        let channeltype = [];
        let aggregation = null;
        let channelquery;
        if (channelType > 0)
            channeltype = [channelType];
        else {
            if (typeid == 2 && businessType == 1)
                channeltype = [3, 4];
            else if (typeid == 2 && businessType == 2)
                channeltype = [3, 5];
            else if (typeid == 2 && businessType == 3)
                channeltype = [3, 4, 5];
            if (typeid == 3 || typeid == 4 || typeid == 5)
                channeltype = [2];
        }
        if (viewId == 1) {
            channelquery = 'select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=2 and case when "requested_to"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" '
                + ' where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) '
                + ' when "requested_by"=' + contactId + ' then "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6))  end and "deletedat" is null    ';
        }
        else if (viewId == 2) {
            channelquery = 'select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT"  where "connectionStatusTypeId" in(7,11) and case when "requested_to"=' + contactId + ' and "connectionStatusTypeId"=11 then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) when "requested_by"=' + contactId + ' and "connectionStatusTypeId"=7 then "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6))  end and "deletedat" is null ';
        }
        else if (viewId == 3) {
            channelquery = 'select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(7,10) '
                + ' and case when "requested_to"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15  and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) end and "deletedat" is null ';
        }
        else if (viewId == 4) {
            channelquery = 'select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=10 and "partnerChannelId" not in(select "partnerChannelId" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "deletedat" is null and "requested_by"=' + contactId + ' and "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') union all select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id  from "tblChannelJCT" where "connectionStatusTypeId"=11 and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "deletedat" is null and "requested_to"=' + contactId + ' and "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\')  ';
        }
        else if (viewId == 5) {
            channelquery = 'select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=11 and case when "requested_by"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) end and "deletedat" is null  ';
        }
        else if (viewId == 6) {
            channelquery = 'select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)  ';
        }
        else if (viewId == 8) {
            channelquery = 'select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(2) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) ';
        }
        else if (viewId == 9) {
            channelquery = 'select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(3) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)  ';
        }
        else if (viewId == 10) {
            channelquery = 'select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(4) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)  ';
        }
        else if (viewId == 14) {
            channelquery = 'select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(5) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)  ';
        }
        else if (viewId == 30) {
            channelquery = 'select "matchingScore","connectionStatusTypeId" as relation_status,\'Confirm\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential",case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id,case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end as contact_id,"updatedAt" from "tblChannelJCT" where "connectionStatusTypeId"=2 and case when "requested_to"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" '
                + ' where  "channelTypeId" in(:channelTypeId) and "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) '
                + ' when "requested_by"=' + contactId + ' then "partnerChannelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6))  end and "deletedat" is null'
                + ' union all'
                + ' select "matchingScore","connectionStatusTypeId" as relation_status,\'Outbound\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential",case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id,case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end as contact_id,"updatedAt" from "tblChannelJCT"  where "connectionStatusTypeId" in(7,11) and case when "requested_to"=' + contactId + ' and "connectionStatusTypeId"=11 then "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) when "requested_by"=' + contactId + ' and "connectionStatusTypeId"=7 then "partnerChannelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6))  end and "deletedat" is null '
                + ' union all'
                + ' select "matchingScore","connectionStatusTypeId" as relation_status,\'Inbound\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential",case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id,case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end as contact_id,"updatedAt" from "tblChannelJCT" where "connectionStatusTypeId" in(7,10) '
                + ' and case when "requested_to"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "deletedAt" is null and "signUpStatusId" = 15  and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) end and "deletedat" is null  '
                + ' union all'
                + ' select "matchingScore","connectionStatusTypeId" as relation_status,\'RequestIntro\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential",case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id,case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end as contact_id,"updatedAt" from "tblChannelJCT" where "connectionStatusTypeId"=10 and "partnerChannelId" not in(select "partnerChannelId" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "deletedat" is null and "requested_by"=' + contactId + ' and "partnerChannelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') union all select "matchingScore","connectionStatusTypeId" as relation_status,\'RequestIntro\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential",case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id,case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end as contact_id,"updatedAt"  from "tblChannelJCT" where "connectionStatusTypeId"=11 and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "deletedat" is null and "requested_to"=' + contactId + ' and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\')  '
                + ' union all'
                + ' select "matchingScore","connectionStatusTypeId" as relation_status,\'Savelater\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential",case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id,case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end as contact_id,"updatedAt" from "tblChannelJCT" where "connectionStatusTypeId"=11 and case when "requested_by"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) end and "deletedat" is null'
                + ' union all'
                + ' select "matchingScore","connectionStatusTypeId" as relation_status,\'Suggestion\' as status,"channelJCTId" as channeljct,"transToContact","note","introVideo","isConfidential","channelId" as channel_id,"requested_by" as contact_id,"updatedAt" from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)'
                + ' union all'
                + ' select CAST( null AS bigint) as "matchingScore",CAST( null AS bigint) as relation_status,\'NonSuggestion\' as status,CAST( null AS bigint) as channeljct,CAST( null AS bigint) as "transToContact",CAST( null AS text) as "note",CAST( null AS bigint) as "introVideo",CAST( null AS bit) as "isConfidential",tc."channelId" as channel_id,CAST( null AS bigint)as contact_id,tc."updatedAt" from "tblChannel" as tc inner join "tblContact" as con on con."channelId"=tc."channelId" and con."isActive"=\'1\' and con."deletedAt" is null and con."contactId" not in(select case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end from "tblChannelJCT" as jct where ("requested_by"=' + contactId + ' or "requested_to"=' + contactId + ') and "connectionStatusTypeId" in(5,6,2,7,10,11,1)) where "signUpStatusId"=15 and  "channelTypeId" not in(6) and tc."isActive"=\'1\' and tc."deletedAt" is null and "channelTypeId" in(:channelTypeId) and tc."channelId" not in(select case when "dismissedBy"=' + channelId + ' then "dismissedChId" when "dismissedChId"=' + channelId + ' then "dismissedBy" end from "tblchanneldismissreason" where "dismissedBy"=' + channelId + ' or ("dismissedChId"=' + channelId + ' and "dismissedBy"=tc."channelId")) ';
        }
        if (viewId == 15) {
            channelquery = 'select "oldChannelId" as channel_id from "tblOldChannel" where "channelTypeId" in(:channelTypeId) and "isActive"=\'1\' and "deletedAt" is null';
        }
        if (viewId == 50) {
            channelquery = 'select "channelid" as channel_id from "tblproductwishlist" where "userid"=:userId and "deletedat" is null';
        }
        let result = await this.sequelizeInstance.query(channelquery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelTypeId: channeltype,
                userId: user.userId
            }
        }).then(x => {
            return _.uniqBy(x, 'channel_id');
        });
        let filterch = [];
        if (result.length > 0)
            chlist = result.map(x => +x.channel_id);
        if (channelFilter.typeId && result.length > 0) {
            let ctype = 'select array_agg("channelId") as ch from "tblChannel" where "channelTypeId" in(:channeltypeid) and "channelId" in(:channelid)';
            await this.sequelizeInstance.query(ctype, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelid: chlist,
                    channeltypeid: +channelFilter.typeId
                }
            }).then((result) => {
                if (result[0].ch)
                    filterch.push(...result[0].ch);
            });
            result = result.filter(ch => { return filterch.includes(ch.channel_id); });
        }
        if ((channelFilter.storeCount || channelFilter.turnOver || channelFilter.brandId || channelFilter.locationId || channelFilter.countryId || channelFilter.specialityId || channelFilter.productCategoryId || channelFilter.retailerprofileId || channelFilter.resellerprofileId) && result.length > 0) {
            if (channelFilter.turnOver) {
                let query;
                if (channelFilter.turnOver == '<1M€') {
                    query = 'select array_agg("channelId") as ch from "tblChannelDetail" where "channelId" in(:channelid) and case when "turnoverRange"=\'<1M€\' or cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)<1 or "turnover"<1 then cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)<1 or "turnoverRange"=\'<1M€\' or "turnover"<1 end';
                }
                else if (channelFilter.turnOver == '1-10M€') {
                    query = 'select  array_agg("channelId") as ch from "tblChannelDetail" where "channelId" in(:channelid) and case when "turnoverRange"=\'1-10M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\'))as int)>1 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<10) or ("turnover">1 and "turnover"<10) then "turnoverRange"=\'1-10M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\'))as int)>1 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<10) or ("turnover">1 and "turnover"<10) end';
                }
                else if (channelFilter.turnOver == '10-100M€') {
                    query = 'select  array_agg("channelId") as ch from "tblChannelDetail" where "channelId" in(:channelid) and "turnoverRange"!=\'>100M€\' and case when "turnoverRange"=\'10-100M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\')) as int)>10 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<=100) or ("turnover">10 and "turnover"<=100) then "turnoverRange"=\'10-100M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\')) as int)>10 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<=100) or ("turnover">10 and "turnover"<=100) end';
                }
                else if (channelFilter.turnOver == '>100M€') {
                    query = 'select array_agg("channelId") as ch from "tblChannelDetail" where "channelId" in(:channelid) and case when "turnoverRange"=\'>100M€\' or cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)>100 or "turnover">100 then cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)>100 or "turnoverRange"=\'>100M€\' or "turnover">100 end';
                }
                await this.sequelizeInstance.query(query, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist,
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
                result = result.filter(ch => { return filterch.includes(ch.channel_id); });
            }
            if (channelFilter.storeCount) {
                let store;
                if (channelFilter.storeCount == '5')
                    store = 'select array_agg("channelId") as ch from "tblChannelDetail" where "channelId" in(:channelid) and ("physicalSales"<=5 or "physicalSales" is null)';
                else
                    store = 'select array_agg("channelId") as ch from "tblChannelDetail" where "channelId" in(:channelid) and "physicalSales">:count';
                await this.sequelizeInstance.query(store, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist,
                        count: +channelFilter.storeCount
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.brandId) {
                let brand = 'select array_agg("channelId") as ch from "tblChannelBrand" where "brandId" in(:brandid) and "channelId" in(:channelid)';
                await this.sequelizeInstance.query(brand, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist,
                        brandid: channelFilter.brandId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
                result = result.filter(ch => { return filterch.includes(ch.channel_id); });
            }
            if (channelFilter.productCategoryId) {
                await this.sequelizeInstance.query('select array_agg("channelId") as ch from "tblChannelProductCategorie" cpc where cpc."productCategorieId" in(:productcatid) and "channelId" in(:channelid) ', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist,
                        productcatid: channelFilter.productCategoryId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
                result = result.filter(ch => { return filterch.includes(ch.channel_id); });
            }
            if (channelFilter.retailerprofileId || channelFilter.resellerprofileId) {
                let query;
                let ids = channelFilter.retailerprofileId ? channelFilter.retailerprofileId : channelFilter.resellerprofileId;
                if (viewId == 8 || viewId == 9)
                    query = 'select array_agg("channelId") as ch from "tblChannelCustomerProfile" as ccp where "profileTypeId" in(:retailprofileid) and "channelId" in(:channelid) and ccp."profileTypeId" in(select "profileTypeId" from "tblProfileTypeClassification" where ("channelTypeId" in(3,4) and ccp."channelId" in(select "channelId" from "tblChannel" where "channelId"=ccp."channelId" and "isOEM"=\'1\')) or '
                        + '("channelTypeId" in(3,5) and ccp."channelId" in(select "channelId" from "tblChannel" where "channelId"=ccp."channelId" and "isOEM"=\'2\')) or'
                        + '("channelTypeId" in(3,4,5) and ccp."channelId" in(select "channelId" from "tblChannel" where "channelId"=ccp."channelId" and "isOEM"=\'3\')))';
                if (viewId == 10 || viewId == 14)
                    query = 'select array_agg("channelId") as ch from "tblChannel" where "profileTypeId" in(:retailprofileid) and "channelId" in(:channelid)';
                await this.sequelizeInstance.query(query, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        retailprofileid: (channelFilter.retailerprofileId && channelFilter.resellerprofileId) ? channelFilter.resellerprofileId.concat(channelFilter.retailerprofileId) : ids
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
                result = result.filter(ch => { return filterch.includes(ch.channel_id); });
            }
            if (channelFilter.countryId) {
                await this.sequelizeInstance.query('select array_agg("channelId") as ch from "tblChannel" where "countryId" in(:countryid) and "channelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist,
                        countryid: channelFilter.countryId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
                result = result.filter(ch => { return filterch.includes(ch.channel_id); });
            }
            if (channelFilter.specialityId) {
                await this.sequelizeInstance.query('select array_agg(distinct "channelId") as ch from "tblContact" where "contactId" in(Select "contactId" from "tblContactInterestedProductCategory" where "productCategorieId" in(:specialityid)) and "channelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist,
                        specialityid: channelFilter.specialityId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
                result = result.filter(ch => { return filterch.includes(ch.channel_id); });
            }
            if (channelFilter.locationId) {
                let locationType = user.channelTypeId == 2 ? 'SELLING' : 'TARGET';
                let query = 'select array_agg("channelId") as ch  from "tblChannelLocation" where "locationType"=:locationType and "channelId" in(:channelid) and "deletedAt" is null and'
                    + '"regionCountryJCTId" in(select "regionCountryJCTId" from "tblRegionCountryJCT" where "countryId" in (:locationid)) ';
                await this.sequelizeInstance.query(query, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist,
                        locationType: locationType,
                        locationid: channelFilter.locationId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
                result = result.filter(ch => { return filterch.includes(ch.channel_id); });
            }
        }
        chlist = result.map(x => +x.channel_id);
        return chlist;
    }
    async getchannelTypes(type) {
        let list = [];
        if (type == 2) {
            list.push({ id: 3, name: 'DISTRIBUTOR', status: false });
            list.push({ id: 4, name: 'RETAILER', status: false });
            list.push({ id: 5, name: 'RESELLER', status: false });
        }
        else if (type == 3) {
            list.push({ id: 2, name: 'VENDOR', status: false });
            list.push({ id: 3, name: 'DISTRIBUTOR', status: false });
            list.push({ id: 4, name: 'RETAILER', status: false });
            list.push({ id: 5, name: 'RESELLER', status: false });
        }
        else if (type == 4) {
            list.push({ id: 2, name: 'VENDOR', status: false });
            list.push({ id: 3, name: 'DISTRIBUTOR', status: false });
        }
        return list;
    }
    async getBrandFilter(chlist) {
        let brandIds;
        try {
            if (chlist.data.length > 0) {
                let brandquery = 'select distinct on(tb."brandName") tb."brandName" as name,tb."id" as id from "tblBrand" tb '
                    + 'inner join "tblDocument" td on td."documentId"=tb."documentId" where id in (select "brandId" from "tblChannelBrand" where "channelId" in(:channelid)) order by tb."brandName" ';
                brandIds = await this.sequelizeInstance.query(brandquery, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist.data
                    }
                });
            }
        }
        catch (e) {
            console.log("brandFilter:", e);
        }
        return brandIds;
    }
    async getLocationFilter(chlist) {
        let locactionIds;
        try {
            if (chlist.data.length > 0) {
                let lookupquery = 'select distinct on("country")"country" as name,"countryId" as id, "priority" from "tblCountry" where "countryId" in '
                    + '(Select pc."countryId" from "tblContactLocation" cpc inner join "tblRegionCountryJCT" pc on pc."regionCountryJCTId" = cpc."regionCountryJCTId" '
                    + 'inner join "tblChannel" ch on ch."channelId" in(:channelid) where cpc."channelId" in(:channelid) and cpc."locationType"=\'SELLING\') order by "country" ';
                locactionIds = await this.sequelizeInstance.query(lookupquery, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist.data
                    }
                });
            }
        }
        catch (e) {
            console.log("locationFilter:", e);
        }
        return locactionIds;
    }
    async getSpecialFilter(chlist) {
        let specialIds;
        try {
            if (chlist.data.length > 0) {
                let intcatquery = 'select distinct on("productCategorie")"productCategorie" as name,"productCategorieId" as id from "tblProductCategories" where "productCategorieId" in '
                    + '(Select cpc."productCategorieId" from "tblContactInterestedProductCategory" cpc where cpc."contactId" in(select "contactId" from "tblContact" where "channelId" in(:channelid) and "deletedAt" is null)) order by "productCategorie" ';
                specialIds = await this.sequelizeInstance.query(intcatquery, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist.data
                    }
                });
            }
        }
        catch (e) {
            console.log("specialFilter:", e);
        }
        return specialIds;
    }
    async getProductFilter(chlist, channelId) {
        let productIds;
        try {
            if (chlist.data.length > 0) {
                let productcatquery = 'select pg."productGroupId" as groupId,pg."productGroup" as groupname,pc."productCategorieId" as childId,pc."productCategorie" as childname,cast(false as boolean) as status from "tblProductGroup" as pg inner join'
                    + ' "tblProductCategories" as pc on pg."productGroupId"=pc."productGroupId" and pc."productCategorieId" in '
                    + '(select cpc."productCategorieId" from "tblChannelProductCategorie" as cpc where "channelId"=:channelId) '
                    + 'where pg."deletedAt" is null and pg."productGroup"!=\'\' ';
                productIds = await this.sequelizeInstance.query(productcatquery, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelId: channelId
                    }
                });
            }
        }
        catch (e) {
            console.log("productFilter:", e);
        }
        return productIds;
    }
    async getInterestedProduct(chlist, contactId) {
        let productIds;
        try {
            if (chlist.data.length > 0) {
                let productcatquery = 'select pg."productGroupId" as groupId,pg."productGroup" as groupname,pc."productCategorieId" as childId,pc."productCategorie" as childname,cast(false as boolean) as status from "tblProductGroup" as pg inner join'
                    + ' "tblProductCategories" as pc on pg."productGroupId"=pc."productGroupId" and pc."productCategorieId" in '
                    + '(select cpc."productCategorieId" from "tblInterestedProductCategory" as cpc where "contactId"=:contactId) '
                    + 'where pg."deletedAt" is null and pg."productGroup"!=\'\' ';
                productIds = await this.sequelizeInstance.query(productcatquery, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        contactId: contactId
                    }
                });
            }
        }
        catch (e) {
            console.log("productFilter:", e);
        }
        return productIds;
    }
    async getCountryFilter(chlist) {
        let countryIds;
        try {
            if (chlist.data.length > 0) {
                let countryquery = 'select distinct on(tc."country")tc."country" as name, tc."priority", ch."countryId" as id from "tblChannel" ch inner join "tblCountry" tc on tc."countryId"=ch."countryId" '
                    + 'where ch."channelId" in(:channelid) order by tc."country" ';
                countryIds = await this.sequelizeInstance.query(countryquery, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist.data
                    }
                });
            }
        }
        catch (e) {
            console.log("countryFilter:", e);
        }
        return countryIds;
    }
    async getRetailFilter(chlist) {
        let retailIds;
        try {
            if (chlist.data.length > 0) {
                let retailcustquery = 'Select distinct on(pt."profileType")pt."profileType" as name,pt."profileTypeId" as id,(select "channelTypeId" from "tblProfileTypeClassification" as pc where pc."profileTypeId"=pt."profileTypeId") from "tblProfileType" pt where "profileTypeId" in '
                    + '(select "profileTypeId" from "tblChannelCustomerProfile" as ccp where ccp."channelId" in(:channelid) and ccp."profileTypeId" in(select "profileTypeId" from "tblProfileTypeClassification" where ("channelTypeId" in(3,4) and ccp."channelId" in(select "channelId" from "tblChannel" where "channelId"=ccp."channelId" and "isOEM"=\'1\')) or '
                    + '("channelTypeId" in(3,5) and ccp."channelId" in(select "channelId" from "tblChannel" where "channelId"=ccp."channelId" and "isOEM"=\'2\')) or'
                    + '("channelTypeId" in(3,4,5) and ccp."channelId" in(select "channelId" from "tblChannel" where "channelId"=ccp."channelId" and "isOEM"=\'3\')) )) ';
                retailIds = await this.sequelizeInstance.query(retailcustquery, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist.data
                    }
                });
            }
            if (chlist.data.length > 0 && retailIds.length == 0) {
                let retailcustquery = 'Select distinct on(pt."profileType")pt."profileType" as name,pt."profileTypeId" as id,(select "channelTypeId" from "tblProfileTypeClassification" as pc where pc."profileTypeId"=pt."profileTypeId") from "tblProfileType" pt where "profileTypeId" in '
                    + '(select "profileTypeId" from "tblChannel" as ccp where ccp."channelId" in(:channelid)) ';
                retailIds = await this.sequelizeInstance.query(retailcustquery, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist.data
                    }
                });
            }
        }
        catch (e) {
            console.log("retailFilter:", e);
        }
        return retailIds;
    }
    async getTargetFilter(user, chlist) {
        let targetIds;
        let locationType = user.channelTypeId == 2 ? 'TARGET' : 'SELLING';
        try {
            if (chlist.data.length > 0) {
                let target = 'select distinct on("country")"country" as name, "priority", "countryId" as id  from "tblCountry" where "countryId" in '
                    + '(select ch."countryId" from "tblChannel" ch inner join "tblCountry" tc on tc."countryId"=ch."countryId" where ch."channelId" in(:channelid) order by tc."country")';
                targetIds = await this.sequelizeInstance.query(target, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        sourceId: user.channelId,
                        locationType: locationType,
                        channelid: chlist.data
                    }
                });
            }
        }
        catch (e) {
            console.log("targetFilter:", e);
        }
        return targetIds;
    }
    async contactFilterBase(data) {
        let user = data;
        let conlist;
        let typeid = user.channelTypeId;
        let channeltype = [];
        let aggregation = null;
        let channelquery;
        if (typeid == 2)
            channeltype = [3, 4];
        else if (typeid == 3)
            channeltype = [2, 4];
        else if (typeid == 4)
            channeltype = [2, 3];
        channelquery = 'select "contactId" from "tblContact" where "deletedAt" is null and "isActive"=\'1\' and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelType)) ';
        let result = await this.sequelizeInstance.query(channelquery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelType: channeltype
            }
        }).then(x => {
            return _.uniqBy(x, 'contactId');
        });
        if (result.length > 0)
            conlist = result.map(x => +x.contactId);
        return conlist;
    }
    async contactFilterBase1(userData, data, order) {
        let user = userData;
        let conlist;
        let typeid = user.channelTypeId;
        let channeltype = [];
        let aggregation = null;
        let channelquery;
        if (typeid == 2)
            channeltype = [3, 4];
        else if (typeid == 3)
            channeltype = [2, 4];
        else if (typeid == 4)
            channeltype = [2, 3];
        channelquery = 'select "contactId" from "tblContact" where "deletedAt" is null and "isActive"=\'1\' and "channelId" in(select "channelId" from "tblChannel" where "channelId" in(:channelId)) order by "firstName" ' + order;
        let result = await this.sequelizeInstance.query(channelquery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: data
            }
        }).then(x => {
            return _.uniqBy(x, 'contactId');
        });
        if (result.length > 0)
            conlist = result.map(x => +x.contactId);
        return conlist;
    }
    async getContactSpecialFilter(chlist) {
        let specialIds;
        try {
            if (chlist.data.length > 0) {
                let intcatquery = 'select distinct on("productCategorie")"productCategorie" as name,"productCategorieId" as id from "tblProductCategories" where "productCategorieId" in '
                    + '(Select cpc."productCategorieId" from "tblContactInterestedProductCategory" cpc where cpc."contactId" in(:contactid)) order by "productCategorie" ';
                specialIds = await this.sequelizeInstance.query(intcatquery, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        contactid: chlist.data
                    }
                });
            }
        }
        catch (e) {
            console.log("specialFilter:", e);
        }
        return specialIds;
    }
    async getContactCountryFilter(chlist) {
        let countryIds;
        try {
            if (chlist.data.length > 0) {
                let countryquery = 'select distinct on(tc."country")tc."country" as name, tc."priority", ch."countryId" as id from "tblContact" ch inner join "tblCountry" tc on tc."countryId"=ch."countryId" '
                    + 'where ch."contactId" in(:contactid) order by tc."country" ';
                countryIds = await this.sequelizeInstance.query(countryquery, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        contactid: chlist.data
                    }
                });
            }
        }
        catch (e) {
            console.log("countryFilter:", e);
        }
        return countryIds;
    }
    async conNameListFilter(chlist) {
        let nameList;
        try {
            if (chlist.length > 0) {
                let listquery = 'select "contactId" as id,concat(ct."firstName",\' \',ct."lastName") as name from "tblContact" as ct where "contactId" in(:contactid) and "deletedAt" is null and "isActive"=\'1\' ';
                nameList = await this.sequelizeInstance.query(listquery, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        contactid: chlist
                    }
                });
            }
        }
        catch (e) {
            console.log("specialFilter:", e);
        }
        return nameList;
    }
    async getFoCompanyList(viewId, planId, data) {
        let contactId = data.contactId;
        let businessType = data.businessType;
        let channelId = data.channelId;
        let typeid = data.channelTypeId;
        let channeltype = [];
        let channelquery;
        if (typeid == 2 && businessType == 1)
            channeltype = [3, 4];
        else if (typeid == 2 && businessType == 2)
            channeltype = [3, 5];
        else if (typeid == 2 && businessType == 3)
            channeltype = [3, 4, 5];
        else if (typeid == 3 || typeid == 4 || typeid == 5)
            channeltype = [2];
        if (viewId == 1) {
            channelquery = 'select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=2 and case when "requested_to"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" '
                + ' where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) '
                + ' when "requested_by"=' + contactId + ' then "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6))  end and "deletedat" is null ';
        }
        else if (viewId == 2) {
            channelquery = 'select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT"  where "connectionStatusTypeId" in(7,11) and case when "requested_to"=' + contactId + ' and "connectionStatusTypeId"=11 then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) when "requested_by"=' + contactId + ' and "connectionStatusTypeId"=7 then "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6))  end and "deletedat" is null ';
        }
        else if (viewId == 3) {
            channelquery = 'select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(7,10) '
                + ' and case when "requested_to"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15  and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) end and "deletedat" is null  ';
        }
        else if (viewId == 4) {
            channelquery = 'select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=10 and "partnerChannelId" not in(select "partnerChannelId" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "deletedat" is null and "requested_by"=' + contactId + ' and "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') union all select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id  from "tblChannelJCT" where "connectionStatusTypeId"=11 and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "deletedat" is null and "requested_to"=' + contactId + ' and "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\')  ';
        }
        else if (viewId == 5) {
            channelquery = 'select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=11 and case when "requested_by"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) end and "deletedat" is null';
        }
        else if (viewId == 6) {
            channelquery = 'select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)';
        }
        else if (viewId == 30) {
            if (planId == 1 || planId == 7) {
                if (typeid == 2) {
                    channelquery = 'select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=2 and case when "requested_to"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" '
                        + ' where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) '
                        + ' when "requested_by"=' + contactId + ' then "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6))  end and "deletedat" is null '
                        + ' union all'
                        + ' select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT"  where "connectionStatusTypeId" in(7,11) and case when "requested_to"=' + contactId + ' and "connectionStatusTypeId"=11 then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) when "requested_by"=' + contactId + ' and "connectionStatusTypeId"=7 then "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\'and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6))  end and "deletedat" is null '
                        + ' union all'
                        + ' select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(7,10) '
                        + ' and case when "requested_to"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15  and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) end and "deletedat" is null  '
                        + ' union all'
                        + ' select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=10 and "partnerChannelId" not in(select "partnerChannelId" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "deletedat" is null and "requested_by"=' + contactId + ' and "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') union all select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id  from "tblChannelJCT" where "connectionStatusTypeId"=11 and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "deletedat" is null and "requested_to"=' + contactId + ' and "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\')  '
                        + ' union all'
                        + ' select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=11 and case when "requested_by"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) end and "deletedat" is null'
                        + ' union all'
                        + ' select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "isConfidential"=\'1\' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)';
                }
                else {
                    let nonsuggcompany;
                    if (typeid == 3)
                        nonsuggcompany = 'select tc."channelId" as channel_id from "tblChannel" as tc inner join "tblContact" as con on con."channelId"=tc."channelId" and con."isActive"=\'1\' and con."deletedAt" is null and con."contactId" not in(select case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end from "tblChannelJCT" as jct where ("requested_by"=' + contactId + ' or "requested_to"=' + contactId + ') and "connectionStatusTypeId" in(5,6,2,7,10,11,1) ) where "signUpStatusId"=15 and  "channelTypeId" not in(5,6) and tc."isActive"=\'1\' and tc."deletedAt" is null and "channelTypeId" in(2) and tc."channelId" not in(select case when "dismissedBy"=' + channelId + ' then "dismissedChId" when "dismissedChId"=' + channelId + ' then "dismissedBy" end from "tblchanneldismissreason" where "dismissedBy"=' + channelId + ' or ("dismissedChId"=' + channelId + ' and "dismissedBy"=tc."channelId")) ';
                    else if (typeid == 4)
                        nonsuggcompany = 'select tc."channelId" as channel_id from "tblChannel" as tc inner join "tblContact" as con on con."channelId"=tc."channelId" and con."isActive"=\'1\' and con."deletedAt" is null and con."contactId" not in(select case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end from "tblChannelJCT" as jct where ("requested_by"=' + contactId + ' or "requested_to"=' + contactId + ') and "connectionStatusTypeId" in(5,6,2,7,10,11,1) ) where "signUpStatusId"=15 and  "channelTypeId" not in(5,6) and tc."isActive"=\'1\' and tc."deletedAt" is null and "channelTypeId" in(2,3) and tc."channelId" not in(select case when "dismissedBy"=' + channelId + ' then "dismissedChId" when "dismissedChId"=' + channelId + ' then "dismissedBy" end from "tblchanneldismissreason" where "dismissedBy"=' + channelId + ' or ("dismissedChId"=' + channelId + ' and "dismissedBy"=tc."channelId")) ';
                    channelquery = 'select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=2 and case when "requested_to"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" '
                        + ' where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) '
                        + ' when "requested_by"=' + contactId + ' then "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6))  end and "deletedat" is null '
                        + ' union all'
                        + ' select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT"  where "connectionStatusTypeId" in(7,11) and case when "requested_to"=' + contactId + ' and "connectionStatusTypeId"=11 then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) when "requested_by"=' + contactId + ' and "connectionStatusTypeId"=7 then "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\'and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6))  end and "deletedat" is null '
                        + ' union all'
                        + ' select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(7,10) '
                        + ' and case when "requested_to"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15  and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) end and "deletedat" is null  '
                        + ' union all'
                        + ' select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=10 and "partnerChannelId" not in(select "partnerChannelId" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "deletedat" is null and "requested_by"=' + contactId + ' and "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') union all select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id  from "tblChannelJCT" where "connectionStatusTypeId"=11 and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "deletedat" is null and "requested_to"=' + contactId + ' and "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\')  '
                        + ' union all'
                        + ' select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=11 and case when "requested_by"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) end and "deletedat" is null'
                        + ' union all'
                        + ' select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "isConfidential"=\'1\' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)'
                        + ' union all ' + nonsuggcompany;
                }
            }
            else
                channelquery = 'select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=2 and case when "requested_to"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" '
                    + ' where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) '
                    + ' when "requested_by"=' + contactId + ' then "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6))  end and "deletedat" is null '
                    + ' union all'
                    + ' select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT"  where "connectionStatusTypeId" in(7,11) and case when "requested_to"=' + contactId + ' and "connectionStatusTypeId"=11 then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) when "requested_by"=' + contactId + ' and "connectionStatusTypeId"=7 then "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\'and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6))  end and "deletedat" is null '
                    + ' union all'
                    + ' select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(7,10) '
                    + ' and case when "requested_to"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15  and "isActive"=\'1\') and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_by" not in(select "requested_by" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) end and "deletedat" is null  '
                    + ' union all'
                    + ' select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=10 and "partnerChannelId" not in(select "partnerChannelId" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "deletedat" is null and "requested_by"=' + contactId + ' and "partnerChannelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') union all select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id  from "tblChannelJCT" where "connectionStatusTypeId"=11 and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "deletedat" is null and "requested_to"=' + contactId + ' and "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\')  '
                    + ' union all'
                    + ' select case when "channelId"=' + channelId + ' then "partnerChannelId" when "partnerChannelId"=' + channelId + ' then "channelId" end as channel_id from "tblChannelJCT" where "connectionStatusTypeId"=11 and case when "requested_by"=' + contactId + ' then "channelId" in(select "channelId" from "tblChannel" where "deletedAt" is null and "signUpStatusId" = 15 and "isActive"=\'1\') and "requested_to" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null) and "requested_to" not in(select "requested_to" from "tblChannelJCT" where "requested_by"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) end and "deletedat" is null'
                    + ' union all'
                    + ' select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:channelTypeId) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)'
                    + ' union all'
                    + ' select tc."channelId" as channel_id from "tblChannel" as tc inner join "tblContact" as con on con."channelId"=tc."channelId" and con."isActive"=\'1\' and con."deletedAt" is null and con."contactId" not in(select case when "requested_to"=' + contactId + ' then "requested_by" when "requested_by"=' + contactId + ' then "requested_to" end from "tblChannelJCT" as jct where ("requested_by"=' + contactId + ' or "requested_to"=' + contactId + ') and "connectionStatusTypeId" in(5,6,2,7,10,11,1) ) where "signUpStatusId"=15 and  "channelTypeId" not in(5,6) and tc."isActive"=\'1\' and tc."deletedAt" is null and "channelTypeId" in(:channelTypeId) and tc."channelId" not in(select case when "dismissedBy"=' + channelId + ' then "dismissedChId" when "dismissedChId"=' + channelId + ' then "dismissedBy" end from "tblchanneldismissreason" where "dismissedBy"=' + channelId + ' or ("dismissedChId"=' + channelId + ' and "dismissedBy"=tc."channelId")) ';
        }
        else if (viewId == 8) {
            if (planId == 1 && typeid == 2)
                channelquery = 'select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "isConfidential"=\'1\' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(2) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)';
            else
                channelquery = 'select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(2) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)';
        }
        else if (viewId == 9) {
            if (planId == 1 && typeid == 2)
                channelquery = 'select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "isConfidential"=\'1\' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(3) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)';
            else
                channelquery = 'select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(3) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)';
        }
        else if (viewId == 10) {
            if (planId == 1 && typeid == 2)
                channelquery = 'select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "isConfidential"=\'1\' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(4) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)';
            else
                channelquery = 'select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(4) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)';
        }
        else if (viewId == 14) {
            if (planId == 1)
                channelquery = 'select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "isConfidential"=\'1\' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(5) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)';
            else
                channelquery = 'select "channelId" as channel_id from "tblChannelJCT" where "connectionStatusTypeId" in(1,16) and "requested_to"=' + contactId + ' and "deletedat" is null and "channelId" not in(select "channelId" from "tblChannelJCT" where "requested_to"=' + contactId + ' and "connectionStatusTypeId" in(5,6)) and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(5) and "isActive"=\'1\' and "signUpStatusId"=15 and "deletedAt" is null and "planId" is not null) and "requested_by" in(select "contactId" from "tblContact" where "isActive"=\'1\' and "deletedAt" is null)';
        }
        else if (viewId == 15) {
            channelquery = 'select "oldChannelId" as channel_id from "tblOldChannel" where "channelTypeId" in(:channelTypeId) and "isActive"=\'1\' and "deletedAt" is null';
        }
        else if (viewId == 50) {
            channelquery = 'select "channelid" as channel_id from "tblproductwishlist" where "userid"=:userId and "deletedat" is null';
        }
        let result = await this.sequelizeInstance.query(channelquery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelTypeId: channeltype,
                userId: data.userId
            }
        }).then(x => {
            return x;
        });
        if (result.length > 0) {
            let chlist = result.map(x => x.channel_id);
            let query = "";
            query = 'select "companyName" as name, "channelId" as id from "tblChannel" where "channelId" in(:channelIds) and "companyName" is not null and "companyName" != \'\' ';
            if (viewId == 15)
                query = 'select "companyName" as name, "oldChannelId" as id from "tblOldChannel" where "oldChannelId" in(:channelIds) and "companyName" is not null and "companyName" != \'\' ';
            result = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelIds: chlist
                },
            });
        }
        return { results: result ? result : [] };
    }
    async getChannel(channelId, user) {
        let channel = await this.channelRepository.scope('channelDetail').findOne({
            where: {
                channelId: +channelId,
                deletedAt: null,
                signUpStatusId: app_constant_1.appconstant.CHANNEL_APPROVED,
                isActive: '1',
                channelTypeId: {
                    [sequelize_1.Op.in]: [app_constant_1.appconstant.CHANNEL_TYPE_VENDOR, app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR, app_constant_1.appconstant.CHANNEL_TYPE_RETAILER, app_constant_1.appconstant.CHANNEL_TYPE_RESELLER]
                }
            },
            include: [
                {
                    model: ChannelB2B_entity_1.ChannelB2B,
                    as: 'channelB2B',
                    attributes: ['channelB2BId', 'channelId', 'channelB2B'],
                    where: { deletedAt: null },
                    required: false,
                },
                { model: this.signUpStatusRepository },
                { model: this.channelTypeRepository },
                { model: Country_entity_1.Country, as: 'country', where: { deletedAt: null } },
                { model: Address_entity_1.Address, as: 'regAddress' },
                { model: ProfileType_entity_1.ProfileType.scope('channelDetail'), as: 'profileType', attributes: ['profileType'], where: { deletedAt: null }, required: false },
                {
                    model: this.productGroupRepository,
                    as: 'speciality',
                    attributes: ['productGroupId', 'productGroup'],
                    required: false,
                    where: { isActive: '1' },
                    through: { attributes: [], where: { deletedAt: null } }
                },
                {
                    model: this.productCategoryRepository,
                    as: 'productCategory',
                    attributes: ['productCategorieId', 'productCategorie'],
                    required: false,
                    where: { isActive: '1' },
                    order: 'productCategorie',
                    through: { attributes: [], where: { deletedAt: null } }
                },
                {
                    model: ChannelAward_entity_1.ChannelAward,
                    attributes: ['awardDetail', 'issuedBy', 'validUpto', 'isLifeTime'],
                    where: { deletedAt: null },
                    required: false
                }
            ]
        });
        if (!channel)
            return false;
        if (+user.channelId != +channelId && (+channel.channelTypeId == +user.channelTypeId && +user.channelTypeId != app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR)) {
            throw new Auth_exception_1.AuthException('Not allowed');
        }
        if (!channel.channelJCT) {
            await new utility_1.Utility().lazyload(channel, 'channelJCT', {
                where: {
                    channelId: user.channelId,
                    partnerChannelId: channelId,
                    deletedat: null
                },
                required: false,
                include: [{
                        model: this.contactJCTRepository,
                        as: 'contactJCT',
                        attributes: ['partnerContactId'],
                        where: { contactId: user.contactId },
                        required: false,
                    }]
            });
        }
        if (!channel.channelJCTPartner) {
            await new utility_1.Utility().lazyload(channel, 'channelJCTPartner', {
                where: {
                    channelId: channelId,
                    partnerChannelId: user.channelId,
                    deletedat: null,
                    subscription_queued: '0'
                },
                required: false,
                include: [{
                        model: this.contactJCTRepository,
                        as: 'contactJCT',
                        attributes: ['partnerContactId'],
                        where: { contactId: user.contactId },
                        required: false,
                    }]
            });
        }
        if (!channel.shareType) {
            await new utility_1.Utility().lazyload(channel, 'shareType', {
                through: { attributes: [], where: { deletedat: null, sharetypeid: app_constant_1.appconstant.shareTypeId[+user.channelTypeId] } },
                required: false,
                attributes: ['sharetypeid', 'sharetype']
            });
        }
        if (+user.channelId != +channelId && (channel.shareType.length === 0) &&
            (channel.channelJCTPartner && channel.channelJCTPartner[0] && [2, 7].includes(+channel.channelJCTPartner[0].connectionStatusTypeId)) &&
            (channel.channelJCT && channel.channelJCT[0] && [2, 7].includes(+channel.channelJCT[0].connectionStatusTypeId))) {
            throw new Auth_exception_1.AuthException('Not allowed');
        }
        try {
            if (!channel.channelDetail) {
                await new utility_1.Utility().lazyload(channel, 'channelDetail', {
                    where: { deletedAt: null },
                    required: false,
                    attributes: ['channelLogoId', 'channelIconId', 'webSiteUrl', 'estYear', 'regYear', 'detailDesc', 'expectations', 'companyDesc', 'empCntRange', 'empCnt', 'empCntDSale', 'empCntISale', 'empCntDMar', 'empCntIMar', 'turnoverRange', 'turnover', 'revD', 'revI', 'deletedAt', 'turnoverPhyStore', 'turnoverOnStore', 'startup', 'storeCount', 'maturitylevel', 'keyretailers', 'keyresellers', 'keydistributors', 'no_of_retailers', 'no_of_resellers', 'no_of_skus', 'no_of_distributors', 'no_of_vendors', 'introvideoId', 'channelBannerId', 'phone1', 'mobileNo', 'bannerURL'],
                    include: [{
                            model: Media_entity_1.Media,
                            as: 'channelLogo',
                            attributes: ['documentUrl', 'documentPath'],
                            where: { deletedAt: null },
                            required: false
                        },
                        {
                            model: Media_entity_1.Media,
                            as: 'channelIcon',
                            where: { deletedAt: null },
                            attributes: ['documentUrl'],
                            required: false
                        },
                        {
                            model: Media_entity_1.Media,
                            as: 'introvideo',
                            where: { deletedAt: null },
                            required: false
                        },
                        {
                            model: Media_entity_1.Media,
                            as: 'channelBanner',
                            where: { deletedAt: null },
                            required: false
                        }
                    ],
                });
            }
            if (!channel.serviceList) {
                await new utility_1.Utility().lazyload(channel, 'serviceList', {
                    through: { attributes: [], where: { deletedAt: null } },
                    required: false,
                    attributes: ['serviceListId', 'serviceList']
                });
            }
            if (!channel.channelLocation) {
                await new utility_1.Utility().lazyload(channel, 'channelLocation', {
                    where: { deletedAt: null },
                    required: false,
                    attributes: ['locationType'],
                    include: [{
                            model: RegionCountryJCT_entity_1.RegionCountryJCT,
                            where: { deletedAt: null },
                            required: false,
                            include: [
                                {
                                    model: Country_entity_1.Country,
                                    where: { deletedAt: null },
                                    attributes: ['countryId', 'country', 'priority'],
                                    required: false
                                }
                            ],
                        }]
                });
            }
            if (!channel.channelBrand) {
                await new utility_1.Utility().lazyload(channel, 'channelBrand', {
                    where: { deletedAt: null },
                    required: false,
                    include: [{
                            model: Brand_entity_1.Brand.scope('channelDetail'),
                            as: 'brand',
                            where: { deletedAt: null, isActive: '1' },
                            required: false,
                            include: [{
                                    model: Media_entity_1.Media,
                                    as: 'document',
                                    where: { deletedAt: null },
                                    required: false
                                }]
                        }]
                });
            }
            if (!channel.channelSocial) {
                await new utility_1.Utility().lazyload(channel, 'channelSocial', {
                    where: { deletedAt: null },
                    required: false,
                    include: [{
                            model: SocialSite_entity_1.SocialSite.scope('channelDetail'),
                            where: { deletedAt: null },
                            attributes: ['socialSite'],
                            required: false
                        }]
                });
            }
            if (!channel.channelCertificate) {
                await new utility_1.Utility().lazyload(channel, 'channelCertificate', {
                    where: { deletedAt: null },
                    attributes: ['cerificateTypeId', 'cerificateName', 'cerificateNumber', 'cerificateDesc'],
                    required: false
                });
            }
            if (!channel.channelSubscription) {
                await new utility_1.Utility().lazyload(channel, 'channelSubscription', {
                    where: { isActive: '1' },
                    required: false,
                    include: [{
                            model: this.subscriptionRepository.scope('channelDetail'),
                            as: 'subscription',
                            where: { deletedAt: null, isActive: '1' },
                            required: false,
                            include: [{
                                    model: SubscriptionPlan_entity_1.SubscriptionPlan.scope('channelDetail'),
                                    as: 'subscriptionPlan',
                                    where: { deletedAt: null, isActive: '1' },
                                    required: false
                                }],
                        }]
                });
            }
            if (!channel.channelDocument) {
                await new utility_1.Utility().lazyload(channel, 'channelDocument', {
                    attributes: ['channelDocumentId', 'documentId', 'name', 'description'],
                    where: { deletedAt: null },
                    required: false,
                    include: [{
                            attributes: ['documentId', 'documentPath', 'documentUrl'],
                            where: { deletedAt: null, documentTypeId: 2 },
                            model: this.mediaRepository,
                            required: true,
                        }]
                });
            }
            channel.toJSON();
            channel['channelKeyRetailer'] = await this.channelKeyPartnerService.getKeyRetailers(+channel.channelId, app_constant_1.appconstant.CHANNEL_TYPE_RETAILER);
            channel['channelKeyReseller'] = await this.channelKeyPartnerService.getKeyRetailers(+channel.channelId, app_constant_1.appconstant.CHANNEL_TYPE_RESELLER);
            channel['channelKeyDistributor'] = await this.channelKeyPartnerService.getKeyRetailers(+channel.channelId, app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR);
            let custquery = 'select tpt."profileType", tptc."channelTypeId" from "tblChannelCustomerProfile" tcp inner join "tblProfileTypeClassification" tptc on tcp."profileTypeClassificationId"=tptc."profileTypeClassificationId" inner join "tblProfileType" tpt on tpt."profileTypeId"=tptc."profileTypeId" where tcp."channelId"=:channelId and tcp."deletedAt" is null';
            channel['customerProfile'] = await await this.sequelizeInstance.query(custquery, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelId: +channel.channelId
                }
            });
            if (channel.channelTypeId == app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR || channel.channelTypeId == app_constant_1.appconstant.CHANNEL_TYPE_RETAILER) {
                channel['sampleOrderCount'] = await this.getSampleOrderCount(channelId);
                channel['sampleEvaluationCount'] = await this.getSampleEvaluationCount(channelId);
            }
            channel['productCount'] = await this.productRepository.count({
                where: {
                    channelId: channelId,
                    isactive: '1',
                    deletedat: null
                }
            });
            channel['certificateType'] = await this.channelCertificateTypeRepository.findAll({
                where: { deletedAt: null }
            });
            let query = 'select "productCategorieId", "productCategorie" from "tblProductCategories" where "productCategorieId" in(select "productCategorieId" from "tblInterestedProductCategory" where "channelId"=:channelId and "deletedAt" is null) order by "productCategorie"';
            let userProductCat = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelId: channelId
                }
            });
            let companyImages = await this.companyMediaImagesRepository.findAll({
                where: {
                    channelId: +channel.channelId,
                    deletedAt: null
                },
                include: [{
                        model: Media_entity_1.Media,
                        where: {
                            documentTypeId: 1,
                            deletedAt: null
                        },
                        required: true
                    }],
                order: [['companyMediaId', 'DESC']]
            });
            let fav_query = 'select "channelgroupid" from "tblproductwishlist" where "userid"=:userId and "channelid"=:channelId and "deletedat" is null limit 1';
            let favorite = await this.sequelizeInstance.query(fav_query, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelId: channelId,
                    userId: user.userId
                }
            }).then(res => {
                var _a;
                return (_a = res[0]) === null || _a === void 0 ? void 0 : _a.channelgroupid;
            });
            let channelTransformed = await this.channelHubDetailOutBound.channelDetail(channel, user, userProductCat, companyImages);
            if (user.channelId != channel.channelId) {
                let viewcount = await Dashboard_entity_1.Dashboard.count({
                    where: {
                        user_id: user.userId,
                        channelid: channel.channelId,
                        visitid: channel.channelId,
                        visittype: 1
                    }
                });
                if (viewcount > 0) {
                    await Dashboard_entity_1.Dashboard.update({ count: viewcount + 1 }, {
                        where: {
                            user_id: user.userId,
                            channelid: channel.channelId,
                            visitid: channel.channelId,
                            visittype: 1
                        }
                    });
                }
                else {
                    let defaultData = {
                        user_id: user.userId,
                        channelid: channel.channelId,
                        visitid: channel.channelId,
                        visittype: '1',
                        count: 1,
                        day: new Date().getDay(),
                        month: new Date().getMonth(),
                        year: new Date().getFullYear(),
                    };
                    await Dashboard_entity_1.Dashboard.create(defaultData);
                }
            }
            return Object.assign(channelTransformed, { favorite: favorite });
        }
        catch (e) {
            console.log("Error+ ", e);
            throw new common_1.InternalServerErrorException();
        }
    }
    async getSampleOrderCount(channelId) {
        try {
            return await SampleOrder_entity_1.SampleOrder.count({
                where: {
                    buyerchannelid: channelId,
                    statusid: { [sequelize_1.Op.ne]: app_constant_1.appconstant.ORDER_STATUS_CANCELED }
                }
            });
        }
        catch (e) {
            console.log("Error+ ", e);
            throw new common_1.InternalServerErrorException();
        }
    }
    async getSampleEvaluationCount(channelId) {
        try {
            return await ProductEvaluation_entity_1.ProductEvaluation.count({
                where: {
                    channelid: channelId,
                    deletedat: null
                }
            });
        }
        catch (e) {
            console.log("Error+ ", e);
            throw new common_1.InternalServerErrorException();
        }
    }
    async getChannelContactCount(channelId, pagination, contactFilter, validateVisibility) {
        let query = 'select count(DISTINCT ct."contactId") from "tblContact" ct left join "tblContactLocation" ctl on ctl."contactId" = ct."contactId" left join "tblRegionCountryJCT" rcJCT on rcJCT."regionCountryJCTId" = ctl."regionCountryJCTId" left join (select "countryId" , "country" from "tblCountry" where "deletedAt" is null ) c on c."countryId" = rcJCT."countryId" left join "tblDocument" d on d."documentId" = ct."documentId" left join "tblUser" u on u."contactId" = ct."contactId" left join "tblUserRole" ur on ur."userId" = u."userId" left join "tblRole" r on ur."roleId" = r."roleId" where ct."channelId" = ' + channelId + ' AND ct."deletedAt" is null AND ctl."deletedAt" is null AND rcJCT."deletedAt" is null and d."deletedAt" is null and u."deletedAt" is null and ur."deletedAt" is null AND ct."isActive" = \'1\' ';
        if (lodash_1.isNull(validateVisibility) || lodash_1.isBoolean(validateVisibility) && validateVisibility) {
            query += ' AND ct."isShared" = \'' + app_constant_1.appconstant.VISIBILITY_SHARED + '\'';
        }
        if (pagination.search) {
            query = query + ' AND ( concat(ct."firstName",\' \', ct."lastName") ilike :searchName';
            query = query + ' OR ct."phone1" SIMILAR TO :search';
            query = query + ' OR ct."mobileNo" SIMILAR TO :search';
            query = query + ' OR ct."email" SIMILAR TO :search';
            query = query + ' OR ct."jobTitle" SIMILAR TO :search)';
        }
        if (contactFilter.isActive) {
            query = query + ' AND ct."isActive" = ' + "'" + contactFilter.isActive + "'";
        }
        if (contactFilter.roleId) {
            query = query + ' AND r."roleId" = ' + contactFilter.roleId;
        }
        if (contactFilter.countryId) {
            query = query + ' AND ct."contactId"  in  (select ctl1."contactId"  from  "tblContactLocation" ctl1,"tblRegionCountryJCT" rcJCT1  where rcJCT1."regionCountryJCTId" = ctl1."regionCountryJCTId" and rcJCT1."countryId" =coalesce(' + contactFilter.countryId + ' ,rcJCT1."countryId")  )';
        }
        if (contactFilter.excludeDefault) {
            query = query + ' AND ct."isDefaultContact" != ' + "'" + 1 + "'";
        }
        return await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                search: '%(' + pagination.search + ')%',
                searchName: '%' + pagination.search + '%',
            }
        }).then(contacts => {
            return contacts[0].count;
        });
    }
    async getChannelContactsList(channelId, pagination, contactFilter, validateVisibility) {
        var query = 'select (select array_to_json(array_agg(row_to_json(z))) from (select "contactSocialLink", "socialSiteId" from "tblContactSocialLink" where "deletedAt" is null and "socialSiteId" in(1) and "contactId"=ct."contactId")z) as sociallink, u."userId", ct."contactId", ct."isEvent", ct."isShared", ct."firstName", ct."lastName", ct.phone1, ct.phone2, ct."mobileNo", ct.email, ct."jobTitle", ct."isActive", ct."countryId", con."country", ct."isDefaultContact", d."documentPath", case when d."documentPath" IS NULL OR d."documentPath" = ' + "''" + ' then ' + "''" + ' else CONCAT(' + "'" + process.env.CDN_URL + "'" + ', d."documentPath") end documentUrl, r.role, r."roleId", string_agg(c."country", ' + "', '" + ') countries, array_to_json(array_agg(row_to_json(c))) countrylist from "tblContact" ct left join "tblCountry" con on con."countryId" = ct."countryId" left join "tblContactLocation" ctl on ctl."contactId" = ct."contactId" left join "tblRegionCountryJCT" rcJCT on rcJCT."regionCountryJCTId" = ctl."regionCountryJCTId" left join (select "countryId" , "country" from "tblCountry" where "deletedAt" is null ) c on c."countryId" = rcJCT."countryId" left join "tblDocument" d on d."documentId" = ct."documentId" left join "tblUser" u on u."contactId" = ct."contactId" left join "tblUserRole" ur on ur."userId" = u."userId" left join "tblRole" r on ur."roleId" = r."roleId" where ct."channelId" = ' + channelId + ' AND ct."deletedAt" is null AND ctl."deletedAt" is null AND rcJCT."deletedAt" is null and d."deletedAt" is null and u."deletedAt" is null and ur."deletedAt" is null AND ct."isActive" = \'1\' ';
        if (lodash_1.isNull(validateVisibility) || lodash_1.isBoolean(validateVisibility) && validateVisibility) {
            query += ' AND ct."isShared" = \'' + app_constant_1.appconstant.VISIBILITY_SHARED + '\'';
        }
        if (pagination.search) {
            query = query + ' AND ( concat(ct."firstName",\' \', ct."lastName") ilike :searchName';
            query = query + ' OR ct."phone1" SIMILAR TO :search';
            query = query + ' OR ct."mobileNo" SIMILAR TO :search';
            query = query + ' OR ct."email" SIMILAR TO :search';
            query = query + ' OR ct."jobTitle" SIMILAR TO :search )';
        }
        if (contactFilter.isActive) {
            query = query + ' AND ct."isActive" = ' + "'" + contactFilter.isActive + "'";
        }
        if (contactFilter.roleId) {
            query = query + ' AND r."roleId" IN (:roleId)';
        }
        if (contactFilter.countryId) {
            query = query + ' AND ct."contactId"  in  (select ctl1."contactId"  from  "tblContactLocation" ctl1,"tblRegionCountryJCT" rcJCT1  where rcJCT1."regionCountryJCTId" = ctl1."regionCountryJCTId" and rcJCT1."countryId" IN (:countryId))';
        }
        if (contactFilter.excludeDefault) {
            query = query + ' AND ct."isDefaultContact" != ' + "'" + 1 + "'";
        }
        query = query + ' group by ct."contactId", d."documentId", r."roleId", u."userId", con."country"';
        if (pagination.limit) {
            query = query + " limit :limit";
        }
        if (pagination.offset) {
            query = query + " offset :offset";
        }
        return await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            model: Contact_entity_1.Contact,
            mapToModel: true,
            replacements: {
                search: '%(' + pagination.search + ')%',
                searchName: '%' + pagination.search + '%',
                limit: pagination.limit,
                offset: pagination.offset,
                roleId: contactFilter.roleId,
                countryId: contactFilter.countryId
            }
        }).then(contacts => {
            let contactIds = [];
            if (contacts.length > 0) {
                contacts.map(function (data, index) {
                    contactIds.push(data.contactId);
                });
            }
            return { list: contacts, contactIds: contactIds };
        });
    }
    async getConnectedContactsList(contactList) {
        console.log('contactList', contactList);
        var query = 'select (select array_to_json(array_agg(row_to_json(z))) from (select "contactSocialLink", "socialSiteId" from "tblContactSocialLink" where "deletedAt" is null and "socialSiteId" in(1) and "contactId"=ct."contactId")z) as sociallink,(select "companyName" from "tblChannel" where "channelId"=ct."channelId"),u."userId", ct."contactId", ct."isEvent", ct."isShared", ct."firstName", ct."lastName", ct.phone1, ct.phone2, ct."mobileNo", ct.email, ct."jobTitle", ct."isActive", ct."countryId", con."country", ct."isDefaultContact", d."documentPath", case when d."documentPath" IS NULL OR d."documentPath" = ' + "''" + ' then ' + "''" + ' else CONCAT(' + "'" + process.env.CDN_URL + "'" + ', d."documentPath") end documentUrl, r.role, string_agg(c."country", ' + "', '" + ') countries, array_to_json(array_agg(row_to_json(c))) countrylist from "tblContact" ct left join "tblCountry" con on con."countryId" = ct."countryId" left join "tblContactLocation" ctl on ctl."contactId" = ct."contactId" left join "tblRegionCountryJCT" rcJCT on rcJCT."regionCountryJCTId" = ctl."regionCountryJCTId" left join (select "countryId" , "country" from "tblCountry" where "deletedAt" is null ) c on c."countryId" = rcJCT."countryId" left join "tblDocument" d on d."documentId" = ct."documentId" left join "tblUser" u on u."contactId" = ct."contactId" left join "tblUserRole" ur on ur."userId" = u."userId" left join "tblRole" r on ur."roleId" = r."roleId" where ct."contactId" in(:contactList) AND ct."deletedAt" is null AND ctl."deletedAt" is null AND rcJCT."deletedAt" is null and d."deletedAt" is null and u."deletedAt" is null and ur."deletedAt" is null AND ct."isActive" = \'1\' ';
        query = query + ' group by ct."contactId", d."documentId", r."roleId", u."userId", con."country"';
        return await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            model: Contact_entity_1.Contact,
            mapToModel: true,
            replacements: {
                contactList: contactList.map(x => x.contact_id)
            }
        }).then(contacts => {
            let records = [];
            if (contacts.length > 0) {
                contacts.map(x => {
                    let data = contactList.filter(con => con.contact_id == x.contactId);
                    console.log("contactList:", data);
                    let rec = {
                        channelJCTId: data[0].channeljct,
                        introVideo: data[0].introVideo,
                        isConfidential: data[0].isConfidential,
                        relationId: +data[0].relation_status,
                        channelId: +data[0].channel_id,
                        channelTypeId: +data[0].channelTypeId,
                        request: data[0].status,
                        companyName: data[0].companyName,
                        record: x
                    };
                    records.push(rec);
                });
            }
            return records;
        });
    }
    async getDefaultContact(partnerChannelId, user, channelContactFilter, onlyCompanyDefault) {
        let defaultContactId = null;
        if (!onlyCompanyDefault) {
            let myDefault = 'select "partnerContactId" FROM "tblContactJCT" CONJCT inner join "tblChannelJCT" CHJCT on CHJCT."channelJCTId" =CONJCT."channelJCTId" where ((CHJCT."partnerChannelId" =:partnerChannelId and CHJCT."channelId"=:channelId) OR (CHJCT."channelId" =:partnerChannelId and CHJCT."partnerChannelId"=:channelId)) and CONJCT."contactId" = :contactId LIMIT 1';
            defaultContactId = await this.sequelizeInstance.query(myDefault, {
                type: sequelize_1.QueryTypes.SELECT,
                replacements: {
                    partnerChannelId: partnerChannelId,
                    channelId: user.channelId,
                    contactId: user.contactId
                }
            }).then(async (result) => {
                if (result[0]) {
                    return +result[0].partnerContactId;
                }
                return null;
            });
        }
        if (lodash_1.isNull(defaultContactId)) {
            let query = 'select "contactId" from "tblUser" as tu where tu."contactId" in(select "contactId" from "tblContact" where "channelId"=:partnerChannelId and "isDefaultContact"=\'1\') and tu."userId" in(select "userId" from "tblUserRole" where "roleId"=\'1\')';
            let defaultq = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                replacements: {
                    partnerChannelId: partnerChannelId,
                }
            });
            if (defaultq.length > 0) {
                defaultContactId = defaultq[0].contactId;
            }
        }
        return defaultContactId ? defaultContactId : 0;
    }
    async getrequestid(conlist, user) {
        let contactlist = [];
        let req;
        console.log('result', conlist);
        for (var i = 0; i < conlist.length; i++) {
            let relation = {};
            let query = 'select "channelJCTId","connectionStatusTypeId","isConfidential",(select doc."documentPath" from "tblDocument" as doc  where doc."documentId"="introVideo") as introvideo from "tblChannelJCT" where "requested_to"=' + user.contactId + ' and "requested_by"=' + conlist[i].contactId + '  and "deletedat" is null ';
            let status = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT
            }).then((result) => {
                if (result.length > 0) {
                    if (result[0].connectionStatusTypeId == 7 || result[0].connectionStatusTypeId == 10)
                        req = 'IN';
                    else if (result[0].connectionStatusTypeId == 11)
                        req = 'OUT';
                    else if (result[0].connectionStatusTypeId == 1)
                        req = 'SUGGESTION';
                    else if (result[0].connectionStatusTypeId == 2)
                        req = 'CONFIRM';
                }
                return result;
            });
            console.log('status', status);
            if (status.length == 0) {
                query = 'select "channelJCTId","connectionStatusTypeId","isConfidential",(select doc."documentPath" from "tblDocument" as doc  where doc."documentId"="introVideo") as introvideo from "tblChannelJCT" where  "requested_by"=' + user.contactId + ' and "requested_to"=' + conlist[i].contactId + '  and "deletedat" is null ';
                status = await this.sequelizeInstance.query(query, {
                    type: sequelize_1.QueryTypes.SELECT
                }).then((result) => {
                    if (result.length > 0) {
                        if (result[0].connectionStatusTypeId == 7)
                            req = 'OUT';
                        else if (result[0].connectionStatusTypeId == 11)
                            req = 'SAVELATER';
                        else if (result[0].connectionStatusTypeId == 10)
                            req = 'REQUESTINTRO';
                        else if (result[0].connectionStatusTypeId == 1)
                            req = 'SUGGESTION';
                        else if (result[0].connectionStatusTypeId == 2)
                            req = 'CONFIRM';
                    }
                    return result;
                });
            }
            console.log('statuIs', status);
            if (status.length > 0 && status[0].connectionStatusTypeId != 5 && status[0].connectionStatusTypeId != 6) {
                relation = {
                    record: conlist[i],
                    channelJCTId: status[0].channelJCTId,
                    introVideo: status[0].introvideo,
                    isConfidential: status[0].isConfidential,
                    relationId: +status[0].connectionStatusTypeId,
                    request: (req) ? req : null
                };
            }
            else if (status.length == 0) {
                relation = {
                    record: conlist[i],
                    channelJCTId: null,
                    isConfidential: null,
                    introVideo: null,
                    relationId: 0,
                    request: null
                };
            }
            console.log('relation', relation);
            if (Object.keys(relation).length !== 0)
                contactlist.push(relation);
        }
        return contactlist;
    }
    async getShareTypeList() {
        try {
            let result = await this.sharetypeRepository.findAll();
            return result;
        }
        catch (e) {
            console.log("Error+", e);
            throw new common_1.InternalServerErrorException();
        }
    }
    async findById(id, productFilter) {
        let result;
        let productGroupFilter = { deletedAt: null };
        let productCategoryFilter = { deletedAt: null };
        let brandFilter = { deletedAt: null };
        if (productFilter && productFilter === 'true') {
            let productlist = await this.productRepository.findAll({
                where: {
                    channelId: id,
                    deletedat: null
                },
                include: [
                    {
                        model: this.brandRepository,
                        as: 'brand',
                        where: { deletedAt: null }
                    }, {
                        model: this.productCategoryRepository,
                        as: 'productCategory',
                        where: { deletedAt: null }
                    }, {
                        model: this.productGroupRepository,
                        as: 'productGroup',
                        where: { deletedAt: null }
                    }
                ]
            });
            let productGroupIds = [];
            let productCategoryIds = [];
            let brandIds = [];
            for (let ii = 0; ii < productlist.length; ii++) {
                productGroupIds.push(productlist[ii].productGroupId);
                productCategoryIds.push(productlist[ii].productCategorieId);
                brandIds.push(productlist[ii].brandId);
            }
            productGroupFilter['productGroupId'] = { [sequelize_1.Op.in]: productGroupIds };
            productCategoryFilter['productCategorieId'] = { [sequelize_1.Op.in]: productCategoryIds };
            brandFilter['id'] = { [sequelize_1.Op.in]: brandIds };
        }
        result = await this.channelRepository.findOne({
            where: {
                channelId: id,
                deletedAt: null
            },
            include: [
                {
                    model: Brand_entity_1.Brand, as: 'brand', required: false, where: brandFilter, through: { attributes: [], where: { deletedAt: null } }, attributes: ['id', 'brandName']
                },
                {
                    model: this.channelCustomerProfileRepository.scope('channelDetail'),
                    where: { deletedAt: null },
                    required: false,
                    include: [
                        {
                            model: this.profileTypeClassificationRepository.scope('profileTypeClassificationInfom'),
                            where: { deletedAt: null },
                            required: false,
                            include: [
                                {
                                    model: this.profileTypeRepository.scope('profileTypeInfom'),
                                    where: { deletedAt: null },
                                    required: false,
                                },
                                {
                                    model: this.channelTypeRepository.scope('channelTypeInfom')
                                }
                            ]
                        }
                    ]
                }
            ],
            attributes: ['channelId', 'channelTypeId']
        });
        if (!result) {
            throw new Process_exception_1.ProcessException('validate:field:notFound');
        }
        await new utility_1.Utility().lazyload(result, 'productGroup', {
            where: productGroupFilter,
            through: {
                attributes: [],
                where: { deletedAt: null }
            },
            attributes: ['productGroupId', 'productGroup']
        });
        await new utility_1.Utility().lazyload(result, 'productCategory', {
            where: productCategoryFilter,
            through: {
                attributes: [],
                where: { deletedAt: null }
            },
            attributes: ['productCategorieId', 'productGroupId', 'productCategorie']
        });
        await new utility_1.Utility().lazyload(result, 'locations', {
            where: {
                deletedAt: null
            }, through: { attributes: ['locationType'], where: { deletedAt: null } }, include: [
                { model: Country_entity_1.Country, required: false, attributes: ['countryId', 'country'] },
                { model: Region_entity_1.Region, required: false, attributes: ['regionId', 'region'] },
            ]
        });
        if (result.customerProfile) {
            result = result.toJSON();
            let returnObject = new Object;
            for (let ii = 0; ii < result.customerProfile.length; ii++) {
                for (let jj = 0; jj < result.customerProfile[ii].profileTypeClass.length; jj++) {
                    let resultObject = {};
                    resultObject.Channel_Customer_Profile_ID = parseInt(result.customerProfile[ii]['ChannelCustomerProfile']['customerProfileId']);
                    resultObject.Channel_Profile_ID = parseInt(result.customerProfile[ii]['profileTypeId']);
                    resultObject.Channel_Profile_Name = result.customerProfile[ii]['profileType'];
                    resultObject.name = result.customerProfile[ii]['profileType'];
                    resultObject.Channel_Type_ID = parseInt(result.customerProfile[ii].profileTypeClass[jj]['channelTypeId']);
                    resultObject.Channel_Type_Name = result.customerProfile[ii].profileTypeClass[jj]['channelType']['channelType'];
                    resultObject.Default = result.customerProfile[ii].profileTypeClass[jj]['isDefault'];
                    let propertyName = result.customerProfile[ii].profileTypeClass[jj]['channelType']['channelType'];
                    if (!returnObject[propertyName]) {
                        returnObject[propertyName] = new Array();
                        returnObject[propertyName].push(resultObject);
                    }
                    else {
                        returnObject[propertyName].push(resultObject);
                    }
                }
            }
            result['customerProfile'] = returnObject;
        }
        return result;
    }
    async getAllContacts(contact) {
        let userData = await this.contactRepository.findAll({
            attributes: ['contactId', 'firstName', 'lastName', 'jobTitle', "channelId"],
            where: {
                deletedAt: null,
                isActive: '1',
                contactId: {
                    [sequelize_1.Op.in]: contact
                }
            },
            include: [
                {
                    model: Media_entity_1.Media,
                    attributes: ['documentPath']
                },
                {
                    model: Country_entity_1.Country,
                    attributes: ['country']
                },
                {
                    model: Channel_entity_1.Channel,
                    attributes: ['companyName', "channelTypeId"],
                    include: [
                        {
                            model: ChannelDetail_entity_1.ChannelDetail,
                            attributes: ['channelLogoId'],
                            include: [
                                {
                                    model: Media_entity_1.Media,
                                    as: 'channelLogo',
                                    attributes: ['documentPath']
                                }
                            ]
                        }
                    ]
                },
            ]
        });
        return userData;
    }
    async getDashboardcount(user) {
        return await this.sequelizeInstance.query('select * from "getdashboardcounts"(:channelId,:contactId,:userId)', {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: user.channelId,
                contactId: user.contactId,
                userId: user.userId
            }
        }).then((results) => {
            return results[0].getdashboardcounts;
        });
    }
    async getSearchList1(data, userData) {
        let user = userData;
        let channelFilter = data.filter;
        let typeid = user.channelTypeId;
        let userId = user.userId;
        let filterch = [];
        let channeltype = [];
        let aggregation = {};
        let channelquery;
        if (typeid == 2)
            channeltype = [3, 4];
        else if (typeid == 3)
            channeltype = [2, 3, 4];
        else if (typeid == 4)
            channeltype = [2, 3];
        channelquery = 'select "channelId" as "channel_id" from "tblChannel" where "channelTypeId" in (:channelTypeId)';
        let result = await this.sequelizeInstance.query(channelquery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelTypeId: channeltype
            }
        }).then(x => {
            return _.uniqBy(x, 'channel_id');
        });
        if (data.search) {
            let searchchannellist = await this.sequelizeInstance.query('select "channelId" as channel_id from "tblContact" where CONCAT_WS(\' \',"firstName","lastName") ILIKE :search', {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    search: '%' + data.search + '%',
                }
            });
            let chl = searchchannellist.map(x => x.channel_id);
            result = result.filter(ch => { return chl.includes(ch.channel_id); });
        }
        if (channelFilter.typeId && result) {
            let chlist = result.map(x => +x.channel_id);
            let ctype = 'select array_agg("channelId") as ch from "tblChannel" where "channelTypeId" in(:channeltypeid) and "channelId" in(:channelid)';
            await this.sequelizeInstance.query(ctype, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelid: chlist,
                    channeltypeid: +channelFilter.typeId
                }
            }).then((result) => {
                if (result[0].ch)
                    filterch.push(...result[0].ch);
            });
            result = result.filter(ch => { return filterch.includes(ch.channel_id); });
        }
        if ((channelFilter.turnOver || channelFilter.brandId || channelFilter.locationId || channelFilter.countryId || channelFilter.specialityId || channelFilter.productCategoryId || channelFilter.retailerprofileId) && result) {
            let chlist = result.map(x => +x.channel_id);
            if (channelFilter.turnOver) {
                let query;
                if (channelFilter.turnOver == '<1M€') {
                    query = 'select array_agg("channelId") as ch from "tblChannelDetail" where "channelId" in(:channelid) and case when "turnoverRange"=\'<1M€\' or cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)<1 or "turnover"<1 then cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)<1 or "turnoverRange"=\'<1M€\' or "turnover"<1 end';
                }
                else if (channelFilter.turnOver == '1-10M€') {
                    query = 'select  array_agg("channelId") as ch from "tblChannelDetail" where "channelId" in(:channelid) and case when "turnoverRange"=\'1-10M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\'))as int)>1 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<10) or ("turnover">1 and "turnover"<10) then "turnoverRange"=\'1-10M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\'))as int)>1 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<10) or ("turnover">1 and "turnover"<10) end';
                }
                else if (channelFilter.turnOver == '10-100M€') {
                    query = 'select  array_agg("channelId") as ch from "tblChannelDetail" where "channelId" in(:channelid) and "turnoverRange"!=\'>100M€\' and case when "turnoverRange"=\'10-100M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\')) as int)>10 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<=100) or ("turnover">10 and "turnover"<=100) then "turnoverRange"=\'10-100M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\')) as int)>10 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<=100) or ("turnover">10 and "turnover"<=100) end';
                }
                else if (channelFilter.turnOver == '>100M€') {
                    query = 'select array_agg("channelId") as ch from "tblChannelDetail" where "channelId" in(:channelid) and case when "turnoverRange"=\'>100M€\' or cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)>100 or "turnover">100 then cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)>100 or "turnoverRange"=\'>100M€\' or "turnover">100 end';
                }
                await this.sequelizeInstance.query(query, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.brandId) {
                let brand = 'select array_agg("channelId") as ch from "tblChannelBrand" where "brandId" in(:brandid) and "channelId" in(:channelid)';
                await this.sequelizeInstance.query(brand, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist,
                        brandid: channelFilter.brandId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.productCategoryId) {
                await this.sequelizeInstance.query('select array_agg("channelId") as ch from "tblChannelProductCategorie" cpc where cpc."productCategorieId" in(:productcatid) and "channelId" in(:channelid) ', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        productcatid: channelFilter.productCategoryId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.retailerprofileId) {
                await this.sequelizeInstance.query('select array_agg("channelId") as ch from "tblChannelCustomerProfile" where "profileTypeId" in(:retailprofileid) and "channelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        retailprofileid: channelFilter.retailerprofileId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.countryId) {
                await this.sequelizeInstance.query('select array_agg("channelId") as ch from "tblChannel" where "countryId" in(:countryid) and "channelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        countryid: channelFilter.countryId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.specialityId) {
                await this.sequelizeInstance.query('select array_agg(distinct "channelId") as ch from "tblContact" where "contactId" in(Select "contactId" from "tblContactInterestedProductCategory" where "productCategorieId" in(:specialityid)) and "channelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        specialityid: channelFilter.specialityId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.locationId) {
                await this.sequelizeInstance.query('select array_agg("channelId") as ch from "tblChannel" where "countryId" in(:locationid) and "channelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        locationid: channelFilter.locationId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            result = result.filter(ch => { return filterch.includes(ch.channel_id); });
        }
        let total = result ? result.length : 0;
        let final = [];
        if (result) {
        }
        else
            result = [];
        let finalres = {
            result: result,
            total: total
        };
        return finalres;
    }
    async getSearchListProfile(data, userData) {
        let user = userData;
        let channelFilter = data.filter;
        let typeid = user.channelTypeId;
        let userId = user.userId;
        let filterch = [];
        let channeltype = [];
        let aggregation = {};
        let channelquery;
        if (typeid == 2)
            channeltype = [3, 4];
        else if (typeid == 3)
            channeltype = [2, 3, 4];
        else if (typeid == 4)
            channeltype = [2, 3];
        channelquery = 'select "channelId" as "channel_id" from "tblContact" where "contactId" in (:contactId)';
        let result = await this.sequelizeInstance.query(channelquery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                contactId: data.contactId
            }
        }).then(x => {
            return _.uniqBy(x, 'channel_id');
        });
        if (data.search) {
            let searchchannellist = await this.sequelizeInstance.query('select "channelId" as channel_id from "tblContact" where CONCAT_WS(\' \',"firstName","lastName") ILIKE :search', {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    search: '%' + data.search + '%',
                }
            });
            let chl = searchchannellist.map(x => x.channel_id);
            result = result.filter(ch => { return chl.includes(ch.channel_id); });
        }
        if (channelFilter.typeId && result) {
            let chlist = result.map(x => +x.channel_id);
            let ctype = 'select array_agg("channelId") as ch from "tblChannel" where "channelTypeId" in(:channeltypeid) and "channelId" in(:channelid)';
            await this.sequelizeInstance.query(ctype, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelid: chlist,
                    channeltypeid: +channelFilter.typeId
                }
            }).then((result) => {
                if (result[0].ch)
                    filterch.push(...result[0].ch);
            });
            result = result.filter(ch => { return filterch.includes(ch.channel_id); });
        }
        if ((channelFilter.turnOver || channelFilter.brandId || channelFilter.locationId || channelFilter.countryId || channelFilter.specialityId || channelFilter.productCategoryId || channelFilter.retailerprofileId) && result) {
            let chlist = result.map(x => +x.channel_id);
            if (channelFilter.turnOver) {
                let query;
                if (channelFilter.turnOver == '<1M€') {
                    query = 'select array_agg("channelId") as ch from "tblChannelDetail" where "channelId" in(:channelid) and case when "turnoverRange"=\'<1M€\' or cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)<1 or "turnover"<1 then cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)<1 or "turnoverRange"=\'<1M€\' or "turnover"<1 end';
                }
                else if (channelFilter.turnOver == '1-10M€') {
                    query = 'select  array_agg("channelId") as ch from "tblChannelDetail" where "channelId" in(:channelid) and case when "turnoverRange"=\'1-10M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\'))as int)>1 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<10) or ("turnover">1 and "turnover"<10) then "turnoverRange"=\'1-10M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\'))as int)>1 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<10) or ("turnover">1 and "turnover"<10) end';
                }
                else if (channelFilter.turnOver == '10-100M€') {
                    query = 'select  array_agg("channelId") as ch from "tblChannelDetail" where "channelId" in(:channelid) and "turnoverRange"!=\'>100M€\' and case when "turnoverRange"=\'10-100M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\')) as int)>10 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<=100) or ("turnover">10 and "turnover"<=100) then "turnoverRange"=\'10-100M€\' or (cast((substring("turnoverRange" FROM \'[0-9]+\')) as int)>10 and cast(substring("turnoverRange" FROM \'[0-9]+\') as int)<=100) or ("turnover">10 and "turnover"<=100) end';
                }
                else if (channelFilter.turnOver == '>100M€') {
                    query = 'select array_agg("channelId") as ch from "tblChannelDetail" where "channelId" in(:channelid) and case when "turnoverRange"=\'>100M€\' or cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)>100 or "turnover">100 then cast(substring("turnoverRange" FROM \'[0-9]+\')as integer)>100 or "turnoverRange"=\'>100M€\' or "turnover">100 end';
                }
                await this.sequelizeInstance.query(query, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.brandId) {
                let brand = 'select array_agg("channelId") as ch from "tblChannelBrand" where "brandId" in(:brandid) and "channelId" in(:channelid)';
                await this.sequelizeInstance.query(brand, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        brandid: channelFilter.brandId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.productCategoryId) {
                await this.sequelizeInstance.query('select array_agg("channelId") as ch from "tblChannelProductCategorie" cpc where cpc."productCategorieId" in(:productcatid) and "channelId" in(:channelid) ', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        productcatid: channelFilter.productCategoryId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.retailerprofileId) {
                await this.sequelizeInstance.query('select array_agg("channelId") as ch from "tblChannelCustomerProfile" where "profileTypeId" in(:retailprofileid) and "channelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        retailprofileid: channelFilter.retailerprofileId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.countryId) {
                await this.sequelizeInstance.query('select array_agg("channelId") as ch from "tblChannel" where "countryId" in(:countryid) and "channelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        countryid: channelFilter.countryId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.specialityId) {
                await this.sequelizeInstance.query('select array_agg(distinct "channelId") as ch from "tblContact" where "contactId" in(Select "contactId" from "tblContactInterestedProductCategory" where "productCategorieId" in(:specialityid)) and "channelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        specialityid: channelFilter.specialityId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.locationId) {
                await this.sequelizeInstance.query('select array_agg("channelId") as ch from "tblChannel" where "countryId" in(:locationid) and "channelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        locationid: channelFilter.locationId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            result = result.filter(ch => { return filterch.includes(ch.channel_id); });
        }
        let total = result ? result.length : 0;
        let final = [];
        if (result.length) {
            let cha = result.map(x => x.channel_id);
            let qu = 'select "contactId" from "tblContact" where "contactId" in (:contactId) and "channelId" in (:channelId) ';
            qu += ' and "contactId" not in (select "requested_to" from "tblChannelJCT" where "requested_by"=' + user.contactId + '  and "requested_to" in (:contactId) and "connectionStatusTypeId" in(5,6)and "deletedat" is null)';
            qu += ' and "contactId" not in (select "requested_by" from "tblChannelJCT" where "requested_to"=' + user.contactId + '  and "requested_by" in (:contactId) and "connectionStatusTypeId" in(5,6)and "deletedat" is null)';
            final = await this.sequelizeInstance.query(qu, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelId: cha,
                    contactId: data.contactId
                }
            });
        }
        else
            result = [];
        let finalres = {
            result: final,
            total: final.length
        };
        return finalres;
    }
    async billingAddress(user) {
        return await Channel_entity_1.Channel.findAll({
            where: {
                channelId: user.channelId,
            },
            include: [
                {
                    model: Address_entity_1.Address,
                    as: 'billAddress',
                    include: [
                        {
                            model: Country_entity_1.Country,
                            as: 'country',
                            attributes: ['country']
                        }
                    ],
                    required: true
                }
            ]
        });
    }
    async mapOrder(array, order, key) {
        array.sort(function (a, b) {
            var A = a[key], B = b[key];
            if (order.indexOf(A) > order.indexOf(B)) {
                return 1;
            }
            else {
                return -1;
            }
        });
        return array;
    }
    ;
    async isEvent(ContactId, isEvent) {
        return await this.contactRepository.update({ isEvent: isEvent }, {
            where: {
                contactId: ContactId,
            },
            returning: true
        });
    }
    async setEventParticipantStatus(eventId, channelId, ContactId) {
        return await EventParticipants_entity_1.EventParticipants.update({ status: '1' }, {
            where: {
                contactId: ContactId,
                channelId: channelId,
                eventId: eventId,
                deletedAt: null
            },
            returning: true
        });
    }
    async getEventListing(channelId, contactId) {
        let result;
        let res = await EventBo_entity_1.EventBo.findAll({
            where: {
                deletedAt: null
            },
            include: [
                {
                    model: Country_entity_1.Country,
                    attributes: ['countryId', 'country'],
                    required: false
                },
                {
                    model: Media_entity_1.Media,
                    as: 'logo',
                    attributes: ['documentId', 'documentPath'],
                    where: {
                        deletedAt: null
                    },
                    required: false
                },
                {
                    model: Media_entity_1.Media,
                    as: 'banner',
                    attributes: ['documentId', 'documentPath'],
                    where: {
                        deletedAt: null
                    },
                    required: false
                },
                {
                    model: EventChannel_entity_1.EventChannel,
                    where: {
                        channelId: channelId
                    },
                    include: [
                        {
                            model: EventPackage_entity_1.EventPackage,
                            required: false
                        }
                    ],
                    required: false
                },
            ]
        }).then(res => res);
        let list = [];
        if (res) {
            res.map(x => {
                var _a;
                let temp = {
                    event_name: x.name,
                    eventId: x.id,
                    event_catalyst_id: x.eventCatalystId,
                    date_start: x.fromDate,
                    date_end: x.toDate,
                    description: x.description,
                    location: x.country.country,
                    logo: x.logo.documentPath,
                    status: "",
                    statusDate: "",
                    type: "",
                    channel: ((_a = x.channels) === null || _a === void 0 ? void 0 : _a.length) ? x.channels[0] : null
                };
                list.push(temp);
            });
        }
        result = { registrations: list };
        return result;
    }
    async getEventPackages(user, eventId) {
        let result;
        result = await EventPackage_entity_1.EventPackage.findAll({
            where: {
                eventId: eventId,
                channelType: user.channelTypeId,
                isSeller: user.channelTypeId == '2' ? '1' : '0',
                isBuyer: user.channelTypeId != '2' ? '1' : '0',
                deletedAt: null
            },
            order: [
                ['price', 'ASC']
            ]
        });
        return result;
    }
    async getEventChannelDetails(channelId, eventId) {
        let result = { participants: [], contacts: [] };
        let participantQuery = 'select tc."contactId" as "id", concat(tc."firstName",  \' \', tc."lastName") as "name", td."documentPath", tpar."eventParticipantId" from "tblEventParticipants" tpar inner join "tblContact" tc on tc."contactId"=tpar."contactId" left join "tblDocument" td on td."documentId"=tc."documentId" where tpar."channelId"=:channelId and tpar."eventId"=:eventId';
        result.participants = await this.sequelizeInstance.query(participantQuery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: channelId,
                eventId: eventId
            }
        }).then(res => res);
        let contactsQuery = 'select tc."contactId" as "id", concat(tc."firstName", \' \', tc."lastName") as "name", td."documentPath"  from "tblContact" tc left join "tblDocument" td on td."documentId"=tc."documentId" where tc."channelId"=:channelId and tc."deletedAt" is null';
        result.contacts = await this.sequelizeInstance.query(contactsQuery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: channelId,
            }
        });
        return result;
    }
    async postEventRegistraion(user, data) {
        let eventchanneldata = {
            channelId: user.channelId,
            eventId: +data.eventId,
            isNew: '0',
            packageId: data.packageId,
            additionalMembers: data.additionalMembers,
            paymenttransactionId: data.paymentTransactionId,
            paymentstatus: data.paymentStatus,
            paymentMethod: data.paymentMethod
        };
        await EventChannel_entity_1.EventChannel.findOrCreate({ where: { channelId: user.channelId, eventId: data.eventId }, defaults: eventchanneldata }).then((result) => {
            if (!result[1]) {
                result[0].update(eventchanneldata);
            }
        });
        let contactId = data.contactId;
        let channelId = user.channelId;
        let eventId = data.eventId;
        let participantType = user.channelTypeId == '2' ? '1' : '2';
        let channelType = user.channelTypeId;
        let packageId = data.packageId;
        let registeredQuery = 'select "contactId", "eventParticipantId", status from "tblEventParticipants" where "channelId"=:channelId and "eventId"=:eventId  and "deletedAt" is null';
        let oldIds = await this.sequelizeInstance.query(registeredQuery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: channelId,
                eventId: eventId
            }
        });
        let activeId = [];
        oldIds.map(x => {
            contactId.map(y => {
                if (x.contactId == y)
                    activeId.push(y);
            });
        });
        await EventParticipants_entity_1.EventParticipants.destroy({ where: {
                eventId: eventId,
                channelId: channelId,
                contactId: {
                    [sequelize_1.Op.notIn]: activeId
                }
            } });
        console.log('activeId', activeId);
        let newRegisteredUsers = [];
        if (activeId.length)
            contactId.map(x => {
                if (activeId.filter(y => x == y).length == 0)
                    newRegisteredUsers.push(x);
            });
        else
            newRegisteredUsers = contactId;
        if (newRegisteredUsers.length) {
            let newContacts = newRegisteredUsers.map(x => {
                let data = { contactId: +x, channelId: +channelId, eventId: +eventId, channelType: +channelType, participantType: +participantType, packageId: +packageId };
                return data;
            });
            console.log('new users', newContacts);
            await EventParticipants_entity_1.EventParticipants.bulkCreate(newContacts);
        }
        return true;
    }
    async foToEventCatalyst(contacts) {
        let query = 'select (select concat(\'https://d35w8j22j5uly8.cloudfront.net\',"documentPath") from "tblDocument" where "documentId"=tcon."documentId") as profileImage, '
            + ' "firstName","lastName","jobTitle","contactId",tcon."mobileNo",tcon."email",tc."companyName",tc."channelId" as companyId, cd."detailDesc",case when tc."channelTypeId"=2 then \'Vendor\' when tc."channelTypeId"=3 then \'Distributor\' when tc."channelTypeId"=4 then \'Retailer\' end as channelType, '
            + ' (select concat(\'https://d35w8j22j5uly8.cloudfront.net\',"documentPath") from "tblDocument" where "documentId"=cd."channelLogoId") as companyLogo, '
            + '\'3e683a61-992b-47d2-8ecf-f88c9849f499\' as eventId,\'Confirmed\' as status, '
            + ' case when tc."channelTypeId"=2 then \'Vendor\' when tc."channelTypeId" in(3,4) then \'Buyer\' end as type, '
            + ' (select "country" from "tblCountry" where "countryId"=tc."countryId"),'
            + ' (select "isoCode" from "tblCountry" where "countryId"=tc."countryId"),(select string_agg("productCategorie",\',\') from "tblProductCategories" where "productCategorieId" in '
            + '(Select cpc."productCategorieId" from "tblContactInterestedProductCategory" cpc where cpc."contactId" = tcon."contactId"))as "IntrestedCategory", '
            + '(select string_agg("productCategorie",\',\') from "tblProductCategories" where "productCategorieId" in '
            + '(Select cpc."productCategorieId" from "tblContactProductCategorie" cpc where cpc."contactId" = tcon."contactId")) as "ExistingCategory", '
            + '(select "profileType" from "tblProfileType" where "profileTypeId"=tc."profileTypeId") as "ProfileType", '
            + '(select string_agg(pt."profileType",\',\') from "tblProfileType" pt where "profileTypeId" in (select "profileTypeId" from "tblChannelCustomerProfile" as ccp where ccp."channelId"=tc."channelId")) as "Retail_Customer_Profile", '
            + '(select "password" from "tblUser" where "contactId"=tcon."contactId") '
            + 'from "tblContact" tcon inner join "tblChannel" tc on tc."channelId"=tcon."channelId"	inner join "tblChannelDetail" cd on cd."channelId"=tcon."channelId" where tcon."contactId" in (:contactId)';
        let result;
        if (contacts.length) {
            result = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                replacements: {
                    contactId: contacts
                }
            });
        }
        return result;
    }
    async getSelectedEventDetails(user, eventId) {
        let result = await EventChannel_entity_1.EventChannel.findOne({
            where: {
                channelId: user.channelId,
                eventId: eventId,
                deletedAt: null
            }
        }).then(res => {
            return res[0];
        });
        return result;
    }
    async eventRegistration(user) {
    }
    async getPendingEvent() {
        return await EventChannel_entity_1.EventChannel.findAndCountAll({
            where: {
                paymentstatus: '0',
                paymentMethod: 2,
                deletedAt: null
            },
            include: [
                {
                    model: EventPackage_entity_1.EventPackage,
                    required: false,
                },
                {
                    model: EventBo_entity_1.EventBo,
                    required: false
                },
                {
                    model: Channel_entity_1.Channel,
                    required: false
                }
            ]
        }).then(res => res);
    }
    async updateEventChannel(req) {
        return await EventChannel_entity_1.EventChannel.update({ paymentstatus: req.status }, {
            where: {
                id: req.eventChannelId,
            },
            returning: true
        });
    }
    async getContactDetail(contactId) {
        try {
            let contactDetails = await this.contactRepository.findOne({
                where: {
                    contactId: contactId,
                    deletedAt: null
                },
                include: [
                    {
                        model: Media_entity_1.Media, as: 'document', required: false, where: {
                            deletedAt: null
                        }
                    },
                    {
                        model: this.countryRepository,
                        required: false
                    },
                    {
                        model: ProductGroup_entity_1.ProductGroup, as: 'productGroups', required: false, through: {
                            attributes: [],
                            where: {
                                deletedAt: null
                            }
                        }, attributes: [
                            'productGroupId', 'productGroup'
                        ]
                    }
                ]
            }).then(async (result) => {
                return result;
            });
            await new utility_1.Utility().lazyload(contactDetails, 'productCategories', {
                through: {
                    attributes: [],
                    where: {
                        deletedAt: null
                    }
                }, attributes: [
                    'productCategorieId', 'productGroupId', 'productCategorie'
                ]
            });
            await new utility_1.Utility().lazyload(contactDetails, 'IntProductCategories', {
                through: {
                    attributes: [],
                    where: {
                        deletedAt: null
                    }
                }, attributes: [
                    'productCategorieId', 'productGroupId', 'productCategorie'
                ]
            });
            await new utility_1.Utility().lazyload(contactDetails, 'locations', {
                through: {
                    attributes: ['locationType'],
                    where: {
                        deletedAt: null
                    }
                }, include: [
                    {
                        model: Country_entity_1.Country,
                        required: false,
                        attributes: [
                            'countryId', 'country'
                        ]
                    }
                ]
            });
            return contactDetails;
        }
        catch (e) {
            console.log("Error+ ", e);
            throw new common_1.InternalServerErrorException();
        }
    }
};
ChannelService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject('SequelizeInstance')),
    __param(1, common_1.Inject('ChannelRepository')),
    __param(2, common_1.Inject('SignUpStatusRepository')),
    __param(3, common_1.Inject('ChannelTypeRepository')),
    __param(4, common_1.Inject('ProductGroupRepository')),
    __param(5, common_1.Inject('ProductCategoryRepository')),
    __param(6, common_1.Inject('ProfileTypeRepository')),
    __param(7, common_1.Inject('ContactJCTRepository')),
    __param(8, common_1.Inject('SubscriptionRepository')),
    __param(9, common_1.Inject('MediaRepository')),
    __param(10, common_1.Inject('ChannelCertificateTypeRepository')),
    __param(11, common_1.Inject('ProductRepository')),
    __param(12, common_1.Inject('SharetypeRepository')),
    __param(13, common_1.Inject('ChannelCustomerProfileRepository')),
    __param(14, common_1.Inject('ProfileTypeClassificationRepository')),
    __param(15, common_1.Inject('BrandRepository')),
    __param(16, common_1.Inject('ContactRepository')),
    __param(18, common_1.Inject('CompanyMediaImagesRepository')),
    __param(19, common_1.Inject('CountryRepository')),
    __metadata("design:paramtypes", [Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, channelKeyPartner_service_1.ChannelKeyPartnerService, Object, Object])
], ChannelService);
exports.ChannelService = ChannelService;
//# sourceMappingURL=channel.service.js.map