"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChannelSettingService = void 0;
const common_1 = require("@nestjs/common");
const context_service_1 = require("../../../context/context.service");
const Process_exception_1 = require("../../../middleware/exception/Process.exception");
const ProductGroup_entity_1 = require("../../product/models/ProductGroup.entity");
const Brand_entity_1 = require("../../product/models/Brand.entity");
const ProductCategory_entity_1 = require("../../product/models/ProductCategory.entity");
const Country_entity_1 = require("../../common/models/Country.entity");
const Region_entity_1 = require("../../common/models/Region.entity");
const RegionCountryJCT_entity_1 = require("../../common/models/RegionCountryJCT.entity");
const sequelize_1 = require("sequelize");
const index_1 = require("../../media/models/index");
const ContactInterestedProductGroup_entity_1 = require("../../user/models/ContactInterestedProductGroup.entity");
const ContactInterestedProductCategory_entity_1 = require("../../user/models/ContactInterestedProductCategory.entity");
const User_entity_1 = require("../../user/models/User.entity");
const Contact_entity_1 = require("../../user/models/Contact.entity");
const product_service_1 = require("../../product/service/product.service");
const app_constant_1 = require("../../../config/app.constant");
const lodash_1 = require("lodash");
const ContactLocation_entity_1 = require("../../user/models/ContactLocation.entity");
const tradeInformationInBound_1 = require("../transformation/tradeInformationInBound");
const ContactProductGroup_entity_1 = require("../../user/models/ContactProductGroup.entity");
const ContactProductCategory_entity_1 = require("../../user/models/ContactProductCategory.entity");
const ChannelKeyPartner_entity_1 = require("../models/ChannelKeyPartner.entity");
const KeyPartnerJCT_entity_1 = require("../models/KeyPartnerJCT.entity");
const OldChannel_entity_1 = require("../models/OldChannel.entity");
const OldChannelDetail_entity_1 = require("../models/OldChannelDetail.entity");
const OldAddress_entity_1 = require("../models/OldAddress.entity");
const Zone_entity_1 = require("../../common/models/Zone.entity");
const Product_entity_1 = require("../../product/models/Product.entity");
const ProductPriceDetail_entity_1 = require("../../product/models/ProductPriceDetail.entity");
const ProductTag_entity_1 = require("../../product/models/ProductTag.entity");
const InterestedProductGroup_entity_1 = require("../../user/models/InterestedProductGroup.entity");
const InterestedProductCategory_entity_1 = require("../../user/models/InterestedProductCategory.entity");
const Auth_exception_1 = require("../../../middleware/exception/Auth.exception");
const CertificateTag_entity_1 = require("../models/CertificateTag.entity");
var _ = require('lodash');
let ChannelSettingService = class ChannelSettingService {
    constructor(productService, sequelizeInstance, channelRepository, channelDetailRepository, channelBrandRepository, channelCustProfileRepository, channelCertiRepository, settingRepository, profileRepository, userRepository, contactRepository, channelProductGroupRepository, productGroupRepository, brandRepository, productCatRepository, channelCatRepository, contactGroupRepository, contactCatRepository, intrestedGroupRepository, intrestedCatRepository, profileTypeRepository, profileTypeClassiRepository, countryRepository, regionRepository, regCtyJCTRepository, channelLocationRepository, contactLocationRepository, channelDocumentRepository, mediaRepository, socialLinkRepository, addressRepository, awardRepository, channelProductCategorieRepository, channelCustomerProfileRepository, channelServiceListRepository, channelSpecialityRepository, serviceListRepository, mediaTypeRepository, channelB2BRepository, currencyRepository, channelPaymentOptionTypeRepository, channelPaymentTermRepository, channelSharePreferenceRepository, channelSubscriptionRepository, subscriptionPlanRepository, subscriptionRepository, zoneRepository, userWalletAmountRepository, productRepository, companyMediaImagesRepository, endCustomersB2bRepository, guestRequirementRepository, context) {
        this.productService = productService;
        this.sequelizeInstance = sequelizeInstance;
        this.channelRepository = channelRepository;
        this.channelDetailRepository = channelDetailRepository;
        this.channelBrandRepository = channelBrandRepository;
        this.channelCustProfileRepository = channelCustProfileRepository;
        this.channelCertiRepository = channelCertiRepository;
        this.settingRepository = settingRepository;
        this.profileRepository = profileRepository;
        this.userRepository = userRepository;
        this.contactRepository = contactRepository;
        this.channelProductGroupRepository = channelProductGroupRepository;
        this.productGroupRepository = productGroupRepository;
        this.brandRepository = brandRepository;
        this.productCatRepository = productCatRepository;
        this.channelCatRepository = channelCatRepository;
        this.contactGroupRepository = contactGroupRepository;
        this.contactCatRepository = contactCatRepository;
        this.intrestedGroupRepository = intrestedGroupRepository;
        this.intrestedCatRepository = intrestedCatRepository;
        this.profileTypeRepository = profileTypeRepository;
        this.profileTypeClassiRepository = profileTypeClassiRepository;
        this.countryRepository = countryRepository;
        this.regionRepository = regionRepository;
        this.regCtyJCTRepository = regCtyJCTRepository;
        this.channelLocationRepository = channelLocationRepository;
        this.contactLocationRepository = contactLocationRepository;
        this.channelDocumentRepository = channelDocumentRepository;
        this.mediaRepository = mediaRepository;
        this.socialLinkRepository = socialLinkRepository;
        this.addressRepository = addressRepository;
        this.awardRepository = awardRepository;
        this.channelProductCategorieRepository = channelProductCategorieRepository;
        this.channelCustomerProfileRepository = channelCustomerProfileRepository;
        this.channelServiceListRepository = channelServiceListRepository;
        this.channelSpecialityRepository = channelSpecialityRepository;
        this.serviceListRepository = serviceListRepository;
        this.mediaTypeRepository = mediaTypeRepository;
        this.channelB2BRepository = channelB2BRepository;
        this.currencyRepository = currencyRepository;
        this.channelPaymentOptionTypeRepository = channelPaymentOptionTypeRepository;
        this.channelPaymentTermRepository = channelPaymentTermRepository;
        this.channelSharePreferenceRepository = channelSharePreferenceRepository;
        this.channelSubscriptionRepository = channelSubscriptionRepository;
        this.subscriptionPlanRepository = subscriptionPlanRepository;
        this.subscriptionRepository = subscriptionRepository;
        this.zoneRepository = zoneRepository;
        this.userWalletAmountRepository = userWalletAmountRepository;
        this.productRepository = productRepository;
        this.companyMediaImagesRepository = companyMediaImagesRepository;
        this.endCustomersB2bRepository = endCustomersB2bRepository;
        this.guestRequirementRepository = guestRequirementRepository;
        this.context = context;
        this.tradeInformationInBound = new tradeInformationInBound_1.TradeInformationInBound();
    }
    async getProfileList(typeId, channelId) {
        let query = 'select "order","icon","heading","desc",rat."value", '
            + '(select "isCompleted" from "tblProfileList" where "ratingId"=rat."order" and "channelId"=:channelId and "deletedAt" is null) as "isCompleted" '
            + 'from "tblProfileCreationRatings" as rat where rat."channelType"=:typeId and rat."deletedAt" is null  ';
        let level = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: channelId,
                typeId: typeId
            }
        }).then(results => {
            let status = results.filter(x => x.isCompleted).length;
            if ((typeId == 3 || typeId == 4 || typeId == 5) && status == 2) {
                results = results.map(x => {
                    x.isCompleted = true;
                    return x;
                });
            }
            return results;
        });
        return level;
    }
    async getUserStatus(channelId, typeId) {
        let count = 'select count(*) as profile_completion_count from "tblProfileList" where "isCompleted"=true and  "channelId"=:channelId and "ratingId" in(:ratingId) and "deletedAt" is null';
        let profile_completion_count = await this.sequelizeInstance.query(count, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: channelId,
                ratingId: typeId == 2 ? [1, 2, 3, 5] : [1, 2]
            }
        }).then(x => {
            return x[0].profile_completion_count;
        });
        return profile_completion_count;
    }
    async save_Company_Profile(data) {
        let ChannelSpecialityObject = [];
        let channelDetail = {
            estYear: data.yearEstablished,
            startup: data.areYouStartUp,
            empCntRange: data.no_of_staffs,
            turnoverRange: data.annualTurnOver,
            maturitylevel: data.maturitylevel,
            channelLogoId: +data.companyLogo,
            detailDesc: data.tweetPitch,
            companyDesc: data === null || data === void 0 ? void 0 : data.companyDescription,
            introvideoId: data.introVideo,
            no_of_skus: (data.typeId == 2) ? data.no_of_skus : 0,
            storeCount: (data.typeId == 4) ? data.no_of_skus : null,
        };
        let certificate = [];
        if (data.companyRegNumber != '')
            certificate.push({ channelId: data.channelId, cerificateTypeId: 1, cerificateName: data.certificateName, cerificateNumber: data.companyRegNumber });
        if (data.vatNumber != null && data.vatNumber != '')
            certificate.push({ channelId: data.channelId, cerificateTypeId: 2, cerificateName: 'VAT', cerificateNumber: data.vatNumber });
        return this.sequelizeInstance.transaction(async (transaction) => {
            return await this.channelCertiRepository.bulkCreate(certificate, {
                transaction,
            }).then(async (certiObject) => {
                var _a, _b;
                await this.channelDetailRepository.update(channelDetail, {
                    where: {
                        channelId: data.channelId
                    },
                    returning: true,
                    transaction
                });
                if (data.typeId == 3 && data.relevantDistributorProfile) {
                    let ChannelProfileTypes = await this.setChannelProfile(data.relevantDistributorProfile, +data.channelId);
                    await this.channelCustProfileRepository.bulkCreate(ChannelProfileTypes, { returning: true, transaction });
                    await this.channelRepository.update({ profileTypeId: data.relevantDistributorProfile[0].profileTypeId }, {
                        where: {
                            channelId: data.channelId
                        }
                    });
                }
                if (data.brands.length > 0) {
                    let channelBrandObject = await this.saveBrand(data.brands, data.channelId, transaction);
                    if (channelBrandObject.channelBrandArrayObject.length > 0) {
                        await this.channelBrandRepository.bulkCreate(channelBrandObject.channelBrandArrayObject, { returning: true, transaction });
                        await this.brandRepository.update({
                            isAssigned: '1'
                        }, {
                            where: {
                                id: {
                                    [sequelize_1.Op.in]: channelBrandObject.brandIds
                                }
                            },
                            returning: true, transaction
                        });
                    }
                }
                let ChannelProfileTypes = await this.setChannelProfile(data.relevantChannelProfile, +data.channelId);
                await this.channelCustProfileRepository.bulkCreate(ChannelProfileTypes, { returning: true, transaction });
                if (data.typeId == '4') {
                    await this.channelRepository.update({ profileTypeId: data.relevantChannelProfile[0].profileTypeId }, {
                        where: {
                            channelId: data.channelId
                        }
                    });
                }
                let channelContacts = await this.contactRepository.scope('basicInfom').findAll({
                    where: {
                        deletedAt: null,
                        contactId: { [sequelize_1.Op.ne]: data.contactId },
                        channelId: data.channelId
                    }
                });
                let contacts = [];
                contacts.push(data.contactId);
                if (channelContacts.length > 0) {
                    channelContacts.map(function (data) {
                        contacts.push(data.contactId);
                    });
                }
                if (ChannelSpecialityObject.length > 0) {
                    let speciality = await this.channelSpecialityRepository.findAll({
                        where: {
                            channelId: data.channelId,
                            deletedAt: null
                        }
                    });
                    let ChannelSpecialityIds = await this.tradeInformationInBound.setProductGroupIds(speciality);
                    let ChannelSpecialityCurrentIds = [];
                    let ChannelSpecialityCreateObject = [];
                    for (let kk = 0; kk < ChannelSpecialityObject.length; kk++) {
                        if (ChannelSpecialityIds.includes(ChannelSpecialityObject[kk].productGroupId)) {
                            ChannelSpecialityCurrentIds.push(ChannelSpecialityObject[kk].productGroupId);
                        }
                        else {
                            ChannelSpecialityCreateObject.push(ChannelSpecialityObject[kk]);
                            ChannelSpecialityCurrentIds.push(ChannelSpecialityObject[kk].productGroupId);
                        }
                    }
                    if (ChannelSpecialityCreateObject.length > 0) {
                        await this.channelSpecialityRepository.bulkCreate(ChannelSpecialityCreateObject, { returning: true, transaction });
                    }
                    await this.channelSpecialityRepository.update({ deletedAt: new Date() }, {
                        where: {
                            channelId: data.channelId,
                            productGroupId: { [sequelize_1.Op.notIn]: ChannelSpecialityCurrentIds },
                            deletedAt: null
                        }, returning: true, transaction
                    });
                }
                if (data.social_linkedin_id) {
                    await this.socialLinkRepository.update({
                        socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_LINKEDIN,
                        channelId: data.channelId,
                        channelSocialLink: data.social_linkedin_url
                    }, {
                        where: { channelSocialLinkId: data.social_linkedin_id },
                        returning: true, transaction,
                    });
                }
                else {
                    if (data.social_linkedin_url && Object.keys(data.social_linkedin_url).length > 0) {
                        await this.socialLinkRepository.create({
                            socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_LINKEDIN,
                            channelId: data.channelId,
                            channelSocialLink: data.social_linkedin_url
                        }, {
                            transaction
                        });
                    }
                }
                if (data.social_googleplus_id) {
                    await this.socialLinkRepository.update({
                        socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_GOOGLEPLUS,
                        channelId: data.channelId,
                        channelSocialLink: data.social_googleplus_url
                    }, {
                        where: { channelSocialLinkId: data.social_googleplus_id },
                        returning: true, transaction,
                    });
                }
                else {
                    if (data.social_googleplus_url && Object.keys(data.social_googleplus_url).length > 0) {
                        await this.socialLinkRepository.create({
                            socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_GOOGLEPLUS,
                            channelId: data.channelId,
                            channelSocialLink: data.social_googleplus_url
                        }, {
                            transaction
                        });
                    }
                }
                if (data.social_instagram_id) {
                    await this.socialLinkRepository.update({
                        channelId: data.channelId,
                        channelSocialLink: data.social_instagram_url
                    }, {
                        where: { channelSocialLinkId: data.social_instagram_id },
                        returning: true, transaction,
                    });
                }
                else {
                    if (data.social_instagram_url && Object.keys(data.social_instagram_url).length > 0) {
                        await this.socialLinkRepository.create({
                            socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_INSTAGRAM,
                            channelId: data.channelId,
                            channelSocialLink: data.social_instagram_url
                        }, {
                            transaction
                        });
                    }
                }
                if (data.social_twitter_id) {
                    await this.socialLinkRepository.update({
                        channelId: data.channelId,
                        channelSocialLink: data.social_twitter_url
                    }, {
                        where: { channelSocialLinkId: data.social_twitter_id },
                        returning: true, transaction,
                    });
                }
                else {
                    if (data.social_twitter_url && Object.keys(data.social_twitter_url).length > 0) {
                        await this.socialLinkRepository.create({
                            socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_TWITTER,
                            channelId: data.channelId,
                            channelSocialLink: data.social_twitter_url
                        }, {
                            transaction
                        });
                    }
                }
                if (data.social_facebook_id) {
                    await this.socialLinkRepository.update({
                        channelId: data.channelId,
                        channelSocialLink: data.social_facebook_url
                    }, {
                        where: { channelSocialLinkId: data.social_facebook_id },
                        returning: true, transaction,
                    });
                }
                else {
                    if (data.social_facebook_url && Object.keys(data.social_facebook_url).length > 0) {
                        await this.socialLinkRepository.create({
                            socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_FACEBOOK,
                            channelId: data.channelId,
                            channelSocialLink: data.social_facebook_url
                        }, {
                            transaction
                        });
                    }
                }
                if (data.B2B_url && Object.keys(data.B2B_url).length > 0) {
                    for (let ii = 0; ii < data.B2B_url.length; ii++) {
                        if (data.B2B_url[ii].channel_B2B_id) {
                            await this.channelB2BRepository.update({
                                channelId: data.channelId,
                                channelB2B: data.B2B_url[ii].B2B_url
                            }, {
                                where: { channelB2BId: data.B2B_url[ii].channel_B2B_id },
                                returning: true, transaction,
                            });
                        }
                        else {
                            await this.channelB2BRepository.create({
                                channelId: data.channelId,
                                channelB2B: data.B2B_url[ii].B2B_url
                            }, {
                                transaction
                            });
                        }
                    }
                }
                if (data.channel_document && Object.keys(data.channel_document).length > 0) {
                    for (let ii = 0; ii < data.channel_document.length; ii++) {
                        if (data.channel_document[ii].channelDocumentId) {
                            await this.channelDocumentRepository.update({
                                channelId: data.channelId,
                                documentId: data.channel_document[ii].documentId,
                                name: _.defaultTo(data.channel_document[ii].documentName, ''),
                                description: _.defaultTo(data.channel_document[ii].documentDescription, ''),
                                updatedBy: data.userId
                            }, {
                                where: { channelDocumentId: data.channel_document[ii].channelDocumentId },
                                returning: true, transaction,
                            });
                        }
                        else {
                            await this.channelDocumentRepository.create({
                                channelId: data.channelId,
                                documentId: data.channel_document[ii].documentId,
                                name: _.defaultTo(data.channel_document[ii].documentName, ''),
                                description: _.defaultTo(data.channel_document[ii].documentDescription, ''),
                                updatedBy: data.userId
                            }, {
                                transaction
                            });
                        }
                    }
                }
                if (data.award_details && Object.keys(data.award_details).length > 0) {
                    for (let ii = 0; ii < data.award_details.length; ii++) {
                        let valid_upto = (data.award_details[ii].valid_upto) ? data.award_details[ii].valid_upto : null;
                        if (data.award_details[ii].channel_award_id) {
                            let documentId = null, documentPath = null;
                            if (data.award_details[ii].image) {
                                if (data.award_details[ii].image.includes('/product/awards/')) {
                                    documentId = data.award_details[ii].documentId;
                                }
                                else {
                                    let media = {};
                                    media.documentTypeId = app_constant_1.appconstant.DOCUMENTTYPE_IMAGE;
                                    media.documentPath = (data.award_details[ii].image) ? data.award_details[ii].image : null;
                                    media.dirName = app_constant_1.appconstant.FOLDER_PATH_PRODUCT_AWARDS;
                                    let logo = await this.imageCreate(media, transaction);
                                    documentId = logo.documentId;
                                    if (data.award_details[ii].documentId) {
                                        await this.mediaRepository.update({
                                            deletedAt: new Date()
                                        }, { where: { documentId: data.award_details[ii].documentId } });
                                    }
                                }
                            }
                            await this.awardRepository.update({
                                channelId: data.channelId,
                                awardDetail: 'channel',
                                issuedBy: 'ch',
                                documentId: documentId,
                            }, {
                                where: { channelAwardId: data.award_details[ii].channel_award_id },
                                returning: true, transaction,
                            });
                            console.log('awardsave');
                        }
                        else {
                            let documentId = null;
                            if (data.award_details[ii].image) {
                                let media = {};
                                media.documentTypeId = app_constant_1.appconstant.DOCUMENTTYPE_IMAGE;
                                media.documentPath = (data.award_details[ii].image) ? data.award_details[ii].image : null;
                                media.dirName = app_constant_1.appconstant.FOLDER_PATH_PRODUCT_AWARDS;
                                let logo = await this.imageCreate(media, transaction);
                                documentId = logo.documentId;
                            }
                            await this.awardRepository.create({
                                channelId: data.channelId,
                                awardDetail: 'channel',
                                issuedBy: 'ch',
                                documentId: documentId,
                            }, {
                                transaction
                            });
                            console.log('awardsave1');
                        }
                    }
                }
                if (data.companyImages && Object.keys(data.companyImages).length > 0) {
                    for (let ii = 0; ii < data.companyImages.length; ii++) {
                        if (!data.companyImages[ii].companyMediaId) {
                            await this.companyMediaImagesRepository.create({
                                channelId: data.channelId,
                                documentId: data.companyImages[ii].documentId,
                                contactId: data.contactId,
                                updatedBy: data.userId
                            }, {
                                transaction
                            });
                        }
                    }
                }
                if (((_a = data.productFamilies) === null || _a === void 0 ? void 0 : _a.length) > 0) {
                    let productGroup = await this.channelProductGroupRepository.findAll({
                        where: {
                            channelId: data.channelId,
                            deletedAt: null
                        }
                    });
                    let ChannelProductGroupIds = await this.tradeInformationInBound.setProductGroupIds(productGroup);
                    let ChannelProductGroupObject = await this.tradeInformationInBound.setProductGroup(data.productFamilies, data.channelId);
                    let ChannelProductGroupCurrentIds = [];
                    let ChannelProductGroupCreateObject = [];
                    let ContactProductGroupObject = await this.tradeInformationInBound.setContactProductGroup(data.productFamilies, data.contactId);
                    let ContactProductGroupCurrentIds = [];
                    for (let kk = 0; kk < ChannelProductGroupObject.length; kk++) {
                        if (ChannelProductGroupIds.includes(ChannelProductGroupObject[kk].productGroupId)) {
                            ChannelProductGroupCurrentIds.push(ChannelProductGroupObject[kk].productGroupId);
                        }
                        else {
                            ChannelProductGroupCreateObject.push(ChannelProductGroupObject[kk]);
                            ChannelProductGroupCurrentIds.push(ChannelProductGroupObject[kk].productGroupId);
                        }
                        ContactProductGroupCurrentIds.push(ContactProductGroupObject[kk].productGroupId);
                    }
                    if (ChannelProductGroupCreateObject.length > 0) {
                        await this.channelProductGroupRepository.bulkCreate(ChannelProductGroupCreateObject, { returning: true, transaction });
                    }
                    await this.channelProductGroupRepository.update({ deletedAt: new Date() }, {
                        where: {
                            channelId: data.channelId,
                            productGroupId: { [sequelize_1.Op.notIn]: ChannelProductGroupCurrentIds },
                            deletedAt: null
                        }, returning: true, transaction
                    });
                    await this.contactGroupRepository.update({ deletedAt: new Date() }, {
                        where: {
                            contactId: { [sequelize_1.Op.in]: contacts },
                            productGroupId: { [sequelize_1.Op.notIn]: ContactProductGroupCurrentIds },
                            deletedAt: null
                        }, returning: true, transaction
                    });
                }
                if (((_b = data.productCategories) === null || _b === void 0 ? void 0 : _b.length) > 0) {
                    let productCategory = await this.channelProductCategorieRepository.findAll({
                        where: {
                            channelId: data.channelId,
                            deletedAt: null
                        }
                    });
                    let productCategoriesIds = await this.tradeInformationInBound.setProductCategoryIds(productCategory);
                    let ProductCategorieObject = await this.tradeInformationInBound.setProductCategories(data.productCategories, data.channelId);
                    let ChannelProductCategoriesCurrentIds = [];
                    let ChannelProductCategoriesCreateObject = [];
                    let contactProductCategorieObject = await this.tradeInformationInBound.setContactProductCategories(data.productCategories, data.contactId);
                    let ContactProductCategoriesCurrentIds = [];
                    for (let kk = 0; kk < ProductCategorieObject.length; kk++) {
                        if (productCategoriesIds.includes(ProductCategorieObject[kk].productCategorieId)) {
                            ChannelProductCategoriesCurrentIds.push(ProductCategorieObject[kk].productCategorieId);
                        }
                        else {
                            ChannelProductCategoriesCreateObject.push(ProductCategorieObject[kk]);
                            ChannelProductCategoriesCurrentIds.push(ProductCategorieObject[kk].productCategorieId);
                        }
                        ContactProductCategoriesCurrentIds.push(contactProductCategorieObject[kk].productCategorieId);
                    }
                    if (ChannelProductCategoriesCreateObject.length > 0) {
                        await this.channelProductCategorieRepository.bulkCreate(ChannelProductCategoriesCreateObject, { returning: true, transaction });
                    }
                    await this.channelProductCategorieRepository.update({ deletedAt: new Date() }, {
                        where: {
                            channelId: data.channelId,
                            productCategorieId: { [sequelize_1.Op.notIn]: ChannelProductCategoriesCurrentIds },
                            deletedAt: null
                        }, returning: true, transaction
                    });
                    await this.contactCatRepository.update({ deletedAt: new Date() }, {
                        where: {
                            contactId: { [sequelize_1.Op.in]: contacts },
                            productCategorieId: { [sequelize_1.Op.notIn]: ContactProductCategoriesCurrentIds },
                            deletedAt: null
                        }, returning: true, transaction
                    });
                }
                let rating = await this.profileRepository.create({
                    channelId: +data.channelId,
                    ratingId: +data.ratingId,
                    isCompleted: true,
                    createdAt: new Date()
                }, { transaction });
                console.log('rating', rating);
                return certiObject;
            });
        })
            .catch((err) => {
            console.log(err);
            throw new Process_exception_1.ProcessException('account:singup:tryAgain');
        });
    }
    async save_User_Profile(data) {
        let user = data;
        let typeid = user.channelTypeId;
        let channelLocation = [];
        if (data.sellingRegion)
            data.sellingRegion.map(x => {
                channelLocation.push({ channelId: data.channelId, locationType: typeid == 3 ? 'SELLING' : typeid == 4 ? 'RETAIL' : typeid == 5 ? 'RESELLING' : 'SELLING', regionCountryJCTId: x });
            });
        if (data.targetRegion)
            data.targetRegion.map(x => {
                channelLocation.push({ channelId: data.channelId, locationType: 'TARGET', regionCountryJCTId: x });
            });
        return this.sequelizeInstance.transaction(async (transaction) => {
            return await this.channelLocationRepository.bulkCreate(channelLocation, {
                transaction,
            }).then(async (location) => {
                await this.userRepository.update({ suggestion_comm: data.suggestions, invitation_comm: data.networkInvitation }, {
                    where: {
                        contactId: data.contactId
                    },
                    returning: true,
                    transaction
                });
                await this.contactRepository.update({ documentId: data.companyLogo }, {
                    where: {
                        contactId: data.contactId
                    },
                    returning: true,
                    transaction
                });
                let ContactGroupObject = await this.setContactProductGroup(data.productGroup, +data.contactId, +data.channelId);
                await this.intrestedGroupRepository.bulkCreate(ContactGroupObject, { returning: true, transaction });
                let ContactCatObject = await this.setContactProductCat(data.productCat, +data.contactId, +data.channelId);
                await this.intrestedCatRepository.bulkCreate(ContactCatObject, { returning: true, transaction });
                await this.profileRepository.create({
                    channelId: data.channelId,
                    ratingId: data.ratingId,
                    isCompleted: true,
                    createdAt: new Date()
                }, { transaction });
                return location;
            });
        })
            .catch((err) => {
            console.log(err);
            throw new Process_exception_1.ProcessException('account:singup:tryAgain');
        });
    }
    async setChannelBrand(channelBrand, channelId) {
        try {
            let resultObject = [];
            if (channelBrand) {
                for (let ii = 0; ii < channelBrand.length; ii++) {
                    let innerObject = {};
                    innerObject.channelId = channelId;
                    innerObject.brandId = channelBrand[ii];
                    innerObject.createdAt = new Date();
                    resultObject.push(innerObject);
                }
            }
            return resultObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:channelBrand');
        }
    }
    async setChannelProfile(channelProfile, channelId) {
        try {
            let resultObject = [];
            if (channelProfile) {
                for (let ii = 0; ii < channelProfile.length; ii++) {
                    let innerObject = {};
                    innerObject.channelId = channelId;
                    innerObject.profileTypeId = channelProfile[ii].profileTypeId;
                    innerObject.profileTypeClassificationId = channelProfile[ii].profileTypeClassificationId;
                    innerObject.createdAt = new Date();
                    resultObject.push(innerObject);
                }
            }
            return resultObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:channelProfile');
        }
    }
    async setContactProductGroup(productGroup, contactId, channelId) {
        try {
            console.log("producdtGroup:", productGroup);
            productGroup = _.uniq(productGroup);
            let resultObject = [];
            if (productGroup) {
                for (let ii = 0; ii < productGroup.length; ii++) {
                    let innerObject = {};
                    innerObject.contactId = contactId;
                    innerObject.channelId = channelId;
                    innerObject.productGroupId = productGroup[ii];
                    innerObject.createdAt = new Date();
                    resultObject.push(innerObject);
                }
            }
            return resultObject;
        }
        catch (e) {
            console.log("err:", e);
            throw new Process_exception_1.ProcessException('channel:objectCreation:channelBrand');
        }
    }
    async setContactProductCat(productCat, contactId, channelId) {
        try {
            let resultObject = [];
            if (productCat) {
                for (let ii = 0; ii < productCat.length; ii++) {
                    let innerObject = {};
                    innerObject.contactId = contactId;
                    innerObject.channelId = channelId;
                    innerObject.productCategorieId = productCat[ii];
                    innerObject.createdAt = new Date();
                    resultObject.push(innerObject);
                }
            }
            return resultObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:channelBrand');
        }
    }
    async setChannelProductGroup(productGroup, channelId) {
        try {
            console.log("producdtGroup:", productGroup);
            productGroup = _.uniq(productGroup);
            let resultObject = [];
            if (productGroup) {
                for (let ii = 0; ii < productGroup.length; ii++) {
                    let innerObject = {};
                    innerObject.channelId = channelId;
                    innerObject.productGroupId = productGroup[ii];
                    innerObject.createdAt = new Date();
                    resultObject.push(innerObject);
                }
            }
            return resultObject;
        }
        catch (e) {
            console.log("err:", e);
            throw new Process_exception_1.ProcessException('channel:objectCreation:channelBrand');
        }
    }
    async setChannelProductCat(productCat, channelId) {
        try {
            let resultObject = [];
            if (productCat) {
                for (let ii = 0; ii < productCat.length; ii++) {
                    let innerObject = {};
                    innerObject.channelId = channelId;
                    innerObject.productCategorieId = productCat[ii];
                    innerObject.createdAt = new Date();
                    resultObject.push(innerObject);
                }
            }
            return resultObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:channelBrand');
        }
    }
    async getInitialProfile(data) {
        let user = data;
        let distProfile;
        let channelTypeId = user.channelTypeId;
        let businessType = user.businessType;
        let isOEM = user.channel.isOEM;
        let channelId = user.channelId;
        let type = [];
        let btype = [];
        if (businessType == 1)
            btype = [1, 3];
        else if (businessType == 2)
            btype = [2, 3];
        else if (businessType == 3)
            btype = [1, 2, 3];
        else
            btype = [-1];
        if ((channelTypeId == 2 || channelTypeId == 3) && businessType == 1)
            type = [4, 5];
        else if ((channelTypeId == 2 || channelTypeId == 3) && businessType == 2)
            type = [4, 5];
        else if ((channelTypeId == 2 || channelTypeId == 3) && businessType == 3)
            type = [4, 5];
        else if (channelTypeId == 4)
            type = [4];
        else if (channelTypeId == 5)
            type = [5];
        else
            type = [-1];
        let query = 'select pg."productGroupId" as groupId,pg."productGroup" as groupname,pc."productCategorieId" as childId,pc."productCategorie" as childname,cast(false as boolean) as status from "tblProductGroup" as pg inner join'
            + ' "tblProductCategories" as pc on pg."productGroupId"=pc."productGroupId" where pg."deletedAt" is null and pg."productGroup"!=\'\' and pg."businessType" in(:businessType) ';
        let productGroup = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                businessType: btype
            }
        }).then(results => {
            return results;
        });
        let url = 'https://d35w8j22j5uly8.cloudfront.net/';
        query = 'select "brandName" as name,"id",doc."documentId" as doc_id,concat(\'' + url + '\',doc."documentPath") as documentPath from "tblBrand" as br inner join "tblDocument" as doc on doc."documentId"=br."documentId" where br."deletedAt" is null';
        let brand = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
        }).then(results => {
            return results;
        });
        if (channelTypeId == 4 || channelTypeId == 5) {
            query = 'select case when ptc."channelTypeId"=3 then \'Distributor\' when ptc."channelTypeId"=4 then \'Retailer\' '
                + 'when ptc."channelTypeId"=2 then \'vendor\' when ptc."channelTypeId"=5 then \'Reseller\' end as groupname,pt."profileType" as childname,'
                + 'pt."profileTypeId" as childId,cast(false as boolean) as status,ptc."profileTypeClassificationId" as profileTypeClassificationId from "tblProfileType" as pt inner join "tblProfileTypeClassification" as ptc on pt."profileTypeId"=ptc."profileTypeId" where ptc."channelTypeId" in(:typeId)';
        }
        else {
            query = 'select case when ptc."channelTypeId"=3 then \'Distributor\' when ptc."channelTypeId"=4 then \'Retailer\' '
                + 'when ptc."channelTypeId"=2 then \'vendor\' when ptc."channelTypeId"=5 then \'Reseller\' end as groupname,pt."profileType" as childname,'
                + 'pt."profileTypeId" as childId,cast(false as boolean) as status,ptc."profileTypeClassificationId" as profileTypeClassificationId from "tblProfileType" as pt inner join "tblProfileTypeClassification" as ptc on pt."profileTypeId"=ptc."profileTypeId" where ptc."channelTypeId" in(:typeId)';
        }
        let profileList = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                typeId: type,
            }
        }).then(results => {
            return results;
        });
        if (channelTypeId == 3) {
            query = 'select case when ptc."channelTypeId"=3 then \'Distributor\' when ptc."channelTypeId"=4 then \'Retailer\' '
                + 'when ptc."channelTypeId"=2 then \'vendor\' when ptc."channelTypeId"=5 then \'Reseller\' end as groupname,pt."profileType" as childname,'
                + 'pt."profileTypeId" as childId,cast(false as boolean) as status,ptc."profileTypeClassificationId" as profileTypeClassificationId from "tblProfileType" as pt inner join "tblProfileTypeClassification" as ptc on pt."profileTypeId"=ptc."profileTypeId" where ptc."channelTypeId" in(:typeId);';
            distProfile = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                replacements: {
                    typeId: [3]
                }
            }).then(results => {
                return results;
            });
        }
        query = 'select "registrationcertificate","isVat" from "tblCountry" as cty inner join "tblChannel" as ch on ch."countryId"=cty."countryId" where ch."channelId"=:channelId';
        let country = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: channelId
            }
        }).then(results => {
            return results;
        });
        let result = {
            productGroup: productGroup,
            productBrand: brand,
            profileList: profileList,
            distProfile: distProfile,
            country: country
        };
        return result;
    }
    async getVat(countryId) {
        let query = 'select "registrationcertificate","isVat" from "tblCountry" as cty where cty."countryId"=:countryId';
        let country = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                countryId: countryId
            }
        }).then(results => {
            return results;
        });
        let result = {
            country: country
        };
        return result;
    }
    async getContactProduct(contactId, channelId) {
        let query = 'select pg."productGroupId" as groupId,(select "productGroup" from "tblProductGroup" where "productGroupId"=pg."productGroupId") as groupname,pc."productCategorieId" as childId,pg."productCategorie" as childname,cast(true as boolean) as status from '
            + ' "tblInterestedProductCategory" as pc inner join "tblProductCategories" as pg on pg."productCategorieId"=pc."productCategorieId"  where pc."contactId"=:contactId and pg."deletedAt" is null and pc."deletedAt" is null';
        let productGroup = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: { contactId: contactId }
        }).then(results => {
            return results;
        });
        if (productGroup.length == 0) {
            query = 'select pg."productGroupId" as groupId,(select "productGroup" from "tblProductGroup" where "productGroupId"=pg."productGroupId") as groupname,pc."productCategorieId" as childId,pg."productCategorie" as childname,cast(true as boolean) as status from '
                + ' "tblChannelProductCategorie" as pc inner join "tblProductCategories" as pg on pg."productCategorieId"=pc."productCategorieId"  where pc."channelId"=:channelId and pg."deletedAt" is null and pc."deletedAt" is null';
            productGroup = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                replacements: { channelId: channelId }
            }).then(results => {
                return results;
            });
        }
        let result = {
            productGroup: productGroup,
        };
        return result;
    }
    async getContactLocation(user) {
        let typeId = user.channelTypeId;
        let type = [];
        if (typeId == 2)
            type = ['TARGET'];
        else if (typeId == 3)
            type = ['TARGET', 'SELLING'];
        else if (typeId == 4)
            type = ['RETAIL'];
        else if (typeId == 5)
            type = ['RESELLING'];
        let query = 'select rc."regionId" as groupId ,(select "region" from "tblRegion" where "regionId"=rc."regionId") as groupname,rc."countryId" as "childId",(select "country" from "tblCountry" where "countryId"=rc."countryId") as childname,rc."regionCountryJCTId", ' +
            ' cast(true as boolean) as status, tc."locationType" from "tblContactLocation" as tc inner join "tblRegionCountryJCT" as rc on tc."regionCountryJCTId"=rc."regionCountryJCTId" where tc."deletedAt" is null and tc."contactId"=:contactId and tc."locationType" in (:type)';
        let contactLocation = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: { contactId: user.contactId,
                type: type }
        }).then(results => {
            return results;
        });
        if (contactLocation.length == 0) {
            query = 'select rc."regionId" as groupId ,(select "region" from "tblRegion" where "regionId"=rc."regionId") as groupname,rc."countryId" as "childId",(select "country" from "tblCountry" where "countryId"=rc."countryId") as childname,rc."regionCountryJCTId", ' +
                ' cast(true as boolean) as status, tc."locationType" from "tblChannelLocation" as tc inner join "tblRegionCountryJCT" as rc on tc."regionCountryJCTId"=rc."regionCountryJCTId" where tc."deletedAt" is null and tc."channelId"=:channelId and tc."locationType" in (:type)';
            contactLocation = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                replacements: { channelId: user.channelId,
                    type: type }
            }).then(results => {
                return results;
            });
        }
        let result = {
            contactLocation: contactLocation
        };
        return result;
    }
    async getUserProfile(channelId, channelTypeId) {
        let query = 'select "regionId" as id,"region" as name from "tblRegion" where "deletedAt" is null';
        query = 'select tr."regionId" as groupId,tr."region" as groupname,cty."countryId" as "childId",cty."country" as childname,rc."regionCountryJCTId",cast(false as boolean) as status from "tblRegion" as tr  inner join "tblRegionCountryJCT" as rc on rc."regionId"=tr."regionId" '
            + 'inner join "tblCountry" as cty on cty."countryId"=rc."countryId" where tr."deletedAt" is null and tr."regionId" in (select "regionId" from "tblZoneRegionJCT" where "zoneId" in (1, 2, 3))';
        let regions = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
        }).then(results => {
            return results;
        });
        query = 'select tr."regionId" as groupId,tr."region" as groupname,cty."countryId" as "childId",cty."country" as childname,rc."regionCountryJCTId",cast(false as boolean) as status from "tblRegion" as tr  inner join "tblRegionCountryJCT" as rc on rc."regionId"=tr."regionId" '
            + 'inner join "tblCountry" as cty on cty."countryId"=rc."countryId" where tr."deletedAt" is null and tr."regionId" in (select "regionId" from "tblZoneRegionJCT" where "zoneId" in (1, 2, 3))';
        let regions1 = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
        }).then(results => {
            return results;
        });
        query = 'select  pg."productGroupId" as groupId,pg."productGroup" as groupname,pc."productCategorieId" as childId,pc."productCategorie" as childname,cast(true as boolean) as status from "tblProductGroup" as pg inner join '
            + '"tblProductCategories" as pc on pg."productGroupId"=pc."productGroupId" and pc."productCategorieId" in(select "productCategorieId" from "tblChannelProductCategorie" where "channelId"=:channelId) '
            + 'and pc."productGroupId" in(select "productGroupId" from "tblChannelProductGroup" where "channelId"=:channelId)';
        let productGroup = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: channelId
            }
        }).then(results => {
            return results;
        });
        let result = {
            productGroup: productGroup,
            regions: regions,
            regions1: regions1
        };
        return result;
    }
    async getChannelProduct(channelId, businessType) {
        let btype = [];
        if (businessType == 1)
            btype = [1, 3];
        else if (businessType == 2)
            btype = [2, 3];
        else if (businessType == 3)
            btype = [1, 2, 3];
        else
            btype = [-1];
        let query = 'select  pg."productGroupId" as groupId,pg."productGroup" as groupname,pc."productCategorieId" as childId,pc."productCategorie" as childname,cast(true as boolean) as status from "tblProductGroup" as pg inner join '
            + '"tblProductCategories" as pc on pg."productGroupId"=pc."productGroupId" and pc."productCategorieId" in(select "productCategorieId" from "tblChannelProductCategorie" where "channelId"=:channelId and "deletedAt" is null) '
            + 'and pc."productGroupId" in(select "productGroupId" from "tblChannelProductGroup" where "channelId"=:channelId) and pg."businessType" in(:businessType)';
        let productGroup = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: channelId,
                businessType: btype
            }
        }).then(results => {
            return results;
        });
        let result = {
            productGroup: productGroup
        };
        return result;
    }
    async getChannelBrand(channelId) {
        let query = 'select concat(\'' + process.env.CDN_URL + '\',(select "documentPath" from "tblDocument" where "documentId"=pg."documentId"))as "documentpath",cpg."brandId" as id,pg."brandName" as name,0 as "isNew" from "tblChannelBrand" as cpg inner join "tblBrand" as pg on cpg."brandId"=pg."id" where cpg."deletedAt" is null and cpg."channelId"=:channelId';
        let productGroup = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: channelId
            }
        }).then(results => {
            return results;
        });
        let result = {
            brand: productGroup
        };
        return result;
    }
    async getChannelDetail(channelId) {
        let query = 'select "turnover","no_of_retailers","no_of_distributors","no_of_skus","startup","turnoverRange","empCnt","revD","revI","empCntRange","maturitylevel","turnoverPhyStore","turnoverOnStore","storeCount", '
            + ' "empCntDSale","empCntISale","empCntDMar","empCntIMar", "keydistributors","keyretailers","keyresellers","no_of_resellers" from "tblChannelDetail" where "channelId"=:channelId ';
        let channelDetail = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: channelId
            }
        }).then(results => {
            return results;
        });
        return channelDetail[0];
    }
    async getProfileAndSpeciality(channelId) {
        let tradeinfo = [];
        tradeinfo = await this.channelRepository.scope().findAll({
            attributes: ['channelId', 'profileTypeId', 'isFrenchTech'],
            where: {
                channelId: channelId
            },
            include: [
                {
                    model: this.channelCustProfileRepository,
                    as: 'channelCustomerProfile',
                    attributes: ['profileTypeId'],
                },
                {
                    model: this.serviceListRepository.scope('tradeinfo'),
                    as: 'serviceList',
                    where: { deletedAt: null },
                    required: false
                },
                {
                    model: this.channelSpecialityRepository,
                    as: 'channelSpeciality',
                    where: { deletedAt: null },
                    required: false,
                    include: [
                        {
                            model: this.productGroupRepository,
                            as: 'productGroup',
                            attributes: [['productGroupId', 'id'], ['productGroup', 'name']]
                        }
                    ]
                },
            ]
        });
        let query = 'select * from "tblProductGroup" where "deletedAt" is null and "isActive"=\'1\'';
        let specialityOptions = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT
        }).then(res => res);
        let final = Object.assign(tradeinfo, { specialityOptions: specialityOptions });
        return final;
    }
    async getProductProfile(channelId) {
        let query = 'select cpg."productCategorieId" as id,pg."productCategorie"  as name,pg."productGroupId" as groupid from "tblChannelProductCategorie" as cpg inner join "tblProductCategories" as pg on cpg."productCategorieId"=pg."productCategorieId"  where cpg."channelId"=:channelId';
        let categorie = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: channelId
            }
        }).then(results => {
            return results;
        });
        query = 'select cpg."brandId" as id,pg."brandName" as name from "tblChannelBrand" as cpg inner join "tblBrand" as pg on cpg."brandId"=pg."id" where cpg."channelId"=:channelId';
        let brand = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: channelId
            }
        }).then(results => {
            return results;
        });
        query = 'select count(*) as "activeProducts" from "tblProduct" as tp  where tp."channelId"= :channelId and tp."deletedat" is null and "isactive"=:isactive';
        let activeProduct = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: channelId,
                isactive: '1'
            }
        }).then(results => {
            return results;
        });
        let result = {
            productCat: categorie,
            productBrand: brand,
            activeProduct: +activeProduct[0].activeProducts
        };
        return result;
    }
    async getCompanyMediaLibrary(channelId, type) {
        let cond = Object.assign(Object.assign(Object.assign({}, (type == "channel" && { channelId: +channelId })), (type == "oldChannel" && { oldChannelId: +channelId })), { deletedAt: null });
        return await this.channelDocumentRepository.findAll({
            where: cond,
            include: [{
                    model: index_1.Media,
                    where: {
                        documentTypeId: 1,
                        deletedAt: null
                    },
                    required: true
                }],
            order: [['channelDocumentId', 'DESC']]
        });
    }
    async getCompanyImages(channelId) {
        return await this.companyMediaImagesRepository.findAll({
            where: {
                channelId: +channelId,
                deletedAt: null
            },
            include: [{
                    model: index_1.Media,
                    where: {
                        documentTypeId: 1,
                        deletedAt: null
                    },
                    required: true
                }],
            order: [['companyMediaId', 'DESC']]
        });
    }
    async getCompanyDocument(channelId) {
        return await this.channelDocumentRepository.findAll({
            where: {
                channelId: +channelId,
                deletedAt: null
            },
            include: [{
                    model: index_1.Media,
                    where: {
                        documentTypeId: 2,
                        deletedAt: null
                    },
                    required: true
                }],
            order: [['channelDocumentId', 'DESC']]
        });
    }
    async createCompanyLogo(doc, user) {
        return this.sequelizeInstance.transaction(async (transaction) => {
            let updatedDocument = await this.mediaRepository.create({
                documentPath: doc.Key,
                documentTypeId: 1,
                dirName: 'company/logo'
            }, transaction);
            var document = updatedDocument;
            let companyMedia = await this.channelDocumentRepository.create(Object.assign(Object.assign({ documentId: document.documentId }, (user.channelId && { channelId: +user.channelId })), (user.oldChannelId && { oldChannelId: +user.oldChannelId })), transaction);
            let data = Object.assign(Object.assign(Object.assign({ documentId: companyMedia.documentId }, (user.channelId && { channelId: companyMedia.channelId })), (user.oldChannelId && { oldChannelId: companyMedia.oldChannelId })), { channelDocumentId: companyMedia.channelDocumentId, document: document, name: companyMedia.name });
            return data;
        })
            .catch((err) => {
            console.log(err);
            throw new Process_exception_1.ProcessException('account:singup:tryAgain');
        });
    }
    async existingBrandCheck(brand) {
        let result = await this.brandRepository.findOne({
            where: {
                brandName: {
                    [sequelize_1.Op.iLike]: brand.brandName.trim()
                },
                id: {
                    [sequelize_1.Op.not]: +brand.id
                },
                deletedAt: null
            }
        });
        console.log(result);
        if (!result) {
            return true;
        }
        return false;
    }
    async saveBrand(brand, channelId, transaction) {
        try {
            let channelBrandArrayObject = [];
            let brandIds = [];
            for (let jj = 0; jj < brand.length; jj++) {
                if (brand[jj].id && brand[jj].isNew == "0") {
                    let channelBrandObject = await this.setChannelBrands(brand[jj].id, channelId);
                    channelBrandArrayObject.push(channelBrandObject);
                    brandIds.push(brand[jj].id);
                }
                else {
                    let brandObject = {};
                    brandObject.brandName = brand[jj].name;
                    brandObject.createdAt = new Date();
                    if (brand[jj].documentpath) {
                        let mediaObject = await this.setDocumentObject(brand[jj].documentpath, app_constant_1.appconstant.DOCUMENTTYPE_IMAGE, app_constant_1.appconstant.FOLDER_PATH_BRAND);
                        let document = await this.mediaRepository.create(mediaObject, { transaction });
                        brandObject.documentId = +document.documentId;
                        console.log('brandObject', brandObject);
                    }
                    else if (brand[jj].documentPath) {
                        let mediaObject = await this.setDocumentObject(brand[jj].documentPath, app_constant_1.appconstant.DOCUMENTTYPE_IMAGE, app_constant_1.appconstant.FOLDER_PATH_BRAND);
                        let document = await this.mediaRepository.create(mediaObject, { transaction });
                        brandObject.documentId = +document.documentId;
                        console.log('brandObject', brandObject);
                    }
                    let newbrand = await this.productService.saveBrand(brandObject, transaction);
                    let channelBrandObject = await this.setChannelBrands(newbrand.id, channelId);
                    channelBrandArrayObject.push(channelBrandObject);
                    brandIds.push(newbrand.id);
                }
            }
            return { "channelBrandArrayObject": channelBrandArrayObject, "brandIds": brandIds };
        }
        catch (e) {
            console.log("Error+ ", e);
            throw new Process_exception_1.ProcessException("channel:");
        }
    }
    async setChannelBrands(brandId, channelId) {
        try {
            let resultObject = {};
            resultObject.brandId = brandId;
            resultObject.channelId = channelId;
            resultObject.createdAt = new Date();
            return resultObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:channelBrand');
        }
    }
    async setDocumentObject(docTempPath, doctype, folderPath) {
        try {
            let mediaObject = {};
            mediaObject.documentPath = docTempPath;
            mediaObject.documentTypeId = doctype;
            if (folderPath) {
                mediaObject.dirName = folderPath;
            }
            return mediaObject;
        }
        catch (e) {
            throw new Process_exception_1.ProcessException('channel:objectCreation:media');
        }
    }
    async getCompanyProfile(user) {
        let companyProfile = '';
        let channelAward = [];
        let data = '';
        let channelStatusArray = [app_constant_1.appconstant.ACCOUNTSETUP, app_constant_1.appconstant.ACCOUNTSETUP_COMPANYPROFILE, app_constant_1.appconstant.ACCOUNTSETUP_TRADEINFORMATION, app_constant_1.appconstant.ACCOUNTSETUP_TRADELOCATION, app_constant_1.appconstant.CHANNEL_APPROVAL, app_constant_1.appconstant.CHANNEL_APPROVED, app_constant_1.appconstant.CLAIM_APPROVED];
        try {
            let userSignUpStatus = channelStatusArray.includes(parseInt(user.signUpStatusId));
            if (userSignUpStatus) {
                companyProfile = await this.sequelizeInstance.query("select * from fngetchannelprofile(" + user.userId + "," + parseInt(user.signUpStatusId) + ",'" + process.env.CDN_URL + "');");
                companyProfile = companyProfile[0][0].fngetchannelprofile;
                console.log('companyProfle', companyProfile);
                if (companyProfile.channel.channelAward) {
                    channelAward = await Promise.all(companyProfile.channel.channelAward.map(async (x) => {
                        if (x.documentId) {
                            let data = await this.sequelizeInstance.query('select "documentId","documentPath" from "tblDocument" where "documentId"=' + x.documentId, {
                                type: sequelize_1.QueryTypes.SELECT,
                                raw: true,
                            }).then(y => {
                                console.log('img', x, y);
                                return Object.assign(x, { awardImg: y[0].documentPath, isOld: true, lifeTime: x.lifeTime == '1' ? true : false });
                            });
                            return data;
                        }
                        else {
                            return Object.assign(x, { awardImg: null, isOld: true, lifeTime: x.lifeTime == '1' ? true : false });
                        }
                    }));
                }
                let bannerImg = [];
                console.log('banner', companyProfile.channel.channelDetail.channelBannerId);
                if (companyProfile.channel.channelDetail.channelBannerId) {
                    bannerImg = await this.sequelizeInstance.query('select "documentId","documentPath" from "tblDocument" where "documentId"=' + companyProfile.channel.channelDetail.channelBannerId, {
                        type: sequelize_1.QueryTypes.SELECT,
                        raw: true,
                    }).then(y => {
                        console.log('img', y);
                        return y[0];
                    });
                }
                let endCustomerB2b = await this.sequelizeInstance.query('select "customerTypeId","other" from "tblEndCustomersB2b" where "channelId"=' + user.channelId, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                }).then(y => {
                    return y[0];
                });
                companyProfile['bannerImg'] = bannerImg;
                companyProfile['channelAward'] = channelAward;
                companyProfile['endCustomerB2b'] = endCustomerB2b;
                companyProfile['linkedInBanner'] = companyProfile.channel.channelDetail.bannerURL;
            }
        }
        catch (e) {
            console.log("Error+", e);
        }
        if (!companyProfile) {
            throw new Process_exception_1.ProcessException('channel:getCompanyProfile:companyNotFound');
        }
        return companyProfile;
    }
    async getTradeInfo(user) {
        let tradeinfo = '';
        tradeinfo = await this.channelRepository.scope().findAll({
            attributes: ['channelId', 'profileTypeId', 'isFrenchTech', 'isCompanyPublic'],
            where: {
                channelId: user.channelId
            },
            include: [
                {
                    model: this.channelBrandRepository,
                    as: 'channelBrand',
                    where: { deletedAt: null },
                    required: false,
                    attributes: ['channelBrandId', 'brandId'],
                    include: [
                        {
                            model: this.brandRepository,
                            as: 'brand',
                            attributes: ['brandName'],
                            include: [
                                {
                                    model: this.mediaRepository,
                                    as: 'document',
                                    attributes: ['documentPath']
                                }
                            ]
                        }
                    ]
                },
                {
                    model: this.channelProductGroupRepository,
                    as: 'channelProductGroup',
                    attributes: ['productGroupId'],
                    where: { deletedAt: null },
                    required: false,
                    include: [
                        {
                            model: this.productGroupRepository,
                            as: 'productGroup',
                            attributes: [['productGroupId', 'groupid'], ['productGroup', 'groupname']]
                        }
                    ]
                },
                {
                    model: this.channelCatRepository,
                    as: 'channelProductCategorie',
                    attributes: ['channelProductCategorieId'],
                    where: { deletedAt: null },
                    required: false,
                    include: [
                        {
                            model: this.productCatRepository,
                            as: 'productCategorie',
                            attributes: [['productCategorieId', 'childid'], ['productCategorie', 'childname'], ['productGroupId', 'groupid']],
                        }
                    ]
                },
                {
                    model: this.channelCustProfileRepository,
                    as: 'channelCustomerProfile',
                    attributes: ['profileTypeId', 'profileTypeClassificationId'],
                    required: false,
                    where: {
                        deletedAt: null
                    }
                },
                {
                    model: this.channelDetailRepository,
                    as: 'channelDetail',
                    attributes: ['no_of_retailers', 'no_of_distributors', 'no_of_skus', 'startup', 'turnoverRange', 'empCnt', 'revD', 'revI', 'empCntRange', 'maturitylevel', 'turnoverPhyStore', 'turnoverOnStore', 'storeCount',
                        'empCntDSale', 'empCntISale', 'empCntDMar', 'empCntIMar', 'keydistributors', 'keyretailers']
                },
                {
                    model: this.serviceListRepository.scope('tradeinfo'),
                    as: 'serviceList',
                    where: { deletedAt: null },
                    required: false
                },
                {
                    model: this.channelSpecialityRepository,
                    as: 'channelSpeciality',
                    where: { deletedAt: null },
                    required: false,
                    include: [
                        {
                            model: this.productGroupRepository,
                            as: 'productGroup',
                            attributes: [['productGroupId', 'id'], ['productGroup', 'name']]
                        }
                    ]
                },
            ]
        });
        let query = 'select * from "tblProductGroup" where "deletedAt" is null and "isActive"=\'1\'';
        let specialityOptions = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT
        }).then(res => res);
        let keyRetailers = [];
        let keyDistributors = [];
        let keyPartner = { retailer: [], distributor: [] };
        if (user.channelTypeId == '2') {
            keyRetailers = await this.searchRetailer('', 4);
            keyDistributors = await this.searchRetailer('', 3);
            keyPartner['retailer'] = keyRetailers;
            keyPartner['distributor'] = keyDistributors;
        }
        else if (user.channelTypeId == '3') {
            keyRetailers = await this.searchRetailer('', 4);
            keyPartner['retailer'] = keyRetailers;
        }
        let serviceListOptions = await this.getServiceList();
        tradeinfo = Object.assign(tradeinfo, { keyPartners: keyPartner, serviceListOptions: serviceListOptions, specialityOptions: specialityOptions });
        return tradeinfo;
    }
    async getTradeLocation(user) {
        let tradelocation = '';
        tradelocation = await this.channelRepository.scope().findAll({
            attributes: ['channelId'],
            where: {
                channelId: user.channelId,
            },
            include: [
                {
                    model: this.channelLocationRepository,
                    as: 'channelLocation',
                    attributes: ['locationType'],
                    where: {
                        locationType: {
                            [sequelize_1.Op.in]: ['TARGET', 'SELLING', 'RETAIL', 'RESELLING']
                        },
                        deletedAt: null,
                    },
                    include: [
                        {
                            model: this.regCtyJCTRepository,
                            as: 'RegionCountryJCT',
                            attributes: ['regionCountryJCTId'],
                            include: [
                                {
                                    model: this.regionRepository,
                                    attributes: ['regionId', 'region'],
                                },
                                {
                                    model: this.countryRepository,
                                    attributes: ['countryId', 'country']
                                }
                            ]
                        }
                    ]
                }
            ]
        });
        return tradelocation;
    }
    async updateChannelLocation(channelLocationDto, user, subscriptionFeatureKeys) {
        let channel = await this.channelRepository.findByPk(user.channelId);
        let isUpdate = true;
        var verify = false;
        if (isUpdate) {
            let zoneFilter = 0;
            let getZone = [];
            try {
                let channelLocationObject = [];
                let contactLocationObject = [];
                let locationType = channelLocationDto.locationType;
                let data;
                data = channelLocationDto.location;
                for (var i in data) {
                    let channellocation = {
                        channelId: user.channelId,
                        locationType: locationType,
                        regionCountryJCTId: data[i],
                        updatedBy: user.userId
                    };
                    let contactlocation = channellocation;
                    contactlocation["contactId"] = user.contactId;
                    channelLocationObject.push(channellocation);
                    contactLocationObject.push(contactlocation);
                }
                if (channelLocationObject.length > 0) {
                    await this.channelLocationRepository.update({ deletedAt: new Date().toUTCString() }, { where: { channelId: user.channelId, locationType: locationType, deletedAt: null } });
                    await this.contactLocationRepository.update({ deletedAt: new Date().toUTCString() }, { where: { channelId: user.channelId, locationType: locationType, contactId: user.contactId, deletedAt: null } });
                }
                let channelLocation = await this.channelLocationRepository.bulkCreate(channelLocationObject);
                let contactLocation = await this.contactLocationRepository.bulkCreate(contactLocationObject);
                return true;
            }
            catch (e) {
                console.log("Error+", e);
            }
        }
        return { signUpStatusId: channel.signUpStatusId };
    }
    async getuserLimits(user) {
        let users = '';
        let query = 'select "keyFeature" FROM "tblChannelSubscription" where "channelId" =:channelId AND "isActive" =:isActive';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: user.channelId,
                isActive: '1'
            }
        }).then(async (x) => {
            let userLimitAccess = {};
            x.forEach(async (data) => {
                userLimitAccess['allowed'] = (data.keyFeature['1'] === 'Unlimited') ? 'Unlimited' : +data.keyFeature['1'];
            });
            console.log(userLimitAccess);
            return userLimitAccess;
        });
        return result;
    }
    async getUsers(user) {
        let users = '';
        let query = 'select case when tc."countryId" is not null then (select "country" from "tblCountry" where "countryId"=tc."countryId") '
            + 'else (select "country" from "tblCountry" where "countryId" in (select "countryId" from "tblChannel" where "channelId"=:channelId)) end as "country", '
            + '(select "roleId" from "tblUserRole" where "userId" in (select "userId" from "tblUser" where "contactId"=tc."contactId")) as "roleId" ,'
            + '(select "documentPath" from "tblDocument" where "documentId"=tc."documentId") as "documentPath" ,'
            + 'tc."contactId",tc."firstName",tc."lastName",tc."jobTitle",tc."mobileNo",tc."email",tc."isActive" from "tblContact" as tc where tc."channelId"=:channelId and tc."deletedAt" is null and tc."isActive"=\'1\' ';
        users = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: user.channelId,
            }
        }).then(x => {
            console.log("users:", x);
            return x;
        });
        let accountuser = users.filter(x => x.roleId == 1);
        let accuser = {
            userdata: accountuser,
            role: "Account Owner",
            total: accountuser.length
        };
        let primary = users.filter(x => x.roleId == 3);
        let puser = {
            userdata: primary,
            role: "Primary",
            total: primary.length
        };
        let admin = users.filter(x => x.roleId == 2);
        let aduser = {
            userdata: admin,
            role: "Admin",
            total: admin.length
        };
        let userLimit = {};
        userLimit['allowed'] = 'unlimited';
        userLimit['total'] = 10;
        let data = [];
        data.push(accuser);
        data.push(aduser);
        data.push(puser);
        return data;
    }
    async deleteUser(contactId) {
        await this.userRepository.update({ deletedAt: new Date().toUTCString(), isActive: '0' }, { where: { contactId: contactId } });
        await this.contactRepository.update({ deletedAt: new Date().toUTCString(), isActive: '0' }, { where: { contactId: contactId } });
        return true;
    }
    async imageCreate(image, transaction) {
        return await this.mediaRepository.create(image, {
            transaction,
        });
    }
    async update_Company_Profile(data) {
        let channelDetail = {
            channelLogoId: +data.companyLogo,
            detailDesc: data.tweetPitch,
            phone1: data.phoneNumber1,
            phone2: data.phoneNumber2,
            mobileNo: data.mobile,
            webSiteUrl: data.websiteUrl,
            expectations: data.sourcing,
        };
        let address = {
            address: data.legalAddress,
            city: data.city,
            countryId: +data.country,
            postalCode: data.zipCode,
            state: null
        };
        let channel = {
            companyName: data.companyLegalName,
            companyMail: data.email,
            countryId: +data.country,
        };
        console.log("vat:", data);
        let certificate = [];
        if (data.companyRegNumber != '')
            certificate.push({ channelId: data.channelId, cerificateTypeId: 1, cerificateName: data.certificateName, cerificateNumber: data.companyRegNumber });
        if (data.vatNumber != null && data.vatNumber != '')
            certificate.push({ channelId: data.channelId, cerificateTypeId: 2, cerificateName: 'VAT', cerificateNumber: data.vatNumber });
        await this.channelCertiRepository.update({ deletedAt: new Date() }, { where: { channelId: data.channelId } });
        return this.sequelizeInstance.transaction(async (transaction) => {
            return await this.channelCertiRepository.bulkCreate(certificate, transaction).then(async (certiObject) => {
                await this.channelDetailRepository.update(channelDetail, {
                    where: {
                        channelId: data.channelId
                    },
                    returning: true,
                    transaction
                });
                if (data.typeId == 3) {
                    let ChannelProfileTypes = await this.setChannelProfile(data.relevantDistributorProfile, +data.channelId);
                    await this.channelCustProfileRepository.update(ChannelProfileTypes, transaction);
                    let ChannelGroupObject = await this.setChannelProductGroup(data.productGroup, +data.channelId);
                    await this.channelProductGroupRepository.update(ChannelGroupObject, transaction);
                    let ChannelCatObject = await this.setChannelProductCat(data.productCat, +data.channelId);
                    await this.channelCatRepository.update(ChannelCatObject, transaction);
                }
                await this.channelRepository.update(channel, { where: {
                        channelId: data.channelId
                    }, transaction });
                if (data.linkedIn) {
                    let linkedIn = { socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_LINKEDIN,
                        channelId: data.channelId,
                        channelSocialLink: data.linkedIn };
                    await this.socialLinkRepository.findOrCreate({
                        where: {
                            channelId: data.channelId,
                            socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_LINKEDIN
                        },
                        defaults: linkedIn, transaction
                    }).then((result) => {
                        if (!result[1]) {
                            result[0].update(linkedIn);
                        }
                    });
                }
                if (data.insta) {
                    let insta = { socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_INSTAGRAM,
                        channelId: data.channelId,
                        channelSocialLink: data.insta };
                    await this.socialLinkRepository.findOrCreate({
                        where: {
                            channelId: data.channelId,
                            socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_INSTAGRAM
                        },
                        defaults: insta, transaction
                    }).then((result) => {
                        if (!result[1]) {
                            result[0].update(insta);
                        }
                    });
                }
                if (data.tradeUrls) {
                    let trade = { socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_GOOGLEPLUS,
                        channelId: data.channelId,
                        channelSocialLink: data.tradeUrls };
                    await this.socialLinkRepository.findOrCreate({
                        where: {
                            channelId: data.channelId,
                            socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_GOOGLEPLUS
                        },
                        defaults: trade, transaction
                    }).then((result) => {
                        if (!result[1]) {
                            result[0].update(trade);
                        }
                    });
                }
                let awards = [];
                await this.awardRepository.update({ deletedAt: new Date() }, {
                    where: {
                        channelId: data.channelId,
                        deletedAt: null
                    }, transaction
                });
                if (data.award_details && Object.keys(data.award_details).length > 0) {
                    for (let ii = 0; ii < data.award_details.length; ii++) {
                        let valid_upto = (data.award_details[ii].valid_upto) ? data.award_details[ii].valid_upto : null;
                        if (data.award_details[ii].image) {
                            let media = {};
                            media.documentTypeId = app_constant_1.appconstant.DOCUMENTTYPE_IMAGE;
                            media.documentPath = (data.award_details[ii].image) ? data.award_details[ii].image : null;
                            media.dirName = app_constant_1.appconstant.FOLDER_PATH_PRODUCT_AWARDS;
                            let logo = await this.imageCreate(media, transaction);
                            data.award_details[ii].imageId = logo.documentId;
                        }
                        else {
                            data.award_details[ii].imageId = null;
                        }
                        let award = {
                            channelAwardId: data.award_details[ii].channelAwardId ? data.award_details[ii].channelAwardId : null,
                            channelId: data.channelId,
                            awardDetail: data.award_details[ii].details,
                            issuedBy: data.award_details[ii].issued_by,
                            validUpto: valid_upto,
                            isLifeTime: data.award_details[ii].isLifeTime,
                            documentId: (+data.award_details[ii].imageId > 0) ? +data.award_details[ii].imageId : null
                        };
                        let award1 = {
                            channelId: data.channelId,
                            awardDetail: data.award_details[ii].details,
                            issuedBy: data.award_details[ii].issued_by,
                            validUpto: valid_upto,
                            isLifeTime: data.award_details[ii].isLifeTime,
                            documentId: (+data.award_details[ii].imageId > 0) ? +data.award_details[ii].imageId : null
                        };
                        await this.awardRepository.findOrCreate({
                            where: {
                                channelId: data.channelId, channelAwardId: award.channelAwardId
                            }, defaults: award1, transaction
                        }).then(res => {
                            if (!res[1]) {
                                res[0].update(award);
                            }
                        });
                    }
                }
                let channeldet = await this.channelRepository.findByPk(data.channelId);
                await this.addressRepository.update(address, { where: {
                        addressId: channeldet.billAddressId
                    }, transaction });
                return certiObject;
            });
        })
            .catch((err) => {
            console.log(err);
            throw new Process_exception_1.ProcessException('account:singup:tryAgain');
        });
    }
    async updateUserCompanyProfile(requestObject, user) {
        let companyProfile = '';
        let companyProfileJson = '';
        let channelStatusArray = [app_constant_1.appconstant.CHANNEL_APPROVED, app_constant_1.appconstant.CHANNEL_APPROVAL];
        let realUser = user;
        if (realUser && realUser.channel && +realUser.channel.channelTypeId === +app_constant_1.appconstant.CHANNEL_TYPE_HUB) {
            let result = await this.channelRepository.findOne({
                where: {
                    companyName: requestObject.company_name.trim(),
                    channelId: {
                        $not: +user.channel.channelId
                    }
                }
            });
            if (result) {
                throw new Process_exception_1.ProcessException('channel:profile:companyNameAlreadyExist');
            }
            channelStatusArray.push(+user.channel.signUpStatusId);
        }
        try {
            let result = '';
            console.log('user.channel.signUpStatusId', user.channel.signUpStatusId);
            let userSignUpStatus = channelStatusArray.includes(+user.channel.signUpStatusId);
            if (userSignUpStatus) {
                companyProfile = await this.userRepository.scope('userBasicInfom').findOne({
                    include: [
                        {
                            model: this.contactRepository.scope('contactInfo'),
                            where: { deletedAt: null },
                            include: [
                                {
                                    model: this.mediaRepository,
                                    include: [
                                        {
                                            model: this.mediaTypeRepository,
                                            required: false
                                        },
                                    ],
                                    required: false
                                }
                            ]
                        },
                        {
                            model: this.channelRepository.scope('profileInfom'),
                            where: { signUpStatusId: parseInt(user.channel.signUpStatusId), deletedAt: null },
                            include: [
                                {
                                    model: this.channelDetailRepository.scope('channelDetail'),
                                    where: { deletedAt: null },
                                    include: [
                                        {
                                            model: this.mediaRepository,
                                            as: 'channelLogo',
                                            include: [
                                                {
                                                    model: this.mediaTypeRepository,
                                                    required: false
                                                },
                                            ],
                                            required: false
                                        },
                                        {
                                            model: this.mediaRepository,
                                            as: 'channelIcon',
                                            include: [
                                                {
                                                    model: this.mediaTypeRepository,
                                                    required: false
                                                },
                                            ],
                                            required: false
                                        }
                                    ]
                                },
                                {
                                    model: this.channelCertiRepository.scope('profileInfo'),
                                    where: { deletedAt: null },
                                    required: false
                                },
                                {
                                    model: this.channelDocumentRepository,
                                    where: { deletedAt: null },
                                    required: false,
                                    include: [
                                        {
                                            model: this.mediaRepository,
                                            as: 'document',
                                            required: false
                                        }
                                    ]
                                }
                            ]
                        }
                    ],
                    where: { userId: parseInt(user.userId), deletedAt: null }
                });
            }
            if (companyProfile) {
                companyProfileJson = companyProfile.toJSON();
                result = await this.sequelizeInstance.transaction(async (transaction) => {
                    var _a, _b;
                    let billAddress;
                    let comapnyLogo;
                    let comapnyIcon;
                    let contactProfileImage;
                    let comapnyLogoId = null;
                    let comapnyIconId = null;
                    let comapnyRegAddressId = null;
                    let comapnyBillAddressId = null;
                    let contactProfileImageId = null;
                    if (requestObject.reg_address_id) {
                        await this.addressRepository.update({
                            address: requestObject.reg_address,
                            city: requestObject.reg_city,
                            countryId: requestObject.reg_country_id,
                            postalCode: requestObject.reg_postal_code,
                        }, {
                            where: { addressId: companyProfile.channel.regAddressId },
                            returning: true, transaction,
                        });
                        comapnyRegAddressId = companyProfile.channel.regAddressId;
                    }
                    if (requestObject.is_same_address) {
                        comapnyBillAddressId = comapnyRegAddressId;
                    }
                    else {
                        if (requestObject.bill_address_id) {
                            await this.addressRepository.update({
                                address: requestObject.bill_address,
                                city: requestObject.bill_city,
                                countryId: requestObject.bill_country_id,
                                postalCode: requestObject.bill_postal_code,
                            }, {
                                where: { addressId: requestObject.bill_address_id },
                                returning: true, transaction,
                            });
                            comapnyBillAddressId = requestObject.bill_address_id;
                        }
                        else {
                            if (requestObject.bill_address && requestObject.bill_city && requestObject.bill_country_id && requestObject.bill_postal_code) {
                                billAddress = await this.addressRepository.create({
                                    address: requestObject.bill_address,
                                    city: requestObject.bill_city,
                                    countryId: requestObject.bill_country_id,
                                    postalCode: requestObject.bill_postal_code,
                                }, { transaction });
                                comapnyBillAddressId = billAddress.addressId;
                            }
                        }
                    }
                    let companyInfoUpdate = {
                        regAddressId: comapnyRegAddressId,
                        billAddressId: comapnyBillAddressId,
                        countryId: +requestObject.reg_country_id,
                        isCompanyPublic: requestObject.is_company_public || '0',
                        isOEM: requestObject.isOEM || '3'
                    };
                    if (realUser && realUser.channel && +realUser.channel.channelTypeId === +app_constant_1.appconstant.CHANNEL_TYPE_HUB) {
                        companyInfoUpdate.companyName = requestObject.company_name.trim();
                    }
                    await this.channelRepository.update(companyInfoUpdate, {
                        where: { channelId: companyProfile.channel.channelId }, returning: true, transaction,
                    });
                    if (requestObject.social_linkedin_id) {
                        await this.socialLinkRepository.update({
                            socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_LINKEDIN,
                            channelId: companyProfile.channelId,
                            channelSocialLink: requestObject.social_linkedin_url
                        }, {
                            where: { channelSocialLinkId: requestObject.social_linkedin_id },
                            returning: true, transaction,
                        });
                    }
                    else {
                        if (requestObject.social_linkedin_url && Object.keys(requestObject.social_linkedin_url).length > 0) {
                            await this.socialLinkRepository.create({
                                socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_LINKEDIN,
                                channelId: companyProfile.channelId,
                                channelSocialLink: requestObject.social_linkedin_url
                            }, {
                                transaction
                            });
                        }
                    }
                    if (requestObject.social_googleplus_id) {
                        await this.socialLinkRepository.update({
                            socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_GOOGLEPLUS,
                            channelId: companyProfile.channelId,
                            channelSocialLink: requestObject.social_googleplus_url
                        }, {
                            where: { channelSocialLinkId: requestObject.social_googleplus_id },
                            returning: true, transaction,
                        });
                    }
                    else {
                        if (requestObject.social_googleplus_url && Object.keys(requestObject.social_googleplus_url).length > 0) {
                            await this.socialLinkRepository.create({
                                socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_GOOGLEPLUS,
                                channelId: companyProfile.channelId,
                                channelSocialLink: requestObject.social_googleplus_url
                            }, {
                                transaction
                            });
                        }
                    }
                    if (requestObject.social_instagram_id) {
                        await this.socialLinkRepository.update({
                            channelId: companyProfile.channelId,
                            channelSocialLink: requestObject.social_instagram_url
                        }, {
                            where: { channelSocialLinkId: requestObject.social_instagram_id },
                            returning: true, transaction,
                        });
                    }
                    else {
                        if (requestObject.social_instagram_url && Object.keys(requestObject.social_instagram_url).length > 0) {
                            await this.socialLinkRepository.create({
                                socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_INSTAGRAM,
                                channelId: companyProfile.channelId,
                                channelSocialLink: requestObject.social_instagram_url
                            }, {
                                transaction
                            });
                        }
                    }
                    if (requestObject.social_twitter_id) {
                        await this.socialLinkRepository.update({
                            channelId: companyProfile.channelId,
                            channelSocialLink: requestObject.social_twitter_url
                        }, {
                            where: { channelSocialLinkId: requestObject.social_twitter_id },
                            returning: true, transaction,
                        });
                    }
                    else {
                        if (requestObject.social_twitter_url && Object.keys(requestObject.social_twitter_url).length > 0) {
                            await this.socialLinkRepository.create({
                                socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_TWITTER,
                                channelId: companyProfile.channelId,
                                channelSocialLink: requestObject.social_twitter_url
                            }, {
                                transaction
                            });
                        }
                    }
                    if (requestObject.social_facebook_id) {
                        await this.socialLinkRepository.update({
                            channelId: companyProfile.channelId,
                            channelSocialLink: requestObject.social_facebook_url
                        }, {
                            where: { channelSocialLinkId: requestObject.social_facebook_id },
                            returning: true, transaction,
                        });
                    }
                    else {
                        if (requestObject.social_facebook_url && Object.keys(requestObject.social_facebook_url).length > 0) {
                            await this.socialLinkRepository.create({
                                socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_FACEBOOK,
                                channelId: companyProfile.channelId,
                                channelSocialLink: requestObject.social_facebook_url
                            }, {
                                transaction
                            });
                        }
                    }
                    if (requestObject.B2B_url && Object.keys(requestObject.B2B_url).length > 0) {
                        for (let ii = 0; ii < requestObject.B2B_url.length; ii++) {
                            if (requestObject.B2B_url[ii].channel_B2B_id) {
                                await this.channelB2BRepository.update({
                                    channelId: companyProfile.channelId,
                                    channelB2B: requestObject.B2B_url[ii].B2B_url
                                }, {
                                    where: { channelB2BId: requestObject.B2B_url[ii].channel_B2B_id },
                                    returning: true, transaction,
                                });
                            }
                            else {
                                await this.channelB2BRepository.create({
                                    channelId: companyProfile.channelId,
                                    channelB2B: requestObject.B2B_url[ii].B2B_url
                                }, {
                                    transaction
                                });
                            }
                        }
                    }
                    if (requestObject.registration_certificate && Object.keys(requestObject.registration_certificate).length > 0) {
                        for (let ii = 0; ii < requestObject.registration_certificate.length; ii++) {
                            if (requestObject.registration_certificate[ii].channel_certificate_id) {
                                await this.channelCertiRepository.update({
                                    channelId: companyProfile.channelId,
                                    cerificateName: requestObject.registration_certificate[ii].name,
                                    cerificateNumber: requestObject.registration_certificate[ii].id,
                                    cerificateTypeId: app_constant_1.appconstant.CERTIFICATETYPE_REGISTRATION
                                }, {
                                    where: { channelCerificateId: requestObject.registration_certificate[ii].channel_certificate_id },
                                    returning: true, transaction,
                                });
                            }
                            else {
                                await this.channelCertiRepository.create({
                                    channelId: companyProfile.channelId,
                                    cerificateName: requestObject.registration_certificate[ii].name,
                                    cerificateNumber: requestObject.registration_certificate[ii].id,
                                    cerificateTypeId: app_constant_1.appconstant.CERTIFICATETYPE_REGISTRATION
                                }, {
                                    transaction
                                });
                            }
                        }
                    }
                    if (requestObject.tax_certificate && Object.keys(requestObject.tax_certificate).length > 0) {
                        for (let ii = 0; ii < requestObject.tax_certificate.length; ii++) {
                            if (requestObject.tax_certificate[ii].channel_certificate_id) {
                                await this.channelCertiRepository.update({
                                    channelId: companyProfile.channelId,
                                    cerificateName: requestObject.tax_certificate[ii].name,
                                    cerificateNumber: requestObject.tax_certificate[ii].id,
                                    cerificateTypeId: app_constant_1.appconstant.CERTIFICATETYPE_TAX
                                }, {
                                    where: { channelCerificateId: requestObject.tax_certificate[ii].channel_certificate_id },
                                    returning: true, transaction,
                                });
                            }
                            else {
                                await this.channelCertiRepository.create({
                                    channelId: companyProfile.channelId,
                                    cerificateName: requestObject.tax_certificate[ii].name,
                                    cerificateNumber: requestObject.tax_certificate[ii].id,
                                    cerificateTypeId: app_constant_1.appconstant.CERTIFICATETYPE_TAX
                                }, {
                                    transaction
                                });
                            }
                        }
                    }
                    if (requestObject.deleted_registration_certificate && requestObject.deleted_registration_certificate.length > 0) {
                        for (let ii = 0; ii < requestObject.deleted_registration_certificate.length; ii++) {
                            if (requestObject.deleted_registration_certificate[ii]) {
                                await this.channelCertiRepository.update({
                                    channelId: companyProfile.channelId,
                                    deletedAt: new Date()
                                }, {
                                    where: { channelCerificateId: requestObject.deleted_registration_certificate[ii] },
                                    returning: true, transaction,
                                });
                            }
                        }
                    }
                    if (requestObject.deleted_tax_certificate && requestObject.deleted_tax_certificate.length > 0) {
                        for (let ii = 0; ii < requestObject.deleted_tax_certificate.length; ii++) {
                            if (requestObject.deleted_tax_certificate[ii]) {
                                await this.channelCertiRepository.update({
                                    channelId: companyProfile.channelId,
                                    deletedAt: new Date()
                                }, {
                                    where: { channelCerificateId: requestObject.deleted_tax_certificate[ii] },
                                    returning: true, transaction,
                                });
                            }
                        }
                    }
                    if (requestObject.channel_document && Object.keys(requestObject.channel_document).length > 0) {
                        for (let ii = 0; ii < requestObject.channel_document.length; ii++) {
                            if (requestObject.channel_document[ii].channelDocumentId) {
                                await this.channelDocumentRepository.update({
                                    channelId: companyProfile.channelId,
                                    documentId: requestObject.channel_document[ii].documentId,
                                    name: _.defaultTo(requestObject.channel_document[ii].documentName, ''),
                                    description: _.defaultTo(requestObject.channel_document[ii].documentDescription, ''),
                                    updatedBy: companyProfile.userId
                                }, {
                                    where: { channelDocumentId: requestObject.channel_document[ii].channelDocumentId },
                                    returning: true, transaction,
                                });
                            }
                            else {
                                await this.channelDocumentRepository.create({
                                    channelId: companyProfile.channelId,
                                    documentId: requestObject.channel_document[ii].documentId,
                                    name: _.defaultTo(requestObject.channel_document[ii].documentName, ''),
                                    description: _.defaultTo(requestObject.channel_document[ii].documentDescription, ''),
                                    updatedBy: companyProfile.userId
                                }, {
                                    transaction
                                });
                            }
                        }
                    }
                    if (requestObject.deleted_channel_documents && requestObject.deleted_channel_documents.length > 0) {
                        for (let ii = 0; ii < requestObject.deleted_channel_documents.length; ii++) {
                            if (requestObject.deleted_channel_documents[ii]) {
                                await this.channelDocumentRepository.update({
                                    deletedAt: new Date()
                                }, {
                                    where: { channelDocumentId: requestObject.deleted_channel_documents[ii] },
                                    returning: true, transaction,
                                });
                            }
                        }
                    }
                    if (requestObject.deleted_award_details && requestObject.deleted_award_details.length > 0) {
                        await this.awardRepository.update({
                            deletedAt: new Date()
                        }, {
                            where: {
                                channelAwardId: {
                                    [sequelize_1.Op.in]: requestObject.deleted_award_details
                                }
                            },
                            returning: true, transaction,
                        });
                    }
                    if (requestObject.deleted_B2B && requestObject.deleted_B2B.length > 0) {
                        for (let ii = 0; ii < requestObject.deleted_B2B.length; ii++) {
                            if (requestObject.deleted_B2B[ii]) {
                                await this.channelB2BRepository.update({
                                    channelId: companyProfile.channelId,
                                    deletedAt: new Date()
                                }, {
                                    where: { channelB2BId: requestObject.deleted_B2B[ii] },
                                    returning: true, transaction,
                                });
                            }
                        }
                    }
                    if (requestObject.award_details && Object.keys(requestObject.award_details).length > 0) {
                        for (let ii = 0; ii < requestObject.award_details.length; ii++) {
                            await this.awardRepository.create({
                                channelId: companyProfile.channelId,
                                awardDetail: 'channel',
                                issuedBy: 'ch',
                                documentId: requestObject.award_details[ii].documentId,
                            }, {
                                transaction
                            });
                        }
                    }
                    if (companyProfileJson.channel.channelDetail.channelLogoId) {
                        comapnyLogoId = companyProfileJson.channel.channelDetail.channelLogoId;
                    }
                    if (requestObject.company_logo_url) {
                        comapnyLogoId = requestObject.company_logo_url;
                    }
                    let bannerId = null;
                    if (requestObject.bannerImage.length > 0) {
                        let companyBanner;
                        if (!lodash_1.isUndefined(requestObject.bannerImage[0].id) && requestObject.bannerImage[0].id != '') {
                            bannerId = requestObject.bannerImage[0].id;
                        }
                        else {
                            let oldBanner = await this.channelDetailRepository.findOne({
                                where: { channelId: user.channelId },
                                attributes: ['channelBannerId']
                            }).then(res => {
                                console.log('banner', res.channelBannerId);
                                return res.channelBannerId;
                            }).catch(err => console.log('banner error', err));
                            if (oldBanner) {
                                await this.mediaRepository.update({ deletedAt: new Date() }, { where: {
                                        documentId: +oldBanner
                                    } });
                            }
                            companyBanner = await this.mediaRepository.create({
                                documentPath: requestObject.bannerImage[0].image,
                                documentTypeId: app_constant_1.appconstant.DOCUMENTTYPE_IMAGE,
                                dirName: app_constant_1.appconstant.FOLDER_PATH_COMPANY_BANNER
                            }, {
                                transaction,
                            });
                            bannerId = companyBanner.documentId;
                        }
                    }
                    if ((_a = requestObject.certificatesList) === null || _a === void 0 ? void 0 : _a.length) {
                        let certificateTag = requestObject.certificatesList.map(x => {
                            x.channelId = user.channelId;
                            x.createdat = new Date();
                            return x;
                        });
                        await CertificateTag_entity_1.CertificateTag.bulkCreate(certificateTag, {
                            transaction
                        });
                    }
                    if ((_b = requestObject.deletedTags) === null || _b === void 0 ? void 0 : _b.length) {
                        await CertificateTag_entity_1.CertificateTag.update({ deletedat: new Date() }, {
                            where: {
                                channelId: user.channelId,
                                certificatetagid: {
                                    [sequelize_1.Op.in]: requestObject.deletedTags
                                }
                            },
                            transaction, returning: true
                        });
                    }
                    if (requestObject.companyImages && Object.keys(requestObject.companyImages).length > 0) {
                        for (let ii = 0; ii < requestObject.companyImages.length; ii++) {
                            if (!requestObject.companyImages[ii].companyMediaId) {
                                await this.companyMediaImagesRepository.create({
                                    channelId: companyProfile.channelId,
                                    documentId: requestObject.companyImages[ii].documentId,
                                    contactId: companyProfile.contactId,
                                    updatedBy: companyProfile.userId
                                }, {
                                    transaction
                                });
                            }
                        }
                    }
                    if (requestObject.deleted_companyImages && requestObject.deleted_companyImages.length > 0) {
                        for (let ii = 0; ii < requestObject.deleted_companyImages.length; ii++) {
                            if (requestObject.deleted_companyImages[ii]) {
                                await this.companyMediaImagesRepository.update({
                                    deletedAt: new Date()
                                }, {
                                    where: { companyMediaId: requestObject.deleted_companyImages[ii] },
                                    returning: true, transaction,
                                });
                            }
                        }
                    }
                    return await this.channelDetailRepository.update({
                        channelLogoId: comapnyLogoId,
                        channelBannerId: bannerId,
                        estYear: requestObject.year_of_estabilishment,
                        phone1: requestObject.company_phone1,
                        webSiteUrl: requestObject.company_website_url,
                        introvideoId: requestObject.company_introvideo,
                        detailDesc: requestObject.company_about,
                        expectations: requestObject.company_expectation,
                        companyDesc: requestObject.companyDesc
                    }, {
                        where: { channelId: companyProfile.channelId }, returning: true, transaction,
                    });
                });
                if (result) {
                    if (+user.channel.signUpStatusId == app_constant_1.appconstant.CHANNEL_APPROVAL || requestObject.ratingId) {
                        let defaultdata = {
                            channelId: +user.channel.channelId,
                            ratingId: 1,
                            isCompleted: true,
                            createdAt: new Date()
                        };
                        await this.profileRepository.findOrCreate({ where: { channelId: +user.channel.channelId, ratingId: 1 }, defaults: defaultdata }).then((result) => {
                            if (!result[1]) {
                                result[0].update(defaultdata);
                            }
                        });
                    }
                    return true;
                }
                else {
                    return false;
                }
            }
        }
        catch (e) {
            console.log("Error+", e);
        }
        if (!companyProfile) {
            throw new Process_exception_1.ProcessException('channel:getCompanyProfile:companyNotFound');
        }
    }
    async imageUpdate(imageId, image, transaction) {
        let logo = await this.mediaRepository.update({ deletedAt: new Date() }, {
            where: { documentId: imageId },
            returning: true, transaction,
        }).then(async () => {
            return await this.imageCreate(image, transaction);
        });
        return logo;
    }
    async updatetradeInformation(params, user) {
        try {
            let ChannelSpecialityObject = [];
            let userDetails = await this.userRepository.scope('userBasicInfom').findOne({
                where: { userId: parseInt(user.userId), isActive: '1' }
            });
            if (userDetails) {
                let result = await this.sequelizeInstance.transaction(async (transaction) => {
                    var _a, _b, _c, _d, _e, _f;
                    let channelContacts = await this.contactRepository.scope('basicInfom').findAll({
                        where: {
                            deletedAt: null,
                            contactId: { [sequelize_1.Op.ne]: user.contactId },
                            channelId: user.channelId
                        }
                    });
                    let contacts = [];
                    contacts.push(user.contactId);
                    if (channelContacts.length > 0) {
                        channelContacts.map(function (data) {
                            contacts.push(data.contactId);
                        });
                    }
                    let ChannelDetailObject = {};
                    if (((_a = params.productFamilies) === null || _a === void 0 ? void 0 : _a.length) > 0) {
                        let productGroup = await this.channelProductGroupRepository.findAll({
                            where: {
                                channelId: user.channelId,
                                deletedAt: null
                            }
                        });
                        let ChannelProductGroupIds = await this.tradeInformationInBound.setProductGroupIds(productGroup);
                        let ChannelProductGroupObject = await this.tradeInformationInBound.setProductGroup(params.productFamilies, user.channelId);
                        let ChannelProductGroupCurrentIds = [];
                        let ChannelProductGroupCreateObject = [];
                        let ContactProductGroupObject = await this.tradeInformationInBound.setContactProductGroup(params.productFamilies, user.contactId);
                        let ContactProductGroupCurrentIds = [];
                        for (let kk = 0; kk < ChannelProductGroupObject.length; kk++) {
                            if (ChannelProductGroupIds.includes(ChannelProductGroupObject[kk].productGroupId)) {
                                ChannelProductGroupCurrentIds.push(ChannelProductGroupObject[kk].productGroupId);
                            }
                            else {
                                ChannelProductGroupCreateObject.push(ChannelProductGroupObject[kk]);
                                ChannelProductGroupCurrentIds.push(ChannelProductGroupObject[kk].productGroupId);
                            }
                            ContactProductGroupCurrentIds.push(ContactProductGroupObject[kk].productGroupId);
                        }
                        if (ChannelProductGroupCreateObject.length > 0) {
                            await this.channelProductGroupRepository.bulkCreate(ChannelProductGroupCreateObject, { returning: true, transaction });
                        }
                        await this.channelProductGroupRepository.update({ deletedAt: new Date() }, {
                            where: {
                                channelId: user.channelId,
                                productGroupId: { [sequelize_1.Op.notIn]: ChannelProductGroupCurrentIds },
                                deletedAt: null
                            }, returning: true, transaction
                        });
                        await this.contactGroupRepository.update({ deletedAt: new Date() }, {
                            where: {
                                contactId: { [sequelize_1.Op.in]: contacts },
                                productGroupId: { [sequelize_1.Op.notIn]: ContactProductGroupCurrentIds },
                                deletedAt: null
                            }, returning: true, transaction
                        });
                    }
                    if (((_b = params.productCategories) === null || _b === void 0 ? void 0 : _b.length) > 0) {
                        let productCategory = await this.channelProductCategorieRepository.findAll({
                            where: {
                                channelId: user.channelId,
                                deletedAt: null
                            }
                        });
                        let productCategoriesIds = await this.tradeInformationInBound.setProductCategoryIds(productCategory);
                        let ProductCategorieObject = await this.tradeInformationInBound.setProductCategories(params.productCategories, user.channelId);
                        let ChannelProductCategoriesCurrentIds = [];
                        let ChannelProductCategoriesCreateObject = [];
                        let contactProductCategorieObject = await this.tradeInformationInBound.setContactProductCategories(params.productCategories, user.contactId);
                        let ContactProductCategoriesCurrentIds = [];
                        for (let kk = 0; kk < ProductCategorieObject.length; kk++) {
                            if (productCategoriesIds.includes(ProductCategorieObject[kk].productCategorieId)) {
                                ChannelProductCategoriesCurrentIds.push(ProductCategorieObject[kk].productCategorieId);
                            }
                            else {
                                ChannelProductCategoriesCreateObject.push(ProductCategorieObject[kk]);
                                ChannelProductCategoriesCurrentIds.push(ProductCategorieObject[kk].productCategorieId);
                            }
                            ContactProductCategoriesCurrentIds.push(contactProductCategorieObject[kk].productCategorieId);
                        }
                        if (ChannelProductCategoriesCreateObject.length > 0) {
                            await this.channelProductCategorieRepository.bulkCreate(ChannelProductCategoriesCreateObject, { returning: true, transaction });
                        }
                        await this.channelProductCategorieRepository.update({ deletedAt: new Date() }, {
                            where: {
                                channelId: user.channelId,
                                productCategorieId: { [sequelize_1.Op.notIn]: ChannelProductCategoriesCurrentIds },
                                deletedAt: null
                            }, returning: true, transaction
                        });
                        await this.contactCatRepository.update({ deletedAt: new Date() }, {
                            where: {
                                contactId: { [sequelize_1.Op.in]: contacts },
                                productCategorieId: { [sequelize_1.Op.notIn]: ContactProductCategoriesCurrentIds },
                                deletedAt: null
                            }, returning: true, transaction
                        });
                    }
                    if (params.customerProfiles && ((_c = params.customerProfiles) === null || _c === void 0 ? void 0 : _c.length) > 0) {
                        let customerProfiles = await this.channelCustomerProfileRepository.findAll({
                            where: {
                                channelId: user.channelId,
                                deletedAt: null
                            }
                        });
                        let customerProfilesIds = await this.tradeInformationInBound.setCustomerProfilesIds(customerProfiles);
                        let customerProfilesObject = await this.tradeInformationInBound.setCustomerProfiles(params.customerProfiles, user.channelId);
                        let channelCustomerProfilesCurrentIds = [];
                        let ChannelCustomerProfilesCreateObject = [];
                        for (let kk = 0; kk < customerProfilesObject.length; kk++) {
                            if (customerProfilesIds.includes(customerProfilesObject[kk].profileTypeId)) {
                                channelCustomerProfilesCurrentIds.push(customerProfilesObject[kk].profileTypeId);
                            }
                            else {
                                ChannelCustomerProfilesCreateObject.push(customerProfilesObject[kk]);
                                channelCustomerProfilesCurrentIds.push(customerProfilesObject[kk].profileTypeId);
                            }
                        }
                        if (ChannelCustomerProfilesCreateObject.length > 0) {
                            await this.channelCustomerProfileRepository.bulkCreate(ChannelCustomerProfilesCreateObject, { returning: true, transaction });
                        }
                        await this.channelCustomerProfileRepository.update({ deletedAt: new Date() }, {
                            where: {
                                channelId: user.channelId,
                                profileTypeId: { [sequelize_1.Op.notIn]: channelCustomerProfilesCurrentIds },
                                deletedAt: null
                            }, returning: true, transaction
                        });
                    }
                    let channelObject = {
                        isFrenchTech: params.is_french_tech
                    };
                    if (params.channelType == app_constant_1.appconstant.CHANNEL_TYPE_VENDOR) {
                        if (((_d = params.tradeInformationVendor.brand) === null || _d === void 0 ? void 0 : _d.length) > 0) {
                            let channelBrandObject = await this.saveBrand(params.tradeInformationVendor.brand, user.channelId, transaction);
                            if (channelBrandObject.channelBrandArrayObject.length > 0) {
                                let brand = await this.channelBrandRepository.findAll({
                                    where: {
                                        channelId: user.channelId,
                                        deletedAt: null
                                    }
                                });
                                let ChannelBrandCurrentIds = [];
                                let ChannelBrandCreateObject = [];
                                let brandObject = channelBrandObject.channelBrandArrayObject;
                                let brandIds = channelBrandObject.brandIds;
                                let ChannelBrandIds = await this.tradeInformationInBound.setchannelbrandIds(brand);
                                let totalRemovedBrands = ChannelBrandIds.filter(e => !brandIds.find(a => e == a));
                                for (let kk = 0; kk < brandObject.length; kk++) {
                                    if (!ChannelBrandIds.includes(brandObject[kk].brandId)) {
                                        ChannelBrandCreateObject.push(brandObject[kk]);
                                    }
                                    if (!totalRemovedBrands.includes(+brandObject[kk].brandId)) {
                                        ChannelBrandCurrentIds.push(brandObject[kk].brandId);
                                    }
                                }
                                if (ChannelBrandCreateObject.length > 0) {
                                    await this.channelBrandRepository.bulkCreate(ChannelBrandCreateObject, { returning: true, transaction });
                                }
                                await this.channelBrandRepository.update({ deletedAt: new Date() }, {
                                    where: {
                                        channelId: user.channelId,
                                        brandId: { [sequelize_1.Op.notIn]: ChannelBrandCurrentIds },
                                        deletedAt: null
                                    }, returning: true, transaction
                                });
                                await this.brandRepository.update({
                                    isAssigned: '1'
                                }, {
                                    where: {
                                        id: {
                                            [sequelize_1.Op.in]: brandIds
                                        }
                                    },
                                    returning: true, transaction
                                });
                                await this.brandRepository.update({
                                    isAssigned: '0'
                                }, {
                                    where: {
                                        id: {
                                            [sequelize_1.Op.in]: totalRemovedBrands
                                        }
                                    },
                                    returning: true, transaction
                                });
                            }
                        }
                        if (params.tradeInformationVendor && params.tradeInformationVendor.profileTypeId) {
                            channelObject.profileTypeId = params.tradeInformationVendor.profileTypeId;
                        }
                        await this.tradeInformationInBound.keyRetailers(app_constant_1.appconstant.CHANNEL_TYPE_RETAILER, params.tradeInformationVendor.channelKeyRetailer, user.channelId, user.userId, params.tradeInformationVendor.deletedkeyretailer);
                        await this.tradeInformationInBound.keyRetailers(app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR, params.tradeInformationVendor.channelKeyDistributor, user.channelId, user.userId, params.tradeInformationVendor.deletedkeydistributor);
                        ChannelDetailObject = await this.tradeInformationInBound.setChannelDetail(params.tradeInformationVendor, user.channelId, user.channelTypeId);
                    }
                    else if (params.channelType == app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR) {
                        if (params.tradeInformationDistributor && ((_e = params.tradeInformationDistributor) === null || _e === void 0 ? void 0 : _e.brand) && params.tradeInformationDistributor.brand.length > 0) {
                            let channelBrandObject = await this.saveBrand(params.tradeInformationDistributor.brand, user.channelId, transaction);
                            if (channelBrandObject.channelBrandArrayObject.length > 0) {
                                let brand = await this.channelBrandRepository.findAll({
                                    where: {
                                        channelId: user.channelId,
                                        deletedAt: null
                                    }
                                });
                                let ChannelBrandCurrentIds = [];
                                let ChannelBrandCreateObject = [];
                                let brandObject = channelBrandObject.channelBrandArrayObject;
                                let ChannelBrandIds = await this.tradeInformationInBound.setchannelbrandIds(brand);
                                let totalRemovedBrands = ChannelBrandIds.filter(e => !brandObject.find(a => e == a.brandId));
                                for (let kk = 0; kk < brandObject.length; kk++) {
                                    if (!ChannelBrandIds.includes(brandObject[kk].brandId)) {
                                        ChannelBrandCreateObject.push(brandObject[kk]);
                                    }
                                    if (!totalRemovedBrands.includes(+brandObject[kk].brandId)) {
                                        ChannelBrandCurrentIds.push(brandObject[kk].brandId);
                                    }
                                }
                                if (ChannelBrandCreateObject.length > 0) {
                                    await this.channelBrandRepository.bulkCreate(ChannelBrandCreateObject, { returning: true, transaction });
                                }
                                await this.channelBrandRepository.update({ deletedAt: new Date() }, {
                                    where: {
                                        channelId: user.channelId,
                                        brandId: { [sequelize_1.Op.notIn]: ChannelBrandCurrentIds },
                                        deletedAt: null
                                    }, returning: true, transaction
                                });
                                console.log(JSON.stringify(ChannelBrandCurrentIds));
                                await this.brandRepository.update({
                                    isAssigned: '1'
                                }, {
                                    where: {
                                        id: {
                                            [sequelize_1.Op.in]: channelBrandObject.brandIds
                                        }
                                    },
                                    returning: true, transaction
                                });
                                await this.brandRepository.update({
                                    isAssigned: '0'
                                }, {
                                    where: {
                                        id: {
                                            [sequelize_1.Op.in]: totalRemovedBrands
                                        }
                                    },
                                    returning: true, transaction
                                });
                                console.log(JSON.stringify(totalRemovedBrands));
                            }
                        }
                        ChannelDetailObject = await this.tradeInformationInBound.setChannelDetail(params.tradeInformationDistributor, user.channelId, user.channelTypeId);
                        ChannelSpecialityObject = await this.tradeInformationInBound.setSpeciality(params.tradeInformationDistributor.distributorSpeciality, user.channelId);
                        if (((_f = params.tradeInformationDistributor.listOfServices) === null || _f === void 0 ? void 0 : _f.length) > 0) {
                            let serviceList = await this.channelServiceListRepository.findAll({
                                where: {
                                    channelId: user.channelId,
                                    deletedAt: null
                                }
                            });
                            let ChannelServiceListIds = await this.tradeInformationInBound.setServiceListIds(serviceList);
                            let ChannelServiceListObject = await this.tradeInformationInBound.setServiceList(params.tradeInformationDistributor.listOfServices, user.channelId);
                            let ChannelServiceListCurrentIds = [];
                            let ChannelServiceListCreateObject = [];
                            for (let kk = 0; kk < ChannelServiceListObject.length; kk++) {
                                if (ChannelServiceListIds.includes(ChannelServiceListObject[kk].serviceListId)) {
                                    ChannelServiceListCurrentIds.push(ChannelServiceListObject[kk].serviceListId);
                                }
                                else {
                                    ChannelServiceListCreateObject.push(ChannelServiceListObject[kk]);
                                    ChannelServiceListCurrentIds.push(ChannelServiceListObject[kk].serviceListId);
                                }
                            }
                            if (ChannelServiceListCreateObject.length > 0) {
                                await this.channelServiceListRepository.bulkCreate(ChannelServiceListCreateObject, { returning: true, transaction });
                            }
                            await this.channelServiceListRepository.update({ deletedAt: new Date() }, {
                                where: {
                                    channelId: user.channelId,
                                    serviceListId: { [sequelize_1.Op.notIn]: ChannelServiceListCurrentIds },
                                    deletedAt: null
                                }, returning: true, transaction
                            });
                        }
                        await this.tradeInformationInBound.keyRetailers(app_constant_1.appconstant.CHANNEL_TYPE_RETAILER, params.tradeInformationDistributor.channelKeyRetailer, user.channelId, user.userId, params.tradeInformationDistributor.deletedkeyretailer);
                        channelObject.profileTypeId = params.tradeInformationDistributor.profileTypeId;
                    }
                    else if (params.channelType == app_constant_1.appconstant.CHANNEL_TYPE_RETAILER) {
                        ChannelDetailObject = await this.tradeInformationInBound.setChannelDetail(params.tradeInformationRetailer, user.channelId, user.channelTypeId);
                        channelObject.profileTypeId = params.tradeInformationRetailer.profileTypeId;
                    }
                    else if (params.channelType == app_constant_1.appconstant.CHANNEL_TYPE_RESELLER) {
                        ChannelDetailObject = await this.tradeInformationInBound.setChannelDetail(params.tradeInformationRetailer, user.channelId, user.channelTypeId);
                        channelObject.profileTypeId = params.tradeInformationRetailer.profileTypeId;
                    }
                    if (ChannelSpecialityObject.length > 0) {
                        let speciality = await this.channelSpecialityRepository.findAll({
                            where: {
                                channelId: user.channelId,
                                deletedAt: null
                            }
                        });
                        let ChannelSpecialityIds = await this.tradeInformationInBound.setProductGroupIds(speciality);
                        let ChannelSpecialityCurrentIds = [];
                        let ChannelSpecialityCreateObject = [];
                        for (let kk = 0; kk < ChannelSpecialityObject.length; kk++) {
                            if (ChannelSpecialityIds.includes(ChannelSpecialityObject[kk].productGroupId)) {
                                ChannelSpecialityCurrentIds.push(ChannelSpecialityObject[kk].productGroupId);
                            }
                            else {
                                ChannelSpecialityCreateObject.push(ChannelSpecialityObject[kk]);
                                ChannelSpecialityCurrentIds.push(ChannelSpecialityObject[kk].productGroupId);
                            }
                        }
                        if (ChannelSpecialityCreateObject.length > 0) {
                            await this.channelSpecialityRepository.bulkCreate(ChannelSpecialityCreateObject, { returning: true, transaction });
                        }
                        await this.channelSpecialityRepository.update({ deletedAt: new Date() }, {
                            where: {
                                channelId: user.channelId,
                                productGroupId: { [sequelize_1.Op.notIn]: ChannelSpecialityCurrentIds },
                                deletedAt: null
                            }, returning: true, transaction
                        });
                    }
                    if (ChannelDetailObject) {
                        await this.channelDetailRepository.update(ChannelDetailObject, { where: { channelId: user.channelId }, returning: true, transaction });
                    }
                    return await this.channelRepository.update(channelObject, { where: { channelId: user.channelId }, returning: true, transaction });
                });
                if (result) {
                    return true;
                }
                else {
                    return false;
                }
            }
            else {
            }
        }
        catch (e) {
            console.log("Error+", e);
        }
    }
    async reportingusers(user) {
        let users = '';
        let query = 'select "contactId" as id,concat(ct."firstName",\' \',ct."lastName") as name from "tblContact" as ct where "deletedAt" is null and "channelId" =:channelId and'
            + ' "contactId" in(select "contactId" from "tblUser" where "userId" in(select "userId" from "tblUserRole" where "roleId" in(1,2))) ';
        users = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: user.channelId,
            }
        }).then(x => {
            console.log("users:", x);
            return x;
        });
        return users;
    }
    async generalInfo(req) {
        let users = '';
        let query = 'select (select array_to_json(array_agg(row_to_json(z))) from (select "contactSocialLink" from "tblContactSocialLink" where "deletedAt" is null and "socialSiteId" in(1,2) and "contactId"=:contactId)z) as sociallink,"rptContactId",(select "roleId" from "tblUserRole" where "userId" in(select "userId" from "tblUser" where "contactId"=:contactId)),(select "userId" from "tblUser" where "contactId"=:contactId) as"userId", "isShared","countryId","firstName","lastName","email","mobileNo","phone1","jobTitle","linkedIn","empId","hubspotContactId","documentId","isActive",(select "documentPath" from "tblDocument" where "documentId"=tc."documentId") from "tblContact" as tc' +
            ' where "contactId"=:contactId ';
        users = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                contactId: req.contactId,
            }
        }).then(x => {
            return Object.assign(x[0], { documentPath: x[0].documentPath ? process.env.CDN_URL + x[0].documentPath : null });
        });
        query = 'select "suggestion_comm", "invitation_comm" from "tblUser" where "contactId"=:contactId';
        let pref = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                contactId: req.contactId,
            }
        }).then(x => {
            return x[0];
        });
        users = Object.assign(users, { preference: pref });
        return users;
    }
    async searchRetailer(pagination, partner_type) {
        return await this.sequelizeInstance.query('select * from "fnfindkeyretailer"(:keyword, :channelType,\':limit\', \':offset\', :cdnUrl)', {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                keyword: (pagination) ? pagination : '',
                channelType: partner_type,
                limit: 1,
                offset: 1,
                cdnUrl: process.env.CDN_URL
            }
        }).then((results) => {
            return results[0].fnfindkeyretailer;
        });
    }
    async getKeyRetailers(channelId, partnerType) {
        return await this.sequelizeInstance.query('select * from "fnGetKeyPartnersbyChannelId"(:channelId, :partnerType, :productId, :cdnUrl)', {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: channelId,
                productId: null,
                cdnUrl: process.env.CDN_URL,
                partnerType: partnerType
            }
        }).then((results) => {
            return (results && results[0] && Array.isArray(results[0].fnGetKeyPartnersbyChannelId) && results[0].fnGetKeyPartnersbyChannelId.length > 0) ? results[0].fnGetKeyPartnersbyChannelId.map((x) => {
                if (x.active != null) {
                    x.weight = 3;
                }
                else if (x.old != null) {
                    x.weight = 2;
                }
                else {
                    x.weight = 1;
                }
                return x;
            }).sort((a, b) => (a.weight > b.weight) ? -1 : 1) : results[0].fnGetKeyPartnersbyChannelId;
        });
    }
    async existingKeyRetailerCheck(KeyRetailer, CountryId, channelId, partner_type, partner_id) {
        let partnerData = null;
        if (partner_id) {
            partnerData = await this.getKeyPartner(partner_id);
        }
        let newQuery = 'select count(*) from "tblchannelkeypartner" where LOWER(partnername) = LOWER(:KeyRetailer) and "countryid" = :countryid and deletedat is null and "channelId" = :channelId and partner_type = :partnerType';
        if (partnerData && partnerData.channelkeypartner && partnerData.channelkeypartner.channelkeypartnerid) {
            newQuery += ' and channelkeypartnerid NOT IN (:channelkeypartnerid)';
        }
        let oldQuery = 'SELECT count(*) FROM "tblOldChannel" toc WHERE LOWER(toc."companyName") = LOWER(:KeyRetailer) AND toc."countryId" = :countryId AND toc."deletedAt" is null AND toc."isActive" = \'1\' AND toc."channelTypeId" = :partnerType AND NOT EXISTS(SELECT 1 FROM "tblChannel" WHERE "oldChannelId" = toc."oldChannelId" AND "deletedAt" is null AND "signUpStatusId" = 15 AND "isActive" = \'1\' AND "channelTypeId" = :partnerType )';
        if (partnerData && partnerData.oldchannel && partnerData.oldchannel.oldChannelId) {
            oldQuery += ' AND toc."oldChannelId" NOT IN (:oldChannelId)';
        }
        if (await this.sequelizeInstance.query(newQuery, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: channelId,
                KeyRetailer: KeyRetailer,
                countryid: CountryId,
                partnerType: partner_type,
                channelkeypartnerid: (partnerData && partnerData.channelkeypartner && partnerData.channelkeypartner.channelkeypartnerid) ? [+partnerData.channelkeypartner.channelkeypartnerid] : []
            }
        }).then(async (results) => {
            if (+results[0].count > 0) {
                return true;
            }
            else {
                return await this.sequelizeInstance.query('SELECT count(*) FROM "tblChannel" WHERE LOWER("companyName") = LOWER(:KeyRetailer) AND "countryId" = :countryId AND "deletedAt" is null AND "signUpStatusId" = 15 AND "isActive" = \'1\' AND "channelTypeId" = :partnerType', {
                    type: sequelize_1.QueryTypes.SELECT,
                    replacements: {
                        KeyRetailer: KeyRetailer,
                        countryId: CountryId,
                        partnerType: partner_type
                    }
                }).then(async (results) => {
                    if (+results[0].count > 0) {
                        return true;
                    }
                    else {
                        if (await this.sequelizeInstance.query(oldQuery, {
                            type: sequelize_1.QueryTypes.SELECT,
                            replacements: {
                                KeyRetailer: KeyRetailer,
                                countryId: CountryId,
                                partnerType: partner_type,
                                oldChannelId: (partnerData && partnerData.oldchannel && partnerData.oldchannel.oldChannelId) ? [+partnerData.oldchannel.oldChannelId] : []
                            }
                        }).then(async (results) => {
                            if (+results[0].count > 0) {
                                return true;
                            }
                            else {
                                return false;
                            }
                        })) {
                            return true;
                        }
                        else {
                            return false;
                        }
                    }
                });
            }
        })) {
            console.error('validation exception key retailer');
            return false;
        }
        return true;
    }
    async getKeyPartner(partnerId) {
        let keyPartner = await KeyPartnerJCT_entity_1.KeyPartnerJCT.findOne({
            include: [
                {
                    model: OldChannel_entity_1.OldChannel,
                    as: 'oldchannel',
                    attributes: ['oldChannelId', 'companyName', 'channelTypeId', 'countryId', 'regAddressId'],
                    include: [
                        {
                            model: OldChannelDetail_entity_1.OldChannelDetail,
                            as: 'oldChannelDetail',
                            attributes: ['OldChannelDetailId', 'channelLogoId'],
                            include: [
                                {
                                    model: index_1.Media,
                                    as: 'channelLogo',
                                    required: false,
                                    attributes: ['documentPath', 'documentUrl']
                                }
                            ],
                            required: true
                        },
                        {
                            model: OldAddress_entity_1.OldAddress,
                            as: 'regAddress',
                            required: false,
                            attributes: ['oldAddressId', 'countryId'],
                            include: [
                                {
                                    model: Country_entity_1.Country,
                                    as: 'country',
                                    required: false,
                                    attributes: ['country', 'countryId']
                                }
                            ]
                        }
                    ],
                    required: false
                },
                {
                    model: ChannelKeyPartner_entity_1.ChannelKeyPartner,
                    as: 'channelkeypartner',
                    required: false,
                    attributes: ['channelkeypartnerid', 'channelId', 'documentid', 'countryid', 'partnername'],
                    include: [
                        {
                            model: index_1.Media,
                            as: 'partnerImage',
                            required: false,
                            attributes: ['documentPath', 'documentUrl']
                        },
                        {
                            model: Country_entity_1.Country,
                            as: 'country',
                            required: false,
                            attributes: ['country', 'countryId']
                        }
                    ]
                }
            ],
            attributes: {
                exclude: ['createdat', 'updatedat', 'deletedat']
            },
            where: {
                keypartnerid: partnerId,
                existchannelid: null
            }
        });
        if (!keyPartner) {
            console.log('not found');
        }
        return keyPartner;
    }
    async getPaymentOption() {
        let users = '';
        let query = 'select "paymentoptiontypeid","paymenttype",cast(false as boolean) as status from "tblpaymentoptiontype"';
        let paymentOption = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
        });
        let paymentTerm = await this.sequelizeInstance.query('select "paymenttermid","paymentterm",cast(false as boolean) as status from "tblpaymentterm"', {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
        });
        let payment = {
            paymentOption: paymentOption,
            paymentTerm: paymentTerm
        };
        return payment;
    }
    async getCurrency() {
        let currency = await this.currencyRepository.findAll({
            attributes: ['currencyid', 'currency', 'currencycode'],
        });
        return currency;
    }
    async getServiceList() {
        try {
            let result = await this.serviceListRepository.scope('serviceListInfom').findAll();
            return result;
        }
        catch (e) {
            console.log("Error+ ", e);
        }
    }
    async updateSettings(settingsDto, user) {
        try {
            let channelDetail = await this.channelDetailRepository.findOne({ where: { channelId: user.channelId } });
            if (settingsDto.currencyId) {
                await channelDetail.update({ currencyid: settingsDto.currencyId });
            }
            if (settingsDto.shareStatus == true || settingsDto.shareStatus == false) {
                await channelDetail.update({ shareStatus: settingsDto.shareStatus });
            }
            if (settingsDto.otherOptions) {
                await channelDetail.update({ paymentoptionothers: settingsDto.otherOptions });
            }
            if (settingsDto.share.length > 0) {
                await this.updateIndividualSetting(settingsDto.share, 'sharetypeid', this.channelSharePreferenceRepository, user);
            }
            return true;
        }
        catch (e) {
            console.log("Internal Server error at ChannelSettingsService: " + e);
        }
    }
    async updateIndividualSetting(data, settingId, repository, user) {
        try {
            let setting = [];
            for (var i in data) {
                let settingObj = {
                    channelid: user.channelId,
                    updatedby: user.userId
                };
                settingObj[settingId] = data[i][settingId] - 1;
                setting.push(settingObj);
            }
            if (setting.length > 0) {
                await repository.update({ deletedat: new Date().toUTCString() }, { where: { channelid: user.channelId, deletedat: null } });
                let data = await repository.bulkCreate(setting);
            }
        }
        catch (e) {
            console.log("Internal Server error at ChannelSettingsService: " + e);
        }
    }
    async settings(user) {
        try {
            let settings = {};
            settings['paymentType'] = await this.channelPaymentOptionTypeRepository.scope('settings').findAll({ where: { channelid: user.channelId, deletedat: null } });
            settings['paymentTerms'] = await this.channelPaymentTermRepository.scope('settings').findAll({ where: { channelid: user.channelId, deletedat: null } });
            settings['share'] = await this.channelSharePreferenceRepository.scope('settings').findAll({ where: { channelid: user.channelId, deletedat: null } });
            let channel = await this.channelRepository.findOne({ where: { channelId: user.channelId } });
            settings['autoRenewalOff'] = false;
            if (channel.autoRenewalOff == '1') {
                settings['autoRenewalOff'] = true;
            }
            let channelDetail = await this.channelDetailRepository.findOne({ where: { channelId: user.channelId } });
            if (channelDetail) {
                settings['currencyId'] = channelDetail.currencyid;
                settings['otherOptions'] = channelDetail.paymentoptionothers;
                settings['shareStatus'] = channelDetail.shareStatus;
            }
            let channelSubscription = await this.channelSubscriptionRepository.findOne({
                where: {
                    isActive: '1',
                    isPaid: '1',
                    channelId: user.channelId
                },
                include: [
                    {
                        model: this.subscriptionRepository,
                        include: [
                            {
                                model: this.subscriptionPlanRepository
                            }
                        ]
                    }
                ],
                order: [['channelSubscriptionId', 'desc']]
            });
            if (channelSubscription) {
                settings['channelSubscription'] = {};
                settings['channelSubscription']['endat'] = new Date(channelSubscription['endAt']).toLocaleString();
                settings['channelSubscription']['plan'] = channelSubscription['subscription']['subscriptionPlan']['subscriptionPlanType'];
                settings['channelSubscription']['planId'] = +channelSubscription['subscription']['subscriptionPlan']['subscriptionPlanId'];
                settings['channelSubscription']['channelSubscriptionId'] = +channelSubscription['channelSubscriptionId'];
            }
            let userWalletAmount = await this.userWalletAmountRepository.findOne({
                where: {
                    channelId: user.channelId
                }
            });
            console.log('userWalletAmount');
            console.log('=================');
            console.log(userWalletAmount);
            if (userWalletAmount) {
                settings['userWalletAmount'] = userWalletAmount.amount;
            }
            else {
                settings['userWalletAmount'] = 0;
            }
            return settings;
        }
        catch (e) {
            console.log("Internal Server error at ChannelSettingsService: " + e);
        }
    }
    async searchRegion(searchRegionDto, user) {
        let tradelocation = '';
        let query = 'select "regionId" from "tblZoneRegionJCT" where "zoneId" in (:zoneId)';
        let regionIds = [];
        let zoneId = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                zoneId: searchRegionDto.zone
            }
        }).then(res => {
            if (res) {
                res.map(x => {
                    regionIds.push(x.regionId);
                });
            }
        });
        tradelocation = await this.regCtyJCTRepository.findAll({
            attributes: ['regionCountryJCTId'],
            include: [
                {
                    model: this.regionRepository,
                    attributes: ['regionId', 'region'],
                },
                {
                    model: this.countryRepository,
                    attributes: ['countryId', 'country']
                }
            ],
            where: {
                regionId: {
                    [sequelize_1.Op.in]: regionIds
                }
            }
        });
        return tradelocation;
    }
    async buyerHighlights(viewId) {
        let channeltype = [];
        let final = [];
        let aggregation = {};
        let channelquery;
        if (viewId == 1)
            channeltype = [3, 4];
        else if (viewId == 2)
            channeltype = [2];
        else if (viewId == 3)
            channeltype = [3];
        else if (viewId == 4)
            channeltype = [4];
        if (viewId == 1 || viewId == 2 || viewId == 3 || viewId == 4) {
            channelquery = 'select "channelId",(select "contactId" from "tblContact" where "isDefaultContact"=\'1\' and "channelId"=tc."channelId") from "tblChannel" as tc where tc."deletedAt" is null and "isActive"=\'1\' and "signUpStatusId"=15 and "channelTypeId" in (:type) order by tc."updatedAt" desc limit 9';
            let result = await this.sequelizeInstance.query(channelquery, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    type: channeltype
                }
            }).then(x => {
                return _.uniqBy(x, 'channelId');
            });
            console.log('result', result);
            if (result) {
                for (let i = 0; i < result.length; i++) {
                    let companyquery;
                    try {
                        companyquery = 'Select '
                            + 'chd."detailDesc" as detaildesc, chd."webSiteUrl" as websiteurl, chd."startup", '
                            + '(select array_to_string(array_agg("productCategorie"), \',\') from "tblProductCategories" where "productCategorieId" in (select "productCategorieId" from "tblInterestedProductCategory" where "contactId"=:contactid) )as lookingfor, '
                            + '(Select td."documentPath" as logo from "tblChannelDetail" chd inner join "tblDocument" td on td."documentId" in(chd."channelLogoId") where chd."channelId"=ch."channelId"), '
                            + '(select array_to_json(array_agg(row_to_json(c))) from (Select td."documentPath",con."isDefaultContact",con."firstName",con."lastName",con."jobTitle" from "tblContact" con left join "tblDocument" td on td."documentId" in(con."documentId") where con."channelId"=ch."channelId" and con."isDefaultContact"=\'1\')c)as contacts, '
                            + 'ch."companyName", tc."country", ch."channelId", ch."channelTypeId", pt."profileType", pt."profileTypeId" from "tblChannel" ch inner join "tblChannelDetail" chd on chd."channelId" = ch."channelId" inner join "tblCountry" tc on tc."countryId" = ch."countryId" inner join "tblProfileType" pt on pt."profileTypeId"=ch."profileTypeId" '
                            + ' where ch."channelId" in(:channelid)';
                        let res = await this.sequelizeInstance.query(companyquery, {
                            type: sequelize_1.QueryTypes.SELECT,
                            raw: true,
                            replacements: {
                                channelid: +result[i].channelId,
                                contactid: +result[i].contactId,
                            }
                        });
                        final.push(...res);
                    }
                    catch (e) {
                        console.log("error:", e);
                    }
                }
            }
            else {
                final = [];
            }
        }
        return final;
    }
    async buyersaggr(viewId, parent, data) {
        var _a, _b, _c;
        let channeltype = [];
        let final = [];
        let aggregation = {};
        let channelquery;
        if (viewId == 1)
            channeltype = [3, 4];
        else if (viewId == 2)
            channeltype = [2];
        else if (viewId == 3)
            channeltype = [3];
        else if (viewId == 4)
            channeltype = [4];
        if (viewId == 1 || viewId == 2 || viewId == 3 || viewId == 4) {
            channelquery = 'select "channelId",(select "contactId" from "tblContact" where "isDefaultContact"=\'1\' and "channelId"=tc."channelId") from "tblChannel" as tc where tc."deletedAt" is null and "isActive"=\'1\' and "isPublic"=\'1\' and "signUpStatusId"=15 and "channelTypeId" in (:type) ';
            if (parent == 'categories' && ((_a = data.categoryId) === null || _a === void 0 ? void 0 : _a.length))
                channelquery += ' and "channelId" in (select "channelId" from "tblChannelProductCategorie" where "productCategorieId" in   (:category)) ';
            if (parent == 'brand' && ((_b = data.brandId) === null || _b === void 0 ? void 0 : _b.length))
                channelquery += ' and "channelId" in (select "channelId" from "tblChannelBrand" where "brandId" in   (:brand)) ';
            if (parent == 'location' && ((_c = data.locationId) === null || _c === void 0 ? void 0 : _c.length))
                channelquery += 'and "channelId" in(select "channelId" from "tblChannel" where "channelTypeId" in(:type) and "countryId" in(:locationId)) ';
            channelquery += ' order by tc."updatedAt"';
            let result = await this.sequelizeInstance.query(channelquery, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    type: channeltype,
                    category: data.categoryId,
                    brand: data.brandId,
                    locationId: data.locationId,
                }
            }).then(x => {
                return _.uniqBy(x, 'channelId');
            });
            if (result) {
                final = result.map(x => x.channelId);
            }
        }
        return final;
    }
    async productsHighlights(btype) {
        let query1 = 'select count(*) from "tblProduct" where "isactive"=\'1\' and "deletedat" is null';
        let count = await this.sequelizeInstance.query(query1, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
        }).then(res => res[0].count);
        let final = { result: {}, total: count };
        return await this.sequelizeInstance.query('select * from "fnGetProductHighlight"(:btype)', {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                btype: btype
            }
        }).then((results) => {
            console.log(results);
            if (results) {
                final = { result: results[0].fnGetProductHighlight, total: count };
            }
            return final;
        });
    }
    async productsaggr(parent, data) {
        let query = 'select "productId" from "tblProduct" where "isactive"=\'1\' and "deletedat" is null ';
        if (parent == 'family' && data.familyId.length)
            query += ' and "productGroupId" in (:familyId) ';
        if (parent == 'categories' && data.categoryId.length)
            query += ' and "productCategorieId" in (:categoryId) ';
        if (parent == 'brand' && data.brandId.length)
            query += ' and "brandId" in (:brandId) ';
        query += 'order by updatedat ';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                familyId: data.familyId,
                categoryId: data.categoryId,
                brandId: data.brandId,
            }
        }).then(x => {
            return _.uniqBy(x, 'productId');
        });
        if (result)
            result = result.map(x => x.productId);
        return result;
    }
    async getBuyerSearchList(viewId, data) {
        let channelFilter = data.filter;
        let total = 0;
        let channeltype = [];
        let final = [];
        let aggregation = {};
        let channelquery;
        if (viewId == 1)
            channeltype = [3, 4];
        else if (viewId == 2)
            channeltype = [2];
        else if (viewId == 3)
            channeltype = [3];
        else if (viewId == 4)
            channeltype = [4];
        let filterch = [];
        let order = data.order ? data.order : ' asc';
        let orderby = ' order by "' + data.orderby + '" ';
        if (data.orderby == 'isFeatured')
            order = ' desc';
        channelquery = 'select ch."channelId",(select "contactId" from "tblContact" where "isDefaultContact"=\'1\' and "channelId"=ch."channelId"), ' +
            'ch."companyName", tc."country", ch."channelId" from "tblChannel" ch inner join "tblChannelDetail" chd on chd."channelId" = ch."channelId" inner join "tblCountry" tc on tc."countryId" = ch."countryId" ' +
            ' where ch."deletedAt" is null and "isActive"=\'1\' and "signUpStatusId"=15 and "channelTypeId" in (:type) and "isPublic" = \'1\'';
        channelquery += orderby + order;
        let result = await this.sequelizeInstance.query(channelquery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                type: channeltype
            }
        }).then(x => {
            return _.uniqBy(x, 'channelId');
        });
        if (result)
            total = result.length;
        if ((channelFilter.brandId || channelFilter.countryId || channelFilter.productCategoryId) && result) {
            let chlist = result.map(x => +x.channelId);
            if (channelFilter.brandId) {
                let brand = 'select array_agg("channelId") as ch from "tblChannelBrand" where "brandId" in(:brandid) and "channelId" in(:channelid)';
                await this.sequelizeInstance.query(brand, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: chlist,
                        brandid: channelFilter.brandId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.countryId) {
                await this.sequelizeInstance.query('select array_agg("channelId") as ch from "tblChannel" where "countryId" in(:countryid) and "channelId" in(:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        countryid: channelFilter.countryId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (channelFilter.productCategoryId) {
                await this.sequelizeInstance.query('select array_agg("channelId") as ch from "tblChannelProductCategorie" cpc where cpc."productCategorieId" in(:productcatid) and "channelId" in(:channelid) ', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: (filterch.length > 0) ? filterch : chlist,
                        productcatid: channelFilter.productCategoryId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            result = result.filter(ch => { return filterch.includes(ch.channelId); });
            total = result.length;
        }
        if (result) {
            result = result.slice(data.offset).slice(0, data.limit);
            for (let i = 0; i < result.length; i++) {
                let companyquery;
                try {
                    companyquery = 'Select '
                        + 'chd."detailDesc" as detaildesc, chd."webSiteUrl" as websiteurl, chd."startup", '
                        + '(select array_to_string(array_agg("productCategorie"), \',\') from "tblProductCategories" where "productCategorieId" in (select "productCategorieId" from "tblInterestedProductCategory" where "contactId"=:contactid) )as lookingfor, '
                        + '(Select td."documentPath" as logo from "tblChannelDetail" chd inner join "tblDocument" td on td."documentId" in(chd."channelLogoId") where chd."channelId"=ch."channelId"), '
                        + '(select array_to_json(array_agg(row_to_json(c))) from (Select td."documentPath",con."isDefaultContact",con."firstName",con."lastName",con."jobTitle" from "tblContact" con left join "tblDocument" td on td."documentId" in(con."documentId") where con."channelId"=ch."channelId" and con."isDefaultContact"=\'1\')c)as contacts, '
                        + 'ch."companyName", tc."country", ch."channelId", ch."isFeatured" from "tblChannel" ch inner join "tblChannelDetail" chd on chd."channelId" = ch."channelId" inner join "tblCountry" tc on tc."countryId" = ch."countryId" '
                        + ' where ch."channelId" in(:channelid) ';
                    let res = await this.sequelizeInstance.query(companyquery, {
                        type: sequelize_1.QueryTypes.SELECT,
                        raw: true,
                        replacements: {
                            channelid: +result[i].channelId,
                            contactid: +result[i].contactId,
                        }
                    });
                    final.push(...res);
                }
                catch (e) {
                    console.log("error:", e);
                }
            }
        }
        else {
            final = [];
        }
        let finaldata = { data: final, total: total };
        return finaldata;
    }
    async getCategoriesFilter(data) {
        let query = 'select "productCategorieId" from "tblChannelProductCategorie" where "channelId" in (:channelId)';
        let catId = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: data.data
            }
        }).then(res => {
            console.log('res', res);
            return _.uniqBy(res, 'productCategorieId');
        });
        let result = [];
        if (catId) {
            let cId = catId.map(x => x.productCategorieId);
            query = 'select "productCategorieId" as "id" , "productCategorie" as "name" from "tblProductCategories" where "isActive"=\'1\' and "deletedAt" is null and "productCategorieId" in (:pId)';
            result = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                replacements: {
                    pId: cId
                }
            }).then(res => {
                console.log('res', res);
                return res;
            });
        }
        return result;
    }
    async getBrandFilter(data) {
        let query = 'select "brandId" from "tblChannelBrand" where "channelId" in (:channelId)';
        let brandIds = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: data.data
            }
        }).then(res => {
            return _.uniqBy(res, 'brandId');
        });
        let result = [];
        if (brandIds) {
            query = 'select "id", "brandName"  as "name" from "tblBrand" where "isActive"=\'1\' and "isAssigned"=\'1\' and "deletedAt" is null and "id" in (:brandIds)';
            let brandId = brandIds.map(x => x.brandId);
            result = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                replacements: {
                    brandIds: brandId
                }
            }).then(res => {
                return res;
            });
        }
        return result;
    }
    async getCountryFilter(data) {
        let query = 'select "countryId" from "tblChannel" as ch where "channelId" in (:channelId)';
        let countryIds = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                channelId: data.data
            }
        }).then(res => {
            return _.uniqBy(res, 'countryId');
        });
        let result = [];
        if (countryIds) {
            query = 'select "countryId" as id, "country"  as "name" from "tblCountry" where  "countryId" in (:countryIds)';
            let countryId = countryIds.map(x => x.countryId);
            result = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                replacements: {
                    countryIds: countryId
                }
            }).then(res => {
                return res;
            });
        }
        return result;
    }
    async editBasicCompany(requestObject, user) {
        let companyProfile = '';
        let companyProfileJson = '';
        let channelStatusArray = [app_constant_1.appconstant.CHANNEL_APPROVED];
        let realUser = user;
        console.log('log', user);
        let result = await this.channelRepository.findOne({
            where: {
                companyName: requestObject.company_name.trim(),
                channelId: {
                    [sequelize_1.Op.not]: +user.channelId
                }
            }
        });
        if (result) {
            throw new Process_exception_1.ProcessException('channel:profile:companyNameAlreadyExist');
        }
        channelStatusArray.push(+user.channel.signUpStatusId);
        try {
            let result = '';
            console.log('user.channel.signUpStatusId', user.channel.signUpStatusId);
            let userSignUpStatus = channelStatusArray.includes(+user.channel.signUpStatusId);
            if (userSignUpStatus) {
                companyProfile = await this.userRepository.scope('userBasicInfom').findOne({
                    include: [
                        {
                            model: this.contactRepository.scope('contactInfo'),
                            where: { deletedAt: null },
                            include: [
                                {
                                    model: this.mediaRepository,
                                    include: [
                                        {
                                            model: this.mediaTypeRepository,
                                            required: false
                                        },
                                    ],
                                    required: false
                                }
                            ]
                        },
                        {
                            model: this.channelRepository.scope('profileInfom'),
                            where: { signUpStatusId: parseInt(user.channel.signUpStatusId), deletedAt: null },
                            include: [
                                {
                                    model: this.channelDetailRepository.scope('channelDetail'),
                                    where: { deletedAt: null },
                                    include: [
                                        {
                                            model: this.mediaRepository,
                                            as: 'channelLogo',
                                            include: [
                                                {
                                                    model: this.mediaTypeRepository,
                                                    required: false
                                                },
                                            ],
                                            required: false
                                        },
                                        {
                                            model: this.mediaRepository,
                                            as: 'channelIcon',
                                            include: [
                                                {
                                                    model: this.mediaTypeRepository,
                                                    required: false
                                                },
                                            ],
                                            required: false
                                        }
                                    ]
                                },
                                {
                                    model: this.channelCertiRepository.scope('profileInfo'),
                                    where: { deletedAt: null },
                                    required: false
                                },
                                {
                                    model: this.channelDocumentRepository,
                                    where: { deletedAt: null },
                                    required: false,
                                    include: [
                                        {
                                            model: this.mediaRepository,
                                            as: 'document',
                                            required: false
                                        }
                                    ]
                                }
                            ]
                        }
                    ],
                    where: { userId: parseInt(user.userId), deletedAt: null }
                });
            }
            console.log('companyProfile', companyProfile);
            if (companyProfile) {
                companyProfileJson = companyProfile.toJSON();
                result = await this.sequelizeInstance.transaction(async (transaction) => {
                    let comapnyLogoId = null;
                    let comapnyRegAddressId = null;
                    if (requestObject.reg_address_id) {
                        await this.addressRepository.update({
                            address: requestObject.reg_address,
                            city: requestObject.reg_city,
                            countryId: requestObject.reg_country_id,
                            postalCode: requestObject.reg_postal_code,
                        }, {
                            where: { addressId: companyProfile.channel.regAddressId },
                            returning: true, transaction,
                        });
                        comapnyRegAddressId = companyProfile.channel.regAddressId;
                    }
                    let companyInfoUpdate = {
                        companyMail: requestObject.company_email || null,
                        regAddressId: comapnyRegAddressId,
                        countryId: +requestObject.reg_country_id,
                        companyName: requestObject.company_name.trim()
                    };
                    await this.channelRepository.update(companyInfoUpdate, {
                        where: { channelId: companyProfile.channel.channelId }, returning: true, transaction,
                    });
                    if (requestObject.social_linkedin_id) {
                        await this.socialLinkRepository.update({
                            socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_LINKEDIN,
                            channelId: companyProfile.channelId,
                            channelSocialLink: requestObject.social_linkedin_url
                        }, {
                            where: { channelSocialLinkId: requestObject.social_linkedin_id },
                            returning: true, transaction,
                        });
                    }
                    else {
                        if (requestObject.social_linkedin_url && Object.keys(requestObject.social_linkedin_url).length > 0) {
                            await this.socialLinkRepository.create({
                                socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_LINKEDIN,
                                channelId: companyProfile.channelId,
                                channelSocialLink: requestObject.social_linkedin_url
                            }, {
                                transaction
                            });
                        }
                    }
                    if (requestObject.social_googleplus_id) {
                        await this.socialLinkRepository.update({
                            socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_GOOGLEPLUS,
                            channelId: companyProfile.channelId,
                            channelSocialLink: requestObject.social_googleplus_url
                        }, {
                            where: { channelSocialLinkId: requestObject.social_googleplus_id },
                            returning: true, transaction,
                        });
                    }
                    else {
                        if (requestObject.social_googleplus_url && Object.keys(requestObject.social_googleplus_url).length > 0) {
                            await this.socialLinkRepository.create({
                                socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_GOOGLEPLUS,
                                channelId: companyProfile.channelId,
                                channelSocialLink: requestObject.social_googleplus_url
                            }, {
                                transaction
                            });
                        }
                    }
                    if (requestObject.social_instagram_id) {
                        await this.socialLinkRepository.update({
                            channelId: companyProfile.channelId,
                            channelSocialLink: requestObject.social_instagram_url
                        }, {
                            where: { channelSocialLinkId: requestObject.social_instagram_id },
                            returning: true, transaction,
                        });
                    }
                    else {
                        if (requestObject.social_instagram_url && Object.keys(requestObject.social_instagram_url).length > 0) {
                            await this.socialLinkRepository.create({
                                socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_INSTAGRAM,
                                channelId: companyProfile.channelId,
                                channelSocialLink: requestObject.social_instagram_url
                            }, {
                                transaction
                            });
                        }
                    }
                    if (requestObject.social_twitter_id) {
                        await this.socialLinkRepository.update({
                            channelId: companyProfile.channelId,
                            channelSocialLink: requestObject.social_twitter_url
                        }, {
                            where: { channelSocialLinkId: requestObject.social_twitter_id },
                            returning: true, transaction,
                        });
                    }
                    else {
                        if (requestObject.social_twitter_url && Object.keys(requestObject.social_twitter_url).length > 0) {
                            await this.socialLinkRepository.create({
                                socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_TWITTER,
                                channelId: companyProfile.channelId,
                                channelSocialLink: requestObject.social_twitter_url
                            }, {
                                transaction
                            });
                        }
                    }
                    if (requestObject.social_facebook_id) {
                        await this.socialLinkRepository.update({
                            channelId: companyProfile.channelId,
                            channelSocialLink: requestObject.social_facebook_url
                        }, {
                            where: { channelSocialLinkId: requestObject.social_facebook_id },
                            returning: true, transaction,
                        });
                    }
                    else {
                        if (requestObject.social_facebook_url && Object.keys(requestObject.social_facebook_url).length > 0) {
                            await this.socialLinkRepository.create({
                                socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_FACEBOOK,
                                channelId: companyProfile.channelId,
                                channelSocialLink: requestObject.social_facebook_url
                            }, {
                                transaction
                            });
                        }
                    }
                    if (requestObject.B2B_url && Object.keys(requestObject.B2B_url).length > 0) {
                        for (let ii = 0; ii < requestObject.B2B_url.length; ii++) {
                            if (requestObject.B2B_url[ii].channel_B2B_id) {
                                await this.channelB2BRepository.update({
                                    channelId: companyProfile.channelId,
                                    channelB2B: requestObject.B2B_url[ii].channelB2B
                                }, {
                                    where: { channelB2BId: requestObject.B2B_url[ii].channel_B2B_id },
                                    returning: true, transaction,
                                });
                            }
                            else {
                                await this.channelB2BRepository.create({
                                    channelId: companyProfile.channelId,
                                    channelB2B: requestObject.B2B_url[ii].channelB2B
                                }, {
                                    transaction
                                });
                            }
                        }
                    }
                    if (requestObject.deleted_B2B && requestObject.deleted_B2B.length > 0) {
                        for (let ii = 0; ii < requestObject.deleted_B2B.length; ii++) {
                            if (requestObject.deleted_B2B[ii]) {
                                await this.channelB2BRepository.update({
                                    channelId: companyProfile.channelId,
                                    deletedAt: new Date()
                                }, {
                                    where: { channelB2BId: requestObject.deleted_B2B[ii] },
                                    returning: true, transaction,
                                });
                            }
                        }
                    }
                    if (companyProfileJson.channel.channelDetail.channelLogoId) {
                        comapnyLogoId = companyProfileJson.channel.channelDetail.channelLogoId;
                    }
                    if (requestObject.company_logo_url) {
                        comapnyLogoId = requestObject.company_logo_url;
                    }
                    return await this.channelDetailRepository.update({
                        channelLogoId: comapnyLogoId,
                        phone1: requestObject.company_phone1,
                        phone2: (lodash_1.isUndefined(requestObject.company_phone2)) ? null : requestObject.company_phone2,
                        mobileNo: (lodash_1.isUndefined(requestObject.company_mobile_no)) ? null : requestObject.company_mobile_no,
                        webSiteUrl: requestObject.company_website_url,
                        introvideoId: requestObject.company_introvideo,
                        detailDesc: requestObject.company_about,
                        companyDesc: requestObject.company_full,
                    }, {
                        where: { channelId: companyProfile.channelId }, returning: true, transaction,
                    });
                });
                if (result) {
                    return true;
                }
                else {
                    return false;
                }
            }
        }
        catch (e) {
            console.log("Error+", e);
            throw new common_1.InternalServerErrorException();
        }
        if (!companyProfile) {
            throw new Process_exception_1.ProcessException('channel:getCompanyProfile:companyNotFound');
        }
    }
    async updateBannerImage(requestObject, user) {
        let bannerId = null;
        let companyBanner;
        let oldBanner = await this.channelDetailRepository.findOne({
            where: { channelId: user.channelId },
            attributes: ['channelBannerId']
        });
        return await this.sequelizeInstance.transaction(async (transaction) => {
            console.log('oldBanner', oldBanner);
            if (oldBanner) {
                await this.mediaRepository.update({ deletedAt: new Date() }, { where: {
                        documentId: +oldBanner.channelBannerId
                    }, returning: true, transaction });
            }
            companyBanner = await this.mediaRepository.create({
                documentPath: requestObject.bannerUrl,
                documentTypeId: app_constant_1.appconstant.DOCUMENTTYPE_IMAGE,
                dirName: app_constant_1.appconstant.FOLDER_PATH_COMPANY_BANNER
            }, {
                transaction,
            });
            bannerId = companyBanner.documentId;
            await this.channelDetailRepository.update({ channelBannerId: bannerId }, {
                where: { channelId: user.channelId }, returning: true, transaction
            });
            return companyBanner;
        });
    }
    async editProfileSave(user, params) {
        try {
            let ChannelSpecialityObject = [];
            let userDetails = await this.userRepository.scope('userBasicInfom').findOne({
                where: { userId: parseInt(user.userId), isActive: '1' }
            });
            if (userDetails) {
                let result = await this.sequelizeInstance.transaction(async (transaction) => {
                    var _a, _b, _c, _d, _e;
                    let channelContacts = await this.contactRepository.scope('basicInfom').findAll({
                        where: {
                            deletedAt: null,
                            contactId: { [sequelize_1.Op.ne]: user.contactId },
                            channelId: user.channelId
                        }
                    });
                    let contacts = [];
                    contacts.push(user.contactId);
                    if (channelContacts.length > 0) {
                        channelContacts.map(function (data) {
                            contacts.push(data.contactId);
                        });
                    }
                    let ChannelDetailObject = {};
                    if (((_a = params.productFamilies) === null || _a === void 0 ? void 0 : _a.length) > 0) {
                        let productGroup = await this.channelProductGroupRepository.findAll({
                            where: {
                                channelId: user.channelId,
                                deletedAt: null
                            }
                        });
                        let ChannelProductGroupIds = await this.tradeInformationInBound.setProductGroupIds(productGroup);
                        let ChannelProductGroupObject = await this.tradeInformationInBound.setProductGroup(params.productFamilies, user.channelId);
                        let ChannelProductGroupCurrentIds = [];
                        let ChannelProductGroupCreateObject = [];
                        let ContactProductGroupObject = await this.tradeInformationInBound.setContactProductGroup(params.productFamilies, user.contactId);
                        let ContactProductGroupCurrentIds = [];
                        for (let kk = 0; kk < ChannelProductGroupObject.length; kk++) {
                            if (ChannelProductGroupIds.includes(ChannelProductGroupObject[kk].productGroupId)) {
                                ChannelProductGroupCurrentIds.push(ChannelProductGroupObject[kk].productGroupId);
                            }
                            else {
                                ChannelProductGroupCreateObject.push(ChannelProductGroupObject[kk]);
                                ChannelProductGroupCurrentIds.push(ChannelProductGroupObject[kk].productGroupId);
                            }
                            ContactProductGroupCurrentIds.push(ContactProductGroupObject[kk].productGroupId);
                        }
                        if (ChannelProductGroupCreateObject.length > 0) {
                            await this.channelProductGroupRepository.bulkCreate(ChannelProductGroupCreateObject, { returning: true, transaction });
                        }
                        await this.channelProductGroupRepository.update({ deletedAt: new Date() }, {
                            where: {
                                channelId: user.channelId,
                                productGroupId: { [sequelize_1.Op.notIn]: ChannelProductGroupCurrentIds },
                                deletedAt: null
                            }, returning: true, transaction
                        });
                        await this.contactGroupRepository.update({ deletedAt: new Date() }, {
                            where: {
                                contactId: { [sequelize_1.Op.in]: contacts },
                                productGroupId: { [sequelize_1.Op.notIn]: ContactProductGroupCurrentIds },
                                deletedAt: null
                            }, returning: true, transaction
                        });
                    }
                    if (((_b = params.productCategories) === null || _b === void 0 ? void 0 : _b.length) > 0) {
                        let productCategory = await this.channelProductCategorieRepository.findAll({
                            where: {
                                channelId: user.channelId,
                                deletedAt: null
                            }
                        });
                        let productCategoriesIds = await this.tradeInformationInBound.setProductCategoryIds(productCategory);
                        let ProductCategorieObject = await this.tradeInformationInBound.setProductCategories(params.productCategories, user.channelId);
                        let ChannelProductCategoriesCurrentIds = [];
                        let ChannelProductCategoriesCreateObject = [];
                        let contactProductCategorieObject = await this.tradeInformationInBound.setContactProductCategories(params.productCategories, user.contactId);
                        let ContactProductCategoriesCurrentIds = [];
                        for (let kk = 0; kk < ProductCategorieObject.length; kk++) {
                            if (productCategoriesIds.includes(ProductCategorieObject[kk].productCategorieId)) {
                                ChannelProductCategoriesCurrentIds.push(ProductCategorieObject[kk].productCategorieId);
                            }
                            else {
                                ChannelProductCategoriesCreateObject.push(ProductCategorieObject[kk]);
                                ChannelProductCategoriesCurrentIds.push(ProductCategorieObject[kk].productCategorieId);
                            }
                            ContactProductCategoriesCurrentIds.push(contactProductCategorieObject[kk].productCategorieId);
                        }
                        if (ChannelProductCategoriesCreateObject.length > 0) {
                            await this.channelProductCategorieRepository.bulkCreate(ChannelProductCategoriesCreateObject, { returning: true, transaction });
                        }
                        await this.channelProductCategorieRepository.update({ deletedAt: new Date() }, {
                            where: {
                                channelId: user.channelId,
                                productCategorieId: { [sequelize_1.Op.notIn]: ChannelProductCategoriesCurrentIds },
                                deletedAt: null
                            }, returning: true, transaction
                        });
                        await this.contactCatRepository.update({ deletedAt: new Date() }, {
                            where: {
                                contactId: { [sequelize_1.Op.in]: contacts },
                                productCategorieId: { [sequelize_1.Op.notIn]: ContactProductCategoriesCurrentIds },
                                deletedAt: null
                            }, returning: true, transaction
                        });
                    }
                    if (params.customerProfiles && ((_c = params.customerProfiles) === null || _c === void 0 ? void 0 : _c.length) > 0) {
                        let customerProfiles = await this.channelCustomerProfileRepository.findAll({
                            where: {
                                channelId: user.channelId,
                                deletedAt: null
                            }
                        });
                        let customerProfilesIds = await this.tradeInformationInBound.setCustomerProfilesIds(customerProfiles);
                        let customerProfilesObject = await this.tradeInformationInBound.setCustomerProfiles(params.customerProfiles, user.channelId);
                        let channelCustomerProfilesCurrentIds = [];
                        let ChannelCustomerProfilesCreateObject = [];
                        for (let kk = 0; kk < customerProfilesObject.length; kk++) {
                            if (customerProfilesIds.includes(customerProfilesObject[kk].profileTypeId)) {
                                channelCustomerProfilesCurrentIds.push(customerProfilesObject[kk].profileTypeId);
                            }
                            else {
                                ChannelCustomerProfilesCreateObject.push(customerProfilesObject[kk]);
                                channelCustomerProfilesCurrentIds.push(customerProfilesObject[kk].profileTypeId);
                            }
                        }
                        if (ChannelCustomerProfilesCreateObject.length > 0) {
                            await this.channelCustomerProfileRepository.bulkCreate(ChannelCustomerProfilesCreateObject, { returning: true, transaction });
                        }
                        await this.channelCustomerProfileRepository.update({ deletedAt: new Date() }, {
                            where: {
                                channelId: user.channelId,
                                profileTypeId: { [sequelize_1.Op.notIn]: channelCustomerProfilesCurrentIds },
                                deletedAt: null
                            }, returning: true, transaction
                        });
                    }
                    let channelObject = {
                        isFrenchTech: params.is_french_tech
                    };
                    if (params.channelType == app_constant_1.appconstant.CHANNEL_TYPE_VENDOR) {
                        if (((_d = params.tradeInformationVendor.brand) === null || _d === void 0 ? void 0 : _d.length) > 0) {
                            let channelBrandObject = await this.saveBrand(params.tradeInformationVendor.brand, user.channelId, transaction);
                            if (channelBrandObject.channelBrandArrayObject.length > 0) {
                                let brand = await this.channelBrandRepository.findAll({
                                    where: {
                                        channelId: user.channelId,
                                        deletedAt: null
                                    }
                                });
                                let ChannelBrandCurrentIds = [];
                                let ChannelBrandCreateObject = [];
                                let brandObject = channelBrandObject.channelBrandArrayObject;
                                let brandIds = channelBrandObject.brandIds;
                                let ChannelBrandIds = await this.tradeInformationInBound.setchannelbrandIds(brand);
                                let totalRemovedBrands = ChannelBrandIds.filter(e => !brandIds.find(a => e == a));
                                for (let kk = 0; kk < brandObject.length; kk++) {
                                    if (!ChannelBrandIds.includes(brandObject[kk].brandId)) {
                                        ChannelBrandCreateObject.push(brandObject[kk]);
                                    }
                                    if (!totalRemovedBrands.includes(+brandObject[kk].brandId)) {
                                        ChannelBrandCurrentIds.push(brandObject[kk].brandId);
                                    }
                                }
                                if (ChannelBrandCreateObject.length > 0) {
                                    await this.channelBrandRepository.bulkCreate(ChannelBrandCreateObject, { returning: true, transaction });
                                }
                                await this.channelBrandRepository.update({ deletedAt: new Date() }, {
                                    where: {
                                        channelId: user.channelId,
                                        brandId: { [sequelize_1.Op.notIn]: ChannelBrandCurrentIds },
                                        deletedAt: null
                                    }, returning: true, transaction
                                });
                                await this.brandRepository.update({
                                    isAssigned: '1'
                                }, {
                                    where: {
                                        id: {
                                            [sequelize_1.Op.in]: brandIds
                                        }
                                    },
                                    returning: true, transaction
                                });
                                await this.brandRepository.update({
                                    isAssigned: '0'
                                }, {
                                    where: {
                                        id: {
                                            [sequelize_1.Op.in]: totalRemovedBrands
                                        }
                                    },
                                    returning: true, transaction
                                });
                            }
                        }
                        if (params.tradeInformationVendor && params.tradeInformationVendor.profileTypeId) {
                            channelObject.profileTypeId = params.tradeInformationVendor.profileTypeId;
                        }
                        await this.tradeInformationInBound.keyRetailers(app_constant_1.appconstant.CHANNEL_TYPE_RETAILER, params.tradeInformationVendor.channelKeyRetailer, user.channelId, user.userId, params.tradeInformationVendor.deletedkeyretailer);
                        await this.tradeInformationInBound.keyRetailers(app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR, params.tradeInformationVendor.channelKeyDistributor, user.channelId, user.userId, params.tradeInformationVendor.deletedkeydistributor);
                        ChannelDetailObject = await this.tradeInformationInBound.setChannelDetail(params.tradeInformationVendor, user.channelId, user.channelTypeId);
                    }
                    else if (params.channelType == app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR) {
                        if (params.tradeInformationDistributor && ((_e = params.tradeInformationDistributor) === null || _e === void 0 ? void 0 : _e.brand) && params.tradeInformationDistributor.brand.length > 0) {
                            let channelBrandObject = await this.saveBrand(params.tradeInformationDistributor.brand, user.channelId, transaction);
                            if (channelBrandObject.channelBrandArrayObject.length > 0) {
                                let brand = await this.channelBrandRepository.findAll({
                                    where: {
                                        channelId: user.channelId,
                                        deletedAt: null
                                    }
                                });
                                let ChannelBrandCurrentIds = [];
                                let ChannelBrandCreateObject = [];
                                let brandObject = channelBrandObject.channelBrandArrayObject;
                                let ChannelBrandIds = await this.tradeInformationInBound.setchannelbrandIds(brand);
                                let totalRemovedBrands = ChannelBrandIds.filter(e => !brandObject.find(a => e == a.brandId));
                                for (let kk = 0; kk < brandObject.length; kk++) {
                                    if (!ChannelBrandIds.includes(brandObject[kk].brandId)) {
                                        ChannelBrandCreateObject.push(brandObject[kk]);
                                    }
                                    if (!totalRemovedBrands.includes(+brandObject[kk].brandId)) {
                                        ChannelBrandCurrentIds.push(brandObject[kk].brandId);
                                    }
                                }
                                if (ChannelBrandCreateObject.length > 0) {
                                    await this.channelBrandRepository.bulkCreate(ChannelBrandCreateObject, { returning: true, transaction });
                                }
                                await this.channelBrandRepository.update({ deletedAt: new Date() }, {
                                    where: {
                                        channelId: user.channelId,
                                        brandId: { [sequelize_1.Op.notIn]: ChannelBrandCurrentIds },
                                        deletedAt: null
                                    }, returning: true, transaction
                                });
                                console.log(JSON.stringify(ChannelBrandCurrentIds));
                                await this.brandRepository.update({
                                    isAssigned: '1'
                                }, {
                                    where: {
                                        id: {
                                            [sequelize_1.Op.in]: channelBrandObject.brandIds
                                        }
                                    },
                                    returning: true, transaction
                                });
                                await this.brandRepository.update({
                                    isAssigned: '0'
                                }, {
                                    where: {
                                        id: {
                                            [sequelize_1.Op.in]: totalRemovedBrands
                                        }
                                    },
                                    returning: true, transaction
                                });
                                console.log(JSON.stringify(totalRemovedBrands));
                            }
                        }
                        ChannelSpecialityObject = await this.tradeInformationInBound.setSpeciality(params.tradeInformationDistributor.distributorSpeciality, user.channelId);
                        channelObject.profileTypeId = params.tradeInformationDistributor.profileTypeId;
                    }
                    else if (params.channelType == app_constant_1.appconstant.CHANNEL_TYPE_RETAILER || params.channelType == app_constant_1.appconstant.CHANNEL_TYPE_RESELLER) {
                        channelObject.profileTypeId = params.tradeInformationRetailer.profileTypeId;
                    }
                    else if (params.channelType == app_constant_1.appconstant.CHANNEL_TYPE_RESELLER) {
                        channelObject.profileTypeId = params.tradeInformationReseller.profileTypeId;
                    }
                    if (ChannelSpecialityObject.length > 0) {
                        let speciality = await this.channelSpecialityRepository.findAll({
                            where: {
                                channelId: user.channelId,
                                deletedAt: null
                            }
                        });
                        let ChannelSpecialityIds = await this.tradeInformationInBound.setProductGroupIds(speciality);
                        let ChannelSpecialityCurrentIds = [];
                        let ChannelSpecialityCreateObject = [];
                        for (let kk = 0; kk < ChannelSpecialityObject.length; kk++) {
                            if (ChannelSpecialityIds.includes(ChannelSpecialityObject[kk].productGroupId)) {
                                ChannelSpecialityCurrentIds.push(ChannelSpecialityObject[kk].productGroupId);
                            }
                            else {
                                ChannelSpecialityCreateObject.push(ChannelSpecialityObject[kk]);
                                ChannelSpecialityCurrentIds.push(ChannelSpecialityObject[kk].productGroupId);
                            }
                        }
                        if (ChannelSpecialityCreateObject.length > 0) {
                            await this.channelSpecialityRepository.bulkCreate(ChannelSpecialityCreateObject, { returning: true, transaction });
                        }
                        await this.channelSpecialityRepository.update({ deletedAt: new Date() }, {
                            where: {
                                channelId: user.channelId,
                                productGroupId: { [sequelize_1.Op.notIn]: ChannelSpecialityCurrentIds },
                                deletedAt: null
                            }, returning: true, transaction
                        });
                    }
                    if (ChannelDetailObject) {
                        await this.channelDetailRepository.update(ChannelDetailObject, { where: { channelId: user.channelId }, returning: true, transaction });
                    }
                    return await this.channelRepository.update(channelObject, { where: { channelId: user.channelId }, returning: true, transaction });
                });
                console.log('resulteditsave', result);
                if (result) {
                    console.log('resulteditsave', result);
                    return true;
                }
                else {
                    return false;
                }
            }
            else {
            }
        }
        catch (e) {
            console.log("Error+", e);
            throw new common_1.InternalServerErrorException();
        }
    }
    async updateFacts(params, user) {
        try {
            let userDetails = await this.userRepository.scope('userBasicInfom').findOne({
                where: { userId: parseInt(user.userId), isActive: '1' }
            });
            if (userDetails) {
                return await this.sequelizeInstance.transaction(async (transaction) => {
                    let contacts = [];
                    contacts.push(user.contactId);
                    let ChannelDetailObject = {};
                    ChannelDetailObject = await this.tradeInformationInBound.setFactsChannelDetail(params);
                    if (ChannelDetailObject) {
                        return await this.channelDetailRepository.update(ChannelDetailObject, { where: { channelId: user.channelId }, returning: true, transaction });
                    }
                });
            }
            else {
                throw new Auth_exception_1.AuthException('channel:subscripion:userNotFound');
            }
        }
        catch (e) {
            console.log("Error+", e);
            throw new common_1.InternalServerErrorException();
        }
    }
    async getFacts(user) {
        try {
            return await this.channelDetailRepository.findOne({
                where: { channelId: user.channelId },
                attributes: ['empCnt', 'empCntRange', 'turnoverRange', 'turnover', 'startup', 'estYear', 'storeCount', 'no_of_skus', 'maturitylevel']
            });
        }
        catch (e) {
            console.log("Error+", e);
            throw new common_1.InternalServerErrorException();
        }
    }
    async getKeyPartnerOptions(user) {
        let keyRetailerOptions = [];
        let keyDistributorOptions = [];
        let keyResellerOptions = [];
        let keyPartner = { retailer: [], reseller: [], distributor: [] };
        if (user.channelTypeId == '2') {
            keyRetailerOptions = await this.searchRetailer('', 4);
            keyDistributorOptions = await this.searchRetailer('', 3);
            keyResellerOptions = await this.searchRetailer('', 5);
            keyPartner['retailer'] = keyRetailerOptions;
            keyPartner['distributor'] = keyDistributorOptions;
            keyPartner['reseller'] = keyResellerOptions;
        }
        else if (user.channelTypeId == '3') {
            keyRetailerOptions = await this.searchRetailer('', 4);
            keyResellerOptions = await this.searchRetailer('', 5);
            keyPartner['reseller'] = keyResellerOptions;
            keyPartner['retailer'] = keyRetailerOptions;
        }
        return Object.assign({ keyPartners: keyPartner });
    }
    async getChannelProfile(user) {
        let tradeinfo = '';
        tradeinfo = await this.channelRepository.scope().findAll({
            attributes: ['channelId', 'profileTypeId'],
            where: {
                channelId: user.channelId
            },
            include: [
                {
                    model: this.channelCustProfileRepository,
                    as: 'channelCustomerProfile',
                    attributes: ['profileTypeId', 'profileTypeClassificationId'],
                    where: {
                        deletedAt: null
                    }
                },
            ]
        });
        return tradeinfo;
    }
    async update_company_new(user, data) {
        let companyProfile = '';
        let companyProfileJson = '';
        let channelStatusArray = [app_constant_1.appconstant.CHANNEL_APPROVED, app_constant_1.appconstant.CHANNEL_APPROVAL];
        let realUser = user;
        if (realUser && realUser.channel && +realUser.channel.channelTypeId === +app_constant_1.appconstant.CHANNEL_TYPE_HUB) {
            let result = await this.channelRepository.findOne({
                where: {
                    companyName: data.company_name.trim(),
                    channelId: {
                        $not: +user.channel.channelId
                    }
                }
            });
            if (result) {
                throw new Process_exception_1.ProcessException('channel:profile:companyNameAlreadyExist');
            }
            channelStatusArray.push(+user.channel.signUpStatusId);
        }
        try {
            let result = '';
            console.log('user.channel.signUpStatusId', user.channel.signUpStatusId);
            let userSignUpStatus = channelStatusArray.includes(+user.channel.signUpStatusId);
            if (userSignUpStatus) {
                companyProfile = await this.userRepository.scope('userBasicInfom').findOne({
                    include: [
                        {
                            model: this.contactRepository.scope('contactInfo'),
                            where: { deletedAt: null },
                            include: [
                                {
                                    model: this.mediaRepository,
                                    include: [
                                        {
                                            model: this.mediaTypeRepository,
                                            required: false
                                        },
                                    ],
                                    required: false
                                }
                            ]
                        },
                        {
                            model: this.channelRepository.scope('profileInfom'),
                            where: { signUpStatusId: parseInt(user.channel.signUpStatusId), deletedAt: null },
                            include: [
                                {
                                    model: this.channelDetailRepository.scope('channelDetail'),
                                    where: { deletedAt: null },
                                    include: [
                                        {
                                            model: this.mediaRepository,
                                            as: 'channelLogo',
                                            include: [
                                                {
                                                    model: this.mediaTypeRepository,
                                                    required: false
                                                },
                                            ],
                                            required: false
                                        },
                                        {
                                            model: this.mediaRepository,
                                            as: 'channelIcon',
                                            include: [
                                                {
                                                    model: this.mediaTypeRepository,
                                                    required: false
                                                },
                                            ],
                                            required: false
                                        }
                                    ]
                                },
                                {
                                    model: this.channelCertiRepository.scope('profileInfo'),
                                    where: { deletedAt: null },
                                    required: false
                                },
                                {
                                    model: this.channelDocumentRepository,
                                    where: { deletedAt: null },
                                    required: false,
                                    include: [
                                        {
                                            model: this.mediaRepository,
                                            as: 'document',
                                            required: false
                                        }
                                    ]
                                }
                            ]
                        }
                    ],
                    where: { userId: parseInt(user.userId), deletedAt: null }
                });
            }
            if (companyProfile) {
                companyProfileJson = companyProfile.toJSON();
                await this.save_company_registration(Object.assign(data.companyRegistration, { user: user }), companyProfile, realUser);
                await this.save_trade_information(Object.assign(data.tradeInformation, { user: user }), companyProfile, realUser);
                if (data.channels)
                    await this.save_channel_info(Object.assign(data.channels, { user: user }), companyProfile, realUser);
                await this.save_marketing_info(Object.assign(data.marketing, { user: user }), companyProfile, realUser);
                await this.save_facts_figures(Object.assign(data.facts, { user: user }), companyProfile, realUser);
                await this.save_settingsdocuments(Object.assign(data.document, { user: user }), companyProfile, realUser);
                if (+user.channel.signUpStatusId == app_constant_1.appconstant.CHANNEL_APPROVAL || data.ratingId) {
                    let defaultdata = {
                        channelId: +user.channel.channelId,
                        ratingId: 1,
                        isCompleted: true,
                        createdAt: new Date()
                    };
                    await this.profileRepository.findOrCreate({ where: { channelId: +user.channel.channelId, ratingId: 1 }, defaults: defaultdata }).then((result) => {
                        if (!result[1]) {
                            result[0].update(defaultdata);
                        }
                    });
                }
            }
            return true;
        }
        catch (err) {
            console.log(err);
        }
    }
    async save_company_registration(data, companyProfile, realUser) {
        let certificate = [];
        let result = '';
        let requestObject = Object.assign({}, data.certificates);
        try {
            result = this.sequelizeInstance.transaction(async (transaction) => {
                var _a;
                let billAddress;
                let comapnyLogoId = null;
                let comapnyRegAddressId = null;
                let comapnyBillAddressId = null;
                if (data.reg_address_id) {
                    await this.addressRepository.update({
                        address: data.reg_address,
                        city: data.reg_city,
                        countryId: data.reg_country_id,
                        postalCode: data.reg_postal_code,
                    }, {
                        where: { addressId: companyProfile.channel.regAddressId },
                        returning: true, transaction,
                    });
                    comapnyRegAddressId = companyProfile.channel.regAddressId;
                }
                if (data.is_same_address) {
                    comapnyBillAddressId = comapnyRegAddressId;
                }
                else {
                    if (data.bill_address_id) {
                        await this.addressRepository.update({
                            address: data.bill_address,
                            city: data.bill_city,
                            countryId: data.bill_country_id,
                            postalCode: data.bill_postal_code,
                        }, {
                            where: { addressId: data.bill_address_id },
                            returning: true, transaction,
                        });
                        comapnyBillAddressId = data.bill_address_id;
                    }
                    else {
                        if (data.bill_address && data.bill_city && data.bill_country_id && data.bill_postal_code) {
                            billAddress = await this.addressRepository.create({
                                address: data.bill_address,
                                city: data.bill_city,
                                countryId: data.bill_country_id,
                                postalCode: data.bill_postal_code,
                            }, {
                                transaction
                            });
                            comapnyBillAddressId = billAddress.addressId;
                        }
                    }
                }
                if (requestObject.registration_certificate && Object.keys(requestObject.registration_certificate).length > 0) {
                    for (let ii = 0; ii < requestObject.registration_certificate.length; ii++) {
                        if (requestObject.registration_certificate[ii].channel_certificate_id) {
                            await this.channelCertiRepository.update({
                                channelId: companyProfile.channelId,
                                cerificateName: requestObject.registration_certificate[ii].name,
                                cerificateNumber: requestObject.registration_certificate[ii].id,
                                cerificateTypeId: app_constant_1.appconstant.CERTIFICATETYPE_REGISTRATION
                            }, {
                                where: { channelCerificateId: requestObject.registration_certificate[ii].channel_certificate_id },
                                returning: true, transaction,
                            });
                        }
                        else {
                            console.log('creating cert');
                            await this.channelCertiRepository.create({
                                channelId: companyProfile.channelId,
                                cerificateName: (_a = requestObject.registration_certificate[ii]) === null || _a === void 0 ? void 0 : _a.name,
                                cerificateNumber: requestObject.registration_certificate[ii].id,
                                cerificateTypeId: app_constant_1.appconstant.CERTIFICATETYPE_REGISTRATION
                            }, {
                                transaction
                            });
                        }
                    }
                }
                if (requestObject.tax_certificate && Object.keys(requestObject.tax_certificate).length > 0) {
                    for (let ii = 0; ii < requestObject.tax_certificate.length; ii++) {
                        if (requestObject.tax_certificate[ii].channel_certificate_id) {
                            await this.channelCertiRepository.update({
                                channelId: companyProfile.channelId,
                                cerificateName: requestObject.tax_certificate[ii].name,
                                cerificateNumber: requestObject.tax_certificate[ii].id,
                                cerificateTypeId: app_constant_1.appconstant.CERTIFICATETYPE_TAX,
                                vat_verified: requestObject.tax_certificate[ii].vat_verified
                            }, {
                                where: { channelCerificateId: requestObject.tax_certificate[ii].channel_certificate_id },
                                returning: true, transaction,
                            });
                        }
                        else {
                            await this.channelCertiRepository.create({
                                channelId: companyProfile.channelId,
                                cerificateName: requestObject.tax_certificate[ii].name,
                                cerificateNumber: requestObject.tax_certificate[ii].id,
                                cerificateTypeId: app_constant_1.appconstant.CERTIFICATETYPE_TAX
                            }, {
                                transaction
                            });
                        }
                    }
                }
                if (requestObject.deleted_registration_certificate && requestObject.deleted_registration_certificate.length > 0) {
                    for (let ii = 0; ii < requestObject.deleted_registration_certificate.length; ii++) {
                        if (requestObject.deleted_registration_certificate[ii]) {
                            await this.channelCertiRepository.update({
                                channelId: companyProfile.channelId,
                                deletedAt: new Date()
                            }, {
                                where: { channelCerificateId: requestObject.deleted_registration_certificate[ii] },
                                returning: true, transaction,
                            });
                        }
                    }
                }
                if (requestObject.deleted_tax_certificate && requestObject.deleted_tax_certificate.length > 0) {
                    for (let ii = 0; ii < requestObject.deleted_tax_certificate.length; ii++) {
                        if (requestObject.deleted_tax_certificate[ii]) {
                            await this.channelCertiRepository.update({
                                channelId: companyProfile.channelId,
                                deletedAt: new Date()
                            }, {
                                where: { channelCerificateId: requestObject.deleted_tax_certificate[ii] },
                                returning: true, transaction,
                            });
                        }
                    }
                }
                let companyInfoUpdate = Object.assign(Object.assign({ regAddressId: comapnyRegAddressId, billAddressId: comapnyBillAddressId, countryId: +data.reg_country_id }, (data.profileTypeId && { profileTypeId: +data.profileTypeId })), (data.isOEM && { isOEM: +data.isOEM }));
                console.log('realUSer', realUser.channel, +realUser.channel.channelTypeId, +app_constant_1.appconstant.CHANNEL_TYPE_HUB);
                if (realUser && realUser.channel && +realUser.channel.channelTypeId === +app_constant_1.appconstant.CHANNEL_TYPE_HUB) {
                    console.log('company_name', data.company_name);
                    companyInfoUpdate.companyName = data.company_name.trim();
                }
                await this.channelRepository.update(companyInfoUpdate, {
                    where: { channelId: companyProfile.channel.channelId }, returning: true, transaction,
                });
                if (companyProfile.channel.channelDetail.channelLogoId) {
                    comapnyLogoId = companyProfile.channel.channelDetail.channelLogoId;
                }
                if (data.company_logo_url) {
                    comapnyLogoId = data.company_logo_url;
                }
                await this.channelDetailRepository.update({
                    channelLogoId: comapnyLogoId,
                    phone1: data.company_phone1,
                }, {
                    where: { channelId: companyProfile.channelId }, returning: true, transaction,
                });
            });
            if (result) {
                return true;
            }
            else {
                return false;
            }
        }
        catch (err) {
            console.log("Error+", err);
        }
        if (!companyProfile) {
            throw new Process_exception_1.ProcessException('channel:getCompanyProfile:companyNotFound');
        }
    }
    async save_trade_information(data, companyProfile, user) {
        let result = '';
        let userDetails = await this.userRepository.scope('userBasicInfom').findOne({
            where: { userId: parseInt(user.userId), isActive: '1' }
        });
        try {
            if (userDetails) {
                result = await this.sequelizeInstance.transaction(async (transaction) => {
                    var _a, _b, _c, _d;
                    let details = {};
                    if (user.channelTypeId == 4 || user.channelTypeId == 5) {
                        console.log('data.companyDesc', data.companyDesc);
                        details = {
                            detailDesc: data.company_about,
                            expectations: data.company_expectation,
                            companyDesc: data.companyDesc,
                            isPhysicalSales: data.isPhysicalSales,
                            physicalSales: data.physicalSales ? +data.physicalSales : null
                        };
                    }
                    else {
                        details = {
                            detailDesc: data.company_about,
                            expectations: data.company_expectation,
                            companyDesc: data.companyDesc
                        };
                    }
                    let con = await this.channelDetailRepository.update(details, {
                        where: { channelId: companyProfile.channelId }, returning: true, transaction,
                    });
                    console.log('con', con);
                    let channelContacts = await this.contactRepository.scope('basicInfom').findAll({
                        where: {
                            deletedAt: null,
                            contactId: { [sequelize_1.Op.ne]: user.contactId },
                            channelId: user.channelId
                        }
                    });
                    let contacts = [];
                    contacts.push(user.contactId);
                    if (channelContacts.length > 0) {
                        channelContacts.map(function (data) {
                            contacts.push(data.contactId);
                        });
                    }
                    if (((_a = data.productFamilies) === null || _a === void 0 ? void 0 : _a.length) > 0) {
                        let productGroup = await this.channelProductGroupRepository.findAll({
                            where: {
                                channelId: user.channelId,
                                deletedAt: null
                            }
                        });
                        let ChannelProductGroupIds = await this.tradeInformationInBound.setProductGroupIds(productGroup);
                        let ChannelProductGroupObject = await this.tradeInformationInBound.setProductGroup(data.productFamilies, user.channelId);
                        let ChannelProductGroupCurrentIds = [];
                        let ChannelProductGroupCreateObject = [];
                        let ContactProductGroupObject = await this.tradeInformationInBound.setContactProductGroup(data.productFamilies, user.contactId);
                        let ContactProductGroupCurrentIds = [];
                        for (let kk = 0; kk < ChannelProductGroupObject.length; kk++) {
                            if (ChannelProductGroupIds.includes(ChannelProductGroupObject[kk].productGroupId)) {
                                ChannelProductGroupCurrentIds.push(ChannelProductGroupObject[kk].productGroupId);
                            }
                            else {
                                ChannelProductGroupCreateObject.push(ChannelProductGroupObject[kk]);
                                ChannelProductGroupCurrentIds.push(ChannelProductGroupObject[kk].productGroupId);
                            }
                            ContactProductGroupCurrentIds.push(ContactProductGroupObject[kk].productGroupId);
                        }
                        if (ChannelProductGroupCreateObject.length > 0) {
                            await this.channelProductGroupRepository.bulkCreate(ChannelProductGroupCreateObject, { returning: true, transaction });
                        }
                        await this.channelProductGroupRepository.update({ deletedAt: new Date() }, {
                            where: {
                                channelId: user.channelId,
                                productGroupId: { [sequelize_1.Op.notIn]: ChannelProductGroupCurrentIds },
                                deletedAt: null
                            }, returning: true, transaction
                        });
                        await this.contactGroupRepository.update({ deletedAt: new Date() }, {
                            where: {
                                contactId: { [sequelize_1.Op.in]: contacts },
                                productGroupId: { [sequelize_1.Op.notIn]: ContactProductGroupCurrentIds },
                                deletedAt: null
                            }, returning: true, transaction
                        });
                    }
                    if (((_b = data.productCategories) === null || _b === void 0 ? void 0 : _b.length) > 0) {
                        let productCategory = await this.channelProductCategorieRepository.findAll({
                            where: {
                                channelId: user.channelId,
                                deletedAt: null
                            }
                        });
                        let productCategoriesIds = await this.tradeInformationInBound.setProductCategoryIds(productCategory);
                        let ProductCategorieObject = await this.tradeInformationInBound.setProductCategories(data.productCategories, user.channelId);
                        let ChannelProductCategoriesCurrentIds = [];
                        let ChannelProductCategoriesCreateObject = [];
                        let contactProductCategorieObject = await this.tradeInformationInBound.setContactProductCategories(data.productCategories, user.contactId);
                        let ContactProductCategoriesCurrentIds = [];
                        for (let kk = 0; kk < ProductCategorieObject.length; kk++) {
                            if (productCategoriesIds.includes(ProductCategorieObject[kk].productCategorieId)) {
                                ChannelProductCategoriesCurrentIds.push(ProductCategorieObject[kk].productCategorieId);
                            }
                            else {
                                ChannelProductCategoriesCreateObject.push(ProductCategorieObject[kk]);
                                ChannelProductCategoriesCurrentIds.push(ProductCategorieObject[kk].productCategorieId);
                            }
                            ContactProductCategoriesCurrentIds.push(contactProductCategorieObject[kk].productCategorieId);
                        }
                        if (ChannelProductCategoriesCreateObject.length > 0) {
                            console.log('ChannelProductCategoriesCreateObject', ChannelProductCategoriesCreateObject);
                            await this.channelProductCategorieRepository.bulkCreate(ChannelProductCategoriesCreateObject, { returning: true, transaction });
                        }
                        await this.channelProductCategorieRepository.update({ deletedAt: new Date() }, {
                            where: {
                                channelId: user.channelId,
                                productCategorieId: { [sequelize_1.Op.notIn]: ChannelProductCategoriesCurrentIds },
                                deletedAt: null
                            }, returning: true, transaction
                        });
                        await this.contactCatRepository.update({ deletedAt: new Date() }, {
                            where: {
                                contactId: { [sequelize_1.Op.in]: contacts },
                                productCategorieId: { [sequelize_1.Op.notIn]: ContactProductCategoriesCurrentIds },
                                deletedAt: null
                            }, returning: true, transaction
                        });
                    }
                    if (((_c = data.brand) === null || _c === void 0 ? void 0 : _c.length) > 0) {
                        let channelBrandObject = await this.saveBrand(data.brand, user.channelId, transaction);
                        if (channelBrandObject.channelBrandArrayObject.length > 0) {
                            let brand = await this.channelBrandRepository.findAll({
                                where: {
                                    channelId: user.channelId,
                                    deletedAt: null
                                }
                            });
                            let ChannelBrandCurrentIds = [];
                            let ChannelBrandCreateObject = [];
                            let brandObject = channelBrandObject.channelBrandArrayObject;
                            let brandIds = channelBrandObject.brandIds;
                            let ChannelBrandIds = await this.tradeInformationInBound.setchannelbrandIds(brand);
                            let totalRemovedBrands = ChannelBrandIds.filter(e => !brandIds.find(a => e == a));
                            for (let kk = 0; kk < brandObject.length; kk++) {
                                if (!ChannelBrandIds.includes(brandObject[kk].brandId)) {
                                    ChannelBrandCreateObject.push(brandObject[kk]);
                                }
                                if (!totalRemovedBrands.includes(+brandObject[kk].brandId)) {
                                    ChannelBrandCurrentIds.push(brandObject[kk].brandId);
                                }
                            }
                            if (ChannelBrandCreateObject.length > 0) {
                                await this.channelBrandRepository.bulkCreate(ChannelBrandCreateObject, { returning: true, transaction });
                            }
                            await this.channelBrandRepository.update({ deletedAt: new Date() }, {
                                where: {
                                    channelId: user.channelId,
                                    brandId: { [sequelize_1.Op.notIn]: ChannelBrandCurrentIds },
                                    deletedAt: null
                                }, returning: true, transaction
                            });
                            await this.brandRepository.update({
                                isAssigned: '1'
                            }, {
                                where: {
                                    id: {
                                        [sequelize_1.Op.in]: brandIds
                                    }
                                },
                                returning: true, transaction
                            });
                            await this.brandRepository.update({
                                isAssigned: '0'
                            }, {
                                where: {
                                    id: {
                                        [sequelize_1.Op.in]: totalRemovedBrands
                                    }
                                },
                                returning: true, transaction
                            });
                        }
                    }
                    if (user.channelTypeId == 4 || user.channelTypeId == 5) {
                        if (data.endCustomers) {
                            let b2b = this.endCustomersB2bRepository.findOne({
                                where: { channelId: +user.channelId }
                            });
                            if (b2b) {
                                this.endCustomersB2bRepository.update({
                                    customerTypeId: data.endCustomers,
                                    other: data.otherEndCustomer
                                }, { where: { channelId: +user.channelId } });
                            }
                            else {
                                this.endCustomersB2bRepository.create({
                                    channelId: +user.channelId,
                                    customerTypeId: data.endCustomers,
                                    other: data.otherEndCustomer
                                });
                            }
                        }
                    }
                    if ((_d = data.distributorSpeciality) === null || _d === void 0 ? void 0 : _d.length) {
                        let ChannelSpecialityObject = [];
                        ChannelSpecialityObject = await this.tradeInformationInBound.setSpeciality(data.distributorSpeciality, user.channelId);
                        console.log('speciality dist', ChannelSpecialityObject, data.distributorSpeciality);
                        if (ChannelSpecialityObject.length > 0) {
                            let speciality = await this.channelSpecialityRepository.findAll({
                                where: {
                                    channelId: user.channelId,
                                    deletedAt: null
                                }
                            });
                            let ChannelSpecialityIds = await this.tradeInformationInBound.setProductGroupIds(speciality);
                            let ChannelSpecialityCurrentIds = [];
                            let ChannelSpecialityCreateObject = [];
                            for (let kk = 0; kk < ChannelSpecialityObject.length; kk++) {
                                if (ChannelSpecialityIds.includes(ChannelSpecialityObject[kk].productGroupId)) {
                                    ChannelSpecialityCurrentIds.push(ChannelSpecialityObject[kk].productGroupId);
                                }
                                else {
                                    ChannelSpecialityCreateObject.push(ChannelSpecialityObject[kk]);
                                    ChannelSpecialityCurrentIds.push(ChannelSpecialityObject[kk].productGroupId);
                                }
                            }
                            if (ChannelSpecialityCreateObject.length > 0) {
                                await this.channelSpecialityRepository.bulkCreate(ChannelSpecialityCreateObject, { returning: true, transaction });
                            }
                            await this.channelSpecialityRepository.update({ deletedAt: new Date() }, {
                                where: {
                                    channelId: user.channelId,
                                    productGroupId: { [sequelize_1.Op.notIn]: ChannelSpecialityCurrentIds },
                                    deletedAt: null
                                }, returning: true, transaction
                            });
                        }
                    }
                });
            }
            if (result) {
                return true;
            }
            else {
                return false;
            }
        }
        catch (err) {
            console.log("Error+", err);
        }
    }
    async save_channel_info(data, companyProfile, user) {
        console.log('datadata,', data);
        let result = '';
        try {
            result = this.sequelizeInstance.transaction(async (transaction) => {
                var _a;
                if (data.customerProfiles && ((_a = data.customerProfiles) === null || _a === void 0 ? void 0 : _a.length) > 0) {
                    let customerProfiles = await this.channelCustomerProfileRepository.findAll({
                        where: {
                            channelId: user.channelId,
                            deletedAt: null
                        }
                    });
                    let customerProfilesIds = await this.tradeInformationInBound.setCustomerProfilesIds(customerProfiles);
                    let customerProfilesObject = await this.tradeInformationInBound.setCustomerProfiles(data.customerProfiles, user.channelId);
                    let channelCustomerProfilesCurrentIds = [];
                    let ChannelCustomerProfilesCreateObject = [];
                    for (let kk = 0; kk < customerProfilesObject.length; kk++) {
                        if (customerProfilesIds.includes(customerProfilesObject[kk].profileTypeId)) {
                            channelCustomerProfilesCurrentIds.push(customerProfilesObject[kk].profileTypeId);
                        }
                        else {
                            ChannelCustomerProfilesCreateObject.push(customerProfilesObject[kk]);
                            channelCustomerProfilesCurrentIds.push(customerProfilesObject[kk].profileTypeId);
                        }
                    }
                    if (ChannelCustomerProfilesCreateObject.length > 0) {
                        await this.channelCustomerProfileRepository.bulkCreate(ChannelCustomerProfilesCreateObject, { returning: true, transaction });
                    }
                    console.log('ChannelCustomerProfilesCreateObject', ChannelCustomerProfilesCreateObject);
                    await this.channelCustomerProfileRepository.update({ deletedAt: new Date() }, {
                        where: {
                            channelId: user.channelId,
                            profileTypeId: { [sequelize_1.Op.notIn]: channelCustomerProfilesCurrentIds },
                            deletedAt: null
                        }, returning: true, transaction
                    });
                }
                if (user.channelTypeId !== 4 && user.channelTypeId !== 5) {
                    if (user.channelTypeId == 2) {
                        await this.tradeInformationInBound.keyRetailers(app_constant_1.appconstant.CHANNEL_TYPE_DISTRIBUTOR, data.channelKeyDistributor, user.channelId, user.userId, data.deletedkeydistributor);
                    }
                    await this.tradeInformationInBound.keyRetailers(app_constant_1.appconstant.CHANNEL_TYPE_RETAILER, data.channelKeyRetailer, user.channelId, user.userId, data.deletedkeyretailer);
                    await this.tradeInformationInBound.keyRetailers(app_constant_1.appconstant.CHANNEL_TYPE_RESELLER, data.channelKeyReseller, user.channelId, user.userId, data.deletedkeyreseller);
                    let ChannelDetailObject = await this.tradeInformationInBound.setChannelDetail(data, user.channelId, user.channelTypeId);
                    console.log('channelDetailObject', ChannelDetailObject);
                    if (ChannelDetailObject) {
                        await this.channelDetailRepository.update(ChannelDetailObject, { where: { channelId: user.channelId }, returning: true, transaction });
                    }
                    await this.channelRepository.update({ isOEM: data.isOEM, isCompanyPublic: data.isCompanyPublic }, { where: { channelId: user.channelId }, returning: true, transaction });
                }
            });
            if (result) {
                return true;
            }
            else {
                return false;
            }
        }
        catch (err) {
            console.log('error', err);
        }
    }
    async save_marketing_info(data, companyProfile, user) {
        let result = '';
        let requestObject = Object.assign(Object.assign(Object.assign({}, data.socialProfile), data.award), data);
        try {
            result = await this.sequelizeInstance.transaction(async (transaction) => {
                var _a, _b;
                if (requestObject.social_linkedin_id) {
                    await this.socialLinkRepository.update({
                        socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_LINKEDIN,
                        channelId: companyProfile.channelId,
                        channelSocialLink: requestObject.social_linkedin_url
                    }, {
                        where: { channelSocialLinkId: requestObject.social_linkedin_id },
                        returning: true, transaction,
                    });
                }
                else {
                    if (requestObject.social_linkedin_url && Object.keys(requestObject.social_linkedin_url).length > 0) {
                        await this.socialLinkRepository.create({
                            socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_LINKEDIN,
                            channelId: companyProfile.channelId,
                            channelSocialLink: requestObject.social_linkedin_url
                        }, {
                            transaction
                        });
                    }
                }
                if (requestObject.social_googleplus_id) {
                    await this.socialLinkRepository.update({
                        socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_GOOGLEPLUS,
                        channelId: companyProfile.channelId,
                        channelSocialLink: requestObject.social_googleplus_url
                    }, {
                        where: { channelSocialLinkId: requestObject.social_googleplus_id },
                        returning: true, transaction,
                    });
                }
                else {
                    if (requestObject.social_googleplus_url && Object.keys(requestObject.social_googleplus_url).length > 0) {
                        await this.socialLinkRepository.create({
                            socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_GOOGLEPLUS,
                            channelId: companyProfile.channelId,
                            channelSocialLink: requestObject.social_googleplus_url
                        }, {
                            transaction
                        });
                    }
                }
                if (requestObject.social_instagram_id) {
                    await this.socialLinkRepository.update({
                        channelId: companyProfile.channelId,
                        channelSocialLink: requestObject.social_instagram_url
                    }, {
                        where: { channelSocialLinkId: requestObject.social_instagram_id },
                        returning: true, transaction,
                    });
                }
                else {
                    if (requestObject.social_instagram_url && Object.keys(requestObject.social_instagram_url).length > 0) {
                        await this.socialLinkRepository.create({
                            socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_INSTAGRAM,
                            channelId: companyProfile.channelId,
                            channelSocialLink: requestObject.social_instagram_url
                        }, {
                            transaction
                        });
                    }
                }
                if (requestObject.social_twitter_id) {
                    await this.socialLinkRepository.update({
                        channelId: companyProfile.channelId,
                        channelSocialLink: requestObject.social_twitter_url
                    }, {
                        where: { channelSocialLinkId: requestObject.social_twitter_id },
                        returning: true, transaction,
                    });
                }
                else {
                    if (requestObject.social_twitter_url && Object.keys(requestObject.social_twitter_url).length > 0) {
                        await this.socialLinkRepository.create({
                            socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_TWITTER,
                            channelId: companyProfile.channelId,
                            channelSocialLink: requestObject.social_twitter_url
                        }, {
                            transaction
                        });
                    }
                }
                if (requestObject.social_facebook_id) {
                    await this.socialLinkRepository.update({
                        channelId: companyProfile.channelId,
                        channelSocialLink: requestObject.social_facebook_url
                    }, {
                        where: { channelSocialLinkId: requestObject.social_facebook_id },
                        returning: true, transaction,
                    });
                }
                else {
                    if (requestObject.social_facebook_url && Object.keys(requestObject.social_facebook_url).length > 0) {
                        await this.socialLinkRepository.create({
                            socialSiteId: app_constant_1.appconstant.SOCIAL_SITE_TYPE_FACEBOOK,
                            channelId: companyProfile.channelId,
                            channelSocialLink: requestObject.social_facebook_url
                        }, {
                            transaction
                        });
                    }
                }
                if (requestObject.B2B_url && Object.keys(requestObject.B2B_url).length > 0) {
                    for (let ii = 0; ii < requestObject.B2B_url.length; ii++) {
                        if (requestObject.B2B_url[ii].channel_B2B_id) {
                            await this.channelB2BRepository.update({
                                channelId: companyProfile.channelId,
                                channelB2B: requestObject.B2B_url[ii].B2B_url
                            }, {
                                where: { channelB2BId: requestObject.B2B_url[ii].channel_B2B_id },
                                returning: true, transaction,
                            });
                        }
                        else {
                            await this.channelB2BRepository.create({
                                channelId: companyProfile.channelId,
                                channelB2B: requestObject.B2B_url[ii].B2B_url
                            }, {
                                transaction
                            });
                        }
                    }
                }
                if (requestObject.deleted_B2B && requestObject.deleted_B2B.length > 0) {
                    for (let ii = 0; ii < requestObject.deleted_B2B.length; ii++) {
                        if (requestObject.deleted_B2B[ii]) {
                            await this.channelB2BRepository.update({
                                channelId: companyProfile.channelId,
                                deletedAt: new Date()
                            }, {
                                where: { channelB2BId: requestObject.deleted_B2B[ii] },
                                returning: true, transaction,
                            });
                        }
                    }
                }
                if (requestObject.deleted_award_details && requestObject.deleted_award_details.length > 0) {
                    await this.awardRepository.update({
                        deletedAt: new Date()
                    }, {
                        where: {
                            channelAwardId: {
                                [sequelize_1.Op.in]: requestObject.deleted_award_details
                            }
                        },
                        returning: true, transaction,
                    });
                }
                if (requestObject.award_details && Object.keys(requestObject.award_details).length > 0) {
                    for (let ii = 0; ii < requestObject.award_details.length; ii++) {
                        await this.awardRepository.create({
                            channelId: companyProfile.channelId,
                            awardDetail: 'channel',
                            issuedBy: 'ch',
                            documentId: requestObject.award_details[ii].documentId,
                        }, {
                            transaction
                        });
                    }
                }
                if (requestObject.companyImages && Object.keys(requestObject.companyImages).length > 0) {
                    for (let ii = 0; ii < requestObject.companyImages.length; ii++) {
                        if (!requestObject.companyImages[ii].companyMediaId) {
                            await this.companyMediaImagesRepository.create({
                                channelId: companyProfile.channelId,
                                documentId: requestObject.companyImages[ii].documentId,
                                contactId: companyProfile.contactId,
                                updatedBy: companyProfile.userId
                            }, {
                                transaction
                            });
                        }
                    }
                }
                if (requestObject.deleted_companyImages && requestObject.deleted_companyImages.length > 0) {
                    for (let ii = 0; ii < requestObject.deleted_companyImages.length; ii++) {
                        if (requestObject.deleted_companyImages[ii]) {
                            await this.companyMediaImagesRepository.update({
                                deletedAt: new Date()
                            }, {
                                where: { companyMediaId: requestObject.deleted_companyImages[ii] },
                                returning: true, transaction,
                            });
                        }
                    }
                }
                let bannerId = null;
                if (requestObject.bannerImage.length > 0) {
                    let companyBanner;
                    if (!lodash_1.isUndefined(requestObject.bannerImage[0].id) && requestObject.bannerImage[0].id != '') {
                        bannerId = requestObject.bannerImage[0].id;
                    }
                    else {
                        let oldBanner = await this.channelDetailRepository.findOne({
                            where: { channelId: user.channelId },
                            attributes: ['channelBannerId']
                        }).then(res => {
                            console.log('banner', res.channelBannerId);
                            return res.channelBannerId;
                        }).catch(err => console.log('banner error', err));
                        if (oldBanner) {
                            await this.mediaRepository.update({ deletedAt: new Date() }, { where: {
                                    documentId: +oldBanner
                                } });
                        }
                        companyBanner = await this.mediaRepository.create({
                            documentPath: requestObject.bannerImage[0].image,
                            documentTypeId: app_constant_1.appconstant.DOCUMENTTYPE_IMAGE,
                            dirName: app_constant_1.appconstant.FOLDER_PATH_COMPANY_BANNER
                        }, {
                            transaction,
                        });
                        bannerId = companyBanner.documentId;
                        await this.channelDetailRepository.update({
                            channelBannerId: bannerId
                        }, { where: {
                                channelId: user.channelId
                            } });
                    }
                }
                if ((_a = data.certificatesList) === null || _a === void 0 ? void 0 : _a.length) {
                    let certificateTag = data.certificatesList.map(x => {
                        x.channelId = user.channelId;
                        x.createdat = new Date();
                        return x;
                    });
                    console.log('certificateTag', certificateTag);
                    await CertificateTag_entity_1.CertificateTag.bulkCreate(certificateTag, {
                        transaction
                    });
                }
                if ((_b = data.deletedTags) === null || _b === void 0 ? void 0 : _b.length) {
                    await CertificateTag_entity_1.CertificateTag.update({ deletedat: new Date() }, {
                        where: {
                            channelId: user.channelId,
                            certificatetagid: {
                                [sequelize_1.Op.in]: data.deletedTags
                            }
                        },
                        transaction, returning: true
                    });
                }
                if (data.company_email)
                    await this.channelRepository.update({
                        companyMail: data.company_email
                    }, { where: {
                            channelId: user.channelId
                        } });
                let channelDetailData = Object.assign(Object.assign(Object.assign({}, (data.company_mobile_no && { mobileNo: data.company_mobile_no })), (bannerId && { channelBannerId: bannerId })), (data.company_website_url && { webSiteUrl: data.company_website_url }));
                await this.channelDetailRepository.update(channelDetailData, { where: {
                        channelId: user.channelId
                    } });
            });
            if (result)
                return true;
            else
                return false;
        }
        catch (err) {
            console.log('error ', err);
        }
    }
    async save_facts_figures(data, companyProfile, user) {
        let result = '';
        try {
            result = await this.sequelizeInstance.transaction(async (transaction) => {
                let channelDetailObject = await this.tradeInformationInBound.setChannelDetail(data, user.channelId, user.channelTypeId);
                await this.channelDetailRepository.update(channelDetailObject, {
                    where: {
                        channelId: user.channelId
                    },
                    returning: true, transaction
                });
            });
            if (result)
                return true;
            else
                return false;
        }
        catch (err) {
            console.log('error', err);
        }
    }
    async save_settingsdocuments(data, companyProfile, user) {
        let result = '';
        let requestObject = Object.assign({}, data);
        try {
            result = await this.sequelizeInstance.transaction(async (transaction) => {
                if (requestObject.channel_document && Object.keys(requestObject.channel_document).length > 0) {
                    for (let ii = 0; ii < requestObject.channel_document.length; ii++) {
                        if (requestObject.channel_document[ii].channelDocumentId) {
                            await this.channelDocumentRepository.update({
                                channelId: companyProfile.channelId,
                                documentId: requestObject.channel_document[ii].documentId,
                                name: _.defaultTo(requestObject.channel_document[ii].documentName, ''),
                                description: _.defaultTo(requestObject.channel_document[ii].documentDescription, ''),
                                updatedBy: companyProfile.userId
                            }, {
                                where: { channelDocumentId: requestObject.channel_document[ii].channelDocumentId },
                                returning: true, transaction,
                            });
                        }
                        else {
                            await this.channelDocumentRepository.create({
                                channelId: companyProfile.channelId,
                                documentId: requestObject.channel_document[ii].documentId,
                                name: _.defaultTo(requestObject.channel_document[ii].documentName, ''),
                                description: _.defaultTo(requestObject.channel_document[ii].documentDescription, ''),
                                updatedBy: companyProfile.userId
                            }, {
                                transaction
                            });
                        }
                    }
                }
                if (requestObject.deleted_channel_documents && requestObject.deleted_channel_documents.length > 0) {
                    for (let ii = 0; ii < requestObject.deleted_channel_documents.length; ii++) {
                        if (requestObject.deleted_channel_documents[ii]) {
                            await this.channelDocumentRepository.update({
                                deletedAt: new Date()
                            }, {
                                where: { channelDocumentId: requestObject.deleted_channel_documents[ii] },
                                returning: true, transaction,
                            });
                        }
                    }
                }
                await this.channelDetailRepository.update({ introvideoId: data.company_introvideo }, {
                    where: {
                        channelId: user.channelId
                    }, returning: true, transaction
                });
            });
            if (result)
                return true;
            else
                return false;
        }
        catch (err) {
            console.log('error ', err);
        }
    }
    async getChannelCertificateTags(user) {
        let result = await CertificateTag_entity_1.CertificateTag.findAll({ where: {
                channelId: user.channelId,
                deletedat: null
            } });
        return result;
    }
    async getCategoryDetails(groupId) {
        let query = 'select "productCategorieId", count(*), (select "productCategorie" from "tblProductCategories" as tp where tp."productCategorieId"=tc."productCategorieId") from "tblProduct" as tc where tc."productCategorieId" in (select "productCategorieId" from "tblProductCategories" where "productGroupId"=:groupId) and tc."isactive"=\'1\' group by "productCategorieId"';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                groupId: groupId
            }
        }).then(res => console.log('catresult', res));
    }
    async getProducts(businessType) {
        let type = [];
        if (businessType == 1)
            type = [1, 3];
        if (businessType == 2)
            type = [2, 3];
        if (businessType == 3)
            type = [1, 2, 3];
        let query = 'select pg."productGroupId" as groupId,pg."productGroup" as groupname from "tblProductGroup" as pg where pg."deletedAt" is null and pg."productGroup"!=\'\' and pg."businessType" in (:businessType) and pg."isActive"=\'1\' ';
        let productGroup = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                businessType: type
            }
        }).then((results) => {
            return results;
        });
        let productGroup1 = [];
        let final = [];
        if (productGroup) {
            query = ' select "productGroupId" as groupId, count(*), (select "productGroup" as groupname from "tblProductGroup" as pg ' +
                'where pg."productGroupId"=tc."productGroupId"' +
                ') from "tblProduct" as tc where tc."productGroupId" in (:productGroup) and tc."isactive"=\'1\' and tc."deletedat" is null  group by "productGroupId" order by count desc';
            productGroup1 = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                replacements: {
                    businessType: type,
                    productGroup: productGroup.map(x => x.groupid)
                }
            }).then((results) => {
                return results;
            });
            final = productGroup.filter(x => !productGroup1.find(y => y.groupid == x.groupid));
            if (final)
                final = final.map(x => ({ groupid: x.groupid, groupname: x.groupname, count: 0 }));
        }
        let data = {
            productGroup: [...productGroup1, ...final],
        };
        return data;
    }
    async getCategories(businessType) {
        let type = [];
        if (businessType == 1)
            type = [1, 3];
        if (businessType == 2)
            type = [2, 3];
        if (businessType == 3)
            type = [1, 2, 3];
        let query = 'select pg."productCategorieId" as id,pg."productCategorie" as name from "tblProductCategories" as pg where pg."deletedAt" is null and pg."productCategorie"!=\'\' and pg."businessType" in (:businessType) and pg."isActive"=\'1\' ';
        let productCat = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            replacements: {
                businessType: type
            }
        }).then((results) => {
            return results;
        });
        let data = {
            productCat: productCat,
        };
        return data;
    }
    async guestUserRequirement(data) {
        let res = {
            email: data.email,
            note: data.note,
            type: data.type
        };
        if (data.type == 2)
            res['productSKU'] = data.productSKU;
        else
            res['channelId'] = data.channelId;
        return await this.guestRequirementRepository.create(res);
    }
    async getTopCompany(keyword, typeId) {
        let type = [];
        if (typeId == 1)
            type = ['3', '1'];
        else if (typeId == 2)
            type = ['2', '3'];
        let query = 'select "channelId","companyName","channelTypeId" from "tblChannel" where "isOEM" in (:typeId) and unaccent("companyName") ILike :search and "deletedAt" is null and "isActive"=\'1\'  ';
        let company = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                search: '' + keyword + '%',
                typeId: type,
            }
        });
        query = 'select "productId","product","productSKU" from "tblProduct" where unaccent("product") ILike :search and "deletedat" is null and "isactive"=\'1\' and '
            + ' "channelId" in (select "channelId" from "tblChannel" where "isactive"=\'1\' and "isOEM" in (:typeId)) limit 4';
        let product = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                search: '' + keyword + '%',
                typeId: type
            }
        });
        let result = {
            company: company,
            product: product,
            type: +typeId
        };
        return result;
    }
    async getMatchingVendors(channelId, data) {
        let query = 'select tc."channelId",tc."companyName", (select td."documentPath" as logo from "tblChannelDetail" chd inner join "tblDocument" td on td."documentId" in (chd."channelLogoId") where chd."channelId"=tc."channelId") ' +
            'from "tblChannel" tc where tc."channelId" in (select "channelId" from "tblProduct" where "productCategorieId" in (select "productCategorieId" from "tblProduct" where "channelId"=:channelId)) and ' +
            'tc."isActive"=\'1\' and tc."deletedAt" is null and tc."channelId"!=:channelId';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: channelId
            },
        });
        let finalRes = { result: [] };
        if (result) {
            finalRes = { result: result.slice(data.offset).slice(0, data.limit) };
        }
        return finalRes;
    }
    async getMatchingBrands(channelId, data) {
        let query = 'select tc."channelId" ' +
            'from "tblChannel" tc where tc."channelId" in (select "channelId" from "tblProduct" where "productCategorieId" in (select "productCategorieId" from "tblProduct" where "channelId"=:channelId)) and ' +
            'tc."isActive"=\'1\' and tc."deletedAt" is null and tc."channelId"!=:channelId and tc."countryId"=(select "countryId" from "tblChannel" where "channelId"=:channelId)';
        let result = await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: channelId
            },
        }).then(x => { return _.uniqBy(x, 'channelId'); });
        let result1 = [];
        if (result) {
            let channelList = result.map(x => +x.channelId);
            let query1 = 'select distinct on(tc."companyName") tc."companyName" as name, tc."channelId" as id, td."documentPath" as logo from "tblChannel" tc inner join "tblChannelDetail" tcd on tc."channelId"=tcd."channelId"  ' +
                'left join "tblDocument" td on td."documentId"=tcd."channelLogoId" where tc."isActive"=\'1\' and tc."deletedAt" is null and tc."isPublic"=\'1\' and tc."channelId" in (:channelId)';
            result1 = await this.sequelizeInstance.query(query1, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelId: channelList.length ? channelList : [-1]
                },
            }).then(res => res);
        }
        let finalRes = { result: [] };
        if (result1) {
            finalRes = { result: result1.slice(data.offset).slice(0, data.limit) };
        }
        return finalRes;
    }
    async getFeaturedVendors(data) {
        let res = await this.sequelizeInstance.query('select * from "fnGetFeatureVendor"(:btype)', {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                btype: data.btype
            }
        }).then((results) => {
            return results[0].fnGetFeatureVendor;
        });
        let finalRes = { result: [] };
        if (res)
            finalRes = { result: res };
        return finalRes;
    }
    async getBuyerSearchCount(data) {
        let filterch = [];
        let total = 0;
        let channelquery = 'select "channelId" from "tblChannel" as tc where tc."deletedAt" is null and "isActive"=\'1\' and "signUpStatusId"=15 ';
        if (data.filter.type) {
            channelquery += ' and "channelTypeId" = ' + data.filter.type;
        }
        let result = await this.sequelizeInstance.query(channelquery, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {}
        }).then(x => {
            return _.uniqBy(x, 'channelId');
        });
        if (result) {
            total = result.length;
        }
        if ((data.filter.countryId || data.filter.categoryId) && result) {
            let chlist = result.map(x => x.channelId);
            if (data.filter.countryId) {
                await this.sequelizeInstance.query('select array_agg("channelId") as ch from "tblChannel" where "countryId" in(:countryid) and "channelId" in (:channelid)', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        countryid: data.filter.countryId,
                        channelid: chlist
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            if (data.filter.categoryId) {
                await this.sequelizeInstance.query('select array_agg("channelId") as ch from "tblChannelProductCategorie" cpc where cpc."productCategorieId" in(:productcatid) and "channelId" in(:channelid) ', {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        channelid: filterch.length > 0 ? filterch : chlist,
                        productcatid: data.filter.categoryId
                    }
                }).then((result) => {
                    if (result[0].ch) {
                        filterch = [];
                        filterch.push(...result[0].ch);
                    }
                    else
                        filterch = [];
                });
            }
            result = result.filter(ch => { return filterch.includes(ch.channelId); });
            result = result.map(x => +x.channelId);
            total = result.length;
        }
        let finalRes = { result: {}, product: 0 };
        let result1 = {};
        let prod = 0;
        if (result.length) {
            if (result[0].hasOwnProperty('channelId'))
                result = result.map(x => x.channelId);
            let query = 'select count(case when tc."channelTypeId"=2 then 1 else null end) as vendor, ' +
                'count(case when tc."channelTypeId"=3 then 1 else null end) as distributor, ' +
                'count(case when tc."channelTypeId"=4 then 1 else null end) as retailer, ' +
                'count(case when tc."channelTypeId"=5 then 1 else null end) as reseller ' +
                'from "tblChannel" tc where tc."channelId" in (:channelId) and tc."isActive"=\'1\' and tc."deletedAt" is null';
            result1 = await this.sequelizeInstance.query(query, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelId: result.length ? result : [null]
                }
            }).then(res => res[0]);
            let query1 = 'select count(*) from "tblProduct" where "channelId" in (select "channelId" from "tblChannel" where "channelId" in (:channelId) and "channelTypeId"=2) and "isactive"=\'1\' and "deletedat" is null';
            prod = await this.sequelizeInstance.query(query1, {
                type: sequelize_1.QueryTypes.SELECT,
                raw: true,
                replacements: {
                    channelId: result.length ? result : [null]
                }
            }).then(res => res[0]);
        }
        if (result1 || prod)
            finalRes = { result: result1, product: prod };
        return finalRes;
    }
    async getFamilyFilter(data) {
        let productIds;
        try {
            if (data.length > 0) {
                let productcatquery = 'select pc."productGroupId" as id,pc."productGroup" as name from'
                    + ' "tblProductGroup" as pc where pc."productGroupId" in '
                    + '(select cpc."productGroupId" from "tblProduct" as cpc where "productId" in(:productId)) ';
                productIds = await this.sequelizeInstance.query(productcatquery, {
                    type: sequelize_1.QueryTypes.SELECT,
                    raw: true,
                    replacements: {
                        productId: data
                    }
                });
            }
        }
        catch (e) {
            console.log("productFilter:", e);
        }
        return productIds;
    }
    async getChannelAwards(user) {
        let query = 'select ad."channelId", ad."channelAwardId" as id, ad."documentId", ad."isLifeTime", ad."issuedBy" as "awardName", (select concat( \'' + process.env.CDN_URL + '\',"documentPath") as "documentUrl" from "tblDocument" where "documentId"=ad."documentId" and "deletedAt" is null) from "tblChannelAward" as ad where "channelId"=:channelId and ad."documentId" is not null and "libraryDeteledAt" is null';
        return await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: +user.channelId,
            }
        });
    }
    async getProductAwards(user) {
        let query = 'select ad."productId", ad."productAwardId" as id, ad."documentId", ad."isLifeTime", ad."issuedBy" as "awardName", (select concat( \'' + process.env.CDN_URL + '\',"documentPath") as "documentUrl" from "tblDocument" where "documentId"=ad."documentId" and "deletedAt" is null) from "tblProductAward" as ad where "productId" in(select "productId" from "tblProduct" where "channelId"=:channelId and "deletedat" is null) and ad."documentId" is not null and "libraryDeteledAt" is null';
        return await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelId: +user.channelId,
            }
        });
    }
    async deleteChannelAwards(data) {
        let query = 'update "tblChannelAward" set "libraryDeteledAt"=now() where "channelAwardId"=:channelAwardId';
        return await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                channelAwardId: data.id
            }
        });
    }
    async deleteProductAwards(data) {
        let query = 'update "tblProductAward" set "libraryDeteledAt"=now() where "productAwardId"=:productAwardId';
        return await this.sequelizeInstance.query(query, {
            type: sequelize_1.QueryTypes.SELECT,
            raw: true,
            replacements: {
                productAwardId: data.id
            }
        });
    }
};
ChannelSettingService = __decorate([
    common_1.Injectable(),
    __param(1, common_1.Inject('SequelizeInstance')),
    __param(2, common_1.Inject('ChannelRepository')),
    __param(3, common_1.Inject('ChannelDetailRepository')),
    __param(4, common_1.Inject('ChannelBrandRepository')),
    __param(5, common_1.Inject('ChannelCustomerProfileRepository')),
    __param(6, common_1.Inject('ChannelCertiRepository')),
    __param(7, common_1.Inject('SettingRepository')),
    __param(8, common_1.Inject('ProfileRepository')),
    __param(9, common_1.Inject('UserRepository')),
    __param(10, common_1.Inject('ContactRepository')),
    __param(11, common_1.Inject('ChannelProductGroupRepository')),
    __param(12, common_1.Inject('ProductGroupRepository')),
    __param(13, common_1.Inject('BrandRepository')),
    __param(14, common_1.Inject('ProductCategoryRepository')),
    __param(15, common_1.Inject('ChannelProductCategoryRepository')),
    __param(16, common_1.Inject('ContactProductGroupRepository')),
    __param(17, common_1.Inject('ContactProductCategoryRepository')),
    __param(18, common_1.Inject('InterestedProductGroupRepository')),
    __param(19, common_1.Inject('InterestedProductCategoryRepository')),
    __param(20, common_1.Inject('ProfileTypeRepository')),
    __param(21, common_1.Inject('ProfileTypeClassiRepository')),
    __param(22, common_1.Inject('CountryRepository')),
    __param(23, common_1.Inject('RegionRepository')),
    __param(24, common_1.Inject('RegionCtyJctRepository')),
    __param(25, common_1.Inject('ChannelLocationRepository')),
    __param(26, common_1.Inject('ContactLocationRepository')),
    __param(27, common_1.Inject('ChannelDocumentRepository')),
    __param(28, common_1.Inject('MediaRepository')),
    __param(29, common_1.Inject('ChannelSocialLinkRepository')),
    __param(30, common_1.Inject('AddressRepository')),
    __param(31, common_1.Inject('ChannelAwardRepository')),
    __param(32, common_1.Inject('ChannelProductCategorieRepository')),
    __param(33, common_1.Inject('ChannelCustomerProfileRepository')),
    __param(34, common_1.Inject('ChannelServiceListRepository')),
    __param(35, common_1.Inject('ChannelSpecialityRepository')),
    __param(36, common_1.Inject('ServiceListRepository')),
    __param(37, common_1.Inject('MediaTypeRepository')),
    __param(38, common_1.Inject('ChannelB2BRepository')),
    __param(39, common_1.Inject('CurrencyRepository')),
    __param(40, common_1.Inject('ChannelPaymentOptionTypeRepository')),
    __param(41, common_1.Inject('ChannelPaymentTermRepository')),
    __param(42, common_1.Inject('ChannelSharePreferenceRepository')),
    __param(43, common_1.Inject('ChannelSubscriptionRepository')),
    __param(44, common_1.Inject('SubscriptionPlanRepository')),
    __param(45, common_1.Inject('SubscriptionRepository')),
    __param(46, common_1.Inject('ZoneRepository')),
    __param(47, common_1.Inject('UserWalletAmountRepository')),
    __param(48, common_1.Inject('ProductRepository')),
    __param(49, common_1.Inject('CompanyMediaImagesRepository')),
    __param(50, common_1.Inject('EndCustomersB2bRepository')),
    __param(51, common_1.Inject('GuestRequirementRepository')),
    __metadata("design:paramtypes", [product_service_1.ProductService, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, Object, context_service_1.ContextService])
], ChannelSettingService);
exports.ChannelSettingService = ChannelSettingService;
//# sourceMappingURL=channel.setting.service.js.map